<?php
// $Id: AddHelpdeskDepartment.php 6370 2006-04-18 20:45:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");

/**
 * This action displays a form to the user, to collect information for a new helpdesk department. A list 
 * of admins is collected from the MBAPI, and dispatched to the template, so that the user can select 
 * a list of admins to be part of the new department. The template dispatched by this action should POST 
 * data to the AddHelpdeskDepartmentResponse action.
 *
 * @author  Vic Fryzel
 */
class AddHelpdeskDepartment extends MB_Action {
	/**
	 * The constructor for an AddHelpdeskDepartment action object. This calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddHelpdeskDepartment() {
		parent::MB_Action();
		$this->stringRep = "AddHelpdeskDepartment";
	}

	/**
	 * The main method of this class that executes the AddHelpdeskDepartment action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise. 0 is never returned.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$admins = $this->getMBAPIData("GetAdmins", "admins", "admin");
		if($admins === false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to collect a list of admins to associate with "
				."the new helpdesk department.");
		} else if(!count($admins)) {
			$this->addError(TRANS_ACTIONERROR, "No admins found. An admin must be added prior to adding a "
				."helpdesk department.");
		}
		if(!$this->getNumErrors()) {
			$s = array();
			$s["admins"] = $admins;
			$this->addTemplate("AddHelpdeskDepartment", collapseArrayElements($s));
				
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddHelpdeskDepartment
?>