<?php
// $Id: AddHelpdeskDepartmentResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action uses the information provided by the AddHelpdeskDepartment action to add a new helpdesk department
 * to the system. The data given by the AddHelpdeskDepartment action is formulated into an MBAPI command
 * and executed.
 *
 * @author  Vic Fryzel
 * @author  Michael Fountain
 */
class AddHelpdeskDepartmentResponse extends MB_Action {
	/**
	 * The constructor for an AddHelpdeskDepartmentResponse action object. This calls the parent constructor,
	 * sets the string representation of this object, and sets up $this->params.
	 */
	function AddHelpdeskDepartmentResponse() {
		parent::MB_Action();
		$this->stringRep = "AddHelpdeskDepartmentResponse";
		$this->params = array("hdDepartmentName", "hdDepartmentDescription");
	}

	/**
	 * The main method of this class that executes the AddHelpdeskDepartmentResponse action, and returns
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = "";
		// Relate this helpdesk department to some admins...
		if(count($_REQUEST["adminIDs"])) {
			$rel = array();
			$rel["adminIDs"]["adminID"] = $_REQUEST["adminIDs"];
			$query = $this->getMBAPIQuery("SetHelpdeskDepartments", "insert", $rel);
		} else {
			$query = $this->getMBAPIQuery("SetHelpdeskDepartments", "insert");
		}
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {


			if ($_REQUEST["redirectURL"] && $_REQUEST["redirectAction"]) {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])
					."&".$_REQUEST["redirectArgs"]);
			} else {
				$hdDepartmentID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
				redirect("helpdesk.php",getActionID("ShowHelpdeskDepartmentDetails"),
					array("hdDepartmentID"=>$hdDepartmentID));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddHelpdeskDepartmentResponse
?>