<?php
// $Id: EditHelpdeskBucket.php 8147 2006-07-27 15:30:59Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action dispatches a template that shows a form prepopulated with helpdesk bucket data. That data should
 * be posted to the EditHelpdeskBucketResponse action, at which point it will be applied to the current helpdesk
 * bucket in the database. The helpdesk bucket to edit is identified by $_REQUEST["hdBucketID"].
 * If an invalid helpdesk bucket ID is provided, an error is thrown, otherwise the template will be displayed,
 * and fed data for the current helpdesk bucket.
 *
 * @author  Vic Fryzel
 */
class EditHelpdeskBucket extends MB_Action {
	/**
	 * The constructor for a EditHelpdeskBucket action object. This calls the parent constructor, and sets
	 * the string representation of this object.
	 */
	function EditHelpdeskBucket() {
		parent::MB_Action();
		$this->stringRep = "EditHelpdeskBucket";
		$this->params = array("hdBucketID");
	}

	/**
	 * The main method of this class that executes the EditHelpdeskBucket action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!notZero($_REQUEST["hdBucketID"])) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk bucket ID given.");
		} else {
			$admins = correctArray($this->getMBAPIData("GetAdmins", "admins", "admin"));
			$departments = correctArray($this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments", "helpdeskDepartment"));

			$query = $this->getMBAPIQuery("GetHelpdeskBuckets", "", array(
										"getAdminData" => 1,
										"getHelpdeskDepartmentData" => 1));
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$results = grabSimpleMBAPIResults($data);
				$results = $results[0];
				// Get the list of department IDs...
				$relDepts = $relAdmins = array();
				if(is_array($results["hdDepartmentIDs"][0]["hdDepartmentID"])
						&& count($results["hdDepartmentIDs"][0]["hdDepartmentID"])) {
					// This is really weird feedback we're getting from the MBAPI command. I saw this in
					// GetHelpdeskDepartments for admins as well. I have to code around it, bad juju.
					foreach($results["hdDepartmentIDs"][0]["hdDepartmentID"] as $dept) {
						$relDepts[] = $dept["hdDepartmentID"];
					}
				} else if(!is_array($results["hdDepartmentIDs"][0]["hdDepartmentID"])
						&& (int) $results["hdDepartmentIDs"][0]["hdDepartmentID"]) {
					$relDepts[] = $results["hdDepartmentIDs"][0]["hdDepartmentID"];
				}
				$results["hdDepartmentIDs"] = $relDepts;

				// Get the list of admin IDs...
				if(is_array( $results['adminIDs'][0] ) && is_array($results["adminIDs"][0]["adminID"])
						&& count($results["adminIDs"][0]["adminID"])) {
					// Again with the weird feedback..
					foreach($results["adminIDs"][0]["adminID"] as $adminID) {
						$relAdmins[] = $adminID["adminID"];
					}
				} else if(is_array( $results['adminIDs'][0] ) && !is_array($results["adminIDs"][0]["adminID"])
						&& (int) $results["adminIDs"][0]["adminID"]) {
					$relAdmins[] = $results["adminIDs"][0]["adminID"];
				}
				$results["adminIDs"] = $relAdmins;

				// Add the complete list of admins and departments...
				$this->smartyVars["admins"] =& $admins;
				$this->smartyVars["helpdeskDepartments"] =& $departments;
				$this->smartyVars["helpdeskBucket"] =& $results;

				$this->mergeFormState( $results );
// 	print_r($this->smartyVars);exit;
				$this->addTemplate("EditHelpdeskBucket");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditHelpdeskBucket
?>