<?php
// $Id: EditHelpdeskDepartmentResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action takes the information provided by the EditHelpdeskDepartment action, and applies it to the
 * database, thus editing a helpdesk department in the system. If the provided helpdesk department ID does
 * not exist, an error is thrown. Provided no errors occur, once the helpdesk department is edited, this action
 * redirects to the ShowHelpdeskDepartmentDetails action, where the new changes can be viewed.
 *
 * @author  Vic Fryzel
 */
class EditHelpdeskDepartmentResponse extends MB_Action {
	/**
	 * The constructor for an EditHelpdeskDepartmentResponse action object. This calls the parent constructor,
	 * sets the string representation of this object and sets up $this->params.
	 */
	function EditHelpdeskDepartmentResponse() {
		parent::MB_Action();
		$this->stringRep = "EditHelpdeskDepartmentResponse";
		$this->params = array("hdDepartmentID", "hdDepartmentName",
			"hdDepartmentDescription");
	}

	/**
	 * The main method of this class that executes the EditHelpdeskDepartmentResponse action, and returns
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$departmentID = (int) $_REQUEST["hdDepartmentID"];
		if(!$departmentID) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk department ID given.");
		} else {
			$department = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments",
				"helpdeskDepartment", array("hdDepartmentID" => $departmentID,
				"getAdminData" => 1));
			if($department === false || !count($department)) {
				$this->addError(TRANS_ACTIONERROR, "Helpdesk department not found.");
			} else {
				$department = $department[0][0];
				$addAdminXML = $remAdminXML = "";
				// Gather admin IDs from the admin data...
				$adminIDs = array();
				if(is_array($department["admins"][0]["admin"]) && count($department["admins"][0]["admin"])) {
					foreach($department["admins"][0]["admin"] as $admin) {
						$adminIDs[] = $admin["adminID"][0];
					}
					$addAdminXML = getAddIDXML("adminID", $adminIDs, $_REQUEST["adminIDs"]);
					$remAdminXML = getRemoveIDXML("adminID", $adminIDs, $_REQUEST["adminIDs"]);
				}
				$query = $this->getMBAPIQuery("SetHelpdeskDepartments", "update",
					array("adminIDs" => $addAdminXML, "removeAdminIDs" => $remAdminXML));
				$data = dispatchMBAPI($query, 1);
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					redirect("helpdesk.php", "ShowHelpdeskDepartments",
						array("hdDepartmentID" => $departmentID));
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditHelpdeskDepartmentResponse
?>