<?php
// $Id: EditHelpdeskResponseTemplateResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action takes the information provided by the EditHelpdeskResponseTemplate action, and applies it 
 * to the database, thus editing a helpdesk response template in the system. If the provided helpdesk response
 * template ID does not exist, an error is thrown. Provided no errors occur, once the helpdesk response template
 * is edited, this action redirects to the ShowHelpdeskResponseTemplateDetails action, where the new changes 
 * can be viewed.
 *
 * @author  Vic Fryzel
 */
class EditHelpdeskResponseTemplateResponse extends MB_Action {
	/**
	 * The constructor for an EditHelpdeskResponseTemplateResponse action object. This calls the parent 
	 * constructor, sets the string representation of this object and sets up $this->params.
	 */
	function EditHelpdeskResponseTemplateResponse() {
		parent::MB_Action();
		$this->stringRep = "EditHelpdeskResponseTemplateResponse";
		$this->params = array("hdRespTplID", "hdRespTplName", 
			"hdRespTplBody");
	}

	/**
	 * The main method of this class that executes the EditHelpdeskResponseTemplateResponse action, and returns 
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$responseTemplateID = ((int) $_REQUEST["hdRespTplID"]);
		if(!$responseTemplateID) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk response template ID given.");
		} else {
			$responseTemplate = $this->getMBAPIData("GetHelpdeskResponseTemplates", 
				"helpdeskResponseTemplates", "helpdeskResponseTemplate",
				array("hdRespTplID" => $responseTemplateID, "getHelpdeskDepartmentData" => 1));
			if($responseTemplate === false || !count($responseTemplate)) {
				$this->addError(TRANS_ACTIONERROR, "Helpdesk response template not found.");
			} else {
				$responseTemplate =& $responseTemplate[0][0];
				$addDepartmentXML = getAddIDXML("hdDepartmentID",
					$responseTemplate["hdDepartmentIDs"][0]["hdDepartmentID"],
					$_REQUEST["hdDepartmentIDs"]);
				$remDepartmentXML = getRemoveIDXML("hdDepartmentID",
					$responseTemplate["hdDepartmentIDs"][0]["hdDepartmentID"],
					$_REQUEST["hdDepartmentIDs"]);
				$query = $this->getMBAPIQuery("SetHelpdeskResponseTemplates", "update", 
					array("adminIDs" => $addAdminXML, "removeAdminIDs" => $remAdminXML, 
						"hdDepartmentIDs" => $addDepartmentXML,
						"removeHelpdeskDepartmentIDs" => $remDepartmentXML));
				$data = dispatchMBAPI($query, 1);
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					
					redirect("helpdesk.php", "ShowHelpdeskResponseTemplates", 
						array("hdRespTplID" => $responseTemplateID));
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditHelpdeskResponseTemplateResponse
?>