<?php
// $Id: RemoveHelpdeskTicketResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action applies the data provided by the RemoveHelpdeskTicket action to the database, 
 * thus removing a helpdesk ticket from the system. To identify the helpdesk ticket to delete, this action 
 * references $_REQUEST["hdTicketID"]. If the helpdesk response template ID does not exist, an error 
 * is thrown; therwise if all goes well, this action redirects to the ShowHelpdeskTickets action.
 *
 * @author  Vic Fryzel
 */
class RemoveHelpdeskTicketResponse extends MB_Action {
	/**
	 * The constructor for an RemoveHelpdeskTicketResponse action object. This calls the parent 
	 * constructor, sets the string representation of this object, and sets up $this->params.
	 */
	function RemoveHelpdeskTicketResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveHelpdeskTicketResponse";
		$this->params = array("hdTicketID");
	}

	/**
	 * The main method of this class that executes the RemoveHelpdeskTicketResponse action, 
	 * and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if(!((int) $_REQUEST["hdTicketID"])) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk ticket ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetHelpdeskTickets", "delete");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				redirect("helpdesk.php", "ShowHelpdeskTickets");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveHelpdeskTicketResponse
?>