<?php
// $Id: ShowHelpdeskBuckets.php 6370 2006-04-18 20:45:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays information on all helpdesk buckets currently maintained by the system. It queries
 * the MBAPI GetHelpdeskBuckets command, and dispatches that data to the template for display.
 *
 * @author  Vic Fryzel
 * @author  Michael Fountain
 */
class ShowHelpdeskBuckets extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskBuckets action object. This calls the parent constructor,
	 * sets the string representation of this object, and sets up $this->sortColumns for use in
	 * $this->getMBAPIQuery().
	 */
	function ShowHelpdeskBuckets() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskBuckets";
		$this->sortColumns = array
		(
			"hdBucketID",
			"hdBucketName"
		);
	}

	/**
	 * The main method of this class that executes the ShowHelpdeskBuckets action, and returns success
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// --------------------------------------
		// Data: GetHelpdeskBuckets
		// --------------------------------------

		$params = array("getHelpdeskDepartmentData" => 1, "getAdminData" => 1);
		$query = $this->getMBAPIQuery("GetHelpdeskBuckets", "", $params, 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		$admins = $this->getMBAPIData("GetAdmins", "admins", "admin");
		$departments = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments", "helpdeskDepartment");
		if($admins === false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to collect a list of admins to potentially associate "
				."with the new helpdesk bucket.");
		} else if(!count($admins)) {
			$this->addError(TRANS_ACTIONERROR, "No admins found. An admin must be added prior to adding a "
				."helpdesk bucket.");
		}
		if($departments === false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to collect a list of helpdesk departments.");
		} else if(!count($departments)) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk departments found. A helpdesk department must be "
				."added prior to adding a helpdesk bucket.");
		}

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$results =& $data["mbapi"][0]["results"][0];

			$s = array();
			$s["admins"] = $admins;
			$s["helpdeskDepartments"] = $departments;
			$s["helpdeskBuckets"] = $results["helpdeskBuckets"][0]["helpdeskBucket"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$s["helpdeskBuckets"] = array(0 => $results["helpdeskBuckets"][0]["helpdeskBucket"]);
			}
			$s["paginationLinks"] = $results["paginationLinks"][0];

			$this->addTemplate("ShowHelpdeskBuckets", collapseArrayElements($s));

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowHelpdeskBuckets
?>