<?php
// $Id: ShowHelpdeskResponseTemplates.php 7183 2006-06-02 21:30:03Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays information on all helpdesk response templates currently maintained by the system. 
 * It queries the MBAPI GetHelpdeskResponseTemplates command, and dispatches that data to the template for 
 * display. The template should link to the AddHelpdeskResponseTemplate, EditHelpdeskResponseTemplate, 
 * RemoveHelpdeskResponseTemplate, and ShowHelpdeskResponseTemplateDetails actions. An error is not thrown 
 * if no helpdesk response templates are found, but rather the template is still dispatched.
 *
 * @author  Vic Fryzel
 */
class ShowHelpdeskResponseTemplates extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskResponseTemplates action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets up $this->sortColumns for use in 
	 * $this->getMBAPIQuery().
	 */
	function ShowHelpdeskResponseTemplates() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskResponseTemplates";
		$this->sortColumns = array("hdRespTplID", "hdRespTplName");
	}

	/**
	 * The main method of this class that executes the ShowHelpdeskResponseTemplates action, and returns 
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$query = $this->getMBAPIQuery("GetHelpdeskResponseTemplates", "", array(
									"getHelpdeskDepartmentData" => 1,
									"getAdminData" => 1
									));
		$data = dispatchMBAPI($query, 1);

		dbg("############# Returned from GetHelpdeskResponseTemplates #############");
		dbg($data);
		
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$results = grabSimpleMBAPIResults($data);
			
			$this->smartyVars["helpdeskResponseTemplates"] =& $results;
			$this->smartyVars["departments"] = correctArray($this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments", "helpdeskDepartment"));
			
			$this->smartyVars["paginationLinks"] = $data["mbapi"][0]["results"][0]["paginationLinks"][0];

			dbg("####### Sent to Smarty ###########");
			dbg($this->smartyVars);
			
			$this->addTemplate("ShowHelpdeskResponseTemplates");
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowHelpdeskResponseTemplates
?>