<?php
// $Id: ShowHelpdeskTickets.php 7228 2006-06-05 19:25:33Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays information on all helpdesk tickets currently maintained by the system. It queries 
 * the MBAPI GetHelpdeskTickets command, and dispatches that data to the template for display. The template 
 * should link to the AddHelpdeskTicket, EditHelpdeskTicket, RemoveHelpdeskTicket, and 
 * ShowHelpdeskTicketDetails actions. An error is not thrown if no companies are found, but rather the template 
 * is still dispatched.
 *
 * @author  Vic Fryzel
 */
class ShowHelpdeskTickets extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskTickets action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets up $this->sortColumns for use in 
	 * $this->getMBAPIQuery().
	 */
	function ShowHelpdeskTickets() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskTickets";
		$this->sortColumns = array(
				"hdTicketID",
				"hdTicketName",
				"hdTicketSubject",
				"hdTicketDateCreated",
				"hdTicketDateModified",
				"hdTicketsStatusID");
	}

	/**
	 * The main method of this class that executes the ShowHelpdeskTickets action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$query = $this->getMBAPIQuery("GetHelpdeskTickets", "", array(
								"getHelpdeskDepartmentData" => 1,
								"getHelpdeskBucketData" => 1,
								"getUserData" => 1), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$results = grabSimpleMBAPIResults($data);
			
			$this->smartyVars = array();
			$this->smartyVars["helpdeskTickets"] =& $results;
			
			$c = count($this->smartyVars["helpdeskTickets"]);
			
			if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) === 1) {
				$this->smartyVars["helpdeskTickets"] = array(0 => $results["helpdeskTickets"][0]["helpdeskTicket"]);
			}
			
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			$this->addTemplate("ShowHelpdeskTickets");
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowHelpdeskTickets
?>