<?php
// $Id: AddGeneralJournalEntry.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action displays the page to enter a journal entry.
 *
 * @author  Kris Bailey
 */
class AddGeneralJournalEntry extends MB_Action {
    /**
     * The constructor for a AddGeneralJournalEntry action object. This merely calls the parent constructor,
     * and sets the string representation of this object. This method also sets up $this->params and
     * $this->sortColumns for use in $this->getMBAPIQuery().
     */
    function ShowGeneralJournal() {
        parent::MB_Action();
        $this->stringRep = "AddGeneralJournalEntry";

    }

    /**
     * Execute this action object, and display any output generated to the screen.
     *
     * @return  1 if no errors occurred during execution, or 0 if otherwise.
     */
    function execute() {
        global $CONF;
        parent::execute();

        $this->smartyVars = array("currencyID"=>$CONF["user"]["locale"]->currency);
        $this->smartyVars["generalDateCreatedYear"] = date("Y");
        $this->smartyVars["generalDateCreatedMonth"] = date("m");
        $this->smartyVars["generalDateCreatedDate"] = date("d");
        $this->addLedgerAccounts();
        dbg($this->smartyVars);

        $this->addTemplate("accounting/AddGeneralJournalEntry", $this->smartyVars);

        $this->addErrorTemplates();
        return $this->hasExecutedSuccessfully();
    }
} // AddGeneralJournalEntry
?>