<?php
// $Id: AddGeneralJournalEntryResponse.php 11809 2007-08-24 22:15:55Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");
require_once mb_path("/lib-modernbill/include/accounting/General.php");

/**
* This Action displays the page to enter a journal entry.
*
* @author  Kris Bailey
*/
class AddGeneralJournalEntryResponse extends MB_Action {
	/**
	* The constructor for a AddGeneralJournalEntryResponse action object. This merely calls the parent constructor,
	* and sets the string representation of this object. This method also sets up $this->params and
	* $this->sortColumns for use in $this->getMBAPIQuery().
	*/
	function AddGeneralJournalEntryResponse() {
		parent::MB_Action();
		$this->stringRep = "AddGeneralJournalEntryResponse";



	}

	/**
	* Execute this action object, and display any output generated to the screen.
	*
	* @return  1 if no errors occurred during execution, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		// get ledger entries from request
		$entries = $this->getRequestLedgerEntryData("addGeneral");
		// validate ledger entries, make sure they add up
		$this->smartyVars["cango"] = $this->validateLedgerEntryData($entries);

		if (!count($entries)){
			$this->smartyVars["cango"] = 0;
		}

		// was there a problem with them? set a failmessage
		if (!$this->smartyVars["cango"]){
			$this->smartyVars["failreason"][] = TRANS_INVALID_LEDGER_ENTRIES;
		}

		// check the currency id for sanity
		if (strlen($_REQUEST["currencyID"])!=3){
			$this->smartyVars["failreason"][] = TRANS_NEED_CURRENCY_ID;
			$this->smartyVars["cango"] = 0;
		}

		// if we cant go, lets redisplay the form with
		if (!(int)$this->smartyVars["cango"]){
			$this->smartyVars["currencyID"] = $_REQUEST["currencyID"];
			$this->smartyVars["generalDescription"] = $_REQUEST["generalDescription"];
			$this->smartyVars["generalDateCreatedYear"] = $_REQUEST["generalYear"];
			$this->smartyVars["generalDateCreatedMonth"] = $_REQUEST["generalMonth"];
			$this->smartyVars["generalDateCreatedDay"] = $_REQUEST["generalDay"];
			$this->addLedgerAccounts();
			$this->smartyVars["existingEntries"] = $entries;
			$this->addTemplate("accounting/AddGeneralJournalEntry", $this->smartyVars);
		} else {

			// ok, going to build inserts because everything is ok.
			$amount = 0;
			foreach ($entries as $row){
				$amount += $row["generalLedgerDebitAmount"];
			}
			if (checkdate($_REQUEST["generalMonth"],$_REQUEST["generalDay"],$_REQUEST["generalYear"])) {
				if (intval($_REQUEST["generalHour"]) <= 23) {
					$generalHour = (int) $_REQUEST["generalHour"];
				} else {
					$generalHour = date("h");
				}
				if (intval($_REQUEST["generalMinute"]) <= 59) {
					$generalMinute = (int) $_REQUEST["generalMinute"];
				} else {
					$generalMinute = date("i");
				}
				$generalDateCreated = mktime($generalHour,$generalMinute,0,$_REQUEST["generalMonth"],$_REQUEST["generalDay"],$_REQUEST["generalYear"]);
			} else {
				$generalDateCreated = mktime();
			}

			$generalDescription = secureInput(unsecureInput(stripslashes($_REQUEST["generalDescription"])));

			$currencyID = ereg_replace("[^[:alpha:]]", "", $_REQUEST["currencyID"]);

			// run the general journal entry object with its options
			$gen =& new General();
			$gen->setClientID(0);
			$gen->setInvoiceID(0);
			$gen->setDescription($generalDescription);
			$gen->setTotalDebits($amount);
			$gen->setTotalCredits($amount);
			$gen->setCurrencyID($currencyID);
			$gen->setLedgerEntries($entries);
			$gen->updateTimestamp = $generalDateCreated;
			$gen->execute();

			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("accounting.php?action=".getActionID("ShowGeneralJournal")."&sid=".secureInput($_REQUEST["sid"]));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddGeneralJournalEntry
