<?php
// $Id: AddLedgerAccount.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on a ledger account, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class AddLedgerAccount extends MB_Action {
	/**
	 * The constructor for a EditLedgerAccount action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddLedgerAccount() {
		parent::MB_Action();
		$this->stringRep = "AddLedgerAccount";

	}

	/**
	 * The main method of this class that executes the ShowLedgerAccounts action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();
        $this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

        $query2 = "
            <mbapi>
                <command>GetAccountingLedgerAccounts</command>
                <params>
                </params>
            </mbapi>
        ";
        $data2 = dispatchMBAPI($query2, 1);
        $CONF["debug"]->add("Action Result (EditLedgerAccountResponse:GetAccountingLedgerAccounts)", $data);

        $this->smartyVars["ledgerAccounts"] = collapseArrayElements($data2["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"]);
        if($data2["mbapi"][0]["header"][0]["numResults"][0] == 1) {
            $this->smartyVars["ledgerAccounts"] = array(0 => collapseArrayElements($data2["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"]));
        }

        $this->addTemplate("accounting/AddLedgerAccount", $this->smartyVars);


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditLedgerAccount
?>