<?php
// $Id: RemoveLedgerAccount.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on a ledger account, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class RemoveLedgerAccount extends MB_Action {
	/**
	 * The constructor for a RemoveLedgerAccount action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function RemoveLedgerAccount() {
		parent::MB_Action();
		$this->stringRep = "EditLedgerAccount";
		$this->params = array("ledgerAccountID");

	}

	/**
	 * The main method of this class that executes the RemoveLedgerAccount action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

        $xmlParams = array
        (
            "ledgerAccountID" => ((int)$_REQUEST["ledgerAccountID"])
        );
        $ledgerDataXML = $this->getMBAPIQuery("GetAccountingGeneralLedger", "",  $xmlParams, 1, 1, 1, 1);
        $ledgerDataReturn = dispatchMBAPI($ledgerDataXML, 1);
        $ledgerData = $ledgerDataReturn["mbapi"][0]["header"][0]["numResults"][0];

        $canRemove = ((int)$ledgerData)?0:1;

        $this->smartyVars["canRemove"] = $canRemove;

        if ($canRemove && (int)$_REQUEST["ledgerAccountID"] && (int)$_REQUEST["removeLedgerAccount"]){

            $removeXML = "
            <mbapi>
                <command>SetAccountingGeneralLedgerAccount</command>
                <subCommand>delete</subCommand>
                <params>
                    <ledgerAccountID>".((int)$_REQUEST["ledgerAccountID"])."</ledgerAccountID>
                </params>
            </mbapi>
            ";
            dispatchMBAPI($removeXML);


            if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
                redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
            } else {
                redirect("accounting.php?action=".getActionID("ShowLedgerAccounts")."&ledgerAccountID=".$ledgerAccountID."&sid=".secureInput($_REQUEST["sid"]));
            }

        } else {

            $query = $this->getMBAPIQuery("GetAccountingLedgerAccounts", array("ledgerAccountID"=>(int)$_REQUEST["ledgerAccountID"]));
            $CONF["debug"]->add("Action Command (ShowLedgerAccountDetails:GetAccountingLedgerAccounts)", htmlentities($query));
            $data = dispatchMBAPI($query, 1);
            $CONF["debug"]->add("Action Result (EditLedgerAccount:GetAccountingLedgerAccounts)", $data);

            $this->smartyVars["account"] = collapseArrayElements($data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]);

            $this->addTemplate("accounting/RemoveLedgerAccount", $this->smartyVars);

        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditLedgerAccount
?>