<?php
// $Id: ShowAccountsPayableLedger.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on all receipt journal records that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class ShowAccountsPayableLedger extends MB_Action {
	/**
	 * The constructor for a ShowAccountsPayableLedger action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowAccountsPayableLedger() {
		parent::MB_Action();
		$this->stringRep = "ShowAccountsPayableLedger";

		$this->params = array
		(
			"generalLedgerDateCreated",
            "generalLedgerDateCreatedLeast",
            "generalLedgerDateCreatedGreatest"
		);

		$_REQUEST["generalLedgerDateCreatedLeast"] = $this->handleDateSelector("apLedgerBegin", 0);
		$_REQUEST["generalLedgerDateCreatedGreatest"] = $this->handleDateSelector("apLedgerEnd", 0);
		if ((int)$_REQUEST["generalLedgerDateCreatedGreatest"])$_REQUEST["generalLedgerDateCreatedGreatest"] += (24*60*60);
		
		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["dateQuery"][0]){
			$this->origDateQuery = $_REQUEST["dateQuery"];
			if ((int)$_REQUEST["dateQuery"][0]>100000){
				$_REQUEST["dateQuery"][0] = date("Y/m/d", $_REQUEST["dateQuery"][0]);
			}
			list($dY,$dM,$dD) = explode("/",$_REQUEST["dateQuery"][0]);
			$_REQUEST["dateQuery"][0] = $_REQUEST["generalLedgerDateCreatedLeast"] = mktime(0,0,0,$dM,$dD,$dY);
			$_REQUEST["generalLedgerDateCreatedGreatest"] = mktime(0,0,0,$dM,$dD+1,$dY)-1;
		}
		
		$this->sortColumns = ($_REQUEST["sortColumn"])?array($_REQUEST["sortColumn"]):array("generalLedgerDateCreated");
	}

	/**
	 * The main method of this class that executes the ShowAccountsPayableLedger action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		foreach (array(
			"apLedgerBeginMonth",
			"apLedgerBeginDay",
			"apLedgerBeginYear",
			"apLedgerEndMonth",
			"apLedgerEndDay",
			"apLedgerEndYear",
			"dateQuery") as $field){
			$this->smartyVars[$field] = $_REQUEST[$field];
		}
		$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];
		
		$xmlArgs = array
		(
			"generalLedgerType" => getGeneralLedgerTypeID("accounts_payable")
		);
		$query = $this->getMBAPIQuery("GetAccountingGeneralLedger","",$xmlArgs,1,1,1,1);
		$CONF["debug"]->add("Action Command (ShowAccountsPayableLedger::execute GetAccountingGeneralLedger)", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result (ShowAccountsPayableLedger::execute GetAccountingGeneralLedger)", $data);

        $this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
        $results =& $data["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"];


        $this->smartyVars["currencies"] = array();

        for ($i = 0; $i < count($results); $i++){

            $this->smartyVars["currencies"][$results[$i]["currencyID"][0]][] = collapseArrayElements($results[$i]);

        }

        $this->addTemplate("accounting/ShowAccountsPayableLedger", $this->smartyVars);


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowAccountsPayableLedger
?>