<?php
// $Id: ShowAgingReport.php 10474 2007-01-11 23:58:14Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

// Remove the time limit b/c this report can take more than 30 seconds to generate.
// A new way to generate this report may be needed soon.
set_time_limit(0);

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");
require_once mb_path("/lib-action/include/reports/ARAging.php");

/**
 * This class is a child class of MB_Action. It displays the aging report for the selected date.
 *
 * @author  Kris Bailey
 */
class ShowAgingReport extends MB_Action {

	function ShowAgingReport() {
		parent::MB_Action();
		$this->stringRep = "ShowAgingReport";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$this->reportParams = array(
			"detailLevel" => 0,
			"outputType" => 0,
			"recordOffset" => 0,
			);
		
		if (is_array($_REQUEST["reportParams"])){
			foreach ((array)$_REQUEST["reportParams"] as $k=>$v){
				$this->reportParams[$k] = $v;
			}
		}

		if ((int)$_REQUEST["recordOffset"]){
			$this->reportParams["recordOffset"] = (int)$_REQUEST["recordOffset"];
		}

		if ((int)$_REQUEST["clientID"]){
			$this->reportParams["clientID"] = (int)$_REQUEST["clientID"];
		}

		// sanify our date
		if ($_REQUEST["dateRange"]){
			$endPointTimestamp = explode("/", unsecureInput($_REQUEST["dateRange"]));
			if ($endPointTimestamp[0]<1 || $endPointTimestamp[0]>12)$endPointTimestamp[0] = date("m");
			if ($endPointTimestamp[1]<1 || $endPointTimestamp[1]>31)$endPointTimestamp[1] = date("d");
			if ($endPointTimestamp[2]<2000)$endPointTimestamp[2] = date("Y");
			unset($_REQUEST["dateRange"]); // we dont want addTemplate to throw it to smarty
		} else {
			$endPointTimestamp = explode("/", date("m/d/Y"));
		}
		$this->smartyVars["endDate"] = $this->reportParams["generalLedgerDateCreatedMax"] = mktime(0,0,0,$endPointTimestamp[0],$endPointTimestamp[1]+1,$endPointTimestamp[2]);

		if ($_REQUEST["ledgerAccountIDs"]){
			$this->reportParams["ledgerAccountID"] = array();
			foreach ($_REQUEST["ledgerAccountIDs"] as $acct){
				if ((int)$acct)$this->reportParams["ledgerAccountID"][] = (int)$acct;
			}
		} else {
			$this->reportParams["ledgerAccountID"] = array(getGeneralLedgerAccountID("accounts_receivable"));
		}

		$this->report =& new ARAgingReport($this->reportParams);
		//dbg($this->report->execute());
		$this->smartyVars["reportData"] = $this->report->execute();
		$this->smartyVars["paginationLinks"] =& $this->smartyVars["reportData"]["paginationLinks"];

		$this->addTemplate("accounting/ShowAgingReport", $this->smartyVars);

	} // execute
} // MB_Action
?>
