<?php
// $Id: ShowCashFlow.php 10474 2007-01-11 23:58:14Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

// Remove the time limit b/c this report can take more than 30 seconds to generate.
// A new way to generate this report may be needed soon.
set_time_limit(0);

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
* @author  Kris Bailey
*/
class ShowCashFlow extends MB_Action {

	function ShowCashFlow() {
		parent::MB_Action();
		$this->stringRep = "ShowCashFlow";

		$this->beginMonth = ((int)$_REQUEST["cashFlowBeginMonth"])?(int)$_REQUEST["cashFlowBeginMonth"]:1;
		$this->beginDay = ((int)$_REQUEST["cashFlowBeginDay"])?(int)$_REQUEST["cashFlowBeginDay"]:1;
		$this->beginYear = ((int)$_REQUEST["cashFlowBeginYear"])?(int)$_REQUEST["cashFlowBeginYear"]:date("Y");

		$this->endMonth = ((int)$_REQUEST["cashFlowEndMonth"])?(int)$_REQUEST["cashFlowEndMonth"]:1;
		$this->endDay = ((int)$_REQUEST["cashFlowEndDay"])?(int)$_REQUEST["cashFlowEndDay"]:1;
		$this->endYear = ((int)$_REQUEST["cashFlowEndYear"])?(int)$_REQUEST["cashFlowEndYear"]:date("Y");

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;

		$this->startYearTime = mktime(0,0,0,1,1,$this->beginYear);

	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();
		$this->smartyVars["startDate"] = $this->startTime;
		$this->smartyVars["endDate"] = $this->endTime;
		
		$ledgerEntries = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetAccountingGeneralLedger",
				"params" => array(
					"generalLedgerDateCreatedLeast" => $this->startTime,
					"generalLedgerDateCreatedGreatest" => $this->endTime,
					"groupByAndSum" => 1,
					"ledgerAccountName" => $this->cashFlowAccounts = array(
						"cash",
						"cash_1",
						"cash_2",
						"accounts_receivable",
						"customer_credits",
						"authorized_payments",
						"deferred_revenue",
					),
					"sortColumn" => "currencyID",
					"sortDir" => "ASC",
				),
			),
		)));

		$this->smartyVars["noData"] = (count($ledgerEntries))?0:1;

		if (!$this->smartyVars["noData"]){
			$this->smartyVars["accountTotals"] = array();
			$this->smartyVars["currencies"] = array();
	
			foreach ($ledgerEntries as $entry){
				$this->smartyVars["currencies"][$entry["currencyID"]] = 1;
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]]["accountInfo"] = $entry;
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]][$entry["currencyID"]]["credits"] += $entry["generalLedgerCreditAmount"];
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]][$entry["currencyID"]]["debits"] += $entry["generalLedgerDebitAmount"];
			}
	
			$this->smartyVars["currencies"] = array_keys($this->smartyVars["currencies"]);
			ksort($this->smartyVars["currencies"]);
		}

		$this->addTemplate("accounting/ShowCashFlow", $this->smartyVars);

	} // execute
} // MB_Action





?>