<?php
// $Id: ShowLedgerAccounts.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on all ledger accountins that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class ShowLedgerAccounts extends MB_Action {
	/**
	 * The constructor for a ShowLedgerAccounts action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowLedgerAccounts() {
		parent::MB_Action();
		$this->stringRep = "ShowLedgerAccounts";
		$this->params = array("ledgerAccountNumber");

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["query"]!="") {
			// test if the searching for a specific column
			if ($_REQUEST["queryColumn"]!="") {
				$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
			} else {
				// test if query is an int, if yes, assume we are searching for the ID
				if (((int) $_REQUEST["query"])) {
					$_REQUEST["clientID"] = $_REQUEST["query"];
				} else {
					// if not an int, then search all other non-ID columns
					foreach($this->params as $value) {
						if ($value!="clientID") {
							$_REQUEST[$value] = $_REQUEST["query"];
						}
					}
				}
			}
		}

		$this->sortColumns = array("ledgerAccountNumber");

	}

	/**
	 * The main method of this class that executes the ShowLedgerAccounts action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();
        $this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

		$query = $this->getMBAPIQuery("GetAccountingLedgerAccounts");
		$CONF["debug"]->add("Action Command (ShowLedgerAccounts:GetAccountingLedgerAccounts)", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result (ShowLedgerAccounts:GetAccountingLedgerAccounts)", $data);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["ledgerAccounts"] = collapseArrayElements($results["ledger_accounts"][0]["account"]);
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["ledgerAccounts"] = array(0 => collapseArrayElements($results["ledger_accounts"][0]["account"]));
			}
			$this->addTemplate("accounting/ShowLedgerAccounts", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowLedgerAccounts
?>