<?php
// $Id: ShowProductsRevenue.php 10474 2007-01-11 23:58:14Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

// Remove the time limit b/c this report can take more than 30 seconds to generate.
// A new way to generate this report may be needed soon.
set_time_limit(0);

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
* @author  Kris Bailey
*/
class ShowProductsRevenue extends MB_Action {

	function ShowProductsRevenue() {
		parent::MB_Action();
		$this->stringRep = "ShowProductsRevenue";

		$this->beginMonth = ((int)$_REQUEST["productsRevenueBeginMonth"])?(int)$_REQUEST["productsRevenueBeginMonth"]:1;
		$this->beginDay = ((int)$_REQUEST["productsRevenueBeginDay"])?(int)$_REQUEST["productsRevenueBeginDay"]:1;
		$this->beginYear = ((int)$_REQUEST["productsRevenueBeginYear"])?(int)$_REQUEST["productsRevenueBeginYear"]:date("Y");

		$this->endMonth = ((int)$_REQUEST["productsRevenueEndMonth"])?(int)$_REQUEST["productsRevenueEndMonth"]:1;
		$this->endDay = ((int)$_REQUEST["productsRevenueEndDay"])?(int)$_REQUEST["productsRevenueEndDay"]:1;
		$this->endYear = ((int)$_REQUEST["productsRevenueEndYear"])?(int)$_REQUEST["productsRevenueEndYear"]:date("Y");

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;

		$this->startYearTime = mktime(0,0,0,1,1,$this->beginYear);

	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();
		$this->smartyVars["startDate"] = $this->startTime;
		$this->smartyVars["endDate"] = $this->endTime;

/*		if ((int)$_REQUEST["clientID"]){
			$packages = arrayFor("packages", array("clientID"=>(int)$_REQUEST["clientID"]));
			$productIDs = array();
			foreach ($packages as $pkg){
				$productIDs[] = $pkg["productID"];
			}
		} else {
			$productIDs = array();
		}*/


		$data = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetProducts",
				"params" => array(
					"recordOffset" => (int)$_REQUEST["recordOffset"],
					"numRecords" => 10,
					"sortDir" => "ASC",
					"sortColumn" => "productID",
				),
			),
		)), 1);
		$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
		$products = grabSimpleMBAPIResults($data);

		$this->smartyVars["products"] = grabHTMLOpsFromArray($products, "productID", array($this, "constructProductName"));
//show($this->smartyVars["products"]);
		$ledgerProductIDs = array_keys($this->smartyVars["products"]);

		// lets get the packages for those ledger entry ids
		$controlData = correctArray(grabResultsFromMBAPIArray2($x = array(
			"mbapi" => array(
				"command" => "GetAccountingControlRel",
				"params" => array(
					"groupingType" => 1,
					"controlType" => getAPITypeID("controls", "products"),
					"controlID" => $ledgerProductIDs,
				),
			),
		)));
//show($x);
//show($controlData);

		$this->smartyVars["productsTotals"] = array();
		foreach ($controlData as $control){
			$prodID = $control["controlID"];
			$ledgerEntries = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetAccountingGeneralLedger",
					"params" => array(
						"generalLedgerDateCreatedLeast" => $this->startTime,
						"generalLedgerDateCreatedGreatest" => $this->endTime,
						"groupByAndSum" => 1,
						"generalLedgerID" => $control["generalLedgerIDs"],
						"ledgerAccountName" => array(
							"revenue",
						),
						"sortColumn" => "currencyID",
						"sortDir" => "ASC",
					),
				),
			)));
	
			foreach ($ledgerEntries as $entry){
				$this->smartyVars["productsTotals"][$prodID][$entry["currencyID"]]["credits"] += $entry["generalLedgerCreditAmount"];
				$this->smartyVars["productsTotals"][$prodID][$entry["currencyID"]]["debits"] += $entry["generalLedgerDebitAmount"];
			}
			
		}

//show($this->smartyVars["productsTotals"]);

/*
		
		$ledgerEntries = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetAccountingGeneralLedger",
				"params" => array(
					"generalLedgerDateCreatedLeast" => $this->startTime,
					"generalLedgerDateCreatedGreatest" => $this->endTime,
					"groupByAndSum" => 1,
					"ledgerAccountName" => $this->productsRevenueAccounts = array(
						"revenue",
					),
					"sortColumn" => "currencyID",
					"sortDir" => "ASC",
				),
			),
		)));

		$this->smartyVars["noData"] = (count($ledgerEntries))?0:1;

		if (!$this->smartyVars["noData"]){
			$this->smartyVars["accountTotals"] = array();
			$this->smartyVars["currencies"] = array();
	
			foreach ($ledgerEntries as $entry){
				$this->smartyVars["currencies"][$entry["currencyID"]] = 1;
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]]["accountInfo"] = $entry;
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]][$entry["currencyID"]]["credits"] += $entry["generalLedgerCreditAmount"];
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]][$entry["currencyID"]]["debits"] += $entry["generalLedgerDebitAmount"];
			}
	
			$this->smartyVars["currencies"] = array_keys($this->smartyVars["currencies"]);
			ksort($this->smartyVars["currencies"]);
		}

*/
		$this->addTemplate("accounting/ShowProductsRevenue", $this->smartyVars);
	
	} // execute
	
	function constructProductName($row){
		if ((int)$row["productAddonGroupID"]){
			return "&nbsp;&nbsp;".TRANS_ADDON.": ".$row["productName"];
		} else {
			return $row["productName"];
		}
	}
	
} // MB_Action





?>