<?php
// $Id: EditAdminGroup.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on an admin group so that that the admin group may be modified in the
 * database.  The ID is passed in, that record is pulled from the database and passed on to the template.
 *
 * @author  Andy Christ
 */
class EditAdminGroup extends MB_Action {
	/**
	 * The constructor for a EditAdminGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditAdminGroup() {
		parent::MB_Action();
		$this->stringRep = "EditAdminGroup";
		$this->params = array("adminGroupID");
	}

	/**
	 * The main method of this class that executes the EditAdminGroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$adminGroupID = ((int) $_REQUEST["adminGroupID"]);
		if(!$adminGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No AdminGroup ID given.");
		} else {

		    // --------------------------------------
		    // Fetch config_groups for the nav menu
		    // --------------------------------------
		    $xmlParams = array
		    (
			    "parentConfigGroupID"=>0,
			    "getNumChildren"=>1,
			    "getLevelOneChildren"=>1
		    );
		    $tmp = $this->params;
		    $this->params = array();
		    $query = $this->getMBAPIQuery("GetConfigGroups","",$xmlParams);
		    $this->params = $tmp;
		    $CONF["debug"]->add("Action Command (Nav)", htmlentities($query), __FILE__, __LINE__);
		    $navConfigGroupData = dispatchMBAPI($query, 1);
		    $CONF["debug"]->add("Action Result (Nav)", $navConfigGroupData, __FILE__, __LINE__);
		    $navConfigGroupsResults =& $navConfigGroupData["mbapi"][0]["results"][0];
		    // fix child config groups structure when only 1 child group exists
		    $numNavGroups = $navConfigGroupData["mbapi"][0]["header"][0]["numResults"][0];
		    for($i=0;$i<$numNavGroups;$i++) {
			    $c =& $navConfigGroupsResults["configGroups"][0]["configGroup"][$i];
			    if((int) $c["numChildren"][0]) {
				    $c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0] =
					    array(0 => @$c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0]);
			    }
		    }

			$query = $this->getMBAPIQuery("GetAdminGroups", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
                $this->smartyVars["navConfigGroups"] =& $navConfigGroupsResults["configGroups"][0]["configGroup"];
				$this->smartyVars["adminGroup"] =& $data["mbapi"][0]["results"][0]["adminGroups"][0]["adminGroup"][0];
                $this->smartyVars = collapseArrayElements($this->smartyVars);
                $this->mergeFormState(array()); // for input validation
				$this->addTemplate("admins/EditAdminGroup", $this->smartyVars, 1);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditAdminGroup
?>