<?php
// $Id: EditAdminGroupResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditAdminGroup action, applies that information to
 * records in the database, and redirects to the ShowAdminGroupDetails action for the given admin group.
 *
 * @author Michael Fountain
 */
class EditAdminGroupResponse extends MB_Action {
	/**
	 * The constructor for an EditAdminGroupResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditAdminGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "EditAdminGroupResponse";
		$this->params = array
		(
			"adminGroupID",
			"adminGroupName",
		);
	}

	/**
	 * The main method of this class that executes the EditAdminGroupResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminGroupID = ((int) $_REQUEST["adminGroupID"]);
		if(!$adminGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No AdminGroup ID given.");
		} else {

			$params = array();

			// --------------------------------------
			// Data: GetAdmins
			// --------------------------------------
/*
			$query = $this->getMBAPIQuery("GetAdmins","",array("sortDir"=>"asc","sortColumn"=>"adminLastName"),0,0,0,0,0,$this->params);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			// assign all admins
			$allAdmins = $data["mbapi"][0]["results"][0]["admins"][0]["admin"];
			if ($data["mbapi"][0]["header"][0]["numResults"][0]==1) {
				$allAdmins = array(0=>$data["mbapi"][0]["results"][0]["admins"][0]["admin"][0]);
			}

			// collect ALL adminIDs in an array to use later
			$allAdminIDs = array();
			foreach($allAdmins as $admin) {
				$allAdminIDs[] = $admin["adminID"][0];
			}
*/
			// --------------------------------------
			// Data: GetAdminGroups
			// --------------------------------------
			$getParams = array
			(
				"getAdminData" => 1,
				"getActionData" => 1,
			);
			$query = $this->getMBAPIQuery("GetAdminGroups","",$getParams);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			// set adminGroup smarty var (only one group returned)
			$adminGroup =& $data["mbapi"][0]["results"][0]["adminGroups"][0]["adminGroup"][0];

			// --------------------------------------
			// Relations: adminID diffs
			// --------------------------------------
			$adminIDsInGroup = $adminRelParams = array();

			if ($_REQUEST["relKey"]=="adminID") {
				// assign all adminIDs in the group to $adminIDsInGroup for later use
				if ($adminGroup["admins"][0]["admin"]) {
					foreach($adminGroup["admins"][0]["admin"] as $admin) {
						$adminIDsInGroup[] = $admin["adminID"][0];
					}
				}
				// we need to test to see if no adminIDs were passed in from the combo box.
				// if none exist, this means we must be removing all admins from this group
				if (!is_array($_REQUEST["addAdminIDs"])) {
					$_REQUEST["addAdminIDs"] = array();
				}
				// find ADD diffs & add to params
				$adminIDs_to_add = array_diff($_REQUEST["addAdminIDs"],$adminIDsInGroup);
				if (count($adminIDs_to_add)>0) {
					$adminRelParams["adminIDs"]["adminID"] = $adminIDs_to_add;
				}
				// find REMOVE diffs & add to params
				$adminIDs_to_remove = array_diff($adminIDsInGroup,$_REQUEST["addAdminIDs"]);
				if (count($adminIDs_to_remove)>0) {
					$adminRelParams["removeAdminIDs"]["adminID"] = $adminIDs_to_remove;
				}
			}

			// --------------------------------------
			// Relations: actionName diffs
			// --------------------------------------
			$actionNamesInGroup = $addActionNames = $actionRelParams = array();

			if ($_REQUEST["relKey"]=="actionName") {
				// assign all actionNames in the group to $actionNamesInGroup for later use
				if (is_array($adminGroup["actions"][0]["actionName"])) {
					$actionNamesInGroup =& $adminGroup["actions"][0]["actionName"];
				}
				// we have to pull out multiple comboAdd_X values from $_REQUEST
				foreach($_REQUEST as $key => $value) {
					if (ereg("comboAdd",$key)) {
						foreach($value as $actionName) {
							$addActionNames[] = $actionName;
						}
						unset($_REQUEST[$key]);
					}
				}
				// find ADD diffs & add to params
				$actionNames_to_add = array_diff($addActionNames,$actionNamesInGroup);
				if (count($actionNames_to_add)>0) {
					$actionRelParams["actionNames"]["actionName"] = $actionNames_to_add;
				}
				// find REMOVE diffs & add to params
				$actionNames_to_remove = array_diff($actionNamesInGroup,$addActionNames);
				if (count($actionNames_to_remove)>0) {
					$actionRelParams["removeActionNames"]["actionName"] = $actionNames_to_remove;
				}
			}

			// --------------------------------------
			// Update relations only
			// --------------------------------------
			$checkRelUpdate = $relUpdateSuccess = false;

			if (count($adminRelParams)>0 || count($actionRelParams)>0) {
				$checkRelUpdate = true;
				$query = $this->getMBAPIQuery("SetAdminGroups", "update", array_merge($adminRelParams,$actionRelParams));
				$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
				$data = dispatchMBAPI($query, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					$relUpdateSuccess = true;
				}
			}

			// --------------------------------------
			// Update group data only
			// --------------------------------------
			$checkEditUpdate = $editUpdateSuccess = false;

			// check to see if we are only changing the name of this group
			// if yes, do it now
			if ( /*count($params)==0 && */$_REQUEST["adminGroupName"]!="") {
				$checkEditUpdate = true;
				$query = $this->getMBAPIQuery("SetAdminGroups", "update");
				$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
				$data = dispatchMBAPI($query, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					$editUpdateSuccess = true;
				}
			}

			// --------------------------------------
			// All updates and relation changes have been made
			// --------------------------------------
			if ( ($checkRelUpdate && $relUpdateSuccess) ||
				 (!$checkEditUpdate || ($checkEditUpdate && $editUpdateSuccess)) ) {

				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
                    if (!$adminGroupID && (int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]) {
					    $adminGroupID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
                    }
					redirect("admins.php",getActionID("ShowAdminGroupDetails"), array("adminGroupID"=>$adminGroupID));
				}

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditAdminGroupResponse
?>