<?php
// $Id: EditAdminResponse.php 12244 2007-11-15 21:34:43Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class EditAdminResponse extends EditResponseAction {

	function EditAdminResponse() {
		parent::EditResponseAction();
		$this->stringRep = "EditAdminResponse";
		$this->setDataSource(new DataSource("admins"));
		if(!empty($_REQUEST["updateGroups"])) {
			$this->params[] = "adminGroup";
		}
	}

	function editResponseValidationHandler() {
		if(!empty($_REQUEST["updateGroups"])) {
			$this->validateParam("adminGroups", 0, true);
		}
		return true;
	}

	function editResponseParamHandler() {
        $adminID = (int) $_REQUEST["adminID"];

		$q =& new MBQuery("GetAdmins", "", array("adminID" => $adminID, "getAdminGroupData" => 1));
		if(!$this->addErrorsFromResult($r =& $q->getResult())) return false;
		
		if(!empty($_REQUEST["updateGroups"])) {
			$adminGroupTable = $r->getTableFrom(array("mbapi", "results", "admins", "admin", "adminGroupIDs"));
			$currentAdminGroupIDs = $adminGroupTable->getColumnDistinct("adminGroupID");
			$selectedAdminGroupIDs = isset($_REQUEST["adminGroups"]) && is_array($_REQUEST["adminGroups"]) ? $_REQUEST["adminGroups"] : array();
			$params = $this->getRelationParams($selectedAdminGroupIDs, $currentAdminGroupIDs, "adminGroupIDs", "adminGroupID");
		}
		// only update the accessHash if set
		if(!empty($_REQUEST["accessHash"])) {
			$params["adminRemoteAccessHash"] = sha1(microtime(1) + mt_rand(1,1000000000));
		}
		$this->d->mergeParams($params);
		
		return true;
	}
	
}
?>
