<?php
// $Id: RecordAdminActions.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It records the actions being performed
 * so that they can be added to an existing admin group.
 *
 * @author  Andy Christ
 */
class RecordAdminActions extends MB_Action {

	function RecordAdminActions() {
		parent::MB_Action();
		$this->stringRep = "RecordAdminActions";
	}

	function execute() {
		global $CONF;

		// set all possible xml params here, $_POST is already cleaned
		$params = array("actionName");

		$adminGroupID = $_REQUEST["adminGroupID"];

		//Stop it if the array is built
		if($CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]]) {
			$recording = unserialize($CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]]);
			//Get rid of duplicates
			$actionNames = array_flip(array_flip($recording["actionNames"]));

			//Default actions
			$actionNames[] = "LoginResponse";
			$actionNames[] = "ShowLogin";
			$actionNames[] = "LogoutResponse";
			$actionNames[] = "ShowClientStats";

			$cmd = "<mbapi>
						<command>SetAdminGroups</command>
						<subCommand>update</subCommand>
						<params>
							<adminGroupID>".$recording["adminGroupID"]."</adminGroupID>
							<actionNames>";
				foreach($actionNames as $value) {
					if($value != "RecordAdminActions")
					$cmd .= "<actionName>$value</actionName>\n";
				}
				$cmd .= "</actionNames>\n";
			$cmd .= "</params>
					</mbapi>";

			$data = dispatchMBAPI($cmd, 1);
			$CONF["debug"]->add("Action Result", $data);

			$CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]] = "";
			storeConfigs("system", "internal");

			$m = & new QueryMaster("delete", "config_params");
			$m->addAndClause("config_param_name", "=", "recording".$CONF["user"]["sessionID"], "s");
			$CONF["debug"]->add("Stop Recording", $m->getQuery(), __FILE__, __LINE__);
			$m->execute();
			redirect("admins.php",getActionID("ShowAdminGroupDetails"),array("adminGroupID" => $recording["adminGroupID"]));

		} else {
			$record["adminGroupID"] = $adminGroupID;
			$record["actionNames"] = "";
			$CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]] = serialize($record);
			storeConfigs("system", "internal");

		}
		if($this->addMBAPIErrors($data) === 0) {
			// show new admin record
			redirect("admins.php",getActionID("ShowAdminGroupDetails"),array("adminGroupID" => $recording["adminGroupID"]));
		}

	} // execute

} // MB_Action
?>