<?php
// $Id: ShowAdminGroupDetails.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["adminGroupID"] it displays all
 * the details for the found admin group, and only displays the details of a single admin group.
 *
 * @author  Andy Christ
 * @author  Michael Fountain
 */
class ShowAdminGroupDetails extends MB_Action {
	/**
	 * The constructor for a ShowAdminGroupDetails object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowAdminGroupDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowAdminGroupDetails";
		$this->params = array("adminGroupID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminGroupID = ((int) $_REQUEST["adminGroupID"]);
		$canRecordActions = FALSE;
		if(!$adminGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No AdminGroup ID given.");
		} else {

		    // --------------------------------------
		    // Fetch config_groups for the nav menu
		    // --------------------------------------
		    $xmlParams = array
		    (
			    "parentConfigGroupID"=>0,
			    "getNumChildren"=>1,
			    "getLevelOneChildren"=>1
		    );
		    $tmp = $this->params;
		    $this->params = array();
		    $query = $this->getMBAPIQuery("GetConfigGroups","",$xmlParams);
		    $this->params = $tmp;
		    $CONF["debug"]->add("Action Command (Nav)", htmlentities($query), __FILE__, __LINE__);
		    $navConfigGroupData = dispatchMBAPI($query, 1);
		    $CONF["debug"]->add("Action Result (Nav)", $navConfigGroupData, __FILE__, __LINE__);
		    $navConfigGroupsResults =& $navConfigGroupData["mbapi"][0]["results"][0];
		    // fix child config groups structure when only 1 child group exists
		    $numNavGroups = $navConfigGroupData["mbapi"][0]["header"][0]["numResults"][0];
		    for($i=0;$i<$numNavGroups;$i++) {
			    $c =& $navConfigGroupsResults["configGroups"][0]["configGroup"][$i];
			    if((int) $c["numChildren"][0]) {
				    $c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0] =
					    array(0 => @$c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0]);
			    }
		    }

			//Find out if we can display the "Record" function
			$query = $this->getMBAPIQuery("GetAdmins","",array("adminID" => $CONF["user"]["id"], "getAdminGroupData" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			$admin = $data["mbapi"][0]["results"][0]["admins"][0]["admin"][0];

			if($CONF["user"]["email"] == $admin["adminEmail"][0]) {
				$adminGroups = $admin["adminGroupIDs"][0]["adminGroupID"];
				foreach($adminGroups as $k => $v) {
					//NOTE: getMBAPIQuery is adding extra adminGroupIDs
					$query = "<mbapi>
						<command>GetAdminGroups</command>
						<params>
							<adminGroupID>".$v."</adminGroupID>
							<getActionData>1</getActionData>
						</params>
					</mbapi>";
					$data = dispatchMBAPI($query, 1);
					$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
					$data = $data["mbapi"][0]["results"][0]["adminGroups"][0];
					
					if($data) {
						$actionNames = $data["adminGroup"][0]["actions"][0]["actionName"];
					}

					if($actionNames) {
						foreach($actionNames as $actionName) {
							if($actionName == "RecordAdminActions") {
								$canRecordActions = TRUE;
							}
						}
					}
				}
			}

			// fetch all admins
			$query = $this->getMBAPIQuery("GetAdmins","",array("sortDir"=>"asc","sortColumn"=>"adminLastName"),0,0,0,0,0,$this->params);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			// assign all admins
			$allAdmins = $data["mbapi"][0]["results"][0]["admins"][0]["admin"];
			if ($data["mbapi"][0]["header"][0]["numResults"][0]==1) {
				$allAdmins = array(0=>$data["mbapi"][0]["results"][0]["admins"][0]["admin"][0]);
			}
			if(!is_array($allAdmins)) {
				$this->addError(TRANS_ACTIONERROR, "Unable to fetch all admins.");
			} else {

				// collect ALL adminIDs in an array to use later
				$allAdminIDs = array();
				foreach($allAdmins as $admin) {
					$allAdminIDs[] = $admin["adminID"][0];
				}

				// fetch this admin group
				$params = array
				(
					"getAdminData" => 1,
					"getActionData" => 1,
				);
				$query = $this->getMBAPIQuery("GetAdminGroups","",$params);
				$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
				$data = dispatchMBAPI($query, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {

						$smartyVars = array();

						// --------------------------------------
						// Data from: admin_groups
						// --------------------------------------

						// set adminGroup smarty var (only one group returned)
						$smartyVars["adminGroup"] =& $data["mbapi"][0]["results"][0]["adminGroups"][0]["adminGroup"][0];

						// --------------------------------------
						// Relations from: admin_group_rel
						// --------------------------------------

						// set adminsInGroup smarty var & correct offset if only 1 admin is returned
						// this will be an array of all admin data where the admin's are assigned to this group
						$smartyVars["adminsInGroup"] = array();
						if(is_array($smartyVars["adminGroup"]["admins"][0]["admin"])) {
							$smartyVars["adminsInGroup"] = $smartyVars["adminGroup"]["admins"][0]["admin"];
							if(count($smartyVars["adminGroup"]["admins"][0]["admin"])==1) {
								$smartyVars["adminsInGroup"] = array($smartyVars["adminGroup"]["admins"][0]["admin"][0]);
							}
							foreach($smartyVars["adminsInGroup"] as $admin) {
								if(is_array($admin["adminID"]) && count($admin["adminID"]) && ((int) $admin["adminID"][0])) {
									$smartyVars["adminInOptions"][$admin["adminID"][0]] = $admin["adminLastName"][0].", "
										.$admin["adminFirstName"][0];
								}
							}
						}

						// nuke nested admins data from adminGroup param, this makes the smarty data easier to deal with
						unset($smartyVars["adminGroup"]["admins"]);

						// assign all adminIDs in the group to $adminIDsInGroup for later use
						$adminIDsInGroup = array();
						foreach($smartyVars["adminsInGroup"] as $admin) {
							if(is_array($admin["adminID"]) && count($admin["adminID"])) {
								$adminIDsInGroup[] = $admin["adminID"][0];
							}
						}

						// assign all adminIDs NOT in the group to $adminIDsNotInGroup for later use
						$adminIDsNotInGroup = array();
						foreach($allAdminIDs as $adminID) {
							if (!in_array($adminID,$adminIDsInGroup)) {
								$adminIDsNotInGroup[] = $adminID;
							}
						}

						// set adminsNotInGroup smarty var
						// this will be an array of all admin data where the admin's are NOT assigned to this group
						$lookupAdminID = array_flip($allAdminIDs);
						$smartyVars["adminsNotInGroup"] = array();
						foreach($adminIDsNotInGroup as $adminID) {
							$smartyVars["adminsNotInGroup"][] = $allAdmins[$lookupAdminID[$adminID]];
						}

						// set adminInOptions for the select list of admins NOT in this group
						foreach($smartyVars["adminsNotInGroup"] as $admin) {
							if (((int) $admin["adminID"][0])) {
								$smartyVars["adminNotInOptions"][$admin["adminID"][0]] = $admin["adminLastName"][0].", ".$admin["adminFirstName"][0];
							}
						}

						// --------------------------------------
						// Relations from: admin_group_action_rel
						// --------------------------------------

						$formElements = $actionCategoriesEven = $actionCategoriesOdd = $adminGroupActions = array();
						$rawCategories = getActionCategories();
						if (is_array($smartyVars["adminGroup"]["actions"][0]["actionName"])) {
							$adminGroupActions = $smartyVars["adminGroup"]["actions"][0]["actionName"];
						}

						$i = 1;
						foreach($rawCategories as $catName => $actions) {
							if ($i %2 === 0) {
								foreach($actions as $actionName) {
									if (in_array($actionName,$adminGroupActions)) {
										$actionCategoriesEven[$catName]["comboAdd"][] = $actionName;
									} else {
										$actionCategoriesEven[$catName]["comboRemove"][] = $actionName;
									}
								}
								$formElements[] = "comboAdd_$catName";
							} else {
								foreach($actions as $actionName) {
									if (in_array($actionName,$adminGroupActions)) {
										$actionCategoriesOdd[$catName]["comboAdd"][] = $actionName;
									} else {
										$actionCategoriesOdd[$catName]["comboRemove"][] = $actionName;
									}
								}
								$formElements[] = "comboAdd_$catName";
							}
							$i++;
						}

						// --------------------------------------
						// Show template
						// --------------------------------------

                        $smartyVars["navConfigGroups"] =& $navConfigGroupsResults["configGroups"][0]["configGroup"];
						$smartyVars = collapseArrayElements($smartyVars);
						$smartyVars["adminGroupActions"] =& $adminGroupActions;
						$smartyVars["actionCategoriesEven"] =& $actionCategoriesEven;
						$smartyVars["actionCategoriesOdd"] =& $actionCategoriesOdd;
						$smartyVars["formElements"] =& $formElements;
						$smartyVars["numActionCategories"] = $i-1;
						$smartyVars["canRecordActions"] = $canRecordActions;
					    $this->addTemplate("admins/ShowAdminGroupDetails",$smartyVars, 1);

					} else {
						$this->addError(TRANS_ACTIONERROR, "AdminGroup does not exist.");
					}
				}

			}

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowAdminGroupDetails
?>