<?php
// $Id: ShowAdminGroups.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all admingroups that match the given parameters, and 
 * generates the display of that information.
 *
 * @author	Michael Fountain
 */
class ShowAdminGroups extends MB_Action {
	/**
	 * The constructor for a ShowAdminGroups action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowAdminGroups() {
		parent::MB_Action();
		$this->stringRep = "ShowAdminGroups";

		$this->params = array
		(
			"adminGroupID",
			"adminGroupName"
		);
		$this->sortColumns = array
		(
			"adminGroupName",
			"adminGroupID",
		);
	}

	/**
	 * The main method of this class that executes the ShowAdminGroups action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetAdminGroups", "", array(), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

			$this->smartyVars["adminGroups"] = $results["adminGroups"][0]["adminGroup"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["adminGroups"] = array(0 => $results["adminGroups"][0]["adminGroup"]);
			}
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];

            $this->smartyVars = collapseArrayElements($this->smartyVars);
			$this->mergeSystemNavData();
			$this->addTemplate("admins/ShowAdminGroups",$this->smartyVars, 1);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowAdminGroups
?>