<?php
// $Id: ShowAdminStats.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It displays the admin stats page.
 *
 * @author  Michael Fountain
 */
class ShowAdminStats extends MB_Action {

	function ShowAdminStats() {
		parent::MB_Action();
		$this->stringRep = "ShowAdminStats";
	}

	function execute() {
		global $CONF;
		parent::execute();

		// --------------------------------------
		// Fetch config_groups for the nav menu
		// --------------------------------------
		$xmlParams = array
		(
			"parentConfigGroupID"=>0,
			"getNumChildren"=>1,
			"getLevelOneChildren"=>1
		);
		$query = $this->getMBAPIQuery("GetConfigGroups","",$xmlParams,0,0,0,0,0,$this->params);
		$CONF["debug"]->add("Action Command (Nav)", htmlentities($query), __FILE__, __LINE__);
		$navConfigGroupData = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result (Nav)", $navConfigGroupData, __FILE__, __LINE__);
		$navConfigGroupsResults =& $navConfigGroupData["mbapi"][0]["results"][0];
		// fix child config groups structure when only 1 child group exists
		$numNavGroups = $navConfigGroupData["mbapi"][0]["header"][0]["numResults"][0];
		for($i=0;$i<$numNavGroups;$i++) {
			if ($navConfigGroupsResults["configGroups"][0]["configGroup"][$i]["children"][0]["numChildren"][0]["numChildren"][0]==1) {
				$navConfigGroupsResults["configGroups"][0]["configGroup"][$i]["levelOneConfigGroups"][0]["levelOneConfigGroup"][0] =
					array(0=>$navConfigGroupsResults["configGroups"][0]["configGroup"][$i]["levelOneConfigGroups"][0]["levelOneConfigGroup"][0]);
			}
		}

		$smartyVars = array();

		// setup vars for config navs
		// + 1 is to account for the support category in navNumDisplayResults
		$smartyVars["navNumDisplayResults"] = $numNavGroups + 1;
		$smartyVars["navNumDisplayRows"] = ceil($smartyVars["navNumDisplayResults"]/4);
		$smartyVars["navConfigGroups"] =& $navConfigGroupsResults["configGroups"][0]["configGroup"];

		// Set the templete for output
		$this->addTemplate("admins/ShowAdminStats", collapseArrayElements($smartyVars), 1);

	} // execute

} // MB_Action
?>