<?php
// $Id: GetAutocompleteClients.php 11713 2007-07-30 19:37:24Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/autocompleteAction.php");

/**
 * This class is a child class of AutocompleteAction. It will return a list of clients that match what you are typing.
 *
 * @author  Kris Bailey
 */
class GetAutocompleteClients extends AutocompleteAction {
	/**
	 * 
	 */
	function GetAutocompleteClients() {
		parent::AutocompleteAction();
		$this->stringRep = "GetAutocompleteClients";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the GetAutocompleteClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clients = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetAutocompleteClients",
				"params" => array(
					"searchTerm" => $_REQUEST["searchTerm"],
				),
			),
		));
		
		$keyedClients = array();
		foreach ($clients as $x=>$c){
			if ($x>MAX_AUTOCOMPLETE_RESULTS) break;
			$c["nameValue"] = $c["contactLastName"].", ".$c["contactFirstName"];
			$keyedClients[] = $c;
		}
		$this->autocompleteOutput($keyedClients);
	
	} // execute
} // GetAutocompleteClients
?>
