<?php
// $Id: AddBookmarkResponse.php 7971 2006-07-06 18:30:55Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["bookmarkID"] and displays all
 * the client detail information for editing.
 *
 * @author  Mark Garrett
 */
class AddBookmarkResponse extends MB_Action {

	/**
	 * The constructor for a AddBookmarkResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params.
	 */
	function AddBookmarkResponse() {
		parent::MB_Action();
		$this->stringRep = "AddBookmarkResponse";
		$this->params = array
		(
			"bookmarkName",
			"bookmarkURL",
			"bookmarkAction",
			"bookmarkArgs",
			"bookmarkTarget",
			"bookmarkWindowWidth",
			"bookmarkWindowHeight",
			"bookmarkCount"
		);
	}
	
	/**
	 * The main method of this class that executes the AddBookmarkResponse action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!$_REQUEST["bookmarkURL"]) {
			$this->addError(TRANS_ACTIONERROR, "No bookmark URL given.");
		} elseif (!notNull($_REQUEST["bookmarkName"])) {
			$this->addError(TRANS_ACTIONERROR, "No Bookmark Name given.");
		} else {
			if($CONF["user"]["type"]==2 || $CONF["user"]["type"]==0) {
				$userID = array("adminID" => $CONF["user"]["id"]);
			}else{
				$userID = array("clientID" => $CONF["user"]["id"]);
			}
			$query = $this->getMBAPIQuery("SetBookmarks", "insert", $userID);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			$header =& $data["mbapi"][0]["header"][0];

			// check for errors
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				#redirect("bookmarks.php");
				redirect($_REQUEST["bookmarkURL"]."?action=".getActionID($_REQUEST["bookmarkAction"])."&".$_REQUEST["bookmarkArgs"]);
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>