<?php
// $Id: EditBookmarkResponse.php 11737 2007-08-03 21:33:01Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditBookmark action
 * and modifies an existing client record if data is valid; else redirects back to a list
 * of bookmarks.
 *
 * @author  Mark Garrett
 */
class EditBookmarkResponse extends MB_Action {
	/**
	 * The constructor for a EditBookmarkResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditBookmarkResponse() {
		parent::MB_Action();
		$this->stringRep = "EditBookmarkResponse";
		$this->params = array(
		"bookmarkID",
		"bookmarkURL",
		"bookmarkName",
		"bookmarkTarget",
		"bookmarkWindowWidth",
		"bookmarkWindowHeight",
		"bookmarkCount");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$bookmarkID = ((int) $_REQUEST["bookmarkID"]);
		if(!$bookmarkID) {
			$this->addError(TRANS_ACTIONERROR, "No bookmark ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetBookmarks", "update");
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
		// check for errors
			if ($this->addMBAPIErrors($data) === 0) {
				// show bookmarks
				
				mbHeader("Location: bookmarks.php");
			}
		} // bookmarkID
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // EditBookmarkResponse
?>