<?php
// $Id: ShowBookmarks.php 8004 2006-07-10 16:10:11Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+



if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. it displays all of the bookmarks for
 * a user or admin with links available for editing and removing individual bookmarks.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */

class ShowBookmarks extends MB_Action {
	/**
	 * The constructor for a ShowBookmarks action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowBookmarks() {
		parent::MB_Action();
		$this->stringRep = "ShowBookmarks";

		$this->params = array("bookmarkID", "adminID");
		$this->sortColumns = array("bookmarkCount", "bookmarkID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$requestedAdminID = $CONF["user"]["id"];
		if (notZero( $_REQUEST["adminID"] ))
			$requestedAdminID = (int)$_REQUEST["adminID"];

		$query =& new MBQuery("GetBookmarks", "", array("adminID" => $requestedAdminID, "sortDir" => "desc"));
		$data = $query->GetResult();

		if (!$data->getErrorCount()) {
			$data = $data->getStructure();
			
			// Assign smarty variables
			$this->smartyVars["bookmarkList"] = grabSimpleMBAPIResults( $data );
			
			$this->smartyVars["targets"] = array(
				"_self" => TRANS_LOAD_BOOKMARK_MAIN_PAGE,
				"_top" => TRANS_LOAD_BOOKMARK_MAIN_PAGE,
				"_blank" => TRANS_LOAD_BOOKMARK_NEW_PAGE);

			$this->smartyVars["paginationLinks"] = $data["mbapi"][0]["results"][0]["paginationLinks"][0];
			$this->mergeSystemNavData();
			// Set the templete for output
			$this->addTemplate("bookmarks/ShowBookmarks");
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>