<?php
// $Id: AddCertResponse.php 6750 2006-05-10 20:01:46Z mfountain $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 * This Action object takes information provided by the AddCert action, applies that
 * information to * records in the database, and redirects to the ShowCertDetails action
 * for the given cert.
 *
 * @author  Michael Fountain
 */
class AddCertResponse extends MB_Action {
	/**
	 * The constructor for an AddCertResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddCertResponse() {
		parent::MB_Action();
		$this->stringRep = "AddCertResponse";
		$this->params = array(
			"clientID",
			"domainName",
			"certTimestamp",
			"orID",
			"rID",
			"ctCode",
			"afID",
			"orStatus",
			"orStartstamp",
			"orSubmitstamp",
			"orSyncstamp",
			"orSUCCESSCODE",
			"orErrorcode",
			"orErrormsg",
			"orTechSameAsAdmin",
			"orBillSameAsPrevious",
			"ODMethod",
			"ODProductCode",
			"ODValidityPeriod",
			"ODServerCount",
			"ODPrice",
			"ODRenewalBehavior",
			"ODSpecialInstructions",
			"ODPartnerOrderID",
			"ODGeoTrustOrderID",
			"ODOrderDate",
			"ODOrderCompleteDate",
			"ODOrderDeactivatedDate",
			"ODOrderStatusMajor",
			"ODOrderStatusMinorCode",
			"ODOrderStatusMinorName",
			"ODApproverNotifiedDate",
			"ODApproverConfirmDate",
			"ODApproverEmailAddress",
			"ORGOrganizationName",
			"ORGDUNS",
			"ORGAddressLine1",
			"ORGAddressLine2",
			"ORGAddressLine3",
			"ORGCity",
			"ORGRegion",
			"ORGPostalCode",
			"ORGCountry",
			"ORGPhone",
			"ORGFax",
			"ACFirstName",
			"ACLastName",
			"ACPhone",
			"ACEmail",
			"TCFirstName",
			"TCLastName",
			"TCPhone",
			"TCEmail",
			"BCFirstName",
			"BCLastName",
			"BCPhone",
			"BCEmail",
			"CSRCSR",
			"CSRWildCard",
			"CSRSubject",
			"CSRDomainName",
			"CSRCountry",
			"CSREmail",
			"CSRLocality",
			"CSROrganization",
			"CSROrganizationUnit",
			"CSRState",
			"CSRIsValidDomainName",
			"CSRHasBadExtensions",
			"CSRCommonName",
			"CSRWebServerType",
			"CSRDNSNames",
			"CSRCertificateStatus",
			"CSRStartDate",
			"CSREndDate",
			"CSRSerialNumber",
			"UPGCUIndicator",
			"UPGCUCertificate",
			"UPGCUmonths",
			"UPGCUSerialNumber",
			"UPGCUExpirationDate",
			"UPGCUIssuer",
			"RIRenewalIndicator",
			"RIRenewalMonths",
			"RIRenewalSerialNumber",
			"RIRenewalExpirationDate",
			"RIRenewalOrderID",
			"RIRenewalProductCode",
			"FFCACertType",
			"FFCACert",
			"FFServerCertificate",
			"FFIconScript",
			"FFChoicePointURL",
			"FFCpsURL");
	}

	/**
	 * The main method of this class that executes the AddCertResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("SetCerts", "insert");
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

		$certID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
		if ($certID == 0) {
			$this->addError(TRANS_ACTIONERROR, "No cert ID returned from insert.");
		}

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors() && $certID > 0) {
			
			redirect("certs.php","ShowCertDetails",array("certID"=>$certID));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddCertResponse
?>