<?php
// $Id: AddBillingAccount.php 10474 2007-01-11 23:58:14Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It displays a form to add a new
 * client billing account record.
 *
 * @author  Michael Fountain
 */
class AddBillingAccount extends MB_Action {

	function AddBillingAccount() {
		parent::MB_Action();
		$this->stringRep = "AddBillingAccount";
		$this->params = array(
			"clientID",
			"clientContactID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		$clientContactID = getParam('clientContactID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("getContactData"=> "4"));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"][0]);
				$this->smartyVars["contact"] = collapseArrayElements($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];
				$this->smartyVars["bankAccountTypes"] = $CONF["types"]["bankAccount"];
				$this->smartyVars["cardTypes"] = $CONF["types"]["card"];
				$this->smartyVars["cardExtraTypes"] = $CONF["types"]["cardExtraIDs"];
				
				$formDefaults = array(
					"billingAccountOrder" => "0",
					"billingAccountPercent" => "100.0",
				);
				if ($_REQUEST["comboAction"] == "AddNewClient") {
					$formDefaults["comboAction"] = "AddNewClient";
				}

				$this->mergeFormState($formDefaults);
				// do we have an lek stored?
				if ($CONF["system"]["encryption"]["lek_pin"]==''){
					$this->smartyVars["needKey"] = 1;
				}

				$this->addTemplate("clients/AddBillingAccount", $this->smartyVars);
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
} // MB_Action
?>
