<?php
// $Id: AddClientContact.php 10474 2007-01-11 23:58:14Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * @author  Michael Fountain
 */
class AddClientContact extends MB_Action {

	/**
	 */
	function AddClientContact() {
		parent::MB_Action();
		$this->stringRep = "AddClientContact";
		$this->params = array(
			"clientID"
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam("clientID");
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			// Only merge the primary contact IF the client already has one.
			// A client will not have a primary contact using the new add client
			// steps.
			if ($_REQUEST["comboAction"] == "AddNewClient" || 
				$_REQUEST["d-comboAction"] == "-AddNewClient") {
				$mergePrimaryContact = 0;
			} else {
				$mergePrimaryContact = 1;
			}

			$query = $this->getMBAPIQuery("GetClients", "", array(
				"mergePrimaryContact" => $mergePrimaryContact
			));
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$this->mergeCountryData();
				$this->mergeLanguageData($CONF["user"]["locale"]->language);
				$this->smartyVars["client"] = correctArray($results["clients"][0]["client"][0]);

				$this->smartyVars["emailActions"] = $CONF["types"]["emailAction"];				
				$this->smartyVars["comboAction"] = $_REQUEST["comboAction"];
				
				$formDefaults = array(
					"clientID" => $clientID,
					"countriesID" => $this->smartyVars["client"]["countriesID"],
					"languageID" => $this->smartyVars["selectedLanguage"],
				);

				if ($_REQUEST["comboAction"] == "AddNewClient") {
					$formDefaults["comboAction"] = "AddNewClient";
					$formDefaults["contactCompany"] = $this->smartyVars["client"]["clientCompany"];
				}

				$this->mergeFormState($formDefaults);
				$this->addTemplate("clients/AddClientContact", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddClientContact
?>
