<?php
// $Id: AddClientContactResponse.php 11121 2007-05-11 16:26:50Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It handles the data from AddClientContact action
 * and creates a new client record if data is valid; else redirects back to AddClientContact.
 *
 * @author  Michael Fountain
 */
class AddClientContactResponse extends MB_Action {

	function AddClientContactResponse() {
		parent::MB_Action();
		$this->stringRep = "AddClientContactResponse";

		// set all possible xml params here, $_REQUEST is already cleaned
		$this->params = array
		(
			"clientID",
			"contactFirstName",
			"contactLastName",
			"contactUsername",
			"contactPassword",
			"contactEmail",
			"contactEmailFormat",
			"contactCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"contactZip",
			"countriesID",
			"languageID",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"contactPrimary",
			"contactMobilePhone",
			"contactCounty",
			"emailActionIDs",
			"contactActive"
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("AddClientContact"));
		$this->setReferralActionFile("clients.php");
		$success = $this->validateMultiInputs(
			array(
				"clientID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"contactFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactEmailFormat" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"contactCompany" => INPUT_RESTRICTION_STRING,
				"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactAddress2" => INPUT_RESTRICTION_STRING,
				"contactCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactZip" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"countriesID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"languageID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"contactPhone1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPhone2" => INPUT_RESTRICTION_STRING,
				"contactFax" => INPUT_RESTRICTION_STRING,
				"contactPrimary" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"contactMobilePhone" => INPUT_RESTRICTION_STRING,
				"contactCounty" => INPUT_RESTRICTION_STRING,
				"contactUsername" => INPUT_RESTRICTION_STRING,
				"comboAction" => INPUT_RESTRICTION_STRING,
				"emailActionIDs" => INPUT_RESTRICTION_ARRAY,
			)
		);
		if($success) {
			$clientID = ((int) $_REQUEST["clientID"]);
			if(!$clientID) {
				$this->addError(TRANS_ACTIONERROR, "No client ID given.");
			} elseif($success) {
				$xmlParams = "";
				foreach ($this->params as $paramName) {
					if (isset($_REQUEST[$paramName])) {
						// set xml paramValue
						if ($paramName == "emailActionIDs"){
							$xmlParams .= "<emailActionIDs>\n";
							foreach($_REQUEST[$paramName] as $key=>$eaid){
								$xmlParams .= "<emailActionID>".(int)$eaid."</emailActionID>\n";
							}
							$xmlParams .= "</emailActionIDs>\n";
						}else{
							$xmlParams .= "<".$paramName.">".$_REQUEST[$paramName]."</".$paramName.">\n";
						}
					}
				}
	
				// create sanatized xml command
				$cmd = "
<mbapi>
	<command>SetClients</command>
	<subCommand>update</subCommand>
	<params>
		<clientID>$clientID</clientID>
		<clientContacts>
			<clientContact>
				$xmlParams
			</clientContact>
		</clientContacts>
	</params>
</mbapi>
				";
				
				$data = dispatchMBAPI($cmd, 1);

				$results =& $data["mbapi"][0]["results"][0];
				
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						if ($_REQUEST["comboAction"] == "AddNewClient") {
						
							$clientData = grabResultsFromMBAPIArray(array(
								"mbapi" => array(
									"command" => "GetClients",
									"params" => array(
										"clientID" => $clientID,
										"mergePrimaryContact" => "1",
									),
								),
							));

							redirect("clients.php", getActionID("AddBillingAccount"), array(
								"clientID" => $clientID,
								"clientContactID" => $clientData[0]["clientContactID"],
								"comboAction" => "AddNewClient"
							));

 						} else {

							redirect("clients.php", getActionID("ShowClientContacts"), array("clientID"=>$clientID));

						}
					}
				}
	
			}
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
