<?php
// $Id: EditBasicClientAttributesResponse.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientID"] and displays
 * the attributes for that client to be edited.
 *
 * @author  modernbill
 */
class EditBasicClientAttributesResponse extends MB_Action {

	function EditBasicClientAttributesResponse() {
		parent::MB_Action();
		$this->stringRep = "EditBasicClientAttributesResponse";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			/*
["activeAttributes"]["reseller"] = yes
["activeAttributes"]["preferredcustomer"] = yes
["activeAttributes"]["maximumdiscount"] = yes
["activeAttributes"]["minimumdiscount"] = yes
["activeAttributes"]["suspensionexempt"] = no
["attributeValues"]["reseller"] = yes
["attributeValues"]["preferredcustomer"] = yes
["attributeValues"]["maximumdiscount"] = 20
["attributeValues"]["minimumdiscount"] = 10
["attributeValues"]["suspensionexempt"] = 
			*/

			$this->smartyVars["client"] = oneById("clients", $clientID, array("mergePrimaryContact" => 1));
			$keyedAttributes = optionsFor("attributes", array());
			$namedAttributes = array_flip($keyedAttributes);
			dbg("attributes:");
			dbg($keyedAttributes);
			dbg($namedAttributes);
			
			$defaultAttrs = array_keys($CONF["types"]["programaticAttributes"]);
			foreach ($defaultAttrs as $attrName){
				if (!$namedAttributes[$attrName]){
					$namedAttributes[$attrName] = "x";
				}
			}
			
			$clientAttributes = arrayFor("clientAttributes", array("clientID" => $clientID));
			$keyedClientAttributes = array();
			foreach ($clientAttributes as $attr){
				if ($_REQUEST["activeAttributes"][$keyedAttributes[$attr["attributeID"]]]=="no"){
					deleteForKey("clientAttributes", $attr["clientAttributeID"]);
				} else {
					$keyedClientAttributes[$keyedAttributes[$attr["attributeID"]]] = $attr["clientAttributeID"];
				}
			}

			foreach ((array)$_REQUEST["activeAttributes"] as $aName=>$active){
				if ($active=="yes"){
					$attributeID = $namedAttributes[$aName];
					if ($attributeID=="x"){
						$namedAttributes[$aName] = $attributeID = insertFor("attributes", array(
							"attributeName" => $aName,
							"attributeType" => 0,
							"attributeSubtype" => 0,
						));
					}
					
					$clientAttributeID = $keyedClientAttributes[$aName];
					if (!(int)$clientAttributeID){
						$keyedClientAttributes[$aName] = $clientAttributeID = insertFor("clientAttributes", array(
							"attributeID" => $attributeID,
							"clientID" => $clientID,
							"clientAttributeValue" => $_REQUEST["attributeValues"][$aName],
						));
					} else {
						updateFor("clientAttributes", array(
							"clientAttributeID" => $clientAttributeID,
							"clientAttributeValue" => $_REQUEST["attributeValues"][$aName],
						));
					}
					
				}
			}


			redirect("clients.php", "ShowClientDetails", array("clientID" => $clientID));

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditBasicClientAttributesResponse
?>
