<?php
// $Id: EditBillingAccount.php 12694 2008-02-26 22:50:18Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["billingAccountID"]
 * and displays all the client billing account detail information.
 *
 * @author  Michael Fountain
 */
class EditBillingAccount extends MB_Action {

	function EditBillingAccount() {
		parent::MB_Action();
		$this->stringRep = "EditBillingAccount";
		$this->params = array(
			"clientID",
			"clientContactID",
			"billingAccountID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		$clientContactID = getParam('clientContactID');
		$billingAccountID = getParam('billingAccountID');
		
		if (!$clientContactID && $billingAccountID){
			$accountInfo = oneByID("billingAccounts", $billingAccountID);
			$clientContactID = $accountInfo["clientContactID"];
		}
		if (!$clientID && $clientContactID){
			$contactInfo = oneByID("clientContacts", $clientContactID);
			$clientID = $contactInfo["clientID"];
		}
		
		if(!$billingAccountID) {
			$this->addError(TRANS_ACTIONERROR, "No billing account ID given.");
		} else if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
		} else if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("getContactData"=>"3", "getBillingData"=>"4"));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				// do we have an lek stored?
				if ($CONF["system"]["encryption"]["lek_pin"]==''){
					$this->smartyVars["needKey"] = 1;
				}

				
				$this->smartyVars["client"] = correctArray($results["clients"][0]["client"][0]);
				$this->smartyVars["contact"] = correctArray($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				$this->smartyVars["billingAccount"] = collapseArrayElements($results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"][0]);
				$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];
				$this->smartyVars["bankAccountTypes"] = $CONF["types"]["bankAccount"];
				$this->smartyVars["cardTypes"] = $CONF["types"]["card"];
				$this->smartyVars["cardExtraTypes"] = $CONF["types"]["cardExtraIDs"];
				
				$this->smartyVars["selectedPackages"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetBillingAccountShares",
						"params" => array(
							"billingAccountID" => $billingAccountID,
							"getPackageData" => 1,
							"billingAccountShareValueGreaterThan" => 0
						),
					),
				)), "packageID", "baMakePackageName");
				$this->smartyVars["selectablePackages"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPackages",
						"params" => array(
							"clientID" => $clientID,
						),
					),
				)), "packageID", "baMakePackageName", array_keys($this->smartyVars["selectedPackages"]));
				
				$defaults = $this->smartyVars["billingAccount"];
				$this->mergeFormState($defaults);
				loadConfigs("payment", "paymentQueue");
				$this->smartyVars["paymentQueueSettings"] =& $CONF["payment"]["paymentQueue"];
				$this->addTemplate("clients/EditBillingAccount", $this->smartyVars);				
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}

} // MB_Action

function baMakePackageName($row){
	return "(".TRANS_ID.": ".$row["packageID"].") ".$row["packageName"];
}

?>
