<?php
// $Id: EditBillingAccountResponse.php 12669 2008-02-21 00:21:28Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

class EditBillingAccountResponse extends EditResponseAction {
	function EditBillingAccountResponse() {
		if(!$billingAccount = oneOf("billingAccounts", array("billingAccountID" => (int) $_REQUEST["billingAccountID"]))) {
			$this->addError(MBAPI_ACTIONERROR, "No valid match.");
			return false;
		}

		$this->d =& new DataSource("billingAccounts");
		$description = $this->d->getDescription();
		parent::EditResponseAction();
		unset($description['columns']['clientContactID']);

		$billingAccountType = (int) $_REQUEST["billingAccountType"];
		if($billingAccountType == getAPITypeID("billingAccount", "manual") || $billingAccountType == getAPITypeID("billingAccount", "secondary")) {
			unset($description["columns"]['billingBankType']);
			unset($description["columns"]['billingBankName']);
			unset($description["columns"]['billingBankState']);
			unset($description["columns"]['billingBankABACode']);
			unset($description["columns"]['billingBankAccountNum']);
			unset($description["columns"]['billingBankLicenseNum']);
			unset($description["columns"]['billingBankLicenseState']);
			unset($description["columns"]['billingBankDob']);

			unset($description["columns"]['billingCardNameOnCard']);
			unset($description["columns"]['billingCardType']);
			unset($description["columns"]['billingCardNum']);
			unset($description["columns"]['billingCardExpMonth']);
			unset($description["columns"]['billingCardExpYear']);
			unset($description["columns"]['billingCardIssueNum']);
			unset($description["columns"]['billingCardStartDate']);
		} else if($billingAccountType == getAPITypeID("billingAccount", "card")) {
			unset($description["columns"]['billingBankType']);
			unset($description["columns"]['billingBankName']);
			unset($description["columns"]['billingBankState']);
			unset($description["columns"]['billingBankABACode']);
			unset($description["columns"]['billingBankAccountNum']);
			unset($description["columns"]['billingBankLicenseNum']);
			unset($description["columns"]['billingBankLicenseState']);
			unset($description["columns"]['billingBankDob']);
			
			$billingCardType = (int) $_REQUEST["billingCardType"];
			$cardExtraTypes = getAPITypes("cardExtraIDs");
			if(!in_array($billingCardType, $cardExtraTypes)) {
				unset($description["columns"]['billingCardIssueNum']);
				unset($description["columns"]['billingCardStartDate']);
			}
			if (!$_REQUEST["billingCardNum"] || $_REQUEST["billingCardNum"]==""){
				unset($description["columns"]['billingCardNum']);
			}
		} else {
			unset($description["columns"]['billingCardNameOnCard']);
			unset($description["columns"]['billingCardType']);
			unset($description["columns"]['billingCardNum']);
			unset($description["columns"]['billingCardExpMonth']);
			unset($description["columns"]['billingCardExpYear']);
			unset($description["columns"]['billingCardIssueNum']);
			unset($description["columns"]['billingCardStartDate']);
		}

		$this->d->setDescription($description);
	}
	
	function editResponseParamHandler() {
		if($_REQUEST["encKey"]) {
			$this->d->mergeParams(array("encKey" => $_REQUEST["encKey"]));
		}
		return true;
	}

	function editResponseHandler() {
		global $CONF;
		// valid match assumed due to earlier check
		$billingAccountID = (int)$_REQUEST["billingAccountID"];
		
		loadConfigs("payment", "paymentQueue");

		if (!(int)$CONF["payment"]["paymentQueue"]["enable_advanced_share_editing"]){
			// we need to remove shares for other billing accounts
			$shares = grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetBillingAccountShares",
					"params" => array(
						"billingAccountID" => $billingAccountID,
					),
				),
			));
		
			$existingShares = array();
			foreach ($shares as $share){
				$existingShares[$share["packageID"]] = $share;
			}
		
			$newShares = array();
			$updateShares = array();
			foreach ((array)$_REQUEST["packages"] as $packageID){
				if ($existingShares[$packageID]){
					$updateShares[$existingShares[$packageID]["billingAccountShareID"]] = 1;
					unset($existingShares[$packageID]);
				} else {
					$newShares[$packageID] = 1;
				}
			}

			if ((int)$_REQUEST["packages"][0]){
				$oldShares = arrayFor(":clientBillingAccountShares", array(
					"packageID" => $_REQUEST["packages"],
				));
				foreach ((array)$oldShares as $os){
					updateForKey(":clientBillingAccountShares", $os["billingAccountShareID"], array(
						"billingAccountShareValue" => 0,
					));
				}
			}

			foreach ($newShares as $packageID=>$shareValue){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "insert",
						"params" => array(
							"billingAccountID" => $billingAccountID,
							"packageID" => $packageID,
							"billingAccountFallbackGroup" => 1,
							"billingAccountShareGroup" => 0,
							"billingAccountShareValue" => $shareValue,
						),
					),
				)));
			}
		
			foreach ($updateShares as $shareID=>$shareValue){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "update",
						"params" => array(
							"billingAccountShareID" => $shareID,
							"billingAccountShareValue" => $shareValue,
						),
					),
				)));
			}
			
			foreach ($existingShares as $packageID=>$share){
				$shareID = $share["billingAccountShareID"];
				$shareValue = 0;
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "update",
						"params" => array(
							"billingAccountShareID" => $shareID,
							"billingAccountShareValue" => $shareValue,
						),
					),
				)));
			}
		} else {
			// we need to preserve shares for other billing accounts
			$shares = grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetBillingAccountShares",
					"params" => array(
						"billingAccountID" => $billingAccountID,
					),
				),
			));
		
			$existingShares = array();
			foreach ($shares as $share){
				$existingShares[$share["packageID"]] = $share;
			}
		
			$newShares = array();
			$updateShares = array();
			foreach ((array)$_REQUEST["packages"] as $packageID){
				if ($existingShares[$packageID]){
					$updateShares[$existingShares[$packageID]["billingAccountShareID"]] = 1;
					unset($existingShares[$packageID]);
				} else {
					$newShares[$packageID] = 1;
				}
			}

			foreach ($newShares as $packageID=>$shareValue){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "insert",
						"params" => array(
							"billingAccountID" => $billingAccountID,
							"packageID" => $packageID,
							"billingAccountFallbackGroup" => 1,
							"billingAccountShareGroup" => 0,
							"billingAccountShareValue" => $shareValue,
						),
					),
				)));
			}
		
			foreach ($updateShares as $shareID=>$shareValue){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "update",
						"params" => array(
							"billingAccountShareID" => $shareID,
							"billingAccountShareValue" => $shareValue,
						),
					),
				)));
			}
			
			foreach ($existingShares as $packageID=>$share){
				$shareID = $share["billingAccountShareID"];
				$shareValue = 0;
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "update",
						"params" => array(
							"billingAccountShareID" => $shareID,
							"billingAccountShareValue" => $shareValue,
						),
					),
				)));
			}
			
		}

		//////////////////////////
		return true;
	}

	function overrideValidateColumnParamType($column, $columnType, $mode, $paramType, $isRequired) {
		switch($column) {
			case "billingCardNum":
				if(empty($_REQUEST["billingCardNum"])) {
					$columnType = "";
					break;
				}
				$paramType |= INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN|INPUT_RESTRICTION_CARD;
				$args = array(
					'maxLength' => 19,
					'minLength' => 13,
					'allowedCardTypes' => getAPITypeName("card", $_REQUEST['billingCardType']),
				);
				break;
			case "billingBankAccountNum":
				if(empty($_REQUEST["billingBankAccountNum"])) {
					$columnType = "";
					break;
				}
				break;
			default:
				$args = array();
				break;
		}
		
		return array($paramType, $isRequired, $args);
	}

	function redirect() {
		if(!$this->goBack()) {
			$billingAccounts =& new DataSource("billingAccounts", array("billingAccountID" => (int) $_REQUEST["billingAccountID"]));
			$contacts =& new DataSource("contacts");
			$clients =& new DataSource("clients");
			
			$clientID = $contacts->getIDByID($clients, $contactID = $billingAccounts->getIDFor(new DataSource("contacts")));
			
			redirect("clients.php", getActionID("ShowBillingAccounts"), array("clientID" => $clientID, "contact" => $contactID));
		}
	}
}

?>
