<?php
// $Id: EditClient.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/mbapimap/clientBillingAccounts.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientID"] and displays all
 * the client detail information for editing.
 *
 * @author  modernbill
 */
class EditClient extends MB_Action {

	function EditClient() {
		parent::MB_Action();
		$this->stringRep = "EditClient";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("mergePrimaryContact" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$this->smartyVars["paymentList"] = $CONF["types"]["payments"];
				$this->smartyVars["statusList"] = getStatuses("client");
				$this->mergeCountryData();
				$this->mergeLanguageData();
				$this->mergeThemeData();
				
				$client = collapseArrayElements($results["clients"][0]["client"]);		
				$this->smartyVars["client"] = $client;
				
				$formDefaults = $client;
				$this->mergeFormState($formDefaults);
				
				$this->smartyVars["attributeGroups"] = optionsFor("attributeGroups", array("groupActive"=>1));
				if (!$this->smartyVars["attributeGroups"][$client["groupID"]] && (int)$client["groupID"]){
					$this->smartyVars["attributeGroups"][$client["groupID"]] = nameById("attributeGroups", $client["groupID"]);
				}
				$this->smartyVars["selectableBillingAccounts"] = array('') + optionsFor("clientBillingAccounts", array("clientID"=>$clientID));
				
				$this->addTemplate("clients/EditClient", $this->smartyVars);
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
