<?php
// $Id: EditClientArchiveState.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * @author  Michael Fountain
 */
class EditClientArchiveState extends MB_Action {

	function EditClientArchiveState() {
		parent::MB_Action();
		$this->stringRep = "EditClientArchiveState";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam("clientID");
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

 			$getMoreData = array
			(
				"mergePrimaryContact" => 1,
				"getPackageData" => 2, // (0=None, 1=All Data, 2=Sum by Status, 3=Sum by Billing Cycle, 4=Sum by Product ID)
			);

			$query = $this->getMBAPIQuery("GetClients", "", $getMoreData);
			$data = dispatchMBAPI($query, 1);
			$results =& $data["mbapi"][0]["results"][0];

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$this->smartyVars["statusList"] = getStatuses("client");
				
				$client = collapseArrayElements($results["clients"][0]["client"]);		

				$this->smartyVars["numActivePackages"] = 0;

				// check for active packages
				foreach((array)$client["packages"] as $status) {
					if ($status["packageStatus"] == getAPIStatusID("package","none")) {
						$this->smartyVars["numActivePackages"] += $status["packageCount"];
					}
				}

				$this->smartyVars["client"] = $client;
			
				$this->addTemplate("clients/EditClientArchiveState", $this->smartyVars);
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
