<?php
// $Id: EditClientContact.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It displays a form to edit an
 * existing client contact.
 *
 * @author  Michael Fountain
 */
class EditClientContact extends MB_Action {
	/**
	 * The constructor for a EditClientContact action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditClientContact() {
		parent::MB_Action();
		$this->stringRep = "EditClientContact";
		$this->params = array("clientContactID");
	}

	/**
	 * The main method of this class that executes the EditClientContact action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientContactID = getParam("clientContactID");

		if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No contact ID given.");
		} else {

			if(getParam("clientContactID")) {
				$clientContactID = (int) getParam("clientContactID");
				$query = $this->getMBAPIQuery("GetClients", "", array("clientContactID" => $clientContactID, "getContactData" => "4", "mergePrimaryContact" => 0));
				$data = dispatchMBAPI($query, 1);
			} else {
				$query = $this->getMBAPIQuery("GetClients", "", array("getContactData" => "4", "mergePrimaryContact" => 1));
				$data = dispatchMBAPI($query, 1);
			}

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				$this->mergeCountryData();
				$this->mergeLanguageData();
				$client = correctArray($results["clients"][0]["client"][0]);
				$contact = correctArray($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				$this->smartyVars["client"] = $client;
				$this->smartyVars["contact"] = $contact;
				
				require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
				$this->smartyVars["emailActions"] = $CONF["types"]["emailAction"];

				$formDefaults = $contact;
				$this->mergeFormState($formDefaults);

				// grab secret questions
				$this->smartyVars["secretQuestions"] = getTypes("clientSecretQuestions");
				$this->smartyVars["contactAnswers"] = arrayFor("contactSecretAnswers", array(
					"clientContactID" => (int)$_REQUEST["clientContactID"]));
				
				$this->addTemplate("clients/EditClientContact", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
