<?php
// $Id: EditClientContactResponse.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

class EditClientContactResponse extends EditResponseAction {
	var $contact;
	function EditClientContactResponse() {
		if(!$this->contact = oneOf("contacts", array("clientContactID" => (int) $_REQUEST["clientContactID"]))) {
			$this->addError(MBAPI_ACTIONERROR, "No valid match.");
			return false;
		}

		if(isset($_REQUEST["contactUsername"]) && ($this->contact["contactUsername"] == $_REQUEST["contactUsername"]))
			unset($_REQUEST["contactUsername"]);

		$this->d =& new DataSource("contacts");
		parent::EditResponseAction();
	}
	
	function setReferral() {
		$this->setReferralActionID(getActionID("EditClientContact"));
		$this->setReferralActionFile($this->d->getEntry("names", "file") . ".php");
	}

	function editResponseParamHandler() {
		if(!$this->contact["contactPrimary"] && isset($_REQUEST["contactPrimary"]) && (bool) $_REQUEST["contactPrimary"]) {
			$contacts =& new DataSource("contacts", array("clientID" => $this->contact["clientID"]));
			$contactIDs = $contacts->getKeys();
			updateFor("contacts", array("clientContactID" => $contactIDs, "contactPrimary" => 0));
		}
		return true;
	}
	
	function editResponseHandler() {
		// valid match assumed due to earlier check
		$contactID = $this->contact["clientContactID"];
		$emailActionIDs = (array) $_REQUEST["emailActionIDs"];
		
		deleteFor("contactEmailActionRels", array("clientContactID" => $contactID));
		foreach($emailActionIDs as $emailActionID) {
			insertFor("contactEmailActionRels", array("clientContactID" => $contactID, "emailActionID" => $emailActionID));
		}

/*		// insert for secret questions
		if (is_array( $_REQUEST["secretQuestion"] ) && is_array( $_REQUEST["secretAnswer"] )) {
			deleteFor("contactSecretAnswers", array("clientContactID" => (int)$contactID));
			
			for( $i=0, $n=count( $_REQUEST["secretQuestion"] ); $i<$n; $i++ ) {
				if (notNull( getTypeName("contactSecretQuestions", $_REQUEST["secretQuestion"][ $i ]) ) && notNull( $_REQUEST["secretAnswer"][ $i ] )) {
					insertFor("contactSecretAnswers", array(
						"clientContactID" => (int)$contactID,
						"questionType" => (int)$_REQUEST["secretQuestion"][ $i ],
						"secretAnswer" => md5( utf8_encode( $_REQUEST["secretAnswer"][ $i ] ) ) ));
				}
			}
		} else {
echo "lost";
		}
exit;
*/
		return true;
	}

	function overrideValidateColumnParamType($column, $columnType, $mode, $paramType, $isRequired) {
		switch($column) {
			case "contactUsername":
				if(empty($_REQUEST["contactUsername"])) {
					$paramType = 0;
					break;
				}
				$paramType |= INPUT_RESTRICTION_NOTINCOL;
				$args = array(
					"source" => "contacts",
					"col" => "contactUsername",
				);
				break;
			default:
				$args = array();
				break;
		}
		
		return array($paramType, $isRequired, $args);
	}

	function redirect() {
		if(!$this->goBack()) {
			redirect("clients.php", getActionID("ShowClientContacts"), array("clientID" => $this->contact["clientID"]));
		}
	}
}

?>
