<?php
// $Id: EditNewOrdersResponse.php 12119 2007-10-19 21:16:51Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

require_once mb_path("/lib-tk/toolkit.php");

/**
 * @author  Andy Christ
 * @author  Michael Fountain
 */
class EditNewOrdersResponse extends MB_Action {

	function EditNewOrdersResponse() {
		parent::MB_Action();
		$this->stringRep = "EditNewOrdersResponse";
		$this->params = array
		(
			"clientID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		if($_REQUEST["referralActionID"] == getActionID("ShowDashboardNewOrders")) {
			$this->setReferralActionID(getActionID("ShowDashboard"));
			$this->setReferralActionFile("dashboard.php");
		} else {
			$this->setReferralActionID(getActionID("ShowNewOrders"));
			$this->setReferralActionFile("clients.php");
		}

		// These are accepted clients, update their status to active
		// AND -- If their packages are pending, update their status to active
		// EXCEPT -- If their packages are in the queue, leave them alone for the queue to run	
		$clientIDs = (array)$_REQUEST["activate"];
		$pendingPackageIDs = NULL;
		foreach($clientIDs as $clientID) {
			$packages = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => (int) $clientID,
						"getPackageAttributeData" => 1,
					),
				),
			)));
			foreach ($packages as $package){
				$pendingID = getAPIStatusID("package", "pending");
				$panelTied = false;
				//Pull the server-group tied packages out
				foreach ((array) $package["packageAttributes"] as $attribute){
					$panelTied = ((int)$attribute["serverGroupID"]) ? true : false ;
				}
				//Remove panel-tied packages from the update list
				if($package["packageActive"] && !$panelTied && $package["packageStatus"]  == $pendingID) {
					//Flip the package status from pending to on
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "none"),
					));
				}
			}
			//Flip client status to active
			updateFor("clients", array(
				"clientID" => (int) $clientID,
				"clientStatus" => getAPIStatusID("client", "none"),
				"clientStatusReason" => "New Customer Approved"
			));
		}

		// These are not accepted clients, update their status to canceled
		// AND -- If their packages are pending, update their status to canceled
		// EXCEPT -- If their packages are in the queue, update the queue item to canceled	
		// ELSE -- If their packages are already active, send them to the queue to be deleted
		$clientIDs = (array)$_REQUEST["cancel"];
		$pendingPackageIDs = NULL;

		foreach($clientIDs as $clientID) {
			$packages = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => (int) $clientID,
						"getPackageAttributeData" => 1,
					),
				),
			)));

			foreach ($packages as $package){
				$pendingID = getAPIStatusID("package", "pending");
				$activeID = getAPIStatusID("package", "none");
				$panelTied = FALSE;
				//Pull the server-group tied packages out
				foreach ((array) $package["packageAttributes"] as $attribute){
					if((int)$attribute["serverGroupID"]) {
						$panelTied = TRUE;
						break;
					}
				}

				// IF Package record is ACTIVE
				// IF Package status is PENDING
				// IF Package IS NOT tied to a panel
				// THEN update package status to canceled
				if($package["packageActive"] && $package["packageStatus"]  == $pendingID && !$panelTied) {

					//Flip the package status to canceled
					dbg("Flip the package status to canceled");
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "canceled"),
						"packageStatusReason" => "New Customer Rejected",
					));

				// IF Package record is ACTIVE
				// IF Package status is ACTIVE
				// IF Package IS NOT tied to a panel
				// THEN update package status to canceled
				} else if($package["packageActive"] && $package["packageStatus"]  == $activeID && !$panelTied) {

					//Flip the package status to canceled
					dbg("Flip the package status to canceled");
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "canceled"),
						"packageStatusReason" => "New Customer Rejected",
					));

				// IF Package record is ACTIVE
				// IF Package status is PENDING
				// IF Package __IS__ tied to a panel
				// THEN update package status to canceled
				// AND update system queue status to canceled
				} else if($package["packageActive"] && $package["packageStatus"]  == $pendingID && $panelTied) {

					//Flip the package status to canceled
					dbg("Flip the package status to canceled");
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "canceled"),
						"packageStatusReason" => "New Customer Rejected",
					));

					//Flip any systeQueue events to canceled if they exist for this package
					dbg("Flip any systeQueue events to canceled if they exist for this package");
					updateFor("systemQueue", array(
						"packageID" => $package["packageID"],
						"systemQueueStatus" => getAPIStatusID("package", "canceled")
					));

				// IF Package record is ACTIVE
				// IF Package status is __ACTIVE__
				// IF Package __IS__ tied to a panel
				// THEN INSERT system queue status to DELETE package
				// **** SYSTEM QUEUE MUST THEN SET THE PACKAGE TO CANCELED AFTER SUCCESS
				} else if ($package["packageActive"] && $package["packageStatus"]  == $activeID && $panelTied) {

					// SEND ITEM TO THE QUEUE
					dbg("SEND ITEM TO THE QUEUE");
					$this->createNewSystemQueueEvent($package,$_REQUEST["cancelAction"]);

				}
			}

			//Flip client status to canceled
			dbg("Flip client status to active");
			updateFor("clients", array(
				"clientID" => (int) $clientID,
				"clientStatus" => getAPIStatusID("client", "canceled"),
				"clientStatusReason" => "New Customer Rejected",
				"clientDateCancelled" => mktime()
			));
		}

		// These are not accepted clients, update their status to fraud
		// AND -- If their packages are pending, update their status to fraud
		// EXCEPT -- If their packages are in the queue, update the queue item to canceled	
		// ELSE -- If their packages are already active, send them to the queue to be deleted
		$clientIDs = (array)$_REQUEST["fraud"];
		$pendingPackageIDs = NULL;

		foreach($clientIDs as $clientID) {

			$invoiceReversal = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "ProcessCreditNote",
					"params" => array(
						"clientID" => (int) $clientID,
					),
				),
			)));

			$packages = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => (int) $clientID,
						"getPackageAttributeData" => 1,
					),
				),
			)));

			foreach ($packages as $package){
				$pendingID = getAPIStatusID("package", "pending");
				$fraudID = getAPIStatusID("package", "fraudulent");
				$activeID = getAPIStatusID("package", "none");
				$panelTied = FALSE;
				//Pull the server-group tied packages out
				foreach ((array) $package["packageAttributes"] as $attribute){
					if((int)$attribute["serverGroupID"]) {
						$panelTied = TRUE;
						break;
					}
				}

				// IF Package record is ACTIVE
				// IF Package status is PENDING
				// IF Package IS NOT tied to a panel
				// THEN update package status to fraud
				if($package["packageActive"] && $package["packageStatus"]  == $pendingID && !$panelTied) {

					//Flip the package status to canceled
					dbg("Flip the package status to fraudulent");
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "fraudulent"),
						"packageStatusReason" => "New Customer Rejected as fraud",
					));

				// IF Package record is ACTIVE
				// IF Package status is ACTIVE
				// IF Package IS NOT tied to a panel
				// THEN update package status to canceled
				} else if($package["packageActive"] && $package["packageStatus"]  == $activeID && !$panelTied) {

					//Flip the package status to canceled
					dbg("Flip the package status to fraudulent");
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "fraudulent"),
						"packageStatusReason" => "New Customer Rejected as fraud",
					));

				// IF Package record is ACTIVE
				// IF Package status is PENDING
				// IF Package __IS__ tied to a panel
				// THEN update package status to canceled
				// AND update system queue status to canceled
				} else if($package["packageActive"] && $package["packageStatus"]  == $pendingID && $panelTied) {

					//Flip the package status to canceled
					dbg("Flip the package status to fraudulent");
					updateFor("packages", array(
						"packageID" => $package["packageID"],
						"packageStatus" => getAPIStatusID("package", "fraudulent"),
						"packageStatusReason" => "New Customer Rejected as fraud",
					));

					//Flip any systeQueue events to canceled if they exist for this package
					dbg("Flip any systeQueue events to canceled if they exist for this package");
					updateFor("systemQueue", array(
						"packageID" => $package["packageID"],
						"systemQueueStatus" => getAPIStatusID("package", "fraudulent")
					));

				// IF Package record is ACTIVE
				// IF Package status is __ACTIVE__
				// IF Package __IS__ tied to a panel
				// THEN INSERT system queue status to DELETE package
				// **** SYSTEM QUEUE MUST THEN SET THE PACKAGE TO CANCELED AFTER SUCCESS
				} else if ($package["packageActive"] && $package["packageStatus"]  == $activeID && $panelTied) {

					// SEND ITEM TO THE QUEUE
					dbg("SEND ITEM TO THE QUEUE");
					$this->createNewSystemQueueEvent($package,$_REQUEST["cancelAction"]);

				}
			}

			//Flip client status to canceled
			dbg("Flip client status to fraudulent");
			updateFor("clients", array(
				"clientID" => (int) $clientID,
				"clientStatus" => getAPIStatusID("client", "fraudulent"),
				"clientStatusReason" => "New Customer Rejected as fraud",
				"clientDateCancelled" => mktime()
			));
		}

		redirect($this->getReferralActionFile(), $this->getReferralActionID(), array("n"=>uniqid(0) ));

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

	function createNewSystemQueueEvent($packageData,$queueAction="suspend") {

		//NOTE: if the package status is changed from active, the system queue items
		//will not run.  The system queue will flip the status after running the suspend or delete calls

		$cancelActions = array("suspend","delete");
		$queueAction = (in_array($queueAction,$cancelActions)) ? $queueAction : "suspend" ;

		$packageID = (int) $packageData["packageID"];

		$pushQueueItem = $serverGroupID = $configGroupID = FALSE;
		if(is_array($packageData["packageAttributes"])) {
			foreach($packageData["packageAttributes"] as $key => $value) {
				if($value["packageAttributeName"] == "panel_status") {
					$pushQueueItem = ($value["packageAttributeValue"] == "none")? TRUE : $pushQueueItem;
					$serverGroupID = $value["serverGroupID"];
					$configGroupID = $value["configGroupID"];
				}
			}
		}

		if($pushQueueItem) {

			switch($queueAction) {
				case "suspend":
					$subCommand = "panelSuspend";
					break;
				case "delete":
					$subCommand = "panelDelete";
					break;
			}

			$panelQuery = array(
				"mbapi" => array(
					"command" => "ProcessPanel",
					"subCommand" => $subCommand,
					"params" =>
					array(
						"subCommand" => $subCommand,
						"configGroupID" => $configGroupID,
						"serverGroupID" => $serverGroupID,
						"packageID" => $packageID,
					))
			);

			$panelXML = toXML($panelQuery);

			$panelQuery =& new MBQuery(
				"SetSystemQueue", "insert",
				array(
					"systemQueueCommand" => "ProcessPanel",
					"configGroupID" => $configGroupID,
					"packageID" => $packageID,
					"systemQueueCommandInput" => htmlentities($panelXML),
					"systemQueueDateToRun" => mktime(),
					"systemQueueDateFinished" => 0,
				)
			);

			if(!$this->addErrorsFromResult($panelResult =& $panelQuery->getResult())) break;
		}

	}

} // MB_Action
?>
