<?php
// $Id: ImportClientFromPanel.php 12386 2007-12-21 23:43:39Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This process has to assume:
 *  -Lowest Billing Cycle
 *  -FIrst Order form's Payment Group
 *  -First Product Variant
 *
 * @author  Kris Bailey
 * @author  Andy Christ
 */
class ImportClientFromPanel extends MB_Action {

	/**
	 */
	function ImportClientFromPanel() {
		parent::MB_Action();
		$this->stringRep = "ImportClientFromPanel";
		$this->params = array(
			"tunnelVars",
			"productID"
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$packageID = getParam("productID");
		if(!$packageID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			foreach ((array)$_REQUEST["tunnelVars"] as $tv){
				$clientInfo = unserialize(base64_decode(secureInput($tv)));
	
				$results = dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetClients",
						"subCommand" => "insert",
						"params" => array(
							"companyID" => 1,
							"clientCompany" => $clientInfo["company_name"],
							"applyTax" => 1,
							"countriesID" => $clientInfo["country"],
							"themeID" => $CONF["user"]["adminData"]["themeID"][0],
							"clientActive" => 1,
							"clientStatus" => getAPIStatusID("client", "none"),
							"clientBillingDay" => 0,
							"clientDateCreated" => strtotime($clientInfo["date_created"]),
							"clientContacts" => array(
								"clientContact" => array(
									"contactFirstName" => $clientInfo["first_name"],
									"contactLastName" => $clientInfo["last_name"],
									"contactEmail" => $clientInfo["email"],
									"contactUsername" => $clientInfo["email"],
									"contactPassword" => ($clientInfo["password"])? getStuff($clientInfo["password"]) : substr(md5(uniqid(0)), 0, 9),
									"contactAddress1" => $clientInfo["address"],
									"contactCity" => $clientInfo["city"],
									"contactState" => $clientInfo["state"],
									"contactZip" => $clientInfo["zip"],
									"contactPhone1" => $clientInfo["phone"],
									"contactFax" => $clientInfo["fax"],
									"contactCompany" => $clientInfo["company_name"],
									"contactPrimary" => 1,
									"languageID" => "en",
									"countriesID" => $clientInfo["country"],
								),
							),
						),
					),
				)), 1);
	
				if (is_array($results) && $results["mbapi"][0]["header"][0]["lastInsertID"]){
					$this->clientID = $clientID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
				}
	
				if ((int)$this->clientID){
	
					$domains = explode("|", $clientInfo["domains"]);
	
					if (count($domains)){
						foreach($domains as $value) {
							$domain = $value;
							while (!strlen($domain) && $x<=count($domains)){
								$domain = $domains[++$x];
							}
							$domainSLD = $domainTLD = NULL;
		
							// this is the first real domain: $domain
							$domainSLD = substr($domain, 0, strpos($domain, "."));
							$domainTLD = substr($domain, strlen($domainSLD)+1, strlen($domain)+1);
	
							if($value) {
	
								$domainID[] = insertFor("packageDomains",
									array(
										"domainSLD" => $domainSLD,
										"domainTLD" => $domainTLD,
										"domainIDNLanguage" => "en",
										"domainActive" => 1,
										"domainDateCreated" => time(),
										"domainDateExpires" => time()+(60*60*24*365),
										"registrarID" => 0,
										"domainRenewType" => getAPITypeID("tldRenew", "disabled"),
									)
								);
							}
	
							//We only want the id of the first domain
							//if(!$domainID) {
							//	$domainID = $lastID;
							//}
						}
					} else {
						$domainID = 0;
					}
	
					if ($productID = (int)$_REQUEST["productID"]){
						$variant = oneOf("productVariants", array(
							"productID" => $productID,
							"productVariantActive" => 1,
							"sortColumn" => "productVariantID",
							"sortDir" => "ASC",
						));
						if ($variantID = $variant["productVariantID"]){
							$productInfo = oneByID("products", $productID, array(
								"getOrderFormData" => 1,
							));
	
							$orderFormID = $productInfo["orderForms"][0]["orderFormID"];
							$paymentGroupInfo = oneByID("paymentGroups", $productInfo["orderForms"][0]["paymentGroupID"]);
							$productVariantPrices = arrayFor("productVariantPrices", array(
								"currencyID" => $paymentGroupInfo["paymentGroupCurrencyID"],
								"productVariantID" => $variantID,
							));
							$cycleIDs = array();
							$pricesByCycle = array();
							foreach ((array)$productVariantPrices as $x=>$price){
								$cycleIDs[] = $price["cycleID"];
								$pricesByCycle[$price["cycleID"]][$price["productVariantPriceType"]] =& $productVariantPrices[$x];
							}
							$smallest = 999999999999;
							$scid = 0;
							foreach ((array)$cycleIDs as $x=>$cycleID){
								$time = getNextBillingTimestamp(0, $cycleID);
								if ($time<$smallest){
									$scid = $cycleID;
									$smallest = $time;
								}
							}
							// scid is the shortest cycle this is tied to
							$cycleID = $scid;
							$priceInfo = $pricesByCycle[$cycleID];
	
							if ($domainID){
								$domainArray = array(
									"domainIDs" => array());
										//"domainID" => array($domainID)
								$i=0;
								foreach($domainID as $value) {
									$domainArray["domainIDs"][$i]["domainID"] = $domainID;
									$i++;
								}
								//);
							} else {
								$domainArray = array();
							}
	
							$attributes = arrayFor("productAttributes", array(
								"productID" => $productID,
							));
	
							$packageAttributes = array();
							$sgid = 0;
							$cfid = (int)$_REQUEST["configGroupID"];
							foreach ((array)$attributes as $x=>$attribute){
								$packageAttributes[] = array(
									"packageAttributeName" => $attribute["productAttributeName"],
									"packageAttributeValue" => $attribute["productAttributeValue"],
									"serverGroupID" => ((int)$attribute["serverGroupID"])?$sgid = $attribute["serverGroupID"]:0,
									"configGroupID" => $cfid,
								);
							}
	
							$clientPassword = NULL;
							if($clientInfo["password"]) {
								$clientPassword = $clientInfo["password"];
							} else {
								$clientPassword = substr(md5(uniqid(0)), 0, 9);
								$pr = dispatchMBAPI(toXML(array(
									"mbapi" => array(
										"command" => "GetEncryptedText",
										"params" => array(
											"text" => $clientPassword
										),
									),
								)),1);
								$clientPassword = $pr["mbapi"][0]["results"][0]["text"][0];
							}
	
							// copy and paste this code to make more attributes by hand ;-)
							$packageAttributes[] = array(
								"packageAttributeName" => "panel_status",
								"packageAttributeValue" => "none",
								"serverGroupID" => $sgid,
								"configGroupID" => $cfid,
							);
	
							$packageAttributes[] = array(
								"packageAttributeName" => "domainPassword",
								"packageAttributeValue" => $clientPassword,
								"serverGroupID" => $sgid,
								"configGroupID" => $cfid,
							);
	
							$packageAttributes[] = array(
								"packageAttributeName" => "clientLogin",
								"packageAttributeValue" => $clientInfo["login"],
								"serverGroupID" => $sgid,
								"configGroupID" => $cfid,
							);
	
							$packageAttributes[] = array(
								"packageAttributeName" => "domainUserName",
								"packageAttributeValue" => $clientInfo["login"],
								"serverGroupID" => $sgid,
								"configGroupID" => $cfid,
							);
	
							$attrArray = array(
								"packageAttributes" => array(
									"packageAttribute" => $packageAttributes,
								),
							);
	
							$pres = dispatchMBAPI(toXML(array(
								"mbapi" => array(
									"command" => "SetPackages",
									"subCommand" => "insert",
									"params" => array(
										"clientID" => $clientID,
										"productID" => $productID,
										"packageVariantID" => $variantID,
										"taxZoneGroupID" => $variant["taxZoneGroupID"],
										"cycleDiscountGroupID" => $variant["cycleDiscountGroupID"],
										"packageName" => $productInfo["productName"],
										"packageQuantity" => 1,
										"packageProratable" => $productInfo["productProratable"],
										"packageDiscountable" => $productInfo["productDiscountable"],
										"packageDateCreated" => time(),
										"packageDateBeginRenewal" => time()+(24*60*60),
										"packageDateLastRenewal" => time()+(24*60*60),
										"packageDateNextRenewal" => time()+(24*60*60),
										"packageDateStopRenewal" => 0,
										"packageDateCancelled" => 0,
										"packagePendingCancellation" => 0,
										"packageActive" => 1,
										"packageStatus" => getAPIStatusID("package", "none"),
										"packageComments" => TRANS_IMPORTED_FROM_PANEL,
										"packageType" => $productInfo["productType"],
										"packageOriginalPrice" => $priceInfo[0]["productVariantPriceAmount"],
										"packagePrice" => $priceInfo[0]["productVariantPriceAmount"],
										"packageDiscount" => 0,
										"packageSetup" => $priceInfo[1]["productVariantPriceAmount"],
										"cycleID" => $cycleID,
										"paymentGroupID" => $productInfo["orderForms"][0]["paymentGroupID"],
										"packageCancellationType" => $productInfo["productCancellationType"],
										"packageClientPermissions" => $productInfo["productClientPermissions"],
									) + $domainArray + $attrArray
								)
							)), 1);
							if (is_array($pres) && $pres["mbapi"][0]["header"][0]["lastInsertID"]){
								$packageID = $pres["mbapi"][0]["header"][0]["lastInsertID"][0];
							} else {
								$packageID = 0;
							}
						
						} else {
							// no variant found error.
						}
					}
				}
			}
		}
		
		redirect("modules.php", "ShowPanelDetails", array(
			"configGroupID" => $_REQUEST["configGroupID"],
			"serverGroupID" => $_REQUEST["serverGroupID"],
		));
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ImportClientFromPanel
?>
