<?php
// $Id: ManageClientActionResponse.php 10911 2007-03-26 23:37:37Z achrist $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This action will take a client ID and change their status and their packages
 * based on the input.  It will not be used to activate new clients for now, difference
 * being, activation handles the queue differently.  Needs more thought...
 *
 * * Pass the clientID
 * _REQUEST["clientID"] = 4;
 *
 * _REQUEST["panelOnly"] = 1; If you only want to push the panel queue items, all other settings remain the same
 * _REQUEST["newStatusID"] = 3; 3=fraudulent
 * _REQUEST["purge"] = 1; 1 to delete this client, pass something for the newStatusID for code's sake
 *
 * * Reason String
 * _REQUEST["clientStatusReason"];  "This client was killing my server"
 *
 * _REQUEST["packages"][1] = array("suspend,suspend");  //Suspend package 1 and push a panel suspend call into the queue
 *                    [4] = array("suspend,suspend");
 *                    [7] = array("suspend,none");  //Suspend package 7 and don't do anything if panel tied
 *                    [8] = array("delete,none");  //Delete the package and don't do anything if panel tied
 *                   [11] = array("delete,suspend");  //Delete the package and suspend the panel account
 *                   [12] = array("unsuspend,unsuspend");  //Unsuspend the package and make the unsuspend panel call
 *
 *
 * @author  Andy Christ
 */
class ManageClientActionResponse extends MB_Action {

	function ManageClientActionResponse() {
		parent::MB_Action();
		$this->stringRep = "ManageClientActionResponse";
		$this->params = array
		(
			"clientID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

#show($_REQUEST); exit;

		$this->setReferralActionID((int) $_REQUEST["referralActionID"]);
		if(!$_REQUEST["referralActionFile"]) {
			$this->setReferralActionFile("clients.php");
		} else {
			$this->setReferralActionFile($_REQUEST["referralActionFile"]);
		}
		//First flip the client's status, seems silly, but do this for purge so that the panel items get set
		//without a bunch of repeditive code
		if($_REQUEST["clientID"] && !$_REQUEST["panelOnly"]) {
			//Flip the client status
			updateFor("clients", array(
				"clientID" => (int) $_REQUEST["clientID"],
				"clientStatus" => (int) $_REQUEST["newStatusID"],
				"clientStatusReason" => $_REQUEST["clientStatusReason"],
				"clientNotes" => array(
					"clientNote" => array(
						#"clientID" => (int) $_REQUEST["clientID"],
						"adminID" => $CONF["user"]["id"],
						"clientNoteDateCreated" => mktime(),
						"clientNoteText" => $_REQUEST["clientStatusReason"],
					)
				)
			));
		}

		$packages = array();
		if(is_array($_REQUEST["packages"])) {
			$packages = $_REQUEST["packages"];
			foreach($packages as $packageID => $newActions) {

				$newActions = explode(",",$newActions[0]);
				//Possible package status
				//	suspend, unsuspend, cancel, archive
				//
				//Possible panel actions
				//	suspend, unsuspend, delete
				$this->changePackageStatus($packageID, $newActions);
			}

			// Now drop this client.  The code above should have taken care of their panel items
			if((int) $_REQUEST["purge"]) {
				deleteForKey("clientsGeneric", (int) $_REQUEST["clientID"]);
			}
		} // is packages an array

		if($_REQUEST["panelOnly"]) {
			redirect($this->getReferralActionFile(), $this->getReferralActionID(), array(
				"packageID" => $packageID,
				"n" => uniqid(0)));
		} else {
			redirect($this->getReferralActionFile(), $this->getReferralActionID(), array(
				"clientID" => $_REQUEST["clientID"],
				"n" => uniqid(0)));
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

   /**
    * This function will do the leg work.  Pass it the package ID and the array of
    * status fields as array(the new package status, what to do if tied to a panel)
    * EX: changePackageStatus(1, array("archive","delete"))
    *
    */

	function changePackageStatus($packageID, $action=array()) {

		//Possible package status
		//	suspend, unsuspend, cancel, archive
		//
		//Possible panel actions
		//	suspend, unsuspend, delete

		$packageAction = $panelAction = $archive = NULL;
		switch ($action[0]) {
			case "unsuspend":
				$packageAction = getAPIStatusID("package", "none");
			break;
			case "suspend":
			case "suspended":
				$packageAction = getAPIStatusID("package", "suspended");
			break;
			case "cancel":
				$packageAction = getAPIStatusID("package", "canceled");
			break;
			case "archive":
				$packageAction = getAPIStatusID("package", "canceled");
				$archive = 1;
			break;
		}
		switch ($action[1]) {
			case "activate":
			case "enable":
			case "unsuspend":
				$panelAction = "panelUnsuspend";
			break;
			case "suspend":
				$panelAction = "panelSuspend";
			break;
			case "delete":
				$panelAction = "panelDelete";
			break;
		}

		dbg("Passed in: ");
		dbg($action);
		dbg("Package Action: $packageAction");
		dbg("Panel Action: $panelAction");

		//Flip the package status
		if(!$_REQUEST["panelOnly"]) {
			if($archive) {
				updateFor("packages", array(
					"packageID" => (int) $packageID,
					"packageStatus" => $packageAction,
					"packageStatusReason" => $_REQUEST["clientStatusReason"],
				));
			} else {
				updateFor("packages", array(
					"packageID" => (int) $packageID,
					"packageStatus" => $packageAction,
					"packageActive" => 0,
					"packageStatusReason" => $_REQUEST["clientStatusReason"],
				));
			}
		}

		$packages = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int) $packageID,
					"getPackageAttributeData" => 1,
				),
			),
		)));

		$panelTied = $pushQueueItem = $serverGroupID = $configGroupID = FALSE;
		if(is_array($packages[0]["packageAttributes"])) {
			//Pull the server-group tied packages out
			foreach ((array) $packages[0]["packageAttributes"] as $attribute){
				if(((int) $attribute["serverGroupID"])) {
					$panelTied = TRUE;
					break;
				}
			}
		}

		if($panelTied) {
			//This needs to take into account the possiblity of being tied to more than one SG
			foreach($packages[0]["packageAttributes"] as $key => $value) {
				if($value["packageAttributeName"] == "panel_status") {
					switch ($value["packageAttributeValue"]) {
						case "none":
							$pushQueueItem = TRUE;
							break;
						case "suspended":
							$pushQueueItem = TRUE;
							break;
					}
					$serverGroupID = $value["serverGroupID"];
					$configGroupID = $value["configGroupID"];
				}
			}
		}

		dbg("Panel Tied: $panelTied");
		dbg("\$pushQueueItem:$pushQueueItem && \$serverGroupID:$serverGroupID && \$configGroupID:$configGroupID");

		if($pushQueueItem && $serverGroupID && $configGroupID) {
			// SEND ITEM TO THE QUEUE
			dbg("SEND ITEM TO THE QUEUE: packageID:$packageID serverGroupID: $serverGroupID panel: $configGroupID");

			//Update all existing queue items for this Package and Config ID to completed
			$query = $this->getMBAPIQuery(
				"GetSystemQueue", "",
				array(
					"configGroupID" => $configGroupID,
					"packageID" => $packageID,
				)
			);
			$data = dispatchMBAPI($query, 1);

			$results =& correctArray($data["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"]);

			if(is_array($results)) {
				foreach($results as $key => $value) {
					if($value["systemQueueStatus"] != getAPIStatusID("queue", "completed")) {
						$message = array(
									"mbapi" => array(
										array("message" => "System update for new queue item")));

						$messageXML = toXML($message);
						$panelUpdateQuery =& new MBQuery(
							"SetSystemQueue", "update",
							array(
								"systemQueueID" => $value["systemQueueID"],
								"systemQueueStatus" => getAPIStatusID("queue", "completed"),
								"systemQueueDateFinished" => mktime(),
								"systemQueueLogs" => array(
									"systemQueueLog" => array("systemQueueLogMessage" => htmlentities($messageXML))
									)
							)
						);
						$result = $panelUpdateQuery->getResult();
					}
				}
			}

			$panelQuery = array(
				"mbapi" => array(
					"command" => "ProcessPanel",
					"subCommand" => $panelAction,
					"params" =>
					array(
						"subCommand" => $panelAction,
						"configGroupID" => $configGroupID,
						"serverGroupID" => $serverGroupID,
						"packageID" => (int) $packageID,
					))
			);

			$panelXML = toXML($panelQuery);

			$panelQuery =& new MBQuery(
				"SetSystemQueue", "insert",
				array(
					"systemQueueCommand" => "ProcessPanel",
					"configGroupID" => $configGroupID,
					"packageID" => $packageID,
					"systemQueueCommandInput" => htmlentities($panelXML),
					"systemQueueDateToRun" => mktime(),
					"systemQueueDateFinished" => 0,
					"systemQueueStatus" => getAPIStatusID("queue", "force"),
				)
			);

			$result = $panelQuery->getResult();

			//if(!$this->addErrorsFromResult($panelResult =& $panelQuery->getResult())) break;
		}
	}

} // MB_Action
?>
