<?php
// $Id: ManageClientNotes.php 12018 2007-10-03 14:27:24Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It displays and manages client notes
 *
 * @author  Ben Woolley
 */
class ManageClientNotes extends MB_Action {
	/**
	 * The constructor for a ManageClientNotes action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ManageClientNotes() {
		parent::MB_Action();
		$this->stringRep = "ManageClientNotes";
		$this->params = array("clientID");
	}

	/**
	 * The main method of this class that executes the AddClientContact action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetClients", "", array("mergePrimaryContact" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$adminID = $CONF["user"]["id"];
				$adminQuery = $this->getMBAPIQuery("GetAdmins","",array("adminID"=>$adminID),0,0,0,0,0,$this->params);
				$adminData = dispatchMBAPI($adminQuery, 1);
				$adminResults =& $adminData["mbapi"][0]["results"][0];

				$this->smartyVars["admin"] = collapseArrayElements($adminResults["admins"][0]["admin"][0]);
				$noteList = arrayFor(":clientNotes", array(
					"clientID" => $clientID,
				));
				$this->smartyVars["noteList"] = $noteList;
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"][0]);

				$clientNoteID = getParam('clientNoteID');
				if($clientNoteID) {
					$editNotesByID = associateArrayRowByID($noteList, "clientNoteID");
					$this->smartyVars["editNotesByID"] = $editNotesByID;
					$editNote = $editNotesByID[$clientNoteID];
					$this->smartyVars["editNote"] = $editNote;
					$formDefaults = array('clientID' => $clientID, 'clientNoteText' => $editNote['clientNoteText']);
				} else {
					$formDefaults = array('clientID' => $clientID);
				}
				$this->mergeFormState($formDefaults);
				$this->addTemplate("clients/ManageClientNotes", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
