<?php
// $Id: MergeClient.php 12675 2008-02-22 21:51:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * @author  Kris Bailey
 */
class MergeClient extends MB_Action {
	/**
	 * The constructor for a ManageClientNotes action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function MergeClient() {
		parent::MB_Action();
		$this->stringRep = "MergeClient";
		$this->params = array("mergeClientID","masterClientID");
	}

	/**
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$mergeClientID = getParam('mergeClientID');
		$masterClientID = getParam('masterClientID');
		if(!$mergeClientID) {
			$this->addError(TRANS_ACTIONERROR, "No merge client ID given.");
		} elseif (!$masterClientID){
			$this->addError(TRANS_ACTIONERROR, "No master client ID given.");
		} else {

			$this->smartyVars["mergeClient"] = oneByID("clients", $mergeClientID, array("mergePrimaryContact"=>1));
			$this->smartyVars["masterClient"] = oneByID("clients", $masterClientID, array("mergePrimaryContact"=>1));

			$this->addTemplate("clients/MergeClient", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
