<?php
// $Id: RemoveBillingAccount.php 10647 2007-02-09 16:19:18Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["billingAccountID"]
 * and displays all the client billing account detail information.
 *
 * @author  Michael Fountain
 */
class RemoveBillingAccount extends MB_Action {

	function RemoveBillingAccount() {
		parent::MB_Action();
		$this->stringRep = "RemoveBillingAccount";
		$this->params = array(
			"clientID",
			"clientContactID",
			"billingAccountID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();
		
		$clientID = (int)$_REQUEST['clientID'];
		$clientContactID = (int)$_REQUEST['clientContactID'];
		$billingAccountID = (int)$_REQUEST['billingAccountID'];
		if(!$clientID) {
				$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else if(!$clientContactID) {
				$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
		} else if(!$billingAccountID) {
				$this->addError(TRANS_ACTIONERROR, "No billing account ID given.");
		} else {

				$contact = oneByID(":contacts", $clientContactID);
				$client = oneByID("clients", $clientID, array("mergePrimaryContact" => 1));
				$billingAccount = oneByID(":billingAccounts", $billingAccountID);
																							
				$this->smartyVars["client"] = $client;
				$this->smartyVars["contact"] = $contact;
				$this->smartyVars["billingAccount"] = $billingAccount;
				$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];

				// Set the templete for output
				$this->addTemplate("clients/RemoveBillingAccount", $this->smartyVars);


		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}

} // MB_Action
?>
