<?php
// $Id: RemoveClientContact.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientContactID"], looks
 * up client contact and asks you for remove confirmation.
 *
 * @author  modernbill
 */
class RemoveClientContact extends MB_Action {

	function RemoveClientContact() {
		parent::MB_Action();
		$this->stringRep = "RemoveClientContact";
		$this->params = array(
			"clientID",
			"clientContactID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		$clientContactID = getParam('clientContactID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("getContactData" => 4));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				// Assign smarty variables
				$client = collapseArrayElements($results["clients"][0]["client"][0]);
				$contact = collapseArrayElements($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				$this->smartyVars["client"] = $client;
				$this->smartyVars["contact"] = $contact;

				if ($this->smartyVars["contact"]["contactPrimary"] == 1) {
					redirect("clients.php", "EditClientContact", array(
									"clientID" => $clientID,
									"clientContactID" => $clientContactID,
									"fd" => 1));
				} else {
					// Set the templete for output
					$this->addTemplate("clients/RemoveClientContact", $this->smartyVars);
				}
				
			} else {
				$this->addError(TRANS_ACTIONERROR, "Problem obtaining contact information");
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
} // MB_Action
?>
