<?php
// $Id: ResetContactPassword.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

/**
 * This class is a child class of MB_Action. It displays a form to edit an
 * existing client contact.
 *
 * @author  Michael Fountain
 */
class ResetContactPassword extends MB_Action {
	/**
	 * The constructor for a ResetContactPassword action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ResetContactPassword() {
		parent::MB_Action();
		$this->stringRep = "ResetContactPassword";
		$this->params = array("clientContactID");
	}

	/**
	 * The main method of this class that executes the ResetContactPassword action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientContactID = getParam("clientContactID");

		if(!notZero( $clientContactID )) {
			$this->addError(TRANS_ACTIONERROR, "No contact ID given.");
		} else {
		
			$this->smartyVars['contact'] = oneByID('contacts', $clientContactID);
			$this->smartyVars['client'] = oneByID('clients', $this->smartyVars['contact']['clientID']);
// show($this->smartyVars);
			$this->mergeFormState( $this->smartyVars['contact'] );

			if (notZero( $this->smartyVars['contact']['contactActive'] )) {
				$this->addTemplate("clients/ResetContactPassword");
			} else {
				$this->addError( TRANS_ACTIONERROR, "Contact is not active. Please activate contact before attempting to reset password." );
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
