<?php
// $Id: ResetContactPasswordResponse.php 10910 2007-03-26 22:14:45Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/include/mail/mail.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-mbapi/include/mail/emailTemplates/passwordNotificationEmail.php");
 
class ResetContactPasswordResponse extends MB_Action {
	function ResetContactPasswordResponse() {
		parent::MB_Action();
		$this->stringRep = "ResetContactPasswordResponse";
		$this->params = array("clientContactID");
	}

	function execute() {
		parent::execute();

		if (!notZero( $_REQUEST['clientContactID'] )) {
			$this->addError( TRANS_ACTIONERROR, "Client Contact ID is not given.");
		} else {
			if(!$thisContact = oneOf("contacts", array("clientContactID" => (int) $_REQUEST["clientContactID"]))) {
				$this->addError(MBAPI_ACTIONERROR, "No valid match.");
				$this->addErrorTemplates();
				return false;
			}
			
			// generate the new password
			$newPass = getRandomPassword();
			
			if (updateFor("contacts", array(
				"clientContactID" => (int)$thisContact["clientContactID"],
				"contactTempPassword" => $newPass ))) {

				/// based off the emailActionID
				$email =& new PasswordNotificationEmail( $newPass, (int)$thisContact['clientContactID'] );
				
				dbg("Email going out");
				dbg($email);

				if (!$email->execute()) {
					$this->addError(TRANS_ACTIONERROR, "Failed to send email");
				} else {
					dbg("AFTER EMAIL SENDING");
					dbg($email);
					
					if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"]) {
						$numMatches = preg_match("/[a-zA-Z0-9\-\_]*\.php/", $_REQUEST["redirectActionFile"], $matches);
						if($numMatches === 1 && $matches[0]) {
							redirect($matches[0]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
						}
					} else {
						redirect("clients.php", "ShowClientContacts", array("msg"=>TRANS_PASSWORD_RESET,
					 		"clientID" => $thisContact['clientID'],
							"clientContactID" => $thisContact['clientContactID']));
					}
				}
			} else {
				$this->addError(TRANS_ACTIONERROR, "Failed updating client contact with new password.");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}

?>
