<?php
// $Id: SendClientEmailResponse.php 11423 2007-06-22 20:36:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

/**
 * This class is a child class of MB_Action. It displays a form to add a new client record.
 *
 * @author  modernbill
 */
class SendClientEmailResponse extends MB_Action {

	function SendClientEmailResponse() {
		parent::MB_Action();
		$this->stringRep = "SendClientEmailResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		// if the client isn't specified we can't do much with it
		if(!notZero( $_REQUEST["clientID"] )) {
			$this->addError( TRANS_ACTIONERROR, "Client ID is not given." );
			$this->addErrorTemplates();
			
			return $this->hasExecutedSuccessfully();
		}
// print_r($_REQUEST);
		$clientID = (int)$_REQUEST["clientID"];
		
		$contacts =array();	// list of destinations
		$contactPrimary =0;	// who be the primary

		$customBodies =array();	// if we have variables to replace in the email text, this is the custom
		$customVars =array();	// what vars we're looking for

		// check if we have custom vars to replace
		if (preg_match_all( '[{\w+}]', (string)$_REQUEST['emailBody'], $matches, PREG_SET_ORDER )) {
			// if I'm here I must have matches
			$matches = array_values( $matches );
			for( $i=0, $n=count( $matches ); $i<=$n; $i++ ) {
				if (notNull( $matches[ $i ][0] ) && !in_array( (string)$matches[ $i ][0], $customVars ))
					$customVars[] = (string)$matches[ $i ][0];
			}
		}

		if(is_array($_REQUEST["addClientContactIDs"])) {
			$clientContactIDs = $_REQUEST["addClientContactIDs"];

			$query =& new MBQuery("GetClients", "", array(
				"clientID" => (int)$_REQUEST["clientID"],
				"getContactData" => 1,
				"mergePrimaryContact" => 1));
			$data = $query->getResult();
			unset( $query );
			
			if (!$data->getErrorCount()) {
				$result = grabSimpleMBAPIResults( $data->getStructure() );
				foreach( (array)$result as $clientInfo ) {
				
					foreach( (array)$clientInfo['contacts'][0]['contact'] as $key => $contact) {
					
						if (notNull( $customVars )) {	// do the replacement
							/// this is ugly and slow, but will do the trick
							$customBodies[ $contact['contactEmail'] ] = unsecureInput($_REQUEST['emailBody']);

							foreach ( (array)$customVars  as $var ) {
								$frmVar = ( stripos( $var, 'contact' ) ? 'contact' : 'clientInfo' );
								$customBodies[ $contact['contactEmail'] ] =
									str_replace(
										$var,
										${$frmVar}[ str_replace( array('{','}'), null, $var ) ],
										$customBodies[ $contact['contactEmail'] ] );
							}	unset( $frmVar, $var );
						}
						
						if(in_array($contact["clientContactID"], $clientContactIDs)) {
							$contacts[ $contact["contactEmail"] ] = array(
								'name' => $contact["contactFirstName"]." " .$contact["contactLastName"],
								'address' => $contact["contactEmail"]);
						}
						if(notZero($contact["contactPrimary"])) {
							$contactPrimary = $contact["clientContactID"];
						}
					}		unset( $key, $contact, $result );
				}	unset( $clientInfo );
			} else {
			 	list( $title, $msg )= each( $data->getErrors() );
				$this->addError( $title, $msg );
				unset( $title, $msg );
			}

			unset( $data );
		} else {
			//No contacts found
		}
		
		if(!$contactPrimary) {
			$contactPrimary = $clientContactIDs[0];
		}
		
		//Look for CC and BCC
		$ccAddresses = $bccAddresses = $body = $subject = NULL;
		if($_REQUEST["emailCC"]) {
			$ccAddresses =explode(",",$_REQUEST["emailCC"]);
		}
		if($_REQUEST["emailBCC"]) {
			$bccAddresses =explode(",",$_REQUEST["emailBCC"]);
		}
		if($_REQUEST["emailBody"]) {
			$body = $_REQUEST["emailBody"];
		}
		if($_REQUEST["emailSubject"]) {
			$subject = $_REQUEST["emailSubject"];
		}

		//This will only allow messages to go out to e-mail addresses inside our system
		if(notNull($contacts) && ($body || $subject)) {
			if (notNull( $customVars )) {
				foreach( (array)$customBodies as $dest => $body ) {
					$this->sendEmail( $subject, secureInput($body), $ccAddresses, $bccAddresses, array($contacts[ $dest ]), $contactPrimary );
				}
			} else {
				$this->sendEmail( $subject, $body, $ccAddresses, $bccAddresses, $contacts, $contactPrimary );
			}

			if (!$this->getNumErrors()) {
				redirect("clients.php", "ShowClientDetails", array("clientID"=>$clientID));
			}
		} else {
			$this->addError(TRANS_ACTIONERROR, "No Subject or Body given.");
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

	function sendEmail( $subject, $body, $ccAddresses, $bccAddresses, $contacts, $contactPrimary ) {
		global $CONF;
		
		$message = array();
		$message["emailSubject"] = $subject;

		$message["emailBody"] = $body;
		$message["emailTextBody"] = $body;

		$message["emailFromAddress"] = $CONF["user"]["email"];
		$message["emailFromName"] = $CONF["user"]["firstName"] ." " .$CONF["user"]["lastName"];
		$message["emailDateCreated"] = mktime();
		$message["emailDateSent"] = mktime();
		$message["emailActive"] = 1;
		$message["emailContactID"] = $contactPrimary;
		
		if (utf8_html_entity_decode( $_REQUEST["emailBody"] ) != $_REQUEST["emailBody"]) {	// has html special chars!
			$message["emailSentType"] = 1;

			$message["emailTextBody"] = strip_tags( unsecureInput($message["emailTextBody"]) );
		}
			

		$message['emailToAddresses']['emailAddress'] = array_values($contacts);

		if($ccAddresses) {
			$message['emailCCAddresses']['emailAddress'] =array();
			foreach( (array)$ccAddresses as $value) {
				$message['emailCCAddresses']['emailAddress'][] = array('address' => $value);
			}	unset( $value );
		}

		if($bccAddresses) {
			$message['emailBCCAddresses']['emailAddress'] =array();
				
			foreach( (array)$bccAddresses as $value) {
				$message['emailBCCAddresses']['emailAddress'] = array('address' => $value);
			}
		}
/*print_r($message);
$xml = new MBXMLLite( $message );

echo $xml->toString();
exit;*/
		$sendEmails =& new MBQuery("ProcessEmail", "", $message);
		$sendEmails = $sendEmails->getResult();
		
		if (!$sendEmails->getErrorCount()) {
			return true;
		} else {
			list( $title, $msg ) = each( $sendEmails->getErrors() );
			$this->addError( $title, $msg );
			return false;
		}
		
	}
} // MB_Action SendClientEmailResponse
?>
