<?php
// $Id: ShowBillingAccountDetails.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["billingAccountID"]
 * and displays all the client billing account detail information.
 *
 * @author  Michael Fountain
 */
class ShowBillingAccountDetails extends MB_Action {

	function ShowBillingAccountDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowBillingAccountDetails";
		$this->params = array("billingAccountID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$billingAccountID = ((int) $_REQUEST["billingAccountID"]);
		if(!$billingAccountID) {
			$this->addError(TRANS_ACTIONERROR, "No billing account ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("getBillingData"=>"3", "mergePrimaryContact" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				$smartyVars["client"] = $results["clients"][0]["client"];
				$smartyVars["billingAccount"] = $results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"];
				
				$this->addTemplate("clients/ShowBillingAccountDetails", collapseArrayElements($smartyVars));
				
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}

} // MB_Action
?>
