<?php
// $Id: ShowClientContacts.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * @author  Michael Fountain
 */
class ShowClientContacts extends MB_Action {
	/**
	 */
	function ShowClientContacts() {
		parent::MB_Action();
		$this->stringRep = "ShowClientContacts";
		$this->params = array("clientID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("getContactData"=>1, "mergePrimaryContact" => 1), 1, 1, 1, 1);
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				//$this->mergeCountryData();
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"]);
				$this->smartyVars["contacts"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["contacts"][0]["contact"]));

				$contacts = $this->smartyVars["contacts"];
				$contactCountries = array();
				$c = count($contacts);
				for($i = 0; $i < $c; $i++) {
					$contactCountries[$contacts[$i]["clientContactID"]] = constant("TRANS_ISO_3166_".$contacts[$i]["countriesISO2"]);
				}
				$this->smartyVars["contactCountries"] = $contactCountries;
				$this->mergeLanguageData();
				$this->addTemplate("clients/ShowClientContacts", $this->smartyVars);
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
