<?php
// $Id: ShowClientCreditHistory.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientID"] and displays all
 * the client accounting detail information.
 *
 * @author  Michael Fountain
 */
class ShowClientCreditHistory extends MB_Action {

	function ShowClientCreditHistory() {
		parent::MB_Action();
		$this->stringRep = "ShowClientCreditHistory";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();
		dbg("at top of action");

		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			// lets get the accounting data here:

			$params = array(
				"ledgerAccountID" => getGeneralLedgerAccountID("customer_credits")
			);

			$query = $this->getMBAPIQuery("GetAccountingGeneralLedger", "", $params, 1, 1, 1, 1);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			dbg("got the data back from the command");
			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			
				if ($results["accounting_general_ledger"] && $results["accounting_general_ledger"][0]["ledger"]){
					$this->smartyVars["ledgerData"] = correctArray($results["accounting_general_ledger"][0]["ledger"]);
				} else {
					$this->smartyVars["ledgerData"] = array();
				}
				$invoiceIDs = array();
				foreach ($this->smartyVars["ledgerData"] as $row){
					$invoiceIDs[] = $row["invoiceID"];
				}
				
				$invoiceData = correctArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetInvoices",
						"params" => array(
							"invoiceID" => $invoiceIDs,
						),
					),
				)));
				$this->smartyVars["keyedInvoices"] = array();
				if (is_array($invoiceData)){
					foreach ($invoiceData as $invoice){
						$this->smartyVars["keyedInvoices"][$invoice["invoiceID"]] = $invoice;
					}
				}
				// ok, we have successfully gotten the accounting data
			
				// lets get this clients data
				$this->smartyVars["client"] = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetClients",
						"params" => array(
							"clientID" => (int)$_REQUEST["clientID"],
							"mergePrimaryContact" => 1,
						),
					),
				)));
				
				$this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);
				
				$this->addTemplate("clients/ShowClientCreditHistory", $this->smartyVars);
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
