<?php
// $Id: ShowClientDetails.php 12597 2008-01-31 23:33:19Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientID"] and displays all
 * the client detail information.
 *
 * @author  Michael Fountain
 */
class ShowClientDetails extends MB_Action {

	function ShowClientDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowClientDetails";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		if ((int)$_REQUEST["resendPackageInfoEmail"] && (int)$_REQUEST["configGroupID"] && (int)$_REQUEST["packageID"]){
			require_once mb_path('/lib-mbapi/include/mail/emailTemplates/packageInfoEmail.php');
			$email =& new PackageInfoEmail((int)$_REQUEST["packageID"], (int)$_REQUEST["configGroupID"]); // need package ID and configGroupID
			if ($email->execute()){
				redirect("clients.php", "ShowClientDetails", array(
					"clientID" => $_REQUEST["clientID"],
					"resendPackageInfoEmailMessage" => "TRANS_PACKAGE_INFO_EMAIL_RESENT_SUCCESSFULLY",
				));
			} else {
				redirect("clients.php", "ShowClientDetails", array(
					"clientID" => $_REQUEST["clientID"],
					"resendPackageInfoEmailMessage" => "TRANS_PACKAGE_INFO_EMAIL_RESENT_UNSUCCESSFULLY",
				));
			}
			exit;
		}
		
		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			if ($_REQUEST["resendPackageInfoEmailMessage"]) $this->smartyVars["resendPackageInfoEmailMessage"] = $_REQUEST["resendPackageInfoEmailMessage"];
			if ((int)$_REQUEST["productID"]){
				$this->smartyVars["productID"] = (int)$_REQUEST["productID"];
				$this->smartyVars["mode"] = (int)$_REQUEST["mode"];
			}

			$suppressFeePackages = ((int)$_REQUEST["showFees"])?0:1;
			$query = toXML(array(
				"mbapi" => array(
					"command" => "GetClients",
					"params" => array(
						"clientID" => (int)$_REQUEST["clientID"],
						"mergePrimaryContact" => 1,
						"getPackageData" => 2, // This fetches stats from all packages even though we do not need them - to do - MF
						"getDomainData" => 2,
						"getAccountingData" => 1,
						"getCertData" => 2,
						"getCreditData" => 1,
						"getContactData" => 3,
						"getBillingData" => 2,
						"getBookmarkData" => 1,
						"getClientGroupData" => 1,
						"getSessionData" => 1,
						"getTicketData" => 2, // (0=None, 1=All Data, 2=Last 5, 3=Last)
						"getNoteData" => 2, // (0=None, 1=All Data, 2=Last 5, 3=Last)
						"suppressFeePackages" => $suppressFeePackages,
						"hooks" => array(
							"hook" => array(
								"hookFunctionName" => "calculateResellerVolumnDiscount", 
							),
						),
					),
				),
			));
			$data = dispatchMBAPI($query, 1);
			$results =& $data["mbapi"][0]["results"][0];

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["clientID"] = $clientID;
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"]);
				$client =& $this->smartyVars["client"];
				// --------------------------------------------------------------
				// MBAPI Call to get the fraud score results for this client
				// --------------------------------------------------------------
				$this->smartyVars["fraudResultsLog"] = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetFraudResultsLog",
						"params" => array(
							"clientID" => $clientID,
						),
					),
				));

				// --------------------------------------------------------------
				// MBAPI call to get the default billing account information
				// --------------------------------------------------------------
				$this->smartyVars["defaultBillingAccount"] = oneByID("billingAccounts", $client["defaultBillingAccountID"]);

				// --------------------------------------------------------------
				// MBAPI Call to get the default billing shares for this client
				// --------------------------------------------------------------
				$this->smartyVars["defaultShareCount"] = countFor("clientBillingAccountShares", array(
					"billingAccountID" => $client["defaultBillingAccountID"],
					"billingAccountShareGroup" => "0",
				));

				// --------------------------------------------------------------
				// Set the primary attribute group for this client
				// --------------------------------------------------------------
				if ($this->smartyVars["client"]["groupID"]) {
					$this->smartyVars["clientAttributeGroup"] = nameByID("attributeGroups", $this->smartyVars["client"]["groupID"]);
				} else {
					$this->smartyVars["clientAttributeGroup"] = "";
				}


				$this->smartyVars["primaryContact"] = collapseArrayElements($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				
				$this->smartyVars["clientGroups"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["clientGroups"][0]["clientGroup"]));
				$this->smartyVars["noteList"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["notes"][0]["note"]));

				// --------------------------------------------------------------
				// Format the ticket data
				// --------------------------------------------------------------
				$this->smartyVars["lastTickets"] =array();
				if (isset( $results["clients"][0]["client"][0]["tickets"] ) && is_array( $results["clients"][0]["client"][0]["tickets"] )) {
					$this->smartyVars["lastTickets"] = correctArray($results["clients"][0]["client"][0]["tickets"][0]["ticket"]);
				}
				
				$this->smartyVars["paymentList"] = getTypes("payments");
				$billingAccountTypes = getTypes("billingAccount");				
				$this->smartyVars["statusList"] = getStatuses("client");
				$this->smartyVars["packageList"] = $packageStatuses = getStatuses("package");
				$this->smartyVars["domainList"] = getStatuses("package");
				$this->smartyVars["certList"] = $certStatuses = getStatuses("package");

				if ($results["clients"][0]["client"][0]["countriesISO2"][0]) {
					$this->smartyVars["clientCountry"] = constant("TRANS_ISO_3166_".$results["clients"][0]["client"][0]["countriesISO2"][0]);
					$this->smartyVars["primaryContactCountry"] = constant("TRANS_ISO_3166_".$results["clients"][0]["client"][0]["contacts"][0]["contact"][0]["countriesISO2"][0]);
				}

                // accounting data we got
                $this->smartyVars["accountingData"] = collapseArrayElements($results["clients"][0]["client"][0]["accountingGeneralLedgers"][0]["accountingGeneralLedger"]);
                if ($this->smartyVars["accountingData"]["currencyID"]){ // clean it up
                    $this->smartyVars["accountingData"] = array($this->smartyVars["accountingData"]);
                }

                // now we can get the totals for each currency of a specific ledger account.
                // ledger accounts you may want totals for are:
                //      "cash", "cash_1", "cash_2" -> the bank accounts, basically, how much money has this client paid us
                //      "accounts_receivable" -> how much this client owes us
                //      "accounts_payable" -> how much misc things (remaining) we have to pay someone else for this client
                //      "domains_payable" -> how much money you have (remaining) to pay registrars for this client
                //      "certs_payable" -> how much money you have (remaining) to pay geotrust for this client
                //      "taxes_payable" -> how much taxes (remaining) you charged this customer to pay to x tax zone
                //      "customer_credits" -> how much money this customer has on credit with you
                //      "revenue" -> how much money you have made off this customer (counts money they paid you and money they still owe you)
                //      "cogs" -> cost of goods, how much money the things you sold this customer have cost you total
                //      "domain_cogs" -> how much money total you have paid for domains you have sold to this customer
                //      "certs_cogs" -> how much money total you have paid for certs you have sold to this customer
                //      "setup_cogs" -> how much money total you have paid in setup fees for things you have sold to this customer
                //      "usage_cogs" -> not implemented yet
                //      "expense" -> misc expenses you have incurred due to this client
                //      "refund_expense" -> how much money you have refunded to this customer
                //
                //      basically, you do:
                //       $var = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "ACCOUNT_NAME_HERE");
                //
                //      and $var will be an array of arrays of form: currencyID=>total, currencyID=>total
                //      example:
                //      array('USD'=>123.45,
                //            'AUD'=>234.56,
                //            'GBP'=>345.67
                //      )
                //
                // below I will do a few accounts we will want by default

                // accounts receivable, what they owe us
                $this->smartyVars["accountingAccountsReceivable"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "accounts_receivable");
                // auth only stuff, what we can get by a prior auth capture
                $this->smartyVars["accountingAuthorized"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "authorized_payments");
                // customers credits, what we owe them
                $this->smartyVars["accountingCustomerCredits"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "customer_credits");
                // revenue, what we have made off them
                $this->smartyVars["accountingRevenue"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "revenue");
                // payables, what we owe someone currently for this customer
                $this->smartyVars["accountingPayables"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], array("accounts_payable", "domains_payable", "certs_payable", "taxes_payable"));
                // cogs, what we have paid other people for this customer
                $this->smartyVars["accountingCogs"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], array("cogs", "domains_cogs", "certs_cogs", "setup_cogs"));
                // refund, what we have refunded this customer
                $this->smartyVars["accountingRefunds"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "refund_expense");
                // expense, misc expenses we have incurred for this customer
                $this->smartyVars["accountingExpenses"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "expense");

                ksort($this->smartyVars["accountingAccountsReceivable"]);
                ksort($this->smartyVars["accountingCustomerCredits"]);
                ksort($this->smartyVars["accountingRevenue"]);
                ksort($this->smartyVars["accountingPayables"]);
                ksort($this->smartyVars["accountingCogs"]);
                ksort($this->smartyVars["accountingRefunds"]);
                ksort($this->smartyVars["accountingExpenses"]);


				// count package status
				if (is_array($results["clients"][0]["client"][0]["packages"][0]["package"])) {
					foreach($results["clients"][0]["client"][0]["packages"][0]["package"] as $package) {
						$this->smartyVars["packageStatuses"][$package["packageStatus"][0]] += $package["packageCount"][0];
					}
				}

				// count domain status
				if (is_array($results["clients"][0]["client"][0]["domains"][0]["domain"])) {
					foreach($results["clients"][0]["client"][0]["domains"][0]["domain"] as $domain) {
						$this->smartyVars["domainStatuses"][$domain["packageStatus"][0]] += $domain["domainPackageCount"][0];
					}
				}

				// count cert status
				if (is_array($results["clients"][0]["client"][0]["certs"][0]["cert"])) {
					foreach($results["clients"][0]["client"][0]["certs"][0]["cert"] as $cert) {
						$this->smartyVars["certStatuses"][$cert["packageStatus"][0]] += $cert["certPackageCount"][0];
					}
				}

				// count billing account types
				if (is_array($results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"])) {
					foreach($results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"] as $billingAccount) {
						$this->smartyVars["billingAccountTypes"][$billingAccount["billingAccountType"][0]] += $billingAccount["billingAccountCount"][0];
					}
				}


/*
				//Fix the invoice list.  It is returning each line item instead of just the invoice
				$displayInvoices = NULL;
				$invoices = array();
				$invoiceLineItems = correctArray($results["clients"][0]["client"][0]["invoices"][0]["invoice"]);
show($invoiceLineItems);
				$invoiceCount = 0;
				if(is_array($invoiceLineItems)) {
					
					//$invoices["totalCount"] = count($invoiceLineItems);
					
					foreach($invoiceLineItems as $lineItem) {
						$invoices[$lineItem["currencyID"]]["amountDue"] += $lineItem["invoiceAmount"];
						$invoices[$lineItem["currencyID"]]["amountPaid"] += $lineItem["invoiceAmountPaid"];
						if($lineItem["invoiceAmount"] === $lineItem["invoiceAmountPaid"]) {
							$invoices[$lineItem["currencyID"]]["paid"]++;
						}
						if($lineItem["invoiceAmount"] > $lineItem["invoiceAmountPaid"]) {
							$invoices[$lineItem["currencyID"]]["due"]++;
						}
					//Get 5 invoices for display
						if (count($displayInvoices)<5){
							$displayInvoices[$lineItem["invoiceID"]] = array(
								"invoiceNumber" => $lineItem["invoiceNumber"],
								"invoiceStatus" => $lineItem["invoiceStatus"],
								"amount"  => $lineItem["invoiceAmount"],
								"paid" => $lineItem["invoiceAmountPaid"]);
						}
					}
					$this->smartyVars["displayInvoices"] = $displayInvoices;
					$this->smartyVars["invoiceDetails"] = $invoices;
				}
*/

				// --------------------------------------------------------------
				// MBAPI call to lookup currency IDs				
				// --------------------------------------------------------------
				$currencyIDs = collapseArrayElements(dispatchMBAPI($this->getMBAPIQuery("GetCurrencyIDs", "", array()), 1));
				dbg($currencyIDs);
				$currencyIDs = $currencyIDs["mbapi"]["results"]["currencyID"];
				if (!is_array($currencyIDs)){
					$currencyIDs = array($currencyIDs);
				}
				foreach ($currencyIDs as $cid){
					$this->smartyVars["currencyIDs"][$cid] = $cid;
				}

				// --------------------------------------------------------------
				// MBAPI call to lookup the client attributes				
				// --------------------------------------------------------------
								
				$this->smartyVars["clientAttributes"] = arrayFor(
					"clientAttributes",
					array(
						"clientID" => $clientID,
						"attribute" => array(),
					)
				);
				
				$this->smartyVars["programaticAttributes"] = getTypes("programaticAttributes");

				// --------------------------------------------------------------
				// MBAPI call to lookup the last 5 emails sent to the client
				// --------------------------------------------------------------
				$lastEmails =& new MBQuery("GetEmailQueue", "", array(
					"clientContactID" => $this->smartyVars["primaryContact"]["clientContactID"],
					"numRecords" => 5,
					"suppressEmailText" => 1,
					"sortDir" => "desc",
					"sortColumn" => "emailDateSent"));				
				$lastEmails = $lastEmails->getResult();
				if ($lastEmails->getSuccess()) {
					$this->smartyVars["lastEmails"] = grabSimpleMBAPIResults( $lastEmails->getStructure() );
				}
				unset($lastEmails);
				
				// --------------------------------------------------------------
				// MBAPI call to get the sums of all invoices by status
				// --------------------------------------------------------------
				$invoiceStats =& new MBQuery("GetInvoices", "", array(
					"clientID" => $clientID,
					"getInvoiceSums" => 1));		
				$results = $invoiceStats->getResult();
				$invoiceStats = grabSimpleMBAPIResults($results->getStructure());
				$n = count($invoiceStats);
				$this->smartyVars["invoiceStats"] = array();
				for($i=0;$i<$n;$i++){
					$invoiceStatus = $invoiceStats[$i]["invoiceStatus"];
					$currencyID = $invoiceStats[$i]["currencyID"];				
					$numInvoices = $invoiceStats[$i]["numInvoices"];
					$sumInvoicesAmount = $invoiceStats[$i]["sumInvoicesAmount"];
					$sumInvoicesAmountPaid = $invoiceStats[$i]["sumInvoicesAmountPaid"];

					$this->smartyVars["invoiceStats"][$currencyID][$invoiceStatus] = 
						array(
							"invoiceStatus" => $invoiceStatus,
							"numInvoices" => $numInvoices,
							"sumInvoicesAmount" => $sumInvoicesAmount,
							"sumInvoicesAmountPaid" => $sumInvoicesAmountPaid,
							"sumInvoicesAmountDue" => $sumInvoicesAmount - $sumInvoicesAmountPaid,
						);

					sort($this->smartyVars["invoiceStats"][$currencyID]);
				}
				

				// --------------------------------------------------------------
				// Set locale data
				// --------------------------------------------------------------
                $tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
                $tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
                $tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
                $CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
                $this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;

				$this->smartyVars["productCount"] = countFor("productsGeneric", array("productAddonGroupID"=>null));

				// --------------------------------------------------------------
				// Set ledger data names
				// --------------------------------------------------------------
/*				$this->smartyVars["ledgerAccountNames"] = 
				array(
					"customer_expense" => TRANS_CUSTOMER_EXPENSE,
					"refund_expense" => TRANS_REFUND_EXPENSE,
					"colocation_expense" => TRANS_COLOCATION_EXPENSE,
					"affiliate_commissions_expense" => TRANS_AFFILIATE_COMMISSIONS,
					"affiliate_commissions_payable" => TRANS_AFFILIATE_COMMISSIONS_PAYABLE
				);*/

				$this->smartyVars["includeAjaxJS"] = 1;
				$this->mergeThemeData();
				$this->smartyVars["cycles"] = getCyclesArray();
				$this->smartyVars["resendEmailPackages"] = correctArray(getMBAPIArray("GetResendEmailPackages", array(
					"clientID" => $clientID,
				)));
				
				$this->addLedgerAccounts();
				$groups = correctArray(getMBAPIArray("GetPaymentGroups"));
				$this->smartyVars["paymentGroups"] = array();
				foreach ((array)$groups as $g){
					$this->smartyVars["paymentGroups"][$g["paymentGroupID"]] = $g["paymentGroupCurrencyID"]." - ".$g["paymentGroupName"];
					$gws = array();
					foreach ((array)$g["gateways"] as $gw){
						$gws[] = $gw["configGroupTransKey"];
					}
					if ($gws){
						$this->smartyVars["paymentGroups"][$g["paymentGroupID"]] .= " (".TRANS_GATEWAYS.": ".implode(", ", $gws).")";
					}
				}
				$contactIDs = IDsOf(":contacts", array(
					"clientID" => $clientID,
				));
				$accounts = arrayFor(":billingAccounts", array(
					"clientContactID" => $contactIDs,
					"contact" => array(),
				));
				$this->smartyVars["billingAccounts"] = array();
				foreach ((array)$accounts as $ac){
					$CONF["sources"]["billingAccounts"]["refColumnGenerator"]($ac);
					$contact = $ac["contact"][0];
					$this->smartyVars["billingAccounts"][$ac["billingAccountID"]] = $contact["contactFirstName"]." ".$contact["contactLastName"]." - ".$ac["billingAccountDisplayName"];
				}
				
				$this->addTemplate("clients/ShowClientDetails", $this->smartyVars);
				
			}

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
