<?php
// $Id: ShowLastFiveClientInvoices.php 11020 2007-04-18 16:52:33Z bsmith $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * @author  Michael Fountain
 */
class ShowLastFiveClientInvoices extends MB_Action {
	/**
	 */
	function ShowLastFiveClientInvoices() {
		parent::MB_Action();
		$this->stringRep = "ShowLastFiveClientInvoices";
		$this->params = array("clientID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetInvoices", "", array(
			"sortDir" => "desc",
			"sortColumn" => "invoiceID",
			"numRecords" => "5",
		));

		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {

			// set master invoices data array
			$this->smartyVars["invoices"] = collapseArrayElements(
                                                protectArray($results["invoices"][0]["invoice"])
                                            );

			// set pagination links data
			$this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);
			
			$this->mergeAvailablePrintDrivers();
			
			// call the display template
			$this->addTemplate("clients/ShowLastFiveClientInvoices");
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowLastFiveClientInvoices
?>
