<?php
// $Id: ShowLastFiveClientPackages.php 12063 2007-10-10 14:53:27Z achrist $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * @author  Michael Fountain
 */
class ShowLastFiveClientPackages extends MB_Action {
	/**
	 */
	function ShowLastFiveClientPackages() {
		global $CONF;
		parent::MB_Action();
		$this->stringRep = "ShowLastFiveClientPackages";
		$this->params = array("clientID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		/*
			function getMBAPIQuery($command, $subCommand = "", $custom = array(), $addSortDirection = 0,
			$addSortColumn = 0, $addRecordOffset = 0, $addNumRecords = 0, $showXMLHeader = 0, $skipParams = array(), $subParams = "") {		

			$CONF["APItypes"]["products"][0] = "undefined";
			$CONF["APItypes"]["products"][1] = "hosting";
			$CONF["APItypes"]["products"][2] = "non-hosting";
			$CONF["APItypes"]["products"][3] = "domain";
			$CONF["APItypes"]["products"][4] = "cert";
			$CONF["APItypes"]["products"][5] = "license";
			$CONF["APItypes"]["products"][6] = "software";
			$CONF["APItypes"]["products"][7] = "usage";
			$CONF["APItypes"]["products"][8] = "contract";
			$CONF["APItypes"]["products"][9] = "fee";
		*/

		$query = $this->getMBAPIQuery("GetPackages", "", array(
			"getClientData" => 1,
			"getDomainData" => 1,
			"suppressFeePackages" => 1,
			"sortDir" => "desc",
			"sortColumn" => "packageID",
			"numRecords" => "5",
			"getPackageAttributeData" => 1,
		));


		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];


		if($this->addMBAPIErrors($data) === 0) {

			// make sure we have packages before we perform any of the sub queries
			if ((int)$data["mbapi"][0]["header"][0]["numResults"][0]) {

			$this->smartyVars["packages"] = correctArray($results["packages"][0]["package"]);
			$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
			/*if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["packages"] = array(0 => $results["packages"][0]["package"]);
			}*/

			//Pull the event queue items out
			$queueStatuses = getStatuses("queue");
			$queueItems = array();

			$packagesTemp = correctArray($results["packages"][0]["package"]);

			// need to put into command post 5.1
			if($packagesTemp) {
				foreach($packagesTemp as $key => $value) {
					if((int) $value["packageID"]) {
						$query = $this->getMBAPIQuery("GetSystemQueue", "", array("packageID"=>$value["packageID"]));
						$data = dispatchMBAPI($query, 1);


						$results =& $data["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"];
						if($results) {
							foreach($results as $v) {
								$this->smartyVars["packages"][$key]["systemQueueItems"][$v["systemQueueID"][0]] =
														array("configGroupID" => $v["configGroupID"][0],
																		"packageID" => $v["packageID"][0],
																		"serverGroupID" => $v["serverGroupID"][0],
																		"systemQueueStatus" => $queueStatuses[(int)$v["systemQueueStatus"][0]],
																		"systemQueueCommand" => $v["systemQueueCommand"][0],
																		"systemQueueDateFinished" => $v["systemQueueDateFinished"][0],
																			);
							}
						}
					}
				}
			}
			$this->smartyVars["productsTypes"] = getTypes("products");
			$this->smartyVars["packageStatuses"] = getStatuses("package");
			$this->smartyVars["cycles"] = getCyclesArray();

			// process product attributes and create package data
			$include = array( "ip", "clientLogin", "clientPassword", "domainUserName", "domainPassword", "packagePassword");
			foreach( (array)$this->smartyVars["packages"] as $pkgK => $package ) {
				foreach( (array)$package["packageAttributes"] as $attribK => $attrib ) {
					if (in_array( $attrib["packageAttributeName"], $include ) && notNull( $attrib["packageAttributeValue"] )) {
						switch( $attrib["packageAttributeName"] ) {
							case "ip":
								$tempIP = $attrib["packageAttributeValue"];
								if($tempIP == ip2long(long2ip($attrib["packageAttributeValue"]))) {
									$attrib["packageAttributeValue"] = long2ip($attrib["packageAttributeValue"]);
								}
								if($tempIP == long2ip(ip2long($attrib["packageAttributeValue"]))) {
									$attrib["packageAttributeValue"] = long2ip(ip2long($attrib["packageAttributeValue"]));
								}
							break;
							case "domainPassword":
							case "packagePassword":
							case "clientPassword":
								require_once mb_path("/lib-tk/include/crypt/crypt.php");
								$c = new Crypt( getPasswordHash(PANELENCRYPTIONKEY), "orangefish", NULL );
								
								$attrib["packageAttributeValue"] = $c->decrypt( $attrib["packageAttributeValue"] );
								unset( $c );
							break;
						}

						if (notZero( $attrib["configGroupID"] )) {
							$cg = oneOf( ":configParams", array("configGroupID" => (int)$attrib["configGroupID"], "configParamName" => "moduleDisplayName"));
							$this->smartyVars["packages"][ $pkgK ]["packageMeta"]["configGroupName"] = $cg["configParamValue"];
							unset( $cg );
						}

						if (notZero( $attrib["serverGroupID"] )) {
							$sg = oneOf( "serverGroups", array("serverGroupID" => (int)$attrib["serverGroupID"]));
							$this->smartyVars["packages"][ $pkgK ]["packageMeta"]["serverGroupName"] = $sg["serverGroupName"];
							unset( $sg );
						}
						
						$this->smartyVars["packages"][ $pkgK ]["packageMeta"][ $attrib["packageAttributeName"] ] = $attrib["packageAttributeValue"];
					}
				}
				unset( $attribK, $attrib );

				if (is_array( $package["domains"][0] )) {
					$this->smartyVars["packages"][ $pkgK ]["packageMeta"]["domainName"] = $package["domains"][0]["domainSLD"].".".$package["domains"][0]["domainTLD"]; 
				}

			}
			unset( $pkgK, $package, $include );
			$this->smartyVars = correctArray($this->smartyVars);
			$this->mergePrimaryContactData();

			} // END IF: Do we have packages?

			$this->addTemplate("clients/ShowLastFiveClientPackages");
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowLastFiveClientPackages
?>
