<?php
// $Id: TakeClientPayment.php 10684 2007-02-16 22:18:33Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It displays a form to allow immediate charging of
 * a client for due invoices.
 *
 * @author  Kris Bailey
 */
class TakeClientPayment extends MB_Action {

	function TakeClientPayment() {
		parent::MB_Action();
		$this->stringRep = "TakeClientPayment";
		$this->params = array(
			"clientID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();
		
		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$this->smartyVars["client"] = oneByID("clients", $clientID, array(
				"mergePrimaryContact" => 1,
			));
			$this->smartyVars["invoices"] = arrayFor("invoices", array(
				"clientID" => $clientID,
				"getDueInvoicesOnly" => 1,
			));
			//$this->smartyVars["invoices"] = array();
			//foreach ($invoices as $inv){
			//	$this->smartyVars["invoices"][$inv["invoiceID"]] = $inv["invoiceNumber"]." - ".TRANS_DUE.": ".$CONF["user"]["locale"]->getLocaleCurrency($inv["invoiceAmount"]-$inv["invoiceAmountPaid"]);
			//}

			$this->addTemplate("clients/TakeClientPayment", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
} // TakeClientPayment
?>
