<?php
// $Id: TakeClientPaymentResponse.php 11916 2007-09-17 16:43:07Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It displays a form to allow immediate charging of
 * a client for due invoices.
 *
 * @author  Kris Bailey
 */
class TakeClientPaymentResponse extends MB_Action {

	function TakeClientPaymentResponse() {
		parent::MB_Action();
		$this->stringRep = "TakeClientPaymentResponse";
		$this->params = array(
			"clientID",
			"invoiceIDs",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();
		loadConfigs("payment");

		$clientID = getParam('clientID');
		$invoiceIDs = (array)$_REQUEST["invoiceIDs"];
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} elseif (!$invoiceIDs || !(int)$invoiceIDs[0]) {
			$this->addError(TRANS_ACTIONERROR, "No invoice ID's given.");
		} else {

			$this->smartyVars["client"] = oneByID("clients", $clientID, array(
				"mergePrimaryContact" => 1,
			));

			$this->paymentAction = $CONF["payment"]["paymentQueue"]["transactionAction"];
			if ($this->paymentAction!="auth"){
				$this->paymentAction = "charge";
			}
			$runCmd = array(
				"mbapi" => array(
					"command" => "ProcessPaymentQueue",
					"params" => array(
						"invoiceID" =>  $invoiceIDs,
						"generateNew" => 1,
						"runPaymentQueue" => 1,
						"getTransactionData" => 1,
						"transactionAction" => $this->paymentAction,
						"key" => $_REQUEST["encKey"],
						"ignoreRetryTime" => (int)$_REQUEST["ignoreRetryTime"]
					),
				),
			);
			
			$results = dispatchMBAPI(toXML($runCmd), 1);
			
			if ($this->addMBAPIErrors($results) === 0 && !$this->getNumErrors()) {
			
				$this->smartyVars["transactionInfo"] = correctArray($results["mbapi"][0]["results"][0]);
	
				$billingAccountIDs = array();
				foreach ((array)$this->smartyVars["transactionInfo"]["transaction"] as $tr){
					$billingAccountIDs[] = $tr["billingAccountID"];
				}
				$billingAccounts = arrayFor("billingAccounts", array(
					"billingAccountID" => $billingAccountIDs,
				));
				$this->smartyVars["billingAccounts"] = array();
				foreach ($billingAccounts as $x=>$ba){
					$this->smartyVars["billingAccounts"][$ba["billingAccountID"]] =& $billingAccounts[$x];
				}
				$this->smartyVars["paymentStatuses"] = $CONF["statuses"]["transactions"];
				if (!$this->smartyVars["transactionInfo"]){
					$this->smartyVars["noTransactions"] = 1;
				}
			} else {
				$this->smartyVars["errors"] = correctArray($results["mbapi"][0]["header"][0]["errors"][0]["error"]);
			}
			
			$this->addTemplate("clients/TakeClientPaymentResponse", $this->smartyVars);
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
} // TakeClientPaymentResponse
?>
