<?php
// $Id: EditEncryptionConfigs.php 9623 2006-10-17 03:01:49Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class gets the info for encryption settings and displays it for editing.
 *
 * @author  Kris Bailey
 */
class EditEncryptionConfigs extends MB_Action {

	function EditEncryptionConfigs() {
		parent::MB_Action();
		$this->stringRep = "EditEncryptionConfigs";
	}

	function execute() {
		global $CONF;
		parent::execute();

		loadConfigs("system", "encryption");

		$this->smartyVars["agree"] = $CONF["system"]["encryption"]["encryption_agree"];
		$this->smartyVars["key"] = $CONF["system"]["encryption"]["encryption_hash"];
		$this->smartyVars["genericType"] = "editobject";
		$this->smartyVars["parentName"] = "TRANS_SYSTEM";
		$this->smartyVars["childName"] = "TRANS_SETTINGS";
		$this->smartyVars["grandchildName"] = "TRANS_ENCRYPTION_SETTINGS";
		$this->smartyVars["sideNavMajor"] = "system";

		$this->smartyVars["saved"] = (int)$_REQUEST["saved"];

		/** AUTO GENERATE FORM DATA BEGIN **/
		$this->smartyVars["editForm"] =& new MBAutoFormFields();
		$this->smartyVars["editForm"]->addFields(array(
			"encryptionAgree" => array("text", "TRANS_ENCRYPTION_TYPE_AGREE_TO_ENABLE"),
			"encryptionHash" => array("textarea", "TRANS_ENCRYPTION_HASH"),
			"lekPin" => array("password", "TRANS_LEK_PIN"),
			"passPhrase" => array("password", "TRANS_PASSPHRASE"),
		));

		$this->smartyVars["editForm"]->setFieldData("encryptionAgree", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("encryptionAgree", "helpText", str_replace("'", '"', TRANS_YOU_MUST_TYPE_AGREE_TO_ENABLE));

		$this->smartyVars["editForm"]->setFieldData("lekPin", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("lekPin", "helpText", TRANS_ENTER_THE_FOUR_DIGIT_PIN_YOU_USED_WHEN_MAKING_YOUR_HASH);

		$this->smartyVars["editForm"]->setFieldData("encryptionHash", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("encryptionHash", "helpText", TRANS_ENTER_YOUR_ENCRYPTION_HASH_HERE_BUT_ONLY_LEK);

		$this->smartyVars["editForm"]->setFieldData("passPhrase", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("passPhrase", "helpText", TRANS_ENTER_PASSPRASE_IF_NOT_LEK);

		$this->smartyVars["editForm"]->addFieldValue("encryptionAgree", $this->smartyVars["agree"]);
		$this->smartyVars["editForm"]->addFieldValue("encryptionHash", $this->smartyVars["key"]);
		$this->smartyVars["editForm"] = $this->smartyVars["editForm"]->getData();

		if($config = oneOf("configParams", array("configParamName" => "priorCypherType"))) {
			$this->smartyVars["priorCypherType"] = $config["configParamValue"];
			$this->smartyVars["priorCypherTypeID"] = getAPITypeID("encryption", $config["configParamValue"]);
		}

		$this->addTemplate("configs/EditEncryptionConfigs", $this->smartyVars, 1);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // EditEncryptionConfigs
?>
