<?php
// $Id: EditEncryptionConfigsConfirm.php 9668 2006-10-17 20:31:45Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class gets the info for encryption settings and displays it for editing.
 *
 * @author  Ben Woolley
 */
class EditEncryptionConfigsConfirm extends MB_Action {

	function EditEncryptionConfigsConfirm() {
		parent::MB_Action();
		$this->stringRep = "EditEncryptionConfigsConfirm";
	}

	function execute() {
		global $CONF;
		parent::execute();

		do {
		
			loadConfigs("system", "encryption");

			if($CONF["system"]["encryption"]["encryption_agree"] != "agree" && $_REQUEST["encryption_agree"] != "agree") {
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&noagree=1");
				break;
			}
			
			$agreeParamID = IDByName("configParams", "encryption_agree");
			if(!updateForKey("configParams", $agreeParamID, array("configParamValue" => "agree"))) {
				$this->addError(TRANS_MBAPIERROR, "Problem enabling encryption." . lastError());
				break;
			}

			if($_REQUEST["lek_pin"]) {
				if($_REQUEST["lek_pin_confirm"] != $_REQUEST["lek_pin"]) {
					redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&pinerr=1");
					break;
				}				
				$lekPin = getEncryptedText($_REQUEST["lek_pin"]);
			}
			
			if($_REQUEST["pass_phrase"] != $_REQUEST["pass_phrase"]) {
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&passerr=1");
				break;
			}

			if($_REQUEST["old_pass_phrase"] != $_REQUEST["old_pass_phrase"]) {
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&oldpasserr=1");
				break;
			}

			foreach(
				array(
					"lek_pin",
					"lek_pin_confirm",
					"old_pass_phrase",
					"old_pass_phrase_config",
					"pass_phrase",
					"pass_phrase_config",
					"encryption_mode",
					"encryption_agree",
					"encryption_hash",
					"priorCypherType",
					"neededCypherType",
				) as $param
			) {
				$this->smartyVars["propagate"][$param] = (string) $_REQUEST[$param];
			}

			$priorCypherType = $_REQUEST["priorCypherType"] ? stripslashes($_REQUEST["priorCypherType"]) : stripslashes($_REQUEST["neededCypherType"]);
			$this->smartyVars["from"] = array(
				"type" => getTypeName("encryption", getAPITypeID("encryption", $priorCypherType)),
			);
			if($CONF["system"]["encryption"]["encryption_agree"] != "agree") {
				$this->smartyVars["from"]["mode"] = "none";
			} else if($CONF["system"]["encryption"]["encryption_hash"]) {			
				$this->smartyVars["from"]["mode"] = "lek";
				$this->smartyVars["from"]["hash"] = $CONF["system"]["encryption"]["encryption_hash"];
			} else {
				$this->smartyVars["from"]["mode"] = "passphrase";
			}
			
			$neededCypherType = stripslashes($_REQUEST["neededCypherType"]);
			$this->smartyVars["to"] = array(
				"type" => getTypeName("encryption", getAPITypeID("encryption", $neededCypherType)),
				"mode" => $_REQUEST["encryption_mode"],
				"hash" => $_REQUEST["encryption_mode"] == "lek" ? stripslashes($_REQUEST["encryption_hash"]) : "",
			);

			$this->addTemplate("configs/EditEncryptionConfigsConfirm", $this->smartyVars, 1);
		} while(0);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // EditEncryptionConfigsResponse
?>
