<?php
// $Id: EditEncryptionConfigsResponse.php 9661 2006-10-17 19:55:47Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class gets the info for encryption settings and displays it for editing.
 *
 * @author  Ben Woolley
 */
class EditEncryptionConfigsResponse extends MB_Action {

	function EditEncryptionConfigsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditEncryptionConfigsResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		do {
		
			loadConfigs("system", "encryption");

			if($CONF["system"]["encryption"]["encryption_agree"] != "agree" && $_REQUEST["encryption_agree"] != "agree") {
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&noagree=1");
				break;
			}
			
			$agreeParamID = IDByName("configParams", "encryption_agree");
			if(!updateForKey("configParams", $agreeParamID, array("configParamValue" => "agree"))) {
				$this->addError(TRANS_MBAPIERROR, "Problem enabling encryption." . lastError());
				break;
			}

			if($_REQUEST["lek_pin"]) {
				if($_REQUEST["lek_pin_confirm"] != $_REQUEST["lek_pin"]) {
					redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&pinerr=1");
					break;
				}				
				$lekPin = getEncryptedText($_REQUEST["lek_pin"]);
			}
			
			if($_REQUEST["pass_phrase"] != $_REQUEST["pass_phrase"]) {
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&passerr=1");
				break;
			}

			if($_REQUEST["old_pass_phrase"] != $_REQUEST["old_pass_phrase"]) {
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&oldpasserr=1");
				break;
			}

			$params = array(
				"from" => array(
					"type" => $_REQUEST["priorCypherType"] ? stripslashes($_REQUEST["priorCypherType"]) : stripslashes($_REQUEST["neededCypherType"]),
				),
				"to" => array(
					"type" => stripslashes($_REQUEST["neededCypherType"]),
				),
			);
			switch($_REQUEST["encryption_mode"]) {
				case "lek":
					$params["to"]["encryption"] = array(
						"encryptionHash" => stripslashes($_REQUEST["encryption_hash"]),
						"lekPin" => $lekPin,
					);
					if($_REQUEST["old_pass_phrase"]) {
						$params["from"]["passPhrase"] = $_REQUEST["old_pass_phrase"];
					}
					break;
				case "passphrase":
					$params["to"]["passPhrase"] = $_REQUEST["pass_phrase"];
					break;
				case "none":
					redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&nocrypt=1");					
					break 2;
			}

			$q =& new MBQuery("ProcessEncryption", "", $params);
			//show($q->getXMLQuery());
			//exit;
			$r =& $q->getResult();
			//show($r);
			//exit;
			if($r->getSuccess()) {
				if($configParamID = IDByName("configParams", "priorCypherType")) {
					updateForKey("configParams", $configParamID, array("configParamValue" => $_REQUEST["neededCypherType"]));
				}
				redirect("configs.php?sid=".$_REQUEST["sid"]."&action=".getActionID("EditEncryptionConfigs")."&saved=1");
				break;
			} else {
				$this->addError(TRANS_MBAPIERROR, "Problem processing encryption: " . lastError());
				break;
			}

		} while(0);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // EditEncryptionConfigsResponse
?>
