<?php
// $Id: ShowDashboard.php 8633 2006-09-04 03:55:29Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action shows the intro for the first time log in
 *
 * @author  Kris Bailey
 */

class FirstTimeDisplayStep extends MB_Action {

	/**
	 */
	function FirstTimeDisplayStep() {
		parent::MB_Action();
		$this->stringRep = "FirstTimeDisplayStep";
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if ($_REQUEST["a"]=="sharedip"){
			$param = oneOf(":configParams", array(
				"configParamName" => "ip",
				"configParamValue" => "UNKNOWN",
			));
			// we don't want to mess with the shared ip from here if they don't need it
			if (!(int)$param["configParamID"]){
				$_REQUEST["a"] = "gateway";
			}
		} elseif ($_REQUEST["a"]=="encryption"){
			loadConfigs("system", "encryption");
			// we don't want to mess with encryption if they have already done it
			if ($CONF["system"]["encryption"]["encryption_agree"]=="agree"){
				$_REQUEST["a"] = "fraudguardian";
			}
		}

		if ($_REQUEST["a"]=="" || $_REQUEST["a"]=="registrar" || !$_REQUEST["a"]){

			if (licRawData!="FREE"){
				$ama = $_MB_ALIASES["app-modernbill-admin"] ? $_MB_ALIASES["app-modernbill-admin"] : "app-modernbill-admin";
				$returnURL = (($CONF["secureURLProtocol"]=="http")?"http://".$CONF["standardURL"]:"https://".$CONF["secureURL"])."/".$ama."/configs.php?action=".getActionID("FirstTimeDisplayStep")."&sid=".$_REQUEST["sid"]."&a=registrar&enomUsername=USERNAME&enomPassword=PASSWORD";
				$securityCode = getPasswordHash(PANELENCRYPTIONKEY.$returnURL);
				$this->smartyVars["returnURL"] = base64_encode($returnURL);
				$this->smartyVars["securityCode"] = $securityCode;
				$this->smartyVars["adminInfo"] = oneByID(":admins", $CONF["user"]["id"]);
				$this->smartyVars["companyInfo"] = oneByID(":companies", 1);
				$country = oneByID(":countries", $this->smartyVars["companyInfo"]["countriesID"]);
				$this->smartyVars["companyInfo"]["countriesISO2"] = $country["countriesISO2"];
			}

			$registrars = getAvailableModules("registrar");

			loadConfigs("server");
			loadConfigs("domain");
			if (!is_array($CONF["domain"]["registrar"])){
				$CONF["domain"]["registrar"] = array();
			}
			$p = $this->getMBAPIQuery("GetConfigGroups", "", array("configGroupName" => "registrar"));
			$parent = grabSimpleMBAPIResults(dispatchMBAPI($p, 1));
			$parentID = $parent[0]["configGroupID"];

			foreach ($registrars as $regName){
				$regName = basename($regName, ".php");
				if ($regName=="generic") continue;
				if (!$CONF["domain"]["registrar"][$regName]){
					$addNew =& new MBQuery("SetConfigGroups", "insert", array(
						"parentConfigGroupID" => $parentID,
						"addRegistrar" => $regName,
					));
					$addNew->getResult();
				} else {
					$CONF["domain"]["registrar"][$regName]["modulePassword"] = getStuff($CONF["domain"]["registrar"][$regName]["modulePassword"]);
				}
			}
			// again to refresh
			loadConfigs("domain");

			if ($_REQUEST["enomUsername"]){
				$cpu = oneOf(":configParams", array(
					"configParamName" => "moduleUsername",
					"configGroupID" => $CONF["domain"]["registrar"]["enom"]["configGroupID"],
				));
				updateForKey(":configParams", $cpu["configParamID"], array(
					"configParamValue" => $_REQUEST["enomUsername"],
				));
				$cpp = oneOf(":configParams", array(
					"configParamName" => "modulePassword",
					"configGroupID" => $CONF["domain"]["registrar"]["enom"]["configGroupID"],
				));
				updateForKey(":configParams", $cpp["configParamID"], array(
					"configParamValue" => getEncryptedText($_REQUEST["enomPassword"]),
				));
			}

			unset($CONF["domain"]["registrar"]["generic"]);

			foreach ($CONF["domain"]["registrar"] as $r=>$d){
				////////////
				$configGroupID = $d["configGroupID"];
				$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
				$data = dispatchMBAPI($xml, 1);
		
				$configParamDataResults =& $data["mbapi"][0]["results"][0]["configs"][0]["config"];
				$configParamDataResults = collapseArrayElements($configParamDataResults);
		
				$parentConfigGroupID = $configParamDataResults[0]["parentConfigGroupID"];
		
				$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
				$data = dispatchMBAPI($xml, 1);
				$CONF["debug"]->add("MBAPI Results (EditRegistrarConfig)", $data, __FILE__, __LINE__);
		
				$configParamValueResults =& $data["mbapi"][0]["results"][0];
				// fix child config param values structure when only 1 child config param value exists
				$numParams = $data["mbapi"][0]["header"][0]["numResults"][0];
		
				// loop through all params to test for param values
				for($i=0;$i<$numParams;$i++) {
					$p =& $configParamValueResults["configs"][0]["config"][$i]["paramValues"][0]["paramValue"];
					// loop through param values if they exist
					$numParamValues = count($p);
					for($j=0;$j<$numParamValues;$j++) {
						// define the translation key or display it raw if not defined
						$translatedName = (defined($p[$j]["configParamValueTransKey"][0])) ?
							constant($p[$j]["configParamValueTransKey"][0]) :
							$p[$j]["configParamValueTransKey"][0];
						// shorten the ID
						$configParamID = $configParamValueResults["configs"][0]["config"][$i]["configParamID"][0];
						// create a new smooshed array for html_options in smarty
						$configParamValueName = $p[$j]["configParamValueName"][0];
						$configParamValues[$configParamID][$configParamValueName] = $translatedName;
					}
				}
		
				foreach($configParamDataResults as $key => $value) {
					if($value["configParamName"] == "modulePassword") {
						$configParamDataResults[$key]["configParamValue"] = getStuff($value["configParamValue"]);
					}
				}
				
				$CONF["domain"]["registrar"][$r]["configParams"] = $configParamDataResults;
				$CONF["domain"]["registrar"][$r]["configParamValues"] = $configParamValues;
				$CONF["domain"]["registrar"][$r]["parentConfigGroupID"] = $parentConfigGroupID;
				////////////
			}

			$this->smartyVars["registrars"] =& $CONF["domain"]["registrar"];

			$this->smartyVars["step"] = "registrar";

		} elseif ($_REQUEST["a"]=="sharedip"){
			$this->smartyVars["step"] = "sharedip";
			$this->smartyVars["configParamID"] = $param["configParamID"];
		} elseif ($_REQUEST["a"]=="gateway"){

			$paymentGroup = oneOf(":paymentGroups");
			if (!$paymentGroup = $paymentGroup["paymentGroupID"]){
				$paymentGroupID = insertFor(":paymentGroups", array(
					"paymentGroupName" => "Payment Group 1",
					"paymentGroupCurrencyID" => "USD",
				));
			} else {
				$paymentGroupID = $paymentGroup['paymentGroupID'];
			}

			// we need to find out the config group id of the
			// "gateway" parent config group where all of the
			// gateway configurations are stored.
			$paymentCG = oneOf(":configGroups", array(
				"parentConfigGroupID" => 0,
				"configGroupName" => "payment",
			));
			$paymentGCG = oneOf(":configGroups", array(
				"parentConfigGroupID" => $paymentCG["configGroupID"],
				"configGroupName" => "paymentGroups",
			));
			$gatewayCG = oneOf(":configGroups", array(
				"parentConfigGroupID" => $paymentGCG["configGroupID"],
				"configGroupName" => "gateway"
			));
			$gatewayConfigGroupID = $gatewayCG["configGroupID"];
			
			$gconfigs = arrayFor(":configGroups", array(
				"parentConfigGroupID" => $gatewayConfigGroupID,
			));
			$gateways = array();
			foreach ((array)$gconfigs as $gc){
				$gateways[$gc['configGroupName']] = $gc['configGroupID'];
			}
			

			// get the available gateway modules:
			//Get list of files in modules/gateway to build gateway list
			$gatewaydir = mb_path("/lib-mbapi/include/modules/gateway/");
			$dh  = opendir($gatewaydir);
			while (false !== ($filename = readdir($dh))) {
				if (is_file($gatewaydir.$filename) && substr($filename, -4)==".php" && !eregi("\.#", $filename)  && !eregi("gateway\.php", $filename)) {
					$gways[] = $filename;
				}
			}
			sort($gways);
			require_once mb_path("/lib-mbapi/SetConfigGroups.php");
			
			$gatewayInfo = array();

			foreach ($gways as $gatewayFile) {
				$gatewayFile = substr($gatewayFile, 0, -4);
				require_once mb_path("/lib-mbapi/include/modules/gateway/".$gatewayFile.".php");
				if (!$gateways[$gatewayFile]){
					$gatewayXML = "
					<mbapi>
					  <command>SetConfigGroups</command>
					  <subCommand>insert</subCommand>
					  <showXMLHeader></showXMLHeader>
					  <params>
						<addGateway>".$gatewayFile."</addGateway>
					  </params>enableTaxes
					</mbapi>";
					$gway =& new MBAPI_SetConfigGroupsCommand($gatewayXML);
					$gway->execute();
				}
				$moduleInfo = call_user_func(array($gatewayFile,"getModuleInfo"));
				if ($moduleInfo["gatewaytype"] == 1) {
					$gatewayInfo[$gatewayFile] = array(
						"name" => $moduleInfo["displayName"]." (".constant($moduleInfo["status"]).")",
						"type" => 1,
					);
				} else {
					$gatewayInfo[$gatewayFile] = array(
						"name" => $moduleInfo["displayName"]." (".constant($moduleInfo["status"]).")",
						"type" => 0,
					);
				}
			}

			loadConfigs("payment");

			foreach ($CONF["payment"]["paymentGroups"]["gateway"] as $gatewayFile=>$gw){
				////////////
				if ($gw[0]["configGroupID"]){
					$gw = $gw[0];
					$CONF["payment"]["paymentGroups"]["gateway"][$gateway] = $gw;
				}
				$configGroupID = $gw["configGroupID"];
				$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
				$data = dispatchMBAPI($xml, 1);
		
				$configParamDataResults =& $data["mbapi"][0]["results"][0]["configs"][0]["config"];
				$configParamDataResults = collapseArrayElements($configParamDataResults);
		
				$parentConfigGroupID = $configParamDataResults[0]["parentConfigGroupID"];
		
				$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
				$data = dispatchMBAPI($xml, 1);
				$CONF["debug"]->add("MBAPI Results (EditRegistrarConfig)", $data, __FILE__, __LINE__);
		
				$configParamValueResults =& $data["mbapi"][0]["results"][0];
				// fix child config param values structure when only 1 child config param value exists
				$numParams = $data["mbapi"][0]["header"][0]["numResults"][0];
		
				// loop through all params to test for param values
				for($i=0;$i<$numParams;$i++) {
					$p =& $configParamValueResults["configs"][0]["config"][$i]["paramValues"][0]["paramValue"];
					// loop through param values if they exist
					$numParamValues = count($p);
					for($j=0;$j<$numParamValues;$j++) {
						// define the translation key or display it raw if not defined
						$translatedName = (defined($p[$j]["configParamValueTransKey"][0])) ?
							constant($p[$j]["configParamValueTransKey"][0]) :
							$p[$j]["configParamValueTransKey"][0];
						// shorten the ID
						$configParamID = $configParamValueResults["configs"][0]["config"][$i]["configParamID"][0];
						// create a new smooshed array for html_options in smarty
						$configParamValueName = $p[$j]["configParamValueName"][0];
						$configParamValues[$configParamID][$configParamValueName] = $translatedName;
					}
				}
		
				$CONF["payment"]["paymentGroups"]["gateway"][$gatewayFile]["configParams"] = $configParamDataResults;
				$CONF["payment"]["paymentGroups"]["gateway"][$gatewayFile]["configParamValues"] = $configParamValues;
				$CONF["payment"]["paymentGroups"]["gateway"][$gatewayFile]["parentConfigGroupID"] = $parentConfigGroupID;
				$CONF["payment"]["paymentGroups"]["gateway"][$gatewayFile]["type"] = $gatewayInfo[$gatewayFile]["type"];
				$CONF["payment"]["paymentGroups"]["gateway"][$gatewayFile]["name"] = $gatewayInfo[$gatewayFile]["name"];
				////////////
			}

			$enabled = arrayFor(":paymentGroupsGatewayRels", array(
				"paymentGroupID" => $paymentGroupID,
			));

			$this->smartyVars["enabledGateways"] = array();
			foreach ((array)$enabled as $r){
				$this->smartyVars["enabledGateways"][$r["configGroupID"]] = 1;
			}

			$this->smartyVars["paymentGroupID"] = $paymentGroupID;
			$this->smartyVars["gateways"] =& $CONF["payment"]["paymentGroups"]["gateway"];
			$this->smartyVars["step"] = "gateway";
		} elseif ($_REQUEST["a"]=="taxes"){
			// lets do some taxes

			$taxZoneGroups = arrayFor(":taxZoneGroups");

			if ($taxZoneGroups[0]['taxZoneGroupID']){
				$this->smartyVars["taxZoneGroupID"] = $taxZoneGroups[0]['taxZoneGroupID'];
				$this->smartyVars["taxZone"] = oneOf(":taxZones", array(
					"taxZoneGroupID" => $taxZoneGroups[0]['taxZoneGroupID'],
				));
			}

			$this->smartyVars["products"] = optionsFor(":products");
			$productVariants = arrayFor(":productVariants", array(
				"productVariantActive" => 1,
			));

			$this->smartyVars["taxesEnabled"] = 0;
			$this->smartyVars["productVariants"] = array();
			foreach ($productVariants as $v){
				if ($v["taxZoneGroupID"]==$this->smartyVars["taxZoneGroupID"]){
					$this->smartyVars["taxesEnabled"] = 1;
				}
				$this->smartyVars["productVariants"][$v["productID"]][] = $v;
			}

			$this->smartyVars["step"] = "taxes";
		} elseif ($_REQUEST["a"]=="encryption"){

			$this->smartyVars["step"] = "encryption";

		} elseif ($_REQUEST["a"]=="fraudguardian"){

			loadConfigs("other", "fraud");

			$this->smartyVars["fraudguardian"] =& $CONF["other"]["fraud"]["fraudguardian"];

			$this->smartyVars["step"] = "fraudguardian";
		} elseif ($_REQUEST["a"]=="finished"){

			$this->smartyVars["step"] = "finished";

		}

		$this->addTemplate("configs/FirstTimeDisplayStep");

		return $this->hasExecutedSuccessfully();
	}
} // FirstTimeDisplayStep
