<?php
// $Id: ShowDashboard.php 8633 2006-09-04 03:55:29Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action shows the intro for the first time log in
 *
 * @author  Kris Bailey
 */

class FirstTimePerformAction extends MB_Action {

	/**
	 */
	function FirstTimePerformAction() {
		parent::MB_Action();
		$this->stringRep = "FirstTimePerformAction";
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg($_REQUEST);

		if ($_REQUEST["a"]=="registrar"){
			foreach ($_REQUEST["configParams"] as $configParamID=>$configParamValue){
				if ((int)$configParamID){
					updateForKey(":configParams", $configParamID, array(
						"configParamValue" => $configParamValue,
					));
				}
			}
			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "sharedip",
			));
			exit;
		} elseif ($_REQUEST["a"]=="sharedip"){
			updateForKey(":configParams", $_REQUEST["configParamID"], array(
				"configParamValue" => $_REQUEST["sharedip"],
			));
			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "gateway",
			));
			exit;
		} elseif ($_REQUEST["a"]=="gateway"){
			// do the gateway save

			foreach ($_REQUEST["configParams"] as $configParamID=>$configParamValue){
				if ((int)$configParamID){
					updateForKey(":configParams", $configParamID, array(
						"configParamValue" => $configParamValue,
					));
				}
			}

			$enabled = arrayFor(":paymentGroupsGatewayRels", array(
				"paymentGroupID" => $_REQUEST['paymentGroupID'],
			));
			foreach ((array)$enabled as $e){
				deleteForKey(":paymentGroupsGatewayRels", $e['paymentGroupsGatewayRelID']);
			}

			foreach ((array)$_REQUEST['pgateways_e'] as $cfgid){
				insertFor(":paymentGroupsGatewayRels", array(
					"paymentGroupID" => $_REQUEST['paymentGroupID'],
					"configGroupID" => $cfgid,
					"gatewayType" => 1,
				));
			}

			foreach ((array)$_REQUEST['sgateways_e'] as $cfgid){
				insertFor(":paymentGroupsGatewayRels", array(
					"paymentGroupID" => $_REQUEST['paymentGroupID'],
					"configGroupID" => $cfgid,
					"gatewayType" => 0,
				));
			}

			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "taxes",
			));
			exit;
		} elseif ($_REQUEST["a"]=="taxes"){

			if (!(int)$_REQUEST["taxZoneGroupID"]){
				$_REQUEST["taxZoneGroupID"] = insertFor(":taxZoneGroups", array(
					"taxZoneGroupName" => "Products",
					"taxZoneGroupActive" => 1,
				));
			}

			if (!(int)$_REQUEST["taxZoneID"]){
				$company = oneOf(":companies");
				$country = oneOf(":countries", array(
					"countriesID" => $company["countriesID"],
				));
				
				$_REQUEST["taxZoneID"] = insertFor(":taxZones", array(
					"countriesISO2" => $country["countriesISO2"],
					"taxZoneName" => "*",
					"taxZoneAmountType" => 0,
					"taxZoneAmount" => $_REQUEST["taxZoneAmount"],
					"taxZoneDescription" => $_REQUEST["taxZoneDescription"],
					"taxZoneActive" => 1,
					"ledgerAccountID" => getGeneralLedgerAccountID("taxes_payable"),
				));
			} else {
				updateForKey(":taxZones", $_REQUEST["taxZoneID"], array(
					"taxZoneAmount" => $_REQUEST["taxZoneAmount"],
				));
			}

			$variants = arrayFor(":productVariants", array(
				"taxZoneGroupID" => $_REQUEST["taxZoneGroupID"],
			));
			foreach ((array)$variants as $variant){
				updateForKey(":productVariants", $variant["productVariantID"], array(
					"taxZoneGroupID" => 0,
				));
			}

			if ((int)$_REQUEST["enableTaxes"]){
				foreach ((array)$_REQUEST["taxableProducts"] as $variantID){
					updateForKey(":productVariants", $variantID, array(
						"taxZoneGroupID" => $_REQUEST["taxZoneGroupID"],
					));
				}
			}

			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "encryption",
			));
			exit;
		} elseif ($_REQUEST["a"]=="encryption"){

			$encryptionseed = stripslashes($_REQUEST["passphrase"]?$_REQUEST["passphrase"]:uniqid().time().uniqid());
			$lek = ereg_replace("[^0-9]+", "", $_REQUEST["lek_pin"]);
			
			$lekhash = getPasswordHash($lek);
			
			$enchash = getPasswordHash($encryptionseed);

			$c =& new Crypt($lekhash, "orangefish", NULL);
			$enckey = $c->encrypt($enchash);

			loadConfigs("system", "encryption");
			$CONF["system"]["encryption"]["encryption_agree"] = $_REQUEST["enableEncryption"];
			$CONF["system"]["encryption"]["encryption_hash"] = $enckey;
			$CONF["system"]["encryption"]["lek_pin"] = getEncryptedText($lek);

			storeConfigs("system", "encryption");

			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "fraudguardian",
			));
			exit;
		} elseif ($_REQUEST["a"]=="fraudguardian"){

			$enableFG = oneOf(":configParams", array(
				"configParamName" => "enableFraudGuardian"
			));
			updateForKey(":configParams", $enableFG['configParamID'], array(
				"configParamValue" => $_REQUEST['enableFraudGuardian'],
			));

			$userFG = oneOf(":configParams", array(
				"configParamName" => "usernameFraudGuardian"
			));
			updateForKey(":configParams", $userFG['configParamID'], array(
				"configParamValue" => $_REQUEST['usernameFraudGuardian'],
			));

			$passFG = oneOf(":configParams", array(
				"configParamName" => "passwordFraudGuardian"
			));
			updateForKey(":configParams", $passFG['configParamID'], array(
				"configParamValue" => $_REQUEST['passwordFraudGuardian'],
			));

			$threshold = oneOf(":fraudCountryThresholds");

			if (!(int)$threshold["thresholdID"]){
				$thresholdID = insertFor(":fraudCountryThresholds", array(
					'thresholdName' => 'default',
					'countryType' => '0',
					'countriesID' => '225',
					'regionsID' => '002',
					'levelOneScore' => '1.0',
					'levelTwoScore' => '3.0',
					'levelThreeScore' => '5.0',
					'levelOneAction' => '0',
					'levelTwoAction' => '2',
					'levelThreeAction' => '3',
					'catchAllAction' => '5',
					'overrideOneAmount' => '0.00',
					'overrideTwoAmount' => '0.00',
					'overrideThreeAmount' => '0.00',
					'overrideOneAction' => '0',
					'overrideTwoAction' => '0',
					'overrideThreeAction' => '0',
					'primaryScoreToUse' => '0',
					'freeEmailWeight' => '2.5',
					'countryMatchWeight' => '2.5',
					'anonProxyWeight' => '5.0',
					'countryRiskWeight' => '5.0',
					'ipDistanceWeight' => '10.0',
					'binMatchWeight' => '2.0',
					'binBankMatchWeight' => '1.0',
					'highRiskEmailWeight' => '5.0',
					'highRiskShippingWeight' => '5.0',
					'openProxyWeight' => '2.5',
					'fraudSoftRejectMessage' => '',
					'fraudHardRejectMessage' => '',
				));

				$fraudSetID = insertFor(":fraudSets", array(
					"fraudSetName" => "Default",
					"fraudSetEmail" => $CONF["user"]["adminData"]["adminEmail"],
				));

				insertFor(":fraudSetThresholdRels", array(
					"thresholdID" => $thresholdID,
					"fraudSetID" => $fraudSetID,
				));

				$orderForm = oneOf(":orderForms");
				$orderFormID = $orderForm["orderFormID"];
				
				insertFor(":fraudSetOrderFormRels", array(
					"fraudSetID" => $fraudSetID,
					"orderFormID" => $orderFormID,
				));

			}

			$CONF["system"]["internal"]["suppressFirstTimeWizard"] = 1;
			storeConfigs("system", "internal");

			redirect("configs.php", "FirstTimeDisplayStep", array(
				"a" => "finished",
			));
			exit;
		}

		redirect("configs.php", "FirstTimeDisplayStep");

		return $this->hasExecutedSuccessfully();
	}
} // FirstTimeDisplayStep
?>
