<?php
// $Id: ShowDashboardNewOrders.php 9128 2006-09-23 16:37:19Z mfountain $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It lists all pending customers.
 *
 * @author  Michael Fountain
 */
class ShowDashboardNewOrders extends MB_Action {
	/**
	 * The constructor for a ShowDashboardNewOrders action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowDashboardNewOrders() {
		parent::MB_Action();
		$this->stringRep = "ShowDashboardNewOrders";

		// set all possible xml params here, $_GET is already cleaned
		$this->params = array
		(
			"clientID",
			"clientCompany",
			"contactFirstName",
			"contactLastName",
			"contactEmail",
			"contactAddress_1",
			"contactAddress_2",
			"contactCity",
			"contactZip",
			"contactUsername"
		);

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["query"]!="") {
			// test if the searching for a specific column
			if ($_REQUEST["queryColumn"]!="") {
				$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
			} else {
				// test if query is an int, if yes, assume we are searching for the ID
				if (((int) $_REQUEST["query"])) {
					$_REQUEST["clientID"] = $_REQUEST["query"];
				} else {
					// if not an int, then search all other non-ID columns
					foreach($this->params as $value) {
						if ($value!="clientID") {
							$_REQUEST[$value] = $_REQUEST["query"];
						}
					}
				}
			}
		}

		$this->sortColumns = array
		(
			"clientID",
			"contactFirstName",
			"contactLastName",
			"clientCompany",
			"contactEmail"
		);

	}

	/**
	 * The main method of this class that executes the ShowDashboardNewOrders action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = array(
			"mbapi" => array(
				"command" => "GetClients",
				"params" => array(
					"clientStatus" => getAPIStatusID("client", "pending"),
					"getInvoiceData" => 3,
					"mergePrimaryContact" => 1,
					"sortDir" => "desc",
					"sortColumn" => "clientDateCreated",
					"recordOffset" => 0,
					"numRecords" => 8,
				),
			),
		);

		$query = toXML($query);

		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

#show(correctArray($results)); exit;

		if($this->addMBAPIErrors($data) === 0) {
			if(isset($results["clients"][0]["client"])) {
				$clients = correctArray($results["clients"][0]["client"]);
			} else {
				$clients = array();
			}
			$this->smartyVars["clients"] = $clients;
			$this->smartyVars["newOrderCount"] = $results["paginationLinks"][0]["paginationStats"][0]["totalRows"][0];
			$this->smartyVars["clientStatuses"] = getStatuses("client");
			$this->smartyVars["invoiceStatuses"] = getStatuses("invoice");
			$this->addTemplate("dashboard/ShowDashboardNewOrders", $this->smartyVars);

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // MB_Action
?>
