<?php
// $Id: ShowDashboardTodos.php 8726 2006-09-08 14:03:25Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-admin/include/lib-action/todos/ShowTodos.php");

/**
 * @author  Michael Fountain
 */
class ShowDashboardTodos extends ShowTodos {

	/**
	 */
	function ShowDashboardTodos() {
		$this->MB_Action();
		$this->stringRep = "ShowDashboardTodos";
		
		$this->params = array(
			"todoID",
			"productID",
			"todoTitle",
			"todoDesc",
			"userID",
			"todoStatusID",
			"todoDateDue",
			"todoDateCreated",
			"todoAssignedAdminID",
			"todoIsPublic");
		$this->sortColumns = array(
			"todoStatusID",
			"todoTitle",
			"userID",
			"todoDateDue",
			"todoAssignedAdminID",
			"todoIsPublic");
	}

	/**
	 * The main method of this class that executes the ShowDashboardTodos action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		MB_Action::execute();

		// past due todo items
		$query = $this->getMBAPIQuery("GetTodos", "",
				array(
					"todoDateDueGreatest" => time(),
					"getAdminData" => 1,
					"numRecords" => 5));
		$data = dispatchMBAPI($query, 1);
		$this->handleGroup( "pastdue", $data );

		$this->smartyVars["rowCount"]["pastdue"] = $this->getMaxCount( "pastdue" );
		
		
		// get todo's that are a day old
		$query = $this->getMBAPIQuery("GetTodos", "",
				array(
					"todoDateDueLeast" => time(),
					"todoDateDueGreatest" => time() + 86400,
					"getAdminData" => 1,
					"numRecords" => 5));
		$data = dispatchMBAPI($query, 1);
		$this->handleGroup( "near", $data );
		
		$this->smartyVars["rowCount"]["near"] = $this->getMaxCount( "near" );
		
		// defs
		$this->smartyVars["todostatus"] = getStatuses("todo");
		$this->smartyVars["todostatusheaders"] = array(
						"pastdue" => TRANS_DUE,
						"near" => TRANS_24HOURS);
		$this->smartyVars['todoAssignHeaders'] = array(
						'mine' => TRANS_MY_TODO_ITEMS,
						'public' => TRANS_PUBLIC);
					

		$data = arrayFor("admins", array("adminActive" => 1));
		
		if (is_array( $data ))
		foreach( $data as $admin ) {
			$this->smartyVars["adminsList"][ $admin["adminID"] ] = $admin["adminLastName"].", ".$admin["adminFirstName"];
		}
		
		if (!$this->_err) {
			$this->smartyVars = correctArray( $this->smartyVars );

			$this->addTemplate("dashboard/ShowDashboardTodos");
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowDashboardTodos
?>
