<?php
// $Id: CheckDomainAvailability.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class CheckDomainAvailability extends MB_Action {
	/**
	 * The constructor for a CheckDomainAvailability action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function CheckDomainAvailability() {
		parent::MB_Action();
		$this->stringRep = "CheckDomainAvailability";
		$this->params = array
		(
			"domainSLD",
			"domainTLD",
			"checkAllTLDs",
			"checkNameSpinner",
			"checkWithDashes",
			"checkKeyword1",
			"checkKeyword2",
			"checkKeyword3",
		);
	}

	/**
	 * The main method of this class that executes the CheckDomainAvailability action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainSLD = strtolower(strval($_REQUEST["domainSLD"]));
		$domainTLD = strtolower(strval($_REQUEST["domainTLD"]));
		$checkAllTLDs = ((int) $_REQUEST["checkAllTLDs"]);
		$checkNameSpinner = ((int) $_REQUEST["checkNameSpinner"]);
		$checkWithDashes = ((int) $_REQUEST["checkWithDashes"]);
		$configGroupID = ((int) $_REQUEST["configGroupID"]);
		$checkKeyword1 = strval($_REQUEST["checkKeyword1"]);
		$checkKeyword2 = strval($_REQUEST["checkKeyword2"]);
		$checkKeyword3 = strval($_REQUEST["checkKeyword3"]);

		$x = "
		<mbapi>
		  <command>ProcessRegistrar</command>
		  <showXMLHeader>0</showXMLHeader>
		  <params>
            <subCommand>checkDomainAvailability</subCommand>
            <configGroupID>".$configGroupID."</configGroupID>
            <domainSLD>".$domainSLD."</domainSLD>
            <domainTLD>".$domainTLD."</domainTLD>
            <checkAllTLDs>".$checkAllTLDs."</checkAllTLDs>
            <checkNameSpinner>".$checkNameSpinner."</checkNameSpinner>
            <checkWithDashes>".$checkWithDashes."</checkWithDashes>
            <checkKeyword1>".$checkKeyword1."</checkKeyword1>
            <checkKeyword2>".$checkKeyword2."</checkKeyword2>
            <checkKeyword3>".$checkKeyword3."</checkKeyword3>
		  </params>
		</mbapi>";

		$data = dispatchMBAPI($x,1);
		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

            $this->smartyVars["configGroupID"] = $configGroupID;
			$this->smartyVars["originalDomain"] = $results["OriginalDomain"][0];
			$this->smartyVars["originalDomainIsAvailable"] = $results["OriginalDomainIsAvailable"][0];
			$this->smartyVars["suggestedDomainCount"] = $results["SuggestedDomainCount"][0];
			$this->smartyVars["suggestedDomainCountLeft"] = ceil($this->smartyVars["suggestedDomainCount"]/2);
			$this->smartyVars["suggestedDomainCountRight"] = floor($this->smartyVars["suggestedDomainCount"]/2);
			$this->smartyVars["suggestedDomains"] = $results["SuggestedDomains"][0];
			$this->addTemplate("widgets/domains/checkDomainAvailability", collapseArrayElements($this->smartyVars));

		} // if($this->addMBAPIErrors($data) === 0) {

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CheckDomainAvailability
?>