<?php
// $Id: EditDomain.php 9896 2006-10-31 22:57:21Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a domain so that that domain may be modified in the 
 * database.
 *
 * @author  Vic Fryzel
 */
class EditDomain extends MB_Action {
	/**
	 * The constructor for a EditDomain action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditDomain() {
		parent::MB_Action();
		$this->stringRep = "EditDomain";
		$this->params = array("domainID");
	}

	/**
	 * The main method of this class that executes the EditDomain action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {
			//Get the Regirstrars
			loadConfigs("domain");
			//saveStateOfCONF();
			$registrarData = $CONF["domain"]["registrar"];

			$registrars = array();
			foreach($registrarData as $registrar => $attrs) {
				$registrars[0] = " ";
				if(isset($attrs['configGroupID'])) {
					$registrars[$attrs['configGroupID']] = $registrar;
				}
			}

			$query = $this->getMBAPIQuery("GetDomains", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["tldRenew"] = getTypes('tldRenew');
				$s["registrars"] = $registrars;
				$s["domain"] = collapseArrayElements($data["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
				$this->addTemplate("domains/EditDomain", $s);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditDomain
?>