<?php
// $Id: RegisterDomainConfirmResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object inserts new domain registerations into the system events queue.
 *
 * @author  Michael Fountain
 */
class RegisterDomainConfirmResponse extends MB_Action {
	/**
	 * The constructor for a RegisterDomainConfirmResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function RegisterDomainConfirmResponse() {
		parent::MB_Action();
		$this->stringRep = "RegisterDomainConfirmResponse";
		$this->params = array
		(
			"buyDomains",
			"domainRenewType",
			"domainLock",
			"domainNumYears"
		);
	}

	/**
	 * The main method of this class that executes the RegisterDomainConfirmResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$c = count($_REQUEST["buyDomains"]);

        if (!(int) $_REQUEST["configGroupID"]) {
			$this->addError(TRANS_ACTIONERROR, "Missing required configGroupID.");
        } else if(!$c) {
			$this->addError(TRANS_ACTIONERROR, "No domains selected to purchase.");
		} else {

			$successSystemQueueIDs = array();
			$failedSystemQueueIDs = array();
            $configGroupID = (int) $_REQUEST["configGroupID"];

		 	// loop each domain to purchase one at a time
            for($i=0;$i<$c;$i++){
				list($domainSLD,$domainTLD,$domainTLD2) = explode(".",$_REQUEST["buyDomains"][$i]);
				if ($domainTLD2) {
					$domainTLD = $domainTLD.".".$domainTLD2;
				}
				$domainRenewType = ($_REQUEST["domainRenewType"][$i]) ? 1 : 0 ;
				$domainLock = ($_REQUEST["domainLock"][$i]) ? 1 : 0 ;
				$domainNumYears = (((int)$_REQUEST["domainNumYears"][$i])>0 && ((int)$_REQUEST["domainNumYears"][$i])>10) ?
					((int) $_REQUEST["domainNumYears"][$i]) : 1 ;

                $ProcessRegistrarXML = "
                <mbapi>
                  <command>ProcessRegistrar</command>
                  <showXMLHeader>0</showXMLHeader>
                  <params>
                    <subCommand>registerDomain</subCommand>
                    <configGroupID>".$configGroupID."</configGroupID>
                    <domainSLD>".$domainSLD."</domainSLD>
                    <domainTLD>".$domainTLD."</domainTLD>
                    <domainNumYears>".$domainNumYears."</domainNumYears>
                    <domainRenewType>".$domainRenewType."</domainRenewType>
                    <domainIDN></domainIDN>
                    <domainLock>".$domainLock."</domainLock>
                    <domainPassword></domainPassword>
                    <domainDNS>default</domainDNS>
                    <domainNameserver1></domainNameserver1>
                    <domainNameserver2></domainNameserver2>
                    <domainNameserver3></domainNameserver3>
                    <domainNameserver4></domainNameserver4>
                    <domainContactData>
	                    <registrant>
		                    <registrantFirstName>Michael1</registrantFirstName>
		                    <registrantLastName>Fountain1</registrantLastName>
		                    <registrantJobTitle>Co Owner1</registrantJobTitle>
		                    <registrantOrganizationName>Company A1</registrantOrganizationName>
		                    <registrantAddress1>123 Main St1</registrantAddress1>
		                    <registrantAddress2>Suite 2021</registrantAddress2>
		                    <registrantCity>Louisville1</registrantCity>
		                    <registrantStateProvinceChoice></registrantStateProvinceChoice>
		                    <registrantStateProvince>KY</registrantStateProvince>
		                    <registrantPostalCode>40202</registrantPostalCode>
		                    <registrantCountry>US</registrantCountry>
		                    <registrantPhone>123456789</registrantPhone>
		                    <registrantPhoneExt>112</registrantPhoneExt>
		                    <registrantFax>123456788</registrantFax>
		                    <registrantEmailAddress>michaelfountain@gmail.com</registrantEmailAddress>
	                    </registrant>
	                    <tech>
		                    <techFirstName>Michael</techFirstName>
		                    <techLastName>Fountain</techLastName>
		                    <techJobTitle>Co Owner</techJobTitle>
		                    <techOrganizationName>Company A</techOrganizationName>
		                    <techAddress1>123 Main St</techAddress1>
		                    <techAddress2>Suite 202</techAddress2>
		                    <techCity>Louisville</techCity>
		                    <techStateProvinceChoice></techStateProvinceChoice>
		                    <techStateProvince>KY</techStateProvince>
		                    <techPostalCode>40202</techPostalCode>
		                    <techCountry>US</techCountry>
		                    <techPhone>123456789</techPhone>
		                    <techPhoneExt>112</techPhoneExt>
		                    <techFax>123456788</techFax>
		                    <techEmailAddress>michaelfountain@gmail.com</techEmailAddress>
	                    </tech>
	                    <admin>
		                    <adminFirstName>John</adminFirstName>
		                    <adminLastName>Smith</adminLastName>
		                    <adminJobTitle>Co Owner</adminJobTitle>
		                    <adminOrganizationName>Company A</adminOrganizationName>
		                    <adminAddress1>123 Main St</adminAddress1>
		                    <adminAddress2>Suite 202</adminAddress2>
		                    <adminCity>Louisville</adminCity>
		                    <adminStateProvinceChoice></adminStateProvinceChoice>
		                    <adminStateProvince>KY</adminStateProvince>
		                    <adminPostalCode>40202</adminPostalCode>
		                    <adminCountry>US</adminCountry>
		                    <adminPhone>123456789</adminPhone>
		                    <adminPhoneExt>112</adminPhoneExt>
		                    <adminFax>123456788</adminFax>
		                    <adminEmailAddress>michaelfountain@gmail.com</adminEmailAddress>
	                    </admin>
                    </domainContactData>
                  </params>
                </mbapi>";

				// Get the time quantities for $current
				// minute;hour;day;month;year
				$timeData = explode(";", date("i;G;j;n;Y"));
				$dateToRun = mktime($timeData[1], $timeData[0], 0, $timeData[3], $timeData[2], $timeData[4]);

				$cmdArgs = array
				(
					"systemQueueCommand" => "ProcessRegistrar",
		            "systemQueueCommandInput" => htmlentities($ProcessRegistrarXML),
		            "systemQueueMinute" => $timeData[0],
					"systemQueueHour" => $timeData[1],
					"systemQueueDay" => $timeData[2],
					"systemQueueMonth" => $timeData[3],
					"systemQueueYear" => $timeData[4],
					"systemQueueIsRecurring" => 0,
		        	"systemQueueDateCreated" => mktime(),
		        	"systemQueueDateToRun" => $dateToRun,
		        	"systemQueueDateStarted" => 0,
		        	"systemQueueDateFinished" => 0,
				);
				$query = $this->getMBAPIQuery("SetSystemQueue", "insert", $cmdArgs);
				$data = dispatchMBAPI($query, 1);

				if($this->addMBAPIErrors($data) === 0 && $data["mbapi"][0]["header"][0]["lastInsertID"][0]) {
				 	$successSystemQueueIDs[] = array
				 	(
						"domainName" => $_REQUEST["buyDomains"][$i],
						"systemQueueID" => $data["mbapi"][0]["header"][0]["lastInsertID"][0]
				 	);
				} else {
				 	$failedSystemQueueIDs[] = $_REQUEST["buyDomains"][$i];
				} // if($this->addMBAPIErrors($data) === 0) {

			} // next domain to register

			$smartyVars = array();
			$smartyVars["successDomains"] = $successSystemQueueIDs;
			$smartyVars["failedDomains"] = $failedSystemQueueIDs;
			$this->addTemplate("domains/RegisterDomainConfirmResponseResults", $smartyVars);

		} // if(!$c) {

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RegisterDomainConfirmResponse
?>