<?php
// $Id: RenewDomainResponse.php 11227 2007-05-31 23:28:25Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RenewDomain action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class RenewDomainResponse extends MB_Action {
	/**
	 * The constructor for an RenewDomainResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RenewDomainResponse() {
		parent::MB_Action();
		$this->stringRep = "RenewDomainResponse";
		$this->params = array
		(
			"domainID",
			"domainYears",
		);
	}

	/**
	 * The main method of this class that executes the RenewDomainResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains");
			$mbapiData = dispatchMBAPI($query, 1);

			$domainYears = (int) $_REQUEST["domainYears"];

			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else if (!$domainYears || $domainYears > 10) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain years.");
			} else {

			 	// fetching domain data from the registrar
			 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
				$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
				$domainID = (int)$mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

				$xml = "
				<mbapi>
				  <command>ProcessRegistrar</command>
				  <showXMLHeader>0</showXMLHeader>
				  <params>
				    <subCommand>renewDomain</subCommand>
		            <configID>0</configID>
		            <domainID>".$domainID."</domainID>
					<domainSLD>".$domainSLD."</domainSLD>
					<domainTLD>".$domainTLD."</domainTLD>
					<domainYears>".$domainYears."</domainYears>
				  </params>
				</mbapi>";
				$data = dispatchMBAPI($xml,1);

				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					redirect("domains.php",getActionID("ShowDomainDetails"), array("domainID"=>$domainID));
				}

			} // if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1)

		} // if(!$domainID)

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainResponse
?>