<?php
// $Id: SyncDomainDates.php 11165 2007-05-22 18:47:28Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class SyncDomainDates extends MB_Action {
	/**
	 * The constructor for a SyncDomainDates action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function SyncDomainDates() {
		parent::MB_Action();
		$this->stringRep = "SyncDomainDates";
		$this->params = array("domainID");
	}

	/**
	 * The main method of this class that executes the SyncDomainDates action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {
			// get domain info
			$domain = oneOf('domains', array('domainID' => $domainID));
			
			if (isset($domain['domainID'])) {
				// run the command
				$cmd =& new MBQuery('ProcessRegistrar', 'getDomainExpDate', array(
					'configID' => 0,
					'domainID' => $domain["domainID"],
					'domainSLD' => $domain["domainSLD"],
					"domainTLD" => $domain["domainTLD"]
					));
					
				$cmd = $cmd->getResult();
				
				if (!$cmd->getErrorCount()) {
					$result = grabSimpleMBAPIResults( $cmd->getStructure() );

					$this->smartyVars['domain'] =& $domain;
					$this->smartyVars['domainExpTimestamp'] = $result['DomainExpTimestamp'];
					
					unset($result);
					$this->addTemplate('domains/SyncDomainDates');
				} else {
					$subject = $cmd->getSubject();
					$subject = $subject->getEssential();
					
					if (isset($subject['mbapi']) && isset($subject['mbapi'][0]['header'][0]['errors'][0])) {
						foreach( (array)$subject['mbapi'][0]['header'][0]['errors'] as $err ) {
							$this->addError( $err['title'], $err['message'] );
						}
					}
					
					unset($subject);
				}
			} // if (isset($domain['domainID']))
		} // if(!$domainID) {

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // SyncDomainDates
?>