<?php
// $Id: AddEmailTemplate.php 11386 2007-06-18 21:24:01Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on an email template so that that email template may be added to the
 * database.
 *
 * @author  Mark Garrett
 */
class AddEmailTemplate extends MB_Action {
	/**
	 * The constructor for a AddEmailTemplate action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddEmailTemplate() {
		parent::MB_Action();
		$this->stringRep = "AddEmailTemplate";
		$this->params = array(
			"emailTplGroupID");
	}

	/**
	 * The main method of this class that executes the AddEmailTemplate action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars["emailTplGroupID"] = (int) $_REQUEST["emailTplGroupID"];
		$this->smartyVars["countryTypes"] = getTypes("countryTypes");
		$this->smartyVars["regionNames"] = getRegions("names");
		$this->smartyVars["nestedRegions"] = getRegions("nested");
		$this->mergeCountryData($CONF["user"]["locale"]->country);
		$this->mergeLanguageData($CONF["user"]["locale"]->language);

		$this->addTemplate("emails/AddEmailTemplate", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddEmailTemplate
?>