<?php
// $Id: AddEmailTemplateGroup.php 6340 2006-04-17 23:35:31Z mgarrett $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * This action collects information for a new email action group so that a new email action group may be added
 * to the database.
 *
 * @author  Vic Fryzel
 */
class AddEmailTemplateGroup extends MB_Action {
	/**
	 * The constructor for a AddEmailTemplateGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddEmailTemplateGroup() {
		parent::MB_Action();
		$this->stringRep = "AddEmailTemplateGroup";
		$this->params = array(
			"emailActionID");
	}

	/**
	 * The main method of this class that executes the AddEmailTemplateGroup action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars["emailActions"] = $CONF["types"]["emailAction"];
		$this->smartyVars["emailActionID"] = (int) $_REQUEST["emailActionID"];
		$this->addTemplate("emails/AddEmailTemplateGroup", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddEmailTemplateGroup
?>