<?php
// $Id: AddEmailTemplateGroupResponse.php 6333 2006-04-17 22:54:50Z mgarrett $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action takes information provided by the AddEmailTemplateGroup action and uses it to add a new email
 * action group to the database.
 *
 * @author  Vic Fryzel
 */
class AddEmailTemplateGroupResponse extends MB_Action {
	/**
	 * The constructor for an AddEmailTemplateGroupResponse action object. This calls the parent constructor,
	 * sets the string representation, and sets up $this->params.
	 */
	function AddEmailTemplateGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "AddEmailTemplateGroupResponse";
		$this->params = array(
			"emailTplGroupID",
			"emailTplGroupName",
			"emailActionID",
			"emailTplGroupPriority",
			"emailTplGroupName",
			"emailTplGroupFromName",
			"emailTplGroupFromAddress",
			"emailTplGroupReplyName",
			"emailTplGroupReplyAddress",
			"emailTplGroupCCAddress",
			"emailTplGroupBCCAddress"
			);
	}

	/**
	 * The main method of this class that executes the AddEmailTemplateGroupResponse action, and returns success
	 * or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("SetEmailTemplateGroups", "insert");
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			redirect("emails.php", getActionID("EditEmailTemplateGroup"),
				array("emailTplGroupID" => $data["mbapi"][0]["header"][0]["lastInsertID"][0]));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddEmailTemplateGroupResponse
?>