<?php
// $Id: EditEmailTemplate.php 12222 2007-11-14 17:50:34Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class EditEmailTemplate extends EditAction {
	function EditEmailTemplate() {
		$this->setDataSource(new DataSource("emailTemplates"));
		EditAction::EditAction();
	}

	function editHandler() {
		global $CONF;

		// These are decoded because we are using a generic get command which encodes it properly, and the data was prepared for the other commands. Normally this would not be needed.
		$this->smartyVars["emailTemplate"]["emailTplBody"] = utf8_xml_entity_decode(utf8_xml_entity_decode($this->smartyVars["emailTemplate"]["emailTplBody"]));
		$this->smartyVars["emailTemplate"]["emailTplTextBody"] = utf8_xml_entity_decode(utf8_xml_entity_decode($this->smartyVars["emailTemplate"]["emailTplTextBody"]));

		$this->smartyVars["countryTypes"] = getTypes("countryTypes");
		$this->smartyVars["regionNames"] = getRegions("names");
		$this->smartyVars["nestedRegions"] = getRegions("nested");

		$this->smartyVars["emailTemplateGroup"] = oneOf("emailTplGroups", array(
			"emailTplGroupID" => $this->smartyVars["emailTemplate"]["emailTplGroupID"]
		));

		$actionName = getAPITypeName( "emailAction", $this->smartyVars["emailTemplateGroup"]["emailActionID"] );
		$fileName = mb_path("/lib-mbapi/include/mail/emailTemplates/$actionName.php");
		$this->smartyVars["canPreview"] = ($fileName) ? 1 : 0;

		$language = oneByID( 'languages', $this->smartyVars["emailTemplate"]["languageID"] );
		$country = oneByID( 'countries', $this->smartyVars["emailTemplate"]["countriesID"] );
		
		list($this->smartyVars['availableTemplates'] ) = $this->findAvailableEmailTemplates( $language['languageISO2'].'_'.$country['countriesISO2'] );
		if (!$this->smartyVars['availableTemplates']){
			list($this->smartyVars['availableTemplates'] ) = $this->findAvailableEmailTemplates($language['languageISO2'].'_US');
		}
		if (!$this->smartyVars['availableTemplates']){
			list($this->smartyVars['availableTemplates'] ) = $this->findAvailableEmailTemplates();
		}
		foreach ($this->smartyVars['availableTemplates'] as $k=>$v) $this->smartyVars['availableTemplates'][$k] = variableToHuman($v);
		
		return true;
	}

	function findAvailableEmailTemplates( $locale = "en_US" ) {
		$path = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/" );

		if (!is_readable( $path ) || !is_dir( $path )) {
			$this->addError( TRANS_ACTIONERROR, "Email Template directory is not readable" );
			return false;
		}

		// create the directory handler
		$dh = opendir( $path );

		$availableTemplates = $htmlTemplates = $txtTemplates = array();

		// move through the files
		while( ($file = readdir( $dh )) !== false ) {
			$matches = array();
			
			if (preg_match( "/(^[\w,\-,_,\040]+)\.$locale\.((?:html|t[e]{0,1}xt))\.tpl$/iU", $file, $matches )) {
				$availableTemplates[ $matches[1] ] = $matches[1];

				switch( strtolower( $matches[2] ) ) {
				case 'html':
					$htmlTemplates[] = $matches[1];
					break;
				case 'txt':
				case 'text':
					$txtTemplates[] = $matches[1];
					break;
				}
			}

		}	unset( $file, $matches );

		closedir( $dh );
		unset( $dh );

		asort( $availableTemplates );
		return array( &$availableTemplates, &$htmlTemplates, &$txtTemplates );
	}
} // EditEmailTemplate
