<?php
// $Id: EditEmailTemplateResponse.php 11465 2007-06-28 17:49:17Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class EditEmailTemplateResponse extends EditResponseAction {
	function EditEmailTemplateResponse() {
		$this->setDataSource(new DataSource("emailTemplates"));
		EditResponseAction::EditResponseAction();
	}

	function editResponseParamHandler() {
		$tplBody = healUTF8(utf8_html_entity_decode(unsecureInput($this->d->params["emailTplBody"])));
		$tplTextBody = healUTF8(unsecureInput($this->d->params["emailTplTextBody"]));

		$pass = true;

		if($tplBody ===  false) {
			$pass = false;
			$this->addError(MBAPI_ACTIONERROR, "Bad character encoding detected in the HTML body.");
		}

		if($tplTextBody ===  false) {
			$pass = false;
			$this->addError(MBAPI_ACTIONERROR, "Bad character encoding detected in the text body.");
		}

		if($pass) {
			// These are double-quoted because they need to be pre-quoted for coming out of the database for now.
			$this->d->params["emailTplBody"] = utf8_xml_entity_encode($tplBody);
			$this->d->params["emailTplTextBody"] = utf8_xml_entity_encode($tplTextBody);
			return true;
		} else {
			return false;
		}
	}

	function redirect() {
		redirect("emails.php", getActionID("EditEmailTemplateGroup"), array("emailTplGroupID" => (int) $_REQUEST["emailTplGroupID"]));
	}
}
header('Content-Type: text/html; charset=UTF-8');

function convertEncoding( $str, $to, $from ) {
	if (function_exists('iconv')) {
		return iconv( $to, $from.'//TRANSLIT', $str );
	} elseif (function_exists('mb_convert_encoding')) {
		return mb_convert_encoding( $str, $to, $from );
	} else {
		// TEMPORARY!
		// do nothing
		// echo 'Neither Iconv nor mb_convert_encoding are present, this is a development function. Please contact Modern Bill Support and register a ticket. Thank you';
		// exit;
		return $str;
	}
}

function detectUTF8($str) {
	$len = strlen($str);
	$current_byte = 0x00;
	$count_good_utf = 0;
	$count_bad_utf = 0;

	for($i; $i < $len; $i++) {
		$previous_byte = $current_byte;
		$current_byte = ord(substr($str, $i, 1));
		//show("x: ${current_byte}; y: ${previous_byte}");

		if(($current_byte & 0xC0) == 0x80) {
			if(($previous_byte & 0xC0) == 0xC0) {
				$count_good_utf++;
			} else if (($previous_byte & 0x80) == 0x00) {
				$count_bad_utf++;
			}
		} else if(($previous_byte & 0xC0) == 0xC0) {
			$count_bad_utf++;
		}
	}
	//show("good: ${count_good_utf}; bad: ${count_bad_utf}");
	return $count_good_utf >= $count_bad_utf;
}

function healUTF8($str) {
	if(detectUTF8($str)) {
		// was utf-8
		//show("was utf-8");
		return $str;
	} else {
		// guess latin-1
		//show("guess latin-1");
		$try_str = convertEncoding($str, "ISO-8859-1", "UTF-8");
		if(detectUTF8($try_str)) {
			// was apparently latin-1
			//show("was apparently latin-1");
			return $try_str;
		} else {
			// was apparently something else
			//show("was apparently something else");
			return false;
		}
	}
}
