<?php
// $Id: GetEmailTemplateVariables.php 11737 2007-08-03 21:33:01Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-mbapi/include/mail/mail.php");

/**
 * This action returns the XML of email template(s) requested
 *
 * @author  Brian Smith
 */
class GetEmailTemplateVariables extends MB_Action {
	
	function GetEmailTemplateVariables() {
		parent::MB_Action();
		$this->stringRep = "GetEmailTemplateVariables";

		$this->params = array("emailTplID", "emailTplGroupID");
	}

	/**
	 * The main method of this class that executes the GetEmailTemplateVariables action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$output = array();
		
		if (!notZero( $_REQUEST['emailTplID'] ) && !notZero( $_REQUEST['emailTplGroupID'] )) {
			$this->addError( TRANS_ACTIONERROR, "Please specify an email template or group ID." );
		} elseif (notZero( $_REQUEST['emailTplID'] ) && !notZero( $_REQUEST['emailTplGroupID'] )) {
			$emlTpl =& new MBQuery("GetEmailTemplates", "", array("emailTplID" => (int)$_REQUEST["emailTplID"]));
			$emlTpl = $emlTpl->getResult();

			if (!$emlTpl->getErrorCount()) {
				$emlTpl = grabSimpleMBAPIResults( $emlTpl->getStructure() );

				if (notZero( $emlTpl[0]['emailTplGroupID'] )) {
					$_REQUEST['emailTplGroupID'] = (int)$emlTpl[0]['emailTplGroupID'];
				}
			} else {
				$this->addError( TRANS_ACTIONERROR, "Failed to be able to fetch requested email template." );
			}
			unset( $emlTpl );
		}

		if (notZero( $_REQUEST['emailTplGroupID'] ) && !$this->getNumErrors()) {
			$tplObj =& new MBTemplateBasedEmail( (int)$_REQUEST['emailTplGroupID'] );
			global $emailTemplateIDCache;
			show($emailTemplateIDCache);
			show($tplObj);exit;
		}
		
		foreach( (array)$this->getErrors() as $err ) {
			$output['errors']['error'][] = array(
				'title' => $err[0],
				'message' => $err[1]);
		}
		
		$output = array("api"=>$output);



		mbHeader("Content-Type: application/json; charset: UTF-8");
		echo $this->createJavascriptAssociativeArray($this->stripSensitiveData( $output ));

		dbg( $this->createJavascriptAssociativeArray($this->stripSensitiveData( $output )) );
		
		return $this->hasExecutedSuccessfully();
	}
} // GetEmailTemplateVariables
?>