<?php
// $Id: PreviewEmailTemplate.php 11737 2007-08-03 21:33:01Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * This action resend an email from the queue.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Brian Smith
 */
class PreviewEmailTemplate extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function PreviewEmailTemplate() {
		parent::MB_Action();
		$this->stringRep = "PreviewEmailTemplate";
		$this->params = array("emailTplID", "emailActionID", "preview");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$emailTplID = (int)$_REQUEST["emailTplID"];
		$emailActionID = (int)$_REQUEST["emailActionID"];

		if (!notZero( $emailTplID ) || !notZero( $emailActionID )) {
			$this->addError( TRANS_ACTIONERROR, "No Email ID or No Email Action ID Given" );
		} elseif (in_array((string)$_REQUEST['preview'], array('html', 'text'))) {
		
			// we need the locale specific info
			$emltpl =& new MBQuery("GetEmailTemplates", '', array("emailTplID" => $emailTplID));
			$emltpl = $emltpl->getResult();
			
			$emltpl = grabSimpleMBAPIResults( $emltpl->getStructure() );
			
			if (is_array($emltpl))
				$emltpl = $emltpl[0];
				
			// get the email action name so we can grab the file
			$actionName = getAPITypeName( "emailAction", $emailActionID );

			$fileName = mb_path("/lib-mbapi/include/mail/emailTemplates/$actionName.php");

			if (!is_readable( $fileName )) {
				$this->addError( TRANS_ACTIONERROR, "The requested email action [$actionName] does not exist." );
			} else {
				require_once $fileName;

				if (!class_exists( $actionName )) {
					$this->addError( TRANS_ACTIONERROR, "$actionName does not exists." );
				} else {
					
					$classObj = new $actionName();
					$classObj->enablePreviewMode();
/** /
$classObj->addContactByID(1205);
$classObj->setID(1969);
/**/
					if (is_array( $emltpl )) {
						if (isset($emltpl['languageID'])) {
							$classObj->languageID = (int)$emltpl['languageID'];
						}
						
						if (isset($emltpl['countriesID'])) {
							$classObj->countriesID = (int)$emltpl['countriesID'];
						}	
					}
					
					if ($_REQUEST["emailTplBody"]) $classObj->setHTMLTemplateCode($_REQUEST["emailTplBody"]);
					if ($_REQUEST["emailTplTextBody"]) $classObj->setTEXTTemplateCode($_REQUEST["emailTplTextBody"]);
					$template = $classObj->execute( true );
// print_r($classObj);exit;
					if ($classObj->getErrorCount()) {
						show($classObj->getErrors());exit;
					}
					if (isset( $template[ (string)$_REQUEST['preview'] ] )) {
						mbHeader('Content-Type: text/html; charset=UTF-8');
						$template['text'] = nl2br(utf8_html_entity_encode($template['text']));
						echo $template[ (string)$_REQUEST['preview'] ];
						exit;
					}
					$this->addError(TRANS_ACTIONERROR, "Invalid preview type requested.");
				}
			}
			
		} else {
			$this->smartyVars['emailTplID'] = $_REQUEST['emailTplID'];
			$this->smartyVars['emailActionID'] = $_REQUEST['emailActionID'];
			$this->addTemplate("emails/PreviewEmailTemplate");
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
