<?php
// $Id: ReloadEmailTemplateResponse.php 12133 2007-10-24 14:37:29Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action records changes made to an email template. The data is provided by the EditEmailTemplate action.
 *
 * @author Mark Garrett
 */
class ReloadEmailTemplateResponse extends MB_Action {
	/**
	 * The constructor for an ReloadEmailTemplateResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function ReloadEmailTemplateResponse() {
		parent::MB_Action();
		$this->stringRep = "ReloadEmailTemplateResponse";
		$this->params = array(
			"emailTplID",
			"templateName",
			"reloadHTML",
			"reloadTXT");
	}

	/**
	 * The main method of this class that executes the ReloadEmailTemplateResponse action, and returns success
	 * or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		// Make sure the given text bodies are valid for XML
		$emailTplID = (int)$_REQUEST["emailTplID"];
		$templateName = unsecureInput( $_REQUEST["templateName"] );

		if(!notZero($emailTplID)) {
			$this->addError(TRANS_ACTIONERROR, "No email template ID given.");
		} else {

			// get the locale info
			$template = new MBQuery("GetEmailTemplates", "", array("emailTplID" => $emailTplID));

			$template = $template->getResult();
			$template = grabSimpleMBAPIResults( $template->getStructure() );

			$language = oneByID( 'languages', $template[0]["languageID"] );
			$country = oneByID( 'countries', $template[0]["countriesID"] );


			$locale = $language["languageISO2"].'_'.$country["countriesISO2"];

			unset( $language, $country, $template );




			$params = array("emailTplID" => $emailTplID);

			if ($_REQUEST["reloadHTML"]) {
				$fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.$locale.html.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.".$language["languageISO2"]."_US.html.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.en_US.html.tpl" );
				
				if (is_readable( $fileName ) && is_file( $fileName ))
					$params["emailTplBody"] = utf8_xml_entity_encode(file_get_contents($fileName));
			}

			if ($_REQUEST["reloadTXT"]) {
				$fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.$locale.txt.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.$locale.text.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.".$language["languageISO2"]."_US.txt.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.".$language["languageISO2"]."_US.text.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.en_US.txt.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-modernbill/templates/emails/$templateName.en_US.text.tpl" );

				if (is_readable( $fileName ) && is_file( $fileName ))
					$params["emailTplTextBody"] = utf8_xml_entity_encode(file_get_contents($fileName));
			}
			unset( $fileName );

			updateFor(":emailTemplates", $params);
			redirect("emails.php","EditEmailTemplate",array("emailTplID" => $emailTplID));

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ReloadEmailTemplateResponse
