<?php
// $Id: RemoveEmailTemplateGroup.php 5845 2006-03-28 14:48:27Z mgarrett $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action confirms that a user is sure they want to remove an email template group.
 *
 * @author  Vic Fryzel
 */
class RemoveEmailTemplateGroup extends MB_Action {
	/**
	 * The constructor for a RemoveEmailTemplateGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveEmailTemplateGroup() {
		parent::MB_Action();
		$this->stringRep = "RemoveEmailTemplateGroup";
		$this->params = array("emailTplGroupID");
	}

	/**
	 * The main method of this class that executes the RemoveEmailTemplateGroup action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$emailTplGroupID = ((int) $_REQUEST["emailTplGroupID"]);
		if(!$emailTplGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No email template group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array());
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$this->smartyVars["emailTplGroup"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]["emailTplGroups"]
							[0]["emailTplGroup"][0]);
					$this->addTemplate("emails/RemoveEmailTemplateGroup", $this->smartyVars);
				} else {
					$this->addError(TRANS_ACTIONERROR, "Email template group not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveEmailTemplateGroup
?>