<?php
// $Id: RemoveEmailTemplateResponse.php 5845 2006-03-28 14:48:27Z mgarrett $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action takes information provided by the RemoveEmailTemplate action, and removes the
 * specified email template.
 *
 * @author  Vic Fryzel
 */
class RemoveEmailTemplateResponse extends MB_Action {
	/**
	 * The constructor for an RemoveEmailTemplateResponse action object. This merely calls the parent
	 * constructor, and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveEmailTemplateResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveEmailTemplateResponse";
		$this->params = array("emailTplID");
	}

	/**
	 * The main method of this class that executes the RemoveEmailTemplateResponse action, and returns
	 * success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$emailTplID = ((int) $_REQUEST["emailTplID"]);
		if(!$emailTplID) {
			$this->addError(TRANS_ACTIONERROR, "No email template ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetEmailTemplates", "delete");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("emails.php", getActionID("ShowEmailTemplateGroups"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveEmailTemplateResponse
?>