<?php
// $Id: ShowEmailTemplateGroupDetails.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action collects detailed information on a single email action group and displays that information to the
 * user.
 *
 * @author  Vic Fryzel
 */
class ShowEmailTemplateGroupDetails extends MB_Action {
	/**
	 * The constructor for a ShowEmailTemplateGroupDetails object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowEmailTemplateGroupDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailTemplateGroupDetails";
		$this->params = array("emailTplGroupID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  int  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$emailTplGroupID = ((int) $_REQUEST["$emailTplGroupID"]);
		if(!$emailTplGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No email action group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array());
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$smartyVars = array();
					$smartyVars["emailTplGroup"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]
						["emailTplGroups"][0]["emailTplGroup"][0]);
					$this->addTemplate("emails/ShowEmailTemplateGroupDetails", $smartyVars);

				} else {
					$this->addError(TRANS_ACTIONERROR, "Email action group does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEmailTemplateGroupDetails
?>