<?php
// $Id: ShowEmailTemplates.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays a list of email templates, and links to manage those templates.
 *
 * @author  Vic Fryzel
 */
class ShowEmailTemplates extends MB_Action {
	/**
	 * The constructor for a ShowEmailTemplates action object. This calls the parent constructor, sets up
	 * the string representation, and sets up $this->params and $this->sortColumns.
	 */
	function ShowEmailTemplates() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailTemplates";

		$this->params = array(
			"emailTplName",
			"emailTplSubject",
			"emailTplBody",
			"emailTplTextBody");
		$this->sortColumns = array("emailTplID", "emailTplName", "emailTplSubject");
	}

	/**
	 * The main method of this class that executes the ShowEmailTemplates action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetEmailTemplates", "", array(), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["emailTemplates"] = $results["emailTemplates"][0]["emailTemplate"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$smartyVars["emailtemplates"] = array(0 => $results["emailTemplates"][0]["emailTemplate"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			$this->addTemplate("emails/ShowEmailTemplates", collapseArrayElements($smartyVars));
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEmailTemplates
?>