<?php
// $Id: EditEmailResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action applies the data given via REQUEST to the email associated with the given email ID.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class EditEmailResponse extends MB_Action {
	/**
	 * Call the parent constructor, set our string representation, and setup our allowed parameters.
	 */
	function EditEmailResponse() {
		parent::MB_Action();
		$this->stringRep = "EditEmailResponse";
		$this->params = array("emailID", "emailSubject", "emailFromAddress", "emailFromName", "emailTextBody", "emailSent",
			"emailFailed", "emailToAddresses", "emailCCAddresses", "emailBCCAddresses", "emailReplyToAddresses",
			"emailHeaders", "emailActive");
	}

	/**
	 * Execute this action and return 1 for a successful execution or 0 if otherwise.
	 *
	 * @return  int  1 if this action has executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		if(!((int) $_REQUEST["emailID"])) {
			$this->addError(TRANS_ACTIONERROR, "No email ID was given for removal.");
		} else {
			$query = $this->getMBAPIQuery("SetEmailQueue", "update");
			$data = dispatchMBAPI($query, 1);
			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("events.php", getActionID("ShowEmailQueue"));
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmailResponse
?>