<?php
// $Id: RemoveEmail.php 8729 2006-09-08 15:29:03Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action removes an email from the queue. The email is not literally removed, but rather set to a state of inactive. 
 * The queue is always malleated in place, but never removed from, as it doubles as an ultimate state log.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class RemoveEmail extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function RemoveEmail() {
		parent::MB_Action();
		$this->stringRep = "RemoveEmail";
		$this->params = array("emailID", "emailIDs");
	}

	/**
	 * Execute this action and return 1 for success, or 0 for failure.
	 *
	 * @return  int  1 if execution succeeded or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		
		if(!notZero( $_REQUEST["emailID"] ) && !is_array( $_REQUEST["emailIDs"] )) {
			$this->addError(TRANS_ACTIONERROR, "No email ID given.");
		} elseif (is_array( $_REQUEST["emailIDs"] )) {
			$this->smartyVars['email'] =array();
			foreach( (array)$_REQUEST["emailIDs"] as $emailID ) {
				if (!notZero( $emailID )) {
					continue;
				}
				
				$query = new MBQuery("GetEmailQueue", "", array('emailID' =>(int)$emailID));
				$result = $query->getResult();

				if (!$result->getErrorCount()) {
					$result = grabSimpleMBAPIResults( $result->getStructure() );
					$this->smartyVars['email'][] = $result[0];
   				}
   			}

   			if (!$this->getNumErrors()) {
				$this->addTemplate("events/RemoveEmail");
   			}
		} else {
			$query = $this->getMBAPIQuery("GetEmailQueue");
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				$smartyVars["email"] =& $results["emails"][0]["email"];
				$this->addTemplate("events/RemoveEmail", collapseArrayElements($smartyVars));
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveEmail
?>