<?php
// $Id: RemoveEmailResponse.php 8729 2006-09-08 15:29:03Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action sets the state of the given email (referenced by the request parameter emailID) to inactive, such that the 
 * email can be considered removed from the queue.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class RemoveEmailResponse extends MB_Action {
	/**
	 * Call the parent constructor, set our string representation, and setup our allowed parameters.
	 */
	function RemoveEmailResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveEmail";
		$this->params = array("emailID", "emailIDs");
	}

	/**
	 * Execute this action and return 1 for a successful execution or 0 if otherwise.
	 *
	 * @return  int  1 if this action has executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		if(!notZero($_REQUEST["emailID"]) && !is_array($_REQUEST["emailIDs"])) {
			$this->addError(TRANS_ACTIONERROR, "No email ID was given for removal.");
		} elseif (is_array( $_REQUEST["emailIDs"] )) {
			// we have a very specific format this needs to match array( [(int)] => (int) );
			foreach( (array)$_REQUEST["emailIDs"] as $k => $emailID ) {
				if (!is_numeric( $k ) || !is_numeric( $emailID )) {
					continue;
				}
				
				// now lets perform the update, instead of deleting we update and deactivate the email record
				$query =& new MBQuery("SetEmailQueue", "update", array(
					"emailActive" => 0,
					"emailID" => (int)$emailID) );
				$result = $query->getResult();
				
				if (!$result->getErrorCount()) {
					// if there were errors I think we would like to know about them
					foreach( (array)$result->getErrors() as $err ) {
						if (is_array( $err ) && isset( $err['title'] )) {	// diff error formats
							$this->addError( $err['title'], $err['message'] );
						} elseif (is_array( $err )) {
							$this->addError( $err[0], $err[1] );
						} else {
							$this->addError( TRANS_ACTIONERROR, $err );
						}
					}	unset( $err );
				}
			}	unset( $k, $v );
		
			if (!$this->getNumErrors()) {
				// redirect after we're finished
				redirect("events.php", "ShowEmailQueue", array("successRemove" => 1));
			}
	
		} else {
			// if just removing a single email
			$query = $this->getMBAPIQuery("SetEmailQueue", "update", array("emailActive" => 0));
			$data = dispatchMBAPI($query, 1);
			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("events.php", "ShowEmailQueue");
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveEmailResponse
?>