<?php
// $Id: RemoveEventResponse.php 7703 2006-06-22 20:33:39Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can event you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action sets the state of the given event (referenced by the request parameter eventID) to inactive, such that the
 * event can be considered removed from the queue.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class RemoveEventResponse extends MB_Action {
	/**
	 * Call the parent constructor, set our string representation, and setup our allowed parameters.
	 */
	function RemoveEventResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveEvent";
		$this->params = array("systemQueueID");
	}

	/**
	 * Execute this action and return 1 for a successful execution or 0 if otherwise.
	 *
	 * @return  int  1 if this action has executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		if(!((int) $_REQUEST["systemQueueID"])) {
			$this->addError(TRANS_ACTIONERROR, "No event ID was given for removal.");
		} else {
			$query = $this->getMBAPIQuery("SetSystemQueue", "delete");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("events.php", "ShowEvents");
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveEventResponse
?>