<?php
// $Id: ResendEmail.php 7386 2006-06-09 20:21:44Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action resend an email from the queue.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Brian Smith
 */
class ResendEmail extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function ResendEmail() {
		parent::MB_Action();
		$this->stringRep = "ResendEmail";
		$this->params = array("emailID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$emailID = (int)$_REQUEST["emailID"];

		if (!notZero( $emailID )) {
			$this->addError( TRANS_ACTIONERROR, "No Email ID Given" );
		} else {
			$query = $this->getMBAPIQuery("GetEmailQueue", "", array("emailID" => $emailID));
			$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
			$data = $data[0];
			
			dbg("#### Returned from GetEmail ####");
			dbg($data);

			if (notZero( $data["emailID"] )) {
				$this->smartyVars["email"] =& $data;
				$this->addTemplate("events/ResendEmail");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>