<?php
// $Id: ShowEmailDetails.php 11413 2007-06-21 20:16:33Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Brian Smith
 */
class ShowEmailDetails extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function ShowEmailDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailDetails";
		$this->params = array("emailID");
	}

	/**
	 * Execute this action and return 1 for success, or 0 for failure.
	 *
	 * @return  int  1 if execution succeeded or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		if(!notZero((int)$this->paramArgs["emailID"])) {
			$this->addError(TRANS_ACTIONERROR, "No email ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailQueue");
			$data = dispatchMBAPI($query, 1);
			
			dbg("########### Returned from GetEmailQueue #############");
			dbg($data);

			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$data = grabSimpleMBAPIResults( $data );
				$this->smartyVars["email"] = $data[0];

				$this->smartyVars["email"]["emailBody"] = utf8_html_entity_decode( $this->smartyVars["email"]["emailBody"] );
				
				dbg("########### Sent to Smarty ###############");
				dbg($this->smartyVars);
				
				$this->addTemplate("events/ShowEmailDetails");
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmail
?>
