<?php
// $Id: ShowEventInputDetails.php 11423 2007-06-22 20:36:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action parses an MBAPI command and displays the details in an easy to read format.
 * For widget display only.
 *
 * @author  Michael Fountain
 */
class ShowEventInputDetails extends MB_Action {
	/**
	 * The constructor for a ShowEventInputDetails action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowEventInputDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowEventInputDetails";
		$this->params = array("systemQueueID");
	}

	/**
	 * The main method of this class that executes the ShowEventInputDetails action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		$query = $this->getMBAPIQuery("GetSystemQueue");
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

			$smartyVars = array();

            $systemQueueCommandInputDirty = $data["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"][0]["systemQueueCommandInput"][0];
            $smartyVars["systemQueueCommandInputDirty"] = $systemQueueCommandInputDirty;

            $xmldoc =& new MBXMLLite(str_replace("&amp;", "&", str_replace("&gt;", ">", str_replace("&lt;", "<", $systemQueueCommandInputDirty))));
            $smartyVars["systemQueueCommandInputParams"] = secureInput($xmldoc->toArray());
    		if(!$xmldoc->isValid()) {
				$smartyVars["systemQueueCommandInputParams"] = array("Error"=>"XML is corrupt!");
			}

			$smartyVars["events"] = ($data["mbapi"][0]["header"][0]["numResults"][0] == 1)
				? array(0 => $results["systemQueue"][0]["systemQueueEvent"])
				: $results["systemQueue"][0]["systemQueueEvent"];

			$c = (is_array($smartyVars["events"])) ? count($smartyVars["events"]) : 0 ;
			for($i=0; $i<$c; $i++) {
				if(isset($smartyVars["events"][$i]["systemQueueLogs"][0]["systemQueueLog"])) {
					$smartyVars["events"][$i]["systemQueueLogs"][0]["systemQueueLog"] = array($smartyVars["events"][$i]["systemQueueLogs"][0]["systemQueueLog"]);
				}
			}

			$this->addTemplate("widgets/showEventInputDetails", collapseArrayElements($smartyVars));
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEventInputDetails
?>