<?php
// $Id: ShowEventStatusBar.php 9220 2006-09-28 04:57:05Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

define("DEBUG_OUTPUT_TO_SERVER", 0);


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays the current status of the system queue events.
 *
 * @author  Michael Fountain
 */
class ShowEventStatusBar extends MB_Action {
	/**
	 * The constructor for a ShowEventStatusBar action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowEventStatusBar() {
		parent::MB_Action();
		$this->stringRep = "ShowEventStatusBar";

	}

	/**
	 * The main method of this class that executes the ShowEventStatusBar action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if ($CONF["system"]["internal"]["systemQueueRunning"]) {
			$s = array();
			if ($CONF["system"]["internal"]["systemQueueStop"]) {
				$s["stopInProgress"] = 1;
			}
			$this->addTemplate("events/ShowEventStatusBar", collapseArrayElements($s));
		} else {
			return 0;
		}

		//return $this->hasExecutedSuccessfully();
	}
} // ShowEventStatusBar
?>