<?php
// $Id: AddFAQCategoryResponse.php 6965 2006-05-19 20:58:44Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a FAQ Category and inserts it into the
 * database. There is also the option to go immediately back and add another.
 *
 * @author  Mark Garrett
 * @author  Vic Fryzel
 */
class AddFAQCategoryResponse extends MB_Action {
	/**
	 * The constructor for a AddFAQCategoryResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddFAQCategoryResponse() {
		parent::MB_Action();
		$this->stringRep = "AddFAQCategoryResponse";
		$this->params = array("faqCategoryName", "faqCategoryType");
	}

	/**
	 * The main method of this class that executes the AddFAQCategoryResponse action, and returns
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID( getActionID("AddFAQCategory") );
		$this->setReferralActionFile( "faqs.php" );
		
		$success = $this->validateMultiInputs(
					array(
						"faqCategoryName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
						"faqCategoryType" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED
						));
		if ($success) {
			$query = $this->getMBAPIQuery("SetFAQCategories", "insert");
			$data = dispatchMBAPI($query, 1);
	
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if((int) $_REQUEST["addAdditionalFAQCategory"]) {
					redirect("faqs.php", "AddFAQCategory", array("addAdditionalFAQCategory" => 1));
				} else {
					redirect("faqs.php", "ShowFAQs");
				}
			}
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddFAQCategoryResponse
?>