<?php
// $Id: MergeFAQCategories.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["faqCategoryID"] and displays all
 * the FAQ Category detail information for merging in to another FAQ category. Obtains a list of all
 * existing categories to choose to merge into. The category with the $_REQUEST["faqCategoryID"]
 * will be deleted and all it's FAQs moved to the new category.
 *
 * @author  Mark Garrett
 */
class MergeFAQCategories extends MB_Action {
	/**
	 * The constructor for a MergeFAQCategories action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function MergeFAQCategories() {
		parent::MB_Action();
		$this->stringRep = "MergeFAQCategories";
		$this->params = array("faqCategoryID");
	}
	/**
	 * The main method of this class that executes the EditTodo action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$faqCategoryID = ((int) $_REQUEST["faqCategoryID"]);
		if(!$faqCategoryID) {
			$this->addError(TRANS_ACTIONERROR, "No category ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetFAQCategories");
			$data = dispatchMBAPI($query, 1);
			$header =& $data["mbapi"][0]["header"][0];
			$results =& $data["mbapi"][0]["results"][0];
	
			// check for errors
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				// Assign smarty variables
				$smartyVars = array();
				$smartyVars["faqcategory"] = $results["faqCategories"][0]["faqCategory"][0];
				$categoriesArray = $this->getMBAPIData("GetFAQCategories", "faqCategories", "faqCategory");
				foreach($categoriesArray as $category) {
					$smartyVars["categories"][$category["faqCategoryID"][0]] = $category["faqCategoryName"][0];
				}
				unset($smartyVars["categories"][$smartyVars["faqcategory"]["faqCategoryID"][0]]);
				// Set the templete for output
				
				$this->addTemplate("faqs/MergeFAQCategories", collapseArrayElements($smartyVars), 1);
				$CONF["debug"]->add("Array to Template", collapseArrayElements($smartyVars), __FILE__, __LINE__);

			}
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>