<?php
// $Id: MergeFAQCategoriesResponse.php 11737 2007-08-03 21:33:01Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the MergeFAQCategories action, applies that information to
 * records in the database, and redirects to the ShowFAQs action.
 *
 * @author  Mark Garrett
 */
class MergeFAQCategoriesResponse extends MB_Action {
	/**
	 * The constructor for a MergeFAQCategoriesResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function MergeFAQCategoriesResponse() {
		parent::MB_Action();
		$this->stringRep = "MergeFAQCategoriesResponse";
		$this->params = array("faqCategoryID");
	}

	/**
	 * The main method of this class that executes the MergeFAQCategoriesResponse action, and returns success or 
	 * failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$faqCategoryID = ((int) $_REQUEST["faqCategoryID"]);
		$mergeFaqCategoryID = ((int) $_REQUEST["mergeFaqCategoryID"]);

		if(!$faqCategoryID || !$mergeFaqCategoryID) {
			$this->addError(TRANS_ACTIONERROR, "No FAQ Category ID or Merge ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetFAQCategories", "merge", array("mergeFaqCategoryID" => $mergeFaqCategoryID));
			$data = dispatchMBAPI($query, 1);
			$header =& $data["mbapi"][0]["header"][0];
			$results =& $data["mbapi"][0]["results"][0];
		// check for errors
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				// show faqs
				
				mbHeader("Location: faqs.php");
			}

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action
?>