<?php
// $Id: EditFraudSetResponse.php 11488 2007-07-02 15:36:16Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
* This action edits an existing new fraud set.
*
* @author Michael Fountain
*/
class EditFraudSetResponse extends MB_Action {
	/**
	* The constructor for an EditFraudSetResponse action object. This merely calls the parent constructor,
	* and sets the string representation of this object. It also sets up $this->params.
	*/
	function EditFraudSetResponse() {
		parent::MB_Action();
		$this->stringRep = "EditFraudSetResponse";
		$this->params = array
		(
			"fraudSetID",
			"configGroupID",
			"fraudSetName",
			"fraudSetEmail",
			"orderFormIDs",
		);
	}

	/**
	* The main method of this class that executes the EditFraudSetResponse action, and returns success or failure.
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError(TRANS_ACTIONERROR, "No fraudSetID ID given.");
		} else {

			// test for updating relations
			$assignedOrderFormIDs = $assignedThresholdIDs = $relParams = array();
			//$addOrderFormIDs = (isset($_REQUEST["addOrderFormIDs"])) ? $_REQUEST["addOrderFormIDs"] : array() ;
			//$addThresholdIDs = (isset($_REQUEST["addThresholdIDs"])) ? $_REQUEST["addThresholdIDs"] : array() ;

			if (isset($_REQUEST["addOrderFormIDs"]) || isset($_REQUEST["addThresholdIDs"]) || isset($_REQUEST["removeOrderFormIDs"]) || isset($_REQUEST["removeThresholdIDs"])) {
				
				$relParams["orderFormIDs"]["orderFormID"] = (array)$_REQUEST["addOrderFormIDs"];
				$relParams["removeOrderFormIDs"]["orderFormID"] = (array)$_REQUEST["removeOrderFormIDs"];
				$relParams["thresholdIDs"]["thresholdID"] = (array)$_REQUEST["addThresholdIDs"];
				$relParams["removeThresholdIDs"]["thresholdID"] = (array)$_REQUEST["removeThresholdIDs"];

				// ------------------------------------------------
				// test to see if we are adding or removing relations
				// ------------------------------------------------
				if (count($relParams["orderFormIDs"]["orderFormID"]) ||
					count($relParams["removeOrderFormIDs"]["orderFormID"]) ||
					count($relParams["thresholdIDs"]["thresholdID"]) ||
					count($relParams["removeThresholdIDs"]["thresholdID"])) {
					$query = $this->getMBAPIQuery("SetFraudSets", "update", $relParams);
					$data = dispatchMBAPI($query, 1);
				} else {
					$skipUpdate = 1;
				}
			} else {
				$query = $this->getMBAPIQuery("SetFraudSets", "update", array());
				$data = dispatchMBAPI($query, 1);
			}

			if($skipUpdate || ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors())) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]."&saved=1");
				} else {
					redirect("fraudsets.php",getActionID("ShowFraudSets"),array("fraudSetID"=>$fraudSetID,"saved"=>1));
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditFraudSetResponse
