<?php
// $Id: RemoveFraudSetResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action removes an existing new fraud set.
 *
 * @author Michael Fountain
 */
class RemoveFraudSetResponse extends MB_Action {
	/**
	 * The constructor for an RemoveFraudSetResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveFraudSetResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveFraudSetResponse";
		$this->params = array("fraudSetID");
	}

	/**
	 * The main method of this class that executes the RemoveFraudSetResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError(TRANS_ACTIONERROR, "No fraudSetID ID given.");
		} else {
		    $query = $this->getMBAPIQuery("SetFraudSets", "delete", array());
		    $data = dispatchMBAPI($query, 1);

		    if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
        	    redirect("fraudsets.php",getActionID("ShowFraudSets"));
		    }
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveFraudSetResponse
?>