<?php
// $Id: ShowFraudSetDetails.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays a single fraud set.
 *
 * @author Michael Fountain
 */
class ShowFraudSetDetails extends MB_Action {
	/**
	 * The constructor for a ShowFraudSetDetails action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function ShowFraudSetDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowFraudSetDetails";
        $this->params = array("fraudSetID");
	}

	/**
	 * The main method of this class that executes the ShowFraudSetDetails action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError(TRANS_ACTIONERROR, "No fraudSetID ID given.");
		} else {
            $args = array
            (
                "getOrderForms" => 1,
                "getCountryThresholdsData" => 1
            );
		    $query = $this->getMBAPIQuery("GetFraudSets", "", $args);
		    $data = dispatchMBAPI($query, 1);
		    $fraudSets =& $data["mbapi"][0]["results"][0];

		    if($this->addMBAPIErrors($data) === 0) {

			    $this->smartyVars["fraudSet"] = collapseArrayElements($fraudSets["fraudSets"][0]["fraudSet"]);

                // ------------------------------------------------
                // find all usedOrderForms
                // ------------------------------------------------
                $usedOrderForms = array();
                $c = count($fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"]);
                for($i=0;$i<$c;$i++){
                    $id = $fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"][$i]["orderFormID"][0];
                    $this->smartyVars["usedOrderForms"][$id] =
                        $fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"][$i]["orderFormName"][0];
                    $usedOrderForms[] = $id;
                }

                // ------------------------------------------------
                // find all availableOrderForms
                // ------------------------------------------------
                $availableOrderForms = array();
                if($usedOrderForms){
					$args = array("notOrderFormIDs"=>array("orderFormID"=>$usedOrderForms));
                }
			    $query2 = $this->getMBAPIQuery("GetOrderForms", "", $args);
			    $data2 = dispatchMBAPI($query2, 1);
                $orderForms =& $data2["mbapi"][0]["results"][0];
                $c = count($orderForms["orderForms"][0]["orderForm"]);
                if (isset($orderForms["orderForms"][0]["orderForm"][0])){
					for($i=0;$i<$c;$i++){
						$id = $orderForms["orderForms"][0]["orderForm"][$i]["orderFormID"][0];
						if ((int) $id) {
							$this->smartyVars["availableOrderForms"][$id] =
								$orderForms["orderForms"][0]["orderForm"][$i]["orderFormName"][0];
							$availableOrderForms[] = $id;
						}
					}
                }

#echo "\$usedOrderForms";
#pr($usedOrderForms);
#echo "\$availableOrderForms";
#pr($availableOrderForms);

                // ------------------------------------------------
                // find all usedThresholds
                // ------------------------------------------------
                $usedThresholds = array();
                $c = count($fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"]);
                for($i=0;$i<$c;$i++){
                    $id = $fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"][$i]["thresholdID"][0];
                    $this->smartyVars["usedThresholds"][$id] =
                        $fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"][$i]["thresholdName"][0];
                    $usedThresholds[] = $id;
                }

                // ------------------------------------------------
                // find all availableThresholds
                // ------------------------------------------------
                $availableThresholds = array();
                if($usedThresholds){
					$args = array("notThresholdIDs"=>array("thresholdID"=>$usedThresholds));
                }
			    $query3 = $this->getMBAPIQuery("GetFraudCountryThresholds", "", $args);
			    $data3 = dispatchMBAPI($query3, 1);
                $thresholds =& $data3["mbapi"][0]["results"][0];
                if (isset($thresholds["countryThresholds"][0]["countryThreshold"][0])){
					$c = count($thresholds["countryThresholds"][0]["countryThreshold"]);
					for($i=0;$i<$c;$i++){
						$id = $thresholds["countryThresholds"][0]["countryThreshold"][$i]["thresholdID"][0];
						if ((int) $id) {
							$this->smartyVars["availableThresholds"][$id] =
								$thresholds["countryThresholds"][0]["countryThreshold"][$i]["thresholdName"][0];
							$availableThresholds[] = $id;
						}
					}
                }

#echo "\$usedThresholds";
#pr($usedThresholds);
#echo "\$availableThresholds";
#pr($availableThresholds);

			    // Set the templete for output
			    $this->mergeSystemNavData();
			    $this->addTemplate("fraudsets/ShowFraudSetDetails",$this->smartyVars, 1);

		    }
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowFraudSetDetails
?>