<?php
// $Id: ShowFinancialGraph.php 8093 2006-07-20 15:29:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * Generate and return a graph image to the user. If a graph for the given credentials has already been generated, and the
 * cached image is within its lifetime, the cached image will be returned.
 *
 * @author  Michael Fountain
 */
class ShowFinancialGraph extends MB_Action {
	/**
	 * The constructor for a EditConfigParams action object. This calls the parent constructor and sets our string
	 * representation.
	 */
	function ShowFinancialGraph() {
		parent::MB_Action();
		$this->stringRep = "ShowFinancialGraph";
		$this->params = array
		(
			"type","dataSource","dataSourceArgs",
			"width","height",
			"title","titleBold","titleColor",
			"text","textBold","textColor","textSize",
			"xTitle","xTitleBold","xTitleColor",
			"yTitle","yTitleBold","yTitleColor",
		);
	}

	/**
	 * The main method of this class that executes the ShowFinancialGraph action, and returns the graph.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$errorMsg = array();
		

		// define all valid data sources for this type of financial graph
		$validDataSources = array
		(
			"ClientList",
		);

		if (in_array($this->paramArgs["dataSource"],$validDataSources)) {

			$graph = NULL;

			if ($this->paramArgs["type"]=="bar") {
				require_once mb_path("/lib-action/include/graph/MB_Bar.php");
				$graph =& new MB_Bar();
			} else if($this->paramArgs["type"]=="line") {
				require_once mb_path("/lib-action/include/graph/MB_Line.php");
				$graph =& new MB_Line();
			} else if($this->paramArgs["type"]=="pie") {
				require_once mb_path("/lib-action/include/graph/MB_Pie.php");
				$graph =& new MB_Pie();
			} else if($this->paramArgs["type"]=="canvas") {
				require_once mb_path("/lib-action/include/graph/MB_Canvas.php");
				$graph =& new MB_Canvas();
			}

			if ($graph) {
				if (mb_path("/lib-action/include/reports/".$this->paramArgs["dataSource"].".php")){
					require_once mb_path("/lib-action/include/reports/".$this->paramArgs["dataSource"].".php");
					$dsoName = $this->paramArgs["dataSource"]."Report";
					$this->paramArgs["dataSourceArgs"]["outputType"] = 1;
					$dso =& new $dsoName($this->paramArgs["dataSourceArgs"]);
					$graph->setGraphDataSource($dso);
					$graph->setGraphSize($this->paramArgs["width"],$this->paramArgs["height"]);
					$graph->setGraphTitle($this->paramArgs["title"],$this->paramArgs["titleBold"],$this->paramArgs["titleColor"]);
					$graph->setGraphXAxisTitle($this->paramArgs["xTitle"],$this->paramArgs["xTitleBold"],$this->paramArgs["xTitleColor"]);
					$graph->setGraphYAxisTitle($this->paramArgs["yTitle"],$this->paramArgs["yTitleBold"],$this->paramArgs["yTitleColor"]);
					$graph->generate();
				} else {
					$errorMsg[] = "Unable to find datasource file. (/lib-action/include/reports/".$this->paramArgs["dataSource"].".php)";
				}
			} else {
				$errorMsg[] = "Unable to create a graph object.";
			}

		} else {
			$errorMsg[] = "Invalid data source.";
		}

		if (count($errorMsg)>0) {
			// error image to be displayed here
			require_once mb_path("/lib-action/include/graph/MB_Canvas.php");
			$graph =& new MB_Canvas();
			$graph->setGraphSize($this->paramArgs["width"],$this->paramArgs["height"]);
			$graph->setGraphMargins(2,2,2,2);
			$graph->setGraphTitle("Error: Unable to generate your graph.",1,"red");
			$graph->setGraphText(implode("\n",$errorMsg),1,"#BBBBBB",10);
			$graph->generate();
		}
	}
}

/* DEBUG 
$g =& new ShowFinancialGraph();
$g->execute();
/**/
?>
