<?php
// $Id: NewClientTrendData.php 9127 2006-09-23 16:36:56Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * @author  Michael Fountain
 */
class ShowNewClientTrendGraph extends MB_Action {
	/**
	 */
	function ShowNewClientTrendGraph() {
		parent::MB_Action();
		$this->stringRep = "ShowNewClientTrendGraph";
		$this->params = array
		(
			"type","dataSource","dataSourceArgs",
			"width","height",
			"title","titleBold","titleColor",
			"text","textBold","textColor","textSize",
			"xTitle","xTitleBold","xTitleColor",
			"yTitle","yTitleBold","yTitleColor",
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$errorMsg = array();
		

		// define all valid data sources for this type of financial graph
		$validDataSources = array
		(
			"ClientList","ClientTrend"
		);

		if (in_array($this->paramArgs["dataSource"],$validDataSources)) {

			$graph = NULL;

			if ($this->paramArgs["type"]=="bar") {
				require_once mb_path("/lib-action/include/graph/MB_Bar.php");
				$graph =& new MB_Bar();
			} else if($this->paramArgs["type"]=="line") {
				require_once mb_path("/lib-action/include/graph/MB_Line.php");
				$graph =& new MB_Line();
			} else if($this->paramArgs["type"]=="pie") {
				require_once mb_path("/lib-action/include/graph/MB_Pie.php");
				$graph =& new MB_Pie();
			} else if($this->paramArgs["type"]=="canvas") {
				require_once mb_path("/lib-action/include/graph/MB_Canvas.php");
				$graph =& new MB_Canvas();
			}

			if ($graph) {
				if (mb_path("/lib-action/include/reports/".$this->paramArgs["dataSource"].".php")){
					require_once mb_path("/lib-action/include/reports/".$this->paramArgs["dataSource"].".php");
					$dsoName = $this->paramArgs["dataSource"]."Report";
					$this->paramArgs["dataSourceArgs"]["outputType"] = 1;
					$dso =& new $dsoName($this->paramArgs["dataSourceArgs"]);
					$graph->setGraphDataSource($dso);
					$graph->setGraphSize($this->paramArgs["width"],$this->paramArgs["height"]);
					$graph->setGraphTitle($this->paramArgs["title"],$this->paramArgs["titleBold"],$this->paramArgs["titleColor"]);
					$graph->setGraphXAxisTitle($this->paramArgs["xTitle"],$this->paramArgs["xTitleBold"],$this->paramArgs["xTitleColor"]);
					$graph->setGraphYAxisTitle($this->paramArgs["yTitle"],$this->paramArgs["yTitleBold"],$this->paramArgs["yTitleColor"]);
					$graph->generate();
				} else {
					$errorMsg[] = "Unable to find datasource file. (/lib-action/include/reports/".$this->paramArgs["dataSource"].".php)";
				}
			} else {
				$errorMsg[] = "Unable to create a graph object.";
			}

		} else {
			$errorMsg[] = "Invalid data source.";
		}

		if (count($errorMsg)>0) {
			// error image to be displayed here
			require_once mb_path("/lib-action/include/graph/MB_Canvas.php");
			$graph =& new MB_Canvas();
			$graph->setGraphSize($this->paramArgs["width"],$this->paramArgs["height"]);
			$graph->setGraphMargins(2,2,2,2);
			$graph->setGraphTitle("Error: Unable to generate your graph.",1,"red");
			$graph->setGraphText(implode("\n",$errorMsg),1,"#BBBBBB",10);
			$graph->generate();
		}
	}
}

?>
