<?php
// $Id: SalesAndReceiptsJournal.php 5679 2006-03-21 23:01:08Z ben $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


function getSalesAndReceiptsJournalData($args) {
	global $CONF;

	$graphData = array();

	$days = 7;
	if ((int) $args[0]) {
		$days = (int) $args[0];
	}

   	$xmlParams = array
	(
		"receiptDateCreatedGreaterThan" => mktime(0,0,0,date("m"),date("d")-$days,date("Y")),
	);
	$query = getMBAPIQuery("GetAccountingReceiptsJournal", "select", $xmlParams);
	$CONF["debug"]->add("ShowGraph::getGraphData",htmlentities($query), __FILE__, __LINE__);
	$data = dispatchMBAPI($query, 1);
	$CONF["debug"]->add("ShowGraph::getGraphData",$data, __FILE__, __LINE__);
	if ($data["mbapi"][0]["header"][0]["errorCount"][0] == 0 && $data["mbapi"][0]["header"][0]["numResults"][0] > 0) {
	 	$num = $data["mbapi"][0]["header"][0]["numResults"][0];
	 	$results =& $data["mbapi"][0]["results"][0]["accounting_receipts"][0]["receipt"];
		// sum totals for the last X days
        for($i=0;$i<=$num;$i++){
         	// day of the year
			$day = date("z",$results[$i]["receiptDateCreated"][0]);
			$sumCashDebitAmount[$day] += $results[$i]["receiptCashDebitAmount"][0];
			#$graphData[$day]["sumAccountsReceivableDebitAmount"] += $results[$i]["receiptAccRecDebitAmount"][0];
			#$graphData[$day]["sumAccountsReceivableCreditAmount"] += $results[$i]["receiptAccRecCreditAmount"][0];
			$sumSalesCreditAmount[$day] += $results[$i]["receiptSalesCreditAmount"][0];
			$sumSalesTaxPayableCreditAmount[$day] += $results[$i]["receiptTaxPayCreditAmount"][0];
		}
	}

	// y-axis data values
	$graphData["yScale"] = "lin";
	// y data set 0
	$graphData["yLegend"][0] = "Sales";
	$graphData["yColor"][0] = "red";
	// y data set 1
	$graphData["yLegend"][1] = "Receipts";
	$graphData["yColor"][1] = "green";
	// y data set 2
	$graphData["yLegend"][2] = "Taxes";
	$graphData["yColor"][2] = "purple";
	// x-axis data values
	$graphData["xScale"] = "dat";
	// set data for the last 7 days (values are required for each day, even if the value is zero)
    for($i=$days-1;$i>=0;$i--){
     	$timeStamp = mktime(0,0,0,date("m"),date("d")-$i,date("Y"));
     	$day = date("z",$timeStamp);
     	$date = date("Y/m/d",$timeStamp);
     	$graphData["xPlots"][] = $timeStamp;
     	$graphData["xPlotLabels"][] = $date;
		$graphData["yPlots"][0][] = ($sumCashDebitAmount[$day]>0) ? $sumCashDebitAmount[$day] : 0 ;
		$graphData["yPlots"][1][] = ($sumSalesCreditAmount[$day]>0) ? $sumSalesCreditAmount[$day] : 0 ;
		$graphData["yPlots"][2][] = ($sumSalesTaxPayableCreditAmount[$day]>0) ? $sumSalesTaxPayableCreditAmount[$day] : 0 ;

		// test for pie charts only
		$graphData["pPlots"][0][] = ($sumCashDebitAmount[$day]>0) ? $sumCashDebitAmount[$day] : 0 ;
		$graphData["pPlotLabels"][] = $date;

	}
	return $graphData;

}
?>
