<?php
// $Id: AddSingleInvoiceResponse.php 12597 2008-01-31 23:33:19Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 */
class AddSingleInvoiceResponse extends MB_Action {

	function AddSingleInvoiceResponse() {
		parent::MB_Action();
		$this->stringRep = "AddSingleInvoiceResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		if(!(int)$_REQUEST["clientID"]) {
			$this->addError( TRANS_ACTIONERROR, "Client ID not found." );
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}
		$clientID = (int)$_REQUEST["clientID"];
		
		$params = array(
			"clientID" => $clientID,
			"packageName" => $_REQUEST["packageName"],
			"packageDescription" => $_REQUEST["packageDescription"],
			"amount" => $this->getNumberFromInput($_REQUEST["amount"]),
			"invoiceDate" => getMBDateFromRequest("invoiceDate"),
			"cycleID" => $_REQUEST["cycleID"],
			"paymentGroupID" => $_REQUEST["paymentGroupID"],
			"enableInvoiceEmail" => $_REQUEST["enableInvoiceEmail"],
			
			"amountPaid" => $this->getNumberFromInput($_REQUEST["amountPaid"]),
			"paymentComments" => $_REQUEST["paymentComments"],
			"transactionDateCreated" => getMBDateFromRequest("transactionDateCreated"),
			"enablePaymentEmail" => $_REQUEST["enablePaymentEmail"],
			"billingAccountID" => $_REQUEST["billingAccountID"],
		);
		
		if (!(int)$_REQUEST["applyPaymentAsWell"]){
			unset($params["amountPaid"]);
			unset($params["paymentComments"]);
			unset($params["transactionDateCreated"]);
			unset($params["enablePaymentEmail"]);
			unset($params["billingAccountID"]);
		}
	
		$results = dispatchMBAPI(array(
			"mbapi" => array(
				"command" => "ProcessSingleInvoice",
				"params" => $params,
			),
		), 1);
		
		$invoiceID = $results["mbapi"][0]["results"][0]["invoiceID"];
		$invoiceID = is_array($invoiceID) ? (int)$invoiceID[0] : 0;
	
		if ($invoiceID){
			redirect("invoices.php", "ShowInvoiceDetails", array("invoiceID"=>$invoiceID));
		} else {
			$this->addError( TRANS_ACTIONERROR, "Error generating invoice." );
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

	}

}
