<?php
// $Id: ConfirmCreditNote.php 10908 2007-03-26 17:21:41Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object takes an invoice id and asks you whether you really want to create a credit note for it or not
 *
 * @author  Kris Bailey
 */
class ConfirmCreditNote extends MB_Action {
	/**
	 * The constructor for a ConfirmCreditNote action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.x
	 */

	function ConfirmCreditNote() {
		parent::MB_Action();
		$this->stringRep = "ConfirmCreditNote";
		$this->params = array("invoiceID");
	}

	/**
	 * The main method of this class that executes the ConfirmCreditNote action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
        $this->smartyVars = array();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No invoice ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetInvoices", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$this->smartyVars["invoice"] = collapseArrayElements($data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]);
				$this->smartyVars["creditNote"] = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetInvoices",
						"params" => array(
							"creditNoteForInvoiceID" => $this->smartyVars["invoice"]["invoiceID"],
						),
					),
				)));
				$this->addTemplate("invoices/ConfirmCreditNote", $this->smartyVars);

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ConfirmCreditNote
?>