<?php
// $Id: ProcessManualPayment.php 12995 2008-07-11 15:29:49Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-modernbill/include/accounting/Payment.php");

/**
 * This Action object collects information on a transaction for the purpose of processing a manual payment
 *
 * @author  Kris Bailey
 */
class ProcessManualPayment extends MB_Action {
	/**
	 * The constructor for a ProcessManualPayment action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.x
	 */

	function ProcessManualPayment() {
		parent::MB_Action();
		$this->stringRep = "ProcessManualPayment";
	}

	/**
	 * The main method of this class that executes the ProcessManualPayment action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		$subaction = (is_numeric($_REQUEST["subaction"])) ? getApiTypeID("payments", $_REQUEST["subaction"]) : $_REQUEST["subaction"];
		$paymentMethod = ($subaction=="applycredit")?getAPITypeID("payments", "credit"):$_REQUEST["paymentMethod"];
		$applyPaymentTo = secureInput($_REQUEST["applyPaymentTo"]);
		$billingAccountID = (int)$_REQUEST["billingAccountID"];
		$lineItemPayments = $this->getLineItemsPayments($_REQUEST["lineItemPayments"]);
		$paymentAmount = $this->getNumberFromInput($_REQUEST["paymentAmount"]);
		$paymentComments = secureInput($_REQUEST["paymentComments"]);
		$transactionCode = secureInput($_REQUEST["transactionCode"]);

		$_REQUEST["transactionDateCreated"] = getMBDateFromRequest("transactionDateCreated");

		$paymentCmd = array(
			"mbapi" => array(
				"command" => "ProcessManualPayment",
				"params" => array(
					"paymentMode" => 0,
					"payments" => array(
						"payment" => array(
							"subaction" => $subaction,
							"paymentMethod" => $paymentMethod,
							"invoiceID" => $invoiceID,
							"billingAccountID" => $billingAccountID,
							"paymentAmount" => ($applyPaymentTo=="invoice") ? $paymentAmount : $lineItemPayments,
							"paymentComments" => $paymentComments,
							"transactionCode" => $transactionCode,
							"transactionDateCreated" => $_REQUEST["transactionDateCreated"],
							"sendPaymentEmail" => (int)$_REQUEST["sendPaymentEmail"],
						),
					),
				),
			),
		);

		
		if ($applyPaymentTo!="invoice"){
			$lineItemPaymentsArray = array();
			foreach ((array)$_REQUEST["lineItemPayments"] as $liID=>$amount){
				$lineItemPaymentsArray[] = array(
					"lineItemID" => $liID,
					"paymentAmount" => $this->getNumberFromInput($amount),
				);
			}
			$paymentCmd["mbapi"]["params"]["payments"]["payment"]["lineItems"] = array(
				"lineItem" => $lineItemPaymentsArray,
			);
		}
		
		dbg(dispatchMBAPI($paymentCmd, 1));

/*
        if ($applyPaymentTo!="invoice"){
            $paymentAmount = array_sum(array_values($lineItemPayments));
        }

        $transactionAmount = $paymentAmount;


        $authReturn = 200;

        switch ($paymentMethod){
            case 1:
            case 2:
            case 4:
            case 5:
                $authReturn = 1;
                break;
        }

        $invoiceXML = "
            <mbapi>
                <command>GetInvoices</command>
                <params>
                    <invoiceID>$invoiceID</invoiceID>
                    <getInvoiceLineItemsData>1</getInvoiceLineItemsData>
                    <getInvoiceLineItemsPaymentsData>1</getInvoiceLineItemsPaymentsData>
                </params>
            </mbapi>
        ";

        $this->invoiceInfo = dispatchMBAPI($invoiceXML, 1);

        $this->invoiceInfo = $this->invoiceInfo["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0];
        $this->lineItems = collapseArrayElements($this->invoiceInfo["lineItems"][0]["lineItem"]);
        $this->invoiceInfo = collapseArrayElements($this->invoiceInfo);

        if ($this->lineItems["lineItemID"]){
            $this->lineItems = array($this->lineItems);
        }
        $clientID = $this->lineItems[0]["clientID"];

        foreach ($this->lineItems as $k=>$v){
            $this->lineItems[$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
        }


/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
        if ($subaction=="applycredit"){

            $paymentMethod = 50;

            $authReturn = 201;

            $clientInfoCmd = "<mbapi>
                                <command>GetClients</command>
                                <showXMLHeader>0</showXMLHeader>
                                <params>
                                  <clientID>$clientID</clientID>
                                  <getContactData>3</getContactData>
                                  <getBillingData>1</getBillingData>
                                  <getCompanyData>1</getCompanyData>
                                  <getAccountingData>1</getAccountingData>
                                  <sortDir></sortDir>
                                  <sortColumn></sortColumn>
                                  <recordOffset>0</recordOffset>
                                  <numRecords>1</numRecords>
                                </params>
                              </mbapi>";

            $clientData = dispatchMBAPI($clientInfoCmd, 1);
            $clientData = $clientData["mbapi"][0]["results"][0]["clients"][0]["client"][0];
            $tmp = collapseArrayElements($clientData["accountingGeneralLedgers"][0]["accountingGeneralLedger"]);
            if ($tmp["currencyID"]){
                $tmp = array($tmp);
            }
            $clientCredits = $this->getAccountingCurrencyTotals($tmp, "customer_credits");
            $creditAmount = $clientCredits[$this->invoiceInfo["currencyID"]];

            $CONF["debug"]->debugMessage("payment amount1: $paymentAmount");

            if ($paymentAmount>$creditAmount){
                $paymentAmount = $creditAmount;
            }

            $CONF["debug"]->debugMessage("payment amount2: $paymentAmount");

            if ($applyPaymentTo!="invoice"){

                // apply the amounts listed to the line items in the requested manner
                // keep track of overages so we can distribute them in order

                $newPayments = array();
                $total = 0;
                foreach ($lineItemPayments as $id=>$amt){
                    if ($total+$amt>$creditAmount){
                        $applyAmount = $creditAmount-$total;
                    } else {
                        $applyAmount = $amt;
                    }
                    $newPayments[$id] = $applyAmount;
                }
                $lineItemPayments = $newPayments;


                $overage = 0;

                foreach ($this->lineItems as $k=>$v){
                    if ($lineItemPayments[$v["lineItemID"]]>$v["lineItemAmountDue"]){
                        $overage += $lineItemPayments[$v["lineItemID"]]-$v["lineItemAmountDue"];
                        $this->lineItems[$k]["lineItemApplyAmount"] = $v["lineItemAmountDue"];
                    } else {
                        $this->lineItems[$k]["lineItemApplyAmount"] = $lineItemPayments[$v["lineItemID"]];
                    }
                }

            } else { // end applying specific payments to line items
                $overage = $paymentAmount;
            }

            // apply the overage, or just the amount they listed, to line items in order.
            foreach ($this->lineItems as $k=>$v){
                if ($overage>0){
                    if ($v["lineItemApplyAmount"]<$v["lineItemAmountDue"]){
                        $diff = $v["lineItemAmountDue"]-$v["lineItemApplyAmount"];
                        if ($overage<$diff){
                            $diff = $overage;
                            $overage = 0;
                        } else {
                            $overage -= $diff;
                        }
                        $this->lineItems[$k]["lineItemApplyAmount"] += $diff;
                    }
                } else {
                    break;
                }
            }

            if ($overage>0){
                $credit = round($overage, 3);
            }
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

        } else {

            if ($applyPaymentTo!="invoice"){

                // apply the amounts listed to the line items in the requested manner
                // keep track of overages so we can distribute them in order

                $overage = 0;

                foreach ($this->lineItems as $k=>$v){
                    if ($lineItemPayments[$v["lineItemID"]]>$v["lineItemAmountDue"]){
                        $overage += $lineItemPayments[$v["lineItemID"]]-$v["lineItemAmountDue"];
                        $this->lineItems[$k]["lineItemApplyAmount"] = $v["lineItemAmountDue"];
                    } else {
                        $this->lineItems[$k]["lineItemApplyAmount"] = $lineItemPayments[$v["lineItemID"]];
                    }
                }

            } else { // end applying specific payments to line items
                $overage = $paymentAmount;
            }

            // apply the overage, or just the amount they listed, to line items in order.
            foreach ($this->lineItems as $k=>$v){
                if ($overage>0){
                    if ($v["lineItemApplyAmount"]<$v["lineItemAmountDue"]){
                        $diff = $v["lineItemAmountDue"]-$v["lineItemApplyAmount"];
                        if ($overage<$diff){
                            $diff = $overage;
                            $overage = 0;
                        } else {
                            $overage -= $diff;
                        }
                        $this->lineItems[$k]["lineItemApplyAmount"] += $diff;
                    }
                } else {
                    break;
                }
            }

            if ($overage>0){
                $credit = round($overage, 3);
            }


        } // end payment processing
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

        $amount = 0;
        $paidtotal = 0;
        foreach ($this->lineItems as $k=>$v){
            $amount += $v["lineItemApplyAmount"];
            $paidtotal += $v["lineItemApplyAmount"]+$v["lineItemPaymentAmount"];
        }
        if ($subaction=="applycredit"){
            $transactionAmount = $amount;
        }


        ///////////// create the transaction
        $_REQUEST['transactionDateCreated'] = strtotime($_REQUEST['transactionDateCreated']);
        $transXML = "
                    <mbapi>
                      <command>SetTransaction</command>
                      <subCommand>insert</subCommand>
                      <params>
                         <transactionPaymentMethod>".$paymentMethod."</transactionPaymentMethod>
                         <authReturn>".$authReturn."</authReturn>
                         <transactionCode>".$transactionCode."</transactionCode>
                         <transactionNotes>".$paymentComments."</transactionNotes>
                         <transactionDateCreated>".( notZero($_REQUEST['transactionDateCreated']) ? (int)$_REQUEST['transactionDateCreated'] : time() )."</transactionDateCreated>
                         <authCode></authCode>
                         <avsCode></avsCode>
                         <transactionAmount>".$transactionAmount."</transactionAmount>
                         <currencyID>".$this->invoiceInfo["currencyID"]."</currencyID>
                         <configGroupID>0</configGroupID>
                         <billingAccountID>".$billingAccountID."</billingAccountID>

                         <invoiceIDs>
                            <invoiceID>".$invoiceID."</invoiceID>
                         </invoiceIDs>

                      </params>
                    </mbapi>";

        $transResponse = dispatchMBAPI($transXML, 1);
        $transactionID = $transResponse["mbapi"][0]["header"][0]["lastInsertID"][0];

        foreach ($this->lineItems as $k=>$v){
            if ($v["lineItemApplyAmount"]>0){
                $successRelXML = "
                        <mbapi>
                            <command>SetTransactionSuccessRel</command>
                            <subCommand>insert</subCommand>
                            <params>
                                <transactionID>$transactionID</transactionID>
                                <billingAccountShareID>0</billingAccountShareID>
                                <lineItemID>".$v["lineItemID"]."</lineItemID>
                                <lineItemPaymentAmount>".$v["lineItemApplyAmount"]."</lineItemPaymentAmount>
                            </params>
                        </mbapi>
                        ";
                $successRel = dispatchMBAPI($successRelXML, 1);
            } else {
                $CONF["debug"]->debugMessage("had a blank amount: $transactionID");
            }
        }


        $updateXML = "
                      <mbapi>
                        <command>SetInvoices</command>
                        <subCommand>update</subCommand>
                        <showXMLHeader>0</showXMLHeader>
                        <params>
                           <invoiceID>".$invoiceID."</invoiceID>
                           <invoiceAmountPaid>".$paidtotal."</invoiceAmountPaid>
                           <invoiceDatePaid>".time()."</invoiceDatePaid>
                      ".((round(doubleval($paidtotal),2)==round(doubleval($this->invoiceInfo["invoiceAmount"]), 2))?"<invoiceStatus>1</invoiceStatus>":"")."
                        </params>
                      </mbapi>";
        $updateResponse = dispatchMBAPI($updateXML, 1);


        if ($subaction=="applycredit"){
            // accounting for applying credit
            $CONF["debug"]->debugMessage("doing credit accting stuff");
            $receipt =& new Payment();
            $receipt->setClientID($clientID);
            $receipt->invoiceNumber = $this->invoiceInfo["invoiceNumber"];
            $receipt->setInvoiceID($invoiceID);
            $receipt->setTransactionID($transactionID);
            $receipt->setDescription(TRANS_MANUAL_PAYMENT_FOR_INVOICE.": ".@constant(getTypeName("payment", $paymentMethod)));
            $receipt->setPaymentAmount($amount);
            $receipt->setCurrencyID($this->invoiceInfo["currencyID"]);
            $receipt->setCreditPayment(1);
            $receipt->execute();

        } else {
            // the accounting for applying a manual payment

            $receipt =& new Payment();
            $receipt->setClientID($clientID);
            $receipt->invoiceNumber = $this->invoiceInfo["invoiceNumber"];
            $receipt->setInvoiceID($invoiceID);
            $receipt->setTransactionID($transactionID);
            $receipt->setDescription(TRANS_MANUAL_PAYMENT_FOR_INVOICE.": ".@constant(getTypeName("payment", $paymentMethod)));
            $receipt->setPaymentAmount($amount+$credit);
            if ($credit>0){
                $receipt->setClientCreditAmount($credit);
            }
            $receipt->setCurrencyID($this->invoiceInfo["currencyID"]);
            $receipt->execute();

        }

		if ((int)$_REQUEST["sendPaymentEmail"]){
		}
*/

        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
        } else {
            redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$invoiceID."&sid=".secureInput($_REQUEST["sid"]));
        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

    /**
     * parse out the numbers from the payment amounts currencyized
     *
     */
    function getLineItemsPayments($lineItemInfo){
        global $CONF;

        $result = array();
        foreach ($lineItemInfo as $k=>$v){
            $result[$k] = $this->getNumberFromInput($v);
        }

        return $result;

    }


} // EditInvoice
?>