<?php
// $Id: ProcessTransactionRefund.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a transaction for the purpose of processing a refund
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ProcessTransactionRefund extends MB_Action {
	/**
	* The constructor for a ProcessTransactionRefund action object. This merely calls the parent constructor,
	* and sets the string representation of this object.x
	*/

	function ProcessTransactionRefund() {
		parent::MB_Action();
		$this->stringRep = "ProcessTransactionRefund";
	}

	/**
	* The main method of this class that executes the ProcessTransactionRefund action, and returns success or failure.
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$transactionIDs = array_unique((array)$_REQUEST["transactionIDs"]);
		$allInvoiceIDs = array_unique((array)$_REQUEST["invoiceID"]);

		// first lets test if we have a transactionID at all
		if ($transactionIDs[0]["transactionID"]){
			// lets get all our transactions
			$this->smartyVars["transactions"] = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetTransactions",
					"params" => array(
						"getGatewayNames" => 1,
						"transactionIDs" => array(
							"transactionID" => $transactionIDs,
						),
					),
				),
			)));
			dbg($this->smartyVars["transactions"]);
			
			$this->smartyVars["invoiceID"] = (int)$_REQUEST["invoiceID"];
			
			// lets get any line item info that we need
			$lineItemIDs = array_unique((array)$_REQUEST["lineItemIDs"]);
			if ($lineItemIDs[0]){
				$successRel = correctArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetTransactionSuccessRel",
						"params" => array(
							"lineItemID" => $lineItemIDs,
							"transactionID" => $transactionIDs,
						),
					),
				)));
				$lineItemInfo = correctArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetLineItems",
						"params" => array(
							"lineItemID" => $lineItemIDs,
						),
					),
				)));
				$this->smartyVars["lineItemNames"] = array();
				foreach ((array)$lineItemInfo as $li){
					$this->smartyVars["lineItemNames"][$li["lineItemID"]] = "(".TRANS_ID.": ".$li["lineItemID"].") ".$li["lineItemDescription"];
				}
				$this->smartyVars["lineItemsForTransactions"] = array();
				$this->smartyVars["transactionInvoiceIDs"] = array();
				$this->smartyVars["transactionRefundTotals"] = array();
				foreach ((array)$successRel as $sr){
					$this->smartyVars["lineItemsForTransactions"][$sr["transactionID"]][] = $sr;
					$this->smartyVars["transactionRefundTotals"][$sr["transactionID"]] += $sr["lineItemPaymentAmount"];
				}
				
			}
			
			$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => $this->smartyVars["invoiceID"],
					),
				),
			)));

			foreach ((array)$this->smartyVars["transactions"] as $k=>$v){

				$this->smartyVars["transactions"][$k]["gatewayActions"] = array("refund" => TRANS_REFUND);

				if ($v["gatewayClassName"]!=""){
					if (file_exists(mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php"))) {
						require_once mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php");
						$caps = call_user_func(array($v["gatewayClassName"], "getModuleInfo"));
						if (in_array(GATEWAY_PARTIAL_REFUND, $caps["capabilities"])){
							if (count($this->smartyVars["lineItemsForTransactions"])){
								$this->smartyVars["transactions"][$k]["gatewayActions"]["partial_refund"] = TRANS_PARTIAL_REFUND;
							}
							$this->smartyVars["transactions"][$k]["canPartial"] = 1;
						}
						if (in_array(GATEWAY_VOID, $caps["capabilities"])){
							$this->smartyVars["transactions"][$k]["gatewayActions"]["void"] = TRANS_VOID;
						}
					} else {
					}
				} else {
					show($v);
				}
				
				$day = date("z", $v["transactionDateCreated"]);
				$today = date("z");
				if ($day!=$today){
					if ($_REQUEST["lineItemIDs"]){
						$this->smartyVars["transactions"][$k]["selectedAction"] = 'partial_refund';
					} else {
						$this->smartyVars["transactions"][$k]["selectedAction"] = 'refund';
					}
				} else {
					$this->smartyVars["transactions"][$k]["selectedAction"] = 'void';
				}
				
			}

			$this->addTemplate("invoices/ProcessTransactionRefund", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditInvoice
?>