<?php
// $Id: ProcessTransactionRefundResponse.php 12216 2007-11-13 20:29:13Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/accounting/Refund.php");

/**
 * This Action object takes information provided by the ProcessTransactionRefund action,
 * and uses it to refund the transaction amount to the customer.
 *
 * @author  Kris Bailey
 */
class ProcessTransactionRefundResponse extends MB_Action {
	/**
	* The constructor for an ProcessTransactionRefundResponse action object. This merely calls the parent constructor,
	* and sets the string representation of this object. It also sets up $this->params.
	*/
	function ProcessTransactionRefundResponse() {
		parent::MB_Action();
		$this->stringRep = "ProcessTransactionRefundResponse";
	}

	/**
	* The main method of this class that executes the ProcessTransactionRefundResponse action, and returns success or failure.
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$transactionID = ((int) $_REQUEST["transactionID"]);
		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		$key = secureInput($_REQUEST["key"]);
		$markUnpaid = (int)$_REQUEST["markUnpaid"];
		
		if ($_REQUEST["refundType"]=="partial"){
			$_REQUEST["refundAmount"] = $this->getNumberFromInput($_REQUEST["lesserAmount"]);
			$markUnpaid = 0;
		}
		
		$results = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetEncryptedText",
				"params" => array(
					"text" => $key,
				),
			),
		)), 1);
		$key = ($results["mbapi"] && $results["mbapi"][0] && $results["mbapi"][0]["results"] && $results["mbapi"][0]["results"][0] && $results["mbapi"][0]["results"][0]["text"])?$results["mbapi"][0]["results"][0]["text"][0]:"";

		$gatewayAction = ($_REQUEST["gatewayAction"]=='void')?'void':'refund';

			if(!$transactionID) {
				$this->addError(TRANS_ACTIONERROR, "No transaction ID given.");
			} elseif (!$key){
				$this->addError(TRANS_ACTIONERROR, "No key given.");
			} else {
		
			$transaction = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetTransactions",
					"params" => array(
						"getGatewayNames" => 1,
						"transactionIDs" => array(
							"transactionID" => $transactionID,
						),
					),
				),
			)));
			dbg($transaction);
			
			$refundAmount = doubleval($_REQUEST["refundAmount"])?doubleval($_REQUEST["refundAmount"]):round($transaction["transactionAmount"]-$transaction["transactionAmountRefunded"], 2);
		
			if ($refundAmount>round($transaction["transactionAmount"]-$transaction["transactionAmountRefunded"], 2)){
				$refundAmount = round($transaction["transactionAmount"]-$transaction["transactionAmountRefunded"], 2);
			}
		

			$q =& new MBQuery("ProcessGateway", $gatewayAction,
				array(
					"configGroupID" => $transaction["configGroupID"],
					"transactionCode" => $transaction["transactionCode"],
					"billingAccountID" => $transaction["billingAccountID"],
					"paymentDescription" => TRANS_REFUND,
					"paymentAmount" => $refundAmount,
					"key" => $key,
				)
			);
			//show($q->getQuery());
			
			$transactionAmountRefunded = $transaction["transactionAmountRefunded"]+$refundAmount;

			$r =& $q->getResult();
			//show($r);
			if ($r->getSuccess()) {
				$s = $r->getSubjectFrom(array("mbapi", "results", "transactions", "transaction"));
				$refundReturns = $s->getTabular();
				$refundReturn = $refundReturns[0];
				//show($refundReturn);
				/*
				$refundReturn = array(
					"status" => 1,
					"statusName" => "successful",
					"statusMessage" => "Successful",
					"authorizationCode" => "",
					"AVSCode" => "",
					"transactionID" => "",
					"message" => "Successful (simulated by mbtech ben)",
				);
				*/
				//show($refundReturn);
				if($refundReturn["statusName"] == "successful") {

					$invoiceInfo = correctArray(grabFirstResultFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetInvoices",
							"params" => array(
								"invoiceID" => $invoiceID,
								"getInvoiceLineItemsData" => 1,
							),
						),
					)));
	
					$lineItemIDs = (array)$_REQUEST["lineItemIDs"];
			
					if ($transaction["transactionAmount"]==$transactionAmountRefunded){
						$refundStatus = "refunded";
					} else {
						$refundStatus = "partially_refunded";
					}
			
					if (array_sum($lineItemIDs)){
					
						dbg(dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "SetTransaction",
								"subCommand" => "update",
								"params" => array(
									"transactionID" => $transactionID,
									"authReturn" => getAPIStatusID("transactions", $refundStatus),
									"transactionAmountRefunded" => $transactionAmountRefunded,
								),
							),
						)), 1));
						
						if ($markUnpaid){
							dbg(dispatchMBAPI(toXML(array(
								"mbapi" => array(
									"command" => "SetInvoices",
									"subCommand" => "update",
									"params" => array(
										"invoiceID" => $invoiceID,
										"invoiceStatus" => getAPIStatusID("invoice", "due"),
										"invoiceAmountPaid" => $invoiceInfo["invoiceAmount"]-$refundAmount,
									),
								),
							)), 1));
								
							foreach ((array)$lineItemIDs as $liID){
								dbg(dispatchMBAPI(toXML(array(
									"mbapi" => array(
										"command" => "SetTransactionSuccessRel",
										"subCommand" => "delete",
										"params" => array(
											"lineItemID" => $liID,
											"transactionID" => $transactionID,
										),
									),
								)), 1));
							}
						}
					
						$return = dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "ProcessRefundAccounting",
								"params" => array(
									"transactionID" => $transactionID,
									"refundAmount" => $refundAmount,
									"ledgerAccountName" => ($unpaid)?"accounts_receivable":"revenue",
									"invoiceID" => $invoiceID,
								),
							),
						)), 1);
						if (!$return["mabpi"][0]["header"][0]["success"][0]){
							$CONF["debug"]->debugMessage($return);
						}
	
					} else {
				
						$clientID = $invoiceData["lineItems"]["lineItem"][0]["clientID"];
						
						if ($gatewayAction=="void"){
							$tStat = "voided";
						} else {
							$tStat = $refundStatus;
						}
						
						dbg(dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "SetTransaction",
								"subCommand" => "update",
								"params" => array(
									"transactionID" => $transactionID,
									"authReturn" => getAPIStatusID("transactions", $tStat),
									"transactionAmountRefunded" => $transactionAmountRefunded,
								),
							),
						)), 1));
						
						if ($markUnpaid){
							dispatchMBAPI(toXML(array(
								"mbapi" => array(
									"command" => "SetTransactionSuccessRel",
									"subCommand" => "delete",
									"params" => array(
										"transactionID" => $transactionID,
									),
								),
							)));
							$amountPaid = $invoiceInfo["invoiceAmountPaid"]-$transaction["transactionAmount"];
							$status = getAPIStatusID("invoice", "due");
							dispatchMBAPI(toXML(array(
								"mbapi" => array(
									"command" => "SetInvoices",
									"subCommand" => "update",
									"params" => array(
										"invoiceID" => $invoiceID,
										"invoiceStatus" => $status,
										"invoiceAmountPaid" => $amountPaid,
									),
								),
							)));
						}
				
						$merge = array();
						if ($refundAmount!=$transaction["transactionAmount"]){
							$merge = array(
								"refundAmount" => $refundAmount,
								"ledgerAccountName" => "revenue",
								"invoiceID" => $invoiceID,
							);
						}
				
						$return = dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "ProcessRefundAccounting",
								"params" => array(
									"transactionID" => $transactionID,
								) + $merge,
							),
						)), 1);
						if (!$return["mabpi"][0]["header"][0]["success"][0]){
							$CONF["debug"]->debugMessage($return);
						}
	
					}

					//exit();

					
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect("invoices.php?action=".getActionID("ShowInvoices")."&sid=".secureInput($_REQUEST["sid"]));
					}
			
			
				} else {
					$this->addError(TRANS_ACTIONERROR, TRANS_GATEWAY_RETURNED_ERROR . ": " . $refundReturn["statusName"] . ": " . $refundReturn["message"]);
				}
			} else {
				$this->addErrorsFromResult($r);
			}
		


		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditInvoiceResponse
?>
