<?php
// $Id: RemoveInvoice.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a Invoice.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class RemoveInvoice extends MB_Action {
	/**
	 * The constructor for a RemoveInvoice action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveInvoice() {
		parent::MB_Action();
		$this->stringRep = "RemoveInvoice";
		$this->params = array("invoiceID");
	}

	/**
	 * The main method of this class that executes the RemoveInvoice action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No Invoice ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetInvoices", "", array('getInvoiceLineItemsData'=>1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {

                    $this->smartyVars["invoice"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]);

                        if (!$this->smartyVars["invoice"]["lineItems"]["lineItem"][0]["clientID"]){
                            $this->smartyVars["invoice"]["lineItems"]["lineItem"] = array($this->smartyVars["invoice"]["lineItems"]["lineItem"]);
                        }


                    $this->smartyVars["redirectArgsX"] = $_REQUEST["redirectArgs"];
					$this->addTemplate("invoices/RemoveInvoice", $this->smartyVars);

				} else {
					$this->addError(TRANS_ACTIONERROR, "Invoice not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveInvoice
?>