<?php
// $Id: RemoveInvoiceTransactionResponse.php 10540 2007-01-21 20:30:44Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object deletes a transaction and related data.
 *
 * @author  Kris Bailey
 */
class RemoveInvoiceTransactionResponse extends MB_Action {
	/**
	 * The constructor for a RemoveInvoiceTransactionResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.x
	 */

	function RemoveInvoiceTransactionResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveInvoiceTransactionResponse";
		$this->params = array("transactionID");
	}

	/**
	 * The main method of this class that executes the RemoveInvoiceTransactionResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
        $this->smartyVars = array();

		$transactionID = ((int) $_REQUEST["transactionID"]);
		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID || !$transactionID) {
			$this->addError(TRANS_ACTIONERROR, "Invalid invoice or transaction specified.");
		} else {
			
			// delete transaction stuff here.
			$receipts = grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetAccountingReceiptsJournal",
					"params" => array(
						"transactionID" => $transactionID,
					),
				),
			));
			
			dbg("got receipts:");
			dbg($receipts);
			
			foreach ($receipts as $receipt){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetAccountingReceiptsJournal",
						"subCommand" => "delete",
						"params" => array(
							"receiptJournalID" => $receipt["receiptJournalID"],
						),
					),
				)), 1);
				dbg("would have deleted receipt: ".$receipt["receiptJournalID"]);
			}
			
			$lineItemPayments = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetTransactions",
					"params" => array(
						"transactionIDs" => array("transactionID" => $transactionID),
						"getLineItemPayments" => 1,
					),
				),
			)));

			dbg("got line item payments data");
			dbg($lineItemPayments);

			$invoicePayments = array();

			if (count($lineItemPayments["lineItemPayments"])){
				foreach ($lineItemPayments["lineItemPayments"] as $row){
					$invoicePayments[$row["invoiceID"]] += $row["lineItemPaymentAmount"];
				}
			}
			
			dbg("invoices and amounts needed to be taken off of them:");
			dbg($invoicePayments);
			
			if (count($invoicePayments)){
				$invoices = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetInvoices",
						"params" => array(
							"invoiceID" => array_keys($invoicePayments),
						),
					),
				));
				
				foreach ($invoices as $invoice){
					$paid = $invoice["invoiceAmountPaid"]-$invoicePayments[$invoice["invoiceID"]];
					if ($paid<0)$paid = 0;
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetInvoices",
							"subCommand" => "update",
							"params" => array(
								"invoiceID" => $invoice["invoiceID"],
								"invoiceStatus" => getAPIStatusID("invoice", "due"),
								"invoiceAmountPaid" => $paid,
							),
						),
					)), 1);
				}
			
			}
			
			dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetTransaction",
					"subCommand" => "delete",
					"params" => array(
						"transactionID" => $transactionID,
					),
				),
			)), 1);
			
			redirect("invoices.php?sid=".$_REQUEST["sid"]."&action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$invoiceID);
		}	

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveInvoiceTransaction
?>