<?php
// $Id: ShowInvoiceDetails.php 12397 2007-12-27 17:36:12Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-mbapi/include/mail/mail.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["invoiceID"] it displays all
 * the details for the found invoice, and only displays the details of a single invoice.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowInvoiceDetails extends MB_Action {
	/**
	 * The constructor for a ShowInvoiceDetails object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowInvoiceDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowInvoiceDetails";
		$this->params = array("invoiceID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		set_time_limit(0);



		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		$print = $_REQUEST["printDriver"];
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No Invoice ID given.");
		} elseif ($_REQUEST["resend"] == 1) {
			$invoice =& new MBQuery("GetInvoices", "", array("invoiceID" => (int)$invoiceID,'getInvoiceLineItemsData'=>1));
			$invoice = $invoice->getResult();

			$invoice = grabSimpleMBAPIResults( $invoice->getStructure() );

			$invoice = $invoice[0];

			$client =& new MBQuery("GetClients", "", array(
				"clientID" => (int)$invoice["lineItems"][0]["lineItem"][0]["clientID"],
				"mergeDefaultBillingAccount" => 1,
				"getBillingData" => 1,
				"getCompanyData" => 1,
				"getContactData" => 1,
				"getAttributeData" => 1,
				"hooks" => array("hook" => array("hookFunctionName" => "calculateResellerVolumnDiscount"))));
			$client = $client->getResult();

			$client = grabSimpleMBAPIResults( $client->getStructure() );

			$email =& new MBTemplateBasedEmail( 0, getAPITypeID("emailAction", "invoiceEmail") );
			$email->addTemplateVars("client", $client[0]);
			$email->addTemplateVars("invoice", $invoiceID);

			$email->addContactByID( $client[0]["billingAccounts"][0]["billingAccount"][0]["clientContactID"] );
			$email->addToAddress( $client[0]["billingAccounts"][0]["billingAccount"][0]["contactEmail"] );

			$email->addVars("paymentType", $CONF["APItypes"]["billingAccount"][ $client[0]["billingAccounts"][0]["billingAccount"][0]["billingAccountType"] ]);

			$email->sendEmails();

			if (notNull( $this->getReferralActionFile() )) {
				redirect($this->getReferralActionFile(), $this->getReferralActionID(), array("invoiceID" => $invoiceID));
			} else {
				redirect("invoices.php", "ShowInvoiceDetails", array("invoiceID" => $invoiceID));
			}

		} else {

			if (strlen($_REQUEST["query"])){
				$packageIDs = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetMatchingLineItems",
						"params" => array(
							"invoiceID" => (int)$_REQUEST["invoiceID"],
							"query" => secureInput($_REQUEST["query"]),
						),
					),
				));
			} else {
				$packageIDs = false;
			}

			$query = array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => (int)$_REQUEST["invoiceID"],
						"getInvoiceLineItemsData"=>1,
						"getInvoiceLineItemsPaymentsData"=>1,
						"getTaxZonesData"=>1,
						"lineItemOffset"=>(int)$_REQUEST['page']*10
					) + (($packageIDs)?array("packageID" => array_unique($packageIDs)):array()),
				),
			);

			if (strlen($print)){
				unset( $query['mbapi']['params']['lineItemOffset'] );
			}

			$CONF["debug"]->add("Action Command", htmlentities(toXML($query)), __FILE__, __LINE__);
			$data = dispatchMBAPI(toXML($query), 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if (((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0){


					$this->smartyVars = array();
					$this->smartyVars["invoice"] = correctArray($data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]);

					if ((int)$this->smartyVars["invoice"]["creditNoteForInvoiceID"]){
						$this->smartyVars["sourceInvoice"] = grabFirstResultFromMBAPIArray(array(
							"mbapi" => array(
								"command" => "GetInvoices",
								"params" => array(
									"invoiceID" => (int)$this->smartyVars["invoice"]["creditNoteForInvoiceID"],
								),
							),
						));
					} else {
						$this->smartyVars["creditNote"] = grabFirstResultFromMBAPIArray(array(
							"mbapi" => array(
								"command" => "GetInvoices",
								"params" => array(
									"creditNoteForInvoiceID" => (int)$this->smartyVars["invoice"]["invoiceID"],
								),
							),
						));
					}

/*					$usageRecords = arrayFor(":packageUsageLogs", array(
						"groupbyInvoiceID" => (int)$this->smartyVars["invoice"]["invoiceID"],
						"numRecords" => 6000
					));
					show($usageRecords);
					die("asdf");
					$this->smartyVars["usageByLineItem"] = array();
					foreach ($usageRecords as $k=>$r){
						$this->smartyVars["usageByLineItem"][$r["lineItemID"]] =& $usageRecords[$k];
					}*/

					$this->smartyVars["totalTax"] = $this->smartyVars["invoice"]["totalTax"];

					$this->smartyVars["totalPages"] = $pages = ceil($this->smartyVars["invoice"]["totalLineItems"]/10);
					$this->smartyVars["page"] = (int)$_REQUEST["page"];
					$this->smartyVars["invoicePageLinks"] = array();
					if ($pages>1){
						for ($i=0; $i<$pages; $i++){
							$this->smartyVars["invoicePageLinks"][$i] = $i;
						}
					}


					$this->smartyVars["taxZones"] = array();
					$this->smartyVars["addonIDs"] = array();
					$this->smartyVars["addonTotals"] = array();
					$this->smartyVars["lineItemIDs"] = array();
					$lastMainLineItem = 0;
					$packageIDsForDomainGetting = array();
					foreach ($this->smartyVars["invoice"]["lineItems"] as $k=>$v){
						$this->smartyVars["lineItemIDs"][] = $v["lineItemID"];
						$packageIDsForDomainGetting[] = $v["packageID"];
						if ($v["packageAddonID"]){
							$this->smartyVars["addonIDs"][] = $v["packageAddonID"];
						} else {
							$lastMainLineItem = $v["lineItemID"];
						}
						$this->smartyVars["addonTotals"]["total"][$lastMainLineItem] += $v["lineItemTotalAmount"];
						$this->smartyVars["addonTotals"]["setup"][$lastMainLineItem] += $v["lineItemSetupAmount"];
						$this->smartyVars["addonTotals"]["tax"][$lastMainLineItem] += $v["lineItemTaxAmount"];

						$this->smartyVars["invoice"]["lineItems"][$k]["packageComments"] = utf8_html_entity_decode($this->smartyVars["invoice"]["lineItems"][$k]["packageComments"]);
						$this->smartyVars["invoice"]["lineItems"][$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
						$taxZones = (array)$this->smartyVars["invoice"]["lineItems"][$k]["taxZones"];
						dbg("tax zones: ");
						dbg($taxZones);
						$this->smartyVars["invoice"]["lineItems"][$k]["taxZones"] = $taxZones;
						foreach ($taxZones as $zone){
							if (!$this->smartyVars["taxZones"][$zone["taxZoneID"]]){
								$this->smartyVars["taxZones"][$zone["taxZoneID"]] = $zone;
							}
							$this->smartyVars["taxZones"][$zone["taxZoneID"]]["taxTotal"] += $zone["lineItemTaxTotal"];
						}
					}

					$this->smartyVars["taxZones"] = array_values($this->smartyVars["taxZones"]);

					$clientID = (int)$this->smartyVars["invoice"]["clientID"];
					$clientContactID = (int)$this->smartyVars["invoice"]["clientContactID"];
					$this->smartyVars["clientID"] = $clientID;

					if ((int)$clientID){
						$clientInfoCmd = "
							<mbapi>
								<command>GetClients</command>
								<showXMLHeader>0</showXMLHeader>
								<params>
									<mergePrimaryContact>1</mergePrimaryContact>
									<clientID>$clientID</clientID>
									<mergeDefaultBillingAccount>1</mergeDefaultBillingAccount>
									<getContactData>3</getContactData>
									<getBillingData>1</getBillingData>
									<getCompanyData>1</getCompanyData>
									<getAccountingData>1</getAccountingData>
								</params>
							</mbapi>";
	
						$clientData = dispatchMBAPI($clientInfoCmd, 1);
						$CONF["debug"]->add("Action Result", $clientData, __FILE__, __LINE__);
						$clientData = $clientData["mbapi"][0]["results"][0]["clients"][0]["client"][0];
						$contactData = $clientData["contacts"][0]["contact"][0];
						$companyData = $clientData;
					}

					if ((int)$clientContactID){
						$contactData = oneByID("contacts", $clientContactID);
					}

					$countryData = oneByID("countries", $contactData["countriesID"]);
					$contactData["countriesISO2"] = $countryData["countriesISO2"];

					$dpids = array_values(array_unique($packageIDsForDomainGetting));

					if (count($dpids)){
						$domainPackages = correctArray(grabResultsFromMBAPIArray($xx = array(
							"mbapi" => array(
								"command" => "GetPackages",
								"params" => array(
									"packageID" => $dpids,
									"getDomainData" => 1,
								),
							),
						)));
	
						$this->smartyVars["domains"] = array();
						foreach ((array)$domainPackages as $dpkg){
							$this->smartyVars["domains"][$dpkg["packageID"]] = $dpkg["domains"];
						}
					}

					$this->smartyVars["billingAccounts"] = (array)correctArray($clientData["billingAccounts"][0]["billingAccount"]);

					$this->smartyVars["billingAccountOptions"] = array();
					foreach ($this->smartyVars["billingAccounts"] as $row){
						if ($row["billingCardType"]==3){
							$thisID = $row["billingAccountID"];
							if (defined($CONF["types"]["billingAccount"][$row["billingAccountType"]])) {
								$thisDesc = constant($CONF["types"]["billingAccount"][$row["billingAccountType"]]);
							} else {
								$thisDesc = $CONF["types"]["billingAccount"][$row["billingAccountType"]];
							}
							$thisDesc .= " - ".$row["contactFirstName"]." ".$row["contactLastName"];
							$this->smartyVars["billingAccountOptions"][$thisID] = $thisDesc;
						}
					}

					$this->smartyVars["clientData"] = correctArray($clientData);
					$this->smartyVars["clientData"]["billingCardNum"] = "";
					$tmp = correctArray($clientData["accountingGeneralLedgers"][0]["accountingGeneralLedger"]);
					if ($tmp["currencyID"]){
						$tmp = array($tmp);
					}
					$this->smartyVars["clientCredits"] = $this->getAccountingCurrencyTotals($tmp, "customer_credits");
					ksort($this->smartyVars["clientCredits"]);
					$this->smartyVars["contactData"] = correctArray($contactData);
					$this->smartyVars["companyData"] = correctArray($companyData);

					$this->smartyVars["transactions"] = correctArray(grabResultsFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetTransactions",
							"params" => array(
								"getGatewayNames" => 1,
								"invoiceIDs" => array(
									"invoiceID" => $invoiceID,
								),
							),
						),
					)));
					dbg($this->smartyVars["transactions"]);

					$refundStatusList = array(
						getAPIStatusID("transactions", "successful"),
						getAPIStatusID("transactions", "captured"),
						getAPIStatusID("transactions", "partially_refunded"),
					);

					$getGatewayCapsStatusList = array_merge($refundStatusList, array(
						getAPIStatusID("transactions", "authorized")
					));

					$this->smartyVars["transactionStatuses"] = getStatuses("transactions");
					foreach ((array)$this->smartyVars["transactions"] as $k => $v){
						if ($v["gatewayClassName"]!=""){
							if (in_array($v["authReturn"], $getGatewayCapsStatusList)){
								if (file_exists(mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php"))) {
									require_once mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php");
								}
								$caps = call_user_func(array($v["gatewayClassName"], "getModuleInfo"));
								if (in_array($v["authReturn"], $refundStatusList) &&
									in_array(GATEWAY_REFUND, $caps["capabilities"])
									){
										$this->smartyVars["transactions"][$k]["canRefund"] = 1;
										$this->smartyVars["transactionActions"][$v["transactionID"]]["canRefund"] = 1;
								}
								if ($v["authReturn"]==getAPIStatusID("transactions", "authorized") &&
									in_array(GATEWAY_PRIOR_AUTH_CHARGE, $caps["capabilities"])
									){
										$this->smartyVars["transactions"][$k]["canFinalize"] = 1;
										$this->smartyVars["transactionActions"][$v["transactionID"]]["canFinalize"] = 1;
								}
								if (in_array($v["authReturn"], $refundStatusList) &&
									in_array(GATEWAY_PARTIAL_REFUND, $caps["capabilities"])
									){
										$this->smartyVars["transactions"][$k]["canPartialRefund"] = 1;
										$this->smartyVars["transactionActions"][$v["transactionID"]]["canPartialRefund"] = 1;
								}
							}
						}
					}

					$successRel = correctArray(grabResultsFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetTransactionSuccessRel",
							"params" => array(
								"lineItemID" => $this->smartyVars["lineItemIDs"],
							),
						),
					)));
					dbg($successRel);
					$this->smartyVars["lineItemsPartialRefund"] = array();
					foreach ((array)$successRel as $relrow){
						if ($this->smartyVars["transactionActions"][$relrow["transactionID"]]["canPartialRefund"]){
							$this->smartyVars["lineItemsPartialRefund"][$relrow["lineItemID"]][$relrow["transactionID"]] = 1;
						}
					}



					$this->smartyVars["paymentMethods"] = getTypes("payments");
					$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
					$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
					$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
					$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
					$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;

					// set up for using the date selector widget

					$this->formDefaults["transactionDateCreated"] = time();
					$this->setupDateSelector("transactionDateCreated");
					$this->mergeFormState();

					$this->smartyVars["invoiceStatuses"] = getStatuses("invoice");

					// just one last thing, find out exactly how much is due.
					$this->smartyVars["invoice"]["invoiceAmountDue"] = $this->smartyVars["invoice"]["invoiceAmount"] - $this->smartyVars["invoice"]["invoiceAmountPaid"];
					$this->smartyVars["invoice"]["invoiceComments"] = utf8_html_entity_decode($this->smartyVars["invoice"]["invoiceComments"]);

					if (strlen($print)) {
						require_once mb_path("/lib-tk/include/printEngine/printEngine.php");

						$printObj = new PrintEngine($print);
						$printObj->setFilename("invoices.pdf");

						$printObj->addPage();
						$normalFont = new FontStyle('Arial', 12, '', 'cd3f00');

						// do the addresses
						$x = $printObj->getLeftMargin();
						$y = $printObj->getTopMargin();

						$printObj->addRect( $x, 10, 200, 100, new MBStyle( '', 'CBEACA', 'DF', 'B3D5B1' ) );


						$printObj->addText( $x+3, $y+10, TRANS_TO.':', new FontStyle('Arial', 13, 'B'));

						$x += 27;
						$y += 10;
						$printObj->addText( $x,$y, 
							($this->smartyVars["clientData"]["clientCompany"] && $this->smartyVars["invoice"]["clientContactID"]==0) ?
							$this->smartyVars["clientData"]["clientCompany"] : 
							$this->smartyVars["contactData"]["contactFirstName"].' '.$this->smartyVars["contactData"]["contactLastName"],
							$normalFont
						);
						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["contactData"]["contactAddress1"], $normalFont);

						if (notNull( $this->smartyVars["contactData"]["contactAddress2"] ))
							$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["contactData"]["contactAddress2"], $normalFont);


						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["contactData"]["contactCity"].', '.strtoupper($this->smartyVars["contactData"]["contactState"]).' '.$this->smartyVars["contactData"]["contactZip"], $normalFont);
						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["contactData"]["contactPhone1"], $normalFont);

						if (notNull( $this->smartyVars["contactData"]["contactPhone2"] ))
							$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["contactData"]["contactPhone2"], $normalFont);

						if (notNull( $this->smartyVars["clientData"]["taxIDNumber"] ))
							$printObj->addText( $x,$y+=$normalFont->getSize(), TRANS_TAX_ID.": ".$this->smartyVars["clientData"]["taxIDNumber"], $normalFont);

						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["contactData"]["countriesISO2"], $normalFont);




						$x = $printObj->getLeftMargin()+300;
						$y = 40;

						// from side of things
						$printObj->addRect( $x-20, 10, 200, 100, new MBStyle( '', 'CCD2E5', 'DF', 'B1BAD5' ) );

						$printObj->addText( $x-15, 25, TRANS_FROM.':', new FontStyle('Arial', 13, 'B') );
						$printObj->addText( $x,$y, $this->smartyVars["companyData"]["companyName"], $normalFont );
						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["companyData"]["companyAddress1"], $normalFont );

						if (notNull( $this->smartyVars["companyData"]["companyAddress2"] ))
							$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["companyData"]["companyAddress2"], $normalFont );


						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["companyData"]["companyCity"].', '.strtoupper($this->smartyVars["companyData"]["companyState"]).' '.$this->smartyVars["companyData"]["companyZip"], $normalFont);
						$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["companyData"]["companyPhone1"], $normalFont);

						if (notNull( $this->smartyVars["companyData"]["companyPhone2"] ))
							$printObj->addText( $x,$y+=$normalFont->getSize(), $this->smartyVars["companyData"]["companyPhone2"], $normalFont);



						// now we begin the nitty gritty side
						$printObj->addLine($printObj->getLeftMargin(),120,$printObj->getLeftMargin()+$printObj->getUsableWidth(), 120, 4);










						$x = $printObj->getLeftMargin();
						$table = new GenericTable( $printObj->getUsableWidth() );

						$table->setHeader( '#', TRANS_ENTERED, TRANS_DUE, TRANS_STATUS, TRANS_SUB_TOTAL, TRANS_TAX_TOTAL, TRANS_INVOICE_TOTAL, TRANS_AMOUNT_PAID, TRANS_AMOUNT_DUE );

						$data = array(
							$this->smartyVars['invoice']['invoiceID'],
							$CONF["user"]["locale"]->getLocaleDate( $this->smartyVars['invoice']['invoiceDateEntered'], 'short' ),
							$CONF["user"]["locale"]->getLocaleDate( $this->smartyVars['invoice']['invoiceDateDue'], 'short' ),
							getStatusName("invoice", $this->smartyVars['invoice']["invoiceStatus"]),
							$CONF["user"]["locale"]->getLocaleCurrency( $this->smartyVars['invoice']['invoiceSubTotal'], $this->smartyVars['invoice']['currencyID'] ),
							$CONF["user"]["locale"]->getLocaleCurrency( $this->smartyVars['invoice']['totalTax'], $this->smartyVars['invoice']['currencyID'] ),
							$CONF["user"]["locale"]->getLocaleCurrency( $this->smartyVars['invoice']['invoiceAmount'], $this->smartyVars['invoice']['currencyID'] ),
							$CONF["user"]["locale"]->getLocaleCurrency( $this->smartyVars['invoice']['invoiceAmountPaid'], $this->smartyVars['invoice']['currencyID'] ),
							$CONF["user"]["locale"]->getLocaleCurrency( $this->smartyVars['invoice']['invoiceAmountDue'], $this->smartyVars['invoice']['currencyID'] ));

						$priceDisp = new FontStyle( 'Arial', 10, null, null, 'right' );
						$normalDisp = new FontStyle( '', 10 );
						$table->insertRow( 0, $data, array(1=>$normalFont,2=>$normalFont,3=>$normalFont,4=>$priceDisp,5=>$priceDisp,6=>$priceDisp,7=>$priceDisp,8=>$priceDisp) );

						unset( $priceDisp, $data, $normalDisp, $normalFont );

						$printObj->addTable( $x, 140, $table );








						// lineItems table
						$table = new GenericTable( $printObj->getUsableWidth() );

						$table->setHeader( '#', TRANS_DESCRIPTION, TRANS_BEGIN, TRANS_CURRENT, TRANS_NEXT,
									TRANS_QUANTITY_ABBR, TRANS_PRICE, TRANS_DISCOUNT, TRANS_SETUP,
									TRANS_SUB_TOTAL, TRANS_TAX, TRANS_TOTALS );


						$columnMap = array('packageID', 'lineItemDescription', 'lineItemDateBeginRenewal', 'lineItemDateCurrentRenewal',
								'lineItemDateNextRenewal', 'lineItemQuantity', 'lineItemPriceAmount', 'lineItemDiscount',
								'lineItemSetupAmount', 'lineItemSubTotalAmount', 'lineItemTaxAmount', 'lineItemTotalAmount');


						$data = $this->smartyVars['invoice']['lineItems'];
						for( $i=0, $n=count( $data ); $i<$n; $i++ ) {
							if (!isset( $data[ $i ]['lineItemSubTotalAmount'] ))
								$data[ $i ]['lineItemSubTotalAmount'] = (float)($data[ $i ]['lineItemPriceAmount'] - $data[ $i ]['lineItemDiscount']);


							$tmpRow = array();
							$styleMap = array();
							foreach( $columnMap as $col ) {

								if (ereg( 'Date', $col ) && notZero( $data[ $i ][ $col ] )) {
									$tmpRow[ $col ] = $CONF["user"]["locale"]->getLocaleDate( (int)$data[ $i ][ $col ], 'short' );
								} elseif (ereg( 'Amount|Discount', $col )) {
									$tmpRow[ $col ] = $CONF["user"]["locale"]->getLocaleCurrency( $data[ $i ][ $col ], $this->smartyVars['invoice']['currencyID'] );
								} elseif (ereg( 'Description', $col )) {
									if (strlen( $data[ $i ][ $col ] ) > 20) {
										$tmpRow[ $col ] = substr( $data[ $i ][ $col ], 0, 17 ).'...';
									} else {
										$tmpRow[ $col ] = $data[ $i ][ $col ];
									}
								} else {
									$tmpRow[ $col ] = $data[ $i ][ $col ];
								}


								$styleMap[ $col ] = new FontStyle('',10);
								$styleMap[ $col ]->setFillMethod( 'f' );
								if ( ($i%2) == 0) {
									$styleMap[ $col ]->setFillColor( 'E9EAAD' );
								} else {
									$styleMap[ $col ]->setFillColor( 'B4C0D4' );
								}

								if (ereg( 'Amount|Discount', $col ) !== false) {
									$styleMap[ $col ]->setAlignment( 'right' );
								}
							}
							$table->insertRow( $i, $tmpRow, $styleMap );
						}	unset( $i, $tmpRow, $styleMap, $col, $data );
						$y = $printObj->addTable( $x, 200, $table );





						// another table! Tax info
						if ($this->smartyVars['taxZones'][0]['taxZoneID']) {
							$x = $printObj->getLeftMargin();
							$y += 50;

							$printObj->addText( $x, $y, TRANS_TAX_ZONES, new FontStyle( 'black', 14, 'b' ) );


							$table = new GenericTable( $printObj->getUsableWidth() );
							$table->setHeader( '#', TRANS_TAX_ZONE_NAME, TRANS_TAX_ZONE_DESCRIPTION, TRANS_TAX_ZONE_TYPE, TRANS_TAX_ZONE_RATE, TRANS_TAX_ZONE_TOTAL );


							for( $i=0, $n=count( $this->smartyVars['taxZones'] ); $i<$n; $i++ ) {
								$v =& $this->smartyVars['taxZones'][ $i ];

								$tmpRow = array(
									'taxZoneID' => $v['taxZoneID'],
									'taxZoneName' => $v['taxZoneName'],
									'taxZoneDescription' => $v['taxZoneDescription'],
									'zoneType' => ( ($v['lineItemTaxAmountType']==0) ? TRANS_PERCENTAGE : TRANS_SET_AMOUNT ),
									'zoneRate' => ( ($v['lineItemTaxAmountType']==0) ? $v['lineItemTaxAmount'].'%' : $CONF['user']['locale']->getLocaleCurrency( $v['lineItemTaxAmount'], $this->smartyVars['invoice']['currencyID']) ),
									'taxTotal' => $CONF['user']['locale']->getLocaleCurrency( $v['taxTotal'], $this->smartyVars['invoice']['currencyID'] ));

								$style = new FontStyle( '', 10 );
								$style->setFillMethod( 'f' );

								if ( !($i%2) )
									$style->setFillColor('E9EAAD');
								else
									$style->setFillColor('B4C0D4');

								$table->insertRow( $i, $tmpRow, $style );

							}	unset( $n, $v, $tmpRow, $style, $i );



							$y = $printObj->addTable( $x, $y, $table );
						}





						// another table! Transactions
						if ($this->smartyVars['transactions']) {
							$y += 50;
							$x = $printObj->getLeftMargin();
							$printObj->addText( $x,$y, TRANS_TRANSACTIONS, new FontStyle( 'black', 14, 'b' ));

							$table = new GenericTable( $printObj->getUsableWidth() );
							$table->setHeader( '#', TRANS_TRANSACTION_PAYMENT_METHOD, TRANS_TRANSACTION_STATUS,
									TRANS_TRANSACTION_CODE, TRANS_TRANSACTION_NOTES, TRANS_TRANSACTION_DATE,
									TRANS_TRANSACTION_GATEWAY, TRANS_TRANSACTION_AMOUNT);

							for( $i=0, $n=count( $this->smartyVars['transactions'] ); $i<$n; $i++ ) {
								$v =& $this->smartyVars['transactions'][ $i ];

								$tmpRow = array(
									'transactionID' => $v['transactionID'],
									'transactionMethod' => ( defined($this->smartyVars['paymentMethods'][ $v['transactionPaymentMethod'] ]) ? constant($this->smartyVars['paymentMethods'][ $v['transactionPaymentMethod'] ]) : $this->smartyVars['paymentMethods'][ $v['transactionPaymentMethod'] ] ),
									'transactionStatus' => ( defined($this->smartyVars['transactionStatuses'][ $v['authReturn'] ]) ? constant($this->smartyVars['transactionStatuses'][ $v['authReturn'] ]) : $this->smartyVars['transactionStatuses'][ $v['authReturn'] ] ),
									'transactionCode' => $v['transactionCode'],
									'transactionNotes' => $v['transactionNotes'],
									'transactionDateCreated' => $CONF['user']['locale']->getLocaleDate( $v['transactionDateCreated'], 'short' ),
									'configGroupTransKey' => ( defined($v['configGroupTransKey']) ? constant($v['configGroupTransKey']) : $v['configGroupTransKey'] ),
									'transactionAmount' => $CONF['user']['locale']->getLocaleCurrency( $v['transactionAmount'], $v['currencyID'] ));

								$style = new FontStyle('',10);
								$style->setFillMethod( 'f' );


								if ( !($i%2) )
									$style->setFillColor('E9EAAD');
								else
									$style->setFillColor('B4C0D4');
								$table->insertRow( $i, $tmpRow, $style );
							}	unset( $i, $n, $v, $tmpRow, $style );

							$y = $printObj->addTable( $x, $y+20, $table );
						}



						if ($printObj->getErrorCount()) {
							foreach( (array)$printObj->getErrors() as $v ) {
								$this->addError( $v[0], $v[1] );
							}	unset( $v );
							$this->addErrorTemplates();return -1;
						}
// show($printObj);exit;
						if (!headers_sent()){
							$printObj->output();
						} else {
							echo 'done.';
						}
					} elseif ((int)$_REQUEST["__print"]){
						$this->addTemplate("invoices/ShowInvoiceDetails.print", $this->smartyVars);
					} else {
						$this->mergeAvailablePrintDrivers();
						$this->addTemplate("invoices/ShowInvoiceDetails", $this->smartyVars);
					}

				} else {
					$this->addError(TRANS_ACTIONERROR, "Invoice does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowInvoiceDetails
?>
