<?php
// $Id: ShowInvoices.php 11340 2007-06-13 15:38:35Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * @author  Kris Bailey
 */
class ShowInvoices extends MB_Action {
	/**
	 */
	function ShowInvoices() {
		parent::MB_Action();
		$this->stringRep = "ShowInvoices";
		
		$this->params = array
		(
			"invoiceID",
			"clientID",
			"clientCompany",
			"contactFirstName",
			"contactLastName",

            "invoiceNumber",

			// invoiceAmount options
			"invoiceAmount",
			"invoiceAmountLessThan",
			"invoiceAmountGreaterThan",

			// invoiceDateEntered options
			"invoiceDateEntered",
			"invoiceDateEnteredLessThan",
			"invoiceDateEnteredGreaterThan",

			// invoiceDateDue options
			"invoiceDateDue",
			"invoiceDateDueLessThan",
			"invoiceDateDueGreaterThan",

		);

        // handle date searches and correct mismatch of amount labels
        $this->setupDateRequestArgs();

        // handle amount searches and correct mismatch of amount labels
        if ($_REQUEST["amountColumn"]!="") {
            for ($i = 0; $i < count($_REQUEST["amountCompare"]); $i++){
                if ($_REQUEST["amountCompare"][$i]!="Greatest" && $_REQUEST["amountCompare"][$i]!="Least" && $_REQUEST["amountCompare"][$i]!="LessThan" && $_REQUEST["amountCompare"][$i]!="GreaterThan"){
                    $_REQUEST[$_REQUEST["amountColumn"]] = (double) $_REQUEST["amountQuery"][$i];
                } else {
                    $_REQUEST["amountCompare"][$i] = (eregi("Than", $_REQUEST["amountCompare"][$i])) ?
                        $_REQUEST["amountCompare"][$i] :
                        ($_REQUEST["amountCompare"][$i]=="Greatest")?"LessThan":"GreaterThan";
                    $_REQUEST[$_REQUEST["amountColumn"].$_REQUEST["amountCompare"][$i]] = (double) $_REQUEST["amountQuery"][$i];
                }
            }
        }

        // search in a specific column
        if ($_REQUEST["queryColumn"]!="") {
            $isDate = (ereg("Date",$_REQUEST["queryColumn"])) ? true : false ;
            if ($_REQUEST["queryGreatest"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]."Greatest"] = $_REQUEST["queryGreatest"];
                if ($isDate) {
                    list($m,$d,$y) = explode("/",$_REQUEST["queryGreatest"]);
                    $_REQUEST[$_REQUEST["queryColumn"]."Greatest"] = mktime(23,59,59,$m,$d,$y);
                }
            }
            if ($_REQUEST["queryLeast"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]."Least"] = $_REQUEST["queryLeast"];
                if ($isDate) {
                    list($m,$d,$y) = explode("/",$_REQUEST["queryLeast"]);
                    $_REQUEST[$_REQUEST["queryColumn"]."Least"] = mktime(0,0,0,$m,$d,$y);
                }
            }
            if ($_REQUEST["query"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
                if ($isDate) {
                    list($m,$d,$y) = explode("/",$_REQUEST["query"]);
                    $_REQUEST[$_REQUEST["queryColumn"]] = null;
                    $_REQUEST[$_REQUEST["queryColumn"]."Least"] = mktime(0,0,0,$m,$d,$y);
                    $_REQUEST[$_REQUEST["queryColumn"]."Greatest"] = mktime(23,59,59,$m,$d,$y);
                }
            }
        } else if ($_REQUEST["query"]!="") {
            $_REQUEST["invoiceNumber"] = $_REQUEST["query"];
            $_REQUEST["invoiceComments"] = $_REQUEST["query"];
        }

		if (isset($_REQUEST["clientID"]) && !is_numeric($_REQUEST["clientID"])){
			$_REQUEST["clientCompany"] = $_REQUEST["clientID"];
			$_REQUEST["contactFirstName"] = $_REQUEST["clientID"];
			$_REQUEST["contactLastName"] = $_REQUEST["clientID"];
			unset($_REQUEST["clientID"]);
		}

		// add filtered columns to $this->params LAST, they are NOT searchable
		if (is_numeric($_REQUEST["invoiceStatus"])) {
			$this->params[] = "invoiceStatus";
		}

		$this->sortColumns = array
		(
			"invoiceID",
			"invoiceAmount",
			"invoiceDateEntered",
			"invoiceDateDue",
			"invoiceStatus",
			"clientLastName"
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

		$xmlParams = array
		(
			"getInvoiceLineItemsData" => 0, // DO NOT ENABLE IF YOU HAVE A LOT OF LINE ITEMS PER INVOICE!
			"mergeContactData" => 1,
		);
		$query = $this->getMBAPIQuery("GetInvoices", "",  $xmlParams, 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

			// set the sorting args for display
			$this->smartyVars["displaySortColumnName"] = $data["mbapi"][0]["header"][0]["sortColumnName"][0];
			$this->smartyVars["displaySortColumn"] = $data["mbapi"][0]["header"][0]["sortColumn"][0];
			$this->smartyVars["displaySortDir"] = $data["mbapi"][0]["header"][0]["sortDir"][0];

			// set master invoices data array
			$this->smartyVars["invoices"] = collapseArrayElements(
                                                protectArray($results["invoices"][0]["invoice"])
                                            );

			#if($this->smartyVars["invoices"]) {
				#for ($i = 0; $i < count($this->smartyVars["invoices"]); $i++){
					#if (!$this->smartyVars["invoices"][$i]["lineItems"]["lineItem"][0]["clientID"]){
					#	$this->smartyVars["invoices"][$i]["lineItems"]["lineItem"] = array($this->smartyVars["invoices"][$i]["lineItems"]["lineItem"]);
					#}
				#}
			#}

			// set master invoices line item data array
			#$lineItems = array();
			$otherContacts = array();
			if (is_array($this->smartyVars["invoices"])){
				foreach ((array)$this->smartyVars["invoices"] as $i => $row) {
	
					// calculate how much is due
					$this->smartyVars["invoices"][$i]["invoiceAmountDue"] = $row["invoiceAmount"] - $row["invoiceAmountPaid"];
					
					if ((int)$row["invoiceClientContactID"]){
						$otherContacts[] = (int)$row["invoiceClientContactID"];
					}
					
					// leave this uncollapsed so that the template code can work with both singular and plural results;
					// see the comment in the template for details
					#$lineItemsData =& $results["invoices"][0]["invoice"][$i]["lineItems"][0]["lineItem"];
					#$lineItems[$results["invoices"][0]["invoice"][$i]["invoiceID"][0]] = collapseArrayElements(protectArray($lineItemsData));
				}
				$otherContacts = arrayFor("contacts", array(
					"clientContactID" => $otherContacts,
				));
				$this->smartyVars["otherContacts"] = array();
				foreach ($otherContacts as $c){
					$this->smartyVars["otherContacts"][$c["clientContactID"]] = $c;
				}
				#$this->smartyVars["lineItems"] = $lineItems;
			} else {
				$this->smartyVars["invoice"] = array();
			}
			// set pagination links data
			$this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);

			// assign filtered columns
			if (is_numeric($_REQUEST["invoiceStatus"])) {
				$this->smartyVars["invoiceStatus"] = ((int) $_REQUEST["invoiceStatus"]);
			}

			// assign sortable columns for advanced options
			$this->smartyVars["sortColumns"] = array
			(
				"invoiceNumber" => TRANS_INVOICE_NUMBER,
				"invoiceAmount" => TRANS_INVOICE_AMOUNT,
				"invoiceDateEntered" => TRANS_DATE_ENTERED,
				"invoiceDateDue" => TRANS_DATE_DUE,
			);

			if ((int)$_REQUEST["clientID"])$this->smartyVars["clientID"] = $_REQUEST["clientID"];

			// call the display template
			$this->mergePrimaryContactData();
			$this->mergeAvailablePrintDrivers();
			$this->addTemplate("invoices/ShowInvoices", $this->smartyVars);
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowInvoices
?>
