<?php
// $Id: ShowResendInvoice.php 11413 2007-06-21 20:16:33Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-mbapi/include/mail/mail.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
include_once mb_path("/".APP_CURRENT."/include/lib-action/invoices/ShowResendInvoiceResponse.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["invoiceID"] it displays all
 * the details for the found invoice, and only displays the details of a single invoice.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowResendInvoice extends ShowResendInvoiceResponse {
	/**
	 * The constructor for a ShowResendInvoice object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowResendInvoice() {
		parent::MB_Action();
		$this->stringRep = "ShowResendInvoice";
		$this->params = array("invoiceID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		MB_Action::execute();
		set_time_limit(0);

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		$print = ((int) $_REQUEST["print"]);
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No Invoice ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetInvoices", "", array('getInvoiceLineItemsData'=>1, 'getInvoiceLineItemsPaymentsData'=>1, 'getTaxZonesData'=>1, 'lineItemOffset'=>(int)$_REQUEST['page']*10));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if (((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0){

					$this->smartyVars = array();
					$this->smartyVars["invoice"] = correctArray($data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]);

					if ((int)$this->smartyVars["invoice"]["creditNoteForInvoiceID"]){
						$this->smartyVars["sourceInvoice"] = grabFirstResultFromMBAPIArray(array(
							"mbapi" => array(
								"command" => "GetInvoices",
								"params" => array(
									"invoiceID" => (int)$this->smartyVars["invoice"]["creditNoteForInvoiceID"],
								),
							),
						));
					} else {
						$this->smartyVars["creditNote"] = grabFirstResultFromMBAPIArray(array(
							"mbapi" => array(
								"command" => "GetInvoices",
								"params" => array(
									"creditNoteForInvoiceID" => (int)$this->smartyVars["invoice"]["invoiceID"],
								),
							),
						));
					}

					$this->smartyVars["totalTax"] = $this->smartyVars["invoice"]["totalTax"];

					$this->smartyVars["totalPages"] = $pages = ceil($this->smartyVars["invoice"]["totalLineItems"]/10);
					$this->smartyVars["page"] = (int)$_REQUEST["page"];
					$this->smartyVars["invoicePageLinks"] = array();
					if ($pages>1){
						for ($i=0; $i<$pages; $i++){
							$this->smartyVars["invoicePageLinks"][$i] = $i;
						}
					}


					$this->smartyVars["taxZones"] = array();
					$this->smartyVars["addonIDs"] = array();
					$this->smartyVars["addonTotals"] = array();
					$lastMainLineItem = 0;
					foreach ($this->smartyVars["invoice"]["lineItems"] as $k=>$v){
						if ($v["packageAddonID"]){
							$this->smartyVars["addonIDs"][] = $v["packageAddonID"];
						} else {
							$lastMainLineItem = $v["lineItemID"];
						}
						$this->smartyVars["addonTotals"]["total"][$lastMainLineItem] += $v["lineItemTotalAmount"];
						$this->smartyVars["addonTotals"]["setup"][$lastMainLineItem] += $v["lineItemSetupAmount"];
						$this->smartyVars["addonTotals"]["tax"][$lastMainLineItem] += $v["lineItemTaxAmount"];
						
						$this->smartyVars["invoice"]["lineItems"][$k]["packageComments"] = utf8_html_entity_decode($this->smartyVars["invoice"]["lineItems"][$k]["packageComments"]);
						$this->smartyVars["invoice"]["lineItems"][$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
						$taxZones = (array)$this->smartyVars["invoice"]["lineItems"][$k]["taxZones"];
						dbg("tax zones: ");
						dbg($taxZones);
						$this->smartyVars["invoice"]["lineItems"][$k]["taxZones"] = $taxZones;
						foreach ($taxZones as $zone){
							if (!$this->smartyVars["taxZones"][$zone["taxZoneID"]]){
								$this->smartyVars["taxZones"][$zone["taxZoneID"]] = $zone;
							}
							$this->smartyVars["taxZones"][$zone["taxZoneID"]]["taxTotal"] += $zone["lineItemTaxTotal"];
						}
					}

					$this->smartyVars["taxZones"] = array_values($this->smartyVars["taxZones"]);

					$clientID = $this->smartyVars["invoice"]["lineItems"][0]["clientID"];
					$this->smartyVars["clientID"] = $clientID;

					$clientInfoCmd = "
						<mbapi>
							<command>GetClients</command>
							<showXMLHeader>0</showXMLHeader>
							<params>
								<mergePrimaryContact>1</mergePrimaryContact>
								<clientID>$clientID</clientID>
								<getContactData>3</getContactData>
								<getBillingData>1</getBillingData>
								<getCompanyData>1</getCompanyData>
								<getAccountingData>1</getAccountingData>
								<sortDir></sortDir>
								<sortColumn></sortColumn>
								<recordOffset>0</recordOffset>
								<numRecords>1</numRecords>
							</params>
						</mbapi>";

					$clientData = dispatchMBAPI($clientInfoCmd, 1);
					$CONF["debug"]->add("Action Result", $clientData, __FILE__, __LINE__);
					$clientData = $clientData["mbapi"][0]["results"][0]["clients"][0]["client"][0];
					$contactData = $clientData["contacts"][0]["contact"][0];
					$companyData = $clientData;


					$domains = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "GetDomains",
							"params" => array(
								"clientID" => $this->smartyVars["clientID"]
							)
						)
					)), 1));
					
					$this->smartyVars["domains"] = array();
					foreach ((array)$domains as $domain){
						$this->smartyVars["domains"][$domain["packageID"]] = $domain;
					}


					$this->smartyVars["billingAccounts"] = (array)correctArray($clientData["billingAccounts"][0]["billingAccount"]);

					$this->smartyVars["billingAccountOptions"] = array();
					foreach ($this->smartyVars["billingAccounts"] as $row){
						if ($row["billingCardType"]==3){
							$thisID = $row["billingAccountID"];
							if (defined($CONF["types"]["billingAccount"][$row["billingAccountType"]])) {
								$thisDesc = constant($CONF["types"]["billingAccount"][$row["billingAccountType"]]);
							} else {
								$thisDesc = $CONF["types"]["billingAccount"][$row["billingAccountType"]];
							}
							$thisDesc .= " - ".$row["contactFirstName"]." ".$row["contactLastName"];
							$this->smartyVars["billingAccountOptions"][$thisID] = $thisDesc;
						}
					}

					$this->smartyVars["clientData"] = correctArray($clientData);
					$tmp = correctArray($clientData["accountingGeneralLedgers"][0]["accountingGeneralLedger"]);
					if ($tmp["currencyID"]){
						$tmp = array($tmp);
					}
					$this->smartyVars["clientCredits"] = $this->getAccountingCurrencyTotals($tmp, "customer_credits");
					ksort($this->smartyVars["clientCredits"]);
					$this->smartyVars["contactData"] = correctArray($contactData);
					$this->smartyVars["companyData"] = correctArray($companyData);


					$paymentsXML = "
						<mbapi>
							<command>GetTransactions</command>
							<params>
								<getGatewayNames>1</getGatewayNames>
								<invoiceIDs>
									<invoiceID>".$invoiceID."</invoiceID>
								</invoiceIDs>
							</params>
						</mbapi>";
					$payments = dispatchMBAPI($paymentsXML, 1);

					$this->smartyVars["transactions"] = collapseArrayElements($payments["mbapi"][0]["results"][0]["transactions"][0]["transaction"]);
					if ($this->smartyVars["transactions"]["transactionID"]>0){
						$this->smartyVars["transactions"] = array($this->smartyVars["transactions"]);
					}
					$this->smartyVars["transactionStatuses"] = getStatuses("transactions");
					if (is_array($this->smartyVars["transactions"])){
						foreach ($this->smartyVars["transactions"] as $k => $v){
							if ($v["gatewayClassName"]!=""){
								$this->smartyVars["transactions"][$k]["canRefund"] = 0;
								if ($v["authReturn"]==getAPIStatusID("transactions", "successful") || $v["authReturn"]==getAPIStatusID("transactions", "captured") || $v["authReturn"]==getAPIStatusID("transactions", "authorized")){
									if (file_exists(mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php"))) {
										require_once mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php");
									}
									$caps = call_user_func(array($v["gatewayClassName"], "getModuleInfo"));
									if (($v["authReturn"]==getAPIStatusID("transactions", "successful") || $v["authReturn"]==getAPIStatusID("transactions", "captured")) && in_array(GATEWAY_REFUND, $caps["capabilities"])){
										$this->smartyVars["transactions"][$k]["canRefund"] = 1;
									}
									if ($v["authReturn"]==getAPIStatusID("transactions", "authorized") && in_array(GATEWAY_PRIOR_AUTH_CHARGE, $caps["capabilities"])){
										$this->smartyVars["transactions"][$k]["canFinalize"] = 1;
									}
								}
							}
						}
					}

					$this->smartyVars["paymentMethods"] = $CONF["types"]["payments"];
					$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
					$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
					$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
					$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
					$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
					
					// set up for using the date selector widget
					
					$this->formDefaults["transactionDateCreated"] = time();
					$this->setupDateSelector("transactionDateCreated");
					$this->mergeFormState();
					
					$this->smartyVars["invoiceStatuses"] = getStatuses("invoice");

					// just one last thing, find out exactly how much is due.
					$this->smartyVars["invoice"]["invoiceAmountDue"] = $this->smartyVars["invoice"]["invoiceAmount"] - $this->smartyVars["invoice"]["invoiceAmountPaid"];

					// grab the preview invoice
					$this->smartyVars["previewInvoice"] = $this->sendInvoice( $invoiceID, true );
					// decode the html so we can view it as it should be
					if (isset( $this->smartyVars["previewInvoice"]["html"] )) {
						$this->smartyVars["previewInvoice"]["html"] = utf8_html_entity_decode( $this->smartyVars["previewInvoice"]["html"] );
					}

					$this->addTemplate("invoices/ShowResendInvoice", $this->smartyVars);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Invoice does not exist.");
				}
			}
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowResendInvoice
?>
