<?php
// $Id: ShowResendInvoiceResponse.php 11809 2007-08-24 22:15:55Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-mbapi/include/mail/mail.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["invoiceID"] it will
 * 
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowResendInvoiceResponse extends MB_Action {
	/**
	 * The constructor for a ShowResendInvoiceResponse object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowResendInvoiceResponse() {
		parent::MB_Action();
		$this->stringRep = "ShowResendInvoiceResponse";
		$this->params = array("invoiceID", "previewInvoice");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		set_time_limit(0);

		$invoiceID = (int) $this->paramArgs["invoiceID"];
		$previewInvoice = (bool)((int) $this->paramArgs["previewInvoice"]);
		
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No Invoice ID given.");
		} else {
			// lets try to send this
			switch ( $this->sendInvoice( $invoiceID, $previewInvoice ) ) {
				case true: // sucess
					if (notNull( $this->getReferralActionFile() )) {
						redirect($this->getReferralActionFile(), $this->getReferralActionID(), array("invoiceID" => $invoiceID));
					} else {
						redirect("invoices.php", "ShowInvoiceDetails", array("invoiceID" => $invoiceID));
					}
					break;

				case -1: // errrror
					$this->addError( TRANS_ACTIONERROR, "Invoice ID not provided.");
					break;

				case false: // failed to send
					$this->addError( TRANS_ACTIONERROR, "Invoice Email Failed to send.");
					break;
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	/**
	 *	@short generate a new invoice email
	 *	@param int the invoiceID to generate
	 *	@param bool if to make this a preview invoice and return the results of the mail body
	 *	@return mixed
	 *		-1 means the invoiceID was not proper
	 *		true success
	 *		false failure
	 */
	function sendInvoice( $invoiceID, $previewInvoice = false ) {
		global $CONF;
		if (!notZero( $invoiceID )) {
			return -1;
		}
		
		$invoice =& new MBQuery("GetInvoices", "", array("invoiceID" => (int)$invoiceID,'getInvoiceLineItemsData'=>1));
		$invoice = $invoice->getResult();

		$invoice = grabSimpleMBAPIResults( $invoice->getStructure() );

		$invoice = $invoice[0];
			
		$client =& new MBQuery("GetClients", "", array(
			"clientID" => (int)$invoice["lineItems"][0]["lineItem"][0]["clientID"],
			"mergeDefaultBillingAccount" => 1,
			"getBillingData" => 1,
			"getCompanyData" => 1,
			"getContactData" => 1,
			"getAttributeData" => 1,
			"hooks" => array("hook" => array("hookFunctionName" => "calculateResellerVolumnDiscount"))));
		$client = $client->getResult();

		$client = grabSimpleMBAPIResults( $client->getStructure() );

		$email =& new MBTemplateBasedEmail( 0, getAPITypeID("emailAction", "invoiceEmail") );
		$email->addTemplateVars("client", $client[0]);
		$email->addTemplateVars("invoice", $invoiceID);
			
		$email->addContactByID( $client[0]["billingAccounts"][0]["billingAccount"][0]["clientContactID"] );
		$email->addToAddress( $client[0]["billingAccounts"][0]["billingAccount"][0]["contactEmail"] );

		$email->addVars("paymentType", $CONF["APItypes"]["billingAccount"][ $client[0]["billingAccounts"][0]["billingAccount"][0]["billingAccountType"] ]);

		if (notNull( $_REQUEST["comments"] )) {
			$email->addVars("comments", $_REQUEST["comments"]);
		}
		$email->addThirdPartyGatewayLinks($invoiceID, $invoice["paymentGroupID"]);

		if ($previewInvoice == true) {
			// exiting method to return the data we have
			return $email->sendEmails( true ) ;
		}

		return $email->sendEmails();
	}
} // ShowResendInvoiceResponse
?>