<?php
// $Id: LoginResponse.php 12048 2007-10-08 19:59:44Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 */
class LoginResponse extends MB_Action {

	/**
	 */
	function LoginResponse() {
		parent::MB_Action();
		$this->stringRep = "LoginResponse";
		$this->params = array("adminUsername", "adminPassword", "adminRemoteAccessHash");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminRemoteAccessHash = secureInput($CONF["user"]["remoteAccessHash"]);
		$internalAdmin = secureInput($CONF["user"]["internalAdmin"]);

		if($CONF["user"]["remoteSessionID"]) {
			list($isSessionActive, $logoutReason) = setSession($CONF["user"]["remoteSessionID"]);
			if($isSessionActive) {
				$this->hasExecutedSuccessfully = 1;
				$CONF["user"]["sessionID"] = $_REQUEST["sid"] = $CONF["user"]["remoteSessionID"];
				return $this->hasExecutedSuccessfully();
			}
		}

		$query = $this->getMBAPIQuery("ProcessAdminLogin", "",
			array("adminIP" => $CONF["user"]["ip"], "adminRemoteAccessHash" => $adminRemoteAccessHash, "internalAdmin" => $internalAdmin));
		$data = dispatchMBAPI($query, 1);
		dbg("admin login response:");
		dbg($data);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

			if(is_array($data["mbapi"][0]["results"][0]["adminID"])) {
			 	dbg("inside");
				$_REQUEST["sid"] = $data["mbapi"][0]["results"][0]["sessionID"][0];

				// Allow expired users to resume a new session from where their last one left off
				if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"]) {
					if(preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])) {
						redirect($_REQUEST["redirectActionFile"]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
					}
				} else {
					//If it's a remote API call, let it bubble back instead of redirect
					if($adminRemoteAccessHash || $internalAdmin) {
						$_REQUEST["adminID"] = $data["mbapi"][0]["results"][0]["adminID"][0];
						$CONF["user"]["type"] = 2;
						$CONF["user"]["sessionID"] = $_REQUEST["sid"];
						$this->hasExecutedSuccessfully = 1;
						return $this->hasExecutedSuccessfully();
					} else {
						// a change in login process
						redirect("dashboard.php", getActionID("ShowDashboard"));
						#redirect("todos.php", getActionID("ShowTodos"));
					}
				}
			} else {
				redirect("login.php",getActionID("ShowLogin"), array("msg" => "TRANS_LOGINFAILURE"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // LoginResponse
?>
