<?php
// $Id: MigrateConfigAssociate.php 12511 2008-01-18 18:27:51Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

class MigrateConfigAssociate extends GenericAction {
	function MigrateConfigAssociate() {
		parent::SourceAction();
		$this->stringRep = "MigrateConfigAssociate";
	}
	
	function execute() {
		parent::execute();
		
		global $CONF;
		$this->smartyVars["migrateProducts"] = $migrateProducts = (bool) $CONF["migrateProducts"];
		
		if(!$migrationConfig = oneByID("migrationConfigs", (int) $_REQUEST["migrationConfigID"])) {
			redirect("migrate.php", getActionID("ShowMigrationConfigs"));
			exit;
		}
		$this->smartyVars["migrationConfig"] = $migrationConfig;
		//show($migrationConfig);
		
		switch ($migrationConfig["migrationType"]){
			/**
			 * WHMCS migration
			 */
			case getAPITypeID("migration", "whmcs351"):
				do {
					$this->smartyVars["migrateProducts"] = 0;
					
					$dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
					$dbr->autoRollback = true;
					$dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
					//show($dbr);
					if(!$dbr->IsConnected()) {
						redirect("migrate.php", getActionID("MigrateError"), array("migrationErrorCode" => 1));
						exit;
					}
					

					$q =& new QueryMaster("select", $dbr);
					$q->enableManualJoining();
					$q->addColumns("tblservers.*");
					$servers = $q->getResults();
					$panelOptions = array();
					foreach ((array)$servers as $s){
						$panelOptions[$s["id"]] = $s["type"]." - ".$s["name"];
					}

					$q =& new QueryMaster("select", $dbr);
					$q->enableManualJoining();
					$q->addColumns("tblregistrars.*");
					$registrarData = $q->getResults();
					$registrars = array();
					foreach ((array)$registrarData as $rd){
						$registrars[$rd["registrar"]][$rd["setting"]] = $rd["value"];
					}
					
					$registrarOptions = array();
					foreach ($registrars as $registrar=>$fields){
						$isOn = false;
						foreach ($fields as $v) $isOn = ($v) ? true : $isOn;
						if ($isOn){
							$registrarOptions[crc32($registrar)] = ucwords($registrar);
						}
					}
					
		
					$productOptions = array(
						abs(crc32("DOMAIN")) => TRANS_DOMAINS,
					);
					$q =& new QueryMaster("select", $dbr);
					$q->addColumns("tblproducts.*");
					$products = $q->getResults();
					foreach ((array)$products as $p){
						$productOptions[abs(crc32("PRODUCT".$p["id"]))] = TRANS_PRODUCT.": ".$p["name"];
					}
					$q =& new QueryMaster("select", $dbr);
					$q->addColumns("tbladdons.*");
					$addons = $q->getResults();
					foreach ((array)$addons as $p){
						$productOptions[abs(crc32("ADDON".$p["id"]))] = TRANS_ADDON.": ".$p["name"];
					}
					
					$toProductOptions = $toDomainProductOptions = optionsFor("products", array("getNonAddons" => 0));
					$selectedProducts = array();
					foreach($productOptions as $pack_id => $pack_name) {
						$L = 1000;
						foreach($toProductOptions as $productID => $productName) {
							$newL = levenshtein($productName, $pack_name, 1, 2, 0);
							if($newL < $L) {
								$L = $newL;
								$selectedProducts[$pack_id] = $productID;
							}
						}
					}
					
					//show($d);
					//show("to products");
					//show($toProductOptions);
					$toPanelOptions = $this->getPanelOptions();
					//show("to panels");
					//show($toPanelOptions);
					$toRegistrarOptions = $this->getRegistrarOptions();
					//show("to registrars");
					//show($toRegistrarOptions);
		
		
					$this->smartyVars["productOptions"] = $productOptions;
					$this->smartyVars["panelOptions"] = $panelOptions;
					$this->smartyVars["registrarOptions"] = $registrarOptions;
		
					$this->smartyVars["toProductOptions"] = $toProductOptions;
					$this->smartyVars["toDomainProductOptions"] = $toDomainProductOptions;
					$this->smartyVars["selectedProducts"] = $selectedProducts;
					$this->smartyVars["toPanelOptions"] = $toPanelOptions;
					$this->smartyVars["toRegistrarOptions"] = $toRegistrarOptions;
					SourceAction::addTemplate("migrate/MigrateConfigAssociate");
				} while(0);
				$this->addErrorTemplates();
			break;
			/**
			 * ModernBill 4 migration
			 */
			case getAPITypeID("migration", "mb4"):
				do {
		
					$dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
					$dbr->autoRollback = true;
					$dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
					//show($dbr);
					if(!$dbr->IsConnected()) {
						redirect("migrate.php", getActionID("MigrateError"), array("migrationErrorCode" => 1));
						exit;
					}
					
					/*
					$q =& new QueryMaster("select", $dbr);
					$q->enableManualJoining();
					$q->addTables("config");
					$q->addColumns("config_59");
					$q->addAndClause("config_type", "=", "main", "s");
					list($version) = explode(":", $q->getOne());
					if(version_compare($version, "4.4", "<")) {
						redirect("migrate.php", getActionID("MigrateError"), array("migrationErrorCode" => 2, "migrationErrorMessage" => $version));
						exit;
					}
					/**/
		
					if(!$migrateProducts) {
						$q =& new QueryMaster("select", $dbr);
						$q->enableManualJoining();
						$q->addTables("package_type");
						$q->addColumns("pack_id", "pack_name");
						$t =& $q->getTable(-1, 0, "pack_id", "pack_name");
						$productOptions = $t->getOptions();
						//show("from products");
						//show($productOptions);
					}
		
					$q =& new QueryMaster("select", $dbr);
					$q->enableManualJoining();
					$q->addTables("account_details");
					$q->addColumns("server");
					$q->addDistinctColumn("server");
		
					//show($q->getQuery());
					$t =& $q->getTable();
					$r = array_filter($t->getColumnDistinct("server"));
					$panelOptions = array();
					foreach($r as $panel) $panelOptions[$panel] = $panel;
					//show("from panels");
					//show($panelOptions);
		
					$registrars = array(
						2 => "mod_opensrs",
						3 => "mod_emailregister",
						4 => "mod_enom",
						9 => "mod_nominet",
						11 => "mod_onlinenic",
						12 => "mod_srsplus",
						14 => "mod_registercom",
					);
					$registrarOptions = array();
					$q =& new QueryMaster("select", $dbr);
					$q->enableManualJoining();
					$q->addTables("domain_names");
					$q->addColumns("registrar_id");
					$q->addDistinctColumn("registrar_id");
		
					//show($q->getQuery());
					$t =& $q->getTable();
					$r = array_filter($t->getColumnDistinct("registrar_id"));
					$registrarOptions = array();
					foreach($registrars as $registrar_id => $registrar_name) if(in_array($registrar_id, $r)) $registrarOptions[$registrar_id] = $registrar_name;
					//show("from registrars");
					//show($registrarOptions);
		
					if(!$migrateProducts) {
						/*
						$d =& new DataSource("products", array("getNonAddons" => 1));
						$t =& $d->getTable();
						$products = $t->getTable();
						$toProductOptions = $toDomainProductOptions = array();
						foreach($products as $product) {
							if($product["productType"] == getAPITypeID("products", "domain")) {
								$toDomainProductOptions[$product["productID"]] = $product["productName"];
							} else {
								$toProductOptions[$product["productID"]] = $product["productName"];
							}
						}
						*/
		
						$toProductOptions = $toDomainProductOptions = optionsFor("products", array("getNonAddons" => 1));
		
						$selectedProducts = array();
						foreach($productOptions as $pack_id => $pack_name) {
							$L = 1000;
							foreach($toProductOptions as $productID => $productName) {
								$newL = levenshtein($productName, $pack_name, 1, 2, 0);
								if($newL < $L) {
									$L = $newL;
									$selectedProducts[$pack_id] = $productID;
								}
							}
						}
					}
					
					//show($d);
					//show("to products");
					//show($toProductOptions);
					$toPanelOptions = $this->getPanelOptions();
					//show("to panels");
					//show($toPanelOptions);
					$toRegistrarOptions = $this->getRegistrarOptions();
					//show("to registrars");
					//show($toRegistrarOptions);
		
		
					$this->smartyVars["productOptions"] = $productOptions;
					$this->smartyVars["panelOptions"] = $panelOptions;
					$this->smartyVars["registrarOptions"] = $registrarOptions;
		
					$this->smartyVars["toProductOptions"] = $toProductOptions;
					$this->smartyVars["toDomainProductOptions"] = $toDomainProductOptions;
					$this->smartyVars["selectedProducts"] = $selectedProducts;
					$this->smartyVars["toPanelOptions"] = $toPanelOptions;
					$this->smartyVars["toRegistrarOptions"] = $toRegistrarOptions;
					SourceAction::addTemplate("migrate/MigrateConfigAssociate");
				} while(0);
				$this->addErrorTemplates();
			break;
		}
	}
}

?>
