<?php
// $Id: MigrateConfigAssociateResponse.php 12609 2008-02-05 22:01:42Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-action/migrate/MigrateProcessCommon.php");

class MigrateConfigAssociateResponse extends SourceAction {
	function MigrateConfigAssociateResponse() {
		parent::SourceAction();
		$this->stringRep = "MigrateConfigAssociateResponse";
	}
	
	function execute() {
		//show($_REQUEST);

		global $CONF;
		$migrateProducts = (bool) $CONF["migrateProducts"];
		$migrateModules = (bool) $CONF["migrateModules"];

		if(!$migrationConfig = oneByID("migrationConfigs", (int) $_REQUEST["migrationConfigID"])) {
			redirect("migrate.php", getActionID("ShowMigrationConfigs"));
			exit;
		}
		
		$this->migrationConfigID = $migrationConfigID = $migrationConfig["migrationConfigID"];

		$products = $panels = $registrars = array();
		foreach($_REQUEST as $param => $val) {
			list($type, $extVal) = explode(":", $param);
			switch($type) {
				case "product":
					$products[$extVal] = $val;
					break;
				case "panel":
					$panels[$extVal] = $val;
					break;
				case "registrar":
					$registrars[$extVal] = $val;
					break;
			}
		}
		//show($products);
		//show($panels);
		//show($registrars);
		
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "products"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "panels"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "registrars"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "lek"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationExtObjName" => "panels"));
		//deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID));
		deleteFor("migrationMappings", array("migrationConfigID" => $migrationConfigID));
		$this->addonOptionIDCache =& new PersistentHash("addonOption:" . $this->migrationConfigID);
		$this->addonGroupIDCache =& new PersistentHash("addonGroup:" . $this->migrationConfigID);
		$this->productIDCache =& new PersistentHash("product:" . $this->migrationConfigID);
		$this->cycleIDCache =& new PersistentHash("cycles");
		
		$this->addonOptionIDCache->destroy();
		$this->addonGroupIDCache->destroy();
		$this->productIDCache->destroy();
		$this->cycleIDCache->destroy();



		switch ($migrationConfig["migrationType"]){
			/**
			 * WHMCS migration
			 */
			case getAPITypeID("migration", "whmcs351"):
		
				$migrationObjID = insertFor(
					"migrationObjs",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjName" => "products",
						"migrationIntObjName" => "products",
						"migrationIntObjKey" => "productID",
						"migrationExtObjName" => "tblproducts",
						"migrationExtObjKey" => "id",
					)
				);
		
				foreach($products as $extID => $intID) {
					insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $migrationObjID,
							"migrationExtID" => $extID,
							"migrationIntID" => $intID,
						)
					);
				}
		
				$migrationObjID = insertFor(
					"migrationObjs",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjName" => "panels",
						"migrationIntObjName" => "configGroups",
						"migrationIntObjKey" => "configGroupID",
						"migrationExtObjName" => "tblservers",
						"migrationExtObjKey" => "id",
					)
				);
		
				foreach($panels as $extID => $intID) {
					insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $migrationObjID,
							"migrationExtID" => $extID,
							"migrationIntID" => $intID,
						)
					);
				}
				
				$migrationObjID = insertFor(
					"migrationObjs",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjName" => "registrars",
						"migrationIntObjName" => "configGroups",
						"migrationIntObjKey" => "configGroupID",
						"migrationExtObjName" => "tblregistrars",
						"migrationExtObjKey" => "registrar",
					)
				);
		
				foreach($registrars as $extID => $intID) {
					insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $migrationObjID,
							"migrationExtID" => $extID,
							"migrationIntID" => $intID,
						)
					);
				}
				
				if(!empty($_REQUEST["lek_passphrase"])) {
					$migrationObjID = insertFor(
						"migrationObjs",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjName" => "lek",
							"migrationExtObjName" => $_REQUEST["lek_passphrase"],
						)
					);
				}
		
				if($migrateModules) {
					redirect("migrate.php", getActionID("MigrateModuleManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				} else if($migrateProducts) {
					redirect("migrate.php", getActionID("MigrateProductManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				} else {
					redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				}
			break;
			/**
			 * Modernbill 4 migration
			 */
			case getAPITypeID("migration", "mb4"):
				
				$migrationObjID = insertFor(
					"migrationObjs",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjName" => "products",
						"migrationIntObjName" => "products",
						"migrationIntObjKey" => "productID",
						"migrationExtObjName" => "package_type",
						"migrationExtObjKey" => "pack_id",
					)
				);
		
				if(!$migrateProducts) {
					foreach($products as $extID => $intID) {
						insertFor(
							"migrationMappings",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjID" => $migrationObjID,
								"migrationExtID" => $extID,
								"migrationIntID" => $intID,
							)
						);
					}
				}
		
				$migrationObjID = insertFor(
					"migrationObjs",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjName" => "panels",
						"migrationIntObjName" => "configGroups",
						"migrationIntObjKey" => "configGroupID",
						"migrationExtObjName" => "account_details",
						"migrationExtObjKey" => "server",
					)
				);
		
				foreach($panels as $extID => $intID) {
					$virtualExtID = insertFor(
						"migrationObjs",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjName" => $extID,
							"migrationExtObjName" => "panels",
						)
					);
		
					insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $migrationObjID,
							"migrationExtID" => $virtualExtID,
							"migrationIntID" => $intID,
						)
					);
				}
				
				$migrationObjID = insertFor(
					"migrationObjs",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjName" => "registrars",
						"migrationIntObjName" => "configGroups",
						"migrationIntObjKey" => "configGroupID",
						"migrationExtObjName" => "domain_names",
						"migrationExtObjKey" => "registrar_id",
					)
				);
		
				foreach($registrars as $extID => $intID) {
					insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $migrationObjID,
							"migrationExtID" => $extID,
							"migrationIntID" => $intID,
						)
					);
				}
				
				if(!empty($_REQUEST["lek_passphrase"])) {
					$migrationObjID = insertFor(
						"migrationObjs",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjName" => "lek",
							"migrationExtObjName" => $_REQUEST["lek_passphrase"],
						)
					);
				}
		
				if($migrateModules) {
					redirect("migrate.php", getActionID("MigrateModuleManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				} else if($migrateProducts) {
					redirect("migrate.php", getActionID("MigrateProductManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				} else {
					redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				}
			break;
		}
	}
}

?>
