<?php
// $Id: MigrateDeprocess.php 12612 2008-02-06 18:31:16Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

set_time_limit(0);
ignore_user_abort();

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");
header("Content-Type: text/html; charset=utf-8");

define("CLIENT_PROCESS_STEP", 5);

class MigrateDeprocess extends SourceAction {
	function MigrateDeprocess() {
		parent::SourceAction();
		$this->stringRep = "MigrateDeprocess";
	}
	
	function execute() {
		do  {
			$e = "";
			
			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			$clientProcessStep = (int) $_REQUEST["clientProcessStep"] ? (int) $_REQUEST["clientProcessStep"] : CLIENT_PROCESS_STEP;

			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				break;
			}
			
			if ($migrationConfig["migrationType"]==getAPITypeID("migration", "whmcs351")){
				die("Demigrating whmcs migrations is not supported at this time.");
			}
			
			// get our client migration information, or redirect back to the details page if not found.
			if(!$clientMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "clients"))) {
				redirect("migrate.php", getActionID("ShowMigrationConfigDetails"), array("migrationConfigID" => $migrationConfig["migrationConfigID"], "error" => 1));
				break;
			} else {
				$clientMigrationID = $clientMigration["migrationObjID"];
			}

			// find out which clients to demigrate in this process
			$lastExtClientID = $clientMigration["migrationExtSeqID"];
			$d =& new DataSource(
				"migrationMappings",
				array(
					"migrationObjID" => $clientMigrationID,
				)
			);
			$d->mergeFilters(
				array(
					"numRecords" => $clientProcessStep,
					"sortColumn" => "migrationMappingID",
					"sortDir" => "desc",
				)
			);
			$t =& $d->getTable();
			$intClientIDs = $t->getColumnDistinct("migrationIntID");
			$mappingsByIntID = $t->getAssociatedBy("migrationIntID");
			//show($d);
			//show($t);
			
			//exit;
			
			$finishedClients = (int) countFor(
				"migrationMappings",
				array(
					"migrationObjID" => $clientMigrationID,
				)
			);
			echo '<script language="javascript">parent.updateNumClients(' . $finishedClients . ');</script>';
			flush();

			foreach($intClientIDs as $intClientID) {
				if(!$intClientID) {
					echo "Internal Client ID is invalid. Must have been a problem migrating it.<br />";
					continue;
				}
				
				$invoiceIDs = IDsOf(":invoices", array(
					"clientID" => $intClientID,
				));
				
				if($invoiceIDs) {
					foreach ((array)$invoiceIDs as $invoiceID){
						show(dbg("Deleted invoice $invoiceID"));
						dispatchMBAPI(array(
							"mbapi" => array(
								"command" => "SetInvoices",
								"subCommand" => "delete",
								"params" => array(
									"invoiceID" => $invoiceID,
								),
							),
						));
					}
				}
				
				if(!deleteForKey(":clients", $intClientID)) {
					$e = "Problem deleting internal client ID $intClientID: " . lastError();
					break 2;
				}
				$id = str_pad($intClientID, 10, "0", STR_PAD_LEFT);
				if(!deleteFor(
					"migrationReservations",
					array(
						"migrationExtID" => $id,
						"migrationObjID" => $clientMigrationID,
					)
				)) {
					$e = "Problem unreserving internal client ID $intClientID";
					break 2;
				}

				$migrationMappingID = $mappingsByIntID[$intClientID]["migrationMappingID"];
				if(!deleteForKey("migrationMappings", $migrationMappingID)) {
					$e = "Problem deleting migration information for client ID $intClientID: " . lastError();
					break 2;
				} else {
					// success message
				}
				
				
				$d =& new DataSource(
					"migrationMappings",
					array(
						"migrationObjID" => $clientMigrationID,
					)
				);
				$d->mergeFilters(
					array(
						"numRecords" => 1,
						"sortColumn" => "migrationMappingID",
						"sortDir" => "desc",
					)
				);
				if($a =& $d->getEssential() === false) {
					$e = "Problem getting old migration mapping for updating sequence: " . lastError();
					break 2;
				} else {
					$oldMigrationMapping = current($a);
					// success message
				}
				$oldMigrationExtID = $oldMigrationMapping["migrationExtID"];
				
				// revert the sequence ID to the last mapped external client ID
				if(!updateFor(
					"migrationObjs",
					array(
						"migrationObjID" => $clientMigrationID,
						"migrationExtSeqID" => $oldMigrationExtID,
					)
				)) {
					$e = "Problem reverting the last mapped external client ID to $oldMigrationExtID: " . lastError();
					break 2;
				} else {
					// success message
				}
				echo "Unmigrated client ID $intClientID <br />";
				flush();

				echo '<script language="javascript">parent.updateNumClients(' . --$finishedClients . ');</script>';
				flush();
			}

			if($intClientIDs) {
				echo '<script language="javascript">parent.runDemigrationLoad();</script>';
				flush();
			}
			
			//redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
		echo '<script language="javascript">parent.enableStartFormElements();</script>';
		flush();
	}
}
