<?php
// $Id: MigrateModuleProcess.php 10906 2007-03-22 22:09:09Z bwoolley $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

set_time_limit(0);
ignore_user_abort();

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-action/migrate/MigrateProcessCommon.php");

define("MODULE_PROCESS_STEP", 25);

class MigrateModuleProcess extends MigrateProcessCommon {
	var $addonGroupIDCache;
	var $addonOptionIDCache;

	function MigrateModuleProcess() {
		MigrateProcessCommon::MigrateProcessCommon();
		$this->stringRep = "MigrateModuleProcess";

	}

	function execute() {
		global $CONF;
		$adminID = $CONF["user"]["id"];
		$syncMigrationIDs = (bool) $CONF["syncMigrationIDs"];
		$raisePriorBalancePackageKeysBy = (int) $CONF["raisePriorBalancePackageKeysBy"];
		$migrateModules = (bool) $CONF["migrateModules"];

		$enableLTDiscount = $CONF["enableLTDiscount"];
		do  {
			$e = "";

			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			$moduleProcessStep = (int) $_REQUEST["moduleProcessStep"] ? (int) $_REQUEST["moduleProcessStep"] : MODULE_PROCESS_STEP;

			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				exit;
			}
			$this->migrationConfig = $migrationConfig;
			$this->migrationConfigID = $migrationConfigID;

			$this->addonGroupIDCache =& new PersistentHash("addonGroup:" . $this->migrationConfigID);
			$this->addonOptionIDCache =& new PersistentHash("addonOption:" . $this->migrationConfigID);

			// get our client migration information
			if(!$moduleMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "modules"))) {
				$e = "Could not get module migration state. Must be called from the migration association page, which will initialize the module migration state.";
				break;
			} else {
				$moduleMigrationID = $moduleMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$panelMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "panels"))) {
				$e = "Could not get panel migration state. Must be called from the migration association page, which will initialize the panel migration state.";
				break;
			} else {
				$panelMigrationID = $panelMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$registrarMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "registrars"))) {
				$e = "Could not get registrar migration state. Must be called from the migration association page, which will initialize the registrar migration state.";
				break;
			} else {
				$registrarMigrationID = $registrarMigration["migrationObjID"];
			}

			if ($this->currencyID){
				$currencyID = $this->currencyID;
			} else {
				$this->paymentGroupInfo = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $paymentGroupID,
						),
					),
				)));
				$this->currencyID = $currencyID = $this->paymentGroupInfo["paymentGroupCurrencyID"];
				dbg("GOT CURRENCY ID OF: ".$currencyID);
			}



			//show($clientMigration);

			// connect to v4
			$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$this->dbr->autoRollback = true;
			$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$this->dbr->IsConnected()) {
				$e = "Could not connect to the database, please check your config options.";
				break;
			}

			// get the system language ID
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("config");
			$q->addColumns("config_3");
			$q->addAndClause("config_type", "=", "main", "s");
			$systemlanguageISO2 = $q->getOne();
			$language = oneOf("languages", array("languageISO2" => $systemlanguageISO2));
			$languageID = $language["languageID"];

			//show($systemlanguageISO2);
			//show($languageID);

			$q =& new MBQuery(
				"ProcessReservations", "",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $moduleMigrationID,
					"numReservations" => $moduleProcessStep,
					"adminID" => $adminID,
				)
			);
			$r =& $q->getResult();

			$s = $r->getSubjectFrom(array("mbapi", "results", 0));
			$results = $s->getCollapsed();
			show($results);
			$reservedModules = $results["reserved"];
			$totalModules = $results["total"];
			$moduleIDs = $results["reservations"]["reservedID"];

			if($moduleIDs) {
				// find out which clients to migrate in this process
				$sql = "
					select
						config.*
					from
						config
					where
						config.config_type in ('" . implode("', '", (array) $moduleIDs) . "')
					order by config.config_type asc
				";
				$r = $this->dbr->SelectLimit($sql, $moduleProcessStep, 0);
				if($r !== false) {
					$t =& new Table($r->GetArray(), "config_type");
					$extModules = $t->getAssociated();
					$extModuleIDs = $t->getKeys();
				} else {
					$e = $this->dbr->ErrorMsg();
					break;
				}
			} else {
				$extModules = array();
			}

			$finishedModules = (int) countFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $moduleMigrationID,
				)
			);
			echo '<script language="javascript">parent.updateNumModules(' . $finishedModules . ');</script>';
			flush();

			// migrate each module
			foreach($extModules as $extModuleID => $extPackData) {

				//show($extPackData);

				$moduleDetails = array();
				preg_match("/(mod_)([a-zA-Z_]+)([0-9]*)/", $extModuleID, $moduleDetails);
				list($match, $prefix, $name, $i) = $moduleDetails;
				$i = (int) $i;

				$intModuleID = false;

				if($name) {
					show(
						array(
							"name" => $name,
							"i" => $i,
						)
					);

					switch($name) {
						case "cpanel":
							$moduleType = "panel";
							$parentConfigGroupName = "cpanel";
							//show($extPackData);
							$serverGroup = $extPackData["config_31"];
							$fillRate = $extPackData["config_34"];
							$params = array(
								"moduleDisplayName" => $name . ": " . quoteXMLconvert($extPackData["config_65"]),
								"moduleEnabled" => $extPackData["config_1"],
								"host" => quoteXMLconvert($extPackData["config_2"]),
								"moduleUsername" => quoteXMLconvert($extPackData["config_3"]),
								"accessHash" => quoteXMLconvert($extPackData["config_41"]),
								"cpanelUseSSL" => quoteXMLconvert($extPackData["config_5"]),
								"panelUsernameRule" => quoteXMLconvert($extPackData["config_63"]),
								"panelMaxAccounts" => quoteXMLconvert($extPackData["config_32"]),
								"panelCurrentAccounts" => quoteXMLconvert($extPackData["config_33"]),
								"panelNameserver1" => quoteXMLconvert($extPackData["config_50"]),
								"panelNameserver1IP" => quoteXMLconvert($extPackData["config_51"]),
								"panelNameserver2" => quoteXMLconvert($extPackData["config_52"]),
								"panelNameserver2IP" => quoteXMLconvert($extPackData["config_53"]),
							);
							//show($params);
							break;

						case "plesk":
							$moduleType = "panel";
							$parentConfigGroupName = in_array($extPackData["config_3"], array(7, 10, 13)) ? "pleskwin" : "plesk";
							//show($extPackData);
							$serverGroup = $extPackData["config_31"];
							$params = array(
								"moduleDisplayName" => $name . ": " . quoteXMLconvert($extPackData["config_65"]),
								"moduleEnabled" => $extPackData["config_1"],
								"api" => quoteXMLconvert($extPackData["config_2"]),
								"ip" => quoteXMLconvert($extPackData["config_42"]),
								"moduleUsername" => quoteXMLconvert($extPackData["config_8"]),
								"modulePassword" => quoteXMLconvert($extPackData["config_9"]),
								"panelMaxAccounts" => quoteXMLconvert($extPackData["config_32"]),
								"panelCurrentAccounts" => quoteXMLconvert($extPackData["config_33"]),
								"panelNameserver1" => quoteXMLconvert($extPackData["config_50"]),
								"panelNameserver1IP" => quoteXMLconvert($extPackData["config_51"]),
								"panelNameserver2" => quoteXMLconvert($extPackData["config_52"]),
								"panelNameserver2IP" => quoteXMLconvert($extPackData["config_53"]),
							);
							//show($params);
							break;

/*
						case "ensim":
							$moduleType = "panel";
							$parentConfigGroupName = "ensim";

//							$serverGroup = $extPackData["config_31"];
//

							$fillRate =
*/

						case "registercom":
						case "enom":
							$registrarGroupID = IDByName("configGroups", "registrar");
							$configGroupID = IDByName("configGroups", $name, array("parentConfigGroupID" => $registrarGroupID));

							$displayName = valueByName("configParams", "moduleDisplayName", NULL, array("configGroupID" => $configGroupID));
							$enabled = valueByName("configParams", "moduleEnabled", NULL, array("configGroupID" => $configGroupID));
							show("existing display name: $displayName");
							if($enabled) show("already enabled");
							if($displayName || $displayName) {
								show("skipping $name module--it seems to already be configured");
								$moduleType = NULL;
								break;
							}

							$moduleType = "registrar";
							$params = array(
								"moduleDisplayName" => $name,
								"moduleEnabled" => quoteXMLconvert($extPackData["config_1"]),
								"moduleTestMode" => (int) (bool) $extPackData["config_5"],
								"moduleUsername" => quoteXMLconvert($extPackData["config_2"]),
								"modulePassword" => quoteXMLconvert(getEncryptedText($extPackData["config_3"])),
								"moduleAllowDomainPassword" => (int) (bool) $extPackData["config_8"],
								"moduleAllowAutorenew" => $extPackData["config_10"] ? getAPITypeID("tldRenew", "internal") : getAPITypeID("tldRenew", "disabled"),
								"moduleAllowRegistrarLock" => (int) (bool) $extPackData["config_9"],
								"moduleAllowNameserverOverride" => (int) (bool) $extPackData["config_11"],
								"moduleUseCustomNameserver" => (int) (bool) $extPackData["config_55"],
								"moduleAllowRenew" => (int) (bool) $extPackData["config_64"],
								"moduleAllowTransfer" => (int) (bool) $extPackData["config_65"],
								"moduleAllowChangeDNS" => (int) (bool) $extPackData["config_66"],
								"moduleAllowChangeContactInfo" => (int) (bool) $extPackData["config_67"],
								"moduleAllowChangeRegistrarLock" => (int) (bool) $extPackData["config_68"],
								"moduleAllowChangeAutorenew" => (int) (bool) $extPackData["config_69"],
								"moduleAllowChangeUpdateDomainPassword" => (int) (bool) $extPackData["config_70"],
								"moduleAllowRegisterNameServer" => (int) (bool) $extPackData["config_71"],
								"adminFirstName" => quoteXMLconvert($extPackData["config_14"]),
								"adminLastName" => quoteXMLconvert($extPackData["config_15"]),
								"adminCompany" => quoteXMLconvert($extPackData["config_16"]),
								"adminEmail" => quoteXMLconvert($extPackData["config_17"]),
								"adminAddress1" => quoteXMLconvert($extPackData["config_18"]),
								"adminAddress2" => quoteXMLconvert($extPackData["config_19"]),
								"adminCity" => quoteXMLconvert($extPackData["config_20"]),
								"adminState" => quoteXMLconvert($extPackData["config_21"]),
								"adminPostalCode" => quoteXMLconvert($extPackData["config_22"]),
								"adminCountry" => quoteXMLconvert($extPackData["config_23"]),
								"adminPhone" => quoteXMLconvert($extPackData["config_24"]),
								"adminFax" => quoteXMLconvert($extPackData["config_25"]),
								"techFirstName" => quoteXMLconvert($extPackData["config_26"]),
								"techLastName" => quoteXMLconvert($extPackData["config_27"]),
								"techCompany" => quoteXMLconvert($extPackData["config_28"]),
								"techEmail" => quoteXMLconvert($extPackData["config_29"]),
								"techAddress1" => quoteXMLconvert($extPackData["config_30"]),
								"techAddress2" => quoteXMLconvert($extPackData["config_31"]),
								"techCity" => quoteXMLconvert($extPackData["config_32"]),
								"techState" => quoteXMLconvert($extPackData["config_33"]),
								"techPostalCode" => quoteXMLconvert($extPackData["config_34"]),
								"techCountry" => quoteXMLconvert($extPackData["config_35"]),
								"techPhone" => quoteXMLconvert($extPackData["config_36"]),
								"techFax" => quoteXMLconvert($extPackData["config_37"]),
								"domainNameserver1" => quoteXMLconvert($extPackData["config_12"]),
								"domainNameserver2" => quoteXMLconvert($extPackData["config_13"]),
							);
							break;

						default:
							$moduleType = NULL;
							break;
					}

					switch($moduleType) {
						case "panel":
							show("Handling $moduleType $name $i");

							$serverGroupName = $migrationConfig["migrationName"] . ": $name $serverGroup";
							if(!$serverGroupID = IDByName("serverGroups", $serverGroupName)) {
								if(!$serverGroupID = insertFor(
									"serverGroups",
									array(
										"serverGroupName" => $serverGroupName,
									)
								)) {
									$e = "Problem inserting new server group: " . lastError();
									break 3;
								}

							}
							show("Server group $serverGroupID: $serverGroupName");

							$q =& new MBQuery(
								"SetPanels", "insert",
								array(
									"serverGroupID" => $serverGroupID,
									"parentConfigGroupName" => $parentConfigGroupName,
								)
							);
							$r =& $q->getResult();
							$configGroupID = $r->getLastInsertID();

							show("Inserted new panel at $configGroupID");

							if(!$this->updateGroupParams($configGroupID, $params)) {
								$e = "Problem updating panel param: " . lastError();
								break 3;
							}

							$intModuleID = $configGroupID;
							$moduleTypeMigrationObjID = $panelMigrationID;
							//exit;
							break;

						case "registrar":
							show("Handling $moduleType $name");

							if(!$this->updateGroupParams($configGroupID, $params)) {
								$e = "Problem updating registrar param: " . lastError();
								break 3;
							}

							$intModuleID = $configGroupID;
							$moduleTypeMigrationObjID = $registrarMigrationID;
							break;
					}
				}

				if($intModuleID) {
					if(isset($this->registrarIDMap[$extModuleID])) {
						$moduleExtObjID = $this->registrarIDMap[$extModuleID];
					} else {
						if ( ($rm_rf_ME = oneOf( 'migrationObjs', array("migrationObjName" => $extModuleID))) !== false) {
							deleteForKey('migrationObjs', $rm_rf_ME['migrationObjID']);
							deleteFor('migrationMappings', array('migrationObjID' => $rm_rf_ME['migrationObjID']));
						}	unset( $rm_rf_ME );

						if(!$moduleExtObjID = insertFor(
							"migrationObjs",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjName" => $extModuleID,
							)
						)) {
							$e = lastError();
							break 2;
						}
					}

					if(!insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $moduleTypeMigrationObjID,
							"migrationExtID" => $moduleExtObjID,
							"migrationIntID" => $intModuleID,
						)
					)) {
						$e = lastError();
						break 2;
					}

					if(!insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $moduleMigrationID,
							"migrationExtID" => $moduleExtObjID,
							"migrationIntID" => $intModuleID,
						)
					)) {
						$e = lastError();
						break 2;
					}
					/*
					show("Made module ID $intModuleID");

					// signifies that we are done with this module
					if(!updateFor(
						"migrationObjs",
						array(
							"migrationObjID" => $moduleMigrationID,
							"migrationExtSeqID" => $extModuleID,
						)
					)) {
						$e = lastError();
						break 2;
					}
					*/
				}

				echo '<script language="javascript">parent.updateNumModules(' . ++$finishedModules . ');</script>';
				flush();
			}

			if($extModules) {
				echo '<script language="javascript">parent.runMigrationLoad();</script>';
				flush();
			} else {
				echo '<script language="javascript">parent.runForward();</script>';
				flush();
			}

			//redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));

		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
		echo '<script language="javascript">parent.enableStartFormElements();</script>';
		flush();
	}

	function updateGroupParams($configGroupID, $params) {
		foreach($params as $paramName => $paramValue) {
			$configParamID = IDByName("configParams", $paramName, array("configGroupID" => $configGroupID));

			if(!updateFor(
				"configParams",
				array(
					"configParamID" => $configParamID,
					"configParamValue" => $paramValue,
				)
			)) return false;

			show("updated param $paramName at $configParamID to $paramValue");
		}

		return true;
	}
}
