<?php
// $Id: MigrateProcess.php 12760 2008-03-12 22:26:32Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

set_time_limit(0);
ignore_user_abort();

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/migration/migrationFunctions.php");
require_once mb_path("/lib-modernbill/include/accounting/Sale.php");
require_once mb_path("/lib-modernbill/include/accounting/Payment.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-tk/include/creditcard/validate.php");
require_once mb_path("/lib-action/migrate/MigrateProcessCommon.php");
//header("Content-Type: text/html; charset=utf-8");

define("CLIENT_PROCESS_STEP", 5);

class MigrateProcess extends MigrateProcessCommon {
	var $productIDCache;
	var $productCache;
	var $addonGroupIDCache;
	var $addonOptionIDCache;
	
	function MigrateProcess() {
		MigrateProcessCommon::MigrateProcessCommon();
		$this->stringRep = "MigrateProcess";
		
		$this->productCache = 
		array();
	}
	
	function execute() {
		global $CONF;
		$adminID = $CONF["user"]["id"];
		$syncMigrationIDs = (bool) $CONF["syncMigrationIDs"];
		$raisePriorBalancePackageKeysBy = (int) $CONF["raisePriorBalancePackageKeysBy"];
		$migrateProducts = (bool) $CONF["migrateProducts"];
		$migrateTLDs = (bool) $CONF["migrateTLDs"];
		if(!empty($_REQUEST["doNotMigrateProducts"]) && $_REQUEST["doNotMigrateProducts"]) $migrateProducts = false;
		$migrateAddonPrices = (bool) $CONF["migrateAddonPrices"];
		$migrationProductGroupID = (int) $CONF["migrationProductGroupID"];
		
		$enableLTDiscount = $CONF["enableLTDiscount"];
		$enableHGMigration = $CONF["enableHGMigration"];
		
		do  {
			$e = "";

			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			$clientProcessStep = (int) $_REQUEST["clientProcessStep"] ? (int) $_REQUEST["clientProcessStep"] : CLIENT_PROCESS_STEP;
		
			if($clientID = $_REQUEST["clientID"]) {
				$clientProcessStep = 1;
			}

			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				exit;
			}
			$this->migrationConfig = $migrationConfig;
			$this->migrationConfigID = $migrationConfigID;

			$this->addonGroupIDCache =& new PersistentHash("addonGroup:" . $this->migrationConfigID);
			$this->addonOptionIDCache =& new PersistentHash("addonOption:" . $this->migrationConfigID);
			$this->productIDCache =& new PersistentHash("product:" . $this->migrationConfigID);

			// get our client migration information
			if(!$clientMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "clients"))) {
				$e = "Could not get client migration state. Must be called from the Migration Manager, which will initialize the client migration state.";
				break;
			} else {
				$clientMigrationID = $clientMigration["migrationObjID"];
			}

			// get our client migration information
			if(!$packageMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "packages"))) {
				$e = "Could not get client migration state. Must be called from the Migration Manager, which will initialize the package migration state.";
				break;
			} else {
				$packageMigrationID = $this->packageMigrationID = $packageMigration["migrationObjID"];
			}

			// get our client migration information
			if(!$productMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "products"))) {
				$e = "Could not get product migration state. Must be called from the migration association page, which will initialize the product migration state.";
				break;
			} else {
				$productMigrationID = $productMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$panelMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "panels"))) {
				$e = "Could not get panel migration state. Must be called from the migration association page, which will initialize the panel migration state.";
				break;
			} else {
				$panelMigrationID = $panelMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$registrarMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "registrars"))) {
				$e = "Could not get registrar migration state. Must be called from the migration association page, which will initialize the registrar migration state.";
				break;
			} else {
				$registrarMigrationID = $registrarMigration["migrationObjID"];
			}

			if (!(int) $this->migrationConfig["migrationOrphanProductID"]){
				$migrationOrphanProductID = insertFor(
					"products",
					array(
						"productName" => TRANS_ORPHAN_PACKAGE_PRODUCT_FOR . " " . $this->migrationConfig["migrationConfigID"],
						"productActive" => 0,
						"productStopNumCycles" => 1,
						"productCancellationType" => getAPITypeID("cancellation", "admin_only"),
					)
				);
				
				if($syncMigrationIDs && ($migrationOrphanProductID < $raisePriorBalancePackageKeysBy)) {
					$newMigrationOrphanProductID = $migrationOrphanProductID + $raisePriorBalancePackageKeysBy;
					$s = updateForKey(
						"productsGeneric",
						$migrationOrphanProductID,
						array(
							"updateToID" => $newMigrationOrphanProductID
						)
					);
					$migrationOrphanProductID = $newMigrationOrphanProductID;
				}
				
				updateFor(
					"migrationConfigs",
					array(
						"migrationConfigID" => $this->migrationConfig["migrationConfigID"],
						"migrationOrphanProductID" => $this->migrationConfig["migrationOrphanProductID"] = $migrationOrphanProductID,
					)
				);
			}
			if (!(int) $this->migrationConfig["migrationProductID"]){
				$migrationProductID = insertFor(
					"products",
					array(
						"productName" => TRANS_PRIOR_BALANCE_PRODUCT_FOR . " " . $this->migrationConfig["migrationConfigID"],
						"productActive" => 0,
						"productStopNumCycles" => 1,
						"productCancellationType" => getAPITypeID("cancellation", "admin_only"),
					)
				);
				
				if($syncMigrationIDs && ($migrationProductID < $raisePriorBalancePackageKeysBy)) {
					$newMigrationProductID = $migrationProductID + $raisePriorBalancePackageKeysBy;
					$s = updateForKey(
						"productsGeneric",
						$migrationProductID,
						array(
							"updateToID" => $newMigrationProductID
						)
					);
					$migrationProductID = $newMigrationProductID;
				}
				
				updateFor(
					"migrationConfigs",
					array(
						"migrationConfigID" => $this->migrationConfig["migrationConfigID"],
						"migrationProductID" => $this->migrationConfig["migrationProductID"] = $migrationProductID,
					)
				);
			}

			if ($this->currencyID){
				$currencyID = $this->currencyID;
			} else {
				$this->paymentGroupInfo = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
						),
					),
				)));
				$this->currencyID = $currencyID = $this->paymentGroupInfo["paymentGroupCurrencyID"];
				dbg("GOT CURRENCY ID OF: ".$currencyID);
			}
			
			$q =& new MBQuery("GetEmailTemplateGroups", "");
			$r =& $q->getResult();
			$s =& $r->getSubjectFrom(array("mbapi", "results", "emailTplGroups", "emailTplGroup"));
			$t =& $s->getTable();
			$t->setKey("emailActionID");
			$emailActionIDs = $t->getKeys();
				
			//show($clientMigration);

			// connect to v4
			$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$this->dbr->autoRollback = true;
			$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$this->dbr->IsConnected()) {
				$e = "Could not connect to the database, please check your config options.";
				break;
			}


			switch ($migrationConfig["migrationType"]){
				/**
				* WHMCS migration
				*/
				case getAPITypeID("migration", "whmcs351"):
//////////////////////////////////////////////////////////
					$encType = "lek";
					/**
					 * implementation of python reverse engineered alg and key
					 */
					function WHMCSPasswordDecrypt($string){
						$key = "N5a8ej8WndK$3#9Ua425!hg741Kkn";
						if (!$string) return "";
						$string = base64_decode($string);
						for ($i=0; $i<strlen($string); $i++){
							$string[$i] = chr(ord($string[$i]) - ord($key[$i%strlen($key)]));
						}
						return $string;
					}
					

					$dotComTLD = oneOf(":TLDs", array(
						"tldExtension" => "com",
					));
					unset($dotComTLD["tldID"]);
					unset($dotComTLD["tldExtension"]);
					unset($dotComTLD["tldName"]);
					unset($dotComTLD["tldWhoisServer"]);
					unset($dotComTLD["tldWhoisResp"]);
					unset($dotComTLD["tldDisplayOrder"]);

					$configurations = array();
					$q =& new QueryMaster("select", $this->dbr);
					$q->enableManualJoining();
					$q->addColumns("tblconfiguration.*");
					$cs = $q->getResults();
					foreach ($cs as $c){
						$configurations[$c["setting"]] = $c["value"];
					}
					
					$systemlanguageName = $configurations["Language"];
					$language = oneOf("languages", array("languageName" => $systemlanguageName));
					$languageID = $language["languageID"];
					
					//show($systemlanguageISO2);
					//show($languageID);
		
					if($clientID) {
						$override = true;
						$clientIDs = explode(" ", $clientID);
						$reservedClients = count($clientIDs);
						$totalClients = count($clientIDs);
						foreach($clientIDs as $clientID) {
							show("Overriding for $clientID");
							show("Pruning...");
							
							// getting v5 ID
							if($mapping = oneOf(
									"migrationMappings",
									array(
										"migrationObjID" => $clientMigrationID,
										"migrationIntID" => $clientID,
									)
								)) {
								
								$migrationMappingID = $mapping["migrationMappingID"];
								show("deleting mapping $migrationMappingID");
								deleteForKey("migrationMappings", $migrationMappingID);
								
								$extClientID = $mapping["migrationExtID"];
								show("deleting v5 client $clientID which was v4 client $extClientID");
								deleteForKey("clientsGeneric", $clientID);
								
								show("Pruned.");
							} else {
								show("Did not need pruning.");
							}
							
							show("Reserving...");
							$id = str_pad($clientID, 10, "0", STR_PAD_LEFT);
							insertFor(
								"migrationReservations",
								array(
									"migrationObjID" => $clientMigrationID,
									"migrationExtID" => $id,
									"adminID" => $adminID,
								)
							);
							show("Reserved.");
						}
					} else {
						$override = false;
						$q =& new MBQuery(
							"ProcessReservations", "",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjID" => $clientMigrationID,
								"numReservations" => $clientProcessStep,
								"adminID" => $adminID,
							)
						);
						$r =& $q->getResult();
		
						$s = $r->getSubjectFrom(array("mbapi", "results", 0));
						$results = $s->getCollapsed();
						show($results);
						$reservedClients = $results["reserved"];
						$totalClients = $results["total"];
						$clientIDs = $results["reservations"]["reservedID"];
					}
					
					if($clientIDs) {
						// find out which clients to migrate in this process
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("tblclients");
						$q->addColumns("tblclients.*");
						$q->addAndClause("id", "=", $clientIDs);
						$t =& $q->getTable(NULL, NULL, "id", "email");
						$extClients = $t->getAssociated();
					} else {
						$extClients = array();
					}
					
					$finishedClients = (int) countFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $clientMigrationID,
						)
					);
					echo '<script language="javascript">parent.updateNumClients(' . $finishedClients . ');</script>';
					flush();
					
					//show($extClients);
					
					// migrate each client
					foreach($extClients as $extClientID => $extClient) {
					
						/**
						* actually migrate the data
						*/
						switch($extClient["status"]) {
							case "Inactive":
								$clientStatus = getAPIStatusID("client", "inactive");
								$clientActive = 0;
								break;
							default:
								$clientStatus = getAPIStatusID("client", "none");
								$clientActive = 1;
								break;
						}
						if(strtoupper($extClient["country"]) == "UK") {
							$extClient["country"] = "GB";
						}
						if (!$extClient["country"]){
							if (!$MBCompany) $MBCompany = oneOf(":companies");
							$country = oneOf("countries", array(
								"countriesID" => $MBCompany["countriesID"],
							));
							$countriesID = $country["countriesID"];
						} else {
							$country = oneOf("countries", array("countriesISO2" => strtoupper($extClient["country"])));
							$countriesID = $country["countriesID"];
						}
						$taxIDNumber = $extClient["taxexempt"];
						
						if (!$extClient["cardtype"]){
							$noshares = true;
							$billingAccountType = getAPITypeID("billingAccount", "card");
						} else {
							$noshares = false;
						}
						
						$lekObject = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfig["migrationConfigID"], "migrationObjName" => "lek"));
						$whmcsEncryptionHashSalt = $lekObject["migrationExtObjName"];
						$billingCardNum = $this->dbr->GetOne("SELECT AES_DECRYPT('".$extClient["cardnum"]."','54X6zoYZZnS35o6m5gEwGmYC6'".$whmcsEncryptionHashSalt."') as plainCardNumber");
						$billingCardNum = preg_replace("/[^0-9]/", "", $billingCardNum);
						$billingCardType = getCardTypeID($billingCardNum);
						//show($billingCardNum);
						//exit;
						if(validateCard($billingCardNum)) {
							$lastFour = substr($billingCardNum, -4);
						} else {
							$lastFour = "XXXX";
						}
						
						$expiration = $this->dbr->GetOne("SELECT AES_DECRYPT('".$extClient["expdate"]."','54X6zoYZZnS35o6m5gEwGmYC6'".$whmcsEncryptionHashSalt."') as plainExpiration");
						$billingCardExpMonth = (int)($expiration[0].$expiration[1]);
						$billingCardExpYear = (int)substr($expiration, 2);
						
						$startdate = $this->dbr->GetOne("SELECT AES_DECRYPT('".$extClient["startdate"]."','54X6zoYZZnS35o6m5gEwGmYC6'".$whmcsEncryptionHashSalt."') as plainStartdate");
						$billingCardStartDate = $startdate[0].$startdate[1]."/".substr($startdate, 2);
						
						$billingCardIssueNum = $this->dbr->GetOne("SELECT AES_DECRYPT('".$extClient["issuenumber"]."','54X6zoYZZnS35o6m5gEwGmYC6'".$whmcsEncryptionHashSalt."') as plainIssueNum");
						
						$intClient = array(
							"clientCompany" => quoteXMLconvert($extClient["companyname"]),
							"companyID" => 1,
							"clientStatus" => $clientStatus,
							"applyTax" => (int)(bool)$extClient["taxexempt"],
							"taxIDNumber" => $extClient["taxexempt"],
							"themeID" => 1,
							"countriesID" => $countriesID,
							"clientActive" => $clientActive,
							"clientDateCreated" => strtotime($extClient["datecreated"]),
						);
						
						if(!$intClientID = insertFor("clientsGeneric", $intClient, NULL)) {
							$e = "Problem inserting client: " . lastError() . ".";
							show($intClient);
							show(toXML($intClient));
							break 3;
						}
						
						if($extClient["notes"]) {
							if(!insertFor(
								"clientNotes",
								array(
									"clientID" => $intClientID,
									"adminID" => $adminID,
									"clientNoteDateCreated" => time(),
									"clientNoteText" => quoteXMLconvert($extClient["notes"]),
								)
							)) {
								$e = "Problem inserting client note: " . lastError() . ".";
								break 3;
							}
						}
						$username = substr($extClient["email"], 0, strpos($extClient["email"], "@"))."_".$extClientID;
						$intPrimaryContact = array(
							"applyFilters" => "no",
							"clientID" => $intClientID,
							"contactPrimary" => 1,
							"contactUsername" => $username,
							"contactPassword" => $clientPassword = WHMCSPasswordDecrypt($extClient["password"]),
							"contactFirstName" => quoteXMLconvert($extClient["firstname"]),
							"contactLastName" => quoteXMLconvert($extClient["lastname"]),
							"contactEmail" => quoteXMLconvert($extClient["email"]),
							"contactEmailFormat" => 0,
							"contactCompany" => quoteXMLconvert($extClient["companyname"]),
							"contactAddress1" => quoteXMLconvert($extClient["address1"]),
							"contactAddress2" => quoteXMLconvert($extClient["address2"]),
							"contactCity" => quoteXMLconvert($extClient["city"]),
							"contactState" => quoteXMLconvert($extClient["state"]),
							"contactZip" => quoteXMLconvert($extClient["postcode"]),
							"languageID" => $languageID,
							"countriesID" => $countriesID,
							"contactPhone1" => quoteXMLconvert($extClient["phonenumber"]),
							"contactDateCreated" => strtotime($extClient["datecreated"]),
							"contactActive" => 1,
						);
						
						if(!$intPrimaryContactID = insertFor("contacts", $intPrimaryContact)) {
							// try again with username filler
							$intPrimaryContact["contactUsername"] .= "_" . dechex(rand());
							if(!$intPrimaryContactID = insertFor("contacts", $intPrimaryContact)) {
								$e = "Problem inserting primary contact: " . lastError() . ".";
								show($intPrimaryContact);
								show(toXML($intPrimaryContact));
								break 2;
							}
						}
						
						foreach($emailActionIDs as $emailActionID) {
							if(insertFor("contactEmailActionRels", array("clientContactID" => $intPrimaryContactID, "emailActionID" => $emailActionID)) === false) {
								$e = "Problem assigning email action ID $emailActionID to contact ID $intPrimaryContactID: " . lastError() . ".";
								break 3;
							}
						}
						
						$intBillingAccount = array(
							"clientContactID" => $intPrimaryContactID,
							"billingCardNameOnCard" => quoteXMLconvert($extClient["firstname"] . " " . $extClient["lastname"]),
							"billingCardType" => $billingCardType,
							"billingCardNum" => quoteXMLconvert($billingCardNum),
							"billingCardExpYear" => quoteXMLconvert($billingCardExpYear),
							"billingCardExpMonth" => quoteXMLconvert($billingCardExpMonth),
							"billingCardIssueNum" => $billingCardIssueNum,
							"billingCardStartDate" => $billingCardStartDate,
							"billingAccountNumLastFour" => quoteXMLconvert($lastFour),
							"billingAccountType" => $billingAccountType,
							"billingAccountStatus" => getAPIStatusID("billingAccount", "normal"),
						);
						
						if(!$intBillingAccountID = insertFor("billingAccounts", $intBillingAccount)) {
							$e = "Problem inserting billing account: " . lastError() . ".";
							show($intBillingAccount);
							show(toXML($intBillingAccount));
							break 2;
						}
						
						if(!updateForKey("clientsGeneric", $intClientID, array("defaultBillingAccountID" => $intBillingAccountID))) {
							$e = "Problem updating default billing account: " . lastError() . ".";
							break 2;
						}
						
						// importing the invoices
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addColumns("tblinvoices.*");
						$q->addAndClause("userid", "=", $extClientID);
						$extInvoices = $q->getResults();
						$extInvoiceIDs = array();
						foreach ((array)$extInvoices as $ei){
							$extInvoiceIDs[] = $ei["id"];
						}
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addColumns("tblinvoiceitems.*");
						$q->addAndClause("invoiceid", "=", $extInvoiceIDs);
						$items = $q->getResults();
						$extInvoiceItems = array();
						foreach ((array)$items as $eii){
							$extInvoiceItems[$eii["invoiceid"]][] = $eii;
						}
						
						foreach ((array)$extInvoices as $invoice){
							$description = "
								Migrated Invoice: ".$invoice["id"]."
								<table width='100%'>
									<tr>
										<td>Package</td>
										<td>Type</td>
										<td>Taxed</td>
										<td>Amount</td>
									</tr>
							";
							foreach ((array)$extInvoiceItems[$invoice["id"]] as $items){
								$description .= "
									<tr>
										<td>".$item["description"]."</td>
										<td>".$item["type"]."</td>
										<td>".($item["taxed"]==1?"Yes":"No")."</td>
										<td>".$item["amount"]."</td>
									</tr>
								";
							}
							$description .= "
									<tr>
										<td align='right' colspan='3'>SubTotal</td>
										<td>".$invoice["subtotal"]."</td>
									</tr>
									<tr>
										<td align='right' colspan='3'>Credit</td>
										<td>".$invoice["credit"]."</td>
									</tr>
									<tr>
										<td align='right' colspan='3'>Tax</td>
										<td>".$invoice["tax"]."</td>
									</tr>
									<tr>
										<td align='right' colspan='3'>Total</td>
										<td>".$invoice["total"]."</td>
									</tr>
								</table>
							";
							$params = array(
								"clientID" => $intClientID,
								"packageName" => TRANS_HISTORICAL_INVOICE,
								"packageDescription" => $description,
								"amount" => $invoice["total"],
								"invoiceDate" => strtotime($invoice["date"]),
								"cycleID" => 0,
								"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
								"enableInvoiceEmail" => 0,
								"amountPaid" => $invoice["status"]=="Paid" ? $invoice["total"] : 0,
								"paymentComments" => "",
								"transactionDateCreated" => $invoice["datepaid"],
								"enablePaymentEmail" => 0,
								"billingAccountID" => $intBillingAccountID,
							);
							
							if ($invoice["status"]!="Paid"){
								unset($params["amountPaid"]);
								unset($params["paymentComments"]);
								unset($params["transactionDateCreated"]);
								unset($params["enablePaymentEmail"]);
								unset($params["billingAccountID"]);
							}
							
							$results = dispatchMBAPI($x = array(
								"mbapi" => array(
									"command" => "ProcessSingleInvoice",
									"params" => $params,
								),
							), 1);
							
							$invoiceID = $results["mbapi"][0]["results"][0]["invoiceID"];
							$invoiceID = is_array($invoiceID) ? (int)$invoiceID[0] : 0;
						}
						
						// find out which domains to migrate in this process
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addColumns("tbldomains.*");
						$q->addAndClause("userid", "=", $extClientID);
						$extDomains = $q->getResults();
						$extDomainsByID = array();
						foreach ($extDomains as $d){
							$extDomainsByID[$d["id"]] = $d;
						}
		
						$clientPackages = array();
						// find out which packages to migrate for this client
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addColumns("tblhosting.*");
						$q->addAndClause("userid", "=", $extClientID);
						$q->addAndClause("billingcycle", "<>", "One Time", "s");
						$packages = $q->getResults();
						foreach ((array)$packages as $pk){
							$clientPackages[$pk["id"]] = $pk;
							$clientPackages[$pk["id"]]["isHosting"] = true;
						}
						$packageIDs = array_keys($clientPackages);

						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addColumns("tblhostingaddons.*");
						$q->addAndClause("billingcycle", "<>", "One Time", "s");
						$q->addAndClause("hostingid", "=", $packageIDs);
						$packages = $q->getResults();
						foreach ((array)$packages as $pk){
							if ($pk["billingcycle"]!=$clientPackages[$pk["hostingid"]]["billingcycle"]){
								// put addon in main packages array...
								$clientPackages["addon".$pk["id"]] = array(
									"isAddon" => true,
									"packageid" => "ADDON".$pk["hostingid"],
									"domain" => $clientPackages[$pk["hostingid"]]["domain"],
									"domainstatus" => $pk["status"],
									"billingcycle" => $pk["billingcycle"],
									"amount" => $pk["recurring"],
									"firstpaymentamount" => $pk["setup"] + $pk["recurring"],
									"regdate" => $pk["regdate"],
									"nextinvoicedate" => $pk["nextinvoicedate"],
									"id" => "addon_".$pk["id"],
									"parentID" => $pk["hostingid"],
								);
							} else {
								$clientPackages[$pk["hostingid"]]["addons"][] = $pk;
							}
						}

						if (!$whmcsProducts){

							$q =& new QueryMaster("select", $this->dbr);
							$q->addColumns("tblproducts.*"); 
							$prods = $q->getResults();
							$whmcsProducts = array();
							foreach ((array)$prods as $wprod){
								$whmcsProducts[$wprod["id"]] = $wprod;
							}
						
							$q =& new QueryMaster("select", $this->dbr);
							$q->addColumns("tbladdons.*"); 
							$prods = $q->getResults();
							$whmcsAddons = array();
							foreach ((array)$prods as $wprod){
								$whmcsAddons[$wprod["id"]] = $wprod;
							}
						
							$q =& new QueryMaster("select", $this->dbr);
							$q->addColumns("tbldomainpricing.*"); 
							$q->addOrderByColumns("id", "ASC");
							$domainPrices = $q->getResults();
							$whmcsDomains = array();
							foreach ((array)$domainPrices as $dprice){
								$tld = $dprice["extension"];
								if ($tld[0]==".") $tld = substr($tld, 1);
								$whmcsDomains[$tld] = $dprice;
							}
						
						}
						
						// migrate domains
						$intDomains = array();
						$domainMappings = array();
						foreach((array)$extDomains as $extDomain) {
							$domainName = $extDomain["domain"];
							$extDomainID = $extDomain["id"];
							list($domainSLD, $domainTLD) = explode(".", $domainName, 2);
							$extRegistrar = $extDomain["registrar"];
							$registrarMappings = oneOf(
								"migrationMappings",
								array(
									"migrationConfigID" => $migrationConfigID,
									"migrationObjID" => $registrarMigrationID,
									"migrationExtID" => abs(crc32($extRegistrar)),
								)
							);
							$intRegistrarID = $registrarMappings["migrationIntID"];
							$defaultRegistrarID = (!$defaultRegistrarID) ? $intRegistrarID : $defaultRegistrarID;
							
							$q =& new MBQuery(
								"SetDomains",
								"insert",
								$intDomain = array(
									"domainSLD" => $domainSLD,
									"domainTLD" => $domainTLD,
									"registrarID" => $intRegistrarID,
									"domainDateCreated" => strtotime($extDomain["registrationdate"]),
									"domainDateExpires" => strtotime($extDomain["expirydate"]),
									"domainRenewType" => getAPITypeID("tldRenew", "disabled"),
								)
							);
							$r =& $q->getResult();
							if($r->getSuccess()) {
								$intDomainID = $r->getLastInsertID();
								$intDomain["domainID"] = $intDomainID;
								$intDomains[trim($domainName)] = $intDomain;
								
								$domainMappings[$extDomain["id"]] = $intDomainID;
								
								echo "Migrated domain $domainName ID $extDomainID as $intDomainID <br />";
								flush();
								$thisDomainPricing = $whmcsDomains[$domainTLD];
								$clientPackages["domain".$intDomainID] = array(
									"id" => $extDomain["id"],
									"isDomain" => true,
									"domainID" => $intDomainID,
									"regdate" => $extDomain["registrationdate"],
									"nextinvoicedate" => $extDomain["nextinvoicedate"],
									"domain" => $extDomain["domain"],
									"billingcycle" => "annual",
									"numCycles" => $extDomain["registrationperiod"],
									"firstpaymentamount" => $extDomain["firstpaymentamount"],
									"amount" => $extDomain["recurringamount"],
									"domainstatus" => $extDomain["status"],
									"notes" => $extDomain["additionalnotes"],
									"domainSLD" => $domainSLD,
									"domainTLD" => $domainTLD,
								);
							} else {
								show("== error inserting domain record ==");
								show($r, 1);
								$intDomainID = NULL;
							}
						}
						
						dbg($clientPackages);
						
						// migrate packages
						foreach($clientPackages as $extPackageID => $extPackage) {
							
							if ($extPackage["isDomain"]){
							
								$extProductID = "DOMAIN";
								$extPackageID = $extPackage["id"];
								
								//$extPackData = $wmhcsProducts[$extProductID];
								$packageComments = "";
								show("== Handling product $extProductID ==");
								
								if(!$extProductID) {
									$intProductID = $this->migrationConfig["migrationOrphanProductID"];
									show("Orphaned package. Using foster product ID $intProductID.");
								} else {
									$extProductID = abs(crc32($extProductID));
									if($this->productIDCache->exists($extProductID)) {
										$intProductID = $this->productIDCache->get($extProductID);
										show("Found ID $intProductID in cache.");
									} else {
										$productMapping = oneOf("migrationMappings", array(
											"migrationConfigID" => $migrationConfigID,
											"migrationObjID" => $productMigrationID,
											"migrationExtID" => $extProductID,
										));
										$intProductID = $productMapping["migrationIntID"];
										$this->productIDCache->set($extProductID, $intProductID);
										show("Found ID $intProductID in mapping.");
									}
								}
								show("Finished handling product.");
								
								if(isset($this->productCache[$intProductID])) {
									$intProduct = $this->productCache[$intProductID];
								} else {
									$intProduct = oneByID("products", $intProductID);
								}
							
								$extDomain = $extPackage["domain"];
	/*							foreach ((array)$intDomains as $dn=>$dninfo){
									if (substr(strtolower($extDomain), -strlen($dn))==strtolower($dn)){
										$extDomain = $dn;
									}
								}*/
								
								if (!($intTLD = $TLDCache[$extPackage["domainTLD"]])){
									$intTLD = oneOf(":TLDs", array(
										"tldExtension" => $extPackage["domainTLD"],
									));
									if (!$intTLD){
										$intTLD = oneByID(":TLDs", insertFor(":TLDs", array(
											"tldExtention" => $extPackage["domainTLD"],
											"tldName" => $extPackage["domainTLD"]." ".TRANS_DOMAINS,
											"tldActive" => 1,
										) + $dotComTLD));
									}
									$TLDCache[$extPackage["domainTLD"]] = $intTLD;
								}
								$intVariant = oneOf("productVariants", array(
									"productID" => $intProductID,
									"tldID" => $intTLD["tldID"],
								));
								if (!$intVariant){
									$intVariant = oneByID(":productVariants", insertFor(":productVariants", array(
										"productVariantDisplayName" => TRANS_VARIANT_FOR.": dot ".$intTLD["tldExtention"],
										"productVariantActive" => 0,
										"productID" => $intProductID,
										"tldID" => $intTLD["tldID"],
									)));
								}
								
								$taxZoneGroupID = $intVariant["taxZoneGroupID"];
								
								$packageActive = 0;
								$packageStatus = getAPIStatusID("package", "none");
								switch(strtolower($extPackage["domainstatus"])){
									case "suspended": // suspended
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "suspended");
										break;
									case "active": // active/on
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "none");
										break;
									case "pending": // new/still in queue
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "pending");
										break;
									case "cancelled": // canceled
									case "terminated": // canceled
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "canceled");
										break;
									case "fraud": // fraud
										$packageActive = 0;
										$packageStatus = getAPIStatusID("package", "fraudulent");
										break;
								}
								$packageStatusName = getAPIStatusName("package", $packageStatus);
								$packageCycle = $extPackage["billingcycle"];
				
								$getFields = array();
								$getFields["cycleNumYears"] = $extPackage["numCycles"];
								
								$cycle = oneOf(":cycles", $getFields);
								if (!$cycle){
									$cycle = oneByID(":cycles", insertFor(":cycles", array(
										"cycleDisplayName" => "TRANS_".strtoupper($packageCycle),
									) + $getFields));
								}
								$intCycleID = $cycle["cycleID"];
				
								// get price data from product
								$extPackPrice = $extPackage["amount"];
								$extPackSetup = (($diff = $extPackage["firstpaymentamount"]-$extPackage["amount"])>0) ? $diff : 0 ;
								$intPrice = $extPackPrice;
								$intSetup = $extPackSetup;
								
								$packageName = $intProduct["productName"];// . ($extDomain ? (' - ' . $extDomain) : "");
			
								show("=== Package Details ===");
								show("Name: ${packageName}");
								show("Cycle: ${packageCycle}");
								show("Cycle Type: ${cycleType}");
								show("pack_price: " . $intPrice);
								show("pack_setup: " . $intSetup);
								
								$intPackage = array(
									"clientID" => $intClientID,
									"productID" => $intProductID,
									"taxZoneGroupID" => $taxZoneGroupID,
									"packageName" => quoteXMLconvert($packageName),
									"packageQuantity" => 1,
									"packageComments" => quoteXMLconvert($packageComments),
									"packageProratable" => 0,
									"packageDateCreated" => $createDate = strtotime($extPackage["regdate"]),
									"packageDateBeginRenewal" => $createDate,
									"packageDateLastRenewal" => (($lastRenewal = getLastBillingTimestamp($nextInvoiceDate = strtotime($extPackage["nextinvoicedate"]), $intCycleID)) < $createDate) ? $createDate : $lastRenewal,
									"packageDateNextRenewal" => ($nextInvoiceDate) ? $nextInvoiceDate : $createDate,
									"packageActive" => $packageActive,
									"packageStatus" => $packageStatus,
									"packageType" => $intProduct["productType"],
									"packageOriginalPrice" => (float) $intPrice,
									"packagePrice" => (float) $intPrice,
									"packageSetup" => (float) $intSetup,
									"packageDiscount" => 0,
									"packageDiscountable" => 1,
									"packagePriceLock" => 0,
									"cycleID" => $intCycleID,
									"AffCode" => quoteXMLconvert($extPackage["aff_code"]),
									"AffDateLastPaid" => $extPackage["aff_last_paid"],
									"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
									"packageCancellationType" => getAPITypeID("cancellation", "admin_suspend"),
								);
								
								if(!$intPackageID = insertFor("packagesGeneric", $intPackage, NULL)) {
									
									$e = "Problem inserting package: " . lastError() . ".";
									//show($intPackage);
									show(toXML($intPackage));
									break 3;
								}
								
								if ($extPackage["domainID"]){
									insertFor(":packageDomainRels", array(
										"packageID" => $intPackageID,
										"domainID" => $extPackage["domainID"],
									));
								}
								
								show("Client ID $extClientID => $intClientID");
								show("Product ID $extProductID => $intProductID");
								show("Package ID $extPackageID => $intPackageID");
								
							
							} else {
							
								$extProductID = $extPackage["packageid"];
								$extPackData = $wmhcsProducts[$extProductID];
								$packageComments = "";
								show("== Handling product $extProductID ==");
								
								if(!$extProductID) {
									$intProductID = $this->migrationConfig["migrationOrphanProductID"];
									show("Orphaned package. Using foster product ID $intProductID.");
								} else {
									$extProductID = abs(crc32(($extPackage["isHosting"]?"PRODUCT":"ADDON").$extProductID));
									if($this->productIDCache->exists($extProductID)) {
										$intProductID = $this->productIDCache->get($extProductID);
										show("Found ID $intProductID in cache.");
									} else {
										$productMapping = oneOf("migrationMappings", array(
											"migrationConfigID" => $migrationConfigID,
											"migrationObjID" => $productMigrationID,
											"migrationExtID" => $extProductID,
										));
										$intProductID = $productMapping["migrationIntID"];
										$this->productIDCache->set($extProductID, $intProductID);
										show("Found ID $intProductID in mapping.");
									}
								}
								show("Finished handling product.");
								
								if(isset($this->productCache[$intProductID])) {
									$intProduct = $this->productCache[$intProductID];
								} else {
									$intProduct = oneByID("products", $intProductID);
								}
							
								$extDomain = trim($extPackage["domain"]);
	/*							foreach ((array)$intDomains as $dn=>$dninfo){
									if (substr(strtolower($extDomain), -strlen($dn))==strtolower($dn)){
										$extDomain = $dn;
									}
								}*/
								
								$intTLD = NULL;
								$intVariant = oneOf("productVariants", array("productID" => $intProductID));
								
								$taxZoneGroupID = $intVariant["taxZoneGroupID"];
								
								$packageActive = 0;
								$packageStatus = getAPIStatusID("package", "none");
								switch($extPackage["domainstatus"]) {
									case "Suspended": // suspended
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "suspended");
										break;
									case "Active": // active/on
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "none");
										break;
									case "Pending": // new/still in queue
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "pending");
										break;
									case "Cancelled": // canceled
									case "Terminated": // canceled
										$packageActive = 1;
										$packageStatus = getAPIStatusID("package", "canceled");
										break;
									case "Fraud": // fraud
										$packageActive = 0;
										$packageStatus = getAPIStatusID("package", "fraudulent");
										break;
								}
								$packageStatusName = getAPIStatusName("package", $packageStatus);
								$packageCycle = $extPackage["billingcycle"];
								if ($packageCycle=="Free Account"){
									$packageCycle = "Monthly";
								}
								if ($packageCycle=="One Time"){
									continue; // we don't need to import things that are one time or free.
								}
				
								$getFields = array();
								switch (strtolower($packageCycle)){
									case "monthly":
										$getFields["cycleNumMonths"] = 1;
									break;
									case "quarterly":
										$getFields["cycleNumMonths"] = 3;
									break;
									case "semiannual":
										$getFields["cycleNumMonths"] = 6;
									break;
									case "annual":
										$getFields["cycleNumYears"] = 1;
									break;
									case "biennial":
										$getFields["cycleNumYears"] = 2;
									break;
								}
								
								$cycle = oneOf(":cycles", $getFields);
								if (!$cycle){
									$cycle = oneByID(":cycles", insertFor(":cycles", array(
										"cycleDisplayName" => "TRANS_".strtoupper($packageCycle),
									) + $getFields));
								}
								$intCycleID = $cycle["cycleID"];
				
								// get price data from product
								$extPackPrice = $extPackage["amount"];
								$extPackSetup = (($diff = $extPackage["firstpaymentamount"]-$extPackage["amount"])>0) ? $diff : 0 ;
								$intPrice = $extPackPrice;
								$intSetup = $extPackSetup;
								
								$packageName = $intProduct["productName"];// . ($extDomain ? (' - ' . $extDomain) : "");
			
								show("=== Package Details ===");
								show("Name: ${packageName}");
								show("Cycle: ${packageCycle}");
								show("Cycle Type: ${cycleType}");
								show("pack_price: " . $intPrice);
								show("pack_setup: " . $intSetup);
								
								$intPackage = array(
									"clientID" => $intClientID,
									"productID" => $intProductID,
									"parentPackageID" => $extIDs2IntIDs[$extPackage["parentID"]],
									"taxZoneGroupID" => $taxZoneGroupID,
									"packageName" => quoteXMLconvert($packageName),
									"packageQuantity" => 1,
									"packageComments" => quoteXMLconvert($packageComments),
									"packageProratable" => 0,
									"packageDateCreated" => $createDate = strtotime($extPackage["regdate"]),
									"packageDateBeginRenewal" => $createDate,
									"packageDateLastRenewal" => (($lastRenewal = getLastBillingTimestamp($nextInvoiceDate = strtotime($extPackage["nextinvoicedate"]), $intCycleID)) < $createDate) ? $createDate : $lastRenewal,
									"packageDateNextRenewal" => ($nextInvoiceDate) ? $nextInvoiceDate : $createDate,
									"packageActive" => $packageActive,
									"packageStatus" => $packageStatus,
									"packageType" => $intProduct["productType"],
									"packageOriginalPrice" => (float) $intPrice,
									"packagePrice" => (float) $intPrice,
									"packageSetup" => (float) $intSetup,
									"packageDiscount" => 0,
									"packageDiscountable" => 1,
									"packagePriceLock" => 0,
									"cycleID" => $intCycleID,
									"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
									"packageCancellationType" => getAPITypeID("cancellation", "admin_suspend"),
								);
								
								if(!$intPackageID = insertFor("packagesGeneric", $intPackage, NULL)) {
									
									$e = "Problem inserting package: " . lastError() . ".";
									//show($intPackage);
									show(toXML($intPackage));
									break 3;
								}
								
								$extIDs2IntIDs[$extPackage["id"]] = $intPackageID;
								
								if ($extPackage["domain"]){
									if ($intDomain = $intDomains[trim($extPackage["domain"])]){
										insertFor(":packageDomainRels", array(
											"packageID" => $intPackageID,
											"domainID" => $intDomain["domainID"],
										));
									} else {
										$domainPieces = explode(".", $extPackage["domain"], 2);
										insertFor(":packageDomainRels", array(
											"packageID" => $intPackageID,
											"domainID" => insertFor(":packageDomains", array(
												"domainSLD" => $domainPieces[0],
												"domainTLD" => $domainPieces[1],
												"domainActive" => 1,
												"domainDateCreated" => $createDate,
												"domainRenewType" => 0,
											)),
										));
									}
								}
								
								show("Client ID $extClientID => $intClientID");
								show("Product ID $extProductID => $intProductID");
								show("Package ID $extPackageID => $intPackageID");
								
								foreach ((array)$extPackage["addons"] as $addon){
									$extAddonInfo = $whmcsAddons[$extAddonID = $addon["id"]];
									$extAddonID = abs(crc32("ADDON".$extAddonID));
									if($this->productIDCache->exists($extAddonID)) {
										$intAddonID = $this->productIDCache->get($extAddonID);
										show("Found ID $intAddonID in cache.");
									} else {
										$productMapping = oneOf("migrationMappings", array(
											"migrationConfigID" => $migrationConfigID,
											"migrationObjID" => $productMigrationID,
											"migrationExtID" => $extAddonID,
										));
										$intAddonID = $productMapping["migrationIntID"];
										$this->productIDCache->set($extAddonID, $intAddonID);
										show("Found ID $intAddonID in mapping.");
									}
									
									$intProduct = oneByID(":products", $intAddonID);
									$thisVariant = oneOf(":productVariants", array(
										"productID" => $intAddonID,
									));
									
									insertFor(":packageAddons", array(
										"packageID" => $intPackageID,
										"packageAddonDisplayName" => $addon["name"],
										"packageAddonOriginalPrice" => $addon["recurring"],
										"packageAddonPrice" => $addon["recurring"],
										"packageAddonSetup" => $addon["setupfee"],
										"packageAddonDiscount" => 0,
										"packageAddonDiscountable" => $intProduct["productDiscountable"],
										"packageAddonActive" => $addon["status"]=="Active" ? 1 : 0,
										"packageAddonProductID" => $intAddonID,
										"taxZoneGroupID" => $thisVariant["taxZoneGroupID"],
									));
									
								}
								
								
							} // end domain vs product if....
							
							
							if(!$noshares) {
								$q =& new MBQuery(
									"SetBillingAccountShare",
									"insert",
									array(
										"billingAccountID" => $intBillingAccountID,
										"packageID" => $intPackageID,
										"billingAccountShareGroup" => 0,
										"billingAccountShareValue" => 1,
										"billingAccountFallbackGroup" => 1,
									)
								);
								$r =& $q->getResult();
								if(!$r->getSuccess()) {
									$e = "Problem setting billing account shares for billing account ID $intBillingAccountID for package ID $intPackageID for client ID $intClientID: : " . lastError() . ".";
									break 3;
								}
							}
							
							echo "Associated billing account $intBillingAccountID with with package $intPackageID <br />";
							flush();
		
/////////////////////////////////////////////////////////////////////////////
							if ($extPackage["isHosting"]){
								
								if (!$intAttributes[$intProductID][0]){
									$intAttributes[$intProductID][0] = arrayFor(":productAttributes", array(
										"productID" => $intProductID,
										"serverGroupID" => 0,
									));
									show("=== GOT THE PRODUCT ATTRIBUTES FOR $intProductID : 0 ===");
								}
								
								$extPanelID = $extPackage["server"];
								show("== external panel ID ==");
								show($extPanelID);
								
								$panelMapping = oneOf(
									"migrationMappings",
									array(
										"migrationConfigID" => $migrationConfigID,
										"migrationObjID" => $panelMigrationID,
										"migrationExtID" => $extPanelID,
									)
								);
								show("== internal mappings ==");
								show($panelMapping);
								$configGroupID = $panelMapping["migrationIntID"];
								$serverGroup = oneOf("serverGroups", array("configGroupID" => $configGroupID));
								$serverGroupID = $serverGroup["serverGroupID"];
	
								if (!$intAttributes[$intProductID][$serverGroupID]){
									$intAttributes[$intProductID][$serverGroupID] = arrayFor(":productAttributes", array(
										"productID" => $intProductID,
										"serverGroupID" => $serverGroupID,
									));
									show("=== GOT THE PRODUCT ATTRIBUTES FOR $intProductID : $serverGroupID ===");
								}
								
								$basePackageAttribute = array(
									"packageID" => $intPackageID,
									"packageAttributeDateCreated" => mktime(),
								);
	
								foreach ((array)$intAttributes[$intProductID][0] as $attr){
									insertFor(":packageAttributes", $basePackageAttribute + array(
										"packageAttributeName" => $attr["productAttributeName"],
										"packageAttributeValue" => $attr["productAttributeValue"],
									));
								}
	
								$basePackageAttribute["serverGroupID"] = $serverGroupID;
								$basePackageAttribute["configGroupID"] = $configGroupID;
								foreach ((array)$intAttributes[$intProductID][$serverGroupID] as $attr){
									insertFor(":packageAttributes", $basePackageAttribute + array(
										"packageAttributeName" => $attr["productAttributeName"],
										"packageAttributeValue" => $attr["productAttributeValue"],
									));
								}
								
								$password = encryptPassword($clientPassword);
								$attributes = array(
									"clientLogin" => $extPackage["username"],
									"domainUserName" => $extPackage["username"],
									"clientPassword" => encryptPassword(WHMCSPasswordDecrypt($extPackage["password"])),
									"domainPassword" => encryptPassword(WHMCSPasswordDecrypt($extPackage["password"])),
									"panel_status" => strtolower($packageStatusName),
								);
								
								foreach ($attributes as $n=>$v){
									insertFor(":packageAttributes", $basePackageAttribute + array(
										"packageAttributeName" => $n,
										"packageAttributeValue" => $v,
									));
								}
	
							}
////////////////////////////////////////////////////////////////

							/** 
							* deal with migration state for the package
							*/
		
							// we are done migrating this package; now associate the external and internal IDs for archival purposes		
							if(!insertFor(
								"migrationMappings",
								array(
									"migrationConfigID" => $migrationConfigID,
									"migrationObjID" => $packageMigrationID,
									"migrationIntID" => $intPackageID,
									"migrationExtID" => $extPackageID,
								)
							)) {
								$e = lastError();
								break 3;
							}
							// signifies that we are done with this client
							if(!updateFor(
								"migrationObjs",
								array(
									"migrationObjID" => $packageMigrationID,
									"migrationExtSeqID" => $extPackageID,
								)
							)) {
								$e = lastError();
								break 3;
							}
		
							echo "Migrated package $extPackageID as $intPackageID <br />";
							flush();
						}
						
						/** 
						* deal with migration state for the client
						*/
		
						// we are done migrating this client; now associate the external and internal IDs for archival purposes		
						if(!insertFor(
							"migrationMappings",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjID" => $clientMigrationID,
								"migrationIntID" => $intClientID,
								"migrationExtID" => $extClientID,
							)
						)) {
							$e = lastError();
							break 2;
						}
						
						// signifies that we are done with this client
						if(!updateFor(
							"migrationObjs",
							array(
								"migrationObjID" => $clientMigrationID,
								"migrationExtSeqID" => $extClientID,
							)
						)) {
							$e = lastError();
							break 2;
						}
						
						echo "Migrated client $extClientID as $intClientID <br />";
						flush();
		
						echo '<script language="javascript">parent.updateNumClients(' . ++$finishedClients . ');</script>';
						flush();
					}
		
					if($extClients && !$override) {
						echo '<script language="javascript">parent.runMigrationLoad();</script>';
						flush();
					}
//////////////////////////////////////////////////////////
				break;
				case getAPITypeID("migration", "mb4"):


					// get the system lek info
					$q =& new QueryMaster("select", $this->dbr);
					$q->enableManualJoining();
					$q->addTables("config");
					$q->addColumns("config_1 as agree", "config_2 as lek_enabled", "config_3 as lek_pin", "config_4 as lek_type", "config_41 as lek_hash");
					$q->addAndClause("config_type", "=", "lek", "s");
					$lek = $q->getRow();
					
					if($lek["lek_hash"]) {
						$encType = "lek";
					} else {
						$encType = "passphrase";
						$lekObject = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfig["migrationConfigID"], "migrationObjName" => "lek"));
						$passphrase = $lekObject["migrationExtObjName"];
					}
		
					//show($lek);
		
					// get the system language ID
					$q =& new QueryMaster("select", $this->dbr);
					$q->enableManualJoining();
					$q->addTables("config");
					$q->addColumns("config_3");
					$q->addAndClause("config_type", "=", "main", "s");
					$systemlanguageISO2 = $q->getOne();
					$language = oneOf("languages", array("languageISO2" => $systemlanguageISO2));
					$languageID = $language["languageID"];
					
					//show($systemlanguageISO2);
					//show($languageID);
		
					if($clientID) {
						$override = true;
						$clientIDs = explode(" ", $clientID);
						$reservedClients = count($clientIDs);
						$totalClients = count($clientIDs);
						foreach($clientIDs as $clientID) {
							show("Overriding for $clientID");
							show("Pruning...");
							
							// getting v5 ID
							if($mapping = oneOf(
									"migrationMappings",
									array(
										"migrationObjID" => $clientMigrationID,
										"migrationIntID" => $clientID,
									)
								)) {
								
								$migrationMappingID = $mapping["migrationMappingID"];
								show("deleting mapping $migrationMappingID");
								deleteForKey("migrationMappings", $migrationMappingID);
								
								$extClientID = $mapping["migrationExtID"];
								show("deleting v5 client $clientID which was v4 client $extClientID");
								deleteForKey("clientsGeneric", $clientID);
								
								show("Pruned.");
							} else {
								show("Did not need pruning.");
							}
							
							show("Reserving...");
							$id = str_pad($clientID, 10, "0", STR_PAD_LEFT);
							insertFor(
								"migrationReservations",
								array(
									"migrationObjID" => $clientMigrationID,
									"migrationExtID" => $id,
									"adminID" => $adminID,
								)
							);
							show("Reserved.");
						}
					} else {
						$override = false;
						$q =& new MBQuery(
							"ProcessReservations", "",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjID" => $clientMigrationID,
								"numReservations" => $clientProcessStep,
								"adminID" => $adminID,
							)
						);
						$r =& $q->getResult();
		
						$s = $r->getSubjectFrom(array("mbapi", "results", 0));
						$results = $s->getCollapsed();
						show($results);
						$reservedClients = $results["reserved"];
						$totalClients = $results["total"];
						$clientIDs = $results["reservations"]["reservedID"];
					}
					
					if($clientIDs) {
						// find out which clients to migrate in this process
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("client_info");
						$q->addColumns("client_info.*");
						$q->addAndClause("client_id", "=", $clientIDs);
						$t =& $q->getTable(NULL, NULL, "client_id", "client_email");
						$extClients = $t->getAssociated();
					} else {
						$extClients = array();
					}
					
					$finishedClients = (int) countFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $clientMigrationID,
						)
					);
					echo '<script language="javascript">parent.updateNumClients(' . $finishedClients . ');</script>';
					flush();
					
					//show($extClients);
					
					// migrate each client
					foreach($extClients as $extClientID => $extClient) {
					
						/**
						* actually migrate the data
						*/
						switch($extClient["client_status"]) {
							case "1":
								$clientStatus = getAPIStatusID("client", "inactive");
								$clientActive = 1;
								break;
							case "2":
								$clientStatus = getAPIStatusID("client", "none");
								$clientActive = 1;
								break;
							case "3":
								$clientStatus = getAPIStatusID("client", "pending");
								$clientActive = 1;
								break;
							case "4":
								$clientStatus = getAPIStatusID("client", "canceled");
								$clientActive = 1;
								break;
							case "5":
								$clientStatus = getAPIStatusID("client", "fraudulent");
								$clientActive = 0;
								break;
						}
						if(strtoupper($extClient["client_country"]) == "UK") {
							$extClient["client_country"] = "GB";
						}
						$country = oneOf("countries", array("countriesISO2" => strtoupper($extClient["client_country"])));
						if(!$country) {
							$country  = oneOf("countries", array("countriesISO2" => "US"));
						}
						$countriesID = $country["countriesID"];
						$taxIDNumber = "";
						
						/*
						1 cc batch
						2 regular check
						3 cc single
						4 echeck
						5 paypal
						6 worldpay
						50 other
						*/
						$noshares = false;
						switch($extClient["billing_method"]) {
							case 3: // CC Single
								$noshares = true;
							case 1: // CC Batch
								$billingAccountType = getAPITypeID("billingAccount", "card");
								break;
							case 4: // eCheck
								$billingAccountType = getAPITypeID("billingAccount", "echeck");
								break;
							case 2: // Check or Money Order
								$billingAccountType = getAPITypeID("billingAccount", "manual");
								break;
							case 5: // PayPal
							case 6: // WorldPay
								$billingAccountType = getAPITypeID("billingAccount", "secondary");
								break;
							case "something else":
								$billingAccountType = getAPITypeID("billingAccount", "bank");
								break;
							case 50: // other
							default:
								$billingAccountType = getAPITypeID("billingAccount", "manual");
								break;
						}
						if($encType == "lek") {
							$billingCardNum = v4encrypt($extClient["client_stamp"].getv4EncryptionKeyFromLek($lek["lek_hash"], $lek["lek_pin"]),$extClient["billing_cc_num"],1,0,$lek["lek_type"]);              
						} else {
							$key = $extClient["client_stamp"].md5($passphrase);
							$billingCardNum = v4encrypt($key,$extClient["billing_cc_num"],1,0,$lek["lek_type"]);               
						}
						$billingCardType = getCardTypeID($billingCardNum);
		
						$billingCardNum = preg_replace("/[^0-9]/", "", $billingCardNum);
						//show($billingCardNum);
						//exit;
						if(validateCard($billingCardNum)) {
							$lastFour = substr($billingCardNum, -4);
						} else {
							$lastFour = "XXXX";
						}
						
						list($billingCardExpMonth, $billingCardExpYear) = explode("/", $extClient["billing_cc_exp"]);
						
						$intClient = array(
							"clientCompany" => quoteXMLconvert($extClient["client_company"]),
							"companyID" => 1,
							"clientStatus" => $clientStatus,
							"applyTax" => $extClient["apply_tax"],
							"taxIDNumber" => $taxIDNumber,
							"themeID" => 1,
							"countriesID" => $countriesID,
							"clientActive" => $clientActive,
							"clientDateCreated" => $extClient["client_stamp"],
						);
						
						if(!$intClientID = insertFor("clientsGeneric", $intClient, ($syncMigrationIDs ? $extClientID : NULL))) {
							$e = "Problem inserting client: " . lastError() . ".";
							show($intClient);
							show(toXML($intClient));
							break 2;
						}
						
						if($extClient["client_comments"]) {
							if(!insertFor(
								"clientNotes",
								array(
									"clientID" => $intClientID,
									"adminID" => $adminID,
									"clientNoteDateCreated" => time(),
									"clientNoteText" => quoteXMLconvert($extClient["client_comments"]),
								)
							)) {
								$e = "Problem inserting client note: " . lastError() . ".";
								break 2;
							}
						}
						
						$intPrimaryContact = array(
							"applyFilters" => "no",
							"clientID" => $intClientID,
							"contactPrimary" => 1,
							"contactPassword" => $extClient["client_password"],
							"contactFirstName" => quoteXMLconvert($extClient["client_fname"]),
							"contactLastName" => quoteXMLconvert($extClient["client_lname"]),
							"contactEmail" => quoteXMLconvert($extClient["client_email"]),
							"contactEmailFormat" => (bool) $extClient["send_email_type"],
							"contactCompany" => quoteXMLconvert($extClient["client_company"]),
							"contactAddress1" => quoteXMLconvert($extClient["client_address"]),
							"contactAddress2" => quoteXMLconvert(substr($extClient["client_address_2"], 0, 100)),
							"contactCity" => quoteXMLconvert($extClient["client_city"]),
							"contactState" => quoteXMLconvert($extClient["client_state"]),
							"contactZip" => quoteXMLconvert($extClient["client_zip"]),
							"languageID" => $languageID,
							"countriesID" => $countriesID,
							"contactPhone1" => quoteXMLconvert($extClient["client_phone1"]),
							"contactFax" => quoteXMLconvert($extClient["client_phone2"]),
							"contactPhone2" => "",
							"contactDateCreated" => $extClient["client_stamp"],
							"contactActive" => 1, // Kris says client being inactive is enough
						);
						if($extClient["client_username"]) {
							$intPrimaryContact["contactUsername"] = quoteXMLconvert($extClient["client_username"]);
						}
						
						if(!$intPrimaryContactID = insertFor("contacts", $intPrimaryContact)) {
							// try again with username filler
							$intPrimaryContact["contactUsername"] .= "_" . dechex(rand());
							if(!$intPrimaryContactID = insertFor("contacts", $intPrimaryContact)) {
								$e = "Problem inserting primary contact: " . lastError() . ".";
								show($intPrimaryContact);
								show(toXML($intPrimaryContact));
								break 2;
							}
						}
						
						foreach($emailActionIDs as $emailActionID) {
							if(insertFor("contactEmailActionRels", array("clientContactID" => $intPrimaryContactID, "emailActionID" => $emailActionID)) === false) {
								$e = "Problem assigning email action ID $emailActionID to contact ID $intPrimaryContactID: " . lastError() . ".";
								break 3;
							}
						}
						
						if(($secondaryEmail = $extClient["client_secondary_email"]) || ($secondaryName = $extClient["secondary_contact"])) {
							if(!$secondaryEmail) {
								$secondaryEmail = $extClient["client_email"];
							}
							if($secondaryName) {
								list($secondaryFirstName, $secondaryLastName) = explode(" ", $secondaryName, 2);
							} else {
								$secondaryFirstName = $extClient["client_fname"];
								$secondaryLastName = $extClient["client_lname"];
							}
							$intSecondaryContact = array(
								"applyFilters" => "no",
								"clientID" => $intClientID,
								"contactPrimary" => 0,
								"contactPassword" => $extClient["client_password"],
								"contactFirstName" => quoteXMLconvert($secondaryFirstName),
								"contactLastName" => quoteXMLconvert($secondaryLastName),
								"contactEmail" => quoteXMLconvert($secondaryEmail),
								"contactEmailFormat" => (bool) $extClient["send_email_type"],
								"contactCompany" => quoteXMLconvert($extClient["client_company"]),
								"contactAddress1" => quoteXMLconvert($extClient["client_address"]),
								"contactAddress2" => quoteXMLconvert($extClient["client_address_2"]),
								"contactCity" => quoteXMLconvert($extClient["client_city"]),
								"contactState" => quoteXMLconvert($extClient["client_state"]),
								"contactZip" => quoteXMLconvert($extClient["client_zip"]),
								"languageID" => $languageID,
								"countriesID" => $countriesID,
								"contactPhone1" => quoteXMLconvert($extClient["client_phone1"]),
								"contactFax" => quoteXMLconvert($extClient["client_phone2"]),
								"contactPhone2" => "",
								"contactDateCreated" => $extClient["client_stamp"],
								"contactActive" => 1, // Kris says client being inactive is enough
							);
							if($extClient["client_username"]) {
								$intSecondaryContact["contactUsername"] = quoteXMLconvert($extClient["client_username"] . "_secondary");
							}
		
							if(!$intSecondaryContactID = insertFor("contacts", $intSecondaryContact)) {
								// try again with username filler
								$intSecondaryContact["contactUsername"] .= "_" . dechex(rand());
								if(!$intSecondaryContactID = insertFor("contacts", $intSecondaryContact)) {
									$e = "Problem inserting secondary contact: " . lastError() . ".";
									show($intSecondaryContact);
									show(toXML($intSecondaryContact));
									break 2;
								}
							}
							
							foreach($emailActionIDs as $emailActionID) {
								if(insertFor("contactEmailActionRels", array("clientContactID" => $intSecondaryContactID, "emailActionID" => $emailActionID)) === false) {
									$e = "Problem assigning email action ID $emailActionID to contact ID $intSecondaryContactID: " . lastError() . ".";
									break 3;
								}
							}
						
						}
						
						$intBillingAccount = array(
							"clientContactID" => $intPrimaryContactID,
							"billingCardNameOnCard" => quoteXMLconvert($extClient["client_fname"] . " " . $extClient["client_lname"]),
							"billingCardType" => $billingCardType,
							"billingCardNum" => quoteXMLconvert($billingCardNum),
							"billingCardExpYear" => quoteXMLconvert($billingCardExpYear),
							"billingCardExpMonth" => quoteXMLconvert($billingCardExpMonth),
							"billingCardIssueNum" => quoteXMLconvert($extClient["billing_cc_issue_num"]),
							"billingCardStartDate" => quoteXMLconvert($extClient["billing_cc_start_date"]),
		
							"billingBankType" => getAPITypeID("bankAccount", "checking"),
							"billingBankName" => quoteXMLconvert($extClient["x_Bank_Name"]),
							"billingBankAbaCode" => quoteXMLconvert($extClient["x_Bank_ABA_Code"]),
							"billingBankAccountNum" => quoteXMLconvert($extClient["x_Bank_Acct_Num"]),
							"billingBankLicenseNum" => quoteXMLconvert($extClient["x_Drivers_License_Num"]),
							"billingBankLicenseState" => quoteXMLconvert($extClient["x_Drivers_License_State"]),
							"billingBankDob" => quoteXMLconvert($extClient["x_Drivers_License_DOB"]),
							"billingBankState" => quoteXMLconvert($extClient["client_state"]),
		
							"billingAccountNumLastFour" => quoteXMLconvert($lastFour),
		
							"billingAccountType" => $billingAccountType,
							"billingAccountStatus" => getAPIStatusID("billingAccount", "normal"),
							
							"secGatewayConfigGroupID" => "",
						);
						
						if(!$intBillingAccountID = insertFor("billingAccounts", $intBillingAccount)) {
							$e = "Problem inserting billing account: " . lastError() . ".";
							show($intBillingAccount);
							show(toXML($intBillingAccount));
							break 2;
						}
						
						if(!updateForKey("clientsGeneric", $intClientID, array("defaultBillingAccountID" => $intBillingAccountID))) {
							$e = "Problem updating default billing account: " . lastError() . ".";
							break 2;
						}
		
						$this->migrateClientFinances(
							$intClientID,
							$extClientID,
							$this->dbr,
							$this->migrationConfig["migrationProductID"],
							$this->migrationConfig["migrationPaymentGroupID"],
							0,
							($noshares ? 0 : $intBillingAccountID)
						);

						if (IN_MBL_MIGRATION==1){
							if (!$this->customLegacyLicenseAttributeID){
								if (!$this->customLegacyLicenseAttribute = oneOf(":attributes", array(
									"attributeName" => "legacyLicenseData",
								))){
									$this->customLegacyLicenseAttributeID = insertFor(":attributes", array(
										"attributeName" => "legacyLicenseData",
									));
								} else {
									$this->customLegacyLicenseAttributeID = $this->customLegacyLicenseAttribute["attributeID"];
								}
							}
							insertFor(":clientAttributes", array(
								"clientID" => $intClientID,
								"attributeID" => $this->customLegacyLicenseAttributeID,
								"clientAttributeValue" => str_replace(array(
									"http://www.modernbill.com/download/register.php?",
									"http://65.18.157.198/download/register.php",
								), "", $extClient["client_field_2"]),
							));
						}
						
						if (IN_MBR_MIGRATION==1){
							if (!$this->resellerAttributeID){
								if (!$this->resellerAttribute = oneOf(":attributes", array(
									"attributeName" => "resellerID",
								))){
									$this->resellerAttributeID = insertFor(":attributes", array(
										"attributeName" => "resellerID",
									));
								} else {
									$this->resellerAttributeID = $this->resellerAttribute["attributeID"];
								}
							}
							insertFor(":clientAttributes", array(
								"clientID" => $intClientID,
								"attributeID" => $this->resellerAttributeID,
								"clientAttributeValue" => trim($extClient["client_field_3"]),
							));
						}

						// find out which domains to migrate in this process
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("domain_names");
						$q->addColumns("domain_names.*");
						$q->addAndClause("client_id", "=", $extClientID);
						$t =& $q->getTable(NULL, NULL, "domain_name");
						$extDomains = $t->getTable();
						$t->setKey("domain_id");
						$extDomainsByID = $t->getAssociated();
		
						// migrate domains
						$intDomains = array();
						$domainMappings = array();
						foreach($extDomains as $extDomain) {
							$domainName = $extDomain["domain_name"];
							list($domainSLD, $domainTLD) = explode(".", $domainName, 2);
							$extRegistrarID = $extDomain["registrar_id"];
							if($extRegistrarID == 1) {
								$intRegistrarID = "";
							} else {
								$registrarMappings = oneOf(
									"migrationMappings",
									array(
										"migrationConfigID" => $migrationConfigID,
										"migrationObjID" => $registrarMigrationID,
										"migrationExtID" => $extRegistrarID,
									)
								);
								$intRegistrarID = $registrarMappings["migrationIntID"];
							}
							$q =& new MBQuery(
								"SetDomains",
								"insert",
								$intDomain = array(
									"domainSLD" => $domainSLD,
									"domainTLD" => $domainTLD,
									"registrarID" => $intRegistrarID,
									"domainDateCreated" => $extDomain["domain_created"],
									"domainDateExpires" => $extDomain["domain_expires"],
									"domainRenewType" => getAPITypeID("tldRenew", "disabled"),
								)
							);
							$r =& $q->getResult();
							if($r->getSuccess()) {
								$intDomainID = $r->getLastInsertID();
								$intDomain["domainID"] = $intDomainID;
								$intDomains[$domainName] = $intDomain;
								
								$domainMappings[$extDomain["domain_id"]] = $intDomainID;
								
								echo "Migrated domain $domainName ID $extDomainID as $intDomainID <br />";
								flush();
							} else {
								$intDomainID = NULL;
							}
						}
						
						// find out which packages to migrate for this client
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("client_package");
						$q->addColumns("client_package.*");
						$q->addAndClause("client_id", "=", $extClientID);
						$t =& $q->getTable(-1, 0, "cp_id");
						$clientPackages = $t->getAssociated();
						$clientPackageIDs = $t->getKeys();
						$packageTypeIDs = $t->getColumnDistinct("pack_id");
		
						if($clientStatus == getAPIStatusID("client", "canceled")) {
							if($lastRenewalDates = $t->getColumnDistinct("cp_renewed_on")) {
								$clientDateCancelled = max($lastRenewalDates);
								
								updateForKey("clientsGeneric", $intClient, array("clientDateCancelled" => $clientDateCancelled));
							}
						}
						
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("change_log");
						$q->addColumns(
							"cl_db_table_pkvalue as cp_id",
							"cl_timestamp as package_date_cancelled"
						);
						$q->addAndClause("cl_db_table_name", "=", "client_package");
						$q->addAndClause("cl_new_value", "=", "4");
						$q->addAndClause("cl_db_table_pkvalue", "=", $clientPackageIDs);
						$t =& $q->getTable();
						$t->setKey("cp_id");
						$t->setName("package_date_cancelled");
						$cancellationDatesByCPID = $t->getOptions();
						
						// can't do a proper join because pack_price may contain different values.
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("package_type");
						$q->addColumns("package_type.pack_id", "package_type.pack_price", "package_type.pack_setup", "package_type.pack_name"); 
						$q->addAndClause("pack_id", "=", $packageTypeIDs);
						$t =& $q->getTable(NULL, NULL, "pack_id");
						$packageTypes = $t->getAssociated();
		
						if($enableLTDiscount) {
							// get the package features
							$q =& new QueryMaster("select", $this->dbr);
							$q->enableManualJoining();
							$q->addTables("package_feature");
							$q->addColumns("package_feature.pack_id", "package_feature.feature_comments");
							$q->addAndClause("pack_id", "=", $packageTypeIDs);
							$q->addAndClause("feature_name", "=", "DiscountBasis", "s");
							$t =& $q->getTable(-1, 0, "pack_id", "feature_comments");
							$discountBasisByPTID = $t->getOptions();
						}
						
						// get the package features
						$q =& new QueryMaster("select", $this->dbr);
						$q->enableManualJoining();
						$q->addTables("package_feature");
						$q->addColumns("package_feature.pack_id", "package_feature.feature_name", "package_feature.feature_comments", "package_feature.feature_stamp");
						$q->addAndClause("pack_id", "=", $packageTypeIDs);
						$q->addAndClause("feature_type", "=", 1, "i"); // 1 = display; 2 = config
						$t =& $q->getTable();
						$t->setKey("pack_id");
						$featuresByExtProductID = $t->getAssociatedSets();
							
						// find out which client package variables (add-on descriptions) to migrate for this client
						$q =& new QueryMaster("select", $this->dbr);
						$q->addColumns(
							"client_package_variables.*",
							"package_variables.variable_caption",
							"package_variables.input_type",
							"package_variables.possible_values",
							"package_variables.visible",
							"package_variables.variable_price",
							"package_variables.upgrade",
							"package_variables.external_id",
							"package_variables.variable_group",
							"package_variables.variable_multiplier",
							"package_variables.order_group",
							"package_variables.var_order"
						);
						$q->addJoin("client_package_variables", "cp_id", "client_package");
						$q->addJoin("package_variables", "var_id", "client_package_variables");
						$q->addAndClause("client_package.client_id", "=", $extClientID);
						$t =& $q->getTable(-1, 0, "cp_id");
						$clientPackageVariablesByCPID = $t->getAssociatedTables();				
						
						//show($q->getQuery());
						//show($t);
						//show("variables");
						//show($clientPackageVariablesByCPID);
		
						// migrate packages
						foreach($clientPackages as $extPackageID => $extPackage) {
							if($enableLTDiscount) {
								switch($extPackage["cp_status"]) {
									case "3":
									case "4":
									case "5":
									case "6":
										// switch is considered a loop, so continue out of both the switch and the loop, to the next package
										continue 2;
								}
							}
							
							$extCancellationDate = $cancellationDatesByCPID[$extPackageID];
							$extProductID = $extPackage["pack_id"];
							$features = $featuresByExtProductID[$extProductID];
		
							// get v4 product info
							$extPackData = $packageTypes[$extPackage["pack_id"]];
		
							if($enableLTDiscount) $discountBasis = (float) $discountBasisByPTID[$extProductID];
							
							$packageComments = "";
							if(isset($clientPackageVariablesByCPID[$extPackageID])) {
								$variableT =& $clientPackageVariablesByCPID[$extPackageID];
								$variableT->setKey("variable_caption");
								$variableT->setname("variable_value");
								if($variables = $variableT->getOptions()) {
									$variableT->setname("input_type");
									$variableTypes = $variableT->getOptions();
									$packageComments .= "<dl>\n";
									foreach($variables as $caption => $value) {
										switch($variableType = $variableTypes[$caption]) {
										//	case 1: // select
											case 2: // text
										//	case 3: // checkbox
										//	case 4: // radio
											case 5: // hidden
											case 6: // password
												$packageComments .= "<dt>" . htmlspecialchars($caption) . "</dt><dd>" . htmlspecialchars($value) . "</dd>\n";
												break;
											default:
												continue;
										}
									}
									$packageComments .= "</dl>\n";
								}
							}
							
							//show($packageComments);
							show("== Handling product $extProductID ==");
							
							if(!$extProductID) {
								$intProductID = $this->migrationConfig["migrationOrphanProductID"];
								show("Orphaned package. Using foster product ID $intProductID.");
							} else {
								if($this->productIDCache->exists($extProductID)) {
									$intProductID = $this->productIDCache->get($extProductID);
									show("Found ID $intProductID in cache.");
								} else {
									if($productMapping = oneOf(
										"migrationMappings",
										array(
											"migrationConfigID" => $migrationConfigID,
											"migrationObjID" => $productMigrationID,
											"migrationExtID" => $extProductID,
										)
									)) {
										$intProductID = $productMapping["migrationIntID"];
										show("Found ID $intProductID in mapping.");
									} else {
										show("Not found. Making new...");
										$intProductName = $extPackData["pack_name"];
		
										//$isDomain = $this->isDomainCycle($extPackage["cp_billing_cycle"]);
		
										$sql = "select distinct pack_id from tld_config where pack_id = ${extProductID}";
										$r =& $this->dbr->selectLimit($sql, 1, 0);
										$isDomain = false;
										if($r !== false) {
											if($r->GetArray()) {
												$isDomain = true;
											}
										} else {
											$e = $this->dbr->ErrorMsg();
											break;
										}
		
										//if($intProductName == "Domain Registration") {
										if($isDomain) {
											$intProductType = getAPITypeID("products", "domain");
											$intProductProratable = 0;
										} else {
											$intProductType = getAPITypeID("products", "hosting");
											$intProductProratable = 1;
										}
		
										$productStopNumCycles = (int) $this->isOneTimeCycle($extPackage["cp_billing_cycle"]);
		
										if($migrationProductGroupID) {
											$productGroups = array(
												"productGroupIDs" => array(
													"productGroupID" => $migrationProductGroupID
												),
											);
										} else {
											$productGroups = array();
										}
										if(!$intProductID = insertFor(
											"productsGeneric",
											$intProduct = array(
												"productName" => quoteXMLconvert($intProductName),
												"productType" => $intProductType,
												"productComments" => quoteXMLconvert($extPackData["pack_comments"]),
												"productStopNumCycles" => $productStopNumCycles,
												"productActive" => 1,
												"productProratable" => $intProductProratable,
												"productDiscountable" => 1,
												"productDateCreated" => mktime(),
												"productDomainRequired" => getAPIStatusID("productdependencyrules", "optional"),
												"productAddonRequired" => getAPIStatusID("productdependencyrules", "optional"),
												"productCancellationType" => getAPITypeID("cancellation", "admin_suspend"),
											) + $productGroups,
											($syncMigrationIDs ? $extProductID : NULL)
										)) {
											$e = lastError();
											break 3;
										}
										
										$relations = array(
										);
										$intCycleIDSet = new Set();
										if($isDomain) {
											show("Handling domain pricing.");
											$intTldIDSet = new Set();
											$domainType = getAPITypeID("products", "domain");
											
											$registrarD =& new DataSource(
												"migrationMappings",
												array(
													"migrationConfigID" => $migrationConfigID,
													"migrationObjID" => $registrarMigrationID,
												)
											);
											$registrarT =& $registrarD->getTable();
											$registrarT->setKey("migrationExtID");
											$registrarT->setName("migrationIntID");
										
											$q =& new QueryMaster("select", $this->dbr);
											$q->enableManualJoining();
											$q->addTables("tld_config");
											$q->addColumns(
												"tld_config.tld_configs",
												"tld_config.tld_id",
												"tld_config.tld_extension",
												"tld_config.tld_name",
												"tld_config.registrar_id",
												"tld_config.tld_transfer",
												"tld_config.tld_1y",
												"tld_config.tld_2y",
												"tld_config.tld_3y",
												"tld_config.tld_4y",
												"tld_config.tld_5y",
												"tld_config.tld_6y",
												"tld_config.tld_7y",
												"tld_config.tld_8y",
												"tld_config.tld_9y",
												"tld_config.tld_10y"
											);
											$q->addAndClause("pack_id", "=", $extProductID);
											$t =& $q->getTable(NULL, NULL, "tld_id", "tld_extension");
											$t =& $t->getJoinedWith($registrarT, "migrationExtID", "registrar_id");
											$tldConfigs = $t->getTable();
											
											$variants = array();
											$yearExtCycleMap = $this->domainYearCycleMap;
											foreach($tldConfigs as $tldConfig) {
												$tldOptions = unserialize($tldConfig["tld_configs"]);
												$intRegistrarID = $tldConfig["migrationIntID"];
												$tldExtension = $tldConfig["tld_extension"];
												switch($tldExtension) {
						// XXX: more needed
													case "co.uk":
														$transferMinimumYear = 2;
														break;
													default:
														$transferMinimumYear = 1;
														break;
												}
												$tldTransferMinimumCycleID = $this->getCycleID($yearExtCycleMap[$transferMinimumYear], $domainType);
												$tldMinimumCycleID = $this->getCycleID($yearExtCycleMap[$tldOptions["tld_minTerm"]], $domainType);
												$tldMaximumCycleID = $this->getCycleID($yearExtCycleMap[$tldOptions["tld_maxTerm"]], $domainType);
		
												switch($tldExtension) {
						// XXX: needs research
													case "some tld":
													case "another tld":
														$tldTransferType = getAPITypeID("tldTransfer", "code");
														break;
													default:
														$tldTransferType = getAPITypeID("tldTransfer", "email");
														break;
												}
		
												if($migrateTLDs) {
													$tld = array(
														"registrarID" => $intRegistrarID,
														"tldExtension" => $tldExtension,
														"tldName" => $tldConfig["tld_name"],
														"tldWhoisServer" => $tldConfig["tld_whois_server"],
														"tldWhoisResp" => $tldConfig["tld_whois_response"],
														"tldActive" => 1,
														"tldAutoSearch" => $tldConfig["tld_auto_search"],
														"tldTransferMinimumCycleID" => $tldTransferMinimumCycleID,
														"tldMinimumCycleID" => $tldMinimumCycleID,
														"tldMaximumCycleID" => $tldMaximumCycleID,
														"tldRenewType" => getAPITypeID("tldRenew", "internal"),
														"tldIsTransferable" => (int) (bool) $tldOptions["tld_transferable"],
														"tldIDNSupport" => (int) (bool) $tldOptions["tld_idn"],
														"tldIDNType" => getAPITypeID("tldIDN", "punycode"),
														"tldRemoteLockEnabled" => (int) (bool) $tldOptions["tld_lockable"],
														"tldDisplayOrder" => $tldConfig["tld_id"],
													);
		
													$tldID = insertFor("TLDs", $tld);
												} else {
													$tldD =& new DataSource(
														"TLDs",
														array(
															"registrarID" => $intRegistrarID,
															"tldExtension" => $tldExtension,
														)
													);
													$tldID = $tldD->getID();
													$tld = $tldD->getOne();
												}
												$intTldIDSet->addElement($tldID);
		
												$variants[] = $variant = array(
													"productVariantDisplayName" => quoteXMLconvert($tldConfig["tld_name"]),
													"productVariantActive" => 1,
													"productID" => $intProductID,
													"tldID" => $tldID,
													"taxZoneGroupID" => (int) $CONF["migrationTaxZoneGroupID"],
													"cycleDiscountGroupID" => (int) $CONF["migrationDiscountGroupID"],
												);
												if(!$variantID = insertFor("variants", $variant)) {
													$e = lastError();
													break 3;
												}
		
												$variantPrices = array();
												if($tldConfig["tld_transfer"]) {
													$price = (float) $tldConfig["tld_transfer"];
													if($price == 0.001 || $price == 0.0001) $price = 0.0;
													$cycleID = $tld["tldTransferMinimumCycleID"];
													$intCycleIDSet->addElement($cycleID);
													$variantPrices[] = $this->getPrice($price, $cycleID, "transfer");
												}
												foreach($yearExtCycleMap as $year => $cycleInfo) {
													if((float) $tldConfig["tld_${year}y"] > 0.0) {
														$price = (float) $tldConfig["tld_${year}y"];
														if($price == 0.001 || $price == 0.0001) $price = 0.0;
														$cycleID = $this->getCycleID($cycleInfo, $domainType);
														$intCycleIDSet->addElement($cycleID);
														$variantPrices[] = $this->getPrice($price, $cycleID);
													}
												}
												
												show("TLD prices:");
												show($variantPrices);
												foreach($variantPrices as $variantPrice) {
													$variantPrice["productVariantID"] = $variantID;
													if(!insertFor("variantPrices", $variantPrice)) {
														$e = lastError();
														break 5;
													}
												}
											}
											$relations["tldIDs"] = array(
												"tldID" => $tldIDs = $intTldIDSet->getSet(),
											);
										} else {
											show("Handling regular pricing.");
											if(!$variantID = insertFor(
												"variants",
												$variant = array(
													"productVariantDisplayName" => quoteXMLconvert($intProductName),
													"productVariantActive" => 1,
													"productID" => $intProductID,
												)
											)) {
												$e = lastError();
												break 3;
											}
											
											$regularPrices = $extPackData["pack_price"];
											$setupPrices = $extPackData["pack_setup"];
											
											$variantPrices = array();
											foreach(array(1, 3, 6, 12, 24, 36) as $cycleInfo) {
		
												if($regularPrice = $this->splitPrice($regularPrices, "price", $cycleInfo) * $cycleInfo) {
													$cycleID = $this->getCycleID($cycleInfo);
													$intCycleIDSet->addElement($cycleID);
													
													show("Got regular price: $regularPrice");
													if($regularPrice == 0.001 || $regularPrice == 0.0001) $regularPrice = 0.0;
													show("Resolved to: $regularPrice");
													$variantPrices[] = $this->getPrice($regularPrice, $cycleID);
												}
												
												if($setupPrice = $this->splitPrice($setupPrices, "setup", $cycleInfo)) {
													$cycleID = $this->getCycleID($cycleInfo);
													$intCycleIDSet->addElement($cycleID);
													
													show("Got regular price: $setupPrice");
													if($setupPrice == 0.001 || $setupPrice == 0.0001) $setupPrice = 0.0;
													show("Resolved to: $setupPrice");
													$variantPrices[] = $this->getPrice($setupPrice, $cycleID, "setup");
												}
		
											}
											
											foreach($variantPrices as $variantPrice) {
												$variantPrice["productVariantID"] = $variantID;
												if(!insertFor("variantPrices", $variantPrice)) {
													$e = lastError();
													break 5;
												}
											}
										}
										show("Done handling pricing.");
										
										$display = $extPackData["pack_display"];
										$displayOrder = $extPackData["pack_order"];
										
										$relations["cycleIDs"] = array(
											"cycleID" => $cycleIDs = $intCycleIDSet->getSet(),
										);
										$relations["orderFormIDs"] = array(
											"orderFormID" => $orderFormID = $this->migrationConfig["migrationOrderFormID"],
										);
										if(!updateForKey("productsGeneric", $intProductID, $relations)) {
											$e = lastError();
											break 3;
										}
										
										$displayName = $this->migrationConfig["migrationName"] . " (" . $this->migrationConfigID . "): " . $display;
										
										if(!$websiteWidgetID = IDByName("websiteWidgets", $displayName, array("comparisonOperator" => "="))) {
											if(!$websiteWidgetID = insertFor(
												"websiteWidgets",
												array(
													"websiteWidgetName" => quoteXMLconvert($displayName),
													"websiteWidgetTpl" => "simpleWidget-List",
													"orderFormID" => $orderFormID,
												)
											)) {
												$e = lastError();
												break 3;
											}
											show("Made new website widget $displayName at ID $websiteWidgetID");
										} else {
											show("Found website widget $displayName at ID $websiteWidgetID");
										}
										
										show("Associating website widget with product.");
										if(!insertFor(
											"websiteWidgetProductRels",
											array(
												"websiteWidgetID" => $websiteWidgetID,
												"websiteWidgetOrder" => $displayOrder,
												"productID" => $intProductID,
											)
										)) {
											//$e = lastError();
											//break 3;
										}
										
										if(!insertFor(
											"productAttributes",
											array(
												"productID" => $intProductID,
												"productAttributeName" => "addons",
												"productAttributeValue" => "yes",
											)
										)) {
											$e = lastError();
											break 3;
										}
										
										show("Adding product to cache and mapping.");								
										$this->productCache[$intProductID] = $intProduct;
										if(!insertFor(
											"migrationMappings",
											array(
												"migrationConfigID" => $migrationConfigID,
												"migrationObjID" => $productMigrationID,
												"migrationExtID" => $extProductID,
												"migrationIntID" => $intProductID,
											)
										)) {
											$e = lastError();
											break 3;
										}
										show("Made product ID $intProductID");
									}
									$this->productIDCache->set($extProductID, $intProductID);
								}
							}
							show("Finished handling product.");
							
							if(isset($this->productCache[$intProductID])) {
								$intProduct = $this->productCache[$intProductID];
							} else {
								$intProduct = oneByID("products", $intProductID);
							}
						
							$extDomain = $extPackage["domain"];
							list($domainSLD, $domainTLD) = explode(".", $extDomain, 2);
							if($domainTLD) {
								$intTLD = oneOf("TLDs", array("tldExtension" => $domainTLD));
								$intTLDID = $intTLD["tldID"];
								
								$intVariant = oneOf("productVariants", array("productID" => $intProductID, "tldID" => $intTLDID));
							} else {
								$intTLD = NULL;
						
								$intVariant = oneOf("productVariants", array("productID" => $intProductID));
							}
							$taxZoneGroupID = $intVariant["taxZoneGroupID"];
							
							$packageActive = 0;
							$packageStatus = getAPIStatusID("package", "none");
							switch($extPackage["cp_status"]) {
								case 1: // suspended
									$packageActive = 1;
									$packageStatus = getAPIStatusID("package", "suspended");
									break;
								case 2: // active/on
									$packageActive = 1;
									$packageStatus = getAPIStatusID("package", "none");
									break;
								case 3: // new/still in queue
									$packageActive = 1;
									$packageStatus = getAPIStatusID("package", "pending");
									break;
								case 4: // canceled
									$packageActive = 1;
									$packageStatus = getAPIStatusID("package", "canceled");
									break;
								case 5: // fraud
									$packageActive = 0;
									$packageStatus = getAPIStatusID("package", "fraudulent");
									break;
								case 6: // error
									$packageActive = 1;
									$packageStatus = getAPIStatusID("package", "failed");
									break;
								case 7: // pending renewal
									$packageActive = 1;
									$packageStatus = getAPIStatusID("package", "pending_renewal");
									break;
							}
							$packageStatusName = getAPIStatusName("package", $packageStatus);
							$packageCycle = $extPackage["cp_billing_cycle"];				
							$cycleType = $this->getCycleType($packageCycle);
			
							list($intCycleID, $extCycleMonths) = $this->getCycleID($packageCycle, NULL, true);
							
							// get price data from product
							$extPackPrice = $extPackData["pack_price"];
							$extPackSetup = $extPackData["pack_setup"];
							$intPrice = $this->splitPrice($extPackPrice, "price", $extCycleMonths);
							if($cycleType == "recurring") {
								$intPrice *= $extCycleMonths;
							}
							$intSetup = $this->splitPrice($extPackSetup, "setup", $extCycleMonths);
		
							// fix free prices
							if($intPrice == 0.001 || $intPrice == 0.0001) {
								$intPrice = 0.00;
							}
							
							// price override on the package
							if((float) $extPackage["pack_price"] > 0.0) {
								$intUnitPrice = (float) $extPackage["pack_price"];
								if($cycleType == "onetime") {
									$intPrice = $intUnitPrice; // one time only
								} else if($cycleType == "domain") {
									$intPrice = $intUnitPrice;
								} else {
									$intPrice = $intUnitPrice * $extCycleMonths;
								}
							}
		
							// get the v4 name of the package
							if(!$packageName = $extPackData["pack_name"]) {
								$packageName = $intProduct["productName"];// . ($extDomain ? (' - ' . $extDomain) : "");
							}
		
							show("=== Package Details ===");
							show("Name: ${packageName}");
							show("Cycle: ${packageCycle}");
							show("Cycle Type: ${cycleType}");
							show("pack_price: " . $extPackData["pack_price"]);
							show("pack_setup: " . $extPackDate["pack_setup"]);
							show("package pack_price: " . $extPackage["pack_price"]);
							show("Final price: ${intPrice}");
							
							$intPackage = array(
								"clientID" => $intClientID,
								"productID" => $intProductID,
								"taxZoneGroupID" => $taxZoneGroupID,
								"packageName" => quoteXMLconvert($packageName),
								"packageQuantity" => $extPackage["cp_qty"],
								"packageComments" => quoteXMLconvert($packageComments),
								"packageProratable" => 0,
								"packageDateCreated" => $extPackage["cp_stamp"],
								"packageDateBeginRenewal" => $extPackage["cp_start_stamp"],
								"packageDateLastRenewal" => $extPackage["cp_renewed_on"],
								"packageDateNextRenewal" => $extPackage["cp_renew_stamp"],
								"packageActive" => $packageActive,
								"packageStatus" => $packageStatus,
								"packageType" => $intProduct["productType"],
								"packageOriginalPrice" => (float) $intPrice,
								"packagePrice" => (float) $intPrice,
								"packageSetup" => (float) $intSetup,
								"packageDiscount" => (float) $extPackage["cp_discount"] * 100,
								"packageDiscountable" => 1,
								"packagePriceLock" => 0,
								"cycleID" => $intCycleID,
								"AffCode" => quoteXMLconvert($extPackage["aff_code"]),
								"AffDateLastPaid" => $extPackage["aff_last_paid"],
								"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
								"packageCancellationType" => getAPITypeID("cancellation", "admin_suspend"),
							);
							if($oneTime) $intPackage["packageDateStopRenewal"] = $intPackage["packageDateNextRenewal"] - 1;
							if($enableLTDiscount && strpos($packageName, "NODISC") !== false) $intPackage["packageDiscountable"] = 0;
							if(!$intPackageID = insertFor("packagesGeneric", $intPackage, ($syncMigrationIDs ? $extPackageID : NULL))) {
								
								$e = "Problem inserting package: " . lastError() . ".";
								//show($intPackage);
								show(toXML($intPackage));
								break 3;
							}
							
							if($extCancellationDate) {
								if(!updateForKey("packagesGeneric", $intPackageID, array("packageDateCancelled" => $extCancellationDate))) {
									$e = "Problem updating cancellation date of package $intPackageID: " . lastError() . ".";
									break 3;
								}
							}
							
							show("Client ID $extClientID => $intClientID");
							show("Product ID $extProductID => $intProductID");
							show("Package ID $extPackageID => $intPackageID");
							
							$optionPriceTotal = 0.0;
							if(isset($clientPackageVariablesByCPID[$extPackageID])) {
								$variableT =& $clientPackageVariablesByCPID[$extPackageID];
								$variables = $variableT->getTable();
								foreach($variables as $variable) {
									if($enableLTDiscount && $variable["variable_caption"] == "DiscountBasis") {
										$discountBasis = (float) $variable["variable_value"];
										continue;
									}
									
									//$addonInfo = array($variable["variable_caption"], $variable["possible_values"], $variable["visible"]);
									$addonInfo = array($variable["variable_caption"], $variable["visible"], $variable["input_type"]);
									$addonHash = str_replace("/", ".", hashVal($addonInfo));
									$addonCode = "ag:$addonHash";
									
									show("== Handling add-on group " . $variable["variable_caption"] . " ==");
									show("Add-on group code: $addonCode");
										
									if($this->addonGroupIDCache->exists($addonCode)) {
										$addonGroupID = $this->addonGroupIDCache->get($addonCode);
										show("Found ID $addonGroupID in cache.");
									} else {
										if($addonGroupObj = oneByName("migrationObjs", $addonCode, array("comparisonOperator" => "="))) {
											$addonGroupID = $addonGroupObj["migrationIntSeqID"];
											show("Found ID $addonGroupID in mapping.");
										} else {
											show("Not found. Making new...");
											switch($variable["input_type"]) {
												// gathered by looking at source
												case 1:  $inputType = "s";   break; // select
												case 2:  $inputType = false; break; // text
												case 3:  $inputType = "c";   break; // checkbox
												case 4:  $inputType = "r";   break; // radio
												case 5:  $inputType = false; break; // hidden
												case 6:  $inputType = false; break; // password
												default: $inputType = false; break;
											}
											if(!$inputType) continue; // XXX: skip add-ons without corresponding input types?
											if(!$s1 = insertFor(
												"migrationObjs",
												array(
													"migrationObjName" => $addonCode,
													"migrationIntSeqID" => $s2 = $addonGroupID = insertFor(
														"productAddonGroups",
														array(
															"productAddonGroupActive" => (int) (bool) $variable["visible"], // XXX: is this right?
															"productAddonGroupName" => $variable["variable_caption"],
															"productAddonGroupInputType" => $inputType,
														)
													),
												)
											) || !$s2) {
												if(!$s1)  {
													$e = "Problem inserting migration object for add-on group: " . lastError() . ".";
													show($e);
												} else if(!$s2) {
													$e = "Problem inserting add-on group: " . lastError() . ".";
													show($e);
												}
												break 4;
											}
											show("Made add-on group ID $addonGroupID");
										}
										$this->addonGroupIDCache->set($addonCode, $addonGroupID);
									}
		
									if(!$s = updateForKey(
										"products",
										$intProductID,
										array(
											"removeProductAddonGroupIDs" => array(
												"productAddonGroupID" => $addonGroupID, // XXX: this is only safe because SetProducts does this first!
											),
											"productAddonGroupIDs" => array(
												"productAddonGroupID" => $addonGroupID,
											),
										)
									)) {
										$e = "Problem associating add-on group $addonGroupID with v5 product $intProductID: " . lastError() . ".";
										show($e);
										break 4;
									}
									show("Associated main product with addon group");
									
									$addonOptions = array_map("trim", explode(",", $variable["possible_values"]));
									$addonInfo = array();
									$selectedOptionCodeID = NULL;
									foreach($addonOptions as $possibleOption) {
										if(!$possibleOption) continue;
										list($apiName, $displayName, $price1, $price3, $price6, $price12, $price24, $price36) = array_map("trim", explode("|", $possibleOption));
										if(!$migrateProducts && $apiName != trim($variable["variable_value"])) continue;
		
										$addonInfo = compact("apiName", "displayName", "price1", "price3", "price6", "price12", "price24", "price36");
		
										$optionHash = str_replace("/", ".", hashVal($addonInfo));
										$optionCode = "ao:$addonHash:$optionHash";
		
										show("== Handling add-on option " . $addonInfo["displayName"] . " ==");
										show("Add-on option code: $optionCode");
		
										if($this->addonOptionIDCache->exists($optionCode)) {
											$optionCodeID = $this->addonOptionIDCache->get($optionCode);
											show("Found ID $optionCodeID in cache.");
										} else {
											if($addonOptionObj = oneByName("migrationObjs", $optionCode, array("comparisonOperator" => "="))) {
												$optionCodeID = $addonOptionObj["migrationIntSeqID"];
												show("Found ID $optionCodeID in mapping.");
											} else {
												show("Not found. Making new...");
												$discountable = 1;
												if($enableLTDiscount) {
													$discountable = 0;
													if($price24 > 0) $discountable = 1;
												}
		
												$prices = array();
												$cycleIDs = array();
												foreach(
													array(
														1 => $addonInfo["price1"],
														3 => $addonInfo["price3"],
														6 => $addonInfo["price6"],
														12 => $addonInfo["price12"],
														24 => $addonInfo["price24"],
														36 => $addonInfo["price36"],
													) as $cycleInfo => $price
												) {
													$cycleIDs[] = $cycleID = $this->getCycleID($cycleInfo);
													if((float) $price > 0) {
														$prices[] = $this->getPrice($price * $cycleInfo, $cycleID);
													} else {
														$prices[] = $this->getPrice(0.0, $cycleID);
													}
												}
		
												if($syncMigrationIDs) {
													$addonProductCommand = "productsGeneric";
													$addonProduct = array(
														"productName" => $addonInfo["displayName"],
														"productIsAddon" => 1,
														"productActive" => 1,
														"productAddonGroupID" => $addonGroupID,
														"productDateCreated" => mktime(),
														"productDiscountable" => $discountable,
													);
													$addonProductDetails = array(
														"cycleIDs" => array(
															"cycleID" => $cycleIDs,
														),
														"orderFormIDs" => array(
															"orderFormID" => $this->migrationConfig["migrationOrderFormID"],
														),
														"productVariants" => array(
															"productVariant" => array(
																"productVariantDisplayName" => $addonInfo["displayName"],
																"productVariantActive" => 1,
																"productVariantPrices" => array(
																	"productVariantPrice" => $prices,
																),
															),
														),
													);
												} else {
													$addonProductCommand = "products";
													$addonProduct = array(
														"productName" => $addonInfo["displayName"],
														"productIsAddon" => 1,
														"productActive" => 1,
														"productAddonGroupID" => $addonGroupID,
														"productDateCreated" => mktime(),
														"productDiscountable" => $discountable,
														"cycleIDs" => array(
															"cycleID" => $cycleIDs,
														),
														"orderFormIDs" => array(
															"orderFormID" => $this->migrationConfig["migrationOrderFormID"],
														),
														"productVariants" => array(
															"productVariant" => array(
																"productVariantDisplayName" => $addonInfo["displayName"],
																"productVariantActive" => 1,
																"productVariantPrices" => array(
																	"productVariantPrice" => $prices,
																),
															),
														),
													);
												}
		
												if(!$s1 = insertFor(
													"migrationObjs",
													array(
														"migrationObjName" => $optionCode,
														"migrationIntSeqID" => $s2 = $addonProductID = $optionCodeID = insertFor($addonProductCommand, $addonProduct),
													)
												) || !$s2) {
													if(!$s1) {
														$e = "Problem inserting migration object for add-on option: " . lastError() . "";
														show($e);
													} else if(!$s2) {
														$e = "Problem inserting add-on option into group $optionCodeID: " . lastError() . "";
														show($e);
													}
													break 4;
												}
												
												if($syncMigrationIDs && ($optionCodeID < $raisePriorBalancePackageKeysBy)) {
													$newOptionCodeID = $optionCodeID + $raisePriorBalancePackageKeysBy;
													$s = updateForKey(
														"productsGeneric",
														$optionCodeID,
														array(
															"updateToID" => $newOptionCodeID
														)
													);
													$optionCodeID = $newOptionCodeID;
												}
												if($syncMigrationIDs) {
													if(!updateForKey("products", $optionCodeID, $addonProductDetails)) {
														$e = "Problem updating add-on product for details ID $optionCodeID.";
														break 4;
													}										
												}
		
												show("Made add-on option ID $addonProductID");
											}
											$this->addonOptionIDCache->set($optionCode, $optionCodeID);
										}
		
										if($apiName == trim($variable["variable_value"])) {
											$selectedOptionCodeID = $optionCodeID;
										}
		
										
										show("Associating add-on option $optionCodeID with product $intProductID");
										if(!$s = updateForKey(
											"products",
											$intProductID,
											array(
												"productChildrenIDs" => array(
													"productID" => $optionCodeID,
												),
											)
										)) {
											$e = "Problem associating add-on option $optionCodeID with v5 product $intProductID: " . lastError() . ".";
											show($e);
											break 4;
										}
		
									}
									
									$optionPriceInfo = $optionDisplayName = NULL;
									foreach($addonOptions as $possibleOption) {
										list($apiName, $displayName, $price) = array_map("trim", explode("|", $possibleOption, 3));
										list($price1, $price3, $price6, $price12, $price24, $price36) = array_map("trim", explode("|", $price));
										if(trim($apiName) == trim($variable["variable_value"])) {
											$optionPriceInfo = $price;
											$optionDisplayName = trim($displayName);
											break;
										}
									}
									
									$discountable = 1;
									if($enableLTDiscount) {
										$discountable = 0;
										if($price24 > 0) $discountable = 1;
									}
									
									$optionPriceTotal += $optionPrice = $this->splitPrice($optionPriceInfo, "price", $extPackage["cp_billing_cycle"]);
									
									if(!$packageAddonID = insertFor(
										"packageAddons", $packageAddon = array(
											"packageID" => $intPackageID,
											"packageAddonDisplayName" => $variable["variable_caption"] . ": " . $optionDisplayName,
											"packageAddonOriginalPrice" => $migrateAddonPrices ? $optionPrice : 0.0,
											"packageAddonPrice" => $migrateAddonPrices ? $optionPrice : 0.0,
											"packageAddonSetup" => 0.0,
											"packageAddonDiscountable" => $discountable,
											"packageAddonActive" => 1,
											"packageAddonProductID" => $selectedOptionCodeID,
											"taxZoneGroupID" => $taxZoneGroupID,
										)
									)) {
										$e = "Problem inserting package addon for package $intPackageID: " . lastError() . ".";
										show($packageAddon);
										show(toXML($packageAddon));
										break 3;
									}
		
								}
							}
							
							if(!$migrateAddonPrices && $enableLTDiscount && $discountBasis > 0) {
								$addonPrice = $intPrice - $discountBasis;
								$intPrice = $discountBasis;
								if($addonPrice > 0) {
									if(!$packageAddonID = insertFor(
										"packageAddons", $packageAddon = array(
											"packageID" => $intPackageID,
											"packageAddonDisplayName" => "Non-discountable Charges",
											"packageAddonOriginalPrice" =>  $addonPrice,
											"packageAddonPrice" => $addonPrice,
											"packageAddonSetup" => 0.0,
											"packageAddonDiscountable" => 0,
											"packageAddonActive" => 1,
											"packageAddonProductID" => $optionCodeID,
											"taxZoneGroupID" => $taxZoneGroupID,
										)
									)) {
										$e = "Problem inserting package addon for Discount Basis for package $intPackageID: " . lastError() . ".";
										show($packageAddon);
										show(toXML($packageAddon));
										break 3;
									}
		
									if(!updateForKey(
										"packagesGeneric",
										$intPackageID,
										array(
											"packageOriginalPrice" => $intPrice,
											"packagePrice" => $intPrice,
										)
									)) {
										$e = "Problem update package price for discounting for package $intPackage: " . lastError() . ".";
										break 3;
									}
								}
							}
							
							if($migrateAddonPrices && $optionPriceTotal > 0) {
								if(!updateForKey(
									"packagesGeneric",
									$intPackageID,
									array(
										"packageOriginalPrice" => $intPrice - $optionPriceTotal,
										"packagePrice" => $intPrice - $optionPriceTotal,
									)
								)) {
									$e = lastError();
									break 3;
								}
							}
		
							if(!$noshares) {
								$q =& new MBQuery(
									"SetBillingAccountShare",
									"insert",
									array(
										"billingAccountID" => $intBillingAccountID,
										"packageID" => $intPackageID,
										"billingAccountShareGroup" => 0,
										"billingAccountShareValue" => 1,
										"billingAccountFallbackGroup" => 1,
									)
								);
								$r =& $q->getResult();
								if(!$r->getSuccess()) {
									$e = "Problem setting billing account shares for billing account ID $intBillingAccountID for package ID $intPackageID for client ID $intClientID: : " . lastError() . ".";
									break 3;
								}
							}
							
							echo "Associated billing account $intBillingAccountID with with package $intPackageID <br />";
							flush();
		
							// find out which package attributes to migrate in this process
							$q =& new QueryMaster("select", $this->dbr);
							$q->enableManualJoining();
							$q->addTables("account_details");
							$q->addColumns("account_details.*");
							$q->addAndClause("cp_id", "=", $extPackageID);
							$t =& $q->getTable(-1, 0, "details_id");
							$packageDetails = $t->getAssociated();
							foreach($packageDetails as $detailsID => $details) {
									
								$extPanel = $details["server"];
	
								if ($extPanel=="mod_subscription" && IN_MBR_MIGRATION==1){
									/**
									 * only need these two pieces of data.
									 */
									insertFor(":packageAttributes", array(
										"packageID" => $intPackageID,
										"packageAttributeName" => "legacyLicenseKey",
										"packageAttributeValue" => $details["password"],
										"packageAttributeDateCreated" => time(),
									));
									insertFor(":packageAttributes", array(
										"packageID" => $intPackageID,
										"packageAttributeName" => "legacyLicenseUsername",
										"packageAttributeValue" => $details["username"],
										"packageAttributeDateCreated" => time(),
									));
								} else {
	
									/**
									 * made system insert all product attributes as package attributes
									 * for more complete package migration
									 */
									if (!$intAttributes[$intProductID]){
										!$intAttributes[$intProductID] = array();
									}
									if (!$intAttributes[$intProductID][0]){
										$intAttributes[$intProductID][0] = arrayFor(":productAttributes", array(
											"productID" => $intProductID,
											"serverGroupID" => 0,
										));
										show("=== GOT THE PRODUCT ATTRIBUTES FOR $intProductID : 0 ===");
									}
									
									$panelIDMapping = oneOf(
										"migrationObjs",
										array(
											"migrationConfigID" => $migrationConfigID,
											"migrationObjName" => $extPanel,
										)
									);
									$extPanelID = $panelIDMapping["migrationObjID"];
		
									$panelMapping = oneOf(
										"migrationMappings",
										array(
											"migrationConfigID" => $migrationConfigID,
											"migrationObjID" => $panelMigrationID,
											"migrationExtID" => $extPanelID,
										)
									);
									$configGroupID = $panelMapping["migrationIntID"];
		
									$serverGroup = oneOf("serverGroups", array("configGroupID" => $configGroupID));
									$serverGroupID = $serverGroup["serverGroupID"];
		
									if (!$intAttributes[$intProductID][$serverGroupID]){
										$intAttributes[$intProductID][$serverGroupID] = arrayFor(":productAttributes", array(
											"productID" => $intProductID,
											"serverGroupID" => $serverGroupID,
										));
										show("=== GOT THE PRODUCT ATTRIBUTES FOR $intProductID : $serverGroupID ===");
									}
									
									$basePackageAttribute = array(
										"packageID" => $intPackageID,
										"packageAttributeDateCreated" => mktime(),
									);
		
									foreach ((array)$intAttributes[$intProductID][0] as $attr){
										insertFor(":packageAttributes", $basePackageAttribute + array(
											"packageAttributeName" => $attr["productAttributeName"],
											"packageAttributeValue" => $attr["productAttributeValue"],
										));
									}
		
									$basePackageAttribute["serverGroupID"] = $serverGroupID;
									$basePackageAttribute["configGroupID"] = $configGroupID;
									foreach ((array)$intAttributes[$intProductID][$serverGroupID] as $attr){
										insertFor(":packageAttributes", $basePackageAttribute + array(
											"packageAttributeName" => $attr["productAttributeName"],
											"packageAttributeValue" => $attr["productAttributeValue"],
										));
									}
									
									$password = encryptPassword($clientPassword);
									$attributes = array(
										"ip" => $details["ip"],
										"clientLogin" =>    $details["username"],
										"domainUserName" => $details["username"],
										"clientPassword" => $password,
										"domainPassword" => $password,
										"panel_status" => $packageStatusName,
									);
									
									if (!$pleskID = $extClient["client_field_10"])
										$pleskID = $extClient["client_field_9"];
									else $pleskID = "";
		
									if($pleskID)
										$attributes["masterAccountID"] = $attributes["clientID"] = $pleskID;
								
								
									foreach($attributes as $name => $value) {
										if((string) $value == "") continue;
			
										$packageAttribute = $basePackageAttribute;
										$packageAttribute["packageAttributeName"] = quoteXMLconvert($name);
										$packageAttribute["packageAttributeValue"] = quoteXMLconvert($value);
										if(!$packageAttributeID = insertFor("packageAttributes", $packageAttribute)) {
											$e = "Problem inserting package attribute: " . lastError() . ".";
											break 4;
										}
										
										echo "Migrated package attribute ID $packageAttributeID for an account detail<br />";
										flush();
									}
								}
								
								if($extDomainID = $details["domain_id"]) {
									$intDomainID = $domainMappings[$extDomainID];
									if($extDomainDetails = $extDomainsByID[$extDomainID]) {
		
										$extRenewType = $extDomainDetails["monitor"];
										switch($extRenewType) {
											case 1:
												$intRenewType = getAPITypeID("tldRenew", "registrar");
												break;
											case 2:
												$intRenewType = getAPITypeID("tldRenew", "internal");
												break;
											default:
												$intRenewType = getAPITypeID("tldRenew", "disabled");
												break;
										}
		
										$q =& new MBQuery(
											"SetDomains",
											"update",
											array(
												"domainID" => $intDomainID,
												"domainRenewType" => $intRenewType,
												"packageIDs" => array(
													"packageID" => $intPackageID,
												),
											)
										);
										$r =& $q->getResult();
										if(!$r->getSuccess()) {
											$e = "Problem updating domain renew type and package association: " . lastError() . ".";
											show($q);
											show($r);
											break 3;
										}
		
										echo "Associated domain $intDomainID with package $intPackageID <br />";
										flush();
									}
								}
							}
							
							foreach($features as $feature) {
								$packageAttribute = array(
									"packageID" => $intPackageID,
									"packageAttributeDateCreated" => $feature["feature_stamp"],
									"packageAttributeName" => quoteXMLconvert($feature["feature_name"]),
									"packageAttributeValue" => quoteXMLconvert($feature["feature_comments"]),
								);
		
								if(!$packageAttributeID = insertFor("packageAttributes", $packageAttribute)) {
									$e = "Problem inserting package attribute: " . lastError() . ".";
									break 4;
								}
		
								echo "Migrated package attribute ID $packageAttributeID for a package feature<br />";
								flush();
							}
		
							/** 
							* deal with migration state for the package
							*/
		
							// we are done migrating this package; now associate the external and internal IDs for archival purposes		
							if(!insertFor(
								"migrationMappings",
								array(
									"migrationConfigID" => $migrationConfigID,
									"migrationObjID" => $packageMigrationID,
									"migrationIntID" => $intPackageID,
									"migrationExtID" => $extPackageID,
								)
							)) {
								$e = lastError();
								break 3;
							}
							// signifies that we are done with this client
							if(!updateFor(
								"migrationObjs",
								array(
									"migrationObjID" => $packageMigrationID,
									"migrationExtSeqID" => $extPackageID,
								)
							)) {
								$e = lastError();
								break 3;
							}
		
							echo "Migrated package $extPackageID as $intPackageID <br />";
							flush();
						}
						
						/** 
						* deal with migration state for the client
						*/
		
						// we are done migrating this client; now associate the external and internal IDs for archival purposes		
						if(!insertFor(
							"migrationMappings",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjID" => $clientMigrationID,
								"migrationIntID" => $intClientID,
								"migrationExtID" => $extClientID,
							)
						)) {
							$e = lastError();
							break 2;
						}
						
						// signifies that we are done with this client
						if(!updateFor(
							"migrationObjs",
							array(
								"migrationObjID" => $clientMigrationID,
								"migrationExtSeqID" => $extClientID,
							)
						)) {
							$e = lastError();
							break 2;
						}
						
						echo "Migrated client $extClientID as $intClientID <br />";
						flush();
		
						echo '<script language="javascript">parent.updateNumClients(' . ++$finishedClients . ');</script>';
						flush();
					}
		
					if($extClients && !$override) {
						echo '<script language="javascript">parent.runMigrationLoad();</script>';
						flush();
					}
				break;
			}
					
			//redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
		
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
		echo '<script language="javascript">parent.enableStartFormElements();</script>';
		flush();
	}

	function migrateClientFinances($clientID, $v4clientID, &$dbr, $productID=0, $paymentGroupID=0, $currencyID=0, $billingAccountID=0){
		global $CONF;
		$dbr = ($dbr!=0)?$dbr:$this->dbr; // get the adodb connection
		$paymentGroupID = ((int)$paymentGroupID)?$paymentGroupID:$this->migrationConfig["migrationPaymentGroupID"]; // get the payment group id
		$productID = ((int)$productID)?$productID:$this->migrationConfig["migrationProductID"]; // get the product id

		if (!$currencyID){
			if ($this->currencyID){
				$currencyID = $this->currencyID;
			} else {
				$this->paymentGroupInfo = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $paymentGroupID,
						),
					),
				)));
				$this->currencyID = $currencyID = $this->paymentGroupInfo["paymentGroupCurrencyID"];
				dbg("GOT CURRENCY ID OF: ".$currencyID);
			}
		}

		if (!isset($CONF["payment"]["paymentGroups"]["gateway"])){
			loadConfigs("payment", "paymentGroups");
			$this->gatewayConfigIDs = array();
			$this->fixGatewayConfigGroups();
			l1dbg("fixing gateways");
			foreach ($CONF["payment"]["paymentGroups"]["gateway"] as $name=>$children){
				foreach ((array)$children as $subName=>$content){
					$this->gatewayConfigIDs[$name][] = $content["configGroupID"];
				}
			}
		}

		if (!$this->secondaryGatewayIDs){
			$this->secondaryGatewayIDs = array();
			foreach ((array)$this->paymentGroupInfo["gateways"] as $k=>$gateway){
				l1dbg("have the gateway:");
				l1dbg($gateway);
				if ((int)$gateway["gatewayType"]){
					// this is a main gateway, don't need to worry about it
				} else {
					if (in_array($gateway["configGroupID"], $this->gatewayConfigIDs["paypal"])){
						$this->secondaryGatewayIDs["mod_paypal"] = $gateway["configGroupID"];
					} elseif (in_array($gateway["configGroupID"], $this->gatewayConfigIDs["worldpay"])){
						$this->secondaryGatewayIDs["mod_worldpay"] = $gateway["configGroupID"];
					}
				}
			}
		}
		
		l1dbg($this->secondaryGatewayIDs);
		
		// ok, lets get any subscriptions they have
		$h =& new QueryMaster("client_subscriptions.*", $dbr);
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$h->addAndClause("cs_status", "=", 1, "i");
		$allSubscriptions = $h->getResults();
		l1dbg($allSubscriptions);
		
		foreach ((array)$allSubscriptions as $subscription){
			l1dbg($subscription);
			l1dbg(dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetSubscriptions",
					"subCommand" => "insert",
					"params" => array(
						"clientID" => $clientID,
						"configGroupID" => $this->secondaryGatewayIDs[$subscription["gateway_module"]],
						"subscriptionExternalID" => $subscription["subscription"],
						"subscriptionDateCreated" => $subscription["cs_create_stamp"],
						"subscriptionDateModified" => $subscription["cs_modify_stamp"],
						"subscriptionStatus" => getAPIStatusID("subscription", "active"),
					),
				),
			))));
		}

		// first get all invoices
		$h =& new QueryMaster("client_invoice.*", $dbr);
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$allInvoices = $h->getResults();

		// second get all the credits
		$h =& new QueryMaster("sum(credit_amount)", $dbr);
		$h->addTables("client_credit");
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$totalCredit = $h->getOne();

		$creditResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetCreditAccounting",
				"params" => array(
					"clientID" => $clientID,
					"ledgerAccountName" => "customer_expense",
					"amount" => doubleval($totalCredit),
					"currencyID" => $currencyID,
					"description" => TRANS_OPENING_CREDIT_BALANCE,
				),
			),
		)), 1);
		dbg("added client credit");
		dbg($creditResult);

		$totalReceivable = 0;
		$packageComments = TRANS_PRIOR_INVOICES;
		foreach ($allInvoices as $invoice){

			$params = array(
				"clientID" => $clientID,
				"packageName" => TRANS_HISTORICAL_INVOICE,
				"packageDescription" => $invoice["invoice_snapshot"],
				"amount" => $invoice["invoice_amount"],
				"invoiceDate" => $invoice["invoice_date_entered"],
				"cycleID" => 0,
				"paymentGroupID" => $paymentGroupID,
				"enableInvoiceEmail" => 0,
				"amountPaid" => $invoice["invoice_amount_paid"],
				"paymentComments" => $invoice["invoice_comments"],
				"transactionDateCreated" => $invoice["invoice_date_paid"],
				"enablePaymentEmail" => 0,
				"billingAccountID" => $billingAccountID,
			);
			
			if (!$invoice["invoice_amount_paid"]>0){
				unset($params["amountPaid"]);
				unset($params["paymentComments"]);
				unset($params["transactionDateCreated"]);
				unset($params["enablePaymentEmail"]);
				unset($params["billingAccountID"]);
			}
			
			$results = dispatchMBAPI($x = array(
				"mbapi" => array(
					"command" => "ProcessSingleInvoice",
					"params" => $params,
				),
			), 1);
			
			$invoiceID = $results["mbapi"][0]["results"][0]["invoiceID"];
			$invoiceID = is_array($invoiceID) ? (int)$invoiceID[0] : 0;

		}

		return true;

	}

}
