<?php
// $Id: MigrateProductManager.php 12511 2008-01-18 18:27:51Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

define("CLIENT_PROCESS_STEP", 5);
define("CONTAINER_WIDTH", 750);

class MigrateProductManager extends SourceAction {
	function MigrateProductManager() {
		parent::SourceAction();
		$this->stringRep = "MigrateProductManager";
	}
	
	function execute() {
		global $CONF;
		do  {
			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				break;
			}
			$this->migrationConfig = $migrationConfig;
			
			switch ($migrationConfig["migrationType"]){
				/**
				* WHMCS migration
				*/
				case getAPITypeID("migration", "whmcs351"):
					// doesn't support product migration yet
					redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
				break;
				case getAPITypeID("migration", "mb4"):
					// get our product migration information, or initialize it if necessary
					if(!$productMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "products"))) {
						if(!$productMigrationID = insertFor(
								"migrationObjs",
								$productMigration = array(
									"migrationConfigID" => $migrationConfigID,
									"migrationObjName" => "products",
									"migrationExtObjName" => "package_info",
									"migrationExtObjKey" => "pack_id",
									"migrationExtSeqID" => 0,
									"migrationIntObjName" => "products",
									"migrationIntObjKey" => "productID",
									"migrationIntSeqID" => 0,
								)
							)
						) {
							$e = "Could not initialize product migration state.";
							break;
						}
						$productMigration["migrationObjID"] = $productMigrationID;
					} else {
						$productMigrationID = $productMigration["migrationObjID"];
					}
		
					// connect to v4
					$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
					$this->dbr->autoRollback = true;
					$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
					//show($dbr);
					if(!$this->dbr->IsConnected()) {
						$e = "Could not connect to the database, please check your config options.";
						break;
					}
					
					$totalProducts = $this->dbr->GetOne("SELECT COUNT(*) FROM package_type");
					$finishedProducts = (int) countFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $productMigrationID,
						)
					);
					$remainingProducts = $totalProducts - $finishedProducts;
		
					$this->smartyVars["migrationConfigID"] = $migrationConfigID;
					$this->smartyVars["productMigrationID"] = $productMigrationID;
					$this->smartyVars["productMigration"] = $productMigration;
					$this->smartyVars["totalProducts"] = $totalProducts;
					$this->smartyVars["remainingProducts"] = $remainingProducts;
					$this->smartyVars["finishedProducts"] = $finishedProducts;
					$this->smartyVars["distributionMetrics"] = array();
					$this->smartyVars["numMachines"] = (int)$CONF["migrationDistributionNumber"];
					if ((int)$CONF["migrationDistributionNumber"]){
						for ($i=0;$i<(int)$CONF["migrationDistributionNumber"];$i++)$this->smartyVars["distributionMetrics"][$i] = $i;
					}
					
					$barWidth = (int) (CONTAINER_WIDTH * ($finishedProducts / $totalProducts));
					$percentage = round(($finishedProducts / $totalProducts)*100, 2);
					if(!$barWidth) $barWidth = 1;
					
					$this->smartyVars["containerWidth"] = CONTAINER_WIDTH;
					$this->smartyVars["barWidth"] = $barWidth;
		
					SourceAction::addTemplate("migrate/MigrateProductManager");
				break;
			}
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
	}
}
