<?php
// $Id: MigrateProductProcess.php 12498 2008-01-16 20:59:34Z bwoolley $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

set_time_limit(0);
ignore_user_abort();

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-action/migrate/MigrateProcessCommon.php");

define("PRODUCT_PROCESS_STEP", 25);

class MigrateProductProcess extends MigrateProcessCommon {
	var $addonGroupIDCache;
	var $addonOptionIDCache;
	
	function MigrateProductProcess() {
		MigrateProcessCommon::MigrateProcessCommon();
		$this->stringRep = "MigrateProductProcess";
		
	}
	
	function execute() {
		global $CONF;
		$adminID = $CONF["user"]["id"];
		$syncMigrationIDs = (bool) $CONF["syncMigrationIDs"];
		$raisePriorBalancePackageKeysBy = (int) $CONF["raisePriorBalancePackageKeysBy"];
		$migrateProducts = (bool) $CONF["migrateProducts"];
		$migrateTLDs = (bool) $CONF["migrateTLDs"];
		$migrateAddonPrices = (bool) $CONF["migrateAddonPrices"];
		$migrationProductGroupID = (int) $CONF["migrationProductGroupID"];
		
		$enableLTDiscount = $CONF["enableLTDiscount"];
		do  {
			$e = "";

			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			$productProcessStep = (int) $_REQUEST["productProcessStep"] ? (int) $_REQUEST["productProcessStep"] : PRODUCT_PROCESS_STEP;

			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				exit;
			}
			$this->migrationConfig = $migrationConfig;
			$this->migrationConfigID = $migrationConfigID;

			$this->addonGroupIDCache =& new PersistentHash("addonGroup:" . $this->migrationConfigID);
			$this->addonOptionIDCache =& new PersistentHash("addonOption:" . $this->migrationConfigID);

			// get our client migration information
			if(!$productMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "products"))) {
				$e = "Could not get product migration state. Must be called from the migration association page, which will initialize the product migration state.";
				break;
			} else {
				$productMigrationID = $productMigration["migrationObjID"];
			}
			
			// get our panel migration information
			if(!$panelMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "panels"))) {
				$e = "Could not get panel migration state. Must be called from the migration association page, which will initialize the panel migration state.";
				break;
			} else {
				$panelMigrationID = $panelMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$registrarMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "registrars"))) {
				$e = "Could not get registrar migration state. Must be called from the migration association page, which will initialize the registrar migration state.";
				break;
			} else {
				$registrarMigrationID = $registrarMigration["migrationObjID"];
			}

			if (!(int) $this->migrationConfig["migrationOrphanProductID"]){
				$migrationOrphanProductID = insertFor(
					"products",
					array(
						"productName" => TRANS_ORPHAN_PACKAGE_PRODUCT_FOR . " " . $this->migrationConfig["migrationConfigID"],
						"productActive" => 0,
						"productStopNumCycles" => 1,
						"productCancellationType" => getAPITypeID("cancellation", "admin_only"),
					)
				);
				
				if($syncMigrationIDs && ($migrationOrphanProductID < $raisePriorBalancePackageKeysBy)) {
					$newMigrationOrphanProductID = $migrationOrphanProductID + $raisePriorBalancePackageKeysBy;
					$s = updateForKey(
						"productsGeneric",
						$migrationOrphanProductID,
						array(
							"updateToID" => $newMigrationOrphanProductID
						)
					);
					$migrationOrphanProductID = $newMigrationOrphanProductID;
				}
				
				updateFor(
					"migrationConfigs",
					array(
						"migrationConfigID" => $this->migrationConfig["migrationConfigID"],
						"migrationOrphanProductID" => $this->migrationConfig["migrationOrphanProductID"] = $migrationOrphanProductID,
					)
				);
			}

			if ($this->currencyID){
				$currencyID = $this->currencyID;
			} else {
				$this->paymentGroupInfo = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
						),
					),
				)));
				$this->currencyID = $currencyID = $this->paymentGroupInfo["paymentGroupCurrencyID"];
				dbg("GOT CURRENCY ID OF: ".$currencyID);
			}



			//show($clientMigration);

			// connect to v4
			$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$this->dbr->autoRollback = true;
			$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$this->dbr->IsConnected()) {
				$e = "Could not connect to the database, please check your config options.";
				break;
			}

			// get the system language ID
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("config");
			$q->addColumns("config_3");
			$q->addAndClause("config_type", "=", "main", "s");
			$systemlanguageISO2 = $q->getOne();
			$language = oneOf("languages", array("languageISO2" => $systemlanguageISO2));
			$languageID = $language["languageID"];
			
			//show($systemlanguageISO2);
			//show($languageID);

			$q =& new MBQuery(
				"ProcessReservations", "",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $productMigrationID,
					"numReservations" => $productProcessStep,
					"adminID" => $adminID,
				)
			);
			$r =& $q->getResult();
			
			$s = $r->getSubjectFrom(array("mbapi", "results", 0));
			$results = $s->getCollapsed();
			show($results);
			$reservedProducts = $results["reserved"];
			$totalProducts = $results["total"];
			$productIDs = $results["reservations"]["reservedID"];

			if($productIDs) {
				// find out which clients to migrate in this process
				$sql = "
					select distinct
						cp_billing_cycle in " . $this->getOneTimeCycleList() . " as one_time_only,
						cp_billing_cycle in " . $this->getDomainCycleList() . " as is_domain,
						package_type.*
					from
						package_type
					left join
						client_package
					on
						package_type.pack_id = client_package.pack_id
					where
						package_type.pack_id in (" . implode(", ", (array) $productIDs) . ")
					order by package_type.pack_id asc
				";
				$r = $this->dbr->SelectLimit($sql, $productProcessStep, 0);
				if($r !== false) {
					$t =& new Table($r->GetArray(), "pack_id", "pack_name");
					$extProducts = $t->getAssociated();
					$extProductIDs = $t->getKeys();
				} else {
					$e = $this->dbr->ErrorMsg();
					break;
				}
			} else {
				$extProducts = array();
			}
			
			$q =& new QueryMaster("select", $this->dbr);
			$q->addJoin("package_type", "pack_id", "package_variables");
			$q->addColumns("package_variables.*");
			$q->addAndClause("package_type.pack_id", "=", $extProductIDs);
			$t =& $q->getTable(NULL, NULL, "pack_id");
			$addonGroupTablesByPID =& $t->getAssociatedTables();
			
			$finishedProducts = (int) countFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $productMigrationID,
				)
			);
			echo '<script language="javascript">parent.updateNumProducts(' . $finishedProducts . ');</script>';
			flush();
			
			//show($extClients);
			
			// migrate each client
			foreach($extProducts as $extProductID => $extPackData) {
				if(isset($addonGroupTablesByPID[$extProductID])) {
					$addonGroupTable =& $addonGroupTablesByPID[$extProductID];
					$addonGroupTable->setKey("var_id");
					$addonGroupsByID = $addonGroupTable->getAssociated();
				} else {
					$addonGroupsByID = array();
				}
			
				$intProductName = $extPackData["pack_name"];
				//if($intProductName == "Domain Registration") {

				$sql = "select distinct pack_id from tld_config where pack_id = ${extProductID}";
				$r = $this->dbr->selectLimit($sql, 1, 0);
				$isDomain = false;
				if($r !== false) {
					if($r->GetArray()) {
						$isDomain = true;
					}
				} else {
					$e = $this->dbr->ErrorMsg();
					break;
				}

				//if($extPackData["is_domain"]) {
				if($isDomain) {
					$isDomain = true;
					$intProductType = getAPITypeID("products", "domain");
					$intProductProratable = 0;
				} else {
					$isDomain = false;
					$intProductType = getAPITypeID("products", "hosting");
					$intProductProratable = 1;
				}
				$productStopNumCycles = (int) $extPackData["one_time_only"];
				if($migrationProductGroupID) {
					$productGroups = array(
						"productGroupIDs" => array(
							"productGroupID" => $migrationProductGroupID
						),
					);
				} else {
					$productGroups = array();
				}
				if(!$intProductID = insertFor(
					"productsGeneric",
					$intProduct = array(
						"productName" => quoteXMLconvert($intProductName),
						"productType" => $intProductType,
						"productComments" => quoteXMLconvert($extPackData["pack_comments"]),
						"productStopNumCycles" => $productStopNumCycles,
						"productActive" => 1,
						"productProratable" => $intProductProratable,
						"productDiscountable" => 1,
						"productDateCreated" => mktime(),
						"productDomainRequired" => getAPIStatusID("productdependencyrules", "optional"),
						"productAddonRequired" => getAPIStatusID("productdependencyrules", "optional"),
						"productCancellationType" => getAPITypeID("cancellation", "admin_suspend"),
					) + $productGroups,
					($syncMigrationIDs ? $extProductID : NULL)
				)) {
					show($intProduct);
					show(toXML($intProduct));
					$e = lastError();
					break 2;
				}

				$relations = array(
				);
				$intCycleIDSet = new Set();
				if($isDomain) {
					show("Handling domain pricing.");
					$intTldIDSet = new Set();
					$domainType = getAPITypeID("products", "domain");

					$registrarD =& new DataSource(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $registrarMigrationID,
						)
					);
					$registrarT =& $registrarD->getTable();
					$registrarT->setKey("migrationExtID");
					$registrarT->setName("migrationIntID");

					$q =& new QueryMaster("select", $this->dbr);
					$q->enableManualJoining();
					$q->addTables("tld_config");
					$q->addColumns(
						"tld_config.tld_configs",
						"tld_config.tld_id",
						"tld_config.tld_extension",
						"tld_config.tld_name",
						"tld_config.registrar_id",
						"tld_config.tld_transfer",
						"tld_config.tld_1y",
						"tld_config.tld_2y",
						"tld_config.tld_3y",
						"tld_config.tld_4y",
						"tld_config.tld_5y",
						"tld_config.tld_6y",
						"tld_config.tld_7y",
						"tld_config.tld_8y",
						"tld_config.tld_9y",
						"tld_config.tld_10y"
					);
					$q->addAndClause("pack_id", "=", $extProductID);
					$t =& $q->getTable(NULL, NULL, "tld_id", "tld_extension");
					$t =& $t->getJoinedWith($registrarT, "migrationExtID", "registrar_id");
					//exit;
					$tldConfigs = $t->getTable();

					$variants = array();
					$yearExtCycleMap = $this->domainYearCycleMap;
					//show($q->getQuery());
					//show($yearExtCycleMap);
					//show($t);
					//show($registrarT);
					//exit();
					foreach($tldConfigs as $tldConfig) {
						$tldOptions = unserialize($tldConfig["tld_configs"]);
						$intRegistrarID = $tldConfig["migrationIntID"];
						$tldExtension = $tldConfig["tld_extension"];
						switch($tldExtension) {
// XXX: more needed
							case "co.uk":
								$transferMinimumYear = 2;
								break;
							default:
								$transferMinimumYear = 1;
								break;
						}
						$tldTransferMinimumCycleID = $this->getCycleID($yearExtCycleMap[$transferMinimumYear], $domainType);
						$tldMinimumCycleID = $this->getCycleID($yearExtCycleMap[$tldOptions["tld_minTerm"]], $domainType);
						$tldMaximumCycleID = $this->getCycleID($yearExtCycleMap[$tldOptions["tld_maxTerm"]], $domainType);
						
						switch($tldExtension) {
// XXX: needs research
							case "some tld":
							case "another tld":
								$tldTransferType = getAPITypeID("tldTransfer", "code");
								break;
							default:
								$tldTransferType = getAPITypeID("tldTransfer", "email");
								break;
						}
						
						if($migrateTLDs) {
							$tld = array(
								"registrarID" => $intRegistrarID,
								"tldExtension" => $tldExtension,
								"tldName" => $tldConfig["tld_name"],
								"tldWhoisServer" => $tldConfig["tld_whois_server"],
								"tldWhoisResp" => $tldConfig["tld_whois_response"],
								"tldActive" => 1,
								"tldAutoSearch" => $tldConfig["tld_auto_search"],
								"tldTransferMinimumCycleID" => $tldTransferMinimumCycleID,
								"tldMinimumCycleID" => $tldMinimumCycleID,
								"tldMaximumCycleID" => $tldMaximumCycleID,
								"tldRenewType" => getAPITypeID("tldRenew", "internal"),
								"tldIsTransferable" => (int) (bool) $tldOptions["tld_transferable"],
								"tldIDNSupport" => (int) (bool) $tldOptions["tld_idn"],
								"tldIDNType" => getAPITypeID("tldIDN", "punycode"),
								"tldRemoteLockEnabled" => (int) (bool) $tldOptions["tld_lockable"],
								"tldDisplayOrder" => $tldConfig["tld_id"],
							);
							
							$tldID = insertFor("TLDs", $tld);
						} else {
							$tldD =& new DataSource(
								"TLDs",
								array(
									"registrarID" => $intRegistrarID,
									"tldExtension" => $tldExtension,
								)
							);
							$tldID = $tldD->getID();
							$tld = $tldD->getOne();
						}
						$intTldIDSet->addElement($tldID);

						$variants[] = $variant = array(
							"productVariantDisplayName" => quoteXMLconvert($tldConfig["tld_name"]),
							"productVariantActive" => 1,
							"productID" => $intProductID,
							"tldID" => $tldID,
							"taxZoneGroupID" => (int) $CONF["migrationTaxZoneGroupID"],
							"cycleDiscountGroupID" => (int) $CONF["migrationDiscountGroupID"],
						);
						if(!$variantID = insertFor("variants", $variant)) {
							$e = lastError();
							break 3;
						}

						$variantPrices = array();
						if($tldConfig["tld_transfer"]) {
							$price = (float) $tldConfig["tld_transfer"];
							if($price == 0.001 || $price == 0.0001) $price = 0.0;
							$cycleID = $tld["tldTransferMinimumCycleID"];
							$intCycleIDSet->addElement($cycleID);
							$variantPrices[] = $this->getPrice($price, $cycleID, "transfer");
						}
						foreach($yearExtCycleMap as $year => $cycleInfo) {
							if((float) $tldConfig["tld_${year}y"] > 0.0) {
								$price = (float) $tldConfig["tld_${year}y"];
								if($price == 0.001 || $price == 0.0001) $price = 0.0;
								$cycleID = $this->getCycleID($cycleInfo, $domainType);
								$intCycleIDSet->addElement($cycleID);
								$variantPrices[] = $this->getPrice($price, $cycleID);
							}
						}

						foreach($variantPrices as $variantPrice) {
							$variantPrice["productVariantID"] = $variantID;
							if(!insertFor("variantPrices", $variantPrice)) {
								$e = lastError();
								break 4;
							}
						}
					}
					$relations["tldIDs"] = array(
						"tldID" => $tldIDs = $intTldIDSet->getSet(),
					);
				} else {
					show("Handling regular pricing.");
					if(!$variantID = insertFor(
						"variants",
						$variant = array(
							"productVariantDisplayName" => quoteXMLconvert($intProductName),
							"productVariantActive" => 1,
							"productID" => $intProductID,
							"taxZoneGroupID" => (int) $CONF["migrationTaxZoneGroupID"],
							"cycleDiscountGroupID" => (int) $CONF["migrationDiscountGroupID"],
						)
					)) {
						$e = lastError();
						break 2;
					}

					$regularPrices = $extPackData["pack_price"];
					$setupPrices = $extPackData["pack_setup"];

					$variantPrices = array();
					foreach(array(1, 3, 6, 12, 24, 36) as $cycleInfo) {

						if($regularPrice = $this->splitPrice($regularPrices, "price", $cycleInfo) * $cycleInfo) {
							$cycleID = $this->getCycleID($cycleInfo);
							$intCycleIDSet->addElement($cycleID);

							show("Got regular price: $regularPrice");
							if($regularPrice == 0.001 || $regularPrice == 0.0001) $regularPrice = 0.0;
							show("Resolved to: $regularPrice");
							$variantPrices[] = $this->getPrice($regularPrice, $cycleID);
						}

						if($setupPrice = $this->splitPrice($setupPrices, "setup", $cycleInfo)) {
							$cycleID = $this->getCycleID($cycleInfo);
							$intCycleIDSet->addElement($cycleID);

							show("Got regular price: $setupPrice");
							if($setupPrice == 0.001 || $setupPrice == 0.0001) $setupPrice = 0.0;
							show("Resolved to: $setupPrice");
							$variantPrices[] = $this->getPrice($setupPrice, $cycleID, "setup");
						}
						
					}

					show($variantPrices);

					foreach($variantPrices as $variantPrice) {
						$variantPrice["productVariantID"] = $variantID;
						if(!insertFor("variantPrices", $variantPrice)) {
							$e = lastError();
							break 3;
						}
					}
				}
				show("Done handling pricing.");

				$display = $extPackData["pack_display"];
				$displayOrder = $extPackData["pack_order"];

				$relations["cycleIDs"] = array(
					"cycleID" => $cycleIDs = $intCycleIDSet->getSet(),
				);
				$relations["orderFormIDs"] = array(
					"orderFormID" => $orderFormID = $this->migrationConfig["migrationOrderFormID"],
				);
				if(!updateForKey("productsGeneric", $intProductID, $relations)) {
					$e = lastError();
					break 2;
				}

				$displayName = $this->migrationConfig["migrationName"] . " (" . $this->migrationConfigID . "): " . $display;

				if(!$websiteWidgetID = IDByName("websiteWidgets", $displayName, array("comparisonOperator" => "="))) {
					if(!$websiteWidgetID = insertFor(
						"websiteWidgets",
						array(
							"websiteWidgetName" => quoteXMLconvert($displayName),
							"websiteWidgetTpl" => "simpleWidget-List",
							"orderFormID" => $orderFormID,
						)
					)) {
						$e = lastError();
						break 2;
					}
					show("Made new website widget $displayName at ID $websiteWidgetID");
				} else {
					show("Found website widget $displayName at ID $websiteWidgetID");
				}

				show("Associating website widget with product.");
				if(!insertFor(
					"websiteWidgetProductRels",
					array(
						"websiteWidgetID" => $websiteWidgetID,
						"websiteWidgetOrder" => $displayOrder,
						"productID" => $intProductID,
					)
				)) {
					//$e = lastError();
					//break 3;
				}

				if(!insertFor(
					"productAttributes",
					array(
						"productID" => $intProductID,
						"productAttributeName" => "addons",
						"productAttributeValue" => "yes",
					)
				)) {
					$e = lastError();
					break 2;
				}

				show("Adding product to cache and mapping.");								
				$this->productCache[$intProductID] = $intProduct;
				
				/*****************
				 * Add-on Groups *
				 *****************/
				
				foreach($addonGroupsByID as $varID => $variable) {
					if($enableLTDiscount && $variable["variable_caption"] == "DiscountBasis") continue;
					
					$addonInfo = array($variable["variable_caption"], $variable["visible"], $variable["input_type"]);
					$addonHash = str_replace("/", ".", hashVal($addonInfo));
					$addonCode = "ag:$addonHash";

					show("== Handling add-on group " . $variable["variable_caption"] . " ==");
					show("Add-on group code: $addonCode");
					
					if($this->addonGroupIDCache->exists($addonCode)) {
						$addonGroupID = $this->addonGroupIDCache->get($addonCode);
						show("Found ID $addonGroupID in cache.");
					} else {
						if($addonGroupObj = oneByName("migrationObjs", $addonCode, array("comparisonOperator" => "="))) {
							$addonGroupID = $addonGroupObj["migrationIntSeqID"];
							show("Found ID $addonGroupID in mapping.");
						} else {
							show("Not found. Making new...");
							switch($variable["input_type"]) {
								// gathered by looking at source
								case 1:  $inputType = "s";   break; // select
								case 2:  $inputType = false; break; // text
								case 3:  $inputType = "c";   break; // checkbox
								case 4:  $inputType = "r";   break; // radio
								case 5:  $inputType = false; break; // hidden
								case 6:  $inputType = false; break; // password
								default: $inputType = false; break;
							}
							if(!$inputType) continue; // XXX: skip add-ons without corresponding input types?
							if(!$s1 = insertFor(
								"migrationObjs",
								array(
									"migrationObjName" => $addonCode,
									"migrationIntSeqID" => $s2 = $addonGroupID = insertFor(
										"productAddonGroups",
										array(
											"productAddonGroupActive" => (int) (bool) $variable["visible"], // XXX: is this right?
											"productAddonGroupName" => $variable["variable_caption"],
											"productAddonGroupInputType" => $inputType,
										)
									),
								)
							) || !$s2) {
								if(!$s1)  {
									$e = "Problem inserting migration object for add-on group: " . lastError() . ".";
									show($e);
								} else if(!$s2) {
									$e = "Problem inserting add-on group: " . lastError() . ".";
									show($e);
								}
								break 3;
							}
							show("Made add-on group ID $addonGroupID");
						}
						$this->addonGroupIDCache->set($addonCode, $addonGroupID);
					}

					if(!$s = updateForKey(
						"products",
						$intProductID,
						array(
							"removeProductAddonGroupIDs" => array(
								"productAddonGroupID" => $addonGroupID, // XXX: this is only safe because SetProducts does this first!
							),
							"productAddonGroupIDs" => array(
								"productAddonGroupID" => $addonGroupID,
							),
						)
					)) {
						$e = "Problem associating add-on group $addonGroupID with v5 product $intProductID: " . lastError() . ".";
						show($e);
						break 3;
					}
					show("Associated main product with addon group");
					
					/******************
					 * Add-on Options *
					 ******************/
				
					$addonOptions = array_map("trim", explode(",", $variable["possible_values"]));
					$addonInfo = array();
					foreach($addonOptions as $possibleOption) {
						if(!$possibleOption) continue;
						list($apiName, $displayName, $price1, $price3, $price6, $price12, $price24, $price36) = array_map("trim", explode("|", $possibleOption));

						$addonInfo = compact("apiName", "displayName", "price1", "price3", "price6", "price12", "price24", "price36");

						$optionHash = str_replace("/", ".", hashVal($addonInfo));
						$optionCode = "ao:$addonHash:$optionHash";

						show("== Handling add-on option " . $addonInfo["displayName"] . " ==");
						show("Add-on option code: $optionCode");
						
						if($this->addonOptionIDCache->exists($optionCode)) {
							$optionCodeID = $this->addonOptionIDCache->get($optionCode);
							show("Found ID $optionCodeID in cache.");
						} else {
							if($addonOptionObj = oneByName("migrationObjs", $optionCode, array("comparisonOperator" => "="))) {
								$optionCodeID = $addonOptionObj["migrationIntSeqID"];
								show("Found ID $optionCodeID in mapping.");
							} else {
								show("Not found. Making new...");
								$discountable = 1;
								if($enableLTDiscount) {
									$discountable = 0;
									if($price24 > 0) $discountable = 1;
								}

								$prices = array();
								$cycleIDs = array();
								foreach(
									array(
										1 => $addonInfo["price1"],
										3 => $addonInfo["price3"],
										6 => $addonInfo["price6"],
										12 => $addonInfo["price12"],
										24 => $addonInfo["price24"],
										36 => $addonInfo["price36"],
									) as $cycleInfo => $price
								) {
									$cycleIDs[] = $cycleID = $this->getCycleID($cycleInfo);
									if((float) $price > 0) {
										$prices[] = $this->getPrice($price * $cycleInfo, $cycleID);
									} else {
										$prices[] = $this->getPrice(0.0, $cycleID);
									}
								}
								
								if($syncMigrationIDs) {
									$addonProductCommand = "productsGeneric";
									$addonProduct = array(
										"productName" => $addonInfo["displayName"],
										"productIsAddon" => 1,
										"productActive" => 1,
										"productAddonGroupID" => $addonGroupID,
										"productDateCreated" => mktime(),
										"productDiscountable" => $discountable,
									);
									$addonProductDetails = array(
										"cycleIDs" => array(
											"cycleID" => $cycleIDs,
										),
										"orderFormIDs" => array(
											"orderFormID" => $this->migrationConfig["migrationOrderFormID"],
										),
										"productVariants" => array(
											"productVariant" => array(
												"productVariantDisplayName" => $addonInfo["displayName"],
												"taxZoneGroupID" => (int) $CONF["migrationTaxZoneGroupID"],
												"cycleDiscountGroupID" => (int) $CONF["migrationDiscountGroupID"],
												"productVariantActive" => 1,
												"productVariantPrices" => array(
													"productVariantPrice" => $prices,
												),
											),
										),
									);
								} else {
									$addonProductCommand = "products";
									$addonProduct = array(
										"productName" => $addonInfo["displayName"],
										"productIsAddon" => 1,
										"productActive" => 1,
										"productAddonGroupID" => $addonGroupID,
										"productDateCreated" => mktime(),
										"productDiscountable" => $discountable,
										"cycleIDs" => array(
											"cycleID" => $cycleIDs,
										),
										"orderFormIDs" => array(
											"orderFormID" => $this->migrationConfig["migrationOrderFormID"],
										),
										"productVariants" => array(
											"productVariant" => array(
												"productVariantDisplayName" => $addonInfo["displayName"],
												"productVariantActive" => 1,
												"taxZoneGroupID" => (int) $CONF["migrationTaxZoneGroupID"],
												"cycleDiscountGroupID" => (int) $CONF["migrationDiscountGroupID"],
												"productVariantPrices" => array(
													"productVariantPrice" => $prices,
												),
											),
										),
									);
								}

								if(!$s1 = insertFor(
									"migrationObjs",
									array(
										"migrationObjName" => $optionCode,
										"migrationIntSeqID" => $s2 = $addonProductID = $optionCodeID = insertFor($addonProductCommand, $addonProduct),
									)
								) || !$s2) {
									if(!$s1) {
										$e = "Problem inserting migration object for add-on option: " . lastError() . "";
										show($e);
									} else if(!$s2) {
										$e = "Problem inserting add-on option into group $optionCodeID: " . lastError() . "";
										show($e);
									}
									break 3;
								}

								if($syncMigrationIDs && ($optionCodeID < $raisePriorBalancePackageKeysBy)) {
									$newOptionCodeID = $optionCodeID + $raisePriorBalancePackageKeysBy;
									$s = updateForKey(
										"productsGeneric",
										$optionCodeID,
										array(
											"updateToID" => $newOptionCodeID
										)
									);
									$optionCodeID = $newOptionCodeID;
								}
								if($syncMigrationIDs) {
									if(!updateForKey("products", $optionCodeID, $addonProductDetails)) {
										$e = "Problem updating add-on product for details ID $optionCodeID.";
										break 3;
									}										
								}

								show("Made add-on option ID $addonProductID");
							}
							$this->addonOptionIDCache->set($optionCode, $optionCodeID);
						}

						show("Associating add-on option $optionCodeID with product $intProductID");
						if(!$s = updateForKey(
							"products",
							$intProductID,
							array(
								"productChildrenIDs" => array(
									"productID" => $optionCodeID,
								),
							)
						)) {
							$e = "Problem associating add-on option $optionCodeID with v5 product $intProductID: " . lastError() . ".";
							show($e);
							break 3;
						}

					}
				}
				
				if(!insertFor(
					"migrationMappings",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjID" => $productMigrationID,
						"migrationExtID" => $extProductID,
						"migrationIntID" => $intProductID,
					)
				)) {
					$e = lastError();
					break 2;
				}
				show("Made product ID $intProductID");

				// signifies that we are done with this product
				if(!updateFor(
					"migrationObjs",
					array(
						"migrationObjID" => $productMigrationID,
						"migrationExtSeqID" => $extProductID,
					)
				)) {
					$e = lastError();
					break 2;
				}


				echo '<script language="javascript">parent.updateNumProducts(' . ++$finishedProducts . ');</script>';
				flush();
			}

			if($extProducts) {
				echo '<script language="javascript">parent.runMigrationLoad();</script>';
				flush();
			} else {
				echo '<script language="javascript">parent.runForward();</script>';
				flush();
			}
			
			//redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
		
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
		echo '<script language="javascript">parent.enableStartFormElements();</script>';
		flush();
	}


}
