<?php
// $Id: MigrateSkip.php 7730 2006-06-23 21:59:28Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

set_time_limit(0);
ignore_user_abort();

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/accounting/Sale.php");
require_once mb_path("/lib-modernbill/include/accounting/Payment.php");
//header("Content-Type: text/html; charset=utf-8");

define("CLIENT_PROCESS_STEP", 5);

class MigrateSkip extends SourceAction {
	function MigrateSkip() {
		parent::SourceAction();
		$this->stringRep = "MigrateSkip";
	}
	
	function execute() {
		do  {
			$e = "";
			
			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];

			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				break;
			}
			
			// get our client migration information, or redirect back to the details page if not found.
			if(!$clientMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "clients"))) {
				redirect("migrate.php", getActionID("ShowMigrationConfigDetails"), array("migrationConfigID" => $migrationConfig["migrationConfigID"], "error" => 1));
				break;
			} else {
				$clientMigrationID = $clientMigration["migrationObjID"];
			}

			$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$this->dbr->autoRollback = true;
			$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$this->dbr->IsConnected()) {
				$e = "Could not connect to the database, please check your config options.";
				break;
			}

			// get the system language ID
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("config");
			$q->addColumns("config_3");
			$q->addAndClause("config_type", "=", "main", "s");
			$systemlanguageISO2 = $q->getOne();
			$language = oneOf("languages", array("languageISO2" => $systemlanguageISO2));
			$languageID = $language["languageID"];

			// find out which clients to migrate in this process
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("client_info");
			$q->addColumns("client_info.*");
			$lastExtClientID = $clientMigration["migrationExtSeqID"];
			$q->addAndClause("client_id", ">", $lastExtClientID);
			$t =& $q->getTable(1, 0, "client_id", "client_email");
			$extClients = $t->getAssociated();

			$finishedClients = (int) countFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $clientMigrationID,
				)
			);
			echo '<script language="javascript">parent.updateNumClients(' . $finishedClients . ');</script>';
			flush();

			foreach($extClients as $extClientID => $extClient) {
				/** 
				 * deal with migration state for the client
				 */

				/**
				 * actually migrate the data
				 */
				switch($extClient["client_status"]) {
					case "1":
						$clientStatus = getAPIStatusID("client", "pending");
						$clientActive = 0;
						break;
					case "2":
						$clientStatus = getAPIStatusID("client", "none");
						$clientActive = 1;
						break;
					case "3":
						$clientStatus = getAPIStatusID("client", "pending");
						$clientActive = 1;
						break;
					case "4":
						$clientStatus = getAPIStatusID("client", "canceled");
						$clientActive = 1;
						break;
					case "5":
						$clientStatus = getAPIStatusID("client", "fraudulent");
						$clientActive = 1;
						break;
				}
				$country = oneOf("countries", array("countriesISO2" => strtoupper($extClient["client_country"])));
				if(!$country) {
					$country  = oneOf("countries", array("countriesISO2" => "US"));
				}
				$countriesID = $country["countriesID"];
				$taxIDNumber = "";
				
				/*
				1 cc batch
				2 regular check
				3 cc single
				4 echeck
				5 paypal
				6 worldpay
				50 other
				*/
				switch($extClient["billing_method"]) {
					case 1:
					case 3:
						$billingCardType = getAPITypeID("billingAccount", "card");
						break;
					case 4:
						$billingCardType = getAPITypeID("billingAccount", "echeck");
						break;
					case 2:
						$billingCardType = getAPITypeID("billingAccount", "manual");
						break;
					case 3:
					case 5:
					case 6:
						$billingCardType = getAPITypeID("billingAccount", "secondary");
						break;
					case "something else":
						$billingCardType = getAPITypeID("billingAccount", "bank");
						break;
				}

				$intClient = array(
					"clientCompany" => "",
					"companyID" => 1,
					"clientStatus" => $clientStatus,
					"applyTax" => $extClient["apply_tax"],
					"taxIDNumber" => $taxIDNumber,
					"themeID" => 1,
					"countriesID" => $countriesID,
					"clientActive" => $clientActive,
					"clientDateCreated" => $extClient["client_stamp"],
					"clientContacts" => array(
						"clientContact" => array(
							$intPrimaryContact = array(
								"contactPrimary" => 1,
								"contactUsername" => "",
								"contactPassword" => "", // md5, but login script will fix it
								"contactFirstName" => "",
								"contactLastName" => "",
								"contactEmail" => "",
								"contactEmailFormat" => (bool) $extClient["send_email_type"],
								"contactCompany" => "",
								"contactAddress1" => "",
								"contactAddress2" => "",
								"contactCity" => "",
								"contactState" => "",
								"contactZip" => "",
								"languageID" => $languageID,
								"countriesID" => $countriesID,
								"contactPhone1" => "",
								"contactPhone2" => "",
								"contactFax" => "",
								"contactDateCreated" => $extClient["client_stamp"],
								"contactActive" => 1, // Kris says client being inactive is enough
								"clientBillingAccounts" => array(
									"clientBillingAccount" => array(
										$intBillingAccount = array(
											"billingCardNameOnCard" => "",
											"billingCardType" => $billingCardType,
											"billingCardNum" => "",
											"billingCardExpYear" => "",
											"billingCardExpMonth" => "",
											"billingCardIssueNum" => "",
											"billingCardStartDate" => "",
											
											"billingBankType" => getAPITypeID("bankAccount", "checking"),
											"billingBankName" => "",
											"billingBankAbaCode" => "",
											"billingBankAccountNum" => "",
											"billingBankLicenseNum" => "",
											"billingBankLicenseState" => "",
											"billingBankDob" => "",
											"billingBankState" => "",
											
											"billingAccountNumLastFour" => "",
											
											"billingAccountType" => "",
											"secGatewayConfigGroupID" => "",
										),
									),
								),
							),
						),
					),
				);
				//show($intClient);
				if(!$intClientID = insertFor("clients", $intClient)) {
					$e = "Problem inserting client.";
					show($intClient);
					show(toXML($intClient));
					break 2;
				}
				
				//show($intClientID);
				
				$this->migrateClientFinances(
					$intClientID,
					$extClientID,
					$this->dbr,
					$this->migrationConfig["migrationProductID"],
					$this->migrationConfig["migrationPaymentGroupID"]
				);
				

				// we are done migrating this client; now associate the external and internal IDs for archival purposes		
				insertFor(
					"migrationMappings",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjID" => $clientMigrationID,
						"migrationIntID" => $intClientID,
						"migrationExtID" => $extClientID,
					)
				);
				// signifies that we are done with this client
				updateFor(
					"migrationObjs",
					array(
						"migrationObjID" => $clientMigrationID,
						"migrationExtSeqID" => $extClientID,
					)
				);
			}			
			
			

			if($extClients) {
				echo '<script language="javascript">parent.runMigrationLoad();</script>';
				flush();
			}
			
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
		//echo '<script language="javascript">parent.enableStartFormElements();</script>';
		//flush();
	}
	function migrateClientFinances($clientID, $v4clientID, &$dbr, $productID=0, $paymentGroupID=0, $currencyID=0){

		$dbr = ($dbr!=0)?$dbr:$this->dbr; // get the adodb connection
		$paymentGroupID = ((int)$paymentGroupID)?$paymentGroupID:$this->migrationConfig["migrationPaymentGroupID"]; // get the payment group id
		$productID = ((int)$productID)?$productID:$this->migrationConfig["migrationProductID"]; // get the product id

		if (!(int)$productID){
			updateFor(
				"migrationConfigs",
				array(
					"migrationConfigID" => $this->migrationConfig["migrationConfigID"],
					"migrationProductID" => $this->migrationConfig["migrationProductID"] = insertFor(
						"products",
						array(
							"productName" => TRANS_PRIOR_BALANCE_PRODUCT_FOR . " " . $this->migrationConfig["migrationConfigID"],
							"productActive" => 0,
							"productStopNumCycles" => 1,
							"productCancellationType" => getAPITypeID("cancellation", "admin_only"),
						)
					),
				)
			);
			$productID = $this->migrationConfig["migrationProductID"];
		}

		if (!$currencyID){
			if ($this->currencyID){
				$currencyID = $this->currencyID;
			} else {
				$this->paymentGroupInfo = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $paymentGroupID,
							"suppressGatewayInfo" => 1,
						),
					),
				)));
				$this->currencyID = $currencyID = $this->paymentGroupInfo["paymentGroupCurrencyID"];
				dbg("GOT CURRENCY ID OF: ".$currencyID);
			}
		}

		// first get all invoices
		$h =& new QueryMaster("client_invoice.*", $dbr);
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$allInvoices = $h->getResults();

		// second get all the credits
		$h =& new QueryMaster("sum(credit_amount)", $dbr);
		$h->addTables("client_credits");
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$totalCredit = $h->getOne();

		$totalReceivable = 0;
		$packageComments = TRANS_PRIOR_INVOICES;
		foreach ($allInvoices as $invoice){

			if ($invoice["invoice_amount"]>$invoice["invoice_amount_paid"]){
				$totalReceivable += $invoice["invoice_amount"]-$invoice["invoice_amount_paid"];
				$packageComments .= "\n<br />".$invoice["invoice_snapshot"];
			}

			if ($invoice["invoice_amount_paid"]>0){

				$sale =& new Sale();
				$sale->setClientID($clientID);
				$sale->setInvoiceID(0);
				$sale->setDescription(TRANS_HISTORICAL_INVOICE_GENERATED);
				$sale->setInvoiceAmount(doubleval($invoice["invoice_amount_paid"]));
				$sale->setInvoiceDiscountAmount(0);
				$sale->setInvoiceCouponAmount(0);
				$sale->setInvoiceTaxAmount(0);
				$sale->setCurrencyID($currencyID);
				$sale->updateTimestamp = $invoice["invoice_date_entered"];
				$sale->execute();

				$receipt =& new Payment();
				$receipt->setClientID($clientID);
				$receipt->setInvoiceID(0);
				$receipt->setTransactionID(0);
				$receipt->setDescription(TRANS_HISTORICAL_PAYMENT);
				$receipt->setPaymentAmount(doubleval($invoice["invoice_amount_paid"]));
				$receipt->setCurrencyID($currencyID);
				$receipt->updateTimestamp = ($invoice["invoice_date_paid"]>0)?$invoice["invoice_date_paid"]:$invoice["invoice_date_entered"];
				$receipt->execute();

			}

		}

		if ($totalCredit>$totalReceivable){
			$totalCredit -= $totalReceivable;
			$totalReceivable = 0;
			$creditResult = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetCreditAccounting",
					"params" => array(
						"clientID" => $clientID,
						"ledgerAccountName" => "customer_expense",
						"amount" => doubleval($totalCredit),
						"currencyID" => $currencyID,
						"description" => TRANS_OPENING_CREDIT_BALANCE,
					),
				),
			)), 1);
			dbg("added client credit");
			dbg($creditResult);

			return 0;

		} else {

			$totalReceivable -= $totalCredit;

			$now = time();

			if($totalReceivable) {
				$packageCommand = array(
					"mbapi" => array(
						"command" => "SetPackages",
						"subCommand" => "insert",
						"params" => array(
							"clientID" => $clientID,
							"productID" => $productID,
							"packageComments" => htmlspecialchars($packageComments),
							"packageName" => TRANS_PRIOR_BALANCE,
							"packageQuantity" => 1,
							"packageProratable" => 0,
							"packageDateCreated" => $now,
							"packageDateBeginRenewal" => $now,
							"packageDateLastRenewal" => 0,
							"packageDateNextRenewal" => $now,
							"packageDateStopRenewal" => $now+1,
							"packageActive" => 1,
							"packageStatus" => 0,
							"packageType" => 0,
							"packageOriginalPrice" => $totalReceivable,
							"packagePrice" => $totalReceivable,
							"packageSetup" => 0,
							"packagePriceLock" => 1,
							"cycleID" => 1,
							"paymentGroupID" => $paymentGroupID,
						),
					),
				);

				$results = correctArray(dispatchMBAPI(toXML($packageCommand), 1));
				dbg("opening balance package created, results:");
				dbg($results);
				return $results["mbapi"]["header"]["lastInsertID"];
			} else {
				return 0;
			}
		}

	} 

}
