<?php
// $Id: EditEmailConfigResponse.php 8778 2006-09-11 16:03:26Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action handles the response when updating Email settings.
 *
 * @author Brian Smith
 */
class EditEmailConfigResponse extends MB_Action {
	/**
	 * The constructor for a EditEmailConfigResponse action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditEmailConfigResponse() {
		parent::MB_Action();
		$this->stringRep = "EditEmailConfigResponse";
        	$this->params = array(
        			"emailMethod",
        			"emailSendmailLocation",
        			"emailSMTPServer",
        			"emailSMTPAuth",
        			"emailSMTPUsername",
        			"emailSMTPPassword");
	}

	/**
	 * Update the config params for this module.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = (int) $_REQUEST["configGroupID"];
		
		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for EditEmailConfig.");
		} else {
			$skipAuthInfo = false;
			if ((int)$_REQUEST["emailSMTPAuth"] != 1) {
				$skipAuthInfo = true;
			}
			
			switch( $_REQUEST["emailMethod"] ) {
			case "smtp":
				if ($skipAuthInfo) {
					$elements2Test = array(
							"emailMethod" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPServer" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPAuth" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED);
				} else {
					$elements2Test = array(
							"emailMethod" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPServer" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPAuth" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPUsername" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPPassword" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED);
				}
			break;

			case "sendmail":
				if (!is_file( $_REQUEST["emailSendmailLocation"] )) {
					$this->addError( TRANS_ACTIONERROR, "Sendmail file cannot be found." );
					$this->addErrorTemplates();
					return $this->hasExecutedSuccessfully();
				}

				$_REQUEST["emailSMTPAuth"] = 0;
				
				$elements2Test = array(
					"emailMethod" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"emailSendmailLocation" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED);
			break;
			}

			$this->setReferralActionID( getActionID("EditEmailConfig") );
			$this->setReferralActionFile( "modules.php" );
			
			$success = $this->validateMultiInputs( $elements2Test, array(), array(), 0, array("configGroupID" => $configGroupID) );

			if ($success) {
				$configParams = array();
				$configParams["configGroupID"] = $configGroupID;
				
				$configParams["configParams"] = array();
				$configParams["configParams"]["configParam"] = array();
				foreach($this->params as $v) {
	
					if ($skipAuthInfo == true)
					switch( $v ) {
					case "emailSMTPUsername":
					case "emailSMTPPassword":
						$_REQUEST[ $v ] = null;
					break;
					}
					
					$configParamID = getConfigParamID($configGroupID, $v);
					
					$configParams["configParams"]["configParam"][] = array(
								"configParamID" => $configParamID,
								"configParamName" => $v,
								"configParamValue" => $_REQUEST[ $v ]);
				}
// show($configParams);exit;
				$setConfig =& new MBQuery("SetConfigs", "update", $configParams);
				$data = $setConfig->getResult();
				$data = $data->getStructure();
// show($data);exit;
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						
						redirect("modules.php", getActionID("EditEmailConfig"), array("configGroupID"=>$configGroupID,"saved"=>1));
					}
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmailConfigResponse
?>
