<?php
// $Id $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a Panel so that that it can be
 * configured and saved to the database.
 *
 * @author  Andy Christ
 */
class LoginToPanel extends MB_Action {
	/**
	 * The constructor for a EditPanel action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function LoginToPanel() {
		parent::MB_Action();
		$this->stringRep = "LoginToPanel";
		$this->params = array("configGroupID");
	}

	/**
	 * The main method of this class that executes the LoginToPanel action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = ((int) $_REQUEST["configGroupID"]);
		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No Config Group ID given.");
		} else {

			$paramsForServer = arrayFor(":configParams", array(
				"configGroupID" => $configGroupID,
			));
			
			$configs = array();
			foreach ((array)$paramsForServer as $cp) {
				$configs[$cp["configParamName"]] = $cp["configParamValue"];
			}
			
			$this->smartyVars["moduleUsername"] = $configs["moduleUsername"];
			$this->smartyVars["modulePassword"] = getStuff($configs["modulePassword"]);
			$this->smartyVars["api"] = $configs["api"];

			$this->addTemplate("modules/LoginToPanel");
	
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTaxZone
?>