<?php
// $Id: EditiDevAffiliateConfig.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays the modules menu.
 *
 * @author Andy Christ
 */
class EditiDevAffiliateConfig extends MB_Action {
	/**
	 * The constructor for a ShowModulesMenu action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditiDevAffiliateConfig() {
		parent::MB_Action();
		$this->stringRep = "EditiDevAffiliateConfig";
	}

	/**
	 * Pull the config items for this affiliate and pass them to the template.  The template
     * can return its data to process config file.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = (int) $_REQUEST["configGroupID"];
		$params = array("enableiDevAffiliate", "pathiDevAffiliate");

		if($_REQUEST["submit"]) {
			$pathiDevAffiliate = secureInput($_REQUEST["pathiDevAffiliate"]);
			//drop ../ from the input instead of using unsecureInput
			$pathiDevAffiliate = str_replace("&#46;", "", $pathiDevAffiliate);
			$_REQUEST["pathiDevAffiliate"] = str_replace(".&#47;", "", $pathiDevAffiliate);
			$configParms = "  <configParams>\n";
			foreach($params as $v) {
				$configParamID = getConfigParamID($configGroupID,$v);
				$configParms .= "    <configParam>\n";
				$configParms .= "       <configParamID>".$configParamID."</configParamID>\n";
				$configParms .= "       <configParamName>$v</configParamName>\n";
				$configParms .= "       <configParamValue>".$_REQUEST[$v]."</configParamValue>\n";
				$configParms .= "    </configParam>\n";
			}
			$configParms .= "  </configParams>\n";
			$xml = "<mbapi>
						<command>SetConfigs</command>
						<subCommand>update</subCommand>
						<params>
							<configGroupID>$configGroupID</configGroupID>
							$configParms
						</params>
					</mbapi>";
			$CONF["debug"]->add("MBAPI Query (EditiDevAffiliateConfig)",htmlentities($xml), __FILE__, __LINE__);
			$data = dispatchMBAPI($xml, 1);
			$CONF["debug"]->add("MBAPI Results (EditiDevAffiliateConfig)", $data, __FILE__, __LINE__);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars["configEditResult"] = TRANS_UPDATE_SUCCESSFUL;
			}
		}


		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for UltimateAffiliate.");
		} else {
			loadConfigs("other");
		}

		//Pull each out
		$smartyVars["configParams"] = $CONF["other"]["affiliates"]["idevaffiliate"];

		$this->addTemplate("modules/EditiDevAffiliateConfig", $smartyVars, 1);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowModulesMenu
?>