<?php
// $Id: EditPanelConfig.php 12863 2008-04-19 04:01:19Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");

/**
 * This Action object displays the modules menu.
 *
 * @author Andy Christ
 */
class EditPanelConfig extends MB_Action {
	/**
	 * The constructor for a ShowModulesMenu action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditPanelConfig() {
		parent::MB_Action();
		$this->stringRep = "EditPanelConfig";
	}

	/**
	 * Pull the config items for this affiliate and pass them to the template.  The template
     * can return its data to process config file.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = (int) $_REQUEST["configGroupID"];


		if($_REQUEST["submit"]) {
			//The possible items depends on the panel
			$configItems = $_REQUEST["configParams"];
			foreach($configItems as $key => $value) {
				if($key == "modulePassword" && $value["configParamValue"]) {
					//Encrypt this password:
					$_REQUEST["configParams"][$key]["configParamValue"] = getEncryptedText($value["configParamValue"]);
				}
				$params[] = $key;
			}

			$configParms = "  <configParams>\n";
			foreach($params as $v) {
				$configParamID =  $_REQUEST["configParams"][$v]["configParamID"];
				$configParms .= "    <configParam>\n";
				$configParms .= "       <configParamID>".$configParamID."</configParamID>\n";
				$configParms .= "       <configParamName>$v</configParamName>\n";
				$configParms .= "       <configParamValue>".$_REQUEST["configParams"][$v]["configParamValue"]."</configParamValue>\n";
				$configParms .= "    </configParam>\n";
			}
			$configParms .= "  </configParams>\n";
			$xml = "<mbapi>
						<command>SetConfigs</command>
						<subCommand>update</subCommand>
						<params>
							<configGroupID>$configGroupID</configGroupID>
							$configParms
						</params>
					</mbapi>";
			$CONF["debug"]->add("MBAPI Query (EditPanelConfig)",htmlentities($xml), __FILE__, __LINE__);
			$data = dispatchMBAPI($xml, 1);
			$CONF["debug"]->add("MBAPI Results (EditPanelConfig)", $data, __FILE__, __LINE__);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$configEditResult = TRANS_UPDATE_SUCCESSFUL;
				$displaySaved = 1;
			}
		}


		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for Panel.");
		} else {
			loadConfigs("server");
		}
		$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
		$data = dispatchMBAPI($xml, 1);
		$CONF["debug"]->add("MBAPI Results (EditPanelConfig)", $data, __FILE__, __LINE__);

		$configParamDataResults =& $data["mbapi"][0]["results"][0];
		// fix child config param values structure when only 1 child config param value exists
		$numParams = $data["mbapi"][0]["header"][0]["numResults"][0];
		// loop through all params to test for param values
		for($i=0;$i<$numParams;$i++) {
			$p =& $configParamDataResults["configs"][0]["config"][$i]["paramValues"][0]["paramValue"];
			// loop through param values if they exist
			$numParamValues = count($p);
			for($j=0;$j<$numParamValues;$j++) {
				// define the translation key or display it raw if not defined
				$translatedName = (defined($p[$j]["configParamValueTransKey"][0])) ?
					constant($p[$j]["configParamValueTransKey"][0]) :
					$p[$j]["configParamValueTransKey"][0];
				// shorten the ID
				$configParamID = $configParamDataResults["configs"][0]["config"][$i]["configParamID"][0];
				// create a new smooshed array for html_options in smarty
				$configParamValueName = $p[$j]["configParamValueName"][0];
				if ($j ==0 && $configParamValueName == 0) {
					// hack to pad the array with a 0 if the name = "0"
					$configParamValues[$configParamID][0][$configParamValueName] = $translatedName;
				} else {
					$configParamValues[$configParamID][$configParamValueName] = $translatedName;
				}
			}
		}

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$smartyVars = array();
			$data = collapseArrayElements($data["mbapi"][0]["results"][0]["configs"][0]["config"]);

			//Move the field name to the key for each
			$genericItems = array("panelMaxAccounts", "panelCurrentAccounts", "panelNameserver1",
						"panelNameserver1IP", "panelNameserver2", "panelNameserver2IP", "panelNameserver3",
						"panelNameserver3IP", "panelNameserver4", "panelNameserver4IP", "panelLoginURL",
						"panelServerInfoHeader", "panelMinUsernameLength", "panelMaxUsernameLength",
						"panelMinPasswordLength", "panelMaxPasswordLength");

			foreach($data as $key => $value) {
				if($value["configParamName"] == "modulePassword" && $value["configParamValue"]) {
					//Decrypt this password:
					$rawPassword = getStuff($value["configParamValue"]);
					$value["configParamValue"] = $rawPassword;
				}

				if(in_array($value["configParamName"],$genericItems)) {
					$genericParms[$value["configParamName"]] = $value;
					if(defined($value["configParamTransKey"])) {
						constant($value["configParamTransKey"]);
					}
				} else {
					$configParams[] = $value;
				}
			}
		/*
			//This has been handled at a lower level now to work around an expat < v 2 issue
			if(is_array($configParams)) {
				foreach($configParams as $configNumber => $value) {
					if($value["configParamInputType"] == "a") {
						if(!strpos($value["configParamValue"], "\n") && strlen($value["configParamValue"]) > 80) {
							//$configParams["configParamValue"]
							$newString = chunk_split($value["configParamValue"],32,"\n");
						}
						$configParams[$configNumber]["configParamValue"] = $newString;
					}
				}
			}
		*/
			$smartyVars["configParams"] = $configParams;
			$smartyVars["genericParams"] = $genericParms;
			$smartyVars["configEditResult"] = $configEditResult;
			$smartyVars["configParamValues"] = $configParamValues;
			$smartyVars["configGroupID"] = $configGroupID;
			$smartyVars["displaySaved"] = $displaySaved;
			$this->addTemplate("modules/EditPanelConfig", $smartyVars, 1);

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowModulesMenu
?>