<?php
// $Id: ShowPanelDetails.php 12436 2008-01-08 19:08:33Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Andy Christ
 */
class ShowPanelDetails extends MB_Action {
	/**
	 * The constructor for a ShowPanelDetails action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowPanelDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowPanelDetails";
		$this->params = array
		("configGroupID");
	}

	/**
	 * The main method of this class that executes the getServerLoad action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$panelName = $configGroupID = $serverGroupID = $capabilities = $moduleEnabled = NULL;

		$configGroupID = (int)($_REQUEST["configGroupID"]);
		$serverGroupID = (int)($_REQUEST["serverGroupID"]);

		$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
		$data = dispatchMBAPI($xml, 1);
		$CONF["debug"]->add("MBAPI Results (EditPanelConfig)", $data, __FILE__, __LINE__);

		$configParams =& correctArray($data["mbapi"][0]["results"][0]["configs"][0]["config"]);
		foreach($configParams as $mod) {
			if($mod["configParamName"]=="panelMaxAccounts" && (int) $mod["configParamValue"]) {
				$moduleDisplayInfo[$mod["configParamName"]] = $mod["configParamValue"];
			} else if($mod["configParamName"]!="panelMaxAccounts"){
				$moduleDisplayInfo[$mod["configParamName"]] = $mod["configParamValue"];
			}
		}
		if(isset($moduleDisplayInfo["modulePassword"])) {
			unset($moduleDisplayInfo["modulePassword"]);
		}

		//Get the name of the module for this server group
		$query = $this->getMBAPIQuery("GetServerGroups", "", array("serverGroupID" => $serverGroupID, "getPanels" => 1));
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		$serverGroup =& correctArray($data["mbapi"][0]["results"][0]);
		$panelName = strtolower($serverGroup["serverGroups"][0]["panels"][0]["configGroupTransKey"]);

		require_once mb_path("/lib-mbapi/include/modules/panel/".secureInput($panelName).".php");
		$moduleInfo = call_user_func(array($panelName,"getModuleInfo"));
		$p =& new $panelName(array("subCommand" => "getCapabilities"));;
		$capabilities = $p->capabilities;

		/*
			PANEL_GETTESTS
			PANEL_GETSERVERLOAD
			PANEL_SETPACKAGES
			PANEL_GETCLIENTS
			PANEL_GETDOMAINS
			PANEL_GETBANDWIDTH
			PANEL_CLIENTLOGIN
			PANEL_ADDONUPGRADE
			PANEL_ADDONDOWNGRADE
			PANEL_PACKAGEUPGRADE
			PANEL_PACKAGEDOWNGRADE
		*/

		//Make sure that the module is enabled
		foreach($configParams as $key => $value) {

			if($value["configParamName"] == "moduleEnabled") {
				$moduleEnabled = (int) $value["configParamValue"];
			}
		}

		$loadResults = $clientResults = $domainResults = NULL;

		if($moduleEnabled) {

			//Check each capability relevent for this page
			if($capabilities[PANEL_GETSERVERLOAD]) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetServerLoad</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$load = dispatchMBAPI($xml,1);
				$loadResults =& correctArray($load["mbapi"][0]["results"][0]);
				$load = NULL;
			} else if($capabilities[PANEL_GETTESTS]) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetTest</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$load = dispatchMBAPI($xml,1);
				$loadResults =& correctArray($load["mbapi"][0]["results"][0]);
				$load = NULL;
			}
			$clientsPerPage = 50;
			if($capabilities[PANEL_GETCLIENTS]) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetClients</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<numRecords>".$clientsPerPage."</numRecords>
							<recordOffset>".(int)$_REQUEST["recordOffset"]."</recordOffset>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$clients = dispatchMBAPI($xml,1);
				$clientResultsTemp =& correctArray($clients["mbapi"][0]["results"][0]);
//show($clients);
				unset($clients);
//show($clientResultsTemp);
				$this->smartyVars["totalPanelClients"] = $clientResultsTemp["totalClients"];
				$this->smartyVars["clientsPerPage"] = $clientsPerPage;
				$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];

				$this->smartyVars["pcpages"] = array();
				for ($xi=0; $xi<$clientResultsTemp["totalClients"]/$clientsPerPage; $xi++){
					$this->smartyVars["pcpages"][] = $xi*$clientsPerPage;
				}

				//See if they are MB clients and fix the IDs
				foreach($clientResultsTemp as $id => $value) {
					if ($id=="totalClients") continue;
					if(is_array($value) && $value[0]["password"]) {
						//encrypt the password before sending to the template
						$pr = dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "GetEncryptedText",
								"params" => array(
									"text" => $value[0]["password"]
								),
							),
						)),1);
						$encryptedPassword = $pr["mbapi"][0]["results"][0]["text"][0];
						$value[0]["password"] = $clientResultsTemp[$id][0]["password"] = $encryptedPassword;
					}

					$mbClient = NULL;
					$value[0]["clientID"] = 0;
					$query = $this->getMBAPIQuery("GetContacts", "", array("contactEmail" => $value[0]["email"]));
					$CONF["debug"]->add("Action Command", htmlentities($query));
					$data = dispatchMBAPI($query, 1);
					$CONF["debug"]->add("Action Result", $data);

					if((int) $data["mbapi"][0]["header"][0]["numResults"][0] > 0) {
						//Grab the first clientID
						$mbClient =& correctArray($data["mbapi"][0]["results"][0]["contacts"][0]["contact"][0]);
						$value[0]["clientID"] = $mbClient["clientID"];
					} else {
						//Try the company name
						$query = $this->getMBAPIQuery("GetClients", "", array("clientCompany" => $value[0]["company_name"]));
						$CONF["debug"]->add("Action Command", htmlentities($query));
						$data = dispatchMBAPI($query, 1);
						$CONF["debug"]->add("Action Result", $data);

						if((int) $data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
							$mbClient =& correctArray($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]);
							$value[0]["clientID"] = $mbClient["clientID"];
						}
					}

					$clientResults[str_replace("client_","",$id)] = $value[0];
				}
				$clientResultsTemp = NULL;
			}

			//To reduce the risk of memory overload, don't make the domain call if more than 50 clients were pulled in
			$runDomainsCall = TRUE;
			if((array) $clientResults) {
				$runDomainsCall = (count($clientResults) > $clientsPerPage+1)? FALSE : TRUE;
			}
			//Check each capability relevent for this page
			if($capabilities[PANEL_GETDOMAINS] && $runDomainsCall) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetDomains</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<numRecords>".$clientsPerPage."</numRecords>
							<recordOffset>".(int)$_REQUEST["recordOffset"]."</recordOffset>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$domain = dispatchMBAPI($xml,1);
//show("At the end");
//show($domain);

				$domainResultsTemp =& correctArray($domain["mbapi"][0]["results"][0]);
				$domain = NULL;

				//See if they are MB clients and fix the IDs
				foreach($domainResultsTemp as $id => $value) {
					$mbClient = $data = $e = $d = NULL;
					$value[0]["clientID"] = 0;

					if($value[0]["email"]) {
						$query = $this->getMBAPIQuery("GetContacts", "", array("contactEmail" => $value[0]["email"]));
						$CONF["debug"]->add("Action Command", htmlentities($query));
						$data = dispatchMBAPI($query, 1);

						$CONF["debug"]->add("Action Result", $data);
						if((int) $data["mbapi"][0]["header"][0]["numResults"][0]) {
							$mbClient =& correctArray($data["mbapi"][0]["results"][0]["contacts"][0]["contact"][0]);
							$value[0]["clientID"] = $mbClient["clientID"];
						}
					}

					if(!$value[0]["clientID"]) {
						//need to change this in the future to account for tlds like .co.uk
						$domain = explode(".",$value[0]["domain_name"]);

						$d =& new DataSource(
							"domainsGeneric",
							array(
								"domainSLD" => $domain[0],
								"domainTLD" => $domain[1],
								"packages" => array(
									"packageType" => "hosting",
								),
							)
						);

						$e = $d->getEssential();

						if((array) $e[0]["packages"][0]["clientID"]) {
							$value[0]["clientID"] = $e[0]["packages"][0]["clientID"];
						} else if((array) $e[1]["packages"][0]["clientID"]) {
							$value[0]["clientID"] = $e[1]["packages"][0]["clientID"];
						}
					}

					if((int) $data["mbapi"][0]["header"][0]["numResults"][0] > 0) {
						$mbClient =& correctArray($data["mbapi"][0]["results"][0]["contacts"][0]["contact"][0]);
						$value[0]["clientID"] = $mbClient["clientID"];
					} else {
						//Try the company name
						if($value[0]["company_name"]) {
							$query = $this->getMBAPIQuery("GetClients", "", array("clientCompany" => $value[0]["company_name"]));
							$CONF["debug"]->add("Action Command", htmlentities($query));
							$data = dispatchMBAPI($query, 1);
							$CONF["debug"]->add("Action Result", $data);
	
							if((int) $data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
								$mbClient =& correctArray($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]);
								$value[0]["clientID"] = $mbClient["clientID"];
							}
						}
					}

					$domainResults[str_replace("domain_","",$id)] = $value[0];
				}
				$domainResultsTemp = NULL;
			}

			//Put the client and domain arrays together if needed
			if($clientResults && $domainResults) {
				foreach($domainResults as $panelDomainID => $value) {
					$clientResults[$value["client_id"]]["domain"][] = $value;
					$clientResults[$value["client_id"]]["domains"] .= $value["domain_name"]."|";
				}
			}

			//Move the MB client IDs up from the domain record if they are set
			$tempClient = NULL;
			foreach((array)$clientResults as $panelClientID => $value) {
				$tempClient = $value;
				unset($tempClient["domain"]);
				$tunnelVars[$panelClientID] = base64_encode(serialize($tempClient));
				if(!$value["clientID"]) {
					if(is_array($value["domain"])) {
						foreach($value["domain"] as $k => $domain) {
							if($domain["clientID"]) {
								$clientResults[$panelClientID]["clientID"] = $domain["clientID"];
							}
						}
					}
				}
			}
		}// Module Enabled
/*
echo "LOADS $panelName<pre>";
print_r($loadResults);
echo "</pre>CLIENTS<pre>";
print_r($clientResults);
echo "</pre>DOMAINS<pre>";
print_r($domainResults);
exit;
/**/

		$smartyVars = $this->smartyVars;
		if($loadResults) {
			$this->smartyVars["load"] = $loadResults;
		}
		if($clientResults) {
			$this->smartyVars["clientResults"] = $clientResults;
		}
		if($domainResults) {
			$this->smartyVars["domainResults"] = $domainResults;
		}
		if($tunnelVars) {
			$this->smartyVars["tunnelVars"] = $tunnelVars;
		}
		$this->smartyVars["moduleDisplayInfo"] = $moduleDisplayInfo;
		$this->addTemplate("modules/ShowPanelDetails", collapseArrayElements($smartyVars), 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // getServerLoad
?>