<?php
// $Id: EditPPCFactoryConfig.php 6933 2006-05-17 06:00:40Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays the FraudGuardian module configs.
 *
 * @author Michael Fountain
 */
class EditPPCFactoryConfig extends MB_Action {
	/**
	 * The constructor for a EditPPCFactoryConfig action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditPPCFactoryConfig() {
		parent::MB_Action();
		$this->stringRep = "EditPPCFactoryConfig";
	}

	/**
	 * Pull the config items for this module.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $configGroupID = (int) $_REQUEST["configGroupID"];
		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for PPCfactory.");
		} else {
			loadConfigs("other");
        }

        $this->smartyVars["numClients"] = (int) numClients;
        if ($this->smartyVars["numClients"] < 100) {
            $this->smartyVars["formDisabled"] = "disabled";
        }
		$this->smartyVars["configGroupID"] = $configGroupID;
		$this->smartyVars["configParams"] = $CONF["other"]["ppc"]["ppcfactory"];
		$this->addTemplate("modules/EditPPCFactoryConfig", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPPCFactoryConfig
?>