<?php
// $Id: EditPPCFactoryConfigResponse.php 6077 2006-04-11 20:15:22Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action handles the response when updating the PPCFactory config settings.
 *
 * @author Michael Fountain
 */
class EditPPCFactoryConfigResponse extends MB_Action {
	/**
	 * The constructor for a EditPPCFactoryConfigResponse action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditPPCFactoryConfigResponse() {
		parent::MB_Action();
		$this->stringRep = "EditPPCFactoryConfigResponse";
        $this->params = array
        (
            "enablePPCfactory",
            "usernamePPCfactory",
			"passwordPPCfactory",
			"testmodePPCfactory",
        );
	}

	/**
	 * Update the config params for this module.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = (int) $_REQUEST["configGroupID"];
		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for PPCfactory.");
		} else {
			#loadConfigs("other");

		    $configParms = "  <configParams>\n";
		    foreach($this->params as $v) {
			    $configParamID = getConfigParamID($configGroupID,$v);
			    $configParms .= "    <configParam>\n";
			    $configParms .= "       <configParamID>".$configParamID."</configParamID>\n";
			    $configParms .= "       <configParamName>$v</configParamName>\n";
			    $configParms .= "       <configParamValue>".$_REQUEST[$v]."</configParamValue>\n";
			    $configParms .= "    </configParam>\n";
		    }
		    $configParms .= "  </configParams>\n";
		    $xml = "<mbapi>
					    <command>SetConfigs</command>
					    <subCommand>update</subCommand>
					    <params>
						    <configGroupID>$configGroupID</configGroupID>
						    $configParms
					    </params>
				    </mbapi>";
		    $data = dispatchMBAPI($xml, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("modules.php", getActionID("EditPPCFactoryConfig"), array("configGroupID"=>$configGroupID,"saved"=>1));
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPPCFactoryConfigResponse
?>
