<?php
// $Id: ShowRegistrarModules.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It displays all config groups.
 *
 * @author  Michael Fountain
 */
class ShowRegistrarModules extends MB_Action {

	function ShowRegistrarModules() {
		parent::MB_Action();
		$this->stringRep = "ShowRegistrarModules";
		$this->params = array("configGroupID","parentConfigGroupID","configGroupName");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if (!isset($_REQUEST["configGroupID"]) &&
			!isset($_REQUEST["parentConfigGroupID"]) &&
			!isset($_REQUEST["configGroupName"])) {
			$_REQUEST["configGroupName"] = "registrar";
		}

		$query = $this->getMBAPIQuery("GetConfigGroups", "", array("getNumChildren"=>1), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["configGroups"] = ($data["mbapi"][0]["header"][0]["numResults"][0]==1) ?
				array(0=>$results["configGroups"][0]["configGroup"]) : $results["configGroups"][0]["configGroup"];
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			
			$this->addTemplate("modules/ShowRegistrarModules", collapseArrayElements($smartyVars), 1);
			
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>