<?php
// $Id: AddNews.php 7733 2006-06-23 23:05:39Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action merely displays a form to the screen allowing a user to add a news article to the database.
 * It queries the MBAPI and collects news group information, and provides those news group to the template.
 * If no news groups exist, the template is not displayed, and execute() will return 0 for failure, as a
 * news article needs a news group. As such a news group must be added before a news article.
 *
 * @author  Vic Fryzel
 */
class AddNews extends MB_Action {
	/**
	 * The constructor for a AddNews action object. This calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddNews() {
		parent::MB_Action();
		$this->stringRep = "AddNews";
	}

	/**
	 * The main method of this class that executes the AddNews action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetNewsGroups", "", array(), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
				$results = grabSimpleMBAPIResults($data);

				$this->smartyVars["newsGroups"] = array();
				if (is_array($results))
				foreach( $results as $v ) {
					$this->smartyVars["newsGroups"][ $v["newsGroupID"] ] = $v["newsGroupName"];
				}
				
				$this->mergeFormState();
				$this->addTemplate("news/AddNews");

			} else {
				$this->addError(TRANS_ACTIONERROR, "No news groups exist yet. Please add at least one "
					."news group before adding a news article.");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddNews
?>