<?php
// $Id: AddNewsResponse.php 7733 2006-06-23 23:05:39Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action takes the information provided by the AddNews action, and tries to store it in the 
 * database as a news article. Note that the adminID associated with the new news article will be 
 * that of the current session. Once complete, this action redirects to the ShowNewsDetails action 
 * for the new news article, so long as an error has not occurred.
 *
 * @author  Vic Fryzel
 */
class AddNewsResponse extends MB_Action {
	/**
	 * The constructor for an AddNewsResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddNewsResponse() {
		parent::MB_Action();
		$this->stringRep = "AddNewsResponse";
		$this->params = array(
			"newsGroupID",
			"newsSubject",
			"newsShortBody",
			"newsBody",
			"newsActive",
			"priorityID");
	}

	/**
	 * The main method of this class that executes the AddNewsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID( getActionID("AddNews") );
		$this->setReferralActionFile( "news.php" );
		
		$success = $this->validateMultiInputs(array(
					"newsGroupID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					"newsSubject" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"newsShortBody" => INPUT_RESTRICTION_STRING,
					"newsBody" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"newsActive" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					"priorityID" => INPUT_RESTRICTION_INT));
		
		$custom = array("adminID" => $CONF["user"]["id"],
			"newsGroupIDs" => "<newsGroupID>".((int) $_REQUEST["newsGroupID"])."</newsGroupID>");
		
		$query = $this->getMBAPIQuery("SetNews", "insert", $custom);
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			
			redirect("news.php", "ShowNews");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddNewsResponse
?>