<?php
// $Id: RemoveNews.php 7733 2006-06-23 23:05:39Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action double checks that a user is sure they want to remove a news article. It provides data 
 * about the news article to a template, and the template should post to the RemoveNewsResponse action 
 * with the newsID to remove if the user is sure. Generally if the user selects to cancel, the template 
 * should send the user to the ShowNews action.
 *
 * @author  Vic Fryzel
 */
class RemoveNews extends MB_Action {
	/**
	 * The constructor for a RemoveNews action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveNews() {
		parent::MB_Action();
		$this->stringRep = "RemoveNews";
		$this->params = array("newsID");
	}

	/**
	 * The main method of this class that executes the RemoveNews action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$newsID = ((int) $_REQUEST["newsID"]);
		if(!$newsID) {
			$this->addError(TRANS_ACTIONERROR, "No news article ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetNews");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$results = grabSimpleMBAPIResults($data);
					$this->smartyVars["article"] = $results[0];
					
					$this->addTemplate("news/RemoveNews");
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "News article not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveNews
?>