<?php
// $Id: RemoveNewsGroup.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action double checks that a user is sure they want to remove a news group by dispatching to 
 * a verification form. The form should then either post to the RemoveNewsGroupResponse 
 * action, or back to the ShowNewsGroups action. If the given news group ID is not found, an error 
 * is thrown. Data for the news group the user wishes to remove is acquired via the GetNewsGroups 
 * MBAPI command and sent to the template.
 *
 * @author  Vic Fryzel
 */
class RemoveNewsGroup extends MB_Action {
	/**
	 * The constructor for a RemoveNewsGroup action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets $this->params to allow the newsGroupID 
	 * parameter.
	 */
	function RemoveNewsGroup() {
		parent::MB_Action();
		$this->stringRep = "RemoveNewsGroup";
		$this->params = array("newsGroupID");
	}

	/**
	 * The main method of this class that executes the RemoveNewsGroup action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$newsGroupID = ((int) $_REQUEST["newsGroupID"]);
		if(!$newsGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No news group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetNewsGroups");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["newsGroup"] = collapseArrayElements($data["mbapi"][0]["results"][0]
						["newsGroups"][0]["newsGroup"][0]);
					$this->addTemplate("news/RemoveNewsGroup", $s);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "News group not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveNewsGroup
?>