<?php
// $Id: RemoveNewsGroupResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action removes a news group from the database. The news group removed is that which is associated 
 * with the given newsGroupID, which was most likely provided by the RemoveNewsGroup action. If the given 
 * newsGroupID is not found, this action throws an error; otherwise the news group associated with that ID 
 * is removed, and this action redirects to the ShowNewsGroups action at news.php.
 *
 * @author  Vic Fryzel
 */
class RemoveNewsGroupResponse extends MB_Action {
	/**
	 * The constructor for an RemoveNewsGroupResponse action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets up $this->params to allow the newsGroupID 
	 * parameter.
	 */
	function RemoveNewsGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveNewsGroupResponse";
		$this->params = array("newsGroupID");
	}

	/**
	 * The main method of this class that executes the RemoveNewsGroupResponse action, and returns 
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$newsGroupID = ((int) $_REQUEST["newsGroupID"]);
		if(!$newsGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No news group ID given for removal.");
		} else {
			$query = $this->getMBAPIQuery("SetNewsGroups", "delete");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				if(!redirect("news.php", "ShowNewsGroups")) {
					$this->addError(TRANS_ACTIONERROR, "Failed to redirect to news group list.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveNewsGroupResponse
?>