<?php
// $Id: AddGenericAttributeResponse.php 8212 2006-08-02 17:30:37Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/sourceaction.php");
require_once mb_path("/lib-action/include/wizard/WizardResolver.php");

class AddGenericAttributeResponse extends MB_Action {
	/**
	 * The constructor for a AddGenericAttributeResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddGenericAttributeResponse() {
		parent::MB_Action();
		$this->stringRep = "AddGenericAttributeResponse";
	}

	/**
	 * The main method of this class that executes the class.
	 */
	function execute() {
		parent::execute();
		
		$questionParams = array(
			"questionDisplayName" => $_REQUEST["questionName"],
		);
		
		$questionResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetQuestions",
				"subCommand" => "insert",
				"params" => $questionParams,
			),
		)), 1);
		
		$questionID = $questionResult["mbapi"][0]["header"][0]["lastInsertID"][0];
		
		$this->setQuestionParam($questionID, "setQuestion", $_REQUEST["question"]);
		$this->setQuestionParam($questionID, "setType", "QUESTION_INPUT_TEXT");
		$this->setQuestionParam($questionID, "setDescription", $_REQUEST["questionDescription"]);
		$this->setQuestionParam($questionID, "addAnswer", $_REQUEST["questionDefaultValue"]);
		//$this->setQuestionParam($questionID, "addAnswer", $_REQUEST["questionDefaultValue"]);
		//$this->setQuestionParam($questionID, "addAnswer", $_REQUEST["questionDefaultValue"]);
		
		
		$attributeParams = array(
			"attributeName" => $_REQUEST["attributeName"],
			"attributeType" => 0,
			"attributeSubtype" => 0,
			"questionID" => $questionID,
		);
		
		dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetAttributes",
				"subCommand" => "insert",
				"params" => $attributeParams,
			),
		)));
		
		redirect("orderforms.php?sid=".$_REQUEST["sid"]."&action=".getActionID("ShowAttributes"));
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
	function setQuestionParam($questionID, $name, $value){
		$questionParamParams = array(
			"questionID" => $questionID,
			"questionParamName" => $name,
			"questionParamOrder" => (int)$this->orderInc++,
		);
		
		$questionParamResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetQuestionParams",
				"subCommand" => "insert",
				"params" => $questionParamParams,
			),
		)), 1);
		
		$questionParamID = $questionParamResult["mbapi"][0]["header"][0]["lastInsertID"][0];

		$questionParamValueParams = array(
			"questionParamID" => $questionParamID,
			"questionParamValueText" => $value,
		);

		$questionParamValueResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetQuestionParamValues",
				"subCommand" => "insert",
				"params" => $questionParamValueParams,
			),
		)), 1);

	}
} // AddGenericAttribute
?>
