<?php
// $Id: AddWizardQuestion.php 12708 2008-02-28 17:01:59Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/sourceaction.php");
require_once mb_path("/lib-action/include/wizard/WizardResolver.php");

class AddWizardQuestion extends SourceAction {
	/**
	 * The constructor for a AddWizardQuestion action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddWizardQuestion() {
		SourceAction::SourceAction();
		$this->stringRep = "AddWizardQuestion";
	}

	/**
	 * The main method of this class that executes the AddWizardQuestion action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		$w =& new Wizard((int) $_REQUEST["wizardID"], TRANS_ADD_CUSTOM_QUESTION, TRANS_ADD_CUSTOM_QUESTION_MESG);
		$s =& new WizardStep(TRANS_ADD_QUESTION, TRANS_ADD_QUESTION_MESG);

		$wr =& new WizardResolver(
			"name",
			"order",
			"question",
			"description",
			"type",
			"restrictions",
			"answers",
			"values",
			"selected",
			"size",
			"maxlength",
			"minlen",
			"maxlen",
			"password"
		);
		$wr->addQuestionRel("type", "answers");
		$wr->addQuestionRel("type", "size");
		$wr->addQuestionRel("type", "maxlength");
		$wr->addQuestionRel("restrictions", "minlen");
		$wr->addQuestionRel("restrictions", "maxlen");
		$wr->addQuestionRel("answers", "values");
		$wr->addQuestionRel("answers", "selected");
				
		$wr->setWizard($w);
		$wr->setWizardStep($s);
		$wr->processForQuestionsReady();

		$questionAnswers = $wr->getQuestionAnswers();

		if($wr->isReady("name")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_NAME);
			$q->setID($wr->getQuestionID("name"));
			$q->setSize(64);
			$q->setMaxLength(80);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);		
			$s->addQuestion($q);			
		}
		
		if($wr->isReady("order")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_DISPLAY_ORDER);			
			$q->setID($wr->getQuestionID("order"));
			$q->setSize(12);
			$q->setMaxLength(12);
			$q->addAnswer("0");
			$q->setRestrictions(INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED);	
			$s->addQuestion($q);		
		}
		
		if($wr->isReady("question")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_QUESTION);
			$q->setID($wr->getQuestionID("question"));
			$q->setSize(64);
			$q->setMaxLength(256);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);		
			$s->addQuestion($q);			
		}
		
		if($wr->isReady("description")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_DESCRIPTION);
			$q->setID($wr->getQuestionID("description"));
			$q->setSize(64);
			$q->setMaxLength(256);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
			$s->addQuestion($q);
		}
		
		if($wr->isReady("type")) {
			$q =& new WizardQuestion(QUESTION_INPUT_SELECT, TRANS_TYPE);
			$q->setID($wr->getQuestionID("type"));
			$q->addAnswer(TRANS_HIDDEN, "1", 1);
			$q->addAnswer(TRANS_TEXT, "2", 0);
			$q->addAnswer(TRANS_PASSWORD, "3", 0);
			$q->addAnswer(TRANS_TEXTAREA, "4", 0);
			$q->addAnswer(TRANS_SELECT, "5", 0);
			//$q->addAnswer(TRANS_MULTISELECT, "6", 0);
			//$q->addAnswer(TRANS_CHECKBOX, "7", 0);
			$q->addAnswer(TRANS_RADIO, "8", 0);
			$q->setRestrictions(INPUT_RESTRICTION_INT);		
			$s->addQuestion($q);
		}
		
		if($wr->isReady("restrictions")) {
			global $inputRestrictionNames;
			$q =& new WizardQuestion(QUESTION_INPUT_MULTISELECT, TRANS_INPUT_RESTRICTIONS);
			$q->setID($wr->getQuestionID("restrictions"));
			foreach($inputRestrictionNames as $flag => $name) {
				$constantName = defined("TRANS_" . $name) ? constant("TRANS_" . $name) : "TRANS_" . $name;
				$q->addAnswer($constantName, $flag, 0);
			}
			$q->setRestrictions(INPUT_RESTRICTION_INT);		
			$s->addQuestion($q);
		}
		
		if($wr->isReady("answers")) {
			// multi-answer types
			if(in_array($questionAnswers["type"], array("5","6","7","8",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXTAREA, TRANS_ANSWERS);
				$q->setSize(5);
				$q->setMaxLength(80);
				$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
			} else {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_DEFAULT_VALUE);
				$q->setSize(12);
				$q->setMaxLength(256);
			}
			$q->setID($wr->getQuestionID("answers"));
			$s->addQuestion($q);
		}
		
		if($wr->isReady("values")) {
		
			// multi-answer types
			if(in_array($questionAnswers["type"], array("5","6","7","8",))) {
				// because array_filter won't work for "0" due to the boolean coersion rule
				$answersTmp = explode("\n", $questionAnswers["answers"]);
				$answertext = array();
				$answernum = 0;
				foreach($answersTmp as $answer) {
					$answer = trim($answer);
					if($answer !== "") {
						$answernum++;
						$answertext[] = $answer . "=";
					}
				}
				$answers = implode("\n", $answertext);
				$q =& new WizardQuestion(QUESTION_INPUT_TEXTAREA, TRANS_VALUES);
				$q->setID($wr->getQuestionID("values"));
				$q->addAnswer($answers);
				$q->setSize($answernum);
				$q->setMaxLength(80);
				$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("values");
			}
		}
		
		if($wr->isReady("selected")) {
			// multi-select types
			if(in_array($questionAnswers["type"], array("6","7",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_MULTISELECT, TRANS_SELECTED);
				$q->setID($wr->getQuestionID("selected"));
				$answers = explode("\n", $questionAnswers["answers"]);
				$i = 0;
				foreach($answers as $answer) {
					$q->addAnswer($answer, ++$i, 0);
				}
				$s->addQuestion($q);
			// single-select types
			} else if(in_array($questionAnswers["type"], array("5","8",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_SELECT, TRANS_SELECTED);
				$q->setID($wr->getQuestionID("selected"));
				$answers = explode("\n", $questionAnswers["answers"]);
				$i = 0;
				foreach($answers as $answer) {
					$q->addAnswer($answer, ++$i, 0);
				}
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("selected");
			}
		}
		
		if($wr->isReady("size")) {
			// textarea type
			if($questionAnswers["type"] == "4") {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_ROWS);			
				$q->setID($wr->getQuestionID("size"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			// text field types
			} else if(in_array($questionAnswers["type"], array("2","3",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_SIZE);			
				$q->setID($wr->getQuestionID("size"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("size");
			}

		}
		
		if($wr->isReady("maxlength")) {
			// textarea type
			if($questionAnswers["type"] == "4") {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_COLS);			
				$q->setID($wr->getQuestionID("maxlength"));
				$q->setSize(12);
				$q->setMaxLength(256);
				$s->addQuestion($q);
			// text field types
			} else if(in_array($questionAnswers["type"], array("2","3",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_MAX_LENGTH);			
				$q->setID($wr->getQuestionID("maxlength"));
				$q->setSize(12);
				$q->setMaxLength(256);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("maxlength");
			}
		}
		
		if($wr->isReady("minlen")) {
			if(is_array($questionAnswers['restrictions']) && in_array(INPUT_RESTRICTION_MINLEN, $questionAnswers['restrictions'])) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_MIN_ACCEPTABLE_LENGTH);			
				$q->setID($wr->getQuestionID("minlen"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("minlen");
			}
		}
		
		if($wr->isReady("maxlen")) {
			if(is_array($questionAnswers['restrictions']) && in_array(INPUT_RESTRICTION_MAXLEN, $questionAnswers['restrictions'])) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_MAX_ACCEPTABLE_LENGTH);			
				$q->setID($wr->getQuestionID("maxlen"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("maxlen");
			}
		}

		if($wr->isReady("password")) {
			if(is_array($questionAnswers['restrictions']) && in_array(INPUT_RESTRICTION_PASSWORD, $questionAnswers['restrictions'])) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_PASSWORD);
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("password");
			}
		}

		$confirm = $_REQUEST['confirm'];
		
		if(!$confirm) {
			$this->mergeSystemNavData();
			$this->addTemplate("orderforms/AddWizardQuestion", $this->smartyVars);
		}
		
		$questionOrder = 0;
		if($confirm || !$wr->display()) {
			$summary = array();
			$questionParams = array();

			if(isset($questionAnswers['name'])) {
				$questionName = $questionAnswers['name'];
				$summary[] = array(TRANS_NAME, unsecureInput($questionName));
			}
			
			if(isset($questionAnswers['order'])) {
				$questionOrder = $questionAnswers['order'];
				$summary[] = array(TRANS_ORDER, unsecureInput($questionOrder));
			}
			
			if(isset($questionAnswers['question'])) {
				$question = $questionAnswers['question'];
				$questionQuestion = preg_match("/^TRANS_/", $question) && defined($question) ? constant($question) : $question;
				$summary[] = array(TRANS_QUESTION, unsecureInput($questionQuestion));
			}
						
			if(isset($questionAnswers['description'])) {
				$desc = $questionAnswers['description'];
				$questionDesc = preg_match("/^TRANS_/", $desc) && defined($desc) ? constant($desc) : $desc;
				$summary[] = array(TRANS_DESCRIPTION, unsecureInput($questionDesc));
			}

			if(isset($questionAnswers['type'])) {
				$paramOrder = 0;
				$questionParams[] = array('setQuestion', $paramOrder++, array($questionAnswers['question']));
				switch ($questionAnswers['type']) {
					case 1:
						$summary[] = array(TRANS_TYPE, TRANS_HIDDEN);
						$q =& new WizardQuestion(QUESTION_INPUT_HIDDEN, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_HIDDEN"));
						break;
					case 2:
						$summary[] = array(TRANS_TYPE, TRANS_TEXT);
						$q =& new WizardQuestion(QUESTION_INPUT_TEXT, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_TEXT"));
						break;
					case 3:
						$summary[] = array(TRANS_TYPE, TRANS_PASSWORD);
						$q =& new WizardQuestion(QUESTION_INPUT_PASSWORD, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_PASSWORD"));
						break;
					case 4:
						$summary[] = array(TRANS_TYPE, TRANS_TEXTAREA);
						$q =& new WizardQuestion(QUESTION_INPUT_TEXTAREA, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_TEXTAREA"));
						break;
					case 5:
						$summary[] = array(TRANS_TYPE, TRANS_SELECT);
						$q =& new WizardQuestion(QUESTION_INPUT_SELECT, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_SELECT"));
						break;
					case 6:
						$summary[] = array(TRANS_TYPE, TRANS_MULTISELECT);
						$q =& new WizardQuestion(QUESTION_INPUT_MULTISELECT, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_MULTISELECT"));
						break;
					case 7:
						$summary[] = array(TRANS_TYPE, TRANS_CHECKBOX);
						$q =& new WizardQuestion(QUESTION_INPUT_CHECKBOX, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_CHECKBOX"));
						break;
					case 8:
						$summary[] = array(TRANS_TYPE, TRANS_RADIO);
						$q =& new WizardQuestion(QUESTION_INPUT_RADIO, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_RADIO"));
						break;
				}
				$q->setDescription($questionDesc);
				$questionParams[] = array('setDescription', $paramOrder++, array($questionAnswers['description']));

			}

			//show($questionAnswers);
			/*
			echo '<pre>';
			print_r($questionAnswers);
			echo '</pre>';
			*/
			
			if(!empty($questionAnswers['restrictions'])) {
				global $inputRestrictionNames;
				$restrictions = array();
				$restrictionBitmap = 0;
				foreach($inputRestrictionNames as $flag => $name) {
					if(in_array($flag, $questionAnswers['restrictions'])) {
						$constantName = defined("TRANS_" . $name) ? constant("TRANS_" . $name) : "TRANS_" . $name;
						$restrictions[] = $constantName;
						$restrictionBitmap |= $flag;
					}
				}
				$restrictions = implode('; ', $restrictions);
				$summary[] = array(TRANS_RESTRICTIONS, $restrictions);
				
				$q->setRestrictions($restrictionBitmap);
				$questionParams[] = array('setRestrictions', $paramOrder++, array($restrictionBitmap));
			}

			if(isset($questionAnswers['answers'])) {
				$answers = array();
				if(in_array($questionAnswers["type"], array("5","6","7","8",))) {
					$lines = array_map("trim", explode("\n", $questionAnswers['answers']));
					foreach($lines as $line) {
						if($line !== "") {
							$answers[] = $line;
						}
					}
					//$summary[] = array(TRANS_ANSWERS, implode(' - ', $answers));

					$optionsMesg = "";
					if(isset($questionAnswers['values'])) {
						// key values
						$keyedValues = array();
						$lines = array_map("trim", explode("\n", $questionAnswers['values']));
						$answers = array_map("trim", explode("\n", $questionAnswers["answers"]));
						$selectedAnswers = array();
						foreach((array) $questionAnswers['selected'] as $i) {
							$selectedAnswers[] = $answers[$i - 1];
						}
						//show($answers);
						//show($selectedAnswers);
						/*
						echo '<pre>';
						print_r($answers);
						print_r($selectedAnswers);
						echo '</pre>';
						*/
						foreach($lines as $line) {
							if($line !== "") {
								list($key, $value) = explode('=', $line, 2);
								$key = trim($key);
								$value = trim($value);
								$keyedValues[$key] = $value;
								
								$thisOptionMesg = htmlentities($key) . " = " . htmlentities($value);
								/*
								echo "<br /> in_array(" . $key . ", " . print_r($selectedAnswers, 1) . ") = " . ( in_array($key, $selectedAnswers) ? "true" : "false" ) . "<br />";
								echo '[';
								echo in_array($key, $selectedAnswers);
								echo '|';
								echo (bool) in_array($key, $selectedAnswers);
								echo ']';
								*/

								if(in_array($key, (array) $selectedAnswers)) {
									$selected = 1;
									$optionsMesg .= "(" . $thisOptionMesg . "), ";
								} else {
									$selected = 0;
									$optionsMesg .= "" . $thisOptionMesg . ", ";
								}
								$q->addAnswer($key, $value, $selected);
								$questionParams[] = array('addAnswer', $paramOrder++, array($key, $value, $selected));
							}
						}

						// order values
						$orderedValues = array();
						$c = count($answers);
						for($i = 0; $i < $c; $i++) {
							$answer = $answers[$i];
							$orderedValues[] = $keyedValues[$answer];

						}
						
						//$summary[] = array(TRANS_VALUES, implode(' - ', $orderedValues));
					}
					$optionsMesg .= "";
					
					$summary[] = array(TRANS_VALUES, unsecureInput($optionsMesg));
				} else {
					$q->addAnswer($questionAnswers['answers']);
					$questionParams[] = array('addAnswer', $paramOrder++, array($questionAnswers['answers']));
					$summary[] = array(TRANS_VALUE, unsecureInput($questionAnswers['answers']));
				}
			}
						
			if(isset($questionAnswers['size'])) {
				// textarea
				if($questionAnswers["type"] == "4") {
					$summary[] = array(TRANS_ROWS, unsecureInput($questionAnswers['size']));
				} else {
					$summary[] = array(TRANS_SIZE, unsecureInput($questionAnswers['size']));
				}
				$q->setSize($questionAnswers['size']);
				$questionParams[] = array('setSize', $paramOrder++, array($questionAnswers['size']));
			}
			
			if(isset($questionAnswers['maxlength'])) {
				// textarea
				if($questionAnswers["type"] == "4") {
					$summary[] = array(TRANS_COLS, unsecureInput($questionAnswers['maxlength']));
				} else {
					$summary[] = array(TRANS_MAX_LENGTH, unsecureInput($questionAnswers['maxlength']));
				}
				$q->setMaxLength($questionAnswers['maxlength']);
				$questionParams[] = array('setMaxLength', $paramOrder++, array($questionAnswers['maxlength']));
			}
			
			if(isset($questionAnswers['minlen'])) {
				$summary[] = array(TRANS_MIN_ACCEPTABLE_LENGTH, unsecureInput($questionAnswers['minlen']));
				$q->addRestrictionArg('minlen', $questionAnswers['minlen']);
				$questionParams[] = array('addRestrictionArg', $paramOrder++, array('minlen', $questionAnswers['minlen']));
			}
			
			if(isset($questionAnswers['maxlen'])) {
				$summary[] = array(TRANS_MAX_ACCEPTABLE_LENGTH, unsecureInput($questionAnswers['maxlen']));
				$q->addRestrictionArg('maxlen', $questionAnswers['maxlen']);
				$questionParams[] = array('addRestrictionArg', $paramOrder++, array('maxlen', $questionAnswers['maxlen']));
			}
			
			if(isset($questionAnswers['password'])) {
				$summary[] = array(TRANS_PASSWORD, unsecureInput($questionAnswers['password']));
				$q->addRestrictionArg('password', $questionAnswers['password']);
				$questionParams[] = array('addRestrictionArg', $paramOrder++, array('password', $questionAnswers['password']));
			}
			
			$sp =& new WizardStep(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
			$sp->addQuestion($q);
			if(!$confirm) {
				$sp->display(true);
			}
			
			if(!$confirm) {
				$this->addTemplate("orderforms/AddWizardQuestion2", array('summary' => $summary, 'wizardID' => $w->getID()));
			}
		}


		if(!$confirm) {
			//echo '<pre>';
			//print_r($_REQUEST);
			//print_r($wr);
			//print_r($w);
			//echo '</pre>';
		
			$this->addTemplate("footer", array());
		} else {
			// insert into database
			
			do {
				$insertQuestion =& new MBQuery(
					"SetQuestions", "insert",
					array(
						"questionDisplayName" => unsecureInput($questionName),
						"stepID" => $questionAnswers['stepID'],
						"questionOrder" => $questionOrder,
					)
				);
				if(!$this->addErrorsFromResult($r =& $insertQuestion->getResult())) break;
				$questionID = $r->getLastInsertID();

				$params = array();
				foreach($questionParams as $param) {
					list($paramName, $paramOrder, $paramValues) = $param;
					
					$params[] = array(
							"questionID" => $questionID,
							"questionParamName" => unsecureInput($paramName),
							"questionParamOrder" => $paramOrder,
							"questionParamValues" => array(
								"questionParamValue" => $paramValues,
							),
					);
					
				}
				$insertQuestionParams =& new MBQuery("SetWizardQuestionParams", "insert", array("questionParams" => array("questionParam" => $params)));
				if(!$this->addErrorsFromResult($r =& $insertQuestionParams->getResult())) break;
				redirect("orderforms.php", getActionID("ShowWizardQuestions"), array());

				//echo '<pre>';
				//echo "Woo!\n";
				//echo "StepID: " . $questionStep . "\n";
				//echo "order: " . $questionOrder . "\n";
				//print_r($questionParams);
				//echo '</pre>';
				//exit;
			
			} while(0);
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddProduct
?>
