<?php
// $Id: RemoveAttribute.php 8245 2006-08-03 18:57:44Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a OrderForm.
 *
 * @author  Kris Bailey
 */
class RemoveAttribute extends MB_Action {
	/**
	 * The constructor for a RemoveAttribute action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveAttribute() {
		parent::MB_Action();
		$this->stringRep = "RemoveAttribute";
		$this->params = array("orderFormID");
	}

	/**
	 * The main method of this class that executes the RemoveAttribute action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$attributeID = ((int) $_REQUEST["attributeID"]);
		if(!$attributeID) {
			$this->addError(TRANS_ACTIONERROR, "No attribute ID given.");
		} else {
			
			$this->smartyVars["attributeInfo"] = oneByID("attributes", $attributeID);
			//$this->smartyVars["questionInfo"] = oneByID("questions", $this->smartyVars["attributeInfo"]["questionID"]);
			//$this->smartyVars["questionInfo"]["other"] = arrayFor("questionParams", array("questionID" => $this->smartyVars["attributeInfo"]["questionID"]));

			$this->addTemplate("orderforms/RemoveAttribute", $this->smartyVars, 1);
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveAttribute
?>