<?php
// $Id: ShowOrderForms.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all orderForms that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Mark Garrett
 */
 
class ShowOrderForms extends MB_Action {
	/**
	 * The constructor for a ShowOrderForms action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowOrderForms() {
		parent::MB_Action();
		$this->stringRep = "ShowOrderForms";
		
		$this->params = array(
			"orderFormID",
			"orderFormName",
			"paymentGroupID");
		$this->sortColumns = array("orderFormID", "orderFormName", "paymentGroupID");
	}

	/**
	 * The main method of this class that executes the ShowOrderForms action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetPaymentGroups");
		$data = dispatchMBAPI($query, 1);
		$smartyVars = array();

		if((int)$data["mbapi"][0]["header"][0]["numResults"][0] !== 0) {
			$getOptions = array(
				"getPaymentGroupData" => 1		
			);
	
			$query = $this->getMBAPIQuery("GetOrderForms", "", $getOptions, 1, 1, 1, 1);
			$data = dispatchMBAPI($query, 1);
	
			$results =& $data["mbapi"][0]["results"][0];
		}else{
			$smartyVars["noPayGroups"] = TRUE;
		}

		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars["orderforms"] = $results["orderForms"][0]["orderForm"];
			if((int)$data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$smartyVars["orderforms"] = array(0 => $results["orderForms"][0]["orderForm"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			
			$this->addTemplate("orderforms/ShowOrderForms", collapseArrayElements($smartyVars), 1);
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowOrderForms
?>