<?php
// $Id: AddHistoricalPackageResponse.php 12423 2008-01-03 20:16:34Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__) . "/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/app-modernbill-admin/include/lib-action/packages/AddHistoricalPackage.php");

class AddHistoricalPackageResponse extends AddHistoricalPackage {
	function AddHistoricalPackageResponse() {
		parent::AddHistoricalPackage();
		$this->stringRep = "AddHistoricalPackageResponse";
		$this->params = array();
	}
	
	function execute() {
		global $CONF;
		
		do {

			//show($_REQUEST);

			$clientID = getParam("clientID");
			$orderFormID = getParam("orderFormID");
			$productID = getParam("productID");
			$productVariantID = getParam("productVariantID");
			$cycleID = getParam("cycleID");

			$this->assignMode();
			$this->assignProductInfo();
			$this->assignClientInfo();
			
			//echo "<pre>";
			//print_r($_REQUEST);

			$billingAccountID = $_REQUEST["billingAccountID"];

			if($this->product["productStopNumCycles"] != 1) {
				$packageNextRenewal = $this->handleDateSelector("packageNextRenewal", mktime());
			}
			$packageStartDate = $this->handleDateSelector("packageStartDate", mktime());

			if($this->type == "domain") {
				$registerDomain = $this->handleDateSelector("registerDomain", false, !$this->historical);
			} else {
				$serverGroupData = array();
				foreach($this->serverGroups as $serverGroupID => $serverGroupName) {
					$key = "sg" . $serverGroupID;
					$serverGroupData[$serverGroupID] = array();
					$serverGroupData[$serverGroupID]["username"] = $_REQUEST[$key . "username"];
					$serverGroupData[$serverGroupID]["password"] = $_REQUEST[$key . "password"];
					$serverGroupData[$serverGroupID]["configGroupID"] = $_REQUEST[$key . "panel"];
					$serverGroupData[$serverGroupID]["provision"] = $this->handleDateSelector($key . "create", false, !$this->historical);
				}
			}
			//echo "next: " . $packageNextRenewal . "\n";
			//echo "start: " . $packageStartDate . "\n";
			//echo $registerDomain . "\n";
			//print_r($serverGroupData);
			//exit;

			$generalPrice = $this->getNumberFromInput($_REQUEST["generalPrice"]);
			$setupPrice = $this->getNumberFromInput($_REQUEST["setupPrice"]);

			$overrideDateDue = $this->handleDateSelector("overrideDateDue", 0);

			$query = array();
			if (!$_REQUEST["emailOptions"]){
				$emailOptions = array(
					"enableInvoiceEmail" => 0,
					"disableNewOrderEmail" => 1,
				);
			} elseif ((int)$_REQUEST["emailOptions"]==1){
				$emailOptions = array(
					"enableInvoiceEmail" => 0,
					"disableNewOrderEmail" => 0,
				);
			} elseif ((int)$_REQUEST["emailOptions"]==2){
				$emailOptions = array(
					"enableInvoiceEmail" => 1,
					"disableNewOrderEmail" => 0,
				);
			}
			$query += array(
				"orderFormID" => $orderFormID,
				"paymentType" => 9999,
				"fraudLevelActionStatus" => 1,
				"disableInvoicing" => empty($_REQUEST["generateInvoice"]) ? 1 : 0,
				"overrideDateDue" => $overrideDateDue,
				"disableCharging" => (int) (bool) !$_REQUEST["enableCharging"],
				"disableFraudguardian" => 1,
				"disableClientUpdates" => 1,
				"client" => array(
					"clientID" => $clientID,
				),
			);
			$query += $emailOptions;
			
			$product = array(
				"ID" => 14736251,
				"productID" => $productID,
				"productVariantID" => $productVariantID,
				"cycleID" => $cycleID,
				"quantity" => 1,
				"taxZoneGroupID" => $this->productVariant["taxZoneGroupID"],
				"comments" => ($_REQUEST["comments"])?secureInput($_REQUEST["comments"]):TRANS_MANUALLY_CREATED_BY_ADMIN.": " . $CONF["user"]["adminData"]["adminUsername"][0],
				"price" => (float) $generalPrice,
				"setup" => (float) $setupPrice,
				"packageDateNextRenewal" => $packageNextRenewal ? $packageNextRenewal : $packageStartDate,
				"packageDateBeginRenewal" => $packageStartDate,
			);

			$servers = array();
			foreach((array)$serverGroupData as $serverGroupID => $serverData) {
				$server = array();

				$server["serverGroupID"] = $serverGroupID;
				if($configGroupID = $serverData["configGroupID"]) $server["configGroupID"] = $configGroupID;
				$server["packageUsername"] = $serverData["username"];
				$server["packagePassword"] = $serverData["password"];
				//Adding this to figure out if this package should just be tied to the server -AC 11-9-07
				$server["serverTieOnly"] = ((int)$serverData["provision"])? 0 : 1;

				$servers[] = $server;
			}
			if($servers) $product["servers"] = array("server" => $servers);

			if($billingAccountID) $query["clientBillingAccount"] = array("billingAccountID" => $billingAccountID);
			
			$contact = $this->primaryContact;
			$TLD = $this->TLD;
			switch ($this->type) {
				case "domain":
					if($registerDomain) {
						$query["domainRegistrant"] = array(
							"registrantFirstName" => $contact["contactFirstName"],
							"registrantLastName" => $contact["contactLastName"],
							"registrantAddress1" => $contact["contactAddress1"],
							"registrantAddress2" => $contact["contactAddress2"],
							"registrantCity" => $contact["contactCity"],
							"registrantStateProvince" => $contact["contactState"],
							"registrantPostalCode" => $contact["contactZip"],
							"registrantOrganizationName" => $client["clientCompany"],
							"registrantJobTitle" => "",
							"registrantEmail" => $contact["contactEmail"],
							"registrantPhone" => $contact["contactPhone1"],
							"registrantFax" => $contact["contactFax"],
							"registrantCountry" => $contact["countriesID"],
						);

						$query["provisionDateRule"] = array(
							"domainID" => (int) $_REQUEST["packageDomainID"],
							"provisionDate" => $registerDomain,
						);

						if($_REQUEST["packageDomainID"]) {
							$product["domain"] = array(
								"domainID" => (int) $_REQUEST["packageDomainID"],
								"domainType" => getAPITypeID("shoppingdomains", "existing"),
							);
						} else if($_REQUEST["domainName"] && $TLD["tldExtension"]) {
							$product["domain"] = array(
								"domainID" => 14736251,
								"domainType" => getAPITypeID("shoppingdomains", "new"),
								"domainSLD" => $_REQUEST["domainName"],
								"domainTLD" => $TLD["tldExtension"],
							);
						}
					} else {
						if($_REQUEST["packageDomainID"]) {
							$query["provisionRules"] = array(
								"disableDomainIDs" => array("domainID" => (int) $_REQUEST["packageDomainID"]),
							);
							$product["domain"] = array(
								"domainID" => (int)$_REQUEST["packageDomainID"],
								"domainType" => getAPITypeID("shoppingdomains", "existing"),
							);
						} else if($_REQUEST["domainName"] && ($TLD["tldExtension"] || $_REQUEST["domainTLD"])) {
							$query["provisionRules"] = array(
								"disableDomainIDs" => array("domainID" => 14736251),
							);
							$product["domain"] = array(
								"domainID" => 14736251,
								"domainType" => getAPITypeID("shoppingdomains", "new"),
								"domainSLD" => $_REQUEST["domainName"],
								"domainTLD" => ($TLD["tldExtension"])?$TLD["tldExtension"]:$_REQUEST["domainTLD"],
							);
						}
					}
					break;
				case "hosting":
					if($_REQUEST["packageDomainID"]) {
						$query["provisionRules"] = array(
							"disableDomainIDs" => array("domainID" => (int) $_REQUEST["packageDomainID"]),
						);
						$product["domain"] = array(
							"domainID" => (int)$_REQUEST["packageDomainID"],
							"domainType" => getAPITypeID("shoppingdomains", "existing"),
						);
					} else if($_REQUEST["domainName"] && $_REQUEST["domainTLD"]) {
						$query["provisionRules"] = array(
							"disableDomainIDs" => array("domainID" => 14736251),
						);
						$product["domain"] = array(
							"domainID" => 14736251,
							"domainType" => getAPITypeID("shoppingdomains", "manual"),
							"domainSLD" => $_REQUEST["domainName"],
							"domainTLD" => $_REQUEST["domainTLD"],
						);
					}
					// fall through
				default:
					$provisionDateRules = array();
					$disableProvisionIDs = array(
						"serverGroupID" => array(),
					);
					foreach($serverGroupData as $serverGroupID => $serverGroupAttrs) {
						if($serverGroupAttrs["provision"]) {
							$provisionDateRules[] = array(
								"serverGroupID" => $serverGroupID,
								"provisionDate" => $serverGroupAttrs["provision"],
							);
						} else {
							$disableProvisionIDs["serverGroupID"][] = $serverGroupID;
						}
					}
					$query["provisionRules"] = array(
						"provisionDateRule" => $provisionDateRules,
						"disableProvisionIDs" => $disableProvisionIDs,
					);
					break;
			}
			$query["products"] = $product;

			//echo '<pre>';
			//print_r($_REQUEST);
			//print_r($query);

			$q =& new MBQuery("ProcessCheckout", "process", $query);
//			show($q->getXMLQuery());
	//		exit;
			//print_r(htmlentities($q->getXMLQuery()));
			//echo '</pre>';
			dbg($q->getXMLQuery());
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;

			$rs =& $r->getSubjectFrom(array("mbapi", "results", "packageID", 0));
			$packageID = $rs->getData();
			updateForKey(":packages", $packageID, array(
				"packageDateBeginRenewal" => $packageStartDate,
			));
			//echo "packageID: " . $packageID;

			//echo '<pre>';
			//print_r($r);
			//echo '</pre>';
			//exit;
			if(!$this->goBack()) redirect("packages.php", getActionID("ShowPackageDetails"), array("packageID" => $packageID));


			//echo "</pre>";
		} while(0);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}

?>
