<?php
// $Id: AddPackageAttribute.php 9760 2006-10-23 17:52:27Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a package so that that package may be added to the 
 * database.
 *
 * @author  Kris Bailey
 */
class AddPackageAttribute extends MB_Action {
	/**
	 * The constructor for a AddPackageAttribute action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddPackageAttribute() {
		parent::MB_Action();
		$this->stringRep = "AddPackageAttribute";
	}

	/**
	 * The main method of this class that executes the AddPackageAttribute action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$attributes = arrayFor("packageAttributes", array("packageID" => (int)$_REQUEST["packageID"]));
		$serverGroups = array();
		foreach ((array)$attributes as $attribute){
			if (!isset($serverGroups[$attribute["serverGroupID"]])){
				$serverGroups[$attribute["serverGroupID"]] = 1;
			}
		}
		if (array_sum(array_keys($serverGroups))){
			$serverGroups = grabHtmlOpsFromArray(
				grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetServerGroups",
						"array" => array(
							"serverGroupID" => array_keys($serverGroups),
						),
					),
				)),
				"serverGroupID", "serverGroupName"
			);
		} else {
			$serverGroups = array();
		}
		
		$this->smartyVars = array();
		$this->smartyVars["parentName"] = "TRANS_PACKAGES";
		$this->smartyVars["childName"] = "TRANS_MANAGE_PACKAGES";
		$this->smartyVars["sideNavMajor"] = "clients";
		$this->smartyVars["sideNavMinor"] = "packages";
		$this->smartyVars["grandchildrenLabels"] = array(
			"edit" => "TRANS_EDIT_ATTRIBUTE",
			"show" => "TRANS_SHOW_ATTRIBUTES",
			"add" => "TRANS_ADD_ATTRIBUTE",
			"showdetails" => "TRANS_ATTRIBUTE_DETAILS",
			"remove" => "TRANS_REMOVE_ATTRIBUTE",
		);
		$this->smartyVars["inForm"] = "no";
		$this->smartyVars["genericType"] = "add";
		$this->smartyVars["grandchildName"] = "TRANS_ADD_ATTRIBUTE";
		$this->smartyVars["addResponseAction"] = "AddPackageAttributeResponse";
		$packageInfo = optionsFor("packages", array("packageID" => (int)$_REQUEST["packageID"]));
		$packageInfo[(int)$_REQUEST["packageID"]] = "(".TRANS_ID.": ".(int)$_REQUEST["packageID"].") ".$packageInfo[(int)$_REQUEST["packageID"]];
		$this->smartyVars["editFields"] = array(
			"packageID" => array(
				"fieldType" => "select",
				"showOnly" => "1",
				"fieldTitle" => "TRANS_PACKAGE",
				"fieldValue" => array(
					"selected" => (int)$_REQUEST["packageID"],
					"selectable" => $packageInfo,
				),
			),
			"serverGroupID" => array(
				"fieldType" => "select",
				"showOnly" => "0",
				"allowBlankChoice" => "1",
				"fieldTitle" => "TRANS_SERVER_GROUP",
				"fieldValue" => array(
					"selected" => "",
					"selectable" => $serverGroups,
				),
			),
			"packageAttributeName" => array(
				"fieldType" => "text",
				"showOnly" => "0",
				"fieldTitle" => "TRANS_ATTRIBUTE_NAME",
				"fieldValue" => ""
			),
			"packageAttributeValue" => array(
				"fieldType" => "text",
				"showOnly" => "0",
				"fieldTitle" => "TRANS_ATTRIBUTE_VALUE",
				"fieldValue" => ""
			),
		);
		
		$this->smartyVars["hiddenFields"] = array(
			"packageAttributeDateCreated" => time(),
			"packageID" => (int)$_REQUEST["packageID"],
		);
		
		$this->addTemplate("widgets/genericTemplate");
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddPackageAttribute
?>