<?php
// $Id: AddPackageResponse.php 11737 2007-08-03 21:33:01Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddPackage action, applies that information to  * records in the database, and redirects to the ShowPackageDetails action for the given package.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddPackageResponse extends MB_Action {
	/**
	 * The constructor for an AddPackageResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddPackageResponse() {
		parent::MB_Action();
		$this->stringRep = "AddPackageResponse";
		$this->params = array(			"packageID",
			"productID",
			"clientID",
			"domainID",
			"invoiceID",
			"certID",
			"productName",
			"packagePriceLessThan",
			"packagePrice",
			"packagePriceGreaterThan",
			"packageSetupFeeLessThan",
			"packageSetupFee",
			"packageSetupFeeGreaterThan",
			"packageQuantityLessThan",
			"packageQuantity",
			"packageQuantityGreaterThan",
			"packageDiscountLessThan",
			"packageDiscount",
			"packageDiscountGreaterThan",
			"packageBillingCycle",
			"packageStatus",
			"packageComments",
			"packageDateBeginRenewalGreaterThan",
			"packageDateBeginRenewal",
			"packageDateBeginRenewalLessThan",
			"packageDateNextRenewalGreaterThan",
			"packageDateNextRenewal",
			"packageDateNextRenewalLessThan",
			"packageDateLastRenewalGreaterThan",
			"packageDateLastRenewal",
			"packageDateLastRenewalLessThan",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
	}

	/**
	 * The main method of this class that executes the AddPackageResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$query = $this->getMBAPIQuery("SetPackages", "insert");
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			
			mbHeader("Location: packages.php?action=".getActionID("ShowPackageDetails")."&packageID="
				.$data["mbapi"][0]["header"][0]["lastInsertID"][0]);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddPackageResponse
?>