<?php
// $Id: ChangePackageClient.php 10540 2007-01-21 20:30:44Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * @author  Kris Bailey
 */
class ChangePackageClient extends MB_Action {
	/**
	 */
	function ChangePackageClient() {
		parent::MB_Action();
		$this->stringRep = "ChangePackageClient";
		$this->params = array("packageID", "clientID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// fake exception handling for php4
		do {
			if($this->err($packageID = getParam("packageID"), "No package ID given.")) break;
			if($this->err($clientID = getParam("clientID"), "No client ID given.")) break;
		
			if($this->err($packageInfo = oneByID("packages", $packageID), "Invalid package ID given.")) break;
			if($this->err($clientInfo = oneByID("clients", $clientID, array(
				"mergePrimaryContact" => 1,
			)), "Invalid client ID given.")) break;
			
			$this->smartyVars["toClient"] = $clientInfo;
			$this->smartyVars["package"] = $packageInfo;
			$this->smartyVars["fromClient"] = oneByID("clients", $packageInfo["clientID"], array(
				"mergePrimaryContact" => 1,
			));
			$this->smartyVars["selectableBillingAccounts"] = array('') + optionsFor("clientBillingAccounts", array("clientID"=>$clientID));
			$this->smartyVars["packageTypes"] = getTypes("products");
			$this->addTemplate("packages/ChangePackageClient", $this->smartyVars);
		} while (false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ChangePackageClient
?>
