<?php
// $Id: ChangePackageClientResponse.php 10540 2007-01-21 20:30:44Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * @author  Kris Bailey
 */
class ChangePackageClientResponse extends MB_Action {
	/**
	 */
	function ChangePackageClientResponse() {
		parent::MB_Action();
		$this->stringRep = "ChangePackageClientResponse";
		$this->params = array("packageID", "clientID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// fake exception handling for php4
		do {
			if($this->err($packageID = getParam("packageID"), "No package ID given.")) break;
			if($this->err($clientID = getParam("clientID"), "No client ID given.")) break;
		
			if($this->err($packageInfo = oneByID("packages", $packageID), "Invalid package ID given.")) break;
			if($this->err($clientInfo = oneByID("clients", $clientID, array(
				"mergePrimaryContact" => 1,
			)), "Invalid client ID given.")) break;
			
			
			$newPackageInfo = $packageInfo;
			unset($newPackageInfo["packageID"]);
			$newPackageInfo["packageStatus"] = getAPIStatusID("package", "transferred");
			$newPackageID = insertFor("packages", $newPackageInfo);
			if($this->err(($this->addMBAPIErrors($results = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetPackageRelations",
					"params" => array(
						"packageID" => $packageID,
						"newPackageID" => $newPackageID,
						"tables" => array(
							"table" => array(
								array(
									"tableName" => "invoice_line_items",
									"columnName" => "package_id",
								),
							),
						),
					),
				),
			)), 1)) === 0 && !$this->getNumErrors()), "Problem cloning old package to keep invoice integrity (line item update error).")) break;
			
			if($this->err(($this->addMBAPIErrors($results = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetPackages",
					"subCommand" => "update",
					"params" => array(
						"packageID" => $packageID,
						"clientID" => $clientID,
					),
				),
			)), 1)) === 0 && !$this->getNumErrors()), "Problem changing client ID on package.")) break;
			
			if($this->err(($this->addMBAPIErrors($results = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetBillingAccountShare",
					"subCommand" => "delete",
					"params" => array(
						"packageID" => $packageID,
					),
				),
			)), 1)) === 0 && !$this->getNumErrors()), "Problem deleting old payment shares..")) break;
			
			if ((int)$_REQUEST["billingAccountID"]){
				if($this->err(($this->addMBAPIErrors($results = dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "insert",
						"params" => array(
							"billingAccountID" => (int)$_REQUEST["billingAccountID"],
							"packageID" => $packageID,
							"billingAccountShareGroup" => 0,
							"billingAccountShareValue" => 1,
							"billingAccountshareFallbackGroup" => 0,
						),
					),
				)), 1)) === 0 && !$this->getNumErrors()), "Problem inserting new payment share for package.")) break;
			}
			
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("packages.php", getActionID("ShowPackageDetails"), array("packageID"=>$packageID));
			}
		
		} while (false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ChangePackageClientResponse
?>
