<?php
// $Id: ChangePackageCycle.php 12523 2008-01-18 23:26:10Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * @author  Blake Tyra
**/
class ChangePackageCycle extends MB_Action {
	/**
	 */
	function ChangePackageCycle() {
		parent::MB_Action();
		$this->stringRep = "ChangePackageCycle";
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		

		$packageID = (isset($_REQUEST["packageID"]) && ((int)$_REQUEST["packageID"])) 
			? $_REQUEST["packageID"] : 0;

		if (!$packageID) {
			$this->addError(TRANS_ACTIONERROR, "Invalid or No Package ID given.");
		} else {
			
			// pull row for package from database, pass to template
			$this->smartyVars["package"] = oneByID(":packages", $packageID);
			
			// find associated domain with package, pass to template
			$domains = arrayFor(":packageDomainRels", array(
				"packageID" => $packageID,
			));
			
			$domainIDs = array();
			foreach ((array)$domains as $d){
				$domainIDs[] = $d["domainID"];
			}
			$this->smartyVars["package"]["domains"] = arrayFor(":packageDomains", array(
				"domainID" => $domainIDs,
			));
			
			// find associated client with package, pass to template
			$this->smartyVars["client"] = oneByID("clients", $this->smartyVars["package"]["clientID"], array(
				"mergePrimaryContact" => 1,
			));
			
			// determine "type" of package, pass to template
			$this->smartyVars["packageTypes"] = getTypes("products");
			
			
			// HERES WHERE THE REST OF MY STUFF WILL GO :))
			
			
			// display template
			$this->addTemplate("packages/ChangePackageCycle", $this->smartyVars);
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
				
		}
	}
} // ChangePackageCycle
?>
