<?php
// $Id: EditPackage.php 11244 2007-06-04 22:15:34Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * @author  Kris, Michael
 */
class EditPackage extends MB_Action {
	/**
	 */
	function EditPackage() {
		parent::MB_Action();
		$this->stringRep = "EditPackage";
		$this->params = array("packageID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// fake exception handling for php4
		do {
			if($this->err($packageID = getParam("packageID"), "No package ID given.")) break;
		
			$packageQuery =& new MBQuery(
				"GetPackages", "",
				array(
					"packageID" => $packageID,
					"getPackageAttributeData" => 1,
					"getPackageAddonData" => 1,
					"getDomainData" => 1,
				)
			);
			if(!$this->addErrorsFromResult($packageResult =& $packageQuery->getResult())) break;
			$packageTable =& $packageResult->getTableFrom(
				array("mbapi", "results", "packages", "package", 0),
				"packageID", "packageName"
			);
			dbg($packageResult);
			$package = $packageTable->getOne();

			
			$domainTable =& $packageResult->getTableFrom(
				array("mbapi", "results", "packages", "package", "domains", "domain"),
				"domainID", "domainSLD"
			);
			$domain = $domainTable->getOne();
			$package["packageDomainID"] = $domain["domainID"]; // interject it so it gets grabbed as the default value

			dbg($domain);
			
			$packageAttributeTable =& $packageResult->getTableFrom(
				array("mbapi", "results", "packages", "package", "packageAttributes", "packageAttribute"),
				"packageAttributeName", "packageAttributeValue"
			);
			$packageAttributes = $packageAttributeTable->getTable();
			$panelPackageAttributeTables =& $packageAttributeTable->getAssociatedTablesBy("configGroupID");
									

			$packageAddons = $packageResult->getEssentialFrom(
				array("mbapi", "results", "packages", "package", "packageAddons", "packageAddon")
			);
			dbg($packageAddons);

			//echo '<pre>';
			//print_r($package);
			$serverTable =& $this->getServerTable();
			$serverTablesByConfigGroupID =& $serverTable->getAssociatedTables();
			
			$panelDetails = array();
			foreach($panelPackageAttributeTables as $configGroupID => $configGroupAttributeTable) {
				if(!isset($serverTablesByConfigGroupID[$configGroupID])) {
					continue;
				}
				$servers =& $serverTablesByConfigGroupID[$configGroupID]->getOne();
				$serverAttributes = $configGroupAttributeTable->getOptions();
				$panelStatus = isset($serverAttributes['panel_status']) ? $serverAttributes['panel_status'] : 'none';
				$statusID = getAPIStatusID("package", $panelStatus);
				$statusName = getStatusName("package", $statusID);
				
				$panelDetails[] = array(
					'servername' => $servers['moduleDisplayName'],
					'configGroupID' => $configGroupID,
					'panel' => $servers['panelName'],
					'statusID' => $statusID,
					'status' => $statusName,
				);
			}

			$this->smartyVars["client"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetClients",
					"params" => array(
						"clientID" => $package["clientID"],
						"mergePrimaryContact" => 1,
					),
				),
			)));

			$packageStatuses = getStatuses("package");
			$panelStatuses = array();
			foreach($packageStatuses as $statusID => $statusName) {
				switch($statusName) {
					case TRANS_ACTIVE:
						$panelStatuses[$statusID] = $statusName;
						break;
					case TRANS_CANCELED:
						$panelStatuses[$statusID] = $statusName;
						break;
					case TRANS_SUSPENDED:
						$panelStatuses[$statusID] = $statusName;
						break;
				}
			}
			
			
			/** AUTO GENERATE FORM DATA BEGIN **/
			$this->smartyVars["editForm"] =& new MBAutoFormFields();
			$this->smartyVars["editForm"]->addFields(array(

				"TRANS_PACKAGE_DETAILS" => array("titleRow","TRANS_PACKAGE_DETAILS"),
				"packageActive" => array("checkbox", "TRANS_RECORD_IS_ACTIVE"),
				"clientContactID" => array("select", "TRANS_BILL_TO_SPECIFIC_CONTACT"),
				"packageType" => array("select", "TRANS_PRODUCT_TYPE"),
				"packageName" => array("text", "TRANS_PRODUCT_NAME"),
				"packageQuantity" => array("text", "TRANS_PRODUCT_QUANTITY"),
				"packageDomainID" => array("select", "TRANS_ASSOCIATED_DOMAIN"),
				"packageComments" => array("textarea", "TRANS_PACKAGE_COMMENTS"),

				"TRANS_PACKAGE_STATUS_OPTIONS" => array("titleRow","TRANS_PACKAGE_STATUS_OPTIONS"),
				"packageStatus" => array("select", "TRANS_CURRENT_PACKAGE_STATUS"),
				"packageStatusReason" => array("textarea", "TRANS_STATUS_CHANGE_REASON"),

				"TRANS_PACKAGE_CANCELLATION_OPTIONS" => array("titleRow","TRANS_PACKAGE_CANCELLATION_OPTIONS"),
				"packageCancellationType" => array("select", "TRANS_CANCELLATION_RULES"),
				"packagePendingCancellation" => array("select", "TRANS_CURRENT_CANCELLATION_ACTION"),

				"TRANS_PACKAGE_PRICE_SETTINGS" => array("titleRow","TRANS_PACKAGE_PRICE_SETTINGS"),
				"packageOriginalPrice" => array("text", "TRANS_ORIGINAL_PRICE"),
				"packagePrice" => array("text", "TRANS_CURRENT_PRICE"),
				"packageSetup" => array("text", "TRANS_SETUP_PRICE"),
				"packageDiscount" => array("text", "TRANS_DISCOUNT_PERCENTAGE"),
				"packageProratable" => array("checkbox", "TRANS_PACKAGE_IS_PRORATABLE"),
				"packagePriceLock" => array("checkbox", "TRANS_PACKAGE_PRICE_LOCKING_ENABLED"),
				"taxZoneGroupID" => array("select", "TRANS_TAX_ZONE_GROUP"),

				"TRANS_COUPON_OPTIONS" => array("titleRow","TRANS_PACKAGE_COUPON_OPTIONS"),
				"couponPrice" => array("text", "TRANS_COUPON_PRICE"),
				"couponNumCycles" => array("text", "TRANS_COUPON_NUM_CYCLES"),

				"TRANS_USAGE_RENEWAL_DATES" => array("titleRow","TRANS_USAGE_RENEWAL_DATES"),
				"usageCycleID" => array("select", "TRANS_USAGE_CYCLE"),
				"usageCalculateOnly" => array("checkbox", "TRANS_USAGE_CALCULATE_ONLY"),
				"usageDateLastRenewal" => array("dateselect", "TRANS_USAGE_DATE_LAST_RENEWAL"),
				"usageDateNextRenewal" => array("dateselect", "TRANS_USAGE_DATE_NEXT_RENEWAL"),

				"TRANS_GENERAL_RENEWAL_DATES" => array("titleRow","TRANS_GENERAL_RENEWAL_DATES"),
				"cycleID" => array("select", "TRANS_BILLING_CYCLE"),
				"packageDateLastRenewal" => array("dateselect", "TRANS_PACKAGE_DATE_LAST_RENEWAL"),
				"packageDateNextRenewal" => array("dateselect", "TRANS_PACKAGE_DATE_NEXT_RENEWAL"),
				"packageDateStopRenewal" => array("dateselect", "TRANS_PACKAGE_DATE_STOP_RENEWAL"),

				"TRANS_SYSTEM_RULES_AND_PERMISSIONS" => array("titleRow","TRANS_SYSTEM_RULES_AND_PERMISSIONS"),
				"packageClientPermissions" => array("select", "TRANS_PACKAGE_CLIENT_PERMISSIONS"),

			));

			$this->smartyVars["editForm"]->addHiddenFields(array(
				"packageID" => $package["packageID"],
			));

			$dd =& new DataSource("clientDomains", array("clientID" => $package["clientID"], "getBillingData" => 1));
			$tldTable =& $this->getTableFromSource($dd);
			if($type == "domain") {
				$TLDsByExt =& $tldTable->getAssociatedTablesBy("domainTLD");
				$extension = $TLD["tldExtension"];
				if(isset($TLDsByExt[$extension])) {
						$tldTable =& $TLDsByExt[$extension];
						$this->smartyVars["clientDomains"] = $tldTable->getOptions();
				} else {
					$clientDomains = array();
				}
			} else {
				$clientDomains = $tldTable->getOptions();
			}

			$this->smartyVars["editForm"]->setFieldData("packageDomainID", "addDomainField", 1);
			$this->smartyVars["editForm"]->setFieldData("packageDomainID", "allowBlankChoice", 1);

			$this->smartyVars["editForm"]->setFieldData("packageStatus", "helpTitle", TRANS_WARNING);
			$this->smartyVars["editForm"]->setFieldData("packageStatus", "helpText", TRANS_SETTING_STATUS_TO_CANCELED_WARNING);

			$this->smartyVars["editForm"]->setFieldData("packageDiscount", "helpTitle", TRANS_WARNING);
			$this->smartyVars["editForm"]->setFieldData("packageDiscount", "helpText", TRANS_SETTING_DISCOUNT_WARNING);

			$this->smartyVars["editForm"]->setFieldData("usageCycleID", "allowBlankChoice", 1);
			$this->smartyVars["editForm"]->setFieldData("taxZoneGroupID", "allowBlankChoice", 1);

			$this->smartyVars["editForm"]->setFieldData("packagePrice", "currencyID", $package["paymentGroupCurrencyID"]);
			$this->smartyVars["editForm"]->setFieldData("packageSetup", "currencyID", $package["paymentGroupCurrencyID"]);
			$this->smartyVars["editForm"]->setFieldData("packageOriginalPrice", "currencyID", $package["paymentGroupCurrencyID"]);
			$this->smartyVars["editForm"]->setFieldData("couponPrice", "currencyID", $package["paymentGroupCurrencyID"]);

			$this->smartyVars["editForm"]->addDataFromSource($package);

			$this->smartyVars["editForm"]->setDateOptional("packageDateStopRenewal");
			$this->smartyVars["editForm"]->setDateOptional("usageDateNextRenewal");
			
			$this->smartyVars["editForm"]->setShowOnly(array(
				"packageDateLastRenewal",
				"packageOriginalPrice",
				"usageDateLastRenewal",
			));
			
			$contacts = arrayFor("contacts", array(
				"clientID" => $package["clientID"],
			));
			
			$contactChoices = array("0" => "");
			foreach ($contacts as $cc){
				$contactChoices[$cc["clientContactID"]] = $cc["contactFirstName"]." ".$cc["contactLastName"];
			}
			
			$this->smartyVars["editForm"]->setSelectable("clientContactID", $contactChoices);
			$this->smartyVars["editForm"]->setSelectable("taxZoneGroupID", grabHTMLOpsFromArray(
						grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZoneGroups</command></mbapi>", 1)), 
						"taxZoneGroupID", 
						"taxZoneGroupName"));
			$this->smartyVars["editForm"]->setSelectable("packageDomainID", $clientDomains);
			$this->smartyVars["editForm"]->setSelectable("packageStatus", getStatuses("package"));
			$this->smartyVars["editForm"]->setSelectable("packageType", getTypes("products"));
			$this->smartyVars["editForm"]->setSelectable("packageClientPermissions", getTypes("packagemanagement"));
			$this->smartyVars["editForm"]->setSelectable("cycleID", getCyclesArray());
			$this->smartyVars["editForm"]->setSelectable("usageCycleID", getCyclesArray());
			$this->smartyVars["editForm"]->setSelectable("packageCancellationType", getTypes("cancellation"));
			$this->smartyVars["editForm"]->setSelectable("packagePendingCancellation", getTypes("pendingcancellation"));
			
			$this->smartyVars["editForm"] = $this->smartyVars["editForm"]->getData();

			/** AUTO GENERATED EDIT FORM DATA END **/

			$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
			$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
			$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
			if (!$tmp[1])$tmp[1] = $tmp[0];
			$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
 			$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;

			$this->smartyVars['package'] = $package;
			$this->smartyVars['package']['domains'] = array($domain);
			$this->smartyVars['packageStatuses'] = $packageStatuses;
			$this->smartyVars['panelStatuses'] = $panelStatuses;
			$this->smartyVars['types'] = getTypes("products");
			$this->smartyVars['packageAttributes'] = $packageAttributes;
			$this->smartyVars['panelDetails'] = $panelDetails;
			
			$defaults = $package;
			
			$this->mergeFormState($defaults);
			$this->addTemplate("packages/EditPackage");
		} while (false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPackage
?>
