<?php
// $Id: ShowPackageAddons.php 8192 2006-08-02 05:51:02Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowPackageAddons extends ShowAction {
	/**
	 * The constructor for a ShowPackages action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowPackageAddons() {
		global $CONF;
		$this->setDataSource(new DataSource("packageAddons"));
		parent::ShowAction();
		$this->stringRep = "ShowPackageAddons";
		// define all possible params that we will accept
		$this->params = array
		(
			"packageID",
		);

	}

	/**
	 * showHandler method to link into execution
	 */
	function showHandler() {
		global $CONF;

		$this->smartyVars["types"] = getTypes("products");

		$this->smartyVars["packageInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));

		$taxZoneGroupData = grabHTMLOpsFromArray(
						grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZoneGroups</command></mbapi>", 1)), 
						"taxZoneGroupID", 
						"taxZoneGroupName");

		foreach ((array)$this->smartyVars["packageAddons"] as $k=>$addon){
			$this->smartyVars["packageAddons"][$k]["taxZoneGroupName"] = $taxZoneGroupData[$addon["taxZoneGroupID"]];
		}

		$this->d->description["columns"]["taxZoneGroupName"] = COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_DISPLAYABLE;
		$this->d->description["columnLabels"]["taxZoneGroupName"] = "TRANS_TAX_ZONE_GROUP";

		$this->smartyVars["manualRowActions"][] = array(
			"action" => "ShowPackageAddonAttributes",
			"args" => array(
				"packageAddonID",
			),
			"icon" => "/ico/cube_molecule.gif",
		);

	}
} // ShowPackageAddons
?>
