<?php
// $Id: UpdatePackageBillingSharesResponse.php 12569 2008-01-24 22:13:44Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditPackage action, applies that information to
 * records in the database, and redirects to the ShowPackageDetails action for the given package.
 *
 * @author  Kris "The Man" Bailey
 */
class UpdatePackageBillingSharesResponse extends MB_Action {
	/**
	 * The constructor for an UpdatePackageBillingSharesResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function UpdatePackageBillingSharesResponse() {
		parent::MB_Action();
		$this->stringRep = "UpdatePackageBillingSharesResponse";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the UpdatePackageBillingSharesResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if ($packageID = (int)$_REQUEST["packageID"]){
		
			if ((int)$_REQUEST["billingAccountID"]){
				$shares = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetBillingAccountShares",
						"params" => array(
							"packageID" => $packageID,
						),
					),
				));
				$done = false;
				foreach ((array)$shares as $s){
					if ($s["billingAccountID"]==$_REQUEST["billingAccountID"]){
						updateForKey(":clientBillingAccountShares", $s["billingAccountShareID"], array(
							"billingAccountShareValue" => 1,
						));
						$done = true;
					} else {
						updateForKey(":clientBillingAccountShares", $s["billingAccountShareID"], array(
							"billingAccountShareValue" => 0,
						));
					}
				}
				
				if (!$done){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "insert",
							"params" => array(
								"billingAccountID" => $_REQUEST["billingAccountID"],
								"packageID" => $packageID,
								"billingAccountFallbackGroup" => 1,
								"billingAccountShareGroup" => 0,
								"billingAccountShareValue" => 1,
							),
						),
					)));
				}
				
			} else {
			
				$shares = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetBillingAccountShares",
						"params" => array(
							"packageID" => $packageID,
						),
					),
				));
			
				$existingShares = array();
				foreach ($shares as $share){
					$existingShares[$share["billingAccountID"]] = $share;
				}
			
				$newShares = array();
				$updateShares = array();
				foreach ($_REQUEST as $k=>$v){
					$test = @substr($k, 0, 11);
					$id = str_replace("shareValue_", "", $k);
					if ($test=="shareValue_"){
						if ($existingShares[$id]){
							$updateShares[$existingShares[$id]["billingAccountShareID"]] = $v;
							unset($existingShares[$id]);
						} else {
							$newShares[$id] = $v;
						}
					}
				}
			
				foreach ($newShares as $billingAccountID=>$shareValue){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "insert",
							"params" => array(
								"billingAccountID" => $billingAccountID,
								"packageID" => $packageID,
								"billingAccountFallbackGroup" => 1,
								"billingAccountShareGroup" => 0,
								"billingAccountShareValue" => $shareValue,
							),
						),
					)));
				}
			
				foreach ($updateShares as $shareID=>$shareValue){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "update",
							"params" => array(
								"billingAccountShareID" => $shareID,
								"billingAccountShareValue" => $shareValue,
							),
						),
					)));
				}
				
				foreach ($existingShares as $billingAccountID=>$share){
					$shareID = $share["billingAccountShareID"];
					$shareValue = 0;
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "update",
							"params" => array(
								"billingAccountShareID" => $shareID,
								"billingAccountShareValue" => $shareValue,
							),
						),
					)));
				}
			}
			
			redirect("packages.php", getActionID("ShowPackageDetails"), array("packageID" => $packageID));
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPackageResponse
?>
