<?php
// $Id: UpgradeDowngradeAction.php 12873 2008-04-22 16:25:41Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This upgrades a package based on request variables submitted from the previous page.
 *
 * @author  Kris Bailey
 */
class UpgradeDowngradeAction extends MB_Action {
	/**
	 * The constructor for a UpgradePackageResponse action object. 
	 */
	function UpgradeDowngradeAction() {
		parent::MB_Action();
	}

	/**
	 * The main method of this class that executes the UpgradePackageResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->packageInfoCache[(int)$_REQUEST["packageID"]] = $this->packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"getPackageAttributeData" => 1,
					"getPackageDatabaseData" => 1,
					"getDomainData" => 1,
					"getCertData" => 1,
					"getPackageAddonData" => 1,
				),
			),
		)));
		
		//show($_REQUEST, 1);
		
		if ($this->packageInfo["productID"]!=(int)$_REQUEST["productID"]){
			$this->processFullUpgradeDowngrade($this->packageInfo);
		} else {
			$this->processUpgradeDowngrade($this->packageInfo);
		}
		
	}
	
	function processFullUpgradeDowngrade($packageInfo){
		global $CONF;
		$copyAttributeNames = array(
			"packageUsername",
			"packagePassword",
			"ip",
			"externalID",
			"clientID",
			"domainID",
		);

		$updatePackageCommand = array(
			"mbapi" => array(
				"command" => "SetPackages",
				"subCommand" => "update",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"packageActive" => 0,
					"packageStatus" => getAPIStatusID("package", "canceled"),
				),
			),
		);
		
		$billingShareInfo = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetBillingAccountShares",
				"params" => array(
					"packageID" => $packageInfo["packageID"],
				),
			),
		)));

		$productInfo = oneByID("products", (int)$_REQUEST["productID"], array(
			"getProductAttributeData" => 1,
			"getCouponData" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getTLDData" => 1,
			"getCycleData" => 1));
			

		$rawaddons = arrayFor("products", array(
			"parentProductID" => (int)$_REQUEST["productID"],
			"productActive" => 1,
			"getProductAttributeData" => 1,
			"getCouponData" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getTLDData" => 1,
			"getCycleData" => 1));

		$keyedAddons = array();
		$addonGroupIDs = array();
		foreach ((array)$rawaddons as $k=>$addon){
			$addonGroupIDs[] = $addon["productAddonGroupID"];
			$keyedAddons[$addon["productID"]] =& $rawaddons[$k];
		}

		$addonGroupNames = optionsFor("productAddonGroups", array("productAddonGroupID" => $addonGroupIDs));

		//dbg($packageInfo);
		//dbg($productInfo);
		//dbg($keyedAddons);
		//dbg($billingShareInfo);
		
		// lets get the tax zone group id's of the variants we are going to use
		$taxZoneGroupIDs = array();
		foreach ((array)$productInfo["productVariants"] as $variant){
			$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
		}
		foreach ((array)$_REQUEST["addons"] as $addonID){
			foreach ((array)$keyedAddons[$addonID]["productVariants"] as $variant){
				$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
				$keyedAddons[$addonID]["taxZoneGroupID"] = $variant["taxZoneGroupID"];
			}
		}
		// ok, now we have tax zone group id's keyed on the variant id's
		// lets figure out the tax zone group id of the package now: (there is an easier way)
		foreach ((array)$productInfo["productVariantPrices"] as $price){
			if ($price["productVariantID"] == (int)$_REQUEST["productVariantID"]){
				$packageTaxZoneGroupID = $taxZoneGroupIDs[$price["productVariantID"]];
			}
		}
		
/*		// now lets get the tax zone group ids for the addons
		foreach ((array)$_REQUEST["addons"] as $addonID){
			foreach ((array)$keyedAddons[$addonID]["productVariantPrices"] as $price){
				if ($price["currencyID"]==$packageInfo["paymentGroupCurrencyID"] && $price["cycleID"]==$packageInfo["cycleID"]){
					$keyedAddons[$addonID]["taxZoneGroupID"] = $price["taxZoneGroupID"];
				}
			}
		}*/
		
		
		// first lets make the attributes we need for the new package, which will include some of the old ones...
		$packageAttributes = $this->getPackageAttributesByName($packageInfo);
		$serverGroupMap = array();
		foreach ((array)$packageAttributes as $attr){
			$serverGroupMap[$attr["serverGroupID"]] = $attr["configGroupID"];
		}
		$this->serverGroupIDs =& $serverGroupMap;
		$productAttributes = $this->getProductAttributesByName($productInfo, $serverGroupMap);
		$addProvisioning = (is_array($serverGroupMap) && count($serverGroupMap))?1:0;

		//dbg($packageAttributes);
		//dbg($productAttributes);
		
		foreach ($packageAttributes as $attribute){
			if (in_array($attribute["packageAttributeName"], $copyAttributeNames)){
				$row = array(
					"serverGroupID" => $attribute["serverGroupID"],
					"packageAttributeName" => $attribute["packageAttributeName"],
					"packageAttributeValue" => $attribute["packageAttributeValue"],
					"packageAttributeDateCreated" => $attribute["packageAttributeDateCreated"],
					"configGroupID" => $attribute["configGroupID"],
				);
				$productAttributes[$attribute["packageAttributeName"]] = $row;
			}
		}


		//dbg(toXML(array("packageAttributes"=>array("packageAttribute"=>array_values($productAttributes)))));
		// done making the attributes, just add into query when needed...


		// ok, lets make the addon array:
		$tempaddons = array();
		foreach ((array)$_REQUEST["addons"] as $addons){
			foreach ((array)$addons as $addon){
				$tempaddons[] = $addon;
			}
		}
		$_REQUEST["addons"] = $tempaddons;
		$packageAddons = array();
		foreach ((array)$_REQUEST["addons"] as $addonID){
			if ($keyedAddons[$addonID]){
				$packageAddons[] = array(
					"copyLedgerEntries" => 1,
					"packageAddonDisplayName" => $addonGroupNames[$keyedAddons[$addonID]["productAddonGroupID"]].": ".$keyedAddons[$addonID]["productName"],
					"packageAddonProductID" => $keyedAddons[$addonID]["productID"],
					"taxZoneGroupID" => $keyedAddons[$addonID]["productVariants"][0]["taxZoneGroupID"],
					"packageAddonPriceLock" => 1,
					"packageAddonActive" => 1,
					"packageAddonDiscountable" => $keyedAddons[$addonID]["productDiscountable"],
					"couponID" => 0,
					"couponNumCycles" => (int)$_REQUEST["prices"][$addonID]["couponcycles"],
					"couponPrice" => $this->getNumberFromInput($_REQUEST["prices"][$addonID]["coupon"]),
					"packageAddonOriginalPrice" => $this->getNumberFromInput($_REQUEST["prices"][$addonID]["general"]),
					"packageAddonPrice" => $this->getNumberFromInput($_REQUEST["prices"][$addonID]["general"]),
					// if we are upgrading at the end of the cycle we add the fee as the setup price
					"packageAddonSetup" => ((int)$_REQUEST["packageUpgradeDowngradeType"]) ? $this->getNumberFromInput($_REQUEST["prices"][$addonID]["fee"]) : 0,
				);
			}
		}


		$packageArray = array(
			"packageName" => $productInfo["productName"],
			"packagePriorID" => $packageInfo["packageID"],
			"clientID" => $packageInfo["clientID"],
			"packageStatus" => $packageInfo["packageStatus"],
			"packageActive" => 1,
			"productID" => $productInfo["productID"],
			"taxZoneGroupID" => $packageTaxZoneGroupID,
			"packageProratable" => $productInfo["productProratable"],
			"packageDateCreated" => time(),
			"packageDateBeginRenewal" => $packageInfo["packageDateNextRenewal"],
			"packageDateLastRenewal" => 0,
			"packageDateNextRenewal" => $packageInfo["packageDateNextRenewal"],
			"packageDateStopRenewal" => $packageInfo["packageDateStopRenewal"],
			"packageComments" => $_REQUEST["packageComments"],
			"packageType" => $productInfo["productType"],
			"packageOriginalPrice" => $this->getNumberFromInput($_REQUEST["packagePrices"]["original"]),
			"packagePrice" => $this->getNumberFromInput($_REQUEST["packagePrices"]["general"]),
			// if we are upgrading at the end of the cycle we add the fee as the setup price
			"packageSetup" => ((int)$_REQUEST["packageUpgradeDowngradeType"]) ? $this->getNumberFromInput($_REQUEST["packagePrices"]["fee"]) : 0,
			"couponPrice" => $this->getNumberFromInput($_REQUEST["packagePrices"]["coupon"]),
			"couponNumCycles" => $this->getNumberFromInput($_REQUEST["packagePrices"]["couponcycles"]),
			"cycleID" => $packageInfo["cycleID"],
			"packagePriceLock" => $packageInfo["packagePriceLock"],
			"usageCycleID" => $packageInfo["usageCycleID"],
			"usageCalculateOnly" => $packageInfo["usageCalculateOnly"],
			"paymentGroupID" => $packageInfo["paymentGroupID"],
			"domainIDs" => array("domainID"=> array()),
		);
		foreach ((array)$packageInfo["domains"] as $domain){
			$packageArray["domainIDs"]["domainID"][] = $domain["domainID"];
		}

		$packageArray["packageAddons"] = array("packageAddon"=>$packageAddons);
		$packageArray["packageAttributes"] = array("packageAttribute"=>array_values($productAttributes));


		// lets get the percentage of the cycle we are through here.
		$feeFromDate = $now = time()-(time()%(24*60*60))+(24*60*60);
		$additionalCycles = 0;
		$feeToDate = $cycleEnd = (int)$packageInfo["packageDateNextRenewal"];
		while ( ($cycleStart = getLastBillingTimestamp($cycleEnd, $packageInfo["cycleID"])) > $now ){
			$additionalCycles++;
			$cycleEnd = getLastBillingTimestamp($cycleEnd, $packageInfo["cycleID"]);
			dbg("taking cycle end backwards one step ....");
		}
		$cycleLength = $cycleEnd-$cycleStart;
		if ((int)$cycleLength){
			$through = $now-$cycleStart;
			$percentageThrough = $through/$cycleLength;
			$percentageLeft = 1-$percentageThrough;
			if ($percentageThrough>1 || $percentageLeft<0){
				$_REQUEST["packageUpgradeDowngradeType"] = 2; // we didn't calculate a valid percentage
			}
		} else {
			$_REQUEST["packageUpgradeDowngradeType"] = 2; // we didnt have a cycle length and couldn't get a percentage
			// so we can't do any proration
		}

		$systemQueueDateToRun = $packageInfo["packageDateNextRenewal"];

		switch ((int)$_REQUEST["packageUpgradeDowngradeType"]){

			case 0: // need to add proration credits
				$doProrationAndCredits = 1;
				$systemQueueDateToRun = time();
				
			break;

			case 1: // don't need to add proration credits per request
				$systemQueueDateToRun = time();
			break;

		}


		$packageResult = dispatchMBAPI($xx = toXML(array(
			"mbapi" => array(
				"command" => "SetPackages",
				"subCommand" => "insert",
				"params" => $packageArray,
			),
		)), 1);

		dbg($xx);

		if (!(int)$packageResult["mbapi"][0]["header"][0]["lastInsertID"][0]){
			$this->addError("TRANS_ACTIONERROR", "Error creating new package.");
		} else {
			$invoicePackages = array();
			$invoicePackages[] = $newPackageID = $packageResult["mbapi"][0]["header"][0]["lastInsertID"][0];
			$currencyID = $packageInfo["paymentGroupCurrencyID"];
			$endCreditDescription = "";
			if ((int)$doProrationAndCredits){
				
				if (!$this->packageInfoCache[$newPackageID]){
					$this->packageInfoCache[$newPackageID] = $newPackageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetPackages",
							"params" => array(
								"packageID" => (int)$newPackageID,
								"getPackageAttributeData" => 1,
								"getPackageDatabaseData" => 1,
								"getDomainData" => 1,
								"getCertData" => 1,
								"getPackageAddonData" => 1,
							),
						),
					)));
				} else {
					$newPackageInfo = $this->packageInfoCache[$newPackageID];
				}

				$endCreditDescription = array();
				$totalCreditsAmount = 0;

				$paidAmounts = $this->getPackageLastLineItemTotal((int)$_REQUEST["packageID"], 0, $now);
				$paidAmountForProration = round($paidAmounts[0], 2);
				$paidAmountNotProrated = array_sum($allPaidAmounts = array_merge($paidAmounts[1], $paidAmounts[2]));
				list($newAmount, $discountPercentage, $taxes, $amount, $discountAmount, $taxZones, $additionalCyclesAmount, $additionalCycleAmounts, $thisTaxZoneGroupID) = array_values($this->getPackageDiscountedAndTaxedAmount($newPackageID, 0, $additionalCycles));
	
				$refundAmount = round($paidAmountForProration*$percentageLeft, 2)+$paidAmountNotProrated;
				$upgradeDowngradeFeeAmount = $this->getNumberFromInput($_REQUEST["packagePrices"]["fee"]);
				$chargeAmount = round($newAmount*$percentageLeft, 2)+$additionalCyclesAmount+$upgradeDowngradeFeeAmount;
				
				$proratedAmts = array(
					round($paidAmountForProration*$percentageLeft, 2),
					round($newAmount*$percentageLeft, 2),
				);
				
				if ($refundAmount>0){
					$refundFinalAmount = round($refundAmount, 2);
					
					$description = array();
					
					$description[] = array(
						"name" => TRANS_PREVIOUS_PACKAGE.": ".$packageInfo["packageID"]." ".TRANS_FOR." ".round($percentageLeft*100, 2)."% ".TRANS_OF." ".@constant(getCycleName($packageInfo["cycleID"]))." @ ".$currencyID." ".number_format($paidAmountForProration, 2, ".", ""),
						"packageName" => $packageInfo["packageName"],
						"op" => "+",
						"value" => $proratedAmts[0],
					);
					
					if ($paidAmountNotProrated>0){
						foreach ($allPaidAmounts as $amt){
							$description[] = array(
								"name" => TRANS_PAID_FOR_CYCLE,
								"op" => "+",
								"value" => round($amt, 2),
							);
						}
					}
					
					$totalCreditsAmount += round($refundFinalAmount, 2);
					$endCreditDescription = $description;
					
					$description[] = array(
						"name" => "",
						"op" => "=",
						"value" => round($refundFinalAmount, 2),
					);
					
					
					dbg("setting credit of: ".$refundFinalAmount);
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetCreditAccounting",
							"params" => array(
								"clientID" => $packageInfo["clientID"],
								"ledgerAccountName" => "revenue",
								"amount" => round($refundFinalAmount, 2),
								"currencyID" => $packageInfo["paymentGroupCurrencyID"],
								"description" => $this->formatTextProrationDescription($description, $currencyID),
							),
						),
					)));
				}
				if ($chargeAmount>0){
					$chargeFinalAmount = round($chargeAmount, 2);
					
					$description = array();
					
					$description[] = array(
						"name" => TRANS_NEW_PACKAGE.": ".$newPackageID." ".TRANS_FOR." ".round($percentageLeft*100, 2)."% ".TRANS_OF." ".@constant(getCycleName($packageArray["cycleID"]))." @ ".$currencyID." ".number_format($newAmount, 2, ".", ""),
						"packageName" => $newPackageInfo["packageName"],
						"op" => "+",
						"value" => $proratedAmts[1],
					);
					if ($upgradeDowngradeFeeAmount>0){
						$description[] = array(
							"name" => $this->constants['TRANS_X_FEE'],
							"packageName" => $newPackageInfo["packageName"],
							"op" => "+",
							"value" => $upgradeDowngradeFeeAmount,
						);
					}
					if ($additionalCyclesAmount>0){
						foreach ($additionalCycleAmounts as $amt){
							$description[] = array(
								"name" => TRANS_ADDITIONAL_CYCLE,
								"op" => "+",
								"value" => round($amt, 2),
							);
						}
					}
					
					$description[] = array(
						"name" => "",
						"op" => "=",
						"value" => round($chargeFinalAmount, 2),
					);
					
					dbg("setting fee of: ".$chargeFinalAmount);

					$tPackageInfo = array_merge(array(), $packageInfo);
					dbg("using tax zone group id: ".$thisTaxZoneGroupID." for package id: ".$tPackageInfo["packageID"]);

					$invoicePackages[] = $this->addProrationFee($tPackageInfo, $this->constants['TRANS_PRORATED_X_FEE'], $this->formatHTMLProrationDescription($description, $currencyID), $chargeFinalAmount, $feeFromDate, $feeToDate, $newPackageID);
				}

##############################################################################
## Here are make the fees for the new addons that were just created
##############################################################################
				foreach ((array)$newPackageInfo["packageAddons"] as $addon){
					if (!$addon["packageAddonActive"]) continue;
					
					list($newAmount, $discountPercentage, $taxes, $amount, $discountAmount, $taxZones, $additionalCyclesAmount, $additionalCycleAmounts, $thisTaxZoneGroupID) = array_values($this->getPackageDiscountedAndTaxedAmount($newPackageID, $addon["packageAddonID"], $additionalCycles));
					$packageAddonUpgradeDowngradeFee = $this->getNumberFromInput($_REQUEST["prices"][$addon["productID"]]["fee"]);
					$chargeAmount = ($newAmount*$percentageLeft)+$additionalCyclesAmount+$packageAddonUpgradeDowngradeFee;
					if ($chargeAmount>0) {
						$chargeFinalAmount = round($chargeAmount, 2);
						
						$proratedAmts = array(
							round($newAmount*$percentageLeft, 2),
						);
						
						$description = array();
						
						$description[] = array(
							"name" => TRANS_NEW_PACKAGE_ADDON.": ".$addon["packageAddonID"]." ".TRANS_FOR." ".round($percentageLeft*100, 2)."% ".TRANS_OF." ".@constant(getCycleName($packageArray["cycleID"]))." @ ".$currencyID." ".number_format($newAmount, 2, ".", ""),
							"packageName" => $addon["packageAddonDisplayName"],
							"op" => "+",
							"value" => $proratedAmts[0],
						);
						if ($packageAddonUpgradeDowngradeFee>0){
							$description[] = array(
								"name" => TRANS_X_FEE,
								"packageName" => $addon["packageAddonDisplayName"],
								"op" => "+",
								"value" => $packageAddonUpgradeDowngradeFee,
							);
						}
						if ($additionalCyclesAmount>0){
							foreach ($additionalCycleAmounts as $amt){
								$description[] = array(
									"name" => TRANS_ADDITIONAL_CYCLE,
									"op" => "+",
									"value" => round($amt, 2),
								);
							}
						}
						
						$description[] = array(
							"name" => "",
							"op" => "=",
							"value" => $chargeFinalAmount,
						);
						
						dbg("adding fee package of: ".$chargeFinalAmount);
					
						$tPackageInfo = array_merge(array(), $newPackageInfo);
						$tPackageInfo["taxZoneGroupID"] = $addon["taxZoneGroupID"];
						$tPackageInfo["packageDiscountable"] = $addon["packageDiscountable"];
						dbg("using tax zone group id: ".$thisTaxZoneGroupID." for package id: ".$addon["packageID"]." package addon id: ".$addon["packageAddonID"]);

						$invoicePackages[] = $this->addProrationFee($tPackageInfo, $this->constants['TRANS_PRORATED_X_FEE'], $this->formatHTMLProrationDescription($description, $currencyID), $chargeFinalAmount, $feeFromDate, $feeToDate, $addon["packageID"], $addon["packageAddonID"]);
					}
				}
##############################################################################
## End new addon fees
##############################################################################
			
##############################################################################
## Here are make the credits for the existing addons that are being canceled
##############################################################################
				foreach ($packageInfo["packageAddons"] as $addon){
					if (!$addon["packageAddonActive"]) continue;
					
					$paidAmounts = $this->getPackageLastLineItemTotal($packageInfo["packageID"], $addon["packageAddonID"], $now);
					$paidAmountForProration = $paidAmounts[0];
					$paidAmountNotProrated = array_sum($allPaidAmounts = array_merge($paidAmounts[1], $paidAmounts[2]));
		
					$refundAmount = round($paidAmountForProration*$percentageLeft, 2)+$paidAmountNotProrated;
					
					$proratedAmts = array(
						round($paidAmountForProration*$percentageLeft, 2),
					);
					
					if ($refundAmount>0){
						$refundFinalAmount = round($refundAmount, 2);
						
						$description = array();
						
						$description[] = array(
							"name" => TRANS_PREVIOUS_PACKAGE_ADDON.": ".$addon["packageAddonID"]." ".TRANS_FOR." ".round($percentageLeft*100, 2)."% ".TRANS_OF." ".@constant(getCycleName($packageInfo["cycleID"]))." @ ".$currencyID." ".number_format($paidAmountForProration, 2, ".", ""),
							"packageName" => $addon["packageAddonDisplayName"],
							"op" => "+",
							"value" => $proratedAmts[0],
						);
						
						if ($paidAmountNotProrated>0){
							foreach ($allPaidAmounts as $amt){
								$description[] = array(
									"name" => TRANS_PAID_FOR_CYCLE,
									"op" => "+",
									"value" => round($amt, 2),
								);
							}
						}
						
						$totalCreditsAmount += round($refundFinalAmount, 2);
						$endCreditDescription = array_merge($endCreditDescription, $description);
						
						$description[] = array(
							"name" => "",
							"op" => "=",
							"value" => $refundFinalAmount,
						);
						
						dbg("setting addon credit of: ".$refundFinalAmount);
						
						dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "SetCreditAccounting",
								"params" => array(
									"clientID" => $packageInfo["clientID"],
									"ledgerAccountName" => "revenue",
									"amount" => round($refundFinalAmount, 2),
									"currencyID" => $packageInfo["paymentGroupCurrencyID"],
									"description" => $this->formatTextProrationDescription($description, $currencyID),
								),
							),
						)));
					}
				}
				
##############################################################################
## End existing addon credits
##############################################################################
	
				if ($totalCreditsAmount>0){
					$endCreditDescription[] = array(
						"name" => TRANS_TOTAL,
						"op" => "=",
						"value" => round($totalCreditsAmount, 2),
					);
//					$invoicePackages[] = $this->addProrationFee($newPackageInfo, TRANS_ITEMIZED_UPGRADE_CREDITS, $this->formatHTMLProrationDescription($endCreditDescription, $currencyID), 0);
					$invoiceComments = $this->constants['TRANS_ITEMIZED_X_CREDITS']." ".TRANS_FOR." ".TRANS_PACKAGE." ".$packageInfo["packageID"]." (".$packageInfo["packageName"].")"."<br />".$this->formatHTMLProrationDescription($endCreditDescription, $currencyID);
				}
				
			
			}

			dispatchMBAPI(toXML($updatePackageCommand));

			foreach ($billingShareInfo as $share){
				foreach ($invoicePackages as $pkgID){
					if ((int)$pkgID){
						dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "SetBillingAccountShare",
								"subCommand" => "insert",
								"params" => array(
									"packageID" => $pkgID,
									"billingAccountID" => $share["billingAccountID"],
									"billingAccountFallbackGroup" => $share["billingAccountFallbackGroup"],
									"billingAccountShareGroup" => $share["billingAccountShareGroup"],
									"billingAccountShareValue" => $share["billingAccountShareValue"],
								),
							),
						)));
						dbg("added share for package: ".$pkgID);
					}
				}
			}
			
			if ((int)$_REQUEST["generateInvoice"]){
				$generateOptions = array(
					"getClients" =>  array("clientID" => $packageInfo["clientID"]),
					"getPackages" =>  array("packageID" => (array)$invoicePackages),
					"setBillingMode" =>  "anniversary",
					"packageDateNextRenewalLessThan" => time() +10,
					"domainDateNextRenewalLessThan" => -1,
				);
				if ($invoiceComments) $generateOptions["invoiceComments"] = secureInput($invoiceComments);
				$invoiceInfo = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "ProcessInvoices",
						"params" => $generateOptions,
					),
				));
				dbg("invoice Info:");
				dbg($invoiceInfo);
			}

			if ((int)$_REQUEST["packageProvision"] && $addProvisioning){
				$timeData = explode(";", date("i;G;j;n;Y", $systemQueueDateToRun));
				foreach ((array)$this->serverGroupIDs as $serverGroupID=>$configGroupID){
					if ((int)$serverGroupID){
						dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "SetSystemQueue",
								"subCommand" => "insert",
								"params" => array(
									"systemQueueCommand" => "ProcessPanel",
									"systemQueueCommandInput" => htmlentities(toXML(array(
										"mbapi" => array(
											"command" => "ProcessPanel",
											"subCommand" => $this->subCommand,
											"params" => array(
												"subCommand" => $this->subCommand,
												"serverGroupID" => (int)$serverGroupID,
												"configGroupID" => (int)$configGroupID,
												"packageID" => $newPackageID,
												"oldPackageID" => $packageInfo["packageID"],
											),
										),
									))),
									"serverGroupID" => (int)$serverGroupID,
									"configGroupID" => (int)$configGroupID,
									"systemQueueMinute" => $timeData[0],
									"systemQueueHour" => $timeData[1],
									"systemQueueDay" => $timeData[2],
									"systemQueueMonth" => $timeData[3],
									"systemQueueYear" => $timeData[4],
									"systemQueueIsRecurring" => 0,
									"systemQueueDateCreated" => time(),
									"systemQueueDateToRun" => $dateToRun,
									"systemQueueDateStarted" => 0,
									"systemQueueDateFinished" => 0,
									"packageID" => $newPackageID,
								),
							),
						)));
					}
				}
			} else {
				$this->setTodo($this->constants['TRANS_PACKAGE_X'].": ".$newPackageID, $this->constants['TRANS_PACKAGE_X_DESC'], $newPackageID);
			}
			
			redirect("packages.php", getActionID("ShowPackages"), array("clientID" => $packageInfo["clientID"]));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	function processUpgradeDowngrade($packageInfo){
		global $CONF;
		
		$packageAttributes = $this->getPackageAttributesByName($packageInfo);
		$serverGroupMap = array();
		foreach ((array)$packageAttributes as $attr){
			$serverGroupMap[$attr["serverGroupID"]] = $attr["configGroupID"];
		}
		unset($serverGroupMap[0]);
		$addProvisioning = (count($serverGroupMap))?1:0;

		$productInfo = oneByID("products", (int)$_REQUEST["productID"], array(
			"getProductAttributeData" => 1,
			"getCouponData" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getTLDData" => 1,
			"getCycleData" => 1));
			

		$billingShareInfo = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetBillingAccountShares",
				"params" => array(
					"packageID" => $packageInfo["packageID"],
				),
			),
		)));

		$rawaddons = arrayFor("products", array(
			"parentProductID" => (int)$_REQUEST["productID"],
			"productActive" => 1,
			"getProductAttributeData" => 1,
			"getCouponData" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getTLDData" => 1,
			"getCycleData" => 1));

		$keyedAddons = array();
		$addonGroupIDs = array();
		foreach ((array)$rawaddons as $k=>$addon){
			$addonGroupIDs[] = $addon["productAddonGroupID"];
			$keyedAddons[$addon["productID"]] =& $rawaddons[$k];
		}

		$addonGroupNames = optionsFor("productAddonGroups", array("productAddonGroupID" => $addonGroupIDs));

		// lets get the tax zone group id's of the variants we are going to use
		$taxZoneGroupIDs = array();
		foreach ((array)$productInfo["productVariants"] as $variant){
			$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
		}
		
		foreach ((array)$_REQUEST["addons"] as $addonID){
			foreach ((array)$keyedAddons[$addonID]["productVariants"] as $variant){
				$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
				$keyedAddons[$addonID]["taxZoneGroupID"] = $variant["taxZoneGroupID"];
			}
		}
		
		// ok, now we have tax zone group id's keyed on the variant id's
		// lets figure out the tax zone group id of the package now: (there is an easier way)
		foreach ((array)$productInfo["productVariantPrices"] as $price){
			if ($price["productVariantID"] == (int)$_REQUEST["productVariantID"]){
				$packageTaxZoneGroupID = $taxZoneGroupIDs[$price["productVariantID"]];
			}
		}
		
		//dbg($packageInfo);
		//dbg($productInfo);
		dbg($keyedAddons);
		//dbg($billingShareInfo);

		$packageAttributes = $this->getPackageAttributesByName($packageInfo);
		$serverGroupMap = array();
		foreach ((array)$packageAttributes as $attr){
			$serverGroupMap[$attr["serverGroupID"]] = $attr["configGroupID"];
		}
		$this->serverGroupIDs =& $serverGroupMap;

/*		// now lets get the tax zone group ids for the addons
		foreach ((array)$_REQUEST["addons"] as $addonID){
			foreach ((array)$keyedAddons[$addonID]["productVariants"] as $variant){
				if ($price["currencyID"]==$packageInfo["paymentGroupCurrencyID"] && $price["cycleID"]==$packageInfo["cycleID"]){
				}
			}
		}*/

		// ok, lets make the addon array:
		$tempaddons = array();
		foreach ((array)$_REQUEST["addons"] as $addons){
			foreach ((array)$addons as $addon){
				$tempaddons[] = $addon;
			}
		}
		$_REQUEST["addons"] = $tempaddons;
		$packageAddons = array();
		foreach ((array)$_REQUEST["addons"] as $addonID){
			if ($keyedAddons[$addonID]){
				$packageAddons[] = array(
					"copyLedgerEntries" => 1,
					"packageAddonDisplayName" => $addonGroupNames[$keyedAddons[$addonID]["productAddonGroupID"]].": ".$keyedAddons[$addonID]["productName"],
					"packageAddonProductID" => $keyedAddons[$addonID]["productID"],
					"taxZoneGroupID" => $keyedAddons[$addonID]["productVariants"][0]["taxZoneGroupID"],
					"packageAddonPriceLock" => 1,
					"packageAddonActive" => 1,
					"packageAddonDiscountable" => $keyedAddons[$addonID]["productDiscountable"],
					"couponID" => 0,
					"couponNumCycles" => (int)$_REQUEST["prices"][$addonID]["couponcycles"],
					"couponPrice" => $this->getNumberFromInput($_REQUEST["prices"][$addonID]["coupon"]),
					"packageAddonOriginalPrice" => $this->getNumberFromInput($_REQUEST["prices"][$addonID]["general"]),
					"packageAddonPrice" => $this->getNumberFromInput($_REQUEST["prices"][$addonID]["general"]),
					"packageAddonSetup" => (int)$_REQUEST["packageUpgradeDowngradeType"] ? $this->getNumberFromInput($_REQUEST["prices"][$addonID]["setup"]) : 0,
				);
			}
		}

		$packageArray = array("packageID" => $packageInfo["packageID"]);
		$packageArray["packageAddons"] = array("packageAddon"=>$packageAddons);

		// lets get the percentage of the cycle we are through here.
		$feeFromDate = $now = time()-(time()%(24*60*60))+(24*60*60);
		$additionalCycles = 0;
		$feeToDate = $cycleEnd = (int)$packageInfo["packageDateNextRenewal"];
		while ( ($cycleStart = getLastBillingTimestamp($cycleEnd, $packageInfo["cycleID"])) > $now ){
			$additionalCycles++;
			$cycleEnd = getLastBillingTimestamp($cycleEnd, $packageInfo["cycleID"]);
			dbg("taking cycle end backwards one step ....");
		}
		$cycleLength = $cycleEnd-$cycleStart;
		if ((int)$cycleLength){
			$through = $now-$cycleStart;
			$percentageThrough = $through/$cycleLength;
			$percentageLeft = 1-$percentageThrough;
			if ($percentageThrough>1 || $percentageLeft<0){
				$_REQUEST["packageUpgradeDowngradeType"] = 2; // we didn't calculate a valid percentage
			}
		} else {
			$_REQUEST["packageUpgradeDowngradeType"] = 2; // we didnt have a cycle length and couldn't get a percentage
							     // so we can't do any proration
		}

		$systemQueueDateToRun = $packageInfo["packageDateNextRenewal"];

		
		switch ((int)$_REQUEST["packageUpgradeDowngradeType"]){

			case 0: // need to add proration credits
				$doProrationAndCredits = 1;
				$systemQueueDateToRun = time();
				
			break;

			case 1: // don't need to add proration credits per request
				$systemQueueDateToRun = time();
			break;

		}

		$oldAddonIDs = array();
		foreach ($packageInfo["packageAddons"] as $addon){
			$oldAddonIDs[] = $addon["packageAddonID"];
		}
		
		dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetPackageAddons",
				"subCommand" => "update",
				"params" => array(
					"packageAddonID" => $oldAddonIDs,
					"packageAddonActive" => 0,
				),
			),
		)));

		$packageResult = dispatchMBAPI($xx = toXML(array(
			"mbapi" => array(
				"command" => "SetPackages",
				"subCommand" => "update",
				"params" => $packageArray,
			),
		)), 1);
		dbg($xx);
		$newPackageID = (int)$_REQUEST["packageID"];

		$this->packageInfoCache[$newPackageID] = $newPackageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$newPackageID,
					"getPackageAddonData" => 1,
				),
			),
		)));
		dbg($newPackageInfo);

		
		$invoicePackages = array();
		$currencyID = $packageInfo["paymentGroupCurrencyID"];
		$endCreditDescription = array();
		if ((int)$doProrationAndCredits){
		
##############################################################################
## Here are make the fees for the new addons that were just created
##############################################################################
			foreach ($newPackageInfo["packageAddons"] as $addon){
				if (!(int)$addon["packageAddonActive"]) continue;
				
				list($newAmount, $discountPercentage, $taxes, $amount, $discountAmount, $taxZones, $additionalCyclesAmount, $additionalCycleAmounts, $thisTaxZoneGroupID) = array_values($this->getPackageDiscountedAndTaxedAmount($packageInfo["packageID"], $addon["packageAddonID"], $additionalCycles));
				$packageAddonUpgradeDowngradeFee = $this->getNumberFromInput($_REQUEST["prices"][$addon["productID"]]["fee"]);
				$chargeAmount = round($newAmount*$percentageLeft, 2)+$additionalCyclesAmount;
				if ($chargeAmount>0) {
					dbg($chargeAmount);
					$chargeFinalAmount = round($chargeAmount, 2);
					
					$proratedAmts = array(
						round($newAmount*$percentageLeft, 2),
					);
					
					$description = array();
					
					$description[] = array(
						"name" => TRANS_NEW_PACKAGE_ADDON.": ".$addon["packageAddonID"]." ".TRANS_FOR." ".round($percentageLeft*100, 2)."% ".TRANS_OF." ".@constant(getCycleName($newPackageInfo["cycleID"]))." @ ".$currencyID." ".number_format($newAmount, 2, ".", ""),
						"packageName" => $addon["packageAddonDisplayName"],
						"op" => "+",
						"value" => $proratedAmts[0],
					);
					if ($packageAddonUpgradeDowngradeFee>0){
						$description[] = array(
							"name" => $this->constants["TRANS_X_FEE"],
							"packageName" => $addon["packageAddonDisplayName"],
							"op" => "+",
							"value" => $packageAddonUpgradeDowngradeFee,
						);
					}
					if ($additionalCyclesAmount>0){
						foreach ($additionalCycleAmounts as $amt){
							$description[] = array(
								"name" => TRANS_ADDITIONAL_CYCLE,
								"op" => "+",
								"value" => round($amt, 2),
							);
						}
					}
					
					$description[] = array(
						"name" => "",
						"op" => "=",
						"value" => round($chargeFinalAmount, 2),
					);
					
					dbg("adding fee package of: ".$chargeFinalAmount);

					$tPackageInfo = array_merge(array(), $newPackageInfo);
					$tPackageInfo["taxZoneGroupID"] = $addon["taxZoneGroupID"];
					$tPackageInfo["packageDiscountable"] = $addon["packageAddonDiscountable"];
					dbg("using tax zone group id: ".$thisTaxZoneGroupID." for package id: ".$addon["packageID"]." and this addon id: ".$addon["packageAddonID"]);
					
					$invoicePackages[] = $this->addProrationFee($tPackageInfo, $this->constants['TRANS_PRORATED_X_FEE'], $this->formatHTMLProrationDescription($description, $currencyID), $chargeFinalAmount, $feeFromDate, $feeToDate, $addon["packageID"], $addon["packageAddonID"]);
				} else {
					dbg("didnt get a charge amount");
				}
			}
##############################################################################
## End new addon fees
##############################################################################
			
##############################################################################
## Here are make the credits for the existing addons that are being canceled
##############################################################################
			foreach ($packageInfo["packageAddons"] as $addon){
				dbg($addon);
				if (!$addon["packageAddonActive"]) continue;
				
				$paidAmounts = $this->getPackageLastLineItemTotal($packageInfo["packageID"], $addon["packageAddonID"], $now);
				dbg($paidAmounts);
				$paidAmountForProration = round($paidAmounts[0], 2);
				$paidAmountNotProrated = array_sum($allPaidAmounts = array_merge($paidAmounts[1], $paidAmounts[2]));
	
				$refundAmount = round($paidAmountForProration*$percentageLeft, 2)+$paidAmountNotProrated;
				
				$proratedAmts = array(
					round($paidAmountForProration*$percentageLeft, 2),
				);
				
				if ($refundAmount>0){
					$refundFinalAmount = round($refundAmount, 2);
					
					$description = array();
					
					$description[] = array(
						"name" => TRANS_PREVIOUS_PACKAGE_ADDON.": ".$addon["packageAddonID"]." ".TRANS_FOR." ".round($percentageLeft*100, 2)."% ".TRANS_OF." ".@constant(getCycleName($packageInfo["cycleID"]))." @ ".$currencyID." ".number_format($paidAmountForProration, 2, ".", ""),
						"packageName" => $addon["packageAddonDisplayName"],
						"op" => "+",
						"value" => $proratedAmts[0],
					);
					
					if ($paidAmountNotProrated>0){
						foreach ($allPaidAmounts as $amt){
							$description[] = array(
								"name" => TRANS_PAID_FOR_CYCLE,
								"op" => "+",
								"value" => round($amt, 2),
							);
						}
					}
					
					$totalCreditsAmount += round($refundFinalAmount, 2);
					$endCreditDescription = array_merge($endCreditDescription, $description);
					
					$description[] = array(
						"name" => "",
						"op" => "=",
						"value" => $refundFinalAmount,
					);
					
					dbg("setting addon credit of: ".$refundFinalAmount);
					
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetCreditAccounting",
							"params" => array(
								"clientID" => $packageInfo["clientID"],
								"ledgerAccountName" => "revenue",
								"amount" => round($refundFinalAmount, 2),
								"currencyID" => $packageInfo["paymentGroupCurrencyID"],
								"description" => $this->formatTextProrationDescription($description, $currencyID),
							),
						),
					)));
				} else {
					dbg("refund amount not greater than 0");
				}
			}
##############################################################################
## End existing addon credits
##############################################################################

			if ($totalCreditsAmount>0){
				$endCreditDescription[] = array(
					"name" => "",
					"op" => "=",
					"value" => round($totalCreditsAmount, 2),
				);
				//$invoicePackages[] = $this->addProrationFee($newPackageInfo, TRANS_ITEMIZED_UPGRADE_CREDITS, $this->formatHTMLProrationDescription($endCreditDescription, $currencyID), 0);
				$invoiceComments = $this->constants['TRANS_ITEMIZED_X_CREDITS']." ".TRANS_FOR." ".TRANS_PACKAGE." ".$packageInfo["packageID"]." (".$packageInfo["packageName"].")"."<br />".$this->formatHTMLProrationDescription($endCreditDescription, $currencyID);
			}
		
		}
		
		
		foreach ($billingShareInfo as $share){
			foreach ($invoicePackages as $pkgID){
				if ((int)$pkgID){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "insert",
							"params" => array(
								"packageID" => $pkgID,
								"billingAccountID" => $share["billingAccountID"],
								"billingAccountFallbackGroup" => $share["billingAccountFallbackGroup"],
								"billingAccountShareGroup" => $share["billingAccountShareGroup"],
								"billingAccountShareValue" => $share["billingAccountShareValue"],
							),
						),
					)));
					dbg("added share for package: ".$pkgID);
				}
			}
		}

		
		if ((int)$_REQUEST["generateInvoice"] && count($invoicePackages)){
			$generateOptions = array(
				"getClients" =>  array("clientID" => $packageInfo["clientID"]),
				"getPackages" =>  array("packageID" => (array)$invoicePackages),
				"setBillingMode" =>  "anniversary",
				"packageDateNextRenewalLessThan" => mktime() +1,
				"domainDateNextRenewalLessThan" => -1,	
			);
			if ($invoiceComments) $generateOptions["invoiceComments"] = secureInput($invoiceComments);
			$invoiceInfo = grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "ProcessInvoices",
					"params" => $generateOptions,
				),
			));
			dbg("invoice Info:");
			dbg($invoiceInfo);
		}

		if ((int)$_REQUEST["packageProvision"] && $addProvisioning){
			$timeData = explode(";", date("i;G;j;n;Y", $systemQueueDateToRun));
			foreach ((array)$this->serverGroupIDs as $serverGroupID=>$configGroupID){
				if ((int)$serverGroupID){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetSystemQueue",
							"subCommand" => "insert",
							"params" => array(
								"systemQueueCommand" => "ProcessPanel",
								"systemQueueCommandInput" => htmlentities(toXML(array(
									"mbapi" => array(
										"command" => "ProcessPanel",
										"subCommand" => "panelUpgrade",
										"params" => array(
											"subCommand" => "panelUpgrade",
											"configGroupID" => (int)$configGroupID,
											"serverGroupID" => (int)$serverGroupID,
											"packageID" => $packageInfo["packageID"],
											"addonsOnly" => 1,
											"oldAddonIDs" => $oldAddonIDs,
											"newAddonIDs" => (array)$_REQUEST["addons"],
										),
									),
								))),
								"configGroupID" => (int)$configGroupID,
								"serverGroupID" => (int)$serverGroupID,
								"systemQueueMinute" => $timeData[0],
								"systemQueueHour" => $timeData[1],
								"systemQueueDay" => $timeData[2],
								"systemQueueMonth" => $timeData[3],
								"systemQueueYear" => $timeData[4],
								"systemQueueIsRecurring" => 0,
								"systemQueueDateCreated" => time(),
								"systemQueueDateToRun" => $dateToRun,
								"systemQueueDateStarted" => 0,
								"systemQueueDateFinished" => 0,
								"packageID" => $newPackageID,
							),
						),
					)));
				}
			}
		} else {
			$this->setTodo($this->constants['TRANS_PACKAGE_ADDON_X'].": ".$packageInfo["packageID"], $this->constants['TRANS_PACKAGE_ADDON_X_DESC'], $packageInfo["packageID"]);
		}
		
		redirect("packages.php", getActionID("ShowPackages"), array("clientID" => $packageInfo["clientID"]));

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
	
	// start the helper functions....
	
	
	function addProrationFee($packageInfo, $name, $description, $amount, $from=false, $to=false, $packageID=0, $packageAddonID=0){
		
		if (!$from)$from = time();
		if (!$to)$to = $packageInfo["packageDateNextRenewal"];
		
		dbg("adding fee package with info:");
		dbg("name: ".$name);
		dbg("description: ".$description);
		dbg("amount: ".$amount);
		dbg("package info");
		dbg($packageInfo);
		
		if (!$this->feeProduct){
			$this->feeProduct = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productType" => getAPITypeID("product", "fee"),
						"productName" => "TRANS_PRORATION_FEE",
					),
				),
			)));
		}
		
		if (!$this->feeProduct["productID"]){
			$result = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetProducts",
					"subCommand" => "insert",
					"params" => array(
						"productName" => "TRANS_PRORATION_FEE",
						"productComments" => "TRANS_ADDITIONAL_CHARGES_DUE_TO_PARTIAL_CYCLE_PRORATION",
						"productActive" => 0,
						"productProratable" => 0,
						"productVariants" => array(
							"productVariant" => array(
								"productVariantDisplayName" => "TRANS_PRORATION_FEE",
								"productVariantActive" => 0,
							),
						),
					),
				),
			)), 1);
			$this->feeProductID = $result["mbapi"][0]["header"][0]["lastInsertID"][0];
		} else {
			$this->feeProductID = $this->feeProduct["productID"];
		}
		
		if (!$this->feeProductVariant){
			$this->feeProductVariant = grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProductVariants",
					"params" => array(
						"productID" => $this->feeProductID
					),
				),
			));
			
			$this->feeProductVariantID = $this->feeProductVariant["productVariantID"];
		} else {
			$this->feeProductVariantID = $this->feeProductVariant["productVariantID"];
		}
		
		$this->feePackageCmd = array(
			"mbapi" => array(
				"command" => "SetPackages",
				"subCommand" => "insert",
				"params" => array(
					"clientID" => $packageInfo["clientID"],
					"productID" => $this->feeProductID,
					"productVariantID" => $this->feeProductVariantID,
					"packageName" => htmlentities($name),
					"packageComments" => htmlentities($description),
					"packageDateNextRenewal" => $t = time(),
					"packageDateStopRenewal" => $t+1,
					"cycleID" => $packageInfo["cycleID"],
					"packageActive" => 1,
					"packageStatus" => getAPIStatusID("package", "none"),
					"taxZoneGroupID" => $packageInfo["taxZoneGroupID"],
					"cycleDiscountGroupID" => $packageInfo["cycleDiscountGroupID"],
					"packageProratable" => 0,
					"packageDiscountable" => $packageInfo["packageDiscountable"],
					"packageDateCreated" => $t,
					"packageDateBeginRenewal" => $t,
					"packageType" => getAPITypeID("products", "fee"),
					"packagePrice" => $amount,
					"packageOriginalPrice" => $amount,
					"paymentGroupID" => $packageInfo["paymentGroupID"],
					"feeForPackageID" => $packageID,
					"feeForPackageAddonID" => $packageAddonID,
					"packageAttributes" => array(
						"packageAttribute" => array(
							array(
								"packageAttributeName" => "fromDate",
								"packageAttributeValue" => $from,
								"packageAttributeDateCreated" => time(),
							),
							array(
								"packageAttributeName" => "toDate",
								"packageAttributeValue" => $to,
								"packageAttributeDateCreated" => time(),
							),
						),
					),
				),
			),
		);
		dbg(toXML($this->feePackageCmd));
		$packageResult = dispatchMBAPI(toXML($this->feePackageCmd), 1);
		dbg("fee package addition result:");
		dbg($packageResult);
		return $packageResult["mbapi"][0]["header"][0]["lastInsertID"][0];
	}

	function getPackageLastLineItemTotal($packageID, $packageAddonID=0, $now=false){
		dbg("running get package last line item total");
		dbg("package id: ".$packageID);
		dbg("package addon id: ".$packageAddonID);
		dbg("now: ".$now);
		$now = ($now)?$now:time();
		
		// lets get the fees for this addon or product
		$feeForName = ((int)$packageAddonID)?"getFeesForPackageAddonID":"getFeesForPackageID";
		$feeForData = ((int)$packageAddonID)?$packageAddonID:$packageID;
		$feePackages = correctArray(grabResultsFromMBAPIArray($x = array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					$feeForName => $feeForData,
					"getPackageAttributeData" => 1,
				),
			),
		)));
		dbg(toXML($x));
		dbg($feePackages);
		$feeReturns = array();
		foreach ((array)$feePackages as $fpackage){
			$attributes = $this->getPackageAttributesByName($fpackage);
			dbg($attributes);
			dbg(date("m/d/Y g:i a", $attributes["fromDate"]["packageAttributeValue"]));
			dbg(date("m/d/Y g:i a", $now));
			dbg(date("m/d/Y g:i a", $attributes["toDate"]["packageAttributeValue"]));
			if ($attributes["toDate"]["packageAttributeValue"]>$now){
				if ($attributes["fromDate"]["packageAttributeValue"]<$now){
					$period = $attributes["toDate"]["packageAttributeValue"]-$attributes["fromDate"]["packageAttributeValue"];
					$perThrough = ($now-$attributes["fromDate"]["packageAttributeValue"])/$period;
					$perLeft = 1-$perThrough;
					dbg("percentage through and left:");
					dbg($perThrough);
					dbg($perLeft);
					if ($perLeft>1 || $perLeft<0)$perLeft=1;
					$feeReturns[] = round($fpackage["packagePrice"]*$perLeft, 2);
				} else {
					$feeReturns[] = $fpackage["packagePrice"];
				}
			}
		}
		
		$lineItems = arrayFor("lineItems", array(
			"packageID" => (int)$packageID,
			"sortColumn" => "lineItemDateCurrentRenewal",
			"sortDir" => "ASC",
			"lineItemDateNextRenewalGreaterThan" => $now-1,
			"packageAddonID" => (int)$packageAddonID,
		));
		
		dbg("got line items:");
		dbg($lineItems);
		
		$firstReturn = 0;
		$return = array();
		foreach ($lineItems as $li){
			if (!(int)$li["lineItemIsUsage"]){
				if ($firstReturn>0){
					$return[] = (float)($li["lineItemTotalAmount"]-$li["lineItemSetupAmount"]);
				} else {
					$firstReturn = (float)($li["lineItemTotalAmount"]-$li["lineItemSetupAmount"]);
				}
			}
		}
		
		dbg("returning: ".$firstReturn." -- ");
		dbg($return);
		
		return array($firstReturn, $return, $feeReturns);
		
	}
	
	
	function formatHTMLProrationDescription($description, $currencyID){
		$out = "<table border=\"0\" width=\"100%\" align=\"right\">\n";
		foreach ((array)$description as $x=>$row){
			$out .= "	<tr>\n";
			$out .= "		<td valign=\"top\" style=\"text-align= right;\">".$row["name"].(($row["packageName"])?"<br />".$row["packageName"]:"")."</td>\n";
			$out .= "		<td valign=\"top\" style=\"text-align= right;\" width=\"25\">".$row["op"]."</td>\n";
			$out .= "		<td valign=\"top\" width=\"100\" style=\"text-align= right;\">".$currencyID." ".number_format($row["value"], 2, ".", "")."</td>\n";
			$out .= "	</tr>\n";
		}
		$out .= "</table>";
		return $out;
	}
	
	function formatTextProrationDescription($description, $currencyID){
		$out = "";
		foreach ((array)$description as $row){
			$out .= $row["op"]." ".$row["name"]." ".$currencyID." ".$row["value"]." ";
		}
		return $out;
	}
	

	function getPackageDiscountedAndTaxedAmount($packageID, $packageAddonID=0, $additionalCycles=0){
	
		dbg("getting package discounted and taxed");
		dbg("package id: ".$packageID);
		dbg("package addon id: ".$packageAddonID);
		dbg("additional cycles: ".$additionalCycles);
	
		if (!$this->cycleDiscountsCache)$this->generateCycleDiscountGroupCache();
	
		if (!$this->packageInfoCache[$packageID]){
			$this->packageInfoCache[$packageID] = $packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"packageID" => (int)$packageID,
						"getPackageAttributeData" => 1,
						"getPackageDatabaseData" => 1,
						"getDomainData" => 1,
						"getCertData" => 1,
						"getPackageAddonData" => 1,
					),
				),
			)));
		} else {
			$packageInfo = $this->packageInfoCache[$packageID];
		}
		$this->populateClientInfo($packageInfo["clientID"]);

		if ($packageAddonID){
			// if we need to do this for an addon, add in the info...
			$packageAddonInfo = oneByID("packageAddons", $packageAddonID);
			$packageInfo["packageName"] = $packageAddonInfo["packageAddonDisplayName"];
			$packageInfo["couponNumCycles"] = $packageAddonInfo["couponNumCycles"];
			$packageInfo["couponPrice"] = $packageAddonInfo["couponPrice"];
			$packageInfo["packageDiscount"] = $packageAddonInfo["packageAddonDiscount"];
			$packageInfo["packageDiscountable"] = $packageAddonInfo["packageAddonDiscountable"];
			$packageInfo["packageAddonID"] = $packageAddonInfo["packageAddonID"];
			$packageInfo["packagePrice"] = $packageAddonInfo["packageAddonPrice"];
			$packageInfo["packageOriginalPrice"] = $packageAddonInfo["packageAddonOriginalPrice"];
			$packageInfo["packageSetup"] = $packageAddonInfo["packageAddonSetup"];
			$packageInfo["taxZoneGroupID"] = (int)$packageAddonInfo["taxZoneGroupID"];
		}

		$volumnDiscountAmount = (isset($this->clientInfo["clientDiscountLevel"]) && $this->clientInfo["clientDiscountLevel"][0]>$this->clientAttributes["minimumdiscount"])
			? (float)$this->clientInfo["clientDiscountLevel"]
			: (float)$this->clientAttributes["minimumdiscount"];
		dbg("volumn discount amt: ".$volumnDiscountAmount, 0, 1);
		$cycleBasedDiscount = 0;
		if ((int)$packageInfo["cycleDiscountGroupID"]){
			foreach ((array)$this->cycleDiscountsCache[$packageInfo["cycleDiscountGroupID"]][$packageInfo["cycleID"]] as $cDisc){
				$cycleBasedDiscount += $cDisc["cycleDiscountAmount"];
			}
		}
		
		$packageInfo["packageDiscount"] = ($packageInfo["packageDiscount"]>$volumnDiscountAmount+$cycleBasedDiscount)?$packageInfo["packageDiscount"]:$volumnDiscountAmount+$cycleBasedDiscount;
		
		if (isset($this->clientAttributes["maximumdiscount"])){
			if ($packageInfo["packageDiscount"]>(float)$this->clientAttributes["maximumdiscount"]){
				$packageInfo["packageDiscount"] = (float)$this->clientAttributes["maximumdiscount"];
			}
		} else {
			if ($packageInfo["packageDiscount"]>DEFAULT_MAXIMUM_DISCOUNT){
				$packageInfo["packageDiscount"] = DEFAULT_MAXIMUM_DISCOUNT;
			}
		}
		$thisPackageDiscount = (!(int)$packageInfo["packageDiscountable"])?0:doubleval($packageInfo["packageDiscount"])/100;
		
		dbg("total discount: ".$thisPackageDiscount, 0, 1);
		
		$thisPackageAmount = ($packageInfo["couponNumCycles"]>0)?$packageInfo["couponPrice"]:$packageInfo["packagePrice"];
		$thisPackageDiscountAmount -= ($thisPackageAmount*$thisPackageDiscount);
		
		$currentTaxZones = $this->getApplicableTaxZones($packageInfo["taxZoneGroupID"]);
		dbg("got applicable tax zones:");
		dbg($currentTaxZones);

		if (!(int)$this->clientInfo["applyTax"]){
			dbg("I DONT THINK I SHOULD APPLY TAX!");
			$currentTaxZones = null;
			$currentTaxZones = array();
		}
		
		$taxReturn = $this->calculateTaxes($thisPackageAmount-$thisPackageDiscountAmount, $currentTaxZones);
		$thisPackageTaxAmount = $taxReturn["amount"];
		
		$additionalCyclesAmount = 0;
		$additionalCycleAmounts = array();
		if ((int)$additionalCycles){
			$couponNumCycles = $packageInfo["couponNumCycles"]--;
			for ($i=0; $i<$additionalCycles; $i++){
				$thisPrice = (--$couponNumCycles<0)?$packageInfo["packagePrice"]:$packageInfo["couponPrice"];
				$thisPrice -= ($thisPackageDiscount*$thisPrice);
				$thisTaxReturn = $this->calculateTaxes($thisPrice, $currentTaxZones);
				$thisPrice += $thisTaxReturn["amount"];
				$additionalCycleAmounts[] = round($thisPrice, 2);
				$additionalCyclesAmount += round($thisPrice, 2);
			}
		}
		
		
		return array(
			"totalAmount" => round($thisPackageAmount, 2),
			"discount" => $thisPackageDiscount,
			"taxes" => $thisPackageTaxAmount,
			"amount" => $thisPackageAmount,
			"discountAmount" => $thisPackageDiscountAmount,
			"taxZones" => $taxReturn["zones"],
			"additionalCyclesAmount" => $additionalCyclesAmount,
			"additionalCycleAmounts" => $additionalCycleAmounts,
			"taxZoneGroupID" => $packageInfo["taxZoneGroupID"],
		);
	}

	function populateClientInfo($clientID){
		dbg("getting client info for id: ".$clientID);
		if (!(int)$clientID) return dbg("BAD CLIENT ID").dbg(debug_backtrace());
		if (!$this->clientInfo){
			$this->clientInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetClients",
					"params" => array(
						"clientID" => $clientID,
						"mergeDefaultBillingAccount" => 1,
						"getContactData" => 1,
						"getCompanyData" => 1,
						"getAttributeData" => 1,
						"hooks" => array(
							"hook" => array(
								"hookFunctionName" => "calculateResellerVolumnDiscount",
							),
						),
					),
				),
			)));
			$attributes = array();
			if (isset($this->clientInfo["groupAttributes"]) && isset($this->clientInfo["groupAttributes"][0]) && isset($this->clientInfo["groupAttributes"][0]["groupAttribute"])){
				$groupAttributes = correctArray($this->clientInfo["groupAttributes"][0]["groupAttribute"]);
				foreach ($groupAttributes as $groupAttribute){
					if ((int)$groupAttribute["groupAttributeActive"]){
						$attributes[$groupAttribute["groupAttributeName"]] = $groupAttribute["groupAttributeValue"];
					}
				}
			}
			dbg("client attributes based on group:");
			dbg($attributes);
			if (isset($this->clientInfo["attributes"]) && isset($this->clientInfo["attributes"][0]) && isset($this->clientInfo["attributes"][0]["attribute"])){
				$clientAttributes = correctArray($this->clientInfo["attributes"][0]["attribute"]);
				foreach ($clientAttributes as $clientAttribute){
					$attributes[$clientAttribute["attributeName"]] = $clientAttribute["clientAttributeValue"];
				}
			}
			dbg("client attributes after manual overrides:", 0, 1);
			dbg($attributes, 0, 1);
			$this->clientAttributes = $attributes;
		}
	}


	/**
	 * generates the cycle discount cache
	 *
	 * @return	nothing
	 */
	function generateCycleDiscountGroupCache(){
		global $CONF;
		dbg("getting cycle discount group data");
		$cycleDiscountData = arrayFor("cycleDiscountGroups", array(
			"cycleDiscounts" => "",
		));
		dbg("cycle discount groups with discounts");
		dbg($cycleDiscountData);
		
		$this->cycleDiscountsCache = array();
		foreach ((array)$cycleDiscountData as $discountGroup){
			if (isset($discountGroup["cycleDiscounts"])){
				foreach ((array)$discountGroup["cycleDiscounts"] as $discount){
					$this->cycleDiscountsCache[$discount["cycleDiscountGroupID"]][$discount["cycleID"]][] = $discount;
				}
			}
		}
	}
	
	/**
	 * Calculates the taxes for this invoice amount
	 *
	 * @param amount	the amount to get taxes on
	 * @param taxzones  the array of tax zones to use to calculate taxes with
	 * @return the tax amount
	 */
	function calculateTaxes($amount, $taxZones) {
		dbg("calculating taxes for amount: ".$amount);
		dbg("with tax zones:");
		dbg($taxZones);
		$ret = array();

		$tax = 0;
		for ($i = 0; $i < count($taxZones); $i++){
			$taxZone =& $taxZones[$i];
			$ret[$i]["taxZoneID"] = $taxZone["taxZoneID"];
			$ret[$i]["countriesISO2"] = $taxZone["countriesISO2"];
			$ret[$i]["taxZoneName"] = $taxZone["taxZoneName"];
			$ret[$i]["taxZoneAmountType"] = $taxZone["taxZoneAmountType"];
			$ret[$i]["taxZoneAmount"] = $taxZone["taxZoneAmount"];
			$ret[$i]["taxZoneDescription"] = $taxZone["taxZoneDescription"];
			$ret[$i]["ledgerAccountID"] = $taxZone["ledgerAccountID"];
			$ret[$i]["taxZoneActive"] = $taxZone["taxZoneActive"];

			if ($taxZone["taxZoneAmountType"]==0){ // if 0 we use as percentage
				dbg("calculating tax on $amount using percentage ".$taxZone["taxZoneAmount"]."");
				$cTax = $this->getLocalAmount($amount*($taxZone["taxZoneAmount"]/100));
				dbg("tax was $cTax");
				$ret[$i]["amount"] = $cTax;
				$tax = $this->getLocalAmount($tax+$cTax);
			} else { // else  we use as set amount
				dbg("calculating tax on $amount using set amount ".$taxZone["taxZoneAmount"]."");
				$cTax = $this->getLocalAmount($taxZone["taxZoneAmount"]);
				$ret[$i]["amount"] = $cTax;
				$tax = $this->getLocalAmount($tax+$cTax);
			}
		}
		dbg("amount is: ".$tax);
		return array("amount"=>$tax, "zones"=>$ret);
	}

	/**
	 * generates the tax zone cache from db calls
	 *
	 * @return	nothing
	 */
	function generateTaxZoneCache(){
	
		dbg("generating the tax zone cache");
	
		$taxData = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetTaxZoneGroups",
				"params" => array(
					"getTaxZoneData" => 1,
				),
			),
		)));
	
		dbg("tax data array:");
		dbg($taxData);
		
		$this->taxZoneGroupCache = array();
		foreach ((array)$taxData as $row){
			$this->taxZoneGroupCache[$row["taxZoneGroupID"]] = $row;
		}

		dbg("tax zone groups:");
		dbg($this->taxZoneGroupCache);

	}


	/**
	 * gets an array of tax zones that apply to this package based on the group id and client info
	 *
	 * @param taxZoneGroupID	The group id of the tax zone group we want to test the zones for.
	 * @param clientInfo	An array return from GetClients mbapi command we use to test country and
	 *						other things for tax application.
	 */
	function getApplicableTaxZones($taxZoneGroupID){
		dbg("getting applicable tax zones for group: ".$taxZoneGroupID);
		if (!$this->taxZoneGroupCache)$this->generateTaxZoneCache();
	
		$clientInfo = $this->clientInfo;
		dbg("tax zone group id: ".$taxZoneGroupID);
		if (!(int)$taxZoneGroupID)return array(); // 0 group id

		$applicableTaxes = $this->taxZoneGroupCache[(int)$taxZoneGroupID]["taxZones"];

		dbg("applicable tax zoneS: ");
		dbg($applicableTaxes);

		if (!count($applicableTaxes))return array(); // no zones

		dbg("client info we were passed:");
		dbg($clientInfo);

		$match1 = $clientInfo["contacts"][0]["contactState"];
		$match2 = $clientInfo["contacts"][0]["contactState"]."-".strtolower($clientInfo["contacts"][0]["contactCity"]);

		dbg("match 1 and 2");
		dbg($match1);
		dbg($match2);

		foreach ($applicableTaxes as $k=>$v){
			if ((int)$v["taxZoneID"]){
		 		dbg("TAX COUNTRY TESTING: ".$v["countriesISO2"]." | ".$clientInfo["countriesISO2"]);
				if ($v["countries_iso_2"]==$clientInfo["countriesISO2"][0]){
					if ((ereg_replace("[[:space:]]", "", $v["taxZoneName"])=="*" || // if its a star apply it
						ereg_replace("[[:space:]]", "", $v["taxZoneName"])=="" || // if its nothing apply it
						strtolower(ereg_replace("[[:space:]]", "", $v["taxZoneName"]))==strtolower($match1) || // if it matches match1 (state) apply it
						strtolower(ereg_replace("[[:space:]]", "", $v["taxZoneName"]))==strtolower($match2))){ // if it matches match2 (state-city) apply it
						// if we get here we will apply the tax
					} else { // dont apply it
						unset($applicableTaxes[$k]);
					}
				} else {
					unset($applicableTaxes[$k]);
				}
			} else {
				unset($applicableTaxes[$k]);
			}
		}

		return $applicableTaxes;
	}

	function getProductAttributesByName($productInfo, $serverGroupMap){
		$attributes = (array)$productInfo["productAttributes"];
		$ret = array();
		foreach ($attributes as $row){
			unset($row["productAttributeID"]);
			$row["packageAttributeName"] = $row["productAttributeName"];
			unset($row["productAttributeName"]);
			$row["packageAttributeValue"] = $row["productAttributeValue"];
			unset($row["productAttributeValue"]);
			$row["packageAttributeDateCreated"] = $row["productAttributeDateCreated"];
			unset($row["productAttributeDateCreated"]);
			$row["configGroupID"] = $serverGroupMap[$row["serverGroupID"]]; // add in the correct config group id
			$ret[$row["packageAttributeName"]] = $row;
		}
		return $ret;
	}

	function getPackageAttributesByName($packageInfo){
		$attributes = (array)$packageInfo["packageAttributes"];
		$ret = array();
		foreach ($attributes as $row){
			$ret[$row["packageAttributeName"]] = $row;
		}
		return $ret;
	}



} // UpgradePackageResponse
?>