<?php
// $Id: AddPaymentGroup.php 10720 2007-02-21 17:34:44Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

/**
 * This Action object collects information on a paymentgroup so that that paymentgroup may be added to the 
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddPaymentGroup extends MB_Action {
	/**
	 * The constructor for a AddPaymentGroup action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddPaymentGroup() {
		parent::MB_Action();
		$this->stringRep = "AddPaymentGroup";
	}

	/**
	 * The main method of this class that executes the AddPaymentGroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		//Get list of files in modules/gateway to build gateway list
		$gatewaydir = mb_path("/lib-mbapi/include/modules/gateway/");
		$gways = getMatchingFilesInDir($gatewaydir, "^[^.][^#].*[.]php\$");
		sort($gways);
		foreach ($gways as $gatewayFile) {
			$gatewayFile = substr($gatewayFile, 0, -4);
			if ($gatewayFile=="gateway") continue;
			require_once $gatewaydir.$gatewayFile.".php";
			$moduleInfo = call_user_func(array($gatewayFile,"getModuleInfo"));
			if ($moduleInfo["gatewaytype"] == 1) {
				$smartyVars["primaryGateways"][$gatewayFile] = $moduleInfo["displayName"];
			} else {
				$smartyVars["secondaryGateways"][$gatewayFile] = $moduleInfo["displayName"];
			}
		}
		
		$this->addTemplate("modules/AddPaymentGroup", $smartyVars, 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddPaymentGroup
?>
