<?php
// $Id: EditPaymentGroup.php 12802 2008-03-24 15:29:35Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

/**
 * This Action object collects information on a paymentgroup so that that the paymentgroup may be modified in the
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditPaymentGroup extends MB_Action {
	/**
	 * The constructor for a EditPaymentgroup action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditPaymentgroup() {
		parent::MB_Action();
		$this->stringRep = "EditPaymentGroup";
		$this->params = array("paymentGroupID");
		
	}

	/**
	 * The main method of this class that executes the EditPaymentgroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		static $secondaryGateways = array("paypal.php", "worldpay.php");

		$paymentgroupID = ((int) $_REQUEST["paymentGroupID"]);
		if(!$paymentgroupID) {
			$this->addError(TRANS_ACTIONERROR, "No Payment Group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetPaymentGroups");
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				
				$smartyVars["paymentgroup"] =& $data["mbapi"][0]["results"][0]["paymentGroups"][0]["paymentGroup"][0];
		
				if (is_array($smartyVars["paymentgroup"]["gateways"][0]["gateway"])){
					$smartyVars["paymentgroup"]["gateways"] = $smartyVars["paymentgroup"]["gateways"][0]["gateway"];
				}else{
					unset($smartyVars["paymentgroup"]["gateways"]);
				}
				
				if(is_array($smartyVars["paymentgroup"]["gateways"][0]["configGroupID"])) {
					$smartyVars["paymentgroup"]["gateways"] = array($smartyVars["paymentgroup"]["gateways"]);
				}
				
				$smartyVars["paymentgroup"] = collapseArrayElements($smartyVars["paymentgroup"]);
				$smartyVars["gatewayCount"] = count($smartyVars["paymentgroup"]["gateways"]);

				//Get list of files in modules/gateway to build gateway list
				$gatewaydir = mb_path("/lib-mbapi/include/modules/gateway/");
				$dh  = opendir($gatewaydir);
				while (false !== ($filename = readdir($dh))) {
				   if (is_file($gatewaydir.$filename) && substr($filename, -4)==".php" && !eregi("\.#", $filename)  && !eregi("gateway\.php", $filename)) {
					   $gways[] = $filename;
				   }
				}
				sort($gways);
				
				foreach ($gways as $gatewayFile) {
					$gatewayFile = substr($gatewayFile, 0, -4);
					
					require_once mb_path("/lib-mbapi/include/modules/gateway/".$gatewayFile.".php");
					$moduleInfo = call_user_func(array($gatewayFile,"getModuleInfo"));
					
					if ($moduleInfo["gatewaytype"] == 1) {
						$smartyVars["primaryGateways"][$gatewayFile] = $moduleInfo["displayName"]." (".constant($moduleInfo["status"]).")";
					} else {
						$smartyVars["secondaryGateways"][$gatewayFile] = $moduleInfo["displayName"]." (".constant($moduleInfo["status"]).")";
					}
					
				}
				

				$this->addTemplate("modules/EditPaymentGroup", $smartyVars, 1);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPaymentgroup
?>