<?php
// $Id: ShowPaymentGroups.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentGroups that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowPaymentGroups extends MB_Action {
	/**
	 * The constructor for a ShowPaymentGroups action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowPaymentGroups() {
		parent::MB_Action();
		$this->stringRep = "ShowPaymentGroups";
		
		$this->params = array(
			"paymentGroupID",
			"paymentGroupName",
			"paymentGroupCurrencyID");
		$this->sortColumns = array("paymentGroupID", "paymentGroupName", "paymentGroupCurrencyID");
	}

	/**
	 * The main method of this class that executes the ShowPaymentGroups action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

		$query = $this->getMBAPIQuery("GetPaymentGroups", "", array(), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["paymentgroups"] = collapseArrayElements($results["paymentGroups"][0]["paymentGroup"]);
			if ($this->smartyVars["paymentgroups"]["paymentGroupID"]) {
				$this->smartyVars["paymentgroups"] = array($this->smartyVars["paymentgroups"]);
			}
			$this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);

            if (is_array($this->smartyVars["paymentgroups"])){
    			foreach ($this->smartyVars["paymentgroups"] as $i => $v) {
    				$this->smartyVars["paymentgroups"][$i]["gateways"] = $this->smartyVars["paymentgroups"][$i]["gateways"]["gateway"];
    				if($this->smartyVars["paymentgroups"][$i]["gateways"]["configGroupID"]) {
    					$this->smartyVars["paymentgroups"][$i]["gateways"] = array($this->smartyVars["paymentgroups"][$i]["gateways"]);
    				}
    				$this->smartyVars["gatewayCount"][$i] = count($this->smartyVars["paymentgroups"][$i]["gateways"]);
    			}
            }

			$this->addTemplate("modules/ShowPaymentGroups", $this->smartyVars, 1);
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowPaymentGroups
?>