<?php
// $Id: CheckRunPaymentQueue.php 9505 2006-10-13 00:57:52Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object to get the data from the MBAPI about what is going on with
 * the payment queue and display it.  Whether that is that it is running right now
 * or that it isn't.
 *
 * @author  Kris Bailey
 */
class CheckRunPaymentQueue extends MB_Action {
	/**
	 * The constructor for a RunPaymentQueue action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function CheckRunPaymentQueue() {
		parent::MB_Action();
		$this->stringRep = "CheckRunPaymentQueue";

	}

	/**
	 * The main method of this class that executes the RunPaymentQueue action which basically just displays a template
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		//set_time_limit(0);

		$stime = time();

		$barW = 450;
		$mBarW = 100;
		$this->smartyVars["barWidth"] = $barW;
		$this->smartyVars["miniBarWidth"] = $mBarW;
		$timestamp = $CONF["system"]["internal"]["paymentQueueRuntime"];
		if (!(int)$timestamp){
			$timestamp = (int) $_REQUEST["queueRunTime"];
		}
		if (!(int)$timestamp){
			$timestamp = mktime();
		}


		$configGroupsXML = "
			<mbapi>
				<command>GetConfigGroups</command>
				<showXMLHeader>0</showXMLHeader>
				<params>
				</params>
			</mbapi>
		";
		$configGroupsResult = dispatchMBAPI($configGroupsXML, 1);

		$gatewayInfo = array();

		if (isset($configGroupsResult["mbapi"][0]["results"][0]["configGroups"][0])){
			foreach ($configGroupsResult["mbapi"][0]["results"][0]["configGroups"][0]["configGroup"] as $row){
				$gatewayInfo[$row["configGroupID"][0]] = collapseArrayElements($row);
			}
		}


		// getting uncharged queue items
		$queueItemsXML = "
			<mbapi>
				<command>GetPaymentQueueTotals</command>
				<showXMLHeader></showXMLHeader>
				<params>
				</params>
			</mbapi>
		";

		$queueItems = dispatchMBAPI($queueItemsXML, 1);

		// getting charged queue items' transactions
		$transactionItemsXML = "
			<mbapi>
				<command>GetTransactions</command>
				<params>
					<transactionDateCreatedGreaterThan>$timestamp</transactionDateCreatedGreaterThan>
					<getInvoiceIDs>1</getInvoiceIDs>
				</params>
			</mbapi>
		";
		$transactionItems = dispatchMBAPI($transactionItemsXML, 1);

		$leftPaymentQueueData = correctArray(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetPaymentQueueStats"
			),
		)), 1));
		$leftPaymentQueueData = $leftPaymentQueueData["mbapi"][0]["results"][0];
		$numLeft = $leftPaymentQueueData["numLeft"];

		$this->smartyVars["errorStatusID"] = getAPIStatusID("invoice", "errored");

		$this->smartyVars["totalCharges"] = $CONF["system"]["internal"]["paymentQueueInvoices"];
		$this->smartyVars["totalChargesAmount"] = $CONF["system"]["internal"]["paymentQueueAmount"];

		$numDone = $this->smartyVars["totalCharges"]-$numLeft;

		$this->smartyVars["unaccountedInvoices"] = $this->smartyVars["totalCharges"]-$queueItems["mbapi"][0]["results"][0]["paymentQueueNumInvoices"][0];
		$this->smartyVars["unaccountedAmount"] = $this->smartyVars["totalChargesAmount"]-$queueItems["mbapi"][0]["results"][0]["paymentQueueTotalAmount"][0];

		if ((int)$CONF["system"]["internal"]["paymentQueueInvoices"]<1){
			$this->smartyVars["noConfigData"] = "true";
		}
		$this->smartyVars["totalDeclines"] = array();
		$this->smartyVars["totalDeclinesAmount"] = 0;
		$this->smartyVars["totalAutofails"] = array();
		$this->smartyVars["totalAutofailsAmount"] = 0;
		$this->smartyVars["totalSuccesses"] = array();
		$this->smartyVars["totalSuccessesAmount"] = 0;
		$this->smartyVars["totalErrors"] = array();
		$this->smartyVars["totalErrorsAmount"] = 0;

		$this->smartyVars["tempCurrenciesData"] = array();



		if ( $transactionItems["mbapi"][0]["results"] && $transactionItems["mbapi"][0]["results"][0]["transactions"] && $transactionItems["mbapi"][0]["results"][0]["transactions"][0]["transaction"] && $transactionItems["mbapi"][0]["results"][0]["transactions"][0]["transaction"][0]["transactionID"][0] > 0){
			$this->smartyVars["hadTransactions"] = true;
			foreach ($transactionItems["mbapi"][0]["results"][0]["transactions"][0]["transaction"] as $transaction){
				$this->smartyVars["doneCharges"][$transaction["invoiceID"][0]]++;
				$this->smartyVars["doneChargesAmount"] += $transaction["transactionAmount"][0];
				switch ($transaction["authReturn"][0]){
					case 1: // GATEWAY_SUCCESS
					case 40: // GATEWAY_SUCCESS - auth
					case 41: // GATEWAY_SUCCESS - finalized
						$this->smartyVars["totalSuccesses"][$transaction["invoiceID"][0]]++;
						$this->smartyVars["totalSuccessesAmount"] += $transaction["transactionAmount"][0];
						$this->smartyVars["unaccountedAmount"] -= $transaction["transactionAmount"][0];
						$this->smartyVars["tempCurrenciesData"][$transaction["currencyID"][0]."-".$transaction["configGroupID"][0]] += $transaction["transactionAmount"][0];
					break;

					case 2: // GATEWAY_DECLINED
					case 42:
						$this->smartyVars["totalDeclines"][$transaction["invoiceID"][0]]++;
						$this->smartyVars["totalDeclinesAmount"] += $transaction["transactionAmount"][0];
						$this->smartyVars["unaccountedAmount"] -= $transaction["transactionAmount"][0];
					break;

					case 100: // Auto-failed transaction
						$this->smartyVars["totalAutofails"][$transaction["invoiceID"][0]]++;
						$this->smartyVars["totalAutofailsAmount"] += $transaction["transactionAmount"][0];
						$this->smartyVars["unaccountedAmount"] -= $transaction["transactionAmount"][0];
					break;

					case 3: // GATEWAY_FAILURE
					case 4:
					case 5:
					default:
						$this->smartyVars["totalErrors"][$transaction["invoiceID"][0]]++;
						$this->smartyVars["totalErrorsAmount"] += $transaction["transactionAmount"][0];
						$this->smartyVars["unaccountedAmount"] -= $transaction["transactionAmount"][0];
					break;
				}
			}
		}


		unset($this->smartyVars["totalDeclines"][0]);
		unset($this->smartyVars["totalAutofails"][0]);
		unset($this->smartyVars["totalSuccesses"][0]);
		unset($this->smartyVars["totalErrors"][0]);

		$this->smartyVars["totalDeclines"] = count($this->smartyVars["totalDeclines"]);
		$this->smartyVars["totalAutofails"] = count($this->smartyVars["totalAutofails"]);
		$this->smartyVars["totalSuccesses"] = count($this->smartyVars["totalSuccesses"]);
		$this->smartyVars["totalErrors"] = count($this->smartyVars["totalErrors"]);

		// make the amounts for the unaccounted for things.  will fix when gateways are working right.
		$this->smartyVars["unaccountedInvoices"] -= ($this->smartyVars["totalDeclines"]+$this->smartyVars["totalSuccesses"]+$this->smartyVars["totalErrors"]);
		if ($this->smartyVars["unaccountedInvoices"]>0){
			//$this->smartyVars["totalErrors"] += $this->smartyVars["unaccountedInvoices"];
		}

		if ($this->smartyVars["unaccountedAmount"]>0){
			//$this->smartyVars["totalErrorsAmount"] += $this->smartyVars["unaccountedAmount"];
		}

		$this->smartyVars["doneCharges"] = count($this->smartyVars["doneCharges"]);


		if ($this->smartyVars["totalCharges"]==0){
			$this->smartyVars["totalCharges"]++;
		}
		if ($this->smartyVars["totalChargesAmount"]==0){
			$this->smartyVars["totalChargesAmount"] = 1;
		}

		$this->smartyVars["currenciesData"] = array();
		foreach ($this->smartyVars["tempCurrenciesData"] as $args => $amt){
			$mbw = floor(($amt/$this->smartyVars["totalChargesAmount"])*100);
			$cid = @substr($args, 0, strpos($args, "-"));
			$gwID = @substr($args, strpos($args, "-")+1);
			$gatewayName = $gatewayInfo[$gwID]["configGroupTransKey"];
			$this->smartyVars["currenciesData"][] = array('gatewayName'=>$gatewayName, 'currencyID'=>$cid, 'amount'=>$amt, 'barWidth'=>$mbw);
		}

/**************************** percentage creations ********************************/

		$batch = ($this->smartyVars["doneCharges"]/$this->smartyVars["totalCharges"]);
		$this->smartyVars["batchBarWidth"] = floor($batch*$barW);
		$this->smartyVars["batchLeftPercentage"] = round($batch*100, 1)."%"; //($this->smartyVars["batchBarWidth"]>20)?round($batch*100)."%":"";
		//$this->smartyVars["batchRightPercentage"] = ($this->smartyVars["batchBarWidth"]<20)?round($batch*100)."%":"";

		$batchDollar = ($this->smartyVars["doneChargesAmount"]/$this->smartyVars["totalChargesAmount"]);
		$this->smartyVars["batchDollarBarWidth"] = floor($batchDollar*$barW);
		$this->smartyVars["batchDollarLeftPercentage"] = round($batchDollar*100, 1)."%"; //($this->smartyVars["batchDollarBarWidth"]>20)?round($batchDollar*100)."%":"";
		//$this->smartyVars["batchDollarRightPercentage"] = ($this->smartyVars["batchDollarBarWidth"]<20)?round($batchDollar*100)."%":"";



		$success = ($this->smartyVars["totalSuccesses"]/$this->smartyVars["totalCharges"]);
		$this->smartyVars["successBarWidth"] = floor($success*$barW);
		$this->smartyVars["successLeftPercentage"] = round($success*100, 1)."%"; //($this->smartyVars["successBarWidth"]>20)?round($success*100)."%":"";
		//$this->smartyVars["successRightPercentage"] = ($this->smartyVars["successBarWidth"]<20)?round($success*100)."%":"";

		$successDollar = ($this->smartyVars["totalSuccessesAmount"]/$this->smartyVars["totalChargesAmount"]);
		$this->smartyVars["successDollarBarWidth"] = floor($successDollar*$barW);
		$this->smartyVars["successDollarLeftPercentage"] = round($successDollar*100, 1)."%"; //($this->smartyVars["successDollarBarWidth"]>20)?round($successDollar*100)."%":"";
		//$this->smartyVars["successDollarRightPercentage"] = ($this->smartyVars["successDollarBarWidth"]<20)?round($successDollar*100)."%":"";




		$decline = ($this->smartyVars["totalDeclines"]/$this->smartyVars["totalCharges"]);
		$this->smartyVars["declinedBarWidth"] = floor($decline*$barW);
		$this->smartyVars["declinedLeftPercentage"] = round($decline*100,1)."%"; //($this->smartyVars["declinedBarWidth"]>20)?round($decline*100)."%":"";
		//$this->smartyVars["declinedRightPercentage"] = ($this->smartyVars["declinedBarWidth"]<20)?round($decline*100)."%":"";

		$declineDollar = ($this->smartyVars["totalDeclinesAmount"]/$this->smartyVars["totalChargesAmount"]);
		$this->smartyVars["declinedDollarBarWidth"] = floor($declineDollar*$barW);
		$this->smartyVars["declinedDollarLeftPercentage"] = round($declineDollar*100,1)."%"; //($this->smartyVars["declinedDollarBarWidth"]>20)?round($declineDollar*100)."%":"";
		//$this->smartyVars["declinedDollarRightPercentage"] = ($this->smartyVars["declinedDollarBarWidth"]<20)?round($declineDollar*100)."%":"";



		$autofail = ($this->smartyVars["totalAutofails"]/$this->smartyVars["totalCharges"]);
		$this->smartyVars["autofailedBarWidth"] = floor($autofail*$barW);
		$this->smartyVars["autofailedLeftPercentage"] = round($autofail*100, 1)."%"; //($this->smartyVars["autofailedBarWidth"]>20)?round($autofail*100)."%":"";
		//$this->smartyVars["declinedRightPercentage"] = ($this->smartyVars["declinedBarWidth"]<20)?round($decline*100)."%":"";

		$autofailDollar = ($this->smartyVars["totalAutofailsAmount"]/$this->smartyVars["totalChargesAmount"]);
		$this->smartyVars["autofailedDollarBarWidth"] = floor($autofailDollar*$barW);
		$this->smartyVars["autofailedDollarLeftPercentage"] = round($autofailDollar*100, 1)."%"; //($this->smartyVars["autofailedDollarBarWidth"]>20)?round($autofailDollar*100)."%":"";
		//$this->smartyVars["declinedDollarRightPercentage"] = ($this->smartyVars["declinedDollarBarWidth"]<20)?round($declineDollar*100)."%":"";



		$error = ($this->smartyVars["totalErrors"]/$this->smartyVars["totalCharges"]);
		$this->smartyVars["erroredBarWidth"] = floor($error*$barW);
		$this->smartyVars["erroredLeftPercentage"] = round($error*100, 1)."%"; //($this->smartyVars["erroredBarWidth"]>20)?round($error*100)."%":"";
		//$this->smartyVars["erroredRightPercentage"] = ($this->smartyVars["erroredBarWidth"]<20)?round($error*100)."%":"";

		$errorDollar = ($this->smartyVars["totalErrorsAmount"]/$this->smartyVars["totalChargesAmount"]);
		$this->smartyVars["erroredDollarBarWidth"] = floor($errorDollar*$barW);
		$this->smartyVars["erroredDollarLeftPercentage"] = round($errorDollar*100, 1)."%"; //($this->smartyVars["erroredDollarBarWidth"]>20)?round($errorDollar*100)."%":"";
		//$this->smartyVars["erroredDollarRightPercentage"] = ($this->smartyVars["erroredDollarBarWidth"]<20)?round($errorDollar*100)."%":"";


/**************************** end *************************************************/

		$this->smartyVars["stop"] = ($this->smartyVars["doneCharges"]==$this->smartyVars["totalCharges"])?'yes':'no';

		$this->addTemplate("paymentqueue/CheckRunPaymentQueue", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RunPaymentQueue
?>