<?php
// $Id: ReplayCallbackLogResponse.php 10177 2006-12-01 00:34:30Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 *
 * @author  Kris Bailey
 */
class ReplayCallbackLogResponse extends MB_Action {
	/**
	 * The constructor for a ReplayCallbackLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ReplayCallbackLogResponse() {
		parent::MB_Action();
		$this->stringRep = "ReplayCallbackLogResponse";
	}

	/**
	 * The main method of this class that executes the ReplayCallbackLogResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$callbackLogID = (int)$_REQUEST["callbackLogID"];
		if (!$callbackLogID){
			$this->addError("TRANS_ACTIONERROR", "Invalid callback log id passed.");
		} else {
		
			$callbackLogInfo = oneByID("callbackLogs", $callbackLogID);
		
			$createClientRecord = ($_REQUEST["replayAction"]=="create")?1:0;
			$overrideClientID = ($_REQUEST["replayAction"]=="use")?(int)$_REQUEST["clientID"]:0;
		
			$replayResult = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "ProcessCallbackReplay",
					"params" => array(
						"callbackLogID" => $callbackLogID,
						"gatewayName" => getAPITypeName("callbackLog", $callbackLogInfo["callbackLogType"]),
						"createClientRecord" => $createClientRecord,
						"overrideClientID" => $overrideClientID,
					),
				),
			)));
			
			// have to get the info again in case the client id got updated to forward to the right place
			$callbackLogInfo = oneByID("callbackLogs", $callbackLogID);
		
			if ((int)$callbackLogInfo["clientID"]){
				redirect("clients.php", "ShowClientDetails", array(
					"clientID" => $callbackLogInfo["clientID"],
				));
			} else {
				redirect("paymentqueue.php", "ShowCallbackLog");
			}
		
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ReplayCallbackLogResponse
?>