<?php
// $Id: RunPaymentQueueResponse.php 9819 2006-10-25 20:45:05Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
* This Action object displays the run payment queue page with the status iframe in it
*
* @author  Kris Bailey
*/
class RunPaymentQueueResponse extends MB_Action {
	/**
	* The constructor for a RunPaymentQueue action object. This merely calls the parent constructor,
	* and sets the string representation of this object.
	*/
	function RunPaymentQueueResponse() {
		parent::MB_Action();
		$this->stringRep = "RunPaymentQueue";

	}

	/**
	* The main method of this class that executes the RunPaymentQueue action which basically just displays a template
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars["hideEventStatusBar"] = 1;
		$this->smartyVars["queueRunTime"] = time();
		
		$queueStats = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetPaymentQueueStats",
			),
		)), 1);
		$numLeft = $queueStats["mbapi"][0]["results"][0]["numLeft"][0];

		if (checkdate($_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]) && (int) $_REQUEST["runWhen"]==2) {
			if (intval($_REQUEST["laterDateHour"]) <= 23) {
				$laterDateHour = (int) $_REQUEST["laterDateHour"];
			} else {
				$laterDateHour = date("h");
			}
			if (intval($_REQUEST["laterDateMinute"]) <= 59) {
				$laterDateMinute = (int) $_REQUEST["laterDateMinute"];
			} else {
				$laterDateMinute = date("i");
			}
			$laterDate = mktime($laterDateHour,$laterDateMinute,0,$_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]);
		} else {
			$laterDate = mktime()-300;
		}

		$timeData = explode(";", date("i;G;j;n;Y", $laterDate));

		if ($_REQUEST["encryptionKey"]){
			$results = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "GetEncryptedText",
					"params" => array(
						"text" => stripslashes($_REQUEST["encryptionKey"]),
					),
				),
			)), 1);
			$_REQUEST["encryptionKey"] = ($results["mbapi"] && $results["mbapi"][0] && $results["mbapi"][0]["results"] && $results["mbapi"][0]["results"][0] && $results["mbapi"][0]["results"][0]["text"])?$results["mbapi"][0]["results"][0]["text"][0]:"";
		}

		//if ( $CONF["system"]["internal"]["systemQueueCommand"] != "ProcessPaymentQueue" || !$CONF["system"]["internal"]["systemQueueRunning"]){
		if ( (int) $_REQUEST["runWhen"] ){


			// its not running our process, so lets set the queue command and start it from the tpl or just say we set it
			$processQueueXML = "
				<mbapi>
					<command>ProcessPaymentQueue</command>
					<params>
						<manualRun>1</manualRun>
						<runPaymentQueue>1</runPaymentQueue>
						<numInvoicesToCharge>3</numInvoicesToCharge>
						<transactionAction>".secureInput($_REQUEST["transactionAction"])."</transactionAction>
						<key>".stripslashes($_REQUEST["encryptionKey"])."</key>
						<chargeLesserAmounts>".(((int)$_REQUEST["chargeLesserAmounts"]>0)?1:0)."</chargeLesserAmounts>
					</params>
				</mbapi>
				"; // run everything in the queue with a date charged of 0

/////////////////////
			$dateToRun = mktime($timeData[1], $timeData[0], 0, $timeData[3], $timeData[2], $timeData[4]);
			$cmdArgs = array
			(
				"systemQueueCommand" => "ProcessPaymentQueue",
				"systemQueueCommandInput" => htmlentities($processQueueXML),
				"systemQueueMinute" => $timeData[0],
				"systemQueueHour" => $timeData[1],
				"systemQueueDay" => $timeData[2],
				"systemQueueMonth" => $timeData[3],
				"systemQueueYear" => $timeData[4],
				"systemQueueIsRecurring" => 0,
				"systemQueueDateCreated" => time(),
				"systemQueueDateToRun" => $dateToRun,
				"systemQueueDateStarted" => 0,
				"systemQueueDateFinished" => 0
			);
			$query = $this->getMBAPIQuery("SetSystemQueue", "insert", $cmdArgs);
			//for ($i = 0; $i < $numLeft/3; $i++){
				$data = dispatchMBAPI($query, 1);
			//	if ($i==0){
					$this->smartyVars["systemQueueID"] = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
			//	}
			//}

			$this->smartyVars["runWhen"] = (int)$_REQUEST["runWhen"];
			$this->smartyVars["runDate"] = $laterDate;
/////////////////////
			$this->smartyVars["showStatus"] = "yes";

		} else { // nope we didnt
			$this->smartyVars["showStatus"] = "yes";
			// get anything from the queue
/*            $getQueueXML = "
					<mbapi>
						<command>GetSystemQueue</command>
						<params>
							<systemQueueID>".$CONF["system"]["internal"]["systemQueueID"]."</systemQueueID>
						</params>
					</mbapi>
			";
			$queueItem = dispatchMBAPI($getQueueXML, 1);
*/
			$this->smartyVars["queueRunTime"] = mktime(); //$queueItem["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"][0]["systemQueueDateToRun"][0];

		}

		$this->addTemplate("paymentqueue/RunPaymentQueueResponse", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RunPaymentQueue
?>