<?php
// $Id: ShowCallbackLog.php 10395 2006-12-29 22:06:04Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentqueue that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowCallbackLog extends MB_Action {
	/**
	 * The constructor for a ShowCallbackLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowCallbackLog() {
		parent::MB_Action();
		$this->stringRep = "ShowCallbackLog";
		$this->params = array(
			"callbackLogAction",
			"callbackLogID",
			"clientID",
			"callbackLogType",
			"callbackLogTransactionID",
			"callbackLogDateCreated",
		);
		$this->sortColumns = array("callbackLogDateCreated");
	}

	/**
	 * The main method of this class that executes the ShowCallbackLog action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$params = array(
			"callbackLogAttributes" => "",
		);

		if ((int)$_REQUEST["clientID"]){
			$this->smartyVars["paginationArgs"] = "clientID=".$params["clientID"];
		} elseif ((int)$_REQUEST["errors"]){
			$this->smartyVars["errorsOnly"] = 1;
			$params["clientID"] = 0;
			$this->smartyVars["paginationArgs"] = "errors=1";
		}


		$query = $this->getMBAPIQuery("GetCallbackLogs", "", $params, 1, 1, 1, 1);
		
		$data = dispatchMBAPI($query, 1);
		
		if ($data["mbapi"][0]["results"][0]["paginationLinks"]){
			$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
		}

		$this->smartyVars["callbackLogs"] = correctArray(grabSimpleMBAPIResults($data));
		
		if ((int)$_REQUEST["clientID"]){
			$this->smartyVars["clientInfo"] = oneByID("clients", (int)$_REQUEST["clientID"], array("mergePrimaryContact"=>1));
		} else {
			// get all tax zone as simple results
			$clientIDs = array();
			foreach ((array)$this->smartyVars["callbackLogs"] as $cbl){
				$clientIDs[$cbl["clientID"]] = 1;
			}
			$clientIDs = array_keys($clientIDs);

			$clients = arrayFor("clientWithPrimary", array("clientID"=>$clientIDs));
			// grab the selectable ones while passing the ignore ID array
			$this->smartyVars["clients"] = grabHTMLOpsFromArray($clients, "clientID", "buildClientNameFromRecord");
			$this->smartyVars["clientContactIDs"] = grabHTMLOpsFromArray($clients, "clientID", "clientContactID");
		}
		
		$this->smartyVars["callbackLogTypes"] = getTypes("callbackLog");
		$this->smartyVars["callbackLogActions"] = getTypes("callbackAction");
		$this->addTemplate("paymentqueue/ShowCallbackLog", $this->smartyVars);
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowCallbackLog

function buildClientNameFromRecord($row){
	return $row["contactFirstName"]." ".$row["contactLastName"];
}

?>