<?php
// $Id: ShowTransactionLog.php 10079 2006-11-21 17:10:17Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentqueue that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowTransactionLog extends MB_Action {
	/**
	 * The constructor for a ShowUncapturedFunds action object.
	 */
	function ShowTransactionLog() {
		parent::MB_Action();
		$this->stringRep = "ShowTransactionLog";

		$this->params = array(
			"transactionID",
			"clientID",
			"billingAccountID",
			"status");
		$this->sortColumns = array("transaction_date_created");
	}

	/**
	 * The main method of this class that executes the ShowUncapturedFunds action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		do {
			if(($status = getAPIStatusID("transactions", $_REQUEST["status"])) === false && $_REQUEST["status"] != "allErrored") {
				$this->addError(TRANS_ACTIONERROR, "Invalid transaction status");
				break;
			}
	
			if($_REQUEST["status"] == "allErrored") {
				$status = array(
					getAPIStatusID("transactions", "errored"),
					getAPIStatusID("transactions", "erroredConnection"),
					getAPIStatusID("transactions", "erroredParam"),
					getAPIStatusID("transactions", "erroredTransport"),
				);
			}
	
			if($_REQUEST["status"] == "authorized") {
				$this->smartyVars = array("invalidpoint"=>time()-(24*60*60*30));
				if ($CONF["system"]["encryption"]["lek_pin"]==''){
		 			$this->smartyVars["showPassword"] = 1;
				}

				if ($_REQUEST['failedID']){
					$this->smartyVars['failed'] = $_REQUEST['failedID'];
				}
			}

			$this->smartyVars["status"] = $_REQUEST["status"];

			$q =& new MBQuery("GetTransactions", "", $this->getRequestParams() + array("getClientNames" => 1, "getGatewayNames" => 1, "authReturn" => $status));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				if($paginationLinks = $r->getPaginationLinks()) $this->smartyVars["paginationLinks"] = $paginationLinks;
				$s =& $r->getSubjectFrom(array("mbapi", "results", "transactions", "transaction"));
				
				$columns = array_merge($this->params, $this->sortColumns);
				$queryArgs = "";
				foreach($columns as $col) {
					if(isBlank($val = $_REQUEST[$col])) continue;
					$queryArgs .= "&" . $col . "=" . $val;
				}
				$this->smartyVars["queryArgs"] = $queryArgs;
				$this->smartyVars["transactions"] = $s->getEssential();
				$this->addTemplate("paymentqueue/ShowTransactionLog");
			} else {
				$this->addError(TRANS_ACTIONERROR, lastError());
				break;
			}
		} while(0);
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowUncapturedFunds
?>
