<?php
// $Id: ShowPPCCodes.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all products that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class ShowPPCCodes extends MB_Action {
	/**
	 * The constructor for a ShowPPCCodes action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowPPCCodes() {
		parent::MB_Action();
		$this->stringRep = "ShowPPCCodes";

		$this->params = array
        (
			"codeID",
			"clientID",
			"codeToUse",
			"codeValue",
			"codeCurrencyID",
			"codeDateCreated",
			"codeDateCreatedLessThan",
			"codeDateCreatedGreaterThan",
			"codeDateExpires",
			"codeDateExpiresLessThan",
			"codeDateExpiresGreaterThan",
			"codeDateDistributed",
			"codeDateDistributedLessThan",
			"codeDateDistributedGreaterThan",
			"codeCustomerEmail",
			"codeCustomerOrderAmount",
        );

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["query"]!="") {
			// test if the searching for a specific column
			if ($_REQUEST["queryColumn"]!="") {
				$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
			} else {
				// test if query is an int, if yes, assume we are searching for the ID
				if (((int) $_REQUEST["query"])) {
					$_REQUEST["codeID"] = $_REQUEST["query"];
				} else {
					// if not an int, then search all other non-ID columns
					foreach($this->params as $value) {
						if ($value!="codeID") {
							$_REQUEST[secureInput($value)] = $_REQUEST["query"];
						}
					}
				}
			}
		}

		// add filtered columns to $this->params LAST, they are NOT searchable
		if (is_numeric($_REQUEST["codeActive"])) {
			$this->params[] = "codeActive";
		}

        // define sortable columns
		$this->sortColumns = array
        (
			"codeID"
        );

	}

	/**
	 * The main method of this class that executes the ShowPPCCodes action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetPPCCodes", "", array(), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["codes"] = ($data["mbapi"][0]["header"][0]["numResults"][0]==1) ?
				array(0=>$results["ppcCodes"][0]["ppcCode"]) : $results["ppcCodes"][0]["ppcCode"];
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			// assign filtered columns
			if (is_numeric($_REQUEST["codeActive"])) {
				$this->smartyVars["codeActive"] = ((int) $_REQUEST["codeActive"]);
			}

            $this->smartyVars = collapseArrayElements($this->smartyVars);
			$this->addTemplate("ppc/ShowPPCCodes", $this->smartyVars);

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowPPCCodes
?>