<?php
// $Id: AddProductAddonResponse.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This class is a child class of MB_ProductAction. It handles the data from AddProductAddonResponse action
 * and creates the new addons if requested.
 *
 * @author  Kris Bailey
 */
class AddProductAddonResponse extends MB_ProductAction {

	function AddProductAddonResponse() {
		parent::MB_ProductAction("children");
		$this->stringRep = "AddProductAddonResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		if (!(int)$_REQUEST["productID"]){
			$this->addError(TRANS_ACTIONERROR, "No Product ID given.");
		} else {

			$this->productInfo = correctArray(grabFirstResultFromMBAPIArray(
				array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"getProductAttributeData" => 1,
							"getProductChildData" => 1,
							"getProductVariantPriceData" => 1,
							"getEmailTemplateData" => 1,
							"getEmailActionGroupData" => 1,
							"getCouponData" => 1,
							"getOrderFormData" => 1,
							"getProductVariantData" => 1,
							"getTLDData" => 1,
							"getCycleGhostData" => 1,
							"getServerGroupGhostData" => 1
						)
					)
				)
			));


			// make sure we have a valid addons array (name, value, and prices)
			$addons = @unserialize(@base64_decode($_REQUEST["addons"]));
			if (!is_array($addons)){
				$this->addError(TRANS_ACTIONERROR, "Invalid addon data passed.");
			} else {



				// gather the other addon information
				$addonGroupID = (int)$_REQUEST["addonGroupID"];
				$attributeID = $_REQUEST["attributeID"];
				$newGroupLabel = $_REQUEST["newGroupLabel"];
				$newGroupDisplayType = $_REQUEST["newGroupDisplayType"];
				$numAddons = (int)$_REQUEST["numAddons"];

				// create the array of products to apply these addons to
				$applyTo = array((int)$_REQUEST["productID"]);
				foreach ((array)$_REQUEST["products"] as $pid){
					if ((int)$pid){
						$applyTo[] = (int)$pid;
					}
				}

				$orderForms = array();
				$cycles = array();
				$serverGroups = array();
				foreach ((array)$this->productInfo["orderForms"] as $of){
					$orderForms[] = $of["orderFormID"];
				}
				foreach ((array)$this->productInfo["ghostCycles"] as $cycle){
					$cycles[] = $cycle["cycleID"];
				}
				foreach ((array)$this->productInfo["ghostServerGroups"] as $group){
					$serverGroups[] = $group["serverGroupID"];
				}

				$info = explode("|", $_REQUEST["attributeID"]);
				$panelAttributes = $this->getAttributesForServerGroupID($info[0], NULL);

				$question =& $panelAttributes[$info[1]];
				dbg("question data:");
				dbg($question);
				
				$this->attributeInfo = array($info[1]=>array(
					"productAttributeName" => $info[1],
					"productAttributeValue" => "",
					"serverGroupID" => $info[0],
					"productAttributeDateCreated" => time(),
				));
				foreach ((array)$question["valueMap"] as $k=>$v){
					foreach ($v as $attr=>$valueMap){
						$this->attributeInfo[$attr] = array();
					}
				}

				foreach ((array)$this->productInfo["productAttributes"] as $attribute){
					if (isset($this->attributeInfo[$attribute["productAttributeName"]])){
						unset($attribute["productAttributeID"]);
						$attribute["productAttributeDateCreated"] = time();
						$this->attributeInfo[$attribute["productAttributeName"]] = $attribute;
					}
				}

				dbg("this attributes:");
				dbg($this->attributeInfo);


				// ok, now the magic, do we need to make a new addon group?
				if (!(int)$addonGroupID){ // yes
					$results = dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetProductAddonGroups",
							"subCommand" => "insert",
							"params" => array(
								"productAddonGroupName" => $newGroupLabel,
								"productAddonGroupInputType" => $newGroupDisplayType,
								"productAddonGroupActive" => 1,
								"productIDs" => array(
									"productID" => $applyTo
								)
							)
						)
					)), 1);
					
					dbg("results of group addition:");
					dbg($results);
					$addonGroupID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
				}

				if (!(int)$addonGroupID){
					$this->addError(TRANS_ACTIONERROR, "Error with addon group, invalid id. ");
				} else {

					$addSkeleton = array("mbapi" => array(
						"command" => "SetProducts",
						"subCommand" => "insert",
						"params" => array(
							"productName" => "",
							"productType" => (getAPITypeID("products", "domain")==$this->productInfo["productType"])?getAPITypeID("products", "undefined"):$this->productInfo["productType"],
							"productIsLockable" => $this->productInfo["productIsLockable"],
							"productComments" => "",
							"productStopNumCycles" => 0,
							"productActive" => 1,
							"productIsAddon" => 1,
							"productProratable" => $this->productInfo["productProratable"],
							"productDateCreated" => time(),
							"productDomainRequired" => getAPIStatusID("productdependencyrules", "cannot"),
							"productAddonRequired" => getAPIStatusID("productdependencyrules", "cannot"),
							"productIntroCycleID" => $this->productInfo["productIntroCycleID"],
							"productIntroNumCycles" => $this->productInfo["productIntroNumCycles"],
							"productCancellationType" => $this->productInfo["productCancellationType"],
							"productAddonGroupID" => $addonGroupID,
							"productAddonAttributeName" => $info[1],
							"productVariants" => array(
								"productVariant" => array(
									"productVariantActive" => 1,
									"tldID" => 0,
								)
							),
							"cycleIDs" => array(
								"cycleID" => $cycles
							),
							"orderFormIDs" => array(
								"orderFormID" => $orderForms
							),
							"serverGroupIDs" => array(
								"serverGroupID" => $serverGroups
							),
							"productAttributes" => array(
								
							),
						)
					));
					
					$addonIDs = array();
					
					foreach ($addons as $addon){
					
						if ($addon["name"]){

							$addon["value"] = unserialize(base64_decode($addon["value"]));
							
							list($key, $value) = each($addon["value"]);
							
							if (count($question["valueMap"])){
							
								dbg("values:");
								dbg($value);
								foreach ($question["valueMap"] as $id=>$map){
									list($attr, $values) = @each($map);
									$this->attributeInfo[$attr]["productAttributeValue"] = (in_array($id, $value))?$values[0]:$values[1];
								}
							
							} else {
								$this->attributeInfo[$info[1]]["productAttributeValue"] = $value;
							}
							dbg($this->attributeInfo);

							$priceArray = array();
							foreach ($addon["prices"] as $currencyID=>$price){
								foreach ($price as $cycleID=>$prices){
								
									$priceArray[] = array(
										"productVariantPriceType" => 0,
										"productVariantPriceAmount" => $this->getNumberFromInput($prices[0]),
										"cycleID" => $cycleID,
										"currencyID" => $currencyID
									);

									$priceArray[] = array(
										"productVariantPriceType" => 1,
										"productVariantPriceAmount" => $this->getNumberFromInput($prices[1]),
										"cycleID" => $cycleID,
										"currencyID" => $currencyID
									);
								
								}
							}
							

							

							$addSkeleton["mbapi"]["params"]["productVariants"]["productVariant"]["productVariantPrices"] = array("productVariantPrice"=>$priceArray);
							$addSkeleton["mbapi"]["params"]["productVariants"]["productVariant"]["productVariantName"] = $addon["name"];
							$addSkeleton["mbapi"]["params"]["productAttributes"]["productAttribute"] = array();
							foreach ($this->attributeInfo as $attr=>$ainfo){
								if (strlen($ainfo["productAttributeName"])>0){
									$addSkeleton["mbapi"]["params"]["productAttributes"]["productAttribute"][] = $ainfo;
								}
							}

							$addSkeleton["mbapi"]["params"]["productName"] = $addon["name"];
							$results = dispatchMBAPI(toXML($addSkeleton), 1);
							$addonIDs[] = $results["mbapi"][0]["header"][0]["lastInsertID"][0];



						} else {
							dbg("had an invalid addon in the bunch");
						}
					
					}

					foreach ($applyTo as $productID){
						dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "SetProducts",
								"subCommand" => "update",
								"params" => array(
									"productID" => $productID,
									"productChildrenIDs" => array(
										"productID" => $addonIDs
									)
								)
							)
						)));
					}

					
					redirect("products.php", getActionID("ShowProductAddons"), array("productID"=>(int)$_REQUEST["productID"]));
					
				}

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}

} // MB_Action $this->getNumberFromInput();
?>
