<?php
// $Id: AddProductResponse.old.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/include/wizard/Wizard.php");

/**
 * This Action object takes information provided by the AddProduct action, applies that information to  * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddProductResponse extends MB_Action {
	/**
	 * The constructor for an AddProductResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddProductResponse() {
		parent::MB_Action();
		$this->stringRep = "AddProductResponse";
		$this->params = array(
			"productName",
			"productType",
			"productComments",
			"productActive",
		);
	}

	/**
	 * The main method of this class that executes the AddProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$w =& new Wizard(intval($_REQUEST["wizardID"]), TRANS_ADD_PRODUCT, TRANS_ADD_PRODUCT_MESG);

		// extract the main data from the wizard into a prettified form
		$wizardData = $w->getData();
		$cursor = 0;
		$product = array(
			'name' =>         $wizardData[++$cursor],
			'type' =>         $wizardData[++$cursor],
			'comment' =>      $wizardData[++$cursor],
			'billingPlan' => $wizardData[++$cursor],
			'proratable' => $wizardData[++$cursor],
			'genericAttributeCount' =>	$wizardData[++$cursor],
			'signupEmailActionGroup' =>    $wizardData[++$cursor],
			'welcomeEmailActionGroup' =>   $wizardData[++$cursor],
			'children' =>     $wizardData[++$cursor],
			'addons' =>       $wizardData[++$cursor],
			'cycles' =>       $wizardData[++$cursor],
			'orderForms' =>   $wizardData[++$cursor],
			'coupons' =>      $wizardData[++$cursor],
			'serverGroups' => $wizardData[++$cursor],
		);
		if((int) $product['type'] === getTypeID("products", TRANS_DOMAIN_PRODUCT)) {
			$product += array(
				'TLDs' =>	$wizardData[++$cursor],
			);
		}
		if($product['billingPlan'] === "3") {
			$product += array(
				'numCycles' =>	$wizardData[++$cursor],
			);
		}
		if($product['billingPlan'] === "1") {
			$product['stopNumCycles'] = 0;
		} else if($product['billingPlan'] === "2") {
			$product['stopNumCycles'] = 1;
		} else {
			$product['stopNumCycles'] = $product['numCycles'];		
		}
		
		$gac = $product['genericAttributeCount'];
		$product['genericAttributes'] = array();
		for($gai = 0; $gai < $gac; $gai++) {
			$attrVar = $wizardData[++$cursor];
			$attrVal = $wizardData[++$cursor];
			$product['genericAttributes'][$attrVar] = $attrVal;
		}
		
		if($product['orderForms']) {
			if($product['TLDs']) {
				$prices = array();
				foreach($product['TLDs'] as $TLD) {
					$TLDprices = array();
					// pick up the number of currencies
					$c = (int) $wizardData[++$cursor];
					// pick up whether a transfer price is included
					$t = $wizardData[++$cursor] ? true : false;
					
					// pick up the currencies (transfer will be last, if it is included)
					for($i = 0; $i < $c; $i++) {
						$allPrices = $wizardData[++$cursor];
						$allCOGS = $wizardData[++$cursor];
						$TLDprices[$i] = array();
						$TLDcogs[$i] = array();
						if($t) {
							// pop transfer prices off the end
							$TLDprices[$i]['transfer'] = array_pop($allPrices);
							$TLDcogs[$i]['transfer'] = array_pop($allCOGS);
						}
						// setup prices are per currency
						// shift setup prices off the beginning
						$TLDprices[$i]['setup'] = array_shift($allPrices);
						$TLDcogs[$i]['setup'] = array_shift($allCOGS);
						
						$TLDprices[$i] += array_combine($product['cycles'], $allPrices);
						$TLDcogs[$i] += array_combine($product['cycles'], $allCOGS);
					}
					
					$prices[$TLD] = array(
						'prices' => $TLDprices,
						'cogs' => $TLDcogs,
					);
				}
				$product['prices'] = $prices;
			} else {
				$prices = array();
				$setups = array();
				$cogs = array();
				$c = (int) $wizardData[++$cursor];
				for($i = 0; $i < $c; $i++) {
					// setup prices are per cycle
					$prices[$i] = array_combine($product['cycles'], $wizardData[++$cursor]);
					$cogs[$i] = array_combine($product['cycles'], $wizardData[++$cursor]);
					$setupPrices[$i] = array_combine($product['cycles'], $wizardData[++$cursor]);
					$setupCogs[$i] = array_combine($product['cycles'], $wizardData[++$cursor]);
				}
				$product['prices'] = array(
					'prices' => $prices,
					'cogs' => $cogs,
					'setupPrices' => $setupPrices,
					'setupCogs' => $setupCogs,
				);
			}
		}
				
		if($product['serverGroups']) {
			$product['serverGroupAttributes'] = array();
			$sgc = count($product['serverGroups']);
			
			for($sgi = 0; $sgi < $sgc; $sgi++) {
				// init structure for this server group
				$serverGroup = $product['serverGroups'][$sgi];
				$product['serverGroupAttributes'][$serverGroup] = array();
				$serverGroupAttrs =& $product['serverGroupAttributes'][$serverGroup];

				// init common attrs for this server group
				$serverGroupAttrs['attrs'] = array();
				$attrs =& $serverGroupAttrs['attrs'];
				
				// add the attributes
				$c = (int) $wizardData[++$cursor];
				for($i = 0; $i < $c; $i++) {
					$attrs[] = $wizardData[++$cursor];
				}
			}
			
			/*
			for($sgi = 0; $sgi < $sgc; $sgi++) {
				// init structure for this server group
				$serverGroup = $product['serverGroups'][$sgi];
				$product['serverGroupAttributes'][$serverGroup] = array();
				$serverGroupAttrs =& $product['serverGroupAttributes'][$serverGroup];

				// init common attrs for this server group
				$serverGroupAttrs['commonAttrs'] = array();
				$attrs =& $serverGroupAttrs['commonAttrs'];
				
				// add the attributes
				$c = (int) $wizardData[++$cursor];
				for($i = 0; $i < $c; $i++) {
					$attrs[] = $wizardData[++$cursor];
				}
		
				// figure out if we are basic or advanced
				$attrAdvanced = (int) $wizardData[++$cursor][0];
				if($attrAdvanced) {
					$attrType = 'advancedAttrs';
				} else {
					$attrType = 'basicAttrs';
				}
		
				// init the rest of the attrs for this server group
				$serverGroupAttrs[$attrType] = array();
				$attrs =& $serverGroupAttrs[$attrType];

				// add the attributes
				$c = (int) $wizardData[++$cursor];
				for($i = 0; $i < $c; $i++) {
					$attrs[] = $wizardData[++$cursor];
				}
			}
			*/
		}

		$attributeData = array();

		if($product['serverGroups']) {
			$sgc = count($product['serverGroups']);
			for($sgi = 0; $sgi < $sgc; $sgi++) {
				// init structure for this server group
				$serverGroup = $product['serverGroups'][$sgi];
				$attributeData[$serverGroup] = array();
				$serverGroupAttributeData =& $attributeData[$serverGroup];
				$serverGroupAttrs =& $product['serverGroupAttributes'][$serverGroup];
				
				$attributes = $this->getAttributesForServerGroupID($serverGroup);
				
				if($attributes) {
					$cursor = 0;
					foreach($attributes as $attrName => $attrData) {
						$q =& $attrData['question'];
						$answers = $serverGroupAttrs['attrs'][$cursor++];
						if(isset($attrData['valueMap'])) {
							$possibles = $q->getAnswers();
							$c = count($possibles);
							for($i = 0; $i < $c; $i++) {
								$val = $possibles[$i]['value'];
								$vals = $attrData['valueMap'][$val];
								foreach($vals as $attrMapName => $attributeAnswers) {
									if(is_array($answers)) {
										if(in_array($val, $answers)) {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[0];
										} else {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[1];
										}
									} else {
										if($val == $answers) {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[0];
										} else {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[1];
										}
									}
								}
							}
						} else {
							$serverGroupAttributeData[$attrName] = $answers;
						}
					}

				/*
				$cursor = 0;
				foreach($attributes as $attrName => $attrData) {
					if($attrData['type'] == getTypeID("productAttribute", "both")) {
						$q =& $attrData['question'];
						$answers = $serverGroupAttrs['commonAttrs'][$cursor++];
						if(isset($attrData['valueMap'])) {
							$possibles = $q->getAnswers();
							$c = count($possibles);
							for($i = 0; $i < $c; $i++) {
								$val = $possibles[$i]['value'];
								$vals = $attrData['valueMap'][$val];
								foreach($vals as $attrMapName => $attributeAnswers) {
									if(is_array($answers)) {
										if(in_array($val, $answers)) {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[0];
										} else {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[1];
										}
									} else {
										if($val == $answers) {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[0];
										} else {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[1];
										}
									}
								}
							}
						} else {
							$serverGroupAttributeData[$attrName] = $answers;
						}
					}
				}
	
				if(isset($serverGroupAttrs['basicAttrs'])) {
					$attrType = 'basic';
				} else {
					$attrType = 'advanced';
				}

				$cursor = 0;
				foreach($attributes as $attrName => $attrData) {
					if($attrData['type'] == getTypeID("productAttribute", $attrType)) {
						$q =& $attrData['question'];
						$answers = $serverGroupAttrs[$attrType . 'Attrs'][$cursor++];
						if(isset($attrData['valueMap'])) {
							$possibles = $q->getAnswers();
							$c = count($possibles);
							for($i = 0; $i < $c; $i++) {
								$val = $possibles[$i]['value'];
								$vals = $attrData['valueMap'][$val];
								foreach($vals as $attrMapName => $attributeAnswers) {
									if(is_array($answers)) {
										if(in_array($val, $answers)) {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[0];
										} else {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[1];
										}
									} else {
										if($val == $answers) {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[0];
										} else {
											$serverGroupAttributeData[$attrMapName] = $attributeAnswers[1];
										}
									}
								}
							}
						} else {
							$serverGroupAttributeData[$attrName] = $answers;
						}
					}
				}
				*/
				}
			}
		}	

		//echo '<pre>';
		//print_r($product);
		//print_r($attributeData);
		//print_r($w);

		$creationDate = mktime();
		$query = "<mbapi>
	<command>SetProducts</command>
	<subCommand>insert</subCommand>
	<showXMLHeader>0</showXMLHeader>
	<params>
		<productName>".htmlentities($product['name'])."</productName>
		<productType>".htmlentities($product['type'])."</productType>
		<productComments>".htmlentities($product['comment'])."</productComments>
		<productStopNumCycles>".htmlentities($product['stopNumCycles'])."</productStopNumCycles>
		<productProratable>". (isset($product['proratable']) ? "1" : "0") ."</productProratable>
		<productActive>1</productActive>
		<productDateCreated>".$creationDate."</productDateCreated>
		";
		if($product['children']) {
			$query .= "<productChildrenIDs>\n\t\t\t<productID>"
			. implode("</productID>\n\t\t\t<productID>", $product['children'])
			. "</productID>\n\t\t</productChildrenIDs>\n\t\t";
		}
		if($product['addons']) {
			$query .= "<productAddonIDs>\n\t\t\t<productAddonID>"
			. implode("</productAddonID>\n\t\t\t<productAddonID>", $product['addons'])
			. "</productAddonID>\n\t\t</productAddonIDs>\n\t\t";
		}
		if($product['coupons']) {
			$query .= "<couponIDs>\n\t\t\t<couponID>"
			. implode("</couponID>\n\t\t\t<couponID>", $product['coupons'])
			. "</couponID>\n\t\t</couponIDs>\n\t\t";
		}
		if($product['orderForms']) {
			$query .= "<orderFormIDs>\n\t\t\t<orderFormID>"
			. implode("</orderFormID>\n\t\t\t<orderFormID>", $product['orderForms'])
			. "</orderFormID>\n\t\t</orderFormIDs>\n\t\t";

			$getquery = "<mbapi>
	<command>GetOrderForms</command>
	<showXMLHeader>0</showXMLHeader>
	<params>
		<orderFormID>" . implode("</orderFormID>\n\t\t\t<orderFormID>", $product['orderForms']) . "</orderFormID>
		<getPaymentGroupData>1</getPaymentGroupData>
	</params>
</mbapi>";
			$CONF["debug"]->add("Action Command", htmlentities($getquery), __FILE__, __LINE__);
			$data = dispatchMBAPI($getquery, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			$orderForms = collapseArrayElements(protectArray($data["mbapi"][0]["results"][0]["orderForms"][0]["orderForm"]));

			$currencyIDs = array();
			foreach($orderForms as $orderForm) {
				$currencyIDs[$orderForm['paymentGroups']['paymentGroup']['paymentGroupCurrencyID']] = true;
			}
			$currencyIDs = array_keys($currencyIDs);
			if($product['prices']) {
				$query .= "<productPrices>\n\t\t\t";
				if((int) $product['type'] === getTypeID("products", TRANS_DOMAIN_PRODUCT) && $product['TLDs']) {
					foreach($product['prices'] as $tldID => $TLD) {
						$currencyPrices = $TLD['prices'];
						$currencyCogs = $TLD['cogs'];
						foreach($currencyPrices as $currencyIndex => $cyclePrices) {
							foreach($cyclePrices as $cycleID => $price) {
								$cogs = $currencyCogs[$currencyIndex][$cycleID];
								$currencyID = $currencyIDs[$currencyIndex];
								
								$query .= "<productPrice>\n\t\t\t\t";
								
								if($cycleID === 'transfer') {
									$query .= "<productPriceType>" . getTypeID("price", TRANS_TRANSFER) . "</productPriceType>\n\t\t\t\t";
								} else if($cycleID === 'setup') {
									$query .= "<productPriceType>" . getTypeID("price", TRANS_SETUP) . "</productPriceType>\n\t\t\t\t";
								} else {
									$query .= "<productPriceType>" . getTypeID("price", TRANS_GENERAL) . "</productPriceType>\n\t\t\t\t";
									$query .= "<cycleID>" . (int) $cycleID . "</cycleID>\n\t\t\t\t";
								}
								
								$query .= "<productPrice>" . round((float) $price, 2) . "</productPrice>\n\t\t\t\t";
								$query .= "<productCogs>" . round((float) $cogs, 2) . "</productCogs>\n\t\t\t\t";
								$query .= "<currencyID>" . $currencyID . "</currencyID>\n\t\t\t\t";
								$query .= "<tldID>" . (int) $tldID . "</tldID>\n\t\t\t";
								
								$query .= "</productPrice>\n\t\t\t";
							}
						}
					}
				} else {
					$currencyPrices = $product['prices']['prices'];
					$currencyCogs = $product['prices']['cogs'];
					$currencySetupPrices = $product['prices']['setupPrices'];
					$currencySetupCogs = $product['prices']['setupCogs'];
					foreach($currencyPrices as $currencyIndex => $cyclePrices) {
						foreach($cyclePrices as $cycleID => $price) {
							$cogs = $currencyCogs[$currencyIndex][$cycleID];
							$setupPrice = $currencySetupPrices[$currencyIndex][$cycleID];
							$setupCogs = $currencySetupCogs[$currencyIndex][$cycleID];
							
							$currencyID = $currencyIDs[$currencyIndex];
							
							$query .= "<productPrice>\n\t\t\t\t";
							$query .= "<productPriceType>" . getTypeID("price", TRANS_GENERAL) . "</productPriceType>\n\t\t\t\t";
							$query .= "<cycleID>" . (int) $cycleID . "</cycleID>\n\t\t\t\t";
							$query .= "<productPrice>" . (float) $price . "</productPrice>\n\t\t\t\t";
							$query .= "<productCogs>" . (float) $cogs . "</productCogs>\n\t\t\t\t";
							$query .= "<currencyID>" . $currencyID . "</currencyID>\n\t\t\t";
							$query .= "</productPrice>\n\t\t\t";

							$query .= "<productPrice>\n\t\t\t\t";
							$query .= "<productPriceType>" . getTypeID("price", TRANS_SETUP) . "</productPriceType>\n\t\t\t\t";
							$query .= "<cycleID>" . (int) $cycleID . "</cycleID>\n\t\t\t\t";
							$query .= "<productPrice>" . (float) $setupPrice . "</productPrice>\n\t\t\t\t";
							$query .= "<productCogs>" . (float) $setupCogs . "</productCogs>\n\t\t\t\t";
							$query .= "<currencyID>" . $currencyID . "</currencyID>\n\t\t\t";
							$query .= "</productPrice>\n\t\t\t";
						}
					}
				}
				$query .= "\n\t\t</productPrices>\n\t\t\t";				
			}
		}
		$query .= "<emailActionGroupIDs>\n\t\t\t";
		if($product['signupEmailActionGroup']) {
			$query .= "<emailActionGroupID>" . $product['signupEmailActionGroup'] . "</emailActionGroupID>\n\t\t";
		}
		if($product['welcomeEmailActionGroup']) {
			$query .= "\t<emailActionGroupID>" . $product['welcomeEmailActionGroup'] . "</emailActionGroupID>\n\t\t";
		}
		$query .= "</emailActionGroupIDs>\n\t\t";
		if($product['serverGroups']) {
			$query .= "<serverGroupIDs>\n\t\t\t<serverGroupID>"
			. implode("</serverGroupID>\n\t\t\t<serverGroupID>", $product['serverGroups'])
			. "</serverGroupID>\n\t\t</serverGroupIDs>\n\t\t";
		}
		if($product['TLDs']) {
			$query .= "<tldIDs>\n\t\t\t<tldID>"
			. implode("</tldID>\n\t\t\t<tldID>", $product['TLDs'])
			. "</tldID>\n\t\t</tldIDs>\n\t\t";
		}
		if($product['cycles']) {
			$query .= "<cycleIDs>\n\t\t\t<cycleID>"
			. implode("</cycleID>\n\t\t\t<cycleID>", $product['cycles'])
			. "</cycleID>\n\t\t</cycleIDs>\n\t\t";
		}
		$query .= "<productAttributes>\n";
		foreach($attributeData as $serverGroup => $serverGroupAttributes) {
			foreach($serverGroupAttributes as $attributeName => $attributeValue) {
				$query .= "\t\t\t<productAttribute>\n"
							."\t\t\t\t<serverGroupID>".$serverGroup."</serverGroupID>\n"
							."\t\t\t\t<productAttributeName>".htmlentities($attributeName)."</productAttributeName>\n"
							."\t\t\t\t<productAttributeValue>".htmlentities($attributeValue)."</productAttributeValue>\n"
							."\t\t\t\t<productAttributeDateCreated>".$creationDate."</productAttributeDateCreated>\n"
							."\t\t\t</productAttribute>\n";
			}
		}
		foreach($product['genericAttributes'] as $attrVar => $attrVal) {
			$query .= "\t\t\t<productAttribute>\n"
						."\t\t\t\t<productAttributeName>".htmlentities($attrVar)."</productAttributeName>\n"
						."\t\t\t\t<productAttributeValue>".htmlentities($attrVal)."</productAttributeValue>\n"
						."\t\t\t\t<productAttributeDateCreated>".$creationDate."</productAttributeDateCreated>\n"
						."\t\t\t</productAttribute>\n";
		}
		$query .= "\t\t</productAttributes>\n\t\t";
		$query .= "
	</params>
</mbapi>";

		//echo htmlentities($query);
		//echo '</pre>';
		//exit;
		$success = 1;
		
		if($success) {
			//$query = $this->getMBAPIQuery("SetProducts", "insert");
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			//exit;

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					$productID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
					redirect("products.php", getActionID("ShowProductDetails"), array("productID"=>$productID));
				}

			}

		}
		//exit;


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // AddProductResponse
?>