<?php
// $Id: AddProductResponse.php 12446 2008-01-10 17:27:44Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

class AddProductResponse extends SourceAction {
	function AddProductResponse() {
		parent::SourceAction();
		$this->stringRep = "AddProductResponse";
	}

	function execute() {
		do {
			$skeleton = array(
				"productName" => TRANS_SKELETON_PRODUCT,
				"productType" => getAPITypeID("products", "undefined"),
				"productComments" => "",
				"productStopNumCycles" => 0,
				"productActive" => 0,
				"productProratable" => 0,
				"productDomainRequired" => getAPIStatusID("productdependencyrules", "cannot"),
				"productAddonRequired" => getAPIStatusID("productdependencyrules", "can"),
				"productDateCreated" => mktime(),
			);
			
			switch($type = getAPITypeName("products", (int) $_REQUEST["productType"])) {
				case "hosting":
					$skeleton["productDomainRequired"] = getAPIStatusID("productdependencyrules", "can");
					$skeleton["productProratable"] = 1;
					break;
				case "non-hosting":
					$skeleton["productProratable"] = 1;
					break;
				case "domain":
					break;
				case "cert":
					break;
				case "license":
					break;
				case "software":
					break;
				case "usage":
					break;
				case "contract":
					$skeleton["productStopNumCycles"] = 1;
					break;
				case "fee":
					$skeleton["productStopNumCycles"] = 1;
					break;
				case "nonrecurring":
					$skeleton["productStopNumCycles"] = 1;
					break;
				case "undefined":
				default:
					$skeleton["productProratable"] = 1;
					break;
			}
			$skeleton["productType"] = getAPITypeID("products", $type);
			$skeleton["productName"] = getTypeName("products", $skeleton["productType"]);
			
			if($productID = insertFor("products", $skeleton)) {
				if ($skeleton["productStopNumCycles"]==1){
					$this->addSmallestCycle($productID);
				}
				$this->syncProductVariants($productID);
				redirect("products.php", "ShowProductDetails", array("productID" => $productID));
			} else {
				$this->addError(TRANS_ACTIONERROR, "Failure adding product.");
			}

		} while(0);
		$this->addErrorTemplates();
	}
	
	function addSmallestCycle($productID){
		$cycles = getAllCycleIDs();
		$smallest = false;
		foreach ($cycles as $c){
			if ($smallest===false){
				$smallest = array($c, getNextBillingTimestamp(0, $c));
			} elseif ($smallest[1]>($t = getNextBillingTimestamp(0, $c))){
				$smallest = array($c, $t);
			}
		}
		if ($smallest[0]){
			insertFor(":productCycleGhostRels", array(
				"productID" => $productID,
				"cycleID" => $smallest[0],
			));
		}
	}
}

?>
