<?php
// $Id: AddTLD.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["tldID"] and displays all
 * the TLD detail information for adding.
 *
 * @author  modernbill
 */
class AddTLD extends MB_Action {

	function AddTLD() {
		parent::MB_Action();
		$this->stringRep = "AddTLD";
		$this->params = array("tldID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$tldNotSupported = (int) $_REQUEST["tldNotSupported"];
		//$this->smartyVars["TLDs"] = collapseArrayElements(protectArray($results["TLDs"][0]["TLD"]));
		$this->smartyVars["tldRenewTypes"] = $CONF["types"]["tldRenew"];
		$this->smartyVars["enabledDisabled"] = array(TRANS_DISABLED, TRANS_ENABLED);
		$this->smartyVars["yesNo"] = array(TRANS_YES, TRANS_NO);
		$this->smartyVars["transferTypes"] = $CONF["types"]["tldTransfer"];
		$this->smartyVars["IDNTypes"] = $CONF["types"]["tldIDN"];

		if($tldNotSupported) {
			$this->smartyVars["tldNotSupported"] = 1;
		}

		loadConfigs("domain");
		//saveStateOfCONF();
		$registrarData = $CONF["domain"]["registrar"];
		$registrars = array();
		foreach($registrarData as $registrar => $attrs) {
			$registrars[0] = " ";
			if(isset($attrs['configGroupID'])) {
				$registrars[$attrs['configGroupID']] = $registrar;
			}
		}
		
		$this->smartyVars["registrars"] = $registrars;
		
		$this->mergeCycleData();
		
		$formDefaults = array();
		$this->mergeFormState($formDefaults);

		$this->addTemplate("products/AddTLD", $this->smartyVars);


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>