<?php
// $Id: AddWizardStep.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/include/wizard/WizardResolver.php");

/**
 * This Action object collects information on a product so that that product may be added to the 
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddWizardStep extends MB_Action {
	/**
	 * The constructor for a AddWizardStep action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddWizardStep() {
		parent::MB_Action();
		$this->stringRep = "AddWizardStep";
	}

	/**
	 * The main method of this class that executes the AddWizardStep action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$w =& new Wizard(intval($_REQUEST["wizardID"]), TRANS_ADD_WIZARD_STEP, TRANS_ADD_WIZARD_STEP_MESG);
		$s =& new WizardStep(TRANS_ADD_STEP, TRANS_ADD_STEP_MESG);

		$wr =& new WizardResolver("stepName");
				
		$wr->setWizard($w);
		$wr->setWizardStep($s);
		$wr->processForQuestionsReady();

		$questionAnswers = $wr->getQuestionAnswers();
		
		if($wr->isReady("stepName")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_STEP);
			$q->setID($wr->getQuestionID("stepName"));
			$q->setSize(64);
			$q->setMaxLength(256);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
			$s->addQuestion($q);		
		}
		
		$confirm = $_REQUEST['confirm'];
		
		if(!$confirm) {
			$this->addTemplate("products/AddWizardStep", $this->smartyVars);
		}
		
		$stepName = "";
		if($confirm || !$wr->display()) {
			$summary = array();
						
			if(isset($questionAnswers['stepName'])) {
				$step = $questionAnswers['stepName'];
				$stepName = preg_match("/^TRANS_/", $step) && defined($step) ? constant($step) : $step;
				$summary[] = array(TRANS_QUESTION, $stepName);
			}
			
			//echo 'Summary';
			//print_r($summary);
			if(!$confirm) {
				$this->addTemplate("products/AddWizardStep2", array('summary' => $summary, 'wizardID' => $w->getID()));
			}
		}


		if(!$confirm) {
			//echo '<pre>';
			//print_r($_REQUEST);
			//print_r($wr);
			//print_r($w);
			//echo '</pre>';
		
			$this->addTemplate("footer", array());
		} else {
			// insert into database
			
			$cmd = "<mbapi>
	<command>SetWizardSteps</command>
	<subCommand>insert</subCommand>
	<params>
		<stepName>" . $stepName . "</stepName>
	</params>
</mbapi>";

			$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
			$data = dispatchMBAPI($cmd, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("products.php", getActionID("ShowWizardSteps"), array());
			}

			//echo '<pre>';
			//echo "stepname: " . $stepName . "\n";
			//echo '</pre>';
			//exit;
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddProduct
?>