<?php
// $Id: CloneProductAddon.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This Action object double checks that a user is sure they want to Clone a Product.
 *
 * @author Andy Christ
 */
class CloneProduct extends MB_Action {
	/**
	 * The constructor for a CloneProduct action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function CloneProduct() {
		parent::MB_Action();
		$this->stringRep = "CloneProductAddon";
		$this->params = array("productAddonID");
	}

	/**
	 * The main method of this class that executes the RemoveProduct action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = ((int) $_REQUEST["productAddonID"]);
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No Product Addon ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetProducts", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["product"] = 
						collapseArrayElements($data["mbapi"][0]["results"][0]["products"][0]["product"][0]);
					$this->addTemplate("products/CloneProduct", $s);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Product not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveProduct
?>