<?php
// $Id: EditAppliedValues.php 12604 2008-02-04 22:10:19Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/config/internal/datasources.php");


/**
 * product <-> order form relation editor
 *
 * @author  Ben Woolley
 */
class EditAppliedValues extends MB_ProductAction {
	/**
	 * The constructor for a EditProductTLDs action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditAppliedValues() {
		parent::MB_ProductAction("options");
		$this->stringRep = "EditAppliedValues";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductTLDs action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		do {
			if($this->err($productID = getParam("productID"), "No product ID given.")) break;
			$this->smartyVars["productID"] = $productID;
			
			$this->syncProductVariants($productID);
			
			$pd =& new DataSource("products");
			$this->assignMultiOptionsForRelationItems(
				"variable",
				$productID,
				// selected many to one
				$pd,
				new DataSource("variants"),
				// selectable many to one
				new DataSource("productVariables"),
				new DataSource("productVariableValues")
			);
			
			$pt =& $pd->getTable();
			$this->smartyVars["product"] = $product = $pt->getOne();
			
			$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
				"productID" => $productID,
			));
			
			$this->setupTypeButtons($product["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$this->mergeFormState();
			$this->addTemplate("widgets/products/EditAppliedValues");
		} while(false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
