<?php
// $Id: EditAppliedValuesResponse.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class EditAppliedValuesResponse extends MB_Action {
	function EditAppliedValuesResponse() {
		parent::MB_Action();
		$this->stringRep = "EditAppliedValuesResponse";
		$this->params = array(
			"productID",
			"variableVariants",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		//echo '<pre>';
		//print_r($_REQUEST);
		do {
			if($this->err($productID = $this->validateParam("productID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED), "No appropriate product ID given")) break;

			$d =& new DataSource("variants", array("productID" => $productID));
			if(!$s =& $this->getSubjectFromSource($d)) return false;
			$t =& $s->getTable();
			$at =& $t->getAssociatedTablesBy("productVariantActive");
			$tt =& $at[1];
			$selectedIDs = (array) $_REQUEST["variableVariants"];
			if(is_object($tt)) {
				$currentIDs = $tt->getColumnDistinct("productVariableValueID");
			} else {
				$currentIDs = array();
			}
			$changes = $this->getRelationUpdateIDs($selectedIDs, $currentIDs);
			//print_r($changes);
			
			$t->setKey("productVariableValueID");
			$t->setName("productVariantID");
			$variantIDsByValueID = $t->getOptions();
			
			$productVariants = array();
			foreach($changes['add'] as $id) {
				$variantID = $variantIDsByValueID[$id];
				$productVariants[] = array(
					'productVariantID' => $variantID,
					'productVariantActive' => 1,
				);
			}
			foreach($changes['remove'] as $id) {
				$variantID = $variantIDsByValueID[$id];
				$productVariants[] = array(
					'productVariantID' => $variantID,
					'productVariantActive' => 0,
				);
			}
			//print_r($productVariants);
			
			if($productVariants) {
				$setVariantQuery =& new MBQuery(
					"SetProducts",
					"update",
					array(
						"productID" => $productID,
						"productVariants" => array(
							"productVariant" => $productVariants,
						),
					)
				);
				//echo '<pre>';
				//echo htmlentities($setVariantQuery->getXMLQuery());
				//echo '</pre>';
				//exit;
			
				if(!$this->addErrorsFromResult($r =& $setVariantQuery->getResult())) break;
			}
			
			if(!$this->goBack()) {
				//exit;
				redirect(
					"products.php", getActionID("EditAppliedValues"),
					array(
						"productID" => $productID,
						"loadActionFile" => "products",
						"loadActionID" => getActionID("EditAppliedValues"),
					)
				);
			}
			
		} while(false);
		//print_r($r);
		//echo '</pre>';
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
