<?php
// $Id: EditCouponResponse.php 13022 2008-07-17 21:26:35Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This Action object takes information provided by the EditCoupon action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditCouponResponse extends MB_Action {
	/**
	 * The constructor for an EditCouponResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditCouponResponse() {
		parent::MB_Action();
		$this->stringRep = "EditCouponResponse";
		$this->params = array(
			"couponID",
			"couponCode",
			"couponType",
			"couponDiscount",
			"couponComments",
			"couponActive",
			//"couponDateCreated",
			
			"couponDateStarted",
			
			"couponDateEnded",

			"couponCount",
			"couponMaxCount",
			"couponNewOnly",
			"couponNumCycles",
			"couponApplyNumber",
		);
	}

	/**
	 * The main method of this class that executes the EditCouponResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID(getActionID("EditCoupon"));
		$this->setReferralActionFile("products.php");
		
		if($_REQUEST['couponType'] === (string) getTypeID("coupon", TRANS_UNIT)) {
			$discountRestriction = INPUT_RESTRICTION_PRICE|INPUT_RESTRICTION_REQUIRED;
		} else if($_REQUEST['couponType'] === (string) getTypeID("coupon", TRANS_PERCENT)) {
			$discountRestriction = INPUT_RESTRICTION_PERCENT2|INPUT_RESTRICTION_REQUIRED;
		} else {
			$discountRestriction = INPUT_RESTRICTION_EMPTY;
		}
		
		$_REQUEST["couponApplyNumber"] = (int)$_REQUEST["couponApplyNumber"];
		
		$results = $this->getRootFromMBAPI("GetCoupons", "", array("couponID" => secureInput($_REQUEST['couponID']), "getOrderFormData" => 1, "getProductData" => 1));
		$coupon = correctArray($results["mbapi"][0]["results"][0]["coupons"][0]["coupon"][0]);
		dbg($coupon);
		if(!(isset($coupon) && ($_REQUEST['couponID'] === $coupon['couponID']))) {
			$codeFlags = INPUT_RESTRICTION_UNIQUE|INPUT_RESTRICTION_REQUIRED;
		} else {
			$codeFlags = INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED;
		}

		$couponDateStarted = $this->handleDateSelector("couponDateStarted");
		$couponDateEnded = $this->handleDateSelector("couponDateEnded", 0, true);

		$success = $this->validateMultiInputs(
			array(
				"couponID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"couponCode" => $codeFlags,
				
				"couponType" => array(INPUT_RESTRICTION_INSET|INPUT_RESTRICTION_REQUIRED, array('set' => $CONF['types']['coupon'])),
				"couponDiscount" => $discountRestriction,
				
				"couponComments" => INPUT_RESTRICTION_STRING,
				"couponActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				//"couponDateCreated" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"couponDateStarted" => INPUT_RESTRICTION_UNSIGNED_INT,
				"couponDateEnded" => INPUT_RESTRICTION_UNSIGNED_INT,
				//"couponCount" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				//"couponMaxCount" => INPUT_RESTRICTION_UNSIGNED_INT,
				"couponNewOnly" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				//"couponNumCycles" => INPUT_RESTRICTION_UNSIGNED_INT,
				
				"couponDateStartedYear" => 0,
				"couponDateStartedMonth" => 0,
				"couponDateStartedDay" => 0,
				"couponDateStartedHours" => 0,
				"couponDateStartedMinutes" => 0,
				"couponDateEndedYear" => 0,
				"couponDateEndedMonth" => 0,
				"couponDateEndedDay" => 0,
				"couponDateEndedHours" => 0,
				"couponDateEndedMinutes" => 0,
				"couponDateEndedChecked" => 0,
			),
			array(),
			array(),
			1
		);
		if($_REQUEST['couponPercentDiscount']) {
			unset($_REQUEST['couponUnitDiscount']);
		} else {
			unset($_REQUEST['couponPercentDiscount']);
		}

		$coupon = oneByID(":coupons", $_REQUEST["couponID"]);
		
		if($success) {
			$query = $this->getMBAPIQuery("SetCoupons", "update",
				array(
					'couponDateCreated' => time(),
					'couponCount' => (isset($_REQUEST["couponCount"])) ? 0 : $coupon["couponCount"],
					'couponDateStarted' => $couponDateStarted,
					'couponDateEnded' => $couponDateEnded,
				),
				0, 0, 0, 0, 0,
				array(
					"couponDateStartedYear",
					"couponDateStartedMonth",
					"couponDateStartedDay",
					"couponDateStartedHours",
					"couponDateStartedMinutes",
					"couponDateEndedYear",
					"couponDateEndedMonth",
					"couponDateEndedDay",
					"couponDateEndedHours",
					"couponDateEndedMinutes",
					"couponDateEndedChecked",
				)
			);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);


			$orderFormIDs = (array)$_REQUEST["orderFormIDs"];
			$productIDs = (array)$_REQUEST["productIDs"];
			

			dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetCoupons",
					"subCommand" => "update",
					"params" => array(
						"couponID" => $coupon["couponID"],
						"productIDs" => array(
							"productID" => $productIDs,
						),
						"removeProductIDs" => array(
							"productID" => $_REQUEST["selectableProductIDs"],
						),
						"orderFormIDs" => array(
							"orderFormID" => $orderFormIDs,
						),
						"removeOrderFormIDs" => array(
							"orderFormID" => $_REQUEST["selectableOrderFormIDs"],
						),
					),
				),
			)), 1);


			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("products.php", getActionID("ShowCoupons"), array());
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditCouponResponse
?>
