<?php
// $Id: EditLedgerGroupEntriesResponse.php 12604 2008-02-04 22:10:19Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
* edits ledger entries for a ledger group (response)
*
* @author  Kris Bailey
*/
class EditLedgerGroupEntriesResponse extends MB_Action {
	/**
	* The constructor for a EditLedgerGroupEntriesResponse action object. This merely calls the parent constructor,
	* and sets the string representation of this object.
	*/
	function EditLedgerGroupEntriesResponse() {
		parent::MB_Action();
		$this->stringRep = "EditLedgerGroupEntriesResponse";
	}

	/**
	* The main method of this class that executes the EditLedgerGroupEntries action, and returns success or failure.
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$productVariantID = (int)$_REQUEST["productVariantID"];
		$ledgerGroupID = (int)$_REQUEST["ledgerGroupID"];
		dbg("request: ");
		dbg($_REQUEST);
		dbg("");
		if (!$productVariantID){
			$this->addError(TRANS_ACTIONERROR, "No Product Variant ID given.");
		} else {

			$variantInfo = oneByID("variants", $productVariantID);

			// lets try and get the info for this ledger group, and if we cant we will just make a new one
			$data = dispatchMBAPI("<mbapi><command>GetLedgerGroups</command><params><ledgerGroupID>".$ledgerGroupID."</ledgerGroupID></params></mbapi>", 1);
			if (!isset($data["mbapi"][0]["results"][0]["groups"][0]["group"][0])){
				dbg("couldnt find group: ".$ledgerGroupID);
				$ledgerGroupID = 0; // we cant find this group, so lets set our id to 0 to make a new one
			}

			if ($ledgerGroupID==0){ // if 0 then we will create a new one

				$ledgerGroupName = secureInput(unsecureInput($_REQUEST["ledgerGroupName"]));
				$query = "<mbapi><command>SetLedgerGroups</command><subCommand>insert</subCommand><params><ledgerGroupName>$ledgerGroupName</ledgerGroupName></params></mbapi>";
				dbg("creating group:");
				$result = dispatchMBAPI($query, 1);
				$ledgerGroupID = $result["mbapi"][0]["header"][0]["lastInsertID"][0];
				dbg($ledgerGroupID);

				$ledgerEntries = $this->getRequestLedgerEntryData("ledgerGroup");

				foreach ($ledgerEntries as $k=>$v){
					$query = "
						<mbapi>
							<command>SetProductLedgerEntries</command>
							<subCommand>insert</subCommand>
							<params>
								<productVariantID>$productVariantID</productVariantID>
								<ledgerGroupID>$ledgerGroupID</ledgerGroupID>
								<generalLedgerType>0</generalLedgerType>
								<journalType>general</journalType>
								<ledgerAccountID>".(int)$v["ledgerAccountID"]."</ledgerAccountID>
								<productLedgerDebit>".doubleval($v["generalLedgerDebitAmount"])."</productLedgerDebit>
								<productLedgerCredit>".doubleval($v["generalLedgerCreditAmount"])."</productLedgerCredit>
								<productLedgerComment>".secureInput(unsecureInput($v["generalLedgerDescription"]))."</productLedgerComment>
								<currencyID>".secureInput(unsecureInput($_REQUEST["currencyID"]))."</currencyID>
									<currencyIDs>
										";
					$filterCurrencies = (array)$_REQUEST["filterCurrencyIDs"];
					$filterCycles = (array)$_REQUEST["filterCycleIDs"];
					foreach ($filterCurrencies as $curr){
						$query .= "<currencyID>".secureInput(unsecureInput($curr))."</currencyID>";
					}
					$query .= "		</currencyIDs>
									<cycleIDs>";
					foreach ($filterCycles as $cycle){
						$query .= "<cycleID>".(int)$cycle."</cycleID>";
					}
					$query .= "		</cycleIDs>
							</params>
						</mbapi>";

					dbg($query);
					$leresult = dispatchMBAPI($query, 1);
					dbg("creating ledger entry:");
					dbg($leresult);

				}

				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("products.php?action=".getActionID("EditLedgerGroups")."&productID=".$variantInfo["productID"]."&sid=".secureInput($_REQUEST["sid"]));
				}

			} else {

				// deal with edit here...
				$data = collapseArrayElements($data["mbapi"][0]["results"][0]["groups"][0]["group"]);
				// fix collapsed ledger entries (should never happen since you can't have just one)
				if (isset($data["ledgerEntries"]["entry"]["productVariantID"])){
					$data["ledgerEntries"]["entry"] = array($data["ledgerEntries"]["entry"]);
				}
				// update our group name here:
				$updateNameXML = "
						<mbapi>
							<command>SetLedgerGroups</command>
							<subCommand>update</subCommand>
							<params>
								<ledgerGroupID>$ledgerGroupID</ledgerGroupID>
								<ledgerGroupName>".secureInput(unsecureInput($_REQUEST["ledgerGroupName"]))."</ledgerGroupName>
							</params>
						</mbapi>";
				$updateGroupResult = dispatchMBAPI($updateNameXML, 1);
				// if we are successful...
				if (isset($updateGroupResult["mbapi"][0]["header"][0]["success"][0]) && (int)$updateGroupResult["mbapi"][0]["header"][0]["success"][0]){

					$productVariantID = $data["ledgerEntries"]["entry"][0]["productVariantID"];

					// init the keyed existing entries array
					$existingEntries = array();
					foreach ($data["ledgerEntries"]["entry"] as $k=>$v){
						$existingEntries[$v["productLedgerID"]] =& $data["ledgerEntries"]["entry"][$k];
					}
					dbg("Keyed Existing Ledger Entries:");
					dbg($existingEntries);

					// get new ledger entry data from request
					$ledgerEntries = $this->getRequestLedgerEntryData("ledgerGroup");
					if ($this->validateLedgerEntryData($ledgerEntries)){
						dbg("Ledger entries to set:");
						dbg($ledgerEntries);


						//**********************************************
						//*********** lets get the filter currencies and
						//*********** cycles of the existing entries
						//**********************************************
						// get the first ledger id, we only need one
						$productLedgerID = $data["ledgerEntries"]["entry"][0]["productLedgerID"];
						// get that ledger entries data with its filter currencies and cycles
						$query = "<mbapi><command>GetProductLedgerEntries</command><params><productLedgerID>".$productLedgerID."</productLedgerID><getProductLedgerCurrenyIDs>1</getProductLedgerCurrenyIDs><getProductLedgerCycleIDs>1</getProductLedgerCycleIDs></params></mbapi>";
						$ledata = dispatchMBAPI($query, 1);
						// init our arrays to hold the ones we need
						$oldCycles = array();
						$oldCurrencies = array();

						// send debug to debug server
						dbg("ledger data");
						dbg($ledata);
						// if we got results, should always...
						if (isset($ledata["mbapi"][0]["results"][0]["productLedgerEntries"][0]["productLedgerEntry"][0])){
							$ledata = $ledata["mbapi"][0]["results"][0]["productLedgerEntries"][0]["productLedgerEntry"][0];
							$this->smartyVars["currencyID"] = $ledata["currencyID"][0];
							// get the currencies
							if (isset($ledata["currencies"][0]["currency"][0]["currencyID"])){
								foreach ($ledata["currencies"][0]["currency"] as $curr){
									$oldCurrencies[] = $curr["currencyID"][0];
								}
							}
							// get the cycles
							if (isset($ledata["cycles"][0]["cycle"][0]["cycleID"])){
								foreach ($ledata["cycles"][0]["cycle"] as $cycle){
									$oldCycles[] = $cycle["cycleID"][0];
								}
							}
						}
						//**********************************************
						//*********** end getting filter currencies and
						//*********** cycles
						//**********************************************

						// lets get the new currencies and cycles:
						$filterCurrencies = (array)$_REQUEST["filterCurrencyIDs"]; // use these for new entries
						$filterCycles = (array)$_REQUEST["filterCycleIDs"]; // use these for new entries
						// init the remove and add cycles and currencies arrays
						$removeCycles = array(); // nothing if there aren't differences
						$removeCurrencies = array(); // "
						$addCycles = array(); // "
						$addCurrencies = array(); // "
						if (count(array_diff($oldCurrencies, $filterCurrencies))>0 || count(array_diff($filterCurrencies, $oldCurrencies))>0){
							dbg("currencies are different:");
							dbg($oldCurrencies);
							dbg($filterCurrencies);
							$removeCurrencies = array_diff($oldCurrencies, $filterCurrencies); // remove these from each updated entry
							$addCurrencies = array_diff($filterCurrencies, $oldCurrencies); // add these to each updated entry
						}
						if (count(array_diff($oldCycles, $filterCycles))>0 || count(array_diff($filterCycles, $oldCycles))>0){
							dbg("cycles are different: ");
							dbg($oldCycles);
							dbg($filterCycles);
							$removeCycles = array_diff($oldCycles, $filterCycles);
							$addCycles = array_diff($filterCycles, $oldCycles);
						}

						$addLedgerEntries = array(); // ledger entries we will have to create
						$updateLedgerEntries = array(); // ledger entries we will have to update
						$deleteLedgerEntries = array(); // ledger entries we will have to remove

						// for each of the ledger entries we received, check if its an update
						// or if its a new one, if its an update, remove the one we are updating from
						// the existing entries array
						foreach ($ledgerEntries as $le){
							if ((int)$existingEntries[$le["productLedgerID"]]["productLedgerID"]){
								$updateLedgerEntries[] = $le;
								unset($existingEntries[$le["productLedgerID"]]);
							} else {
								$addLedgerEntries[] = $le;
							}
						}
						$deleteLedgerEntries = $existingEntries;

						//**********************************************
						//********** lets add the new ones:
						//**********************************************
						foreach ($addLedgerEntries as $k=>$v){
							$query = "
								<mbapi>
									<command>SetProductLedgerEntries</command>
									<subCommand>insert</subCommand>
									<params>
										<productVariantID>$productVariantID</productVariantID>
										<ledgerGroupID>$ledgerGroupID</ledgerGroupID>
										<generalLedgerType>0</generalLedgerType>
										<journalType>general</journalType>
										<ledgerAccountID>".(int)$v["ledgerAccountID"]."</ledgerAccountID>
										<productLedgerDebit>".doubleval($v["generalLedgerDebitAmount"])."</productLedgerDebit>
										<productLedgerCredit>".doubleval($v["generalLedgerCreditAmount"])."</productLedgerCredit>
										<productLedgerComment>".secureInput(unsecureInput($v["generalLedgerDescription"]))."</productLedgerComment>
										<currencyID>".secureInput(unsecureInput($_REQUEST["currencyID"]))."</currencyID>
											<currencyIDs>
												";
							foreach ($filterCurrencies as $curr){
								$query .= "<currencyID>".secureInput(unsecureInput($curr))."</currencyID>";
							}
							$query .= "		</currencyIDs>
											<cycleIDs>";
							foreach ($filterCycles as $cycle){
								$query .= "<cycleID>".(int)$cycle."</cycleID>";
							}
							$query .= "		</cycleIDs>
									</params>
								</mbapi>";
							dbg($query);
							$leresult = dispatchMBAPI($query, 1);
							dbg("creating ledger entry:");
							dbg($leresult);

						}
						//**********************************************
						//********** lets update the ones we need to:
						//**********************************************
						foreach ($updateLedgerEntries as $k=>$v){
							$query = "
								<mbapi>
									<command>SetProductLedgerEntries</command>
									<subCommand>update</subCommand>
									<params>
										<productLedgerID>".(int)$v["productLedgerID"]."</productLedgerID>
										<productVariantID>$productVariantID</productVariantID>
										<ledgerGroupID>$ledgerGroupID</ledgerGroupID>
										<generalLedgerType>0</generalLedgerType>
										<journalType>general</journalType>
										<ledgerAccountID>".(int)$v["ledgerAccountID"]."</ledgerAccountID>
										<productLedgerDebit>".doubleval($v["generalLedgerDebitAmount"])."</productLedgerDebit>
										<productLedgerCredit>".doubleval($v["generalLedgerCreditAmount"])."</productLedgerCredit>
										<productLedgerComment>".secureInput(unsecureInput($v["generalLedgerDescription"]))."</productLedgerComment>
										<currencyID>".secureInput(unsecureInput($_REQUEST["currencyID"]))."</currencyID>
											<currencyIDs>
												";
							foreach ($addCurrencies as $curr){
								$query .= "<currencyID>".secureInput(unsecureInput($curr))."</currencyID>";
							}
							$query .= "		</currencyIDs>
											<cycleIDs>";
							foreach ($addCycles as $cycle){
								$query .= "<cycleID>".(int)$cycle."</cycleID>";
							}
							$query .= "		</cycleIDs>
											<removeCurrencyIDs>
												";
							foreach ($removeCurrencies as $curr){
								$query .= "<currencyID>".secureInput(unsecureInput($curr))."</currencyID>";
							}
							$query .= "		</removeCurrencyIDs>
											<removeCycleIDs>";
							foreach ($removeCycles as $cycle){
								$query .= "<cycleID>".(int)$cycle."</cycleID>";
							}
							$query .= "		</removeCycleIDs>
									</params>
								</mbapi>";
							dbg($query);
							$leresult = dispatchMBAPI($query, 1);
							dbg("updating ledger entry:");
							dbg($leresult);
						}

						//**********************************************
						//********** lets update the ones we need to:
						//**********************************************
						foreach ($deleteLedgerEntries as $k=>$v){
							$query = "
								<mbapi>
									<command>SetProductLedgerEntries</command>
									<subCommand>delete</subCommand>
									<params>
										<productLedgerID>".$v["productLedgerID"]."</productLedgerID>
									</params>
								</mbapi>";
							dbg($query);
							$leresult = dispatchMBAPI($query, 1);
							dbg("deleted ledger entry");
							dbg($leresult);
						}

						if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
							redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
						} else {
							redirect("products.php?action=".getActionID("EditLedgerGroups")."&productID=".$variantInfo["productID"]."&sid=".secureInput($_REQUEST["sid"]));
						}

					} else {
						$this->addError(TRANS_ACTIONERROR, "Invalid Ledger Entries.");
					}

				} else {
					$this->addError(TRANS_ACTIONERROR, "Unable to set group name.");
				}

			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
