<?php
// $Id: EditLedgerGroups.php 12604 2008-02-04 22:10:19Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");


/**
 * @author  Kris Bailey
 */
class EditLedgerGroups extends MB_ProductAction {
	/**
	 * The constructor for a EditProductCycles action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditLedgerGroups() {
		parent::MB_ProductAction("ledgergroups");
		$this->stringRep = "EditLedgerGroups";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductCycles action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$q =& new MBQuery("GetProducts", "", array("productID" => $productID, "getCycleGhostData" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();
				
				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));
				$variantIDs = array();
				foreach ((array)$this->smartyVars["productVariants"] as $v){
					$variantIDs[] = $v["productVariantID"];
				}
				
				
				$q =& new MBQuery("GetLedgerGroups", "", array("productVariantID" => $variantIDs));
				$query = $q->getXMLQuery();
		
				dbg("query: ".$query);
		
				$results = dispatchMBAPI($query, 1);
				$results = collapseArrayElements($results["mbapi"][0]["results"][0]["groups"][0]["group"]);
				if ((int)$results["productVariantID"]){
					$results = array($results);
				}
				$results = (array)$results;
				dbg("Results: ");
				dbg($results);
				dbg("");
		
				$groupsByVariant = array();
				foreach ($results as $k=>$row){
					$groupsByVariant[$row["productVariantID"]][] =& $results[$k];
				}
		
				foreach ($this->smartyVars["productVariants"] as $k=>$row){
					$this->smartyVars["productVariants"][$k]["ledgerGroups"] = $groupsByVariant[$row["productVariantID"]];
				}
				
				$this->addTemplate("widgets/products/EditLedgerGroups", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
