<?php
// $Id: EditOneProductRelationsResponse.php 10687 2007-02-19 18:45:10Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditProductChildren action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditOneProductRelationsResponse extends MB_Action {
	/**
	 * The constructor for an EditOneProductRelationsResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditOneProductRelationsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditOneProductRelationsResponse";
		$this->params = array(
			"productID",
			"productChildren",
		);
	}

	/**
	 * The main method of this class that executes the EditOneProductRelationsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID(getActionID("EditOneProductRelations"));
		$this->setReferralActionFile("products.php");

		$productID = (int) $_REQUEST["productID"];
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
 			$params = array();

			dbg($_REQUEST);

			$productUpgradeIDs = (array)$_REQUEST["productUpgradeIDs"];
			$productDowngradeIDs = (array)$_REQUEST["productDowngradeIDs"];
			$skipUpgradeIDs = array();
			$skipDowngradeIDs = array();

			$oldUpgradeRelations = arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "upgrade")));
			$oldDowngradeRelations = arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "downgrade")));


			foreach ((array)$oldUpgradeRelations as $relation){
				if (!in_array($relation["relatedProductID"], $productUpgradeIDs)){
					deleteFor("productRelations", array("productRelationID"=>$relation["productRelationID"]));
				} else {
					$skipUpgradeIDs[] = $relation["relatedProductID"];
				}
			}
			foreach ((array)$oldDowngradeRelations as $relation){
				if (!in_array($relation["relatedProductID"], $productDowngradeIDs)){
					deleteFor("productRelations", array("productRelationID"=>$relation["productRelationID"]));
				} else {
					$skipDowngradeIDs[] = $relation["relatedProductID"];
				}
			}


			foreach ($productUpgradeIDs as $uid){
				if (!in_array($uid, $skipUpgradeIDs)){
					insertFor("productRelations", array("subjectProductID" => $productID, "relatedProductID" => $uid, "productRelationType" => getAPITypeID("productrelations", "upgrade")));
				}
			}
			foreach ($productDowngradeIDs as $did){
				if (!in_array($did, $skipDowngradeIDs)){
					insertFor("productRelations", array("subjectProductID" => $productID, "relatedProductID" => $did, "productRelationType" => getAPITypeID("productrelations", "downgrade")));
				}
			}

			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect(
					"products.php", getActionID("EditOneProductRelations"),
					array(
						"productID" => $productID,
						"loadActionFile" => "products",
						"loadActionID" => getActionID("EditOneProductRelations"),
					)
				);
			}
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
