<?php
// $Id: EditProduct.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object collects information on a product so that that the product may be modified in the
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditProduct extends MB_Action {
	/**
	 * The constructor for a EditProduct action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProduct() {
		parent::MB_Action();
		$this->stringRep = "EditProduct";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProduct action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$params = array();
			$this->applyRequestTo($params);
			$q =& new MBQuery("GetProducts", "", $params);
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;
				/*
				echo '<pre>';
				echo htmlentities($q->getXMLQuery());
				//print_r($r);
				print_r($product);
				echo '</pre>';
				/**/
				
				/*
				$q =& new MBQuery("GetEmailActionGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_SIGNUP)));
				$signupResult =& $q->getResult();
				$signupSubject =& $signupResult->getSubjectFrom(
					array("mbapi", "results", "emailActionGroups", "emailActionGroup"),
					"emailActionGroupID", "emailActionGroupName"
				);
				$this->assignOptionsFromSubject("signupEmailActionGroups", $signupSubject);

				$q =& new MBQuery("GetEmailActionGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_WELCOME)));
				$welcomeResult =& $q->getResult();
				$welcomeSubject =& $welcomeResult->getSubjectFrom(
					array("mbapi", "results", "emailActionGroups", "emailActionGroup"),
					"emailActionGroupID", "emailActionGroupName"
				);
				$this->assignOptionsFromSubject("welcomeEmailActionGroups", $welcomeSubject);
				*/

				/*
				$q =& new MBQuery("GetProducts", "", array());
				$childrenResult =& $q->getResult();
				$childrenSubject =& $childrenResult->getSubjectFrom(
					array("mbapi", "results", "products", "product"),
					"productID", "productName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productChildren", "productChild"));
				$this->assignMultiOptionsFromSubject("children", $childrenSubject, "productChildren", $r, "childProductID");
				
				$q =& new MBQuery("GetOrderForms", "", array());
				$orderFormResult =& $q->getResult();
				$orderFormSubject =& $orderFormResult->getSubjectFrom(
					array("mbapi", "results", "orderForms", "orderForm"),
					"orderFormID", "orderFormName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "orderForms", "orderForm"));
				$this->assignMultiOptionsFromSubject("orderForms", $orderFormSubject, "orderForms", $r, "orderFormID");

				$q =& new MBQuery("GetServerGroups", "", array());
				$serverGroupResult =& $q->getResult();
				$serverGroupSubject =& $serverGroupResult->getSubjectFrom(
					array("mbapi", "results", "serverGroups", "serverGroup"),
					"serverGroupID", "serverGroupName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "serverGroups", "serverGroup"));
				$this->assignMultiOptionsFromSubject("serverGroups", $serverGroupSubject, "serverGroups", $r, "serverGroupID");

				$q =& new MBQuery("GetCycles", "", array());
				$cycleResult =& $q->getResult();
				$cycleSubject =& $cycleResult->getSubjectFrom(
					array("mbapi", "results", "cycles", "cycle"),
					"cycleID", "cycleDisplayName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productPriceCycles", "productPriceCycle"));
				$this->assignMultiOptionsFromSubject("cycles", $cycleSubject, "cycles", $r, "cycleID");
				*/

				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("products/EditProduct", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditProduct
?>