<?php
// $Id: EditProductAddonGroupResponse.php 12437 2008-01-08 19:23:08Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * @author  Kris Bailey
 */
class EditProductAddonGroupResponse extends MB_Action {
	/**
	 */
	function EditProductAddonGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductAddonGroupResponse";
		$this->params = array(
			"productAddonGroupID",
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if (!(int)$_REQUEST["productID"] || !(int)$_REQUEST["productAddonGroupID"]){
			$this->addError(TRANS_ACCIONERROR, "Invalid product or addon group ID passed.");
		} else {

			$relData = arrayFor(":productAddonGroupRels", array(
				"productAddonGroupID" => $_REQUEST["productAddonGroupID"],
				"productID" => $_REQUEST["productID"],
			));
			
			if ($relData){
				foreach ($relData as $relation){
					deleteForKey(":productAddonGroupRels", $relation["productAddonGroupRelID"]);
				}
			}
			insertFor(":productAddonGroupRels", array(
				"productAddonGroupID" => $_REQUEST["productAddonGroupID"],
				"productID" => $_REQUEST["productID"],
				"defaultSelectedProductID" => $_REQUEST["defaultSelectedProductID"],
			));
			
			updateForKey(":productAddonGroups", (int)$_REQUEST["productAddonGroupID"], array(
				"productAddonGroupActive" => (int)$_REQUEST["productAddonGroupActive"],
				"productAddonGroupName" => $_REQUEST["productAddonGroupName"],
				"productAddonGroupInputType" => $_REQUEST["productAddonGroupInputType"],
				"productAddonGroupNoneChoice" => (int)$_REQUEST["productAddonGroupNoneChoice"],
			));

			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect(
					"products.php", getActionID("ShowProductAddons"),
					array(
						"productID" => $productID,
					)
				);
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
