<?php
// $Id: EditProductAddons.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> addon relation editor
 *
 * @author  Ben Woolley
 */
class EditProductAddons extends MB_Action {
	/**
	 * The constructor for a EditProductAddons action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProductAddons() {
		parent::MB_Action();
		$this->stringRep = "EditProductAddons";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductAddons action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$q =& new MBQuery("GetProducts", "", array("productID" => $productID, "getProductAddonData" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;

				$q =& new MBQuery("GetProductAddons", "", array());
				$productAddonResult =& $q->getResult();
				$productAddonSubject =& $productAddonResult->getSubjectFrom(
					array("mbapi", "results", "productAddons", "productAddon"),
					"productAddonID", "productAddonName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productAddons", "productAddon"));
				$this->assignMultiOptionsFromSubject("productAddons", $productAddonSubject, "productAddons", $r, "productAddonID");
				
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditProductAddons", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
