<?php
// $Id: EditProductEmails.php 12604 2008-02-04 22:10:19Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> order form relation editor
 *
 * @author  Ben Woolley
 */
class EditProductEmails extends MB_ProductAction {
	/**
	 * The constructor for a EditProductEmails action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProductEmails() {
		parent::MB_ProductAction("emails");
		$this->stringRep = "EditProductEmails";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductEmails action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$q =& new MBQuery("GetProducts", "", array("productID" => $productID, "getEmailActionGroupData" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];
				
				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;
				
				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

				$q =& new MBQuery("GetEmailTemplateGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_PACKAGE_INFO_EMAIL)));
				$welcomeResult =& $q->getResult();
				if($welcomeResult->errorCount==0) {
					$emailTemplates = $welcomeResult->structure["mbapi"][0]["results"][0];
				}
				$welcomeResult = correctArray($emailTemplates,1);

				//pull the good stuff out old school
				$templates[0] = " ";
				foreach($welcomeResult["emailTplGroups"] as $value) {
					$templates[$value["emailTplGroupID"]] = $value["emailTplGroupName"];
				}

				$this->smartyVars["templateID"] = (int) $product["emailTplGroupID"];
				$this->smartyVars["templates"] = $templates;
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditProductEmails", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
