<?php
// $Id: EditProductMiscellaneous.php 12740 2008-03-05 22:47:46Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * @author  Kris Bailey
 */
class EditProductMiscellaneous extends MB_ProductAction {
	/**
	 */
	function EditProductMiscellaneous() {
		parent::MB_ProductAction("miscellaneous");
		$this->stringRep = "EditProductMiscellaneous";
		$this->params = array("productID");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$q =& new MBQuery("GetProducts", "", array(
				"productID" => $productID,
				"getCouponData" => 1, 
				"getPreCouponData" => 1,
			));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);

				$productInfo = $s->getEssential();
				dbg($productInfo);
				$this->smartyVars["selectedPreCouponID"] = (isset($productInfo["preappliedCoupons"]) && isset($productInfo["preappliedCoupons"][0]["couponID"]))?$productInfo["preappliedCoupons"][0]["couponID"][0]:0;
				
				$this->smartyVars["product"] = $product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;
				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();


				// website widget info
				$orderForms = arrayFor(":orderFormItems", array(
					"productID" => $productID,
				));
				foreach ((array)$orderForms as $of){
					$orderFormIDs[] = $of["orderFormID"];
				}
				
				$allWebsiteWidgets = optionsFor(":websiteWidgets", array(
					"orderFormID" => $orderFormIDs
				));
				$selectedWidgets = arrayFor(":websiteWidgetsProductsRels", array(
					"productID" => $productID,
				));
				$this->smartyVars["websiteWidgets"] = array();
				$this->smartyVars["selectableWebsiteWidgets"] = array();
				foreach ((array)$selectedWidgets as $widget){
					$this->smartyVars["websiteWidgets"][$widget["websiteWidgetID"]] = $allWebsiteWidgets[$widget["websiteWidgetID"]];
					unset($allWebsiteWidgets[$widget["websiteWidgetID"]]);
				}
				$this->smartyVars["selectableWebsiteWidgets"] = $allWebsiteWidgets;

				////////// coupon info
				$q =& new MBQuery("GetCoupons", "", array());
				$couponResult =& $q->getResult();
				$couponSubject =& $couponResult->getSubjectFrom(
					array("mbapi", "results", "coupons", "coupon"),
					"couponID", "couponCode"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "coupons", "coupon"));
				$this->assignOptionsFromSubject("precoupons", $couponSubject);
				$this->assignMultiOptionsFromSubject("coupons", $couponSubject, "coupons", $r, "couponID");
				
				////////// upgrade/downgrade info
				$this->smartyVars["productsInfo"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"getNonAddons" => 1,
						),
					),
				)), "productID", "productName");
				
				/* stuff to get relations */
				$this->smartyVars["selectedUpgradeRelations"] = grabHTMLOpsFromArray(arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "upgrade"))), "relatedProductID", array($this, "grabProductName"));
				$this->smartyVars["selectedDowngradeRelations"] = grabHTMLOpsFromArray(arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "downgrade"))), "relatedProductID", array($this, "grabProductName"));

				$this->smartyVars["selectableUpgradeRelations"] = array();
				$this->smartyVars["selectableDowngradeRelations"] = array();
				foreach ($this->smartyVars["productsInfo"] as $pid=>$product){
					if (/*$pid!=$productID && */!$this->smartyVars["selectedUpgradeRelations"][$pid]){
						$this->smartyVars["selectableUpgradeRelations"][$pid] = $product;
					}
				}				
				foreach ($this->smartyVars["productsInfo"] as $pid=>$product){
					if (/*$pid!=$productID && */!$this->smartyVars["selectedDowngradeRelations"][$pid]){
						$this->smartyVars["selectableDowngradeRelations"][$pid] = $product;
					}
				}				


				$q =& new MBQuery("GetProducts", "", array());
				$childrenResult =& $q->getResult();
				$childrenSubject =& $childrenResult->getSubjectFrom(
					array("mbapi", "results", "products", "product"),
					"productID", "productName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productChildren", "productChild"));
				$this->assignMultiOptionsFromSubject("children", $childrenSubject, "productChildren", $r, "childProductID");
				
				////////// usage pricing
				$getUsagePriceXML = "
					<mbapi>
						<command>GetProductUsagePrices</command>
						<params>
							<productID>".$productID."</productID>
						</params>
					</mbapi>
					";
				$usagePriceData = dispatchMBAPI($getUsagePriceXML, 1);
				dbg("usage price data");
				dbg($usagePriceData);
				$usagePrices = array();
				if (isset($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"])){
					if(is_array($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"])) {
						foreach ($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"] as $row){
							$usagePrices[$row["currencyID"][0]] = $row["productUsagePriceAmount"][0];
						}
					}
				}
				$this->smartyVars["oldPrices"] = $usagePrices;
				$getProductXML = "
					<mbapi>
						<command>GetProducts</command>
						<params>
							<productID>".$productID."</productID>
							<getOrderFormData>1</getOrderFormData>
						</params>
					</mbapi>
					";
				$productInfo = dispatchMBAPI($getProductXML, 1);
				dbg("product info");
				dbg($productInfo);
				if (isset($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]["orderForms"][0]["orderForm"][0])){
					$this->smartyVars["product"] = correctArray($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]);
					$orderForms = collapseArrayElements($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]["orderForms"][0]["orderForm"]);
					if ((int)$orderForms["orderFormID"]){
						$orderForms = array($orderForms);
					}
	
					$makeFields = array();
	
					foreach ($orderForms as $row){
						$makeFields[] = $row["paymentGroupCurrencyID"];
					}
					$this->smartyVars["makeFields"] = $makeFields;
	
				}
				$this->smartyVars["helpRowSpan"] = count($this->smartyVars["makeFields"]);
				
	
	
				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));
				
				$this->setupTypeButtons($this->smartyVars["product"]["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();
	
	
				$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
	
				$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
				$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
				$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
				$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
				$this->smartyVars["numPrices"] = count($this->smartyVars["makeFields"]);
				
				////////// emails
				$q =& new MBQuery("GetEmailTemplateGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_PACKAGE_INFO_EMAIL)));
				$welcomeResult =& $q->getResult();
				if($welcomeResult->errorCount==0) {
					$emailTemplates = $welcomeResult->structure["mbapi"][0]["results"][0];
				}
				$welcomeResult = correctArray($emailTemplates,1);

				//pull the good stuff out old school
				$templates[0] = " ";
				foreach($welcomeResult["emailTplGroups"] as $value) {
					$templates[$value["emailTplGroupID"]] = $value["emailTplGroupName"];
				}

				$this->smartyVars["templateID"] = (int) $this->smartyVars["product"]["emailTplGroupID"];
				$this->smartyVars["templates"] = $templates;
				
				////////// notifications
				
				// grab the admin groups
				$adminGroups = arrayFor("adminGroups");
				$this->smartyVars['adminGroups'] = array();
				$this->smartyVars['adminGroups'][0] = TRANS_NONE;
				
				foreach( (array)$adminGroups as $v ) {
					if (isset( $v['adminGroupID'] ) && notZero( $v['adminGroupID'] )) {
						$this->smartyVars['adminGroups'][ (int)$v['adminGroupID'] ] = (string)$v['adminGroupName'];
					}
				}	unset( $v );
				//////////
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditProductMiscellaneous", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	function grabProductName($row){
		return $this->smartyVars["productsInfo"][$row["relatedProductID"]];
	}
}
?>
