<?php
// $Id: EditProductNotifications.php 12604 2008-02-04 22:10:19Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> order form relation editor
 *
 * @author  Brian Smith
 */
class EditProductNotifications extends MB_ProductAction {
	/**
	 * The constructor for a EditProductNotifications action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditProductNotifications() {
		parent::MB_ProductAction("notifications");
		$this->stringRep = "EditProductNotifications";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductNotifications action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!notZero( $productID )) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$q =& new MBQuery( "GetProducts", "", array("productID" => (int)$productID) );
			$r =& $q->getResult();
			
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$this->smartyVars["product"] =& $product;

				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));
				
				// setup the button menu
				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();
				
				// grab the admin groups
				$adminGroups = arrayFor("adminGroups");
				$this->smartyVars['adminGroups'] =array();
				$this->smartyVars['adminGroups'][0] = TRANS_NONE;
				
				foreach( (array)$adminGroups as $v ) {
					if (isset( $v['adminGroupID'] ) && notZero( $v['adminGroupID'] )) {
						$this->smartyVars['adminGroups'][ (int)$v['adminGroupID'] ] = (string)$v['adminGroupName'];
					}
				}	unset( $v );

				// display the template
				$this->addTemplate("widgets/products/EditProductNotifications");
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
