<?php
// $Id: EditProductPrices.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> price relation editor
 *
 * @author  Ben Woolley
 */
class EditProductPrices extends MB_Action {
	/**
	 * The constructor for a EditProductPrices action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProductPrices() {
		parent::MB_Action();
		$this->stringRep = "EditProductPrices";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductPrices action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		// fake exception handling for php4
		do {
			if(!success($productID = getParam("productID"))) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
				break;
			}
						
			$priceTypes = $CONF["types"]["price"];
			$productTypes = $CONF["types"]["products"];

			$this->smartyVars['prices'] = $prices;
			$this->smartyVars['priceTypes'] = $priceTypes;
			$this->smartyVars['productTypes'] = $productTypes;
			$this->smartyVars['productTypeIndex'] = array_flip($productTypes);

			/**
			 * get wanted price structure and price data
			 */
			$q =& new MBQuery(
				"GetProducts", "",
				array(
					"productID" => $productID,
					"getProductVariantData" => 1,
					"getProductVariantPriceData" => 1,
					"getOrderFormData" => 1,
					"getCycleGhostData" => 1,
					"getTLDGhostData" => 1,
				)
			);
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;

			$productTable =& $r->getTableFrom(
				array("mbapi", "results", "products", "product"),
				"productID"
			);
			$product = $productTable->getTable();
			$product = $product[0];
			
			$orderFormTable =& $r->getTableFrom(
				array("mbapi", "results", "products", "product", "orderForms", "orderForm"),
				"orderFormID"
			);
			$orderFormIDs = $orderFormTable->getKeys();

			$variantTable =& $r->getTableFrom(
				array("mbapi", "results", "products", "product", "productVariants", "productVariant"),
				"productVariantID"
			);
			//$variants = $variantTable->getAssociated();

			$variantPriceTable =& $r->getTableFrom(
				array("mbapi", "results", "products", "product", "productVariantPrices", "productVariantPrice"),
				"productVariantPriceID"
			);
			//$variantPrices = $variantPriceTable->getAssociated();
			
			$priceTable =& $variantPriceTable->getLeftJoinedWith($variantTable);
			
			$variantIDs = $variantTable->getKeys();
			//$variantSet =& $variantTable->getKeySet();
			//$variantSet->addElement($variantSet);
			//print_r($variantSet->getSet());
			
			$cogsQuery =& new MBQuery(
				"GetProductLedgerEntries", "",
				array(
					"productVariantID" => $variantIDs,
					"getProductLedgerCycleIDs" => 1,
				)
			);
			if(!$this->addErrorsFromResult($cogsResult =& $cogsQuery->getResult())) break;
			
			$cogsSubject =& $cogsResult->getSubjectFrom(array("mbapi", "results", "productLedgerEntries", "productLedgerEntry"));

			$c = $cogsSubject->getNumRows();
			for($i = 0; $i < $c; $i++) {
				if(isset($cogsSubject->structure[$i]) && isset($cogsSubject->structure[$i]["cycles"][0]["cycle"][0]["cycleID"][0])) {
					$cogsSubject->structure[$i]["cycleID"] = $cogsSubject->structure[$i]["cycles"][0]["cycle"][0]["cycleID"][0];
				}
			}
			
			$ledgerEntriesTable =& $cogsSubject->getTable("productVariantID");
			
			$priceTable =& $variantPriceTable->getLeftJoinedWith($variantTable);
			$cogsTable =& $ledgerEntriesTable->getLeftJoinedWith($variantTable);

			//echo '<pre>';
			//print_r($r);
			//print_r($product);
			//print_r($cogsQuery);
			//echo htmlentities($cogsQuery->getXMLQuery());
			//print_r($variants);
			//print_r($variantIDs);
			//print_r($variantSet);
			//print_r($variantPriceTable);
			//print_r($variantTable);
			//print_r($priceTable);
			//print_r($variantPrices);
			//print_r($cogsSubject);
			//print_r($cogsTable);
			//print_r($cogsByVariantID);
			//echo '</pre>';

			$currencyQuery =& new MBQuery(
				"GetOrderForms", "",
				array(
					"orderFormID" => $orderFormIDs,
					"getPaymentGroupData" => 1,
				)
			);
			if(!$this->addErrorsFromResult($currencyResult =& $currencyQuery->getResult())) break;

			$orderFormDetailSubject =& $currencyResult->getSubjectFrom(
				array("mbapi", "results", "orderForms", "orderForm"),
				"orderFormID"
			);
			$currencyIDs = array();
			$c = count($orderFormIDs);
			for($i = 0; $i < $c; $i++) {
				//$paymentGroupCurrencyIDSubject =& $orderFormDetailSubject->newFrom(array($i, "paymentGroups", "paymentGroup", 0, "paymentGroupCurrencyID", 0));
				$paymentGroupCurrencyIDSubject =& $orderFormDetailSubject->newFrom(array($i, "paymentGroupCurrencyID", 0));
				$currencyID = $paymentGroupCurrencyIDSubject->getData();
				$currencyIDs[$currencyID] = true;
			}
			$currencyIDs = array_keys($currencyIDs);

			$cycleSubject =& $r->getSubjectFrom(
				array("mbapi", "results", "products", "product", "ghostCycles", "ghostCycle"),
				"cycleID", "cycleDisplayName"
			);
			$cycles = $cycleSubject->getOptions();

			//echo '<pre>';
			//print_r($currencyIDs);
			//echo '</pre>';
			
			//echo '<pre>';

			if($product["productType"] == getTypeID("products", TRANS_DOMAIN_PRODUCT)) {
				$tldTable =& $r->getTableFrom(
					array("mbapi", "results", "products", "product", "ghostTLDs", "ghostTLD"),
					"tldID", "tldName"
				);
				$TLDs = $tldTable->getOptions();
				$generalPriceType = getTypeID("price", TRANS_GENERAL);
				$setupPriceType = getTypeID("price", TRANS_SETUP);
				$transferPriceType = getTypeID("price", TRANS_TRANSFER);
				
				
				$questions = array();
				$tldPrices =& $priceTable->getAssociatedTablesBy("tldID");
				$tldCogs =& $cogsTable->getAssociatedTablesBy("tldID");
				//print_r($tldPrices);
				//print_r($tldCogs);
				foreach($TLDs as $tldID => $tldName) {
					$questions[$tldID] = array();
					if(isset($tldPrices[$tldID])) {
						$currencyPrices =& $tldPrices[$tldID]->getAssociatedTablesBy("currencyID");
					} else {
						$currencyPrices = false;
					}
					if(isset($tldCogs[$tldID])) {
						$currencyCogs =& $tldCogs[$tldID]->getAssociatedTablesBy("currencyID");
					} else {
						$currencyCogs = false;
					}
					//print_r($currencyPrices);
					//print_r($currencyCogs);
					foreach($currencyIDs as $currencyID) {
						$questions[$tldID][$currencyID] = array();
						
						if($tldPrices && isset($currencyPrices[$currencyID])) {
							// list() blows away references, so it isn't used
							$tmp =& $currencyPrices[$currencyID]->getAssociatedTablesByEach(array("cycleID", "productVariantPriceType"));
							$cyclePrices = $tmp[0];
							$typePrices = $tmp[1];
							
						} else {
							$cyclePrices = false;
							$typePrices = false;
						}
						
						if($tldCogs && isset($currencyCogs[$currencyID])) {
							// list() blows away references, so it isn't used
							$tmp =& $currencyCogs[$currencyID]->getAssociatedTablesByEach(array("cycleID", "productLedgerComment"));
							$cycleCogs = $tmp[0];
							$typeCogs = $tmp[1];
							
						} else {
							$cycleCogs = false;
							$typeCogs = false;
						}
						//echo 1;
						//print_r($cyclePrices);
						//echo 2;
						//print_r($typePrices);
						//echo 3;
						//print_r($cycleCogs);
						//echo 4;
						//print_r($typeCogs);
						
						if($typePrices) {
							if($typePrices && isset($typePrices[$setupPriceType])) {
								$priceData = $typePrices[$setupPriceType]->getOne();
							} else {
								$priceData = array("productVariantPriceAmount" => "0.00");
							}
							if($typeCogs && isset($typeCogs[$setupPriceType])) {
								$cogsData = $typeCogs[$setupPriceType]->getOne();
							} else {
								$cogsData = array("productLedgerDebit" => "0.00");
							}
							$setupPrice = array(
								$priceData['productVariantPriceAmount'],
								$cogsData['productLedgerDebit'],
								$priceData['productVariantPriceID'],
								$cogsData['productLedgerID'],
							);
							if(isset($priceData['productVariantID'])) {
								$setupPrice[] = $priceData['productVariantID'];
							} else if(isset($cogsData['productVariantID'])) {
								$setupPrice[] = $cogsData['productVariantID'];
							}
							if($typePrices && isset($typePrices[$transferPriceType])) {
								$priceData = $typePrices[$transferPriceType]->getOne();
							} else {
								$priceData = array("productVariantPriceAmount" => "0.00");
							}
							if($typeCogs && isset($typeCogs[$transferPriceType])) {
								$cogsData = $typeCogs[$transferPriceType]->getOne();
							} else {
								$cogsData = array("productLedgerDebit" => "0.00");
							}
							$transferPrice = array(
								$priceData['productVariantPriceAmount'],
								$cogsData['productLedgerDebit'],
								$priceData['productVariantPriceID'],
								$cogsData['productLedgerID'],
							);
							if(isset($priceData['productVariantID'])) {
								$transferPrice[] = $priceData['productVariantID'];
							} else if(isset($cogsData['productVariantID'])) {
								$transferPrice[] = $cogsData['productVariantID'];
							}
						} else {
							$setupPrice = $transferPrice = array(
								"0.00",
								"0.00",
								NULL,
								NULL,
								NULL,
							);
						}
						$questions[$tldID][$currencyID]['setup'] = $setupPrice;
						
						foreach($cycles as $cycleID => $cycleDisplayName) {
							if($cyclePrices && isset($cyclePrices[$cycleID])) {
								if($cyclePrices && isset($cyclePrices[$cycleID])) {
									$priceData = $cyclePrices[$cycleID]->getOne();
								} else {
									$priceData = array("productVariantPriceAmount" => "0.00");
								}
								if($cycleCogs && isset($cycleCogs[$cycleID])) {
									$cogsData = $cycleCogs[$cycleID]->getOne();
								} else {
									$cogsData = array("productLedgerDebit" => "0.00");
								}
								$price = array(
									$priceData['productVariantPriceAmount'],
									$cogsData['productLedgerDebit'],
									$priceData['productVariantPriceID'],
									$cogsData['productLedgerID'],
								);
								if(isset($priceData['productVariantID'])) {
									$price[] = $priceData['productVariantID'];
								} else if(isset($cogsData['productVariantID'])) {
									$price[] = $cogsData['productVariantID'];
								}
							} else {
								$price = array(
									"0.00",
									"0.00",
									NULL,
									NULL,
									NULL,
								);
							}
							$questions[$tldID][$currencyID][$cycleID] = $price;
						}

						$questions[$tldID][$currencyID]['transfer'] = $transferPrice;
					}
				}
			} else {
				$TLDs = false;				
				$neededPriceTypes = array(
					getTypeID("price", TRANS_GENERAL),
					getTypeID("price", TRANS_SETUP),
				);
				
				$questions = array();
				$currencyPrices =& $priceTable->getAssociatedTablesBy("currencyID");
				$currencyCogs =& $cogsTable->getAssociatedTablesBy("currencyID");
				foreach($currencyIDs as $currencyID) {
					$questions[$currencyID] = array();
					if(isset($currencyPrices[$currencyID])) {
						$cyclePrices =& $currencyPrices[$currencyID]->getAssociatedTablesBy("cycleID");
					} else {
						$cyclePrices = false;
					}
					if(isset($currencyCogs[$currencyID])) {
						$cycleCogs =& $currencyCogs[$currencyID]->getAssociatedTablesBy("cycleID");
					} else {
						$cycleCogs = false;
					}
					//print_r($cyclePrices);
					//print_r($cycleCogs);
					foreach($cycles as $cycleID => $cycleDisplayName) {
						$questions[$currencyID][$cycleID] = array();
						if($cyclePrices && isset($cyclePrices[$cycleID])) {
							$typePrices =& $cyclePrices[$cycleID]->getAssociatedTablesBy("productVariantPriceType");
						} else {
							$typePrices = false;
						}
						if($cycleCogs && isset($cycleCogs[$cycleID])) {
							$typeCogs =& $cycleCogs[$cycleID]->getAssociatedTablesBy("productLedgerComment");
						} else {
							$typeCogs = false;
						}
						//echo $cycleID . ": ";
						//print_r($typePrices);
						//print_r($typeCogs);
						foreach($neededPriceTypes as $neededPriceType) {
							if($cyclePrices && $typePrices && isset($typePrices[$neededPriceType])) {
								$priceData = $typePrices[$neededPriceType]->getOne();
								if(isset($typeCogs[$neededPriceType])) {
									$cogsData = $typeCogs[$neededPriceType]->getOne();
								} else {
									$cogsData = array("productLedgerDebit" => "0.00");
								}
								$price = array(
									$priceData['productVariantPriceAmount'],
									$cogsData['productLedgerDebit'],
									$priceData['productVariantPriceID'],
									$cogsData['productLedgerID'],
								);
								if(isset($priceData['productVariantID'])) {
									$price[] = $priceData['productVariantID'];
								} else if(isset($cogsData['productVariantID'])) {
									$price[] = $cogsData['productVariantID'];
								}
							} else {
								$price = array(
									"0.00",
									"0.00",
									NULL,
									NULL,
									NULL,
								);
							}
							$questions[$currencyID][$cycleID][$neededPriceType] = $price;
						}
					}
				}
			}
			
			//print_r($priceTable);
			//print_r($r);
			//print_r($TLDs);
			//print_r($currencyPrices);
			//print_r($product);
			//echo '<pre>';
			//print_r($questions);
						
			//echo '</pre>';

			$this->smartyVars['questions'] = $questions;
			$this->smartyVars['product'] = $product;
			$this->smartyVars['cycles'] = $cycles;
			$this->smartyVars['TLDs'] = $TLDs;
			
			$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
			$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
			$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
			$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
 			$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
			 
			$formDefaults = array(); //$prices;
			$this->mergeFormState($formDefaults);
			$this->addTemplate("widgets/products/EditProductPrices");
		} while (false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>