<?php
// $Id: EditProductServerGroupsResponse.php 10474 2007-01-11 23:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditProductServerGroups action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  Ben Woolley
 */
class EditProductServerGroupsResponse extends MB_Action {
	/**
	 * The constructor for an EditProductServerGroupsResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductServerGroupsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductServerGroupsResponse";
		$this->params = array(
			"productID",
			"serverGroups",
		);
	}

	/**
	 * The main method of this class that executes the EditProductServerGroupsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT,
			),
			array(),
			array(),
			0,
			array("loadActionFile"=>"products","loadActionID"=>getActionID("EditProductServerGroups"))
		);
		if($success) {

			$productID = ((int) $_REQUEST["productID"]);
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {
 				$params = array();
				$this->applyRequestTo(
					$params,
					array(
						'serverGroups',
					)
				);

				$q =& new MBQuery(
					"GetProducts", "",
					array(
						"productID" => $productID,
						"getServerGroupGhostData" => 1,
					)
				);
				$r =& $q->getResult();
				
				$serverGroups =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", "ghostServerGroups", "ghostServerGroup"),
					"serverGroupID"
				);
				$relParams = $this->getRelationParamsFromSubject($serverGroups, "serverGroupIDs", "serverGroupID", "serverGroups");
				$params += $relParams;

				if($relParams) {
					$setQuery =& new MBQuery("SetProducts", "update", $params);
					$setResult =& $setQuery->getResult();
					$skipSuccess = false;
				} else {
					$skipSuccess = true;
				}
											
				if($skipSuccess || $setResult->getSuccess()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect(
							"products.php", getActionID("EditProductServerGroups"),
							array(
								"productID" => $productID,
								"loadActionFile" => "products",
								"loadActionID" => getActionID("EditProductServerGroups"),
							)
						);
					}
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
