<?php
// $Id: EditTLD.php 12900 2008-04-25 23:18:35Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["tldID"] and displays all
 * the TLD detail information for editing.
 *
 * @author  modernbill
 */
class EditTLD extends MB_Action {

	function EditTLD() {
		parent::MB_Action();
		$this->stringRep = "EditTLD";
		$this->params = array("tldID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$tldID = getParam('tldID');
		if(!$tldID) {
			$this->addError(TRANS_ACTIONERROR, "No TLD ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetTLDs", "", array("getOrderFormData" => 1, "getCycleData" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				//$this->smartyVars["TLDs"] = collapseArrayElements(protectArray($results["TLDs"][0]["TLD"]));
				$this->smartyVars["tldRenewTypes"] = $CONF["types"]["tldRenew"];
				$this->smartyVars["enabledDisabled"] = array(TRANS_DISABLED, TRANS_ENABLED);
				$this->smartyVars["yesNo"] = array(TRANS_YES, TRANS_NO);
				$this->smartyVars["transferTypes"] = $CONF["types"]["tldTransfer"];
				$this->smartyVars["IDNTypes"] = $CONF["types"]["tldIDN"];

				$tld = collapseArrayElements($results["TLDs"][0]["TLD"][0]);
				$thisTLD = $tld["tldExtension"];
				loadConfigs("domain");

				//saveStateOfCONF();
				$registrarData = $CONF["domain"]["registrar"];
				$registrars = array();
				foreach($registrarData as $registrar => $attrs) {
					$registrars[0] = " ";
					if(isset($attrs['configGroupID'])) {
						//See if this registrar is capable of registering this TLD
						if($registrar) {
							$registrarFile = secureinput(strtolower($registrar));
							if(file_exists(mb_path("/lib-mbapi/include/modules/registrar/$registrarFile.php"))) {
								require_once mb_path("/lib-mbapi/include/modules/registrar/$registrarFile.php");
	
								$r =& new $registrar(array('configGroupID'=>$attrs["configGroupID"]));
								$tlds = $r->capabilities[REGISTRAR_TLDS];

								if(in_array($thisTLD, (array) $tlds)) {
									$registrars[$attrs['configGroupID']] = $registrar;
								}
							}
						}
					}
				}
				$this->smartyVars["registrars"] = $registrars;
				
				$this->mergeCycleData();

				$this->smartyVars["TLD"] = $tld;

				$formDefaults = $tld;
								
				$this->mergeFormState($formDefaults);

				$this->addTemplate("products/EditTLD", $this->smartyVars);
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>