<?php
// $Id: ShowProductAddons.php 8185 2006-08-01 17:58:14Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all productaddons that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowProductAddons extends MB_ProductAction {
	/**
	 * The constructor for the entry point of product addons.
	 */
	function ShowProductaddons() {
		parent::MB_ProductAction("children");
		$this->stringRep = "ShowProductAddons";
	}

	/**
	 * The main method of this class that executes the ShowProductAddons action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if (!(int)$_REQUEST["productID"]){
			$this->addError(TRANS_ACTIONERROR, "No Product ID given.");
		} else {

			$this->productInfo = correctArray(grabFirstResultFromMBAPIArray(
				array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"getProductAttributeData" => 1,
							"getProductChildData" => 1,
							"getProductVariantPriceData" => 1,
							"getEmailTemplateData" => 1,
							"getEmailActionGroupData" => 1,
							"getCouponData" => 1,
							"getOrderFormData" => 1,
							"getProductVariantData" => 1,
							"getTLDData" => 1,
							"getCycleGhostData" => 1,
							"getServerGroupGhostData" => 1
						)
					)
				)
			));
			$this->smartyVars["product"] =& $this->productInfo;
			$this->smartyVars["canDoAddons"] = count($this->smartyVars["product"]["productAttributes"]);
			$types = $CONF["types"]["products"];
			$this->smartyVars['types'] = $types;


			$this->serverGroups = correctArray(
				grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetServerGroups",
						"params" => array()
					)
				))
			);
			$this->keyedServerGroups = array();
			foreach ((array)$this->serverGroups as $k=>$group){
				$this->keyedServerGroups[$group["serverGroupID"]] =& $this->serverGroups[$k];
			}
			$this->smartyVars["serverGroups"] =& $this->keyedServerGroups;

			$this->setupTypeButtons($this->smartyVars["product"]["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$this->smartyVars["rawAddons"] = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"parentProductID" => $_REQUEST["productID"],
						"getProductAttributeData" => 1
					)
				)
			)));


			$this->smartyVars["addons"] = array();

			$groups = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProductAddonGroups",
					"params" => array(
						"getGroupsByProductID" => $_REQUEST["productID"],
					)
				)
			)));
			
			
			$this->smartyVars["addonGroups"] = array();
			foreach ((array)$groups as $group){
				$this->smartyVars["addons"][$group["productAddonGroupID"]] = array();
				$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
			}

			foreach ((array)$this->smartyVars["rawAddons"] as $addon){
				$this->smartyVars["addons"][$addon["productAddonGroupID"]][] = $addon;
			}

			$this->smartyVars["addoninputs"] = getTypes("addoninputs");

			$this->addTemplate("widgets/products/ShowProductAddons", $this->smartyVars);

		}
			
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowProducts
?>
