<?php
// $Id: ShowProducts.php 12386 2007-12-21 23:43:39Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowProducts extends ShowAction {
	/**
	 * The constructor for a ShowProducts action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowProducts() {
		$this->setDataSource(
			new DataSource(
				":products",
				array(
					"productAddonGroupID" => "",
					"productVendorRels" => array(),
					"packages" => array(
						"packageActive" => "true",
						"packageStatus" => "none",
						"aggregate" => array("function" => "count"),
						"groupBy" => array("column" => "productID"),
					),
				)
			)
		);
		parent::ShowAction();
		$this->stringRep = "ShowProducts";
		// define all possible params that we will accept
		$this->params = array
		(
			"productID",
			"productName",
		);

	}

	/**
	 * showHandler method to link into execution
	 */
	function showHandler() {	
		$products = $this->d->getEssential();
		$this->smartyVars["packageCounts"] = array();
		$vendorIDs = array();
		foreach($products as $product) {
			if ($product["productVendorRels"] && $product["productVendorRels"][0]){
				$vendorIDs[] = $product["productVendorRels"][0]["vendorID"];
			}
			if($packageCount = $product["packages"][0]["packageID.count"]) {
				$this->smartyVars["packageCounts"][$product["productID"]] = $packageCount;
			}
		}

		if(file_exists(mb_path("/lib-modernbill/include/config/vendor.php"))) {
			$this->smartyVars["vendorEnabled"] = true;
		}

		if ($vendorIDs){
			$this->smartyVars["vendors"] = optionsFor("vendors", array(
				"vendorID" => $vendorIDs,
			));
		} else {
			$this->smartyVars["noVendors"] = 1;
		}

       	$h = $this->d->getHeader();
		// set the sorting args for display
		$this->smartyVars["displaySortColumnName"] = $h[0]["sortColumnName"];
		$this->smartyVars["displaySortColumn"] = $h[0]["sortColumn"];
		$this->smartyVars["displaySortDir"] = $h[0]["sortDir"];

		if ($clientID = (int)$_REQUEST["clientID"]){
			$this->smartyVars["clientInfo"] = oneByID("clients", $clientID, array("mergePrimaryContact"=>1));
			$this->smartyVars["mode"] = $_REQUEST["mode"];
		} elseif ($tunnelVars = $_REQUEST["tunnelVars"]){
			$this->smartyVars["tunnelVars"] = $tunnelVars;
		}
		if((int)$_REQUEST["configGroupID"]) {
			$this->smartyVars["configGroupID"] = (int)$_REQUEST["configGroupID"];
		}
		if((int)$_REQUEST["serverGroupID"]) {
			$this->smartyVars["serverGroupID"] = (int)$_REQUEST["serverGroupID"];
		}

	}
} // ShowProducts
?>
