<?php
// $Id: ShowReportAction.php 10388 2006-12-29 18:09:13Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It has member methods to populate some
 * common smarty variables for each report action.
 *
 * @author  Kris Bailey
 */
class ShowReportAction extends MB_Action {
	/**
	 * Constructor run the parents constructor.
	 */
	function ShowReportAction() {
		parent::MB_Action();
		$this->stringRep = "ShowReportAction";
	}

	/**
	 * Executes parents execute.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
	} // execute


	function mergeReportsData(){
		$this->sourcePath = $sourcePath = mb_path("/app-modernbill-admin/include/lib-action/reports/sources");
	
		$files = getMatchingFilesInDir($sourcePath, "^.*[.].*[.]php\$"); // preg match regex
		$this->smartyVars["reportGroupNames"] = array(
			"Accounting" => "TRANS_REPORTS_ACCOUNTING_REPORTS",
			"Clients" => "TRANS_REPORTS_CLIENT_REPORTS",
			"Invoices" => "TRANS_REPORTS_INVOICE_REPORTS",
			"Packages" => "TRANS_REPORTS_PACKAGE_REPORTS",
			"Products" => "TRANS_REPORTS_PRODUCT_REPORTS",
			"Tax" => "TRANS_REPORTS_TAX_REPORTS",
			"Coupons" => "TRANS_REPORTS_COUPON_REPORTS",
			"Transactions" => "TRANS_REPORTS_TRANSACTION_REPORTS",
			"General" => "TRANS_REPORTS_GENERAL_REPORTS",
		);
		
		$this->smartyVars["reportGroups"] = array();
		
		$this->smartyVars["totalReports"] = count($files);
		$this->smartyVars["firstColNum"] = floor($this->smartyVars["totalReports"]/2);
		
		foreach ($files as $file){
			list($cat, $name, $fname) = $this->getNamePieces($file);
			if (!$this->smartyVars["reportGroupNames"][$cat]){
				$cat = "General";
			}
			$this->smartyVars["reportGroups"][$cat][$fname] = variableToHuman($name);
		}
	
	}

	function getNamePieces($name){
		$p = explode(".", $name);
		return array($p[0], $p[1], $p[0].".".$p[1]);
	}


} // ShowReportAction
?>