<?php
// $Id: ShowReportContainer.php 10415 2007-01-04 18:53:53Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/reports/ShowReportAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It will display a mini invoice report.
 *
 * @author  Kris Bailey
 */
class ShowReportContainer extends ShowReportAction {
	/**
	 * The constructor for a ShowReports action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowReportContainer() {
		parent::ShowReportAction();
		$this->stringRep = "ShowReportContainer";
	}

	/**
	 * The main method of this class that executes the ShowReportContainer action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->mergeReportsData();
		list($category, $name, $fullName) = $this->getNamePieces($_REQUEST["reportName"]);
		
		require_once mb_path($this->sourcePath."/".$fullName.".php");
		
		$this->smartyVars["reportInfo"] = (array)$CONF["reportData"][$fullName]+array("reportName" => $fullName);
		$rn = "MB_Report_".$name;
		$report =& new $rn();
		$this->smartyVars = $this->smartyVars + (array)$report->getParamData($_REQUEST);

		$this->smartyVars["tunnelVars"] = base64_encode(serialize($_REQUEST));

		$this->addTemplate("reports/ShowReportContainer", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute
} // ShowReportContainer
?>