<?php
// $Id: ClientStatusReportData.php 9130 2006-09-23 16:41:05Z mfountain $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",5)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-action/include/reports/Reports.php");

/**
 * This is the client list report.  The basic requirements for a report class are that you
 * override 3 functions: generateReport(); // this function gets and formats ALL of the data for this report
 *			 getOutput(); // this function gets output meant to be displayed by a smarty template
 *			 getGraphOutput(); // this function gets output meant to be used for a graph generating class
 *
 *
 */

class ClientStatusReportDataReport extends MB_Report {

	// constructor for report
	function ClientStatusReportDataReport($params){
		parent::MB_Report($params);
		$this->stringRep = "ClientStatusReportDataReport";
	}

	function generateReport(){
		global $CONF;
		
		// get the query object
		$clientQuery =& new MBQuery("GetClients", "", array(
			"getClientStats" => 1,
			"clientActive" => 1));
		dbg($clientQuery->getXMLQuery());

		// get this data
		$clientResult =& $clientQuery->getResult();
		$s =& $clientResult->getSubjectFrom(array("mbapi","results","clients","client"));
		$this->rawData["clients"] = $s->getCollapsed();
	
	}
	
	function getOutput(){
		global $CONF;
		return $this->data["clients"];
	}

	function getGraphOutput(){
		global $CONF;

		/* BEFORE
		$this->rawData["clients"]
		(
		    [0] => Array
		        (
		            [clientStatus] => 0
		            [numClients] => 13
		        )
			...etc...
		)
		*/

		$totals = array();

		$n = count($this->rawData["clients"]);
		for($i=0;$i<$n;$i++){
			$totals[$this->rawData["clients"][$i]["clientStatus"]] = (int)$this->rawData["clients"][$i]["numClients"];
		}

		/* AFTER
		$totals
		(
		    [0] => 13
		    [1] => 31
		    [2] => 67
		) 
		*/

		// get the list of client statuses
		$statuses = getStatuses("client");
		
		dbg($statuses);
		dbg($totals);

		// y-axis data values
		$graphData["yScale"] = "lin";

		$x = 0;
		$colors = array("red", "green", "blue", "purple", "yellow", "black");
		foreach ($statuses as $id=>$val){
			$graphData["xLegend"][$x] = $val;
			$graphData["yColor"][$x] = $colors[$x];
			$x++;
		}

		// x-axis data values
		$graphData["xScale"] = "dat";

		// set data for each status
		$x = 0;
		foreach ($statuses as $k=>$v){

			$graphData["xPlots"][] = $k;
			$graphData["xPlotLabels"][] = $v."(".(int)$totals[$k].")";
			$graphData["yPlots"][0][] = (int)$totals[$k];
			$graphData["pPlots"][0][] = (int)$totals[$k];
			$graphData["pPlotLabels"][] = $v." (".(int)$totals[$k].")";

		}
		dbg($graphData);
		return $graphData;
		
	}

}
?>
