<?php
// $Id: ClientTrendReportData.php 9061 2006-09-21 03:29:46Z mfountain $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",5)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-action/include/reports/Reports.php");

/**
 * This is the client list report.  The basic requirements for a report class are that you
 * override 3 functions: generateReport(); // this function gets and formats ALL of the data for this report
 *			 getOutput(); // this function gets output meant to be displayed by a smarty template
 *			 getGraphOutput(); // this function gets output meant to be used for a graph generating class
 *
 *
 */

class ClientTrendReportData extends MB_Report {

	/**
	 * An array containing the full date range for this trend report.
	 */
	var $dateRange;

	/**
	 * The primary range for this this trend report.
	 * Possible values: today, thisWeek, thisMonth, thisQuarter, thisYear
	 */
	var $primaryRange;

	/**
	 * The secondary range for this trend report.
	 * Possible values: yesterday, lastWeek, lastMonth, lastQuarter, lastyear 
	 */
	var $secondaryRange;

	/**
	 * Constructor
	 */
	function ClientTrendReportData($params){
		parent::MB_Report($params);
		$this->stringRep = "ClientTrendReportData";

		$primaryRanges = array("today", "thisWeek", "thisMonth", "thisQuarter", "thisYear");
		$secondaryRanges = array("yesterday", "lastWeek", "lastMonth", "lastQuarter", "lastYear");

		if (in_array($_REQUEST["primaryRange"],$primaryRanges)) {
			$this->primaryRange = $_REQUEST["primaryRange"];
		} else {
			$this->primaryRange = "thisMonth";
		}

		if (in_array($_REQUEST["secondaryRange"],$secondaryRanges)) {
			$this->secondaryRange = $_REQUEST["secondaryRange"];
		} else {
			$this->secondaryRange = "lastMonth";
		}

		$this->dateRange = array();
	}

	/**
	 * 
	 */
	function generateReport(){
		global $CONF;
		
		$args = array();

		if ($this->primaryRange=="today") {

			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m"),date("d"),date("Y"));
			$args["clientDateCreatedGreatest"] = mktime();
			$this->rawData["legend"] = date("Y/m/d",$args["clientDateCreatedLeast"]);

		} else if ($this->primaryRange=="thisWeek") {

			$dayOfWeek = date("w");
			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m"),date("d")-$dayOfWeek,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime();
			$this->rawData["legend"] = date("Y/m/d",$args["clientDateCreatedLeast"]);

			// build padding
			#for($i=0;$i<=6;$i++){
			#	$trendPadding[] =  
			#}

		} else if ($this->primaryRange=="thisMonth") {

			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m"),1,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime();
			$this->rawData["legend"] = date("Y/m",$args["clientDateCreatedLeast"]);

			// build padding for the range
			$daysInMonth = 31;//date("t");
			for($i=1;$i<=$daysInMonth;$i++){
				$this->dateRange[0][$i] = 0;
			}

		} else if ($this->primaryRange=="thisQuarter") {

			$monthOfYear = date("m");
			if ($monthOfYear <= 3) {
				$startOfQuarter = 1;
			} else if ($monthOfYear <= 6) {
				$startOfQuarter = 4;
			} else if ($monthOfYear <= 9) {
				$startOfQuarter = 7;
			} else if ($monthOfYear <= 12) {
				$startOfQuarter = 10;
			}
			$args["clientDateCreatedLeast"] = mktime(0,0,0,$startOfQuarter,1,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime();
			$this->rawData["legend"] = date("Y/m",$args["clientDateCreatedLeast"]);

		} else if ($this->primaryRange=="thisYear") {

			$args["clientDateCreatedLeast"] = mktime(0,0,1,1,1,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime();
			$this->rawData["legend"] = date("Y",$args["clientDateCreatedLeast"]);

			// build padding for the range
			for($i=1;$i<=12;$i++){
				$this->dateRange[0][$i] = 0;
				$this->xPlotLabels[] = $CONF["user"]["locale"]->localeArray["locale_month_abbreviated_".$i];
			}

		} else if ($this->primaryRange=="yesterday") {

			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m"),date("d")-1,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime(0,0,0,date("m"),date("d"),date("Y"));
			$this->rawData["legend"] = date("Y/m/d",$args["clientDateCreatedLeast"]);

		} else if ($this->primaryRange=="lastWeek") {

			$dayOfWeek = date("z");
			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m"),date("d")-$dayOfWeek-7,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime(0,0,0,date("m"),date("d")-$dayOfWeek,date("Y"));
			$this->rawData["legend"] = date("Y/m/d",$args["clientDateCreatedLeast"]);

		} else if ($this->primaryRange=="lastMonth") {

			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m")-1,1,date("Y"));
			$args["clientDateCreatedGreatest"] = mktime(0,0,0,date("m"),1,date("Y"));
			$this->rawData["legend"] = date("Y/m",$args["clientDateCreatedLeast"]);

			// build padding for the range
			$daysInMonth = 31;//date("t");
			for($i=1;$i<=$daysInMonth;$i++){
				$this->dateRange[1][$i] = 0;
			}

		} else if ($this->primaryRange=="lastQuarter") {

			$yearVar = 0;
			$monthOfYear = date("m");
			if ($monthOfYear <= 3) {
				$startOfQuarter = 10;
				$endOfQuarter = 12;
				$yearVar = 1;
			} else if ($monthOfYear <= 6) {
				$startOfQuarter = 1;
				$endOfQuarter = 3;
			} else if ($monthOfYear <= 9) {
				$startOfQuarter = 4;
				$endOfQuarter = 6;
			} else if ($monthOfYear <= 12) {
				$startOfQuarter = 7;
				$endOfQuarter = 9;
			}
			$args["clientDateCreatedLeast"] = mktime(0,0,0,$startOfQuarter,1,date("Y")-$yearVar);
			$args["clientDateCreatedGreatest"] = mktime(0,0,0,$endOfQuarter+1,0,date("Y")-$yearVar);
			$this->rawData["legend"] = date("Y/m",$args["clientDateCreatedLeast"]);

		} else if ($this->primaryRange=="lastYear") {

			$args["clientDateCreatedLeast"] = mktime(0,0,0,1,1,date("Y")-1);
			$args["clientDateCreatedGreatest"] =mktime(0,0,0,12,31,date("Y")-1);
			$this->rawData["legend"] = date("Y",$args["clientDateCreatedLeast"]);

			// build padding for the range
			for($i=1;$i<=12;$i++){
				$this->dateRange[1][$i] = 0;
			}

		} else {

			$args["clientDateCreatedLeast"] = mktime(0,0,0,date("m"),date("d"),date("Y"));
			$args["clientDateCreatedGreatest"] = mktime();
			$this->rawData["legend"] = date("Y/m/d",$args["clientDateCreatedLeast"]);

		}

		$startDay = floor($args["clientDateCreatedLeast"] / 86400);
		$endDay = floor($args["clientDateCreatedGreatest"] / 86400);

		// get the query object
		$args["getClientTrend"] = 1;
		$args["groupClientTrendBy"] = "day";

		$clientQuery =& new MBQuery("GetClients", "", $args);
		dbg($clientQuery->getXMLQuery());

		// get this data
		$clientResult =& $clientQuery->getResult();
		$s =& $clientResult->getSubjectFrom(array("mbapi","results","clients","client"));
		$this->rawData["clients"] = $s->getCollapsed();

	}
	
	function getOutput(){
		global $CONF;
		return $this->data["clients"];
	}

	function getGraphOutput(){
		global $CONF;

		/* BEFORE
		$this->rawData["clients"]
		(
		    [0] => Array
		        (
		            [numClients] => 3
		            [clientDayCreated] => 13385
		        )
			...etc...
		)
		*/

		// assign primary range
		$data[1] = $this->rawData["clients"];
		$graphData["yLegend"][1] = $this->rawData["legend"];

		// generate secondary range
		$this->primaryRange = $this->secondaryRange;
		$this->generateReport();

		// assign secondary range
		$data[0] = $this->rawData["clients"];
		$graphData["yLegend"][0] = $this->rawData["legend"];

		// loop through ranges
		$n = count($data);
		for($i=0;$i<$n;$i++){
			// loop through results in each range
			$nn = count($data[$i]);
			for($j=0;$j<$nn;$j++){
				if ($_REQUEST["byMonth"]) {
					$_month = date("n",$data[$i][$j]["clientDayCreated"]*86400);
					$this->dateRange[$i][$_month] += (int)$data[$i][$j]["numClients"];
				} else {
					$_day = date("j",$data[$i][$j]["clientDayCreated"]*86400);
					/////$this->dateRange[$i][$data[$i][$j]["clientDayCreated"]] = (int)$data[$i][$j]["numClients"];
					$this->dateRange[$i][$_day] = (int)$data[$i][$j]["numClients"];
				}
			}
			ksort($this->dateRange[$i]);
		}

#show($this->dateRange); exit;

		/* AFTER
		$dailyTotals
		(
		    [13149] => 1
		    [13150] => 6
		    [13151] => 4
			...
		) 
		$monthlyTotals
		(
		    [1] => 133
		    [2] => 160
		    [3] => 128
			...
		)
		*/

		// set the colors
		$colors = array("#4BA5FF","#3CB300");
		$gradients = array("#328BE5","#39AA00");

		if ($_REQUEST["byMonth"]) {
			// loop through ranges
			$n = count($data);
			for($i=0;$i<$n;$i++){
				$graphData["xPlots"] = $graphData["xPlotLabels"] = array();
				$graphData["yColor"][$i] = $colors[$i];
				$graphData["yColorGradient"][$i] = $gradients[$i];
				foreach($this->dateRange[$i] as $month => $num) {
					$graphData["yPlots"][$i][] = $num;
					$graphData["xPlots"][] = $month;
				}
			}
		} else {
			// loop through ranges
			$n = count($data);
			for($i=0;$i<$n;$i++){
				$graphData["xPlots"] = $graphData["xPlotLabels"] = array();
				$graphData["yColor"][$i] = $colors[$i];
				$graphData["yColorGradient"][$i] = $gradients[$i];
				foreach($this->dateRange[$i] as $day => $num) {
					$graphData["yPlots"][$i][] = $num;
					$graphData["xPlots"][] = $day;
					#$graphData["xPlotLabels"][] = date("Y/m/d",(($day+1)*86400))."($num)";
				}
			}
		}

		// set xLabels
		if ($this->xPlotLabels) {
			$graphData["xPlotLabels"] = $this->xPlotLabels;
		}

		// show line values
		$graphData["lineValues"] = true;

		// x-axis data values
		$graphData["xScale"] = "lin";

		// y-axis data values
		$graphData["yScale"] = "lin";

		return $graphData;
		
	}

}
?>
