<?php

$CONF["reportData"]["Accounting.RecurringRevenue"] = array(
	"version" => "1.0",
	"template" => dirname(__FILE__)."/Accounting.RecurringRevenue.tpl",
	"name" => "Recurring Revenue",
	"description" => "The recurring revenue report will tell you the amount of money you invoiced for, or will invoice for in a specific date range.",
);


class MB_Report_RecurringRevenue {

	function MB_Report_RecurringRevenue(){
		// constructor, nothing necessary in here I guess
	}

	function getData($params){
		$ret = $this->getParamData($params);
		
		$this->beginMonth = (int)$_REQUEST["mrrBeginMonth"];
		$this->beginDay = (int)$_REQUEST["mrrBeginDay"];
		$this->beginYear = (int)$_REQUEST["mrrBeginYear"];

		$this->endMonth = (int)$_REQUEST["mrrEndMonth"];
		$this->endDay = (int)$_REQUEST["mrrEndDay"];
		$this->endYear = (int)$_REQUEST["mrrEndYear"];

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;

		
		if (!(int)$ret["displayParams"] && numClients<2501){
		
			$all = dispatchMBAPI(array(
				"mbapi" => array(
					"command" => "ProcessInvoices",
					"params" => array(
						"overrideLimits" => 1,
						"displayTotalsOnly" => 1,
						"generateInvoicePreview" => 1,
						"packageDateNextRenewalLessThan" => $this->endTime,
						"domainDateNextRenewalLessThan" => $this->endTime,
					),
				),
			), 1);
			
			$upto = dispatchMBAPI(array(
				"mbapi" => array(
					"command" => "ProcessInvoices",
					"params" => array(
						"overrideLimits" => 1,
						"displayTotalsOnly" => 1,
						"generateInvoicePreview" => 1,
						"packageDateNextRenewalLessThan" => $this->startTime,
						"domainDateNextRenewalLessThan" => $this->startTime,
					),
				),
			), 1);
			
			$allTotalsRaw = correctArray($all["mbapi"][0]["results"][0]["totals"][0]);
			$uptoTotalsRaw = correctArray($upto["mbapi"][0]["results"][0]["totals"][0]);
			
			$allProductTotals = correctArray($all["mbapi"][0]["results"][0]["productTotals"][0]);
			$uptoProductTotals = correctArray($upto["mbapi"][0]["results"][0]["productTotals"][0]);
			
			$allUsageTotals = correctArray($all["mbapi"][0]["results"][0]["usageTotals"][0]);
			$uptoUsageTotals = correctArray($upto["mbapi"][0]["results"][0]["usageTotals"][0]);
			
			$productIDs = array();
			
			$totals = array();
			foreach ((array)$allTotalsRaw as $currencyID=>$amt){
				if (strlen($currencyID)==3){
					$totals[$currencyID] += $amt;
				}
			}
			foreach ((array)$uptoTotalsRaw as $currencyID=>$amt){
				if (strlen($currencyID)==3){
					$totals[$currencyID] -= $amt;
				}
			}
			
			$productTotals = array();
			foreach ((array)$allProductTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["productTotalAmount"][$currencyID] += $pin["amount"];
						$productTotals[$currencyID][$pin["productID"]] += $pin["amount"];
					}
				}
			}
			foreach ((array)$uptoProductTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["productTotalAmount"][$currencyID] -= $pin["amount"];
						$productTotals[$currencyID][$pin["productID"]] -= $pin["amount"];
					}
				}
			}
			
			$usageTotals = array();
			foreach ((array)$allUsageTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["usageTotalAmount"][$currencyID] += $pin["amount"];
						$usageTotals[$currencyID][$pin["productID"]] += $pin["amount"];
					}
				}
			}
			foreach ((array)$uptoUsageTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["usageTotalAmount"][$currencyID] -= $pin["amount"];
						$usageTotals[$currencyID][$pin["productID"]] -= $pin["amount"];
					}
				}
			}
			
			
			$invoiceAmounts = grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetLineItemProductTotals",
					"params" => array(
						"startDate" => $this->startTime,
						"endDate" => $this->endTime,
					),
				),
			));
			
			foreach ((array)$invoiceAmounts as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$totals[$currencyID] += $pin["amount"]+$pin["usageAmount"];
						$ret["productTotalAmount"][$currencyID] += $pin["amount"];
						$ret["usageTotalAmount"][$currencyID] += $pin["usageAmount"];
						if ($pin["amount"]>0) $productTotals[$currencyID][$pin["productID"]] += $pin["amount"];
						if ($pin["usageAmount"]>0) $usageTotals[$currencyID][$pin["productID"]] += $pin["usageAmount"];
					}
				}
			}
			
			
			$productIDs = array_keys($productIDs);
			
			$ret["productNames"] = optionsFor(":products", array(
				"productID" => $productIDs,
			));
			
			
			$ret["startTime"] = $this->startTime;
			$ret["endTime"] = $this->endTime;
			
			$ret["totals"] = $totals;
			$ret["productTotals"] = $productTotals;
			$ret["usageTotals"] = $usageTotals;
			
			
			ksort($ret["productTotals"]);
			ksort($ret["usageTotals"]);
			ksort($ret["totals"]);
		} elseif (!(int)$ret["displayParams"]){
			$ret["toManyClients"] = 1;
		}
		
		return $ret;
	}
	
	function getParamData($params=array()){
		
		$ret = array();
		
		// test for the presence of something that will always be there when we are going to generate the report
		// and have already specified some parameters
		$ret["displayParams"] = ((int)$params["mrrBeginMonth"])?0:1;
		
		$ret["sevenDaysStart"] = $ret["thirtyDaysStart"] = explode("/", date("d/m/Y", ($ret["sevenDaysStartTime"] = $ret["thirtyDaysStartTime"] = time()-(time()%(60*60*24)))));
		$ret["sevenDaysEnd"] = explode("/", date("d/m/Y", $ret["sevenDaysEndTime"] = ($ret["sevenDaysStartTime"] + (60*60*24*7) - 1)));
		$ret["thirtyDaysEnd"] = explode("/", date("d/m/Y", $ret["thirtyDaysEndTime"] = ($ret["thirtyDaysStartTime"] + (60*60*24*30) - 1)));
		$datePieces = explode("/", date("m/Y"));
		$ret["lastMonthStart"] = explode("/", date("d/m/Y", $ret["lastMonthStartTime"] = mktime(0,0,0,$datePieces[0]-1,1,$datePieces[1])));
		$ret["lastMonthEnd"] = explode("/", date("d/m/Y", $ret["lastMonthEndTime"] = mktime(0,0,0,$datePieces[0],1,$datePieces[1])-1));
		
		return $ret;
	
	}

}