<?php

$CONF["reportData"]["Clients.RangedDailySignupReport"] = array(
	"version" => "1.0",
	"template" => dirname(__FILE__)."/Clients.RangedDailySignupReport.tpl",
	"name" => "Ranged Daily Signup Report",
	"description" => "This is a list of the clients that signed up in a particular date range, grouped by day, and totaled daily, and for the range.  The revenue from their signup invoices is also included.",
);


class MB_Report_RangedDailySignupReport {

	function MB_Report_RangedDailySignupReport(){
		// constructor, nothing necessary in here I guess
	}

	function getData($params){
		$ret = $this->getParamData($params);
		
		list($m, $d, $y) = explode("/", date("m/d/Y"));
		
		require_once mb_path("/app-modernbill-api/include/lib-action/api/GetReportDailySignups.php");

		$r =& new GetReportDailySignups();
		$ret = $ret + (array)$r->getReportData();
		
		return $ret;
	}
	
	function getParamData($params=array()){
		
		$ret = array();
		
		// test for the presence of something that will always be there when we are going to generate the report
		// and have already specified some parameters
		$ret["displayParams"] = ((int)$params["signupSheetBeginMonth"])?0:1;
		
		$ret["sevenDaysStart"] = $ret["thirtyDaysStart"] = explode("/", date("d/m/Y", ($ret["sevenDaysStartTime"] = $ret["thirtyDaysStartTime"] = time()-(time()%(60*60*24))-(24*60*60*7))));
		$ret["thirtyDaysStartTime"] -= (24*60*60*23);
		$ret["sevenDaysEnd"] = explode("/", date("d/m/Y", $ret["sevenDaysEndTime"] = ($ret["sevenDaysStartTime"] + (60*60*24*7) - 1)));
		$ret["thirtyDaysEnd"] = explode("/", date("d/m/Y", $ret["thirtyDaysEndTime"] = ($ret["thirtyDaysStartTime"] + (60*60*24*30) - 1)));
		$datePieces = explode("/", date("m/Y"));
		$ret["lastMonthStart"] = explode("/", date("d/m/Y", $ret["lastMonthStartTime"] = mktime(0,0,0,$datePieces[0]-1,1,$datePieces[1])));
		$ret["lastMonthEnd"] = explode("/", date("d/m/Y", $ret["lastMonthEndTime"] = mktime(0,0,0,$datePieces[0],1,$datePieces[1])-1));
		
		return $ret;
	
	}

}