<?php

$CONF["reportData"]["Packages.ExpectedRevenueReport"] = array(
	"version" => "1.0",
	"template" => dirname(__FILE__)."/Packages.ExpectedRevenueReport.tpl",
	"name" => "Expected Revenue",
	"description" => "The expected revenue report will work from the packages that you have existing and tell you what how much you are going to invoice for in the future.",
);


class MB_Report_ExpectedRevenueReport {

	function MB_Report_ExpectedRevenueReport(){
		// constructor, nothing necessary in here I guess
	}

	function getData($params){
		
		loadConfigs("billing");
		$invoiceSettings =& $CONF["billing"]["invoice"];
		$dueOffset = $invoiceSettings["invoice_due_offset"]*(60*60*24);
		
		if (!(int)$_REQUEST["dueInRange"]){
			$dueOffset = 0;
		}
		
		$ret = $this->getParamData($params);
		
		$this->beginMonth = (int)$_REQUEST["errBeginMonth"];
		$this->beginDay = (int)$_REQUEST["errBeginDay"];
		$this->beginYear = (int)$_REQUEST["errBeginYear"];

		$this->endMonth = (int)$_REQUEST["errEndMonth"];
		$this->endDay = (int)$_REQUEST["errEndDay"];
		$this->endYear = (int)$_REQUEST["errEndYear"];

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear) - $dueOffset;
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear) - 1 - $dueOffset;
		
		if (!(int)$ret["displayParams"] && numClients<2501){
		
			$all = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "ProcessInvoices",
					"params" => array(
						"overrideLimits" => 1,
						"displayTotalsOnly" => 1,
						"generateInvoicePreview" => 1,
						"packageDateNextRenewalLessThan" => $this->endTime,
						"domainDateNextRenewalLessThan" => $this->endTime,
					),
				),
			)), 1);
			
			$upto = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "ProcessInvoices",
					"params" => array(
						"overrideLimits" => 1,
						"displayTotalsOnly" => 1,
						"generateInvoicePreview" => 1,
						"packageDateNextRenewalLessThan" => $this->startTime,
						"domainDateNextRenewalLessThan" => $this->startTime,
					),
				),
			)), 1);
			
			dbg($all, 0, 1);
			dbg($upto, 0, 1);
			
			$allTotalsRaw = correctArray($all["mbapi"][0]["results"][0]["totals"][0]);
			$uptoTotalsRaw = correctArray($upto["mbapi"][0]["results"][0]["totals"][0]);
			
			$allProductTotals = correctArray($all["mbapi"][0]["results"][0]["productTotals"][0]);
			$uptoProductTotals = correctArray($upto["mbapi"][0]["results"][0]["productTotals"][0]);
			
			$allUsageTotals = correctArray($all["mbapi"][0]["results"][0]["usageTotals"][0]);
			$uptoUsageTotals = correctArray($upto["mbapi"][0]["results"][0]["usageTotals"][0]);
			
			$productIDs = array();
			
			$totals = array();
			foreach ((array)$allTotalsRaw as $currencyID=>$amt){
				if (strlen($currencyID)==3){
					$totals[$currencyID] += $amt;
				}
			}
			foreach ((array)$uptoTotalsRaw as $currencyID=>$amt){
				if (strlen($currencyID)==3){
					$totals[$currencyID] -= $amt;
				}
			}
			
			$productTotals = array();
			foreach ((array)$allProductTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["productTotalAmount"][$currencyID] += $pin["amount"];
						$productTotals[$currencyID][$pin["productID"]] += $pin["amount"];
					}
				}
			}
			foreach ((array)$uptoProductTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["productTotalAmount"][$currencyID] -= $pin["amount"];
						$productTotals[$currencyID][$pin["productID"]] -= $pin["amount"];
					}
				}
			}
			
			$usageTotals = array();
			foreach ((array)$allUsageTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["usageTotalAmount"][$currencyID] += $pin["amount"];
						$usageTotals[$currencyID][$pin["productID"]] += $pin["amount"];
					}
				}
			}
			foreach ((array)$uptoUsageTotals as $currencyID=>$prods){
				if (strlen($currencyID)==3){
					foreach ($prods as $x=>$pin){
						$productIDs[$pin["productID"]] = 1;
						$ret["usageTotalAmount"][$currencyID] -= $pin["amount"];
						$usageTotals[$currencyID][$pin["productID"]] -= $pin["amount"];
					}
				}
			}
			
			
			$productIDs = array_keys($productIDs);
			
			$ret["productNames"] = optionsFor(":products", array(
				"productID" => $productIDs,
			));
			
			$ret["dueInRange"] = (int)$_REQUEST["dueInRange"];
			$ret["startTime"] = $this->startTime + $dueOffset;
			$ret["endTime"] = $this->endTime + $dueOffset;
			
			$ret["totals"] = $totals;
			$ret["productTotals"] = $productTotals;
			$ret["usageTotals"] = $usageTotals;
			
			
			ksort($ret["productTotals"]);
			ksort($ret["usageTotals"]);
			ksort($ret["totals"]);
		} elseif (!(int)$ret["displayParams"]){
			$ret["toManyClients"] = 1;
		}
		
		return $ret;
	}
	
	function getParamData($params=array()){
		
		$ret = array();
		
		// test for the presence of something that will always be there when we are going to generate the report
		// and have already specified some parameters
		$ret["displayParams"] = ((int)$params["errBeginMonth"])?0:1;
		
		$ret["sevenDaysStart"] = $ret["thirtyDaysStart"] = explode("/", date("d/m/Y", ($ret["sevenDaysStartTime"] = $ret["thirtyDaysStartTime"] = time()-(time()%(60*60*24)))));
		$ret["sevenDaysEnd"] = explode("/", date("d/m/Y", $ret["sevenDaysEndTime"] = ($ret["sevenDaysStartTime"] + (60*60*24*7) - 1)));
		$ret["thirtyDaysEnd"] = explode("/", date("d/m/Y", $ret["thirtyDaysEndTime"] = ($ret["thirtyDaysStartTime"] + (60*60*24*30) - 1)));
		
		return $ret;
	
	}

}