<?php
// $Id: CheckServerLoad.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Andy Christ
 */
class CheckServerLoad extends MB_Action {
	/**
	 * The constructor for a CheckServerLoad action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function CheckServerLoad() {
		parent::MB_Action();
		$this->stringRep = "CheckServerLoad";
		$this->params = array
		("configGroupID");
	}

	/**
	 * The main method of this class that executes the getServerLoad action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$serverGroupID = (int) ($_REQUEST["serverGroupID"]);
		$configGroupID = (int) ($_REQUEST["configGroupID"]);

        //Look up the panel type
		if(!$serverGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ServerGroup ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetServerGroups", "", array("serverGroupID" => $serverGroupID, "getPanels" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
		}

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
				$data = $data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]["panels"][0];
				if($data) {
					$panel = $data["panel"][0]["configGroupTransKey"][0];
				}
			}
		}

		if($panel) {
			$panelFile = secureinput(strtolower($panel));
			if(file_exists(mb_path("/lib-mbapi/include/modules/panel/$panelFile.php"))) {
				require_once mb_path("/lib-mbapi/include/modules/panel/$panelFile.php");
			}
		}

		//If the $configGroupID is passed in, just call that one panel, otherwise, loop all in this server group
		if($configGroupID) {
			$p =& new $panel(array("subCommand" => "panelGetServerLoad", "configGroupID" => $configGroupID));
			$serverLoadData = dispatchMBAPI($xml,1);
			$serverLoadResults =& $serverLoadData["mbapi"][0]["results"][0];
		} else {


			foreach($data["panel"] as $value) {

				$p =& new $panel(array("subCommand" => "panelDummy", "configGroupID" => $value["configGroupID"][0]));
				if($p->capabilities[PANEL_GETSERVERLOAD]) {
					$serverLoadResult = $p->panelGetServerLoad();
					$serverLoadData[$value["configGroupID"][0]] = $p->arrayData;
				} else {
					//This panel can't do it.
					if($p->capabilities[PANEL_GETTESTS]){
						$serverLoadResult = $p->panelGetTest();
						$serverLoadData[$value["configGroupID"][0]] = $p->arrayData;
					} else {
						$serverLoadData[$value["configGroupID"][0]] = "not capable";
					}
				}
			}
		}

		$smartyVars = array();
		$smartyVars["panelCount"] = count($serverLoadData);
		$smartyVars["serverLoadData"] = $serverLoadData;

		$this->addTemplate("widgets/checkServerLoad", $smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // getServerLoad
?>