<?php
// $Id: EditPanel.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a Panel so that that it can be
 * configured and saved to the database.
 *
 * @author  Andy Christ
 */
class EditPanel extends MB_Action {
	/**
	 * The constructor for a EditPanel action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditPanel() {
		parent::MB_Action();
		$this->stringRep = "EditPanel";
		$this->params = array("configGroupID");
	}

	/**
	 * The main method of this class that executes the EditPanel action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = ((int) $_REQUEST["configGroupID"]);
		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No Config Group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetConfigs", "", array("getFormAttributes" => 1));
			$CONF["debug"]->add("Action Command (This)", htmlentities($query), __FILE__, __LINE__);
			$configGroupsData = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result (This)", $configGroupsData, __FILE__, __LINE__);



			if($this->addMBAPIErrors($configGroupsData) === 0) {
	
				$smartyVars = array();
	
				// setup this config group & its children groups & its params
				$smartyVars["configGroups"] = ($configGroupsData["mbapi"][0]["header"][0]["numResults"][0]==1) ?
					array(0=>$configGroupsResults["configGroups"][0]["configGroup"]) :
					$configGroupsResults["configGroups"][0]["configGroup"];
	
				// setup this group's config params
				$smartyVars["configParams"] = ($configParamData["mbapi"][0]["header"][0]["numResults"][0]==1) ?
					array(0=>$configParamDataResults["configs"][0]["config"]) :
					$configParamDataResults["configs"][0]["config"];
				$smartyVars["configParamValues"] = $configParamValues;

				$this->addTemplate("modules/EditPanel", collapseArrayElements($smartyVars), 1);
	
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTaxZone
?>