<?php
// $Id: EditServerGroup.php 6116 2006-04-12 19:06:54Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-mbapi/include/modules/panel/panel.php");

/**
 * This Action object collects information on a servergroup so that that the servergroup may be modified in the
 * database.  The ID is passed in, that record is pulled from the database and passed on to the template.
 *
 * @author  Andy Christ
 */
class EditServerGroup extends MB_Action {
	/**
	 * The constructor for a EditServerGroup action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditServerGroup() {
		parent::MB_Action();
		$this->stringRep = "EditServerGroup";
		$this->params = array("serverGroupID", "serverGroupFillType");
	}

	/**
	 * The main method of this class that executes the EditServerGroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$serverGroupID = ((int) $_REQUEST["serverGroupID"]);
		if(!$serverGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No servergroup ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetServerGroups", "", array("getPanels" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);

			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			if(!$data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]["panels"][0]) {
				//Get list of files in modules/panel to build panel list
				// Only if a Panel isn't associated yet, otherwise, must keep the same Panel.
				$panels = getAvailableModules("panel");
				sort($panels);
				foreach ($panels as $panelFile) {
					$panelFile = substr($panelFile, 0, -4);
					require_once mb_path("/lib-mbapi/include/modules/panel/".$panelFile.".php");
					$moduleInfo = call_user_func(array($panelFile,"getModuleInfo"));
					$smartyVars["panels"][$panelFile] = $moduleInfo["displayName"];
				}
			} else {
				$panels = $data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]["panels"][0]["panel"];
				//Grab the Panel parent ID from the first panel, they should all be the same
				$panelParentID = $panels[0]["parentConfigGroupID"][0];
			}
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();

				$smartyVars["panelSelectionOptions"] = Panel::getPanelSelectionOptions();
				foreach ($smartyVars["panelSelectionOptions"] as $k=>$v){
					$smartyVars["panelSelectionOptions"][$k] = (defined($v))?constant($v):$v;
				}
				$smartyVars["serverGroup"] = collapseArrayElements($data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]);
				$this->addTemplate("servers/EditServerGroup", $smartyVars, 1);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditServerGroup
?>
