<?php
// $Id: RemovePanel.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["configGroupID"], looks
 * up admin and asks you for remove confirmation.
 *
 * @author  Andy Christ
 */
class RemovePanel extends MB_Action {

	function RemovePanel() {
		parent::MB_Action();
		$this->stringRep = "RemovePanel";
	}

	function execute() {
		global $CONF;

		$configGroupID = ((int) $_REQUEST["configGroupID"]);

		if(!$configGroupID) {

			// Assign smarty variables
			$smartyVars = array();
			$smartyVars["errors"][] = array
			("title" => TRANS_ACTIONERROR,"message" => "No Panel ID given.");

		} else {
			$query = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$header = $data['mbapi'][0]['header'][0];
			$results =  $data['mbapi'][0]['results'][0]["configs"][0]["config"];

			if($this->addMBAPIErrors($data) === 0) {

				if($results) {
					foreach($results as $k => $v) {
						if($v["configParamName"][0] == "moduleDisplayName") {
							$serverName = $v["configParamValue"][0];
							$type = $v["configGroupTransKey"][0];
						} 
					}
				}
				if(!$serverName) {
					$serverName = "Unknown";
				}
				if(!$type) {
					$type = "Unknown";
				}
				// Assign smarty variables
				$smartyVars = array();
				$smartyVars["panel"]["configGroupID"] = $configGroupID;
				$smartyVars["panel"]["panelName"] = $serverName;
				$smartyVars["panel"]["panelType"] = $type;

				$smartyVars["pageLinks"] = $results["paginationLinks"];
				// Set the templete for output
				//
				$this->addTemplate("servers/RemovePanel", $smartyVars, 1);
				//
				
			}
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();

		}

	}
} // MB_Action
?>