<?php
// $Id: RemovePanelResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditPanel action
 * and modifies an existing admin record if data is valid; else redirects back to ShowServerGroups.
 *
 * @author  Andy Christ
 */
class RemovePanelResponse extends MB_Action {

	function RemovePanelResponse() {
		parent::MB_Action();
		$this->stringRep = "RemovePanelResponse";
	}

	function execute() {
		global $CONF;

		$configGroupID = ((int) $_REQUEST["configGroupID"]);

		if(!$configGroupID) {

			// Assign smarty variables
			$smartyVars = array();
			$smartyVars["errors"][] = array
			("title" => TRANS_ACTIONERROR, "message" => "No Panel ID given.");

		} else {

			$query = "<mbapi>
						<command>SetServerGroups</command>
						<subCommand>Update</subCommand>
						<params>
							<configGroupID>$configGroupID</configGroupID>
							<removeServerIDs>
								<serverID>$configGroupID</serverID>
							</removeServerIDs>
						</params>
					</mbapi>";
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$query = $this->getMBAPIQuery("SetConfigs", "Delete", array("configGroupID" => $configGroupID));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$header = $data['mbapi'][0]['header'][0];
			$results =  $data['mbapi'][0]['results'][0];

			if($this->addMBAPIErrors($data) === 0) {
				redirect("servergroups.php", getActionID("ShowServerGroups"));
			}
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();

		} // configGroupID

	} // execute

} // MB_Action
?>