<?php
// $Id: EditIPLog.php 7631 2006-06-19 23:00:24Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all IP Log records that match the given parameters, and
 * generates the display of that information for the edit form.
 *
 * @author  Andy Christ
 */
class EditIPLog extends MB_Action {
	/**
	 * The constructor for a EditIPLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditIPLog() {
		parent::MB_Action();
		$this->stringRep = "EditIPLog";
		
		$this->params = array("ip", "externalID", "configGroupID");
		$this->sortColumns = array("ip", "configGroupID");
	}

	/**
	 * The main method of this class that executes the EditIPLog action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		
		$ip = ((int) ip2long($_REQUEST["ip"]));
		
		if(!$ip) {
			$this->addError(TRANS_ACTIONERROR, "No IP given.");
		} else {
			$_REQUEST["ip"] = $ip;
		}

		//Get the Panel names for the select list
		$query =& new MBQuery("GetServerGroups", "", array("getPanels" => 1));
		$result = $query->getResult();
		if(!$result->getErrorCount()) {
			$serverGroups = grabSimpleMBAPIResults( $result->getStructure() );
			foreach($serverGroups as $key => $value) {
				if(is_array($value["panels"][0]["panel"])) {
					foreach($value["panels"][0]["panel"] as $panelItems) {
						if(notNull($panelItems["configParamValue"])) {
							$panels[ $panelItems["configGroupID"] ] = $panelItems["configParamValue"];
						} else {
							$panels[ $panelItems["configGroupID"] ] = $panelItems["configGroupID"];
						}
						unset($panelName);
					}
				} else {
					$panels[0] = TRANS_NO_SERVER_FOUND;
				}
			}
			
			$this->mergeSystemNavData();
		}

		$query =& new MBQuery("GetIPLogs", "", array("ip" => $ip));
		$resultObj = $query->getResult();
		$results = grabSimpleMBAPIResults( $resultObj->getStructure() );
		$results = $results[0];

		$rawData =& $resultObj->getStructure();
		
		
		if(!$resultObj->getErrorCount()) {
		
			$this->smartyVars["panels"] = $panels;
			$this->smartyVars["ipLog"] = $results;
			$this->smartyVars["paginationLinks"] = $rawData["mbapi"][0]["results"][0]["paginationLinks"][0];
			
			$this->addTemplate("servers/EditIPLog");
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditIPLog
?>