<?php
// $Id: ShowIPLog.php 10582 2007-01-26 16:50:29Z achrist $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all IP Log records that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Andy Christ
 * @author  Brian Smith
 */
class ShowIPLog extends MB_Action {
	/**
	 * The constructor for a ShowIPLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowIPLog() {
		parent::MB_Action();
		$this->stringRep = "ShowIPLog";
		
		$this->params = array("ip", "externalID", "configGroupID");
		$this->sortColumns = array("ip", "configGroupID");
	}

	/**
	 * The main method of this class that executes the ShowIPLogs action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		//Temp link to IP queue has it's own configGroupID so it looks like a filter
		if($this->paramArgs["configGroupID"] && $this->paramArgs["configGroupID"] < 60){
			unset($this->paramArgs["configGroupID"]);
			unset($_REQUEST["configGroupID"]);
		}

		$query =& new MBQuery("GetIPLogs", "", $this->getRequestParams());
		$data = $query->getResult();

		$results = grabSimpleMBAPIResults($data->getStructure());
		$rawData =& $data->getStructure();
		
		if(!$data->getErrorCount()) {

			$serverGroups = array(); // indexed by configGroupID
			foreach( $results as $k => $v ) {
				if (is_numeric( $v["configGroupID"] )) {
					if (!notNull( $serverGroups[ $v["configGroupID"] ] )) {
						$tmpQuery =& new MBQuery("GetServerGroups", "", array("getPanels" => 1, "configGroupID" => $v["configGroupID"]));
						$tmpData = $tmpQuery->getResult();
						$serverGroups[ $v["configGroupID"] ] = grabSimpleMBAPIResults($tmpData->getStructure());
					}

					if (notNull( $serverGroups[ $v["configGroupID"] ][0]["panels"][0]["panel"] ) && is_array( $serverGroups[ $v["configGroupID"] ][0]["panels"][0]["panel"] )) {
						foreach( $serverGroups[ $v["configGroupID"] ][0]["panels"][0]["panel"] as $panel ) {
							if ($panel["configGroupID"] == $v["configGroupID"]) {
								$results[ $k ]["configGroupName"] = notNull($panel["configParamValue"]) ? $panel["configParamValue"] : $v["configGroupID"];
							}
						}
					}
				}
			}

			$this->smartyVars["ips"] = $results;
			$this->mergeSystemNavData();
			$this->smartyVars["paginationLinks"] = collapseArrayElements($rawData["mbapi"][0]["results"][0]["paginationLinks"][0]);
		}

		$this->addTemplate("servers/ShowIPLog");
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowIPLog
?>