<?php
// $Id: AddTaxZoneGroup.php 10077 2006-11-21 15:34:03Z mgarrett $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a tax zone group so that that tax zone group may be added to the
 * database.
 *
 * @author  Kris Bailey
 */
class AddTaxZoneGroup extends MB_Action {
	/**
	 * The constructor for a AddTaxZoneGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddTaxZoneGroup() {
		parent::MB_Action();
		$this->stringRep = "AddTaxZoneGroup";
	}

	/**
	 * The main method of this class that executes the AddTaxZoneGroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->smartyVars = array();
 		$this->mergeCountryData2($CONF["user"]["locale"]->country);

		// get all tax zones as simple results
		$taxZones = grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZones</command></mbapi>", 1));
		// grab the selectable ones while passing the ignore ID array
		$this->smartyVars["selectableTaxZones"] = grabHTMLOpsFromArray($taxZones, "taxZoneID", "taxZoneDescription");

		$this->addTemplate("taxes/AddTaxZoneGroup", $this->smartyVars, 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddTaxZoneGroup
?>