<?php
// $Id: AddTaxZoneGroupResponse.php 10077 2006-11-21 15:34:03Z mgarrett $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddTaxZoneGroupResponse action, applies that information to  * records in the
 * database, and redirects to the ShowTaxZoneGroups action for the given taxzone.
 *
 * @author  Kris Bailey
 */
class AddTaxZoneGroupResponse extends MB_Action {
	/**
	 * The constructor for an AddTaxZoneGroupResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddTaxZoneGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "AddTaxZoneGroupResponse";
	}

	/**
	 * The main method of this class that executes the AddTaxZoneGroupResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$taxZoneIDs = array();
		$_REQUEST["taxZones"] = (array)$_REQUEST["taxZones"];
		foreach ($_REQUEST["taxZones"] as $v){
		 	$taxZoneIDs[] = (int)$v;
		}

		$query = "	<mbapi>
						<command>SetTaxZoneGroup</command>
						<subCommand>insert</subCommand>
						<params>
							<taxZoneGroupName>".secureInput($_REQUEST["taxZoneGroupName"])."</taxZoneGroupName>
							<taxZoneGroupActive>".(int)$_REQUEST["taxZoneGroupActive"]."</taxZoneGroupActive>
							".((count($taxZoneIDs))?"<taxZoneIDs>
								<taxZoneID>".@implode("</taxZoneID><taxZoneID>", $taxZoneIDs)."</taxZoneID>
							</taxZoneIDs>":"")."
						</params>
					</mbapi>";
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			redirect("taxes.php",getActionID("ShowTaxZoneGroups"),array());
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddTaxZoneGroupResponse
?>
