<?php
// $Id: AddTaxZoneResponse.php 11070 2007-04-30 20:51:12Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddTaxZone action, applies that information to  * records in the 
 * database, and redirects to the ShowTaxZoneDetails action for the given taxzone.
 *
 * @author  Mark Garrett
 */
class AddTaxZoneResponse extends MB_Action {
	/**
	 * The constructor for an AddTaxZoneResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddTaxZoneResponse() {
		parent::MB_Action();
		$this->stringRep = "AddTaxZoneResponse";
		$this->params = array(
			"countriesISO2",
			"taxZoneName",
			"taxZoneAmount",
			"taxZoneDescription",
			"taxZoneActive",
			"ledgerAccountID");
	}

	/**
	 * The main method of this class that executes the AddTaxZoneResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg("request:");
		dbg($_REQUEST);

		$taxZoneGroupIDs = array();
		$_REQUEST["taxZoneGroups"] = (array)$_REQUEST["taxZoneGroups"];
		foreach ($_REQUEST["taxZoneGroups"] as $v){
		 	$taxZoneGroupIDs[] = (int)$v;
		}

		$query = "	<mbapi>
						<command>SetTaxZones</command>
						<subCommand>insert</subCommand>
						<params>
							<countriesISO2>".secureInput($_REQUEST["countriesISO2"])."</countriesISO2>
							<taxZoneName>".secureInput($_REQUEST["taxZoneName"])."</taxZoneName>
							<taxZoneAmountType>".(int)$_REQUEST["taxZoneAmountType"]."</taxZoneAmountType>
							<taxZoneAmount>".doubleval($_REQUEST["taxZoneAmount"])."</taxZoneAmount>
							<taxZoneDescription>".secureInput($_REQUEST["taxZoneDescription"])."</taxZoneDescription>
							<taxZoneActive>".(int)$_REQUEST["taxZoneActive"]."</taxZoneActive>
							<ledgerAccountID>".(int)$_REQUEST["ledgerAccountID"]."</ledgerAccountID>
							<taxZoneStackable>".(int)$_REQUEST["taxZoneStackable"]."</taxZoneStackable>
							".((count($taxZoneGroupIDs))?"<taxZoneGroupIDs>
								<taxZoneGroupID>".@implode("</taxZoneGroupID><taxZoneGroupID>", $taxZoneGroupIDs)."</taxZoneGroupID>
							</taxZoneGroupIDs>":"")."
						</params>
					</mbapi>";
		dbg("query:");
		dbg($query);
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			redirect("taxes.php",getActionID("ShowTaxZones"),array());
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddTaxZoneResponse
?>
