<?php
// $Id: EditTaxZoneGroup.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a tax zone so that that the tax zone may be modified in the
 * database.
 *
 * @author  Kris Bailey
 */
class EditTaxZoneGroup extends MB_Action {
	/**
	 * The constructor for a EditTaxZoneGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditTaxZoneGroup() {
		parent::MB_Action();
		$this->stringRep = "EditTaxZoneGroup";
		$this->params = array("taxZoneID");
	}

	/**
	 * The main method of this class that executes the EditTaxZone action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();
        $this->addLedgerAccounts();

		$taxZoneGroupID = ((int) $_REQUEST["taxZoneGroupID"]);
		if(!$taxZoneGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No taxzone group ID given.");
		} else {
			$query = "	<mbapi>
							<command>GetTaxZoneGroups</command>
							<params>
								<taxZoneGroupID>".$taxZoneGroupID."</taxZoneGroupID>
								<getTaxZoneData>1</getTaxZoneData>
							</params>
						</mbapi>";
 			$data = dispatchMBAPI($query, 1);
 			dbg("raw query:");
 			dbg($query);
 			dbg("raw data:");
 			dbg($data);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->mergeCountryData2();
				$this->smartyVars["taxGroup"] = grabSimpleMBAPIResults($data); // grab the simple results
				$this->smartyVars["taxGroup"] = $this->smartyVars["taxGroup"][0]; // get the first of the simple results
				dbg($this->smartyVars["taxGroup"]);
				if (isset($this->smartyVars["taxGroup"]["taxZones"][0]["taxZone"])){ // if there are tax zone
					// get the selected tax zone for the multi select menu
					$this->smartyVars["selectedTaxZones"] = grabHTMLOpsFromArray($this->smartyVars["taxGroup"]["taxZones"][0]["taxZone"], "taxZoneID", "taxZoneDescription");
				} else { // if there arent tax zone groups set some arrays
					dbg("didnt find tax zones");
					$this->smartyVars["taxGroup"]["taxZones"][0]["taxZone"] = array();
					$this->smartyVars["selectedTaxZones"] = array();
				}

				// get all tax zone as simple results
				$taxZones = grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZones</command></mbapi>", 1));
				// grab the selectable ones while passing the ignore ID array
				$this->smartyVars["selectableTaxZones"] = grabHTMLOpsFromArray($taxZones, "taxZoneID", "taxZoneDescription", array_keys($this->smartyVars["selectedTaxZones"]));

				dbg("smarty vars:");
				dbg($this->smartyVars);

				// run the template...
				$this->addTemplate("taxes/EditTaxZoneGroup", $this->smartyVars, 1);

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTaxZoneGroup
?>