<?php
// $Id: EditTaxZoneGroupResponse.php 6694 2006-05-08 22:48:21Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditTaxZoneGroupResponse action, applies that information to
 * records in the database, and redirects to the ShowTaxZoneGroups action for the given taxzone.
 *
 * @author  Kris Bailey
 */
class EditTaxZoneGroupResponse extends MB_Action {
	/**
	 * The constructor for an EditTaxZoneGroupResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditTaxZoneGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "EditTaxZoneGroupResponse";
	}

	/**
	 * The main method of this class that executes the EditTaxZoneGroupResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$taxZoneGroupID = ((int) $_REQUEST["taxZoneGroupID"]);
		if(!$taxZoneGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No taxzone group ID given.");
		} else {

			$taxZoneIDs = array();
			$_REQUEST["taxZones"] = (array)$_REQUEST["taxZones"];
			foreach ($_REQUEST["taxZones"] as $v){
			 	$taxZoneIDs[] = (int)$v;
			}

			$query = "	<mbapi>
							<command>GetTaxZoneGroups</command>
							<params>
								<getTaxZoneData>1</getTaxZoneData>
								<taxZoneGroupID>".$taxZoneGroupID."</taxZoneGroupID>
							</params>
						</mbapi>";
			$data = grabSimpleMBAPIResults(dispatchMBAPI($query, 1));
			$data = $data[0];
			if (isset($data["taxZones"][0]["taxZone"][0]["taxZoneID"])){
				$currentTaxZoneIDs = array_keys(grabHTMLOpsFromArray($data["taxZones"][0]["taxZone"], "taxZoneID", "taxZoneName"));
			} else {
				$currentTaxZoneIDs = array();
			}

			dbg("ids we need to have:");
			dbg($taxZoneIDs);
			dbg("ids we already have set:");
			dbg($currentTaxZoneIDs);

			$zoneIDs = $this->getRelationUpdateIDs($taxZoneIDs, $currentTaxZoneIDs);


	 		$query = "	<mbapi>
						<command>SetTaxZoneGroup</command>
						<subCommand>update</subCommand>
						<params>
							<taxZoneGroupID>".$taxZoneGroupID."</taxZoneGroupID>
							<taxZoneGroupName>".secureInput($_REQUEST["taxZoneGroupName"])."</taxZoneGroupName>
							<taxZoneGroupActive>".(int)$_REQUEST["taxZoneGroupActive"]."</taxZoneGroupActive>
							".((count($zoneIDs["add"]))?"<taxZoneIDs>
								<taxZoneID>".@implode("</taxZoneID><taxZoneID>", $zoneIDs["add"])."</taxZoneID>
							</taxZoneIDs>":"")."
							".((count($zoneIDs["remove"]))?"<removeTaxZoneIDs>
								<taxZoneID>".@implode("</taxZoneID><taxZoneID>", $zoneIDs["remove"])."</taxZoneID>
							</removeTaxZoneIDs>":"")."
						</params>
					</mbapi>";
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("taxes.php",getActionID("ShowTaxZoneGroups"),array());
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTaxZoneGroupResponse
?>
