<?php
// $Id: EditTaxZoneResponse.php 11070 2007-04-30 20:51:12Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditTaxZone action, applies that information to
 * records in the database, and redirects to the ShowTaxZoneDetails action for the given taxzone.
 *
 * @author  Mark Garrett
 */
class EditTaxZoneResponse extends MB_Action {
	/**
	 * The constructor for an EditTaxZoneResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditTaxZoneResponse() {
		parent::MB_Action();
		$this->stringRep = "EditTaxZoneResponse";
		$this->params = array(
			"taxZoneID",
			"countriesISO2",
			"taxZoneName",
			"taxZoneAmount",
			"taxZoneDescription",
			"taxZoneActive",
			"ledgerAccountID");
	}

	/**
	 * The main method of this class that executes the EditTaxZoneResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$taxZoneID = ((int) $_REQUEST["taxZoneID"]);
		if(!$taxZoneID) {
			$this->addError(TRANS_ACTIONERROR, "No taxzone ID given.");
		} else {

			$taxZoneGroupIDs = array();
			$_REQUEST["taxZoneGroups"] = (array)$_REQUEST["taxZoneGroups"];
			foreach ($_REQUEST["taxZoneGroups"] as $v){
			 	$taxZoneGroupIDs[] = (int)$v;
			}

			$query = "	<mbapi>
							<command>GetTaxZones</command>
							<params>
								<getTaxZoneGroupData>1</getTaxZoneGroupData>
								<taxZoneID>".$taxZoneID."</taxZoneID>
							</params>
						</mbapi>";
			$data = grabSimpleMBAPIResults(dispatchMBAPI($query, 1));
			$data = $data[0];
			if (isset($data["taxZoneGroups"][0]["taxZoneGroup"][0]["taxZoneGroupID"])){
				$currentTaxZoneGroupIDs = array_keys(grabHTMLOpsFromArray($data["taxZoneGroups"][0]["taxZoneGroup"], "taxZoneGroupID", "taxZoneGroupName"));
			} else {
				$currentTaxZoneGroupIDs = array();
			}

			dbg("ids we need to have:");
			dbg($taxZoneGroupIDs);
			dbg("ids we already have set:");
			dbg($currentTaxZoneGroupIDs);

			$groupIDs = $this->getRelationUpdateIDs($taxZoneGroupIDs, $currentTaxZoneGroupIDs);


	 		$query = "	<mbapi>
						<command>SetTaxZones</command>
						<subCommand>update</subCommand>
						<params>
							<taxZoneID>".$taxZoneID."</taxZoneID>
							<countriesISO2>".secureInput($_REQUEST["countriesISO2"])."</countriesISO2>
							<taxZoneName>".secureInput($_REQUEST["taxZoneName"])."</taxZoneName>
							<taxZoneAmount>".doubleval($_REQUEST["taxZoneAmount"])."</taxZoneAmount>
							<taxZoneAmountType>".(int)$_REQUEST["taxZoneAmountType"]."</taxZoneAmountType>
							<taxZoneDescription>".secureInput($_REQUEST["taxZoneDescription"])."</taxZoneDescription>
							<taxZoneActive>".(int)$_REQUEST["taxZoneActive"]."</taxZoneActive>
							<ledgerAccountID>".(int)$_REQUEST["ledgerAccountID"]."</ledgerAccountID>
							<taxZoneStackable>".(int)$_REQUEST["taxZoneStackable"]."</taxZoneStackable>
							".((count($groupIDs["add"]))?"<taxZoneGroupIDs>
								<taxZoneGroupID>".@implode("</taxZoneGroupID><taxZoneGroupID>", $groupIDs["add"])."</taxZoneGroupID>
							</taxZoneGroupIDs>":"")."
							".((count($groupIDs["remove"]))?"<removeTaxZoneGroupIDs>
								<taxZoneGroupID>".@implode("</taxZoneGroupID><taxZoneGroupID>", $groupIDs["remove"])."</taxZoneGroupID>
							</removeTaxZoneGroupIDs>":"")."
						</params>
					</mbapi>";
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("taxes.php",getActionID("ShowTaxZones"),array());
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTaxZoneResponse
?>
