<?php
// $Id: RemoveTaxZoneGroup.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a TaxZone.
 *
 * @author  Kris Bailey
 */
class RemoveTaxZoneGroup extends MB_Action {
	/**
	 * The constructor for a RemoveTaxZoneGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveTaxZoneGroup() {
		parent::MB_Action();
		$this->stringRep = "RemoveTaxZoneGroup";
		$this->params = array("taxZoneGroupID");
	}

	/**
	 * The main method of this class that executes the RemoveTaxZoneGroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$taxZoneID = ((int) $_REQUEST["taxZoneGroupID"]);
		if(!$taxZoneID) {
			$this->addError(TRANS_ACTIONERROR, "No Tax Zone ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetTaxZoneGroups");
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = $smartyVars;
					$s["taxzone"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]["taxZoneGroups"][0]["taxZoneGroup"][0]);

					$this->addTemplate("taxes/RemoveTaxZoneGroup", $s, 1);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "TaxZoneGroup not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveTaxZoneGroup
?>