<?php
// $Id: ShowTaxZoneGroups.php 8334 2006-08-14 19:30:09Z mgarrett $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all taxzones that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowTaxZoneGroups extends MB_Action {
	/**
	 * The constructor for a ShowTaxZoneGroups action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowTaxZoneGroups() {
		parent::MB_Action();
		$this->stringRep = "ShowTaxZoneGroups";
		
		$this->params = array(
			"taxZoneGroupID",
			"taxZoneGroupName",
			"taxZoneGroupActive");
		$this->sortColumns = array("taxZoneGroupName");
	}

	/**
	 * The main method of this class that executes the ShowTaxZoneGroups action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();



		$query = $this->getMBAPIQuery("GetTaxZoneGroups", "", array("getTaxZoneData"=>1), 1, 1, 1, 1);
		$results = dispatchMBAPI($query, 1);
		$data = grabSimpleMBAPIResults($results);

		$this->smartyVars = array();

		$this->smartyVars["taxGroups"] = $data;

   		if ($this->smartyVars["taxGroups"]) {
			foreach ($this->smartyVars["taxGroups"] as $k=>$v){
			 	if (isset($v["taxZones"][0]["taxZone"])){
				 	foreach($v["taxZones"][0]["taxZone"] as $z=>$zone) {
						$this->smartyVars["taxGroups"][$k]["taxZones"][0]["taxZone"][$z]["countryName"] = constant("TRANS_ISO_3166_".$zone["countriesISO2"]);
					}
				} else {
					$this->smartyVars["taxGroups"][$k]["taxZones"][0]["taxZone"] = array();
				}
			}
		}


		$this->smartyVars["paginationLinks"] = collapseArrayElements($results["mbapi"][0]["results"][0]["paginationLinks"][0]);

		dbg("smarty Vars:");
		dbg($this->smartyVars);
		$this->addTemplate("taxes/ShowTaxZoneGroups", $this->smartyVars, 1);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowTaxZoneGroups
?>