<?php
// $Id: ShowThemes.php 10058 2006-11-20 15:34:20Z achrist $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all themes that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 * @author  Vic Fryzel
 */
class ShowThemes extends MB_Action {
	/**
	 * The constructor for a ShowThemes action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowThemes() {
		parent::MB_Action();
		$this->stringRep = "ShowThemes";
		
		$this->params = array(
			"adminID",
			"clientID",
			"themeID",
			"themeName",
			"themeDisplayName",
			"themeActive",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
		$this->sortColumns = array("");
	}

	/**
	 * The main method of this class that executes the ShowThemes action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$query = $this->getMBAPIQuery("GetThemes", "", array(), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		$results =& $data["mbapi"][0]["results"][0];
		//Check for new themes
		if(is_array($results["themes"][0]["theme"])) {
			foreach($results["themes"][0]["theme"] as $key => $value) {
				$currentThemes[$value["themeID"][0]] = $value["themeName"][0];
			}
		}

		$themeDir = mb_path("/lib-themes");

		if (is_dir($themeDir)) {
			// loop through all files of this module type
			$dh = opendir($themeDir."/");
			while ($dirName = readdir($dh)) {
				if(is_dir($themeDir."/".$dirName) && !ereg("\.",$dirName) && $dirName != "CVS") {
					$directoryThemes[] = $dirName;
				}
			}
		}
		$newThemes = array_diff($directoryThemes,$currentThemes);
		$missingThemes = array_diff($currentThemes,$directoryThemes);

		$newThemes = array_flip($newThemes);
		$missingThemes = array_flip($missingThemes);

		//Don't load a theme if the name is mobile
		if(isset($newThemes["mobile"])) {
			unset($newThemes["mobile"]);
		}

		foreach($newThemes as $key => $value) {
			$newThemes[$key] = $key;
		}

		$missingThemes = array_flip($missingThemes);

		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["themes"] = $results["themes"][0]["theme"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$smartyVars["themes"] = array(0 => $results["themes"][0]["theme"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			$smartyVars["newThemes"] = $newThemes;
			$smartyVars["missingThemes"] = $missingThemes;
			$this->addTemplate("themes/ShowThemes", collapseArrayElements($smartyVars), 1);
			
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowThemes
?>