<?php
// $Id: AddTodoResponse.php 7339 2006-06-08 15:37:42Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddTodo action, applies that information to  * records in the database, and redirects to the ShowTodoDetails action for the given todo.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class AddTodoResponse extends MB_Action {
	/**
	 * The constructor for an AddTodoResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddTodoResponse() {
		parent::MB_Action();
		$this->stringRep = "AddTodoResponse";
		$this->params = array(
			"todoID",
			"todoTitle",
			"userID",
			"todoDesc",
			"todoStatusID",
			"todoDateDue",
			"todoAssignedAdminID",
			"todoIsPublic");
	}

	/**
	 * The main method of this class that executes the AddTodoResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF, $_REQUEST;
		parent::execute();
		
		$_REQUEST["userID"] = $CONF["user"]["id"];

		$this->handleDateSelector("todoDateDue");


		$query = $this->getMBAPIQuery("SetTodos", "insert");
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			// redirect somewhere else after commiting the new todo
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				dbg("saving new todo and redirecting to ".$_REQUEST["redirectURL"]);
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				dbg("saving new todo and redirect to view details");
				redirect("todos.php", getActionID("ShowTodoDetails"), array("todoID"=>$data["mbapi"][0]["header"][0]["lastInsertID"][0]));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddTodoResponse
?>