<?php
// $Id: EditTodo.php 8155 2006-07-27 22:50:02Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a todo so that that the todo may be modified in the
 * database.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class EditTodo extends MB_Action {
	/**
	 * The constructor for a EditTodo action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditTodo() {
		parent::MB_Action();
		$this->stringRep = "EditTodo";
		$this->params = array("todoID");
	}

	/**
	 * The main method of this class that executes the EditTodo action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$todoID = ((int) $_REQUEST["todoID"]);
		if(!$todoID) {
			$this->addError(TRANS_ACTIONERROR, "No todo ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetTodos");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["todostatus"] = getStatuses("todo");

				// Get Admins data for select menu
				$this->smartyVars["adminsArray"] = correctArray( $this->getMBAPIData("GetAdmins", "admins", "admin", array("adminActive" => 1)) );
				
				foreach ($this->smartyVars["adminsArray"] as $admin) {
					$this->smartyVars["adminsList"][ $admin["adminID"] ] = $admin["adminFirstName"]." ".$admin["adminLastName"]." - ".$admin["adminUsername"];
				}

				
				$this->smartyVars["todo"] = correctArray( $data["mbapi"][0]["results"][0]["todos"][0]["todo"][0] );

				$this->mergeFormState( $this->smartyVars["todo"] );
				
				$this->formDefaults["todoDateDue"] = $this->smartyVars["todo"]["todoDateDue"];
				$this->setupDateSelector("todoDateDue");

				$this->mergeFormState($this->formDefaults+$this->smartyVars['formValues']);
				
 				$this->addTemplate("todos/EditTodo");
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTodo
?>