<?php
// $Id: EditTodoResponse.php 7917 2006-07-05 23:45:20Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditTodo action, applies that information to
 * records in the database, and redirects to the ShowTodoDetails action for the given todo.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class EditTodoResponse extends MB_Action {
	/**
	 * The constructor for an EditTodoResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditTodoResponse() {
		parent::MB_Action();
		$this->stringRep = "EditTodoResponse";
		$this->params = array(
			"todoID",
			"todoTitle",
			"todoDesc",
			"todoStatusID",
			"todoDateDue",
			"todoAssignedAdminID",
			"todoIsPublic");
	}

	/**
	 * The main method of this class that executes the EditTodoResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg("### REQUEST DATA ###");
		dbg($_REQUEST);
		
		$todoID = ((int) $_REQUEST["todoID"]);
		if(!$todoID) {
			$this->addError(TRANS_ACTIONERROR, "No todo ID given.");
		} else {
			$this->handleDateSelector("todoDateDue");
			
			$query = $this->getMBAPIQuery("SetTodos", "update");
			$data = dispatchMBAPI($query, 1);
			
			dbg($data);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("todos.php", getActionID("ShowTodoDetails"), array("todoID"=>$todoID));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTodoResponse
?>