<?php
// $Id: ShowAllTodos.php 11585 2007-07-16 17:22:45Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all todos that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Brian Smith
 */
class ShowAllTodos extends MB_Action {
	/**
	 * The constructor for a ShowAllTodos action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowAllTodos() {
		parent::MB_Action();
		$this->stringRep = "ShowAllTodos";
		
		$this->params = array(
			"todoID",
			"productID",
			"todoTitle",
			"todoDesc",
			"userID",
			"todoStatusID",
			"todoDateDue",
			"todoDateCreated",
			"todoAssignedAdminID",
			"todoIsPublic");
		$this->sortColumns = array(
			"todoStatusID",
			"todoTitle",
			"userID",
			"todoAssignedAdminID",
			"todoDateDue",
			"todoIsPublic");
	}

	/**
	 * The main method of this class that executes the ShowAllTodos action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$t= &new Timer;
		$query = $this->getMBAPIQuery("GetTodos", "", array("getAssignedData" => 1,
											"getAssociated" => 1,
											"userID" => $CONF["user"]["id"],
											"todoAssignedAdminID" => $CONF["user"]["id"],
											"todoIsPublic" => 1), 1, 1);
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["todos"] = $results["todos"][0]["todo"];
			
			$this->smartyVars["todos"] = correctArray( $this->smartyVars["todos"] );

			if (is_array( $this->smartyVars["todos"] ))
			foreach( $this->smartyVars["todos"] as $k => $item ) {
				if ($item["assigned"] && $item["assigned"][0] && $item["assigned"][0]["assigned"] && $item["assigned"][0]["assigned"][0] && is_array($item["assigned"][0]["assigned"][0] )) {
					$this->smartyVars["todos"][$k]["assigned"][0] = $item["assigned"][0]["assigned"][0];
				}
			}
			unset( $k, $item, $data, $query );
			

			$this->smartyVars["todostatus"] = getStatuses("todo");
			
			
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			
			$CONF["debug"]->add("Time before adding smarty templates", $t->getElapsedTime(), __FILE__, __LINE__);
			$this->addTemplate("todos/ShowAllTodos");
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowAllTodos
?>