<?php
// $Id: AddVendorResponse.php 11158 2007-05-21 23:22:09Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This action object displays a page to add a vendor.
 *
 * @author  Kris Bailey
 */
class AddVendorResponse extends MB_Action {
	/**
	 * 
	 */
	function AddVendorResponse() {
		parent::MB_Action();
		$this->stringRep = "AddVendorResponse";
		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddVendorResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


		if ($_REQUEST["vendorAPIURL"]){

			$vendorInfo = $this->getVendorInfo();

			$user = getPasswordHash(time().$_REQUEST["vendorAPIURL"]);
			$pass = getPasswordHash(uniqid(0)); // having a 40 char pass, this IS the plaintext
			dbg("password i will pass: ".$pass);

			$vendorAdminID = $this->createVendorUser($user, $pass, $vendorInfo["companyName"]);
				
			$companyInfo = oneOf("companies", array("sortColumn" => "companyID", "sortDir" => "ASC"));
			
			if (!$_REQUEST["vendorSellerUsername"]){
				$vsUser = $companyInfo["companyEmail"];
				$vsPass = substr(getPasswordHash(time().serialize($_SERVER)), 0, 9);
				dbg($vsUser);
				dbg($vsPass);
				dbg(dispatchMBAPI);
			}
			
			$tp = getOtherStuff($_REQUEST["vendorSellerPassword"] ? $_REQUEST["vendorSellerPassword"] : $vsPass);
			
			$vendorID = insertFor("vendors", array(
				"vendorName" => $vendorInfo["companyName"],
				"vendorActive" => 1,
				"vendorActivationRule" => getAPITypeID("vendorActivationRule", "inactive"),
				"vendorMarkupPercentage" => 0,
				"vendorAddress1" => $vendorInfo["companyAddress1"],
				"vendorAddress2" => $vendorInfo["companyAddress2"],
				"vendorCity" => $vendorInfo["companyCity"],
				"vendorState" => $vendorInfo["companyState"],
				"vendorZip" => $vendorInfo["companyZip"],
				"countriesID" => $vendorInfo["countriesID"],
				"vendorApiURL" => $_REQUEST["vendorAPIURL"],
				"vendorSellerUsername" => $_REQUEST["vendorSellerUsername"] ? $_REQUEST["vendorSellerUsername"] : $vsUser,
				"vendorSellerPassword" => $tp,
				"adminID" => $vendorAdminID,
			));
			
			$selfAPIURL = ($CONF["secureURLProtocol"]=="https")?"https://".$CONF["secureURL"]."/".mb_path_convert_name("app-modernbill-api")."/api.php":"http://".$CONF["standardURL"]."/".mb_path_convert_name("app-modernbill-api")."/api.php";
			
			$params = array(
				"apiURL" => $selfAPIURL,
				"vendorUsername" => $user,
				"vendorPassword" => $pass,
			);
			
			if ($_REQUEST["vendorSellerUsername"]){
				$params["contactUsername"] = $_REQUEST["vendorSellerUsername"];
				$params["contactPassword"] = $_REQUEST["vendorSellerPassword"];
			} else {
				$params["countriesISO2"] = $CONF["user"]["locale"]->localeData["locale_country_iso_2"];
				$params["languageISO2"] = $CONF["user"]["locale"]->localeData["locale_language"];
				$params["client_contactFirstName"] = $CONF["user"]["adminData"]["adminFirstName"][0];
				$params["client_contactLastName"] = $CONF["user"]["adminData"]["adminLastName"][0];
				$params["client_clientCompany"] = $companyInfo["companyName"];
				$params["client_contactUsername"] = $vsUser;
				$params["client_contactPassword"] = $vsPass;
				$params["client_contactEmail"] = $companyInfo["companyEmail"];
				$params["client_contactEmailFormat"] = 0;
				$params["client_contactAddress1"] = $companyInfo["companyAddress1"];
				$params["client_contactAddress2"] = $companyInfo["companyAddress2"];
				$params["client_contactCity"] = $companyInfo["companyCity"];
				$params["client_contactState"] = $companyInfo["companyState"];
				$params["client_contactZip"] = $companyInfo["companyZip"];
				$params["client_contactPhone1"] = $companyInfo["companyPhone1"];
				$params["client_contactPhone2"] = $companyInfo["companyPhone2"];
				$params["client_contactFax"] = $companyInfo["companyFax"];
			}
			
			$results = collapseArrayElements(runActionAPICommand($_REQUEST["vendorAPIURL"], "createMarketplaceSeller", $params));
		
			if ($results["api"]["results"]["sellerStatus"]=="active"){
				if ($results["api"]["results"]["sellerUsername"]!=$tuser){
					updateForKey("vendors", $vendorID, array(
						"vendorSellerUsername" => $results["api"]["results"]["sellerUsername"],
					));
				}
				redirect("vendors.php", "ShowVendors");
			} else {
				$this->addError(TRANS_ACTIONERROR, "Error setting up vendor in system.");
			}
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
	function getVendorInfo(){
		if ($_REQUEST["vendorSellerUsername"]){
			$params = array(
				"contactUsername" => $_REQUEST["vendorSellerUsername"],
				"contactPassword" => $_REQUEST["vendorSellerPassword"],
			);
		} elseif ($vendorInfo["vendorSellerUsername"]){
			$params = array(
				"contactUsername" => $vendorInfo["vendorSellerUsername"],
				"contactPassword" => getStuff($vendorInfo["vendorSellerPassword"]),
			);
		}
		$results = runActionAPICommand($_REQUEST["vendorAPIURL"], "getVendorInformation", $params);
		return collapseArrayElements($results["api"][0]["results"][0]["company"][0]);
	}
	
	function createVendorUser($user, $pass, $vendorName){
		global $CONF;
		$adminID = insertFor(":admins", array(
			"adminFirstName" => $vendorName,
			"adminLastName" => TRANS_VENDOR,
			"adminUsername" => $user,
			"adminPassword" => $pass,
			"adminActive" => 1,
			"themeID" => $CONF["user"]["themeID"],
			"languageID" => $CONF["user"]["languageID"],
			"countriesID" => $CONF["user"]["countriesID"],
		));
		
		if (!($group = IDOf(":adminGroups", array("adminGroupName" => "MARKETPLACE VENDORS")))){
			dbg(dispatchMBAPI($cmd = toXML(array(
				"mbapi" => array(
					"command" => "SetAdminGroups",
					"subCommand" => "insert",
					"params" => array(
						"adminGroupName" => "MARKETPLACE VENDORS",
						"adminIDs" => array(
							"adminID" => array(
								$adminID,
							),
						),
						"actionNames" => array(
							"actionName" => array(
								"GetCompanyInformation",
								"UpdateVendorInformation",
								"UpdateSellerStatus",
								"SyncSellerInventory",
								"SendSellerMessage",
								"ManageSellerProduct",
								"AddVendorInvoices",
							),
						),
					),
				),
			)), 1));
			dbg($cmd);
		} else {
			dbg(dispatchMBAPI($cmd = toXML(array(
				"mbapi" => array(
					"command" => "SetAdminGroups",
					"subCommand" => "update",
					"params" => array(
						"adminGroupID" => $group,
						"adminIDs" => array(
							"adminID" => array(
								$adminID,
							),
						),
					),
				),
			)), 1));
			dbg($cmd);
		}
		return $adminID;
	}
	
} // AddVendorResponse

















?>