<?php
// $Id: ShowVendors.php 10845 2007-03-09 00:40:50Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowVendors extends ShowAction {
	/**
	 */
	function ShowVendors() {
		$this->setDataSource(
			new DataSource(
				":vendors",
				array()
			)
		);
		parent::ShowAction();
		$this->stringRep = "ShowVendors";
		// define all possible params that we will accept
		$this->params = array
		(
			"vendorID",
			"vendorName",
			"vendorActive",
			"vendorApiURL",
			"vendorSellerUsername",
			"vendorSellerPassword",
			"vendorDateLastInvoiceSync",
			"vendorAddress1",
			"vendorAddress2",
			"vendorCity",
			"vendorState",
			"vendorZip",
			"countriesID",
		);

	}

	/**
	 * showHandler method to link into execution
	 */
	function showHandler() {
		global $CONF;
		$vendors = $this->d->getEssential();
       	$h = $this->d->getHeader();
		// set the sorting args for display
		$this->smartyVars["displaySortColumnName"] = $h[0]["sortColumnName"];
		$this->smartyVars["displaySortColumn"] = $h[0]["sortColumn"];
		$this->smartyVars["displaySortDir"] = $h[0]["sortDir"];
		
		$this->smartyVars["vendorActivationRule"] = $CONF["types"]["vendorActivationRule"];

		foreach ($this->smartyVars["vendors"] as $k=>$v){
			//$dec = getStuff($v["vendorSellerPassword"]);
			//echo $dec." vs ".$v["vendorSellerPassword"]."\n";
			$this->smartyVars["vendors"][$k]["vendorSellerPassword"] = getStuff($v["vendorSellerPassword"]);
		}

	}
} // ShowVendors
?>
