<?php
// $Id: SyncVendorAPIURL.php 10872 2007-03-13 21:18:48Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * Connects to an api url and tests it.
 *
 * @author  Kris Bailey
 */
class SyncVendorAPIURL extends MB_Action {
	function SyncVendorAPIURL() {
		parent::MB_Action();
		$this->stringRep = "SyncVendorAPIURL";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the SyncVendorAPIURL action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		if ((int)$_REQUEST["vendorID"]){
			$vendorInfo = oneOf("vendors", array(
				"vendorID" => $_REQUEST["vendorID"],
			));
			dbg($vendorInfo);

			$selfAPIURL = ($CONF["secureURLProtocol"]=="https")?"https://".$CONF["secureURL"]."/".mb_path_convert_name("app-modernbill-api")."/api.php":"http://".$CONF["standardURL"]."/".mb_path_convert_name("app-modernbill-api")."/api.php";

			$params = array(
				"contactUsername" => $vendorInfo["vendorSellerUsername"],
				"contactPassword" => getStuff($vendorInfo["vendorSellerPassword"]),
				"sellerApiURL" => $selfAPIURL,
			);

			if (!(int)$vendorInfo["vendorActive"]){
				$params["deactivate"] = 1;
			} else {
				$params["activate"] = 1;
			}

			if ($vendorInfo["vendorApiURL"]){
				$results = collapseArrayElements(runActionAPICommand($vendorInfo["vendorApiURL"], "updateSellerInformation", $params));
				dbg($results);
				if ((int)$results["api"]["header"]["errors"]["title"]){
					die("error");
				} else {
					die("success");
				}
			} else {
				die("error");
			}
		
		} else {
			die("error");
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // SyncVendorAPIURL
?>