<?php
// $Id: TestVendorAPIURL.php 10611 2007-01-31 23:58:12Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * Connects to an api url and tests it.
 *
 * @author  Kris Bailey
 */
class TestVendorAPIURL extends MB_Action {
	function TestVendorAPIURL() {
		parent::MB_Action();
		$this->stringRep = "TestVendorAPIURL";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		if ((int)$_REQUEST["vendorID"]){
			$vendorInfo = oneOf("vendors", array(
				"vendorID" => $_REQUEST["vendorID"],
			));
			dbg($vendorInfo);
		}

		$params = array();
		
		if ($_REQUEST["vendorSellerUsername"]){
			$params = array(
				"contactUsername" => $_REQUEST["vendorSellerUsername"],
				"contactPassword" => $_REQUEST["vendorSellerPassword"],
			);
		} elseif ($vendorInfo["vendorSellerUsername"]){
			$params = array(
				"contactUsername" => $vendorInfo["vendorSellerUsername"],
				"contactPassword" => getStuff($vendorInfo["vendorSellerPassword"]),
			);
		}

		if ($_REQUEST["vendorAPIURL"]){
			$results = runActionAPICommand($_REQUEST["vendorAPIURL"], "getVendorInformation", $params);
			dbg($results);
			if ($results["api"][0]["header"][0]["errors"][0]["title"][0]=="1002"){
				echo "login<|>";
			} elseif ((int)$results["api"][0]["header"][0]["errors"][0]["title"][0]){
				echo "invalid<|>";
			} else {
				echo $results["api"][0]["results"][0]["company"][0]["companyName"][0]."<|>".$results["api"][0]["results"][0]["company"][0]["companyURL"][0];
			}
			flush();
			exit;
		} else {
			echo "invalid<|>";
			flush();
			exit;
		}
		
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // TestVendorAPIURL
?>