<?php
// $Id: RemoveWebsiteWidget.php 7004 2006-05-23 17:12:33Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a Website Widget.
 *
 * @author  Kris Bailey
 */
class RemoveWebsiteWidget extends MB_Action {
	/**
	 * The constructor for a RemoveWebsiteWidget action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveWebsiteWidget() {
		parent::MB_Action();
		$this->stringRep = "RemoveWebsiteWidget";
		$this->params = array("websiteWidgetID");
	}

	/**
	 * The main method of this class that executes the RemoveWebsiteWidget action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$websiteWidgetID = ((int) $_REQUEST["websiteWidgetID"]);
		if(!$websiteWidgetID) {
			$this->addError(TRANS_ACTIONERROR, "No Widget ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetWebsiteWidgets");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["widget"] = grabSimpleMBAPIResults($data);
					$s["widget"] = $s["widget"][0];
					$this->addTemplate("websitewidgets/RemoveWebsiteWidget", $s, 1);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Widget not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveTodo
?>
