<?php
// $Id: RemoveWebsiteWidgetResponse.php 9852 2006-10-30 15:43:39Z achrist $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RemoveWebsiteWidget action, and removes the specified widget
 * @author  Mark Garrett
 */
class RemoveWebsiteWidgetResponse extends MB_Action {
	/**
	 * The constructor for an RemoveTodoResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveWebsiteWidgetResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveWebsiteWidgetResponse";
		$this->params = array("websiteWidgetID");
	}

	/**
	 * The main method of this class that executes the RemoveWebsiteWidgetResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$websiteWidgetID = ((int) $_REQUEST["websiteWidgetID"]);
		if(!$websiteWidgetID) {
			$this->addError(TRANS_ACTIONERROR, "No Website Widget ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetWebsiteWidget", "delete");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("websitewidgets.php", getActionID("ShowWebsiteWidgets"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveWebsiteWidgetResponse
?>
