<?php
// $Id: ShowWebsiteWidgets.php 8304 2006-08-11 16:18:41Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action object displays a list of website widgets.
 *
 * @author  Kris Bailey
 */
class ShowWebsiteWidgets extends MB_Action {
	/**
	 * The constructor for a ShowWebsiteWidgets action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowWebsiteWidgets() {
		parent::MB_Action();
		$this->stringRep = "ShowWebsiteWidgets";
		
		$this->params = array(
			"websiteWidgetID",
			"websiteWidgetName",
			"websiteWidgetTpl");
		$this->sortColumns = array("websiteWidgetID");
	}

	/**
	 * The main method of this class that executes the ShowWebsiteWidgets action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$t= &new Timer;
		$query = $this->getMBAPIQuery("GetWebsiteWidgets", "", array("getOrderFormData"=>1), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		$this->smartyVars["wwLocalPath"] = addslashes(realpath(mb_path("/app-modernbill-order")));
		if ($CONF["secureURLProtocol"]=="http"){
			$this->smartyVars["wwRemotePath"] = addslashes("http://".$CONF["standardURL"]."/".mb_path_convert_name("app-modernbill-order"));
		} else {
			$this->smartyVars["wwRemotePath"] = addslashes("https://".$CONF["secureURL"]."/".mb_path_convert_name("app-modernbill-order"));
		}

		$this->smartyVars["websiteWidgets"] = grabSimpleMBAPIResults($data);
		$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);

		$this->addTemplate("websitewidgets/ShowWebsiteWidgets", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowWebsiteWidgets
?>
