<?php
// $Id: AddVendorInvoices.php 11778 2007-08-10 21:23:17Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

//$_REQUEST["__JSON"] = 1;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");
require_once mb_path("/lib-modernbill/include/accounting/Purchase.php");

/**
 */
class AddVendorInvoices extends MB_AdminAPIAction {
	/**
	 */
	function AddVendorInvoices() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "AddVendorInvoices";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->getVendorInformation();

		// at this point you have to test for $this->vendorData["vendorID"] to make sure
		// they are a vendor, then you have access to:
		// $this->vendorData
		// $this->adminData

		// use this line for fatal errors...
		// Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] System not accepting sellers.");

		if (!$this->vendorData["vendorID"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] You must be a valid vendor to report invoice data to us.");
			return;
		}

		dbg($_REQUEST["invoices"]);

		if ($_REQUEST["invoices"]){
			$this->invoices = (array)$_REQUEST["invoices"];
			foreach ($this->invoices as $x=>$invoice){
				if (is_array($invoice["lineItems"])){
					foreach ($invoice["lineItems"] as $xx=>$lineItem){
						// track down package locally via $lineItem["packageID"] and make purchase entry
						if ($lineItem["packageID"]){
							$packageVendorInfo = oneOf("packageVendorRels", array(
								"vendorPackageID" => $lineItem["packageID"],
								"vendorID" => $this->vendorData["vendorID"],
								"packages" => array(),
							));
							dbg($packageVendorInfo);
							if ($packageVendorInfo["packageID"]){
								dbg("ok, i need to do the cost for ".$packageVendorInfo["packageID"]);
								$purchase =& new Purchase();
								$purchase->setClientID((int)$packageVendorInfo["packages"][0]["clientID"]);
								$purchase->setCurrencyID($invoice["currencyID"]);
								$purchase->setDescription($lineItem["lineItemDescription"]);
								$purchase->setPurchaseAmount($lineItem["lineItemTotalAmount"]);
								$purchase->setPurchaseType("package");
								$purchase->setBeginDate($lineItem["lineItemDateCurrentRenewal"]);
								$purchase->setEndDate($lineItem["lineItemDateNextRenewal"]);
								$purchase->execute();
								dbg($purchase);
							}
						}
					}
				}
			}
		} else {
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] No invoice data supplied.");
		}

	}

} // AddVendorInvoices
