<?php
// $Id: CreateInvoice.php 11737 2007-08-03 21:33:01Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/apiaction.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
*/
class CreateInvoice extends MB_AdminAPIAction {
	/**
	 */
	function CreateInvoice() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "CreateInvoice";
		$this->params = array(
			"clientID",
			
			"shoppingSessionID",
			"set_locale",
			"customerType",
			"clientFirstName",
			"clientLastName",
			"clientCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"countriesID",
			"contactZip",
			"clientEmail",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"registrantFirstName",
			"registrantLastName",
			"registrantEmail",
			"registrantOrganizationName",
			"registrantJobTitle",
			"registrantAddress1",
			"registrantAddress2",
			"registrantCity",
			"registrantStateProvince",
			"registrantPostalCode",
			"registrantCountry",
			"registrantPhone",
			"registrantFax",
			"extAttrib",
			"contactUsername",
			"contactPassword",
			"existContactUsername",
			"existContactPassword",
			"clientNoteText",
			"taxIDNumber",
			"paymentType",
			"CRM",
			"invoiceID",
			"billingCardNameOnCard",
			"billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardStartDate",
			"billingBankType",
			"billingBankName",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankState",
			"billingBankDob",
			"billingAccountType",
			"billingAccountID",
			"cardCVV2",

			"ctlCustomer",
			"useContactInfo",
			
			"domain",
			"product");
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		dbg("#####################################\n#### Data _REQUEST in CreateInvoice ####\n#####################################");
		dbg($_REQUEST);
		
		$shoppingSessionData = $this->updateShoppingSession($_REQUEST['shoppingSessionID']);

		dbg("#####################################\n#### Shopping Session Data ####\n#####################################");
		dbg($shoppingSessionData);

		$processCheckoutParams =array();
		$processCheckoutParams["orderFormID"] = (int)$_REQUEST["orderFormID"];
		
		if ( (notZero($shoppingSessionData['clientID']) && notZero($_REQUEST['clientID']))
				&& ($shoppingSessionData['clientID'] != (int)$_REQUEST['clientID'])) {
			$this->addError(2000, "Possible Session Hijack Attempt");
			
		} else {
			if (notZero($shoppingSessionData['clientID']) && notZero($_REQUEST['clientID'])) {
				
				if ($shoppingSessionData['clientID'] == (int)$_REQUEST['clientID']) {
					// grab the client information
					$thisUser = oneOf("contacts", array(
										"clientID" => (int)$_REQUEST['clientID'],
										'clientContactID' => (int)$shoppingSessionData['clientContactID']));
					dbg("!!!!!!!!\n#### Client id in shopping session and request match ####\n!!!!!!!!!");
					dbg($thisUser);
					if (notNull( $thisUser )) {	// this is our current user.
						$processCheckoutParams['client'] = $thisUser;
			
						$processCheckoutParams['clientContact'] =array();
						foreach( (array)$processCheckoutParams['client'] as $k => $v ) {
							if (ereg('^contact.+', $k)) {
								$processCheckoutParams['clientContact'][ $k ] = $v;
										
								if (in_array($k, array('contactUsername','contactPassword'))) {
									unset($processCheckoutParams['client'][ $k ]);
									unset($processCheckoutParams['clientContact'][ $k ]);
								}
							}
						}
			
						// some translations the automation misses
						$processCheckoutParams['client']['clientFirstName'] = $processCheckoutParams['clientContact']['contactFirstName'];
						$processCheckoutParams['client']['clientLastName'] = $processCheckoutParams['clientContact']['contactLastName'];
								
						if (!notNull( $processCheckoutParams['client']['clientEmail'] ))
							$processCheckoutParams['client']['clientEmail'] = $processCheckoutParams['clientContact']['contactEmail'];

					} else {
						$this->addError(2000, "Client can not be found.");
					}
				} else {
					$this->addError(2001, "Session did not have client information associated.");
				}
			} else {
				dbg("!!!!!!!!!\n#### Shopping session has no info about user, so check it out and create one. ####\n!!!!!!!!!!!!!!");
				$generalValues = array(
					"contactUsername" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"contactPassword" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED); // it's assumed the password confirmation was done on the client side of the api

				if ($_REQUEST["ctlCustomer"] != "existing")
					$generalValues += array(
							"clientFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"clientLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
								
							"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"contactAddress2" => INPUT_RESTRICTION_STRING,
							"contactCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"contactZip" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			
							"clientCompany" => INPUT_RESTRICTION_STRING,
							"clientEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			
							"contactPhone1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"contactPhone2" => INPUT_RESTRICTION_STRING,
							"contactFax" => INPUT_RESTRICTION_STRING,
			
							"countriesID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
							"taxIDNumber" => INPUT_RESTRICTION_STRING);
				$registrantValues = array(
						"registrantFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
						"registrantLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
	
						"registrantEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
		
						"registrantAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
						"registrantAddress2" => INPUT_RESTRICTION_STRING,
						"registrantCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
						"registrantStateProvince" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
						"registrantPostalCode" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
		
						"registrantOrganizationName" => INPUT_RESTRICTION_STRING,
						"registrantJobTitle" => INPUT_RESTRICTION_STRING,
		
						"registrantPhone" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
						"registrantFax" => INPUT_RESTRICTION_STRING,
		
						"registrantCountry" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
						);
				if (is_array($_REQUEST["domain"]) && (notNull($_REQUEST["domain"]["domainName"]) && !$_REQUEST["useContactInfo"])) {
					$generalValues += $registrantValues;
				}
				
				$success = $this->validateMultiInputs($generalValues);
				
				if ($success) {
					/**
					 * Check if the client contact exists, start with username
					 */
					dbg("Successfully passed data check for contact information.");
					$userCheck = arrayFor("contacts", array("contactUsername" => (string)$_REQUEST["contactUsername"]));
					if (notNull($userCheck)) { // if this has errors, most likely nothing would be found
						if (count($userCheck) > 1 && ($_REQUEST["ctlCustomer"] != "existing")) {
							$this->addError(2002, "Username is already taken,");
							
						} else {
							// username exists in system, lets see if it's the same person maybe
							$thisUser = oneOf("contacts", array(
										"contactUsername" => (string)$_REQUEST["contactUsername"],
										"contactPassword" => getPasswordHash((string)$_REQUEST["contactPassword"]) ));

							dbg("Username match, results of checking password also.");
							dbg($thisUser);
							
							
							if (notNull( $thisUser )) {	// this is our current user.
								dbg("This is the current user!");

								$thisUser = array_merge( (array)oneOf("clients", array("clientID" => $thisUser['clientID'])), $thisUser);
								
								$processCheckoutParams['client'] = $thisUser;
			
								$processCheckoutParams['clientContact'] =array();
								foreach( (array)$processCheckoutParams['client'] as $k => $v ) {
									if (ereg('^contact.+', $k) || in_array($k, array('countriesID'))) {
										$processCheckoutParams['clientContact'][ $k ] = $v;
										
										if (in_array($k, array('contactUsername','contactPassword'))) {
											unset($processCheckoutParams['client'][ $k ]);
											unset($processCheckoutParams['clientContact'][ $k ]);
										}
									}
								}

								/// otherwise it will reinsert the password as the hash of the clear password
								$processCheckoutParams['client']['contactPassword'] = (string)$_REQUEST['contactPassword'];
								$processCheckoutParams['clientContact']['contactPassword'] = (string)$_REQUEST['contactPassword'];

								
								// some translations the automation misses
								if (!notNull($processCheckoutParams['client']['clientFirstName'])) {
									$processCheckoutParams['client']['clientFirstName'] = $processCheckoutParams['clientContact']['contactFirstName'];
									$processCheckoutParams['client']['clientLastName'] = $processCheckoutParams['clientContact']['contactLastName'];
								}
								
								if (!notNull( $processCheckoutParams['client']['clientEmail'] ))
									$processCheckoutParams['client']['clientEmail'] = $processCheckoutParams['clientContact']['contactEmail'];

								// associate the client with the session
								if (notZero( $shoppingSessionData['clientID'] )) {
									dbg("Client ID was set before, check if they are the same clientID");
									if ($shoppingSessionData['clientID'] != $thisUser['clientID']) {
										$this->addError(2003, 'Client supplied differs session record.');
									}
								} else {
									$this->setShoppingSessionContact($shoppingSessionData['shoppingSessionID'], $thisUser['clientID'], $thisUser['clientContactID']);
								}
							} else {
								$this->addError(2002, "Username is already taken.");
							}
						}
					} elseif (!notNull($userCheck) && ($_REQUEST["ctlCustomer"] == "existing")) {
						$this->addError(2004, "Supplied user credentials not found.");
					} else {
						$processCheckoutParams['client'] = array(
								"clientFirstName" => $_REQUEST["clientFirstName"],
								"clientLastName" => $_REQUEST["clientLastName"],
								"clientEmail" => $_REQUEST["clientEmail"],
								"clientCompany" => $_REQUEST["clientCompany"],
								"contactUsername" => $_REQUEST["contactUsername"],
								"contactPassword" => $_REQUEST["contactPassword"],
								"countriesID" => $_REQUEST["countriesID"]);
						$processCheckoutParams['clientContact'] = array(
								"clientFirstName" => $_REQUEST["clientFirstName"],
								"clientLastName" => $_REQUEST["clientLastName"],
								"clientEmail" => $_REQUEST["clientEmail"],
								"clientCompany" => $_REQUEST["clientCompany"],
								"contactUsername" => $_REQUEST["contactUsername"],
								"contactPassword" => $_REQUEST["contactPassword"],
								
								"contactAddress1" => $_REQUEST["contactAddress1"],
								"contactAddress2" => $_REQUEST["contactAddress2"],
								"contactCity" => $_REQUEST["contactCity"],
								"contactState" => $_REQUEST["contactState"],
								"contactZip" => $_REQUEST["contactZip"],
								"contactCountriesID" => $_REQUEST["countriesID"],
								"countriesID" => $_REQUEST["countriesID"],
								"contactPhone1" => $_REQUEST["contactPhone1"],
								"contactPhone2" => $_REQUEST["contactPhone2"],
								"contactFax" => $_REQUEST["contactFax"]);
					}
				} else { // success
					$this->addError(3000, "Could not validate input.");
				}
			}
		}
		
		$this->writeCorrectContactInfo($processCheckoutParams, $output['client']);
		
		dbg("Client params for processCheckoutParams");
		dbg($processCheckoutParams);

		

		/// lets associate with the correct languageID
		if (!notNull( $_REQUEST["set_locale"] )) {
			if (isset( $_REQUEST["domain"]["set_locale"] ) && notNull( $_REQUEST["domain"]["set_locale"] ))
				$_REQUEST["set_locale"] =& $_REQUEST["domain"]["set_locale"];
		}
		if (preg_match('|^(\w*)_[A-Z]{2}$|m', $_REQUEST["set_locale"], $locale, PREG_OFFSET_CAPTURE) != false) {
			$locale = $locale[1][0];
			
			$language = oneOf("languages", array(
					"languageISO2" => $locale));
			
			if (isset( $language['languageID'] ) && notZero( $language['languageID'] )) {
				$processCheckoutParams['client']['languageID'] = $language['languageID'];
				$processCheckoutParams['clientContact']['languageID'] = $language['languageID'];
			} else {
				$this->addError(4000, "Invalid Language Passed With Locale");
			}
			unset( $locale, $language );
		} else {
			$this->addError(3001, "Locale not provided.");
		}
		
		if ($this->getNumErrors()) {
			$this->writeOutput( array() );
		}

		
		
		$params =array();
		foreach( (array)$this->params as $param ) {
			if (notNull( $_REQUEST[ $param ] )) {
				$params[ $param ] = $_REQUEST[ $param ];
			}
		}

		// so customer information should be out of the way by this point. now we need to group the domain and product information
		// make domain
		if (is_array( $_REQUEST["domain"] ) && notZero( $_REQUEST["domain"]["productVariantID"] )) {
			$domainID = rand(0,300);
			
			$domainInfo =& new MBQuery("GetProductVariants", "",array(
						"productVariantID" => (int)$_REQUEST["domain"]["productVariantID"],
						"cycleID" => (int)$_REQUEST["domain"]["cycleID"],
						"productVariantActive" => 1,
						"getProductVariantPriceData" => 1));
			$domainInfo = $domainInfo->getResult();

			$fail = false;
			foreach( array('cycleID','productID','productVariantID','domainType','domainName','set_locale') as $key ) {
				switch( $key ) {
				case 'domainType':
					if (getAPITypeID('shoppingdomains', $_REQUEST["domain"]["domainType"]) === false)
						$fail = true;
					
					if (($_REQUEST['domain']['domainType'] == 'transfer') && !notNull( $_REQUEST['domain']['domainType'] ))
						$fail = true;
				break;

				default:
					if (!notNull( $_REQUEST["domain"][ $key ] ))
						$fail = true;
				break;
				}
			}
			
			if (notZero($domainInfo->getErrorCount()) || $fail) {
				$this->addError(5000, "Failed to retrieve domain product information.");
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}

			$domainInfo = grabSimpleMBAPIResults( $domainInfo->getStructure() );
			
			$setup = $price =0.00;

			foreach( (array)$domainInfo[0]["productVariantPrices"][0]["productVariantPrice"] as $p ) {
			/*	if (!notZero( $p["productVariantID"] )) {
					$this->addError(5001, "Failed to retrieve product information.");
					$this->addErrorTemplates();
					return -1;
				}
			*/
				if ( ($p["productVariantPriceType"] == getAPITypeID("price", 'general')) && ($_REQUEST['domain']['cycleID'] > 0) ) {
					$price = $p["productVariantPriceAmount"];
				} elseif ($p["productVariantPriceType"] == getAPITypeID("price", 'setup')) {
					$setup = $p["productVariantPriceAmount"];
				}
			}

			$_REQUEST["domain"]["domainName"] = explode('.', $_REQUEST["domain"]["domainName"]);

			if ($_REQUEST["domain"]["cycleID"] == -2) {
				$t = oneOf( 'productVariantPrices', array('productVariantID' => (int)$_REQUEST["domain"]["productVariantID"], 'productVariantPriceType' => 'transfer'));
				$_REQUEST['domain']['cycleID'] = $t['cycleID'];
				$price = $t['productVariantPriceAmount'];
				unset( $t );

				
			}

			$processCheckoutParams["products"][] = array(
						"ID" => $domainID,
						"productID" => (int)$_REQUEST["domain"]["productID"],
						"productVariantID" => (int)$_REQUEST["domain"]["productVariantID"],
						"packageDateNextRenewal" => mktime()+(60*20), //add 20 minutes
						"cycleID" => (int)$_REQUEST["domain"]["cycleID"],
						"quantity" => 1,
						"price" => $price,
						"setup" => $setup,
						"domain" => array(
							"domainType" => getAPITypeID("shoppingdomains", $_REQUEST["domain"]["domainType"]),
							"domainTransferKey" => $_REQUEST["domain"]["domainTransferKey"],
							"domainID" => $domainID,
							"domainSLD" => $_REQUEST["domain"]["domainName"][0],
							"domainTLD" => $_REQUEST["domain"]["domainName"][1],
							"domainIDNLanguage" => $_REQUEST["domain"]["domainLanguage"]
							),
						);
			unset( $domainInfo, $fail, $setup, $price, $p );
		}








		
		/**
		 * done adding domain, $domainID should be populated with the random id of the domain from the first product,
		 * if there is one.
		 */
		if (is_array( $_REQUEST["product"] )) {
			$productID = rand(0,300);
			$productInfo =& new MBQuery("GetProductVariants", "",array(
						"productVariantID" => (int)$_REQUEST["product"]["productVariantID"],
						"cycleID" => (int)$_REQUEST["product"]["cycleID"],
						"productVariantActive" => 1,
						"getProductVariantPriceData" => 1));
			$productInfo = $productInfo->getResult();

			$fail = false;
			foreach( array('cycleID','productID','productVariantID') as $key ) {
				if (!notNull( $_REQUEST["product"][ $key ] ))
					$fail = true;
			}
			
			if (notZero($productInfo->getErrorCount()) || $fail) {
				$this->addError(5001, "Failed to retrieve product information.");
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}

			$productInfo = grabSimpleMBAPIResults( $productInfo->getStructure() );

			$setup = $price =0.00;
			foreach( (array)$productInfo[0]["productVariantPrices"][0]["productVariantPrice"] as $p ) {
				if ($p["productVariantPriceType"] == getAPITypeID("price", 'general')) {
					$price = $p["productVariantPriceAmount"];
				} elseif ($p["productVariantPriceType"] == getAPITypeID("price", 'setup')) {
					$setup = $p["productVariantPriceAmount"];
				}
			}
			if (!is_array( $_REQUEST["domain"]["domainName"] ))
				$_REQUEST["domain"]["domainName"] = explode('.', $_REQUEST["domain"]["domainName"]);
				
			$processCheckoutParams["products"][] = array(
						"ID" => $productID,
						"productID" => (int)$_REQUEST["product"]["productID"],
						"productVariantID" => (int)$_REQUEST["product"]["productVariantID"],
						"packageDateNextRenewal" => mktime()+(60*20), //add 20 minutes
						"cycleID" => (int)$_REQUEST["product"]["cycleID"],
						"quantity" => 1,
						"price" => $price,
						"setup" => $setup)+(notZero($domainID) ? array( // ghetto if statement
							"domain" => array(
								"domainType" => $_REQUEST["domain"]["domainType"],
								"domainID" => $domainID,
								) ) : array( // else
								"domain" => array(
									"domainSLD" => $_REQUEST["domain"]["domainName"][0],
									"domainTLD" => $_REQUEST["domain"]["domainName"][1])
									) );
			unset( $productInfo, $fail );
		}

		
		
		$processCheckoutParams['fraudLevelAction'] = 1;
		$processCheckoutParams['fraudLevelActionStatus'] = 1;

		if ($_REQUEST["process"]) { // grab billing info
			$processCheckoutParams['clientBillingAccount'] = array(
				"billingAccountID" => (int)$_REQUEST["billingAccountID"],
				"billingCardNameOnCard" => $_REQUEST["billingCardNameOnCard"],
				"billingCardType" => $_REQUEST["billingCardType"],
				"billingCardExpMonth" => $_REQUEST["billingCardExpMonth"],
				"billingCardExpYear" => $_REQUEST["billingCardExpYear"],
				"billingCardStartDate" => mktime(),
				"billingBankType" => $_REQUEST["billingBankType"],
				"billingBankName" => $_REQUEST["billingBankName"],
				"billingBankAbaCode" => $_REQUEST["billingBankAbaCode"],
				"billingBankAccountNum" => $_REQUEST["billingBankAccountNum"],
				"billingBankLicenseNum" => $_REQUEST["billingBankLicenseNum"],
				"billingBankLicenseState" => $_REQUEST["billingBankLicenseState"],
				"billingBankState" => $_REQUEST["billingBankState"],
				"billingBankDob" => $_REQUEST["billingBankDob"],
				"billingAccountType" => $_REQUEST["billingAccountType"],
				"cardCVV2" => $_REQUEST["cardCVV2"]);
			$_REQUEST["paymentType"] = explode( '|', $_REQUEST["paymentType"] );
			$processCheckoutParams["paymentType"] = (int)$_REQUEST["paymentType"][0];

			if (isset( $_REQUEST["paymentType"][1] ))
				$processCheckoutParams["secondary"] = (int)$_REQUEST["paymentType"][1];

			$processCheckoutParams['domainRegistrant'] = array();
			foreach( (array)$_REQUEST as $k => $v ) {
				if (ereg('registrant[a-z,A-Z]+', $k)) {
					$processCheckoutParams['domainRegistrant'][ $k ] = $v;
				}
			}
		}

		dbg("#### ProcessCheckout::".(notNull($_REQUEST["process"]) ? "process" : "preview")." Params ####");
// show($processCheckoutParams);exit;
		// safer to default to a preview than to actually process an order just because someone neglected the preview param.
		$previewCheckout =& new MBQuery("ProcessCheckout", ( notNull($_REQUEST["process"]) ? "process" : "preview" ), $processCheckoutParams);
		$previewCheckout = $previewCheckout->getResult();

		if ($previewCheckout->getErrorCount()) {
			$this->addError(6000,"Failed to build invoice.");
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		$previewCheckout = correctArray($previewCheckout->getStructure());

		$previewCheckout = $previewCheckout["mbapi"][0]["results"][0];

		if (isset($previewCheckout['invoice'][0])) {
			$output['invoice'] =& $previewCheckout['invoice'][0];
		} elseif (isset($previewCheckout['invoiceID'])) {
			$output['invoice'] =& $previewCheckout;
		}

		// lets make sure we have the client id, because it _WILL_ be required for the process
		if (!isset($output['client']['clientID']) || !notZero($output['client']['clientID'])) {
			$output['client']['clientID'] = $output['invoice']['clientID'];
		}

		if (isset( $_REQUEST['paymentType'] ))
		unset($processCheckoutParams);
		
		if (notNull($_REQUEST['process'])) {
			$invoiceData =& new MBQuery("GetInvoices","", array(
					"invoiceID" => (int)$output['invoice']['invoiceID'],
					"getTransactionData" => 1));
			$invoiceData = $invoiceData->getResult();

			if (!$invoiceData->getErrorCount()) {
				$invoiceData = grabSimpleMBAPIResults($invoiceData->getStructure());
				$output['invoice'] += $invoiceData[0];
			}
		}

		if (notZero($previewCheckout['clientContactID'])) { // lookup contactID
			$this->setShoppingSessionContact($shoppingSessionData["shoppingSessionID"], $previewCheckout["clientID"], $previewCheckout["clientContactID"]);
		}


		// output check!
		$this->writeOutput( $output );
		
		return true;
	}
	// overloading add error templates function
	function addErrorTemplates() {
		$this->writeOutput(array());
	}
	
	function writeOutput( $apiContent ) {
		
		$headers = array(
			"app" => "app-modernbill-api",
			"success" => 1,
			"timestamp" => time());
		
		foreach( (array)$this->getErrors() as $err ) {
			$headers['success'] = 0;
			$headers['errorCount']++;
			$headers['errors']['error'][] = array();
			$headers['errors']['error'][ count($headers['errors']['error'])-1 ]['title'] = $err[0];
			$headers['errors']['error'][ count($headers['errors']['error'])-1 ]['message'] = $err[1];
		}	unset($err);
		
		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n\n";
		
		echo toXML(array("api" => array("header" => $headers,"results"=>$apiContent) ));

		exit;
	}

	function writeCorrectContactInfo( &$params, &$dest ) {
		if (!is_array($params) && !notNull($params)) {
			return false;
		}

		foreach( array('client','clientContact') as $pKey )
		foreach( (array)$params[ $pKey ] as $k => $v ) {
			if (eregi('^client', $k) || eregi('^contact', $k) || ($k == "countriesID")) {
				$dest[ $k ] = $v;

				if ($k == 'contactPassword')
					unset($dest[ $k ]);
			}
		}
		
		if (!notZero( $dest["countriesID"] ) && notZero( $dest["contactCountriesID"]))
			$dest["countriesID"] = $dest['contactCountriesID'];

		if ($_REQUEST["useContactInfo"]) {
			$dest["registrantFirstName"] = $dest['contactFirstName'];
			$dest["registrantLastName"] = $dest['contactLastName'];

			if (!notNull($dest["registrantFirstName"]))
				$dest["registrantFirstName"] = $dest['clientFirstName'];

			if (!notNull($dest["registrantLastName"]))
				$dest["registrantLastName"] = $dest['clientLastName'];

			$dest["registrantEmail"] = $dest['clientEmail'];

			$dest["registrantAddress1"] = $dest['contactAddress1'];
			$dest["registrantAddress2"] = $dest['contactAddress2'];
			$dest["registrantCity"] = $dest['contactCity'];

			$dest["registrantStateProvince"] = $dest['contactState'];
			$dest["registrantPostalCode"] = $dest['contactZip'];

			$dest["registrantOrganizationName"] = $dest['contactCompany'];

			$dest["registrantPhone"] = $dest['contactPhone1'];
			$dest["registrantFax"] = $dest['contactFax'];


			$country = oneOf("countries", array("countriesID" => $dest['countriesID']));
			$dest["registrantCountry"] = $dest["countriesID"]; //$country['countriesISO2'];

			$dest["registrantCountriesID"] = $dest["countriesID"];
		}
		
	}

	function setShoppingSessionContact( $sid, $clientID, $contactID, $ofID = 0 ) {
		if (!notNull( $sid ) || !notNull( $clientID ) || !notNull( $contactID )) {
			return false;
		}

		if (!notZero( $ofID )) {
			$ofID = notZero($_REQUEST["orderFormID"]) ? (int)$_REQUEST["orderFormID"] : 1;
		}
		
		dbg("Recording new contact with shopping cart.");
		$query =& new MBQuery("SetShoppingSession", "update", array(
			"shoppingSessionID" => $sid,
			"clientID" => $clientID,
			"clientContactID" => $contactID,
			"orderFormID" => $ofID));
		$query = $query->getResult();
		if ($query->getErrorCount()) {
			$this->addError(4001, "Failed to record session");
			return false;
		}
		unset($query);

		return true;
	}
}
?>
