<?php
// $Id: CreateMarketplaceSeller.php 10872 2007-03-13 21:18:48Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

//$_REQUEST["__JSON"] = 1;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");
require_once mb_path("/lib-action/include/url/url.php");

/**
 */
class CreateMarketplaceSeller extends MB_APIAction {
	/**
	 */
	function CreateMarketplaceSeller() {
		parent::MB_APIAction();
		$this->stringRep = "CreateMarketplaceSeller";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if (MB_VENDOR==1){
		
			if ($_REQUEST["contactUsername"] && $_REQUEST["contactPassword"]){
			
				$authenticationResults = correctArray(dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "ProcessClientLogin",
						"params" => array(
							"contactUsername" => $_REQUEST["contactUsername"],
							"contactPassword" => $_REQUEST["contactPassword"],
							"clientIP" => $_SERVER["REMOTE_ADDR"],
							"suppressSetConf" => 1,
						),
					),
				)), 1));
				
				dbg($authenticationResults);
				
				if (!($authenticationResults["mbapi"][0]["results"] && $authenticationResults["mbapi"][0]["results"][0]["clientID"])){
					Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to authenticate client_");
				}
		
				$clientID = $authenticationResults["mbapi"][0]["results"][0]["clientID"][0];
				$this->clientInfo = oneByID("clients", $clientID, array(
					"mergePrimaryContact" => 1,
				));
			
				$this->sellerInfo = oneOf("marketplaceSellers", array("clientID" => $this->clientInfo["clientID"]));
				
			}
		
		
			if (MB_VENDOR_ALLOW_AUTO_SIGNUP!=1 && !(int)$this->clientInfo["clientID"]){
				Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] System not accepting automated seller signups, please contact vendor for signup instructions.");
			} elseif (!(int)$this->clientInfo["clientID"]){
			
				$results = runActionAPICommand($url, "getCompanyInformation", array(
					"adminUsername" => $_REQUEST["vendorUsername"],
					"adminPassword" => $_REQUEST["vendorPassword"],
				));
				if ((int)$results["api"][0]["header"][0]["errors"][0]["title"][0]){
					Error::api(1003, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Invalid API Information Passed to system.");
				}
				
				$countriesInfo = oneOf("countries", array(
					"countriesISO2" => ($_REQUEST["countriesISO2"])?$_REQUEST["countriesISO2"]:"US",
				));
				$countriesID = ($countriesInfo["countriesID"])?$countriesInfo["countriesID"]:224;
				$languageInfo = oneOf("languages", array(
					"languageISO2" => ($_REQUEST["languageISO2"])?$_REQUEST["languageISO2"]:"en",
				));
				$languageID = ($languageInfo["languageID"])?$languageInfo["languageID"]:21;
				
				$companyInfo = collapseArrayElements($results["api"][0]["results"][0]["company"][0]);
				
				$userIter = 1;
				$tuser = $_REQUEST["client_contactUsername"];
				if (!trim($tuser)){
					$xu = new URL($_REQUEST["apiURL"]);
					$tuser = $_REQUEST["client_contactUsername"] = ereg_replace("[^[:alnum:]]", "", $xu->getHost());
				}
				$testUser = arrayFor(":contacts", array(
					"contactUsername" => $tuser,
				));
				dbg($testUser);
				while ((int)$testUser[0]["clientContactID"]) {
					dbg("tried user: ".$tuser);
					$tuser = $_REQUEST["client_contactUsername"]."_".$userIter++;
					$testUser = arrayFor(":contacts", array(
						"contactUsername" => $tuser,
					));
				}
				$_REQUEST["client_contactUsername"] = $tuser;
				dbg("settled on: ".$tuser);
				dbg("password passed: ".$_REQUEST["client_contactPassword"]);
				$setClients = array(
					"mbapi" => array(
						"command" => "SetClients",
						"subCommand" => "insert",
						"params" => array(
							"clientFirstName" => $_REQUEST["client_contactFirstName"],
							"clientLastName" =>  $_REQUEST["client_contactLastName"],
							"clientEmail" => $_REQUEST["client_contactEmail"],
							"clientCompany" => $_REQUEST["client_clientCompany"],
							"clientDateCreated" => time(),
							"countriesID" => $countriesID,
							"companyID" => "1",
							"themeID" => $CONF["theme"]["id"],
							"languageID" => $languageID,
							"applyTax" => "1",
							"taxIDNumber" => "",
							"clientStatus" => 0,
							"clientStatusReason" => "",
							"clientActive" => 1,
							"clientContacts" => array(
								"clientContact" => array(
									"contactFirstName" => $_REQUEST["client_contactFirstName"],
									"contactLastName" => $_REQUEST["client_contactLastName"],
									"contactUsername" => $_REQUEST["client_contactUsername"],
									"contactPassword" => $_REQUEST["client_contactPassword"],
									"contactEmail" => $_REQUEST["client_contactEmail"],
									"contactEmailFormat" => $_REQUEST["client_contactEmailFormat"],
									"contactCompany" => $_REQUEST["client_contactCompany"],
									"contactAddress1" => $_REQUEST["client_contactAddress1"],
									"contactAddress2" => $_REQUEST["client_contactAddress2"],
									"contactCity" => $_REQUEST["client_contactCity"],
									"contactState" => $_REQUEST["client_contactState"],
									"contactZip" => $_REQUEST["client_contactZip"],
									"countriesID" => $countriesID,
									"languageID" => $languageID,
									"contactPhone1" => $_REQUEST["client_contactPhone1"],
									"contactPhone2" => $_REQUEST["client_contactPhone2"],
									"contactFax" => $_REQUEST["client_contactFax"],
									"contactPrimary" => 1,
								),
							),
						),
					),
				);
				
				$setClientResults = collapseArrayElements(dispatchMBAPI(toXML($setClients), 1));
				
				if (!($clientID = $setClientResults["mbapi"]["header"]["lastInsertID"])){
					Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Error creating client record.");
				}
			
				$this->clientInfo = oneByID("clients", $clientID, array(
					"mergePrimaryContact" => 1,
				));

			}
			
			if ($this->sellerInfo["sellerID"]){
				if ($this->testAPIURL($_REQUEST["apiURL"])==getAPIStatusID("sellerApi", "up")){
					updateForKey("marketplaceSellers", $this->sellerInfo["sellerID"], array(
						"sellerApiURL" => $_REQUEST["apiURL"],
					));
				}
				return $this->output(array(
					"sellerStatus" => ((int)$this->sellerInfo["sellerActive"])?"active":"inactive"
				));
			}
		
			$sellerID = insertFor("marketplaceSellers", array(
				"sellerDateRegistered" => time(),
				"sellerApiURL" => $_REQUEST["apiURL"],
				"clientID" => $this->clientInfo["clientID"],
				"sellerActive" => 1,
				"sellerApiStatus" => $this->testAPIURL($_REQUEST["apiURL"]),
				"sellerUsername" => $_REQUEST["vendorUsername"],
				"sellerPassword" => getOtherStuff($_REQUEST["vendorPassword"]),
			));
			
			return $this->output(array(
				"sellerStatus" => "active",
				"sellerUsername" => $tuser,
			));
			
		
		} else {
			Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] System not accepting sellers.");
		}

	}
	
	function testAPIURL($url){
		$results = runActionAPICommand($url, "getCompanyInformation", array(
			"adminUsername" => $_REQUEST["vendorUsername"],
			"adminPassword" => $_REQUEST["vendorPassword"],
		));
		if ((int)$results["api"][0]["header"][0]["errors"][0]["title"][0]){
			return getAPIStatusID("sellerApi", "authfailure");
		} elseif ($results["api"][0]["header"][0]){
			return getAPIStatusID("sellerApi", "up");
		} else {
			return getAPIStatusID("sellerApi", "down");
		}
	}

} // CreateMarketplaceSeller
