<?php
// $Id: CreatePackage.php 11859 2007-09-11 20:39:09Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class CreatePackage extends MB_AdminAPIAction {
	/**
	 */
	function CreatePackage() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "CreatePackage";
		$this->params = array
		(
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();


		if (!(int)$_REQUEST["clientID"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid client ID.");
		}
		if (!(int)$_REQUEST["orderFormID"]){
			Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid order form ID.");
		}
		if (!$_REQUEST["productID"]){
			if (!$_REQUEST["productAttributeName"]){
				Error::api(1003, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product attribute name.");
			}
			if (!$_REQUEST["productAttributeValue"]){
				Error::api(1003, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product attribute value.");
			}
		}
		if (!(int)$_REQUEST["billingAccountID"]){
			Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid billing account ID.");
		}
		# Install location is optional.
		#if (!$_REQUEST["installLocation"]){
		#	Error::api(1005, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid install location.");
		#}
		
		if (!$_REQUEST["productID"]){
			$attributes = arrayFor("productAttributes", array(
				"productAttributeName" => $_REQUEST["productAttributeName"],
				"productAttributeValue" => $_REQUEST["productAttributeValue"],
			));
			dbg($attributes);
			$productID = $attributes[0]["productID"];
		} elseif ($_REQUEST["productID"]){
			$productID = $_REQUEST["productID"];
		} else {
			$productID = 0;
		}
		$orderFormInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetOrderForms",
				"params" => array(
					"orderFormID" => (int)$_REQUEST["orderFormID"],
				),
			),
		)));

		$productInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProducts",
				"params" => array(
					"productID" => $productID,
					"productActive" => 1,
					"getProductVariantData" => 1,
					"getProductVariantPriceData" => 1,
					"getCycleData" => 1,
				),
			),
		)));
				
		if (!(int)$productInfo["productID"]){
			Error::api(1006, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid license def ID.");
		}

		/**
		 *
		 * below is the code that is takes to find out the price and cycle and tax zone group id
		 * and all that so that you can run the ProcessCheckout command that sets up everything.
		 *
		 */

		$taxZoneGroupIDs = array();
		foreach ((array)$productInfo["productVariants"] as $variant){
			$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
		}

		$prices = array();
		$cycleID = 0;
		if (isset($productInfo["productVariantPrices"])){
			foreach ($productInfo["productVariantPrices"] as $price){
				if ($price["currencyID"]==$orderFormInfo["paymentGroupCurrencyID"]){
					if (!$cycleID){
						$cycleID = $price["cycleID"];
					}
					if (!$productVariantID){
						$productVariantID = $price["productVariantID"];
					}
					if (!$prices[$price["productVariantPriceType"]]){
						$prices[$price["productVariantPriceType"]] = $price;
					}
				}
			}
		} else {
			dbg("variant price not set");
		}

		$productInfo["prices"] = $prices;
		if (!count($productInfo["prices"])){
			Error::api(1007, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to find valid price for specified product.");
		}

		$ID = 1;
		$productID = $productInfo["productID"];
		foreach ((array)$productInfo["productVariantPrices"] as $price){
			if ($price["productVariantID"] == $productVariantID){
				$taxZoneGroupID = $taxZoneGroupIDs[$price["productVariantID"]];
			}
		}
		$price = $productInfo["prices"][0]["productVariantPriceAmount"];
		$setup = $productInfo["prices"][1]["productVariantPriceAmount"];
		
		$processCheckout = array(
			"mbapi" => array(
				"command" => "ProcessCheckout",
				"subCommand" => "process",
				"params" => array(
					"orderFormID" => (int)$_REQUEST["orderFormID"],
					"paymentType" => 9999,
					"fraudLevelActionStatus" => 1,
					"disableInvoicing" => ((int)$_REQUEST["disableInvoicing"]) ? 1 : 0,
					"disableCharging" => ((int)$_REQUEST["enableCharging"])? 0 : 1,
					"disableProvisioning" => (int)$_REQUEST["disableProvisioning"],					
					"disableFraudguardian" => 1,
					"disableClientUpdates" => 1,
					"client" => array(
						"clientID" => (int)$_REQUEST["clientID"],
					),
					"clientBillingAccount" => array(
						"clientBillingAccountID" => (int)$_REQUEST["billingAccountID"],
					),
					"products" => array(
						0 => array(
							"ID" => $ID,
							"nameAppend" => $_REQUEST["installLocation"],
							"productID" => $productID,
							"productVariantID" => $productVariantID,
							"cycleID" => $cycleID,
							"quantity" => 1,
							"taxZoneGroupID" => $taxZoneGroupID,
							"price" => $price,
							"discount" => (float)$_REQUEST["discount"],
							"originalPrice" => $price,
							"setup" => $setup,
						),
					),
				),
			),
		);

		$checkoutResults = dispatchMBAPI(toXML($processCheckout), 1);
		dbg($checkoutResults);
		if (!(int)$checkoutResults["mbapi"][0]["header"][0]["success"][0]){
			Error::api(1008, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to insert package.");
		}

		$output = array("packageID" => $checkoutResults["mbapi"][0]["results"][0]["packageID"][0]);

		return $this->output($output);

	}
} // CreatePackage
?>