<?php
// $Id: CreateVendorPackage.php 11286 2007-06-07 22:56:12Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class CreateVendorPackage extends MB_ClientAPIAction {
	/**
	 */
	function CreateVendorPackage() {
		parent::MB_ClientAPIAction();
		$this->stringRep = "CreateVendorPackage";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->mergeMarketplaceSellerInfo();

		if (!(int)$this->sellerInfo["sellerActive"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] This seller account is not active.");
		}
		if (!(int)$_REQUEST["productVariantID"]){
			Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product variant ID.");
		}
		if (!(int)$_REQUEST["orderFormID"]){
			Error::api(1003, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid order form ID.");
		}
	
		$cycleInfo = oneOf("cycles", array(
			"cycleNumSeconds" => (int)$_REQUEST["cycle"]["seconds"],
			"cycleNumMinutes" => (int)$_REQUEST["cycle"]["minutes"],
			"cycleNumHours" => (int)$_REQUEST["cycle"]["hours"],
			"cycleNumDays" => (int)$_REQUEST["cycle"]["days"],
			"cycleNumMonths" => (int)$_REQUEST["cycle"]["months"],
			"cycleNumYears" => (int)$_REQUEST["cycle"]["years"],
		));
		
		if (!(int)$cycleInfo["cycleID"]){
			Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass valid cycle information.");
		}
		
		
		#if (!(int)$_REQUEST["billingAccountID"]){
		#	Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid billing account ID.");
		#}
		# Install location is optional.
		#if (!$_REQUEST["installLocation"]){
		#	Error::api(1005, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid install location.");
		#}
		
		$productVariantInfo = oneByID("productVariants", (int)$_REQUEST["productVariantID"], array(
			"productVariantActive" => 1,
			"orderFormID" => (int)$_REQUEST["orderFormID"],
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"cycleID" => (int)$cycleInfo["cycleID"],
		));
		dbg($productVariantInfo);
		
		if (!(int)$productVariantInfo["productID"]){
			Error::api(1007, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product variant ID.");
		}

		$price = 0;
		$setup = 0;
		$gotPrices = 0;
		foreach ($productVariantInfo["productVariantPrices"] as $p){
			if ($p["productVariantPriceType"]==1){
				$setup = (float)$p["productVariantPriceAmount"];
				$gotPrices = 1;
			} elseif ($p["productVariantPriceType"]==0){
				$price = (float)$p["productVariantPriceAmount"];
				$gotPrices = 1;
			}
		}

		if (!$gotPrices){
			Error::api(1008, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product variant ID.");
		}

		$quantity = ((int)$_REQUEST["quantity"])?(int)$_REQUEST["quantity"]:1;
		
		$processCheckout = array(
			"mbapi" => array(
				"command" => "ProcessCheckout",
				"subCommand" => "process",
				"params" => array(
					"orderFormID" => (int)$_REQUEST["orderFormID"],
					"paymentType" => 9999,
					"fraudLevelActionStatus" => 1,
					"disableInvoicing" => 1,
					"disableCharging" => 1,
					"disableFraudguardian" => 1,
					"disableClientUpdates" => 1,
					"client" => array(
						"clientID" => $this->clientInfo["clientID"],
					),
					"clientBillingAccount" => array(
						"clientBillingAccountID" => $this->clientInfo["defaultBillingAccountID"],
					),
					"products" => array(
						0 => array(
							"ID" => "1111",
							"productID" => $productVariantInfo["productID"],
							"productVariantID" => $productVariantInfo["productVariantID"],
							"cycleID" => $cycleInfo["cycleID"],
							"quantity" => $quantity,
							"taxZoneGroupID" => $productVariantInfo["taxZoneGroupID"],
							"price" => $price,
							"setup" => $setup,
						),
					),
				),
			),
		);

		$checkoutResults = dispatchMBAPI(toXML($processCheckout), 1);
		dbg($checkoutResults);
		if (!(int)$checkoutResults["mbapi"][0]["header"][0]["success"][0]){
			Error::api(1009, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to insert package.");
		}

		$output = array("packageID" => $checkoutResults["mbapi"][0]["results"][0]["packageID"][0]);

		return $this->output($output);

	}
} // CreateVendorPackage