<?php
// $Id: DeleteVendorPackage.php 10526 2007-01-19 22:25:36Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class DeleteVendorPackage extends MB_ClientAPIAction {
	/**
	 */
	function DeleteVendorPackage() {
		parent::MB_ClientAPIAction();
		$this->stringRep = "DeleteVendorPackage";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->mergeMarketplaceSellerInfo();

		if (!(int)$this->sellerInfo["sellerActive"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product variant ID.");
		}
		if (!(int)$_REQUEST["packageID"]){
			Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid package ID.");
		}

		$packageInfo = oneByID("packages", (int)$_REQUEST["packageID"], array(
			"clientID" => $this->clientInfo["clientID"],
		));

		if (!(int)$packageInfo["packageID"]){
			Error::api(1003, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid package ID.");
		}

		if ($packageInfo["packageCancellationType"]==getAPITypeID("cancellation", "admin_suspend") || $packageInfo["packageCancellationType"]==getAPITypeID("cancellation", "admin_delete")){
			Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] You are not allowed to cancel this package.");
		}

		if ($packageInfo["packageCancellationType"]==getAPITypeID("cancellation", "both_delete")){
			$action = "delete";
		} else {
			$action = "suspend";
		}

		$this->changePackageStatus($packageInfo["packageID"], array("cancel", "delete"));

		$output = array("success" => 1);

		return $this->output($output);

	}
} // DeleteVendorPackage
?>