<?php
// $Id: GetClientStatus.php 11737 2007-08-03 21:33:01Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");
require_once mb_path("/lib-action/include/reports/ARAging.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 */
class GetClientStatus extends MB_AdminAPIAction {
	/**
	 */
	function GetClientStatus() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "GetClientStatus";
		$this->params = array
		(
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if ((int)$_REQUEST["packageID"]){
			$packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"packageID" => (int)$_REQUEST["packageID"],
					),
				),
			)));
			$_REQUEST["clientID"] = $packageInfo["clientID"];
		}

		$clientInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetClients",
				"params" => array(
					"clientID" => (int)$_REQUEST["clientID"],
				),
			),
		)));


		if (!(int)$clientInfo["clientID"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid client ID.");
		}

		$this->reportParams = array(
			"detailLevel" => 0,
			"outputType" => 0,
			"clientID" => (int)$clientInfo["clientID"],
			"generalLedgerDateCreatedMax" => time(),
			"ledgerAccountID" => array(getGeneralLedgerAccountID("accounts_receivable")),
			);
		$this->report =& new ARAgingReport($this->reportParams);
		$this->reportdata = $this->report->execute();
		
		$agingLevel = 0;
		foreach ((array)$this->reportdata["data"][$clientInfo["clientID"]] as $currency=>$data){
			foreach ((array)$data as $level=>$leveldata){
				if ($leveldata["debits"]>0){
					if ($level>=$agingLevel){
						$agingLevel = $level+1;
					}
				}
			}
		}
		
		$output = array(
			"clientStatus" => $clientInfo["clientStatus"], 
			"clientAPIStatus" => $CONF["APIstatuses"]["client"][$clientInfo["clientStatus"]], 
			"clientStatusName" => $CONF["statuses"]["client"][$clientInfo["clientStatus"]],
			"agingLevel" => $agingLevel,
		);


		$retArray = array(
			"api" => array(
				"header" => array(
					"app" => "app-modernbill-api",
					"success" => 1,
					"timestamp" => mktime(),
				),
				"results" => $output,
			)
		);

   		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n\n";
		echo toXML($retArray);

		return true;
	}
} // GetClientStatus
?>