<?php
// $Id: GetMBAPIMap.php 8618 2006-09-01 14:56:50Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

//$_REQUEST["__JSON"] = 1;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class GetMBAPIMap extends MB_AdminAPIAction {
	/**
	 */
	function GetMBAPIMap() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "GetMBAPIMap";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		require_once mb_path("/lib-tk/mbapimap.php");
		
		$this->typeMap = array(
			"COLUMN_SORTABLE_DEFAULT" => constant("COLUMN_SORTABLE_DEFAULT"),
			"COLUMN_SORTABLE" => constant("COLUMN_SORTABLE"),
			"COLUMN_SEARCHABLE" => constant("COLUMN_SEARCHABLE"),
			"COLUMN_BOOL" => constant("COLUMN_BOOL"),
			"COLUMN_INT" => constant("COLUMN_INT"),
			"COLUMN_STRING" => constant("COLUMN_STRING"),
			"COLUMN_FLOAT" => constant("COLUMN_FLOAT"),
			"COLUMN_PASSWORD" => constant("COLUMN_PASSWORD"),
			"COLUMN_ENCRYPT" => constant("COLUMN_ENCRYPT"),
			"COLUMN_IS_DATE" => constant("COLUMN_IS_DATE"),
			"COLUMN_IS_AMOUNT" => constant("COLUMN_IS_AMOUNT"),
			"COLUMN_KEY" => constant("COLUMN_KEY"),
			"COLUMN_PRIOR_KEY" => constant("COLUMN_PRIOR_KEY"),
			"COLUMN_NAME" => constant("COLUMN_NAME"),
			"COLUMN_CONSTANT" => constant("COLUMN_CONSTANT"),
			"COLUMN_IS_HISTORICAL" => constant("COLUMN_IS_HISTORICAL"),
			"COLUMN_IS_ACTIVE" => constant("COLUMN_IS_ACTIVE"),
			"COLUMN_IS_TYPE" => constant("COLUMN_IS_TYPE"),
			"COLUMN_IS_STATUS" => constant("COLUMN_IS_STATUS"),
			"COLUMN_IS_EDITABLE" => constant("COLUMN_IS_EDITABLE"),
			"COLUMN_IS_DISPLAYABLE" => constant("COLUMN_IS_DISPLAYABLE"),
			"COLUMN_IS_LISTABLE" => constant("COLUMN_IS_LISTABLE"),
			"COLUMN_HAS_FOREIGN_NAME" => constant("COLUMN_HAS_FOREIGN_NAME"),
			"COLUMN_IS_QUICK_EDITABLE" => constant("COLUMN_IS_QUICK_EDITABLE"),
			"COLUMN_IS_SERIALIZED_DATA" => constant("COLUMN_IS_SERIALIZED_DATA"),
			"COLUMN_RESTRICT_SHOW" => constant("COLUMN_RESTRICT_SHOW"),
			"COLUMN_RESTRICT_EDIT" => constant("COLUMN_RESTRICT_EDIT"),
			"COLUMN_RESTRICT_ADD" => constant("COLUMN_RESTRICT_ADD"),
			"COLUMN_RESTRICT_REMOVE" => constant("COLUMN_RESTRICT_REMOVE"),
			"COLUMN_RESTRICT_MODIFY" => constant("COLUMN_RESTRICT_MODIFY"),
			"COLUMN_RESTRICT_DETAILS" => constant("COLUMN_RESTRICT_DETAILS")
		);
		
		$startDir = mb_path("/lib-modernbill/include/config/internal/mbapimap/");
		$dh  = opendir($startDir);
		while (false !== ($filename = readdir($dh))) {
			if (is_file($startDir.$filename) && substr($filename, -4)==".php" && !eregi("\.#", $filename)) {
				if ($_REQUEST["dataSource"]){
					if ($_REQUEST["dataSource"].".php"==$filename){
						require_once $startDir.$filename;
					}
				} else {
					require_once $startDir.$filename;
				}
			}
		}
		
		if (!(int)$_REQUEST["rawColumns"]){
			foreach ($CONF["sources"] as $datasource=>$def){
				$this->correctColumnDefinitions($datasource);
			}
		}
		
		$this->addTemplate("", $output = array("MBAPIMap" => $CONF['sources']));

		return (!$_REQUEST["__JS"] && !$_REQUEST["__JSON"] && !$_REQUEST["__XML"])?$this->output($output):array();

	}
	
	function correctColumnDefinitions($dname){
		global $CONF;
		
		$replaceCols = array();
		
		foreach ($CONF["sources"][$dname]["columns"] as $col=>$type){
			$ar = array();
			foreach ($this->typeMap as $name=>$val){
				if ($type & constant($name)){
					$ar[] = $name;
				}
			}
			$replaceCols[$col] = $ar;
		}
		$CONF["sources"][$dname]["columns"] = $replaceCols;
		
	}

} // GetOrderForms
?>
