<?php
// $Id: GetReportDailyInvoices.php 12506 2008-01-16 23:21:11Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

//$_REQUEST["__JSON"] = 1;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class GetReportDailyInvoices extends MB_AdminAPIAction {
	/**
	 */
	function GetReportDailyInvoices() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "GetReportDailyInvoices";
		$this->params = array();
		
		list($m, $d, $y) = explode("/", $_REQUEST["dateRange"]);
		dbg("report day: $m $d $y");
		$this->startTime = mktime(0,0,0,$m,$d,$y);
		$this->endTime = $this->startTime + (24*60*60) - 1;
		unset($_REQUEST["dateRange"]);
	
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->addTemplate("", $output = array("reportData" => $this->getReportData()));

		return (!$_REQUEST["__JS"] && !$_REQUEST["__JSON"] && !$_REQUEST["__XML"])?$this->output($output):array();

	}
	
	function getReportData(){
		dbg("RUNNING IN API REPORT!!!");
		$ret = array();
		$ret["startDate"] = $this->startTime;

/*		$ret["invoices"] = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"mergeContactData" => 1, 
					"invoiceDateEnteredLeast" => $this->startTime,
					"invoiceDateEnteredGreatest" => $this->endTime,
					/*"recordOffset" => (int)$_REQUEST["recordOffset"],
					"numRecords" => 10,* /
					"sortDir" => "ASC",
					"sortColumn" => "invoiceID",
				),
			),
		)); */
		
		$ret["invoices"] = arrayFor(":invoices", array(
			"invoiceDateEnteredGreaterThan" => $this->startTime-1,
			"invoiceDateEnteredLessThan" => $this->endTime+1,
			"sortDir" => "ASC",
			"sortColumn" => "invoiceID",
		));
		$contactIDs = array();
		$clientIDs = array();
		foreach ($ret["invoices"] as $row){
			if ($row["clientContactID"]){
				$contactIDs[] = $row["clientContactID"];
			} else {
				$clientIDs[] = $row["clientID"];
			}
		}
		$contacts = arrayFor(":contacts", array(
			"clientContactID" => $contactIDs,
		)) + arrayFor(":contacts", array(
			"clientID" => $clientIDs,
			"contactPrimary" => 1,
		));
		$keyedContacts = array();
		foreach ($contacts as $x=>$c){
			$keyedContacts[$c["clientID"]] =& $contacts[$x];
		}
		
		
		$ret["numInvoices"] = count($ret["invoices"]);
		$ret["numClients"] = array();
		$clientIDs = array();
		foreach ((array)$ret["invoices"] as $x=>$inv){
			$inv = (array)$inv + (array)$keyedContacts[$inv["clientID"]];
			$ret["invoices"][$x] = (array)$ret["invoices"][$x] + (array)$keyedContacts[$inv["clientID"]];
			$ret["numClients"][$inv["clientID"]] = 1;
			$ret["currencies"][$inv["currencyID"]]["numInvoices"]++;
			$ret["currencies"][$inv["currencyID"]]["numClients"][$inv["clientID"]] = 1;
			$ret["currencies"][$inv["currencyID"]]["totalAmount"] += $inv["invoiceAmount"];
			$ret["currencies"][$inv["currencyID"]]["totalAmountPaid"] += $inv["invoiceAmountPaid"];
		}
		
		$ret["numClients"] = count($ret["numClients"]);
		foreach ((array)$ret["currencies"] as $currencyID=>$data){
			$ret["currencies"][$currencyID]["numClients"] = count($ret["currencies"][$currencyID]["numClients"]);
		}
		return $ret;
	}
	

} // GetReportDailyInvoices
?>
