<?php
// $Id: GetReportRevenuePerServer.php 12276 2007-11-26 19:54:27Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

//$_REQUEST["__JSON"] = 1;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class GetReportRevenuePerServer extends MB_AdminAPIAction {
	/**
	 */
	function GetReportRevenuePerServer() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "GetReportRevenuePerServer";
		$this->params = array();
		
		$this->beginMonth = ((int)$_REQUEST["signupSheetBeginMonth"])?(int)$_REQUEST["signupSheetBeginMonth"]:1;
		$this->beginDay = ((int)$_REQUEST["signupSheetBeginDay"])?(int)$_REQUEST["signupSheetBeginDay"]:1;
		$this->beginYear = ((int)$_REQUEST["signupSheetBeginYear"])?(int)$_REQUEST["signupSheetBeginYear"]:date("Y");

		$this->endMonth = ((int)$_REQUEST["signupSheetEndMonth"])?(int)$_REQUEST["signupSheetEndMonth"]:1;
		$this->endDay = ((int)$_REQUEST["signupSheetEndDay"])?(int)$_REQUEST["signupSheetEndDay"]:1;
		$this->endYear = ((int)$_REQUEST["signupSheetEndYear"])?(int)$_REQUEST["signupSheetEndYear"]:date("Y");

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;
	
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->addTemplate("", $output = array("reportData" => $this->getReportData()));

		return (!$_REQUEST["__JS"] && !$_REQUEST["__JSON"] && !$_REQUEST["__XML"])?$this->output($output):array();

	}
	
	function getReportData(){
		dbg("RUNNING IN API REPORT!!!");
		$ret = array();
		$ret["startDate"] = $this->startTime;
		$ret["endDate"] = $this->endTime;

		$invoices = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"mergeContactData" => 1,
					"clientDateCreatedLeast" => $this->startTime,
					"clientDataCreatedGreatest" => $this->endTime,
					"getInvoiceLineItemsData" => 1,
				),
			),
		)));
		
		dbg($invoices);
		
		$packageIDs = array();
		$packageAddonIDs = array();
		foreach ((array)$invoices as $x=>$invoice){
			foreach ((array)$invoice["lineItems"] as $li){
				if ($li["packageAddonID"]){
					$packageAddonIDs[$li["packageAddonID"]] = 1;
				} else {
					$packageIDs[$li["packageID"]] = 1;
				}
			}
		}
		$packageAddonIDs = array_keys($packageAddonIDs);
		$packageIDs = array_keys($packageIDs);
		
		$packagesInfo = arrayFor("packages", array("packageID" => $packageIDs));
		if ($packageAddonIDs){
			$packageAddonsInfo = arrayFor("packageAddons", array("packageAddonID" => $packageAddonIDs));
		} else {
			$packageAddonsInfo = array();
		}
		
		$addonsToProducts = array();
		$packagesToProducts = array();
		
		$productIDs = array();
		foreach ((array)$packagesInfo as $pkg){
			$packagesToProducts[$pkg["packageID"]] = $pkg["productID"];
			$productIDs[$pkg["productID"]] = 1;
		}
		foreach ((array)$packageAddonsInfo as $pkg){
			$addonsToProducts[$pkg["packageAddonID"]] = $pkg["packageAddonProductID"];
			$productIDs[$pkg["packageAddonProductID"]] = 1;
		}
		$productIDs = array_keys($productIDs);
		
		if (count($productIDs)){
			$ret["productNames"] = grabHTMLOpsFromArray($products = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productID" => $productIDs,
					),
				),
			))), "productID", array($this, "constructProductName"));
		}
		
		$invoicedClients = array();
		
		$ret["datedProductTotals"] = array();
		$ret["productTotals"] = array();
		$ret["datedClients"] = array();
		$ret["datedClientTotals"] = array();
		$ret["totalClients"] = 0;
		$ret["totalProducts"] = array();
		$ret["currencyTotals"] = array();
		
		
		foreach ((array)$invoices as $x=>$invoice){
			if (!$invoicedClients[$invoice["clientID"]]){
				foreach ((array)$invoice["lineItems"] as $xx=>$lineItem){
					if ((int)$lineItem["packageAddonID"]){
						$tpid = $addonsToProducts[$lineItem["packageAddonID"]];
					} else {
						$tpid = $packagesToProducts[$lineItem["packageID"]];
					}
					$ret["totalProducts"][$tpid] = 1;
					$ret["productTotals"][$tpid]["num"]++;
					$ret["productTotals"][$tpid]["rev"][$invoice["currencyID"]] += $lineItem["lineItemTotalAmount"];
					$ret["datedTotalProducts"][date("m-d-Y", $invoice["clientDateCreated"])]++;
					$ret["datedProductTotals"][date("m-d-Y", $invoice["clientDateCreated"])][$tpid]["num"]++;
					$ret["datedProductTotals"][date("m-d-Y", $invoice["clientDateCreated"])][$tpid]["rev"][$invoice["currencyID"]] += $lineItem["lineItemTotalAmount"];
				
				}
				$ret["currencyTotals"][$invoice["currencyID"]] += $invoice["invoiceAmount"];
				unset($invoices[$x]["lineItems"]);
				$invoicedClients[$invoice["clientID"]] = 1;
				$ret["totalClients"]++;
				$ret["datedClientTotals"][date("m-d-Y", $invoice["clientDateCreated"])]++;
				$ret["datedClients"][date("m-d-Y", $invoice["clientDateCreated"])][] =& $invoices[$x];
			} // else its not their first invoice so we don't need it
		}
		
		$ret["totalProducts"] = count($ret["totalProducts"]);
		
		return $ret;
	}
	
	function constructProductName($row){
		if ((int)$row["productAddonGroupID"]){
			return "&nbsp;&nbsp;".TRANS_ADDON.": ".$row["productName"];
		} else {
			return $row["productName"];
		}
	}

	

} // GetReportRevenuePerServer
?>