<?php
// $Id: ManageSellerProduct.php 11779 2007-08-10 21:35:57Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

//$_REQUEST["__JSON"] = 1;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 */
class ManageSellerProduct extends MB_AdminAPIAction {
	/**
	 */
	function ManageSellerProduct() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "ManageSellerProduct";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->getVendorInformation();

		// at this point you have to test for $this->vendorData["vendorID"] to make sure
		// they are a vendor, then you have access to:
		// $this->vendorData
		// $this->adminData

		// use this line for fatal errors...
		// Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Error receiving products.");

		if ((int)$this->vendorData["vendorID"]){
			if (is_array($_REQUEST["products"])){
				$foreignProductIDs = array();
				foreach ($_REQUEST["products"] as $x=>$productInfo){
					$foreignProductIDs[] = $productInfo["productID"];
				}
				$this->cacheCommonInformation($foreignProductIDs);
				$markup = $this->vendorData["vendorMarkupPercentage"]/100;
				$this->markup = 1+$markup;
				foreach ($_REQUEST["products"] as $x=>$productInfo){
					if (($err = $this->handleProductInformation($productInfo))!==1){
						Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Error while processing product $x. ERROR: ".$err);
					}
				}
				return $this->output(array(
					"numProducts" => count($_REQUEST["products"]),
				));
			} else {
				Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Invalid API Call, please provide a \"products\" array.");
			}
		} else {
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Invalid Vendor Record.");
		}
	}

	function handleProductInformation($productInfo){
		global $CONF;
			
		$activeFlag = (isset($productInfo["productActive"]) && $productInfo["productActive"]=="0") ? 0 : (getAPITypeID("vendorActivationRule", "active")==$this->vendorData["vendorActivationRule"])? 1 : 0;
	
		$createCMDBase = array(
			"mbapi" => array(
				"command" => "SetProducts",
				"subCommand" => "insert",
				"params" => array(
					"productName" => $productInfo["productName"],
					"productType" => $productInfo["productType"],
					"productComments" => $productInfo["productComments"],
					"productActive" => $activeFlag,
					"productProratable" => $productInfo["productProratable"],
					"productStopNumCycles" => $productInfo["productStopNumCycles"],
					"productDateCreated" => time(),
					"productDomainRequired" => $productInfo["productDomainRequired"],
					"productAddonRequired" => $productInfo["productAddonRequired"],
					"productCancellationType" => $productInfo["productCancellationType"],
				),
			),
		);
		
		$updateCMDBase = array(
			"mbapi" => array(
				"command" => "SetProducts",
				"subCommand" => "update",
				"params" => array(
					"productID" => 0,
					"productName" => $productInfo["productName"],
					"productType" => $productInfo["productType"],
					"productComments" => $productInfo["productComments"],
					"productProratable" => $productInfo["productProratable"],
					"productStopNumCycles" => $productInfo["productStopNumCycles"],
					"productDateCreated" => time(),
					"productDomainRequired" => $productInfo["productDomainRequired"],
					"productAddonRequired" => $productInfo["productAddonRequired"],
					"productCancellationType" => $productInfo["productCancellationType"],
				),
			),
		);
		
		if (isset($productInfo["productActive"]) && $productInfo["productActive"]=="0"){
			$updateCMDBase["mbapi"]["params"]["productActive"] = 0;
			dbg("setting to inactive");
		}

		$currentCycles = array();
		$cycleMap = array();
		if (is_array($productInfo["cycles"])){
			dbg("processing cycles");
			foreach ($productInfo["cycles"] as $c){
				$Vcid = $c["cycleID"];
				if ($cid = $this->cycleInfo[$c["cycleNumYears"]][$c["cycleNumMonths"]][$c["cycleNumDays"]][$c["cycleNumHours"]][$c["cycleNumMinutes"]][$c["cycleNumSeconds"]]){
					$currentCycles[] = $cid;
					dbg("found cycle");
				} else {
					dbg("creating cycle");
					unset($c["cycleID"]);
					$cid = $this->cycleInfo[$c["cycleNumYears"]][$c["cycleNumMonths"]][$c["cycleNumDays"]][$c["cycleNumHours"]][$c["cycleNumMinutes"]][$c["cycleNumSeconds"]] = insertFor("cycles", $c);
					$currentCycles[] = $cid;
				}
				$cycleMap[$Vcid] = $cid;
			}
		}
		dbg("the cycle map");
		dbg($cycleMap);

		if (is_array($productInfo["variants"])){
			dbg("found some variants");
			$VproductID = $productInfo["productID"];
			foreach ($productInfo["variants"] as $x=>$variant){
				$VvariantID = $variant["productVariantID"];
				if (is_array($variant["orderForms"])){
					dbg("found an order form");
					foreach ($variant["orderForms"] as $orderForm){
						dbg("running for an order form:");
						dbg($orderForm);
						$VorderFormID = $orderForm["orderFormID"];
						$VorderFormCurrency = $orderForm["currencyID"];
						$SorderFormID = $this->orderFormsByCurrency[$VorderFormCurrency]["orderFormID"];
						if ($SorderFormID){
							dbg("found a local order form of the same currency: ".$SorderFormID);
							$existingProductID = $this->productVendorRels[$VproductID][$VorderFormID][$VvariantID];
							if ((int)$existingProductID){
								// update it
								$existingProductInfo = getMBAPIRow("GetProducts", array(
									"productID" => $existingProductID,
									"getProductVariantData" => 1,
									"getProductVariantPriceData" => 1,
									"getCycleGhostIDs" => 1,
								));
								$existingVariantIDs = array();
								$removeVariantPriceIDs = array();
								$removeCycleIDs = array();
								if (is_array($existingProductInfo["ghostCycles"])){
									foreach ($existingProductInfo["ghostCycles"] as $cycle){
										$removeCycleIDs[] = $cycle["cycleID"];
									}
								}
								if (is_array($existingProductInfo["productVariants"])){
									foreach ($existingProductInfo["productVariants"] as $vv){
										$existingVariantIDs[] = $vv["productVariantID"];
									}
								}
								if (is_array($existingProductInfo["productVariantPrices"])){
									foreach ($existingProductInfo["productVariantPrices"] as $vv){
										$removeVariantPriceIDs[] = $vv["productVariantPriceID"];
									}
								}
								deleteFor("variantPrices", array(
									"productVariantPriceID" => $removeVariantPriceIDs,
								));
								
								// insert it
								$thisCMD = $updateCMDBase;
								$thisCMD["mbapi"]["params"]["productID"] = $existingProductID;
								$thisCMD["mbapi"]["params"]["removeCycleIDs"]["cycleID"] = $removeCycleIDs;
								$thisCMD["mbapi"]["params"]["cycleIDs"]["cycleID"] = $currentCycles;
								$thisCMD["mbapi"]["params"]["orderFormIDs"]["orderFormID"] = $SorderFormID;
							
								$prices = array();
								if (is_array($orderForm["prices"])){
									foreach ($orderForm["prices"] as $p){
										$prices[] = array(
											"productVariantPriceType" => getAPITypeID("price", "general"),
											"currencyID" => $VorderFormCurrency,
											"cycleID" => $cycleMap[$p["cycleID"]],
											"productVariantPriceAmount" => $p["price"]*$this->markup,
											"costCurrenyID" => $VorderFormCurrency,
											"costAmount" => $p["price"],
										);
										$prices[] = array(
											"productVariantPriceType" => getAPITypeID("price", "setup"),
											"currencyID" => $VorderFormCurrency,
											"cycleID" => $cycleMap[$p["cycleID"]],
											"productVariantPriceAmount" => $p["setup"]*$this->markup,
											"costCurrenyID" => $VorderFormCurrency,
											"costAmount" => $p["setup"],
										);
									}
								}
								
								$thisCMD["mbapi"]["params"]["productVariants"]["productVariant"] = array(
									"productVariantID" => $existingVariantIDs[0],
									"productVariantPrices" => array(
										"productVariantPrice" => $prices,
									),
								);
							
								$thisCMD["mbapi"]["params"]["serverGroupIDs"]["serverGroupID"] = $this->serverGroupID;
							
								// run the command
								dbg("about to run final command:");
								dbg($thisCMD);
								$results = dispatchMBAPI(toXML($thisCMD), 1);
								dbg($results);
							
							} else {
								// insert it
								$thisCMD = $createCMDBase;
								$thisCMD["mbapi"]["params"]["cycleIDs"]["cycleID"] = $currentCycles;
								$thisCMD["mbapi"]["params"]["orderFormIDs"]["orderFormID"] = $SorderFormID;
								
								$prices = array();
								if (is_array($orderForm["prices"])){
									foreach ($orderForm["prices"] as $p){
										$prices[] = array(
											"productVariantPriceType" => getAPITypeID("price", "general"),
											"currencyID" => $VorderFormCurrency,
											"cycleID" => $cycleMap[$p["cycleID"]],
											"productVariantPriceAmount" => $p["price"]*$this->markup,
											"costCurrenyID" => $VorderFormCurrency,
											"costAmount" => $p["price"],
										);
										$prices[] = array(
											"productVariantPriceType" => getAPITypeID("price", "setup"),
											"currencyID" => $VorderFormCurrency,
											"cycleID" => $cycleMap[$p["cycleID"]],
											"productVariantPriceAmount" => $p["setup"]*$this->markup,
											"costCurrenyID" => $VorderFormCurrency,
											"costAmount" => $p["setup"],
										);
									}
								}
								
								$thisCMD["mbapi"]["params"]["productVariants"]["productVariant"] = array(
									"productVariantActive" => 1,
									"productVariantDisplayName" => "TRANS_VARIANT_TEMPLATE",
								);
								
								$thisCMD["mbapi"]["params"]["productVariants"]["productVariant"]["productVariantPrices"]["productVariantPrice"] = $prices;
							
								$thisCMD["mbapi"]["params"]["serverGroupIDs"]["serverGroupID"] = $this->serverGroupID;
							
								// run the command
								dbg("about to run final command:");
								dbg($thisCMD);
								$results = dispatchMBAPI(toXML($thisCMD), 1);
								dbg($results);
								$newProductID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
								if ((int)$newProductID){
									insertFor("productVendorRels",  array(
										"productID" => $newProductID,
										"vendorID" => $this->vendorData["vendorID"],
										"vendorOrderFormID" => $VorderFormID,
										"vendorProductID" => $VproductID,
										"vendorProductVariantID" => $VvariantID,
									));
									insertFor(":productAttributes", array(
										"productID" => $newProductID,
										"serverGroupID" => $this->serverGroupID,
										"productAttributeName" => "autoProvision",
										"productAttributeValue" => 1,
										"productAttributeDateCreated" => time(),
									));
								}
							}
						}
					}
				} else {
					return "'orderForms' key for variant '$x' did not contain a usable array of data.";
				}
			}
		} else {
			return "'variants' key for product was not a usable array of data.";
		}
		return 1;
	}


	function cacheCommonInformation($productIDs){
		global $CONF;
		$fpr = arrayFor("productVendorRels", array(
			"vendorID" => $this->vendorData["vendorID"],
			"vendorProductID" => $productIDs,
		));
		$this->productVendorRels = array();
		foreach ($fpr as $f){
			$this->productVendorRels[$f["vendorProductID"]][$f["vendorOrderFormID"]][$f["vendorProductVariantID"]] = $f["productID"];
		}
		
		$cys = arrayFor("cycles");
		$this->cycleInfo = array();
		$this->cycles = array();
		foreach ($cys as $c){
			$this->cycles[$c["cycleID"]] = $c;
			$this->cycleInfo[$c["cycleNumYears"]][$c["cycleNumMonths"]][$c["cycleNumDays"]][$c["cycleNumHours"]][$c["cycleNumMinutes"]][$c["cycleNumSeconds"]] = $c["cycleID"];
		}
		
		$pgs = arrayFor("paymentGroups");
		$this->paymentGroups = array();
		foreach ($pgs as $p){
			$this->paymentGroups[$p["paymentGroupID"]] = $p;
		}
		$odf = arrayFor("orderForms");
		$this->orderForms = array();
		$this->orderFormsByCurrency = array();
		foreach ($odf as $o){
			$this->orderFormsByCurrency[$this->paymentGroups[$o["paymentGroupID"]]["paymentGroupCurrencyID"]] = (array)$o + (array)$this->paymentGroups[$o["paymentGroupID"]];
			$this->orderForms[$o["orderFormID"]] = (array)$o + (array)$this->paymentGroups[$o["paymentGroupID"]];
		}
		
		loadConfigs("server", "serverGroups", "panel", "marketplacevendor");
		
		if ($CONF["server"]["serverGroups"]["panel"]["marketplacevendor"]){
			if ($CONF["server"]["serverGroups"]["panel"]["marketplacevendor"]["configGroupID"]){
				$serverID = $CONF["server"]["serverGroups"]["panel"]["marketplacevendor"]["configGroupID"];
			} else {
				if ($CONF["server"]["serverGroups"]["panel"]["marketplacevendor"][0]["configGroupID"]){
					$serverID = $CONF["server"]["serverGroups"]["panel"]["marketplacevendor"][0]["configGroupID"];
				}
			}
		}
		
		if ($serverID){
			$serverGroup = getMBAPIRow("GetServerGroups", array(
				"configGroupID" => $serverID,
			));
			if (!$this->serverGroupID = $serverGroup["serverGroupID"]){
				// need to make a server group with a server in it
				$this->serverGroupID = $this->createServerGroup();
			}
		} else {
			// need to make a server group with a server in it
			$this->serverGroupID = $this->createServerGroup();
		}
		
	}

	function createServerGroup(){
		$serverGroupID = insertFor("serverGroups", array(
			"serverGroupName" => TRANS_MARKETPLACE_VENDOR_PRODUCTS,
		));
		
		$configGroup = oneOf("configGroups", array(
			"configGroupName" => "marketplacevendor",
		));

		$panelInsert = array(
			"mbapi" => array(
				"command" => "SetPanels",
				"subCommand" => "insert",
				"params" => array(
					"serverGroupID" => $serverGroupID,
					"parentConfigGroupName" => "marketplacevendor",
					"parentConfigGroupID" => $configGroup["configGroupID"],
				),
			),
		);
		dbg(dispatchMBAPI(toXML($panelInsert)));
		return $serverGroupID;
	}


} // ManageSellerProduct
