<?php
// $Id: UpdatePackage.php 11737 2007-08-03 21:33:01Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

/**
 * this is an admin based api action so extent the MB_AdminAPIAction class to handle auth
 */
class UpdatePackage extends MB_AdminAPIAction {
	/**
	 */
	function UpdatePackage() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "UpdatePackage";
		$this->params = array(
			"taxZoneGroupID", 
			"packageName", 
			"packageQuantity", 
			"packageProratable",
			"packageDateNextRenewal",
			"packageDateStopRenewal",
			"packageActive",
			"packageStatus",
			"packageComments",
			"packageType",
			"packagePrice",
			"packageSetup",
			"packagePriceLock",
			"packageCancellationType",
			"cycleID",
			"usageDateNextRenewal",
			"usageCycleID",
			"usageCalculateOnly",
			"couponNumCycles",
			"packageClientPermissions",
			"couponPrice",
			"packagePendingCancellation",
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));

		if (!(int)$packageInfo["packageID"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid package ID.");
		}
		
		if ((int)$_REQUEST["terminate"]){
			$_REQUEST["packagePendingCancellation"] = getAPITypeID("pendingcancellation", "admin");
		}
		if ((int)$_REQUEST["unterminate"]){
			$_REQUEST["packagePendingCancellation"] = getAPITypeID("pendingcancellation", "none");
		}
		if ((int)$_REQUEST["enable"]){
			$_REQUEST["packageStatus"] = getAPIStatusID("package", "none");
		}

		$params = array();
		foreach ($this->params as $field){
			if (isset($_REQUEST[$field])){
				$params[$field] = $_REQUEST[$field];
			}
		}		

		$results = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetPackages",
				"subCommand" => "update",
				"params" => array(
					"packageID" => $packageInfo["packageID"],
				) + $params,
			),
		)), 1);

		if (!(int)$results["mbapi"][0]["header"][0]["success"][0]){
			Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to update package.");
		}

		$retArray = array(
			"api" => array(
				"header" => array(
					"app" => "app-modernbill-api",
					"action" => "updatePackage",
					"success" => 1,
					"timestamp" => mktime(),
				),
				"results" => array(),
			)
		);

   		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n\n";
		echo toXML($retArray);

		return true;
	}
} // UpdatePackage
?>
