<?php
// $Id: apiaction.php 11737 2007-08-03 21:33:01Z kbailey $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",3)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");


/**
 * This action class handles authenticating an admin for an api action
 */
class MB_APIAction extends MB_Action {
	/**
	 */
	function MB_APIAction() {
		parent::MB_Action();
		$this->stringRep = "MB_APIAction";
		$this->retArray = array(
			"api" => array(
				"header" => array(
					"app" => "app-modernbill-api",
					"success" => 1,
					"timestamp" => mktime(),
				),
				"results" => array(),
			)
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// this is just a placeholder class so that we can make api action methods that propagate to all 
		// api based actions.

		return true;
	}
	
	function output($data){
		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n\n";
		$this->retArray["api"]["results"] = $data;
		echo toXML($this->retArray);
		return true;
	}

	function filterFields($data, $filterType=null, $filterFields=null){
		if ($filterType==null) $filterType = (int)$_REQUEST["filterType"];
		if ($filterFields==null) $filterFields = (array)$_REQUEST["filterFields"];

		if ($filterType===0){
			return $data;
		}

		foreach ((array)$data as $k=>$row){
			if (is_array($data[$k])){
				foreach ($data[$k] as $fieldName=>$value){
					switch ($filterType){
						case 0: // return all fields
						break;
						case 1: // filter out fields NOT in list
							if (!in_array($fieldName, $filterFields)){
								unset($data[$k][$fieldName]);
}
						break;
						case 2: // filter out fields IN list
							if (in_array($fieldName, $filterFields)){
								unset($data[$k][$fieldName]);
							}
						break;
					}
				}
			}
		}
		return $data;
	}
} // MB_APIAction


/**
 * This action class handles authenticating an admin for an api action
 */
class MB_AdminAPIAction extends MB_APIAction {
	/**
	 */
	function MB_AdminAPIAction() {
		parent::MB_APIAction();
		$this->stringRep = "MB_AdminAPIAction";
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->authenticated = false;

		$authenticationResults = correctArray(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "ProcessAdminLogin",
				"params" => array(
					"adminUsername" => $_REQUEST["adminUsername"],
					"adminPassword" => $_REQUEST["adminPassword"],
					"adminIP" => $_SERVER["REMOTE_ADDR"],
					"adminRemoteAccessHash" => $_REQUEST["adminRemoteAccessHash"],
				),
			),
		)), 1));
		
		dbg($authenticationResults);
		
		if (!($authenticationResults["mbapi"][0]["results"] && $authenticationResults["mbapi"][0]["results"][0]["adminID"])){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to authenticate admin.");
		}
		$this->adminID = (int)$authenticationResults["mbapi"][0]["results"][0]["adminID"][0];

		return true;
	}
	
	function getVendorInformation(){
		$this->adminData = oneOf("admins", array("adminID" => $this->adminID));
		$this->vendorData = oneOf("vendors", array("adminID" => $this->adminID));
	}
	
} // MB_AdminAPIAction



/**
 * This action class handles authenticating a client for an api action
 */
class MB_ClientAPIAction extends MB_APIAction {
	/**
	 */
	function MB_ClientAPIAction() {
		parent::MB_APIAction();
		$this->stringRep = "MB_ClientAPIAction";
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->authenticated = false;

		$authenticationResults = correctArray(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "ProcessClientLogin",
				"params" => array(
					"contactUsername" => $_REQUEST["contactUsername"],
					"contactPassword" => $_REQUEST["contactPassword"],
					"clientIP" => $_SERVER["REMOTE_ADDR"],
					"suppressSetConf" => 1,
				),
			),
		)), 1));
		
		dbg($authenticationResults);
		
		if (!($authenticationResults["mbapi"][0]["results"] && $authenticationResults["mbapi"][0]["results"][0]["clientID"])){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to authenticate client.");
		}

		return true;
	}
} // MB_ClientAPIAction
?>
