<?php
// $Id: APILoginResponse.php 12048 2007-10-08 19:59:44Z bwoolley $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This version of APILoginResponse executes an ADMIN login.
 *
 * @author  Michael Fountain
 */
class APILoginResponse extends MB_Action {
	/**
	 * The constructor for a APILoginResponse action object. This calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function APILoginResponse() {
		parent::MB_Action();
		$this->stringRep = "APILoginResponse";
	}

	/**
	 * The main method of this class that executes the APILoginResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminRemoteAccessHash = secureInput($CONF["user"]["remoteAccessHash"]);
		$internalAdmin = secureInput($CONF["user"]["internalAdmin"]);

		$query = $this->getMBAPIQuery("ProcessAdminLogin", "", array("adminIP" => $CONF["user"]["ip"], "adminRemoteAccessHash" => $adminRemoteAccessHash, "internalAdmin" => $internalAdmin));
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

			if(is_array($data["mbapi"][0]["results"][0]["adminID"])) {
			 	dbg("inside");
				$_REQUEST["sid"] = $data["mbapi"][0]["results"][0]["sessionID"][0];

				//If it's a remote API call, let it bubble back instead of redirect
				$_REQUEST["adminID"] = $data["mbapi"][0]["results"][0]["adminID"][0];
				$CONF["user"]["type"] = 2;
				$CONF["user"]["sessionID"] = $_REQUEST["sid"];
				$this->hasExecutedSuccessfully = 1;
				return $this->hasExecutedSuccessfully();

			}
		} else {
			Error::fatal(TRANS_LOGINFAILURE, "Failed to authenticate.");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // APILoginResponse
?>
