#!/usr/bin/env php
<?php

/**
 * Setup the path for this API_APP
 */

//define("APP_IP_CHECK", 1);
define("COMMAND_DELIM", "<?mb end ?>");

define("HAS_SYSVSHM", extension_loaded("sysvshm"));
define("HAS_SYSVSEM", extension_loaded("sysvsem"));

chdir(dirname(__FILE__));
require_once(dirname(__FILE__)."/path.php");

// inetd apps have no way of obtaining IP address information
$_SERVER["REMOTE_ADDR"] = "127.0.0.2";

/**
 * Setup the config for this API_APP
 * ** IMPORTANT ** The variable $adminRemoteAccessHash MUST BE SET for the API calls to work!
 */
require_once mb_path("/app-modernbill-api/config.php");
$adminRemoteAccessHash = $CONF["remoteAccessHash"];

/**
 * Setup common for this API_APP
 */

require_once mb_path("/lib-tk/include/common.php");
require_once mb_path("/lib-tk/include/io/ipc.php");
require_once mb_path("/lib-tk/include/io/fifo.php");

/**
 * Begin processing
 */

set_time_limit(0);
error_reporting(0);

/**
 * parse auth line
 */
$args = array();
parse_str(fgets(STDIN), $args);

if(HAS_SYSVSHM) {	
	if(HAS_SYSVSEM)	$m =& new ProtectedSharedMemory(ftok(__FILE__, chr(2)), 65536);
	else			$m =& new SharedMemory(ftok(__FILE__, chr(2)), 65536);

	$hashCache = $m->get();
	if(!is_array($hashCache))
		$hashCache = array();
		
} else $hashCache = array();

$auth = isset($args["auth"]) ? trim($args["auth"]) : false;
if($auth) {
	if(!in_array($auth, $hashCache)) {
		if(!$admin = queryFor(":admins", array(
			"adminRemoteAccessHash" => $auth,
			"comparisonOperator" => "=",
		))) {
			fwrite(STDERR, "Invalid credentials.");
			exit(1);
		}
		if(HAS_SYSVSHM) {
			$hashCache[] = $auth;
			$m->set($hashCache);
		}
	} else {
		dbg("Validated from cache!");
	}
} else {
	fwrite(STDERR, "Could not find credentials.");
	exit(1);
}

if(HAS_SYSVSHM) $m->detach();


function detect_delim($command) {
	return contains($command, COMMAND_DELIM) && substr($command, -1) == "\n";
}

$command = "";
$stdin =& new NamedPipe(STDIN);
$stdout =& new NamedPipe(STDOUT);
while(true) {
	if($stdin->isError($command = $stdin->readUntil("detect_delim"))) break;
	
	$response = dispatchMBAPI($command) . "\r\n" . COMMAND_DELIM . "\r\n";
	
	if(!$stdout->writeAll($response)) break;
}

$inErr = $stdin->getError();
$outErr = $stdout->getError();
if($inErr || $outErr) {
	fwrite(STDERR, $inErr . $outErr);
	fflush(STDERR);
	exit(1);
}

exit(0);

?>
