#!/usr/bin/env php
<?php

if (isset($_SERVER["GATEWAY_INTERFACE"])) {
	echo "This is not for HTTP.\n";
	exit;
}

/**
 * Setup the path for this API_APP
 */

define("COMMAND_DELIM", "<?mb end ?>");

chdir(dirname(__FILE__));
require_once(dirname(__FILE__)."/path.php");

// we have no way of obtaining IP address information
$_SERVER["REMOTE_ADDR"] = "127.0.0.2";

/**
 * The API_APP is ALWAYS local
 */
$CONF["installType"] = "local";

/**
 * Define that this is an API based APP
 */
define("ACCESS_TYPE", API_APP);
define("DEBUG", 0);

/**
 * Setup common for this API_APP
 */

require_once mb_path("/lib-tk/include/common.php");
require_once mb_path("/lib-tk/include/io/fifo.php");

/**
 * Begin processing
 */

set_time_limit(0);
error_reporting(0);

function detect_delim($command) {
	return contains($command, COMMAND_DELIM) && substr($command, -1) == "\n";
}

$command = "";
$stdin =& new NamedPipe(STDIN);
$stdout =& new NamedPipe(STDOUT);
while(true) {
	if($stdin->isError($command = $stdin->readUntil("detect_delim"))) break;
	
	$response = dispatchMBAPI($command) . "\r\n" . COMMAND_DELIM . "\r\n";
	
	if(!$stdout->writeAll($response)) break;
}

$inErr = $stdin->getError();
$outErr = $stdout->getError();
if($inErr || $outErr) {
	fwrite(STDERR, $inErr . $outErr);
	fflush(STDERR);
	exit(1);
}

exit(0);

?>
