mbapi_server="$(dirname "${0}")/mbapi.php"
mbapi_call="$(dirname "${0}")/mbapi_call"

mbapi_open () {
	fifo="${1}"
	
	mkfifo -m 600 "${fifo}_in"
	mkfifo -m 600 "${fifo}_out"
	$mbapi_server < "${fifo}_in" > "${fifo}_out" &
	
	pid="${!}"
	
	echo "${pid}" > "${fifo}.pid"
	
	echo "mbapi_open: connection ${fifo} open to pid ${pid}."
}

mbapi_call () {
	. "${mbapi_call}"
}

mbapi_close () {
	fifo="${1}"
	
	if [ -f "${fifo}.pid" ]
	then
		pid=$(cat "${fifo}.pid")
		
		unlink "${fifo}_in"
		unlink "${fifo}_out"
		unlink "${fifo}.pid"
		echo "mbapi_close: connection ${fifo} closed."

		kill "${pid}"
		echo "mbapi_close: pid ${pid} signalled to terminate."
	else
		echo "mbapi_close: connection ${fifo} does not exist."
	fi
}
