#!/usr/bin/env python

"""
$Id: popper.py 10450 2007-01-09 00:44:47Z bwoolley $
+----------------------------------------------------------------------+
| ModernBill [TM] .:. Client Billing System                            |
+----------------------------------------------------------------------+
| Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
+----------------------------------------------------------------------+
| This source file is subject to the ModernBill End User License       |
| Agreement (EULA), that is bundled with this package in the file      |
| LICENSE, and is available at through the world-wide-web at           |
| http://www.modernbill.com/extranet/LICENSE.txt                       |
| If you did not receive a copy of the ModernBill license and are      |
| unable to obtain it through the world-wide-web, please send a note   |
| to license@modernbill.com so we can email you a copy immediately.    |
+----------------------------------------------------------------------+
| Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
| Support: http://www.modernsupport.com/modernbill/                    |
+----------------------------------------------------------------------+
| ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
+----------------------------------------------------------------------+

Populates a database with fake clients and packages using the MBAPI
"""

from sys import argv
proc, auth = argv[1], argv[2]

from mbapilib import MBAPIPipe
m = MBAPIPipe(auth, proc)
m.open()

remote_hash = ""

def mbapi(command):
	global m
	
	result = m.call(command)
	id = result.getLastInsertID()
	
	print "===COMMAND XML==="
	print command
	print "===RESULT XML==="
	print result.xml
	print "===LAST INSERT ID==="
	print id
	
	return id

from random import choice, uniform
import time

SetClients_template = """
<mbapi>
	<command>SetClients</command>
	<subCommand>insert</subCommand>
	<remoteAccessHash>%(hash)s</remoteAccessHash>
	<params>
		<clientCompany>Some Company %(i)i</clientCompany>
		<companyID>1</companyID>
		<clientStatus>%(clientStatus)i</clientStatus>
		<themeID>1</themeID>
		<countriesID>US</countriesID>
		<clientActive>1</clientActive>
		<clientContacts>
			<clientContact>
				<contactPrimary>1</contactPrimary>
				<contactUsername>alice%(i)i</contactUsername>
				<contactPassword></contactPassword>
				<contactFirstName>Alice%(i)i</contactFirstName>
				<contactLastName>Wonderland</contactLastName>
				<contactEmail>alice%(i)i@example.com</contactEmail>
				<contactEmailFormat>1</contactEmailFormat>
				<contactCompany>Some Company %(i)i</contactCompany>
				<contactAddress1>%(i)i Wonderland Lane</contactAddress1>
				<contactCity>Wonder</contactCity>
				<contactState>WO</contactState>
				<contactZip>%(i)i</contactZip>
				<languageID>21</languageID>
				<countriesID>US</countriesID>
				<contactPhone1>%(i)i</contactPhone1>
				<contactActive>1</contactActive>
				<clientBillingAccounts>
					<clientBillingAccount>
						<billingCardNameOnCard>Alice Wonderland</billingCardNameOnCard>
						<billingCardType>1</billingCardType>
						<billingCardNum>4200000000000000</billingCardNum>
						<billingCardExpYear>2007</billingCardExpYear>
						<billingCardExpMonth>4</billingCardExpMonth>
						<billingAccountNumLastFour>0000</billingAccountNumLastFour>
						<billingAccountType>0</billingAccountType>
					</clientBillingAccount>
				</clientBillingAccounts>
			</clientContact>
		</clientContacts>
	</params>
</mbapi>
"""

SetPackages_template = """
<mbapi>
	<command>SetPackages</command>
	<subCommand>insert</subCommand>
	<remoteAccessHash>%(hash)s</remoteAccessHash>
	<params>
		<clientID>%(clientID)s</clientID>
		<productID>%(productID)s</productID>
		<packageName>Gold Hosting</packageName>
		<packageQuantity>1</packageQuantity>
		<packageProratable>0</packageProratable>
		<packageDateCreated>%(packageDateCreated)i</packageDateCreated>
		<packageDateBeginRenewal>%(packageDateBeginRenewal)i</packageDateBeginRenewal>
		<packageDateLastRenewal>%(packageDateLastRenewal)i</packageDateLastRenewal>
		<packageDateNextRenewal>%(packageDateNextRenewal)i</packageDateNextRenewal>
		<packageActive>1</packageActive>
		<packageStatus>%(packageStatus)i</packageStatus>
		<packageType>1</packageType>
		<packageOriginalPrice>%(packageOriginalPrice)f</packageOriginalPrice>
		<packagePrice>%(packagePrice)f</packagePrice>
		<packageSetup>0</packageSetup>
		<packagePriceLock>0</packagePriceLock>
		<cycleID>%(cycleID)i</cycleID>
		<paymentGroupID>%(paymentGroupID)i</paymentGroupID>
		<packageCancellationType>0</packageCancellationType>
	</params>
</mbapi>
"""

SetPackageBillingShares_template = """
<mbapi>
	<command>SetBillingAccountShare</command>
	<subCommand>insert</subCommand>
	<remoteAccessHash>%(hash)s</remoteAccessHash>
	<params>
		<billingAccountID>%(clientID)i</billingAccountID>
		<packageID>%(packageID)i</packageID>
		<billingAccountFallbackGroup>1</billingAccountFallbackGroup>
		<billingAccountShareGroup>0</billingAccountShareGroup>
		<billingAccountShareValue>1</billingAccountShareValue>
	</params>
</mbapi>
"""

def pop(i):
	clientStatus = choice(xrange(0,4))
	if (i%2==0):
		clientStatus = 0

	clientID = mbapi(
		SetClients_template % {
			"i": i,
			"hash": remote_hash,
			"clientStatus": clientStatus,
		}
	)
	print "Added client ID %i" % (clientID)

	cycleID = 3
	cycleSeconds = 60 * 60 * 24 * 30

	paymentGroupID = 1

	price = uniform(10,20)
	
	now = time.time()
	packageDateCreated = int(uniform(now - (cycleSeconds*2), now + (cycleSeconds*2)))
	packageDateBeginRenewal =  packageDateNextRenewal = packageDateCreated + cycleSeconds
	packageDateLastRenewal = 0 
	
	packageID = mbapi(
		SetPackages_template % {
			"i": i,
			"clientID": clientID,
			"productID": 2,
			"cycleID": cycleID,
			"paymentGroupID": paymentGroupID,
			"hash": remote_hash,
			"packageStatus": choice(xrange(0,10)),
			"packageDateCreated": packageDateCreated,
			"packageDateBeginRenewal": packageDateBeginRenewal,
			"packageDateLastRenewal": packageDateLastRenewal,
			"packageDateNextRenewal": packageDateNextRenewal,
			"packagePrice": price,
			"packageOriginalPrice": price,
		}
	)
	print "Added package ID %i" % (packageID)
	shareID = mbapi(
		SetPackageBillingShares_template % {
			"i": i,
			"clientID": clientID,
			"packageID": packageID,
			"hash": remote_hash,
		}
	)
	print "Added billing share ID %i" % (shareID)


	if (packageID%3==0):
		packageID = mbapi(
			SetPackages_template % {
				"i": i,
				"clientID": clientID,
				"productID": 3,
				"cycleID": cycleID,
				"paymentGroupID": paymentGroupID,
				"hash": remote_hash,
				"packageStatus": choice(xrange(0,10)),
				"packageDateCreated": packageDateCreated,
				"packageDateBeginRenewal": packageDateBeginRenewal,
				"packageDateLastRenewal": packageDateLastRenewal,
				"packageDateNextRenewal": packageDateNextRenewal,
				"packagePrice": price,
				"packageOriginalPrice": price,
			}
		)
		print "Added package ID %i" % (packageID)
		shareID = mbapi(
			SetPackageBillingShares_template % {
				"i": i,
				"clientID": clientID,
				"packageID": packageID,
				"hash": remote_hash,
			}
		)
		print "Added billing share ID %i" % (shareID)

def main():
	for i in xrange(1,5000):
		pop(i)

main()
