<?php
// $Id: OrderCertCSRRequestResponse.php 7365 2006-06-08 21:32:52Z bsmith $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");
require_once mb_path("/lib-modernbill/include/config/internal/datasources.php");
require_once mb_path("/lib-tk/toolkit.php");


/**
 *
 */
class OrderCertCSRRequestResponse extends MB_Action {

	function OrderCertCSRRequestResponse() {
		parent::MB_Action();
		$this->stringRep = "OrderCertCSRRequestResponse";

		$this->params = array(
			"CSRCSR",
			"RIRenewalIndicator",
			"UPGCUIndicator",
			"certID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID( getActionID("OrderCertCSRRequest") );
		$this->setReferralActionFile( "certs.php" );

		$success = $this->validateMultiInputs(
				array(
					"CSRCSR" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"RIRenewalIndicator" => INPUT_RESTRICTION_STRING,
					"UPGCUIndicator" => INPUT_RESTRICTION_STRING
					), array(), array(), 0, array("emptyCSR" => 1, "certID" => (int)$_REQUEST["certID"]));
		
		if ($success) {
			$query = $this->getMBAPIQuery("GetCerts", "", array("certID" => (int)$_REQUEST["certID"],"clientID"=>$CONF["user"]["id"]));
			$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1) );
			$data = $data[0];

			$orderParams = array(
					"subCommand" => "ValidateOrderParameters",
					"ProductCode" => $data["ODProductCode"],
					"Method" => "RESELLER",
					"ValidityPeriod" => $data["ODValidityPeriod"],
					"ServerCount" => (notZero($data["ODServerCount"]) ? $data["ODServerCount"] : 1),
					"CSR" => $_REQUEST["CSRCSR"],
					"WebServerType" => "other",
					"WildCard" => 'false',
					"CUIndicator" => ($_REQUEST["UPGCUIndicator"] == "true") ? 'true' : 'false',
					"CUCertificate" => null,
					"RenewalIndicator" => ($_REQUEST["RIRenewalIndicator"] == "true") ? 'true' : 'false',
					"RenewalBehavior" => "GEOTRUST",
					"SpecialInstructions" => null
					);
			if (notNull( $data["orID"] )) {
				$orderParams["orID"] = $data["orID"];
			}

			dbg( "########## Package sent to SSLF ############" );
			dbg( $orderParams );
			
			$query = $this->getMBAPIQuery( "ProcessSSLfactory", "", $orderParams, 0, 0, 0, 0, 1, array_keys( $_REQUEST ) );
			$data = dispatchMBAPI( $query, 1 );
			
			dbg( "########## Returned Package from SSLF #############" );
			dbg($data);
			
			if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					$results = correctArray($data["mbapi"][0]["results"][0]);
					
					$params = array(
							"CSRDomainName" => $results["PARSEDCSR"][0]["DOMAINNAME"],
							"CSRCountry" => $results["PARSEDCSR"][0]["COUNTRY"],
							"CSREmail" => $results["PARSEDCSR"][0]["EMAIL"],
							"CSRLocality" => $results["PARSEDCSR"][0]["LOCALITY"],
							"CSROrganization" => $results["PARSEDCSR"][0]["ORGANIZATION"],
							"CSROrganizationUnit" => $results["PARSEDCSR"][0]["ORGANIZATIONUNIT"],
							"CSRState" => $results["PARSEDCSR"][0]["STATE"],
							"CSRIsValidDomainName" => $results["PARSEDCSR"][0]["ISVALIDTRUEDOMAINNAME"],
							"CSRHasBadExtensions" => $results["PARSEDCSR"][0]["HASBADEXTENSIONS"],
							"CSRStartDate" => mktime(),

							"ODPrice" => $results["PRICE"],
							"orSuccesscode" => $results["ORDERRESPONSEHEADER"][0]["SUCESSCODE"],
							"orID" => $results["or_id"]);

					$this->applyRequestTo( $params );
					
					
					if (notZero($data["ODServerCount"]) && notZero( $params["ODServerCount"]))
						// no server count made
						$params["ODServerCount"] = 1;

						
					$setQuery =& new MBQuery("SetCerts", "update", $params);

					if ($this->addErrorsFromResult( $r =& $setQuery->getResult() )) {
						redirect( "certs.php", "OrderCertCSRVerify", array("certID" => (int)$_REQUEST["certID"]) );
					} else {
						$this->addError(TRANS_ACTIONERROR, "Cert failed to record properly");
					}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // OrderCertCSRRequestResponse
?>