<?php
// $Id: OrderCertContactRequest.php 7365 2006-06-08 21:32:52Z bsmith $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 *
 */
class OrderCertContactRequest extends MB_Action {

	function OrderCertContactRequest() {
		parent::MB_Action();
		$this->stringRep = "OrderCertContactRequest";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$certID = (int)$_REQUEST["certID"];

		if (notZero( $certID )) {
			$query = $this->getMBAPIQuery("GetCerts", "", array("certID" => $certID,"clientID"=>$CONF["user"]["id"]));
			$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
			$data = $data[0];

			if (notZero( $data["certID"] )) {
				$this->smartyVars["cert"] =& $data;
				
				switch( $this->smartyVars["cert"]["ODProductCode"] ) {
				case "QuickSSL":
					$this->smartyVars["pageTitle"] = getCertName(0);
					$this->smartyVars["show_org_info"] = false;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
				break;

				case "QuickSSLPremium":
					$this->smartyVars["pageTitle"] = getCertName(1);
					$this->smartyVars["show_org_info"] = false;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
				break;

				case "TrueBizID":
					$this->smartyVars["pageTitle"] = getCertName(2);
					$this->smartyVars["show_org_info"] = true;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
				break;

				case "RapidSSL":
					$this->smartyVars["pageTitle"] = getCertName(3);
					$this->smartyVars["show_org_info"] = false;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
				break;
				}
				
				$this->addTemplate("certs/OrderCertContactRequest");
			}
		} else {
			$this->addError( TRANS_ACTIONERROR, "Cert ID not Set" );
		}	
		
		$this->addErrorTemplates();

		return $this->hasExecutedSuccessfully();
	}
} // OrderCertContactRequest
?>