<?php
// $Id: OrderCertGetApproverEula.php 7365 2006-06-08 21:32:52Z bsmith $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 *
 */
class OrderCertGetApproverEula extends MB_Action {

	function OrderCertGetApproverEula() {
		parent::MB_Action();
		$this->stringRep = "OrderCertGetApproverEula";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$certID = (int)$_REQUEST["certID"];

		if (notZero( $certID )) {
			$query = $this->getMBAPIQuery( "GetCerts", "", array("certID" => $certID,"clientID"=>$CONF["user"]["id"]) );
			$data = dispatchMBAPI( $query, 1 );

			dbg( "################ GetCerts #########" );
			dbg( $data );
			
			if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["cert"] = correctArray( $data["mbapi"][0]["results"][0]["certs"][0]["cert"][0] );
				dbg( "########### Results from GetCerts ############" );
				dbg( $this->smartyVars["cert"] );

				$params = array(
					"subCommand" => "GetQuickApproverList",
					"orID" => $this->smartyVars["cert"]["orID"],
					"Domain" => $this->smartyVars["cert"]["CSRDomainName"]
					);
				dbg( "############# Params to ProcessSSLfactory #############" );
				dbg( $params );
				
				$query = $this->getMBAPIQuery( "ProcessSSLfactory", "", $params, 0, 0, 0, 0, 1, array_keys( $_REQUEST ) );
				$data = dispatchMBAPI( $query, 1 );
				dbg( "############# ProcessSSLfactory ############" );
				dbg( $data );
				
				if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					$results = correctArray( $data["mbapi"][0]["results"][0] );
					
					dbg( "################# Results from ProcessSSLfactory ############" );
					dbg( $results );
					
					if (notNull( $results["APPROVERLIST"][0]["APPROVER"] ) && notZero(count( $results["APPROVERLIST"][0]["APPROVER"] ))) {
						
						foreach( $results["APPROVERLIST"][0]["APPROVER"] as $user ) {
							switch( strtolower($user["APPROVERTYPE"]) ) {
							case 'generic':
								$domain = strstr($user["APPROVEREMAIL"], '@');
								if (count( explode( '.', $domain ) ) > 2) {
									$type = 'level3';
								} else {
									$type = 'level2';
								}
							break;

							default:
								$type = $user["APPROVERTYPE"];
							break;
							}
							$this->smartyVars["approvers"][ $type ][] = $user["APPROVEREMAIL"];
						}

						$this->smartyVars["certID"] = $certID;
						$this->smartyVars["pageTitle"] = getCertName( getCertID( $this->smartyVars["cert"]["ODProductCode"] ) );
						$this->addTemplate("certs/OrderCertGetApproverEula");
						
					} else {
						$this->addError( TRANS_ACTIONERROR, "Failed to recieve Approver List" );
					}
				}
			}
		} else {
			$this->addError( TRANS_ACTIONERROR, "Cert ID not Set");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // OrderCertGetApproverEula
?>