<?php
// $Id: OrderCertOrderResponse.php 7365 2006-06-08 21:32:52Z bsmith $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 *
 */
class OrderCertOrderResponse extends MB_Action {

	function OrderCertOrderResponse() {
		parent::MB_Action();
		$this->stringRep = "OrderCertOrderResponse";
		$this->params = array("certID", "iagree");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$certID = (int)$_REQUEST["certID"];
		
		if (notZero( $certID )) {
			if ($_REQUEST["iagree"] == "checked") {
				$query = $this->getMBAPIQuery("GetCerts", "", array("certID" => $certID,"clientID"=>$CONF["user"]["id"]));
				$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
				$data = $data[0];

				if (notZero( $data["certID"] )) {
					$params = array(
							"subCommand" => "QuickOrder",
							"orID" => $data["orID"],
							"ProductCode" => $data["ODProductCode"],
							"ValidityPeriod" => $data["ODValidityPeriod"],
							"Method" => "RESELLER",
							"ServerCount" => $data["ODServerCount"],
							"CSR" => $data["CSRCSR"],
							"CUIndicator" => $data["UPGCUIndicator"],
							"RenewalIndicator" => $data["RIRenewalIndicator"],
							"RenewalBehavior" => "GEOTRUST",
							"Domain" => $data["CSRDomainName"],
							"SpecialInstructions" => $data["ODSpecialInstructions"],
							"UserAgreementProductCode" => $data["ODProductCode"],

							"OD_ApproverEmailAddress" => $data["ODApproverEmailAddress"],

							"ORG_OrganizationName" => $data["ORGOrganizationName"],
							"ORG_DUNS" => $data["ORGDUNS"],
							"ORG_Phone" => $data["ORGPhone"],
							"ORG_Fax" => $data["ORGFax"],
							"ORG_AddressLine1" => $data["ORGAddressLine1"],
							"ORG_AddressLine2" => $data["ORGAddressLine2"],
							"ORG_AddressLine3" => $data["ORGAddressLine3"],
							"ORG_City" => $data["ORGCity"],
							"ORG_Region" => $data["ORGRegion"],
							"ORG_PostalCode" => $data["ORGPostalCode"],
							"ORG_Country" => $data["ORGCountry"],

							"AC_FirstName" => $data["ACFirstName"],
							"AC_LastName" => $data["ACLastName"],
							"AC_Phone" => $data["ACPhone"],
							"AC_Email" => $data["ACEmail"]);

					switch( $data["orTechSameAsAdmin"] ) {
					case "new":
						$params["or_techSameAsAdmin"] = "false";
						$params["TC_FirstName"] = $data["TCFirstName"];
						$params["TC_LastName"] = $data["TCLastName"];
						$params["TC_Phone"] = $data["TCPhone"];
						$params["TC_Email"] = $data["TCEmail"];
					break;

					case "admin":
						$params["or_techSameAsAdmin"] = "true";
						$params["TC_FirstName"] = $data["ACFirstName"];
						$params["TC_LastName"] = $data["ACLastName"];
						$params["TC_Phone"] = $data["ACPhone"];
						$params["TC_Email"] = $data["ACEmail"];
					break;
					}

					switch( $data["orBillSameAsPrevious"] ) {
					case "new":
						$params["or_billSameAsPrevious"] = "false";
						$params["BC_FirstName"] = $data["BCFirstName"];
						$params["BC_LastName"] = $data["BCLastName"];
						$params["BC_Phone"] = $data["BCPhone"];
						$params["BC_Email"] = $data["BCEmail"];
					break;

					case "admin":
						$params["or_billSameAsPrevious"] = "true";
						$params["BC_FirstName"] = $data["ACFirstName"];
						$params["BC_LastName"] = $data["ACLastName"];
						$params["BC_Phone"] = $data["ACPhone"];
						$params["BC_Email"] = $data["ACEmail"];
					break;

					case "tech":
						$params["or_billSameAsPrevious"] = "true";
						$params["BC_FirstName"] = $data["TCFirstName"];
						$params["BC_LastName"] = $data["TCLastName"];
						$params["BC_Phone"] = $data["TCPhone"];
						$params["BC_Email"] = $data["TCEmail"];
					break;
					}
					
					dbg( "################### Params passed to SSLfactory ###############" );
					dbg( $params );

					
					$query = $this->getMBAPIQuery( "ProcessSSLfactory", "", $params, 0, 0, 0, 0, 1, array_keys( $_REQUEST ) );
					$data = dispatchMBAPI( $query, 1 );
	
					dbg( "######### Returned from ProcessSSLfactory ###############" );
					dbg( $data );

					$data = grabSimpleMBAPIResults( $data );
					
					$params = array(
							"ODGeoTrustOrderID" => $data["GEOTRUSTORDERID"],
							"ODPartnetOrderID" => $data["ORDERRESPONSEHEADER"][0]["PARTNERORDERID"],
							"certID" => $certID);

					$setQuery =& new MBQuery("SetCerts", "update", $params);
					
					if ($this->addErrorsFromResult( $r =& $setQuery->getResult() )) {
						redirect( "certs.php", "OrderCertOrderResults", array("certID" => $certID));
					} else {
						$this->setError( TRANS_ACTIONERROR, "Cert Failed to Record." );
					}
				}
			} else {
				$this->addError( TRANS_ACTIONERROR, "Please Agree to the Service Agreements Term" );
			}
		} else {
			$this->addError( TRANS_ACTIONERROR, "Cert ID not set." );
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // OrderCertOrderResponse
?>