<?php
// $Id: OrderCertOrderResults.php 10479 2007-01-12 22:56:05Z bsmith $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 *
 */
class OrderCertOrderResults extends MB_Action {

	function OrderCertOrderResults() {
		parent::MB_Action();
		$this->stringRep = "OrderCertOrderResults";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$certID = (int)$_REQUEST["certID"];

		if (notZero( $certID )) {
			$query = $this->getMBAPIQuery("GetCerts", "", array("certID" => $certID,"clientID"=>$CONF["user"]["id"]));
			$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
			$data = $data[0];

			if (notZero( $data["certID"] )) {

				$this->smartyVars["productName"] = getCertName( getCertID( $data["ODProductCode"] ) );
				$this->smartyVars["cert"] =& $data;

				if ($data["ODProductCode"] == "TrueBizID") {
					$this->smartyVars["pageMessage"] = TRANS_TRUEBIZNOTICE;
				} else {
					$this->smartyVars["pageMessage"] = TRANS_NORMALNOTICE;
				}


				/**
				 * Now it that the order is complete it is time
				 * to flip the package as active
				 */
				$packageData = oneOf("packageCertRels", array("certID"=>$certID));

				if (notNull( $packageData )) {
					updateFor("packages", array(
						"packageID" => (int)$packageData["packageID"],
						"packageStatus" => getAPIStatusID("packages", "none")));
				}

				$this->addTemplate("certs/OrderCertOrderResults");
			}
		} else {
			$this->addError( TRANS_ACTIONERROR, "Cert ID not set.");
		}
		
		
		$this->addErrorTemplates();

		return $this->hasExecutedSuccessfully();
	}
} // OrderCertOrderResults
?>