<?php
// $Id: EditDomainDNSResponse.php 12494 2008-01-16 19:11:10Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditDomainAccessPassword action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class EditDomainDNSResponse extends MB_Action {
	/**
	 * The constructor for an EditDomainDNSResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditDomainDNSResponse() {
		parent::MB_Action();
		$this->stringRep = "EditDomainDNSResponse";
		$this->params = array
		(
			"domainID",
			"domainDNS",  //an array

		);
	}

	/**
	 * The main method of this class that executes the EditDomainDNSResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		$useDNSOld = ((int) $_REQUEST["useDNSOld"]);
		$useDNS = ((int) $_REQUEST["useDNS"]);
		$nameServers = array();
		$commandXML = "";

		if(!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",TRANS_DOMAIN_PRODUCT)));
			$mbapiData = dispatchMBAPI($query, 1);

			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else {

				// fetching domain data from the registrar
				$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
				$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
				$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

				//If useDNS has changed from yes to no, pass that along with the new servers
				if(!$useDNS && $useDNSOld) {
					$commandXML = "<domainDNS>0</domainDNS>";
					$nameServers = (array) $_REQUEST["domainDNS"];
					foreach($nameServers as $key => $value) {
						//if($value) { //Let the blank go through so that servers can be removed
							$commandXML .= "<domainNameserver".($key+1).">".$value."</domainNameserver".($key+1).">\n";
						//}
					}
				}

				// Pull the host items
				$hostDNSHostname = $hostDNSType = $hostDNSAddress = array();
				if($useDNS) {
					$hostSettings = array();
					$hostDNSHostname = $_REQUEST["hostDNSHostname"];
					$hostDNSType = $_REQUEST["hostDNSType"];
					$hostDNSAddress = $_REQUEST["hostDNSAddress"];

					$i=0;
					for($i;$i<=10;$i++) {
//						if($hostDNSHostname[$i]) {
						if($hostDNSAddress[$i]) {
							$hostSettings[$i]["hostname"] = $hostDNSHostname[$i];
							$hostSettings[$i]["type"] = $hostDNSType[$i];
							$hostSettings[$i]["address"] = $hostDNSAddress[$i];
						}
					}
					$hostXML = "";
					foreach($hostSettings as $k => $value) {
						$hostXML .= "<host>\n";
						$hostXML .= "  <HostName".($k+1).">".$value["hostname"]."</HostName".($k+1).">\n";
						$hostXML .= "  <RecordType".($k+1).">".$value["type"]."</RecordType".($k+1).">\n";
						$hostXML .= "  <Address".($k+1).">".$value["address"]."</Address".($k+1).">\n";
						$hostXML .= "</host>\n";
					}
				}
				//if useDNS has changed from no to yes, just pass that and look for host fields
				if($useDNS && !$useDNSOld) {
					$commandXML = "<domainDNS>1</domainDNS>";
				}
				//if yes and yes just send the host info
				if($useDNS && $useDNSOld) {
					$commandXML = "<domainDNS>1</domainDNS>";
				}
				//if no and no pass the servers
				if(!$useDNS && !$useDNSOld) {
					$nameServers = (array) $_REQUEST["domainDNS"];
					foreach($nameServers as $key => $value) {
						$commandXML .= "<domainNameserver".($key+1).">".$value."</domainNameserver".($key+1).">";
					}
				}

				$xml = "
				<mbapi>
					<command>ProcessRegistrar</command>
					<subCommand>setDomainDNS</subCommand>
					<showXMLHeader>0</showXMLHeader>
					<params>
						<subCommand>setDomainDNS</subCommand>
						<configID>0</configID>
						<domainSLD>$domainSLD</domainSLD>
						<domainTLD>$domainTLD</domainTLD>
						<domainID>$domainID</domainID>
						$commandXML
						$hostXML
					</params>
				</mbapi>";

				$data = dispatchMBAPI($xml,1);

				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					redirect("domains.php",getActionID("ShowDomainDetails"), array("domainID"=>$domainID));
				} else {
					//Try to use the warining class
					$warningMessage =& new Warning($this->errors[0][0][0],$this->errors[0][1][0]);
					$warningMessage->addButton(getActionID("EditDomainDNS"),
								"domains.php", "go back", array("domainID" => $domainID, "sid" => $_REQUEST["sid"]));
					$this->addWarning($warningMessage);
					$this->addWarningTemplates();
				}

			} // if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1)

		} // if(!$domainID)

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainDNSResponse
?>
