<?php
// $Id: ShowFAQs.php 6965 2006-05-19 20:58:44Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+



if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes displays all FAQ categories thath have FAQs along with all FAQ information.
 *
 * @author  Mark Garrett
 * @author  Vic Fryzel
 */

class ShowFAQs extends MB_Action {
	/**
	 * The constructor for a ShowFAQs action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowFAQs() {
		parent::MB_Action();
		$this->stringRep = "ShowFAQs";

		$this->params = array("faqID");
		$this->sortColumns = array("faqCategoryID", "faqID");
	}

	/**
	 * The main method of this class that executes the ShowFAQs action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetFAQCategories", "", array("getFAQData" => 1), 1,1,1,1);
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0]["faqCategories"][0]["faqCategory"];
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$smartyVars = array();
			if($data["mbapi"][0]["header"][0]["numResults"][0] > 0) {
				$faqCategories = $faqs = array();
				foreach($results as $faqCategory) {
					// We use the following line to reset the variable each round.
					// The one above is only to declare it once, instead of n times.
					$faqs = array();
					if(is_array($faqCategory["FAQs"][0]["FAQ"]) && count($faqCategory["FAQs"][0]["FAQ"]) > 1) {
						$faqs = collapseArrayElements($faqCategory["FAQs"][0]["FAQ"]);
					} else if(is_array($faqCategory["FAQs"][0]["FAQ"])) {
						$faqs[] = collapseArrayElements($faqCategory["FAQs"][0]["FAQ"][0]);
					}
					$faqCategories[] = array(
						"faqCategoryID" => $faqCategory["faqCategoryID"][0],
						"faqCategoryName" => unsecureInput($faqCategory["faqCategoryName"][0]),
						"faqCategoryType" => $faqCategory["faqCategoryType"][0],
						"faqs" => $faqs);
				}
				$smartyVars["faqCategories"] = $faqCategories;
				$smartyVars["paginationLinks"] = $data["mbapi"][0]["results"][0]["paginationLinks"][0];
			}

			$CONF["debug"]->add("Output Array", $smartyVars, __FILE__, __LINE__);
			
			$this->addTemplate("faq/ShowFAQs", $smartyVars);
		}
		return $this->hasExecutedSuccessfully();
	}
} // ShowFAQs
?>