<?php
// $Id: PayInvoices.php 12449 2008-01-10 20:28:56Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object displays a client dashboard.
 *
 * @author  Kris Bailey
 */
class PayInvoices extends MB_Action {
	/**
	 * The constructor for a PayInvoices action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function PayInvoices() {
		parent::MB_Action();
		$this->stringRep = "PayInvoices";
	}

	/**
	 * The main method of this class that executes the ShowDashboard action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		loadConfigs("payment");

		if ($CONF["system"]["encryption"]["lek_pin"]==''){
			$this->smartyVars["nolek"] = 1;
		}

		// get client data
		$clientID = ((int) $CONF["user"]["id"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "You must not be logged in because you don't have an ID.");
		} else {

			// ---------------------------------------------------
			// Get client data ...
			// ---------------------------------------------------
			$this->mergeClientData($clientID, array("getBillingData"=>1));
			if ($this->smartyVars["client"]["billingAccounts"]["billingAccount"]["billingAccountID"]){
				$this->smartyVars["client"]["billingAccounts"]["billingAccount"] = array($this->smartyVars["client"]["billingAccounts"]["billingAccount"]);
			}
			$this->smartyVars["client"]["billingAccounts"]["billingAccount"] = (array)$this->smartyVars["client"]["billingAccounts"]["billingAccount"];
			$this->smartyVars["billingAccounts"] = array();
			foreach ($this->smartyVars["client"]["billingAccounts"]["billingAccount"] as $acct){
				if ($acct["billingAccountType"]==0 && !(int)$this->smartyVars["nolek"]){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".getTypeName("card", $acct["billingCardType"])." - ".$acct["billingCardNameOnCard"];
				}
				if ($acct["billingAccountType"]==1){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".$acct["billingBankName"]." - ".@substr($acct["billingBankAccountNum"], -4);
				}
			}
			dbg($this->smartyVars);
			for ($i=date("Y"); $i<date("Y")+21; $i++){
				$this->smartyVars["cardYears"][$i] = $i;
			}


			$this->smartyVars["cardTypes"] = $CONF["types"]["card"];

			$this->smartyVars["payTotal"] = 0;

			// ---------------------------------------------------
			// Get DUE invoices ...
			// ---------------------------------------------------
			$this->smartyVars["invoices"] = array(); // init
			$this->smartyVars["invoiceGroups"] = array();
			$params = array
				(
				"clientID" => $clientID,
				"getDueInvoicesOnly" => 1,
				);
			if ((int)$_REQUEST["invoiceID"]){
				$params["invoiceID"] = $this->smartyVars["invoiceID"] = (int)$_REQUEST["invoiceID"];
			}
			$query = getMBAPIQuery("GetInvoices", "",  $params, "ASC", "invoiceID", 0);
			dbg($query);
			$data = dispatchMBAPI($query, 1);
			dbg($data);
			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0) {
				// set master invoices data array
				$this->smartyVars["invoices"] = collapseArrayElements(protectArray($results["invoices"][0]["invoice"]));
				// build invoice line item data
				if($this->smartyVars["invoices"]) {
					for ($i = 0; $i < count($this->smartyVars["invoices"]); $i++){
						//if (!$this->smartyVars["invoices"][$i]["lineItems"]["lineItem"][0]["clientID"]){
						//	$this->smartyVars["invoices"][$i]["lineItems"]["lineItem"] = array($this->smartyVars["invoices"][$i]["lineItems"]["lineItem"]);
						//}
						$this->smartyVars["invoices"][$i]["invoiceAmountDue"] = $this->smartyVars["invoices"][$i]["invoiceAmount"]-$this->smartyVars["invoices"][$i]["invoiceAmountPaid"];
						$this->smartyVars["invoiceGroups"][$this->smartyVars["invoices"][$i]["paymentGroupID"]]["invoices"][] =& $this->smartyVars["invoices"][$i];
						$thisdue = $this->smartyVars["invoices"][$i]["invoiceAmount"]-$this->smartyVars["invoices"][$i]["invoiceAmountPaid"];
						if ($thisdue<0)$thisdue = 0;
						$this->smartyVars["invoiceGroups"][$this->smartyVars["invoices"][$i]["paymentGroupID"]]["payTotal"] += $thisdue;
					}
				}

				$groupIDs = array_keys($this->smartyVars["invoiceGroups"]);

				$groups = correctArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $groupIDs,
						),
					),
				)));
				
				foreach ($groups as $group){
					if ($this->smartyVars["invoiceGroups"][$group["paymentGroupID"]]){
						foreach ((array)$group["gateways"] as $gateway){
							if ($gateway["gatewayType"]){
								$this->smartyVars["invoiceGroups"][$group["paymentGroupID"]]["hasPrimary"] = 1;
								$this->smartyVars["invoiceGroups"][$group["paymentGroupID"]]["cardTypes"] = $this->getAcceptedCardTypesByID($gateway["configGroupID"]);
							} else {
								$this->smartyVars["invoiceGroups"][$group["paymentGroupID"]]["secondary"][] = $gateway;
							}
						}
					}
				}
				
				$this->smartyVars["secondaryGatewayNames"] = array();
				
				foreach ((array)$this->smartyVars["invoices"] as $k=>$invoice){
					$secondaries = $this->smartyVars["invoiceGroups"][$invoice["paymentGroupID"]]["secondary"];
					foreach ((array)$secondaries as $secGatewayInfo){
						$results = correctArray(dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "ProcessGateway",
								"params" => array(
									"configGroupID" => $secGatewayInfo["configGroupID"],
									"subCommand" => "charge",
									"invoiceName" => $invoice["invoiceID"],
									"singlePayment" => 1,
								),
							),
						)), 1));
						if ($results["mbapi"][0]["results"][0]["transactions"] && $results["mbapi"][0]["results"][0]["transactions"]){
							$results = $results["mbapi"][0]["results"][0]["transactions"][0];
						} else {
							$results = array();
						}
						$this->smartyVars["invoices"][$k]["secondary"][$secGatewayInfo["configGroupTransKey"]][] = $results;
					}
					if ($this->smartyVars["invoices"] && $this->smartyVars["invoices"][$k] && is_array($this->smartyVars["invoices"][$k])){
						$this->smartyVars["secondaryGatewayNames"][$invoice["paymentGroupID"]] = array_keys((array)$this->smartyVars["invoices"][$k]["secondary"]);
					}
				}
				


				// set master invoices line item data array
				/*$lineItems = array();
				$c = count($results["invoices"][0]["invoice"]);
				for($i = 0; $i < $c; $i++) {
					// leave this uncollapsed so that the template code can work with both singular and plural results;
					// see the comment in the template for details
					$lineItemsData =& $results["invoices"][0]["invoice"][$i]["lineItems"][0]["lineItem"];
					$lineItems[$results["invoices"][0]["invoice"][$i]["invoiceID"][0]] = collapseArrayElements(protectArray($lineItemsData));
				}
				$this->smartyVars["lineItems"] = $lineItems;*/
				
			}

			$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoices", $this->smartyVars));

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowDashboard
?>
