<?php
// $Id: PayInvoicesResponse.php 12344 2007-12-11 22:01:42Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-modernbill/include/accounting/Payment.php");

/**
 * This Action object displays a client dashboard.
 *
 * @author  Kris Bailey
 */
class PayInvoicesResponse extends MB_Action {
	/**
	* The constructor for a PayInvoicesResponse action object. This method calls the parent constructor,
	* and sets the string representation of this object.
	*/
	function ShowDashboard() {
		parent::MB_Action();
		$this->stringRep = "PayInvoices";
	}

	/**
	* The main method of this class that executes the PayInvoicesResponse action, and returns success or failure.
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();
		loadConfigs("payment");
		$this->fixGatewayConfigGroups();
		dbg($_REQUEST);

		// get client data
		$clientID = ((int) $CONF["user"]["id"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "You must not be logged in because you don't have an ID.");
		} else {

			$clientInfo = dispatchMBAPI("<mbapi>
											<command>GetClients</command>
											<params>
												<clientID>".$clientID."</clientID>
												<getContactData>3</getContactData>
											</params>
										</mbapi>", 1);
			if ($clientInfo["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"][0]){
				$mainContact = correctArray($clientInfo["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
			}



			$invoiceIDs = $_REQUEST["invoiceIDs"];
			$billingAccountID = (int)$_REQUEST["billingAccountID"];
			$paymentAmount = doubleval($_REQUEST["payTotal"]);

			$oid = ((int)$_REQUEST["invoiceID"]) ? "<invoiceID>".(int)$_REQUEST["invoiceID"]."</invoiceID>":"";

			$invoiceXML = " <mbapi>
								<command>GetInvoices</command>
								<params>
									<clientID>".$clientID."</clientID>
									<getDueInovicesOnly>1</getDueInovicesOnly>
									<getInvoiceLineItemsData>1</getInvoiceLineItemsData>
									".$oid."
									<paymentGroupID>".((int)$_REQUEST["paymentGroupID"])."</paymentGroupID>
								</params>
							</mbapi>";
			$invoices = dispatchMBAPI($invoiceXML, 1);
			$invoices = $invoices["mbapi"][0]["results"][0];
			if (isset($invoices["invoices"][0]["invoice"])){
				$invoices = correctArray($invoices["invoices"][0]["invoice"]);
			}
			$validInvoiceIDs = array();
			foreach ($invoices as $invoice){
				$validInvoiceIDs[] = $invoice["invoiceID"];
			}
			$newInvoiceIDs = array();
			if (isset($invoiceIDs)){
				foreach ($invoiceIDs as $v){
					if (in_array($v, $validInvoiceIDs)){
						$newInvoiceIDs[] = $v;
					}
				}
				$invoiceIDs = $newInvoiceIDs;
			} else {
				dbg("redirected prematurely");
				redirect("invoices.php?action=".getActionID("PayInvoices")."&sid=".secureInput($_REQUEST["sid"]));
				return 1;
			}

			$newInvoices = array();
			foreach ($invoices as $invoice){
				if (@in_array($invoice["invoiceID"], $invoiceIDs)){
					$newInvoices[] = $invoice;
					$lastInvoiceID = $invoice["invoiceID"];
				}
			}
			$invoices = $newInvoices;

			if (count($invoices)){


				//
				if ($billingAccountID==0){

					$cardCVV2 = ereg_replace("[^0-9]", "", $_REQUEST["cardCVV2"]);
					$cardNum = ereg_replace("[^0-9]", "", $_REQUEST["billingCardNum"]);
					$cardExpMonth = ereg_replace("[^0-9]", "", $_REQUEST["billingCardExpMonth"]);
					$cardExpYear = ereg_replace("[^0-9]", "", $_REQUEST["billingCardExpYear"]);
					$nameOnCard = $_REQUEST["billingCardNameOnCard"];
					$accountType = (int)$_REQUEST["billingAccountType"];
					$cardType = (int)$_REQUEST["billingCardType"];
					$cardStartDate = $_REQUEST["billingCardStartDate"];
					$cardIssueNum = $_REQUEST["billingCardIssueNum"];

					$billingAccountID = insertFor("billingAccounts", array(
						"clientContactID" => $mainContact["clientContactID"],
						"billingAccountType" => getAPITypeID("billingAccount", "card"),
						"clientContactID" => $mainContact["clientContactID"],
						"billingCardNameOnCard" => $nameOnCard,
						"billingCardType" => $cardType,
						"billingCardNum" => $cardNum,
						"billingCardExpMonth" => $cardExpMonth,
						"billingCardExpYear" => $cardExpYear,
						"billingCardIssueNum" => $cardIssueNum,
						"billingCardStartDate" => $cardStartDate,
					));

				}
				//


				$paymentGroupData = oneByID("paymentGroups", (int)$_REQUEST["paymentGroupID"]);
				if (!(int)$paymentGroupData["paymentGroupID"]){
					$this->smartyVars["paymentError"] = 1;
					$this->smartyVars["paymentErrorText"] = TRANS_PAYMENT_GROUP_ERROR;
					$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
				} else {

					$gatewayinfo = array();
					foreach ($paymentGroupData["gateways"] as $gateway){
						if ($gateway["gatewayType"]){
							$gatewayinfo = $gateway;
						}
					}
					//$gatewayinfo["parentname"] = $this->getGatewayParentNameByID($gatewayinfo["configGroupID"]);
					//$gatewayName = $gatewayinfo["parentname"];

					$chargeXML = "  <mbapi>
										<command>ProcessGateway</command>
										<params>
											<key>".$CONF["system"]["encryption"]["lek_pin"]."</key>
											<configGroupID>".$gatewayinfo["configGroupID"]."</configGroupID>
											<subCommand>charge</subCommand>
											<invoiceName>".@implode(", ", $invoiceIDs)."</invoiceName>
											<paymentDescription>".TRANS_PAYMENT_FOR_INVOICES.": ".@implode(", ", $invoiceIDs)."</paymentDescription>
											<paymentAmount>".$paymentAmount."</paymentAmount>
											<paymentMethod>CC</paymentMethod>
											<billingAccountID>".$billingAccountID."</billingAccountID>
											".(($cardCVV2>0)?"<cardCVV2>".$cardCVV2."</cardCVV2>":"<isRecurring>1</isRecurring>")."
											".(($cardNum>0)?"<cardNum>".$cardNum."</cardNum>":"")."
										</params>
									</mbapi>";
					dbg($chargeXML);
					// run the charge.
					$chargeResults = dispatchMBAPI($chargeXML, 1);
					dbg($chargeResults);

					if ($chargeResults["mbapi"][0]["results"] && $chargeResults["mbapi"][0]["results"][0]["transactions"] && $chargeResults["mbapi"][0]["results"][0]["transactions"][0]["transaction"]){
						$chargeResults = correctArray($chargeResults["mbapi"][0]["results"][0]["transactions"][0]["transaction"][0]);
					}
					$chargeData = $chargeResults;
					dbg($chargeData);

					$this->smartyVars["currencyID"] = $invoices[0]["currencyID"];
					$this->smartyVars["payTotal"] = $paymentAmount;
					$this->smartyVars["invoices"] = $invoices;
					$this->smartyVars["authorizationCode"] = $chargeData["authorizationCode"];

					dbg($invoices);

					///////////// create the transaction
					$transXML = "
								<mbapi>
								<command>SetTransaction</command>
								<subCommand>insert</subCommand>
								<params>
									<transactionPaymentMethod>2</transactionPaymentMethod>
									<authReturn>".$chargeData["status"]."</authReturn>
									<transactionCode>".$chargeData["authorizationCode"]."</transactionCode>
									<transactionNotes>".$chargeData["message"]."</transactionNotes>
									<transactionDateCreated>".time()."</transactionDateCreated>
									<authCode></authCode>
									<avsCode>".$chargeData["AVSCode"]."</avsCode>
									<transactionAmount>".$paymentAmount."</transactionAmount>
									<currencyID>".$invoices[0]["currencyID"]."</currencyID>
									<configGroupID>".$gatewayinfo["configGroupID"]."</configGroupID>
									<billingAccountID>".$billingAccountID."</billingAccountID>
									<invoiceIDs>
										<invoiceID>".@implode("</invoiceID>\n<invoiceID>", $invoiceIDs)."</invoiceID>
									</invoiceIDs>
								</params>
								</mbapi>";

					$transResponse = dispatchMBAPI($transXML, 1);
					$transactionID = $transResponse["mbapi"][0]["header"][0]["lastInsertID"][0];

					$this->smartyVars["transactionID"] = $transactionID;


					switch ($chargeData["status"]){
						case GATEWAY_SUCCESS:
	
							$transactionAmount = $paymentAmount;
							$overage = $paymentAmount;
	
	
	
							foreach ($invoices as $invoice){
								$invoiceID = $invoice["invoiceID"];
								$this->invoiceInfo = $invoice;
								$this->lineItems = correctArray($this->invoiceInfo["lineItems"]);
								foreach ($this->lineItems as $k=>$v){
									$this->lineItems[$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
								}
	
		/////////////////////////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////////////////////
	
								// apply the overage, or just the amount they listed, to line items in order.
	
								foreach ($this->lineItems as $k=>$v){
									if ($overage>0){
										if ($v["lineItemApplyAmount"]<$v["lineItemAmountDue"]){
											$diff = $v["lineItemAmountDue"]-$v["lineItemApplyAmount"];
											if ($overage<$diff){
												$diff = $overage;
												$overage = 0;
											} else {
												$overage -= $diff;
											}
											$this->lineItems[$k]["lineItemApplyAmount"] += $diff;
										}
									} else {
										break;
									}
								}
	
								// do success rel
	
								foreach ($this->lineItems as $k=>$v){
									if ($v["lineItemApplyAmount"]>0){
										$successRelXML = "
												<mbapi>
													<command>SetTransactionSuccessRel</command>
													<subCommand>insert</subCommand>
													<params>
														<transactionID>$transactionID</transactionID>
														<billingAccountShareID>0</billingAccountShareID>
														<lineItemID>".$v["lineItemID"]."</lineItemID>
														<lineItemPaymentAmount>".$v["lineItemApplyAmount"]."</lineItemPaymentAmount>
													</params>
												</mbapi>
												";
										$successRel = dispatchMBAPI($successRelXML, 1);
									} else {
										$CONF["debug"]->debugMessage("had a blank amount: $transactionID");
									}
								}
	
								// update the invoice
	
								$amount = 0;
								$paidtotal = $invoice["invoiceAmountPaid"];
								foreach ($this->lineItems as $k=>$v){
									$amount += $v["lineItemApplyAmount"];
									$paidtotal += $v["lineItemApplyAmount"]+$v["lineItemPaymentAmount"];
								}
	
								$updateXML = "
											<mbapi>
												<command>SetInvoices</command>
												<subCommand>update</subCommand>
												<showXMLHeader>0</showXMLHeader>
												<params>
												<invoiceID>".$invoiceID."</invoiceID>
												<invoiceAmountPaid>".$paidtotal."</invoiceAmountPaid>
												<invoiceDatePaid>".time()."</invoiceDatePaid>
											".((round($paidtotal,2)==round($this->invoiceInfo["invoiceAmount"],2))?"<invoiceStatus>1</invoiceStatus>":"")."
												</params>
											</mbapi>";
	
								$updateResponse = dispatchMBAPI($updateXML, 1);
	
								if ($invoiceID==$lastInvoiceID){
									dbg("the last one");
									if ($overage>0){
										$credit = round($overage, 3);
									}
								} else {
									dbg("not the last one");
									$credit = 0;
								}
	
								dbg("overage: ".$credit);
	
								$receipt =& new Payment();
								$receipt->setClientID($clientID);
								$receipt->setInvoiceID($invoiceID);
								$receipt->setTransactionID($transactionID);
								$receipt->setDescription(TRANS_PAYMENT_FOR_INVOICE.": ".@constant(getTypeName("payment", 2)));
								$receipt->setPaymentAmount($amount+$credit);
								if ($credit>0){
									$receipt->setClientCreditAmount($credit);
								}
								$receipt->setCurrencyID($this->invoiceInfo["currencyID"]);
								$receipt->execute();
	
							}
	
							$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
						break;

						case GATEWAY_DECLINE:
							dbg($chargeReturn);
							$this->smartyVars["paymentError"] = 1;
							$this->smartyVars["paymentErrorText"] = TRANS_PAYMENT_DECLINED;
							$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
							break;

						case GATEWAY_PARAM_FAILURE:
							dbg($chargeReturn);
							$this->smartyVars["paymentError"] = 1;
							$this->smartyVars["paymentErrorText"] = TRANS_GATEWAY_FAILURE;
							$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
							break;

						case GATEWAY_FAILURE:
						default:
							dbg($chargeReturn);
							$this->smartyVars["paymentError"] = 1;
							$this->smartyVars["paymentErrorText"] = TRANS_GATEWAY_FAILURE;
							$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
							break;

					}

				}

			} else {
				$this->smartyVars["paymentError"] = 1;
				$this->smartyVars["paymentErrorText"] = TRANS_INVOICES_ALREADY_PAID_FOR;
				$this->hasExecutedSuccessfully = ((int) $this->addTemplate("invoices/PayInvoicesResponse", $this->smartyVars));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // PayInvoicesResponse
