<?php
// $Id: ShowInvoiceDetails.php 11792 2007-08-15 19:58:52Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["invoiceID"] it displays all
 * the details for the found invoice, and only displays the details of a single invoice.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowInvoiceDetails extends MB_Action {
	/**
	 * The constructor for a ShowInvoiceDetails object. This merely sets up our string represenation, calls 
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowInvoiceDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowInvoiceDetails";
		$this->params = array("invoiceID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		$print = ((int) $_REQUEST["print"]);
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No Invoice ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetInvoices", "", array('clientID'=>$CONF["user"]["id"], 'getInvoiceLineItemsData'=>1, 'getInvoiceLineItemsPaymentsData'=>1, 'getTaxZonesData'=>1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if (((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0){

					$this->smartyVars = array();
					$this->smartyVars["invoice"] = correctArray($data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]);

					$this->smartyVars["taxZones"] = array();
					$this->smartyVars["addonIDs"] = array();
					$this->smartyVars["addonTotals"] = array();
					$packageIDsForDomainGetting = array();
					foreach ($this->smartyVars["invoice"]["lineItems"] as $k=>$v){
						$packageIDsForDomainGetting[] = $v["packageID"];
						
						if ($v["packageAddonID"]){
							$this->smartyVars["addonIDs"][] = $v["packageAddonID"];
						} else {
							$lastMainLineItem = $v["lineItemID"];
						}
						$this->smartyVars["addonTotals"]["total"][$lastMainLineItem] += $v["lineItemTotalAmount"];
						$this->smartyVars["addonTotals"]["setup"][$lastMainLineItem] += $v["lineItemSetupAmount"];
						$this->smartyVars["addonTotals"]["tax"][$lastMainLineItem] += $v["lineItemTaxAmount"];
						
						$this->smartyVars["invoice"]["lineItems"][$k]["packageComments"] = utf8_html_entity_decode($this->smartyVars["invoice"]["lineItems"][$k]["packageComments"]);
						$this->smartyVars["invoice"]["lineItems"][$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
						$taxZones = (array)$this->smartyVars["invoice"]["lineItems"][$k]["taxZones"];
						dbg("tax zones: ");
						dbg($taxZones);
						$this->smartyVars["invoice"]["lineItems"][$k]["taxZones"] = $taxZones;
						foreach ($taxZones as $zone){
							if (!$this->smartyVars["taxZones"][$zone["taxZoneID"]]){
								$this->smartyVars["taxZones"][$zone["taxZoneID"]] = $zone;
							}
							$this->smartyVars["taxZones"][$zone["taxZoneID"]]["taxTotal"] += $zone["lineItemTaxTotal"];
						}
					}

					$this->smartyVars["taxZones"] = array_values($this->smartyVars["taxZones"]);

					$clientID = $this->smartyVars["invoice"]["lineItems"][0]["clientID"];
					$this->smartyVars["clientID"] = $clientID;

					$clientInfoCmd = "
						<mbapi>
							<command>GetClients</command>
							<showXMLHeader>0</showXMLHeader>
							<params>
								<mergePrimaryContact>1</mergePrimaryContact>
								<clientID>$clientID</clientID>
								<getContactData>3</getContactData>
								<getBillingData>1</getBillingData>
								<getCompanyData>1</getCompanyData>
								<getAccountingData>1</getAccountingData>
								<sortDir></sortDir>
								<sortColumn></sortColumn>
								<recordOffset>0</recordOffset>
								<numRecords>1</numRecords>
							</params>
						</mbapi>";

					$clientData = dispatchMBAPI($clientInfoCmd, 1);
					$CONF["debug"]->add("Action Result", $clientData, __FILE__, __LINE__);
					$clientData = $clientData["mbapi"][0]["results"][0]["clients"][0]["client"][0];
					$contactData = $clientData["contacts"][0]["contact"][0];
					$companyData = $clientData;


					$domainPackages = correctArray(grabResultsFromMBAPIArray($xx = array(
						"mbapi" => array(
							"command" => "GetPackages",
							"params" => array(
								"packageID" => array_values(array_unique($packageIDsForDomainGetting)),
								"getDomainData" => 1,
							),
						),
					)));

					$this->smartyVars["domains"] = array();
					foreach ((array)$domainPackages as $dpkg){
						$this->smartyVars["domains"][$dpkg["packageID"]] = $dpkg["domains"];
					}


					$this->smartyVars["billingAccounts"] = (array)correctArray($clientData["billingAccounts"][0]["billingAccount"]);

					$this->smartyVars["billingAccountOptions"] = array();
					foreach ($this->smartyVars["billingAccounts"] as $row){
						if ($row["billingCardType"]==3){
							$thisID = $row["billingAccountID"];
							$thisDesc = (@constant($x1 = $CONF["types"]["billingAccount"][$row["billingAccountType"]])) ? constant($x1) : $x1;
							$thisDesc .= " - ".$row["contactFirstName"]." ".$row["contactLastName"];
							$this->smartyVars["billingAccountOptions"][$thisID] = $thisDesc;
						}
					}

					$this->smartyVars["clientData"] = correctArray($clientData);
					$tmp = correctArray($clientData["accountingGeneralLedgers"][0]["accountingGeneralLedger"]);
					if ($tmp["currencyID"]){
						$tmp = array($tmp);
					}
					$this->smartyVars["clientCredits"] = $this->getAccountingCurrencyTotals($tmp, "customer_credits");
					ksort($this->smartyVars["clientCredits"]);
					$this->smartyVars["contactData"] = correctArray($contactData);
					$this->smartyVars["companyData"] = correctArray($companyData);


					$paymentsXML = "
						<mbapi>
							<command>GetTransactions</command>
							<params>
								<getGatewayNames>1</getGatewayNames>
								<invoiceIDs>
									<invoiceID>".$invoiceID."</invoiceID>
								</invoiceIDs>
							</params>
						</mbapi>";
					$payments = dispatchMBAPI($paymentsXML, 1);

					$this->smartyVars["transactions"] = collapseArrayElements($payments["mbapi"][0]["results"][0]["transactions"][0]["transaction"]);
					if ($this->smartyVars["transactions"]["transactionID"]>0){
						$this->smartyVars["transactions"] = array($this->smartyVars["transactions"]);
					}
					$this->smartyVars["transactionStatuses"] = getStatuses("transactions");
					if (is_array($this->smartyVars["transactions"])){
						foreach ($this->smartyVars["transactions"] as $k => $v){
							if ($v["gatewayClassName"]!=""){
								$this->smartyVars["transactions"][$k]["canRefund"] = 0;
								if ($v["authReturn"]==getAPIStatusID("transactions", "successful") || $v["authReturn"]==getAPIStatusID("transactions", "captured") || $v["authReturn"]==getAPIStatusID("transactions", "authorized")){
									if (file_exists(mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php"))) {
										require_once mb_path("/lib-mbapi/include/modules/gateway/".$v["gatewayClassName"].".php");
									}
									$caps = call_user_func(array($v["gatewayClassName"], "getModuleInfo"));
									if (($v["authReturn"]==getAPIStatusID("transactions", "successful") || $v["authReturn"]==getAPIStatusID("transactions", "captured")) && in_array(GATEWAY_REFUND, $caps["capabilities"])){
										$this->smartyVars["transactions"][$k]["canRefund"] = 1;
									}
									if ($v["authReturn"]==getAPIStatusID("transactions", "authorized") && in_array(GATEWAY_PRIOR_AUTH_CHARGE, $caps["capabilities"])){
										$this->smartyVars["transactions"][$k]["canFinalize"] = 1;
									}
								}
							}
						}
					}

					$this->smartyVars["paymentMethods"] = $CONF["types"]["payments"];
					$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
					$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
					$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
					$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
					$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
					if($print) {
						$this->addTemplate("invoices/ShowInvoiceDetails.print", $this->smartyVars);
					} else {
						$this->addTemplate("invoices/ShowInvoiceDetails", $this->smartyVars);
					}
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Invoice does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowInvoiceDetails
?>
