<?php
// $Id: ShowInvoices.php 11448 2007-06-27 16:44:50Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all invoices that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowInvoices extends MB_Action {
	/**
	 * The constructor for a ShowInvoices action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowInvoices() {
		parent::MB_Action();
		$this->stringRep = "ShowInvoices";
		$this->params = array("invoiceID", "invoiceNumber", "invoiceAmount", "invoiceDateEntered", "invoiceDateDue", "invoiceDatePaid", "invoiceComments", "invoiceStatus");
		$this->sortColumns = array("invoiceID");

        	// handle date searches and correct mismatch of amount labels
        	$this->setupDateRequestArgs();

        	// handle amount searches and correct mismatch of amount labels
        	$this->setupAmountRequestArgs();

        	// search in a specific column
        	if ($_REQUEST["queryColumn"]!=""){
        	    if ($_REQUEST["query"]!="") {
                	$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
        	    }
        	}

	}

	/**
	 * The main method of this class that executes the ShowInvoices action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = mktime();
		
		dbg($data = dispatchMBAPI(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"clientID" => $CONF["user"]["id"],
					//"getInvoiceLineItemsData" => 1,
					"ignoreCreditNotesAndVoids" => 1,
				) + $this->getRequestParams()
			)
		), 1));
		
		if($this->addMBAPIErrors($data) === 0) {		
			$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
			
			$this->smartyVars["invoices"] = correctArray(grabSimpleMBAPIResults($data));
			$this->smartyVars["lineItems"] = array();
			foreach ($this->smartyVars["invoices"] as $k=>$v){
				$this->smartyVars["lineItems"][$v["invoiceID"]] = $v["lineItems"];
			}
			
			$this->addTemplate("invoices/ShowInvoices", $this->smartyVars);
			
			$this->hasExecutedSuccessfully = 1;
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowInvoices
?>
