<?php
// $Id: LogoutResponse.php 5691 2006-03-22 20:48:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action expires all sessions for the current clients's session ID.
 *
 * @author  Michael Fountain
 */
class LogoutResponse extends MB_Action {
	/**
	 * The constructor for a LogoutResponse action object. This calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function LogoutResponse() {
		parent::MB_Action();
		$this->stringRep = "LogoutResponse";
	}

	/**
	 * The main method of this class that executes the LogoutResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if($CONF["user"]["sessionID"]) {
			$query = $this->getMBAPIQuery("ProcessClientLogout", "", array("sessionID" => $CONF["user"]["sessionID"]));
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("login.php", getActionID("ShowLogin"), array("msg", TRANS_LOGOUTSUCCESSFUL));
			}
		} else {
			redirect("login.php", getActionID("ShowLogin"));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // LogoutResponse
?>