<?php
// $Id: ShowLogin.php 12032 2007-10-05 14:09:29Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays a login form to the user.
 *
 * @author  Vic Fryzel
 */
class ShowLogin extends MB_Action {
	/**
	 * The constructor for a ShowLogin action object. This method calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function ShowLogin() {
		parent::MB_Action();
		$this->stringRep = "ShowLogin";
	}

	/**
	 * The main method of this class that executes the ShowLogin action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(isset($_REQUEST["msg"]) && defined($msg = $_REQUEST["msg"]) && startswith($msg, "TRANS_")) {
			$this->smartyVars["msg"] = $msg;
		} else {
			$this->smartyVars["msg"] = NULL;
		}

		// force usage of the user login template since we are not logged in yet
		$CONF["theme"]["type"] = "client";
		
		// We allow for action redirects here, so if someone's session expired, they can at least
		// get to the same page immediately.
		if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"]) {
			$smartyVars = array(
				"redirectActionID" => $_REQUEST["redirectActionID"],
				"redirectActionFile" => $_REQUEST["redirectActionFile"],
				"redirectActionArgs" => $_REQUEST["redirectActionArgs"],
			);
		}
		$smartyVars["htmlTitle"] = "ModernBill Billing Software .:. ".TRANS_CLIENT_LOGIN;
		$this->hasExecutedSuccessfully = ((int) $this->addTemplate("login/ShowLogin", $smartyVars));
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowLogin
?>
