<?php
// $Id: CancelPackageResponse.php 10541 2007-01-21 20:57:42Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class CancelPackageResponse extends MB_Action {
	/**
	 * The constructor for a CancelPackageResponse action object.
	 */
	function CancelPackageResponse() {
		parent::MB_Action();
		$this->stringRep = "CancelPackageResponse";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the CancelPackageResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->smartyVars = array();
		
		$this->smartyVars["package"] = grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
					)
				)
			)
		);

		dbg("got package, going in");

		if (!(int)$this->smartyVars["package"]["packageID"] || $this->smartyVars["package"]["packageCancellationType"]==getAPITypeID("cancellation", "admin_delete") || $this->smartyVars["package"]["packageCancellationType"]==getAPITypeID("cancellation", "admin_suspend")){
			$this->addError(TRANS_ACTIONERROR, "Invalid Package ID Provided.");
			$this->hasExecutedSuccessfully = 0;
		} else {

			dbg("got past error checking");

			if ($this->smartyVars["package"]["packagePendingCancellation"]==0 && $_REQUEST["desiredAction"]=="cancel"){

				dbg("got into cancellation area");

				$query =& new MBQuery("SetPackages", "update", array("packageID"=>$this->smartyVars["package"]["packageID"], "packagePendingCancellation"=>1));
				dbg(dispatchMBAPI($query->getXMLQuery()));
				$this->hasExecutedSuccessfully = 1;


			} elseif ($this->smartyVars["package"]["packagePendingCancellation"]==1 && $_REQUEST["desiredAction"]=="uncancel"){
			
				$query =& new MBQuery("SetPackages", "update", array("packageID"=>$this->smartyVars["package"]["packageID"], "packagePendingCancellation"=>0));
				dispatchMBAPI($query->getXMLQuery());
				$this->hasExecutedSuccessfully = 1;
			
			} else {
				$this->hasExecutedSuccessfully = 1;
			}

			if ($this->hasExecutedSuccessfully == 1){
				redirect("packages.php?sid=".$_REQUEST["sid"]."&action=".getActionID("ShowPackages"));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CancelPackageResponse
?>
