<?php
// $Id: DowngradePackageResponse.php 12256 2007-11-19 17:42:33Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/packages/UpgradeDowngradeAction.php");

/**
 * This upgrades a package based on request variables submitted from the previous page.
 *
 * @author  Kris Bailey
 */
class DowngradePackageResponse extends UpgradeDowngradeAction {
	/**
	 * The constructor for a DowngradePackageResponse action object. 
	 */
	function DowngradePackageResponse() {
		parent::UpgradeDowngradeAction();
		global $CONF;
		loadConfigs("product", "managementrules");
		$this->stringRep = "DowngradePackageResponse";
		$this->constants = array(
			"TRANS_PRORATED_X_FEE" => TRANS_PRORATED_DOWNGRADE_FEE,
			"TRANS_ITEMIZED_X_CREDITS" => TRANS_ITEMIZED_DOWNGRADE_CREDITS,
			"TRANS_PACKAGE_X" => TRANS_PACKAGE_DOWNGRADE,
			"TRANS_PACKAGE_X_DESC" => TRANS_PACKAGE_DOWNGRADE_DESC,
			"TRANS_PACKAGE_ADDON_X" => TRANS_PACKAGE_ADDON_DOWNGRADE,
			"TRANS_PACKAGE_ADDON_X_DESC" => TRANS_PACKAGE_ADDON_DOWNGRADE_DESC,
			"TRANS_X_FEE" => TRANS_DOWNGRADE_FEE,
		);
		$this->subCommand = "panelDowngrade";
		$this->params = array("packageID");
		
		$clientID = $CONF["user"]["id"];
		
		$rules =& $CONF["product"]["managementrules"];
		$_REQUEST["packageDowngradeDowngradeType"] = ((int)$rules["whenDowngrade"]==0) ? ((int)$rules["applyDowngradeCredits"]==1 ? 0 : 1 ) : 2;
		$_REQUEST["packageProvision"] = (int)$rules["provisionDowngrades"];
		$_REQUEST["generateInvoice"] = (int)$rules["generateDowngradeInvoice"];
		$_REQUEST["packageComments"] = "";
		
		$_REQUEST["packagePrices"] = array(
			"original" => 0,
			"general" => 0,
			"fee" => 0,
			"coupon" => 0,
			"couponcycles" => 0,
		);
		
		$this->packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"clientID" => $clientID,
					"packageID" => (int)$_REQUEST["packageID"],
					"getPackageAttributeData" => 1,
					"getPackageDatabaseData" => 1,
					"getDomainData" => 1,
					"getCertData" => 1,
					"getPackageAddonData" => 1,
				),
			),
		)));

		$this->packageInfoCache[(int)$_REQUEST["packageID"]] =& $this->packageInfo;
		$packageInfo =& $this->packageInfo;
		
		if (!$packageInfo["packageID"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid packageID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		}
		
		//$packageInfo = oneByID(":packages", (int)$_REQUEST["packageID"]);
		$paymentGroup = oneByID(":paymentGroups", (int)$packageInfo["paymentGroupID"]);
		$productInfo = oneOf("products", array(
			"productID" => (int)$_REQUEST["productID"],
			"productActive" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getCycleData" => 1,
		));
		$prices = array();
		if (!$productInfo["productID"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid productID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		} else {
			foreach ($productInfo["productVariantPrices"] as $p){
				if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$paymentGroup["paymentGroupCurrencyID"] && $p["productVariantID"]==(int)$_REQUEST["productVariantID"]){
					$prices[$p["productVariantPriceType"]] = $p;
				}
			}
			$_REQUEST["packagePrices"] = array(
				"original" => (float)$prices[0]["productVariantPriceAmount"],
				"general" => (float)$prices[0]["productVariantPriceAmount"],
				"fee" => (float)$prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"],
			);
	
			$addonsInfo = arrayFor("products", array(
				"parentProductID" => $productInfo["productID"],
				"productActive" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getCycleData" => 1,
			));
			
			foreach ($addonsInfo as $addon){
				$prices = array();
				foreach ($addon["productVariantPrices"] as $p){
					if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$paymentGroup["paymentGroupCurrencyID"]){
						$prices[$p["productVariantPriceType"]] = $p;
					}
				}
				$_REQUEST["prices"][$addon["productID"]] = array(
					"general" => (float)$prices[0]["productVariantPriceAmount"],
					"original" => (float)$prices[0]["productVariantPriceAmount"],
					"fee" => (float)$prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"],
					"coupon" => 0,
					"couponcycles" => 0,
				);
			}
		}
	}
}
