<?php
// $Id: EditPackageAddons.php 10541 2007-01-21 20:57:42Z mfountain $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

exit;

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all packages that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class EditPackageAddons extends MB_Action {
	/**
	 * The constructor for a EditPackageAddons action object.
	 */
	function EditPackageAddons() {
		parent::MB_Action();
		$this->stringRep = "EditPackageAddons";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the EditPackageAddons action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->smartyVars = array();
		
		$this->smartyVars["package"] = correctArray(grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
					)
				)
			)
		));
		
		$this->smartyVars["selectedAddons"] = correctArray(grabResultsFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackageAddons",
					"params" => array(
						"packageID" => (int)$_REQUEST["packageID"],
						"getProductInfo" => 1,
						"getPackageAddonAttributes" => 1, 
					)
				)
			)
		));


		$this->smartyVars["packageStatuses"] = getStatuses("package");
		$this->smartyVars["cycles"] = getCyclesArray();

		if (!(int)$this->smartyVars["package"]["packageID"]){
			$this->addError(TRANS_ACTIONERROR, "Invalid Package ID Provided.");
			$this->hasExecutedSuccessfully = 0;
		} else {

			if ($this->smartyVars["package"]["packageDateNextRenewal"]<time()){
				$this->smartyVars["immediately"] = 1;
			} else {
				$this->smartyVars["immediately"] = 0;
			}


			$this->addTemplate("packages/EditPackageAddons", $this->smartyVars);

			$this->hasExecutedSuccessfully = 1;

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CancelPackage
?>
