<?php
// $Id: PerformPanelAction.php 12813 2008-03-27 10:03:40Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 */
class PerformPanelAction extends MB_Action {
	/**
	 */
	function PerformPanelAction() {
		parent::MB_Action();
		$this->stringRep = "PerformPanelAction";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;

		$packages = collapsePluralsAndSingulars(grabResultsFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
						"getDomainData" => 1,
						"getPackageAttributeData" => 1,
						"getPackageAddonData" => 1,
						"suppressFeePackages" => $suppressFeePackages,
					)
				)
			)
		));
		$package =& $packages[0];
		
		$serverGroups = array();
		
		$keyedAttributes = array();
		$serverGroups = array();
		foreach ((array)$package["packageAttributes"] as $attribute){
			$serverGroups[$attribute["serverGroupID"]] = $attribute["configGroupID"];
			$keyedAttributes[$attribute["serverGroupID"]][$attribute["packageAttributeName"]] = $attribute;
		}
		
		foreach ((array)$serverGroups as $serverGroupID=>$configGroupID){
			if ($_REQUEST["serverGroupID"]==$serverGroupID){
				$d =& new DataSource("serverGroups", array("serverGroupID" => $serverGroupID, "getPanels" => 1));
				$s =& $d->getSubject();
				$data = $s->getStructureFrom(array("panels", "panel", "configGroupTransKey"));
				if($data) {
					$panel = current($data);
				} else {
					return false;
				}
				
				$panelFile = strtolower($panel);
				if ($panel && file_exists(mb_path("/lib-mbapi/include/modules/panel/$panelFile.php"))){
					require_once mb_path("/lib-mbapi/include/modules/panel/$panelFile.php");
					$params = array("subCommand" => "panelDummy", "configGroupID" => $configGroupID);
					$panelObj =& new $panel($params);
					$actionResults = $panelObj->handlePerformPanelActions($package["packageID"], $serverGroupID, $configGroupID, $_REQUEST);
				}
				$this->smartyVars["serverGroupID"] = $serverGroupID;
				$this->smartyVars["configGroupID"] = $configGroupID;
				break;
			}
		}
		
		$this->smartyVars["packageInfo"] = $package;
		$this->smartyVars["actionTemplate"] = $actionResults[0];
		$this->smartyVars["actionTemplateData"] = $actionResults[1];
		
		$this->addTemplate("packages/PerformPanelAction", $this->smartyVars);
			
		$this->hasExecutedSuccessfully = 1;

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}