<?php
// $Id: ShowClientServiceInputForm.php 12386 2007-12-21 23:43:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This Action object collects information on all packages that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowClientServiceInputForm extends MB_Action {
	/**
	 */
	function ShowClientServiceInputForm() {
		parent::MB_Action();
		$this->stringRep = "ShowClientServiceInputForm";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;

		$this->smartyVars["packageInfo"] = $packageInfo = oneByID(":packages", $_REQUEST["packageID"], array(
			"clientID" => $clientID = $CONF["user"]["id"],
		));

		if (!(int)$packageInfo["packageID"]){
			$this->addError(TRANS_ACTIONERROR, "Invalid packageID provided");
		} else {
			
			$this->smartyVars["formData"] = $this->getClientInputDataForService($packageInfo["packageID"], $_REQUEST["serverGroupID"], $_REQUEST["configGroupID"], "template");
			
			$attributes = arrayFor(":packageAttributes", array(
				"packageID" => $packageInfo["packageID"],
				"serverGroupID" => array($_REQUEST["serverGroupID"], 0),
			));
			$this->smartyVars["existingAttributes"] = array();
			foreach ((array)$attributes as $attr){
				$this->smartyVars["existingAttributes"][$attr["packageAttributeName"]] = $attr;
			}

			$this->addTemplate("packages/ShowClientServiceInputForm", $this->smartyVars);
			
			$this->hasExecutedSuccessfully = 1;
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}