<?php
// $Id: ShowClientServiceInputFormResponse.php 12386 2007-12-21 23:43:39Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This Action object collects information on all packages that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowClientServiceInputFormResponse extends MB_Action {
	/**
	 */
	function ShowClientServiceInputFormResponse() {
		parent::MB_Action();
		$this->stringRep = "ShowClientServiceInputFormResponse";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;

		$this->smartyVars["packageInfo"] = $packageInfo = oneByID(":packages", $_REQUEST["packageID"], array(
			"clientID" => $clientID = $CONF["user"]["id"],
		));

		if (!(int)$packageInfo["packageID"]){
			$this->addError(TRANS_ACTIONERROR, "Invalid packageID provided");
		} else {
			
			$safeAttributes = $this->getClientInputDataForService($packageInfo["packageID"], $_REQUEST["serverGroupID"], $_REQUEST["configGroupID"], "attributes");
			
			$attributes = arrayFor(":packageAttributes", array(
				"packageID" => $packageInfo["packageID"],
				"serverGroupID" => array($_REQUEST["serverGroupID"], 0),
			));
			
			foreach ((array)$attributes as $attr){
				if (in_array($attr["packageAttributeName"], $safeAttributes["attributes"]) && isset($_REQUEST["serviceAttributes"][$attr["packageAttributeName"]])){
					updateForKey(":packageAttributes", $attr["packageAttributeID"], array(
						"packageAttributeValue" => $_REQUEST["serviceAttributes"][$attr["packageAttributeName"]],
					));
				}
			}
			
			$systemQueueItem = oneOf(":systemQueue", array(
				"packageID" => $packageInfo["packageID"],
				"serverGroupID" => $_REQUEST["serverGroupID"],
			));
			
			if ($systemQueueItem["systemQueueID"] && $systemQueueItem["systemQueueStatus"]==getAPIStatusID("queue", "new")){
				updateForKey(":systemQueue", $systemQueueItem["systemQueueID"], array(
					"systemQueueStatus" => getAPIStatusID("queue", "force"),
				));
				$result = dispatchMBAPI(array(
					"mbapi" => array(
						"command" => "ProcessSystemQueue",
						"params" => array(
							"runMax" => 1,
							"systemQueueID" => $systemQueueItem["systemQueueID"],
						),
					),
				), 1);
				dbg($result);
			}
			
			redirect("dashboard.php", "ShowClientDashboard");
			
			$this->hasExecutedSuccessfully = 1;
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}