<?php
// $Id: ShowPackageDetails.php 12879 2008-04-22 17:43:41Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 */
class ShowPackageDetails extends MB_Action {
	/**
	 */
	function ShowPackageDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowPackageDetails";
		$this->params = array("packageID");
	}

	/**
	 */
	function execute() {
		global $CONF;

		dbg($CONF["user"]);

		$rawPackages = collapsePluralsAndSingulars(grabResultsFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"getDomainData" => 1,
						"getPackageAttributeData" => 1,
						"getPackageAddonData" => 1,
						"suppressFeePackages" => $suppressFeePackages,
						"packageID" => (int)$_REQUEST["packageID"],
					),
				)
			)
		));
		
		loadConfigs("product", "managementrules");
		
		$serverGroups = array();
		
		foreach ((array)$rawPackages as $x=>$p){
			$keyedAttributes = array();
			$serverGroups = array();
			foreach ((array)$p["packageAttributes"] as $attribute){
				$serverGroups[$attribute["serverGroupID"]] = $attribute["configGroupID"];
				$keyedAttributes[$attribute["serverGroupID"]][$attribute["packageAttributeName"]] = $attribute;
			}
			
			foreach ((array)$serverGroups as $serverGroupID=>$configGroupID){
				if ($xx = $this->getPanelCustomActionData($p["packageID"], $serverGroupID, $configGroupID)){
					$serverGroups[$serverGroupID] = $xx;
				} else {
					unset($serverGroups[$serverGroupID]);
				}
			}
			$rawPackages[$x]["panelTemplates"] = $serverGroups;
			$rawPackages[$x]["keyedAttributes"] = $keyedAttributes;
		}
		
		$this->smartyVars = array();
		$this->smartyVars["managementrules"] = $CONF["product"]["managementrules"];
		$this->smartyVars["numPackages"] = count((array)$rawPackages);
		$this->smartyVars["statusPackages"] = array();

		$this->smartyVars["upgradeDowngradeStatuses"] = array(
			getAPIStatusID("package", "none") => 1,
			getAPIStatusID("package", "pending") => 1,
		);

		foreach ((array)$rawPackages as $k => $package){
		
		
			if ($package["packageDateStopRenewal"]>(25*60*60)){
				$numCycles = 0;
				$nextRenewal = $package["packageDateNextRenewal"];
				while ($nextRenewal<$package["packageDateStopRenewal"]){
					$numCycles++;
					$nextRenewal = getNextBillingTimestamp($nextRenewal, $package["cycleID"]);
				}
				$rawPackages[$k]["moreCycles"] = $numCycles;
				$rawPackages[$k]["stopDate"] = $nextRenewal;
			} else {
				$rawPackages[$k]["stopDate"] = 0;
				$rawPackages[$k]["moreCycles"] = 0;
			}
		
			//Pull all of the server group IDs out
			$panels = array();
			$attributes = $package["packageAttributes"];
			if(is_array($attributes)) {
				foreach($attributes as $attribute) {
					if($attribute["packageAttributeName"] == "panel_status") {
						$panels[] = $attribute["configGroupID"];
					}
				}
			}

			foreach($panels as $panel) {

				$tmp = collapsePluralsAndSingulars(grabResultsFromMBAPIArray(
					array(
						"mbapi" => array(
							"command" => "GetPackageUsageLog",
							"params" => array(
								"packageID" => $package["packageID"],
								"configGroupID" => $panel,
								"usageLogDateBilled" => -1,
								"getTotals" => 1,
				
							)
						)
					)
				));
				$packageUsage[$package["packageID"]] = $tmp[0];
				unset($tmp);
			}

			$rawPackages[$k]["rules"] = array(
				"addons" => $CONF["product"]["managementrules"]["allowClientAddonManagement"],
				"upgrade" => $CONF["product"]["managementrules"]["allowClientUpgrade"],
				"downgrade" => $CONF["product"]["managementrules"]["allowClientDowngrade"],
			);


			switch ($rawPackages[$k]["packageClientPermissions"]){
				case getAPITypeID("packagemanagement", "upgradedowngradeaddon"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 1,
						"upgrade" => 1,
						"downgrade" => 1,
					);
				break;
				case getAPITypeID("packagemanagement", "upgradedowngrade"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 0,
						"upgrade" => 1,
						"downgrade" => 1,
					);
				break;
				case getAPITypeID("packagemanagement", "upgrade"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 0,
						"upgrade" => 1,
						"downgrade" => 0,
					);
				break;
				case getAPITypeID("packagemanagement", "downgrade"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 0,
						"upgrade" => 0,
						"downgrade" => 1,
					);
				break;
				case getAPITypeID("packagemanagement", "downgradeaddon"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 1,
						"upgrade" => 0,
						"downgrade" => 1,
					);
				break;
				case getAPITypeID("packagemanagement", "upgradeaddon"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 1,
						"upgrade" => 1,
						"downgrade" => 0,
					);
				break;
				case getAPITypeID("packagemanagement", "addon"):
					$rawPackages[$k]["rules"] = array(
						"addons" => 1,
						"upgrade" => 0,
						"downgrade" => 0,
					);
				break;
			}
		
			switch ($rawPackages[$k]["packageStatus"]){
				case getAPIStatusID("package", "none"):
				case getAPIStatusID("package", "pending"):
				case getAPIStatusID("package", "pending_renewal"):
					$rawPackages[$k]["mayCancel"] = 1;
				break;
				default:
					$rawPackages[$k]["mayCancel"] = 0;
				break;
			}
			
			switch ($rawPackages[$k]["packageCancellationType"]){
				case getAPITypeID("cancellation", "both_suspend"):
				case getAPITypeID("cancellation", "both_delete"):
					$rawPackages[$k]["clientCancel"] = 1;
				break;
				default:
					$rawPackages[$k]["clientCancel"] = 0;
				break;
			}
			
			switch( (int)$package["packageType"] ) {
				case getAPITypeID("products", "cert"):
				
					$lineItem = oneOf("lineItems", array(
							"packageID" => (int)$package["packageID"],
							"packageAddonID" => 0,
							
							"lineItemIsUsage" => false,

							"sortColumn" => "lineItemID",
							"sortDir" => "asc",
							"recordOffset" => 0,
							"numRecords" => 1));

					dbg("Returned Line Item for Cert Package $package[packageID]");
					dbg($lineItem);

					if ( (int)$lineItem["invoiceID"] ) {
						$invoice = oneByID("invoices", $lineItem["invoiceID"]);
						
						dbg("Invoice line item is connected to");
						dbg($invoice);
						
						$amountDue = round($invoice["invoiceAmount"], 2);
						$amountPaid = round($invoice["invoiceAmountPaid"], 2);
												
						if ($amountDue == $amountPaid && $amountDue > 0) {
							$rawPackages[ $k ]["invoicePaid"] = true;
						} else {
							$rawPackages[ $k ]["invoicePaid"] = false;
						}
						
						unset( $invoice, $amountDue, $amountPaid );
					} else {
						$rawPackages[ $k ]["invoicePaid"] = false;
					}
					unset( $lineItem );
				break;
			}

			if ((int)$package["parentPackageID"]){
				$this->smartyVars["childPackages"][$package["parentPackageID"]][] =& $rawPackages[$k];
			} else {
				$this->smartyVars["statusPackages"][$package["packageStatus"]]["packages"][] =& $rawPackages[$k];
			}
			$this->smartyVars["packageUsage"][$package["packageID"]] =& $packageUsage[$package["packageID"]];
		}

		$this->smartyVars["cancelledStatusID"] = getAPIStatusID("package", "canceled");

		$this->smartyVars["packageStatuses"] = getStatuses("package");
		$this->smartyVars["cycles"] = getCyclesArray();

		ksort($this->smartyVars["statusPackages"]);
		dbg($this->smartyVars);
		
		$this->addTemplate("packages/ShowPackageDetails", $this->smartyVars);
			
		$this->hasExecutedSuccessfully = 1;

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}