<?php
// $Id: ShowPackages.php 12880 2008-04-22 17:44:25Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all packages that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowPackages extends MB_Action {
	/**
	 * The constructor for a ShowPackages action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowPackages() {
		parent::MB_Action();
		$this->stringRep = "ShowPackages";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowPackages action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$query = $this->getMBAPIQuery("GetPackages", "", array(
			"suppressFeePackages" => 1,
			"clientID" => $CONF["user"]["id"],
		), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

		dbg($results);

		// redirect to a single client record if only one record is returned
		if(is_array($results) && $data["mbapi"][0]["header"][0]["numResults"][0] == 1){
			redirect("packages.php","ShowPackageDetails", array("packageID" => $results["packages"][0]["package"][0]["packageID"][0]));
		}

		if($this->addMBAPIErrors($data) === 0) {

			// set the sorting args for display
			$this->smartyVars["displaySortColumnName"] = $data["mbapi"][0]["header"][0]["sortColumnName"][0];
			$this->smartyVars["displaySortColumn"] = $data["mbapi"][0]["header"][0]["sortColumn"][0];
			$this->smartyVars["displaySortDir"] = $data["mbapi"][0]["header"][0]["sortDir"][0];

			$this->smartyVars["packages"] = $results["packages"][0]["package"];
			$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["packages"] = array(0 => $results["packages"][0]["package"]);
			}

			$this->smartyVars = correctArray($this->smartyVars);
			$this->mergePrimaryContactData();
			$this->addTemplate("packages/ShowPackages");
			
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}