<?php
// $Id: AddBillingAccountResponse.php 10866 2007-03-13 18:36:46Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class AddBillingAccountResponse extends AddResponseAction {
	function AddBillingAccountResponse() {
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		
		$_REQUEST["clientContactID"] = $clientContactID;

		loadConfigs("payment");
		if ($CONF["payment"]["clientSidePaymentOptions"][ getAPITypeName( "billingAccount", (int)$_REQUEST["billingAccountType"] ) ] != 1) {
			$this->addError(MBAPI_ACTIONERROR, "That Billing Account Type is not Allowed");
			$this->addErrorTemplates();
			exit;
		}
		
		$this->d =& new DataSource("billingAccounts", array("billingAccountStatus" => getAPIStatusID("billingAccount", "active")));
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		parent::AddResponseAction();

		$billingAccountType = (int) $_REQUEST["billingAccountType"];
		if($billingAccountType == getAPITypeID("billingAccount", "manual") || $billingAccountType == getAPITypeID("billingAccount", "secondary")) {
			unset($description["columns"]['billingBankType']);
			unset($description["columns"]['billingBankName']);
			unset($description["columns"]['billingBankState']);
			unset($description["columns"]['billingBankABACode']);
			unset($description["columns"]['billingBankAccountNum']);
			unset($description["columns"]['billingBankLicenseNum']);
			unset($description["columns"]['billingBankLicenseState']);
			unset($description["columns"]['billingBankDob']);

			unset($description["columns"]['billingCardNameOnCard']);
			unset($description["columns"]['billingCardType']);
			unset($description["columns"]['billingCardNum']);
			unset($description["columns"]['billingCardExpMonth']);
			unset($description["columns"]['billingCardExpYear']);
			unset($description["columns"]['billingCardIssueNum']);
			unset($description["columns"]['billingCardStartDate']);
		} else if($billingAccountType == getAPITypeID("billingAccount", "card")) {
			unset($description["columns"]['billingBankType']);
			unset($description["columns"]['billingBankName']);
			unset($description["columns"]['billingBankState']);
			unset($description["columns"]['billingBankABACode']);
			unset($description["columns"]['billingBankAccountNum']);
			unset($description["columns"]['billingBankLicenseNum']);
			unset($description["columns"]['billingBankLicenseState']);
			unset($description["columns"]['billingBankDob']);
			
			$billingCardType = (int) $_REQUEST["billingCardType"];
			$cardExtraTypes = getAPITypes("cardExtraIDs");
			if(!in_array($billingCardType, $cardExtraTypes)) {
				unset($description["columns"]['billingCardIssueNum']);
				unset($description["columns"]['billingCardStartDate']);
			}
		} else {
			unset($description["columns"]['billingCardNameOnCard']);
			unset($description["columns"]['billingCardType']);
			unset($description["columns"]['billingCardNum']);
			unset($description["columns"]['billingCardExpMonth']);
			unset($description["columns"]['billingCardExpYear']);
			unset($description["columns"]['billingCardIssueNum']);
			unset($description["columns"]['billingCardStartDate']);
		}

		$this->d->setDescription($description);
	}
	
	function addResponseHandler() {
		$billingAccountID = $this->lastInsertID;
		foreach((array) $_REQUEST["packages"] as $packageID) {
			$q =& new MBQuery(
				"SetBillingAccountShare", "insert",
				array(
					"billingAccountID" => $billingAccountID,
					"billingAccountShareGroup" => "0",
					"billingAccountFallbackGroup" => "1",
					"billingAccountShareValue" => "1",
					"packageID" => (int) $packageID,
				)
			);
			$r =& $q->getResult();
			if(!$r->getSuccess()) {
				$this->addErrorsFromResult($r);
				return false;
			}
		}
		return true;
	}

	function overrideValidateColumnParamType($column, $columnType, $mode, $paramType, $isRequired) {
		switch($column) {
			case "billingCardNum":
				$paramType |= INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN|INPUT_RESTRICTION_CARD;
				$args = array(
					'maxLength' => 19,
					'minLength' => 13,
					'allowedCardTypes' => getAPITypeName("card", $_REQUEST['billingCardType']),
				);
				break;
			case "billingBankAccountNum":
				if(empty($_REQUEST["billingBankAccountNum"])) {
					$columnType = 0;
					break;
				}
				break;
			default:
				$args = array();
				break;
		}
		
		return array($paramType, $isRequired, $args);
	}
}

?>
