<?php
// $Id: AddClientContact.php 8129 2006-07-24 19:25:06Z bsmith $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It displays a form to add a new
 * client contact record.
 *
 * @author  Michael Fountain
 */
class AddClientContact extends MB_Action {
	/**
	 * The constructor for a AddClientContact action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddClientContact() {
		parent::MB_Action();
		$this->stringRep = "AddClientContact";
		$this->params = array("clientID");
	}

	/**
	 * The main method of this class that executes the AddClientContact action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		$clientContactID = getParam("clientContactID");

		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetClients", "", array());
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$this->mergeCountryData();
				$this->mergeLanguageData();
				$this->smartyVars["client"] = correctArray($results["clients"][0]["client"][0]);
				
				require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
				$this->smartyVars["emailActions"] = $CONF["types"]["emailAction"];
				
				$formDefaults = array('clientID' => $clientID, "countriesID" => $this->smartyVars["client"]["countriesID"]);
				$this->smartyVars["clientContactID"] = $clientContactID;
				$this->mergeFormState($formDefaults);

				$this->addTemplate("profile/AddClientContact");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
