<?php
// $Id: EditBillingAccount.php 12881 2008-04-22 17:47:57Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class EditBillingAccount extends EditAction {
	function EditBillingAccount() {
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		$clientID = (int)$CONF["user"]["id"];
		
		$contacts = arrayFor(":contacts", array(
			"clientID" => $clientID,
		));
		
		$keyedContacts = array();
		foreach ($contacts as $x=>$c){
			$keyedContacts[$c["clientContactID"]] =& $contacts[$x];
		}
		
		// if we are the primary contact and we can edit the billing accounts of
		// any contact for this client, else just edit our own
		if ((int)$keyedContacts[$clientContactID]["contactPrimary"] && is_array($keyedContacts[(int)$_REQUEST["clientContactID"]])){
			$clientContactID = (int)$_REQUEST["clientContactID"];
		}
		$_REQUEST["clientContactID"] = $clientContactID;
		
		$this->d =& new DataSource("billingAccounts", array("clientContactID" => $clientContactID));
		$this->d->setSaltCallback("billingAccountSalter");
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		$description["display"]["editTemplate"] = "profile/EditBillingAccount";
		$this->d->setDescription($description);
		parent::EditAction();
	}
	
	function editParamHandler() {
		global $CONF;
		$clientID = $CONF["user"]["id"];
		$clientContactID = $CONF["user"]["clientContactID"];
		$billingAccountID = (int) $_REQUEST["billingAccountID"];

		loadConfigs("payment");

		$this->smartyVars["billingAccountTypes"] = getTypes("billingAccount");
		// remove account types that the admin wants to restrict from the client.
		foreach( (array)$this->smartyVars["billingAccountTypes"] as $k => $v ) {
			if ($CONF["payment"]["clientSidePaymentOptions"][ getAPITypeName( "billingAccount", $k ) ] != 1) {
				unset( $this->smartyVars["billingAccountTypes"][ $k ] );
			}
		}	unset( $k, $v );
		
		$this->smartyVars["bankAccountTypes"] = getTypes("bankAccount");
		$this->smartyVars["cardTypes"] = getTypes("card");
		$this->smartyVars["cardExtraTypes"] = getTypes("cardExtraIDs");

		$this->smartyVars["selectedPackages"] = array();
		$shares = arrayFor(":clientBillingAccountShares", array(
			"billingAccountID" => $billingAccountID,
			"package" => array(
				"column" => array(
					"packageID",
					"packageName",
				),
			),
		));
		
		$ptypes = $CONF["types"]["products"];
		unset($ptypes[getAPITypeID("products", "fee")]);
		
		$packages = arrayFor(":packages", array(
			"clientID" => $clientID,
			"packageType" => array_keys($ptypes),
			"column" => array(
				"packageID", "packageName"
			),
		));
		
		foreach ($shares as $share){
			$this->smartyVars["selectedPackages"][$share["packageID"]] = "(ID: ".$share["packageID"].") ".$share["package"][0]["packageName"];
		}


		$this->smartyVars["selectablePackages"] = array();
		foreach ($packages as $p){
			if (!isset($this->smartyVars["selectedPackages"][$p["packageID"]])){
				$this->smartyVars["selectablePackages"][$p["packageID"]] = "(ID: ".$p["packageID"].") ".$p["packageName"];
			}
		}

		$d =& new DataSource(
			"gwTransactions",
			array(
				"billingAccountID" => $billingAccountID,
				"gwTransactionType" => "reject",
				"groupBy" => array(
					"column" => "configGroupID",
				),
				"column" => "configGroupID",
			)
		);
		$t =& $d->getTable();
		$gatewayIDs = $t->getColumnDistinct("configGroupID");
		
		$rejects = array();
		foreach($gatewayIDs as $gatewayID) {
			$reject = oneOf(
				"gwTransactions",
				array(
					"billingAccountID" => $billingAccountID,
					"gwTransactionType" => "reject",
					"configGroupID" => $gatewayID,
					"gwTransactionAttrs" => array(),
					"sortColumn" => "gwTransactionID",
					"sortDir" => "DESC",
					"numRecords" => 1,
				)
			);
			$t =& new Table($reject["gwTransactionAttrs"], "gwTransactionAttrName", "gwTransactionAttrValue");
			$reject["attrs"] = $t->getOptions();
			$rejects[] = $reject;
		}
		$this->smartyVars["rejects"] = $rejects;
		
		return true;
	}
}