<?php
// $Id: EditBillingAccountResponse.php 12881 2008-04-22 17:47:57Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class EditBillingAccountResponse extends EditResponseAction {
	function EditBillingAccountResponse() {
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		$clientID = (int)$CONF["user"]["id"];
		
		$contacts = arrayFor(":contacts", array(
			"clientID" => $clientID,
		));
		
		$keyedContacts = array();
		foreach ($contacts as $x=>$c){
			$keyedContacts[$c["clientContactID"]] =& $contacts[$x];
		}
		
		// if we are the primary contact and we can edit the billing accounts of
		// any contact for this client, else just edit our own
		if ((int)$keyedContacts[$clientContactID]["contactPrimary"] && is_array($keyedContacts[(int)$_REQUEST["clientContactID"]])){
			$clientContactID = (int)$_REQUEST["clientContactID"];
		}
		$_REQUEST["clientContactID"] = $clientContactID;
		
		if(!$currentBillingAccount = oneOf("billingAccounts", array("clientContactID" => $clientContactID, "billingAccountID" => (int) $_REQUEST["billingAccountID"]))) {
			$this->addError(MBAPI_ACTIONERROR, "No valid match.");
			return false;
		}

		loadConfigs("payment");
		if ($CONF["payment"]["clientSidePaymentOptions"][ getAPITypeName( "billingAccount", (int)$_REQUEST["billingAccountType"] ) ] != 1) {
			$this->addError(MBAPI_ACTIONERROR, "That Billing Account Type is not Allowed");
			$this->addErrorTemplates();
			exit;
			
		}
		
		$this->d =& new DataSource("billingAccounts");
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		parent::EditResponseAction();
		unset($description['columns']['clientContactID']);

		$billingAccountType = (int) $currentBillingAccount["billingAccountType"];
		if($billingAccountType == getAPITypeID("billingAccount", "manual") || $billingAccountType == getAPITypeID("billingAccount", "secondary")) {
			unset($description["columns"]['billingBankType']);
			unset($description["columns"]['billingBankName']);
			unset($description["columns"]['billingBankState']);
			unset($description["columns"]['billingBankABACode']);
			unset($description["columns"]['billingBankAccountNum']);
			unset($description["columns"]['billingBankLicenseNum']);
			unset($description["columns"]['billingBankLicenseState']);
			unset($description["columns"]['billingBankDob']);

			unset($description["columns"]['billingCardNameOnCard']);
			unset($description["columns"]['billingCardType']);
			unset($description["columns"]['billingCardNum']);
			unset($description["columns"]['billingCardExpMonth']);
			unset($description["columns"]['billingCardExpYear']);
			unset($description["columns"]['billingCardIssueNum']);
			unset($description["columns"]['billingCardStartDate']);
		} else if($billingAccountType == getAPITypeID("billingAccount", "card")) {
			unset($description["columns"]['billingBankType']);
			unset($description["columns"]['billingBankName']);
			unset($description["columns"]['billingBankState']);
			unset($description["columns"]['billingBankABACode']);
			unset($description["columns"]['billingBankAccountNum']);
			unset($description["columns"]['billingBankLicenseNum']);
			unset($description["columns"]['billingBankLicenseState']);
			unset($description["columns"]['billingBankDob']);
			
			$billingCardType = (int) $_REQUEST["billingCardType"];
			$cardExtraTypes = getAPITypes("cardExtraIDs");
			if(!in_array($billingCardType, $cardExtraTypes)) {
				unset($description["columns"]['billingCardIssueNum']);
				unset($description["columns"]['billingCardStartDate']);
			}
			if (!$_REQUEST["billingCardNum"] || $_REQUEST["billingCardNum"]==""){
				unset($description["columns"]['billingCardNum']);
			}
		} else {
			unset($description["columns"]['billingCardNameOnCard']);
			unset($description["columns"]['billingCardType']);
			unset($description["columns"]['billingCardNum']);
			unset($description["columns"]['billingCardExpMonth']);
			unset($description["columns"]['billingCardExpYear']);
			unset($description["columns"]['billingCardIssueNum']);
			unset($description["columns"]['billingCardStartDate']);
		}

		$this->d->setDescription($description);
	}
	
	function editResponseHandler() {
		// valid match assumed due to earlier check
		$billingAccountID = (int) $_REQUEST["billingAccountID"];
		
		$shares = arrayFor(":clientBillingAccountShares", array(
			"billingAccountID" => $billingAccountID,
		));
		
		$packageIDs = array();
		foreach ((array)$_REQUEST["packages"] as $pid){
			$packageIDs[$pid] = 1;
		}
		
		foreach ((array)$shares as $share){
			if ($packageIDs[$share["packageID"]]){
				updateForKey(":clientBillingAccountShares", $share["billingAccountShareID"], array(
					"billingAccountShareValue" => 1,
				));
				unset($packageIDs[$share["packageID"]]);
			} else {
				updateForKey(":clientBillingAccountShares", $share["billingAccountShareID"], array(
					"billingAccountShareValue" => 0,
				));
			}
		}
		
		$_REQUEST["packages"] = array_keys($packageIDs);
		
		foreach((array) $_REQUEST["packages"] as $packageID) {
			insertFor(":clientBillingAccountShares", array(
				"billingAccountID" => $billingAccountID,
				"billingAccountShareGroup" => "0",
				"billingAccountFallbackGroup" => "1",
				"billingAccountShareValue" => "1",
				"packageID" => (int) $packageID,
			));
		}
		return true;
	}

	function overrideValidateColumnParamType($column, $columnType, $mode, $paramType, $isRequired) {
		switch($column) {
			case "billingCardNum":
				if(empty($_REQUEST["billingCardNum"])) {
					$columnType = "";
					break;
				}
				$paramType |= INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN|INPUT_RESTRICTION_CARD;
				$args = array(
					'maxLength' => 19,
					'minLength' => 13,
					'allowedCardTypes' => getAPITypeName("card", $_REQUEST['billingCardType']),
				);
				break;
			case "billingBankAccountNum":
				if(empty($_REQUEST["billingBankAccountNum"])) {
					$columnType = "";
					break;
				}
				break;
			default:
				$args = array();
				break;
		}
		
		return array($paramType, $isRequired, $args);
	}
}