<?php
// $Id: ReauthBillingAccountResponse.php 9347 2006-10-08 02:09:45Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
class ReauthBillingAccountResponse extends GenericAction {
	function ReauthBillingAccountResponse() {
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		if(!oneOf("billingAccounts", array("clientContactID" => $clientContactID, "billingAccountID" => (int) $_REQUEST["billingAccountID"]))) {
			$this->addError(MBAPI_ACTIONERROR, "No valid match.");
			return false;
		}

		$_REQUEST["clientContactID"] = $clientContactID;

		$this->d =& new DataSource("billingAccounts");
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		parent::GenericAction();

		$this->d->setDescription($description);
		$this->d->setMode("update");
	}
	
	function execute() {
		parent::execute();
		
		$transactionRecord = oneOf(
			"gwTransactions",
			array(
				"gwTransactionID" => (int) $_REQUEST["gwTransactionID"],
				"billingAccountID" => (int) $_REQUEST["billingAccountID"],
			)
		);
		$billingAccountID = (int) $_REQUEST["billingAccountID"];
		$gatewayConfigGroup = oneByID("configGroups", $transactionRecord["configGroupID"]);
		$parentConfigGroup = oneByID("configGroups", $gatewayConfigGroup["parentConfigGroupID"]);
		$gateway = $parentConfigGroup["configGroupName"];
		$configGroupName = $gatewayConfigGroup["configGroupName"];
		$paymentAmount = (float) $_REQUEST["authAmount"];
		$cardNum = $_REQUEST["cardNum"];
		$cardCVV2 = $_REQUEST["cardCVV2"];
		do {
			$q =& new MBQuery(
				"ProcessGateway", "",
				array(
					"gateway" => array(
						$gateway => array(
							"subCommand" => "reauth",
							"configGroupName" => $configGroupName,
							"paymentDescription" => "Reauthorization",
							"paymentAmount" => $paymentAmount,
							"cardNum" => $cardNum,
							"cardCVV2" => $cardCVV2,
							"billingAccountID" => $billingAccountID,
						),
					),
				)
			);
			//show($q->getXMLQuery(), 1);
			$r =& $q->getResult();
			if(!$status = $r->getSuccess()) {
				$this->addErrorsFromResult($r);
				break;
			}
			$s =& $r->getSubjectFrom(array("mbapi", "results", "gatewayReturn", 0));
			$results = $s->getCollapsed();
			if(!$resultStatus = ($results["status"] != 3)) {
				$this->addError(TRANS_ACTIONERROR, "Reauthorization transaction failed: " . $results["message"]);
				break;
			}
			
			$authedTransactionRecordIDs = IDsOf(
				"gwTransactions",
				array(
					"gwTransactionType" => "reject",
					"billingAccountID" => (int) $_REQUEST["billingAccountID"],
					"configGroupID" => $transactionRecord["configGroupID"],
				)
			);
			if(!$clearStatus = updateForKey(
				"gwTransactions", $authedTransactionRecordIDs,
				array(
					"gwTransactionType" => "reauthedreject",
				)
			)) {
				$this->addError(TRANS_ACTIONERROR, "Failed to clear authed rejections: " . lastError());
				break;
			}
		
			$this->redirect();
		} while(0);
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
}

?>
