<?php
// $Id: ShowClients.php 6609 2006-05-05 04:24:42Z mgarrett $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all clients that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowClients extends MB_Action {
	/**
	 * The constructor for a ShowClients action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowClients() {
		parent::MB_Action();
		$this->stringRep = "ShowClients";
		$this->params = array(
			"domainID",
			"packageID",
			"invoiceID",
			"certID",
			"creditID",
			"clientContactID",
			"billingID",
			"clientFirstName",
			"clientLastName",
			"clientEmail",
			"clientCompany",
			"clientAddress",
			"clientAddress2",
			"clientCity",
			"clientState",
			"clientZip",
			"countriesID",
			"clientPhone",
			"clientPhone2",
			"billingMethod",
			"billingCCType",
			"clientComments",
			"clientDateCreated",
			"contactUsername",
			"currencyID",
			"languageID",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
		$this->sortColumns = array("");
	}

	/**
	 * The main method of this class that executes the ShowClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = mktime();
		
		$query = $this->getMBAPIQuery("GetClients", "", array("clientID"=>$CONF["user"]["id"]), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["clients"] = $results["clients"][0]["client"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$smartyVars["clients"] = array(0 => $results["clients"][0]["client"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			
			$this->addTemplate("ShowClients", collapseArrayElements($smartyVars));
			
			$this->hasExecutedSuccessfully = 1;
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowClients
?>