<?php
// $Id: ShowSellerStatus.php 10559 2007-01-23 18:02:40Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This Action object takes information provided by the EditClient action, applies that information to
 * records in the database, and redirects to the ShowClientDetails action for the given client.
 *
 * @author  Kris Bailey
 */
class ShowSellerStatus extends MB_Action {
	/**
	 * The constructor for an ShowSellerStatus action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function ShowSellerStatus() {
		parent::MB_Action();
		$this->stringRep = "ShowSellerStatus";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowSellerStatus action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->smartyVars["sellerInfo"] = oneOf("marketplaceSellers", array(
			"clientID" => $CONF["user"]["id"],
		));

		$this->addTemplate("sellers/ShowSellerStatus", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowSellerStatus
?>