<?php
// $Id: FinalizeOrder.php 11423 2007-06-22 20:36:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all orderForms that match the given parameters, and 
 * generates the display of that information.
 *
 * @author Brian Smith
 */
class FinalizeOrder extends MB_Action {
	/**
	 * The constructor for a FinalizeOrder action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function FinalizeOrder() {
		parent::MB_Action();
		$this->stringRep = "FinalizeOrder";
		
		$this->params = array(
			"sid",
			"set_locale",
			"customerType",
			"clientFirstName",
			"clientLastName",
			"clientCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"countriesID",
			"contactZip",
			"clientEmail",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"registrantFirstName",
			"registrantLastName",
			"registrantEmail",
			"registrantOrganizationName",
			"registrantJobTitle",
			"registrantAddress1",
			"registrantAddress2",
			"registrantCity",
			"registrantStateProvince",
			"registrantPostalCode",
			"registrantCountry",
			"registrantPhone",
			"registrantFax",
			"extAttrib",
			"contactUsername",
			"contactPassword",
			"confirmcontactPassword",
			"existContactUsername",
			"existContactPassword",
			"clientNoteText",
			"taxIDNumber",
			"paymentType",
			"CRM",
			"invoiceID",
			"billingCardNameOnCard",
			"billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardStartDate",
			"billingBankType",
			"billingBankName",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankState",
			"billingBankDob",
			"billingAccountType",
			"billingAccountID",
			"cardCVV2",
			"clientID",
			"ctlCustomer",
			"useContactInfo",
			"mb_shopping_session",
			"orderFormID",
			
			"domain_cycleID",
			"domain_productID",
			"domain_productVariantID",
			"domain_domainType",
			"domain_domainTransferKey",
			"domain_domainName",
			"domain_domainLanguage",
			"domain_set_locale",

			"product_productID",
			"product_productVariantID",
			"product_cycleID"
			);
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the FinalizeOrder action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$ofdata = NULL;
				
		$CONF["theme"]["type"] = "public";

		dbg("/** Prior to Cleaning **\\");
		dbg($_REQUEST);
		/// we don't need anything more than what is in $this->params
		foreach( (array)$_REQUEST as $key => $v) {
			if (!in_array($key, (array)$this->params)) {
				unset( $_REQUEST[ $key ] );
			}
		} unset($key, $v);

		dbg("/** After Sanitization **\\");
		dbg($_REQUEST);
		 
// show($_REQUEST);exit;

		if (file_exists( "../include/themes/".$CONF["theme"]["name"]."/templates/order".$_REQUEST["orderFormID"])) {
			$this->smartyVars["orderFormDir"] = "order".$_REQUEST["orderFormID"];
		} else {
			$this->smartyVars["orderFormDir"] = "order";
		}
		$this->smartyVars["oderFormCSSDir"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];







		/**
		 * Verify our needed information is here
		 */
		$generalValues = array(
				"clientID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED);

		
		$registrantValues = array(
					"registrantFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"registrantEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"registrantAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantAddress2" => INPUT_RESTRICTION_STRING,
					"registrantCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantStateProvince" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantPostalCode" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"registrantOrganizationName" => INPUT_RESTRICTION_STRING,
					"registrantJobTitle" => INPUT_RESTRICTION_STRING,

					"registrantPhone" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantFax" => INPUT_RESTRICTION_STRING,

					"registrantCountry" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					);
		if (notNull( $_REQUEST['domain_cycleID'] ))
			$generalValues += $registrantValues;		
		$success = $this->validateMultiInputs($generalValues);
		
		if (!$success) {
			
//show($this);
// 			$this->addTemplate($this->smartyVars['orderFormDir'].'/ProcessOrder');
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		


		
		/**
		 *	lets try to get our data
		 */
		$apiURL = $CONF["secureURLProtocol"]."://".$CONF["secureURL"]."/app-modernbill-api/api.php";
		
		$apiConn =& new Curl( $apiURL );
		$fields = $_REQUEST+array(
				"adminRemoteAccessHash" => ACCESS_HASH,
				"apiAction" => "createInvoice",
				"process" => 1,
				"shoppingSessionID" => ( notNull($_REQUEST["shoppingSessionID"]) ? $_REQUEST["shoppingSessionID"] : $_REQUEST["mb_shopping_session"])
				);
		
		/// need to tidy the domain and product array's for the curl call
		foreach( (array)$fields as $k => $v ) {
			$match =array();
			if (preg_match("[^(domain|product)_(.+)]", $k, $match)) {
				$fields[ $match[1]."[$match[2]]" ] = $v;
				unset( $fields[ $k ] );
			}
		}

		dbg("Fields sent to $apiURL");
		dbg( $fields );
// show($fields);
		$apiConn->addMultiFields( $fields );
				
		$ofData = new MBXMLLite($apiConn->execute());
		$ofData = correctArray($ofData->toArray());

		dbg("RESPONSE from $apiURL");
		dbg($apiConn);
// echo $apiConn->getRawResponse();exit;
		unset( $apiConn, $fields, $apiURL );
		

		if (is_array( $ofData['api'][0]['results'][0]['errors'] )) {
			$this->addError(TRANS_ACTIONERROR, "Errors have occured during api transaction.");
			$this->addErrorTemplates();
			return false;
		}
		$results = $ofData['api'][0]['results'][0];
		if (isset($results['invoice'][0]) && is_array($results['invoice'][0]))
			$this->smartyVars['invoiceInfo'] = $results['invoice'][0];

		if (isset($results['invoice'][0]['transaction'][0]) && is_array($results['invoice'][0]['transaction'][0]))
			$this->smartyVars['transaction'] = $results['invoice'][0]['transaction'][0];

		if (isset($results['invoice'][0]['transactions'][0]) && is_array($results['invoice'][0]['transactions'][0]))
			$this->smartyVars['transaction'] += $results['invoice'][0]['transactions'][0];

		if (isset($results['invoice'][0]['transaction'][0]) && is_array($results['invoice'][0]['transaction'][0]))
			$this->smartyVars['transaction'] += $results['invoice'][0]['transaction'][0];

// print_r($this->smartyVars);exit;

		$this->addTemplate('shopping/CheckoutSuccess');
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // FinalizeOrder
?>
