<?php
// $Id: NewOrder.php 11423 2007-06-22 20:36:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on all orderForms that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Brian Smith
 */
class NewOrder extends MB_Action {
	/**
	 * The constructor for a NewOrder action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function NewOrder() {
		parent::MB_Action();
		$this->stringRep = "NewOrder";
		
		$this->params = array(
			"orderFormID",
			"productID",
			"cycleID",
			"domainName",
			"sid",
			"set_locale",
			"afcode"
			);
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the NewOrder action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		
		if (!notZero($_REQUEST["orderFormID"]))
			$_REQUEST["orderFormID"] = 1;
		dbg($_REQUEST);
		
		$this->fetchOrderForm( $_REQUEST["orderFormID"] );

		$this->mergeFormState($this->smartyVars['formValues']);

		if (isset( $this->smartyVars['formValues']['domain_domainName'] ) && notNull( $this->smartyVars['formValues']['domain_domainName'] )) {
			if (preg_match( "[(.+)\.((?:".str_replace('.', '\.', implode('|', $this->smartyVars['domainInfo']['tld']) )."))]", $this->smartyVars['formValues']['domain_domainName'], $match)) {
				$this->smartyVars['formValues']['domain_domainSLD'] = $match[1];
				$this->smartyVars['formValues']['domain_domainTLD'] = $match[2];
			}	unset( $match );
		}
		dbg($this->smartyVars);
// show($this->smartyVars);exit;
		$this->addTemplate($this->smartyVars["orderFormDir"]."/NewOrder");
				
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	function fetchOrderForm( $orderFormID ) {
		global $CONF;
			
		$apiURL = $CONF["secureURLProtocol"]."://".$CONF["secureURL"]."/app-modernbill-api/api.php";
		
		$apiConn =& new Curl( $apiURL );
		$fields = array(
				"adminRemoteAccessHash" => ACCESS_HASH,
				"apiAction" => "getOrderForms",
				"getOrderFormParams" => 1,
				"getOrderFormItems" => 3,
				"getOrderFormProductAddons" => 1,
				"getTLDs" => 1,
				"orderFormID" => $_REQUEST["orderFormID"]);
		
		$apiConn->addMultiFields( $fields );
		$apiConn->execute();
		
		$ofData = new MBXMLLite($apiConn->getRawResponse());
		$ofData = correctArray($ofData->toArray());
// echo $apiConn->getRawResponse();exit;
		$orderForm = $ofData["api"][0]["results"][0]["orderForms"][0];
		$tlds = $ofData["api"][0]["results"][0]["tlds"];

		unset($fields, $apiURL);
		
		if (notNull( $orderForm )) {
			// check to see if ip is banned
			#$_varIP = 
			if (Order::checkBanning(1, ip2long(getRemoteIP()))) {
				// this is a definition so it's a pseudo default
				$_var = 'TRANS_ORDER_IP_BANNING_MESSAGE';
				
				// fix for php4 static method calling bug is this loop
				foreach( (array)$orderForm["orderFormParams"] as $p ) {
					if ($p['orderFormParamName'] == 'ip_banning_text') {
						$_var = $p['orderFormParamValue'];
						break;
					}
				}	unset( $p );
				
				$this->addError(TRANS_FATALERROR, ( defined($_var) ? constant($_var) : $_var ) );
			} else {
				$this->smartyVars["domainInfo"] = array();
				foreach( (array)$tlds as $tld ) {
					if ($tld["tldActive"] != 1)	continue;

					$this->smartyVars["domainInfo"]["idn"][ $tld["tldExtension"] ] = $tld["tldActive"];
					$this->smartyVars["domainInfo"]["tld"][ $tld["tldExtension"] ] = $tld["tldName"];
				}
				unset($tld, $tlds);
				
				$orderFormParams = array();

				foreach( (array)$orderForm["orderFormParams"] as $param ) {
					switch( $param["orderFormParamName"] ) {
					case "dom_options":
						$this->smartyVars["domainInfo"]["domOptions"] = array_flip(unserialize($param["orderFormParamValue"]));
					break;

					case (($pos = strpos( $param['orderFormParamName'], 'payment_type_')) !== false):
						$this->smartyVars["paymentOptions"][ substr($param['orderFormParamName'], $pos+13) ] = $param['orderFormParamValue'];
						unset( $pos );
					break;

					case 'username_min_length':
						$this->smartyVars['orderParams']['usermin'] = $param['orderFormParamValue'];
					break;
					case 'username_max_length':
						$this->smartyVars['orderParams']['usermax'] = $param['orderFormParamValue'];
					break;
					case 'password_min_length':
						$this->smartyVars['orderParams']['passmin'] = $param['orderFormParamValue'];
					break;
					case 'password_max_length':
						$this->smartyVars['orderParams']['passmax'] = $param['orderFormParamValue'];
					break;


					default:
// 						echo $param["orderFormParamName"]."<br />";
				/*		$orderFormParams[ $param["orderFormParamName"] ] = array(
											"value" => $param["orderFormParamValue"],
											"transKey" => $param["orderFormParamTransKey"],
											"desc" => $param["orderFormParamDescription"]);
				*/	break;
					}
				}
				unset( $param );


				// payment groups!
				if (is_array( $orderForm["paymentGroup"] ) && is_array( $orderForm["paymentGroup"][0]["gateway"] )) {
					foreach( (array)$orderForm["paymentGroup"][0]["gateway"] as $gateway ) {
						if ($gateway["gatewayType"]) {
							$this->smartyVars["paymentOptions"]["cc"] = TRUE;
							$this->smartyVars["paymentOptions"]["primaryConfigGroupID"] = $gateway["configGroupID"];
						} else {
							$this->smartyVars["paymentOptions"]["secondary"][ $gateway["configGroupID"] ] = $gateway["configGroupTransKey"];
						}
					}	unset( $gateway );
				}
				
				// get bank account types
				$this->smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];

				// build years array
				for ($i=date("Y"); $i<date("Y")+21; $i++){
					$this->smartyVars["cardYears"][$i] = $i;
				}

				// select our default payment type
				if (!$this->smartyVars["paymentOptions"]["cc"] && !$this->smartyVars["paymentType"]){
					if ($this->smartyVars["paymentOptions"]["check"]){
						$this->smartyVars["paymentType"] = 3;
					} elseif ($this->smartyVars["paymentOptions"]["invoice"]){
						$this->smartyVars["paymentType"] = 50;
					} elseif ($this->smartyVars["paymentOptions"]["secondary"]){
						$this->smartyVars["paymentType"] = "2|".key($this->smartyVars["paymentOptions"]["secondary"]);
					} elseif ($this->smartyVars["paymentOptions"]["echeck"]){
						$this->smartyVars["paymentType"] = 4;
					}
				}
				
				
				$this->smartyVars["IDN"] = $this->createJSArray($this->smartyVars["domainInfo"]["idn"]);
				$this->smartyVars["set_locale"] = $orderForm["languageISO2"].'_'.$orderForm["countriesISO2"];

				if (file_exists( "../include/themes/".$CONF["theme"]["name"]."/templates/order".$_REQUEST["orderFormID"])) {
					$this->smartyVars["orderFormDir"] = "order".$_REQUEST["orderFormID"];
				} else {
					$this->smartyVars["orderFormDir"] = "order";
				}
				$this->smartyVars["oderFormCSSDir"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];
				
				// seperate our products
				for( $i=0, $n=count( (array)$orderForm["products"] ); $i<$n; $i++ ) {
					$p =& $orderForm["products"][ $i ]; // pointer

					$p["productComments"] = utf8_html_entity_decode( $p["productComments"] );
					
					for( $x=0, $m=count( (array)$p["cycles"] ); $x<$m; $x++ ) {
						$c =& $p["cycles"][ $x ]; // pointer
							
						$c["cycleDisplayName"] = defined($c["cycleDisplayName"]) ? constant($c["cycleDisplayName"]) : $c["cycleDisplayName"];
						
						$p["variants"][] = array(
								"displayName" => $c["cycleDisplayName"],
								"cycleID" => (int)$c["cycleID"]);

						$cur = count($p["variants"])-1;
						
						for( $y=0, $l=count( (array)$p["productVariantPrices"] ); $y<$l; $y++ ) {
							$v =& $p["productVariantPrices"][ $y ]; // pointer
							
							if ($c["cycleID"] == $v["cycleID"]) {
								
								$p["variants"][ $cur ]["variantID"] = (int)$v["productVariantID"];
								$p["variants"][ $cur ]["variantPriceAmount"] += $v["productVariantPriceAmount"];
							}
							unset( $v ); // disconnect the pointer
						}
						
						$p["variants"][ $cur ]["displayName"] .= " - ".$CONF["user"]["locale"]->getLocaleCurrency($p["variants"][ $cur ]["variantPriceAmount"], $orderForm["paymentGroupCurrencyID"]);
						unset( $c, $cur ); // disconnect the pointer
					}
					unset( $p ); // disconnect the pointer
				}
				$this->smartyVars["products"] =& $orderForm["products"];

				$this->mergeCountryData();
				$this->smartyVars['formValues']['countriesID'] = $orderForm['countriesID'];
				$this->smartyVars["orderForm"] =& $orderForm;
			}
		} elseif (notZero($apiConn->getNumErrors())) {
			foreach( (array)$apiConn->errors as $err ) {
				$this->addError(TRANS_ACTIONERROR, $err);
			}
		} elseif (($apiConn->httpCode != 200) && !isset( $ofData["api"][0] )) {
			$this->addError( TRANS_ACTIONERROR, "HTTP Response (".$apiConn->httpCode.") :: ".$apiConn->getHTTPResponseString( $apiConn->httpCode ));
		} else {
			if (isset( $ofData["api"] )) {
				foreach( (array)$ofData["api"][0]["header"][0]["errors"] as $err ) {
					$this->addError( $err["title"], $err["msg"] );
				}
			} else {
				$this->addError( TRANS_ACTIONERROR, "API Connection Failed"  );
			}
			
		}
	}
} // NewOrder
?>
