<?php
// $Id: ProcessOrder.php 11423 2007-06-22 20:36:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}

require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");


// has method we need
require_once mb_path("/app-modernbill-order/include/lib-action/order/NewOrder.php");
/**
 * This Action object collects information on all orderForms that match the given parameters, and 
 * generates the display of that information.
 *
 * @author Brian Smith
 */
class ProcessOrder extends NewOrder {
	/**
	 * The constructor for a ProcessOrder action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ProcessOrder() {
		parent::MB_Action();
		$this->stringRep = "ProcessOrder";
		
		$this->params = array(
			"sid",
			"set_locale",
			"customerType",
			"clientFirstName",
			"clientLastName",
			"clientCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"countriesID",
			"contactZip",
			"clientEmail",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"registrantFirstName",
			"registrantLastName",
			"registrantEmail",
			"registrantOrganizationName",
			"registrantJobTitle",
			"registrantAddress1",
			"registrantAddress2",
			"registrantCity",
			"registrantStateProvince",
			"registrantPostalCode",
			"registrantCountry",
			"registrantPhone",
			"registrantFax",
			"extAttrib",
			"contactUsername",
			"contactPassword",
			"confirmcontactPassword",
			"existContactUsername",
			"existContactPassword",
			"clientNoteText",
			"taxIDNumber",
			"paymentType",
			"CRM",
			"invoiceID",
			"billingCardNameOnCard",
			"billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardStartDate",
			"billingBankType",
			"billingBankName",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankState",
			"billingBankDob",
			"billingAccountType",
			"billingAccountID",
			"cardCVV2",
			"clientID",
			"ctlCustomer",
			"useContactInfo",
			"mb_shopping_session",
			"orderFormID",

			"domain_cycleID",
			"domain_productID",
			"domain_productVariantID",
			"domain_domainType",
			"domain_domainTransferKey",
			"domain_domainName",
			"domain_domainLanguage",
			"domain_set_locale",

			"product_productID",
			"product_productVariantID",
			"product_cycleID"
			);
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ProcessOrder action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		MB_Action::execute();

		$ofdata = NULL;
				
		$CONF["theme"]["type"] = "public";

		dbg("/*** PRIOR TO SANITATION ***\\");
		dbg($_REQUEST);

		/// we don't need anything more than what is in $this->params
		foreach( (array)$_REQUEST as $key => $v) {
			if (!in_array($key, (array)$this->params)) {
				unset( $_REQUEST[ $key ] );
			}
		} unset($key, $v);

		dbg("/*** AFTER TO SANITATION ***\\");
		dbg($_REQUEST);




		$this->setReferralActionFile( "ezorder.php" );


		/**
		 * Verify our needed information is here
		 */
		$generalValues = array(
				"contactUsername" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPassword" => array(
						INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_PASSWORD|INPUT_RESTRICTION_REQUIRED,
						array('confirm' => 'confirmcontactPassword')
						),
				"product_productID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
				"product_productVariantID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
				"product_cycleID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,

				"domain_cycleID" => INPUT_RESTRICTION_INT,
				"domain_productID" => INPUT_RESTRICTION_INT,
				"domain_productVariantID" => INPUT_RESTRICTION_STRING,
				"domain_domainType" => INPUT_RESTRICTION_STRING,
				"domain_domainTransferKey" => INPUT_RESTRICTION_STRING,
				"domain_domainName" => INPUT_RESTRICTION_STRING,
				"domain_domainLanguage" => INPUT_RESTRICTION_STRING,
				"domain_set_locale" => INPUT_RESTRICTION_STRING
					);

		if ($_REQUEST["ctlCustomer"] != "existing")
			$generalValues += array(
					"clientFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"clientLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					
					"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"contactAddress2" => INPUT_RESTRICTION_STRING,
					"contactCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"contactZip" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"clientCompany" => INPUT_RESTRICTION_STRING,
					"clientEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"contactPhone1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"contactPhone2" => INPUT_RESTRICTION_STRING,
					"contactFax" => INPUT_RESTRICTION_STRING,

					"countriesID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					"taxIDNumber" => INPUT_RESTRICTION_STRING);

		$registrantValues = array(
					"registrantFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"registrantEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"registrantAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantAddress2" => INPUT_RESTRICTION_STRING,
					"registrantCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantStateProvince" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantPostalCode" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,

					"registrantOrganizationName" => INPUT_RESTRICTION_STRING,
					"registrantJobTitle" => INPUT_RESTRICTION_STRING,

					"registrantPhone" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"registrantFax" => INPUT_RESTRICTION_STRING,

					"registrantCountry" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					);
		if (notNull( $_REQUEST['domain_cycleID'] ) && !$_REQUEST["useContactInfo"])
			$generalValues += $registrantValues;
		
		$success = $this->validateMultiInputs($generalValues);
		
		if (!$success) {
// show($_REQUEST);
// 			$this->addTemplate($this->smartyVars['orderFormDir'].'/NewOrder');
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		


		
		/**
		 *	lets try to get our data
		 */
		$apiURL = $CONF["secureURLProtocol"]."://".$CONF["secureURL"]."/app-modernbill-api/api.php";
		
		$apiConn =& new Curl( $apiURL );
		$fields = $_REQUEST+array(
				"adminRemoteAccessHash" => ACCESS_HASH,
				"apiAction" => "createInvoice",
				"preview" => 1,
				"shoppingSessionID" => ( notNull($_REQUEST["shoppingSessionID"]) ? $_REQUEST["shoppingSessionID"] : $_REQUEST["mb_shopping_session"])
				);

		/// need to tidy the domain and product array's for the curl call
		foreach( (array)$fields as $k => $v ) {
			$match =array();
			if (preg_match("[^(domain|product)_(.+)]", $k, $match)) {
				$fields[ $match[1]."[$match[2]]" ] = $v;
				unset( $fields[ $k ] );
			}
		}	unset( $k, $v, $match );

		dbg("Fields sent to ".$apiURL);
		dbg($fields);

		$apiConn->addMultiFields( $fields );
				
		$ofData = new MBXMLLite($apiConn->execute());
		$ofData = correctArray($ofData->toArray());

		dbg("RESPONSE from $apiURL");
		dbg($apiConn);
// echo $apiConn->getRawResponse();exit;
		unset( $apiConn, $fields, $apiURL );
		
		if (is_array( $ofData['api'][0]['header'][0]['errors'] )) {
			foreach( (array)$ofData['api'][0]['header'][0]['errors'] as $err ) {
				if (isset( $err['title'] )) {
					$this->addError(TRANS_ACTIONERROR, $err['message']);
				} elseif (isset( $err[1] )) {
					$this->addError(TRANS_ACTIONERROR, $err[1]);
				}
			}
			$this->addErrorTemplates();
			return false;
		}
		
		$results = $ofData['api'][0]['results'][0];
		$clientData = array();
		if (is_array( $results['client'][0] )) {
			$clientData = $results['client'][0];
		} else {
			$this->addError(TRANS_ACTIONERROR, "Error occured while fetching client data.");
		}
		
		if (is_array( $results['invoice'][0] )) {
			$this->smartyVars['invoice'] =& $results['invoice'][0];
		} else {
			$this->addError(TRANS_ACTIONERROR, "Invoice Generation was Unsuccessful");
		}

		/// grab orderForm info
		$this->fetchOrderForm( $_REQUEST["orderFormID"] );

		// grab domain info
		if (is_array($_REQUEST["domain"]) && isset($_REQUEST["domain"]["domainName"]) && notNull($_REQUEST["domain"]["domainName"])) {
			list($_REQUEST["domain"]["domainSLD"], $_REQUEST["domain"]["domainTLD"]) = explode('.', $_REQUEST["domain"]["domainName"]);
		}

		$this->mergeFormState( array_merge($_REQUEST, $clientData) );
// 		$this->smartyVars["formVa"] = array_merge($_REQUEST, $clientData);
//		$this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];


		$this->mergeCycleData();

		$this->smartyVars["countriesList"] =array();
		foreach( (array)arrayFor("countries") as $c ) {
			$this->smartyVars["countriesList"][ $c["countriesID"] ] = $c["countriesISO2"];
		}	unset( $c );

	
		
		


		// google ppcfactory
		$this->monthlyCycles = getCyclesArray("monthly");
		$this->ppcID = 0;
		$this->ppcName = "";
		$this->ppcPrice = 0;
		$this->ppcType = 0;

		if (file_exists( "../include/themes/".$CONF["theme"]["name"]."/templates/order".$_REQUEST["orderFormID"])) {
			$this->smartyVars["orderFormDir"] = "order".$_REQUEST["orderFormID"];
		} else {
			$this->smartyVars["orderFormDir"] = "order";
		}
		$this->smartyVars["oderFormCSSDir"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];



		dbg("SMARTY!");
		dbg($this->smartyVars);
		
		if (!$this->getNumErrors()) {
			$this->addTemplate($this->smartyVars['orderFormDir'].'/displayFinalOrder');
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ProcessOrder
?>
