<?php
// $Id: AddCartProductResponse.php 12070 2007-10-11 17:36:10Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/AddCartStepAction.php";

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class AddCartProductResponse extends AddCartStepAction {
	/**
	 * The constructor for a AddCartProductResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddCartProductResponse() {
		parent::AddCartStepAction();
		$this->stringRep = "AddCartProductResponse";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddCartProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";
		dbg($_REQUEST);
		$this->smartyVars = array();

		$this->shoppingSessionData = 
		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $_REQUEST["orderFormID"], 1);

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$this->order = 
		$order =& new Order($orderObjectParams);

		$this->currencyID = 
		$currencyID = $order->orderFormCurrency;

		if ($_REQUEST["couponCode"]){
			$possibleCoupons = array();
			if (isset($order->orderFormData["coupons"][0]["coupon"][0]["couponID"][0])){
				foreach ($order->orderFormData["coupons"][0]["coupon"] as $coupon){
					$possibleCoupons[$coupon["couponID"][0]] = $coupon;
				}
			}
	
			dbg("possible coupons:");
			dbg($possibleCoupons);
	
			$couponCode = secureInput(stripslashes($_REQUEST["couponCode"]));
			$couponInfo = dispatchMBAPI(array(
				"mbapi" => array(
					"command" => "GetCoupons",
					"params" => array(
						"couponCode" => $couponCode,
					),
				),
			), 1);
			dbg("coupon info gotten from mbapi:");
			dbg($couponInfo);
			if (isset($couponInfo["mbapi"][0]["results"])
				&& isset($couponInfo["mbapi"][0]["results"][0]["coupons"])
				&& isset($couponInfo["mbapi"][0]["results"][0]["coupons"][0]["coupon"])
				&& isset($couponInfo["mbapi"][0]["results"][0]["coupons"][0]["coupon"][0]["couponID"])){
	
				dbg("going to test validity");
	
				$couponInfo = collapseArrayElements($couponInfo["mbapi"][0]["results"][0]["coupons"][0]["coupon"][0]);
	
				dbg("collapsed coupon info:");
				dbg($couponInfo);
	
				if (($couponInfo["couponCount"]>=$couponInfo["couponMaxCount"] && $couponInfo["couponMaxCount"] > 0) || !(int)$possibleCoupons[$couponInfo["couponID"]]["couponID"][0] || $couponInfo["couponActive"]<1 || ($couponInfo["couponDateEnded"]>0 && $couponInfo["couponDateEnded"]<time()) || $couponInfo["couponDateStarted"]>time()){
					dbg("determined invalid");
					if (!$_REQUEST["redirectURL"]){
						$_REQUEST["redirectURL"] = "cart.php?sid=".secureInput($_REQUEST["sid"])."&invalidCoupon=yes";
					}
				} else {
					dbg("determined valid");
					dbg(dispatchMBAPI(array(
						"mbapi" => array(
							"command" => "SetShoppingCoupon",
							"params" => array(
								"shoppingSessionsID" => $shoppingSessionData["shoppingSessionID"],
								"couponID" => $couponInfo["couponID"],
							),
						),
					), 1));
	
				}
	
			}
		}
		
		$this->idMap = array();
		$this->preappliedCoupons = array();

		// this section is to reconstruct the items' structure for the add
		// wizard's request structure
		if ((int)$_REQUEST["addWizard"]){
			
			dbg("reconstructing...");
			$items = array($_REQUEST) + (array)$_REQUEST["items"];
			unset($items[0]["items"]);
			
			if ($_REQUEST["domains"]){
				$domainItems = array();
				parse_str($_REQUEST["domains"], $domainItems);
				$items = array_merge($items, array_values((array)$domainItems["items"]));
			}
			
			dbg($items);
			
			$_REQUEST["items"] = $items;
			
		}


		if ($_REQUEST["items"]){
			foreach ($_REQUEST["items"] as $k=>$item){
				if (is_numeric($k) && is_array($item)){
					$item["sid"] = $_REQUEST["sid"];
					$this->addCartProduct($item);
				}
			}
		} else {
			$this->addCartProduct($_REQUEST);
		}

		if (count($this->preappliedCoupons)){
			$this->addPreappliedCoupons($this->preappliedCoupons);
		}

		if ($_REQUEST["redirectURL"]!="") {
			redirect($_REQUEST["redirectURL"]);
		} else {
			redirect("cart.php?sid=".secureInput($_REQUEST["sid"]));
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}


}
