<?php
// $Id: AddCartStepAction.php 12266 2007-11-21 17:43:16Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * @author  Kris Bailey
 */
class AddCartStepAction extends MB_Action {
	/**
	 */
	function AddCartStepAction() {
		parent::MB_Action();
		$this->stringRep = "AddCartStepAction";
		$this->params = array();
		$this->sortColumns = array();
	}
	
	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		$shoppingSessionData = $this->shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $_REQUEST["orderFormID"]);
		$this->smartyVars["shoppingSession"] = $shoppingSessionData;
		$this->mergeCycleData();

		$this->smartyVars["cartURL"] = "cart.php?sid=".$_REQUEST["sid"];
		$this->smartyVars["remoteURL"] = "remote.php?sid=".$_REQUEST["sid"];
		$this->smartyVars["whoisURL"] = "remotewhois.php?multiDomain=1&sid=".$_REQUEST["sid"];

		if ($CONF["secureURLProtocol"]=="http"){
			$this->smartyVars["fullCartURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullTransferURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/remote.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullWhoisURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/remotewhois.php?multiDomain=1&sid=".$_REQUEST["sid"];
			$url =& new URL($this->smartyVars["whoisURL"]);
			$this->smartyVars["baseURL"] = $CONF["secureURLProtocol"]."://".$url->getHost();
		} else {
			$this->smartyVars["fullCartURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullTransferURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/remote.php?sid=".$_REQUEST["sid"];
			$this->smartyVars["fullWhoisURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/remotewhois.php?multiDomain=1&sid=".$_REQUEST["sid"];
			$url =& new URL($this->smartyVars["whoisURL"]);
			$this->smartyVars["baseURL"] = $CONF["secureURLProtocol"]."://".$url->getHost();
		}


		switch ($this->stringRep){
			case "ShowMultiDomainWhoisStep":
				if ($_REQUEST["source"]=="addons"){
					$this->smartyVars["nextActionName"] = "AddCartProductResponse";
				} else {
					$this->smartyVars["nextActionName"] = "ShowCartProductAddonsStep";
				}
			break;
			case "ShowCartProductAddonsStep":
				if ($_REQUEST["source"]=="domains"){
					$this->smartyVars["nextActionName"] = "AddCartProductResponse";
				} else {
					$this->smartyVars["nextActionName"] = "ShowMultiDomainWhoisStep";
				}
			break;
		}

	}
	
	function mergeMultiDomainData($orderFormID, $domainSLD, $domainTLD){
		global $CONF;
		$orderFormData = ($this->smartyVars["orderFormInfo"]["orderFormID"]==$orderFormID) ? $this->smartyVars["orderFormInfo"] : oneByID(":orderForms", $orderFormID);
		$paymentGroupData = oneByID(":paymentGroups", $orderFormData["paymentGroupID"]);
		$this->smartyVars["currencyID"] = $currencyID = $paymentGroupData["paymentGroupCurrencyID"];
		
		$shoppingSessionData = $this->shoppingSessionData;

		if ($domainSLD){
			$this->smartyVars["domainSLD"] = str_replace(array("http://", "https://", "www."), "", strtolower($domainSLD));
			if (strpos($this->smartyVars["domainSLD"], ".")!==false){
				$this->smartyVars["domainSLD"] = substr($this->smartyVars["domainSLD"], 0, strpos($this->smartyVars["domainSLD"], "."));
			}
			$this->smartyVars["selectedTLD"] = $domainTLD;
		}
		
		$domainProducts = arrayFor("products", array(
			"getProductVariantData" => 1,
			"productType" => getAPITypeID("products", "domain"),
			"productActive" => 1,
		));
		$keyedProducts = array();
		foreach ((array)$domainProducts as $product){
			$keyedProducts[$product["productID"]] = $product;
		}
		$productIDs = array_keys($keyedProducts);
		
		dbg($keyedProducts);
		
		$orderFormItems = arrayFor(":orderFormItems", array(
			"orderFormID" => $orderFormID,
			"productID" => $productIDs,
		));
		
		dbg($orderFormItems);
		
		if (!count($orderFormItems)){
			$this->smartyVars["noDomainProductFound"] = 1;
		} else {
			$this->smartyVars["productID"] = $domainProductID = $orderFormItems[0]["productID"];
			$domainProduct =& $keyedProducts[$domainProductID];

			if (!$domainProduct){
				$this->smartyVars["noDomainProductFound"] = 1;
			} else {
				$tldIDs = array();

				$variants = $domainProduct["productVariants"];
				$tldPrices = array();
				$tldHasTransferPrice = array();
				$variants2tlds = array();
				foreach ((array)$variants as $v){
					if ($v["productVariantActive"]){
						$tldIDs[] = $v["tldID"];
						$variants2tlds[$v["productVariantID"]] = $v["tldID"];
					}
				}

				$tlds2variants = array_flip($variants2tlds);

				$domainProductPrices = oneByID("products", $domainProduct["productID"], array(
					"getProductVariantPriceData" => 1,
				));

				$variantPrices = $domainProductPrices["productVariantPrices"];
				foreach ((array)$variantPrices as $price){
					if ($price["currencyID"]==$currencyID && $price["productVariantPriceAmount"]>0){
						$tldPrices[$variants2tlds[$price["productVariantID"]]][$price["cycleID"]][$price["productVariantPriceType"]] = $CONF["user"]["locale"]->getLocaleCurrency($price["productVariantPriceAmount"], $currencyID);
						if ($price["productVariantPriceType"]==getAPITypeID("price", "transfer")){
							$tldHasTransferPrice[$variants2tlds[$price["productVariantID"]]] = true;
						}
					}
				}

				$tlds = arrayFor(":TLDs", array(
					"sortColumn" => "tldDisplayOrder",
					"sortDir" => "ASC",
					"tldActive" => 1,
					"tldID" => $tldIDs,
				));
				$this->smartyVars["cycleInfo"] = getCyclesArray();
				$this->smartyVars["cycleValues"] = array();
				foreach ($this->smartyVars["cycleInfo"] as $cycleID=>$cycleName){
					$this->smartyVars["cycleValues"][$cycleID] = getNextBillingTimestamp(0, $cycleID);
				}
				$this->smartyVars["tlds"] = array();
				foreach ($tlds as $tld){
					$tld["productID"] = $domainProductID;
					$tld["productVariantID"] = $tlds2variants[$tld["tldID"]];
					$tld["prices"] = $tldPrices[$tld["tldID"]];
					$tld["hasTransferPrice"] = $tldHasTransferPrice[$tld["tldID"]];
					$this->smartyVars["tlds"][$tld["tldExtension"]] = $tld;
				}
			}
			
		}
		$this->smartyVars["showDomainBox"] = 1;
	}

	function mergeProductData($productID, $productVariantID, $orderFormID, $cycleID=false, $allowRedirect=true){
		global $CONF;
		$this->smartyVars["orderFormInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetOrderForms",
				"params" => array(
					"orderFormID" => $orderFormID,
					"getCouponData" => 1,
				),
			),
		)));

		dbg($this->smartyVars["orderFormInfo"]);
		
		$this->smartyVars["orderFormID"] = $orderFormID;
		$this->smartyVars["currencyID"] = $this->smartyVars["orderFormInfo"]["paymentGroupCurrencyID"];
		
		$this->allowedCoupons = array();

		foreach ((array)$this->smartyVars["orderFormInfo"]["coupons"] as $coupon){
			$this->allowedCoupons[$coupon["productID"]][$coupon["couponID"]] = $coupon;
		}

		dbg("getting ready to get product $productID.");

		$productInfo = oneByID("products", $productID, array(
			"productActive" => 1,
			"getProductAttributeData" => 1,
			"getCouponData" => 1,
			"getPreCouponData" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getCycleData" => 1,
			"getCycleGhostIDs" => 1,
		));
		
		dbg($productInfo);

		dbg("redirecting?");
		if ($allowRedirect){
			dbg("possibly...");
			switch ($this->stringRep){
				case "ShowMultiDomainWhoisStep":
					if ($productInfo["productDomainRequired"]==getAPIStatusID("productdependencyrules", "cannot")){
						dbg("on the whois set and product domain required is: ".$productInfo["productDomainRequired"]);
						if ($_REQUEST["source"]=="addons"){
							$url = $this->smartyVars["cartURL"]."&action=".getActionID("AddCartProductResponse")."&".makeRequestQueryString();
							dbg("sending to cart url:");
							dbg($url);
							header("Location: $url");
							exit;
						} else {
							unset($_REQUEST["source"]);
							$url = $this->smartyVars["cartURL"]."&source=domains&action=".getActionID("ShowCartProductAddonsStep")."&".makeRequestQueryString();
							dbg("sending to domain url:");
							dbg($url);
							header("Location: $url");
							exit;
						}
					}
				break;
				case "ShowCartProductAddonsStep":
					if ($productInfo["productAddonRequired"]==getAPIStatusID("productdependencyrules", "cannot")){
						if ($_REQUEST["source"]=="domains"){
							$url = $this->smartyVars["cartURL"]."&action=".getActionID("AddCartProductResponse")."&".makeRequestQueryString();
							dbg("sending to cart url:");
							dbg($url);
							header("Location: $url");
							exit;
						} else {
							unset($_REQUEST["source"]);
							$url = $this->smartyVars["cartURL"]."&source=addons&action=".getActionID("ShowMultiDomainWhoisStep")."&".makeRequestQueryString();
							dbg("sending to domain url:");
							dbg($url);
							header("Location: $url");
							exit;
						}
					}
				break;
			}
		}


		if ($productInfo["preappliedCoupons"] && $productInfo["preappliedCoupons"][0] && $productInfo["preappliedCoupons"][0]["couponID"]){
			$preappliedCouponID = $productInfo["preappliedCoupons"][0]["couponID"];
			if ($this->allowedCoupons[$productInfo["productID"]][$preappliedCouponID]){
				$preappliedCoupon = $this->allowedCoupons[$productInfo["productID"]][$preappliedCouponID];
			} else {
				$preappliedCoupon = 0;
			}
		} else {
			$preappliedCoupon = 0;
		}

		foreach ((array)$productInfo["productVariants"] as $k=>$v){
			$keyedVariants[$v["productVariantID"]] =& $productInfo["productVariants"][$k];
		}

		$validCycles = array();
		if (!(int)$_REQUEST["cycleID"]){
			foreach ((array)$productInfo["ghostCycles"] as $cycle){
				$validCycles[] = $cycle["cycleID"];
			}
		} else {
			$validCycles[] = (int)$_REQUEST["cycleID"];
		}

		$prices = array();
		if (isset($productInfo["productVariantPrices"])){
			foreach ($productInfo["productVariantPrices"] as $price){
				if (in_array($price["cycleID"], $validCycles) && $price["productVariantID"]==$productVariantID){
					$prices[$price["currencyID"]][$price["cycleID"]][$price["productVariantPriceType"]] = $price;
				}
			}
		} else {
			dbg("didnt find prices");
		}
		
		foreach ($prices as $currency => $rows){
			$productPrice = array_values($rows);
			if ($preappliedCoupon){
				foreach ((array)$productPrice as $k=>$tempprice){
					$productPrice[$k][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
					$productPrice[$k][0]["discountPrice"] = $productPrice[$k][0]["productVariantPriceAmount"]-$productPrice[$k][0]["discountAmount"];
				}
			}
			$productInfo["prices"][$currency] = $productPrice;
		}
		$productInfo["productComments"] = utf8_html_entity_decode($productInfo["productComments"]);
		unset($productInfo["productVariantPrices"]);
		
		$productInfo["productVariantID"] = $productVariantID;
		$productInfo["cycleID"] = $cycleID;
		
		$this->smartyVars["product"] = $productInfo;

	}

	function getCouponAmount($price, $coupon){
		if ((int)$coupon["couponType"]){
			return $coupon["couponDiscount"];
		} else {
			return round(($coupon["couponDiscount"]/100)*$price["productVariantPriceAmount"], 2);
		}

	}

	function mergeProductAddonsData($productID, $cycleID, $productVariantID){

		$shoppingSessionData = $this->shoppingSessionData;
		
		$this->smartyVars["productID"] = $productID;
		$this->smartyVars["cycleID"] = $cycleID;
		$this->smartyVars["productVariantID"] = $productVariantID;

		$getAddonsXML = "	<mbapi>
								<command>GetProducts</command>
								<params>
									<parentProductID>".$this->smartyVars["productID"]."</parentProductID>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getCycleData>1</getCycleData>
								</params>
							</mbapi>";
		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI($getAddonsXML, 1)));


		foreach ($productsInfo as $addon){
			$groups[$addon["productAddonGroupID"]] = 1;
		}
		$groups = array_keys((array)$groups);
		$groups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"getGroupsByProductID" => $this->smartyVars["productID"]
				)
			)
		)));
		
		$this->smartyVars["addonGroups"] = array();
		foreach ((array)$groups as $group){
			$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
		}

		dbg("prods:");
		dbg($productsInfo);

		foreach ((array)$productsInfo as $k=>$product){
			if (!isset($this->smartyVars["addonGroups"][$product["productAddonGroupID"]]) && (int)$product["productAddonGroupID"]){
				unset($productsInfo[$k]);
			}
		}

		if (!is_array($productsInfo)){
		 	$productsInfo = array();
		}

		$mainProducts = array();

		foreach ($productsInfo as $k=>$v){

			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}
			
			$prices = array();
			if (isset($productsInfo[$k]["productVariantPrices"])){
				if ($v["productIsAddon"]){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("cycle id: ".$price["cycleID"]);
						dbg("match to cycle: ".$this->smartyVars["cycleID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"] && $price["cycleID"]==$this->smartyVars["cycleID"]){
							$prices[$price["productVariantPriceType"]] = $price;
						}
					}
				} else {
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"]){
							$prices[$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
				foreach ($productsInfo[$k]["prices"] as $currency => $rows){
					if ($preappliedCoupon){
						foreach ((array)$row as $xk=>$tempprice){
							$productsInfo[$k]["prices"][$currency][$xk][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
							$productsInfo[$k]["prices"][$currency][$xk][0]["discountPrice"] = $productsInfo[$k]["prices"][$currency][$xk][0]["productVariantPriceAmount"]-$productsInfo[$k]["prices"][$currency][$xk][0]["discountAmount"];
						}
					}
				}
			} else {
				unset($productsInfo[$k]);
			}
		
		}

		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}
		
		$this->smartyVars["addonproducts"] = $keyedAddons;
		$this->mergeCycleData();
	}

	function addCartProduct($productData){
		global $CONF;

		if (!$productData["productID"] && 
			$productData["addType"]!="associateDomain" && 
			$productData["addType"]!="addons" && 
			!$productData["existsld"]){
			dbg("aparently this isn't a valid product:");
			dbg($productData);
			return;
		}

		$shoppingSessionData =& $this->shoppingSessionData;
		$order =& $this->order;
		$currencyID = $this->currencyID;


		if ($productData["parentID"] && !$productData["parentShoppingItemID"]){
			$productData["parentShoppingItemID"] = $this->idMap[$productData["parentID"]];
		}
		
		dbg("ADDING PRODUCT");
		dbg($productData);
		dbg($this->idMap);

		if ($productData["addType"]=="domain"){

			dbg($productData);

			if ($productData["existsld"]){ // existing
				$type = getAPITypeID("shoppingdomains", "manual");

				$productData["existsld"] = eregi_replace("^www\.|http://|https://", "", trim($productData["existsld"]));

				if ($productData["existtld"]=="" && strpos($productData["existsld"], ".")){
					$pp = explode(".", $productData["existsld"]);
					$productData["existtld"] = $pp[count($pp)-1];
					unset($pp[count($pp)-1]);
					$productData["existsld"] = implode(".", $pp);
				}

				if ($productData["existsld"][strlen($productData["existsld"])-1]=="."){
					$productData["existsld"] = substr($productData["existsld"], 0, -1);
				}

				$setRelXML = "
					<mbapi>
						<command>SetShoppingItemsDomain</command>
						<subCommand>insert</subCommand>
						<params>
							<shoppingItemID>".(int)$productData["parentShoppingItemID"]."</shoppingItemID>
							<shoppingItemsDomainsType>".$type."</shoppingItemsDomainsType>
							<domainSLD>".secureInput($productData["existsld"])."</domainSLD>
							<domainTLD>".secureInput($productData["existtld"])."</domainTLD>
						</params>
					</mbapi>";
				dbg($results = dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...

				if ($results["mbapi"][0]["header"][0]["lastInsertID"]){
					$domainRelID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
				}

			} else {

				$variantXML = "
						<mbapi>
							<command>GetProductVariants</command>
							<params>
								<productVariantID>".(int)$productData["productVariantID"]."</productVariantID>
								<getProductVariantPriceData>1</getProductVariantPriceData>
								<getTLDData>1</getTLDData>
							</params>
						</mbapi>";
				$variantInfo = dispatchMBAPI($variantXML, 1);
				dbg($variantInfo);
				if (isset($variantInfo["mbapi"][0]["results"][0]["productVariants"][0]["productVariant"][0])){
					$variantInfo = correctArray($variantInfo["mbapi"][0]["results"][0]["productVariants"][0]["productVariant"][0]);
					dbg("Variant Info for transfer:");
					dbg($variantInfo);

					if ($productData["cycleID"]=="-2"){
						$type = 1;
						$priceType = 2;
						dbg($productData["cycleID"] = $variantInfo["tldTransferMinimumCycleID"]);
					} else {
						dbg("not a transfer");
						$priceType = 0;
						$type = 0;
					}


					$priceInfo = array();

					foreach ($variantInfo["productVariantPrices"] as $price){
						if ($price["currencyID"]==$currencyID && $price["cycleID"]==(int)$productData["cycleID"]){
							$priceInfo[$price["productVariantPriceType"]] = $price;
						} else {
							dbg("currency: ".$price["currencyID"]."=".$currencyID." -- cycle: ".$price["cycleID"]."=".$productData["cycleID"]);
						}
					}
					dbg($priceInfo);

					if (count($priceInfo)){

						$backLen = strlen($variantInfo["tldExtension"])+1;
	
						$domainSLD = substr($productData["domain"], 0, -$backLen);
						$domainTLD = $variantInfo["tldExtension"];
	
						$setItemXML = "
								<mbapi>
									<command>SetShoppingItem</command>
									<subCommand>insert</subCommand>
									<params>
										<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
										<productID>".(int)$productData["productID"]."</productID>
										<productVariantID>".(int)$productData["productVariantID"]."</productVariantID>
										<cycleID>".(int)$productData["cycleID"]."</cycleID>
										<currencyID>".$currencyID."</currencyID>
										<shoppingItemQuantity>1</shoppingItemQuantity>
										<shoppingItemTransferKey>".secureInput($productData["domainTransferKey"])."</shoppingItemTransferKey>
										<shoppingItemSLD>".secureInput($domainSLD)."</shoppingItemSLD>
										<shoppingItemTLD>".secureInput($domainTLD)."</shoppingItemTLD>
										<shoppingItemDomainLanguage>".secureInput($productData["domainLanguage"])."</shoppingItemDomainLanguage>
										<shoppingItemDomainType>".$type."</shoppingItemDomainType>
										<shoppingItemPrice>".doubleval($priceInfo[$priceType]["productVariantPriceAmount"])."</shoppingItemPrice>
										<shoppingItemSetupPrice>".doubleval($priceInfo[1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
										<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
									</params>
								</mbapi>";
						dbg($setItemXML);
						$setItem = dispatchMBAPI($setItemXML, 1);
						dbg("result:");
						dbg($setItem);
						if (isset($setItem["mbapi"][0]["header"][0]["lastInsertID"][0])){
	
							$setRelXML = "
								<mbapi>
									<command>SetShoppingItemsDomain</command>
									<subCommand>insert</subCommand>
									<params>
										<shoppingItemID>".(int)$productData["parentShoppingItemID"]."</shoppingItemID>
										<shoppingItemsDomainsType>".$type."</shoppingItemsDomainsType>
										<domainSLD>".secureInput($domainSLD)."</domainSLD>
										<domainTLD>".secureInput($domainTLD)."</domainTLD>
										<domainShoppingItemID>".$setItem["mbapi"][0]["header"][0]["lastInsertID"][0]."</domainShoppingItemID>
									</params>
								</mbapi>";
							dbg($setRelXML);
							dbg($results = dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...
	
							if ($results["mbapi"][0]["header"][0]["lastInsertID"]){
								$domainRelID = $results["mbapi"][0]["header"][0]["lastInsertID"][0];
							}
	
							if ($productData["ID"] && $setItem["mbapi"][0]["header"][0]["lastInsertID"]){
								$this->idMap[$productData["ID"]] = $setItem["mbapi"][0]["header"][0]["lastInsertID"][0];
							}
	
						}
	
						$productsInfoXML = "
										<mbapi>
											<command>GetProducts</command>
											<params>
													<productID>".(int)$productData["productID"]."</productID>
													<getCouponData>1</getCouponData>
													<getPreCouponData>1</getPreCouponData>
													<getCouponIDs>1</getCouponIDs>
											</params>
										</mbapi>";
						$productsInfo = dispatchMBAPI($productsInfoXML, 1);
						$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
			
						$priceInfo = array();
			
						foreach ($productsInfo as $k=>$v){
							if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
								$this->preappliedCoupons[] = $v["preappliedCoupons"][0]["couponID"];
							}
						}
					} else {
						// couldn't find the price info
					}

				} else {
					// do nothing since we couldnt find the variant
				}

			}
			
			if ($domainRelID && $productData["parentShoppingItemID"] && (int)$productData["primaryDomain"]){
				updateForKey(":shoppingItems", $productData["parentShoppingItemID"], array(
					"shoppingItemPrimaryDomainID" => $domainRelID,
				));
			}

		} elseif ($productData["addType"]=="associateDomain"){

			dbg($productData);


			$setRelXML = "
				<mbapi>
					<command>SetShoppingItemsDomain</command>
					<subCommand>insert</subCommand>
					<params>
						<shoppingItemID>".(int)$productData["parentShoppingItemID"]."</shoppingItemID>
						<shoppingItemsDomainsType>0</shoppingItemsDomainsType>
						<domainSLD>".secureInput($productData["domainSLD"])."</domainSLD>
						<domainTLD>".secureInput($productData["domainTLD"])."</domainTLD>
						<domainShoppingItemID>".(int)$productData["domainShoppingItemID"]."</domainShoppingItemID>
					</params>
				</mbapi>";
			dbg($setRelXML);
			dbg(dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...


		} elseif ($productData["addType"]=="addons"){

			if ($productData["parentShoppingItemID"] && !$productData["shoppingItemID"]){
				$productData["shoppingItemID"] = $productData["parentShoppingItemID"];
			}

			dbg($productData);

			$productIDs = (array)$productData["addonID"];
			$cycleMap = array();
			foreach ($productIDs as $k=>$v){
				if (count(explode("|", $v))>1){
					$v = explode("|", $v);
					$cycleMap[$v[0]] = $v[1];
					$v = (int)$v[0];
				} else {
					$v = (int)$v;
				}
				$productIDs[$k] = $v;
			}

			dbg("product ids of the addons we chose:");
			dbg($productIDs);

			$shoppingItemInfoXML = "<mbapi>
										<command>GetShoppingItems</command>
										<params>
											<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
											<shoppingItemID>".(int)$productData["shoppingItemID"]."</shoppingItemID>
										</params>
									</mbapi>";
			$shoppingItemInfo = dispatchMBAPI($shoppingItemInfoXML, 1);

			if (isset($shoppingItemInfo["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
				$shoppingItemInfo = correctArray($shoppingItemInfo["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0]);

				$removeCurrentAddonsXML = "	<mbapi>
												<command>SetShoppingItem</command>
												<subCommand>delete</subCommand>
												<params>
													<parentShoppingItemID>".(int)$productData["shoppingItemID"]."</parentShoppingItemID>
												</params>
											</mbapi>";
				dbg("remove result:");
				dbg(dispatchMBAPI($removeCurrentAddonsXML, 1));

				$this->smartyVars["shoppingItemID"] = (int)$productData["shoppingItemID"];
				$this->smartyVars["productID"] = $shoppingItemInfo["productID"];
				$this->smartyVars["cycleID"] = $shoppingItemInfo["cycleID"];
				$this->smartyVars["productVariantID"] = $shoppingItemInfo["productVariantID"];
				dbg("smarty vars");
				dbg($this->smartyVars);

				$getAddonsXML = "	<mbapi>
								<command>GetProducts</command>
								<params>
									<parentProductID>".$this->smartyVars["productID"]."</parentProductID>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
								</params>
							</mbapi>";
				$productsInfo = dispatchMBAPI($getAddonsXML, 1);
				$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

				dbg("prods:");
				dbg($productsInfo);

				

				foreach ($productsInfo as $k=>$v){

					if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
						$this->preappliedCoupons[] = $v["preappliedCoupons"][0]["couponID"];
					}
					
					$prices = array();
					$cycleID = (isset($cycleMap[$v["productID"]]))?$cycleMap[$v["productID"]]:$this->smartyVars["cycleID"];
					if (in_array($v["productID"], $productIDs)){
					 	if (isset($productsInfo[$k]["productVariantPrices"])){
						 	foreach ($productsInfo[$k]["productVariantPrices"] as $price){
								if ($price["currencyID"]==$currencyID && $price["cycleID"]==$cycleID){
									$prices[$price["productVariantPriceType"]] = $price;
									$productsInfo[$k]["productVariantID"] = $price["productVariantID"];
								}
							}
						} else {
							dbg("variant price not set");
						}
						dbg("prices:");
						dbg($prices);
						$productsInfo[$k]["prices"] = $prices;
						if (count($productsInfo[$k]["prices"])){
							unset($productsInfo[$k]["productVariantPrices"]);
						} else {
					 		unset($productsInfo[$k]);
						}
					} else {
					 	dbg("product id: ".$v["productID"]." not in: ");
					 	dbg($productIDs);
					 	unset($productsInfo[$k]);
					}
				}

				dbg("products info after filtering");

				foreach ($productsInfo as $k=>$v){
					// add each to cart
					$setItemXML = "
							<mbapi>
								<command>SetShoppingItem</command>
								<subCommand>insert</subCommand>
								<params>
									<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
									<productID>".(int)$v["productID"]."</productID>
									<productVariantID>".(int)$v["productVariantID"]."</productVariantID>
									<cycleID>".(int)$v["prices"][0]["cycleID"]."</cycleID>
									<currencyID>".$this->smartyVars["currencyID"]."</currencyID>
									<shoppingItemQuantity>1</shoppingItemQuantity>
									<shoppingItemSLD></shoppingItemSLD>
									<shoppingItemPrice>".doubleval($v["prices"][0]["productVariantPriceAmount"])."</shoppingItemPrice>
									<shoppingItemSetupPrice>".doubleval($v["prices"][1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
									<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
									<parentShoppingItemID>".(int)$productData["shoppingItemID"]."</parentShoppingItemID>
								</params>
							</mbapi>";
					if ($v["prices"][0]){
						$setItem = dispatchMBAPI($setItemXML, 1);
					}
					dbg("result:");
					dbg($setItem);

				}

			} else {
				// do nothing, we didn't get a valid shoppingItemID
			}

		} else {

			/////////////////////////////////////
			$productsInfoXML = "
							<mbapi>
								<command>GetProducts</command>
								<params>
										<productID>".(int)$productData["productID"]."</productID>
										<getCouponData>1</getCouponData>
										<getPreCouponData>1</getPreCouponData>
										<getCouponIDs>1</getCouponIDs>
										<getProductVariantData>1</getProductVariantData>
										<getProductVariantPriceData>1</getProductVariantPriceData>
								</params>
							</mbapi>";
			$productsInfo = dispatchMBAPI($productsInfoXML, 1);
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

			foreach ($productsInfo as $k=>$v){
				$priceInfo = array();
				if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
					$this->preappliedCoupons[] = $v["preappliedCoupons"][0]["couponID"];
				}
				$prices = array();
				dbg($v);
				
				$validVariants = array();
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					$validVariants[] = $price["productVariantID"];
				}

				if (!(int)$productData["productVariantID"] || !in_array((int)$productData["productVariantID"], $validVariants)){
					$productData["productVariantID"] = $validVariants[0];
				}

				
				if (isset($productsInfo[$k]["productVariantPrices"])){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						if ($price["currencyID"]==$currencyID && $price["cycleID"]==(int)$productData["cycleID"] && $price["productVariantID"]==(int)$productData["productVariantID"]){
							$priceInfo[$price["productVariantPriceType"]] = $price;
						}
					}
				}
			}

			dbg($priceInfo);

			if ($priceInfo[0]){
	
				$setItemXML = "
						<mbapi>
							<command>SetShoppingItem</command>
							<subCommand>insert</subCommand>
							<params>
								<shoppingSessionID>".secureInput($productData["sid"])."</shoppingSessionID>
								<productID>".(int)$productData["productID"]."</productID>
								<productVariantID>".(int)$productData["productVariantID"]."</productVariantID>
								<cycleID>".(int)$productData["cycleID"]."</cycleID>
								<currencyID>".$currencyID."</currencyID>
								<shoppingItemQuantity>1</shoppingItemQuantity>
								<shoppingItemSLD></shoppingItemSLD>
								<shoppingItemPrice>".doubleval($priceInfo[0]["productVariantPriceAmount"])."</shoppingItemPrice>
								<shoppingItemSetupPrice>".doubleval($priceInfo[1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
								<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
							</params>
						</mbapi>";
				$setItem = dispatchMBAPI($setItemXML, 1);
				dbg("result:");
				dbg($setItem);
	
				if ($productData["ID"] && $setItem["mbapi"][0]["header"][0]["lastInsertID"][0]){
					$this->idMap[$productData["ID"]] = $setItem["mbapi"][0]["header"][0]["lastInsertID"][0];
				}
	
			} else {
				// no prices....
			}

		} // end adding non domain product

	}
	
	
	function mergeWidgetData($websiteWidgetID=0){
		$productIDs = array();
		if ((int)$websiteWidgetID){
			$websiteWidgetInfo = oneByID(":websiteWidgets", $websiteWidgetID);
			if ($websiteWidgetInfo["websiteWidgetID"]){
				$hadWidget = 1;
				$productIDsArray = arrayFor(":websiteWidgetsProductsRels", array(
					"websiteWidgetID" => $websiteWidgetInfo["websiteWidgetID"],
					"sortColumn" => "websiteWidgetOrder",
					"sortDir" => "ASC",
				));
				foreach ($productIDsArray as $par){
					$productIDs[] = $par["productID"];
				}
			}
		}
		if (!$productIDs && $this->smartyVars["shoppingSession"]["orderFormID"] && !$hadWidget){
			$productIDsArray = arrayFor(":orderFormItems", array(
				"orderFormID" => $this->smartyVars["shoppingSession"]["orderFormID"],
			));
			foreach ($productIDsArray as $par){
				$productIDs[] = $par["productID"];
			}
		}
		
		if ($productIDs){
		
////////////////////////////////////////////////////////////////////////////
			$this->smartyVars["orderFormID"] = $this->smartyVars["shoppingSession"]["orderFormID"];
			$this->smartyVars["orderFormInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetOrderForms",
					"params" => array(
						"orderFormID" => $this->smartyVars["shoppingSession"]["orderFormID"],
						"getCouponData" => 1,
					),
				),
			)));
	
			$this->currencyID = $currencyID = $this->smartyVars["currencyID"] = $this->smartyVars["orderFormInfo"]["paymentGroupCurrencyID"];
	
			dbg($this->smartyVars["orderFormInfo"]);
	
			$this->allowedCoupons = array();
	
			foreach ((array)$this->smartyVars["orderFormInfo"]["coupons"] as $coupon){
				$this->allowedCoupons[$coupon["productID"]][$coupon["couponID"]] = $coupon;
			}
			
			$productsInfo = getMBAPIArray("GetProducts", array(
				"productID" => $productIDs,
				"productActive" => 1,
				"getProductAttributeData" => 1,
				"getCouponData" => 1,
				"getPreCouponData" => 1,
				"getAllOrderFormItemData" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getTLDData" => 1,
				"getCycleData" => 1,
				"getCycleGhostIDs" => 1,
			));
			dbg($productsInfo);
	
			foreach ($productsInfo as $k=>$product){
				if ($product["productDomainRequired"]==getAPIStatusID("productdependencyrules", "cannot")){
					unset($productsInfo[$k]);
				}
			}
			$productsInfo = array_values($productsInfo);
	
			$keyedProducts = array();
			$this->smartyVars["keyedVariants"] = array();
			$numVariants = 0;
			$numCycles = 0;
			foreach ($productsInfo as $k=>$v){
				
				if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
					$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
					if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
						$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
					} else {
						$preappliedCoupon = 0;
					}
				} else {
					$preappliedCoupon = 0;
				}
	
				$keyedProducts[$v["productID"]] =& $productsInfo[$k];
	
				foreach ((array)$productsInfo[$k]["productVariants"] as $vk=>$vv){
					$numVariants++;
					$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $productsInfo[$k]["productVariants"][$vk];
				}
	
				$validCycles = array();
				foreach ((array)$v["ghostCycles"] as $cycle){
					$numCycles++;
					$validCycles[] = $cycle["cycleID"];
				}
	
				dbg("testing product: ".$v["productID"]);
				$prices = array();
				if (isset($productsInfo[$k]["productVariantPrices"])){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						if (in_array($price["cycleID"], $validCycles)){
							$prices[$price["currencyID"]][$price["productVariantID"]."-".$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
				} else {
					dbg("didnt find prices");
				}
				foreach ($prices as $currency => $rows){
					$productPrice = array_values($rows);
					if ($preappliedCoupon){
						foreach ((array)$productPrice as $xk=>$tempprice){
							$productPrice[$xk][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
							$productPrice[$xk][0]["discountPrice"] = $productPrice[$xk][0]["productVariantPriceAmount"]-$productPrice[$xk][0]["discountAmount"];
						}
					}
					$productsInfo[$k]["prices"][$currency] = $productPrice;
				}
				$productsInfo[ $k ]["productComments"] = utf8_html_entity_decode($productsInfo[$k]["productComments"]);
				unset($productsInfo[$k]["productVariantPrices"]);
			}
	
			$this->smartyVars["products"] = array();
	
			foreach ($productIDs as $id){
				if ($keyedProducts[$id]){
					$this->smartyVars["products"][] = $keyedProducts[$id];
				}
			}
	
			dbg("smarty vars:");
			dbg($this->smartyVars);
	
			// count the number of products to help display differeny type of widgets
			$c = count($this->smartyVars["products"]);
			$this->smartyVars["numProducts"] = $c;
	
////////////////////////////////////////////////////////////////////////////

		}
		
	}
	
	function addPreappliedCoupons($ids){
		$ids = array_unique((array)$ids);
	
		$coupons = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetShoppingCoupons",
				"params" => array(
					"shoppingSessionID" => $this->shoppingSessionData["shoppingSessionID"],
				),
			),
		));

		$skip = array();
		foreach ((array)$coupons as $coupon){
			$skip[] = $coupon["couponID"];
		}
		foreach ($ids as $cid){
			if (!in_array($cid, $skip)){
				dispatchMBAPI(array(
					"mbapi" => array(
						"command" => "SetShoppingCoupon",
						"subCommand" => "insert",
						"params" => array(
							"shoppingSessionID" => $this->shoppingSessionData["shoppingSessionID"],
							"couponID" => $cid,
							"shoppingCouponType" => 1,
						),
					),
				));
			}
		}

	}

}