<?php
// $Id: CheckMultiDomainWhois.php 12717 2008-02-29 22:05:14Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/include/io/whois.php");
require_once mb_path("/lib-domain/include/whois/Whois.php");


/**
 * @author  Kris Bailey
 */
class CheckMultiDomainWhois extends MB_Action {
	function CheckMultiDomainWhois() {
		parent::MB_Action();
		$this->stringRep = "AddCartDomain";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the CheckMultiDomainWhois action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		dbg("show multi domain whois");

		$this->smartyVars = array();

		$orderFormID = $_REQUEST["orderFormID"];

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $orderFormID);

		$this->smartyVars["domainSLD"] = str_replace(array("http://", "https://", "www."), "", strtolower($_REQUEST["domainSLD"]));
		if (strpos($this->smartyVars["domainSLD"], ".")!==false){
			$this->smartyVars["domainSLD"] = substr($this->smartyVars["domainSLD"], 0, strpos($this->smartyVars["domainSLD"], "."));
		}
		$domainProducts = arrayFor("products", array(
			"getProductVariantData" => 1,
			"productType" => getAPITypeID("products", "domain"),
			"productActive" => 1,
		));
		$keyedProducts = array();
		foreach ((array)$domainProducts as $product){
			$keyedProducts[$product["productID"]] = $product;
		}
		$productIDs = array_keys($keyedProducts);
		
		dbg($keyedProducts);
		
		$orderFormItems = arrayFor(":orderFormItems", array(
			"orderFormID" => $orderFormID,
			"productID" => $productIDs,
		));
		
		dbg($orderFormItems);
		
		if (!count($orderFormItems)){
			$this->smartyVars["noDomainProductFound"] = 1;
		} else {
			$domainProductID = $orderFormItems[0]["productID"];
			$domainProduct =& $keyedProducts[$domainProductID];
			
			if (!$domainProduct){
				$this->smartyVars["noDomainProductFound"] = 1;
			} else {
				$tldIDs = array();
				$variants = $domainProduct["productVariants"];
				foreach ((array)$variants as $v){
					if ($v["productVariantActive"]){
						$tldIDs[] = $v["tldID"];
					}
				}
				$tlds = arrayFor(":tlds", array(
					"tldActive" => 1,
					"tldID" => $tldIDs,
				));
				$this->smartyVars["cycleInfo"] = getCyclesArray();
				$this->smartyVars["cycleValues"] = array();
				foreach ($this->smartyVars["cycleInfo"] as $cycleID=>$cycleName){
					$this->smartyVars["cycleValues"][$cycleID] = getNextBillingTimestamp(0, $cycleID);
				}
				$this->TLDInfo = array();
				$this->smartyVars["selectedTLD"] = strtolower($_REQUEST["domainTLD"]);
				foreach ($tlds as $tld){
					if ((int)$tld["tldAutoSearch"] || strtolower($tld["tldExtension"])==$this->smartyVars["selectedTLD"]){

						$server = $tld["tldWhoisServer"];
						$pattern = $tld["tldWhoisResp"];
						$extension = $tld["tldExtension"];

						if($server && !contains($server, "://")) {
							$server = "whois://${server}/";
						}
						
						$url =& new HTTPURL($server);

						$whois_service =& default_whois_service($extension);

						if($server) {
							$whois_service->protocol->setName($url->scheme);
							switch($url->scheme) {
								case "http":
								case "https":
									$whois_service->host = $server;
									break;
								default:
									$whois_service->host = $url->host;
									break;
							}
							$whois_service->port = $url->port;
						}
						if($pattern) {
							if(contains($pattern, "|")) {
								list($pattern, $reject_pattern) = explode("|", $pattern, 2);
							} else {
								$reject_pattern = NULL;
							}
	
							if(startswith($pattern, "!")) {
								$pattern = substr($pattern, 1);
								$not = true;
							} else {
								$not = false;
							}
	
							$whois_service->available_condition =& new WhoisCondition($pattern, $not);
	
							if($reject_pattern) {
								if(startswith($reject_pattern, "!")) {
									$reject_pattern = substr($reject_pattern, 1);
									$reject_not = true;
								} else {
									$reject_not = false;
								}
								$whois_service->reject_condition =& new WhoisCondition($reject_pattern, $reject_not);
							} else {
								$whois_service->reject_condition = NULL;
							}
						}
						//show($whois_service);

						$this->TLDInfo[$extension] =& $whois_service;
					}
				}
				//show($this->TLDInfo, 1);
				//exit();
				if(version_compare(phpversion(), "5.0", ">=")) {
						$w =& new AsyncWhois(array($this->smartyVars["domainSLD"]), $this->TLDInfo, "updateDomainAvailability");
						$w->complete();
				} else {

						foreach ($this->TLDInfo as $tldInfo){

								$domToCheck =& new Whois($this->smartyVars["domainSLD"], $tldInfo[0]);
								$domToCheck->execute();
								$domToCheck->setIsAvailable();
								if ($domToCheck->getIsAvailable()){
										updateDomainAvailability($this->smartyVars["domainSLD"],$tldInfo[0],true);
								} else {
										updateDomainAvailability($this->smartyVars["domainSLD"],$tldInfo[0],false);
								}
						}
				}

			}
			
		}
			
		
//		$this->addErrorTemplates();
//		return $this->hasExecutedSuccessfully();
	}

} // CheckMultiDomainWhois

function updateDomainAvailability($sld, $tld, $available){
	dbg($sld);
	dbg($tld);
	dbg($available);
	?>
	<script language="javascript">
		parent.<?php echo $_REQUEST["jsCallbackFunction"];?>('<?php echo $sld;?>', '<?php echo $tld;?>', '<?php echo str_replace("'", "\\'", $available);?>');
	</script>
	<?php
	echo $sld.".".$tld." is ".($available===true?"available":($available)?"'".$available."'":"not available")."<br />";
	flush();
}


