<?php
// $Id: CheckWhois.php 12346 2007-12-11 22:33:24Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on all orderForms that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Mark Garrett
 */
class CheckWhois extends MB_Action {
	/**
	 * The constructor for a CheckWhois action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function CheckWhois() {
		parent::MB_Action();
		$this->stringRep = "CheckWhois";
		$this->params = array(
			"sld",
			"tld",
			"sid",
			"trans",
			"idn",
			"set_locale"
			);
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the CheckWhois action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$ofdata = NULL;

		$CONF["theme"]["type"] = "public";

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		$orderObjectParams = array(
			"ofid" => $shoppingSessionData["orderFormID"],
			"sid" => $shoppingSessionData["shoppingSessionID"],
			"set_locale" => "en_US",
		);
		$orderobj =& new Order($orderObjectParams);

		$_REQUEST["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];

		$orderobj->orderFormSessionID = $this->paramArgs["sid"];

		if($this->paramArgs["sld"] && $this->paramArgs["tld"]) {
			require_once(mb_path("/lib-domain/include/whois/Whois.php"));
			$smartyVars = array();

			//quick check to remove periods in slds. Needs to be replaced with better checking!
			$this->paramArgs["sld"] = eregi_replace("^www\.", "", $this->paramArgs["sld"]);
			$this->paramArgs["sld"] = str_replace(" ", "", $this->paramArgs["sld"]);

			// Check to see if this is an IDN name. if so, we need to see if this TLD supports
			if (utf8_decode($this->paramArgs["sld"]) !== $this->paramArgs["sld"] && $this->paramArgs["idn"]){
				require_once mb_path("/lib-domain/include/idna/idna_convert.class.php");
				$idn = new Net_IDNA_php4();
				$encoded = $idn->encode($this->paramArgs["sld"]);
				$decoded = $idn->decode($encoded);

				// Double check that the encoding works
				if ($this->paramArgs["sld"] === $decoded){
					$nativeName = $this->paramArgs["sld"];
					$this->paramArgs["sld"] = str_replace("&#45;", "-", $encoded);
				}
			}else{
				$this->paramArgs["sld"] = str_replace("&#45;", "-", $this->paramArgs["sld"]);
				$this->paramArgs["sld"] = strtolower($this->paramArgs["sld"]);
			}

			//Check the sld
			if (!preg_match ("/^[a-z0-9]([a-z0-9\-]*[a-z0-9])?$/i", $this->paramArgs["sld"])) {
				$this->addError(TRANS_INVALIDDOMAINNAME, TRANS_ENTERVALIDDOMAINNAME);
			} else {

				$domToCheck =& new Whois($this->paramArgs["sld"], $this->paramArgs["tld"]);

				/**
				 * GET TLD WHOIS SERVER AND SET $domToCheck->whoisServer = XXX
				 */

				$domToCheck->execute();
				$domToCheck->setIsAvailable();

				//Switch back the name if it was an IDN name

				if($nativeName){
					$PUNYcode = $this->paramArgs["sld"];
					$this->paramArgs["sld"] = $nativeName;
				}

				if (($domToCheck->getIsAvailable() && $this->paramArgs["trans"] == 0) || (!$domToCheck->getIsAvailable() && $this->paramArgs["trans"] == 1)){
					$smartyVars["whoisCheck"]["available"] = TRUE;
					$domainInfo = $orderobj->getDomainInfo($this->paramArgs["tld"]);

					$priceSelectArray = array();

					dbg($domainInfo["pricing"][$this->paramArgs["tld"]]);

					if (is_array($domainInfo)){
						foreach($domainInfo["pricing"][$this->paramArgs["tld"]] as $price){
							if(!isset($used[$price["cycleID"]."|".$price["productPriceType"]]) && $price["cycleID"]){
								$used[$price["cycleID"]."|".$price["productPriceType"]] = $price;
							}
							if ($price["cycleID"] == $price["tldTransferMinimumCycleID"] && $price["productTransfer"] && $this->paramArgs["trans"] == 1 && $price["tldIsTransferable"]){
								$smartyVars["domainTransfer"] = $CONF["user"]["locale"]->getLocaleCurrency($price["productTransfer"], $orderobj->orderFormCurrency);
								$smartyVars["domainProdID"] = $price["productID"];
								$smartyVars["productVariantID"] = $price["productVariantID"];
								if($price["productSetupPrice"]){
									$smartyVars["domainTransfer"] .=" + ".TRANS_SETUP.": ".$CONF["user"]["locale"]->getLocaleCurrency($price["productSetup"], $orderobj->orderFormCurrency);
								}
							}
						}

						foreach($used as $price2){
							$cycleDisplayName = (defined($price2["cycleDisplayName"])) ? constant($price2["cycleDisplayName"]) : $price2["cycleDisplayName"];
							$priceSelectArray[$price2["cycleID"]."|".$price2["productID"]."|".$price2["productVariantID"]."|".$_REQUEST["shoppingItemID"]] = $cycleDisplayName." - ".$CONF["user"]["locale"]->getLocaleCurrency($price2["productPrice"], $orderobj->orderFormCurrency);
							if((float)$price2["productSetupPrice"] > 0.00){
								$priceSelectArray[$price2["cycleID"]."|".$price2["productID"]."|".$price2["productVariantID"]."|".$_REQUEST["shoppingItemID"]] .=" + ".TRANS_SETUP.": ".$CONF["user"]["locale"]->getLocaleCurrency($price2["productSetupPrice"], $orderobj->orderFormCurrency);
							}
						}
					}
					if ($this->paramArgs["trans"]==1 && !isset($smartyVars["domainTransfer"])){
						$smartyVars["whoisCheck"]["available"] = FALSE;
						$smartyVars["domainTransfer"] = 1;
					}
				}else{
					$smartyVars["whoisCheck"]["available"] = FALSE;
					if ($this->paramArgs["trans"] == 1){
						$smartyVars["domainTransfer"] = 1;
					}
				}

				$smartyVars["shoppingItemID"] = $_REQUEST["shoppingItemID"];
				$smartyVars["priceSelectArray"] = $priceSelectArray;
				$smartyVars["domainName"] = $this->paramArgs["sld"].".".$this->paramArgs["tld"];
				if ($PUNYcode){
					$smartyVars["PUNYcode"] = $PUNYcode.".".$this->paramArgs["tld"];
					$this->mergeIDNLanguageData($CONF["user"]["locale"]->language);
					$smartyVars["idnLanguageList"] = $this->smartyVars["idnLanguageList"];
					$smartyVars["selectedLanguage"] = $this->smartyVars["selectedLanguage"];
				}
				$smartyVars["sid"] = $orderobj->orderFormSessionID;
				$smartyVars["set_locale"] = $orderobj->orderFormLocale;
				$orderobj->orderFormData = NULL;
   				$smartyVars["ofCssDir"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];

				if ((int)$_REQUEST["whoisWidget"]){
					$smartyVars["whoisCall"] = (int)$_REQUEST["whoisWidget"];
				}

				$this->addTemplate("shopping/CheckWhois", collapseArrayElements($smartyVars));
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CheckWhois
?>
