<?php
// $Id: DisassociateDomain.php 12080 2007-10-12 00:20:23Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class DisassociateDomain extends MB_Action {
	/**
	 * The constructor for a DisassociateDomain action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function DisassociateDomain() {
		parent::MB_Action();
		$this->stringRep = "DisassociateDomain";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddCartDomain action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);

		if ((int)$_REQUEST["shoppingItemsDomainsRelID"]){
		
			$shoppingItem = oneOf(":shoppingItems", array(
				"shoppingItemID" => (int)$_REQUEST["shoppingItemID"],
				"shoppingSessionID" => $_REQUEST["sid"],
			));
		
			if ($shoppingItem["shoppingItemID"]){
		
				$domainRels = arrayFor(":shoppingItemsDomainsRels", array(
					"shoppingItemID" => $shoppingItem["shoppingItemID"],
				));
				
				$firstDomain = -1;
				foreach ((array)$domainRels as $dr){
					if ($dr["shoppingItemsDomainsRelID"]==(int)$_REQUEST["shoppingItemsDomainsRelID"]){
						if ($dr["domainShoppingItemID"]==$shoppingItem["shoppingItemPrimaryDomainID"]){
							$firstDomain = 0;
						}
						$removeXML = "	<mbapi>
											<command>SetShoppingItemsDomain</command>
											<subCommand>delete</subCommand>
											<params>
												<shoppingItemsDomainsRelID>".(int)$_REQUEST["shoppingItemsDomainsRelID"]."</shoppingItemsDomainsRelID>
											</params>
										</mbapi>";
						dbg(dispatchMBAPI($removeXML, 1));
					}
				}
				if ($firstDomain>-1){
					foreach ((array)$domainRels as $dr){
						if ($dr["shoppingItemsDomainsRelID"]!=(int)$_REQUEST["shoppingItemsDomainsRelID"]){
							updateForKey(":shoppingItems", $shoppingItem["shoppingItemID"], array(
								"shoppingItemPrimaryDomainID" => $dr["domainShoppingItemID"],
							));
							break;
						}
					}
				}
			
			}
		}

        if ($_REQUEST["redirectURL"]!="") {
            redirect($_REQUEST["redirectURL"]);
        } else {
            redirect("cart.php?sid=".secureInput($_REQUEST["sid"]));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // DisassociateDomain
?>