<?php
// $Id: EditCartProductResponse.php 12080 2007-10-12 00:20:23Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a products associated addon children products and displays it.
 *
 * @author  Kris Bailey
 */
class EditCartProductResponse extends MB_Action {
	/**
	 * The constructor for a EditCartProductResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditCartProductResponse() {
		parent::MB_Action();
		$this->stringRep = "EditCartProductResponse";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the EditCartProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		dbg("request:");
		dbg($_REQUEST);

		$this->smartyVars = array();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $_REQUEST["orderFormID"], 1);

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;

		$this->smartyVars["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];

		$getShoppingItemXML = "	<mbapi>
									<command>GetShoppingItems</command>
									<params>
										<shoppingItemID>".(int)$_REQUEST["shoppingItemID"]."</shoppingItemID>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
									</params>
								</mbapi>";
		$shoppingItem = dispatchMBAPI($getShoppingItemXML, 1);
		if (isset($shoppingItem["mbapi"][0]["results"][0]["shoppingItems"][0]) && isset($shoppingItem["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			$shoppingItem = correctArray($shoppingItem["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0]);
		}

		dbg("shopping item");
		dbg($shoppingItem);

		if ($shoppingItem["shoppingItemID"]){

			$getSelectedAddonsXML = "	<mbapi>
											<command>GetShoppingItems</command>
											<params>
												<parentShoppingItemID>".(int)$_REQUEST["shoppingItemID"]."</parentShoppingItemID>
											</params>
										</mbapi>";
			$selectedAddons = dispatchMBAPI($getSelectedAddonsXML, 1);
			dbg("selected addons");
			dbg($selectedAddons);
			$this->smartyVars["selectedAddons"] = array();
			if (isset($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
				foreach ($selectedAddons["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"] as $row){
					$this->smartyVars["selectedAddons"][$row["productID"][0]] = 1;
				}
			}
			$currentAddons = array_keys($this->smartyVars["selectedAddons"]);

			$cycleID = (int)$_REQUEST["cycleID"] ? (int)$_REQUEST["cycleID"] : $shoppingItem["cycleID"];

			$productsInfoXML = "
							<mbapi>
								<command>GetProducts</command>
								<params>
										<productID>".(int)$shoppingItem["productID"]."</productID>
										<getProductAttributeData>1</getProductAttributeData>
										<getCouponData>1</getCouponData>
										<getProductVariantData>1</getProductVariantData>
										<getProductVariantPriceData>1</getProductVariantPriceData>
										<getTLDData>1</getTLDData>
										<getCycleData>1</getCycleData>
								</params>
							</mbapi>";
			$productsInfo = dispatchMBAPI($productsInfoXML, 1);
			dbg("products info");
			dbg($productsInfo);
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]);

			dbg("products info parsed");
			dbg($productsInfo);

			if ($productsInfo["productID"]){

			 	$this->smartyVars["productID"] = $productsInfo["productID"];
				$thisprice = array();

			 	if (isset($productsInfo["productVariantPrices"])){
					foreach ($productsInfo["productVariantPrices"] as $price){
				 		if ($shoppingItem["productVariantID"]==$price["productVariantID"] && $price["cycleID"]==$cycleID && $price["currencyID"]==$this->smartyVars["currencyID"]){
							dbg("price here:");
							dbg($price);
							$thisprice[$price["productVariantPriceType"]] = $price;
						}
					}
				}
				unset($productsInfo[$k]["productVariantPrices"]);

				$primaryDomainXML = ((int)$_REQUEST["shoppingItemPrimaryDomainID"]) ?
					"<shoppingItemPrimaryDomainID>".(int)$_REQUEST["shoppingItemPrimaryDomainID"]."</shoppingItemPrimaryDomainID>" :
					"";

				$updateProductXML = "	<mbapi>
											<command>SetShoppingItem</command>
											<subCommand>update</subCommand>
											<params>
												<productID>".$shoppingItem["productID"]."</productID>
												<productVariantID>".$shoppingItem["productVariantID"]."</productVariantID>
												<shoppingItemID>".$shoppingItem["shoppingItemID"]."</shoppingItemID>
												<cycleID>".$thisprice[0]["cycleID"]."</cycleID>
												<shoppingItemPrice>".$thisprice[0]["productVariantPriceAmount"]."</shoppingItemPrice>
												<shoppingItemSetupPrice>".$thisprice[1]["productVariantPriceAmount"]."</shoppingItemSetupPrice>
												$primaryDomainXML
											</params>
										</mbapi>";
				dbg("update results");
				if ($thisprice[0]){
					dbg(dispatchMBAPI($updateProductXML, 1));
				}

				if (count($currentAddons)){
					$_REQUEST["redirectURL"] = "cart.php?addType=addons&sid=".secureInput($_REQUEST["sid"])."&action=".getActionID("AddCartProductResponse")."&shoppingItemID=".$shoppingItem["shoppingItemID"]."&";
					foreach ($currentAddons as $cid){
					 	$_REQUEST["redirectURL"] .= "addonID[]=".$cid."&";
					}
				}

			}
		}

        if ($_REQUEST["redirectURL"]!="") {
            redirect($_REQUEST["redirectURL"]);
        } else {
            redirect("cart.php?sid=".secureInput($_REQUEST["sid"]));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>
