<?php
// $Id: OrderFormProvisioning.php 12694 2008-02-26 22:50:18Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

/**
* This Action object calls the ProcessCheckout command that creates their packages and invoice and billing
*	accounts and shares and charges depending.
*
* @author  Kris Bailey
*/
class OrderFormProvisioning extends MB_Action {
	
	function OrderFormProvisioning() {
		parent::MB_Action();
		$this->stringRep = "OrderFormProvisioning";

		$this->params = array("systemQueueID");
		$this->sortColumns = array();
	}

	/**
	* The main method of this class that executes the OrderFormProvisioning action, and returns success or failure.
	*
	* @return  1 if this action executed successfully, or 0 if otherwise.
	*/
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		dbg("shopping session");
		dbg($shoppingSessionData);

		$clientID = (int)$shoppingSessionData["clientID"];

		if (count($_REQUEST["systemQueueID"])){
			$systemQueueItems = arrayFor(":systemQueue", array(
				"systemQueueID" => $_REQUEST["systemQueueID"],
			));
			dbg("system queue items:");
			dbg($systemQueueItems);
			$packageIDs = array();
			foreach ($systemQueueItems as $systemQueueItem){
				$packageIDs[] = $systemQueueItem["packageID"];
			}
			$packages = arrayFor(":packages", array(
				"packageID" => $packageIDs,
			));
			$keyedPackages = array();
			foreach ($packages as $x=>$package){
				$keyedPackages[$package["packageID"]] =& $packages[$x];
			}
			
			dbg("keyed packages");
			dbg($keyedPackages);
			
			$allAttributes = arrayFor(":packageAttributes", array(
				"packageID" => $packageIDs,
			));
			$keyedAttributes = array();
			foreach ($allAttributes as $x=>$attr){
				if(strpos($attr["packageAttributeName"],"Password")) {
					$allAttributes[$x]["packageAttributeValue"] = getStuff($attr["packageAttributeValue"]);
				}
				$keyedAttributes[$attr["packageID"]][$attr["serverGroupID"]]["{".$attr["packageAttributeName"]."}"] =& $allAttributes[$x]["packageAttributeValue"];
			}
			
			
			$runSystemQueueItems = array();
			foreach ($systemQueueItems as $systemQueueItem){
				$systemQueuePackage =& $keyedPackages[$systemQueueItem["packageID"]];
				dbg("system queue package: ");
				dbg($systemQueuePackage);
				if (!(int)$keyedAttributes[$systemQueueItem["packageID"]][$systemQueueItem["serverGroupID"]]["{provisionImmediately}"]){
					dbg("this one is not supposed to provision immediately...");
					continue;
				}
				if ($clientID==$systemQueuePackage["clientID"]){
					$results = dispatchMBAPI(dbg(toXML(array(
						"mbapi" => array(
							"command" => "ProcessSystemQueue",
							"params" => array(
								"systemQueueID" => $systemQueueItem["systemQueueID"],
							),
						),
					))), 1);
					$runSystemQueueItems[] = $systemQueueItem["systemQueueID"];
				} else {
					dbg("clientID $clientID does not match: ".$systemQueuePackage["clientID"]);
				}
			}
			
			$runSystemQueueItems = arrayFor(":systemQueue", array(
				"systemQueueID" => $runSystemQueueItems,
			));
			
			dbg("run system queue items");
			dbg($runSystemQueueItems);
			
			if (count($runSystemQueueItems)){
			
				// need to re-get all attributes because they have new values or there are new ones period
				// after provisioning
				$allAttributes = arrayFor(":packageAttributes", array(
					"packageID" => $packageIDs,
				));
				$keyedAttributes = array();
				foreach ($allAttributes as $x=>$attr){
					if(strpos($attr["packageAttributeName"],"Password")) {
						$allAttributes[$x]["packageAttributeValue"] = getStuff($attr["packageAttributeValue"]);
					}
					$keyedAttributes[$attr["packageID"]][$attr["serverGroupID"]]["{".$attr["packageAttributeName"]."}"] =& $allAttributes[$x]["packageAttributeValue"];
				}
			
				$defaultTemplate = "
					<table class='instantProvisioningResults' border='0'>
						<tr>
							<th colspan='2'>".TRANS_YOUR_ACCOUNT_FOR." \"{packageName}\" ".TRANS_HAS_BEEN_CREATED."</th>
						</tr>
						<tr>
							<th align='right'>".TRANS_USERNAME."</th>
							<td>{domainUserName}</td>
						</tr>
						<tr>
							<th align='right'>".TRANS_PASSWORD."</th>
							<td>{domainPassword}</td>
						</tr>
					</table>
				";
				//orderformDisplayMessage
				$this->smartyVars["systemQueueResults"] = array();
				foreach ($runSystemQueueItems as $systemQueueItem){
					dbg("setting up the data for system queue item");
					dbg($systemQueueItem);
					dbg("attributes for it");
					dbg($keyedAttributes[$systemQueueItem["packageID"]][$systemQueueItem["serverGroupID"]]);
					$displayMessage = $keyedAttributes[$systemQueueItem["packageID"]][$systemQueueItem["serverGroupID"]]["{orderformDisplayMessage}"];
					unset($keyedAttributes[$systemQueueItem["packageID"]][$systemQueueItem["serverGroupID"]]["orderformDisplayMessage"]);
					$thisAttributes =& $keyedAttributes[$systemQueueItem["packageID"]][$systemQueueItem["serverGroupID"]];
					if (!trim($displayMessage)){
						$displayMessage = $defaultTemplate;
					}
					$this->smartyVars["systemQueueResults"][] = array(
						"systemQueueStatus" => getAPIStatusName("queue", $systemQueueItem["systemQueueStatus"]),
						"packageName" => $keyedPackages[$systemQueueItem["packageID"]]["packageName"],
						"displayInfo" => str_replace("{packageName}", $keyedPackages[$systemQueueItem["packageID"]]["packageName"], str_replace(array_keys($thisAttributes), array_values($thisAttributes), $displayMessage)),
					);
				}
				
				if (!count($this->smartyVars["systemQueueResults"])){
					$this->smartyVars["noQueueItems"] = 1;
				}
			} else {
				$this->smartyVars["noQueueItems"] = 1;
			}
			
		} else {
			$this->smartyVars["noQueueItems"] = 1;
		}

		dbg($this->smartyVars);

		$this->addTemplate("shopping/OrderFormProvisioning", $this->smartyVars);
				
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}


} // OrderFormProvisioning
