<?php
// $Id: ProcessCartCheckoutLoader.php 11466 2007-06-28 19:42:50Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays a loading page and submits to the next step.
 *
 * @author  Kris Bailey
 */
class ProcessCartCheckoutLoader extends MB_Action {
	/**
	 * The constructor for a ProcessCartCheckoutLoader action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ProcessCartCheckoutLoader() {
		parent::MB_Action();
		$this->stringRep = "ProcessCartCheckoutLoader";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ProcessCartCheckoutLoader action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		
		$this->smartyVars["passVar"] = $_REQUEST["passVar"];
		$this->smartyVars["termAgreement"] = $_REQUEST["termAgreement"];
        if ($_REQUEST["awo"]) {
		    $this->smartyVars["awo"] = (int) $_REQUEST["awo"];
		    $this->smartyVars["awid"] = (int) $_REQUEST["awid"];
        }

		$this->addTemplate("shopping/CheckoutLoader", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}




} // ProcessCartCheckoutLoader
?>
