<?php
// $Id: ProcessCartLoginResponse.php 11423 2007-06-22 20:36:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action Handles logging in a client in their shopping session.
 *
 * @author  Kris Bailey
 */
class ProcessCartLoginResponse extends MB_Action {
	/**
	 * The constructor for a ProcessCartLoginResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ProcessCartLoginResponse() {
		parent::MB_Action();
		$this->stringRep = "ProcessCartLoginResponse";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ProcessCartLoginResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";
		dbg($_REQUEST);
		$this->smartyVars = array();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $_REQUEST["orderFormID"], 1);

		if ((int)$_REQUEST["logout"]){

			$setSessionLoginXML = "	<mbapi>
										<command>SetShoppingSession</command>
										<subCommand>update</subCommand>
										<params>
											<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
											<clientID>0</clientID>
											<clientContactID>0</clientContactID>
										</params>
									</mbapi>";
			$setResult = dispatchMBAPI($setSessionLoginXML, 1);
			dbg("logout shopping session result:");
			dbg($setResult);

		} else {

			$loginXML = "	<mbapi>
								<command>ProcessCartLogin</command>
								<params>
									<contactUsername>".secureInput($_REQUEST["contactUsername"])."</contactUsername>
									<contactPassword>".secureInput($_REQUEST["contactPassword"])."</contactPassword>
								</params>
							</mbapi>";
			$loginResult = dispatchMBAPI($loginXML, 1);
			dbg("login result:");
			dbg($loginResult);

			$clientID = (int)$loginResult["mbapi"][0]["results"][0]["clientID"][0];
			$clientContactID = (int)$loginResult["mbapi"][0]["results"][0]["clientContactID"][0];
			if ($clientID){
				$setSessionLoginXML = "	<mbapi>
											<command>SetShoppingSession</command>
											<subCommand>update</subCommand>
											<params>
												<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
												<clientID>".$clientID."</clientID>
												<clientContactID>".$clientContactID."</clientContactID>
											</params>
										</mbapi>";
				$setResult = dispatchMBAPI($setSessionLoginXML, 1);
				dbg("set session client id result:");
				dbg($setResult);

			} else {
				$_REQUEST["redirectURL"] = "cart.php?sid=".secureInput($_REQUEST["sid"])."&incorrectLogin=yes";
				if ((int)$_REQUEST["gotoCheckout"]){
					$_REQUEST["redirectURL"] .= "&action=".getActionID("ShowCartCheckoutForm");
				}
				dbg("bad url");
			}

		}


        if ($_REQUEST["redirectURL"]!="") {
        	dbg("going to url");
            redirect($_REQUEST["redirectURL"]);
        } else {
			if ((int)$_REQUEST["gotoCheckout"]){
				dbg("going to checkout");
            	redirect("cart.php?sid=".secureInput($_REQUEST["sid"])."&action=".getActionID("ShowCartCheckoutForm"));
			} else {
				dbg("going to cart");
            	redirect("cart.php?sid=".secureInput($_REQUEST["sid"]));
			}
        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ProcessCartLoginResponse
?>
