<?php
// $Id: ProcessCartRegister.php 12651 2008-02-18 20:56:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-action/include/wizard/Wizard.php");

/**
 * This Action object takes in crm info then forwards to the checkout confirm page.
 *
 * @author  Kris Bailey
 */
class ProcessCartRegister extends MB_Action {
	/**
	 * The constructor for a ProcessCartRegister action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ProcessCartRegister() {
		parent::MB_Action();
		$this->stringRep = "ProcessCartRegister";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ProcessCartRegister action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		loadConfigs("payment");

		$CONF["theme"]["type"] = "public";


		$this->additionalInfo = array();
		foreach ($_REQUEST as $k=>$v){
			if (substr($k, 0, strlen("question_"))=="question_"){
				$ids = explode("_", $k);
				//     additionalInfo[shoppingItemID][questionID]
				$this->additionalInfo[$ids[1]][$ids[2]] = $v;
			}
		}
		dbg("wizard based input:");
		dbg($this->additionalInfo);


		$this->monthlyCycles = getCyclesArray("monthly");
		$this->ppcID = 0;
		$this->ppcName = "";
		$this->ppcPrice = 0;
		$this->ppcType = 0;


		$this->smartyVars = array();
		$this->smartyVars["checkoutFormInfo"] = $_REQUEST;
		$this->smartyVars["paymentType"] = $_REQUEST["paymentType"];
//		$this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		$this->mergeCycleData();

		$regInfo = array();
   		$regInfo["registrantFirstName"] = $_REQUEST["registrantFirstName"];
		$regInfo["registrantLastName"] = $_REQUEST["registrantLastName"];
		$regInfo["registrantOrganizationName"] = $_REQUEST["registrantOrganizationName"];
		$regInfo["registrantAddress1"] = $_REQUEST["registrantAddress1"];
		$regInfo["registrantAddress2"] = $_REQUEST["registrantAddress2"];
		$regInfo["registrantCity"] = $_REQUEST["registrantCity"];
		$regInfo["registrantStateProvince"] = $_REQUEST["registrantStateProvince"];
		$regInfo["registrantCountry"] = $_REQUEST["registrantCountry"];
		$regInfo["registrantPostalCode"] = $_REQUEST["registrantPostalCode"];
		$regInfo["registrantEmail"] = $_REQUEST["registrantEmail"];
		$regInfo["registrantPhone"] = $_REQUEST["registrantPhone"];
		$regInfo["registrantFax"] = $_REQUEST["registrantFax"];
		$regInfo["registrantJobTitle"] = $_REQUEST["registrantJobTitle"];

		setcookie("mb_domain_info", base64_encode(serialize($regInfo)), (24*60*60*30)+time(), "/");

/**********************************************************************************************
 * get cart info here, will use to create command.
 */

 		$this->smartyVars["hasDomain"] = false;

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;
		$this->smartyVars["orderParams"] = $order->getOrderParams();

		$this->orderObj =& $order;

		$this->orderFormData =& $order->orderFormData;

		$languagesArray = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetLanguages</command><params><languageISO2>".$CONF["user"]["locale"]->language."</languageISO2></params></mbapi>", 1)));
		dbg("languages:");
		dbg($languagesArray);
		foreach ($languagesArray as $language) {
			$order->orderFormLanguageID = $language["languageID"];
		}

		dbg($CONF["user"]["locale"]);
		
		dbg("ORDER OBJ");
		dbg($order);

		$this->smartyVars["continueShoppingURL"] = str_replace("%SID%", $_REQUEST["sid"], $order->continueShoppingURL);

		$shoppingCouponsXML = "	<mbapi>
									<command>GetShoppingCoupons</command>
									<params>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
										<getCouponsData>1</getCouponsData>
									</params>
								</mbapi>";
		$shoppingCoupons = (array)correctArray(grabSimpleMBAPIResults(dispatchMBAPI($shoppingCouponsXML, 1)));

		$this->smartyVars["coupons"] = $shoppingCoupons;

		$shoppingItemsXML = "
				<mbapi>
					<command>GetShoppingItems</command>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						<getDomainsRelData>1</getDomainsRelData>
					</params>
				</mbapi>";

		$shoppingItems = dispatchMBAPI($shoppingItemsXML, 1);

		if (isset($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			$shoppingItems = correctArray($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]);
		} else {
			$shoppingItems = array();
		}

		//dbg("shopping items:");
		//dbg($shoppingItems);

		$getProductIDs = array();
		$getProductVariantIDs = array();
		$getProductIDs[0] = 1;
		foreach ($shoppingItems as $row){
		 	$getProductIDs[$row["productID"]] = 1;
		 	$getProductVariantIDs[$row["productVariantID"]] = 1;
		}

////////////////////////////////////////
		// get products info here:
   		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", array_keys($getProductIDs))."</productID>
									<filterVariants>
										<productVariantID>".@implode("</productVariantID><productVariantID>", array_keys($getProductVariantIDs))."</productVariantID>
									</filterVariants>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getCycleData>1</getCycleData>
							</params>
						</mbapi>";
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		if (isset($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0])){
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
		} else {
			$productsInfo = array();
		}

		loadConfigs("billing", "invoice");
		$gentime = time()+10;
		if ($CONF["billing"]["invoice"]["billingMode"]=="monthly"){
			$noProratedProducts = true;
			foreach ($productsInfo as $prod){
				if ((int)$prod["productProratable"]){
					$noProratedProducts = false;
				}
			}
			if ($noProratedProducts==false){
				$gentime += (60*20);
			}
		}
		$this->smartyVars["packageDateNextRenewal"] = $gentime;
		//dbg("products info");
		//dbg($productsInfo);

		$this->smartyVars["products"] = array();
		$this->smartyVars["productVariantTaxZoneGroupIDs"] = array();
		$addonGroupIDs = array();
		foreach ($productsInfo as $row){
			if ((int)$row["productAddonGroupID"]){
				$addonGroupIDs[] = (int)$row["productAddonGroupID"];
			}
			$coupons = array();
			if (isset($row["coupons"])){
				foreach ($row["coupons"] as $coupon){
					$coupons[$coupon["couponID"]] = $coupon;
				}
			}
			$row["coupons"] = $coupons;
			$this->smartyVars["products"][$row["productID"]] = $row;
			if (isset($row["productVariants"])){
				foreach ($row["productVariants"] as $variant){
					$this->smartyVars["productVariantTaxZoneGroupIDs"][$variant["productVariantID"]] = (int)$variant["taxZoneGroupID"];
				}
			}
		}


		$addonGroupInfo = correctArray(grabResultsFromMBAPIArray(array("mbapi" => array(
			"command" => "GetProductAddonGroups",
			"params" => array(
				"productAddonGroupID" => $addonGroupIDs+array(0),
			),
		))));

		$keyedAddonGroups = grabHtmlOpsFromArray($addonGroupInfo, "productAddonGroupID", "productAddonGroupName");

////////////////////////////////////////

		$keyedItems = array();
		$keyedDomains = array();
		$this->smartyVars["domainsExtraInfo"] = array();
		$this->smartyVars["wizardShoppingItems"] = array();
		foreach ($shoppingItems as $row){
			$this->smartyVars["wizardShoppingItems"][$row["shoppingItemID"]] = $row["productID"];
			if ($this->smartyVars["products"][$row["productID"]]["productType"]==getAPITypeID("products", "domain")){
 				$this->smartyVars["hasDomain"] = true;
 				if ($row["shoppingItemDomainType"]==0){
 					dbg("getting extra info");
					$domdata = getTLDParamsData($row["shoppingItemSLD"].".".$row["shoppingItemTLD"]);
					dbg("extra info was");
					dbg($domdata);
					if ($domdata){
						dbg("added it to smarty");
						$this->smartyVars["domainsExtraInfo"][$row["shoppingItemSLD"].".".$row["shoppingItemTLD"]] = correctArray($domdata);
						$domdata = NULL;
					} else {
						dbg("didn't add it to smarty");
					}
				}
			}
		 	if (isset($row["domains"])){
		 		//dbg("DOMAIN EXISTED!");
				foreach ($row["domains"] as $row2){
				 	$keyedDomains[$row2["domainShoppingItemID"]] = $row2;
				}
			} else {
				$row["domains"] = array();
			}
			$appliedCoupons = array();
			$couponTotal = 0;
			foreach ($this->smartyVars["coupons"] as $k=>$coupon){
				if ((int)$this->smartyVars["products"][$row["productID"]]["coupons"][$coupon["couponID"]]["couponID"]
				 && !count($appliedCoupons)
				 && ($coupon["couponApplyNumber"]==0 || $coupon["applied"]<1)){
					if ((int)$coupon["couponType"]){
					 	$coupon["discount"] = $coupon["couponDiscount"];
					} else {
						$coupon["discount"] = round(($coupon["couponDiscount"]/100)*$row["shoppingItemPrice"], 2);
					}
					$coupon["negdiscount"] = 0-$coupon["discount"];
					$appliedCoupons[] = $coupon;
					$this->smartyVars["coupons"][$k]["discountTotal"] = round($this->smartyVars["coupons"][$k]["discountTotal"]+$coupon["discount"], 2);
					$this->smartyVars["coupons"][$k]["applied"]++;
					$couponTotal = round($coupon["discount"]+$couponTotal, 2);
				}
			}
			$row["appliedCoupons"] = $appliedCoupons;
			$row["couponTotal"] = $couponTotal;

			$key = (int)$row["parentShoppingItemID"];

			if (!$this->smartyVars["products"][$row["productID"]]["productIsAddon"]){
				$key = 0;
			}

			$keyedItems[$key][] = $row;

		}
		//dbg("keyed domains:");
		//dbg($keyedDomains);

		$this->smartyVars["shoppingItems"] = (array)$keyedItems[0];

		foreach ($this->smartyVars["shoppingItems"] as $k=>$v){
			$addonTotal = 0;
			if (isset($keyedItems[$v["shoppingItemID"]])){
			   	foreach ($keyedItems[$v["shoppingItemID"]] as $row){
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemSetupPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal-round($row["couponTotal"], 2), 2);
				}
			}
		 	$this->smartyVars["shoppingItems"][$k]["children"] = $keyedItems[$v["shoppingItemID"]];
		 	$this->smartyVars["shoppingItems"][$k]["addonPrice"] = $addonTotal;
		}


		$this->smartyVars["paymentOptions"] = $order->getPaymentOptions();
		$this->smartyVars["paymentOptions"]["cardTypes"] = $this->getAcceptedCardTypesByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
		$this->smartyVars["paymentOptions"]["echeck"] = $this->getGatewayeCheckByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
		$this->smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];
		for ($i=date("Y"); $i<date("Y")+21; $i++){
			$this->smartyVars["cardYears"][$i] = $i;
		}

		if (!$this->smartyVars["paymentOptions"]["cc"] && !$this->smartyVars["paymentType"]){
			if ($this->smartyVars["paymentOptions"]["check"]){
				$this->smartyVars["paymentType"] = 3;
			} elseif ($this->smartyVars["paymentOptions"]["invoice"]){
				$this->smartyVars["paymentType"] = 50;
			} elseif ($this->smartyVars["paymentOptions"]["secondary"]){
				$this->smartyVars["paymentType"] = "2|".key($this->smartyVars["paymentOptions"]["secondary"]);
			} elseif ($this->smartyVars["paymentOptions"]["echeck"]){
				$this->smartyVars["paymentType"] = 4;
			}
		}


		if ((int)$CONF["shoppingSession"]["id"]){

			$clientInfo = collapsePluralsAndSingulars(grabSimpleMBAPIResults(dispatchMBAPI("
				<mbapi>
					<command>GetClients</command>
					<params>
						<clientID>".(int)$CONF["shoppingSession"]["id"]."</clientID>
						<getContactData>1</getContactData>
						<getBillingData>1</getBillingData>
					</params>
				</mbapi>", 1)));
			$clientInfo = $clientInfo[0];
			$contactInfo = $clientInfo["contacts"][0];
			dbg($clientInfo);

			switch ($clientInfo["clientStatus"]){
				case getAPIStatusID("client", "fraudulent"):
				case getAPIStatusID("client", "suspended"):
				case getAPIStatusID("client", "inactive"):
					die("Sorry, we are unable to accept your order at this time.");
				break;
			}
			
			$this->smartyVars["billingAccounts"] = array();
			$clientInfo["billingAccounts"] = (array)$clientInfo["billingAccounts"];
			foreach ($clientInfo["billingAccounts"] as $acct){
				if ($acct["billingAccountType"]==0 && !(int)$this->smartyVars["nolek"]){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".getTypeName("card", $acct["billingCardType"])." - Last 4 Digits: ".$acct["billingAccountNumLastFour"]." - ".$acct["billingCardNameOnCard"];
				}
				if ($acct["billingAccountType"]==1){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".$acct["billingBankName"]." - ".@substr($acct["billingBankAccountNum"], -4);
				}
			}
			$this->smartyVars["numBillingAccounts"] = count($this->smartyVars["billingAccounts"]);

			$this->smartyVars["suppressFields"] = $clientInfo["clientActive"];

		}
		//dbg("SMARTY VARS");
		//dbg($this->smartyVars);

/**********************************************************************************************
 * end get cart info here
 */
		define("WIZARD_CART_DISPLAY", 1);

		// errors.....
 		$inputErrors = array();

		$pidar = array_keys($getProductIDs);
		if (!count($pidar))$pidar = array(0);

		// get order form based attributes
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"orderFormID" => $shoppingSessionData["orderFormID"]
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		$keyed_product_attributes = array();
		$all_question_ids = array();
		$keyed_questions_array = array();
		foreach ((array)$attributes as $attribute){
			// we key these on 0 because they are for the order form not a product.
			$keyed_questions_array[$attribute["questionID"]] =& $attributes[$k];
			$keyed_product_attributes[0][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
			$keyed_attribute_ids[0][$attribute["questionID"]] = $attribute["attributeID"];
		}

		// get products attributes stuff
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"productID" => $pidar
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		foreach ((array)$attributes as $attribute){
			$keyed_questions_array[$attribute["questionID"]] =& $attributes[$k];
			$keyed_product_attributes[(int)$attribute["productID"]][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
			$keyed_attribute_ids[(int)$attribute["productID"]][$attribute["questionID"]] = $attribute["attributeID"];
		}
		dbg("keyed attributes");
		dbg($keyed_product_attributes);


#################################################################################################


#################################################################################################
#################################################################################################


		$this->smartyVars["shoppingItemQuestions"] = array();



		$questions =& new MBQuery("GetWizardQuestions", "", array("questionID"=>$all_question_ids));
		if ($this->addErrorsFromResult($r =& $questions->getResult())){
			$s =& $r->getSubjectFrom(array("mbapi", "results", "questions", "question"));
			$t =& $s->getTable("questionID");
			$questionsByID = $t->getAssociatedBy("questionID");

			$questionParams =& new MBQuery("GetWizardQuestionParams", "", array("questionID" => $all_question_ids, "getParamValues" => 1));
			if ($this->addErrorsFromResult($r =& $questionParams->getResult())){
				$s =& $r->getSubjectFrom(array("mbapi", "results", "questionParams", "questionParam"));
				$t =& $s->getTable("questionParamID");
				$questionParamTablesByID = $t->getAssociatedTablesBy("questionID");
	
				$questionParamValueSubjectsByID =& $s->getAdditionalDataBy("questionParamID", "questionParamValues", "questionParamValue");
				$questionParamValuesByID = array();
				foreach($questionParamValueSubjectsByID as $questionParamID => $paramSubject) {
					$questionParamValuesByID[$questionParamID] = $paramSubject->getStructure();
				}
	
				dbg("question objects and stuff");
				dbg($questionsByID);
				dbg($questionParamTablesByID);
				dbg($questionParamValuesByID);
	
	
				$this->smartyVars["showShoppingItemQuestions"] = 0;
				$this->smartyVars["showCustomerQuestions"] = 0;
				$this->smartyVars["wizardShoppingItems"][0] = 0; // for order form attributes
	
				foreach ($this->smartyVars["wizardShoppingItems"] as $shoppingItemID=>$productID){
					dbg("doing shopping item: ".$shoppingItemID);
					$questionIDs = $keyed_product_attributes[$productID];
	
					if (count($questionIDs)){
	
						$w =& new Wizard(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
						$w->setID($shoppingItemID);
						$w->cached = true;
	
						$s =& new WizardStep(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
						$s->setID($shoppingItemID);
	
						foreach ($questionIDs as $questionID){
							if (isset($questionParamTablesByID[$questionID])){
								$q =& new WizardQuestion(QUESTION_INPUT_HIDDEN, "");
								$q->setID($questionID);
								$params = $questionParamTablesByID[$questionID]->getTable();
								foreach($params as $param) {
									call_user_func_array(
										array(&$q, $param["questionParamName"]),
										array_map(
											array('ProcessCartRegister', 'constantize'),
											$questionParamValuesByID[$param["questionParamID"]]
										)
									);
								}
								$questionType = $q->getType();
								if ($questionType!=QUESTION_INPUT_HIDDEN){
									if ($shoppingItemID){
										$this->smartyVars["showShoppingItemQuestions"] = 1;
									} else {
										$this->smartyVars["showCustomerQuestions"] = 1;
									}
								}
								switch($questionType) {
									case QUESTION_INPUT_MULTISELECT:
									case QUESTION_INPUT_SELECT:
									case QUESTION_INPUT_CHECKBOX:
									case QUESTION_INPUT_RADIO:
										dbg($this->additionalInfo[$shoppingItemID][$questionID]);
										$q->setSelected((array)$this->additionalInfo[$shoppingItemID][$questionID]);
									break;
									default:
										dbg($this->additionalInfo[$shoppingItemID][$questionID]);
										$q->setAnswers((array)$this->additionalInfo[$shoppingItemID][$questionID]);
									break;
								}
								$errors = $q->validateFor($this->additionalInfo[$shoppingItemID][$questionID]);
								dbg($errors);
								$s->erroredQuestions[$questionID] = $errors;
								$s->invalidQuestions[$questionID] = errorMesgsFor($errors);
	
								if ($errors && !in_array(TRANS_INVALID_ADDITIONAL_INFORMATION_PROVIDED, $inputErrors)){
									$inputErrors[] = TRANS_INVALID_ADDITIONAL_INFORMATION_PROVIDED;
								}
								$s->addQuestion($q);
							}
						}
	
						$w->addSteps($s);
						$w->fetch = true;
						$this->smartyVars["shoppingItemQuestion"][$shoppingItemID] = $w->displayNextStep();
	
					}
	
				}
			}
		}


#################################################################################################
#################################################################################################



/**********************************************************************************************
 * lets do some input validation here and redirect back to the form if needed.
 */

		$this->smartyVars["invalidFields"] = array();

 		// check non-domain reg info

 		// first we need to know if this is a returning user or not:
		if ((int)$CONF["shoppingSession"]["id"]){
			dbg("we have a session");
			$clientInfo = collapsePluralsAndSingulars(grabSimpleMBAPIResults(dispatchMBAPI("
				<mbapi>
					<command>GetClients</command>
					<params>
						<clientID>".(int)$CONF["shoppingSession"]["id"]."</clientID>
						<getContactData>1</getContactData>
						<getBillingData>1</getBillingData>
					</params>
				</mbapi>																   ", 1)));
			$clientInfo = $clientInfo[0];

			$contactInfo = $clientInfo["contacts"][0];
			dbg($clientInfo);

			$this->smartyVars["billingAccounts"] = array();
			$clientInfo["billingAccounts"] = (array)$clientInfo["billingAccounts"];
			foreach ($clientInfo["billingAccounts"] as $acct){
				if ($acct["billingAccountType"]==0 && !(int)$this->smartyVars["nolek"]){
				$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".getTypeName("card", $acct["billingCardType"])." - Last 4 Digits: ".$acct["billingAccountNumLastFour"]." - ".$acct["billingCardNameOnCard"];
				}
				if ($acct["billingAccountType"]==1){
				$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".$acct["billingBankName"]." - ".@substr($acct["billingBankAccountNum"], -4);
				}
			}
			$this->smartyVars["numBillingAccounts"] = count($this->smartyVars["billingAccounts"]);

			$this->smartyVars["suppressFields"] = $clientInfo["clientActive"];

			$this->smartyVars["checkoutFormInfo"] = array(
												"taxIDNumber" => $clientInfo["taxIDNumber"],
												"clientFirstName" => $contactInfo["contactFirstName"],
												"registrantFirstName" => $contactInfo["contactFirstName"],
												"clientLastName" => $contactInfo["contactLastName"],
												"registrantLastName" => $contactInfo["contactLastName"],
												"clientCompany" => $contactInfo["contactCompany"],
												"registrantOrganizationName" => $contactInfo["contactCompany"],
												"contactAddress1" => $contactInfo["contactAddress1"],
												"registrantAddress1" => $contactInfo["contactAddress1"],
												"contactAddress2" => $contactInfo["contactAddress2"],
												"registrantAddress2" => $contactInfo["contactAddress2"],
												"contactCity" => $contactInfo["contactCity"],
												"registrantCity" => $contactInfo["contactCity"],
												"contactState" => $contactInfo["contactState"],
												"registrantStateProvince" => $contactInfo["contactState"],
												"countriesID" => $contactInfo["countriesID"],
												"registrantCountry" => $contactInfo["countriesID"],
												"contactZip" => $contactInfo["contactZip"],
												"registrantPostalCode" => $contactInfo["contactZip"],
												"clientEmail" => $contactInfo["contactEmail"],
												"registrantEmail" => $contactInfo["contactEmail"],
												"contactPhone1" => $contactInfo["contactPhone1"],
												"registrantPhone" => $contactInfo["contactPhone1"],
												"contactFax" => $contactInfo["contactFax"],
												"registrantFax" => $contactInfo["contactFax"],
														);

			} else {
				dbg("we have to verify our user info");
				// check username and password info.
				if (strlen(stripslashes($_REQUEST["contactUsername"]))<$this->smartyVars["orderParams"]["usermin"] || strlen(stripslashes($_REQUEST["contactUsername"]))>$this->smartyVars["orderParams"]["usermax"]){
					$inputErrors[] = TRANS_USERNAME_INVALID_LENGTH;
					$this->smartyVars["invalidFields"]["contactUsername"] = 1;
				}
				
				$usernameCheck = oneOf(":contacts", array("contactUsername" => secureInput($_REQUEST["contactUsername"])));
				if (notZero($usernameCheck["clientID"]) && notNull($usernameCheck["contactUsername"]) && ($usernameCheck["clientContactID"]!=$shoppingSessionData["clientContactID"])) {
					$inputErrors[] = TRANS_USERNAME_ALREADY_TAKEN;
					$this->smartyVars["invalidFields"]["contactUsername"] = 1;
				}
	
				$emailCheck = oneOf(":contacts", array("contactEmail" => $_REQUEST["clientEmail"]));
				if (notZero($emailCheck["clientID"]) && notNull($emailCheck["contactEmail"]) && ($emailCheck["clientContactID"]!=$shoppingSessionData["clientContactID"])) {
					$inputErrors[] = TRANS_EMAIL_ALREADY_TAKEN_PLEASE_TRY_LOGGING_IN;
					$this->smartyVars["invalidFields"]["contactEmail"] = 1;
				}
				if ((int)$this->orderObj->emailBan){
					$pieces = explode("@", $_REQUEST["clientEmail"], 2);
					$emailCheck = oneOf(":bans", array(
						"banString" => $pieces[1],
						"banActive" => 1,
					));
					if ((int)$emailCheck["banID"]){
						updateForKey(":bans", $emailCheck["banID"], array(
							"banCount" => $emailCheck["banCount"]+1,
							"banDateLastUsed" => time(),
						));
						$inputErrors[] = $this->orderObj->emailBanText;
						$this->smartyVars["invalidFields"]["contactEmail"] = 1;
					}
				}
	
				if ($_REQUEST["contactPassword"]==$_REQUEST["confirmcontactPassword"]){
					if (strlen(stripslashes($_REQUEST["contactPassword"]))<$this->smartyVars["orderParams"]["passmin"] || strlen(stripslashes($_REQUEST["contactPassword"]))>$this->smartyVars["orderParams"]["passmax"]){
						$this->smartyVars["invalidFields"]["contactPassword"] = 1;
						$this->smartyVars["invalidFields"]["confirmcontactPassword"] = 1;
						$inputErrors[] = TRANS_PASSWORD_INVALID_LENGTH;
					}
				} else {
					$this->smartyVars["invalidFields"]["contactPassword"] = 1;
					$this->smartyVars["invalidFields"]["confirmcontactPassword"] = 1;
					$inputErrors[] = TRANS_PASSWORDS_DONT_MATCH;
				}
	
				$requiredFields = array(
									"clientFirstName",
									"clientLastName",
									"clientEmail",
									"contactAddress1",
									"contactCity",
									"contactPhone1",
									);
				foreach ($_REQUEST as $field=>$value){
					if (in_array($field, $requiredFields)){
						if (!strlen(ereg_replace("[[:space:]]", "", $_REQUEST[$field]))){
							$this->smartyVars["invalidFields"][$field] = 1;
							$inputErrors[] = TRANS_INVALID_PERSONAL_INFO;
						}
					}
				}


				if ($_REQUEST["countriesID"] != idOf(":countries", array("countriesISO2" => "IE")) && (!strlen(ereg_replace("[[:space:]]", "", $_REQUEST["contactZip"])))) {
					$this->smartyVars["invalidFields"]["contactZip"] = 1;
					$inputErrors[] = TRANS_INVALID_PERSONAL_INFO;
				}

				dbg("INPUT ERRORS");
				dbg($inputErrors);
			}
	
			if (strpos($_REQUEST["paymentType"], "|")){
				$pieces = explode("|", $_REQUEST["paymentType"]);
				$_REQUEST["paymentType"] = $pieces[0];
				$_REQUEST["secondary"] = $pieces[1];
			}
			$requiredFields = array();
	
			switch ($_REQUEST["paymentType"]){
				case "1":
					$requiredFields = array(
											"billingCardNameOnCard",
											"billingCardNum",
											);
					$billingAccountType = 0;
					$billingCardNum = $_REQUEST["billingCardNum"];
					if (!validateCard($billingCardNum)){
						$this->smartyVars["invalidFields"]["billingCardNum"] = 1;
						$inputErrors[] = TRANS_INVALID_PAYMENT_INFO;
					}
				break;
				case "2":
				case "3":
				break;
				case "4":
				case "5":
					$requiredFields = array(
											"billingBankName",
//											"billingBankState",
											"billingBankAccountNum",
//											"billingBankLicenseNum",
//											"billingBankLicenseState",
//											"billingBankDob",
											"billingBankAbaCode",
											);
				break;
				case "50":
				break;
				case "9999":
				break;
			}
	
			foreach ($requiredFields as $field){
				if (!strlen(ereg_replace("[[:space:]]", "", $_REQUEST[$field]))){
					$this->smartyVars["invalidFields"][$field] = 1;
					$inputErrors[] = TRANS_INVALID_PAYMENT_INFO;
				}
			}
	
			// Need to get payment options regardless - this is what hat the TOS URL
			$this->smartyVars["paymentOptions"] = $order->getPaymentOptions();
	
			if (count($inputErrors)){
	
				$this->smartyVars["inputErrors"] = array_unique($inputErrors);
				$this->mergeCountryData();
	
				$this->smartyVars["paymentOptions"]["cardTypes"] = $this->getAcceptedCardTypesByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
				$this->smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];
				for ($i=date("Y"); $i<date("Y")+21; $i++){
					$this->smartyVars["cardYears"][$i] = $i;
				}
	
				if (!$this->smartyVars["paymentOptions"]["cc"] && !$this->smartyVars["paymentType"]){
					if ($this->smartyVars["paymentOptions"]["check"]){
						$this->smartyVars["paymentType"] = 3;
					} elseif ($this->smartyVars["paymentOptions"]["invoice"]){
						$this->smartyVars["paymentType"] = 50;
					} elseif ($this->smartyVars["paymentOptions"]["secondary"]){
						$this->smartyVars["paymentType"] = "2|".key($this->smartyVars["paymentOptions"]["secondary"]);
					}
				}
	
				dbg("smarty vars:");
				dbg($this->smartyVars);
	
				// ok, we didn't make it through, lets redisplay the form
				$this->addTemplate("shopping/ShowCartCheckoutForm", $this->smartyVars);
	
	
			} else {
	
	/**********************************************************************************************
	* ok, aparently we got past the input validation, lets process the preview invoice
	*/
	
				dbg("SHOPPING ITEMS: ");
				dbg($this->smartyVars["shoppingItems"]);
	
	
					$processCheckoutXML = "
		<mbapi>
		<command>ProcessCheckout</command>
		<showXMLHeader></showXMLHeader>
		<subCommand>preview</subCommand>
		<params>
	
				<orderFormID>".$shoppingSessionData["orderFormID"]."</orderFormID>
				<affiliateCode>".secureInput($_REQUEST["affiliateCode"])."</affiliateCode>
				<paymentType>".(int)$_REQUEST["paymentType"]."</paymentType>
				<secondary>".(int)$_REQUEST["secondary"]."</secondary>
				<invoiceID>".$shoppingSessionData["invoiceID"]."</invoiceID>
				<fraudLevelAction>".$shoppingSessionData["fraudLevelAction"]."</fraudLevelAction>
				<fraudLevelActionStatus>".$shoppingSessionData["fraudLevelActionStatus"]."</fraudLevelActionStatus>
				";
	
				if ((int)$shoppingSessionData["clientID"]){
					if ($CONF["shoppingSession"]["clientInfo"]["clientActive"]){
						$processCheckoutXML .= "
						<client>
							<clientID>".$shoppingSessionData["clientID"]."</clientID>
							<clientLastIP>".ip2long($_SERVER["REMOTE_ADDR"])."</clientLastIP>
						</client>";
					} else {
						$processCheckoutXML .= "
						<client>
							<clientID>".$shoppingSessionData["clientID"]."</clientID>
							<clientFirstName>".secureInput($_REQUEST["clientFirstName"])."</clientFirstName>
							<clientLastName>".secureInput($_REQUEST["clientLastName"])."</clientLastName>
							<clientEmail>".secureInput($_REQUEST["clientEmail"])."</clientEmail>
							<clientCompany>".secureInput($_REQUEST["clientCompany"])."</clientCompany>
							<clientComments>".secureInput($_REQUEST["clientComments"])."</clientComments>
							<contactUsername>".secureInput($_REQUEST["contactUsername"])."</contactUsername>
							<contactPassword>".secureInput($_REQUEST["contactPassword"])."</contactPassword>
							<countriesID>".secureInput($_REQUEST["countriesID"])."</countriesID>
							<applyTax>".$this->checkApplyTax($_REQUEST["taxIDNumber"], $_REQUEST["countriesID"])."</applyTax>
							<taxIDNumber>".secureInput($_REQUEST["taxIDNumber"])."</taxIDNumber>
							<languageID>".$order->orderFormLanguageID."</languageID>
							<themeID>1</themeID>
							<companyID>1</companyID>
							<clientSignupIP>".ip2long($_SERVER["REMOTE_ADDR"])."</clientSignupIP>
							<clientLastIP>".ip2long($_SERVER["REMOTE_ADDR"])."</clientLastIP>
						</client>
						<clientContact>
							<contactAddress1>".secureInput($_REQUEST["contactAddress1"])."</contactAddress1>
							<contactAddress2>".secureInput($_REQUEST["contactAddress2"])."</contactAddress2>
							<contactCity>".secureInput($_REQUEST["contactCity"])."</contactCity>
							<contactState>".secureInput($_REQUEST["contactState"])."</contactState>
							<contactZip>".secureInput($_REQUEST["contactZip"])."</contactZip>
							<contactPhone1>".secureInput($_REQUEST["contactPhone1"])."</contactPhone1>
							<contactPhone2>".secureInput($_REQUEST["contactPhone2"])."</contactPhone2>
							<contactFax>".secureInput($_REQUEST["contactFax"])."</contactFax>
						</clientContact>
						<clientBillingAccount>
							<billingAccountType>$billingAccountType</billingAccountType>
							<billingCardNum>$billingCardNum</billingCardNum>
						</clientBillingAccount>
						";
					}
				} else {
						$processCheckoutXML .= "
						<client>
							<clientFirstName>".secureInput($_REQUEST["clientFirstName"])."</clientFirstName>
							<clientLastName>".secureInput($_REQUEST["clientLastName"])."</clientLastName>
							<clientEmail>".secureInput($_REQUEST["clientEmail"])."</clientEmail>
							<clientCompany>".secureInput($_REQUEST["clientCompany"])."</clientCompany>
							<clientComments>".secureInput($_REQUEST["clientComments"])."</clientComments>
							<contactUsername>".secureInput($_REQUEST["contactUsername"])."</contactUsername>
							<contactPassword>".secureInput($_REQUEST["contactPassword"])."</contactPassword>
							<countriesID>".secureInput($_REQUEST["countriesID"])."</countriesID>
							<languageID>".$order->orderFormLanguageID."</languageID>
							<applyTax>".$this->checkApplyTax($_REQUEST["taxIDNumber"], $_REQUEST["countriesID"])."</applyTax>
							<taxIDNumber>".secureInput($_REQUEST["taxIDNumber"])."</taxIDNumber>
							<themeID>1</themeID>
							<companyID>1</companyID>
						</client>
						<clientContact>
							<contactAddress1>".secureInput($_REQUEST["contactAddress1"])."</contactAddress1>
							<contactAddress2>".secureInput($_REQUEST["contactAddress2"])."</contactAddress2>
							<contactCity>".secureInput($_REQUEST["contactCity"])."</contactCity>
							<contactState>".secureInput($_REQUEST["contactState"])."</contactState>
							<contactZip>".secureInput($_REQUEST["contactZip"])."</contactZip>
							<contactPhone1>".secureInput($_REQUEST["contactPhone1"])."</contactPhone1>
							<contactPhone2>".secureInput($_REQUEST["contactPhone2"])."</contactPhone2>
							<contactFax>".secureInput($_REQUEST["contactFax"])."</contactFax>
						</clientContact>";
				}
	
				$processCheckoutXML .= "
					<packageUsername>".secureInput($_REQUEST["contactUsername"])."</packageUsername>
					<packagePassword>".secureInput($_REQUEST["contactPassword"])."</packagePassword>
					";
	
				if ($this->additionalInfo[0]){
					$processCheckoutXML .= "<attributes>\n";
					foreach ($this->additionalInfo[0] as $questionID=>$answers){
						$attributeID = $keyed_attribute_ids[0][$questionID];
						$processCheckoutXML .= "<attribute>
										<questionID>".$questionID."</questionID>
										<attributeID>".$attributeID."</attributeID>
										<answers>";
											
						foreach ((array)$answers as $answer){
							$processCheckoutXML .= "<answer>".$answer."</answer>\n";
						}
												
						$processCheckoutXML .= "	</answers>
									</attribute>\n";
					}
					$processCheckoutXML .= "</attributes>\n";
				}
	
	
	
				foreach ($this->smartyVars["shoppingItems"] as $shoppingItem){
	
					$processCheckoutXML .= "
					<products>
						<ID>".$shoppingItem["shoppingItemID"]."</ID>
						<parentProductID>".$shoppingItem["parentShoppingItemID"]."</parentProductID>
						<productID>".$shoppingItem["productID"]."</productID>
						<productVariantID>".$shoppingItem["productVariantID"]."</productVariantID>
						<packageDateNextRenewal>".$this->smartyVars["packageDateNextRenewal"]."</packageDateNextRenewal>
						<cycleID>".$shoppingItem["cycleID"]."</cycleID>
						<couponID>".$shoppingItem["appliedCoupons"][0]["couponID"]."</couponID>
						<couponPrice>".((isset($shoppingItem["appliedCoupons"][0]["discount"]))?(float)$shoppingItem["shoppingItemPrice"]-$shoppingItem["appliedCoupons"][0]["discount"]:0)."</couponPrice>
						<couponNumCycles>".$shoppingItem["appliedCoupons"][0]["couponNumCycles"]."</couponNumCycles>
						<quantity>1</quantity>
						<taxZoneGroupID>".$this->smartyVars["productVariantTaxZoneGroupIDs"][$shoppingItem["productVariantID"]]."</taxZoneGroupID>
						<comments></comments>
						<price>".(float)$shoppingItem["shoppingItemPrice"]."</price>
						<setup>".(float)$shoppingItem["shoppingItemSetupPrice"]."</setup>
						<addons>";
	
	
					if (isset($shoppingItem["children"][0]["shoppingItemID"])){
						foreach ($shoppingItem["children"] as $child){
							$thisProduct = $this->smartyVars["products"][$child["productID"]];
							$displayName = $keyedAddonGroups[$thisProduct["productAddonGroupID"]].": ".$thisProduct["productName"];
							$processCheckoutXML .= "
								<addon>
									<productName>".$displayName."</productName>
									<productID>".$child["productID"]."</productID>
									<productVariantID>".$child["productVariantID"]."</productVariantID>
									<couponID>".$child["appliedCoupons"][0]["couponID"]."</couponID>
									<couponPrice>".((isset($child["appliedCoupons"][0]["discount"]))?(float)$child["shoppingItemPrice"]-$child["appliedCoupons"][0]["discount"]:0)."</couponPrice>
									<couponNumCycles>".$child["appliedCoupons"][0]["couponNumCycles"]."</couponNumCycles>
									<quantity>1</quantity>
									<taxZoneGroupID>".$this->smartyVars["productVariantTaxZoneGroupIDs"][$child["productVariantID"]]."</taxZoneGroupID>
									<price>".(float)$child["shoppingItemPrice"]."</price>
									<setup>".(float)$child["shoppingItemSetupPrice"]."</setup>
								</addon>";
						}
					}
	
					$processCheckoutXML .= "
						</addons>";
	
					if ($this->smartyVars["products"][$shoppingItem["productID"]]["productType"]==getAPITypeID("products", "domain")){
	
						$processCheckoutXML .= "
							<domain>
								<domainType>".$shoppingItem["shoppingItemDomainType"]."</domainType>
								<domainID>".$shoppingItem["shoppingItemID"]."</domainID>
								<domainSLD>".$shoppingItem["shoppingItemSLD"]."</domainSLD>
								<domainTLD>".$shoppingItem["shoppingItemTLD"]."</domainTLD>
								<domainIDNLanguage>".$shoppingItem["shoppingItemDomainLanguage"]."</domainIDNLanguage>
								<domainTransferKey>".$shoppingItem["shoppingItemTransferKey"]."</domainTransferKey>
							</domain>";
	
					} else {
	
						if ($shoppingItem["domains"]){
							foreach ($shoppingItem["domains"] as $currentDomain){
								$primaryXML = ($shoppingItem["shoppingItemPrimaryDomainID"]==$currentDomain["shoppingItemsDomainsRelID"]) ?
									"<primaryDomain>1</primaryDomain>" :
									"";
								switch ($currentDomain["shoppingItemsDomainsType"]){
									case getAPITypeID("shoppingdomains", "new"):
									case getAPITypeID("shoppingdomains", "transfer"):
										$processCheckoutXML .= "
											<domain>
												$primaryXML
												<domainType>".$currentDomain["shoppingItemsDomainsType"]."</domainType>
												<domainID>".$currentDomain["domainShoppingItemID"]."</domainID>
											</domain>";
									break;
									case getAPITypeID("shoppingdomains", "manual"):
									case getAPITypeID("shoppingdomains", "existing"):
										$processCheckoutXML .= "
											<domain>
												$primaryXML
												<domainType>".$currentDomain["shoppingItemsDomainsType"]."</domainType>
												<domainSLD>".$currentDomain["domainSLD"]."</domainSLD>
												<domainTLD>".$currentDomain["domainTLD"]."</domainTLD>
											</domain>";
									break;
								}
							}
						}
	
					}
	
					if ($this->additionalInfo[$shoppingItem["shoppingItemID"]]){
						$processCheckoutXML .= "<attributes>\n";
						foreach ($this->additionalInfo[$shoppingItem["shoppingItemID"]] as $questionID=>$answers){
							$attributeID = $keyed_attribute_ids[$shoppingItem["productID"]][$questionID];
							$processCheckoutXML .= "<attribute>
											<questionID>".$questionID."</questionID>
											<attributeID>".$attributeID."</attributeID>
											<answers>";
											
							foreach ((array)$answers as $answer){
								$processCheckoutXML .= "<answer>".$answer."</answer>\n";
							}
												
							$processCheckoutXML .= "	</answers>
										</attribute>\n";
						}
						$processCheckoutXML .= "</attributes>\n";
					}
	
	
					$processCheckoutXML .= "
					</products>";
	
				}
	
				$processCheckoutXML .= "
		</params>
		</mbapi>";
	
				dbg("#########################################################################################", 0, 1);
				dbg($processCheckoutXML, 0, 1);
				dbg("#########################################################################################", 0, 1);
	
				$result = dispatchMBAPI($processCheckoutXML, 1);
				dbg("#########################################################################################
				#########################################################################################
				#########################################################################################
				#########################################################################################");
				dbg($result, 0, 1);
				dbg("#########################################################################################
				#########################################################################################
				#########################################################################################
				#########################################################################################");
	
				if ($result["mbapi"][0]["results"][0]["clientID"][0]){
	
					$this->smartyVars["invoice"] = correctArray($result["mbapi"][0]["results"][0]["invoice"][0]);
					
					$packageIDs = array();
					foreach ($this->smartyVars["invoice"]["packages"] as $pkg){
						$packageIDs[] = $pkg["packageID"];
					}
					
					$domainRels = correctArray($result["mbapi"][0]["results"][0]["packageDomains"]);
					
					$this->smartyVars["packageDomains"] = array();
					if($domainRels) {
						foreach ($domainRels as $dr){
							$this->smartyVars["packageDomains"][$dr["packageID"]][] = $dr["domainID"];
						}
					}
					
					$this->smartyVars["domains"] = array();
					$domains = correctArray($result["mbapi"][0]["results"][0]["domains"]);
					
					dbg("domains we got back from process checkout");
					dbg($domains);
					if(is_array($domains)) {
						foreach ($domains as $domain){
							$this->smartyVars["domains"][$domain["domainID"]] = $domain;
						}
					}
					$_REQUEST["smartyRedisplay"] = $this->smartyVars;
	
					$this->smartyVars["passVar"] = base64_encode(serialize($_REQUEST));
					$fingerprint = getPasswordHash($this->smartyVars["passVar"]);
	
					if (isset($result["mbapi"][0]["results"][0]["fraudResults"]) && is_array($result["mbapi"][0]["results"][0]["fraudResults"][0])){
						$arg = $result["mbapi"][0]["results"][0]["fraudResults"][0]["actionToUse"][0];
						$fraudThresholdID = (int)$result["mbapi"][0]["results"][0]["fraudResults"][0]["thresholdID"][0];
						dbg($result["mbapi"][0]["results"][0]["fraudResults"][0]);
						dbg($fraudThresholdID);
						$this->smartyVars["thresholdData"] = getMBAPIRow("GetFraudCountryThresholds", array(
							"thresholdID" => $fraudThresholdID
						));
						dbg($this->smartyVars["thresholdData"]);
					} else {
						dbg("");
						$arg = "";
					}
					$fraudLevelAction = (int)getAPIStatusID("fraudLevelActions", $arg);
	
					$this->smartyVars["fraudLevelAction"] = $fraudLevelAction;
	
					$setSessionLoginXML = "	<mbapi>
												<command>SetShoppingSession</command>
												<subCommand>update</subCommand>
												<params>
													<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
													<clientID>".(int)$result["mbapi"][0]["results"][0]["clientID"][0]."</clientID>
													<clientContactID>".(int)$result["mbapi"][0]["results"][0]["clientContactID"][0]."</clientContactID>
													<shoppingSessionFingerprint>".$fingerprint."</shoppingSessionFingerprint>
													<fraudLevelAction>$fraudLevelAction</fraudLevelAction>
													<fraudLevelActionStatus>1</fraudLevelActionStatus>
												</params>
											</mbapi>";
					$setResult = dispatchMBAPI($setSessionLoginXML, 1);
					dbg("set session client id result:");
					dbg($setResult);
					$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
					dbg("shoppingSessionData:");
					dbg($shoppingSessionData);
	
					dbg("SMARTY VARS");
					dbg($this->smartyVars);
	
//					$fraudLevelAction = getAPIStatusID("fraudLevelActions", "rejectHard");
					switch ($fraudLevelAction){
						case getAPIStatusID("fraudLevelActions", "activeAuthCapture"):
						case getAPIStatusID("fraudLevelActions", "activeAuthOnly"):
						case getAPIStatusID("fraudLevelActions", "pendingAuthCapture"):
						case getAPIStatusID("fraudLevelActions", "pendingAuthOnly"):
	
							// ppcfactory logic
							loadConfigs("other");
	
							// only run PPC logic if enabled
							dbg("enablePPCfactory:".$CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]);
							if ((int)$CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {
	
								$this->getHighestPricedHostingMonthlyInfo();
								$ppcProductID = $this->ppcID;
								$ppcProductType = $this->ppcType;
								$ppcProductCurrency = $this->smartyVars["currencyID"];
								$ppcProductName = $this->ppcName;
								$ppcProductPrice = $this->ppcPrice;
								$ppcCustomerID = $this->smartyVars["invoice"]["clientID"];
								$ppcCustomerName = $this->smartyVars["checkoutFormInfo"]["clientFirstName"]." ".$this->smartyVars["checkoutFormInfo"]["clientLastName"];
								$ppcCustomerEmail = $this->smartyVars["checkoutFormInfo"]["clientEmail"];
								$ppcCustomerCountryISO2 = $this->smartyVars["invoice"]["countriesISO2"];
								$ppcOrderTotal = $this->smartyVars["invoice"]["invoiceDueAmount"];
	
								dbg("\$ppcProductType:".$this->ppcType);
								dbg("\$ppcProductCurrency:".$this->smartyVars["currencyID"]);
								dbg("\$ppcProductID:".$this->ppcID);
	
								// only run PPC logic if hosting product in USD currency and we have one.
								if ($ppcProductType == getAPITypeID("products", "hosting") && $ppcProductCurrency == "USD" && (int) $ppcProductID){
									$ppcArgs = array
									(
									"customerKey" => $ppcCustomerID,
									"customerName" => $ppcCustomerName,
									"customerEmail" => $ppcCustomerEmail,
									"customerCountryISO2" => $ppcCustomerCountryISO2,
									"orderAmount" => $ppcOrderTotal,
									"productKey" => $ppcProductID,
									"productName" => $ppcProductName,
									"productType" => "hosting",
									"productPrice" => round($ppcProductPrice), // monthly price
									"apiAction" => "reserve",
									);
									$ppcQuery = getMBAPIQuery("ProcessPPCfactory", "", $ppcArgs);
									$ppcData = correctArray(dispatchMBAPI($ppcQuery, 1));
	
									dbg("\$ppcData");
									dbg($ppcData);
	
									#echo "<pre>".print_r($ppcArgs,1)."</pre>";
									#echo "<pre>".print_r($ppcData,1)."</pre>";
	
									if ($ppcData["mbapi"][0]["header"][0]["success"]) {
										$this->smartyVars["showAdWordsOffer"] = 1;
										$this->smartyVars["adWordsOffer"] = $ppcData["mbapi"][0]["results"][0];
									}
	
								} // productType && USD
							} // enablePPCfactory*/
	
							$this->addTemplate("shopping/ShowCartCheckoutConfirmForm", $this->smartyVars);
						break;
						case getAPIStatusID("fraudLevelActions", "rejectSoft"):
							$this->addTemplate("shopping/SoftReject", $this->smartyVars);
						break;
						case getAPIStatusID("fraudLevelActions", "rejectHard"):
							$this->addTemplate("shopping/HardReject", $this->smartyVars);
	//						$this->addError(TRANS_ACTIONERROR, "Failed to pass fraud screening.");
						break;
					}
	
	
				} else {
	
					$this->addError(TRANS_ACTIONERROR, "ProcessCheckout Command Failed to return client ID.");
	
				}
	
	
			}
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

	/**
	 *	function to get the monthly price of this product including the children of it.
	 */
	function getHighestPricedHostingMonthlyInfo(){
		global $CONF;
   		$this->monthlyCycles = getCyclesArray("monthly");
		$this->ppcID = 0;
		$this->ppcName = "";
		$this->ppcPrice = 0;
		$this->ppcType = 0;

		foreach ($this->smartyVars["shoppingItems"] as $item){
	        if (isset($this->monthlyCycles[$item["cycleID"]]) && $this->smartyVars["products"][$item["productID"]]["productType"]==getAPITypeID("products", "hosting")) {
				$price = $item["shoppingItemPrice"] /*+$item["addonPrice"]*/ - $item["couponTotal"];
	            // find the multiplier for this cycle
	            $cycleMultiplier = $CONF["cycles"][$item["cycleID"]][1];
	            // only run if we have a valid multiplier
	            if ($cycleMultiplier) {
					$productPrice = round(($price / $cycleMultiplier),2);
					if ($productPrice > $this->ppcPrice){
						$this->ppcID = $item["productID"];
						$this->ppcName = $this->smartyVars["products"][$item["productID"]]["productName"];
						$this->ppcPrice = $productPrice;
						$this->ppcType = $this->smartyVars["products"][$item["productID"]]["productType"];
					}
				}
			}

		}

	}
	/**
	 * if a value is a constant, resolve it
	 *
	 * @param  string  value
	 * @return  string|constant  value or resolved value
	 */
	function constantize($value) {
		return defined($value) ? constant($value) : $value;
	}

	/**
	 * function to check a vat number if necessary
	 *
	 * @param string vat number
	 * @param int	country id of customer
	 * @return int	1 or 0
	 */
	function checkApplyTax($taxID, $countryID){
	
		dbg($taxID);
		dbg($countryID);
		
		dbg($this->orderFormData);
	
		if ((int)$this->orderFormData["orderFormVerifyVat"][0]){
			
			$vatCountries = array("AT", "BE", "CY", "CZ", "DE", "DK", "EE", "EL", "ES", "FI", "FR", "GB", "HU", "IE", "IT", "LT", "LU", "LV", "MT", "NL", "PL", "PT", "SE", "SI", "SK");
			
			$companyInfo = oneByID("companies", array("companyID" => $this->orderFormData["companyID"]));
			
			
			if ($countryID==$companyInfo["countriesID"]){ // if we are in the same country apply tax always
				dbg("we are in the same country, apply tax...");
				return 1;
			} else {
				$countryInfo = grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetCountries",
						"params" => array(
							"countriesID" => $countryID,
						),
					),
				));
				dbg($countryInfo);
				$countriesISO2 = $countryInfo["countriesISO2"];
				if (in_array($countriesISO2, $vatCountries)){
				
					if (strtoupper(substr($taxID, 0, 2)) == $countriesISO2){
						$taxID = substr($taxID, 2);
					}
				
					$validVatNumber = $this->checkVatNumber($taxID, $countriesISO2);
					dbg("valid vat number: ".$validVatNumber);
					return ($validVatNumber==1)?0:1;
				
				} else {
					dbg("we aren't in a vattable country.");
					return 0; // dont apply tax since their country is not a vat country
				}
			}
		} else {
			dbg("apply tax because they didnt check the option on the order form");
			return 1; // apply tax
		}
	}
	
	function checkVatNumber($taxID, $countryCode){
		//VAT SOAP
		require_once mb_path("/lib-mbapi/include/nusoap/core/nusoap.php");
		
		// vatNumber should fit: [0-9A-Za-z\+\*\.]{2,12}
		$client = new nu_soapclient("http://ec.europa.eu/taxation_customs/vies/api/checkVatPort?wsdl",true);
		$vatInfo = array("countryCode" => $countryCode,
						"vatNumber" => $taxID,
						);
		$functionToCall = "checkVat";
		$params = array($vatInfo);
		$result = $client->call($functionToCall, $params);
		dbg("vat check return:");
		dbg($result);
		dbg("errors:");
		dbg($client->getError());
		return ((int)$result["valid"]==1)?1:0;
	}
	
} // ProcessCartRegister
?>
