<?php
// $Id: ShowCartCheckoutForm.php 12651 2008-02-18 20:56:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");
require_once mb_path("/lib-action/include/wizard/Wizard.php");

/**
 * This Action object displays a form for a person to register as a client and submit
 * payment information, or just submit payment information if they are already a client.
 *
 * @author  Kris Bailey
 */
class ShowCartCheckoutForm extends MB_Action {
	/**
	 * The constructor for a ShowCartCheckoutForm action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowCartCheckoutForm() {
		parent::MB_Action();
		$this->stringRep = "ShowCartCheckoutForm";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowCart action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		loadConfigs("payment");
//		$this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];

		if ($CONF["system"]["encryption"]["lek_pin"]==''){
			$this->smartyVars["nolek"] = 1;
		}

		$this->smartyVars["hasDomain"] = 0;
		// all the stuff necessary to get info for the cart summary display here:

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		$this->mergeCycleData();

		$orderObjectParams = array(
			"ofid" => $shoppingSessionData["orderFormID"],
			"sid" => $shoppingSessionData["shoppingSessionID"],
			"set_locale" => $_REQUEST["set_locale"],
		);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;
		$this->smartyVars["orderParams"] = $order->getOrderParams();

		$languagesArray = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetLanguages</command><params><languageISO2>".$CONF["user"]["locale"]->language."</languageISO2></params></mbapi>", 1)));
		dbg("languages:");
		dbg($languagesArray);
		foreach ($languagesArray as $language) {
			$order->orderFormLanguageID = $language["languageID"];
		}

		$this->smartyVars["continueShoppingURL"] = str_replace("%SID%", $_REQUEST["sid"], $order->continueShoppingURL);

		$shoppingCouponsXML = "	<mbapi>
						<command>GetShoppingCoupons</command>
						<params>
							<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
							<getCouponsData>1</getCouponsData>
						</params>
					</mbapi>";
		$shoppingCoupons = (array)correctArray(grabSimpleMBAPIResults(dispatchMBAPI($shoppingCouponsXML, 1)));

		$this->smartyVars["coupons"] = $shoppingCoupons;

		$shoppingItemsXML = "
				<mbapi>
					<command>GetShoppingItems</command>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						<getDomainsRelData>1</getDomainsRelData>
					</params>
				</mbapi>";
		$shoppingItems = dispatchMBAPI($shoppingItemsXML, 1);

		if (isset($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			$shoppingItems = correctArray($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]);
		} else {
			$shoppingItems = array();
		}

		dbg("shopping items:");
		dbg($shoppingItems);


		$getProductIDs = array();
		$getProductVariantIDs = array();
		$getProductIDs[0] = 1;
		foreach ($shoppingItems as $row){
		 	$getProductIDs[$row["productID"]] = 1;
		 	$getProductVariantIDs[$row["productVariantID"]] = 1;
		}

////////////////////////////////////////
		// get products info here:
   		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", array_keys($getProductIDs))."</productID>
									<filterVariants>
										<productVariantID>".@implode("</productVariantID><productVariantID>", array_keys($getProductVariantIDs))."</productVariantID>
									</filterVariants>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getCycleData>1</getCycleData>
									<getGhostCycleIDs>1</getGhostCycleIDs>
							</params>
						</mbapi>";
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		if (isset($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0])){
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
		} else {
			$productsInfo = array();
		}

		dbg("products info");
		dbg($productsInfo);

		$this->smartyVars["products"] = array();
		$this->smartyVars["keyedVariants"] = array();
		foreach ($productsInfo as $row){
			$coupons = array();
			if (isset($row["coupons"])){
				foreach ($row["coupons"] as $coupon){
					$coupons[$coupon["couponID"]] = $coupon;
				}
			}
			$row["productComments"] = utf8_html_entity_decode( $row["productComments"] );
			$row["coupons"] = $coupons;
			$row["numCycles"] = count($row["ghostCycles"]);
			$this->smartyVars["products"][$row["productID"]] = $row;
			foreach ((array)$row["productVariants"] as $vk=>$vv){
				$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $row["productVariants"][$vk];
			}
		}

////////////////////////////////////////


		$keyedItems = array();
		$keyedDomains = array();
		$this->smartyVars["domainsExtraInfo"] = array();
		$this->smartyVars["wizardShoppingItems"] = array();
		foreach ($shoppingItems as $row){
			$this->smartyVars["wizardShoppingItems"][$row["shoppingItemID"]] = $row["productID"];
			if ($this->smartyVars["products"][$row["productID"]]["productType"]==getAPITypeID("products", "domain")){
 				$this->smartyVars["hasDomain"] = 1;
 				dbg("is a domain");
 				if ($row["shoppingItemDomainType"]==0){
 					dbg("getting extra info");
					$domdata = getTLDParamsData($row["shoppingItemSLD"].".".$row["shoppingItemTLD"]);
					dbg("extra info was");
					dbg($domdata);
					if ($domdata){
						dbg("added it to smarty");
						$this->smartyVars["domainsExtraInfo"][$row["shoppingItemSLD"].".".$row["shoppingItemTLD"]] = correctArray($domdata);
						$domdata = NULL;
					} else {
						dbg("didn't add it to smarty");
					}
				}
			} else {
				dbg("NOT a domain.");
			}
		 	if (isset($row["domains"])){
		 		dbg("DOMAIN EXISTED!");
				foreach ($row["domains"] as $row2){
				 	$keyedDomains[$row2["domainShoppingItemID"]] = $row2;
				}
			} else {
				$row["domains"] = array();
			}
			$appliedCoupons = array();
			$couponTotal = 0;
			foreach ($this->smartyVars["coupons"] as $k=>$coupon){
				if ((int)$this->smartyVars["products"][$row["productID"]]["coupons"][$coupon["couponID"]]["couponID"]
				 && !count($appliedCoupons)
				 && ($coupon["couponApplyNumber"]==0 || $coupon["applied"]<1)){
					if ((int)$coupon["couponType"]){
					 	$coupon["discount"] = $coupon["couponDiscount"];
					} else {
						$coupon["discount"] = round(($coupon["couponDiscount"]/100)*$row["shoppingItemPrice"], 2);
					}
					$coupon["negdiscount"] = 0-$coupon["discount"];
					$appliedCoupons[] = $coupon;
					$this->smartyVars["coupons"][$k]["discountTotal"] = round($this->smartyVars["coupons"][$k]["discountTotal"]+$coupon["discount"], 2);
					$this->smartyVars["coupons"][$k]["applied"]++;
					$couponTotal = round($coupon["discount"]+$couponTotal, 2);
				}
			}
			$row["appliedCoupons"] = $appliedCoupons;
			$row["couponTotal"] = $couponTotal;

			$key = (int)$row["parentShoppingItemID"];

			if (!$this->smartyVars["products"][$row["productID"]]["productIsAddon"]){
				//$key = 0;
			}

			$keyedItems[$key][] = $row;
		}



		$this->smartyVars["shoppingItems"] = (array)$keyedItems[0];

		foreach ($this->smartyVars["shoppingItems"] as $k=>$v){
			$addonTotal = 0;
			if (isset($keyedItems[$v["shoppingItemID"]])){
			   	foreach ($keyedItems[$v["shoppingItemID"]] as $row){
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemSetupPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal-round($row["couponTotal"], 2), 2);
				}
			}
		 	$this->smartyVars["shoppingItems"][$k]["children"] = $keyedItems[$v["shoppingItemID"]];
		 	$this->smartyVars["shoppingItems"][$k]["addonPrice"] = $addonTotal;
		}

		$this->smartyVars["incorrectLogin"] = secureInput($_REQUEST["incorrectLogin"]);

		dbg("Smarty Vars:");
		dbg($this->smartyVars);

		$this->smartyVars["paymentOptions"] = $order->getPaymentOptions();
		$this->smartyVars["paymentOptions"]["cardTypes"] = $this->getAcceptedCardTypesByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
		$this->smartyVars["paymentOptions"]["echeck"] = $this->getGatewayeCheckByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
		$this->smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];
		for ($i=date("Y"); $i<date("Y")+21; $i++){
			$this->smartyVars["cardYears"][$i] = $i;
		}

		if (!$this->smartyVars["paymentOptions"]["cc"] && !$this->smartyVars["paymentType"]){
			if ($this->smartyVars["paymentOptions"]["check"]){
				$this->smartyVars["paymentType"] = 3;
			} elseif ($this->smartyVars["paymentOptions"]["invoice"]){
				$this->smartyVars["paymentType"] = 50;
			} elseif ($this->smartyVars["paymentOptions"]["secondary"]){
				$this->smartyVars["paymentType"] = "2|".key($this->smartyVars["paymentOptions"]["secondary"]);
			} elseif ($this->smartyVars["paymentOptions"]["echeck"]){
				$this->smartyVars["paymentType"] = 4;
			}
		}


		// end cart item information getting
		if ((int)$shoppingSessionData["clientID"]){

			$results = dispatchMBAPI("
				<mbapi>
					<command>GetClients</command>
					<params>
						<clientID>".(int)$shoppingSessionData["clientID"]."</clientID>
						<getContactData>1</getContactData>
						<getBillingData>1</getBillingData>
					</params>
				</mbapi>", 1);
			$clientInfo = collapsePluralsAndSingulars(grabSimpleMBAPIResults($results));
			$clientInfo = $clientInfo[0];
			$contactInfo = $clientInfo["contacts"][0];
			dbg($clientInfo);

			switch ($clientInfo["clientStatus"]){
				case getAPIStatusID("client", "fraudulent"):
				case getAPIStatusID("client", "suspended"):
				case getAPIStatusID("client", "inactive"):
					$this->smartyVars["cantCheckout"] = 1;
				break;
			}

			$this->smartyVars["billingAccounts"] = array();
			$clientInfo["billingAccounts"] = (array)$clientInfo["billingAccounts"];
			foreach ($clientInfo["billingAccounts"] as $acct){
				if ($acct["billingAccountType"]==0 && !(int)$this->smartyVars["nolek"]){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".getTypeName("card", $acct["billingCardType"])." - Last 4 Digits: ".$acct["billingAccountNumLastFour"]." - ".$acct["billingCardNameOnCard"];
				}
				if ($acct["billingAccountType"]==1){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".$acct["billingBankName"]." - ".@substr($acct["billingBankAccountNum"], -4);
				}
			}
			$this->smartyVars["numBillingAccounts"] = count($this->smartyVars["billingAccounts"]);

			$this->smartyVars["suppressFields"] = $clientInfo["clientActive"];

			$this->smartyVars["checkoutFormInfo"] = array(
				"taxIDNumber" => $clientInfo["taxIDNumber"],
				"clientFirstName" => $contactInfo["contactFirstName"],
				"registrantFirstName" => $contactInfo["contactFirstName"],
				"clientLastName" => $contactInfo["contactLastName"],
				"registrantLastName" => $contactInfo["contactLastName"],
				"clientCompany" => $contactInfo["contactCompany"],
				"registrantOrganizationName" => $contactInfo["contactCompany"],
				"contactAddress1" => $contactInfo["contactAddress1"],
				"registrantAddress1" => $contactInfo["contactAddress1"],
				"contactAddress2" => $contactInfo["contactAddress2"],
				"registrantAddress2" => $contactInfo["contactAddress2"],
				"contactCity" => $contactInfo["contactCity"],
				"registrantCity" => $contactInfo["contactCity"],
				"contactState" => $contactInfo["contactState"],
				"registrantStateProvince" => $contactInfo["contactState"],
				"countriesID" => $contactInfo["countriesID"],
				"registrantCountry" => $contactInfo["countriesID"],
				"contactZip" => $contactInfo["contactZip"],
				"registrantPostalCode" => $contactInfo["contactZip"],
				"clientEmail" => $contactInfo["contactEmail"],
				"registrantEmail" => $contactInfo["contactEmail"],
				"contactPhone1" => $contactInfo["contactPhone1"],
				"registrantPhone" => $contactInfo["contactPhone1"],
				"contactFax" => $contactInfo["contactFax"],
				"registrantFax" => $contactInfo["contactFax"],
				);




		} else {
			$this->smartyVars["checkoutFormInfo"] = array();
		}

		if ($_REQUEST["mb_domain_info"]){
			$regInfo = unserialize(base64_decode($_REQUEST["mb_domain_info"]));
			dbg("reg info:");
			dbg($regInfo);
			if ($regInfo["registrantFirstName"]){
//			if (is_array($regInfo)){
				$this->smartyVars["checkoutFormInfo"]["registrantFirstName"] = $regInfo["registrantFirstName"];
				$this->smartyVars["checkoutFormInfo"]["registrantLastName"] = $regInfo["registrantLastName"];
				$this->smartyVars["checkoutFormInfo"]["registrantOrganizationName"] = $regInfo["registrantOrganizationName"];
				$this->smartyVars["checkoutFormInfo"]["registrantAddress1"] = $regInfo["registrantAddress1"];
				$this->smartyVars["checkoutFormInfo"]["registrantAddress2"] = $regInfo["registrantAddress2"];
				$this->smartyVars["checkoutFormInfo"]["registrantCity"] = $regInfo["registrantCity"];
				$this->smartyVars["checkoutFormInfo"]["registrantStateProvince"] = $regInfo["registrantStateProvince"];
				$this->smartyVars["checkoutFormInfo"]["registrantCountry"] = $regInfo["registrantCountry"];
				$this->smartyVars["checkoutFormInfo"]["registrantPostalCode"] = $regInfo["registrantPostalCode"];
				$this->smartyVars["checkoutFormInfo"]["registrantEmail"] = $regInfo["registrantEmail"];
				$this->smartyVars["checkoutFormInfo"]["registrantPhone"] = $regInfo["registrantPhone"];
				$this->smartyVars["checkoutFormInfo"]["registrantFax"] = $regInfo["registrantFax"];
				$this->smartyVars["checkoutFormInfo"]["registrantJobTitle"] = $regInfo["registrantJobTitle"];
			}
		}

		$this->mergeCountryData();

		if (!$this->smartyVars["checkoutFormInfo"]["countriesID"]){
			$this->smartyVars["checkoutFormInfo"]["countriesID"] = $order->orderFormData["countriesID"];
		}
		if (!$this->smartyVars["checkoutFormInfo"]["registrantCountry"]){
			$this->smartyVars["checkoutFormInfo"]["registrantCountry"] = $order->orderFormData["countriesID"];
		}

		dbg($CONF["shoppingSession"]);

		define("WIZARD_CART_DISPLAY", 1);


		$pidar = array_keys($getProductIDs);
		if (!count($pidar))$pidar = array(0);

		// get order form based attributes
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"orderFormID" => $shoppingSessionData["orderFormID"]
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		$keyed_product_attributes = array();
		$all_question_ids = array();
		foreach ((array)$attributes as $attribute){
			// we key these on 0 because they are for the order form not a product.
			$keyed_product_attributes[0][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
		}

		// get products attributes stuff
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"productID" => $pidar
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		foreach ((array)$attributes as $attribute){
			$keyed_product_attributes[(int)$attribute["productID"]][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
		}
		dbg("keyed attributes");
		dbg($keyed_product_attributes);


#################################################################################################
#################################################################################################


		$this->smartyVars["shoppingItemQuestions"] = array();


		$questions =& new MBQuery("GetWizardQuestions", "", array("questionID"=>$all_question_ids));
		if ($this->addErrorsFromResult($r =& $questions->getResult())){
			$s =& $r->getSubjectFrom(array("mbapi", "results", "questions", "question"));
			$t =& $s->getTable("questionID");
			$questionsByID = $t->getAssociatedBy("questionID");

			$questionParams =& new MBQuery("GetWizardQuestionParams", "", array("questionID" => $all_question_ids, "getParamValues" => 1));
			if ($this->addErrorsFromResult($r =& $questionParams->getResult())){
				$s =& $r->getSubjectFrom(array("mbapi", "results", "questionParams", "questionParam"));
				$t =& $s->getTable("questionParamID");
				$questionParamTablesByID = $t->getAssociatedTablesBy("questionID");
	
				$questionParamValueSubjectsByID =& $s->getAdditionalDataBy("questionParamID", "questionParamValues", "questionParamValue");
				$questionParamValuesByID = array();
				foreach($questionParamValueSubjectsByID as $questionParamID => $paramSubject) {
					$questionParamValuesByID[$questionParamID] = $paramSubject->getStructure();
				}
	
				dbg("question objects and stuff");
				dbg($questionsByID);
				dbg($questionParamTablesByID);
				dbg($questionParamValuesByID);
	
	
				$this->smartyVars["showShoppingItemQuestions"] = 0;
				$this->smartyVars["showCustomerQuestions"] = 0;
				$this->smartyVars["wizardShoppingItems"][0] = 0; // for order form attributes
	
				foreach ($this->smartyVars["wizardShoppingItems"] as $shoppingItemID=>$productID){
	
					$questionIDs = $keyed_product_attributes[$productID];
	
					if (count($questionIDs)){
	
						$w =& new Wizard(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
						$w->setID($shoppingItemID);
						$w->cached = true;
	
						$s =& new WizardStep(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
						$s->setID($shoppingItemID);
	
						foreach ($questionIDs as $questionID){
							if (isset($questionParamTablesByID[$questionID])){
								$q =& new WizardQuestion(QUESTION_INPUT_HIDDEN, "");
								$q->setID($questionID);
								$params = $questionParamTablesByID[$questionID]->getTable();
								foreach($params as $param) {
									if ($param["questionParamName"]=="setType"){
										$valueArray =& $questionParamValuesByID[$param["questionParamID"]];
										if ($valueArray[0]=="QUESTION_INPUT_HIDDEN"){
										} else {
											if ($shoppingItemID){
												$this->smartyVars["showShoppingItemQuestions"] = 1;
											} else {
												$this->smartyVars["showCustomerQuestions"] = 1;
											}
										}
									}
									call_user_func_array(
										array(&$q, $param["questionParamName"]),
										array_map(
											array('ShowCartCheckoutForm', 'constantize'),
											$questionParamValuesByID[$param["questionParamID"]]
										)
									);
								}
								$s->addQuestion($q);
							}
						}
						$w->addSteps($s);
						$w->fetch = true;
						$this->smartyVars["shoppingItemQuestion"][$shoppingItemID] = str_replace("&amp;", "&", $w->displayNextStep());
	
					}
	
				}
			}
		}

#################################################################################################
#################################################################################################

		dbg("SMARTY VAHS!");
		dbg($this->smartyVars);

		$this->addTemplate("shopping/ShowCartCheckoutForm", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	/**
	 * if a value is a constant, resolve it
	 *
	 * @param  string  value
	 * @return  string|constant  value or resolved value
	 */
	function constantize($value) {
		return defined($value) ? constant($value) : $value;
	}

} // ShowCartCheckoutForm
?>
