<?php
// $Id: ShowOrderFormProductsStep.php 12157 2007-11-01 16:03:35Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/AddCartStepAction.php";

/**
 * @author  Kris Bailey
 */
class ShowOrderFormProductsStep extends AddCartStepAction {
	/**
	 */
	function ShowOrderFormProductsStep() {
		parent::AddCartStepAction();
		$this->stringRep = "ShowOrderFormProductsStep";
		$this->sortColumns = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$shoppingSessionData = $this->shoppingSessionData;
		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$this->order = 
		$order =& new Order($orderObjectParams);

		$this->currencyID = 
		$currencyID = $order->orderFormCurrency;
	
		if ((int)$_REQUEST["finalStep"]){
			
			if (!(int)$_REQUEST["hostingProduct"]){
				$this->addCartProduct(array(
					"sid" => $shoppingSessionData["shoppingSessionID"],
					"productID" => $_REQUEST["productID"],
					"productVariantID" => $_REQUEST["productVariantID"],
					"addType" => "domain",
					"cycleID" => $_REQUEST["cycleID"],
					"domain" => $_REQUEST["domainSLD"].".".$_REQUEST["domainTLD"],
				));
				$this->smartyVars["domainAdded"] = 1;
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			} else {
				$hostingProductInfo = explode("|", $_REQUEST["hostingProduct"]);
				$this->addCartProduct(array(
					"sid" => $shoppingSessionData["shoppingSessionID"],
					"ID" => 1111,
					"productID" => $hostingProductInfo[0],
					"productVariantID" => $hostingProductInfo[1],
					"cycleID" => $hostingProductInfo[2],
					"domainTransferKey" => $_REQUEST["domainTransferKey"],
				));
				$this->addCartProduct(array(
					"sid" => $shoppingSessionData["shoppingSessionID"],
					"parentID" => 1111,
					"productID" => $_REQUEST["productID"],
					"productVariantID" => $_REQUEST["productVariantID"],
					"cycleID" => $_REQUEST["cycleID"],
					"domainTransferKey" => $_REQUEST["domainTransferKey"],
					"addType" => "domain",
					"domain" => $_REQUEST["domainSLD"].".".$_REQUEST["domainTLD"],
				));
				$this->smartyVars["domainAdded"] = 1;
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			}
		} else {
			$this->mergeWidgetData((int)$_REQUEST["websiteWidgetID"]);
			if ($this->smartyVars["numProducts"]==0){
				$this->addCartProduct(array(
					"sid" => $shoppingSessionData["shoppingSessionID"],
					"productID" => $_REQUEST["productID"],
					"productVariantID" => $_REQUEST["productVariantID"],
					"addType" => "domain",
					"cycleID" => -2,
					"domain" => $_REQUEST["domainSLD"].".".$_REQUEST["domainTLD"],
					"domainTransferKey" => $_REQUEST["domainTransferKey"],
				));
				$this->smartyVars["domainAdded"] = 1;
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			} else {
				$this->addTemplate("shopping/ShowOrderFormProductsStep", $this->smartyVars);
			}
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

}
