<?php
// $Id: ShowWebsiteWidget.php 13101 2008-08-08 10:09:40Z mdmitriev $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowWebsiteWidget extends MB_Action {
	/**
	 * The constructor for a ShowWebsiteWidget action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowWebsiteWidget() {
		parent::MB_Action();
		$this->stringRep = "ShowWebsiteWidget";

		$this->params = array("wwid");
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowWebsiteWidget action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg("at the top of website widget show action.");

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		$this->smartyVars["shoppingSession"] = $shoppingSessionData;
		$this->mergeCycleData();

		dbg("at the top of website widget show action. 2");

		if ($CONF["secureURLProtocol"]=="http"){
		 	$this->smartyVars["shopURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/products.php";
		 	$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
		 	$this->smartyVars["plainCartURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php";
		} else {
		 	$this->smartyVars["shopURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/products.php";
		 	$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
		 	$this->smartyVars["plainCartURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php";
		}

		dbg("at the top of website widget show action. 3");

		$wwInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetWebsiteWidgets",
				"params" => array(
					"websiteWidgetID" => (int)$_REQUEST["wwid"],
					"getProductInformation" => 1,
					"getOrderFormData" => 1,
				),
			),
		)));
		dbg($wwInfo);

		if (!$wwInfo["websiteWidgetID"]){
			echo "Invalid widget ID: ".(int)$_REQUEST["wwid"];
			return;
		}

		dbg("at the top of website widget show action. 4");

		$this->smartyVars["orderFormID"] = $orderFormID = $wwInfo["orderFormID"];
		$this->smartyVars["currencyID"] = $wwInfo["paymentGroupCurrencyID"];

		$this->smartyVars["orderFormInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetOrderForms",
				"params" => array(
					"orderFormID" => $this->smartyVars["orderFormID"],
					"getCouponData" => 1,
				),
			),
		)));

		dbg($this->smartyVars["orderFormInfo"]);

		$this->allowedCoupons = array();

		foreach ((array)$this->smartyVars["orderFormInfo"]["coupons"] as $coupon){
			$this->allowedCoupons[$coupon["productID"]][$coupon["couponID"]] = $coupon;
		}


		$shoppingSessionData = $this->shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $orderFormID);

		dbg("at the top of website widget show action. 5");

		$productIDs = (array) $wwInfo["products"];
		dbg("product info");
		dbg($productIDs);

		$getProductIDs = array();
		foreach ($productIDs as $row){
		 	$getProductIDs[] = $row["productID"];
		}
		if (count($getProductIDs) == 0) {
			$getProductIDs = array(0);
		}

		$getProductIDs = array_unique($getProductIDs);

		dbg("at the top of website widget show action. 6");

		dbg("ids to get:");
		dbg($getProductIDs);

		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", $getProductIDs)."</productID>
									<productActive>1</productActive>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
									<getCycleGhostIDs>1</getCycleGhostIDs>
							</params>
						</mbapi>";
		dbg("SEARCH FOR ME");
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		$productsInfo = correctArray(grabSimpleMBAPIResults($productsInfo));
		
		dbg($productsInfo);

		dbg("at the top of website widget show action. 7");

        $this->smartyVars["numClients"] = (int) numClients;
        if ($this->smartyVars["numClients"] > 100) {
            $this->smartyVars["formDisabled"] = "disabled";
        }
		$this->smartyVars["configGroupID"] = $configGroupID;
		$this->smartyVars["configParams"] = $CONF["other"]["ppc"]["ppcfactory"];

		// Is PPCFactory enabled?
		loadConfigs("other");
		if ($CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {
			$monthlyCycles = getCyclesArray("monthly");
		}

		$keyedProducts = array();
		$this->smartyVars["keyedVariants"] = array();
		$numVariants = 0;
		$numCycles = 0;
		foreach ($productsInfo as $k=>$v){
			

			$keyedAttributes = array();
			foreach ((array)$v["productAttributes"] as $attribute){
				$keyedAttributes[$attribute["productAttributeName"]] = $attribute["productAttributeValue"];
			}
			$productsInfo[$k]["keyedAttributes"] = $keyedAttributes;

			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}

			$keyedProducts[$v["productID"]] = & $productsInfo[$k];

			foreach ((array)$productsInfo[$k]["productVariants"] as $vk=>$vv){
				$numVariants++;
				$this->smartyVars["keyedVariants"][$vv["productVariantID"]] =& $productsInfo[$k]["productVariants"][$vk];
			}

			$validCycles = array();
			foreach ((array)$v["ghostCycles"] as $cycle){
				$numCycles++;
				if (!(int)$_REQUEST["cycleID"]){
					$_REQUEST["onlyCycleID"] = $cycle["cycleID"];
				}
				$validCycles[] = $cycle["cycleID"];
			}

			dbg("testing product: ".$v["productID"]);
			$prices = array();
		 	if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					if (in_array($price["cycleID"], $validCycles)){
						$_REQUEST["onlyProductVariantID"] = $price["productVariantID"];
						$prices[$price["currencyID"]][$price["productVariantID"]."-".$price["cycleID"]][$price["productVariantPriceType"]] = $price;
					}
				}
			} else {
				dbg("didnt find prices");
			}
			foreach ($prices as $currency => $rows){
				$productPrice = array_values($rows);
				if ($preappliedCoupon){
					foreach ((array)$productPrice as $xk=>$tempprice){
						$productPrice[$xk][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
						$productPrice[$xk][0]["discountPrice"] = $productPrice[$xk][0]["productVariantPriceAmount"]-$productPrice[$xk][0]["discountAmount"];
					}
				}
				$productsInfo[$k]["prices"][$currency] = $productPrice;

				// only run PPC logic if enabled
				if ($CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {

					// only run PPC logic if hosting product in USD currency
					if ($productsInfo[$k]["productType"] == 1 && $currency == "USD") {

						// set the current package cycleID
						$cycleID = $productPrice[0][0]["cycleID"];
			
						// only run the PPC logic if the cycleID is in the "monthly" group
						if (array_key_exists($cycleID, $monthlyCycles)) {

							// find the multiplier for this cycle
							$cycleMultiplier = $CONF["cycles"][$cycleID][1];

							// only run if we have a valid multiplier
							if ($cycleMultiplier) {

								// ** THESE ARE HARD CODED BUSINESS RULES FOR DISPLAY PURPOSES ONLY **
								// ** DO NOT EDIT **
								$monthlyPrice = round($productPrice[0][0]["productVariantPriceAmount"] / $cycleMultiplier);
								if ($monthlyPrice <= 25) {
									$codeValue = "25.00";
								} else if ($monthlyPrice <= 100) {
									$codeValue = "50.00";
								} else if ($monthlyPrice > 100) {
									$codeValue = "75.00";
								}
								$productsInfo[$k]["adWordsCredit"] = $codeValue;
								// ** DO NOT EDIT **
								// ** THESE ARE HARD CODED BUSINESS RULES FOR DISPLAY PURPOSES ONLY **
							} // $cycleMultiplier
						} // array_key_exists
					} // productType && USD
				} // enablePPCfactory

			}
			$productsInfo[ $k ]["productComments"] = html_entity_decode( $productsInfo[ $k ]["productComments"] );
			unset($productsInfo[$k]["productVariantPrices"]);
		}

		$this->smartyVars["products"] = array();

		foreach ($getProductIDs as $id){
			$this->smartyVars["products"][] = $keyedProducts[$id];
		}

		dbg("smarty vars:");
		dbg($this->smartyVars);

		dbg("at the top of website widget show action. 8");

		// count the number of products to help display differeny type of widgets
		$c = count($this->smartyVars["products"]);
		$this->smartyVars["numProducts"] = $c;
		$this->smartyVars["ceilProducts"] = ceil($c / 2);
		$this->smartyVars["evenProducts"] = ($c % 2) ? 1 : 0 ;
		$this->smartyVars["adWordsExpiresDate"] = date("m/d/Y",mktime(0,0,0,date("m"),date("d")+15,date("y")));
		

		if ($c==1 && ($numVariants==1 || $_REQUEST["productVariantID"]) && ($numCycles==1 || $_REQUEST["cycleID"])){
			if (!$_REQUEST["cycleID"]){
				$_REQUEST["cycleID"] = $_REQUEST["onlyCycleID"];
			}
			if (!$_REQUEST["productVariantID"]){
				$_REQUEST["productVariantID"] = $_REQUEST["onlyProductVariantID"];
			}
			$this->addAddonsDataToWidget($this->smartyVars["products"][0]["productID"], $_REQUEST["cycleID"], $_REQUEST["onlyProductVariantID"]);
		}


		$this->addTemplate("website_widgets/".$wwInfo["websiteWidgetTpl"], $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	function getCouponAmount($price, $coupon){
		if ((int)$coupon["couponType"]){
			return $coupon["couponDiscount"];
		} else {
			return round(($coupon["couponDiscount"]/100)*$price["productVariantPriceAmount"], 2);
		}

	}

	function addAddonsDataToWidget($productID, $cycleID, $productVariantID){

		$shoppingSessionData = $this->shoppingSessionData;
		
//		$this->smartyVars["currencyID"] = $order->orderFormCurrency;
		$this->smartyVars["productID"] = $productID;
		$this->smartyVars["cycleID"] = $cycleID;
		$this->smartyVars["productVariantID"] = $productVariantID;

		$getAddonsXML = "	<mbapi>
								<command>GetProducts</command>
								<params>
									<parentProductID>".$this->smartyVars["productID"]."</parentProductID>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getPreCouponData>1</getPreCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
								</params>
							</mbapi>";
		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI($getAddonsXML, 1)));


		foreach ($productsInfo as $addon){
			$groups[$addon["productAddonGroupID"]] = 1;
		}
		$groups = array_keys((array)$groups);
		$groups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"getGroupsByProductID" => $this->smartyVars["productID"]
				)
			)
		)));
		
		$this->smartyVars["addonGroups"] = array();
		foreach ((array)$groups as $group){
			$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
		}

		dbg("prods:");
		dbg($productsInfo);

		foreach ((array)$productsInfo as $k=>$product){
			if (!isset($this->smartyVars["addonGroups"][$product["productAddonGroupID"]]) && (int)$product["productAddonGroupID"]){
				unset($productsInfo[$k]);
			}
		}

		if (!is_array($productsInfo)){
		 	$productsInfo = array();
		}

		$mainProducts = array();

		foreach ($productsInfo as $k=>$v){

			if ($v["preappliedCoupons"] && $v["preappliedCoupons"][0] && $v["preappliedCoupons"][0]["couponID"]){
				$preappliedCouponID = $v["preappliedCoupons"][0]["couponID"];
				if ($this->allowedCoupons[$v["productID"]][$preappliedCouponID]){
					$preappliedCoupon = $this->allowedCoupons[$v["productID"]][$preappliedCouponID];
				} else {
					$preappliedCoupon = 0;
				}
			} else {
				$preappliedCoupon = 0;
			}
			
			$prices = array();
			if (isset($productsInfo[$k]["productVariantPrices"])){
				if ($v["productIsAddon"]){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("cycle id: ".$price["cycleID"]);
						dbg("match to cycle: ".$this->smartyVars["cycleID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"] && $price["cycleID"]==$this->smartyVars["cycleID"]){
							$prices[$price["productVariantPriceType"]] = $price;
						}
					}
				} else {
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
						dbg("compared: ");
						dbg("currency id: ".$price["currencyID"]);
						dbg("match to currency: ".$this->smartyVars["currencyID"]);
						if ($price["currencyID"]==$this->smartyVars["currencyID"]){
							$prices[$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
				foreach ($productsInfo[$k]["prices"] as $currency => $rows){
					if ($preappliedCoupon){
						foreach ((array)$row as $xk=>$tempprice){
							$productsInfo[$k]["prices"][$currency][$xk][0]["discountAmount"] = $this->getCouponAmount($tempprice[0], $preappliedCoupon);
							$productsInfo[$k]["prices"][$currency][$xk][0]["discountPrice"] = $productsInfo[$k]["prices"][$currency][$xk][0]["productVariantPriceAmount"]-$productsInfo[$k]["prices"][$currency][$xk][0]["discountAmount"];
						}
					}
				}
			} else {
				unset($productsInfo[$k]);
			}
		
		}

		

		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}

		$this->smartyVars["addonproducts"] = $keyedAddons;
		$this->mergeCycleData();

	}

} // ShowWebsiteWidget
?>
