<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.assignTypes.php
 * Type:     function
 * Name:     assignTypes
 * Purpose:  assign types to a template variable
 * -------------------------------------------------------------
 */
function smarty_function_assignFor($params, &$smarty)
{

	if (!$params["var"] || !$params["source"]) return;
	$testSource = str_replace(":", "", $params["source"]);
	
	$dataSourceWhiteList = array(
		"attributeGroups",
//		"billingAccounts",
		"callbackLogAttributes",
		"callbackLogs",
		"clientAttributes",
		"clientBillingAccounts",
		"clientContacts",
		"clientDomains",
		"clientGroups",
		"clientNotes",
		"clientsGeneric",
		"clients",
		"clientWithContact",
		"clientWithPrimary",
		"companies",
		"contacts",
		"countries",
		"coupons",
		"cycleDiscountGroups",
		"cycleDiscounts",
		"cycleGroups",
		"cycles",
		"domainsGeneric",
		"domains",
		"fraudResultsLog",
		"groupAttributes",
		"invoices",
		"invoicingGroups",
		"languages",
		"lineItems",
		"marketplaceSellers",
		"orderFormItems",
		"orderForms",
		"packageAddonAttributes",
		"packageAddonsGeneric",
		"packageAddons",
		"packageAttributes",
		"packageCertRels",
		"packageDomainRels",
		"packageDomains",
		"packagesGeneric",
		"packages",
		"packageUsageLogs",
		"packageVendorRels",
		"paymentGroups",
		"prepayDiscounts",
		"productAddonGroups",
		"productAttributes",
		"productChildren",
		"productCycles",
		"productGroups",
		"productRelations",
		"productsGeneric",
		"products",
		"productUsagePrices",
		"productVariables",
		"productVariableValues",
		"productVariantPrices",
		"productVariants",
		"productVendorQties",
		"productVendorQtyRels",
		"productVendorRels",
		"questionParams",
		"questionParamValues",
		"questions",
		"questionValueMappings",
		"questionValueMaps",
		"TLDs",
		"transactionLog",
		"transactionSuccessRel",
		"variantPrices",
		"variants",
		"vendorContacts",
		"vendorInventoryMsgs",
		"vendorInventoryNotes",
		"vendorProvisionings",
		"vendorProvPackageRels",
		"vendors",
		"websiteWidgetProductRels",
		"websiteWidgets",
	);

	if (in_array($testSource, $dataSourceWhiteList)){
		
		$passParams = array();
		foreach ($params as $k=>$v){
			if ($k!="source" && $k!="var"){
				if (strpos($k, "_")){
					$pieces = explode("_", $k);
					$cp =& $passParams;
					foreach ($pieces as $xi=>$p){
						if ($xi==count($pieces)-1){
							if ($p==""){
								$cp[] = $v;
							} else {
								$cp[$p] = $v;
							}
						} else {
							if ($p==""){
								$cp[] = array();
								$cp =& $cp[count($cp)-1];
							} else {
								if (in_array($p, $dataSourceWhiteList) || in_array(substr($p, 0, -1), $dataSourceWhiteList) || in_array($p."s", $dataSourceWhiteList)){
									if (isset($cp[$p])){
										$cp =& $cp[$p];
									} else {
										$cp[$p] = array();
										$cp =& $cp[$p];
									}
								} else {
									break;
								}
							}
						}
					}
				} else {
					$passParams[$k] = $v;
				}
			}
		}
		
		$data = queryFor(":".$testSource, $passParams);
		
		$smarty->assign($params['var'], $data);
	}
	
}
