<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.assignTypes.php
 * Type:     function
 * Name:     assignTypes
 * Purpose:  assign types to a template variable
 * -------------------------------------------------------------
 */
function smarty_function_assignTypes($params, &$smarty)
{
	if (empty($params['var'])) {
		$smarty->trigger_error("assign: missing 'var' parameter");
		return;
	}

	if (empty($params['type'])) {
		$smarty->trigger_error("assign: missing 'type' parameter");
		return;
	}

	if (!empty($params['api'])) {
		$smarty->assign($params['var'], getAPITypes($params['type']));
	} else {
		$smarty->assign($params['var'], getTypes($params['type']));
	}
}
?>
