<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty {getHREF} function plugin
 *
 * Type:     function<br>
 * Name:     getHREF<br>
 * Purpose:  append the sessionID to an getHREF<br>
 * @param array
 * @author Michael Fountain
 */
function smarty_function_getHREF($params)
{
	/**
	  * $params["page"]
  	  * $params["actionName"]
  	  * $params["actionID"]
	  * $params["args"]
	  */

	$actionURL = $paramsURL = "";

	// set action as first param
	if ($params["actionName"]!="") {
		$actionURL = "?action=".getActionID($params["actionName"]);
	} else if ($params["actionID"]!=="") {
		$actionURL = "?action=".$params["actionID"];
	}

	// set additional args if they exist
	if ($params["args"]) {
		$paramsURL = ($actionURL) ?  "&" : "?" ;
		$paramsURL .= $params["args"];
	}

	if ($params["suppressSID"]) {
		return $params["page"].$actionURL.$paramsURL;
	} else {
		return appendSID($params["page"].$actionURL.$paramsURL);
	}
}
?>