<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty lookup_id modifier plugin
 *
 * Type:     modifier<br>
 * Name:     getHash<br>
 * Purpose:  get a hash of a string value
 * @param  string  hash type: "sha1", "md5", defaults to "sha1".  
 * @return  string  hashed version of the string
 * @author Ben Woolley
 */
function smarty_function_getHiddenFields($params, &$smarty){
	$fields = MB_makeMultiLevelHiddenFields('', '', $_GET, explode("|", $params["exclude"]));
	$fields = explode("__XSEP__", $fields);
	$ret = "";
	foreach ($fields as $field){
		$field = explode("__YSEP__", $field);
		$ret .= ($params["encode"]) ? "&lt;input type=\\'hidden\\' name=\\'".utf8_html_entity_encode($field[0])."\\' value=\\'".utf8_html_entity_encode($field[1])."\\' /&gt;" : "<input type='hidden' name='".utf8_html_entity_encode($field[0])."' value='".utf8_html_entity_encode($field[1])."' />";
	}
	return $ret;
}

function MB_makeMultiLevelHiddenFields($start, $b, $ar, $addOmit=array()){
	$ret = $start;
	$omitVars = array("recordOffset","numRecords","x","y");
	$omitVars = array_merge((array)$omitVars, (array)$addOmit);
	@reset($ar);
	while (list($k, $v) = @each($ar)){
		if (!(in_array($k, $omitVars) && $b=='')){
			if (is_array($v)){
					$p = ($b=='')?"$k":$b."[$k]";
					$ret = MB_makeMultiLevelHiddenFields($ret, $p, $v, $addOmit);
			} else {
					$ret .= ($b=='')?$k."__YSEP__".$v."__XSEP__":$b."[$k]__YSEP__".$v."__XSEP__";
			}
		}
	}
	return $ret;
}


?>
