<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty {getJSON} function plugin
 *
 * Type:     function<br>
 * Name:     getJSON<br>
 * Purpose:  create a JSON array that can be used seemlessly in javascript from a smarty var<br>
 * @param array
 * @author Kris 'da man' Bailey
 */
function smarty_function_getJSON($params)
{
	return $params["data"] ? createJSONOutputFromArray($params["data"]) : "{}";
}

if (!function_exists('createJSONOutputFromArray')){
	/**
	 * create a javascript associative array from smarty vars sent to template
	 *
	 * @param	array	array to convert to js array
	 * @return	string	string javascript array notation of input array
	 */
	function createJSONOutputFromArray($array, $prefix="\t"){
		$output = array();

		foreach ((array)$array as $k=>$v){
			if (is_array($v) || is_object($v)){
				$output[] = "\n".$prefix.'"'.str_replace("\"", "\\\"", $k).'" : '.createJSONOutputFromArray($v, "\t".$prefix);
			} else {
				$output[] = "\n".$prefix.'"'.str_replace("\"", "\\\"", $k).'" : "'.str_replace("\"", "\\\"", $v).'"';
			}
		}
		return "{".@implode(",", $output)."\n".$prefix."}";
	}
}

