<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Method to translate constants or define new defaults if the constant does not exist. This method should only be accessed
 * from the smarty tpl file.
 *
 * Usage: {t c="TRANS_CONSTANT" d="The default text if the constant does not exist."}
 *
 * Set $CONF["smarty"]["logUnknownConstants"] = TRUE in the include/config/smarty.php file to log unknown constants. Unknown
 * constants will populate the $CONF["smarty"]["unknownConstants"] array.
 *
 * @param  array  An array of paramaters for this smarty function: c = constant, d = default
 * @author  Michael Fountain
 */
$CONF["smarty"]["unknownDefines"] = array();
function smarty_function_t($params)
{
    GLOBAL $CONF;
	/**
	 * $params value shortcuts:
 	 *
	 * c = constant
	 * d = default
 	 * u = urlencode flag
	 */
	// define the unknown constant
    define($params["c"],$params["d"]);
	// log the unknown constant
	if ($CONF["smarty"]["logUnknownConstants"]) {
		$CONF["smarty"]["unknownConstants"][$params["c"]] = $params["d"];
	}
}
?>
