<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty constant modifier plugin
 *
 * Type:     modifier<br>
 * Name:     constant<br>
 * Purpose:  checks to see if sting is a constant and returns the value of that constant
 * @param string
 * @return string
 */
function smarty_modifier_constant($string)
{
	if (strpos($string, "::")) return $string;
	if (defined($string)) {
		$string = constant($string);
	}elseif(strpos($string, "TRANS_") !== false){
		$string = preg_replace("/(TRANS_\w+)/e", "(defined('\\1')) ? constant('\\1') : '\\1'", $string);
	}
	return $string;
}

?>
