<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty gerAmount modifier plugin
 *
 * Type:     modifier<br>
 * Name:     getAmountRounded<br>
 * Purpose:  checks to see if sting is a constant and returns the value of that constant
 * @param 	 amount to display (double)
 * @param	 three digit currency code
 * @param    whether to return a space or formatted zeros when amount = 0
 * @return string
 */
function smarty_modifier_getAmountRounded($amount, $curr=NULL, $returnZeros=true, $allZeros=false)
{
	global $CONF;

    if ($returnZeros==false && $amount==0)return "&nbsp;";

    $ret = $CONF["user"]["locale"]->getLocaleCurrency($amount, $curr);

    if ($allZeros==true){
        $ret = str_replace("1", "0", $ret);
    }

    $ret = ereg_replace(".00$", "", $ret);

	return $ret;
}

?>