<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty getDate modifier plugin. Takes a UNIX timestamp and returns a string representation of it.
 *
 * Type:     modifier<br>
 * Name:     getDate<br>
 * Purpose:  To convert the given UNIX timestamp to a string.
 * @param int  The UNIX timestamp to get the string representation of.
 * @param string  The "length" of the formatted date to return.
 * @return string  A formatted string representation of the given timestamp.
 */
function smarty_modifier_getDate($timestamp, $format = "short") {
	global $CONF;
	$retval = TRANS_NEVER;
	$timestamp = (int) $timestamp;
	if($timestamp > 0) {
		// getDate  -> timestamp, string (full, long, medium, short)
		$retval = $CONF["user"]["locale"]->getLocaleDate($timestamp, $format);
	}
	return $retval;
}
?>