<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty getDiffTime modifier plugin
 *
 * Type:     modifier<br>
 * Name:     getDiffTime<br>
 * Purpose:  Return the time in a locale sensitive format
 * @param int
 * @param string
 * @return string
 */
function smarty_modifier_getDiffTime($timestamp)
{
	global $CONF;

	$day = 86400;

	$days = round($timestamp / $day, 0);

	$hours = round(($timestamp - ($day * $days)) / (60*60), 0) ;

	$minutes = round(($timestamp - (($day * $days) + (60 * $hours))) / 60, 0) - 60 ;

	return $days."d ".$hours."h ".$minutes."m";

}

?>