<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty lookup_id modifier plugin
 *
 * Type:     modifier<br>
 * Name:     getHash<br>
 * Purpose:  get a hash of a string value
 * @param  string  hash type: "sha1", "md5", defaults to "sha1".  
 * @return  string  hashed version of the string
 * @author Ben Woolley
 */
function smarty_modifier_getHash($string, $hashType = "sha1") {
	switch($hashType) {
		case "md5":
			return md5($string);
			break;
		default:
			return sha1($string);
			break;
	}
}
?>
