<?php
// $Id: calculateResellerVolumnDiscount.php 10687 2007-02-19 18:45:10Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../lib-tk/shield.php";

/**
 * This file contains any function definitions needed for hooks in the GetClients
 * command.
 */

function calculateResellerVolumnDiscount($row, $params=array()){
	global $CONF;
	if (!$row["client_id"]){
		return array("clientDiscountLevel" => 0);
	}
	dbg("hook initiated");
	
	// comment out the following line to do a sample teired discount based
	// on product groups
	if (USE_PREDEFINED_RESELLER_VOLUME_DISCOUNTS<1){
		return array("clientDiscountLevel" => 0);
	}
	
	$h =& new QueryMaster("client_attributes.client_attribute_value");
	$h->addTables("attributes");
	$h->addJoin("attributes", "attribute_id", "client_attributes");
	$h->addAndClause("client_attributes.client_id", "=", (int)$row["client_id"], "i");
	$h->addAndClause("attributes.attribute_name", "=", "reseller", "s");
	//dbg($h->getQuery(), 0, 1);
	$reseller = $h->getOne();
	
	
	if ((int)$reseller!=1){
		return array("clientDiscountLevel" => 0);
	}
	
	dbg("got past reseller check", 0, 1);
	
	// create querymaster object
	$h =& new QueryMaster("packages.package_id");
	// add extra tables for where clause creation
	$h->addTables("products", "product_group_rel", "product_groups");
	// manually add join statements
	$h->addJoin("products", "product_id", "packages");
	$h->addJoin("product_group_rel", "product_id", "products");
	$h->addJoin("product_groups", "product_group_id", "product_group_rel");
	// add where clause to limit returned package id's to those for this client and for this product group, and limit it to some statuses
	$h->addAndClause("product_groups.product_group_api_name", "=", RESELLER_VOLUME_PRODUCT_GROUP_API_NAME, "s");
	$h->addAndClause("packages.client_id", "=", (int)$row["client_id"], "i");
	$h->addAndClause("packages.package_status", "=", array(
		getAPIStatusID("package", "none"),
		getAPIStatusID("package", "pending"),
		getAPIStatusID("package", "pending_renewal"),
	), "i");
	
	dbg($h->getQuery(), 0, 1);
	
	// ok, now we have the querymaster object ready, lets get the results
	$packageIDs = $h->getCol();
	dbg($packageIDs, 0, 1);
	// if we would want to do something with the package ids such as additional
	// checking we could, but right now we just want to see how many there are
	$numServers = count($packageIDs);
	
	// lets set the default discount to 0
	$discount = 0; 
	
	// set up the discount amounts that go with the number of servers
	$discountTiers = array(
		2 => 5, // at or over 2 servers = 5% discount
		5 => 8,
		10 => 10,
		25 => 15,
		50 => 20, // at or over 50 = 20% discount
	);
	
	foreach ($discountTiers as $serverRequirement=>$earnedDiscount){
		if ($numServers>=$serverRequirement){
			$discount = $earnedDiscount;
		}
	}
	
	// ok, we have been through it all!
	return array("clientDiscountLevel" => $discount);
}

?>
