<?php
// $Id: cycles.php 12582 2008-01-29 17:58:45Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

/*
cycles
cycle_groups
cycle_group_rel
packages.cycle_id
product_cycle_group_rel
suspend_cycles
*/

/**
 * This file maintains all information having to do with billing cycles. The order of the
 * $CONF["cycles"] array in this file is very important, do not change it, as the
 * array keys are used to associate billing cycle with their delta timestamps.
 *
 * billingCycleData => array (
 *     [0] => ### (Seconds)
 *     [1] => ### (Minutes)
 *     [2] => ### (Hours)
 *     [3] => ### (Days)
 *     [4] => ### (Months)
 *     [5] => ### (Years)
 *  )
 *
 * @author  Michael Fountain
 */

// hourly billing cycles: 1 to 48 hours
$CONF["cycles"] = array();

function populateCONFCycles(){
	global $CONF;
	if (!is_array($CONF["cycles"][1])){
		// get all billing cycles
		//$d =& new datasource("cycles", array("cycleGroups"=>array()));
		$tempcycles = arrayFor(":cycles"); //, array("cycleGroups"=>array())); //$d->getEssential();
		// put all billing cycles info $CONF[""] cycles by cycleID with same format as old way
		dbg($tempcycles);
		foreach ($tempcycles as $cycle) {
			if ($cycle["cycleNumSeconds"]>0){
				$operativeUnitValue = $cycle["cycleNumSeconds"];
			}
			if ($tempcycles[$i]["cycleNumMinutes"]>0){
				$operativeUnitValue = $cycle["cycleNumMinutes"];
			}
			if ($tempcycles[$i]["cycleNumHours"]>0){
				$operativeUnitValue = $cycle["cycleNumHours"];
			}
			if ($tempcycles[$i]["cycleNumDays"]>0){
				$operativeUnitValue = $cycle["cycleNumDays"];
			}
			if ($tempcycles[$i]["cycleNumMonths"]>0){
				$operativeUnitValue = $cycle["cycleNumMonths"];
			}
			if ($tempcycles[$i]["cycleNumYears"]>0){
				$operativeUnitValue = $cycle["cycleNumYears"];
			}
			$CONF["cycles"][$cycle["cycleID"]] = array(
				$cycle["cycleGroups"][0]["cycleGroupInternalName"], // group internal name
				$operativeUnitValue, // the number of x units we are using
				$cycle["cycleDisplayName"], // TRANS_ name of cycle
				array(
					$cycle["cycleNumSeconds"],
					$cycle["cycleNumMinutes"],
					$cycle["cycleNumHours"],
					$cycle["cycleNumDays"],
					$cycle["cycleNumMonths"],
					$cycle["cycleNumYears"]
				) // mktime array
			);
		}
	} // END IF $CONF["cycles"]
} // populateCONFCycles

/*
$CONF["cycles"][1] = array("hourly",1,TRANS_1HOUR,array(0,0,1,0,0,0));
$CONF["cycles"][2] = array("hourly",2,TRANS_2HOURS,array(0,0,2,0,0,0));
$CONF["cycles"][3] = array("hourly",3,TRANS_3HOURS,array(0,0,3,0,0,0));
$CONF["cycles"][4] = array("hourly",4,TRANS_4HOURS,array(0,0,4,0,0,0));
$CONF["cycles"][5] = array("hourly",5,TRANS_5HOURS,array(0,0,5,0,0,0));
$CONF["cycles"][6] = array("hourly",6,TRANS_6HOURS,array(0,0,6,0,0,0));
$CONF["cycles"][7] = array("hourly",7,TRANS_7HOURS,array(0,0,7,0,0,0));
$CONF["cycles"][8] = array("hourly",8,TRANS_8HOURS,array(0,0,8,0,0,0));
$CONF["cycles"][9] = array("hourly",9,TRANS_9HOURS,array(0,0,9,0,0,0));
$CONF["cycles"][10] = array("hourly",10,TRANS_10HOURS,array(0,0,10,0,0,0));
$CONF["cycles"][11] = array("hourly",11,TRANS_11HOURS,array(0,0,11,0,0,0));
$CONF["cycles"][12] = array("hourly",12,TRANS_12HOURS,array(0,0,12,0,0,0));
$CONF["cycles"][13] = array("hourly",13,TRANS_13HOURS,array(0,0,13,0,0,0));
$CONF["cycles"][14] = array("hourly",14,TRANS_14HOURS,array(0,0,14,0,0,0));
$CONF["cycles"][15] = array("hourly",15,TRANS_15HOURS,array(0,0,15,0,0,0));
$CONF["cycles"][16] = array("hourly",16,TRANS_16HOURS,array(0,0,16,0,0,0));
$CONF["cycles"][17] = array("hourly",17,TRANS_17HOURS,array(0,0,17,0,0,0));
$CONF["cycles"][18] = array("hourly",18,TRANS_18HOURS,array(0,0,18,0,0,0));
$CONF["cycles"][19] = array("hourly",19,TRANS_19HOURS,array(0,0,19,0,0,0));
$CONF["cycles"][20] = array("hourly",20,TRANS_20HOURS,array(0,0,20,0,0,0));
$CONF["cycles"][21] = array("hourly",21,TRANS_21HOURS,array(0,0,21,0,0,0));
$CONF["cycles"][22] = array("hourly",22,TRANS_22HOURS,array(0,0,22,0,0,0));
$CONF["cycles"][23] = array("hourly",23,TRANS_23HOURS,array(0,0,23,0,0,0));
$CONF["cycles"][24] = array("hourly",24,TRANS_24HOURS,array(0,0,24,0,0,0));
$CONF["cycles"][25] = array("hourly",25,TRANS_25HOURS,array(0,0,25,0,0,0));
$CONF["cycles"][26] = array("hourly",26,TRANS_26HOURS,array(0,0,26,0,0,0));
$CONF["cycles"][27] = array("hourly",27,TRANS_27HOURS,array(0,0,27,0,0,0));
$CONF["cycles"][28] = array("hourly",28,TRANS_28HOURS,array(0,0,28,0,0,0));
$CONF["cycles"][29] = array("hourly",29,TRANS_29HOURS,array(0,0,29,0,0,0));
$CONF["cycles"][30] = array("hourly",30,TRANS_30HOURS,array(0,0,30,0,0,0));
$CONF["cycles"][31] = array("hourly",31,TRANS_31HOURS,array(0,0,31,0,0,0));
$CONF["cycles"][32] = array("hourly",32,TRANS_32HOURS,array(0,0,32,0,0,0));
$CONF["cycles"][33] = array("hourly",33,TRANS_33HOURS,array(0,0,33,0,0,0));
$CONF["cycles"][34] = array("hourly",34,TRANS_34HOURS,array(0,0,34,0,0,0));
$CONF["cycles"][35] = array("hourly",35,TRANS_35HOURS,array(0,0,35,0,0,0));
$CONF["cycles"][36] = array("hourly",36,TRANS_36HOURS,array(0,0,36,0,0,0));
$CONF["cycles"][37] = array("hourly",37,TRANS_37HOURS,array(0,0,37,0,0,0));
$CONF["cycles"][38] = array("hourly",38,TRANS_38HOURS,array(0,0,38,0,0,0));
$CONF["cycles"][39] = array("hourly",39,TRANS_39HOURS,array(0,0,39,0,0,0));
$CONF["cycles"][40] = array("hourly",40,TRANS_40HOURS,array(0,0,40,0,0,0));
$CONF["cycles"][41] = array("hourly",41,TRANS_41HOURS,array(0,0,41,0,0,0));
$CONF["cycles"][42] = array("hourly",42,TRANS_42HOURS,array(0,0,42,0,0,0));
$CONF["cycles"][43] = array("hourly",43,TRANS_43HOURS,array(0,0,43,0,0,0));
$CONF["cycles"][44] = array("hourly",44,TRANS_44HOURS,array(0,0,44,0,0,0));
$CONF["cycles"][45] = array("hourly",45,TRANS_45HOURS,array(0,0,45,0,0,0));
$CONF["cycles"][46] = array("hourly",46,TRANS_46HOURS,array(0,0,46,0,0,0));
$CONF["cycles"][47] = array("hourly",47,TRANS_47HOURS,array(0,0,47,0,0,0));
$CONF["cycles"][48] = array("hourly",48,TRANS_48HOURS,array(0,0,48,0,0,0));

// daily billing cycles: 1 to 365 days
$CONF["cycles"][49] = array("daily",1,TRANS_1DAY,array(0,0,0,1,0,0));
$CONF["cycles"][50] = array("daily",2,TRANS_2DAYS,array(0,0,0,2,0,0));
$CONF["cycles"][51] = array("daily",3,TRANS_3DAYS,array(0,0,0,3,0,0));
$CONF["cycles"][52] = array("daily",4,TRANS_4DAYS,array(0,0,0,4,0,0));
$CONF["cycles"][53] = array("daily",5,TRANS_5DAYS,array(0,0,0,5,0,0));
$CONF["cycles"][54] = array("daily",6,TRANS_6DAYS,array(0,0,0,6,0,0));
$CONF["cycles"][55] = array("daily",7,TRANS_7DAYS,array(0,0,0,7,0,0));
$CONF["cycles"][56] = array("daily",8,TRANS_8DAYS,array(0,0,0,8,0,0));
$CONF["cycles"][57] = array("daily",9,TRANS_9DAYS,array(0,0,0,9,0,0));
$CONF["cycles"][58] = array("daily",10,TRANS_10DAYS,array(0,0,0,10,0,0));
$CONF["cycles"][59] = array("daily",11,TRANS_11DAYS,array(0,0,0,11,0,0));
$CONF["cycles"][60] = array("daily",12,TRANS_12DAYS,array(0,0,0,12,0,0));
$CONF["cycles"][61] = array("daily",13,TRANS_13DAYS,array(0,0,0,13,0,0));
$CONF["cycles"][62] = array("daily",14,TRANS_14DAYS,array(0,0,0,14,0,0));
$CONF["cycles"][63] = array("daily",15,TRANS_15DAYS,array(0,0,0,15,0,0));
$CONF["cycles"][64] = array("daily",16,TRANS_16DAYS,array(0,0,0,16,0,0));
$CONF["cycles"][65] = array("daily",17,TRANS_17DAYS,array(0,0,0,17,0,0));
$CONF["cycles"][66] = array("daily",18,TRANS_18DAYS,array(0,0,0,18,0,0));
$CONF["cycles"][67] = array("daily",19,TRANS_19DAYS,array(0,0,0,19,0,0));
$CONF["cycles"][68] = array("daily",20,TRANS_20DAYS,array(0,0,0,20,0,0));
$CONF["cycles"][69] = array("daily",21,TRANS_21DAYS,array(0,0,0,21,0,0));
$CONF["cycles"][70] = array("daily",22,TRANS_22DAYS,array(0,0,0,22,0,0));
$CONF["cycles"][71] = array("daily",23,TRANS_23DAYS,array(0,0,0,23,0,0));
$CONF["cycles"][72] = array("daily",24,TRANS_24DAYS,array(0,0,0,24,0,0));
$CONF["cycles"][73] = array("daily",25,TRANS_25DAYS,array(0,0,0,25,0,0));
$CONF["cycles"][74] = array("daily",26,TRANS_26DAYS,array(0,0,0,26,0,0));
$CONF["cycles"][75] = array("daily",27,TRANS_27DAYS,array(0,0,0,27,0,0));
$CONF["cycles"][76] = array("daily",28,TRANS_28DAYS,array(0,0,0,28,0,0));
$CONF["cycles"][77] = array("daily",29,TRANS_29DAYS,array(0,0,0,29,0,0));
$CONF["cycles"][78] = array("daily",30,TRANS_30DAYS,array(0,0,0,30,0,0));
$CONF["cycles"][79] = array("daily",31,TRANS_31DAYS,array(0,0,0,31,0,0));
$CONF["cycles"][80] = array("daily",32,TRANS_32DAYS,array(0,0,0,32,0,0));
$CONF["cycles"][81] = array("daily",33,TRANS_33DAYS,array(0,0,0,33,0,0));
$CONF["cycles"][82] = array("daily",34,TRANS_34DAYS,array(0,0,0,34,0,0));
$CONF["cycles"][83] = array("daily",35,TRANS_35DAYS,array(0,0,0,35,0,0));
$CONF["cycles"][84] = array("daily",36,TRANS_36DAYS,array(0,0,0,36,0,0));
$CONF["cycles"][85] = array("daily",37,TRANS_37DAYS,array(0,0,0,37,0,0));
$CONF["cycles"][86] = array("daily",38,TRANS_38DAYS,array(0,0,0,38,0,0));
$CONF["cycles"][87] = array("daily",39,TRANS_39DAYS,array(0,0,0,39,0,0));
$CONF["cycles"][88] = array("daily",40,TRANS_40DAYS,array(0,0,0,40,0,0));
$CONF["cycles"][89] = array("daily",41,TRANS_41DAYS,array(0,0,0,41,0,0));
$CONF["cycles"][90] = array("daily",42,TRANS_42DAYS,array(0,0,0,42,0,0));
$CONF["cycles"][91] = array("daily",43,TRANS_43DAYS,array(0,0,0,43,0,0));
$CONF["cycles"][92] = array("daily",44,TRANS_44DAYS,array(0,0,0,44,0,0));
$CONF["cycles"][93] = array("daily",45,TRANS_45DAYS,array(0,0,0,45,0,0));
$CONF["cycles"][94] = array("daily",46,TRANS_46DAYS,array(0,0,0,46,0,0));
$CONF["cycles"][95] = array("daily",47,TRANS_47DAYS,array(0,0,0,47,0,0));
$CONF["cycles"][96] = array("daily",48,TRANS_48DAYS,array(0,0,0,48,0,0));
$CONF["cycles"][97] = array("daily",49,TRANS_49DAYS,array(0,0,0,49,0,0));
$CONF["cycles"][98] = array("daily",50,TRANS_50DAYS,array(0,0,0,50,0,0));
$CONF["cycles"][99] = array("daily",51,TRANS_51DAYS,array(0,0,0,51,0,0));
$CONF["cycles"][100] = array("daily",52,TRANS_52DAYS,array(0,0,0,52,0,0));
$CONF["cycles"][101] = array("daily",53,TRANS_53DAYS,array(0,0,0,53,0,0));
$CONF["cycles"][102] = array("daily",54,TRANS_54DAYS,array(0,0,0,54,0,0));
$CONF["cycles"][103] = array("daily",55,TRANS_55DAYS,array(0,0,0,55,0,0));
$CONF["cycles"][104] = array("daily",56,TRANS_56DAYS,array(0,0,0,56,0,0));
$CONF["cycles"][105] = array("daily",57,TRANS_57DAYS,array(0,0,0,57,0,0));
$CONF["cycles"][106] = array("daily",58,TRANS_58DAYS,array(0,0,0,58,0,0));
$CONF["cycles"][107] = array("daily",59,TRANS_59DAYS,array(0,0,0,59,0,0));
$CONF["cycles"][108] = array("daily",60,TRANS_60DAYS,array(0,0,0,60,0,0));
$CONF["cycles"][109] = array("daily",61,TRANS_61DAYS,array(0,0,0,61,0,0));
$CONF["cycles"][110] = array("daily",62,TRANS_62DAYS,array(0,0,0,62,0,0));
$CONF["cycles"][111] = array("daily",63,TRANS_63DAYS,array(0,0,0,63,0,0));
$CONF["cycles"][112] = array("daily",64,TRANS_64DAYS,array(0,0,0,64,0,0));
$CONF["cycles"][113] = array("daily",65,TRANS_65DAYS,array(0,0,0,65,0,0));
$CONF["cycles"][114] = array("daily",66,TRANS_66DAYS,array(0,0,0,66,0,0));
$CONF["cycles"][115] = array("daily",67,TRANS_67DAYS,array(0,0,0,67,0,0));
$CONF["cycles"][116] = array("daily",68,TRANS_68DAYS,array(0,0,0,68,0,0));
$CONF["cycles"][117] = array("daily",69,TRANS_69DAYS,array(0,0,0,69,0,0));
$CONF["cycles"][118] = array("daily",70,TRANS_70DAYS,array(0,0,0,70,0,0));
$CONF["cycles"][119] = array("daily",71,TRANS_71DAYS,array(0,0,0,71,0,0));
$CONF["cycles"][120] = array("daily",72,TRANS_72DAYS,array(0,0,0,72,0,0));
$CONF["cycles"][121] = array("daily",73,TRANS_73DAYS,array(0,0,0,73,0,0));
$CONF["cycles"][122] = array("daily",74,TRANS_74DAYS,array(0,0,0,74,0,0));
$CONF["cycles"][123] = array("daily",75,TRANS_75DAYS,array(0,0,0,75,0,0));
$CONF["cycles"][124] = array("daily",76,TRANS_76DAYS,array(0,0,0,76,0,0));
$CONF["cycles"][125] = array("daily",77,TRANS_77DAYS,array(0,0,0,77,0,0));
$CONF["cycles"][126] = array("daily",78,TRANS_78DAYS,array(0,0,0,78,0,0));
$CONF["cycles"][127] = array("daily",79,TRANS_79DAYS,array(0,0,0,79,0,0));
$CONF["cycles"][128] = array("daily",80,TRANS_80DAYS,array(0,0,0,80,0,0));
$CONF["cycles"][129] = array("daily",81,TRANS_81DAYS,array(0,0,0,81,0,0));
$CONF["cycles"][130] = array("daily",82,TRANS_82DAYS,array(0,0,0,82,0,0));
$CONF["cycles"][131] = array("daily",83,TRANS_83DAYS,array(0,0,0,83,0,0));
$CONF["cycles"][132] = array("daily",84,TRANS_84DAYS,array(0,0,0,84,0,0));
$CONF["cycles"][133] = array("daily",85,TRANS_85DAYS,array(0,0,0,85,0,0));
$CONF["cycles"][134] = array("daily",86,TRANS_86DAYS,array(0,0,0,86,0,0));
$CONF["cycles"][135] = array("daily",87,TRANS_87DAYS,array(0,0,0,87,0,0));
$CONF["cycles"][136] = array("daily",88,TRANS_88DAYS,array(0,0,0,88,0,0));
$CONF["cycles"][137] = array("daily",89,TRANS_89DAYS,array(0,0,0,89,0,0));
$CONF["cycles"][138] = array("daily",90,TRANS_90DAYS,array(0,0,0,90,0,0));
$CONF["cycles"][139] = array("daily",91,TRANS_91DAYS,array(0,0,0,91,0,0));
$CONF["cycles"][140] = array("daily",92,TRANS_92DAYS,array(0,0,0,92,0,0));
$CONF["cycles"][141] = array("daily",93,TRANS_93DAYS,array(0,0,0,93,0,0));
$CONF["cycles"][142] = array("daily",94,TRANS_94DAYS,array(0,0,0,94,0,0));
$CONF["cycles"][143] = array("daily",95,TRANS_95DAYS,array(0,0,0,95,0,0));
$CONF["cycles"][144] = array("daily",96,TRANS_96DAYS,array(0,0,0,96,0,0));
$CONF["cycles"][145] = array("daily",97,TRANS_97DAYS,array(0,0,0,97,0,0));
$CONF["cycles"][146] = array("daily",98,TRANS_98DAYS,array(0,0,0,98,0,0));
$CONF["cycles"][147] = array("daily",99,TRANS_99DAYS,array(0,0,0,99,0,0));
$CONF["cycles"][148] = array("daily",100,TRANS_100DAYS,array(0,0,0,100,0,0));
$CONF["cycles"][149] = array("daily",101,TRANS_101DAYS,array(0,0,0,101,0,0));
$CONF["cycles"][150] = array("daily",102,TRANS_102DAYS,array(0,0,0,102,0,0));
$CONF["cycles"][151] = array("daily",103,TRANS_103DAYS,array(0,0,0,103,0,0));
$CONF["cycles"][152] = array("daily",104,TRANS_104DAYS,array(0,0,0,104,0,0));
$CONF["cycles"][153] = array("daily",105,TRANS_105DAYS,array(0,0,0,105,0,0));
$CONF["cycles"][154] = array("daily",106,TRANS_106DAYS,array(0,0,0,106,0,0));
$CONF["cycles"][155] = array("daily",107,TRANS_107DAYS,array(0,0,0,107,0,0));
$CONF["cycles"][156] = array("daily",108,TRANS_108DAYS,array(0,0,0,108,0,0));
$CONF["cycles"][157] = array("daily",109,TRANS_109DAYS,array(0,0,0,109,0,0));
$CONF["cycles"][158] = array("daily",110,TRANS_110DAYS,array(0,0,0,110,0,0));
$CONF["cycles"][159] = array("daily",111,TRANS_111DAYS,array(0,0,0,111,0,0));
$CONF["cycles"][160] = array("daily",112,TRANS_112DAYS,array(0,0,0,112,0,0));
$CONF["cycles"][161] = array("daily",113,TRANS_113DAYS,array(0,0,0,113,0,0));
$CONF["cycles"][162] = array("daily",114,TRANS_114DAYS,array(0,0,0,114,0,0));
$CONF["cycles"][163] = array("daily",115,TRANS_115DAYS,array(0,0,0,115,0,0));
$CONF["cycles"][164] = array("daily",116,TRANS_116DAYS,array(0,0,0,116,0,0));
$CONF["cycles"][165] = array("daily",117,TRANS_117DAYS,array(0,0,0,117,0,0));
$CONF["cycles"][166] = array("daily",118,TRANS_118DAYS,array(0,0,0,118,0,0));
$CONF["cycles"][167] = array("daily",119,TRANS_119DAYS,array(0,0,0,119,0,0));
$CONF["cycles"][168] = array("daily",120,TRANS_120DAYS,array(0,0,0,120,0,0));
$CONF["cycles"][169] = array("daily",121,TRANS_121DAYS,array(0,0,0,121,0,0));
$CONF["cycles"][170] = array("daily",122,TRANS_122DAYS,array(0,0,0,122,0,0));
$CONF["cycles"][171] = array("daily",123,TRANS_123DAYS,array(0,0,0,123,0,0));
$CONF["cycles"][172] = array("daily",124,TRANS_124DAYS,array(0,0,0,124,0,0));
$CONF["cycles"][173] = array("daily",125,TRANS_125DAYS,array(0,0,0,125,0,0));
$CONF["cycles"][174] = array("daily",126,TRANS_126DAYS,array(0,0,0,126,0,0));
$CONF["cycles"][175] = array("daily",127,TRANS_127DAYS,array(0,0,0,127,0,0));
$CONF["cycles"][176] = array("daily",128,TRANS_128DAYS,array(0,0,0,128,0,0));
$CONF["cycles"][177] = array("daily",129,TRANS_129DAYS,array(0,0,0,129,0,0));
$CONF["cycles"][178] = array("daily",130,TRANS_130DAYS,array(0,0,0,130,0,0));
$CONF["cycles"][179] = array("daily",131,TRANS_131DAYS,array(0,0,0,131,0,0));
$CONF["cycles"][180] = array("daily",132,TRANS_132DAYS,array(0,0,0,132,0,0));
$CONF["cycles"][181] = array("daily",133,TRANS_133DAYS,array(0,0,0,133,0,0));
$CONF["cycles"][182] = array("daily",134,TRANS_134DAYS,array(0,0,0,134,0,0));
$CONF["cycles"][183] = array("daily",135,TRANS_135DAYS,array(0,0,0,135,0,0));
$CONF["cycles"][184] = array("daily",136,TRANS_136DAYS,array(0,0,0,136,0,0));
$CONF["cycles"][185] = array("daily",137,TRANS_137DAYS,array(0,0,0,137,0,0));
$CONF["cycles"][186] = array("daily",138,TRANS_138DAYS,array(0,0,0,138,0,0));
$CONF["cycles"][187] = array("daily",139,TRANS_139DAYS,array(0,0,0,139,0,0));
$CONF["cycles"][188] = array("daily",140,TRANS_140DAYS,array(0,0,0,140,0,0));
$CONF["cycles"][189] = array("daily",141,TRANS_141DAYS,array(0,0,0,141,0,0));
$CONF["cycles"][190] = array("daily",142,TRANS_142DAYS,array(0,0,0,142,0,0));
$CONF["cycles"][191] = array("daily",143,TRANS_143DAYS,array(0,0,0,143,0,0));
$CONF["cycles"][192] = array("daily",144,TRANS_144DAYS,array(0,0,0,144,0,0));
$CONF["cycles"][193] = array("daily",145,TRANS_145DAYS,array(0,0,0,145,0,0));
$CONF["cycles"][194] = array("daily",146,TRANS_146DAYS,array(0,0,0,146,0,0));
$CONF["cycles"][195] = array("daily",147,TRANS_147DAYS,array(0,0,0,147,0,0));
$CONF["cycles"][196] = array("daily",148,TRANS_148DAYS,array(0,0,0,148,0,0));
$CONF["cycles"][197] = array("daily",149,TRANS_149DAYS,array(0,0,0,149,0,0));
$CONF["cycles"][198] = array("daily",150,TRANS_150DAYS,array(0,0,0,150,0,0));
$CONF["cycles"][199] = array("daily",151,TRANS_151DAYS,array(0,0,0,151,0,0));
$CONF["cycles"][200] = array("daily",152,TRANS_152DAYS,array(0,0,0,152,0,0));
$CONF["cycles"][201] = array("daily",153,TRANS_153DAYS,array(0,0,0,153,0,0));
$CONF["cycles"][202] = array("daily",154,TRANS_154DAYS,array(0,0,0,154,0,0));
$CONF["cycles"][203] = array("daily",155,TRANS_155DAYS,array(0,0,0,155,0,0));
$CONF["cycles"][204] = array("daily",156,TRANS_156DAYS,array(0,0,0,156,0,0));
$CONF["cycles"][205] = array("daily",157,TRANS_157DAYS,array(0,0,0,157,0,0));
$CONF["cycles"][206] = array("daily",158,TRANS_158DAYS,array(0,0,0,158,0,0));
$CONF["cycles"][207] = array("daily",159,TRANS_159DAYS,array(0,0,0,159,0,0));
$CONF["cycles"][208] = array("daily",160,TRANS_160DAYS,array(0,0,0,160,0,0));
$CONF["cycles"][209] = array("daily",161,TRANS_161DAYS,array(0,0,0,161,0,0));
$CONF["cycles"][210] = array("daily",162,TRANS_162DAYS,array(0,0,0,162,0,0));
$CONF["cycles"][211] = array("daily",163,TRANS_163DAYS,array(0,0,0,163,0,0));
$CONF["cycles"][212] = array("daily",164,TRANS_164DAYS,array(0,0,0,164,0,0));
$CONF["cycles"][213] = array("daily",165,TRANS_165DAYS,array(0,0,0,165,0,0));
$CONF["cycles"][214] = array("daily",166,TRANS_166DAYS,array(0,0,0,166,0,0));
$CONF["cycles"][215] = array("daily",167,TRANS_167DAYS,array(0,0,0,167,0,0));
$CONF["cycles"][216] = array("daily",168,TRANS_168DAYS,array(0,0,0,168,0,0));
$CONF["cycles"][217] = array("daily",169,TRANS_169DAYS,array(0,0,0,169,0,0));
$CONF["cycles"][218] = array("daily",170,TRANS_170DAYS,array(0,0,0,170,0,0));
$CONF["cycles"][219] = array("daily",171,TRANS_171DAYS,array(0,0,0,171,0,0));
$CONF["cycles"][220] = array("daily",172,TRANS_172DAYS,array(0,0,0,172,0,0));
$CONF["cycles"][221] = array("daily",173,TRANS_173DAYS,array(0,0,0,173,0,0));
$CONF["cycles"][222] = array("daily",174,TRANS_174DAYS,array(0,0,0,174,0,0));
$CONF["cycles"][223] = array("daily",175,TRANS_175DAYS,array(0,0,0,175,0,0));
$CONF["cycles"][224] = array("daily",176,TRANS_176DAYS,array(0,0,0,176,0,0));
$CONF["cycles"][225] = array("daily",177,TRANS_177DAYS,array(0,0,0,177,0,0));
$CONF["cycles"][226] = array("daily",178,TRANS_178DAYS,array(0,0,0,178,0,0));
$CONF["cycles"][227] = array("daily",179,TRANS_179DAYS,array(0,0,0,179,0,0));
$CONF["cycles"][228] = array("daily",180,TRANS_180DAYS,array(0,0,0,180,0,0));
$CONF["cycles"][229] = array("daily",181,TRANS_181DAYS,array(0,0,0,181,0,0));
$CONF["cycles"][230] = array("daily",182,TRANS_182DAYS,array(0,0,0,182,0,0));
$CONF["cycles"][231] = array("daily",183,TRANS_183DAYS,array(0,0,0,183,0,0));
$CONF["cycles"][232] = array("daily",184,TRANS_184DAYS,array(0,0,0,184,0,0));
$CONF["cycles"][233] = array("daily",185,TRANS_185DAYS,array(0,0,0,185,0,0));
$CONF["cycles"][234] = array("daily",186,TRANS_186DAYS,array(0,0,0,186,0,0));
$CONF["cycles"][235] = array("daily",187,TRANS_187DAYS,array(0,0,0,187,0,0));
$CONF["cycles"][236] = array("daily",188,TRANS_188DAYS,array(0,0,0,188,0,0));
$CONF["cycles"][237] = array("daily",189,TRANS_189DAYS,array(0,0,0,189,0,0));
$CONF["cycles"][238] = array("daily",190,TRANS_190DAYS,array(0,0,0,190,0,0));
$CONF["cycles"][239] = array("daily",191,TRANS_191DAYS,array(0,0,0,191,0,0));
$CONF["cycles"][240] = array("daily",192,TRANS_192DAYS,array(0,0,0,192,0,0));
$CONF["cycles"][241] = array("daily",193,TRANS_193DAYS,array(0,0,0,193,0,0));
$CONF["cycles"][242] = array("daily",194,TRANS_194DAYS,array(0,0,0,194,0,0));
$CONF["cycles"][243] = array("daily",195,TRANS_195DAYS,array(0,0,0,195,0,0));
$CONF["cycles"][244] = array("daily",196,TRANS_196DAYS,array(0,0,0,196,0,0));
$CONF["cycles"][245] = array("daily",197,TRANS_197DAYS,array(0,0,0,197,0,0));
$CONF["cycles"][246] = array("daily",198,TRANS_198DAYS,array(0,0,0,198,0,0));
$CONF["cycles"][247] = array("daily",199,TRANS_199DAYS,array(0,0,0,199,0,0));
$CONF["cycles"][248] = array("daily",200,TRANS_200DAYS,array(0,0,0,200,0,0));
$CONF["cycles"][249] = array("daily",201,TRANS_201DAYS,array(0,0,0,201,0,0));
$CONF["cycles"][250] = array("daily",202,TRANS_202DAYS,array(0,0,0,202,0,0));
$CONF["cycles"][251] = array("daily",203,TRANS_203DAYS,array(0,0,0,203,0,0));
$CONF["cycles"][252] = array("daily",204,TRANS_204DAYS,array(0,0,0,204,0,0));
$CONF["cycles"][253] = array("daily",205,TRANS_205DAYS,array(0,0,0,205,0,0));
$CONF["cycles"][254] = array("daily",206,TRANS_206DAYS,array(0,0,0,206,0,0));
$CONF["cycles"][255] = array("daily",207,TRANS_207DAYS,array(0,0,0,207,0,0));
$CONF["cycles"][256] = array("daily",208,TRANS_208DAYS,array(0,0,0,208,0,0));
$CONF["cycles"][257] = array("daily",209,TRANS_209DAYS,array(0,0,0,209,0,0));
$CONF["cycles"][258] = array("daily",210,TRANS_210DAYS,array(0,0,0,210,0,0));
$CONF["cycles"][259] = array("daily",211,TRANS_211DAYS,array(0,0,0,211,0,0));
$CONF["cycles"][260] = array("daily",212,TRANS_212DAYS,array(0,0,0,212,0,0));
$CONF["cycles"][261] = array("daily",213,TRANS_213DAYS,array(0,0,0,213,0,0));
$CONF["cycles"][262] = array("daily",214,TRANS_214DAYS,array(0,0,0,214,0,0));
$CONF["cycles"][263] = array("daily",215,TRANS_215DAYS,array(0,0,0,215,0,0));
$CONF["cycles"][264] = array("daily",216,TRANS_216DAYS,array(0,0,0,216,0,0));
$CONF["cycles"][265] = array("daily",217,TRANS_217DAYS,array(0,0,0,217,0,0));
$CONF["cycles"][266] = array("daily",218,TRANS_218DAYS,array(0,0,0,218,0,0));
$CONF["cycles"][267] = array("daily",219,TRANS_219DAYS,array(0,0,0,219,0,0));
$CONF["cycles"][268] = array("daily",220,TRANS_220DAYS,array(0,0,0,220,0,0));
$CONF["cycles"][269] = array("daily",221,TRANS_221DAYS,array(0,0,0,221,0,0));
$CONF["cycles"][270] = array("daily",222,TRANS_222DAYS,array(0,0,0,222,0,0));
$CONF["cycles"][271] = array("daily",223,TRANS_223DAYS,array(0,0,0,223,0,0));
$CONF["cycles"][272] = array("daily",224,TRANS_224DAYS,array(0,0,0,224,0,0));
$CONF["cycles"][273] = array("daily",225,TRANS_225DAYS,array(0,0,0,225,0,0));
$CONF["cycles"][274] = array("daily",226,TRANS_226DAYS,array(0,0,0,226,0,0));
$CONF["cycles"][275] = array("daily",227,TRANS_227DAYS,array(0,0,0,227,0,0));
$CONF["cycles"][276] = array("daily",228,TRANS_228DAYS,array(0,0,0,228,0,0));
$CONF["cycles"][277] = array("daily",229,TRANS_229DAYS,array(0,0,0,229,0,0));
$CONF["cycles"][278] = array("daily",230,TRANS_230DAYS,array(0,0,0,230,0,0));
$CONF["cycles"][279] = array("daily",231,TRANS_231DAYS,array(0,0,0,231,0,0));
$CONF["cycles"][280] = array("daily",232,TRANS_232DAYS,array(0,0,0,232,0,0));
$CONF["cycles"][281] = array("daily",233,TRANS_233DAYS,array(0,0,0,233,0,0));
$CONF["cycles"][282] = array("daily",234,TRANS_234DAYS,array(0,0,0,234,0,0));
$CONF["cycles"][283] = array("daily",235,TRANS_235DAYS,array(0,0,0,235,0,0));
$CONF["cycles"][284] = array("daily",236,TRANS_236DAYS,array(0,0,0,236,0,0));
$CONF["cycles"][285] = array("daily",237,TRANS_237DAYS,array(0,0,0,237,0,0));
$CONF["cycles"][286] = array("daily",238,TRANS_238DAYS,array(0,0,0,238,0,0));
$CONF["cycles"][287] = array("daily",239,TRANS_239DAYS,array(0,0,0,239,0,0));
$CONF["cycles"][288] = array("daily",240,TRANS_240DAYS,array(0,0,0,240,0,0));
$CONF["cycles"][289] = array("daily",241,TRANS_241DAYS,array(0,0,0,241,0,0));
$CONF["cycles"][290] = array("daily",242,TRANS_242DAYS,array(0,0,0,242,0,0));
$CONF["cycles"][291] = array("daily",243,TRANS_243DAYS,array(0,0,0,243,0,0));
$CONF["cycles"][292] = array("daily",244,TRANS_244DAYS,array(0,0,0,244,0,0));
$CONF["cycles"][293] = array("daily",245,TRANS_245DAYS,array(0,0,0,245,0,0));
$CONF["cycles"][294] = array("daily",246,TRANS_246DAYS,array(0,0,0,246,0,0));
$CONF["cycles"][295] = array("daily",247,TRANS_247DAYS,array(0,0,0,247,0,0));
$CONF["cycles"][296] = array("daily",248,TRANS_248DAYS,array(0,0,0,248,0,0));
$CONF["cycles"][297] = array("daily",249,TRANS_249DAYS,array(0,0,0,249,0,0));
$CONF["cycles"][298] = array("daily",250,TRANS_250DAYS,array(0,0,0,250,0,0));
$CONF["cycles"][299] = array("daily",251,TRANS_251DAYS,array(0,0,0,251,0,0));
$CONF["cycles"][300] = array("daily",252,TRANS_252DAYS,array(0,0,0,252,0,0));
$CONF["cycles"][301] = array("daily",253,TRANS_253DAYS,array(0,0,0,253,0,0));
$CONF["cycles"][302] = array("daily",254,TRANS_254DAYS,array(0,0,0,254,0,0));
$CONF["cycles"][303] = array("daily",255,TRANS_255DAYS,array(0,0,0,255,0,0));
$CONF["cycles"][304] = array("daily",256,TRANS_256DAYS,array(0,0,0,256,0,0));
$CONF["cycles"][305] = array("daily",257,TRANS_257DAYS,array(0,0,0,257,0,0));
$CONF["cycles"][306] = array("daily",258,TRANS_258DAYS,array(0,0,0,258,0,0));
$CONF["cycles"][307] = array("daily",259,TRANS_259DAYS,array(0,0,0,259,0,0));
$CONF["cycles"][308] = array("daily",260,TRANS_260DAYS,array(0,0,0,260,0,0));
$CONF["cycles"][309] = array("daily",261,TRANS_261DAYS,array(0,0,0,261,0,0));
$CONF["cycles"][310] = array("daily",262,TRANS_262DAYS,array(0,0,0,262,0,0));
$CONF["cycles"][311] = array("daily",263,TRANS_263DAYS,array(0,0,0,263,0,0));
$CONF["cycles"][312] = array("daily",264,TRANS_264DAYS,array(0,0,0,264,0,0));
$CONF["cycles"][313] = array("daily",265,TRANS_265DAYS,array(0,0,0,265,0,0));
$CONF["cycles"][314] = array("daily",266,TRANS_266DAYS,array(0,0,0,266,0,0));
$CONF["cycles"][315] = array("daily",267,TRANS_267DAYS,array(0,0,0,267,0,0));
$CONF["cycles"][316] = array("daily",268,TRANS_268DAYS,array(0,0,0,268,0,0));
$CONF["cycles"][317] = array("daily",269,TRANS_269DAYS,array(0,0,0,269,0,0));
$CONF["cycles"][318] = array("daily",270,TRANS_270DAYS,array(0,0,0,270,0,0));
$CONF["cycles"][319] = array("daily",271,TRANS_271DAYS,array(0,0,0,271,0,0));
$CONF["cycles"][320] = array("daily",272,TRANS_272DAYS,array(0,0,0,272,0,0));
$CONF["cycles"][321] = array("daily",273,TRANS_273DAYS,array(0,0,0,273,0,0));
$CONF["cycles"][322] = array("daily",274,TRANS_274DAYS,array(0,0,0,274,0,0));
$CONF["cycles"][323] = array("daily",275,TRANS_275DAYS,array(0,0,0,275,0,0));
$CONF["cycles"][324] = array("daily",276,TRANS_276DAYS,array(0,0,0,276,0,0));
$CONF["cycles"][325] = array("daily",277,TRANS_277DAYS,array(0,0,0,277,0,0));
$CONF["cycles"][326] = array("daily",278,TRANS_278DAYS,array(0,0,0,278,0,0));
$CONF["cycles"][327] = array("daily",279,TRANS_279DAYS,array(0,0,0,279,0,0));
$CONF["cycles"][328] = array("daily",280,TRANS_280DAYS,array(0,0,0,280,0,0));
$CONF["cycles"][329] = array("daily",281,TRANS_281DAYS,array(0,0,0,281,0,0));
$CONF["cycles"][330] = array("daily",282,TRANS_282DAYS,array(0,0,0,282,0,0));
$CONF["cycles"][331] = array("daily",283,TRANS_283DAYS,array(0,0,0,283,0,0));
$CONF["cycles"][332] = array("daily",284,TRANS_284DAYS,array(0,0,0,284,0,0));
$CONF["cycles"][333] = array("daily",285,TRANS_285DAYS,array(0,0,0,285,0,0));
$CONF["cycles"][334] = array("daily",286,TRANS_286DAYS,array(0,0,0,286,0,0));
$CONF["cycles"][335] = array("daily",287,TRANS_287DAYS,array(0,0,0,287,0,0));
$CONF["cycles"][336] = array("daily",288,TRANS_288DAYS,array(0,0,0,288,0,0));
$CONF["cycles"][337] = array("daily",289,TRANS_289DAYS,array(0,0,0,289,0,0));
$CONF["cycles"][338] = array("daily",290,TRANS_290DAYS,array(0,0,0,290,0,0));
$CONF["cycles"][339] = array("daily",291,TRANS_291DAYS,array(0,0,0,291,0,0));
$CONF["cycles"][340] = array("daily",292,TRANS_292DAYS,array(0,0,0,292,0,0));
$CONF["cycles"][341] = array("daily",293,TRANS_293DAYS,array(0,0,0,293,0,0));
$CONF["cycles"][342] = array("daily",294,TRANS_294DAYS,array(0,0,0,294,0,0));
$CONF["cycles"][343] = array("daily",295,TRANS_295DAYS,array(0,0,0,295,0,0));
$CONF["cycles"][344] = array("daily",296,TRANS_296DAYS,array(0,0,0,296,0,0));
$CONF["cycles"][345] = array("daily",297,TRANS_297DAYS,array(0,0,0,297,0,0));
$CONF["cycles"][346] = array("daily",298,TRANS_298DAYS,array(0,0,0,298,0,0));
$CONF["cycles"][347] = array("daily",299,TRANS_299DAYS,array(0,0,0,299,0,0));
$CONF["cycles"][348] = array("daily",300,TRANS_300DAYS,array(0,0,0,300,0,0));
$CONF["cycles"][349] = array("daily",301,TRANS_301DAYS,array(0,0,0,301,0,0));
$CONF["cycles"][350] = array("daily",302,TRANS_302DAYS,array(0,0,0,302,0,0));
$CONF["cycles"][351] = array("daily",303,TRANS_303DAYS,array(0,0,0,303,0,0));
$CONF["cycles"][352] = array("daily",304,TRANS_304DAYS,array(0,0,0,304,0,0));
$CONF["cycles"][353] = array("daily",305,TRANS_305DAYS,array(0,0,0,305,0,0));
$CONF["cycles"][354] = array("daily",306,TRANS_306DAYS,array(0,0,0,306,0,0));
$CONF["cycles"][355] = array("daily",307,TRANS_307DAYS,array(0,0,0,307,0,0));
$CONF["cycles"][356] = array("daily",308,TRANS_308DAYS,array(0,0,0,308,0,0));
$CONF["cycles"][357] = array("daily",309,TRANS_309DAYS,array(0,0,0,309,0,0));
$CONF["cycles"][358] = array("daily",310,TRANS_310DAYS,array(0,0,0,310,0,0));
$CONF["cycles"][359] = array("daily",311,TRANS_311DAYS,array(0,0,0,311,0,0));
$CONF["cycles"][360] = array("daily",312,TRANS_312DAYS,array(0,0,0,312,0,0));
$CONF["cycles"][361] = array("daily",313,TRANS_313DAYS,array(0,0,0,313,0,0));
$CONF["cycles"][362] = array("daily",314,TRANS_314DAYS,array(0,0,0,314,0,0));
$CONF["cycles"][363] = array("daily",315,TRANS_315DAYS,array(0,0,0,315,0,0));
$CONF["cycles"][364] = array("daily",316,TRANS_316DAYS,array(0,0,0,316,0,0));
$CONF["cycles"][365] = array("daily",317,TRANS_317DAYS,array(0,0,0,317,0,0));
$CONF["cycles"][366] = array("daily",318,TRANS_318DAYS,array(0,0,0,318,0,0));
$CONF["cycles"][367] = array("daily",319,TRANS_319DAYS,array(0,0,0,319,0,0));
$CONF["cycles"][368] = array("daily",320,TRANS_320DAYS,array(0,0,0,320,0,0));
$CONF["cycles"][369] = array("daily",321,TRANS_321DAYS,array(0,0,0,321,0,0));
$CONF["cycles"][370] = array("daily",322,TRANS_322DAYS,array(0,0,0,322,0,0));
$CONF["cycles"][371] = array("daily",323,TRANS_323DAYS,array(0,0,0,323,0,0));
$CONF["cycles"][372] = array("daily",324,TRANS_324DAYS,array(0,0,0,324,0,0));
$CONF["cycles"][373] = array("daily",325,TRANS_325DAYS,array(0,0,0,325,0,0));
$CONF["cycles"][374] = array("daily",326,TRANS_326DAYS,array(0,0,0,326,0,0));
$CONF["cycles"][375] = array("daily",327,TRANS_327DAYS,array(0,0,0,327,0,0));
$CONF["cycles"][376] = array("daily",328,TRANS_328DAYS,array(0,0,0,328,0,0));
$CONF["cycles"][377] = array("daily",329,TRANS_329DAYS,array(0,0,0,329,0,0));
$CONF["cycles"][378] = array("daily",330,TRANS_330DAYS,array(0,0,0,330,0,0));
$CONF["cycles"][379] = array("daily",331,TRANS_331DAYS,array(0,0,0,331,0,0));
$CONF["cycles"][380] = array("daily",332,TRANS_332DAYS,array(0,0,0,332,0,0));
$CONF["cycles"][381] = array("daily",333,TRANS_333DAYS,array(0,0,0,333,0,0));
$CONF["cycles"][382] = array("daily",334,TRANS_334DAYS,array(0,0,0,334,0,0));
$CONF["cycles"][383] = array("daily",335,TRANS_335DAYS,array(0,0,0,335,0,0));
$CONF["cycles"][384] = array("daily",336,TRANS_336DAYS,array(0,0,0,336,0,0));
$CONF["cycles"][385] = array("daily",337,TRANS_337DAYS,array(0,0,0,337,0,0));
$CONF["cycles"][386] = array("daily",338,TRANS_338DAYS,array(0,0,0,338,0,0));
$CONF["cycles"][387] = array("daily",339,TRANS_339DAYS,array(0,0,0,339,0,0));
$CONF["cycles"][388] = array("daily",340,TRANS_340DAYS,array(0,0,0,340,0,0));
$CONF["cycles"][389] = array("daily",341,TRANS_341DAYS,array(0,0,0,341,0,0));
$CONF["cycles"][390] = array("daily",342,TRANS_342DAYS,array(0,0,0,342,0,0));
$CONF["cycles"][391] = array("daily",343,TRANS_343DAYS,array(0,0,0,343,0,0));
$CONF["cycles"][392] = array("daily",344,TRANS_344DAYS,array(0,0,0,344,0,0));
$CONF["cycles"][393] = array("daily",345,TRANS_345DAYS,array(0,0,0,345,0,0));
$CONF["cycles"][394] = array("daily",346,TRANS_346DAYS,array(0,0,0,346,0,0));
$CONF["cycles"][395] = array("daily",347,TRANS_347DAYS,array(0,0,0,347,0,0));
$CONF["cycles"][396] = array("daily",348,TRANS_348DAYS,array(0,0,0,348,0,0));
$CONF["cycles"][397] = array("daily",349,TRANS_349DAYS,array(0,0,0,349,0,0));
$CONF["cycles"][398] = array("daily",350,TRANS_350DAYS,array(0,0,0,350,0,0));
$CONF["cycles"][399] = array("daily",351,TRANS_351DAYS,array(0,0,0,351,0,0));
$CONF["cycles"][400] = array("daily",352,TRANS_352DAYS,array(0,0,0,352,0,0));
$CONF["cycles"][401] = array("daily",353,TRANS_353DAYS,array(0,0,0,353,0,0));
$CONF["cycles"][402] = array("daily",354,TRANS_354DAYS,array(0,0,0,354,0,0));
$CONF["cycles"][403] = array("daily",355,TRANS_355DAYS,array(0,0,0,355,0,0));
$CONF["cycles"][404] = array("daily",356,TRANS_356DAYS,array(0,0,0,356,0,0));
$CONF["cycles"][405] = array("daily",357,TRANS_357DAYS,array(0,0,0,357,0,0));
$CONF["cycles"][406] = array("daily",358,TRANS_358DAYS,array(0,0,0,358,0,0));
$CONF["cycles"][407] = array("daily",359,TRANS_359DAYS,array(0,0,0,359,0,0));
$CONF["cycles"][408] = array("daily",360,TRANS_360DAYS,array(0,0,0,360,0,0));
$CONF["cycles"][409] = array("daily",361,TRANS_361DAYS,array(0,0,0,361,0,0));
$CONF["cycles"][410] = array("daily",362,TRANS_362DAYS,array(0,0,0,362,0,0));
$CONF["cycles"][411] = array("daily",363,TRANS_363DAYS,array(0,0,0,363,0,0));
$CONF["cycles"][412] = array("daily",364,TRANS_364DAYS,array(0,0,0,364,0,0));
$CONF["cycles"][413] = array("daily",365,TRANS_365DAYS,array(0,0,0,365,0,0));

// weekly billing cycles: 1 to 52 weeks
$CONF["cycles"][414] = array("weekly",1,TRANS_1WEEK,array(0,0,0,7,0,0));
$CONF["cycles"][415] = array("weekly",2,TRANS_2WEEKS,array(0,0,0,14,0,0));
$CONF["cycles"][416] = array("weekly",3,TRANS_3WEEKS,array(0,0,0,21,0,0));
$CONF["cycles"][417] = array("weekly",4,TRANS_4WEEKS,array(0,0,0,28,0,0));
$CONF["cycles"][418] = array("weekly",5,TRANS_5WEEKS,array(0,0,0,35,0,0));
$CONF["cycles"][419] = array("weekly",6,TRANS_6WEEKS,array(0,0,0,42,0,0));
$CONF["cycles"][420] = array("weekly",7,TRANS_7WEEKS,array(0,0,0,49,0,0));
$CONF["cycles"][421] = array("weekly",8,TRANS_8WEEKS,array(0,0,0,56,0,0));
$CONF["cycles"][422] = array("weekly",9,TRANS_9WEEKS,array(0,0,0,63,0,0));
$CONF["cycles"][423] = array("weekly",10,TRANS_10WEEKS,array(0,0,0,70,0,0));
$CONF["cycles"][424] = array("weekly",11,TRANS_11WEEKS,array(0,0,0,77,0,0));
$CONF["cycles"][425] = array("weekly",12,TRANS_12WEEKS,array(0,0,0,84,0,0));
$CONF["cycles"][426] = array("weekly",13,TRANS_13WEEKS,array(0,0,0,91,0,0));
$CONF["cycles"][427] = array("weekly",14,TRANS_14WEEKS,array(0,0,0,98,0,0));
$CONF["cycles"][428] = array("weekly",15,TRANS_15WEEKS,array(0,0,0,105,0,0));
$CONF["cycles"][429] = array("weekly",16,TRANS_16WEEKS,array(0,0,0,112,0,0));
$CONF["cycles"][430] = array("weekly",17,TRANS_17WEEKS,array(0,0,0,119,0,0));
$CONF["cycles"][431] = array("weekly",18,TRANS_18WEEKS,array(0,0,0,126,0,0));
$CONF["cycles"][432] = array("weekly",19,TRANS_19WEEKS,array(0,0,0,133,0,0));
$CONF["cycles"][433] = array("weekly",20,TRANS_20WEEKS,array(0,0,0,140,0,0));
$CONF["cycles"][434] = array("weekly",21,TRANS_21WEEKS,array(0,0,0,147,0,0));
$CONF["cycles"][435] = array("weekly",22,TRANS_22WEEKS,array(0,0,0,154,0,0));
$CONF["cycles"][436] = array("weekly",23,TRANS_23WEEKS,array(0,0,0,161,0,0));
$CONF["cycles"][437] = array("weekly",24,TRANS_24WEEKS,array(0,0,0,168,0,0));
$CONF["cycles"][438] = array("weekly",25,TRANS_25WEEKS,array(0,0,0,175,0,0));
$CONF["cycles"][439] = array("weekly",26,TRANS_26WEEKS,array(0,0,0,182,0,0));
$CONF["cycles"][440] = array("weekly",27,TRANS_27WEEKS,array(0,0,0,189,0,0));
$CONF["cycles"][441] = array("weekly",28,TRANS_28WEEKS,array(0,0,0,196,0,0));
$CONF["cycles"][442] = array("weekly",29,TRANS_29WEEKS,array(0,0,0,203,0,0));
$CONF["cycles"][443] = array("weekly",30,TRANS_30WEEKS,array(0,0,0,210,0,0));
$CONF["cycles"][444] = array("weekly",31,TRANS_31WEEKS,array(0,0,0,217,0,0));
$CONF["cycles"][445] = array("weekly",32,TRANS_32WEEKS,array(0,0,0,224,0,0));
$CONF["cycles"][446] = array("weekly",33,TRANS_33WEEKS,array(0,0,0,231,0,0));
$CONF["cycles"][447] = array("weekly",34,TRANS_34WEEKS,array(0,0,0,238,0,0));
$CONF["cycles"][448] = array("weekly",35,TRANS_35WEEKS,array(0,0,0,245,0,0));
$CONF["cycles"][449] = array("weekly",36,TRANS_36WEEKS,array(0,0,0,252,0,0));
$CONF["cycles"][450] = array("weekly",37,TRANS_37WEEKS,array(0,0,0,259,0,0));
$CONF["cycles"][451] = array("weekly",38,TRANS_38WEEKS,array(0,0,0,266,0,0));
$CONF["cycles"][452] = array("weekly",39,TRANS_39WEEKS,array(0,0,0,273,0,0));
$CONF["cycles"][453] = array("weekly",40,TRANS_40WEEKS,array(0,0,0,280,0,0));
$CONF["cycles"][454] = array("weekly",41,TRANS_41WEEKS,array(0,0,0,287,0,0));
$CONF["cycles"][455] = array("weekly",42,TRANS_42WEEKS,array(0,0,0,294,0,0));
$CONF["cycles"][456] = array("weekly",43,TRANS_43WEEKS,array(0,0,0,301,0,0));
$CONF["cycles"][457] = array("weekly",44,TRANS_44WEEKS,array(0,0,0,308,0,0));
$CONF["cycles"][458] = array("weekly",45,TRANS_45WEEKS,array(0,0,0,315,0,0));
$CONF["cycles"][459] = array("weekly",46,TRANS_46WEEKS,array(0,0,0,322,0,0));
$CONF["cycles"][460] = array("weekly",47,TRANS_47WEEKS,array(0,0,0,329,0,0));
$CONF["cycles"][461] = array("weekly",48,TRANS_48WEEKS,array(0,0,0,336,0,0));
$CONF["cycles"][462] = array("weekly",49,TRANS_49WEEKS,array(0,0,0,343,0,0));
$CONF["cycles"][463] = array("weekly",50,TRANS_50WEEKS,array(0,0,0,350,0,0));
$CONF["cycles"][464] = array("weekly",51,TRANS_51WEEKS,array(0,0,0,357,0,0));
$CONF["cycles"][465] = array("weekly",52,TRANS_52WEEKS,array(0,0,0,364,0,0));

// monthly billing cycles: 1 to 60 months
$CONF["cycles"][466] = array("monthly",1,TRANS_MONTHLY,array(0,0,0,0,1,0));
$CONF["cycles"][467] = array("monthly",2,TRANS_BIMONTHLY,array(0,0,0,0,2,0));
$CONF["cycles"][468] = array("monthly",3,TRANS_QUARTERLY,array(0,0,0,0,3,0));
$CONF["cycles"][469] = array("monthly",6,TRANS_SEMIANNUALLY,array(0,0,0,0,6,0));
$CONF["cycles"][470] = array("monthly",12,TRANS_ANNUALLY,array(0,0,0,0,12,0));
$CONF["cycles"][471] = array("monthly",24,TRANS_24MONTHS,array(0,0,0,0,24,0));
$CONF["cycles"][472] = array("monthly",36,TRANS_36MONTHS,array(0,0,0,0,36,0));
$CONF["cycles"][473] = array("monthly",48,TRANS_48MONTHS,array(0,0,0,0,48,0));
$CONF["cycles"][474] = array("monthly",60,TRANS_60MONTHS,array(0,0,0,0,60,0));

// yearly billing cycles: 1 to 10 years (for domains & certs primarily)
$CONF["cycles"][475] = array("yearly",1,TRANS_1YEAR,array(0,0,0,0,0,1));
$CONF["cycles"][476] = array("yearly",2,TRANS_2YEARS,array(0,0,0,0,0,2));
$CONF["cycles"][477] = array("yearly",3,TRANS_3YEARS,array(0,0,0,0,0,3));
$CONF["cycles"][478] = array("yearly",4,TRANS_4YEARS,array(0,0,0,0,0,4));
$CONF["cycles"][479] = array("yearly",5,TRANS_5YEARS,array(0,0,0,0,0,5));
$CONF["cycles"][480] = array("yearly",6,TRANS_6YEARS,array(0,0,0,0,0,6));
$CONF["cycles"][481] = array("yearly",7,TRANS_7YEARS,array(0,0,0,0,0,7));
$CONF["cycles"][482] = array("yearly",8,TRANS_8YEARS,array(0,0,0,0,0,8));
$CONF["cycles"][483] = array("yearly",9,TRANS_9YEARS,array(0,0,0,0,0,9));
$CONF["cycles"][484] = array("yearly",10,TRANS_10YEARS,array(0,0,0,0,0,10));

*/

/**
 * Get all integer IDs & constant values of the time cycle with the given internal name.
 *
 * @param  type  The type of time cycle to lookup (i.e. "monthly", or "yearly", or "" for all)
 * @return  The integer ID & constant value of the time cycle as an array.
 */
function getCyclesArray($type="") {
	global $CONF;
    populateCONFCycles();
	$retval = array();
	$type = strval($type);
	foreach($CONF["cycles"] as $key => $value) {
        if( $type == $value[0] || !$type) {
		    $retval[$key] = (defined($value[2])) ? constant($value[2]) : $value[2] ;
		}
	}
    ksort($retval);
	return $retval;
}

/**
 * Get the integer ID of the time cycle with the given internal name and multiplier value.
 * If the given internal name & multiplier values are not found, this function returns false.
 *
 * @param  type  The type of time cycle to lookup (i.e. "monthly", or "yearly")
 * @param  multiplier  The value of the time cycle multiplier
 * @return  The integer ID of the time cycle, or false if the name was not found.
 */
function getCycleID($type, $multiplier) {
	global $CONF;
    populateCONFCycles();
	$retval = false;
	$type = strval($type);
	$multiplier = ((int) $multiplier);
	foreach($CONF["cycles"] as $key => $value) {
		if( @ereg($type,$value[0]) && ($value[1] == $multiplier) ) {
			$retval = $key;
			break;
		}
	}
	return $retval;
}

/**
 * Returns an array of time cycle ids of a certain type.
 *
 * @param  type  The type of time cycle ids to return.
 * @return  An array of time cycle ids of the given type, or empty array if the type was not found.
 */
function getCycleIDs($type) {
    global $CONF;
    populateCONFCycles();
    $type = strval($type);
    $retval = array();
    foreach($CONF["cycles"] as $key => $value) {
        if( @ereg($type,$value[0])) {
            $retval[] = $key;
        }
    }
    print_r($retval);
    return $retval;
}

/**
 * Returns an array of all time cycle ids.
 *
 * @return  An array of all time cycle ids.
 */
function getAllCycleIDs() {
    global $CONF;
    populateCONFCycles();
    $retval = array();
    foreach($CONF["cycles"] as $key => $value) {
        $retval[] = $key;
    }
    return $retval;
}

/**
 * Get the string constant name of the time cycle associated with the given integer ID.
 * If the given ID is not found, then this function returns false.
 *
 * @param  id  The id of the time cycle constant to lookup
 * @return  The string constant name associated with the given ID, or false if the ID was not found
 */
function getCycleName($id) {
	global $CONF;
    populateCONFCycles();
	$id = ((int) $id);
	$retval = false;
	if(is_array($CONF["cycles"][$id])) {
		$retval = $CONF["cycles"][$id][2];
	}
	return $retval;
}

/**
 * Get the time cycle data of the time cycle associated with the given integer ID.
 * If the given ID is not found, then this function returns false.
 *
 * @param  id  The id of the time cycle data to lookup
 * @return  The array of time cycle data associated with the given ID, or false if the ID was not found
 */
function getCycleData($id) {
	global $CONF;
    populateCONFCycles();
	$id = ((int) $id);
	$retval = false;
	if(is_array($CONF["cycles"][$id])) {
		$retval = $CONF["cycles"][$id][3];
	}
	return $retval;
}

/**
 * Returns next renewal timestamp in unix seconds. This will be the NEXT time this package renews.
 *
 * @param  timestamp  The current renewal timestamp of this package.
 * @param  cycleID  The time cycle id of this package.
 * @return  the next time timestamp for this package or 0 if not valid.
 */
function getNextBillingTimestamp($timestamp, $cycleID) {
    $timeData = localtime(((int) $timestamp), 1);

    $billingCycleData = getCycleData($cycleID);
    $retval = 0;


    if(is_array($billingCycleData)) {
        $secs   = ((int) $timeData["tm_sec"])   + ((int) $billingCycleData[0]);
        $mins   = ((int) $timeData["tm_min"])   + ((int) $billingCycleData[1]);
        $hours  = ((int) $timeData["tm_hour"])  + ((int) $billingCycleData[2]);
        $days   = ((int) $timeData["tm_mday"])  + ((int) $billingCycleData[3]);
        $months = ((int) $timeData["tm_mon"])   + 1 + ((int) $billingCycleData[4]); // localtime counts 0 as January
        $years  = 1900 + ((int) $timeData["tm_year"])  + ((int) $billingCycleData[5]);

        $retval = mktime($hours, $mins, $secs, $months, $days, $years);
    }

    return $retval;
}


/**
 * Returns last renewal timestamp in unix seconds. This will be the LAST time this package renewed.
 * (unless they switched packages from a package with a different payment cycle in the last cycle)
 *
 * @param  timestamp  The current renewal timestamp of this package.
 * @param  cycleID  The time cycle id of this package.
 * @return  the next time timestamp for this package or 0 if not valid.
 */
function getLastBillingTimestamp($timestamp, $cycleID) {
    $timeData = localtime(((int) $timestamp), 1);

    $billingCycleData = getCycleData($cycleID);
    $retval = 0;

    if(is_array($billingCycleData)) {
        $secs   = ((int) $timeData["tm_sec"])   - ((int) $billingCycleData[0]);
        $mins   = ((int) $timeData["tm_min"])   - ((int) $billingCycleData[1]);
        $hours  = ((int) $timeData["tm_hour"])  - ((int) $billingCycleData[2]);
        $days   = ((int) $timeData["tm_mday"])  - ((int) $billingCycleData[3]);
        $months = ((int) $timeData["tm_mon"])   + 1 - ((int) $billingCycleData[4]); // localtime counts 0 as January
        $years  = 1900 + ((int) $timeData["tm_year"])  - ((int) $billingCycleData[5]);

        $retval = mktime($hours, $mins, $secs, $months, $days, $years);
    }
    return $retval;
}
?>
