<?php
// $Id: accountingGeneralLedger.php 9939 2006-11-03 17:43:10Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['accountingGeneralLedger'] = array(
	"names" => array(
		"singular" => "accountingGeneralLedgerEntry",
		"plural" => "accountingGeneralLedger",
		"file" => "accounting.php",
	),
	"request" => array(
		'command' => "GetAccountingGeneralLedger",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("GetAccountingGeneralLedger", "GetAccountingGeneralLedgerEntry"),
	),
	"insert" => array(
		"command" => "SetAccountingGeneralLedger",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetAccountingGeneralLedger",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetAccountingGeneralLedger",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("cycleID")),
	),
	"table" => "accounting_general_ledger",
	"columns" => array(
		"generalLedgerID" => COLUMN_PRIMARY_KEY,
		"clientID" => COLUMN_ID,
		"invoiceID" => COLUMN_ID,
		"journalTableID" => COLUMN_ID,
		"journalTableName" => COLUMN_TEXT,
		"generalLedgerType" => COLUMN_INT,
		"ledgerAccountID" => COLUMN_INT,
		"generalLedgerDateCreated" => COLUMN_DATE,
		"generalLedgerDescription" => COLUMN_TEXT,
		"generalLedgerDebitAmount" => COLUMN_AMOUNT,
		"generalLedgerCreditAmount" => COLUMN_AMOUNT,
		"currencyID" => COLUMN_TEXT,		
	),
	"display" => array(
		"filterContextValues" => array(
			"clientID",
			"invoiceID",
		),
		"context" => array(
			"clientID" => "clients",
			"invoiceID" => "invoices",
		),
		"revContext" => array(
			"accountingControlRels" => "generalLedgerID",
		),
	),
);

?>
