<?php
// $Id: callbackLogs.php 10180 2006-12-01 17:51:54Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['callbackLogs'] = array(
	"names" => array(
		"singular" => "callbackLog",
		"plural" => "callbackLogs",
		"file" => "paymentqueue",
	),
	"request" => array(
		'command' => "GetCallbackLogs",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("callbackLogs", "callbackLog"),
	),
	"insert" => array(
		"command" => "SetCallbackLogs",
		"subCommand" => "insert",
		"params" => array(),//$allParamsRoot,
	),
	"update" => array(
		"command" => "SetCallbackLogs",
		"subCommand" => "update",
		"params" => array(),//$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetCallbackLogs",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeID")),
	),
	"table" => "callback_log",
	"columns" => array(
		"callbackLogID" => COLUMN_PRIMARY_KEY|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogType" => COLUMN_TYPE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogTransactionID" => COLUMN_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogParentTransactionID" => COLUMN_NAME|COLUMN_DISPLAYABLE,
		"callbackLogAction" => COLUMN_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogActionStatus" => COLUMN_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"transactionID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"clientID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"subscriptionID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"configGroupID" => COLUMN_ID,
		"billingAccountID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"callbackLogDateCreated" => COLUMN_IS_DATE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
	),
	"types" => array(
		"callbackLogType" => "callbackLog",
	),
	"columnLabels" => array(
		"callbackLogID" => TRANS_CALLBACK_LOG_ID,
		"callbackLogType" => TRANS_CALLBACK_LOG_TYPE,
		"callbackLogTransactionID" => TRANS_TRANSACTION_ID,
		"callbackLogParentTransactionID" => TRANS_PARENT_TRANSACTION_ID,
		"callbackLogAction" => TRANS_CALLBACK_ACTION,
		"callbackLogActionStatus" => TRANS_ACTION_STATUS,
		"transactionID" => TRANS_TRANSACTION,
		"clientID" => TRANS_CLIENT,
		"subscriptionID" => TRANS_SUBSCRIPTION,
		"configGroupID" => TRANS_GATEWAY_ID,
		"billingAccountID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogDateCreated" => COLUMN_IS_DATE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_FINANCES",
		"childName" => "TRANS_MANAGE_BILLING",
		"sideNavMajor" => "finances",
		"sideNavMinor" => "billing",
		"grandchildrenLabels" => array(
			"show" => "TRANS_SHOW_CALLBACK_LOGS",
			"showdetails" => "TRANS_CALLBACK_LOG_DETAILS",
		)
	),
	"display" => array(
		'context' => array(
			'clientID' => 'clientWithPrimary',
			'transactionID' => 'transactionLog',
			'billingAccountID' => 'billingAccounts',
		),
		'revContext' => array(
			'callbackLogAttributes' => 'callbackLogID',
		),
		'showTemplate' => "1",
		'showDetailsTemplate' => "1",
		"suppressActions" => array("add","edit"),
	),
);
