<?php
// $Id: configGroups.php 10225 2006-12-06 23:11:47Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['configGroups'] = array(
	"names" => array(
		"singular" => "configGroup",
		"plural" => "configGroups",
		"file" => "system",
	),
	"request" => array(
		'command' => "GetConfigGroups",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("configGroups", "configGroup"),
	),
	"insert" => array(
		"command" => "SetConfigGroups",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetConfigGroups",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetConfigGroups",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "config_groups",
	"columns" => array(
		"configGroupID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT|COLUMN_RESTRICT_REMOVE,
		"parentConfigGroupID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"configGroupName" => COLUMN_PRIMARY_NAME|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupIcon" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupTransKey" => COLUMN_TEXT|COLUMN_TRANSLATION_MESSAGE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupOrder" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupLocked" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupActionFile" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupActionName" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE,
	),
	"columnLabels" => array(
	),
	"types" => array(
	),
	"relations" => array(
		"paymentGroups" => array("payment_groups_gateway_rel", "paymentGroupIDs", "paymentGroupID"),
	),
	"display" => array(
		"options" => array("cycles"),
		"context" => array(
			"parentConfigGroupID" => "configGroups",
		),
		"revContext" => array(
			"configParams" => "configGroupID",
			"configGroups" => "configGroupID",
			"transactionLog" => "configGroupID",
			"packageAttributes" => "configGroupID",
			"serverGroupRels" => "serverID",
		),
		'showTemplate' => "packages/ShowPackageAddons",
		'showParams' => array(
			'packageAddonActive' => 1,
		),
		'suppressActions' => array('showdetails', 'remove'),
		'showDetailsTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
	),
);
