<?php
// $Id: accountingReceiptsJournals.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["accountingReceiptsJournals"] = baseMap("accounting_receipts_journal", null, "accountingReceiptsJournals", "accountingReceiptsJournal") + array(
	"columns" => array(
		'receiptJournalID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'clientID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptDescription' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptCashDebitAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptCashCreditAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptAccRecDebitAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptAccRecCreditAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptSalesDebitAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptSalesCreditAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptTaxPayDebitAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptTaxPayCreditAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptCouponDebitAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'receiptCouponCreditAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'currencyID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'receiptJournalID' => TRANS_RECEIPT_JOURNAL_ID,
		'clientID' => TRANS_CLIENT_ID,
		'invoiceID' => TRANS_INVOICE_ID,
		'transactionID' => TRANS_TRANSACTION_ID,
		'receiptDateCreated' => TRANS_RECEIPT_DATE_CREATED,
		'receiptDescription' => TRANS_RECEIPT_DESCRIPTION,
		'receiptCashDebitAmount' => TRANS_RECEIPT_CASH_DEBIT_AMOUNT,
		'receiptCashCreditAmount' => TRANS_RECEIPT_CASH_CREDIT_AMOUNT,
		'receiptAccRecDebitAmount' => TRANS_RECEIPT_ACC_REC_DEBIT_AMOUNT,
		'receiptAccRecCreditAmount' => TRANS_RECEIPT_ACC_REC_CREDIT_AMOUNT,
		'receiptSalesDebitAmount' => TRANS_RECEIPT_SALES_DEBIT_AMOUNT,
		'receiptSalesCreditAmount' => TRANS_RECEIPT_SALES_CREDIT_AMOUNT,
		'receiptTaxPayDebitAmount' => TRANS_RECEIPT_TAX_PAY_DEBIT_AMOUNT,
		'receiptTaxPayCreditAmount' => TRANS_RECEIPT_TAX_PAY_CREDIT_AMOUNT,
		'receiptCouponDebitAmount' => TRANS_RECEIPT_COUPON_DEBIT_AMOUNT,
		'receiptCouponCreditAmount' => TRANS_RECEIPT_COUPON_CREDIT_AMOUNT,
		'currencyID' => TRANS_CURRENCY_ID,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_ACCOUNTINGRECEIPTSJOURNALS",
		"childName" => "TRANS_ACCOUNTINGRECEIPTSJOURNALS",
		"sideNavMajor" => "accountingReceiptsJournals",
		"sideNavMinor" => "accountingReceiptsJournals",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_ACCOUNTINGRECEIPTSJOURNAL",
			"show" => "TRANS_SHOW_ACCOUNTINGRECEIPTSJOURNALS",
			"add" => "TRANS_ADD_ACCOUNTINGRECEIPTSJOURNAL",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'clientID' => 'clients',
			'invoiceID' => 'invoices',
			'transactionID' => 'transactionLogs',
		),
		"revContext" => array(
		),
	),
);