<?php
// $Id: clientBillingAccounts.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["clientBillingAccounts"] = baseMap("client_billing_accounts", null, "clientBillingAccounts", "clientBillingAccount") + array(
	"columns" => array(
		'billingAccountID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'priorBillingAccountID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountDateFailed' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountHistorical' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientContactID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardNameOnCard' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardNum' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardExpMonth' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardExpYear' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardIssueNum' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingCardStartDate' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'protxSecurityKey' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'protxTransactionCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'protxTransactionID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'protxAuthorizationCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'velocitypayCrossReference' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'velocitypayAuthAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankType' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankName' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankAbaCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankAccountNum' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankLicenseNum' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankLicenseState' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankDob' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingBankState' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountNumLastFour' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountActive' => COLUMN_ACTIVE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountStatus' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'secGatewayConfigGroupID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'billingAccountID' => TRANS_BILLING_ACCOUNT_ID,
		'priorBillingAccountID' => TRANS_PRIOR_BILLING_ACCOUNT_ID,
		'billingAccountDateFailed' => TRANS_BILLING_ACCOUNT_DATE_FAILED,
		'billingAccountHistorical' => TRANS_BILLING_ACCOUNT_HISTORICAL,
		'clientContactID' => TRANS_CLIENT_CONTACT_ID,
		'billingCardNameOnCard' => TRANS_BILLING_CARD_NAME_ON_CARD,
		'billingCardType' => TRANS_BILLING_CARD_TYPE,
		'billingCardNum' => TRANS_BILLING_CARD_NUM,
		'billingCardExpMonth' => TRANS_BILLING_CARD_EXP_MONTH,
		'billingCardExpYear' => TRANS_BILLING_CARD_EXP_YEAR,
		'billingCardIssueNum' => TRANS_BILLING_CARD_ISSUE_NUM,
		'billingCardStartDate' => TRANS_BILLING_CARD_START_DATE,
		'protxSecurityKey' => TRANS_PROTX_SECURITY_KEY,
		'protxTransactionCode' => TRANS_PROTX_TRANSACTION_CODE,
		'protxTransactionID' => TRANS_PROTX_TRANSACTION_ID,
		'protxAuthorizationCode' => TRANS_PROTX_AUTHORIZATION_CODE,
		'velocitypayCrossReference' => TRANS_VELOCITYPAY_CROSS_REFERENCE,
		'velocitypayAuthAmount' => TRANS_VELOCITYPAY_AUTH_AMOUNT,
		'billingBankType' => TRANS_BILLING_BANK_TYPE,
		'billingBankName' => TRANS_BILLING_BANK_NAME,
		'billingBankAbaCode' => TRANS_BILLING_BANK_ABA_CODE,
		'billingBankAccountNum' => TRANS_BILLING_BANK_ACCOUNT_NUM,
		'billingBankLicenseNum' => TRANS_BILLING_BANK_LICENSE_NUM,
		'billingBankLicenseState' => TRANS_BILLING_BANK_LICENSE_STATE,
		'billingBankDob' => TRANS_BILLING_BANK_DOB,
		'billingBankState' => TRANS_BILLING_BANK_STATE,
		'billingAccountNumLastFour' => TRANS_BILLING_ACCOUNT_NUM_LAST_FOUR,
		'billingAccountActive' => TRANS_BILLING_ACCOUNT_ACTIVE,
		'billingAccountType' => TRANS_BILLING_ACCOUNT_TYPE,
		'billingAccountStatus' => TRANS_BILLING_ACCOUNT_STATUS,
		'secGatewayConfigGroupID' => TRANS_SEC_GATEWAY_CONFIG_GROUP_ID,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_CLIENTBILLINGACCOUNTS",
		"childName" => "TRANS_CLIENTBILLINGACCOUNTS",
		"sideNavMajor" => "clientBillingAccounts",
		"sideNavMinor" => "clientBillingAccounts",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_CLIENTBILLINGACCOUNT",
			"show" => "TRANS_SHOW_CLIENTBILLINGACCOUNTS",
			"add" => "TRANS_ADD_CLIENTBILLINGACCOUNT",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'clientContactID' => 'clientContacts',
		),
		"revContext" => array(
			'callbackLogs' => 'billingAccountID',
			'clientBillingAccountShares' => 'billingAccountID',
			'gwTransactions' => 'billingAccountID',
			'shoppingSessions' => 'billingAccountID',
			'subscriptions' => 'billingAccountID',
			'transactionLogs' => 'billingAccountID',
		),
	),
);