<?php
// $Id: clients.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["clients"] = baseMap("clients", null, "clients", "client") + array(
	"columns" => array(
		'clientID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'companyID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientCompany' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientStatus' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientStatusReason' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'applyTax' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxIDNumber' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'themeID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'countriesID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientActive' => COLUMN_ACTIVE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientMailInvoices' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'groupID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientBillingDay' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'defaultBillingAccountID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientDateCancelled' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientSignupIP' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientLastIP' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'clientID' => TRANS_CLIENT_ID,
		'companyID' => TRANS_COMPANY_ID,
		'clientCompany' => TRANS_CLIENT_COMPANY,
		'clientStatus' => TRANS_CLIENT_STATUS,
		'clientStatusReason' => TRANS_CLIENT_STATUS_REASON,
		'applyTax' => TRANS_APPLY_TAX,
		'taxIDNumber' => TRANS_TAX_ID_NUMBER,
		'themeID' => TRANS_THEME_ID,
		'countriesID' => TRANS_COUNTRIES_ID,
		'clientActive' => TRANS_CLIENT_ACTIVE,
		'clientMailInvoices' => TRANS_CLIENT_MAIL_INVOICES,
		'groupID' => TRANS_GROUP_ID,
		'clientBillingDay' => TRANS_CLIENT_BILLING_DAY,
		'defaultBillingAccountID' => TRANS_DEFAULT_BILLING_ACCOUNT_ID,
		'clientDateCreated' => TRANS_CLIENT_DATE_CREATED,
		'clientDateCancelled' => TRANS_CLIENT_DATE_CANCELLED,
		'clientSignupIP' => TRANS_CLIENT_SIGNUP_IP,
		'clientLastIP' => TRANS_CLIENT_LAST_IP,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_CLIENTS",
		"childName" => "TRANS_CLIENTS",
		"sideNavMajor" => "clients",
		"sideNavMinor" => "clients",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_CLIENT",
			"show" => "TRANS_SHOW_CLIENTS",
			"add" => "TRANS_ADD_CLIENT",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'companyID' => 'companies',
			'themeID' => 'themes',
			'countriesID' => 'countries',
			'groupID' => 'attributeGroups',
		),
		"revContext" => array(
			'accountingGeneralLedgers' => 'clientID',
			'accountingPurchasesJournals' => 'clientID',
			'accountingReceiptsJournals' => 'clientID',
			'affiliates' => 'clientID',
			'bookmarks' => 'clientID',
			'callbackLogs' => 'clientID',
			'clientAttributes' => 'clientID',
			'clientChangeLogs' => 'clientID',
			'clientChildrenRels' => 'clientID',
			'clientContacts' => 'clientID',
			'clientGroupRels' => 'clientID',
			'clientNotes' => 'clientID',
			'fraudResultsLogs' => 'clientID',
			'invoices' => 'clientID',
			'marketplaceSellers' => 'clientID',
			'packages' => 'clientID',
			'savedOrders' => 'clientID',
			'shoppingSessions' => 'clientID',
			'subscriptions' => 'clientID',
		),
	),
);