<?php
// $Id: fraudCountryThresholds.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["fraudCountryThresholds"] = baseMap("fraud_country_thresholds", null, "fraudCountryThresholds", "fraudCountryThreshold") + array(
	"columns" => array(
		'thresholdID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'thresholdName' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'countryType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'countriesID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'regionsID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'levelOneScore' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'levelTwoScore' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'levelThreeScore' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'levelOneAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'levelTwoAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'levelThreeAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'catchAllAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'overrideOneAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'overrideTwoAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'overrideThreeAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'overrideOneAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'overrideTwoAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'overrideThreeAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'primaryScoreToUse' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'freeEmailWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'countryMatchWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'anonProxyWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'countryRiskWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'ipDistanceWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'binMatchWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'binBankMatchWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'highRiskEmailWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'highRiskShippingWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'openProxyWeight' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'fraudSoftRejectMessage' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'fraudHardRejectMessage' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'thresholdID' => TRANS_THRESHOLD_ID,
		'thresholdName' => TRANS_THRESHOLD_NAME,
		'countryType' => TRANS_COUNTRY_TYPE,
		'countriesID' => TRANS_COUNTRIES_ID,
		'regionsID' => TRANS_REGIONS_ID,
		'levelOneScore' => TRANS_LEVEL_ONE_SCORE,
		'levelTwoScore' => TRANS_LEVEL_TWO_SCORE,
		'levelThreeScore' => TRANS_LEVEL_THREE_SCORE,
		'levelOneAction' => TRANS_LEVEL_ONE_ACTION,
		'levelTwoAction' => TRANS_LEVEL_TWO_ACTION,
		'levelThreeAction' => TRANS_LEVEL_THREE_ACTION,
		'catchAllAction' => TRANS_CATCH_ALL_ACTION,
		'overrideOneAmount' => TRANS_OVERRIDE_ONE_AMOUNT,
		'overrideTwoAmount' => TRANS_OVERRIDE_TWO_AMOUNT,
		'overrideThreeAmount' => TRANS_OVERRIDE_THREE_AMOUNT,
		'overrideOneAction' => TRANS_OVERRIDE_ONE_ACTION,
		'overrideTwoAction' => TRANS_OVERRIDE_TWO_ACTION,
		'overrideThreeAction' => TRANS_OVERRIDE_THREE_ACTION,
		'primaryScoreToUse' => TRANS_PRIMARY_SCORE_TO_USE,
		'freeEmailWeight' => TRANS_FREE_EMAIL_WEIGHT,
		'countryMatchWeight' => TRANS_COUNTRY_MATCH_WEIGHT,
		'anonProxyWeight' => TRANS_ANON_PROXY_WEIGHT,
		'countryRiskWeight' => TRANS_COUNTRY_RISK_WEIGHT,
		'ipDistanceWeight' => TRANS_IP_DISTANCE_WEIGHT,
		'binMatchWeight' => TRANS_BIN_MATCH_WEIGHT,
		'binBankMatchWeight' => TRANS_BIN_BANK_MATCH_WEIGHT,
		'highRiskEmailWeight' => TRANS_HIGH_RISK_EMAIL_WEIGHT,
		'highRiskShippingWeight' => TRANS_HIGH_RISK_SHIPPING_WEIGHT,
		'openProxyWeight' => TRANS_OPEN_PROXY_WEIGHT,
		'fraudSoftRejectMessage' => TRANS_FRAUD_SOFT_REJECT_MESSAGE,
		'fraudHardRejectMessage' => TRANS_FRAUD_HARD_REJECT_MESSAGE,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_FRAUDCOUNTRYTHRESHOLDS",
		"childName" => "TRANS_FRAUDCOUNTRYTHRESHOLDS",
		"sideNavMajor" => "fraudCountryThresholds",
		"sideNavMinor" => "fraudCountryThresholds",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_FRAUDCOUNTRYTHRESHOLD",
			"show" => "TRANS_SHOW_FRAUDCOUNTRYTHRESHOLDS",
			"add" => "TRANS_ADD_FRAUDCOUNTRYTHRESHOLD",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'countriesID' => 'countries',
		),
		"revContext" => array(
			'fraudResultsLogs' => 'thresholdID',
			'fraudSetThresholdRels' => 'thresholdID',
		),
	),
);