<?php
// $Id: invoiceLineItems.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["invoiceLineItems"] = baseMap("invoice_line_items", null, "invoiceLineItems", "invoiceLineItem") + array(
	"columns" => array(
		'lineItemID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'invoiceID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'packageID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'packageAddonID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'cycleID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemQuantity' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemDescription' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemDateBeginRenewal' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemDateCurrentRenewal' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemDateNextRenewal' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemPriceAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemDiscountAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemDiscount' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemSetupAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemTaxAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemTaxableTaxAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemTotalAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'prorationDiscountAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'prorationDiscount' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'prorationDuration' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemIsUsage' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'lineItemID' => TRANS_LINE_ITEM_ID,
		'invoiceID' => TRANS_INVOICE_ID,
		'packageID' => TRANS_PACKAGE_ID,
		'packageAddonID' => TRANS_PACKAGE_ADDON_ID,
		'cycleID' => TRANS_CYCLE_ID,
		'lineItemQuantity' => TRANS_LINE_ITEM_QUANTITY,
		'lineItemDescription' => TRANS_LINE_ITEM_DESCRIPTION,
		'lineItemDateBeginRenewal' => TRANS_LINE_ITEM_DATE_BEGIN_RENEWAL,
		'lineItemDateCurrentRenewal' => TRANS_LINE_ITEM_DATE_CURRENT_RENEWAL,
		'lineItemDateNextRenewal' => TRANS_LINE_ITEM_DATE_NEXT_RENEWAL,
		'lineItemPriceAmount' => TRANS_LINE_ITEM_PRICE_AMOUNT,
		'lineItemDiscountAmount' => TRANS_LINE_ITEM_DISCOUNT_AMOUNT,
		'lineItemDiscount' => TRANS_LINE_ITEM_DISCOUNT,
		'lineItemSetupAmount' => TRANS_LINE_ITEM_SETUP_AMOUNT,
		'lineItemTaxAmount' => TRANS_LINE_ITEM_TAX_AMOUNT,
		'lineItemTaxableTaxAmount' => TRANS_LINE_ITEM_TAXABLE_TAX_AMOUNT,
		'lineItemTotalAmount' => TRANS_LINE_ITEM_TOTAL_AMOUNT,
		'prorationDiscountAmount' => TRANS_PRORATION_DISCOUNT_AMOUNT,
		'prorationDiscount' => TRANS_PRORATION_DISCOUNT,
		'prorationDuration' => TRANS_PRORATION_DURATION,
		'lineItemIsUsage' => TRANS_LINE_ITEM_IS_USAGE,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_INVOICELINEITEMS",
		"childName" => "TRANS_INVOICELINEITEMS",
		"sideNavMajor" => "invoiceLineItems",
		"sideNavMinor" => "invoiceLineItems",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_INVOICELINEITEM",
			"show" => "TRANS_SHOW_INVOICELINEITEMS",
			"add" => "TRANS_ADD_INVOICELINEITEM",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'invoiceID' => 'invoices',
			'packageID' => 'packages',
			'packageAddonID' => 'packageAddons',
			'cycleID' => 'cycles',
		),
		"revContext" => array(
			'accountingPurchasesJournals' => 'lineItemID',
			'lineItemsTaxZoneRels' => 'lineItemID',
			'packageUsageLogs' => 'lineItemID',
			'paymentQueues' => 'lineItemID',
			'transactionSuccessRels' => 'lineItemID',
		),
	),
);