<?php
// $Id: invoices.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["invoices"] = baseMap("invoices", null, "invoices", "invoice") + array(
	"columns" => array(
		'invoiceID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'invoiceProcessID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceProcessDate' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceNumber' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'creditNoteForInvoiceID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientContactID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'currencyID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceAmountPaid' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDateEntered' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDateDue' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDatePaid' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDatePushed' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoicePaymentMethod' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceSnapshot' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceComments' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceBatchTimestamp' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceSubTotal' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDiscount' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceStatus' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentGroupID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'invoiceID' => TRANS_INVOICE_ID,
		'invoiceProcessID' => TRANS_INVOICE_PROCESS_ID,
		'invoiceProcessDate' => TRANS_INVOICE_PROCESS_DATE,
		'invoiceNumber' => TRANS_INVOICE_NUMBER,
		'creditNoteForInvoiceID' => TRANS_CREDIT_NOTE_FOR_INVOICE_ID,
		'clientID' => TRANS_CLIENT_ID,
		'clientContactID' => TRANS_CLIENT_CONTACT_ID,
		'currencyID' => TRANS_CURRENCY_ID,
		'invoiceAmount' => TRANS_INVOICE_AMOUNT,
		'invoiceAmountPaid' => TRANS_INVOICE_AMOUNT_PAID,
		'invoiceDateEntered' => TRANS_INVOICE_DATE_ENTERED,
		'invoiceDateDue' => TRANS_INVOICE_DATE_DUE,
		'invoiceDatePaid' => TRANS_INVOICE_DATE_PAID,
		'invoiceDatePushed' => TRANS_INVOICE_DATE_PUSHED,
		'invoicePaymentMethod' => TRANS_INVOICE_PAYMENT_METHOD,
		'invoiceSnapshot' => TRANS_INVOICE_SNAPSHOT,
		'invoiceComments' => TRANS_INVOICE_COMMENTS,
		'invoiceBatchTimestamp' => TRANS_INVOICE_BATCH_TIMESTAMP,
		'invoiceSubTotal' => TRANS_INVOICE_SUB_TOTAL,
		'invoiceDiscount' => TRANS_INVOICE_DISCOUNT,
		'invoiceStatus' => TRANS_INVOICE_STATUS,
		'paymentGroupID' => TRANS_PAYMENT_GROUP_ID,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_INVOICES",
		"childName" => "TRANS_INVOICES",
		"sideNavMajor" => "invoices",
		"sideNavMinor" => "invoices",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_INVOICE",
			"show" => "TRANS_SHOW_INVOICES",
			"add" => "TRANS_ADD_INVOICE",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'clientID' => 'clients',
			'clientContactID' => 'clientContacts',
			'paymentGroupID' => 'paymentGroups',
		),
		"revContext" => array(
			'accountingGeneralLedgers' => 'invoiceID',
			'accountingPurchasesJournals' => 'invoiceID',
			'accountingReceiptsJournals' => 'invoiceID',
			'invoiceLineItems' => 'invoiceID',
			'invoiceTaxZoneRels' => 'invoiceID',
			'invoiceTransactionRels' => 'invoiceID',
			'shoppingSessions' => 'invoiceID',
			'suspendLogs' => 'invoiceID',
		),
	),
);