<?php
// $Id: paymentQueues.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["paymentQueues"] = baseMap("payment_queue", null, "paymentQueues", "paymentQueue") + array(
	"columns" => array(
		'paymentID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'paymentProcessID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentProcessDate' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'lineItemID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'groupbyInvoiceID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentDescription' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountShareID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentDateCharged' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'paymentID' => TRANS_PAYMENT_ID,
		'paymentProcessID' => TRANS_PAYMENT_PROCESS_ID,
		'paymentProcessDate' => TRANS_PAYMENT_PROCESS_DATE,
		'lineItemID' => TRANS_LINE_ITEM_ID,
		'groupbyInvoiceID' => TRANS_GROUPBY_INVOICE_ID,
		'paymentDescription' => TRANS_PAYMENT_DESCRIPTION,
		'paymentAmount' => TRANS_PAYMENT_AMOUNT,
		'billingAccountShareID' => TRANS_BILLING_ACCOUNT_SHARE_ID,
		'paymentDateCreated' => TRANS_PAYMENT_DATE_CREATED,
		'paymentDateCharged' => TRANS_PAYMENT_DATE_CHARGED,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_PAYMENTQUEUES",
		"childName" => "TRANS_PAYMENTQUEUES",
		"sideNavMajor" => "paymentQueues",
		"sideNavMinor" => "paymentQueues",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_PAYMENTQUEUE",
			"show" => "TRANS_SHOW_PAYMENTQUEUES",
			"add" => "TRANS_ADD_PAYMENTQUEUE",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'lineItemID' => 'invoiceLineItems',
			'billingAccountShareID' => 'clientBillingAccountShares',
		),
		"revContext" => array(
		),
	),
);