<?php
// $Id: products.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["products"] = baseMap("products", null, "products", "product") + array(
	"columns" => array(
		'productID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'productType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productVariableID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productIsLockable' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productIsAddon' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productInvoiceSeparately' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productAddonGroupID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productAddonAttributeName' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productName' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productComments' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productStopNumCycles' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productActive' => COLUMN_ACTIVE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productProratable' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productDiscountable' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productDomainRequired' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productAddonRequired' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productIntroCycleID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productIntroNumCycles' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'emailTplGroupID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'notifyAdminGroupID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'productCancellationType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'productID' => TRANS_PRODUCT_ID,
		'productType' => TRANS_PRODUCT_TYPE,
		'productVariableID' => TRANS_PRODUCT_VARIABLE_ID,
		'productIsLockable' => TRANS_PRODUCT_IS_LOCKABLE,
		'productIsAddon' => TRANS_PRODUCT_IS_ADDON,
		'productInvoiceSeparately' => TRANS_PRODUCT_INVOICE_SEPARATELY,
		'productAddonGroupID' => TRANS_PRODUCT_ADDON_GROUP_ID,
		'productAddonAttributeName' => TRANS_PRODUCT_ADDON_ATTRIBUTE_NAME,
		'productName' => TRANS_PRODUCT_NAME,
		'productComments' => TRANS_PRODUCT_COMMENTS,
		'productStopNumCycles' => TRANS_PRODUCT_STOP_NUM_CYCLES,
		'productActive' => TRANS_PRODUCT_ACTIVE,
		'productProratable' => TRANS_PRODUCT_PRORATABLE,
		'productDiscountable' => TRANS_PRODUCT_DISCOUNTABLE,
		'productDateCreated' => TRANS_PRODUCT_DATE_CREATED,
		'productDomainRequired' => TRANS_PRODUCT_DOMAIN_REQUIRED,
		'productAddonRequired' => TRANS_PRODUCT_ADDON_REQUIRED,
		'productIntroCycleID' => TRANS_PRODUCT_INTRO_CYCLE_ID,
		'productIntroNumCycles' => TRANS_PRODUCT_INTRO_NUM_CYCLES,
		'emailTplGroupID' => TRANS_EMAIL_TPL_GROUP_ID,
		'notifyAdminGroupID' => TRANS_NOTIFY_ADMIN_GROUP_ID,
		'productCancellationType' => TRANS_PRODUCT_CANCELLATION_TYPE,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_PRODUCTS",
		"childName" => "TRANS_PRODUCTS",
		"sideNavMajor" => "products",
		"sideNavMinor" => "products",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_PRODUCT",
			"show" => "TRANS_SHOW_PRODUCTS",
			"add" => "TRANS_ADD_PRODUCT",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'productVariableID' => 'productVariables',
			'productAddonGroupID' => 'productAddonGroups',
			'emailTplGroupID' => 'emailTplGroups',
		),
		"revContext" => array(
			'attributes' => 'productID',
			'companyProductRels' => 'productID',
			'orderFormItems' => 'productID',
			'packages' => 'productID',
			'productAddonGroupRels' => 'productID',
			'productAttributes' => 'productID',
			'productChildrenRels' => 'productID',
			'productCouponPreRels' => 'productID',
			'productCouponRels' => 'productID',
			'productCycleGhostRels' => 'productID',
			'productFileRels' => 'productID',
			'productGroupRels' => 'productID',
			'productOrderFormGhostRels' => 'productID',
			'productServerGroupGhostRels' => 'productID',
			'productTldGhostRels' => 'productID',
			'productUsagePrices' => 'productID',
			'productVariants' => 'productID',
			'productVendorRels' => 'productID',
			'shoppingItems' => 'productID',
			'websiteWidgetsProductsRels' => 'productID',
		),
	),
);