<?php
// $Id: reportTotals.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["reportTotals"] = baseMap("report_totals", null, "reportTotals", "reportTotal") + array(
	"columns" => array(
		'reportDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientTotalCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientActiveCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientInactiveCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientPendingCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientCanceledCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientFraudCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'packageNewCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'packageNewSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'packageRenewCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'packageRenewSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceTotalCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceTotalSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDueCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDueSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoicePaidCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoicePaidSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceBatchCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceBatchSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDeclinedCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceDeclinedSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceErrorCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceErrorSum' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'registrarDebits' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'registrarCredits' => COLUMN_FLOAT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'domainCount' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'domainExpThis' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'domainExpNext' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'updateBy' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'updateTimestamp' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'reportSaved' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'reportDateCreated' => TRANS_REPORT_DATE_CREATED,
		'clientTotalCount' => TRANS_CLIENT_TOTAL_COUNT,
		'clientActiveCount' => TRANS_CLIENT_ACTIVE_COUNT,
		'clientInactiveCount' => TRANS_CLIENT_INACTIVE_COUNT,
		'clientPendingCount' => TRANS_CLIENT_PENDING_COUNT,
		'clientCanceledCount' => TRANS_CLIENT_CANCELED_COUNT,
		'clientFraudCount' => TRANS_CLIENT_FRAUD_COUNT,
		'packageNewCount' => TRANS_PACKAGE_NEW_COUNT,
		'packageNewSum' => TRANS_PACKAGE_NEW_SUM,
		'packageRenewCount' => TRANS_PACKAGE_RENEW_COUNT,
		'packageRenewSum' => TRANS_PACKAGE_RENEW_SUM,
		'invoiceTotalCount' => TRANS_INVOICE_TOTAL_COUNT,
		'invoiceTotalSum' => TRANS_INVOICE_TOTAL_SUM,
		'invoiceDueCount' => TRANS_INVOICE_DUE_COUNT,
		'invoiceDueSum' => TRANS_INVOICE_DUE_SUM,
		'invoicePaidCount' => TRANS_INVOICE_PAID_COUNT,
		'invoicePaidSum' => TRANS_INVOICE_PAID_SUM,
		'invoiceBatchCount' => TRANS_INVOICE_BATCH_COUNT,
		'invoiceBatchSum' => TRANS_INVOICE_BATCH_SUM,
		'invoiceDeclinedCount' => TRANS_INVOICE_DECLINED_COUNT,
		'invoiceDeclinedSum' => TRANS_INVOICE_DECLINED_SUM,
		'invoiceErrorCount' => TRANS_INVOICE_ERROR_COUNT,
		'invoiceErrorSum' => TRANS_INVOICE_ERROR_SUM,
		'registrarDebits' => TRANS_REGISTRAR_DEBITS,
		'registrarCredits' => TRANS_REGISTRAR_CREDITS,
		'domainCount' => TRANS_DOMAIN_COUNT,
		'domainExpThis' => TRANS_DOMAIN_EXP_THIS,
		'domainExpNext' => TRANS_DOMAIN_EXP_NEXT,
		'updateBy' => TRANS_UPDATE_BY,
		'updateTimestamp' => TRANS_UPDATE_TIMESTAMP,
		'reportSaved' => TRANS_REPORT_SAVED,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_REPORTTOTALS",
		"childName" => "TRANS_REPORTTOTALS",
		"sideNavMajor" => "reportTotals",
		"sideNavMinor" => "reportTotals",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_REPORTTOTAL",
			"show" => "TRANS_SHOW_REPORTTOTALS",
			"add" => "TRANS_ADD_REPORTTOTAL",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
		),
		"revContext" => array(
		),
	),
);