<?php
// $Id: taxZones.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["taxZones"] = baseMap("tax_zones", null, "taxZones", "taxZone") + array(
	"columns" => array(
		'taxZoneID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'countriesISO2' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxZoneName' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxZoneAmountType' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxZoneAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxZoneDescription' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'ledgerAccountID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxZoneActive' => COLUMN_ACTIVE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'taxZoneStackable' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'taxZoneID' => TRANS_TAX_ZONE_ID,
		'countriesISO2' => TRANS_COUNTRIES_ISO_2,
		'taxZoneName' => TRANS_TAX_ZONE_NAME,
		'taxZoneAmountType' => TRANS_TAX_ZONE_AMOUNT_TYPE,
		'taxZoneAmount' => TRANS_TAX_ZONE_AMOUNT,
		'taxZoneDescription' => TRANS_TAX_ZONE_DESCRIPTION,
		'ledgerAccountID' => TRANS_LEDGER_ACCOUNT_ID,
		'taxZoneActive' => TRANS_TAX_ZONE_ACTIVE,
		'taxZoneStackable' => TRANS_TAX_ZONE_STACKABLE,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_TAXZONES",
		"childName" => "TRANS_TAXZONES",
		"sideNavMajor" => "taxZones",
		"sideNavMinor" => "taxZones",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_TAXZONE",
			"show" => "TRANS_SHOW_TAXZONES",
			"add" => "TRANS_ADD_TAXZONE",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'ledgerAccountID' => 'accountingLedgerAccounts',
		),
		"revContext" => array(
			'invoiceTaxZoneRels' => 'taxZoneID',
			'lineItemsTaxZoneRels' => 'taxZoneID',
			'taxZoneGroupZoneRels' => 'taxZoneID',
		),
	),
);