<?php
// $Id: tlds.php 12257 2007-11-19 18:08:56Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["tlds"] = baseMap("tlds", null, "tlds", "tld") + array(
	"columns" => array(
		'tldID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'registrarID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldExtension' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldName' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldWhoisServer' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldWhoisResp' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldActive' => COLUMN_ACTIVE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldAutoSearch' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldTransferMinimumCycleID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldMinimumCycleID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldMaximumCycleID' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldRenewType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldIsTransferable' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldTransferType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldIDNSupport' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldIDNType' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldRemoteLockEnabled' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'tldDisplayOrder' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'tldID' => TRANS_TLD_ID,
		'registrarID' => TRANS_REGISTRAR_ID,
		'tldExtension' => TRANS_TLD_EXTENSION,
		'tldName' => TRANS_TLD_NAME,
		'tldWhoisServer' => TRANS_TLD_WHOIS_SERVER,
		'tldWhoisResp' => TRANS_TLD_WHOIS_RESP,
		'tldActive' => TRANS_TLD_ACTIVE,
		'tldAutoSearch' => TRANS_TLD_AUTO_SEARCH,
		'tldTransferMinimumCycleID' => TRANS_TLD_TRANSFER_MINIMUM_CYCLE_ID,
		'tldMinimumCycleID' => TRANS_TLD_MINIMUM_CYCLE_ID,
		'tldMaximumCycleID' => TRANS_TLD_MAXIMUM_CYCLE_ID,
		'tldRenewType' => TRANS_TLD_RENEW_TYPE,
		'tldIsTransferable' => TRANS_TLD_IS_TRANSFERABLE,
		'tldTransferType' => TRANS_TLD_TRANSFER_TYPE,
		'tldIDNSupport' => TRANS_TLD_IDN_SUPPORT,
		'tldIDNType' => TRANS_TLD_IDN_TYPE,
		'tldRemoteLockEnabled' => TRANS_TLD_REMOTE_LOCK_ENABLED,
		'tldDisplayOrder' => TRANS_TLD_DISPLAY_ORDER,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_TLDS",
		"childName" => "TRANS_TLDS",
		"sideNavMajor" => "tlds",
		"sideNavMinor" => "tlds",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_TLD",
			"show" => "TRANS_SHOW_TLDS",
			"add" => "TRANS_ADD_TLD",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
		),
		"revContext" => array(
			'productTldGhostRels' => 'tldID',
			'productVariants' => 'tldID',
		),
	),
);