<?php
// $Id: transactionLogs.php 11928 2007-09-18 21:52:22Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["transactionLogs"] = baseMap("transaction_log", null, "transactionLogs", "transactionLog") + array(
	"columns" => array(
		'transactionID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'authReturn' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionPaymentMethod' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionNotes' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'authCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'avsCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionAmountRefunded' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'currencyID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'configGroupID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'transactionID' => TRANS_TRANSACTION_ID,
		'authReturn' => TRANS_AUTH_RETURN,
		'transactionPaymentMethod' => TRANS_TRANSACTION_PAYMENT_METHOD,
		'transactionCode' => TRANS_TRANSACTION_CODE,
		'transactionNotes' => TRANS_TRANSACTION_NOTES,
		'transactionDateCreated' => TRANS_TRANSACTION_DATE_CREATED,
		'authCode' => TRANS_AUTH_CODE,
		'avsCode' => TRANS_AVS_CODE,
		'transactionAmount' => TRANS_TRANSACTION_AMOUNT,
		'transactionAmountRefunded' => TRANS_TRANSACTION_AMOUNT_REFUNDED,
		'currencyID' => TRANS_CURRENCY_ID,
		'configGroupID' => TRANS_CONFIG_GROUP_ID,
		'billingAccountID' => TRANS_BILLING_ACCOUNT_ID,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_TRANSACTIONLOGS",
		"childName" => "TRANS_TRANSACTIONLOGS",
		"sideNavMajor" => "transactionLogs",
		"sideNavMinor" => "transactionLogs",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_TRANSACTIONLOG",
			"show" => "TRANS_SHOW_TRANSACTIONLOGS",
			"add" => "TRANS_ADD_TRANSACTIONLOG",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'configGroupID' => 'configGroups',
			'billingAccountID' => 'clientBillingAccounts',
		),
		"revContext" => array(
			'accountingReceiptsJournals' => 'transactionID',
			'callbackLogs' => 'transactionID',
			'invoiceTransactionRels' => 'transactionID',
			'transactionSuccessRels' => 'transactionID',
		),
	),
);