<?php
// $Id: invoices.php 12127 2007-10-22 20:26:50Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['invoices'] = array(
	"names" => array(
		"singular" => "invoice",
		"plural" => "invoices",
		"file" => "invoices",
	),
	"request" => array(
		'command' => "GetInvoices",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("invoices", "invoice"),
	),
	"insert" => array(
		"command" => "SetInvoices",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetInvoices",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetInvoices",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("cycleID")),
	),
	"table" => "invoices",
	"columns" => array(
		"invoiceID" => COLUMN_PRIMARY_KEY,
		"clientID" => COLUMN_ID,
		"invoiceNumber" => COLUMN_PRIMARY_NAME,
		"currencyID" => COLUMN_TEXT,
		"invoiceAmount" => COLUMN_AMOUNT,
		"invoiceAmountPaid" => COLUMN_AMOUNT,
		"invoiceDateEntered" => COLUMN_DATE,
		"invoiceDateDue" => COLUMN_DATE,
		"invoiceDatePaid" => COLUMN_DATE,
		"invoiceDatePushed" => COLUMN_DATE,
		"invoicePaymentMethod" => COLUMN_TEXT,
		"invoiceSnapshot" => COLUMN_TEXT,
		"invoiceComments" => COLUMN_TEXT,
		"invoiceBatchTimestamp" => COLUMN_DATE,
		"invoiceSubTotal" => COLUMN_AMOUNT,
		"invoiceDiscount" => COLUMN_AMOUNT,
		"invoiceStatus" => COLUMN_STATUS,
		"paymentGroupID" => COLUMN_ID,
		"invoiceProcessID" => COLUMN_TEXT,
		"invoiceProcessDate" => COLUMN_DATE,
	),
	"statuses" => array(
		"invoiceStatus" => "invoice",
	),
	"display" => array(
		"context" => array(
			"clientID" => "clients",
			/*"paymentGroupID" => "paymentGroups",*/
		),
		"revContext" => array(
			"lineItems" => "invoiceID",
			"accountingReceiptsJournal" => "invoiceID",
			"accountingPurchasesJournal" => "invoiceID",
			"accountingGeneralLedger" => "invoiceID",
		),
	),
);

