<?php
// $Id: lineItems.php 11070 2007-04-30 20:51:12Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['lineItems'] = array(
	"names" => array(
		"singular" => "lineItem",
		"plural" => "lineItems",
		"file" => "invoices",
	),
	"request" => array(
		'command' => "GetLineItems",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("lineItems", "lineItem"),
	),
	"insert" => array(
		"command" => "SetLineItems",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetLineItems",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetLineItems",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("cycleID")),
	),
	"table" => "invoice_line_items",
	"columns" => array(
		"lineItemID" => COLUMN_PRIMARY_KEY,
		"invoiceID" => COLUMN_ID,
		"packageID" => COLUMN_ID,
		"packageAddonID" => COLUMN_ID,
		"cycleID" => COLUMN_ID,
		"lineItemQuantity" => COLUMN_INT,
		"lineItemDescription" => COLUMN_STRING,
		"lineItemDateBeginRenewal" => COLUMN_DATE,
		"lineItemDateCurrentRenewal" => COLUMN_DATE,
		"lineItemDateNextRenewal" => COLUMN_DATE,
		"lineItemPriceAmount" => COLUMN_AMOUNT,
		"lineItemDiscountAmount" => COLUMN_AMOUNT,
		"lineItemSetupAmount" => COLUMN_AMOUNT,
		"lineItemTaxableTaxAmount" => COLUMN_AMOUNT,
		"lineItemTaxAmount" => COLUMN_AMOUNT,
		"lineItemTotalAmount" => COLUMN_AMOUNT,
		"lineItemIsUsage" => COLUMN_BOOL,
		"prorationDiscountAmount" => COLUMN_AMOUNT,
		"prorationDuration" => COLUMN_DATE,
	),
	"display" => array(
		"filterContextValues" => array(
			"packageID",
			"clientID",
			"packageAddonID",
		),
		"context" => array(
			"invoiceID" => "invoices",
			"packageID" => "packages",
			"packageAddonID" => "packageAddons",
			"cycleID" => "cycles",
		),
		"revContext" => array(
			"accountingPurchasesJournal" => "lineItemID",
		),
	),
);

?>
