<?php
// $Id: migrationConfigs.php 12328 2007-12-07 22:08:15Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['migrationConfigs'] = array(
	"names" => array(
		"singular" => "migrationConfig",
		"plural" => "migrationConfigs",
		"file" => "migrate",
	),
	"request" => array(
		'command' => "GetMigrationConfigs",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("migrationConfigs", "migrationConfig"),
	),
	"insert" => array(
		"command" => "SetMigrationConfigs",
		"subCommand" => "insert",
		"params" => array(),//$allParamsRoot,
	),
	"update" => array(
		"command" => "SetMigrationConfigs",
		"subCommand" => "update",
		"params" => array(),//$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetMigrationConfigs",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeID")),
	),
	"table" => "migration_configs",
	"columns" => array(
		"migrationConfigID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE,
		"migrationName" => COLUMN_PRIMARY_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationType" => COLUMN_TYPE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationComment" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationDBDRIVERType" => COLUMN_TYPE|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationDBHOST" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationDBNAME" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationDBUSERNAME" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationDBPASSWORD" => COLUMN_TEXT|COLUMN_EDITABLE,
		"migrationPaymentGroupID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationOrderFormID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		"migrationProductID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"migrationOrphanProductID" => COLUMN_ID|COLUMN_DISPLAYABLE,
	),
	"columnLabels" => array(
		"migrationConfigID" => "TRANS_ID",
		"migrationName" => "TRANS_NAME",
		"migrationComment" => "TRANS_COMMENTS",
		"migrationType" => "TRANS_TYPE",
		"migrationDBDRIVERType" => "TRANS_DRIVER",
		"migrationDBHOST" => "TRANS_DATABASE_HOST",
		"migrationDBNAME" => "TRANS_DATABASE_NAME",
		"migrationDBUSERNAME" => "TRANS_DATABASE_USERNAME",
		"migrationDBPASSWORD" => "TRANS_DATABASE_PASSWORD",
		"migrationOrderFormID" => "TRANS_ORDER_FORM",
		"migrationPaymentGroupID" => "TRANS_PAYMENT_GROUP",
		"migrationProductID" => "TRANS_PRODUCT_FOR_PRIOR_BALANCE_PACKAGES",
		"migrationOrphanProductID" => "TRANS_PRODUCT_FOR_ORPHAN_PACKAGES",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_MIGRATION",
		"childName" => "TRANS_MIGRATION_CONFIGURATION",
		"sideNavMajor" => "system",
		"sideNavMinor" => "migrate",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_MIGRATION",
			"show" => "TRANS_SHOW_MIGRATIONS",
			"add" => "TRANS_ADD_MIGRATION",
			"showdetails" => "TRANS_MIGRATION_DETAILS",
			"remove" => "TRANS_REMOVE_MIGRATION",
		)
	),
	"foreignNames" => array(
		'migrationPaymentGroupID' => array(
			"command" => "GetPaymentGroups",
			"nameParamName" => "paymentGroupName",
			"idParamName" => "paymentGroupID",
			"defaultParams" => array(
				"suppressGatewayInfo" => 1
			),
		),
		'migrationOrderFormID' => array(
			"command" => "GetOrderForms",
			"nameParamName" => "orderFormName",
			"idParamName" => "orderFormID", // only necessary IF different from the main column name 
			"defaultParams" => array(
			),
		),
		'migrationProductID' => array(
			"command" => "GetProducts",
			"nameParamName" => "productName",
			"idParamName" => "productID", // only necessary IF different from the main column name 
			"defaultParams" => array(
				"getNonAddons" => 1,
			),
		),
		'migrationOrphanProductID' => array(
			"command" => "GetProducts",
			"nameParamName" => "productName",
			"idParamName" => "productID", // only necessary IF different from the main column name 
			"defaultParams" => array(
				"getNonAddons" => 1,
			),
		),
	),
	"types" => array(
		"migrationDBDRIVERType" => "DBDriver",
		"migrationType" => "migration",
	),
	"display" => array(
		'showTemplate' => "1",
		'showDetailsTemplate' => "migrate/ShowMigrationConfigDetails",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
		"context" => array(
			"migrationOrderFormID" => "orderForms",
			"migrationPaymentGroupID" => "paymentGroups",
			"migrationProductID" => "products",
			"migrationOrphanProductID" => "products",
		),
		"revContext" => array(
			"migrationMappings" => "migrationMappingID",
			"migrationObjs" => "migrationObjID",
		),
	),
);
