<?php
// $Id: packageAddons.php 9760 2006-10-23 17:52:27Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['packageAddons'] = array(
	"names" => array(
		"singular" => "packageAddon",
		"plural" => "packageAddons",
		"file" => "packages",
	),
	"request" => array(
		'command' => "GetPackageAddons",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("packageAddons", "packageAddon"),
	),
	"insert" => array(
		"command" => "SetPackageAddons",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetPackageAddons",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetPackageAddons",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "package_addons",
	"columns" => array(
		"packageAddonID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT|COLUMN_RESTRICT_REMOVE,
		"packageID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonDisplayName" => COLUMN_PRIMARY_NAME|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonOriginalPrice" => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonDiscount" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonPrice" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonSetup" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonPriceLock" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonActive" => COLUMN_ACTIVE|COLUMN_EDITABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonDiscountable" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_RESTRICT_EDIT,
		"packageAddonProductID" => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_RESTRICT_EDIT,
		"taxZoneGroupID" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_RESTRICT_EDIT,
		"couponPrice" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"couponNumCycles" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_RESTRICT_EDIT,
	),
	"columnLabels" => array(
		"packageAddonID" => "TRANS_PACKAGE_ADDON_ID",
		"packageID" => "TRANS_PACKAGE_ID",
		"packageAddonDisplayName" => "TRANS_NAME",
		"packageAddonOriginalPrice" => "TRANS_ORIGINAL_PRICE",
		"packageAddonPrice" => "TRANS_PRICE",
		"packageAddonSetup" => "TRANS_SETUP_PRICE",
		"packageAddonPriceLock" => "TRANS_PRICE_LOCK",
		"packageAddonActive" => "TRANS_ACTIVE",
		"packageAddonDiscountable" => "TRANS_DISCOUNTABLE",
		"packageAddonProductID" => "TRANS_OPTION_ID",
		"taxZoneGroupID" => "TRANS_TAX_ZONE_GROUP_ID",
		"couponPrice" => "TRANS_COUPON_PRICE",
		"couponNumCycles" => "TRANS_COUPON_NUM_CYCLES",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_PACKAGES",
		"childName" => "TRANS_MANAGE_PACKAGE_ADDONS",
		"sideNavMajor" => "clients",
		"sideNavMinor" => "packages",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_ADDON",
			"show" => "TRANS_SHOW_ADDONS",
			"add" => "TRANS_ADD_ADDON",
			"showdetails" => "TRANS_ADDON_DETAILS",
			"remove" => "TRANS_REMOVE_ADDON",
		)
	),
	"types" => array(
	),
	"display" => array(
		"filterContextValues" => array(
			"packageID",
		),
		"context" => array(
			/*"taxZoneGroupID" => "taxZoneGroups",*/
			"packageID" => "packages",
		),
		"revContext" => array(
			"packageAddonAttributes" => "packageAddonID",
			/*"packageAddonLedgerEntries" => "packageAddonID",*/
		),
		'showTemplate' => "packages/ShowPackageAddons",
		'showParams' => array(
			'packageAddonActive' => 1,
		),
		'suppressActions' => array('showdetails', 'remove'),
		'showDetailsTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
	),
);
