<?php
// $Id: packageAttributes.php 12885 2008-04-22 18:08:51Z btyra $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['packageAttributes'] = array(
	"names" => array(
		"singular" => "packageAttribute",
		"plural" => "packageAttributes",
		"file" => "packages",
	),
	"request" => array(
		'command' => "GetPackageAttributes",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("packageAttributes", "packageAttribute"),
	),
	"insert" => array(
		"command" => "SetPackageAttributes",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetPackageAttributes",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetPackageAttributes",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("clientAttributeID")),
	),
	"table" => "package_attributes",
	"columns" => array(
		"packageAttributeID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		"packageID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"serverGroupID" => COLUMN_ID|COLUMN_LISTABLE|COLUMN_EDITABLE,
		"configGroupID" => COLUMN_ID|COLUMN_LISTABLE|COLUMN_EDITABLE,
		"packageAttributeName" => COLUMN_PRIMARY_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE,
		"packageAttributeValue" => COLUMN_SEARCHABLE_STRING|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"packageAttributeDateCreated" => COLUMN_IS_DATE|COLUMN_LISTABLE|COLUMN_EDITABLE,
	),
	"columnLabels" => array(
		"packageAttributeID" => "TRANS_ATTRIBUTE_ID",
		"packageID" => "TRANS_PACKAGE",
		"serverGroupID" => "TRANS_SERVER_GROUP",
		"configGroupID" => "TRANS_SERVER",
		"packageAttributeName" => "TRANS_ATTRIBUTE_NAME",
		"packageAttributeValue" => "TRANS_ATTRIBUTE_VALUE",
		"packageAttributeDateCreated" => "TRANS_DATE_CREATED",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PACKAGES",
		"childName" => "TRANS_MANAGE_PACKAGES",
		"sideNavMajor" => "clients",
		"sideNavMinor" => "packages",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_ATTRIBUTE",
			"show" => "TRANS_SHOW_ATTRIBUTES",
			"add" => "TRANS_ADD_ATTRIBUTE",
			"showdetails" => "TRANS_ATTRIBUTE_DETAILS",
			"remove" => "TRANS_REMOVE_ATTRIBUTE",
		)
	),
	"types" => array(
	),
	"statuses" => array(
	),
	"refColumnGenerator" => "NameColumnGenerator",
	"display" => array(
		"filterContextValues" => array(
			"packageID",
			"serverGroupID",
		),
		"parentForeignKeys" => array(
			"packageID",
		),
		"context" => array(
			"packageID" => "packages",
			"serverGroupID" => "serverGroups",
			//"configGroupID" => "configGroups",
		),
		'showTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		"suppressActions" => array("showdetails"),
		"showAddButton" => 1,
	),
);
