<?php
// $Id: packageUsageLogs.php 11586 2007-07-16 17:48:23Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["packageUsageLogs"] = baseMap("package_usage_log", "packageUsageLogs", "packageUsageLogs", "packageUsageLog") + array(
	"columns" => array(
		"usageLogID" => COLUMN_PRIMARY_KEY|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"packageID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"configGroupID" => COLUMN_INT|COLUMN_LISTABLE,
		"packageUsage" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"usageLogDateCreated" => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"groupbyInvoiceID" => COLUMN_INT, // just meant for getting all without joining through line items
		"lineItemID" => COLUMN_ID,
		"packageUsageType" => COLUMN_TYPE,
		"externalID" => COLUMN_TEXT, // every column below here is "external"
		"packageUsageRecordType" => COLUMN_TYPE,
		"usageLogDateBilled" => COLUMN_DATE,
		"interfaceID" => COLUMN_TYPE,
		"packageUsageMessageDuration" => COLUMN_INT,
		"packageUsageDataSize" => COLUMN_INT,
		"packageUsageMessageDate" => COLUMN_DATE,
		"packageUsageDateCreated" => COLUMN_DATE,
		"packageUsageDateBilled" => COLUMN_DATE,
		"packageUsageVessel" => COLUMN_TEXT,
		"packageUsageRate" => COLUMN_TEXT,
		"packageUsageComType" => COLUMN_INT,
		"packageUsageComBrand" => COLUMN_INT,
		"packageUsageLinkStatus" => COLUMN_INT,
		"packageUsageVendor" => COLUMN_TEXT,
		"packageUsageUsername" => COLUMN_TEXT,
		"packageUsageSerialNumber" => COLUMN_TEXT,
		"packageUsageAggregateID" => COLUMN_TEXT,
		"packageUsageExternalStatus" => COLUMN_TEXT,
		"packageUsageExternalStatusError" => COLUMN_INT,
		"packageUsageExtraInfo1" => COLUMN_TEXT,
		"packageUsageExtraInfo2" => COLUMN_TEXT,
		"packageUsageExtraInfo3" => COLUMN_TEXT,
		"packageUsagePrice" => COLUMN_AMOUNT,
		"packageUsageCost" => COLUMN_AMOUNT,
		"packageUsageRate" => COLUMN_TEXT,
		"packageUsageDateSession" => COLUMN_DATE,
		"packageUsageLinkDate" => COLUMN_DATE,
	),
	"columnLabels" => array(
		"usageLogID" => TRANS_USAGE_LOG_ID,
		"packageID" => TRANS_PACKAGE_ID,
		"configGroupID" => TRANS_SERVER_ID,
		"packageUsage" => TRANS_USAGE,
		"usageLogDateCreated" => TRANS_USAGE_LOG_DATE_CREATED,
		"groupbyInvoiceID" => TRANS_INVOICE_ID, // just meant for getting all without joining through line items
		"lineItemID" => TRANS_LINE_ITEM_ID,
		"packageUsageType" => TRANS_USAGE_TYPE,
		"externalID" => TRANS_EXTERNAL_ID, // every column below here is "external"
		"usageLogDateBilled" => TRANS_USAGE_LOG_DATE_BILLED,
		"interfaceID" => TRANS_INTERFACE_ID,
		"packageUsageRecordType" => TRANS_USAGE_RECORD_TYPE,
		"packageUsageMessageDuration" => TRANS_USAGE_MESSAGE_DURATION,
		"packageUsageDataSize" => TRANS_USAGE_DATA_SIZE,
		"packageUsageMessageDate" => TRANS_USAGE_MESSAGE_DATE,
		"packageUsageDateCreated" => TRANS_USAGE_DATE_CREATED,
		"packageUsageDateBilled" => TRANS_USAGE_DATE_BILLED,
		"packageUsageVessel" => TRANS_USAGE_VESSEL,
		"packageUsageRate" => TRANS_USAGE_RATE,
		"packageUsageComType" => TRANS_USAGE_COM_TYPE,
		"packageUsageComBrand" => TRANS_USAGE_COM_BRAND,
		"packageUsageLinkStatus" => TRANS_USAGE_LINK_STATUS,
		"packageUsageExternalStatusError" => TRANS_EXTERNAL_STATUS_ERROR,
		"packageUsageLinkStatus" => TRANS_USAGE_LINK_STATUS,
		"packageUsageVendor" => TRANS_USAGE_VENDOR,
		"packageUsageUsername" => TRANS_USAGE_USERNAME,
		"packageUsageSerialNumber" => TRANS_USAGE_SERIAL_NUMBER,
		"packageUsageAggregateID" => TRANS_USAGE_AGGREGATE_ID,
		"packageUsageExternalStatus" => TRANS_USAGE_EXTERNAL_STATUS,
		"packageUsageExtraInfo1" => TRANS_USAGE_EXTRA_INFO_1,
		"packageUsageExtraInfo2" => TRANS_USAGE_EXTRA_INFO_2,
		"packageUsageExtraInfo3" => TRANS_USAGE_EXTRA_INFO_3,
		"packageUsagePrice" => TRANS_USAGE_PRICE,
		"packageUsageCost" => TRANS_USAGE_COST,
		"packageUsageDateSession" => TRANS_SESSION_DATE,
		"packageUsageLinkDate" => TRANS_LINK_DATE,
	),
	"types" => array(
		"interfaceID" => "swInterfaces",
		"packageUsageType" => "packageUsageType",
		"packageUsageRecordType" => "cdrDataTypes",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PACKAGES",
		"childName" => "TRANS_MANAGE_PACKAGE_USAGE",
		"sideNavMajor" => "clients",
		"sideNavMinor" => "packages",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_PACKAGE_USAGE",
			"show" => "TRANS_SHOW_USAGE_LOGS",
			"showdetails" => "TRANS_SHOW_LOG_DETAILS",
		),
	),
	"display" => array(
		"context" => array(
			"packageID" => "packages",
			"lineItemID" => "lineItems",
		),
	),
);

?>
