<?php
// $Id: productAddonGroups.php 12437 2008-01-08 19:23:08Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['productAddonGroups'] = array(
	"names" => array(
		"singular" => "productAddonGroup",
		"plural" => "productAddonGroups",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductAddonGroups",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("productAddonGroups", "productAddonGroup"),
	),
	"insert" => array(
		"command" => "SetProductAddonGroups",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetProductAddonGroups",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetProductAddonGroups",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "product_addon_groups",
	"columns" => array(
		"productAddonGroupID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE,
		"productAddonGroupActive" => COLUMN_ACTIVE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"productAddonGroupName" => COLUMN_PRIMARY_NAME|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"productAddonGroupInputType" => COLUMN_TYPE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"productAddonGroupNoneChoice" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
	),
	"columnLabels" => array(
		"productAddonGroupID" => "TRANS_PRODUCT_ADDON_ID",
		"productAddonGroupActive" => "TRANS_ACTIVE",
		"productAddonGroupName" => "TRANS_PRODUCT_ADDON_NAME",
		"productAddonGroupInputType" => "TRANS_PRODUCT_ADDON_INPUT_TYPE",
		"productAddonGroupNoneChoice" => "TRANS_PRODUCT_ADDON_GROUP_ALLOW_NONE",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_PRODUCTS",
		"childName" => "TRANS_MANAGE_ADDONS",
		"sideNavMajor" => "products",
		"sideNavMinor" => "products",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_ADDON",
			"show" => "TRANS_SHOW_ADDONS",
			"add" => "TRANS_ADD_ADDON",
			"showdetails" => "TRANS_ADDON_DETAILS",
			"remove" => "TRANS_REMOVE_ADDON",
		)
	),
	"types" => array(
		"productAddonGroupInputType" => "addoninputs",
	),
	"relations" => array(
		"products" => array("product_addon_group_rel", "productIDs", "productID"),
	),
	"display" => array(
		"revContext" => array(
			"products" => "productAddonGroupID",
		),
		'show' => "1",
		'showTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
	),
);
