<?php
// $Id: productGroups.php 8615 2006-09-01 00:58:57Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['productGroups'] = array(
	"names" => array(
		"singular" => "productGroup",
		"plural" => "productGroups",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductGroups",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("productGroups", "productGroup"),
	),
	"insert" => array(
		"command" => "SetProductGroups",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetProductGroups",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetProductGroups",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("cycleID")),
	),
	"table" => "product_groups",
	"columns" => array(
		"productGroupID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		"productGroupApiName" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"productGroupName" => COLUMN_PRIMARY_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		"productGroupID" => "TRANS_PRODUCT_GROUP_ID",
		"productGroupApiName" => "TRANS_PRODUCT_GROUP_API_NAME",
		"productGroupName" => "TRANS_PRODUCT_GROUP_NAME",
	),
	"relations" => array(
		"products" => array("product_group_rel", "productIDs", "productID"),
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PRODUCTS",
		"childName" => "TRANS_MANAGE_PRODUCTS",
		"sideNavMajor" => "products",
		"sideNavMinor" => "productgroups",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_PRODUCT_GROUP",
			"show" => "TRANS_SHOW_PRODUCT_GROUPS",
			"add" => "TRANS_ADD_PRODUCT_GROUP",
			//"showdetails" => "TRANS_CYCLE_GROUP_DETAILS",
		)
	),
	"display" => array(
		'showTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
		"suppressActions" => array("showdetails", "remove"),
	),
);

?>
