<?php
// $Id: productLedgerEntries.php 8874 2006-09-14 16:18:40Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['productLedgerEntries'] = array(
	"names" => array(
		"singular" => "productLedgerEntry",
		"plural" => "productLedgerEntries",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductLedgerEntries",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("productLedgerEntries", "productLedgerEntry"),
	),
	"insert" => array(
		"command" => "SetProductLedgerEntries",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetProductLedgerEntries",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetProductLedgerEntries",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "product_ledger_entries",
	"columns" => array(
		"productLedgerID" => COLUMN_PRIMARY_KEY,
		"ledgerGroupID" => COLUMN_ID,
		"productVariantID" => COLUMN_ID,
		"productLedgerNumCycles" => COLUMN_INT,
		"generalLedgerType" => COLUMN_TYPE,
		"journalType" => COLUMN_TEXT,
		"ledgerAccountID" => COLUMN_ID,
		"productLedgerDebit" => COLUMN_AMOUNT,
		"productLedgerCredit" => COLUMN_AMOUNT,
		"productLedgerComment" => COLUMN_PRIMARY_NAME,
		"currencyID" => COLUMN_TEXT,
	),
	"types" => array(
		"generalLedgerType" => "ledger",
	),
	"relations" => array(
		"cycles" => array("product_ledger_cycle_rel", "cycleIDs", "cycleID"),
	),
	"display" => array(
		"context" => array(
			//"ledgerGroupID" => "ledgerGroups",
			"productVariantID" => "productVariants",
			//"ledgerAccountID" => "ledgerAccounts",
		),
		"revContext" => array(
			"productLedgerCurrencies" => "productLedgerID",
		),
	),
);
