<?php
// $Id: productVariantPrices.php 10532 2007-01-20 00:28:38Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['productVariantPrices'] = array(
	"names" => array(
		"singular" => "productVariantPrice",
		"plural" => "productVariantPrices",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductVariants",
		'subCommand' => "",
		'params' => array("getProductVariantPriceData" => 1),
	),
	"response" => array(
		'path' => array("productVariants", "productVariant", "productVariantPrices", "productVariantPrice"),
	),
	"insert" => array(
		"command" => "SetProducts",
		"subCommand" => "insert",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => array(
						"productVariantPrices" => array(
							"productVariantPrice" => $allParams,
						),
					),
				),
			)
		),
	),
	"update" => array(
		"command" => "SetProducts",
		"subCommand" => "update",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => array(
						"productVariantPrices" => array(
							"productVariantPrice" => $allParams,
						),
					),
				),
			)
		),
	),
	"delete" => array(
		"command" => "SetProductVariants",
		"subCommand" => "delete",
		"params" => new Params(
			array(
				"removeProductVariantPriceIDs" => new Param("productVariantPriceID"),
			)
		),
	),
	"table" => "product_variant_prices",
	"columns" => array(
		"productVariantPriceID" => COLUMN_PRIMARY_KEY,
		"productVariantID" => COLUMN_ID,
		"productVariantPriceType" => COLUMN_TYPE,
		"cycleID" => COLUMN_ID,
		"currencyID" => COLUMN_TEXT,
		"productVariantPriceAmount" => COLUMN_AMOUNT|COLUMN_NAME,
		"costCurrencyID" => COLUMN_TEXT,
		"costAmount" => COLUMN_AMOUNT,
	),
	"types" => array(
		"productVariantPriceType" => "price",
	),
	"display" => array(
		'showTemplate' => "products/ShowProductVariantPrices",
		'options' => array("TLDs", "cycles", "products", "productVariants"),
		'context' => array(
			"productVariantID" => "variants",
			"cycleID" => "cycles",
		),
	),
);

?>
