<?php
// $Id: productVariants.php 10354 2006-12-22 03:33:05Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

/**
 * generate the productVariantPrimaryName column
 */
class VariantColumnGenerator extends NameColumnGenerator {
	function generateRowByRef(&$row) {
		parent::generateRowByRef($row);
		if(preg_match("/^TRANS_/", $row["productVariantDisplayName"])) {
			if(defined($row["productVariantDisplayName"])) {
				$row["productVariantDisplayName"] = constant($row["productVariantDisplayName"]);
			} else {
				$row["productVariantDisplayName"] = "{variable} {product}";
			}
		}
		if($row["tldName"]) {
			$variable = $row["tldName"];
		} else if($row["productVariableValue"]) {
			$variable = $row["productVariableValue"];
		} else {
			$variable = TRANS_ITSELF;
		}
		$row["productVariantPrimaryName"] = str_replace(
			array(
				"{product}",
				"{variable}",
			),
			array(
				$row["productName"],
				$variable,
			),
			$row["productVariantDisplayName"]
		);
		return true;
	}
}

$CONF['sources']['productVariants'] = array(
	"names" => array(
		"singular" => "productVariant",
		"plural" => "productVariants",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductVariants",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("productVariants", "productVariant"),
	),
	"insert" => array(
		"command" => "SetProducts",
		"subCommand" => "insert",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => $allParams,
				),
			)
		),
	),
	"update" => array(
		"command" => "SetProducts",
		"subCommand" => "update",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => $allParams,
				),
			)
		),
	),
	"delete" => array(
		"command" => "SetProducts",
		"subCommand" => "delete",
		"params" => new Params(
			array(
				"removeProductVariantIDs" => new Param("productVariantID"),
			)
		),
	),
	"table" => "product_variants",
	"columns" => array(
		"productVariantID" => COLUMN_PRIMARY_KEY,
		"productVariantPrimaryName" => COLUMN_PRIMARY_NAME, // generated by the VariantColumnGenerator class
		"productVariantDisplayName" => COLUMN_TEXT,
		"productVariantActive" => COLUMN_ACTIVE,
		"productVariableValueID" => COLUMN_ID,
		"tldID" => COLUMN_ID,
		"productID" => COLUMN_ID,
		"taxZoneGroupID" => COLUMN_ID,
		"cycleDiscountGroupID" => COLUMN_ID,
		"invoicingGroupID" => COLUMN_ID,
	),
	"refColumnGenerator" => "VariantColumnGenerator",
	"display" => array(
		'showTemplate' => "products/ShowProductVariants",
		'options' => array("TLDs", "products"),
		"noFilter" => array("products"),
		'context' => array(
			"productID" => "products",
			"productVariableValueID" => "productVariableValues",
			"tldID" => "TLDs",
			"cycleDiscountGroupID" => "cycleDiscountGroups",
		),
		"revContext" => array(
			"productVariantPrices" => "productVariantID",
			"productLedgerEntries" => "productVariantID",
		),
	),
);

?>
