<?php
// $Id: systemQueue.php 9413 2006-10-11 02:03:42Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['systemQueue'] = array(
	"names" => array(
		"singular" => "systemQueueEvent",
		"plural" => "systemQueue",
		"file" => "events",
	),
	"request" => array(
		'command' => "GetSystemQueue",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("systemQueue", "systemQueueEvent"),
	),
	"insert" => array(
		"command" => "SetSystemQueue",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetSystemQueue",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetSystemQueue",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "system_queue",
	"columns" => array(
		"systemQueueID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE,
		"packageID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"configGroupID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"serverGroupID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueParentID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueStatus" => COLUMN_STATUS|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueCommand" => COLUMN_PRIMARY_NAME|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueCommandInput" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueMinute" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueHour" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueDay" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueMonth" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueYear" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueIsRecurring" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueDateCreated" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueDateToRun" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueDateStarted" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"systemQueueDateFinished" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
	),
	"columnLabels" => array(
	),
	"statuses" => array(
		"systemQueueStatus" => "queue",
	),
	"relations" => array(
	),
	"display" => array(
		"context" => array(
			"packageID" => "packages",
			"configGroupID" => "configGroups",
			"serverGroupID" => "serverGroups",
			"systemQueueParentID" => "systemQueue",
		),
		"revContext" => array(
			"systemQueue" => "systemQueueID",
		),
	),
);

?>
