<?php
// $Id: transactionLog.php 10247 2006-12-08 19:54:50Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['transactionLog'] = array(
	"names" => array(
		"singular" => "transactionLogEntry",
		"plural" => "transactionLog",
		"file" => "clients",
	),
	"request" => array(
		'command' => "GetTransactionLog",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("transactionLog", "transactionLogEntry"),
	),
	"insert" => array(
		"command" => "SetTransactionLog",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetTransactionLog",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetTransactionLog",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "transaction_log",
	"columns" => array(
		"transactionID" => COLUMN_PRIMARY_KEY,
		"authReturn" => COLUMN_STATUS,
		"transactionPaymentMethod" => COLUMN_INT,
		"transactionCode" => COLUMN_TEXT,
		"transactionNotes" => COLUMN_TEXT,
		"transactionDateCreated" => COLUMN_DATE,
		"authCode" => COLUMN_TEXT,
		"transactionAmount" => COLUMN_AMOUNT,
		"transactionAmountRefunded" => COLUMN_AMOUNT,
		"currencyID" => COLUMN_TEXT,
		"configGroupID" => COLUMN_ID,
		"billingAccountID" => COLUMN_ID,
	),
	"statuses" => array(
		"authReturn" => "transactions",
	),
	"relations" => array(
	),
	"display" => array(
		"context" => array(
			"billingAccountID" => "billingAccounts",
			"configGroupID" => "configGroups",
		),
		"revContext" => array(
			"accountingReceiptsJournal" => "transactionID",
		),
	),
);

?>
