<?php
// $Id: vendors.php 12056 2007-10-09 15:52:42Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["vendors"] = baseMap("vendors", "vendors", "vendors", "vendor") + array(
	"columns" => array(
		"vendorID" => COLUMN_PRIMARY_KEY|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"vendorName" => COLUMN_PRIMARY_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"vendorActive" => COLUMN_ACTIVE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		"vendorApiURL" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"vendorSellerUsername" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		"vendorSellerPassword" => COLUMN_TEXT,
		"vendorDateLastInvoiceSync" => COLUMN_DATE,
		"vendorActivationRule" => COLUMN_TYPE,
		"vendorMarkupPercentage" => COLUMN_AMOUNT,
		"vendorAddress1" => COLUMN_TEXT,
		"vendorAddress2" => COLUMN_TEXT,
		"vendorCity" => COLUMN_TEXT,
		"vendorState" => COLUMN_TEXT,
		"vendorZip" => COLUMN_TEXT,
		"countriesID" => COLUMN_ID,
		"adminID" => COLUMN_ID,
	),
	"relations" => array(
		//"productVendorQties" => array("product_vendor_qty_rel", "productVendorQtyIDs", "productVendorQtyID"),
	),
	"columnLabels" => array(
		"vendorID" => TRANS_VENDOR_ID,
		"vendorName" => TRANS_VENDOR_NAME,
		"vendorActive" => TRANS_ACTIVE,
		"vendorApiURL" => TRANS_VENDOR_API_URL,
		"vendorSellerUsername" => TRANS_USERNAME,
		"vendorSellerPassword" => TRANS_PASSWORD,
		"vendorDateLastInvoiceSync" => TRANS_LAST_INVOICE_SYNC,
		"vendorActivationRule" => TRANS_ACTIVATION_RULE,
		"vendorMarkupPercentage" => TRANS_DEFAULT_MARKUP_PERCENTAGE,
		"vendorAddress1" => TRANS_ADDRESS1,
		"vendorAddress2" => TRANS_ADDRESS2,
		"vendorCity" => TRANS_CITY,
		"vendorState" => TRANS_STATE,
		"vendorZip" => TRANS_ZIP,
		"countriesID" => TRANS_COUNTRY,
		"adminID" => TRANS_ADMIN_ID,
	),
	"types" => array(
		"vendorActivationRule" => "vendorActivationRule",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PRODUCTS",
		"childName" => "TRANS_MANAGE_VENDORS",
		"sideNavMajor" => "products",
		"sideNavMinor" => "vendors",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_VENDOR",
			"show" => "TRANS_SHOW_VENDORS",
			"showdetails" => "TRANS_SHOW_VENDOR_DETAILS",
		),
	),
	"display" => array(
		"showTemplate" => "vendors/ShowVendors",
		"context" => array(
			"countriesID" => "countries",
			"adminID" => "admins",
		),
		"revContext" => array(
			"vendorInventoryMsgs" => "vendorID",
			"vendorContacts" => "vendorID",
			"productVendorQtyRels" => "vendorID",
			"productVendorRels" => "vendorID",
			"packageVendorRels" => "vendorID",
		),
	),
);