#!/bin/sh

for foreign in *.admin.php *.user.php
do
	case "${foreign}" in
		en.*)
			# not a foriegn translation file
			continue 2;;
		*.admin.php)
			# admin translation file
			english="en.admin.php";;
		*.user.php)
			# user translation file
			english="en.user.php";;
		*)
			# not a translation file
			continue 2;;
	esac

	echo
	echo "Syncing ${foreign}."

	echo "Backing up old."
	cp "${foreign}" "${foreign}.old"

	echo -n "Creating new... "
	grep -v '[?]>' "${foreign}" > "${foreign}.new"
	./trans_compare.sh "${english}" "${foreign}" >> "${foreign}.new"
	echo "done."

	echo -n "Verifying syntax... "
	if php -l "${foreign}.new" >/dev/null 2>/dev/null
	then
		echo "done."
	else
		echo "!!!!! Unable to update ${foreign}."
		exit 1
		continue
	fi

	echo "Moving new into place."
	mv "${foreign}.new" "${foreign}"

	
done
