#!/bin/sh

english="${1}"
foreign="${2}"

en_messages="en_messages.${$}"
fo_messages="fo_messages.${$}"
script_file="message.${$}.awk"

grep '^define' "${english}" | cut -d"'" -f2 | sort -u > "${en_messages}"
grep '^define' "${foreign}" | cut -d"'" -f2 | sort -u > "${fo_messages}"

new_messages="$(diff "${en_messages}" "${fo_messages}" | grep '^<' | cut -d" " -f2)"

new_messages_pattern="$(echo "${new_messages}" | sed -e "s,.*,'&'," | tr '\n' '|' | sed -e 's,|$,,')"

script='
	BEGIN {
		RS="[)];"; # record separator
		ORS=");"; # output record separator
	}

	/'"${new_messages_pattern}"'/
'

echo "${script}" > "${script_file}"

gawk -f "${script_file}" "${english}"

rm "${en_messages}" "${fo_messages}" "${script_file}"
