{* $Id: ShowLedgerAccountDetails.tpl 9656 2006-10-17 19:26:37Z eradtke $
 * --------------------------------------------------------------
 * This template displays the ledger accounts management page.
 *
 * Smarty Variables:
 *	$ledgerAccounts (array of ledger account data)
 *		ledgerAccountID
 *		ledgerAccountNumber
 *		ledgerAccountType
 * 		ledgerAccountName
 *		ledgerAccountTransKey
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_LEDGER_ACCOUNT_DETAILS" d="Ledger Account Details"}
{t c="TRANS_NO_LEDGER_ACCOUNTS_FOUUND" d="No ledger accounts found."}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_ACCOUNTS_PAYABLE" d="Accounts Payable"}
{t c="TRANS_CERTS_PAYABLE" d="Certs Payable"}
{t c="TRANS_CASH" d="Cash 1"}
{t c="TRANS_CASH_1" d="Cash 2"}
{t c="TRANS_CASH_2" d="Cash 3"}
{t c="TRANS_HARDWARE_ASSETS" d="Hardware Assets"}
{t c="TRANS_EQUITY" d="Owner Equity"}
{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_DOMAINS_PAYABLE" d="Domains Payable"}
{t c="TRANS_GL_NUMBER" d="GL Number"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_TAXES_PAYABLE" d="Taxes Payable"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_COGS" d="Misc Cost of Goods Sold"}
{t c="TRANS_DOMAIN_COGS" d="Domain COGS"}
{t c="TRANS_CERTS_COGS" d="Certificates COGS"}
{t c="TRANS_SETUP_COGS" d="Setup COGS"}
{t c="TRANS_USAGE_COGS" d="Usage COGS"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}

{t c="TRANS_EXPENSE" d="Misc Expense"}
{t c="TRANS_REFUND_EXPENSE" d="Refund Expense"}
{t c="TRANS_CUSTOMER_EXPENSE" d="Customer Relations Expense"}
{t c="TRANS_WAGES_EXPENSE" d="Wages Expense"}
{t c="TRANS_ENTERTAINMENT_EXPENSE" d="Entertainment/Meals Expense"}
{t c="TRANS_RENT_EXPENSE" d="Rent/Lease Expense"}
{t c="TRANS_TRAVEL_EXPENSE" d="Travel Expense"}
{t c="TRANS_COMMISSIONS_EXPENSE" d="Commissions Expense"}
{t c="TRANS_INCOME_TAX_EXPENSE" d="Income Tax Expense"}
{t c="TRANS_DEPRECIATION_EXPENSE" d="Depreciation Expense"}
{t c="TRANS_HARDWARE_LEASE_EXPENSE" d="Hardware Lease Expense"}
{t c="TRANS_COLOCATION_EXPENSE" d="Colocation Expense"}



{t c="TRANS_ASSET_ACCOUNTS" d="Asset Accounts"}
{t c="TRANS_LIABILITY_ACCOUNTS" d="Liability Accounts"}
{t c="TRANS_EQUITY_ACCOUNTS" d="Equity Accounts"}
{t c="TRANS_REVENUE_ACCOUNTS" d="Revenue Accounts"}
{t c="TRANS_COGS_ACCOUNTS" d="Cost of Goods Sold Accounts"}
{t c="TRANS_EXPENSE_ACCOUNTS" d="Expense Accounts"}
{t c="TRANS_OTHER_REVENUE_ACCOUNTS" d="Other Revenue Accounts"}
{t c="TRANS_OTHER_EXPENSE_ACCOUNTS" d="Other Expense Accounts"}

{t c="TRANS_BALANCE_SHEET_ACCOUNTS" d="Balance Sheet Accounts"}
{t c="TRANS_GL_TYPE" d="Account Group"}
{t c="TRANS_FINANCIAL_STATEMENT_ACCOUNTS" d="Financial Statement Accounts"}

{t c="TRANS_CLIENT_NAME" d="Client"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_INVOICE_NUMBER" d="Inv. #"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_DEBITS" d="Debits"}
{t c="TRANS_CREDITS" d="Credits"}
{t c="TRANS_CURRENCY_SHORT" d="Curr."}
{t c="TRANS_GL_TRANSACTIONS" d="Ledger Transactions"}
{t c="TRANS_NO_TRANSACTIONS" d="No transaction returned for this query."}
{t c="TRANS_EDIT" d="Edit"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_LEDGER_ACCOUNT_DETAILS"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

{assign var="ledgerAccountID" value=$ledgerAccounts.ledgerAccountID}

<fieldset><legend>{$smarty.const.TRANS_LEDGER_ACCOUNT_DETAILS}</legend>

        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
            <tr class="headerRow">
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_GL_NUMBER" sortColumn="ledgerAccountNumber"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_NAME"  headerAlign="left"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_GL_TYPE"  headerAlign="left"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_EDIT"  headerAlign="left"}
            </tr>
            <tr class="alt1">
                <td>{$ledgerAccounts.ledgerAccountNumber}</td>
                <td>{assign var="ledgerAccountTransKey" value=$ledgerAccounts.ledgerAccountTransKey}
                        {$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}</td>
                <td>{assign var="ledgerAccountType" value=$ledgerAccounts.ledgerAccountType}
                    {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
                    {$smarty.const.$transkey|default:$transkey}</td>
                <td><a href="{getHREF page="accounting.php" actionName="EditLedgerAccount" args="ledgerAccountID=`$ledgerAccounts.ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a></td>
            </tr>
        </table>
</fieldset>

<fieldset><legend>{$smarty.const.TRANS_GL_TRANSACTIONS}</legend>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
            <tr class="headerRow">
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_CLIENT_NAME" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="clientLastName"}
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_INVOICE_NUMBER" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="invoiceID"}
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_DESCRIPTION" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDescription"}
                {include file="$tplDirectory/widgets/table/tableSortDateHeader.tpl" headerName="TRANS_DATE" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDateCreated"}
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_CURRENCY_SHORT" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="currencyID"}
                {include file="$tplDirectory/widgets/table/tableSortAmountHeader.tpl" headerAlign="left" headerName="TRANS_DEBITS" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDebitAmount"}
                {include file="$tplDirectory/widgets/table/tableSortAmountHeader.tpl" headerAlign="left" headerName="TRANS_CREDITS" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerCreditAmount"}
                {* include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_EDIT" headerAlign="left" *}
            </tr>

        {section name=i loop=$ledgerData}
            {if $className=="alt1"}
                {assign var="className" value="alt2"}
            {else}
                {assign var="className" value="alt1"}
            {/if}

            <tr class="{cycle values="alt1,alt2"}">
                <td>{if $ledgerData[i].clientID}{$ledgerData[i].contactLastName}, {$ledgerData[i].contactFirstName}{else}{$smarty.const.TRANS_NONE}{/if}</td>
                <td>{if $ledgerData[i].invoiceID}{$ledgerData[i].invoiceNumber}{else}{$smarty.const.TRANS_NONE}{/if}</td>
                <td>{assign var="description" value=$ledgerData[i].generalLedgerDescription}
                {$smarty.const.$description|default:$description}</td>
                <td>{$ledgerData[i].generalLedgerDateCreated|getDate:short}</td>
                <td>{$ledgerData[i].currencyID}</td>
                <td align="right">{$ledgerData[i].generalLedgerDebitAmount|getAmount:$ledgerData[i].currencyID:false}</td>
                <td align="right">{$ledgerData[i].generalLedgerCreditAmount|getAmount:$ledgerData[i].currencyID:false}</td>
                <!-- <td><a href="{getHREF page="accounting.php" actionName="EditLedgerTransaction" args="generalLedgerID=`$ledgerData[i].generalLedgerID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a></td> -->
            </tr>

        {sectionelse}

            <tr class="alt1">
                <td colspan="8">{$smarty.const.TRANS_NO_TRANSACTIONS}</td>
            </tr>

        {/section}

        </table>

        {include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="ledgerAccountID=`$ledgerAccountID`"}

{include file="$tplDirectory/footer.tpl"}