{* $Id: ShowLedgerAccounts.tpl 5685 2006-03-22 00:48:07Z kbailey $
 * --------------------------------------------------------------
 * This template displays the ledger accounts management page.
 *
 * Smarty Variables:
 *	$ledgerAccounts (array of ledger account data)
 *		ledgerAccountID
 *		ledgerAccountNumber
 *		ledgerAccountType
 * 		ledgerAccountName
 *		ledgerAccountTransKey
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_NO_LEDGER_ACCOUNTS_FOUUND" d="No ledger accounts found."}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_ACCOUNTS_PAYABLE" d="Accounts Payable"}
{t c="TRANS_CERTS_PAYABLE" d="Certs Payable"}
{t c="TRANS_CASH" d="Cash 1"}
{t c="TRANS_CASH_1" d="Cash 2"}
{t c="TRANS_CASH_2" d="Cash 3"}
{t c="TRANS_HARDWARE_ASSETS" d="Hardware Assets"}
{t c="TRANS_EQUITY" d="Owner Equity"}
{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_DOMAINS_PAYABLE" d="Domains Payable"}
{t c="TRANS_GL_NUMBER" d="GL Number"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_TAXES_PAYABLE" d="Taxes Payable"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_COGS" d="Misc Cost of Goods Sold"}
{t c="TRANS_DOMAIN_COGS" d="Domain COGS"}
{t c="TRANS_CERTS_COGS" d="Certificates COGS"}
{t c="TRANS_SETUP_COGS" d="Setup COGS"}
{t c="TRANS_USAGE_COGS" d="Usage COGS"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}

{t c="TRANS_EXPENSE" d="Misc Expense"}
{t c="TRANS_REFUND_EXPENSE" d="Refund Expense"}
{t c="TRANS_CUSTOMER_EXPENSE" d="Customer Relations Expense"}
{t c="TRANS_WAGES_EXPENSE" d="Wages Expense"}
{t c="TRANS_ENTERTAINMENT_EXPENSE" d="Entertainment/Meals Expense"}
{t c="TRANS_RENT_EXPENSE" d="Rent/Lease Expense"}
{t c="TRANS_TRAVEL_EXPENSE" d="Travel Expense"}
{t c="TRANS_COMMISSIONS_EXPENSE" d="Commissions Expense"}
{t c="TRANS_INCOME_TAX_EXPENSE" d="Income Tax Expense"}
{t c="TRANS_DEPRECIATION_EXPENSE" d="Depreciation Expense"}
{t c="TRANS_HARDWARE_LEASE_EXPENSE" d="Hardware Lease Expense"}
{t c="TRANS_COLOCATION_EXPENSE" d="Colocation Expense"}



{t c="TRANS_ASSET_ACCOUNTS" d="Asset Accounts"}
{t c="TRANS_LIABILITY_ACCOUNTS" d="Liability Accounts"}
{t c="TRANS_EQUITY_ACCOUNTS" d="Equity Accounts"}
{t c="TRANS_REVENUE_ACCOUNTS" d="Revenue Accounts"}
{t c="TRANS_COGS_ACCOUNTS" d="Cost of Goods Sold Accounts"}
{t c="TRANS_EXPENSE_ACCOUNTS" d="Expense Accounts"}
{t c="TRANS_OTHER_REVENUE_ACCOUNTS" d="Other Revenue Accounts"}
{t c="TRANS_OTHER_EXPENSE_ACCOUNTS" d="Other Expense Accounts"}

{t c="TRANS_BALANCE_SHEET_ACCOUNTS" d="Balance Sheet Accounts"}
{t c="TRANS_FINANCIAL_STATEMENT_ACCOUNTS" d="Financial Statement Accounts"}

{t c="TRANS_ADD_LEDGER_ACCOUNT" d="Add Ledger Account"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_LEDGER_ACCOUNTS"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
    <td colspan="2" align="right"><div class="rm"><a href="{getHREF page="accounting.php" actionName="AddLedgerAccount"}">{$smarty.const.TRANS_ADD_LEDGER_ACCOUNT}</a><div></td>
</tr>
<tr>
	{* left column *}
	<td width="50%" valign="top">
	<fieldset><legend>{$smarty.const.TRANS_BALANCE_SHEET_ACCOUNTS}</legend>
		<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_GL_NUMBER" sortColumn="ledgerAccountNumber"}
			{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_NAME"  headerAlign="left"}
            {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"  headerAlign="left"}
		</tr>
		{section name=i loop=$ledgerAccounts}
			{assign var="ledgerAccountID" value=$ledgerAccounts[i].ledgerAccountID}
            {if $ledgerAccounts[i].ledgerAccountType < 4}
    			{if $className=="alt1"}
    			    {assign var="className" value="alt2"}
    			{else}
    			    {assign var="className" value="alt1"}
    			{/if}
    			{if $ledgerAccounts[i].ledgerAccountType != $ledgerAccountType}
    				{assign var="ledgerAccountType" value=$ledgerAccounts[i].ledgerAccountType}
    				<tr>
    					<td colspan="3" class="headerRow">
                                {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
    							{$smarty.const.$transkey|default:$transkey}
    					</td>
    				</tr>
    			{/if}
    			<tr class="{cycle values="alt1,alt2"}">
    				<td width="70">
    					{$ledgerAccounts[i].ledgerAccountNumber}
    				</td>
    				<td>
    					{assign var="ledgerAccountTransKey" value=$ledgerAccounts[i].ledgerAccountTransKey}
    					{$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}
    				</td>
                    <td>
        {strip}
        <a href="{getHREF page="accounting.php" actionName="ShowLedgerAccountDetails" args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
        </a>
        &nbsp;
        <a href="{getHREF page="accounting.php" actionName="EditLedgerAccount" args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a>
        &nbsp;
        <a href="{getHREF page="accounting.php" actionName="RemoveLedgerAccount" args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
        </a>
        {/strip}
                    </td>
    			</tr>
            {/if}
		{sectionelse}
			<tr>
				<td colspan="3">
						{$smarty.const.TRANS_NO_LEDGER_ACCOUNTS_FOUND}
				</td>
			</tr>
		{/section}
		</table>
		</fieldset>
	</td>

	{* right column *}
	<td width="50%" valign="top" align="left">
	<fieldset><legend>{$smarty.const.TRANS_FINANCIAL_STATEMENT_ACCOUNTS}</legend>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
        <tr class="headerRow">
            {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_GL_NUMBER" sortColumn="ledgerAccountNumber"}
            {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_NAME"  headerAlign="left"}
            {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"  headerAlign="left"}
        </tr>
        {section name=i loop=$ledgerAccounts}
            {assign var="ledgerAccountID" value=$ledgerAccounts[i].ledgerAccountID}
            {if $ledgerAccounts[i].ledgerAccountType > 3}
                {if $className=="alt1"}
                    {assign var="className" value="alt2"}
                {else}
                    {assign var="className" value="alt1"}
                {/if}
                {if $ledgerAccounts[i].ledgerAccountType != $ledgerAccountType}
                    {assign var="ledgerAccountType" value=$ledgerAccounts[i].ledgerAccountType}
                    <tr>
                        <td colspan="3" class="headerRow">
                                {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
                              {$smarty.const.$transkey|default:$transkey}
                        </td>
                    </tr>
                {/if}
                <tr class="{cycle values="alt1,alt2"}">
                    <td width="70">
                        {$ledgerAccounts[i].ledgerAccountNumber}
                    </td>
                    <td>
                        {assign var="ledgerAccountTransKey" value=$ledgerAccounts[i].ledgerAccountTransKey}
                        {$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}
                    </td>
                    <td>
        {strip}
        <a href="{getHREF page="accounting.php" actionName="ShowLedgerAccountDetails" args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
        </a>
        &nbsp;
        <a href="{getHREF page="accounting.php" actionName="EditLedgerAccount" args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a>
        &nbsp;
        <a href="{getHREF page="accounting.php" actionName="RemoveLedgerAccount" args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgs"}">
            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
        </a>
        {/strip}
                    </td>
                </tr>
            {/if}
        {sectionelse}
            <tr>
                <td colspan="3">
                        {$smarty.const.TRANS_NO_LEDGER_ACCOUNTS_FOUND}
                </td>
            </tr>
        {/section}
        </fieldset>
        </table>
	</td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}