{* $Id: ShowProfitAndLoss.tpl 9331 2006-10-06 14:56:50Z mfountain $
 * --------------------------------------------------------------
 * This template displays a mini accounting stats report.
 *
 * Smarty Variables:
 *	$invoiceStats (array of invoice status and their count)
 *		invoiceStatus
 *		numInovices
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_FINANCIAL_STATEMENT" d="Financial Statements"}

{t c="TRANS_CURRENCY" d="Currency"}

{t c="TRANS_PROFIT_AND_LOSS" d="Profit and Loss"}

{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_OTHER_REVENUE" d="Other Revenue"}
{t c="TRANS_COGS" d="Cost of Goods"}
{t c="TRANS_EXPENSE" d="Expense"}
{t c="TRANS_OTHER_EXPENSE" d="Other Expense"}
{t c="TRANS_NET_INCOME" d="Net Income"}

{t c="TRANS_GL_ACCOUNT_NUMBER" d="GL #"}
{t c="TRANS_GL_ACCOUNT_NAME" d="Description"}
{t c="TRANS_GL_BALANCE" d="Range Balance"}
{t c="TRANS_YTD_GL_BALANCE" d="YTD Balance"}

{t c="TRANS_REVENUE_LABEL" d="Revenue Accounts"}
{t c="TRANS_OTHER_REVENUE_LABEL" d="Other Revenue Accounts"}
{t c="TRANS_COGS_LABEL" d="Cost of Goods Sold Accounts"}
{t c="TRANS_EXPENSE_LABEL" d="Expense Accounts"}
{t c="TRANS_OTHER_EXPENSE_LABEL" d="Other Expense Accounts"}

{t c="TRANS_REVENUE_TOTALS" d="Revenue Totals"}
{t c="TRANS_OTHER_REVENUE_TOTALS" d="Other Revenue Totals"}
{t c="TRANS_COGS_TOTALS" d="Cost of Goods Sold Totals"}
{t c="TRANS_EXPENSE_TOTALS" d="Expense Totals"}
{t c="TRANS_OTHER_EXPENSE_TOTALS" d="Other Expense Totals"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}

{t c="TRANS_NET_PROFIT" d="Net Profit"}
{t c="TRANS_GROSS_PROFIT" d="Gross Profit"}
{t c="TRANS_PANDL" d="P & L"}

<table width="100%" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tr>
	<td>
		<h1 style="text-align:center;">{$smarty.const.TRANS_PANDL}: {$startDate|getDate:short} - {$endDate|getDate:short}</h1>

		{foreach key="currencyID" item="totals" from=$ledgerAccountsTotals}
		<fieldset>
		    <legend>{$smarty.const.TRANS_CURRENCY}: {$currencyID}</legend>

		        <table width="100%" cellpadding="4" class="ledger">
		            <tr>
		                <th>{$smarty.const.TRANS_GL_ACCOUNT_NUMBER}</th>
		                <th>{$smarty.const.TRANS_GL_ACCOUNT_NAME}</th>
		                <th align="right">{$smarty.const.TRANS_GL_BALANCE}</th>
		                <th align="right">{$smarty.const.TRANS_YTD_GL_BALANCE}</th>
		            </tr>

		            {* ------------------------ REVENUE ----------------------------- *}

		            {assign var="didFirst" value=0}
		            {assign var="loopData" value=$totals.revenue}
		            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.revenue}
		            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdrevenue}

		            {foreach key="i" item="Data" from=$loopData}
		                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
		                {if $didFirst}
		                    {assign var="class" value=""}
		                {else}
		            <tr class="first">
		                <td colspan="4"><h1>{$smarty.const.TRANS_REVENUE_LABEL}<h1></td>
		            </tr>
		                    {assign var="didFirst" value=1}
		                    {assign var="class" value="first"}
		                {/if}

		            <tr class="{$class}">
		                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
		                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
		                <td>{$smarty.const.$tkey|default:$tkey}</td>
		                <td align="right">{$Data.total|getAmount:$currencyID}</td>
		                <td align="right">{$Data.ytdtotal|getAmount:$currencyID}</td>
		            </tr>
		            {/foreach}
		            <tr class="total">
		                <td colspan="2"><h1><i>{$smarty.const.TRANS_REVENUE_TOTALS}</i></h1></td>
		                <td align="right">{$totalsData|getAmount:$currencyID}</td>
		                <td align="right">{$ytdTotalsData|getAmount:$currencyID}</td>
		            </tr>

		            {* ------------------------------------------------------------- *}

		            {* ------------------------ OTHER REV -------------------------- *}

		            {assign var="didFirst" value=0}
		            {assign var="loopData" value=$totals.otherRev}
		            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.otherRev}
		            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdotherRev}

		            {foreach key="i" item="Data" from=$loopData}
		                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
		                {if $didFirst}
		                    {assign var="class" value=""}
		                {else}
		            <tr class="first">
		                <td colspan="4"><h1>{$smarty.const.TRANS_OTHER_REVENUE_LABEL}<h1></td>
		            </tr>
		                    {assign var="didFirst" value=1}
		                    {assign var="class" value="first"}
		                {/if}

		            <tr class="{$class}">
		                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
		                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
		                <td>{$smarty.const.$tkey|default:$tkey}</td>
		                <td align="right">{$Data.total|getAmount:$currencyID}</td>
		                <td align="right">{$Data.ytdtotal|getAmount:$currencyID}</td>
		            </tr>
		            {/foreach}

		            <tr class="total">
		                <td colspan="2"><h1><i>{$smarty.const.TRANS_OTHER_REVENUE_TOTALS}</i></h1></td>
		                <td align="right">{$totalsData|getAmount:$currencyID}</td>
		                <td align="right">{$ytdTotalsData|getAmount:$currencyID}</td>
		            </tr>

		            {* ------------------------------------------------------------- *}

		            <tr class="first alt1">
		                <td colspan="2" align="right"><h1>{$smarty.const.TRANS_GROSS_PROFIT}</h1></td>
		                <td align="right">{$ledgerTypeTotals.$currencyID.revenue+$ledgerTypeTotals.$currencyID.otherRev|getAmount:$currencyID}</td>
		                <td align="right">{$ledgerTypeTotals.$currencyID.ytdrevenue+$ledgerTypeTotals.$currencyID.ytdotherRev|getAmount:$currencyID}</td>
		            </tr>

		            {* ------------------------ COGS ------------------------------- *}

		            {assign var="didFirst" value=0}
		            {assign var="loopData" value=$totals.cogs}
		            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.cogs}
		            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdcogs}

		            {foreach key="i" item="Data" from=$loopData}
		                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
		                {if $didFirst}
		                    {assign var="class" value=""}
		                {else}
		            <tr class="first">
		                <td colspan="4"><h1>{$smarty.const.TRANS_COGS_LABEL}<h1></td>
		            </tr>
		                    {assign var="didFirst" value=1}
		                    {assign var="class" value="first"}
		                {/if}

		            <tr class="{$class}">
		                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
		                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
		                <td>{$smarty.const.$tkey|default:$tkey}</td>
		                <td align="right">{$Data.total|getAmount:$currencyID}</td>
		                <td align="right">{$Data.ytdtotal|getAmount:$currencyID}</td>
		            </tr>
		            {/foreach}

		            <tr class="total">
		                <td colspan="2"><h1><i>{$smarty.const.TRANS_COGS_TOTALS}</i></h1></td>
		                <td align="right">{$totalsData|getAmount:$currencyID}</td>
		                <td align="right">{$ytdTotalsData|getAmount:$currencyID}</td>
		            </tr>

		            {* ------------------------------------------------------------- *}

		            {* ------------------------ EXPENSE ---------------------------- *}

		            {assign var="didFirst" value=0}
		            {assign var="loopData" value=$totals.expense}
		            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.expense}
		            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdexpense}

		            {foreach key="i" item="Data" from=$loopData}
		                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
		                {if $didFirst}
		                    {assign var="class" value=""}
		                {else}
		            <tr class="first">
		                <td colspan="4"><h1>{$smarty.const.TRANS_EXPENSE_LABEL}<h1></td>
		            </tr>
		                    {assign var="didFirst" value=1}
		                    {assign var="class" value="first"}
		                {/if}

		            <tr class="{$class}">
		                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
		                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
		                <td>{$smarty.const.$tkey|default:$tkey}</td>
		                <td align="right">{$Data.total|getAmount:$currencyID}</td>
		                <td align="right">{$Data.ytdtotal|getAmount:$currencyID}</td>
		            </tr>
		            {/foreach}

		            <tr class="total">
		                <td colspan="2"><h1><i>{$smarty.const.TRANS_EXPENSE_TOTALS}</i></h1></td>
		                <td align="right">{$totalsData|getAmount:$currencyID}</td>
		                <td align="right">{$ytdTotalsData|getAmount:$currencyID}</td>
		            </tr>

		            {* ------------------------------------------------------------- *}

		            {* ------------------------ OTHER EXPENSE ---------------------- *}

		            {assign var="didFirst" value=0}
		            {assign var="loopData" value=$totals.otherExp}
		            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.otherExp}
		            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdotherExp}

		            {foreach key="i" item="Data" from=$loopData}
		                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
		                {if $didFirst}
		                    {assign var="class" value=""}
		                {else}
		            <tr class="first">
		                <td colspan="4"><h1>{$smarty.const.TRANS_OTHER_EXPENSE_LABEL}<h1></td>
		            </tr>
		                    {assign var="didFirst" value=1}
		                    {assign var="class" value="first"}
		                {/if}

		            <tr class="{$class}">
		                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
		                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
		                <td>{$smarty.const.$tkey|default:$tkey}</td>
		                <td align="right">{$Data.total|getAmount:$currencyID}</td>
		                <td align="right">{$Data.ytdtotal|getAmount:$currencyID}</td>
		            </tr>
		            {/foreach}

		            <tr class="total">
		                <td colspan="2"><h1><i>{$smarty.const.TRANS_OTHER_EXPENSE_TOTALS}</i></h1></td>
		                <td align="right">{$totalsData|getAmount:$currencyID}</td>
		                <td align="right">{$ytdTotalsData|getAmount:$currencyID}</td>
		            </tr>

		            {* ------------------------------------------------------------- *}

		            <tr class="first alt1">
		                <td colspan="2" align="right"><h1>{$smarty.const.TRANS_NET_PROFIT}</h1></td>
		                <td align="right">{$ledgerTypeTotals.$currencyID.total|getAmount:$currencyID}</td>
		                <td align="right">{$ledgerTypeTotals.$currencyID.ytdtotal|getAmount:$currencyID}</td>
		            </tr>


		        </table>
		</fieldset>
		{/foreach}

	</td>
</tr>
</table>

