{* $Id: ShowReceiptsJournal.tpl 10261 2006-12-11 19:48:58Z kbailey $
 * --------------------------------------------------------------
 * This template displays the daily sales & receipts journal
 *
 * Smarty Variables:
 *	$salesReceiptsJournal (array of journal entries)
 *		receiptJournalID
 *		clientID
 *		invoiceID
 *		transactionID
 *		receiptDateCreated
 *		receiptDescription
 *		receiptCashDebitAmount
 *		receiptAccRecDebitAmount
 *		receiptAccRecCreditAmount
 *		receiptSalesCreditAmount
 *		receiptTaxPayCreditAmount
 *	$salesReceiptsJournalTotals (array of this pages totals)
 *		receiptCashDebitAmount
 *		receiptAccRecDebitAmount
 *		receiptAccRecCreditAmount
 *		receiptSalesCreditAmount
 *		receiptTaxPayCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_ACCOUNTS_PAYABLE" d="Accounts Payable"}
{t c="TRANS_AR_CREDIT" d="Accounts Receivable Credit"}
{t c="TRANS_AR_DEBIT" d="Accounts Receivable Debit"}
{t c="TRANS_CASH_DEBIT" d="Cash Debit"}
{t c="TRANS_DEBIT" d="Debit"}
{t c="TRANS_CREDIT" d="Credit"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_INVOICE" d="Invoice"}
{t c="TRANS_SALES_AND_RECEIPTS_JOURNAL" d="Sales & Receipts Journal"}
{t c="TRANS_SALES_AND_RECEIPTS_DESC" d="All daily sales and payments received are recorded in a combined sales and cash receipts journal."}
{t c="TRANS_SELECT_JOURNAL_DATE" d="Select a journal date to view."}
{t c="TRANS_SALES_CREDIT" d="Sales Credit"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_TAX_CREDIT" d="Tax Credit"}
{t c="TRANS_CURRENCY" d="Currency"}
{t c="TRANS_NO_RECEIPTS_MATCH_YOUR_QUERY" d="No receipts match your query"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}
{t c="TRANS_CASH_STRING" d="Cash"}
{t c="TRANS_SALES" d="Sales"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_SALES_AND_RECEIPTS_JOURNAL"
	sideNavMajor="finances"
	sideNavMinor="accounting"}


{*
		<table width="100%" border="0" cellpadding="0" cellspacing="3" class="tab07">
		<tr class="althover">
			<th>{$smarty.const.TRANS_SALES_AND_RECEIPTS_JOURNAL}</th>
		</tr>
		<tr class="alt2">
			<td>{$smarty.const.TRANS_SALES_AND_RECEIPTS_DESC}</td>
		</tr>
		<tr class="alt1">
			<td align="center">
				<form>
					{$smarty.const.TRANS_SELECT_JOURNAL_DATE} <input class="button" type="button" id="salesJournalCal" value=" ... " />
				</form>
			</td>
		</tr>
		</table>
*}

{assign var="firstCurrency" value=1}
{foreach key="currencyID" item="salesReceiptsJournal" from=$currencies}
    {assign var="salesReceiptsJournalTotals" value=$currencies_totals.$currencyID}
    <fieldset>
    <legend>{$smarty.const.TRANS_CURRENCY}: {$currencyID}</legend>
    {if $firstCurrency==1}
    <div style="text-align: right;">
		{include file="$tplDirectory/widgets/context/sortedBy.tpl" displaySortColumnName=$smarty.request.sortColumn displaySortDir=$smarty.request.sortDir}
    </div>
    	{assign var="firstCurrency" value=0}
    {/if}
    <br />
    
		<table width="100%" cellpadding="4" class="ledger">
			<tr>
				<th colspan="2">&nbsp;</th>
				<th>&nbsp;</th>
                <th colspan="2">{$smarty.const.TRANS_CASH_STRING}</th>
                <th colspan="2">{$smarty.const.TRANS_ACCOUNTS_RECEIVABLE}</th>
                <th colspan="2">{$smarty.const.TRANS_SALES}</th>
                <th colspan="2">{$smarty.const.TRANS_TAX}</th>
                <th colspan="2">{$smarty.const.TRANS_COUPON}</th>
			</tr>
			{assign var="queryArgs" value="dateQuery=`$dateQuery.0`&salesJournalBeginMonth=`$salesJournalBeginMonth`&salesJournalBeginDay=`$salesJournalBeginDay`&salesJournalBeginYear=`$salesJournalBeginYear`&salesJournalEndMonth=`$salesJournalEndMonth`&salesJournalEndDay=`$salesJournalEndDay`&salesJournalEndYear=`$salesJournalEndYear`"}
			<tr>
				<th class="green">{include file="$tplDirectory/widgets/headerSortLink.tpl" text=$smarty.const.TRANS_DATE action="ShowReceiptsJournal" sortColumn="receiptDateCreated" queryArgs=$queryArgs}</th>
				<th>{include file="$tplDirectory/widgets/headerSortLink.tpl" text=$smarty.const.TRANS_INVOICE action="ShowReceiptsJournal" sortColumn="invoiceID" queryArgs=$queryArgs}</th>
				<th>{include file="$tplDirectory/widgets/headerSortLink.tpl" text=$smarty.const.TRANS_DESCRIPTION action="ShowReceiptsJournal" sortColumn="receiptDescription" queryArgs=$queryArgs}</th>
                <th class="green">{include text=$smarty.const.TRANS_DEBIT sortColumn="receiptCashDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th>{include text=$smarty.const.TRANS_CREDIT sortColumn="receiptCashCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th class="green">{include text=$smarty.const.TRANS_DEBIT sortColumn="receiptAccRecDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
				<th>{include text=$smarty.const.TRANS_CREDIT sortColumn="receiptAccRecCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th class="green">{include text=$smarty.const.TRANS_DEBIT sortColumn="receiptSalesDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th>{include text=$smarty.const.TRANS_CREDIT sortColumn="receiptSalesCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th class="green">{include text=$smarty.const.TRANS_DEBIT sortColumn="receiptTaxPayDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th>{include text=$smarty.const.TRANS_CREDIT sortColumn="receiptTaxPayCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th class="green">{include text=$smarty.const.TRANS_DEBIT sortColumn="receiptCouponDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                <th>{include text=$smarty.const.TRANS_CREDIT sortColumn="receiptCouponCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
			</tr>
			{section name="i" loop=$salesReceiptsJournal}
				{if $smarty.section.i.iteration==1}
					{assign var="class" value="first"}
				{else}
					{assign var="class" value=""}
				{/if}
				<tr class="{$class}">
					<td class="green" align="center">{$salesReceiptsJournal[i].receiptDateCreated|getDate}</td>
					<td align="right">{$salesReceiptsJournal[i].invoiceID}</td>
					<td>{$salesReceiptsJournal[i].receiptDescription}</td>
                    <td class="divider" align="right">{$salesReceiptsJournal[i].receiptCashDebitAmount|getAmount:$currencyID:false}</td>
                    <td align="right">{$salesReceiptsJournal[i].receiptCashCreditAmount|getAmount:$currencyID:false}</td>
					<td class="divider" align="right">{$salesReceiptsJournal[i].receiptAccRecDebitAmount|getAmount:$currencyID:false}</td>
					<td align="right">{$salesReceiptsJournal[i].receiptAccRecCreditAmount|getAmount:$currencyID:false}</td>
                    <td class="divider" align="right">{$salesReceiptsJournal[i].receiptSalesDebitAmount|getAmount:$currencyID:false}</td>
                    <td align="right">{$salesReceiptsJournal[i].receiptSalesCreditAmount|getAmount:$currencyID:false}</td>
                    <td class="divider" align="right">{$salesReceiptsJournal[i].receiptTaxPayDebitAmount|getAmount:$currencyID:false}</td>
                    <td align="right">{$salesReceiptsJournal[i].receiptTaxPayCreditAmount|getAmount:$currencyID:false}</td>
                    <td class="divider" align="right">{$salesReceiptsJournal[i].receiptCouponDebitAmount|getAmount:$currencyID:false}</td>
                    <td align="right">{$salesReceiptsJournal[i].receiptCouponCreditAmount|getAmount:$currencyID:false}</td>
				</tr>
			{/section}
			<tr class="total">
				<td width="10%" class="green">&nbsp;</td>
				<td width="5%">&nbsp;</td>
				<td width="30%">&nbsp;</td>
                <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptCashDebitAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptCashCreditAmount|getAmount:$currencyID:false}</strong></td>
				<td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptAccRecDebitAmount|getAmount:$currencyID:false}</strong></td>
				<td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptAccRecCreditAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptSalesDebitAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptSalesCreditAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptTaxPayDebitAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptTaxPayCreditAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptCouponDebitAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptCouponCreditAmount|getAmount:$currencyID:false}</strong></td>
			</tr>
		</table>
{foreachelse}
    {$smarty.const.TRANS_NO_RECEIPTS_MATCH_YOUR_QUERY}
{/foreach}

        {include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="dateQuery=`$dateQuery.0`&salesJournalBeginMonth=`$salesJournalBeginMonth`&salesJournalBeginDay=`$salesJournalBeginDay`&salesJournalBeginYear=`$salesJournalBeginYear`&salesJournalEndMonth=`$salesJournalEndMonth`&salesJournalEndDay=`$salesJournalEndDay`&salesJournalEndYear=`$salesJournalEndYear`"}
</fieldset>

<script type="text/javascript">//<![CDATA[
{literal}
var startDate;
var endDate;
var callbacks = 0;

function resetDates() {
    startDate = endDate = null;
}

/*
* Given two dates (in seconds) find out if date1 is bigger, date2 is bigger or
* they're the same, taking only the dates, not the time into account.
* In other words, different times on the same date returns equal.
* returns -1 for date1 bigger, 1 for date2 is bigger 0 for equal
*/

function compareDatesOnly(date1, date2) {
    var year1 = date1.getYear();
    var year2 = date2.getYear();
    var month1 = date1.getMonth();
    var month2 = date2.getMonth();
    var day1 = date1.getDate();
    var day2 = date2.getDate();
    if (year1 > year2) {
        return -1;
    }
    if (year2 > year1) {
        return 1;
    }
    //years are equal
    if (month1 > month2) {
        return -1;
    }
    if (month2 > month1) {
        return 1;
    }
    //years and months are equal
    if (day1 > day2) {
        return -1;
    }
    if (day2 > day1) {
        return 1;
    }
    //days are equal
    return 0;
}

function disableDates(date) {
    var now = new Date();
    if (compareDatesOnly(now, date) > 0) {
        return (true);
    }
    //all other days are enabled
    return false;
}

function goSalesJournal(cal) {
    if (cal.dateClicked) {
        {/literal}
        var url = "accounting.php?action={getActionID action="ShowReceiptsJournal"}&dateQuery[]=" + cal.date.print("%Y/%m/%d/") + "&sid={$sid}";
        {literal}
        window.location = url;
    }
}

/*Zapatec.Calendar.setup({
    weekNumbers       : false,
    showOthers        : false,
    showsTime         : false,
    timeFormat        : "12",
    step              : 2,
    range             : [1990.01, 2020.12],
    dateStatusFunc      : disableDates,
    button            : "salesJournalCal",
    onSelect          : goSalesJournal
});*/


{/literal}
//]]></script>

{include file="$tplDirectory/footer.tpl"}