{* $Id: ShowTaxPayableLedger.tpl 10261 2006-12-11 19:48:58Z kbailey $
 * --------------------------------------------------------------
 * This template displays the daily purchases journal.
 *
 * Smarty Variables:
 *	$generalLedger (array of ledger entries)
 *		generalLedgerID
 *		clientID
 *		invoiceID
 *		journalTableID
 *		journalTableName
 *		generalLedgerDateCreated
 *		generalLedgerDescription
 *		generalLedgerDebitAmount
 *		generalLedgerCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_TAX_PAYABLE_LEDGER" d="Tax Payable Ledger"}
{t c="TRANS_AR_CREDIT" d="Accounts Receivable Credit"}
{t c="TRANS_AR_DEBIT" d="Accounts Receivable Debit"}
{t c="TRANS_BALANCE" d="Balance"}
{t c="TRANS_DEBIT" d="Debit"}
{t c="TRANS_CASH_CREDIT" d="Cash Credit"}
{t c="TRANS_CREDIT" d="Credit"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_INVOICE" d="Inv."}
{t c="TRANS_PURCHASE_DEBIT" d="Purchase Debit"}
{t c="TRANS_GENERAL_LEDGER" d="General Ledger"}
{t c="TRANS_GL_NUMBER" d="GL Number"}
{t c="TRANS_GL_ACCOUNT" d="GL Account"}
{t c="TRANS_REFERENCE" d="Ref."}
{t c="TRANS_SALES_CREDIT" d="Sales Credit"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_TAX_CREDIT" d="Tax Credit"}

{t c="TRANS_CASH" d="Cash 1"}
{t c="TRANS_CASH_1" d="Cash 2"}
{t c="TRANS_CASH_2" d="Cash 3"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_HARDWARE_ASSETS" d="Hardware Assets"}
{t c="TRANS_EQUITY" d="Owner Equity"}
{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_DOMAINS_PAYABLE" d="Domains Payable"}
{t c="TRANS_GL_NUMBER" d="GL Number"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_TAXES_PAYABLE" d="Taxes Payable"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_COGS" d="Misc Cost of Goods Sold"}
{t c="TRANS_DOMAIN_COGS" d="Domain COGS"}
{t c="TRANS_CERTS_COGS" d="Certificates COGS"}
{t c="TRANS_SETUP_COGS" d="Setup COGS"}
{t c="TRANS_USAGE_COGS" d="Usage COGS"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}

{t c="TRANS_EXPENSE" d="Misc Expense"}
{t c="TRANS_REFUND_EXPENSE" d="Refund Expense"}
{t c="TRANS_CUSTOMER_EXPENSE" d="Customer Relations Expense"}
{t c="TRANS_WAGES_EXPENSE" d="Wages Expense"}
{t c="TRANS_ENTERTAINMENT_EXPENSE" d="Entertainment/Meals Expense"}
{t c="TRANS_RENT_EXPENSE" d="Rent/Lease Expense"}
{t c="TRANS_TRAVEL_EXPENSE" d="Travel Expense"}
{t c="TRANS_COMMISSIONS_EXPENSE" d="Commissions Expense"}
{t c="TRANS_INCOME_TAX_EXPENSE" d="Income Tax Expense"}
{t c="TRANS_DEPRECIATION_EXPENSE" d="Depreciation Expense"}
{t c="TRANS_HARDWARE_LEASE_EXPENSE" d="Hardware Lease Expense"}
{t c="TRANS_COLOCATION_EXPENSE" d="Colocation Expense"}

{t c="TRANS_CURRENCY" d="Currency"}
{t c="TRANS_NO_TAX_PAYABLE_LEDGER_ENTRIES" d="No tax payable ledger entries for this date."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_TAX_PAYABLE_LEDGER"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

{foreach key="currencyID" item="generalLedger" from=$currencies}
	<fieldset>
    <legend>{$smarty.const.TRANS_CURRENCY}: {$currencyID}</legend>

		<table width="100%" cellpadding="4" class="ledger">
			{assign var="queryArgs" value="dateQuery[]=`$dateQuery.0`&taxLedgerBeginMonth=`$taxLedgerBeginMonth`&taxLedgerBeginDay=`$taxLedgerBeginDay`&taxLedgerBeginYear=`$taxLedgerBeginYear`&taxLedgerEndMonth=`$taxLedgerEndMonth`&taxLedgerEndDay=`$taxLedgerEndDay`&taxLedgerEndYear=`$taxLedgerEndYear`"}
			<tr>
				<th class="green">{include sortColumn="generalLedgerDateCreated" text=$smarty.const.TRANS_DATE file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowTaxPayableLedger" queryArgs=$queryArgs}</th>
				<th class="green">{include sortColumn="invoiceID" text=$smarty.const.TRANS_INVOICE file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowTaxPayableLedger" queryArgs=$queryArgs}</th>
				<th>{$smarty.const.TRANS_PACKAGE_NAME}</th>
				<th class="green">{include sortColumn="generalLedgerDescription" text=$smarty.const.TRANS_DESCRIPTION file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowTaxPayableLedger" queryArgs=$queryArgs}</th>
				<th>{include sortColumn="ledgerAccountNumber" text=$smarty.const.TRANS_GL_ACCOUNT file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowTaxPayableLedger" queryArgs=$queryArgs}</th>
				<th class="green">{include sortColumn="generalLedgerDebitAmount" text=$smarty.const.TRANS_DEBIT file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowTaxPayableLedger" queryArgs=$queryArgs}</th>
				<th>{include sortColumn="generalLedgerCreditAmount" text=$smarty.const.TRANS_CREDIT file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowTaxPayableLedger" queryArgs=$queryArgs}</th>
			</tr>
			{section name="i" loop=$generalLedger}
				{assign var="generalLedgerID" value=$generalLedger[i].generalLedgerID}
				{if $smarty.section.i.iteration==1}
					{assign var="class" value="first"}
				{else}
					{assign var="class" value=""}
				{/if}
				<tr class="{$class}">
					<td class="green" style="white-space: nowrap;" align="center">{$generalLedger[i].generalLedgerDateCreated|getDate}</td>
					<td class="green" align="right"><a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$generalLedger[i].invoiceID`"}">{$generalLedger[i].invoiceNumber}</a></td>
					<td><a href="{getHREF page="packages.php" actionName="ShowPackageDetails" args="packageID=`$ledgerPackageNames[$generalLedgerID].packageID`"}">{$ledgerPackageNames[$generalLedgerID].name}</a></td>
					<td class="description">{$generalLedger[i].generalLedgerDescription}</td>
                    {assign var="tkey" value=$generalLedger[i].ledgerAccountTransKey}
                    <td>{$generalLedger[i].ledgerAccountNumber} - {$smarty.const.$tkey|default:$tkey}</td>
					<td width="10%" align="right">{$generalLedger[i].generalLedgerDebitAmount|getAmount:$generalLedger[i].currencyID:false}</td>
					<td width="10%" align="right">{$generalLedger[i].generalLedgerCreditAmount|getAmount:$generalLedger[i].currencyID:false}</td>
				</tr>
			{/section}
		</table>
		</fieldset>
{foreachelse}
    {$smarty.const.TRANS_NO_TAX_PAYABLE_LEDGER_ENTRIES}
{/foreach}

{include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="dateQuery[]=`$dateQuery.0`&taxLedgerBeginMonth=`$taxLedgerBeginMonth`&taxLedgerBeginDay=`$taxLedgerBeginDay`&taxLedgerBeginYear=`$taxLedgerBeginYear`&taxLedgerEndMonth=`$taxLedgerEndMonth`&taxLedgerEndDay=`$taxLedgerEndDay`&taxLedgerEndYear=`$taxLedgerEndYear`"}

{include file="$tplDirectory/footer.tpl"}