{* $Id: EditMyProfile.tpl 6697 2006-05-08 23:12:39Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a form to edit the current admin's profile.
 *
 * Smarty Variables:
 *	$profile (array of this admin's profile data)
 *		adminID			A unique admin ID
 *		adminFirstName	An admin's first name
 *		adminLastName	An admin's last name
 *		adminEmail		An admin's email address
 *		adminUsername	An admin's username
 *		adminActive		The active state of an admin
 *		themeID 		The unique themeID
 *		languageID 		The unique languageID
 *		countriesID 	The unique countriesID
 *	$actionID			The unique action ID for this page view
 *  $actionName			The action name for this action ID
 *	$imageDirectory		The image directory for this theme
 *	$tplDirectory		The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_UPDATE_PROFILE" d="Update Profile"}
{t c="TRANS_MYPROFILE" d="My Profile"}
{t c="TRANS_ADMIN_ID" d="Admin ID"}
{t c="TRANS_ADMIN_PROFILE" d="Admin Profile"}
{t c="TRANS_ASSIGNED_ADMIN_GROUPS" d="Assigned Admin Groups"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_CHANGE_REMOTE_ACCESS_HASH" d="Change Remote Access Hash"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LANGUAGE" d="Language"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_MANAGE_ADMINS" d="Manage Admins"}
{t c="TRANS_MANAGE_SYSTEM" d="Manage System"}
{t c="TRANS_NEW_PASSWORD" d="New Password"}
{t c="TRANS_ENTER_PASSWORD_AGAIN" d="Enter Password Again"}
{t c="TRANS_THEME" d="Theme"}
{t c="TRANS_UPDATE_PROFILE" d="Update Profile"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_USERNAME" d="Active"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName="TRANS_MANAGE_ADMINS"
	grandchildName="TRANS_MYPROFILE"
	sideNavMajor="system"
	sideNavMinor="admins"}

{assign var="adminID" value=$admin.adminID}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form method="post" action="admins.php">
<input type="hidden" name="action" value="{getActionID action="EditMyProfileResponse"}" />
<input type="hidden" name="adminID" value="{$admin.adminID}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>
<tr>
	<td class="title">{$smarty.const.TRANS_ADMIN_ID}</td>
	<td>{$adminID}</td>
</tr>
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminFirstName"
	value=$formValues.adminFirstName|stripslashes
	title="TRANS_FIRST_NAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminLastName"
	value=$formValues.adminLastName|stripslashes
	title="TRANS_LAST_NAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminEmail"
	value=$formValues.adminEmail|stripslashes
	title="TRANS_EMAIL"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminUsername"
	value=$formValues.adminUsername|stripslashes
	title="TRANS_USERNAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputPassword.tpl"
	name="adminPassword"
	value=$formValues.adminPassword
	title="TRANS_NEW_PASSWORD"}
{include
	file="$tplDirectory/widgets/forms/validateInputPassword.tpl"
	name="adminPasswordConfirm"
	value=$admin.adminPasswordConfirm
	title="TRANS_ENTER_PASSWORD_AGAIN"}
<tr {if $invalid.themeID}class="highlight"{/if}>
	<td class="title">{$smarty.const.TRANS_THEME}</td>
	<td>
        <select id="themeID" name="themeID">
            {html_options options=$themes selected=$formValues.themeID}
        </select>  {$invalid.themeID}
    </td>
</tr>
<tr {if $invalid.languageID}class="highlight"{/if}>
	<td class="title">{$smarty.const.TRANS_LANGUAGE}</td>
	<td>
        <select id="languageID" name="languageID">
            {html_options options=$languages selected=$formValues.languageID}
        </select>  {$invalid.languageID}
    </td>
</tr>
<tr {if $invalid.countriesID}class="highlight"{/if}>
	<td class="title">{$smarty.const.TRANS_COUNTRY}</td>
	<td>
        <select id="countriesID" name="countriesID">
            {html_options options=$countries selected=$formValues.countriesID}
        </select>  {$invalid.countriesID}
    </td>
</tr>
<tr {if $invalid.adminActive}class="highlight"{/if}>
	<td class="title">{$smarty.const.TRANS_ACTIVE}</td>
	<td>
        {html_radios id="adminActive" name="adminActive" options=$activeInactive selected=$formValues.adminActive separator="<br />"}
    </td>
</tr>

<tr class="listButtons">
	<td colspan="2"><div><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_UPDATE_PROFILE}" /></div></td>
</tr>
</tbody>
</table>


</form>

{include file="$tplDirectory/footer.tpl"}
