{* $Id: ShowAdminGroups.tpl 10143 2006-11-28 15:00:06Z eradtke $
 * --------------------------------------------------------------
 * This template displays the admin groups.
 *
 * Smarty Variables:
 *	$adminGroups (array of adminGroup data)
 *		adminGroupID
 *		adminGroupName
 *  $actionID			The unique action ID for this page view
 *  $actionName			The action name for this action ID
 *  $imageDirectory		The image directory for this theme
 *  $tplDirectory		The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ADD_GROUP" d="Add New Group"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADMIN_GROUPS" d="Admin Groups"}
{t c="TRANS_ADMIN_GROUP_NAME" d="Admin Group Name"}
{t c="TRANS_MANAGE_SYSTEM" d="Manage System"}
{t c="TRANS_MANAGE_ADMIN_GROUPS" d="Manage Admin Groups"}
{t c="TRANS_NO_ADMIN_GROUPS_FOUND" d="No admin groups found."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName="TRANS_MANAGE_ADMIN_GROUPS"
	sideNavMajor="system"
	sideNavMinor="admins"}

	{* left column *}
		<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_ADMIN_GROUPS" sortColumn="adminGroupName"}
			{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
		</tr>
		{section name=i loop=$adminGroups}
			{assign var="adminGroupID" value=$adminGroups[i].adminGroupID}
			{if $className=="alt1"}
			    {assign var="className" value="alt2"}
			{else}
			    {assign var="className" value="alt1"}
			{/if}
			<tr class="{cycle values="alt1,alt2"}">
				<td>
					{$adminGroups[i].adminGroupName}
					{include
						file="$tplDirectory/widgets/quickEditLink.tpl"
						editActionName="EditAdminGroupResponse"
						editID=$adminGroupID
						editKey="adminGroupID"
						editName="TRANS_ADMIN_GROUP_NAME"
						editColumn="adminGroupName"
						editValue=$adminGroups[i].adminGroupName}
				</td>
				<td>
					{strip}
					<a href="{getHREF page="admins.php" actionName="ShowAdminGroupDetails" args="adminGroupID=$adminGroupID"}">
						<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" style="margin-right: 4px; vertical-align:middle;border-style:none;" /></a><a href="{getHREF page="admins.php" actionName="ShowAdminGroupDetails" args="adminGroupID=$adminGroupID"}">Manage Actions
					</a>
					&nbsp;
					<a href="{getHREF page="admins.php" actionName="EditAdminGroup" args="adminGroupID=$adminGroupID"}">
						<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" style="margin-right: 4px; vertical-align:middle;border-style:none;" /></a><a href="{getHREF page="admins.php" actionName="EditAdminGroup" args="adminGroupID=$adminGroupID"}">Edit Name
					</a>
					&nbsp;
					<a href="{getHREF page="admins.php" actionName="RemoveAdminGroup" args="adminGroupID=$adminGroupID"}">
						<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" style="margin-right: 4px; vertical-align:middle;border-style:none;" /></a><a href="{getHREF page="admins.php" actionName="RemoveAdminGroup" args="adminGroupID=$adminGroupID"}">Remove
					</a>
					{/strip}
				</td>
			</tr>
		{sectionelse}
			<tr>
				<td colspan="2">
						{$smarty.const.TRANS_NO_ADMIN_GROUPS_FOUND}
				</td>
			</tr>
		{/section}
		<tr>
			<td colspan="2">
				{include file="$tplDirectory/widgets/paginationLinks.tpl"}
			</td>
		</tr>
		</table>

	{* right column *}
	<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
	<tr class="listButtons">
		<td><div>
		<form method="post" action="admins.php">
		<input type="hidden" name="action" value="{getActionID action="AddAdminGroupResponse"}">
		<input type="hidden" name="sid" value="{$sid}">
		<input type="text" name="adminGroupName" value="">
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_GROUP}">
		</form>
		</div></td>
	</tr>
	</table>

{include file="$tplDirectory/footer.tpl"}