{* $Id: ShowAdmins.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of admin records.
 *
 * Smarty Variables:
 *	$admins (array of admins that match input criteria)
 *		adminID			A unique admin ID
 *		adminFirstName	An admin's first name
 *		adminLastName	An admin's last name
 *		adminEmail		An admin's email address
 *		adminUsername	An admin's username
 *		adminActive		The active state of an admin
 *	$actionID			The unique action ID for this page view
 *  $actionName			The action name for this action ID
 *	$imageDirectory		The image directory for this theme
 *	$tplDirectory		The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ADMIN_ID" d="Admin ID"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADMIN_GROUPS" d="Admin Groups"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_MANAGE_ADMINS" d="Manage Admins"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_ADMINS" d="Show Admins"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}
{t c="TRANS_SAVED_SUCCESSFULLY" d="Saved Successfully"}

{assign var="sortArgs" value="action=$actionID&adminActive=$adminActive&query=$query&queryColumn=$queryColumn&offset=$offset"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_ADMINS"
	childName="TRANS_SHOW_ADMINS"
	sideNavMajor="system"
	sideNavMinor="admins"}

{if $saved}
{include
	file="$tplDirectory/widgets/showInvalidCustom.tpl"
	duration="4"
	message=$smarty.const.TRANS_SAVED_SUCCESSFULLY}
{/if}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="7" style="cursor: pointer;" onclick="{strip} {section name=iter loop=$admins}
		XKtoggle('row_{$admins[iter].adminID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerClass="firstTD" headerName="TRANS_ID" sortColumn="adminID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_FIRST_NAME" sortColumn="adminFirstName"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_LAST_NAME" sortColumn="adminLastName"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_EMAIL" sortColumn="adminEmail"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_USERNAME" sortColumn="adminUsername"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" filterName="TRANS_STATUS" filterColumn="adminActive" filterOptions="$activeInactive"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerClass="lastTD" headerName="TRANS_ACTIONS"}
</tr>
</thead>
{section name=i loop=$admins}
{assign var="adminID" value=$admins[i].adminID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td class="" style="cursor: pointer;" onclick="return XKtoggle('row_{$admins[i].adminID}');">
        <img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
	    {$adminID}
	</td>
	<td>
		{$admins[i].adminFirstName}
	</td>
	<td>
		{$admins[i].adminLastName}
	</td>
	<td>
		{if $admins[i].adminEmail}{mailto address=$admins[i].adminEmail}{/if}
	</td>
	<td>
		{$admins[i].adminUsername}
	</td>
	<td>
		{$admins[i].adminActive|getArrayValueByID:$activeInactive}
	</td>
	<td>
		{strip}
		<a href="{getHREF page="admins.php" actionName="ShowAdminDetails" args="adminID=$adminID"}">
			<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		</a>
		&nbsp;
		<a href="{getHREF page="admins.php" actionName="EditAdmin" args="adminID=$adminID"}">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
		</a>
		&nbsp;
		<a href="{getHREF page="admins.php" actionName="RemoveAdmin" args="adminID=$adminID"}">
			<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
		</a>
		{/strip}
	</td>
</tr>
</tbody>
<tbody id="row_{$admins[i].adminID}" class="off">
<tr>
	<td colspan="13" class="comments altinner">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$adminID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;
		<b>{$smarty.const.TRANS_ADMIN_ID}: {$adminID} ({$smarty.const.TRANS_ADDITIONAL_INFORMATION})</b>
		{/strip}
		<br clear="all" />
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
        <tr>
			<td>
				<strong>{$smarty.const.TRANS_ASSIGNED_ADMIN_GROUPS}:</strong>&nbsp;
		        {assign var="adminGroups" value=$admins[i].adminGroupIDs}
		        {section name=j loop=$adminGroups}
		            {assign var="adminGroupID" value=$adminGroups[j].adminGroupID}
		            <a href="{getHREF page="admins.php" actionName="ShowAdminGroupDetails" args="adminGroupID=$adminGroupID"}">{$adminGroups[j].adminGroupName}</a>&nbsp;
		        {sectionelse}
		            {$smarty.const.TRANS_NORESULTS}&nbsp;
		        {/section}
			</td>
		</tr>
		</table>
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="13">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
