{* $Id: CloneBookmark.tpl 8004 2006-07-10 16:10:11Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to edit a bookmark. Using the given smarty variable 
 * $bookmark, the form is prepopulated with the bookmark's current information. The 
 * form should post to bookmarks.php, with the action ID for the CloneBookmarkResponse action.
 *
 * Smarty Variables:
 *	$bookmark  An array of this bookmark data. Every element in this array can be considered
 *			   to be one bookmark, and as such, every element is an array. Every bookmark
 *			   has the following keys:
 *				bookmarkID  -- The ID of the bookmark.
 *				bookmarkURL  -- The full URL of the bookmark including any GET variables.
 *				bookmarkTarget -- Whether to open the bookmark in a new window or not.
 *				bookmarkWindowWidth -- If the bookmark opens in a new window, the width of that window
 *				bookmarkWindowHeight -- If the bookmark opens in a new window, the height of that window
 *				bookmarkCount -- The number of times that a bookmark has been clicked on. This can also
 *								 be set arbitrarily to "arrange" the display order. Default sort column.
 *  $targets	Array of targets for the bookmark to be launched in.
 *}
{strip}
{t c="TRANS_MANAGE_BOOKMARKS" d="Manage Bookmarks"}
{t c="TRANS_CLONE" d="Clone"}
{t c="TRANS_CLONE_BOOKMARK" d="Close bookmark"}
{t c="TRANS_CLONE_TO_ADMIN" d="Clone to selected admin"}
{/strip}
{include
	file="$tplDirectory/header.tpl"

	parentName="TRANS_MANAGE_ADMINS"
	childName="TRANS_MANAGE_BOOKMARKS"
	grandchildName="TRANS_CLONE"

	sideNavMajor="system"}
<form method="post" action="bookmarks.php">
<input type="hidden" name="action" value="{getActionID action="CloneBookmarkResponse"}" />
<input type="hidden" name="bookmarkID" value="{$bookmark.bookmarkID}" />
<input type="hidden" name="sid" value="{$sid}" />

<table cellpadding="0" cellspacing="0" border="0" width="100%" class="list">
<tr>
	<td class="title">{$smarty.const.TRANS_CLONE_BOOKMARK}:</td>
	<td>
		{strip}
		<a href="{getHREF page=$bookmark.bookmarkURL actionName=$bookmark.bookmarkAction args=$bookmark.bookmarkArgs}" target="_blank">
			<strong>{$bookmark.bookmarkName}</strong>
		</a>
		{/strip}
	</td>
</tr>
<tr>	
	<td class="title">{$smarty.const.TRANS_CLONE_TO_ADMIN}:</td>
	<td>
		<select name="adminID">
			{html_options options=$admins}
		</select>
	</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div>
		<input type="submit" class="submit" value="{$smarty.const.TRANS_CLONE}" />
	</div></td>
</tr>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}