{* $Id: RemoveBookmark.tpl 8004 2006-07-10 16:10:11Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to add a new bookmark. The form must post to bookmarks.php, 
 * with the action ID for the RemoveBookmarkResponse action, so that the POST data can
 * be handled by the server. This template takes the $targets smarty variables, used to display
 * the options for where the bookmark will display once clicked - a new window, or the current one.
 *
 * Smarty Variables:
 *	$targets	Array of targets for the bookmark to be launched in.
 *}
{strip}
{t c="TRANS_MANAGE_BOOKMARKS" d="Manage Bookmarks"}
{t c="TRANS_LINK" d="Link"}
{t c="TRANS_OPENING_METHOD" d="Opening Method"}
{t c="TRANS_LOAD_BOOKMARK_MAIN_PAGE" d="Load Bookmark in main page"}
{t c="TRANS_LOAD_BOOKMARK_NEW_PAGE" d="Load Bookmark in new page"}
{t c="TRANS_REMOVE_BOOKMARK_MESG" d="Are you sure you want to remove this bookmark?"}
{/strip}
{include
	file="$tplDirectory/header.tpl"
	
	parentName="TRANS_MANAGE_ADMINS"
	childName="TRANS_MANAGE_BOOKMARKS"
	grandchildName="TRANS_REMOVE"

	sideNavMajor="system"}

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_LINK"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_OPENING_METHOD"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ADMIN"}
</tr>
</thead>
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td>
		<a href="{getHREF page=$bookmark.bookmarkURL actionName=$bookmark.bookmarkAction args=$bookmark.bookmarkArgs}" target="_blank">
			{$bookmark.bookmarkName}
		</a>
	</td>
	<td>
		{assign var=transValue value=$bookmark.bookmarkTarget}
		{if $smarty.const.$transValue}
			{$smarty.const.$transValue}
		{else}
			{$transValue}
		{/if}
	</td>
	<td>{$bookmark.admin.adminUsername} - {$bookmark.admin.adminFirstName} {$bookmark.admin.adminLastName}</td>
</tr>
</tbody>
</table>
<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>
<tr>
	<td colspan="2">{$smarty.const.TRANS_REMOVE_BOOKMARK_MESG}</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div>
		<form method="post" action="bookmarks.php" style="display:inline">
		<input type="hidden" name="action" value="{getActionID action="RemoveBookmarkResponse"}" />
		<input type="hidden" name="bookmarkID" value="{$bookmark.bookmarkID}" />
		<input type="hidden" name="sid" value="{$sid}" />

		<input type="hidden" name="redirectURL" value="admins.php" />
		<input type="hidden" name="redirectAction" value="ShowAdminDetails" />
		<input type="hidden" name="redirectArgs" value="adminID={$bookmark.adminID}" />
		
		<input type="submit" class="submit" value="{$smarty.const.TRANS_REMOVE}" />
		</form>
		<form method="get" action="admins.php" style="display:inline">
		<input type="hidden" name="action" value="{getActionID action="ShowAdminDetails"}" />
		<input type="hidden" name="adminID" value="{$bookmark.adminID}" />
		<input type="hidden" name="sid" value="{$sid}" />

		<input type="submit" class="submit" value="{$smarty.const.TRANS_CANCEL}" />
		</form>
	</div></td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}