{* $Id: AddClient.tpl 12059 2007-10-09 20:46:01Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to add a new client.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTID" d="Client ID"}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EDIT_CLIENT" d="Edit Client"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_BILLING_METHOD" d="Billing Method"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_NEW_PASSWORD" d="New Password"}
{t c="TRANS_CONFIRM_PASSWORD" d="Confirm Password"}
{t c="TRANS_PASSWORD_MSG" d="Leave blank to keep old password."}
{t c="TRANS_TAX_ID_NUMBER" d="Tax ID Number"}
{t c="TRANS_APPLY" d="Apply"}
{t c="TRANS_TAX" d="Tax"}
{t c="TRANS_ACCOUNT" d="Account"}
{t c="TRANS_PERSONAL" d="Personal"}
{t c="TRANS_BILLING" d="Billing"}
{t c="TRANS_RESET" d="Reset"}
{t c="TRANS_LANGUAGE" d="Language"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_THEME" d="Theme"}
{t c="TRANS_BILLING_DAY_OF_MONTH" d="Monthly Billing Day"}
{t c="TRANS_BILLING_DAY_EXPLAINED" d="This only applies if you bill in monthly mode rather than anniversary."}
{t c="TRANS_STATUS_CHANGE_REASON" d="Status Change Reason"}
{t c="TRANS_COMPANY_NAME" d="Company Name"}
{t c="TRANS_BILLING_AND_TAX_SETTINGS" d="Billing and Tax Settings"}

{t c="TRANS_RECORD_IS_ACTIVE" d="Record Is Active"}
{t c="TRANS_DEFAULT_THEME" d="Default Theme"}
{t c="TRANS_CURRENT_STATUS" d="Current Status"}
{t c="TRANS_IS_TAXABLE" d="Is Taxable"}
{t c="TRANS_IS_ARCHIVED" d="Is Archived"}
{t c="TRANS_BILLING_COUNTRY" d="Billing Country"}
{t c="TRANS_DEFAULT_BILLING_ACCOUNT" d="Default Billing Account"}
{t c="TRANS_CURRENT_STATUS_CHANGING" d="Only active accounts can be billed."}
{t c="TRANS_OBEY_SYSTEMWIDE_SETTINGS" d="Obey system wide settings."}
{t c="TRANS_CLIENT_GROUP" d="Client Group"}
{t c="TRANS_LOADING_PLEASE_WAIT" d="Loading, Please Wait"}
{t c="TRANS_SAVE_AND_ADD_PRIMARY_CONTACT" d="Save and add primary contact"}
{t c="TRANS_MAIL_INVOICES" d="Mail Invoices"}
{t c="TRANS_YOUR_LICENSE_ONLY_ALLOWS" d="Your license only allows"}
{t c="TRANS_ACTIVE_CLIENT_SLOTS" d="active client slots and you have no more available."}
{t c="TRANS_EITHER_PURCHASE_A_LARGER_CAPACITY_LICENSE_OR_REMOVE_OR_ARCHIVE_SOME_OLD_CLIENTS" d="Either purchase a larger capacity license or remove or archive some old clients."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CLIENTS"
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{if $smarty.const.numClientsRemaining<1}

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
	<tr class="highlight">
		<td>{$smarty.const.TRANS_YOUR_LICENSE_ONLY_ALLOWS} <strong>{$smarty.const.numClients}</strong> {$smarty.const.TRANS_ACTIVE_CLIENT_SLOTS}<br />
			{$smarty.const.TRANS_EITHER_PURCHASE_A_LARGER_CAPACITY_LICENSE_OR_REMOVE_OR_ARCHIVE_SOME_OLD_CLIENTS}
		</td>
	</tr>
</table>

{else}

<form method="post" action="clients.php" onsubmit="$('sub').disabled=true;$('sub').value='{$smarty.const.TRANS_LOADING_PLEASE_WAIT}...';">
<input type="hidden" name="action" value="{getActionID action="AddClientResponse"}" />
<input type="hidden" name="nextAction" value="AddClientContact" />
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="clientActive" value="1" />

<fieldset>
<legend>{$smarty.const.TRANS_CLIENT_DETAILS}</legend>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">

{********* TRANS_CLIENT_DETAILS *********}
<tr {if $invalid.clientCompany}class="highlight"{/if}>
	<td class="title"><label for="clientCompany">{$smarty.const.TRANS_COMPANY_NAME}</label>:</td>
	<td><input style="width:200px;" maxlength="100" type="text" id="clientCompany" name="clientCompany" value="{$formValues.clientCompany}" /> {$invalid.clientCompany}</td>
</tr>
<tr {if $invalid.themeID}class="highlight"{/if}>
	<td class="title"><label for="themeID">{$smarty.const.TRANS_DEFAULT_THEME}</label>:</td>
	<td><select style="width:200px;" id="themeID" name="themeID"> {html_options options=$themeList selected=$formValues.themeID} </select> {$invalid.themeID}</td>
</tr>
<tr {if $invalid.themeID}class="highlight"{/if}>
	<td class="title"><label for="themeID">{$smarty.const.TRANS_CLIENT_GROUP}</label>:</td>
	<td>
		<select style="width:200px;" id="groupID" name="groupID">
	 		<option value="0">{$smarty.const.TRANS_NONE}</option>
	 		{html_options options=$attributeGroups selected=$formValues.groupID}
		</select>
		&nbsp;
		[{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="ShowAttributeGroups"
			args="groupID=`$formValues.groupID`"
			altText="TRANS_MANAGE"
			linkText="TRANS_MANAGE"}]
	</td>
</tr>

{********* TRANS_CLIENT_STATUS *********}
<tr class="headerRow">
	<td colspan="2">{$smarty.const.TRANS_CLIENT_STATUS}</td>
</tr>
<tr {if $invalid.clientStatus}class="highlight"{/if}>
	<td class="title"><label for="clientStatus">{$smarty.const.TRANS_CURRENT_STATUS}</label>:</td>
	<td>
		<select style="width:200px;" id="clientStatus" id="clientStatus" name="clientStatus"> 
			{html_options options=$statusList selected=$formValues.clientStatus}
		</select> 
		{$smarty.const.TRANS_CURRENT_STATUS_CHANGING}
	</td>
</tr>

{********* TRANS_CLIENT_STATUS *********}
<tr class="headerRow">
	<td colspan="2">{$smarty.const.TRANS_BILLING_AND_TAX_SETTINGS}</td>
</tr>
<tr {if $invalid.clientBillingDay}class="highlight"{/if}>
	<td class="title"><label for="clientBillingDay">{$smarty.const.TRANS_BILLING_DAY_OF_MONTH}</label>:</td>
	<td><select style="width:200px;" id="clientBillingDay" name="clientBillingDay">
		<option value="0" selected="selected">{$smarty.const.TRANS_OBEY_SYSTEMWIDE_SETTINGS}</option>
		<option value="1">1</option>
		<option value="2">2</option>
		<option value="3">3</option>
		<option value="4">4</option>
		<option value="5">5</option>
		<option value="6">6</option>
		<option value="7">7</option>
		<option value="8">8</option>
		<option value="9">9</option>
		<option value="10">10</option>
		<option value="11">11</option>
		<option value="12">12</option>
		<option value="13">13</option>
		<option value="14">14</option>
		<option value="15">15</option>
		<option value="16">16</option>
		<option value="17">17</option>
		<option value="18">18</option>
		<option value="19">19</option>
		<option value="20">20</option>
		<option value="21">21</option>
		<option value="22">22</option>
		<option value="23">23</option>
		<option value="24">24</option>
		<option value="25">25</option>
		<option value="26">26</option>
		<option value="27">27</option>
		<option value="28">28</option>
	</select> {$smarty.const.TRANS_BILLING_DAY_EXPLAINED} {$invalid.clientBillingDay}</td>
</tr>
<tr {if $invalid.countriesID}class="highlight"{/if}>
	<td class="title"><label for="countriesID">{$smarty.const.TRANS_BILLING_COUNTRY}</label>:</td>
	<td><select style="width:200px;" id="countriesID" id="countriesID" name="countriesID"> {html_options options=$countryList selected=$formValues.countriesID} </select> {$invalid.countriesID}</td>
</tr>

{* <tr class="{cycle values="alt1,alt2"}">
	<td class="title"><label for="applyTax">{$smarty.const.TRANS_MAIL_INVOICES}</label>:</td>
	<td>
		<input type="radio" name="clientMailInvoices" value="1" /> 
		{$smarty.const.TRANS_YES}
		&nbsp;
		<input type="radio" name="clientMailInvoices" value="0" checked="checked" /> 
		{$smarty.const.TRANS_NO}
	</td>
</tr> *}
<tr {if $invalid.applyTax}class="highlight"{/if}>
	<td class="title"><label for="applyTax">{$smarty.const.TRANS_IS_TAXABLE}</label>:</td>
	<td>
		<input type="radio" name="applyTax" value="1" {if $formValues.applyTax=="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_YES}
		&nbsp;
		<input type="radio" name="applyTax" value="0" {if $formValues.applyTax!="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_NO}
	</td>
</tr>
<tr {if $invalid.taxIDNumber}class="highlight"{/if}>
	<td class="title"><label for="taxIDNumber">{$smarty.const.TRANS_TAX_ID_NUMBER}</label>:</td>
	<td><input style="width:200px;" maxlength="50" id="taxIDNumber" type="text" name="taxIDNumber" value="{$formValues.taxIDNumber}" /> {$invalid.taxIDNumber}</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div>
		<input class="submit" type="submit" id="sub" value="{$smarty.const.TRANS_SAVE_AND_ADD_PRIMARY_CONTACT}" />
	</div></td>
</tr>
</table>

</fieldset>

</form>

<br />

{/if}

{include file="$tplDirectory/footer.tpl"}
