{* $Id: EditClientArchiveState.tpl 9367 2006-10-09 20:32:39Z mfountain $
 * --------------------------------------------------------------
 * This template displays a form to edit an existing client.
 *
 * Smarty Variables:
 *	$formValues (array of this clients data)
 *		clientID			A unique client ID
 *		clientFirstName		A client's first name
 *		clientLastName		A client's last name
 *		clientEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{t c="TRANS_IS_ARCHIVED" d="Is Archived"}
{t c="TRANS_EDIT_CLIENT_ARCHIVE_SETTINGS" d="Edit Client Archive Settings"}
{t c="TRANS_WARNING_ACTIVE_PACKAGES" d="Warning: This client has active packages that will not be billed if this record is archived."}
{t c="TRANS_NOTICE_ACTIVE_PACKAGES" d="Notice: A record that is archived is suppressed and no longer billable. The accounting history will still be used for reports."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CLIENTS"
	grandchildName="TRANS_EDIT"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form method="post" action="clients.php">
<input type="hidden" name="action" value="{getActionID action="EditClientArchiveStateResponse"}">
<input type="hidden" name="clientID" value="{$client.clientID}">
<input type="hidden" name="sid" value="{$sid}">

<fieldset>
<legend>{$smarty.const.TRANS_EDIT_CLIENT_ARCHIVE_SETTINGS}</legend>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">

{********* TRANS_CLIENT_DETAILS *********}
<tr {if $invalid.clientActive}class="highlight"{/if}>
	<td colspan="2">
		{if $numActivePackages}
			<strong style="color:red;">
			{$smarty.const.TRANS_WARNING_ACTIVE_PACKAGES}
			</strong>
		{else}
			<strong style="color:#444444;">
			{$smarty.const.TRANS_NOTICE_ACTIVE_PACKAGES}
			</strong>
		{/if}
	</td>
</tr>
<tr {if $invalid.clientActive}class="highlight"{/if}>
	<td class="title"><label for="clientActive">{$smarty.const.TRANS_IS_ARCHIVED}</label>:</td>
	<td>
		<input type="radio" name="clientActive" value="0" {if $client.clientActive!="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_YES}
		<br />
		<input type="radio" name="clientActive" value="1" {if $client.clientActive=="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_NO}
	</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div>
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_SAVE}" />
		&nbsp;
		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" />
	</div></td>
</tr>
</table>

</fieldset>

</form>

<br />

{include file="$tplDirectory/footer.tpl"}
