{* $Id: EditClientContact.tpl 11361 2007-06-15 15:09:11Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to add a new client contact.
 *
 * Smarty Variables:
 * $formValues				Array of default form values
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}{strip}
{t c="TRANS_EMAIL_FORMAT" d="Email Format"}
{t c="TRANS_HTML" d="HTML"}
{t c="TRANS_IS_PRIMARY" d="Set another contact as primary to remove this designation"}
{t c="TRANS_REFUSE_DELETE_PRIMARY_CONTACT" d="Primary contact cannot be removed."}
{t c="TRANS_RESET_PASSWORD" d="Reset Password"}
{t c="TRANS_CONTACT_INFORMATION" d="Contact Information"}
{t c="TRANS_LOGIN_INFORMATION" d="Login Information"}
{t c="TRANS_EMAIL_PREFERENCES" d="Email Preferences"}
{t c="TRANS_CONTACT_IS_PRIMARY" d="Contact Is Primary"}
{t c="TRANS_CONTACT_IS_ACTIVE" d="Contact Is Active"}
{t c="TRANS_PLAIN_TEXT" d="Plain Text"}
{t c="TRANS_PASSWORD_NOTIFICATIONS" d="Password Notification Emails"}
{t c="TRANS_USER_DEFINED_EMAILS" d="User Defined Emails"}
{t c="TRANS_GENERATE_AND_RESEND_PASSWORD" d="Generate and Resend Password"}

{t c="TRANS_SECRET_QUESTIONS" d="Secret Questions"}

{t c="TRANS_SECRET_QUESTION_1" d="What city were you born in?"}
{t c="TRANS_SECRET_QUESTION_2" d="What is your mothers maiden name?"}
{t c="TRANS_SECRET_QUESTION_3" d="What is your favorite pet's name?"}
{t c="TRANS_SECRET_QUESTION_4" d="What grade school did you go to?"}
{t c="TRANS_SECRET_QUESTION_5" d="What is the first vehicle you owned?"}
{t c="TRANS_SECRET_QUESTION_6" d="Squipity doo!"}
{t c="TRANS_COUNTY" d="County"}
{t c="TRANS_MOBILE_PHONE" d="Mobile Phone"}
{t c="TRANS_TOGGLE" d="Toggle All"}

{/strip}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CONTACTS"
	grandchildName="TRANS_EDIT"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

{if $formValues.contactPrimary}
	{assign var="suppressDeleteLink" value=1}
{else}
	{assign var="suppressDeleteLink" value=0}
{/if}

{include file="$tplDirectory/widgets/context/contact.tpl" 
	client=$client contact=$contact suppressEditLink=1 suppressDeleteLink=$suppressDeleteLink}

<script language="javascript">
<!--
{literal}
function updateCountyList(){
	var state = $('contactState').value;
	if (state.length!=2){
		turnOffCounty();
		return;
	}
	var myAjax = new Ajax.Request(
		'../lib-modernbill/getstatecounties.php?state='+state,
		{
			method: 'get',
			onComplete: handleCountiesUpdate
		});
}

function handleCountiesUpdate(res){
	res = XKgetJSONArray(res.responseText);
	if (typeof res=="undefined"){
		turnOffCounty();
		return;
	}
	
	var fd = $('contactCounty');
	fd.options.length = 0;
	toggleOn('countyTB');
	
	for (x in res){
		fd.options[x] = new Option(res[x], res[x]);
	}
}

function turnOffCounty(){
	$('contactCounty').options.length = 0;
	$('contactCounty').options[0] = new Option('', '');
	toggleOff('countyTB');
}

{/literal}
// -->
</script>


<form name="editClientContact" id="editClientContactForm" method="post" action="clients.php">
<input type="hidden" name="action" value="{getActionID action="EditClientContactResponse"}">
<input type="hidden" name="clientContactID" value="{$formValues.clientContactID}">
<input type="hidden" name="sid" value="{$sid}">

<fieldset>
<legend>{$smarty.const.TRANS_CONTACT_DETAILS}</legend>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">

{********* TRANS_CONTACT_DETAILS *********}
{if $smarty.request.fd == 1}
	<tr class="highlight">
		<td colspan="2">{$smarty.const.TRANS_REFUSE_DELETE_PRIMARY_CONTACT}</td>
	</tr>
{/if}
<tr>
	<td class="title"><label for="clientContactID">{$smarty.const.TRANS_CLIENT_CONTACTID}</label>:</td>
	<td>{$formValues.clientContactID}</td>
</tr>
<tr {if $invalid.contactPrimary}class="highlight"{/if}>
	<td class="title"><label for="contactPrimary">{$smarty.const.TRANS_CONTACT_IS_PRIMARY}</label>:</td>
	<td>
		{* The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. *}

		{if $formValues.contactPrimary}
			<input type="hidden" name="contactPrimary" value="1">
			{if $invalid}{assign var="isinvalid" value="1"}{else}{assign var="isinvalid" value="0"}{/if}
			<input type="checkbox" id="contactPrimary" name="contactPrimary" value="1" {if $formValues.contactPrimary}checked="checked" disabled{/if}/> <label for="contactPrimary">{$smarty.const.TRANS_IS_PRIMARY}</label>
			{$invalid.contactPrimary}
		{else}
			<input type="hidden" name="contactPrimary" value="0">
			{if $invalid}{assign var="isinvalid" value="1"}{else}{assign var="isinvalid" value="0"}{/if}
			<input type="checkbox" id="contactPrimary" name="contactPrimary" value="1" {if $formValues.contactPrimary}checked="checked" {/if}/> <label for="contactPrimary">{$smarty.const.TRANS_SET_PRIMARY}</label>
			{$invalid.contactPrimary}
		{/if}

	</td>
</tr>
<tr {if $invalid.contactActive}class="highlight"{/if}>
	<td class="title"><label for="clientActive">{$smarty.const.TRANS_CONTACT_IS_ACTIVE}</label>:</td>
	<td>
		<input type="radio" name="contactActive" value="1" {if $formValues.contactActive=="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_YES}
		&nbsp;
		<input type="radio" name="contactActive" value="0" {if $formValues.contactActive!="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_NO}
	</td>
</tr>

{********* TRANS_CONTACT_INFORMATION *********}
<tr>
	<td colspan="2" class="headerRow">{$smarty.const.TRANS_CONTACT_INFORMATION}</td>
</tr>
<tr {if $invalid.contactCompany}class="highlight"{/if}>
	<td class="title"><label for="contactCompany">{$smarty.const.TRANS_COMPANY}</label>:</td>
	<td><input size="100" maxlength="100" type="text" style="width:200px;" id="contactCompany" name="contactCompany" value="{$formValues.contactCompany}" /> {$invalid.contactCompany}</td>
</tr>
<tr {if $invalid.contactFirstName}class="highlight"{/if}>
	<td class="title"><label for="contactFirstName">{$smarty.const.TRANS_FIRST_NAME}</label>:</td>
	<td><input size="50" maxlength="50" type="text" style="width:200px;" id="contactFirstName" name="contactFirstName" value="{$formValues.contactFirstName}" /> {$invalid.contactFirstName}</td>
</tr>
<tr {if $invalid.contactLastName}class="highlight"{/if}>
	<td class="title"><label for="contactLastName">{$smarty.const.TRANS_LAST_NAME}</label>:</td>
	<td><input size="50" maxlength="50" type="text" style="width:200px;" id="contactLastName" name="contactLastName" value="{$formValues.contactLastName}" /> {$invalid.contactLastName}</td>
</tr>
<tr {if $invalid.contactEmail}class="highlight"{/if}>
	<td class="title"><label for="contactEmail">{$smarty.const.TRANS_EMAIL}</label>:</td>
	<td><input size="100" maxlength="100" type="text" style="width:200px;" id="contactEmail" name="contactEmail" value="{$formValues.contactEmail}" /> {$invalid.contactEmail}</td>
</tr>
<tr {if $invalid.contactAddress1}class="highlight"{/if}>
	<td class="title"><label for="contactAddress1">{$smarty.const.TRANS_ADDRESS}</label>:</td>
	<td><input size="100" maxlength="100" type="text" style="width:200px;" id="contactAddress1" name="contactAddress1" value="{$formValues.contactAddress1}" /> {$invalid.contactAddress1}</td>
</tr>
<tr {if $invalid.contactAddress2}class="highlight"{/if}>
	<td class="title"><label for="contactAddress2">{$smarty.const.TRANS_ADDRESS2}</label>:</td>
	<td><input size="100" maxlength="100" type="text" style="width:200px;" id="contactAddress2" name="contactAddress2" value="{$formValues.contactAddress2}" /> {$invalid.contactAddress2}</td>
</tr>
<tr {if $invalid.contactCity}class="highlight"{/if}>
	<td class="title"><label for="contactCity">{$smarty.const.TRANS_CITY}</label>:</td>
	<td><input size="100" maxlength="100" type="text" style="width:200px;" id="contactCity" name="contactCity" value="{$formValues.contactCity}" /> {$invalid.contactCity}</td>
</tr>
<tr {if $invalid.contactState}class="highlight"{/if}>
	<td class="title"><label for="contactState">{$smarty.const.TRANS_STATE}</label>:</td>
	<td><input size="25" maxlength="100" type="text" style="width:200px;" id="contactState" name="contactState" value="{$formValues.contactState}" onchange="updateCountyList();" /> {$invalid.contactState}</td>
</tr>
<tbody id="countyTB" {if $formValues.contactCounty}on{else}off{/if}">
<tr {if $invalid.contactState}class="highlight"{/if}>
	<td class="title"><label for="contactCounty">{$smarty.const.TRANS_COUNTY}</label>:</td>
	<td><select id="contactCounty" name="contactCounty">
		<option value="{$formValues.contactCounty}">{$formValues.contactCounty}</option>
	</select></td>
</tr>
</tbody>
<tr {if $invalid.contactZip}class="highlight"{/if}>
	<td class="title"><label for="contactZip">{$smarty.const.TRANS_ZIP}</label>:</td>
	<td><input size="25" maxlength="100" type="text" style="width:200px;" id="contactZip" name="contactZip" value="{$formValues.contactZip}" /> {$invalid.contactZip}</td>
</tr>
<tr {if $invalid.countriesID}class="highlight"{/if}>
	<td class="title"><label for="countriesID">{$smarty.const.TRANS_COUNTRY}</label>:</td>
	<td><select style="width:200px;" id="countriesID" id="countriesID" name="countriesID"> {html_options options=$countryList selected=$formValues.countriesID} </select> {$invalid.countriesID}</td>
</tr>
<tr {if $invalid.contactPhone1}class="highlight"{/if}>
	<td class="title"><label for="contactPhone1">{$smarty.const.TRANS_PRIMARY_PHONE}</label>:</td>
	<td><input size="25" maxlength="25" type="text" style="width:200px;" id="contactPhone1" name="contactPhone1" value="{$formValues.contactPhone1}" /> {$invalid.contactPhone1}</td>
</tr>
<tr {if $invalid.contactPhone2}class="highlight"{/if}>
	<td class="title"><label for="contactPhone2">{$smarty.const.TRANS_SECONDARY_PHONE}</label>:</td>
	<td><input size="25" maxlength="25" type="text" style="width:200px;" id="contactPhone2" name="contactPhone2" value="{$formValues.contactPhone2}" /> {$invalid.contactPhone2}</td>
</tr>
<tr {if $invalid.contactFax}class="highlight"{/if}>
	<td class="title"><label for="contactFax">{$smarty.const.TRANS_FAX}</label>:</td>
	<td><input size="25" maxlength="25" type="text" style="width:200px;" id="contactFax" name="contactFax" value="{$formValues.contactFax}" /> {$invalid.contactFax}</td>
</tr>
<tr {if $invalid.contactFax}class="highlight"{/if}>
	<td class="title"><label for="contactMobilePhone">{$smarty.const.TRANS_MOBILE_PHONE}</label>:</td>
	<td><input size="25" maxlength="25" type="text" style="width:200px;" id="contactMobilePhone" name="contactMobilePhone" value="{$formValues.contactMobilePhone}" /> {$invalid.contactMobilePhone}</td>
</tr>

{if $contactExternalFields}
	{include
		file="$tplDirectory/widgets/forms/autoEditForm.tpl"
		inTable="yes"
		inForm="yes"
		fields=$contactExternalFields.fields}
{/if}

{********* TRANS_LOGIN_INFORMATION *********}
<tr>
	<td colspan="2" class="headerRow">{$smarty.const.TRANS_LOGIN_INFORMATION}</td>
</tr>
<tr {if $invalid.contactUsername}class="highlight"{/if}>
	<td class="title"><label for="contactUsername">{$smarty.const.TRANS_USERNAME}</label>:</td>
	<td><input autocomplete="no" size="20" maxlength="20" type="text" style="width:200px;" id="contactUsername" name="contactUsername" value="{$formValues.contactUsername}" /> {$invalid.contactUsername}</td>
</tr>

<tr {if $invalid.contactPassword}class="highlight"{/if}>
	<td class="title"><label for="contactPassword">{$smarty.const.TRANS_NEW_PASSWORD}</label>:</td>
	<td>
		<input size="32" autocomplete="no" maxlength="32" type="password" style="width:200px;" id="contactPassword" name="contactPassword" value="" /> {$invalid.contactPassword}
		{if $formValues.contactActive}
			<strong>
			<a href="{getHREF page="clients.php" actionName="ResetContactPassword" args="clientContactID=`$formValues.clientContactID`"}">
				{$smarty.const.TRANS_GENERATE_AND_RESEND_PASSWORD}
			</a>
			</strong>
		{/if}
	</td>
</tr>
<tr {if $invalid.contactPasswordConfirm}class="highlight"{/if}>
	<td class="title"><label for="contactPasswordConfirm">{$smarty.const.TRANS_CONFIRM_PASSWORD}</label>:</td>
	<td><input size="32" autocomplete="no" maxlength="32" type="password" style="width:200px;" id="contactPasswordConfirm" name="contactPasswordConfirm" value="" /> {$invalid.contactPasswordConfirm}</td>
</tr>

{********* TRANS_SECRET_QUESTIONS **********
<script language="javascript" type="text/javascript">
//<[[CDATA][
{literal}
function XKinArray( needle, haystack ) {
        try {
                for( i=0, n=haystack.length; i<n; i++ ) {
                        if (haystack[ i ]==needle) {
                                return true;
                        }
                }
                
        } catch (e) {
                // do nothing
        }
        return false;
}

function XKthereCanBeOnlyOne() {
	var trail = new Array(3);
	var theDiv;
	try {
		for( var i=0; i<=3; i++ ) {
			theDiv = eval("document.editClientContact.secretQuestion_"+i );
			if (theDiv) {
				var val = theDiv.options[ theDiv.selectedIndex ].value;
				if (!val || val==0)	continue;
				
				if (XKinArray( val, trail)) {
					
					return false;
				}
				
				trail[ i ] = val;
			}
		}
	} catch (e) {
		alert(e.lineNumber+' '+e.name+' '+e.type+' '+e.message);
		// do nothing
	}

	return true;
}
{/literal}
//]]>
</script>
<tr>
	<td colspan="2" class="headerRow">{$smarty.const.TRANS_SECRET_QUESTIONS}</td>
</tr>
{section name=foo loop=3 start=0}
	<tr>
		<td class="title">
			{assign var=index value=$smarty.section.foo.index}
			<select name="secretQuestion[]">
			{if $contactAnswers.$index}
				{html_options options=$secretQuestions selected=$contactAnswers.$index.questionType}
			{else}
				{html_options options=$secretQuestions}
			{/if}
			</select>
		</td>
		<td>
			<input type="text" name="secretAnswer[]" value="{if $contactAnswers.$index}{$contactAnswers.$index.secretAnswer}{/if}" />
		</td>
	</tr>
{/section}
{**}
{********* TRANS_EMAIL_PREFERENCES *********}
<tr>
	<td colspan="2" class="headerRow">{$smarty.const.TRANS_EMAIL_PREFERENCES}</td>
</tr>
<tr {if $invalid.countriesID}class="highlight"{/if}>
	<td class="title"><label for="languageID">{$smarty.const.TRANS_LANGUAGE}</label>:</td>
	<td><select style="width:200px;" id="languageID" id="languageID" name="languageID"> {html_options options=$languageList selected=$formValues.languageID} </select> {$invalid.languageID}</td>
</tr>
<tr {if $invalid.contactEmailFormat}class="highlight"{/if}>
	<td class="title"><label for="contactEmailFormat">{$smarty.const.TRANS_EMAIL_FORMAT}</label>:</td>
	<td>
		<input type="radio" name="contactEmailFormat" value="1" {if $formValues.contactEmailFormat=="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_HTML}
		&nbsp;
		<input type="radio" name="contactEmailFormat" value="0" {if $formValues.contactEmailFormat!="1"}checked="checked"{/if} /> 
		{$smarty.const.TRANS_PLAIN_TEXT}
	</td>
</tr>
<tr>
	<td class="title"><label for="emailActions">{$smarty.const.TRANS_EMAIL_ACTIONS}</label>:</td>
	<td>
		<a href="javascript:XKtoggleFormCheckboxes($('editClientContactForm'), 'emailActionIDs');">[{$smarty.const.TRANS_TOGGLE}]</a><br />
		{html_checkboxes name="emailActionIDs" options=$emailActions selected=$contact.emailActionIDs separator="<br />"}
	</td>
</tr>

<tr class="listButtons">
	<td colspan="2"><div>
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_SAVE}" />
		&nbsp;
		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" />
	</div></td>
</tr>

</table>

</fieldset> {* box07 *}

</form>

<br />

{include file="$tplDirectory/footer.tpl"}
