{* $Id: ManageClientNotes.tpl 9620 2006-10-17 02:47:38Z mfountain $
 * --------------------------------------------------------------
 * This template displays a form to add a new client contact.
 *
 * Smarty Variables:
clientNoteID => 1
adminID => 1
clientNoteDateCreated => 1161047180
clientNoteDateModified => 0
clientNoteText => testing notes
adminUsername => root
adminFirstName => Michael
adminLastName => Fountain
adminEmail => michael@modernbill.com
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_NOTES" d="Notes"}
{t c="TRANS_NOTE_MESG" d="Note message"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_ADD" d="Add"}
{t c="TRANS_ADD_NOTE" d="Add Note"}
{t c="TRANS_RESET" d="Reset"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_CLIENT" d="Client"}
{t c="TRANS_CLIENTID" d="Client ID"}
{t c="TRANS_CLIENT_USERNAME" d="Client Username"}
{t c="TRANS_CLIENT_FIRSTNAME" d="Client First Name"}
{t c="TRANS_CLIENT_LASTNAME" d="Client Last Name"}
{t c="TRANS_CLIENT_CONTACTID" d="Client Contact ID"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EDIT_NOTE" d="Edit Note"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_MODIFIED" d="Modified"}
{t c="TRANS_DELETE_MESG" d="Are you sure you want to delete this note?"}

{assign var="clientID" value=$client.clientID}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_NOTES"
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

<fieldset>
	<legend>{$smarty.const.TRANS_NOTES}</legend>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
{section name="j" loop=$noteList}
	{assign var="note" value=$noteList[j]}
	{assign var="clientNoteID" value=$note.clientNoteID}
	<tr {if $editNote && $editNote.clientNoteID == $clientNoteID && $invalid.clientNoteText}class="highlight"{/if}>
		<td>
			{$note.adminFirstName} {$note.adminLastName} 
			&raquo;
			{$note.clientNoteDateCreated|getDateTime:full}
			
			{if $note.clientNoteDateModified}
				&raquo;
				{$smarty.const.TRANS_MODIFIED}: {$note.clientNoteDateModified|getDateTime:full}
			{/if}

			<br />
			<blockquote>

			{if $editNote && $editNote.clientNoteID == $clientNoteID}
			<form method="post" action="clients.php">
				<input type="hidden" name="action" value="{getActionID action="ManageClientNotesResponse"}" />
				<input type="hidden" name="clientID" value="{$clientID}" />
				<input type="hidden" name="clientNoteID" value="{$clientNoteID}" />
				<input type="hidden" name="sid" value="{$sid}" />
				<textarea cols="80" rows="4" id="clientNoteText" name="clientNoteText">{$formValues.clientNoteText}</textarea> {$invalid.clientNoteText}
				<br />
				<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_EDIT_NOTE}" />
			</form>
			{else}
				{strip}
					{include file="$tplDirectory/widgets/actionLink.tpl"
						page="clients.php"
						actionName="ManageClientNotes"
						args="clientID=$clientID&clientNoteID=$clientNoteID#n$clientNoteID"
						icoImage="note_edit.gif"
						icoWidth=""
						icoHeight=""
						icoStyle=""
						altText="TRANS_EDIT"
						titleText="TRANS_EDIT"
						linkText=""
						noSpace="1"
					}
					&nbsp;
					{include file="$tplDirectory/widgets/actionLink.tpl"
						page="clients.php"
						actionName="RemoveClientNoteResponse"
						args="clientID=$clientID&clientNoteID=$clientNoteID"
						icoImage="note_delete.gif"
						icoWidth=""
						icoHeight=""
						icoStyle=""
						altText="TRANS_REMOVE"
						titleText="TRANS_REMOVE"
						linkText=""
						noSpace="1"
					}
				{/strip}
				&nbsp;
				{$note.clientNoteText|nl2br}
			{/if}

			</blockquote>

		</td>
	</tr>
{sectionelse}
	<tr>
		<td><i>{$smarty.const.TRANS_NONE}</i></td>
	</tr>
{/section}	
</table>

</fieldset>

<br />

<fieldset>
	<legend>{$smarty.const.TRANS_ADD_NOTE}</legend>

	<form method="post" action="clients.php">
	<input type="hidden" name="action" value="{getActionID action="ManageClientNotesResponse"}" />
	<input type="hidden" name="clientID" value="{$clientID}" />
	<input type="hidden" name="sid" value="{$sid}" />

	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
	<tr {if !$editNote && $invalid.clientNoteText}class="highlight"{/if}>
		<td class="title"><label for="clientNoteText">{$smarty.const.TRANS_NOTE_MESG}</label></td>
		<td><textarea cols="80" rows="10" id="clientNoteText" name="clientNoteText">{if !$editNote}{$formValues.clientNoteText}{/if}</textarea> {$invalid.clientNoteText}</td>
	</tr>
	<tr class="listButtons">
		<td colspan="2"><div>
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_NOTE}" />
		</div></td>
	</tr>
	</table>

	</form>

</fieldset>

<br />

{include file="$tplDirectory/footer.tpl"}
