{* $Id: ShowClientARHistory.tpl 9690 2006-10-18 01:57:46Z kbailey $
 * --------------------------------------------------------------
 * This template displays a single client record and a summary of all client information.
 *
 * Smarty Variables:
 *	$client (array of client information that matches input criteria)
 *
 * Author: Michael Fountain
 *}
{strip}
{t c="TRANS_LOGIN_CLIENT_AREA" d="Login to Client Area"}
{t c="TRANS_LAST_5_TICKETS" d="Last 5 Tickets"}
{t c="TRANS_CLIENT_AR_HISTORY" d="Client Payment History"}
{t c="TRANS_NO_ENTRIES" d="There are no entries for this client."}
{t c="TRANS_PAYMENT" d="Payment"}
{t c="TRANS_FOR_PACKAGES" d="For Packages"}

{/strip}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CLIENT_DETAILS"
	grandchildName="TRANS_CLIENT_AR_HISTORY"
	sideNavMajor="clients"
	sideNavMinor="clients"
	useMenu="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

		<fieldset>
        <legend>{$smarty.const.TRANS_CLIENT_AR_HISTORY}</legend>
        <table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
        <tr class="headerRow">
            {include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_INVOICE_NUMBER" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="invoiceID"}
            {include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_DESCRIPTION" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDescription"}
            {include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_FOR_PACKAGES"}
            {include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_DATE" headerAlign="left" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDateCreated"}
            {include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_CURRENCY_SHORT" headerAlign="left" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="currencyID"}
            {include file="$tplDirectory/widgets/table/listHeaderSortAmount.tpl" headerAlign="left" headerAlign="left" headerName="TRANS_DEBITS" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDebitAmount"}
            {include file="$tplDirectory/widgets/table/listHeaderSortAmount.tpl" headerAlign="left" headerAlign="left" headerName="TRANS_CREDITS" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerCreditAmount"}
            {include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS" headerAlign="left"}
        </tr>

        {section name=i loop=$ledgerData}
        	{assign var="invoiceID" value=$ledgerData[i].invoiceID}
            {if $className=="alt1"}
                {assign var="className" value="alt2"}
            {else}
                {assign var="className" value="alt1"}
            {/if}
			{assign var="generalLedgerID" value=$ledgerData[i].generalLedgerID}

            <tr class="{cycle values="alt1,alt2"}"
                    onmouseover="this.className='althover';"
                    onmouseout="this.className='{$className}';">
                <td>{if $keyedInvoices.$invoiceID}<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoiceID`"}">{$keyedInvoices.$invoiceID.invoiceNumber}</a>{else}{$smarty.const.TRANS_NONE}{/if}</td>
                {if $ledgerData[i].generalLedgerCreditAmount>0}
                <td colspan="2">{$ledgerData[i].generalLedgerDescription}</td>
                {else}
                <td>{$ledgerData[i].generalLedgerDescription}</td>
                <td><a href="{getHREF page="packages.php" actionName="ShowPackageDetails" args="packageID=`$ledgerPackageNames[$generalLedgerID].packageID`"}">{$ledgerPackageNames[$generalLedgerID].name}</a></td>
                {/if}
                <td style="text-align:center;">{$ledgerData[i].generalLedgerDateCreated|getDate:short}</td>
                <td style="text-align:center;">{$ledgerData[i].currencyID}</td>
                <td style="text-align:right;">{$ledgerData[i].generalLedgerDebitAmount|getAmount:$ledgerData[i].currencyID:false}</td>
                <td style="text-align:right;">{$ledgerData[i].generalLedgerCreditAmount|getAmount:$ledgerData[i].currencyID:false}</td>
            	<td style="text-align:center;">
				{if $ledgerData[i].journalTableName=='accounting_general_journal'}
					{include file="$tplDirectory/widgets/actionLink.tpl"
							page="accounting.php"
							actionName="EditGeneralJournalEntry"
							args="generalJournalID=`$ledgerData[i].journalTableID`"
							icoImage="edit"
							icoWidth=""
							icoHeight=""
							icoStyle=""
							altText="TRANS_REMOVE"
							titleText=""
							linkText="TRANS_EDIT"
							noSpace="1"
					}
            	{else}
					<i>{$smarty.const.TRANS_NONE}</i>
				{/if}</td>
            </tr>

        {sectionelse}

            <tr class="alt1">
                <td colspan="7">{$smarty.const.TRANS_NO_ENTRIES}</td>
            </tr>

        {/section}

        </table>
        </fieldset>

        {include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="clientID=`$client.clientID`"}

{include file="$tplDirectory/footer.tpl"}
