{* $Id: ShowClientContacts.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template shows all contacts for a particular client.
 *
 * Smarty Variables:
 * $client					Array of client information
 * $contacts				Array of all associated contact information
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Ben Woolley
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_CONTACTS" d="Contacts"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_RESET" d="Reset"}
{t c="TRANS_CONTACT" d="Contact"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_ADDRESS" d="Street Address"}
{t c="TRANS_ADDRESS2" d="Suite/Apartment"}
{t c="TRANS_CITY" d="City"}
{t c="TRANS_STATE" d="State"}
{t c="TRANS_ZIP" d="Zip"}
{t c="TRANS_PRIMARY_PHONE" d="Primary Phone"}
{t c="TRANS_SECONDARY_PHONE" d="Secondary Phone"}
{t c="TRANS_FAX" d="Fax"}
{t c="TRANS_PRIMARY" d="Primary"}
{t c="TRANS_SET_PRIMARY" d="Set this person as the primary contact"}
{t c="TRANS_CLIENT" d="Client"}
{t c="TRANS_CONTACT" d="Contact"}
{t c="TRANS_PRIMARY_CONTACT" d="Primary Contact"}
{t c="TRANS_ALTERNATE_CONTACTS" d="Alternate Contacts"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_PHONE" d="Phone"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_ADD_CONTACT" d="Add Contact"}
{t c="TRANS_CONTACT_DETAILS" d="Contact Details"}
{t c="TRANS_SECONDARY_PHONE" d="Secondary Phone"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_ALL_CONTACTS" d="All Contacts"}
{t c="TRANS_CONTACT_ID" d="Contact ID"}
{t c="TRANS_MORE" d="More"}
{t c="TRANS_ADDITIONAL_ACTIONS" d="Additional Actions"}
{t c="TRANS_LOGIN_AS_CONTACT" d="Login As Contact"}
{t c="TRANS_RESET_RESEND_PASSWORD" d="Reset and Resend Password"}
  
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CONTACTS"
	grandchildName="TRANS_SHOW_ALL"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

{assign var="clientID" value=$client.clientID}

<fieldset>
<legend>{$smarty.const.TRANS_PRIMARY_CONTACT}</legend>

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="firstTD" headerName="TRANS_CONTACT_ID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_FIRST_NAME"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_LAST_NAME"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_COMPANY"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_EMAIL"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="" headerName="TRANS_STATUS"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="lastTD" headerName="TRANS_ACTIONS"}
</tr>
{section name="i" loop="$contacts"}
{assign var="clientContactID" value=$contacts[i].clientContactID}
{if $lastWasPrimary}
	{assign var="reset" value=true}
	<tbody>
	<tr>
		<td colspan="7" style="padding:0px;"><br />
			{strip}
			<fieldset>
			<legend>
				{$smarty.const.TRANS_ALTERNATE_CONTACTS}
				&nbsp;&nbsp;&nbsp;
				[&nbsp;<a href="{getHREF page="clients.php" actionName="AddClientContact" args="clientID=$clientID"}">
					{$smarty.const.TRANS_ADD_CONTACT}
				</a>&nbsp;]
			</legend>
			</fieldset>
			{/strip}
		</td>
	</tr>
	<tr class="headerRow">
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="firstTD" headerName="TRANS_CONTACT_ID"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_FIRST_NAME"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_LAST_NAME"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_COMPANY"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_EMAIL"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="" headerName="TRANS_STATUS"}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
			headerClass="lastTD" headerName="TRANS_ACTIONS"}
	</tr>
	</tbody>
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2" reset=$reset}">
	<td>
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		{$clientContactID}
	</td>
	<td>{$contacts[i].contactFirstName}</td>
	<td>{$contacts[i].contactLastName}</td>
	<td>{$contacts[i].contactCompany}</td>
	<td>{$contacts[i].contactEmail}</td>
	<td>{$contacts[i].contactActive|getStatusName:"active"}</td>
	<td>
		{strip}
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			{$smarty.const.TRANS_MORE}
		</a>
		{/strip}
	</td>
</tr>
</tbody>

{if $smarty.request.clientContactID == $contacts[i].clientContactID}
	{assign var="class" value="on"}
{else}
	{assign var="class" value="off"}
{/if}
<tbody id="row_{$clientContactID}" class="{$class}">
<tr>
	<td colspan="7" class="comments altinner">
		<a href="javascript:XKtoggle('row_{$clientContactID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;
		<strong>{$smarty.const.TRANS_ADDITIONAL_ACTIONS}:</strong>

		{if $contacts[i].contactActive && $client.clientActive && $client.clientStatus == "client"|getStatusID:"none"}{* client is active *}
			&nbsp;
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="clients.php"
				actionName="ForwardToClientInterface"
				args="clientID=$clientID&clientContactID=$clientContactID"
				icoImage="id_card.gif"
				altText="TRANS_LOGIN_AS_CONTACT"
				linkText="TRANS_LOGIN_AS_CONTACT"
				target="_blank"}
			&nbsp;
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="clients.php"
				actionName="ResetContactPassword"
				args="clientContactID=$clientContactID"
				icoImage="id_card_new.gif"
				altText="TRANS_RESET_RESEND_PASSWORD"
				linkText="TRANS_RESET_RESEND_PASSWORD"}
		{/if}

		&nbsp;
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="EditClientContact"
			args="clientID=$clientID&clientContactID=$clientContactID"
			icoImage="contact_edit.gif"
			altText="TRANS_EDIT"
			linkText="TRANS_EDIT"
			noSpace="0"
		}
		&nbsp;
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="RemoveClientContact"
			args="clientID=$clientID&clientContactID=$clientContactID"
			icoImage="contact_delete.gif"
			altText="TRANS_REMOVE"
			linkText="TRANS_REMOVE"
			noSpace="0"
		}

        <table width="100%" border="0" cellpadding="0" cellspacing="0">
        <tr>
            {************************** COLUMN 1 **************************}
            <td width="50%" valign="top" style="border:0px;">
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="addData">
				<tr class="alt1">
					<td><strong>{$smarty.const.TRANS_ADDRESS}:</strong></td>
					<td>{$contacts[i].contactAddress1|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{$smarty.const.TRANS_ADDRESS2}:</strong></td>
					<td>{$contacts[i].contactAddress2|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt1">
					<td><strong>{$smarty.const.TRANS_CITY}:</strong></td>
					<td>{$contacts[i].contactCity|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{$smarty.const.TRANS_STATE}:</strong></td>
					<td>{$contacts[i].contactState|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt1">
					<td><strong>{$smarty.const.TRANS_ZIP}:</strong></td>
					<td>{$contacts[i].contactZip|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{$smarty.const.TRANS_COUNTRY}:</strong></td>
					<td>
						{assign var="trans_countriesISO2" value="TRANS_ISO_3166_`$contacts[i].countriesISO2`"}
						<img src="{$imageDirectory}/flags/flag-{$contacts[i].countriesISO2}.gif" style="vertical-align:middle;border-style:none;" title="{$smarty.const.$trans_countriesISO2}" alt="{$smarty.const.$trans_countriesISO2}" /> 
						{$contactCountries.$clientContactID}
					</td>
				</tr>
				</table>
			</td>
            {************************** COLUMN 2 **************************}
            <td width="50%" valign="top" style="border:0px;">
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="addData">
				<tr class="alt1">
					<td><strong>{$smarty.const.TRANS_PRIMARY_PHONE}:</strong></td>
					<td>{$contacts[i].contactPhone1|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{$smarty.const.TRANS_SECONDARY_PHONE}:</strong></td>
					<td>{$contacts[i].contactPhone2|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt1">
					<td><strong>{$smarty.const.TRANS_FAX}:</strong></td>
					<td>{$contacts[i].contactFax|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				<tr class="alt2">
					<td><strong>{$smarty.const.TRANS_LANGUAGE}:</strong></td>
					{assign var="languageID" value=$contacts[i].languageID}
					<td>{$languageList[$languageID]}</td>
				</tr>
				</table>
				<br />
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="addData">
				<tr class="alt1">
					<td width="35%"><strong>{$smarty.const.TRANS_USERNAME}:</strong></td>
					<td>{$contacts[i].contactUsername|default:"<i>`$smarty.const.TRANS_EMPTY`</i>"}</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
	</td>
</tr>
</tbody>
{if $contacts[i].contactPrimary}
	{assign var="lastWasPrimary" value=1}
{else}
	{assign var="lastWasPrimary" value=0}
{/if}
{sectionelse}
<tr class="alt1">
	<td colspan="7">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
<tr>
	{assign var="clientID" value=$client.clientID}
	<td colspan="7"><a href="{getHREF page="clients.php" actionName="AddClientContact" args="clientID=$clientID"}">{$smarty.const.TRANS_ADD_CONTACT}</a></td>
</tr>
{/section}
</table>

</fieldset>
<br />

{include file="$tplDirectory/footer.tpl"}
