{* $Id: ShowClientCreditHistory.tpl 8361 2006-08-16 21:14:01Z kbailey $
 * --------------------------------------------------------------
 * This template displays a single client record and a summary of all client information.
 *
 * Smarty Variables:
 *	$client (array of client information that matches input criteria)
 *
 * Author: Michael Fountain
 *}
{strip}
{t c="TRANS_LOGIN_CLIENT_AREA" d="Login to Client Area"}
{t c="TRANS_LAST_5_TICKETS" d="Last 5 Tickets"}
{t c="TRANS_CLIENT_CREDIT_HISTORY" d="Client Credit History"}
{t c="TRANS_NO_CREDITS" d="This client has had no credits."}

{/strip}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CLIENT_DETAILS"
	grandchildName="TRANS_CLIENT_CREDIT_HISTORY"
	sideNavMajor="clients"
	sideNavMinor="clients"
	useMenu="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" client=$client}



        <fieldset>
        <legend>{$smarty.const.TRANS_CLIENT_CREDIT_HISTORY}</legend>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
            <tr>
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_INVOICE_NUMBER" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="invoiceID"}
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_DESCRIPTION" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDescription"}
                {include file="$tplDirectory/widgets/table/tableSortDateHeader.tpl" headerName="TRANS_DATE" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDateCreated"}
                {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_CURRENCY_SHORT" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="currencyID"}
                {include file="$tplDirectory/widgets/table/tableSortAmountHeader.tpl" headerAlign="left" headerName="TRANS_DEBITS" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerDebitAmount"}
                {include file="$tplDirectory/widgets/table/tableSortAmountHeader.tpl" headerAlign="left" headerName="TRANS_CREDITS" queryArgs="ledgerAccountID=`$ledgerAccountID`" queryArgCol="ledgerAccountID" queryArgValue=$ledgerAccountID sortColumn="generalLedgerCreditAmount"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_EDIT" headerAlign="left"}
            </tr>

        {section name=i loop=$ledgerData}
        	{assign var="invoiceID" value=$ledgerData[i].invoiceID}
            {if $className=="alt1"}
                {assign var="className" value="alt2"}
            {else}
                {assign var="className" value="alt1"}
            {/if}

            <tr class="{cycle values="alt1,alt2"}">
                <td>{if $keyedInvoices.$invoiceID}<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoiceID`"}">{$keyedInvoices.$invoiceID.invoiceNumber}</a>{else}{$smarty.const.TRANS_NONE}{/if}</td>
                <td>{$ledgerData[i].generalLedgerDescription}</td>
                <td>{$ledgerData[i].generalLedgerDateCreated|getDate:short}</td>
                <td>{$ledgerData[i].currencyID}</td>
                <td align="right">{$ledgerData[i].generalLedgerDebitAmount|getAmount:$ledgerData[i].currencyID:false}</td>
                <td align="right">{$ledgerData[i].generalLedgerCreditAmount|getAmount:$ledgerData[i].currencyID:false}</td>
            	<td>{if $ledgerData[i].journalTableName=='accounting_general_journal'}
			{include file="$tplDirectory/widgets/actionLink.tpl"
					page="accounting.php"
					actionName="EditGeneralJournalEntry"
					args="generalJournalID=`$ledgerData[i].journalTableID`"
					icoImage="edit"
					icoWidth=""
					icoHeight=""
					icoStyle=""
					altText="TRANS_REMOVE"
					titleText=""
					linkText="TRANS_EDIT"
					noSpace="1"
			}

            	{/if}</td>
            </tr>

        {sectionelse}

            <tr class="alt1">
                <td colspan="7">{$smarty.const.TRANS_NO_CREDITS}</td>
            </tr>

        {/section}

        </table>

        {include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="clientID=`$client.clientID`"}

{include file="$tplDirectory/footer.tpl"}
