{* $Id: ShowClients.tpl 11352 2007-06-14 19:43:19Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of client records.
 *
 * Smarty Variables:
 *	$clients (array of clients that match input criteria)
 *		clientID			A unique client ID
 *		contactFirstName		A client's first name
 *		contactLastName		A client's last name
 *		contactEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$clientActive			The $_REQUEST value of clientActive filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 * Author: Ben Woolley
 *}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADD_NEW_CONTACT" d="Add new contact"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_CLIENT_ID" d="Client ID"}
{t c="TRANS_LAST_NOTE" d="Last Note"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_NO_NOTES" d="No Notes"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_PRIMARY_CONTACT" d="Primary Contact"}
{t c="TRANS_PHONE" d="Phone"}
{t c="TRANS_LAST_ACCESS" d="Last Access"}
{t c="TRANS_LAST_TICKET" d="Last Ticket"}
{t c="TRANS_ONLINE" d="Online"}
{t c="TRANS_OFFLINE" d="Offline"}
{t c="TRANS_SHOW_ALL_ADD_NEW" d="Show All/Add New"}
{t c="TRANS_ADD_NEW" d="Add New"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_ADDITIONAL_INFORMATION" d="Additional Information"}
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_RESULTS_SORTED_BY" d="Results sorted by"}
{t c="TRANS_ARCHIVED" d="Archived"}
{t c="TRANS_SHOW_LIVE_CLIENTS" d="Show Live Clients"}
{t c="TRANS_SHOW_ARCHIVED_CLIENTS" d="Show Archived Clients"}

{assign var="filterArgs" value="clientActive=$clientActive&clientStatus=$clientStatus"}

{if $smarty.request.clientActive=="1"} {* 1 = Not Archived *}
    {assign var="childName" value="TRANS_SHOW_LIVE_CLIENTS"}
{elseif $smarty.request.clientActive=="0"}  {* 0 = Not Archived *}
    {assign var="childName" value="TRANS_SHOW_ARCHIVED_CLIENTS"}
{else}
    {assign var="childName" value="TRANS_SHOW_ALL_CLIENTS"}
{/if}


{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName=$childName
	sideNavMajor="clients"
	sideNavMinor="clients"}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="3" style="text-align:left;">
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$clients}
			XKtoggle('row_{$clients[iter].clientID}'); 
		{/section} 
		{/strip}return false;">
			<img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$clients}
			XKtoggle('row_{$clients[iter].clientID}'); 
		{/section} 
		{/strip}return false;">
			{$smarty.const.TRANS_ADDITIONAL_DATA}
		</a>
	</td>
	<td colspan="4" style="text-align:right;">
		{include file="$tplDirectory/widgets/context/sortedBy.tpl"}
	</td>
</tr>
<tr class="{if $smarty.request.clientActive=="0"}subHeaderRow{else}headerRow{/if}">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" 
		headerClass="firstTD" headerName="TRANS_ID" sortColumn="clientID"}
	
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" 
		headerName="TRANS_COMPANY" sortColumn="clientCompany"}

	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" 
		headerName="TRANS_PRIMARY_CONTACT" sortColumn="contactLastName"}

	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" 
		headerName="TRANS_EMAIL" sortColumn="contactEmail"}

	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" 
		headerName="TRANS_COUNTRY" sortColumn="countriesISO2"}

	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" 
		filterName="TRANS_STATUS" filterColumn="clientStatus" filterOptions="$clientStatusList" suppressFilterName=1 mergeFilterName=1}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerClass="lastTD" headerName="TRANS_ACTIONS"}
</tr>
</thead>
{section name=i loop="$clients"}
{assign var="clientID" value=$clients[i].clientID}

{assign var="classAlt1" value="alt1"}
{assign var="classAlt2" value="alt2"}
{assign var="classAltHover" value="althover"}

{if $smarty.request.clientActive=="0"} {* 0 = Archived *}
    {assign var="classAlt1" value="subalt1"}
    {assign var="classAlt2" value="subalt2"}
    {assign var="classAltHover" value="subalthover"}
{/if}

{if $classReverse==$classAlt1}
    {assign var="classReverse" value=$classAlt2}
{else}
    {assign var="classReverse" value=$classAlt1}
{/if}

<tbody>
<tr class="{cycle values="$classAlt1,$classAlt2"}">
	<td class="listRowFirstTD" {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		<table style="border:0;padding:0;marging:0;width:100%;">
		<tr>
			<td style="border:0;padding:0;marging:0;">
		        <a href="javascript:void(0);" onclick="return XKtoggle('row_{$clientID}');">
					<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
				</a>
			</td>
			<td style="border:0;padding:0;marging:0;width:100%;">
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$clientID"
					clientID=$clientID
					clientContactID=$clients[i].clientContactID
					altText=$clientID
					linkText=$clientID
				}
			</td>
			{if !$clients[i].clientActive}
				<td style="border:0;padding:0;marging:0;text-align:right;">
					{include file="$tplDirectory/widgets/actionLink.tpl"
						page="clients.php"
						actionName="EditClientArchiveState"
						args="clientID=$clientID"
						icoImage="cabinet.gif"
						icoWidth=""
						icoHeight=""
						icoStyle=""
						altText="TRANS_ARCHIVED"
						titleText="TRANS_ARCHIVED"
						linkText=""
						noSpace="1"
					}
				</td>
			{/if}
		</tr>
		</table>
	</td>
	<td {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		{$clients[i].clientCompany|default:$smarty.const.TRANS_EMPTY|stripslashes|mb_truncate:20}
	</td>
	<td {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		{$clients[i].contactLastName|stripslashes|mb_truncate:12}, {$clients[i].contactFirstName|stripslashes|mb_truncate:12}
	</td>
	<td {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		<a href="{getHREF actionName="SendClientEmail" args="clientID=`$clients[i].clientID`"}">{$clients[i].contactEmail|mb_truncate:25}</a>
	</td>
	<td style="text-align:center;" {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		{assign var="trans_countriesISO2" value="TRANS_ISO_3166_`$clients[i].countriesISO2`"}
		<img src="{$imageDirectory}/flags/flag-{$clients[i].countriesISO2}.gif" style="vertical-align:middle;border-style:none;" title="{$smarty.const.$trans_countriesISO2}" alt="{$smarty.const.$trans_countriesISO2}" /> 
		{$clients[i].countriesISO2}
	</td>
	<td {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		{$clients[i].clientStatus|getStatusName:"client"}
	</td>
	<td class="nowrap" {if !$clients[i].clientActive}style="color:#666666;"{/if}>
		{* DETAILS *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="ShowClientDetails"
			args="clientID=$clientID"
			clientID=$clientID
			clientContactID=$clients[i].clientContactID
			icoImage="view"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_DETAILS"
			titleText=""
			linkText="TRANS_DETAILS"
			noSpace="1"
		}
	</td>
</tr>
</tbody>
<tbody id="row_{$clientID}" class="off">
<tr>
	<td colspan="7"  class="comments altinner">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$clientID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;
		<b>{$smarty.const.TRANS_CLIENT_ID}: {$clientID} ({$smarty.const.TRANS_ADDITIONAL_INFORMATION})</b>
		{/strip}
		<br clear="all" />
        <table width="100%" border="0" cellpadding="0" cellspacing="0">
        <tr>
            {************************** COLUMN 1 **************************}
            <td width="33%" valign="top">
                <table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
                <tr>
                    <th colspan="2">
                        <strong>{$smarty.const.TRANS_PRIMARY_CONTACT}</strong>
                        &nbsp;
                        {assign var="contactID" value=$clients[i].clientContactID}
		                <a href="{getHREF page="clients.php" actionName="ShowClientContacts" args="clientID=$clientID"}">
			                <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		                </a>
                        &nbsp;
		                <a href="{getHREF page="clients.php" actionName="EditClientContact" args="clientContactID=$contactID"}">
			                <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
		                </a>
                    </th>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_NAME}:</strong></td>
                    <td>{$clients[i].contactLastName|stripslashes}, {$clients[i].contactFirstName|stripslashes}</td>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_EMAIL}:</strong></td>
                    <td>{mailto address=$clients[i].contactEmail}</td>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_PHONE}:</strong></td>
                    <td>{$clients[i].contactPhone1}</td>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_USERNAME}:</strong></td>
                    <td>{$clients[i].contactUsername}</td>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_LAST_ACCESS}:</strong></td>
                    <td>{$clients[i].sessions.0.sessionDateAccessed|getDateTime} ({if $clients[i].sessions.0.sessionActive}{$smarty.const.TRANS_ONLINE}{else}{$smarty.const.TRANS_OFFLINE}{/if})</td>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_LAST_TICKET}:</strong></td>
                    {assign var="ticketID" value=$clients[i].helpdeskTicket.hdTicketID}
                    <td><a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$ticketID"}">{$clients[i].helpdeskTicket.hdTicketSubject}</a></td>
                </tr>
                </table>
            </td>
            {************************** COLUMN 2 **************************}
            <td width="33%" valign="top">
                <table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
                <tr>
                    <th colspan="2">
                        <strong>{$smarty.const.TRANS_CLIENT_DETAILS}</strong>
                        &nbsp;
		                <a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID"}">
			                <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		                </a>
                        &nbsp;
		                <a href="{getHREF page="clients.php" actionName="EditClient" args="clientID=$clientID"}">
			                <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
		                </a>
                    </th>
                </tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_DATE_CREATED}:</strong></td>
                    <td>{$clients[i].clientDateCreated|getDateTime}</td>
                </tr>
				<tr>
					<td><strong>{$smarty.const.TRANS_COUNTRY}</strong></td>
					<td>{$clients[i].countriesISO2}</td>
				</tr>
                <tr>
                    <td><strong>{$smarty.const.TRANS_TAX}:</strong></td>
                    <td>{if $clients[i].applyTax}{$smarty.const.TRANS_APPLIED}{else}{$smarty.const.TRANS_NOT_APPLIED}{/if}</td>
                </tr>
				{if $clients[i].taxIDNumber}
				<tr>
					<td><strong>{$smarty.const.TRANS_TAX_ID_NUMBER}</strong></td>
					<td>{$clients[i].taxIDNumber}</td>
				</tr>
				{/if}
                </table>
            </td>
            {************************** COLUMN 3 **************************}
            <td width="33%" valign="top">
                <table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
                <tr>
                    <th colspan="2">
                        <strong>{$smarty.const.TRANS_LAST_NOTE}</strong>
                        &nbsp;
		                <a href="{getHREF page="clients.php" actionName="ManageClientNotes" args="clientID=$clientID"}">
			                <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_SHOW_ALL_ADD_NEW}" title="{$smarty.const.TRANS_SHOW_ALL_ADD_NEW}" />
		                </a>
                        &nbsp;
				        {include
					        file="$tplDirectory/widgets/quickAddLink.tpl"
                            useEditIcon=1
					        addActionName="ManageClientNotesResponse"
					        addName="TRANS_NOTE"
					        addColumn="clientNoteText"
					        addValue=""
					        extraparam="clientID"
					        extravalue=$clientID}
                    </th>
                </tr>
                <tr>
                    <td>
				    {assign var="clientNotes" value=$noteList.$clientID}
				    {section name="j" loop=$clientNotes}
					    <div class="note">
						    <div class="floatright">
							    {assign var="noteAdminID" value=$clientNotes[j].adminID}
							    <a href="{getHREF page="admins.php" actionName="ShowAdminDetails" args="adminID=$noteAdminID"}">
								    {$clientNotes[j].adminUsername}
							    </a>
						    </div>
						    {$clientNotes[j].clientNoteText|nl2br}
					    </div>
				    {sectionelse}
                        {$smarty.const.TRANS_NONE}
				    {/section}
				    </td>
                </tr>
                </table>
            </td>
        </tr>
        </table>
	</td>
</tr>
<tr>
	<td colspan="13">&nbsp;</td>
</tr>
</tbody>
{sectionelse}
<tr class="{$classAlt1}">
	<td colspan="13">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
