{* $Id: ShowNewOrders.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of client records.
 *
 * Smarty Variables:
 *	$clients (array of clients that match input criteria)
 *		clientID			A unique client ID
 *		contactFirstName		A client's first name
 *		contactLastName		A client's last name
 *		contactEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$clientActive			The $_REQUEST value of clientActive filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 * Author: Ben Woolley
 *}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADD_NEW_CONTACT" d="Add new contact"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_CLIENT_ID" d="Client ID"}
{t c="TRANS_LAST_NOTE" d="Last Note"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_NO_NOTES" d="No Notes"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_PRIMARY_CONTACT" d="Primary Contact"}
{t c="TRANS_PHONE" d="Phone"}
{t c="TRANS_LAST_ACCESS" d="Last Access"}
{t c="TRANS_LAST_TICKET" d="Last Ticket"}
{t c="TRANS_ONLINE" d="Online"}
{t c="TRANS_OFFLINE" d="Offline"}
{t c="TRANS_SHOW_ALL_ADD_NEW" d="Show All/Add New"}
{t c="TRANS_ADD_NEW" d="Add New"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_ADDITIONAL_INFORMATION" d="Additional Information"}
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}
{t c="TRANS_NEW_ORDERS" d="New Orders"}
{t c="TRANS_TREND_REPORTS" d="Trend Reports"}
{t c="TRANS_YEARLY_CLIENT_TREND" d="Yearly Client Trend"}
{t c="TRANS_MONTHLY_SIGNUP_TREND" d="Monthly Signup Trend"}
{t c="TRANS_REFRESH" d="Refresh"}
{t c="TRANS_SHOW_ALL_NEW_ORDERS" d="Show All New Orders"}
{t c="TRANS_NEW_CUSTOMERS" d="New Customers"}
{t c="TRANS_SHOW_ALL_NEW_CUSTOMERS" d="Show All New Customers"}
{t c="TRANS_ACTIVATE" d="Activate"}
{t c="TRANS_REVIEW" d="Review"}
{t c="TRANS_REJECT" d="Reject"}
{t c="TRANS_NO_NEW_ORDERS" d="No New Orders"}
{t c="TRANS_SET_CANCEL_ACTION" d="Set Cancel Action"}
{t c="TRANS_SUSPEND_PACKAGE_IF_PROVISIONED" d="suspend package if provisioned"}
{t c="TRANS_DELETE_PACKAGE_IF_PROVISIONED" d="delete package if provisioned"}

{assign var="filterArgs" value="clientActive=$clientActive&clientStatus=$clientStatus"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_NEW_CUSTOMERS"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{literal}
<script language="JavaScript">
	function cbx_register_click(id,targetID) {
		setTimeout('cbx_process_event("'+id+'","'+targetID+'");',100);
	}
	function cbx_process_event(id,targetID) {
		if (document.getElementById(id).checked) {
			cbx_select(id,targetID);
		} else {
			cbx_deselect(id,targetID);
		}
	}
	function cbx_select(id,targetID) {
		document.getElementById(targetID).disabled = true;
		document.getElementById(targetID).checked = false;
	}
	function cbx_deselect(id,targetID) {
		document.getElementById(targetID).disabled = false;
	}
</script>
{/literal}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="7" style="cursor: pointer;" onclick="{strip} {section name=iter loop=$clients}
		XKtoggle('row_{$clients[iter].clientID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>

</thead>
<form method="post" action={getHREF page="clients.php" actionName="EditNewOrdersResponse"}>
	{section name=i loop="$clients"}
	{assign var="clientID" value=$clients[i].clientID}
	{assign var="trans_countriesISO2" value="TRANS_ISO_3166_`$clients[i].countriesISO2`"}
	{if $className=="alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	<tbody>
	
	<tr class="{cycle values="alt1,alt2"}">
		<td class="listRowFirstTD" style="cursor: pointer;" onclick="return XKtoggle('row_{$clientID}');">
			<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
			{$clientID}
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			<img src="{$imageDirectory}/flags/flag-{$clients[i].countriesISO2}.gif" style="vertical-align:middle;border-style:none;" /> {$smarty.const.$trans_countriesISO2|mb_truncate:15}
			<br />
			{$clients[i].clientDateCreated|getDateTime}
			<br />
			{if $clients[i].invoices[0]}
				{$smarty.const.TRANS_INVOICE}: {$clients[i].invoices[0].invoiceAmount|getAmount:$clients[i].invoices[0].currencyID}
				{if $clients[i].invoices[0].invoiceStatus|getAPIStatusName:"invoice" == "closed"}
					{assign var="color" value="green"}
				{else}
					{assign var="color" value="red"}
				{/if}
				<font color="{$color}">
					{$clients[i].invoices[0].invoiceStatus|getStatusName:"invoice"}
				</font>
			{else}			
				{$smarty.const.TRANS_INVOICE}: <font color="red"><i>{$smarty.const.TRANS_UNKNOWN}</i></font>
			{/if}
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			{if $clients[i].clientCompany}
				{$clients[i].clientCompany|mb_truncate:22}
				<br />
			{/if}	
			{$clients[i].contactLastName|stripslashes|mb_truncate:12}, {$clients[i].contactFirstName|stripslashes|mb_truncate:12}
			<br />
			{$clients[i].contactEmail|mb_truncate:25}
		</td>
		<td style="width:40px; font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			{* COMING SOON
			<a href="javascript:void(0);" onclick="openwin('{getHREF page="clients.php" actionName="ShowNewOrderReview" args="clientID=$clientID"}',400,400,'clientID_{$clientID}');">{$smarty.const.TRANS_REVIEW|mb_truncate:10}</a>
			*}
			<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID&__print=1"}" target="_blank">{$smarty.const.TRANS_REVIEW|mb_truncate:10}</a>
		</td>
		<td style="width:55px; font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			<input type="checkbox" name="activate[]" id="cbx_activate_{$clientID}" value="{$clientID}" 
				onmouseup="cbx_register_click('cbx_activate_{$clientID}','cbx_cancel_{$clientID}');" />&nbsp;{$smarty.const.TRANS_ACTIVATE}
			<br />
			<input type="checkbox" name="cancel[]" id="cbx_cancel_{$clientID}" value="{$clientID}" 
				onmouseup="cbx_register_click('cbx_cancel_{$clientID}','cbx_activate_{$clientID}');" />&nbsp;{$smarty.const.TRANS_CANCEL}
		</td>
	</tr>
	</tbody>
	<tbody id="row_{$clientID}" class="off">
	<tr>
		<td colspan="5"  class="comments altinner">
			{strip}
			<a href="javascript:void(0);" onclick="return XKtoggle('row_{$clientID}');">
				<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
			</a>
			&nbsp;
			<b>{$smarty.const.TRANS_CLIENT_ID}: {$clientID} ({$smarty.const.TRANS_ADDITIONAL_INFORMATION})</b>
			{/strip}
			<br clear="all" />
			<table width="100%" border="0" cellpadding="0" cellspacing="5">
			<tr>
				{************************** COLUMN 1 **************************}
				<td width="33%" valign="top">
					<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
					<tr>
						<th colspan="2">
							<strong>{$smarty.const.TRANS_PRIMARY_CONTACT}</strong>
							&nbsp;
							{assign var="contactID" value=$clients[i].contacts.0.clientContactID}
							<a href="{getHREF page="clients.php" actionName="ShowClientContacts" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
							</a>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="EditClientContact" args="clientContactID=$contactID"}">
								<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
							</a>
						</th>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_NAME}:</strong></td>
						<td>{$clients[i].contactLastName|stripslashes}, {$clients[i].contactFirstName|stripslashes}</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_EMAIL}:</strong></td>
						<td>{mailto address=$clients[i].contactEmail}</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_PHONE}:</strong></td>
						<td>{$clients[i].contactPhone1}</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_USERNAME}:</strong></td>
						<td>{$clients[i].contactUsername}</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_LAST_ACCESS}:</strong></td>
						<td>{$clients[i].sessions.0.sessionDateAccessed|getDateTime} ({if $clients[i].sessions.0.sessionActive}{$smarty.const.TRANS_ONLINE}{else}{$smarty.const.TRANS_OFFLINE}{/if})</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_LAST_TICKET}:</strong></td>
						{assign var="ticketID" value=$clients[i].helpdeskTicket.hdTicketID}
						<td><a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$ticketID"}">{$clients[i].helpdeskTicket.hdTicketSubject}</a></td>
					</tr>
					</table>
				</td>
				{************************** COLUMN 2 **************************}
				<td width="33%" valign="top">
					<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
					<tr>
						<th colspan="2">
							<strong>{$smarty.const.TRANS_CLIENT_DETAILS}</strong>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
							</a>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="EditClient" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
							</a>
						</th>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_DATE_CREATED}:</strong></td>
						<td>{$clients[i].clientDateCreated|getDateTime}</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_COUNTRY}</strong></td>
						<td>{$clients[i].countriesISO2}</td>
					</tr>
					<tr>
						<td><strong>{$smarty.const.TRANS_TAX}:</strong></td>
						<td>{if $clients[i].applyTax}{$smarty.const.TRANS_APPLIED}{else}{$smarty.const.TRANS_NOT_APPLIED}{/if}</td>
					</tr>
					{if $clients[i].taxIDNumber}
					<tr>
						<td><strong>{$smarty.const.TRANS_TAX_ID_NUMBER}</strong></td>
						<td>{$clients[i].taxIDNumber}</td>
					</tr>
					{/if}
					</table>
				</td>
				{************************** COLUMN 3 **************************}
				<td width="33%" valign="top">
					<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
					<tr>
						<th colspan="2">
							<strong>{$smarty.const.TRANS_LAST_NOTE}</strong>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="ManageClientNotes" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_SHOW_ALL_ADD_NEW}" title="{$smarty.const.TRANS_SHOW_ALL_ADD_NEW}" />
							</a>
							&nbsp;
							{include
								file="$tplDirectory/widgets/quickAddLink.tpl"
								useEditIcon=1
								addActionName="ManageClientNotesResponse"
								addName="TRANS_NOTE"
								addColumn="clientNoteText"
								addValue=""
								extraparam="clientID"
								extravalue=$clientID}
						</th>
					</tr>
					<tr>
						<td>
						{assign var="clientNotes" value=$noteList.$clientID}
						{section name="j" loop=$clientNotes}
							<div class="note">
								<div class="floatright">
									{assign var="noteAdminID" value=$clientNotes[j].adminID}
									<a href="{getHREF page="admins.php" actionName="ShowAdminDetails" args="adminID=$noteAdminID"}">
										{$clientNotes[j].adminUsername}
									</a>
								</div>
								{$clientNotes[j].clientNoteText|nl2br}
							</div>
						{sectionelse}
							{$smarty.const.TRANS_NONE}
						{/section}
						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</tbody>
	{sectionelse}
	<tr class="alt1">
		<td colspan="5" style="text-align:center;"><i>{$smarty.const.TRANS_NO_NEW_ORDERS}</i></td>
	</tr>
	{/section}
	{if count($clients)>0}
		<tr class="listRowNoBorders">
			<td colspan="4" style="text-align:right;">
				<strong>{$smarty.const.TRANS_SET_CANCEL_ACTION}:</strong>
				&nbsp;
				<select name="cancelAction" style="width:150px;">
					<option value="suspend">{$smarty.const.TRANS_SUSPEND_PACKAGE_IF_PROVISIONED}</option>
					<option value="delete">{$smarty.const.TRANS_DELETE_PACKAGE_IF_PROVISIONED}</option>
				</select>
			</td>
			<td>
				<input type="submit" name="submitActivateClients" value="{$smarty.const.TRANS_SUBMIT}">
			</td>
		</tr>
	{/if}
	</table>
</form>


{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
