{* $Id: EditEncryptionConfigs.tpl 9773 2006-10-23 20:08:03Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a form to edit a Package.
 *
 * Smarty Variables:
 *	n/a
 *
 *}
{t c="TRANS_LOCAL_ENCRYPTION_KEY" d="Local Encryption Key (LEK)"}
{t c="TRANS_PASSPHRASE2" d="Passphrase"}
{t c="TRANS_NO_ENCRYPTION" d="No Encryption"}
{t c="TRANS_OLD_LEK_HASH" d="Current Hash"}
{t c="TRANS_NEW_LEK_HASH" d="New Hash"}
{t c="TRANS_LEK_PIN_CONFIRM" d="LEK Pin Again"}
{t c="TRANS_PASSPHRASE" d="Passphrase Again"}
{t c="TRANS_PASSPHRASE_CONFIRM" d="Passphrase"}
{t c="TRANS_OLD_PASSPHRASE" d="Current Passphrase"}
{t c="TRANS_OLD_PASSPHRASE_CONFIRM" d="Current Passphrase Again"}
{t c="TRANS_LEK_DESC" d="LEK encryption is required for full automation. <strong>Check the option above to enable LEK encryption</strong>. You will be prompted to only enter your LEK pin to decrypt encoded data for viewing."}
{t c="TRANS_PASSPHRASE_DESC" d="Passphrase encryption does not support automated billing. <strong>Check the option above to enable passphrase encryption</strong>. You will be prompted to enter this passphrase to decrypt and encrypt encoded data for viewing and setting. When clients enter new encoded data, you will be assigned a todo to re-encrypt the data with your passphrase."}
{t c="TRANS_CYPHER_CHANGE" d="Cypher Change"}
{t c="TRANS_CURRENT_CYPHER" d="Current Cypher"}
{t c="TRANS_NEEDED_CYPHER" d="Needed Cypher"}
{t c="TRANS_SUBMIT_CHANGES" d="Submit Changes"}
{t c="TRANS_SECRET_TO_REMEMBER" d="Secret to Remember"}
{t c="TRANS_HASH" d="Hash"}
{t c="TRANS_AGREE" d="Agree"}
{t c="TRANS_GENERAL_ENCRYPTION_SETTINGS" d="General Encryption Settings"}
{t c="TRANS_ENCRYPTION_CYPHER_NOTICE" d="Encryption Cypher Notice"}
{t c="TRANS_LEK_ENCRYPTION_SETTINGS" d="LEK Encryption Settings"}
{t c="TRANS_PASSPHRASE_ENCRYPTION_SETTINGS" d="Passphrase Encryption Settings"}
{t c="TRANS_CYPHER_WARNING_MSG" d="You are using an old encryption cypher. You must re-encrypt here to update the cypher used on your data."}
{t c="TRANS_PASSPHRASE_NEEDED_FOR_REENCRYPTION" d="Your old passphrase is needed to decrypt the old data for re-encryption."}
{t c="TRANS_MODERNBILL_SUPPORTS_LEK_MSG" d="ModernBill supports fully-automated encryption using &quot;<strong>LEK</strong>&quot; and semi-automated encryption using a unique &quot;<strong>Passphrase</strong>&quot;. To enable either option, you must type the word &quot;<strong>agree</strong>&quot; in the confirmation field above."}

{t c="TRANS_RED_MISMATCH" d="<strong><font color=red>No Match!</font></strong>"}
{t c="TRANS_GREEN_MATCH" d="<strong><font color=green>Match OK</font></strong>"}


{include file="$tplDirectory/header.tpl"
	parentName=$parentName
	childName=$childName
	grandchildName=$grandchildName
	sideNavMajor=$sideNavMajor
	sideNavMinor=$sideNavMinor}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{if $editForm.fields.encryptionAgree.fieldValue == "agree"}
	{assign var="enabled" value=1}
{else}
	{assign var="enabled" value=0}
{/if}

{if $enabled && $editForm.fields.encryptionHash.fieldValue}
	{assign var="lek_enabled" value=1}
	{assign var="passphrase_enabled" value=0}
{else}
	{assign var="lek_enabled" value=0}
	{assign var="passphrase_enabled" value=1}
{/if}

<form method="post" action="configs.php">
<div>
	<input type="hidden" name="action" value="{getActionID action="EditEncryptionConfigsConfirm"}" />
	<input type="hidden" name="sid" value="{$sid}" />
	<input type="hidden" name="neededCypherType" value="modernbill51" />
</div>
<fieldset>
	<legend>{$smarty.const.TRANS_GENERAL_ENCRYPTION_SETTINGS}</legend>

	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
	<tr>
		<td>
			<fieldset>
				<legend style="color:red">
					<input name="encryption_agree" value="{$editForm.fields.encryptionAgree.fieldValue}" /> * 
				</legend>
				<p style="color:red">
				* {$smarty.const.TRANS_MODERNBILL_SUPPORTS_LEK_MSG}
				</p>
			</fieldset>
		</td>
	</tr>
	</table>

</fieldset>

<br />

{if $priorCypherType && $priorCypherType != "modernbill51"}
	<fieldset>
		<legend>{$smarty.const.TRANS_ENCRYPTION_CYPHER_NOTICE}</legend>
		<input type="hidden" name="priorCypherType" value="{$priorCypherType}" />
		<p style="color: white; background-color: red; padding: .25em;">{$smarty.const.TRANS_CYPHER_WARNING_MSG}</p>
			<strong>{$smarty.const.TRANS_CURRENT_CYPHER}:</strong> {$priorCypherTypeID|getTypeName:"encryption"}
			<br />
			<strong>{$smarty.const.TRANS_NEEDED_CYPHER}:</strong> {$smarty.const.TRANS_MODERNBILL_5_1}
	</fieldset>
	<br />
{/if}

<fieldset>
	<legend>{$smarty.const.TRANS_LEK_ENCRYPTION_SETTINGS}</legend>

	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
	<tr>
		<td>
			<fieldset>
				<legend style="color:blue">
					<input id="encryption_mode_lek" name="encryption_mode" value="lek" type="radio" {if $enabled && $lek_enabled}checked="checked" {/if}/>
					<label for="encryption_mode_lek">{$smarty.const.TRANS_LOCAL_ENCRYPTION_KEY} *</label>
				</legend>
				<p style="color:blue">
				* {$smarty.const.TRANS_LEK_DESC}
				</p>
				<br />
				{if $enabled && $passphrase_enabled}
					<h1>{$smarty.const.TRANS_OLD_PASSPHRASE}</h1>
					<p><i>{$smarty.const.TRANS_PASSPHRASE_NEEDED_FOR_REENCRYPTION}</i></p>
					<table width="100%" class="list">
					<tbody>
					<tr>
						<td class="title"><label for="old_pass_phrase">{$smarty.const.TRANS_OLD_PASSPHRASE}</label>:</td>
						<td><input type="password" style="width: 200px;" id="old_pass_phrase" name="old_pass_phrase" value="{$editForm.fields.passPhrase.fieldValue}" /></td>
					</tr>
					<tr>
						<td class="title"><label for="old_pass_phrase_confirm">{$smarty.const.TRANS_OLD_PASSPHRASE_CONFIRM}</label>:</td>
						<td><input type="password" style="width: 200px;" id="old_pass_phrase_confirm" name="old_pass_phrase_confirm" value="{$editForm.fields.passPhraseConfirm.fieldValue}" /></td>
					</tr>
					</tbody>
					</table>
					<br />
				{/if}
				
				{assign var="fieldName" value="lek_pin"}
				<h1>{$smarty.const.TRANS_SECRET_TO_REMEMBER}</h1>
				<table width="100%" class="list">
				<tbody>
				<tr>
					<td class="title"><label for="lek_pin">{$smarty.const.TRANS_LEK_PIN}</label>:</td>
					<td><input type="password" size="4" id="lek_pin" name="lek_pin" value="{$editForm.fields.lekPin.fieldValue}" onkeyup="if (this.value!=document.getElementById('{$fieldName}_confirm').value){literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_RED_MISMATCH}';{literal}}{/literal}else{literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_GREEN_MATCH}';{literal}}{/literal}" /></td>
				</tr>
				<tr>
					<td class="title"><label for="lek_pin_confirm">{$smarty.const.TRANS_LEK_PIN_CONFIRM}</label>:</th>
					<td><input type="password" size="4" id="lek_pin_confirm" name="lek_pin_confirm" value="{$editForm.fields.lekPinConfirm.fieldValue}" onkeyup="if (this.value!=document.getElementById('{$fieldName}').value){literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_RED_MISMATCH}';{literal}}{/literal}else{literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_GREEN_MATCH}';{literal}}{/literal}" />
					<span id="{$fieldName}_confirm_status"></span></td>
				</tr>
				</tbody>
				</table>
				<br />

				<h1>{$smarty.const.TRANS_HASH}</h1>
				<table width="100%" class="list">
				{if $editForm.fields.encryptionHash.fieldValue}
					<tr>
						<td class="title"><label for="encryption_hash">{$smarty.const.TRANS_OLD_LEK_HASH}</label>:</td>
						<td><textarea disabled="disabled" style="width: 300px;">{$editForm.fields.encryptionHash.fieldValue}</textarea></td>
					</tr>
				{/if}
				<tr>
					<td class="title"><label for="encryption_hash">{$smarty.const.TRANS_NEW_LEK_HASH}</label>:</td>
					<td><textarea style="width: 300px;" id="encryption_hash" name="encryption_hash">{$editForm.fields.encryptionHash.fieldValue}</textarea></td>
				</tr>
				</table>
			</fieldset>
		</td>
	</tr>
	</table>

</fieldset>

<br />

<fieldset>
	<legend>{$smarty.const.TRANS_PASSPHRASE_ENCRYPTION_SETTINGS}</legend>

	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
	<tr>
		<td>
			<fieldset>
				{assign var="fieldName" value="pass_phrase"}
				<legend style="color:blue">
					<input id="encryption_mode_passphrase" name="encryption_mode" value="passphrase" type="radio" {if $enabled && $passphrase_enabled}checked="checked" {/if}/>
					<label for="encryption_mode_passphrase">{$smarty.const.TRANS_PASSPHRASE2} *</label>
				</legend>
				<p style="color:blue">
				* {$smarty.const.TRANS_PASSPHRASE_DESC}
				</p>
				<br />
				<h1>{$smarty.const.TRANS_SECRET_TO_REMEMBER}</h1>
				<table width="100%" class="list">
				<tbody>
				<tr>
					<td class="title"><label for="pass_phrase">{$smarty.const.TRANS_PASSPHRASE}</label>:</td>
					<td><input type="password" style="width: 200px;" id="pass_phrase" name="pass_phrase" value="{$editForm.fields.passPhrase.fieldValue}" onkeyup="if (this.value!=document.getElementById('{$fieldName}_confirm').value){literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_RED_MISMATCH}';{literal}}{/literal}else{literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_GREEN_MATCH}';{literal}}{/literal}" /></td>
				</tr>
				<tr>
					<td class="td"><label for="pass_phrase_confirm">{$smarty.const.TRANS_CONFIRM}</label>:</td>
					<td><input type="password" style="width: 200px;" id="pass_phrase_confirm" name="pass_phrase_confirm" value="{$editForm.fields.passPhraseConfirm.fieldValue}" onkeyup="if (this.value!=document.getElementById('{$fieldName}').value){literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_RED_MISMATCH}';{literal}}{/literal}else{literal}{{/literal}document.getElementById('{$fieldName}_confirm_status').innerHTML='{$smarty.const.TRANS_GREEN_MATCH}';{literal}}{/literal}" />
					<span id="{$fieldName}_confirm_status"></span></td>				
				</tr>
				</tbody>
				</table>
			</fieldset>
		</td>
	</tr>
	</table>

</fieldset>

<br />
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
	<tr class="listButtons">
		<td><div>
<input class="submit" type="submit" value="{$smarty.const.TRANS_SUBMIT_CHANGES}" />
		</div></td>
	</tr>
	</table>
<br />

</form>

{include file="$tplDirectory/footer.tpl"}


