{* $Id: ShowConfigs.tpl 10464 2007-01-09 20:13:44Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of config groups and their params for editing.
 *
 * Smarty Variables:
 *	$configGroups (array of config group data)
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_NO_CHILDREN_FOUND" d="No children found."}
{t c="TRANS_CONFIGURATION_PARAMETERS" d="Configuration Parameters"}
{t c="TRANS_SAVE_SETTINGS" d="Save Settings"}
{t c="TRANS_PARAMETERS" d="Parameters"}
{t c="TRANS_SETTINGS_SAVED_SUCCESSFULLY" d="Settings Saved Successfully"}
{t c="TRANS_MANAGE_FRAUD_SETTINGS" d="Manage Fraud Settings"}

{php}
	$this->assign("cfg_icomenu", array(
		"TRANS_SYSTEM_SETTINGS" => "mnu_manage_sys_sett",
			"TRANS_MAIN_SYSTEM_SETTINGS" => "mnu_manage_sys_sett_main",
			"TRANS_ENCRYPTION_SETTINGS" => "mnu_manage_sys_sett_encryption",
			"TRANS_ADMIN_SETTINGS" => "mnu_manage_sys_sett_admin",
			"TRANS_MIGRATION_SETTINGS" => "mnu_manage_migrat",
			"TRANS_COMPANY_SETTINGS" => "mnu_manage_sys_sett_company",
			"TRANS_VERSIONS" => "mnu_manage_sys_sett_version",

		"TRANS_PAYMENT_SETTINGS" => "mnu_manage_payment",
			"TRANS_PAYMENT_GROUPS" => "mnu_manage_payment_groups",
			"TRANS_PAYMENT_QUEUE" => "mnu_manage_payment_queue",
			"TRANS_CLIENT_SIDE_PAYMENT_OPTIONS" => "mnu_manage_payment_client",
			"TRANS_VIRTUAL_TERMINALS" => "mnu_manage_payment_terminals",
		
		"TRANS_ORDER_SETTINGS" => "mnu_manage_order",
			"TRANS_ORDER_FORM_SETTINGS" => "mnu_manage_order_form",
			"TRANS_MANAGE_FRAUD_SETTINGS" => "mnu_manage_order_fraud",
			"TRANS_PPC_SETTINGS" => "mnu_manage_order_adv",
			"TRANS_CUSTOM_ATTRIBUTES" => "mnu_manage_order_attrib",
		
		"TRANS_SERVER_SETTINGS" => "mnu_manage_settings",
		
		"TRANS_PRODUCT_SETTINGS_CONFIGURATION" => "mnu_manage_prod",
			"TRANS_PRODUCT_SETTINGS" => "mnu_manage_prod_sett",
			"TRANS_PRODUCT_MANAGEMENT_SETTINGS" => "mnu_manage_prod_manag",
			"TRANS_CYCLE_SETTINGS" => "mnu_manage_prod_cycle",
		
		"TRANS_DOMAIN_SETTINGS" => "mnu_manage_domain",
			"TRANS_DOMAIN_TLD_SETTINGS" => "mnu_manage_domain_tld",
			"TRANS_DOMAIN_SYNC_SETTINGS" => "mnu_manage_domain_sync",
			"TRANS_REGISTRAR_MODULES" => "mnu_manage_domain_modul",

		"TRANS_BILLING_SETTINGS" => "mnu_manage_bill",
			"TRANS_INVOICE_SETTINGS" => "mnu_manage_bill_invoice",
			"TRANS_TAX_SETTINGS" => "mnu_manage_bill_tax",
			"TRANS_PREPAY_DISCOUNT_TIERS" => "mnu_manage_bill_prepay",
		
		"TRANS_EMAIL_SETTINGS" => "mnu_manage_email",
			"TRANS_EMAIL_TEMPLATE_GROUPS" => "mnu_manage_email_template",
		
		"TRANS_AUTOMATION_SETTINGS" => "mnu_manage_automat",
			"TRANS_SYSTEM_QUEUE_SETTINGS" => "mnu_manage_automat_queue",
			"TRANS_IP_QUEUE_SETTINGS" => "mnu_manage_automat_ip_queue",
			"TRANS_AUTOSUSPEND_SETTINGS" => "mnu_manage_automat_autosusp",
		
		"TRANS_USER_SETTINGS" => "mnu_manage_user",
			"TRANS_USER_SETTINGS" => "mnu_manage_user_sett",
			"TRANS_FORUMS_SETTINGS" => "mnu_manage_user_forum",
			"TRANS_THEME_SETTINGS" => "mnu_manage_user_theme",

		"TRANS_OTHER_SETTINGS" => "mnu_manage_other",
			"TRANS_FAQ_SETTINGS" => "mnu_manage_other_faq",
			"TRANS_NEWS_SETTINGS" => "mnu_manage_other_news",
			"TRANS_AFFILIATE_MODULES" => "mnu_manage_other_affiliate",
			"TRANS_FRAUD_MODULES" => "mnu_manage_other_fraud",
			"TRANS_PPC_MODULES" => "mnu_manage_other_ppc",
			"TRANS_SSL_MODULES" => "mnu_manage_other_ssl",
		));
{/php}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName=$configGroups[0].configGroupTransKey
	sideNavMajor="system"
	parentConfigGroupID=$configGroups[0].parentConfigGroupID}

{if $saved}
{include
	file="$tplDirectory/widgets/showInvalidCustom.tpl"
	duration="4"
	message=$smarty.const.TRANS_SETTINGS_SAVED_SUCCESSFULLY}
{/if}

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
{section name="i" loop=$configGroups}
	{assign var="configGroupTransKey" value=$configGroups[i].configGroupTransKey}
	{assign var="parentConfigGroupID" value=$configGroups[i].parentConfigGroupID}

    {******************* HEADER ROW *******************}
	<tr class="listRowNoBorders">
		<td>
            {strip}
			<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}">
				<img src="{$imageDirectory}/ico/arrow_left_blue.gif" width="16" height="16" alt="{$smarty.const.TRANS_PREVIOUS}" title="{$smarty.const.TRANS_PREVIOUS}" style="vertical-align:text-bottom;" />
			</a>
			<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}">
			{if $configGroupTransKey!="" && defined($configGroupTransKey)}
				{$smarty.const.$configGroupTransKey}
			{else}
				{$configGroupTransKey}
			{/if}
			</a>
            {/strip}
		</td>
	</tr>

	{section name=link loop=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup}
		{* create shorter variables names for easier usage below *}
		{assign var="configChildGroupTransKey" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupTransKey}
		{assign var="configChildGroupID" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupID}
		{assign var="configChildGroupActionFile" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupActionFile}
		{assign var="configChildGroupActionName" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupActionName}
		{if $className=="alt1"}
			{assign var="className" value="alt2"}
		{else}
			{assign var="className" value="alt1"}
		{/if}
		<tr>
			<td>
				{if $configChildGroupTransKey!="" && defined($configChildGroupTransKey)}
					{assign var="linkTitle" value=$smarty.const.$configChildGroupTransKey}
				{else}
					{assign var="linkTitle" value=$configChildGroupTransKey}
				{/if}
				{assign var="icomenuone" value=$cfg_icomenu[$configChildGroupTransKey]}
				{if $configChildGroupActionFile!="" && $configChildGroupActionName!=""}
					<a href="{getHREF page=$configChildGroupActionFile actionName=$configChildGroupActionName args="configGroupID=$configChildGroupID"}" class="inner">
						<img src="{$imageDirectory}/ico/{$icomenuone}.gif" width="16" height="16" alt="{$smarty.const.TRANS_NEXT}" title="{$smarty.const.TRANS_NEXT}" style="vertical-align:text-bottom;" />
					</a>
					<a href="{getHREF page=$configChildGroupActionFile actionName=$configChildGroupActionName args="configGroupID=$configChildGroupID"}" class="inner">
					{$linkTitle}
					</a>
				{else}
					<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="configGroupID=$configChildGroupID"}" class="inner">
						<img src="{$imageDirectory}/ico/{$icomenuone}.gif" width="16" height="16" alt="{$smarty.const.TRANS_NEXT}" title="{$smarty.const.TRANS_NEXT}" style="vertical-align:text-bottom;" />
					</a>
					<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="configGroupID=$configChildGroupID"}" class="inner">
					{$linkTitle}
					</a>
				{/if}
			</td>
		</tr>
	{sectionelse}
        {* NO USE FOR THIS YET -- BUT DO NOT REMOVE IT -- MF
		<tr>
			<td>{$smarty.const.TRANS_NO_CHILDREN_FOUND}</td>
		</tr>
        *}
	{/section}
{/section}
</table>

<br />

<form method="post" action="configs.php">
<input type="hidden" name="action" value="{getActionID action="EditConfigParamsResponse"}" />
<input type="hidden" name="adminGroupID" value="{$adminGroup.adminGroupID}" />
<input type="hidden" name="redirectURL" value="{$fileName}" />
<input type="hidden" name="redirectAction" value="{$actionName}" />
<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">

	{section name="i" loop="$configParams"}
	{assign var="configParamID" value=$configParams[i].configParamID}
	{assign var="configParamName" value=$configParams[i].configParamName}
	{assign var="configParamTransKey" value=$configParams[i].configParamTransKey}
	{assign var="configParamDescription" value=$configParams[i].configParamDescription}
	{if !$results}
		{assign var="results" value=1}
		<thead>
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="30%" headerName="TRANS_CONFIGURATION_PARAMETERS"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="40%" headerName="TRANS_VALUES"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="30%" headerName="TRANS_DESCRIPTION"}
		</tr>
		</thead>
	{/if}
	{if $className=="alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	{if $configParamTransKey!="" && defined($configParamTransKey)}
		{assign var="configTitle" value=$smarty.const.$configParamTransKey}
	{else}
		{assign var="configTitle" value=$configParamTransKey}
	{/if}
	<tr>
		<td valign="top" class="title">
			{$configTitle}:
		</td>
		<td class="nowrap">
			{* the ID must be passed as well! *}
			<input type="hidden" name="configParams[{$configParamName}][configParamID]" value="{$configParams[i].configParamID}" />
			{if !$configParams[i].configParamInputType || $configParams[i].configParamInputType=="t"}
				<input type="text" name="configParams[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="p"}
				<input type="password" name="configParams[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="a"}
				<textarea name="configParams[{$configParamName}][configParamValue]" cols="40" rows="3">{$configParams[i].configParamValue}</textarea>
			{elseif $configParams[i].configParamInputType=="s"}
				<select name="configParams[{$configParamName}][configParamValue]">
					{html_options options=$configParamValues[$configParamID] selected=$configParams[i].configParamValue}
				</select>
			{elseif $configParams[i].configParamInputType=="m"}
				<select name="configParams[{$configParamName}][configParamValue]" multiple="multiple">
					{html_options options=$configParamValues[$configParamID] selected=$configParams[i].configParamValue}
				</select>
			{elseif $configParams[i].configParamInputType=="c"}
				{html_checkboxes
					name="configParams[$configParamName][configParamValue]"
					options=$configParamValues[$configParamID]
					selected=$configParams[i].configParamValue
					separator="<br />"}
			{elseif $configParams[i].configParamInputType=="r"}
				{html_radios
					name="configParams[$configParamName][configParamValue]"
					options=$configParamValues[$configParamID]
					selected=$configParams[i].configParamValue
					separator="&nbsp;&nbsp;"}
			{else}
				<input type="text" name="configParam[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{/if}
		</td>
		<td>
			{if $configParamDescription!="" && defined($configParamDescription)}
				{assign var="caption" value=$smarty.const.TRANS_DESCRIPTION}
				{assign var="text" value=$smarty.const.$configParamDescription}
				{assign var="closetext" value=$smarty.const.TRANS_CLOSE}
				{strip}
	            <a href="javascript:void(0);" onclick="return XKol('{$text|addslashes}','{$caption}: {$configTitle}');">
					<img src="{$imageDirectory}/ico/help.gif" width="16" height="16" style="vertical-align:text-bottom;" />
	            </a>
	            {/strip}
			{else}
				<i>{$configParamDescription|default:$smarty.const.TRANS_NONE}</i>
			{/if}
		</td>
	</tr>
	{sectionelse}
		{assign var="results" value=0}
		<tr>
			<td colspan="3">{$smarty.const.TRANS_NO_CONFIG_PARAMS_FOUND}</td>
		</tr>
	{/section}
	{if $results==1}
		<tr class="listButtons">
			<td colspan="3"><div><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_SAVE_SETTINGS}" /></div></td>
		</tr>
	{/if}
	</table>

</form>

{include file="$tplDirectory/footer.tpl"}
