{* $Id: ShowDashboardNewOrders.tpl 10941 2007-03-30 20:07:51Z achrist $
 * --------------------------------------------------------------
 * This template displays a list of client records.
 *
 * Smarty Variables:
 *	$clients (array of clients that match input criteria)
 *		clientID			A unique client ID
 *		contactFirstName		A client's first name
 *		contactLastName		A client's last name
 *		contactEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$clientActive			The $_REQUEST value of clientActive filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 * Author: Ben Woolley
 *}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADD_NEW_CONTACT" d="Add new contact"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_CLIENT_ID" d="Client ID"}
{t c="TRANS_LAST_NOTE" d="Last Note"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_NO_NOTES" d="No Notes"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_PRIMARY_CONTACT" d="Primary Contact"}
{t c="TRANS_PHONE" d="Phone"}
{t c="TRANS_LAST_ACCESS" d="Last Access"}
{t c="TRANS_LAST_TICKET" d="Last Ticket"}
{t c="TRANS_ONLINE" d="Online"}
{t c="TRANS_OFFLINE" d="Offline"}
{t c="TRANS_SHOW_ALL_ADD_NEW" d="Show All/Add New"}
{t c="TRANS_ADD_NEW" d="Add New"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_ADDITIONAL_INFORMATION" d="Additional Information"}
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}

{t c="TRANS_ACTIVATE" d="Activate"}
{t c="TRANS_FRAUD" d="Fraud"}
{t c="TRANS_REVIEW" d="Review"}
{t c="TRANS_REJECT" d="Reject"}
{t c="TRANS_NO_NEW_ORDERS" d="No New Orders"}
{t c="TRANS_SET_CANCEL_ACTION" d="Set Cancel Action"}
{t c="TRANS_SUSPEND_PACKAGE_IF_PROVISIONED" d="suspend package if provisioned"}
{t c="TRANS_DELETE_PACKAGE_IF_PROVISIONED" d="delete package if provisioned"}

{assign var="filterArgs" value="clientActive=$clientActive&clientStatus=$clientStatus"}

<form method="post" action="clients.php">
<input type="hidden" name="action" value="{getActionID action="EditNewOrdersResponse"}" />
<input type="hidden" name="referralActionID" value="{getActionID action="ShowDashboardNewOrders"}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellpadding="0" cellspacing="0">
{section name=i loop="$clients"}
{assign var="clientID" value=$clients[i].clientID}
{assign var="trans_countriesISO2" value="TRANS_ISO_3166_`$clients[i].countriesISO2`"}
	<tr>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			<img src="{$imageDirectory}/flags/flag-{$clients[i].countriesISO2}.gif" style="vertical-align:middle;border-style:none;" /> {$smarty.const.$trans_countriesISO2|mb_truncate:15}
			<br />
			{$clients[i].clientDateCreated|getDateTime}
			<br />
			{if $clients[i].invoices[0]}				
				{$smarty.const.TRANS_INVOICE}: {$clients[i].invoices[0].invoiceAmount|getAmount:$clients[i].invoices[0].currencyID}
				{if $clients[i].invoices[0].invoiceStatus|getAPIStatusName:"invoice" == "closed"}
					{assign var="color" value="green"}
				{else}
					{assign var="color" value="red"}
				{/if}
				<font color="{$color}">
					{$clients[i].invoices[0].invoiceStatus|getStatusName:"invoice"}
				</font>
			{else}			
				{$smarty.const.TRANS_INVOICE}: <font color="red"><i>{$smarty.const.TRANS_UNKNOWN}</i></font>
			{/if}
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			{if $clients[i].clientCompany}
				{$clients[i].clientCompany|mb_truncate:22}
				<br />
			{/if}	
			{$clients[i].contactLastName|stripslashes|mb_truncate:12}, {$clients[i].contactFirstName|stripslashes|mb_truncate:12}
			<br />
			{$clients[i].contactEmail|mb_truncate:25}
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			{* COMING SOON
			<a href="javascript:void(0);" onclick="openwin('{getHREF page="clients.php" actionName="ShowNewOrderReview" args="clientID=$clientID"}',400,400,'clientID_{$clientID}');">{$smarty.const.TRANS_REVIEW|mb_truncate:10}</a>
			*}
			<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID&__print=1"}" target="_blank">{$smarty.const.TRANS_REVIEW|mb_truncate:10}</a>
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			<input type="checkbox" name="activate[]" id="cbx_activate_{$clientID}" value="{$clientID}" 
				onmouseup="cbx_register_click('activate', '{$clientID}');"
				onkeyup="cbx_register_click('activate', '{$clientID}');" />&nbsp;{$smarty.const.TRANS_ACTIVATE}
			<br />
			<input type="checkbox" name="cancel[]" id="cbx_cancel_{$clientID}" value="{$clientID}" 
				onmouseup="cbx_register_click('cancel', '{$clientID}');"
				onkeyup="cbx_register_click('cancel', '{$clientID}');" />&nbsp;{$smarty.const.TRANS_CANCEL}
			<br />
			<input type="checkbox" name="fraud[]" id="cbx_fraud_{$clientID}" value="{$clientID}"
				onmouseup="cbx_register_click('fraud', '{$clientID}');"
				onkeyup="cbx_register_click('fraud', '{$clientID}');" />&nbsp;{$smarty.const.TRANS_FRAUD}
		</td>
	</tr>
{sectionelse}
	<tr>
		<td colspan="4" style="text-align:center;"><i>{$smarty.const.TRANS_NO_NEW_ORDERS}</i></td>
	</tr>
{/section}
{if count($clients)>0}
	<tr>
		<td colspan="3" style="text-align:right;">
			<strong>{$smarty.const.TRANS_SET_CANCEL_ACTION}:</strong>
			&nbsp;
			<select name="cancelAction" style="width:150px;">
				<option value="suspend">{$smarty.const.TRANS_SUSPEND_PACKAGE_IF_PROVISIONED}</option>
				<option value="delete">{$smarty.const.TRANS_DELETE_PACKAGE_IF_PROVISIONED}</option>
			</select>
		</td>
		<td>
			<input type="submit" name="submitActivateClients" value="{$smarty.const.TRANS_SUBMIT}">
		</td>
	</tr>
{/if}
</table>

</form>
