{* $Id: ShowDashboardTodos.tpl 10248 2006-12-08 20:04:16Z eradtke $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template 
 * will eventually display less information about a to-do item than the ShowTodoDetails action; but 
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *
 * Author: Brian Smith
 *}
{t c="TRANS_MY_TODO_ITEMS" d="My Todo Items"}
{t c="TRANS_ASSIGNED" d="Assigned"}
{t c="TRANS_PAST_DUE" d="Past Due"}
{t c="TRANS_PUBLIC" d="Public"}

{* for todo assignments of certs *}
{t c="TRANS_TODO_BEGIN_CERT_REQUEST" d="Begin Cert Request"}
{t c="TRANS_TODO_BEGIN_CERT_REQUEST_MSG" d="Your SSL Certificate token has been purchased. Please continue to order the certificate."}

{foreach key=key item=title from=$todostatusheaders}
	<table width="100%" border="0" cellpadding="0" cellspacing="0" class="todoCapsule todoCapsule_{$key}">
	<thead>
		<tr>
			<th height="25"><img src="{$imageDirectory}/ico/note.gif" width="16" height="16" alt="" title="" style="vertical-align:middle;" /> {$title|upper}</th>
		</tr>
	</thead>
	<tbody>
	{foreach from=$todoAssignHeaders key=assignment item=todos_ptr}
		{assign var=todos_ptr value=$todos.$key.$assignment}
		<tr>
			<th height="25" class="{$assignment}">&#187; {$todoAssignHeaders.$assignment}</th>
		</tr>
		{cycle reset=true values="high1,high2" print=false}
		{foreach from=$todos_ptr item=todo}
			<tr class="{cycle values="high2,high1"}">
				<td class="{$assignment}">
					{if $todo.todoID != ''}
						&#187; <a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=`$todo.todoID`"}">{$todo.todoTitle|constant}</a><br />
						&nbsp;&nbsp;&nbsp;({$todo.todoDateDue|getDateTime:short})
					{/if}
				</td>
			</tr>
		{foreachelse}
			<tr class="{cycle value="high2,high1"}">
				<td><i>{$smarty.const.TRANS_NO_TODO_ITEMS}</i></td>
			</tr>
		{/foreach}
	{/foreach}
	</tbody>
	</table>
{/foreach}