{* $Id: EditDomainDNS.tpl 10831 2007-03-08 00:27:10Z achrist $
 * --------------------------------------------------------------
 * This template displays a single domain's DNS info editing.
 * This data is fetched from the registrar DIRECTLY! ModernBill does not store
 * this data!
 *
 * Smarty Variables:
 *	$domain (array of this domain's data in ModernBill)
 *	$listDNS (array of DNS records)
 *  $useDNS (1 if using the registrar as the name server)
 *  $dnsShowExtra (This is an experimental way to show 8 fields per domain.)
 *
 * Author: Andy Christ
 *}
{t c="TRANS_ACCESS_DNS_MSG" d="You can let the registrar act as your DNS by leaving useDNS set to yes"}
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_DOMAIN_DNS" d="Domain DNS"}
{t c="TRANS_DOMAIN_SERVER" d="Server"}
{t c="TRANS_DOMAIN_REGISTRAR_AS_DNS" d="User Registrar as DNS"}
{t c="TRANS_DOMAIN_DETAILS" d="Domain Details"}
{t c="TRANS_MANAGE_DOMAINS" d="Manage Domains"}
{t c="TRANS_SAVE_CHANGES" d="Save Changes"}
{t c="TRANS_USER_PASSWORD" d="User Password"}
{t c="TRANS_DOMAIN_DNS_ADVANCED" d="Advanced DNS Settings"}
{t c="TRANS_DOMAIN_DNS_ADVANCED_DESC" d="These settings are only used if this registrar is your DNS"}
{t c="TRANS_DOMAIN_DNS_HOSTNAME" d="Hostname"}
{t c="TRANS_DOMAIN_DNS_RECORD_TYPE" d="Record Type"}
{t c="TRANS_DOMAIN_DNS_ADDRESS" d="Address"}

{assign var="domainID" value=$domain.domainID}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_DOMAINS"
	childName="TRANS_ACCESS_PASSWORD"
	sideNavMajor="clients"
    sideNavMinor="domains"
    includeDomainJS=1}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}
{include file="$tplDirectory/widgets/context/client.tpl" client=$domain}


<script language="javascript" charset="UTF-8">
<!--
{literal}
function updateDNSformstate(x,y){
	for (i=0; i<document.EditDomainDNS.elements.length; i++){
		if (document.EditDomainDNS.elements[i].name){
			if (document.EditDomainDNS.elements[i].name.substring(0,9)=="domainDNS"){
				document.EditDomainDNS.elements[i].disabled = x;
			}
			if (document.EditDomainDNS.elements[i].name.substring(0,15)=="hostDNSHostname"){
				document.EditDomainDNS.elements[i].disabled = y;
			}
			if (document.EditDomainDNS.elements[i].name.substring(0,11)=="hostDNSType"){
				document.EditDomainDNS.elements[i].disabled = y;
			}
			if (document.EditDomainDNS.elements[i].name.substring(0,14)=="hostDNSAddress"){
				document.EditDomainDNS.elements[i].disabled = y;
			}
		}
	}
}
{/literal}
//-->
</script>

<hr size="1" color="#444444" />

<strong><a href="{getHREF page="domains.php" actionName="ShowDomainDetails" args="domainID=$domainID"}">{$domain.domainSLD}.{$domain.domainTLD}</a></strong>

<br />

<form method="post" action="domains.php" name="EditDomainDNS">
<input type="hidden" name="action" value="{getActionID action="EditDomainDNSResponse"}" />
<input type="hidden" name="domainID" value="{$domainID}" />
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="useDNSOld" value="{$useDNS}" />

<fieldset>
<legend>{$smarty.const.TRANS_DOMAIN_DNS}</legend>

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tr>
	<td class="title">{$smarty.const.TRANS_DOMAIN_REGISTRAR_AS_DNS}</td>
	<td>
		<input type="radio" value="0"{if $useDNS != 1} checked="checked"{/if} onclick="updateDNSformstate(false,true);" name="useDNS"> {$smarty.const.TRANS_NO}
		<input type="radio" value="1" onclick="updateDNSformstate(true,false);" name="useDNS"{if $useDNS} checked="checked"{/if}> {$smarty.const.TRANS_YES}</td>
</tr>

{section name="i" loop="$listDNS"}
	<tr>
		<td class="title">{$smarty.const.TRANS_DOMAIN_SERVER} {$smarty.section.i.index+1}</td>
		<td><input type="text"{if $useDNS} disabled="disabled"{/if} name="domainDNS[]" value="{$listDNS[i]}" size="40" /></td>
	</tr>

{sectionelse}
<!--List 8 input boxes but only enable them if the UseDNS is set to no meaning that Use the registrar as DNS server is no-->
{/section}

{section name="j" loop="$dnsShowExtra"}
	<tr>
		<td class="title">{$smarty.const.TRANS_DOMAIN_SERVER} {$smarty.section.j.index+$dnsCount+1}</td>
		<td><input type="text"{if $useDNS} disabled="disabled"{/if} name="domainDNS[]" value="" size="40" /></td>
	</tr>
{/section}

{if $dnsOptions}
	<tr>
		<td colspan="2">{$smarty.const.TRANS_DOMAIN_DNS_ADVANCED}</td>
	</tr>
	<tr>
		<td colspan="2">{$smarty.const.TRANS_DOMAIN_DNS_ADVANCED_DESC}</td>
	</tr>

	<tr>
	<td colspan="2">

	<table width="60%">
		
				<tr>
					<td>
					</td>

					<td>
						{$smarty.const.TRANS_DOMAIN_DNS_HOSTNAME}
					</td>

					<td>
						{$smarty.const.TRANS_DOMAIN_DNS_RECORD_TYPE}
					</td>

					<td>
						{$smarty.const.TRANS_DOMAIN_DNS_ADDRESS}
					</td>
				</tr>
				{section name="k" loop="$hostLoop"}
					{assign var="hostRecord" value=$host[k]}
					<tr>
						<td>{$smarty.section.k.index+1}</td>
						<td>{if $hostRecord.name}
								{$hostRecord.name}
								<input type="hidden" name="hostDNSHostname[]" value="{$hostRecord.name}">
							{else}
								<input type="text" {if !$useDNS} disabled="disabled"{/if} name="hostDNSHostname[]">
							{/if}
						</td>
						<td class="title">
							{html_options name=hostDNSType[]
							options=$dnsOptions selected=$hostRecord.type}
						</td>
						<td><input type="text"{if !$useDNS} disabled="disabled"{/if} name="hostDNSAddress[]" value="{$hostRecord.address}" size="20" /></td>
					</tr>
		
				{/section}
		</table>

		</td>
		</tr>
{/if}
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
	</table>

<br /><br />
{$smarty.const.TRANS_ACCESS_DNS_MSG}
<br /><br />

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tr class="listButtons"><td><div><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_SAVE_CHANGES}" /></div></td></tr>
</table>

</fieldset>>

</form>

{include file="$tplDirectory/footer.tpl"}
