{* $Id: ShowDomainDetails.tpl 7622 2006-06-19 20:37:05Z bsmith $
 * --------------------------------------------------------------
 * This template displays a single domain's details.
 *
 * Smarty Variables:
 *	$domain (array of this domain's data & this domain's client data)
 *  $capabilities (array of management options this domain's registrar is capable of)
 *       domainGetRenewDate
 *       domainContact
 *       domainRenewType
 *       domainLock
 *       domainPassword
 *       domainDNS
 *       domainLiveRenew
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_DATE_EXPIRES" d="Date Expires"}
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_DOMAIN_DETAILS" d="Domain Details"}
{t c="TRANS_DOMAIN_UTILITITES" d="Domain Utilities"}
{t c="TRANS_EDIT_CONTACT_WHOIS_INFORMATION" d="Edit Contact/Whois Information for this domain"}
{t c="TRANS_MANAGE_DOMAINS" d="Manage Domains"}
{t c="TRANS_RENEW" d="renew"}
{t c="TRANS_SET_AUTO_RENEW_OPTIONS" d="Set Auto-Renew Options for this domain"}
{t c="TRANS_SET_DOMAIN_ACCESS_PASSWORD" d="Set Domain Access Password"}
{t c="TRANS_SET_REGISTRAR_LOCK_OPTIONS" d="Set Registrar-Lock Options for this domain"}
{t c="TRANS_SYNCRONIZE" d="syncronize"}
{t c="TRANS_SET_DNS" d="Set DNS for this domain"}

{assign var="domainID" value=$domain.domainID}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_DOMAINS"
	childName="TRANS_DOMAIN_DETAILS"
	sideNavMajor="clients"
    sideNavMinor="domains"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}
{include file="$tplDirectory/widgets/context/client.tpl" client=$domain suppressEditLink=1 suppressDeleteLink=1}

<hr size="1" color="#444444" />

<fieldset>
<legend><a href="{getHREF page="domains.php" actionName="ShowDomainDetails" args="domainID=$domainID"}">{$domain.domainSLD}.{$domain.domainTLD}</a></legend>
{if $domainStillPending == 0}
&raquo; {$smarty.const.TRANS_DATE_CREATED}: {$domain.domainDateCreated|getDate}
<br />
&raquo; {$smarty.const.TRANS_DATE_EXPIRES}: {$domain.domainDateExpires|getDate}

	{if $capabilities.domainGetRenewDate}
	[<a href="{getHREF page="domains.php" actionName="SyncDomainDates" args="domainID=$domainID"}">{$smarty.const.TRANS_SYNCRONIZE}</a>]
	{/if}
	{if $capabilities.domainLiveRenew}
	[<a href="{getHREF page="domains.php" actionName="RenewDomain" args="domainID=$domainID"}">{$smarty.const.TRANS_RENEW}</a>]
	<br />
	{/if}
	<br />
	<fieldset>
	<legend>{$smarty.const.TRANS_DOMAIN_UTILITITES}</legend>
	{if $capabilities.domainContact}
	&raquo; <a href="{getHREF page="domains.php" actionName="EditDomainContactData" args="domainID=$domainID"}">{$smarty.const.TRANS_EDIT_CONTACT_WHOIS_INFORMATION}</a>
	<br />
	{/if}
	{if $capabilities.domainRenewType}
	&raquo; <a href="{getHREF page="domains.php" actionName="EditDomainRenewTypeOptions" args="domainID=$domainID"}">{$smarty.const.TRANS_SET_AUTO_RENEW_OPTIONS}</a>
	<br />
	{/if}
	{if $capabilities.domainLock}
	&raquo; <a href="{getHREF page="domains.php" actionName="EditDomainRegistrarLockOptions" args="domainID=$domainID"}">{$smarty.const.TRANS_SET_REGISTRAR_LOCK_OPTIONS}</a>
	<br />
	{/if}
	{if $capabilities.domainPassword}
	&raquo; <a href="{getHREF page="domains.php" actionName="EditDomainAccessPassword" args="domainID=$domainID"}">{$smarty.const.TRANS_SET_DOMAIN_ACCESS_PASSWORD}</a>
	<br />
	{/if}
	{if $capabilities.domainDNS}
	&raquo; <a href="{getHREF page="domains.php" actionName="EditDomainDNS" args="domainID=$domainID"}">{$smarty.const.TRANS_SET_DNS}</a>
	<br />
	{/if}
	</fieldset>
{/if}
</fieldset>
{include file="$tplDirectory/footer.tpl"}