{* $Id: EditEmail.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of emails in the email queue. From this list, the user should be able to add, edit, or 
 * remove items from the queue, and also run items in the queue. All of these actions can be accessed via events.php, and 
 * their action names are as follows:
 *   AddEmail
 *   EditEmail
 *   RemoveEmail
 *   RunEmailQueue
 *
 * Smarty Variables:
 *	$emails (an array of all emails available to this display)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	  
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Vic Fryzel
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_CREATED" d="Created"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FROM" d="From"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_MANAGE_EMAILS" d="Manage Emails"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_RUN" d="Run"}
{t c="TRANS_SENT" d="Sent"}
{t c="TRANS_SHOW_EMAILS" d="Show Emails"}
{t c="TRANS_SUBJECT" d="Subject"}

{assign var="filterArgs" value="isActive=$isActive"}

{include file="$tplDirectory/header.tpl" parentName="TRANS_MANAGE_EMAILS" childName="TRANS_SHOW_EMAILS"
	sideNavMajor="events"}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
<tr>
	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_ID" sortColumn="emailID"}
	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_FROM"
		sortColumn="emailFromAddress"}
	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_SUBJECT"
		sortColumn="emailSubject"}
	{include file="$tplDirectory/widgets/table/tableSortDateHeader.tpl" headerName="TRANS_CREATED"
		sortColumn="dateCreated"}
	{include file="$tplDirectory/widgets/table/tableSortDateHeader.tpl" headerName="TRANS_SENT"
		sortColumn="dateSent"}
	{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
</tr>
{section name=i loop="$emails"}
{assign var="emailID" value=$emails[i].emailID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tr class="{cycle values="alt1,alt2"}">
	<td onmouseover="this.style.cursor='hand'" onclick="return XKtoggle('row_{$emailID}');">
		<a href="#">{$emailID}</a>
	</td>
	<td>
		{if ($emails[i].emailFromName)}
			{$emails[i].emailFromName} <{$emails[i].emailFromAddress}>
		{else}
			{$emails[i].emailFromAddress}
		{/if}
	</td>
	<td>
		{$emails[i].emailSubject}
	</td>
	<td>
		{$emails[i].dateCreated|getDate}
	</td>
	<td>
		{$emails[i].dateSent|getDate}
	</td>
	<td>
		{strip}
		<a href="{getHREF page="events.php" actionName="showEventDetails" args="emailID=$emailID"}">
			<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0"
				alt="{$smarty.const.TRANS_DETAILS}" />
		</a>
		&nbsp;
		<a href="{getHREF page="events.php" actionName="editEvent" args="emailID=$emailID"}">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0"
				alt="{$smarty.const.TRANS_EDIT}" />
		</a>
		&nbsp;
		<a href="{getHREF page="events.php" actionName="removeEvent" args="emailID=$emailID"}">
			<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0"
				alt="{$smarty.const.TRANS_REMOVE}" />
		</a>
		{/strip}
	</td>
</tr>
<tbody id="row_{$emailID}">
<tr>
	<td colspan="7" class="althover">
			<a href="{getHREF page="events.php" actionName="RunEmailQueue" args="emailID=$emailID"}" target="_blank">
				{$smarty.const.TRANS_RUN}
			</a>
			<br />
			emailBody: {$emails[i].emailBody}
	</td>
</tr>
</tbody>
<script type="text/JavaScript">XKtoggle('row_{$emails[i].emailID}');</script>
{sectionelse}
<tr class="alt1">
	<td colspan="7">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
