 {* Smarty Variables:
 *	$event (array of this event's data)
 *     systemQueueID  -  The ID of this system queue event
 *     packageID
 *     configGroupID
 *     serverGroupID
 *     systemQueueParentID
 *     systemQueueStatus
 *     systemQueueCommand  -  The name of the MBAPI command that will be run by this system queue event.
 *     systemQueueCommandInput  -  The actual XML input to the MBAPI.
 *     systemQueueMinute  -  The number of minutes to add to the date to run every time a recurring event is regenerated.
 *     systemQueueHour  -  The number of hours to add to the date to run every time a recurring event is regenerated.
 *     systemQueueDay  -  The number of days to add to the date to run every time a recurring event is regenerated.
 *     systemQueueMonth  -  The number of months to add to the date to run every time a recurring event is regenerated.
 *     systemQueueYear  -  The number of years to add to the date to run every time a recurring event is regenerated.
 *     systemQueueIsRecurring  -  1 if this system queue event is recurring, or 0 if otherwise.
 *     systemQueueDateToRun  -  The UNIX timestamp for which this system queue event is scheduled to run.
 *     systemQueueDateCreated  -  The UNIX timestamp for which this system queue event was created.
 *     systemQueueDateStarted  -  The UNIX timestamp for which this system queue event was started.
 *     systemQueueDateFinished  -  The UNIX timestamp for which this system queue event was finished.
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $statusList				List of Queue Stati
 *
 * Author: Vic Fryzel
 *}
{t c="TRANS_EVENTS" d="Events"}
{t c="TRANS_MANAGE_EVENTS" d="Manage Events"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_TIME" d="Time"}
{t c="TRANS_TIME_DESC" d="To run an item every 5 minutes, set Minute to 5.  To run an item every 2 hours, set Hour to 2.  So the number in each setting will add to the next time this item runs.  Month of 2 will run an item every two months"}

{include file="$tplDirectory/header.tpl" parentName="TRANS_MANAGE_EVENTS" childName="TRANS_EVENTS"
	grandchildName="TRANS_EDIT" sideNavMajor="events" sideNavMinor="events"}

<form method="post" action="events.php">
<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >

	<input type="hidden" name="systemQueueID" value="{$event.systemQueueID}" />
	<input type="hidden" name="sid" value="{$sid}" />
	<input type="hidden" name="action" value="{getActionID action="EditEventResponse"}">

<tr {if $invalid.packageID}class="highlight"{/if}>
	<td class="title"><label for="packageID">{$smarty.const.TRANS_PACKAGE_ID}</label></td>
	<td><input type="text" name="packageID" size="2" value="{$event.packageID}" /> {$invalid.packageID}</td>
</tr>
<tr {if $invalid.configGroupID}class="highlight"{/if}>
	<td class="title"><label for="configGroupID">{$smarty.const.TRANS_MODULE_ID}</label></td>
	<td><input type="text" name="configGroupID" size="2" value="{$event.configGroupID}" /> {$invalid.configGroupID}</td>
</tr>

<tr {if $invalid.serverGroupID}class="highlight"{/if}>
	<td class="title"><label for="serverGroupID">{$smarty.const.TRANS_SERVER_GROUP_ID}</label></td>
	<td><input type="text" name="serverGroupID" size="2" value="{$event.serverGroupID}" /> {$invalid.serverGroupID}</td>
</tr>

<tr {if $invalid.systemQueueParentID}class="highlight"{/if}>
	<td class="title"><label for="systemQueueParentID">{$smarty.const.TRANS_PARENT_ID}</label></td>
	<td><input type="text" name="systemQueueParentID" size="2" value="{$event.systemQueueParentID}" /> {$invalid.systemQueueParentID}</td>
</tr>

<tr {if $invalid.systemQueueStatus}class="highlight"{/if}>
	<td class="title"><label for="clientStatus">{$smarty.const.TRANS_STATUS}</label></td>
	<td><select id="systemQueueStatus" id="systemQueueStatus" name="systemQueueStatus"> {html_options options=$statusList selected=$event.systemQueueStatus} </select> {$invalid.systemQueueStatus}</td>
</tr>

<tr {if $invalid.systemQueueCommand}class="highlight"{/if}>
	<td class="title"><label for="systemQueueCommand">{$smarty.const.TRANS_QUEUE_COMMAND}</label></td>
	<td><input type="text" name="systemQueueCommand" size="25" value="{$event.systemQueueCommand}" /> {$invalid.systemQueueCommand}</td>
</tr>

<tr {if $invalid.systemQueueCommandInput}class="highlight"{/if}>
	<td class="title"><label for="systemQueueCommandInput">{$smarty.const.TRANS_QUEUE_INPUT}</label></td>
	<td><textarea name="systemQueueCommandInput" style="width:90%" rows="10">{$event.systemQueueCommandInput}</textarea> {$invalid.systemQueueCommandInput}</td>
</tr>

<tr {if $invalid.systemQueueIsRecurring}class="highlight"{/if}>
	<td class="title"><label for="systemQueueIsRecurring">{$smarty.const.TRANS_IS_RECURRING}</label></td>
	<td><select id="systemQueueIsRecurring" id="systemQueueIsRecurring" name="systemQueueIsRecurring"> {html_options options=$yesNo selected=$event.systemQueueIsRecurring} </select> {$invalid.systemQueueIsRecurring}</td>
</tr>


			{if $event.systemQueueIsRecurring}

<tr {if $invalid.systemQueueTime}class="highlight"{/if}>
	<td><label for="systemQueueTime">{include file="$tplDirectory/widgets/showTips.tpl"
        title="TRANS_TIME"
        msg="TRANS_TIME_DESC"
        width="100%"
        align="center"}</label></td>
	<td>

	<table>
		<tr valign="top">
			<td>Minute:</td><td>Hour:</td><td>Day:</td><td>Month:</td><td>Year:</td>
		</tr>
		<tr valign="top">
			<td>
				<input type="text" name="systemQueueMinute" size="4" value="{$event.systemQueueMinute}" />
			</td>
			<td>
				<input type="text" name="systemQueueHour" size="4" value="{$event.systemQueueHour}" />
			</td>
			<td>
				<input type="text" name="systemQueueDay" size="4" value="{$event.systemQueueDay}" />
			</td>
			<td>
				<input type="text" name="systemQueueMonth" size="4" value="{$event.systemQueueMonth}" />
			</td>
			<td>
				<input type="text" name="systemQueueYear" size="4" value="{$event.systemQueueYear}" />
			</td>
		</tr>
	</table>

</td>
</tr>
			{else}

				<!--Use the editor on the list screen-->

			{/if}
			<br />
			
<tr class="listButtons">
	<td colspan="2"><div><input class="submit" type="submit" name="submit" value="submit"></div></td>
</tr>

</table>
</form>
{include file="$tplDirectory/footer.tpl"}