{* $Id: RemoveEmail.tpl 8729 2006-09-08 15:29:03Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to remove an email from the email queue.
 *
 * Smarty Variables:
 *	$email (array of this email's data)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Vic Fryzel
 *}{strip}
{t c="TRANS_EMAILS" d="Emails"}
{t c="TRANS_MANAGE_EMAILS" d="Manage Emails"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_REMOVE_EMAILS" d="Remove Email(s)"}
{/strip}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EMAILS"
	childName="TRANS_SHOW_EMAILS"
	sideNavMajor="events"}

<fieldset>
<legend>{$smarty.const.TRANS_REMOVE_EMAILS}</legend>
	
<table border="0" cellpadding="0" cellspacing="0" class="list" width="100%">
<tr>
	<td>
		{if $email.0.emailID}
			<table>
			{foreach from=$email item=eml}
				<tr>
					<td>{$eml.emailID}</td>
					<td>{$eml.emailSubject}</td>
				</tr>
			{/foreach}
			</table>
		{else}
			#{$email.emailID}?
		{/if}
	</td>
</tr>
<tr class="listButtons">
	<td><div>
		<form method="post" action="events.php" style="display:inline;">
			<input type="hidden" name="action" value="{getActionID action="RemoveEmailResponse"}" />
			{if $email.0.emailID}
				{foreach from=$email item=eml}
					<input type="hidden" name="emailIDs[]" value="{$eml.emailID}" />
				{/foreach}
			{else}
				<input type="hidden" name="emailID" value="{$email.emailID}" />
			{/if}
			<input type="hidden" name="sid" value="{$sid}" />
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_YES}" />
		</form>
		<form method="get" action="events.php" style="display:inline;">
			
			<input type="hidden" name="sid" value="{$sid}" />
			{if $email.0.emailID}
				<input type="hidden" name="action" value="{getActionID action="ShowEmailQueue"}" />
			{else}
				<input type="hidden" name="action" value="{getActionID action="ShowEmailDetails"}" />
				<input type="hidden" name="emailID" value="{$email.emailID}" />
			{/if}
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_NO}"><br />
		</form>
	</div></td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}