{* $Id: RemoveEvent.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of all events in the system queue. From this template, a user should be able to 
 * display, edit, delete, and run or stop events in the system queue.
 *
 * Smarty Variables:
 *  $event  -  The event that match input criteria. Every item in this array is an array representing an event,
 *              structure as follows:
 *    systemQueueID  -  The ID of this system queue event.
 *    systemQueueCommand  -  The MBAPI command that this system queue event will be executing.
 *    systemQueueCommandInput  -  The full XML input for the MBAPI command to be run.
 *
 *    (The following parameters only affect recurring items in the queue.)
 *    systemQueueMinute  -  The frequency of minutes with which to run this event (5 would be every 5 minutes)
 *    systemQueueHour  -  The frequency of hours with which to run this event (7 would be every 7 hours)
 *    systemQueueDay  -  The frequency of days with which to run this event (170 would be every 170 days)
 *    systemQueueMonth  -  The frequency of months with which to run this event
 *    systemQueueYear  -  The frequency of years with which to run this event
 *
 *    isRecurring  -  1 if this event is recurring, or 0 if otherwise
 *    dateCreated  -  The UNIX timestamp for which this event was created
 *    dateStarted  -  The UNIX timestamp for which this event was started
 *    dateFinished  -  The UNIX timestamp for which this event was finished
 *
 *
 *  $actionID  -  The unique action ID for this page view
 *  $actionName  -  The action name for this action ID
 *  $imageDirectory  -  The image directory for this theme
 *  $tplDirectory  -  The template directory for this theme
 *  $sid  -  The current sessionID
 *
 * Author: Brian Smith
 *}
{strip}
{t c="TRANS_REMOVE_EVENT" d="Remove Event"}
{t c="TRANS_TO_RUN" d="To Run"}
{t c="TRANS_DATE_STARTED" d="Date Started"}
{t c="TRANS_DATE_FINISHED" d="Date Finished"}
{/strip}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EVENTS"
	childName="TRANS_REMOVE_EVENT"

	sideNavMajor="events"
	sideNavMinor="events"}
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_COMMAND"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_DATE_CREATED"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_TO_RUN"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_DATE_STARTED"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_DATE_FINISHED"}
</tr>
</thead>

<tbody>
<tr onClick="XKtoggle('rowInput');">
	<td>{$event.systemQueueID}</td>
	<td>{$event.systemQueueCommand}</td>
	<td>{$event.systemQueueDateCreated|getDateTime}</td>
	<td>{$event.systemQueueDateToRun|getDateTime}</td>
	<td>{$event.systemQueueDateStarted|getDateTime}</td>
	<td>{$event.systemQueueDateFinished|getDateTime}</td>
</tr>
</tbody>

<tbody id="rowInput">
<tr>
	<td colspan="6">
		{$event.systemQueueCommandInput|nl2br}
	</td>
</tr>
</tbody>

<tbody>
<tr class="listButtons">
	<td colspan="6"><div>
		<form action="events.php" method="post" style="display:inline;">
		<input type="hidden" name="action" value="{getActionID action="RemoveEventResponse"}" />
		<input type="hidden" name="systemQueueID" value="{$event.systemQueueID}" />
		<input type="hidden" name="sid" value="{$sid}" />
		<input type="submit" class="submit" value="{$smarty.const.TRANS_REMOVE}" />
		</form>
		<form action="events.php" method="post" style="display:inline;">
		<input type="hidden" name="action" value="{getActionID action="ShowEvents"}" />
		<input type="hidden" name="sid" value="{$sid}" />
		<input type="submit" class="submit" value="{$smarty.const.TRANS_CANCEL}" />
		</form>
	</div></td>
</tr>
</tbody>
</table>
<script language="javascript">
//<[[CDATA][
XKtoggle("rowInput");
//]]>
</script>
{include file="$tplDirectory/footer.tpl"}
