{* $Id: ResendEmail.tpl 8395 2006-08-21 23:53:51Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to remove an email from the email queue.
 *
 * Smarty Variables:
 *	$email (array of this email's data)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Brian Smith
 *}

{t c="TRANS_RESEND" d="Resend"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EMAILS"
	childName="TRANS_SHOW_EMAILS"
	grandchildName="TRANS_RESEND"

	sideNavMajor="events"
	sideNavMinor="emails"}

<form action="events.php" method="post">
<input type="hidden" name="action" value="{getActionID action="ResendEmailResponse"}" />
<input type="hidden" name="emailID" value="{$email.emailID}" />
<input type="hidden" name="sid" value="{$sid}" />

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="10%" headerName="TRANS_ID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="20%" headerName="TRANS_FROM"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="20%" headerName="TRANS_SUBJECT"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="20%" headerName="TRANS_CREATED"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="10%" headerName="TRANS_SENT"}
	
</tr>
</thead>
<tbody>
<tr class="alt1">
	<td>{$email.emailID}</td>
	<td>
		{if ($email.emailFromName)}
			{$email.emailFromName} &lt;{$email.emailFromAddress}&gt;
		{else}
			{$email.emailFromAddress|default:$smarty.const.TRANS_EMPTY|stripslashes|mb_truncate:20}
		{/if}
	</td>
	<td>
		{$email.emailSubject|default:$smarty.const.TRANS_EMPTY|stripslashes|mb_truncate:25}
	</td>
	<td>
		{$email.emailDateCreated|getDateTime:long}
	</td>
	<td class="nowrap">
		{$email.emailDateSent|getDateTime:long}
	</td>
</tr>
</tbody>
</table>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tr class="listButtons">
	<td><div>
		<input type="submit" class="submit" value="{$smarty.const.TRANS_RESEND}" />
		<input type="button" class="button" value="{$smarty.const.TRANS_CANCEL}" onClick="javascript:document.location.href='{getHREF page="events.php" actionName="ShowEmailQueue"}'" />
	</div></td>
</tr>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}
