{* $Id: ShowEmailDetails.tpl 12424 2008-01-03 21:25:24Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to remove an email from the email queue.
 *
 * Smarty Variables:
 *	$email (array of this email's data)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Brian Smith
 *}{strip}
{t c="TRANS_EMAILS" d="Emails"}
{t c="TRANS_MANAGE_EMAILS" d="Manage Emails"}
{t c="TRANS_VIEW_EMAIL_DETAILS" d="View Email Details"}

{t c="TRANS_EMAIL_ADDRESS_DESTINATIONS" d="Email Address Destinations"}
{t c="TRANS_SUCCESS" d="Success"}
{t c="TRANS_HEADERS" d="Headers"}
{t c="TRANS_ATTACHMENTS" d="Attachments"}
{t c="TRANS_EMAIL_ID" d="Email ID"}
{t c="TRANS_EDIT_EMAIL" d="Edit Email"}

{/strip}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EMAILS"
	childName="TRANS_SHOW_EMAILS"
	sideNavMajor="events"}

<fieldset>
<legend>{$smarty.const.TRANS_VIEW_EMAIL_DETAILS}</legend>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_ID}</td>
	<td>
		<strong>{$email.emailID}</strong>
		{* RESEND *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="ResendEmail"
			args="emailID=`$email.emailID`"
			icoImage="014.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_RESEND"
			titleText=""
			linkText="TRANS_RESEND"
			noSpace="1"}

		{* EDIT AND SEND *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="SendClientEmail"
			args="emailID=`$email.emailID`"
			icoImage="edit"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_EDIT_EMAIL"
			titleText=""
			linkText="TRANS_EDIT_EMAIL"
			noSpace="1"}
	
	</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_FROM_NAME}</td>
	<td>{$email.emailFromName}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_FROM_ADDRESS}</td>
	<td>{$email.emailFromAddress}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_STATUS}</td>
	<td>
		{if $email.emailSent == 1}
			<font color="green">{$smarty.const.TRANS_SUCCESS}</font>
		{/if}
		{if $email.emailFailed == 1}
			<font color="red">{$smarty.const.TRANS_FAILURE}</font>
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_DATE_CREATED}</td>
	<td>{$email.emailDateCreated|getDateTime:long}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_SENT}</td>
	<td>{$email.emailDateSent|getDateTime:long}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_ACTIVE}</td>
	<td>{$email.emailActive|getArrayValueByID:$yesNo}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_ADDRESS_DESTINATIONS}</td>
	<td>
		{if $email.emailToAddresses}
			<ul style="list-style:none;padding:0;">
				{foreach from=$email.emailToAddresses.0.emailToAddress item=to}
					{if $to.emailAddressName}
						<li>"{$to.emailAddressName}" &lt;{$to.emailAddress}&gt;</li>
					{else}
						<li>{$to.emailAddress}</li>
					{/if}
				{foreachelse}
					<li>{$smarty.const.TRANS_NORESULTS}</li>
				{/foreach}
			</ul>
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_CC_ADDRESS}</td>
	<td>{if $email.emailCCAddresses}
		<ul style="list-style:none;padding:0;">
		{foreach from=$email.emailCCAddresses.0.emailCCAddress item=cc}
			{if $cc.emailAddressName}
				<li>"{$cc.emailAddressName}" &lt;{$cc.emailAddress}&gt;</li>
			{else}
				<li>{$cc.emailAddress}</li>
			{/if}
		{/foreach}
		</ul>
		{else}
			{$smarty.const.TRANS_NORESULTS}
		{/if}</td>
	</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_BCC_ADDRESS}</td>
	<td>{if $email.emailBCCAddresses}
		<ul style="list-style:none;padding:0;">
		{foreach from=$email.emailBCCAddresses.0.emailBCCAddress item=bcc}
			{if $bcc.emailAddressName}
				<li>"{$bcc.emailAddressName}" &lt;{$bcc.emailAddress}&gt;</li>
			{else}
				<li>{$bcc.emailAddress}</li>
			{/if}
		{/foreach}
		</ul>
		{else}
			{$smarty.const.TRANS_NORESULTS}
		{/if}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_REPLY_ADDRESS}</td>
	<td>{if $email.emailReplyToAddresses}
		<ul style="list-style:none;padding:0;">
		{foreach from=$email.emailReplyToAddresses.0.emailReplyToAddress item=reply}
			{if $reply.emailAddressName}
				<li>"{$reply.emailAddressName}" &lt;{$reply.emailAddress}&gt;</li>
			{else}
				<li>{$reply.emailAddress}</li>
			{/if}
		{foreachelse}
			<li>{$smarty.const.TRANS_NORESULTS}</li>
		{/foreach}
		</ul>
	{else}
		{$smarty.const.TRANS_NORESULTS}
	{/if}
	</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_ATTACHMENTS}</td>
	<td>{$email.emailAttachments}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_HEADERS}</td>
	<td>
		{if $email.emailHeaders}
			<ul style="list-style:none;padding:0;">
				{foreach from=$email.emailHeaders item=header}
					<li>{$header.emailHeader}</li>
				{foreachelse}
					<li>{$smarty.const.TRANS_NORESULTS}</li>
				{/foreach}
			</ul>
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_MESSAGE_SUBJECT}</td>
	<td>{$email.emailSubject}</td>
</tr>

<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_MESSAGE_BODY}</td>
	<td>{$email.emailBody|html_entity_decode}</td>
</tr>

</tbody>
</table>
</fieldset>
{include file="$tplDirectory/footer.tpl"}


