{* $Id: ShowEvents.tpl 11979 2007-09-26 17:41:31Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of all events in the system queue. From this template, a user should be able to 
 * display, edit, delete, and run or stop events in the system queue.
 *
 * Smarty Variables:
 *  $events  -  An array of events that match input criteria. Every item in this array is an array representing an event,
 *              structure as follows:
 *    systemQueueID  -  The ID of this system queue event.
 *    systemQueueCommand  -  The MBAPI command that this system queue event will be executing.
 *    systemQueueCommandInput  -  The full XML input for the MBAPI command to be run.
 *
 *    (The following parameters only affect recurring items in the queue.)
 *    systemQueueMinute  -  The frequency of minutes with which to run this event (5 would be every 5 minutes)
 *    systemQueueHour  -  The frequency of hours with which to run this event (7 would be every 7 hours)
 *    systemQueueDay  -  The frequency of days with which to run this event (170 would be every 170 days)
 *    systemQueueMonth  -  The frequency of months with which to run this event
 *    systemQueueYear  -  The frequency of years with which to run this event
 *
 *    isRecurring  -  1 if this event is recurring, or 0 if otherwise
 *    dateCreated  -  The UNIX timestamp for which this event was created
 *    dateStarted  -  The UNIX timestamp for which this event was started
 *    dateFinished  -  The UNIX timestamp for which this event was finished
 *
 *
 *  $actionID  -  The unique action ID for this page view
 *  $actionName  -  The action name for this action ID
 *  $imageDirectory  -  The image directory for this theme
 *  $tplDirectory  -  The template directory for this theme
 *  $sid  -  The current sessionID
 *
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_COMMAND" d="Command"}
{t c="TRANS_COMMENTS" d="Comments"}
{t c="TRANS_CREATED" d="Created"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_EXECUTION_LOG" d="Execution Log"}
{t c="TRANS_FINISHED" d="Finished"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_MANAGE_EVENTS" d="Manage Events"}
{t c="TRANS_MBAPI_COMMAND_INPUT" d="MBAPI Command Input"}
{t c="TRANS_MBAPI_COMMAND_OUTPUT" d="MBAPI Command Output"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_RECURRING" d="Recurring"}
{t c="TRANS_RESULT" d="Result"}
{t c="TRANS_RUN" d="Run"}
{t c="TRANS_SHOW_EVENTS" d="Show Events"}
{t c="TRANS_STARTED" d="Started"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_NUM_ERRORS" d="Errors"}
{t c="TRANS_VIEW_DETAILS" d="View Details"}
{t c="TRANS_SYSTEM_EVENT_ID" d="System Event ID"}
{t c="TRANS_ADDITIONAL_INFORMATION" d="Additional Information"}
{t c="TRANS_FOR_PANEL" d="for panel"}
{t c="TRANS_FOR_REGISTRAR" d="for registrar"}
{t c="TRANS_IN_GROUP" d="in group"}
{t c="TRANS_OF_PACKAGE" d="of package"}
{t c="TRANS_WARN_SYSTEM_QUEUE_CLEAR" d="Starting this event right now will stop the current execution of the event queue.\\nContinue running this queue event?"}

{t c="TRANS_RUN_EVENT_WITH_DEBUG" d="Debug Run"}
{t c="TRANS_ADDITIONAL_ACTIONS" d="Additional Actions"}
{t c="TRANS_RESULTS_SORTED_BY" d="Results Sorted By"}

{assign var="filterArgs" value="isActive=$isActive&systemQueueStatus=`$smarty.request.systemQueueStatus`$systemQueueStatus$systemQueueIDsArgs"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EVENTS"
	childName="TRANS_SHOW_EVENTS"
	sideNavMajor="events"
	sideNavMinor="events"
	includeAjaxJS=1}

<script type="text/javascript" language="javascript" charset="utf-8">
// <![CDATA[
	var cp = new cpaint();
	var QID = "";
	cp.set_transfer_mode('get');
	cp.set_response_type('text');
	cp.set_use_cpaint_api(false);

	{literal}
	function parseSystemEventInput(id) {
		QID = id;
        document.getElementById("parseSystemEventOutput_"+QID).innerHTML = "<br /><br /><center><img src=\"{/literal}{$imageDirectory}{literal}/loading2.gif\" /></center>";
		cp.call('{/literal}events.php?action={getActionID action="ShowEventInputDetails"}&systemQueueID='+ id +'&ajax=1&sid={$sid}{literal}', 'parseSystemEventInput', parseSystemEventInputResponse);
		return false;
	}
	function parseSystemEventInputResponse(result) {
		if (result) {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = result;
		} else {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = {/literal}"unable to parse command"{literal};
		}
	}
	function parseSystemEventOutput(id) {
		QID = id;
        document.getElementById("parseSystemEventOutput_"+QID).innerHTML = "<br /><br /><center><img src=\"{/literal}{$imageDirectory}{literal}/loading2.gif\" /></center>";
		cp.call('{/literal}events.php?action={getActionID action="ShowEventOutputDetails"}&systemQueueID='+ id +'&ajax=1&sid={$sid}{literal}', 'parseSystemEventOutput', parseSystemEventOutputResponse);
		return false;
	}
	function parseSystemEventOutputResponse(result) {
		if (result) {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = result;
		} else {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = {/literal}"unable to parse logs"{literal};
		}
	}


	function warnClear(url){
		{/literal}
		{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1}
		if (confirm("{$smarty.const.TRANS_WARN_SYSTEM_QUEUE_CLEAR}"))document.location.href = url;
		{else}
		document.location.href = url;
		{/if}
		{literal}
	}

	{/literal}
// ]]>
</script>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="4" style="text-align:left;">
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$events}
			XKtoggle('row_{$events[iter].systemQueueID}'); 
		{/section} 
		{/strip}return false;">
			<img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$events}
			XKtoggle('row_{$events[iter].systemQueueID}'); 
		{/section} 
		{/strip}return false;">
			{$smarty.const.TRANS_ADDITIONAL_DATA}
		</a>
	</td>
	<td colspan="4" style="text-align:right;color:#666666;">
		{include file="$tplDirectory/widgets/context/sortedBy.tpl"}
	</td>
</tr>
<tr class="headerRow">
	{include
		file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		headerClass="firstTD"
		headerName="TRANS_ID"
		sortColumn="systemQueueID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		headerName="TRANS_MODULE"
		sortColumn="configGroupID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		headerName="TRANS_COMMAND"
		sortColumn="systemQueueCommand"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_CREATED"
		sortColumn="systemQueueDateCreated"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_RUN"
		sortColumn="systemQueueDateToRun"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_STARTED"
		sortColumn="systemQueueDateStarted"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_FINISHED"
		sortColumn="systemQueueDateFinished"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl"
		filterName="TRANS_STATUS"
		filterColumn="systemQueueStatus"
		filterOptions="$statuses"
		suppressFilterName=1
		mergeFilterName=1}
<!--
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerClass="lastTD"
		headerName="TRANS_ACTIONS"}
-->
</tr>
</thead>
{section name=i loop="$events"}
{assign var="systemQueueID" value=$events[i].systemQueueID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td>
		<table border="0" cellpadding="0" cellspacing="0">
		<tr class="listRowNoBorders">
			<td>
				<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
        			<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
				</a>
			</td>
			<td>{$systemQueueID}</td>
		</tr>
		</table>
	</td>

	<td>
		{if $events[i].configGroupID}
			{assign var=configGroupID value=$events[i].configGroupID}
			{if $panels.$configGroupID}
				<a href="{getHREF page="modules.php" actionName="EditPanelConfig" args="configGroupID=$configGroupID"}">{$panels.$configGroupID}</a>
				{if $events[i].serverGroupID}
					{assign var=serverGroupID value=$events[i].serverGroupID}
					{$smarty.const.TRANS_IN_GROUP} <a href="{getHREF page="servergroups.php" actionName="EditServerGroup" args="serverGroupID=$serverGroupID"}">{$serverGroupList.$serverGroupID}</a>

				{/if}
			{elseif $registrars.$configGroupID}
				<a href="{getHREF page="modules.php" actionName="EditRegistrarConfig" args="configGroupID=$configGroupID"}">{$registrars.$configGroupID}</a>
			{/if}
			{elseif $events[i].serverGroupID}
				{assign var=serverGroupID value=$events[i].serverGroupID}
				{if $serverGroupList.$serverGroupID}
					{$serverGroupList.$serverGroupID}
				{/if}
		{/if}
	</td>
	<td>
		{$events[i].systemQueueCommand}
		{if $events[i].packageID}
			{assign var=packageID value=$events[i].packageID}
			{$smarty.const.TRANS_OF_PACKAGE} <a href="{getHREF page="packages.php" actionName="ShowPackageDetails" args="packageID=$packageID"}">{$packageID}</a>
		{/if}
	</td>
	<td>
		{$events[i].systemQueueDateCreated|getDateTime:full}
	</td>
	<td>
		{$events[i].systemQueueDateToRun|getDateTime:full}
		{include
			file="$tplDirectory/widgets/quickEditDateLink.tpl"
			editID=$systemQueueID
			editKey="systemQueueID"
			editActionName="EditEventResponse"
			editName="TRANS_RUN"
			editColumn="systemQueueDateToRun"
			editValue=$events[i].systemQueueDateToRun
			showHourMin=1
			icoFile="ico/quickedit.gif"}
	</td>
	<td>
		{if $events[i].systemQueueIsRecurring}
			--
		{else}
			{$events[i].systemQueueDateStarted|getDateTime:full}
		{/if}
	</td>
	<td>
		{if $events[i].systemQueueIsRecurring}
			--
		{else}
			{$events[i].systemQueueDateFinished|getDateTime:full}
		{/if}
		{if $events[i].systemQueueDateFinished}
		&nbsp;
		<a href="{getHREF page="events.php" actionName="EditEventResponse" args="systemQueueID=$systemQueueID&systemQueueDateFinished=0"}">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_RERUN}" title="{$smarty.const.TRANS_RERUN}" />
		</a>
		{/if}
	</td>
	<td>
		{$events[i].systemQueueStatus|getArrayValueByID:$statuses}
	</td>
<!--
	<td align="center" nowrap="nowrap">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_VIEW}" title="{$smarty.const.TRANS_VIEW}" />
		</a>
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
			{$smarty.const.TRANS_VIEW}
		</a>

		{/strip}
	</td>
-->
</tr>
</tbody>
<tbody id="row_{$systemQueueID}" class="off">
<tr>
	<td colspan="8" class="comments altinner">
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;

		<strong>{$smarty.const.TRANS_ACTIONS}:</strong>
		&nbsp;

		{strip}
		{* RUN NOW *}
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1&$redirectArgs"}');">
			<img src="{$imageDirectory}/ico/run.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_RUN}" title="{$smarty.const.TRANS_RUN}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1&$redirectArgs"}');">
			{$smarty.const.TRANS_RUN}
		</a>
		&nbsp;

		{* FORCE RUN NOW *}
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1&forceRun=1&$redirectArgs"}');">
			<img src="{$imageDirectory}/ico/run.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_RUN}" title="{$smarty.const.TRANS_FORCE_RUN}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1&forceRun=1&$redirectArgs"}');">
			{$smarty.const.TRANS_FORCE_RUN}
		</a>
		&nbsp;

		{* EDIT *}
	    {include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="EditEvent"
			args="systemQueueID=$systemQueueID"
			icoImage="edit"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_EDIT"
			titleText=""
			linkText="TRANS_EDIT"
			noSpace="1"
		}
		&nbsp;

		{* DELETE *}
		{if !$events[i].systemQueueIsRecurring}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="events.php"
				actionName="RemoveEvent"
				args="systemQueueID=$systemQueueID"
				icoImage="remove"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_DELETE"
				titleText=""
				linkText="TRANS_DELETE"
				noSpace="1"
			}
			&nbsp;&nbsp;
		{/if}

		{* DEBUG VIEW COMMAND INPUT *}
		<a href="javascript:void(0);" onclick="parseSystemEventInput({$events[i].systemQueueID});">
			<img src="{$imageDirectory}/ico/debug_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_RUN}" title="{$smarty.const.TRANS_RUN}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:void(0);" onclick="parseSystemEventInput({$events[i].systemQueueID});">
			{$smarty.const.TRANS_MBAPI_COMMAND_INPUT}
		</a>
		&nbsp;&nbsp;

		{* DEBUG VIEW COMMAND OUTPUT *}
		<a href="javascript:void(0);" onclick="parseSystemEventOutput({$events[i].systemQueueID});">
			<img src="{$imageDirectory}/ico/debug_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_RUN}" title="{$smarty.const.TRANS_RUN}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:void(0);" onclick="parseSystemEventOutput({$events[i].systemQueueID});">
			{$smarty.const.TRANS_MBAPI_COMMAND_OUTPUT}
		</a>
		&nbsp;&nbsp;

		{* RUN IN DEBUG MODE *}
		<a href="{getHREF page="events.php" actionName="RunDebugEvent" args="systemQueueID=$systemQueueID"}" target="_blank">
			<img src="{$imageDirectory}/ico/debug_run.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_RUN}" title="{$smarty.const.TRANS_RUN}" style="margin-right: 4px;" />
		</a>
		<a href="{getHREF page="events.php" actionName="RunDebugEvent" args="systemQueueID=$systemQueueID"}" target="_blank">
			{$smarty.const.TRANS_RUN_EVENT_WITH_DEBUG}
		</a>
		&nbsp;

		{/strip}
	</td>
</tr>
<tr class="comments">
	<td colspan="8" class="comments altinner">
		<div id="parseSystemEventOutput_{$events[i].systemQueueID}"></div>
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="8">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
