{* $Id: ShowFraudSetDetails.tpl 11488 2007-07-02 15:36:16Z kbailey $
 * --------------------------------------------------------------
 * This template displays a fraud set's details.
 *
 * Smarty Variables:
 *  $fraudSet (array of this fraud set's data)
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_MODULE_SETTINGS" d="Module Settings"}
{t c="TRANS_DOMESTIC_THRESHOLDS" d="Domestic Thresholds"}
{t c="TRANS_DOMESTIC_THRESHOLDS_MSG" d="Set the threshold levels to be applied to ALL DOMESTIC orders. Each threshold level is compared to the fraud score generated by FraudGuardian in real-time. You decide what actions you want to perform based on the comparison of each threshold level."}
{t c="TRANS_DOMESTIC_COUNTRY" d="Domestic Country"}
{t c="TRANS_LEVEL_1" d="Level 1"}
{t c="TRANS_LEVEL_2" d="Level 2"}
{t c="TRANS_LEVEL_3" d="Level 3"}
{t c="TRANS_LEVEL_4" d="Level 4"}
{t c="TRANS_AMOUNT_OVERRIDE" d="Amount Override"}
{t c="TRANS_MANAGE_FRAUD_SETTINGS" d="Manage Fraud Settings"}

{t c="TRANS_FRAUD_SET" d="Fraud Set"}
{t c="TRANS_CREATE_NEW_FRAUD_SET" d="Create New Fraud Set"}
{t c="TRANS_FRAUD_SET_NAME" d="Fraud Set Name"}
{t c="TRANS_FRAUD_SET_EMAIL" d="Fraud Set Email"}
{t c="TRANS_NO_FRAUD_SETS_FOUND" d="No Fraud Sets Found"}

{t c="TRANS_SELECT_ORDER_FORMS_THAT_APPLY" d="Select order forms that apply to this fraud set:"}
{t c="TRANS_SELECT_COUNTRY_THRESHOLDS_THAT_APPLY" d="Select country thresholds that apply to this fraud set:"}

{t c="TRANS_ASSIGNED_ORDER_FORMS" d="Assigned Order Forms"}
{t c="TRANS_UNASSIGNED_ORDER_FORMS" d="Unassigned Order Forms"}

{t c="TRANS_ASSIGNED_THRESHOLDS" d="Assigned Thresholds"}
{t c="TRANS_UNASSIGNED_THRESHOLDS" d="Unassigned Thresholds"}

{t c="TRANS_FRAUD_COUNTRY_THRESHOLDS" d="Fraud Country Thresholds"}
{t c="TRANS_SAVE_ALL" d="Save All"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_SYSTEM"
	childName="TRANS_MANAGE_FRAUD_SETTINGS"
	grandchildName="TRANS_DETAILS"
	sideNavMajor="system"
    sideNavMinor="order"}

{if $saved}
{include
	file="$tplDirectory/widgets/showInvalidCustom.tpl"
	duration="4"
	message=$smarty.const.TRANS_SETTINGS_SAVED_SUCCESSFULLY}
{/if}

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
{******************* HEADER ROW *******************}
<tr class="listRowNoBorders">
	<td colspan="2">
        {strip}
		<a href="{getHREF page="fraudsets.php" actionName="ShowFraudSets"}" class="inner">
			<img src="{$imageDirectory}/ico/arrow_left_blue.gif" width="16" height="16" style="vertical-align:middle;" alt="" title="" />
		</a>
        {/strip}
		<a href="{getHREF page="fraudsets.php" actionName="ShowFraudSets"}" class="inner">
		    {$smarty.const.TRANS_MANAGE_FRAUD_SETTINGS}
		</a>
   	</th>
</tr>
</table>

<fieldset>
<legend>{$smarty.const.TRANS_FRAUD_SET}</legend>

    {************************** CENTER **************************}
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
        <tr>
            <td class="title">{$smarty.const.TRANS_FRAUD_SET_NAME}:</td>
            <td>{include
					file="$tplDirectory/widgets/quickEditLink.tpl"
                    useEditIcon=1
					editActionName="EditFraudSetResponse"
					editID=$fraudSet.fraudSetID
					editKey="fraudSetID"
					editName="TRANS_FRAUD_SET_NAME"
					editColumn="fraudSetName"
					editValue=$fraudSet.fraudSetName}
                &nbsp;
                {$fraudSet.fraudSetName}
            </td>
        </tr>
        <tr>
            <td class="title">{$smarty.const.TRANS_FRAUD_SET_EMAIL}:</td>
			<td>{include
					file="$tplDirectory/widgets/quickEditLink.tpl"
                    useEditIcon=1
					editActionName="EditFraudSetResponse"
					editID=$fraudSet.fraudSetID
					editKey="fraudSetID"
					editName="TRANS_FRAUD_SET_EMAIL"
					editColumn="fraudSetEmail"
					editValue=$fraudSet.fraudSetEmail}
                &nbsp;
                {$fraudSet.fraudSetEmail}
			</td>
        </tr>
</table>
</fieldset>

<form action="fraudsets.php" method="post" name="combo_box" onsubmit="XKselectAllOptionsInMultiSelects(this);">
<input type="hidden" name="action" value="{getActionID action="EditFraudSetResponse"}" />
<input type="hidden" name="fraudSetID" value="{$fraudSet.fraudSetID}" />
<input type="hidden" name="redirectURL" value="{$fileName}" />
<input type="hidden" name="redirectAction" value="{$actionName}" />
<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
<tr>
    {************************** LEFT - ORDER FORMS **************************}
    <td width="50%" valign="top">
		<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
		<tr class="headerRow">
			<td>
				<strong>{$smarty.const.TRANS_SELECT_ORDER_FORMS_THAT_APPLY}</strong>
			</td>
		</tr>
		<tr>
			<td>
	 		{include file="$tplDirectory/widgets/comboBox.tpl"
				comboTitleLeft="TRANS_ASSIGNED_ORDER_FORMS"
				comboNameLeft="addOrderFormIDs"
				comboOptionsLeft=$usedOrderForms
				comboTitleRight="TRANS_UNASSIGNED_ORDER_FORMS"
				comboNameRight="removeOrderFormIDs"
				comboOptionsRight=$availableOrderForms
				formName="combo_box"
				submitName="suppress"}
			</td>
		</tr>
		</table>
    </td>

    {************************** RIGHT - COUNTRY THRESHOLDS**************************}
    <td width="50%" valign="top">
		<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
		<tr class="headerRow">
			<td>
				<strong>{$smarty.const.TRANS_SELECT_COUNTRY_THRESHOLDS_THAT_APPLY}</strong>
			</td>
		</tr>
		<tr>
			<td>
	 		{include file="$tplDirectory/widgets/comboBox.tpl"
				comboTitleLeft="TRANS_ASSIGNED_THRESHOLDS"
				comboNameLeft="addThresholdIDs"
				comboOptionsLeft=$usedThresholds
				comboTitleRight="TRANS_UNASSIGNED_THRESHOLDS"
				comboNameRight="removeThresholdIDs"
				comboOptionsRight=$availableThresholds
				formName="combo_box"
				submitName="suppress"}
			</td>
		</tr>
		</table>
    </td>
</tr>
<tr class="listButtons">
    <td colspan="2"><div>
        <input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_SAVE_ALL}" onClick="{strip}
		    selectAll(document.combo_box.elements['addOrderFormIDs[]']);
            selectAll(document.combo_box.elements['addThresholdIDs[]']);
			{/strip}" />
    </div></td>
</tr>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}