{* $Id: ShowFraudSets.tpl 5685 2006-03-22 00:48:07Z kbailey $
 * --------------------------------------------------------------
 * This template displays the fraud sets configured in ModernBill.
 *
 * Smarty Variables:
 *  $fraudSets (array of fraud sets)
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_FRAUDGUARDIAN" d="FraudGuardian"}
{t c="TRANS_FRAUDGUARDIAN_POWERED_BY_TAG" d="Powered by MaxMind ... Under Your Control!"}
{t c="TRANS_MODULE_SETTINGS" d="Module Settings"}
{t c="TRANS_DOMESTIC_THRESHOLDS" d="Domestic Thresholds"}
{t c="TRANS_DOMESTIC_THRESHOLDS_MSG" d="Set the threshold levels to be applied to ALL DOMESTIC orders. Each threshold level is compared to the fraud score generated by FraudGuardian in real-time. You decide what actions you want to perform based on the comparison of each threshold level."}
{t c="TRANS_DOMESTIC_COUNTRY" d="Domestic Country"}
{t c="TRANS_LEVEL_1" d="Level 1"}
{t c="TRANS_LEVEL_2" d="Level 2"}
{t c="TRANS_LEVEL_3" d="Level 3"}
{t c="TRANS_LEVEL_4" d="Level 4"}
{t c="TRANS_AMOUNT_OVERRIDE" d="Amount Override"}
{t c="TRANS_MANAGE_FRAUD_SETTINGS" d="Manage Fraud Settings"}

{t c="TRANS_CURRENT_FRAUD_SETS" d="Current Fraud Sets"}
{t c="TRANS_CURRENT_COUNTRY_THRESHOLDS" d="Current Country Thresholds"}
{t c="TRANS_DEFINE_NEW_FRAUD_SET" d="Define New Fraud Set"}
{t c="TRANS_DEFINE_NEW_COUNTRY_THRESHOLD" d="Define New Country Threshold"}
{t c="TRANS_FRAUD_SET_NAME" d="Fraud Set Name"}
{t c="TRANS_FRAUD_SET_EMAIL" d="Fraud Set Email"}
{t c="TRANS_NO_FRAUD_SETS_DEFINED" d="No Fraud Sets Defined"}
{t c="TRANS_NO_COUNTRY_THRESHOLDS_DEFINED" d="No Country Thresholds Defined"}

{t c="TRANS_THRESHOLD_TYPE" d="Threshold Type"}
{t c="TRANS_THRESHOLD_NAME" d="Threshold Name"}
{t c="TRANS_REGION" d="Region"}
{t c="TRANS_MANAGE" d="Manage"}

{t c="TRANS_THRESHOLD_COUNTRY_OR_REGION" d="Threshold Country or Region"}

{t c="TRANS_APPLY_TO_ALL_COUNTRIES" d="Apply to ALL countries"}
{t c="TRANS_APPLY_TO_ONE_COUNTRY" d="Apply to ONE country"}
{t c="TRANS_APPLY_TO_REGION_OF_COUNTRIES" d="Apply to REGION of countries"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_SYSTEM"
	childName="TRANS_MANAGE_FRAUD_SETTINGS"
	sideNavMajor="system"}

<script language="javascript">
    {literal}
    function showCountryOptions(x) {
        if (x=="all") {
            hideobjbyid("countriesID");
            hideobjbyid("regionsID");
        } else if(x=="one") {
            showobjbyid("countriesID");
            hideobjbyid("regionsID");
        } else if(x=="region") {
            showobjbyid("regionsID");
            hideobjbyid("countriesID");
        }
    }
    {/literal}
</script>

{if $saved}
{include
	file="$tplDirectory/widgets/showInvalidCustom.tpl"
	duration="4"
	message=$smarty.const.TRANS_SETTINGS_SAVED_SUCCESSFULLY}
{/if}

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
{******************* HEADER ROW *******************}
<tr class="listRowNoBorders">
	<td colspan="2">
        {strip}
		<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}" class="inner">
			<img src="{$imageDirectory}/ico/arrow_left_blue.gif" width="16" height="16" style="vertical-align:middle;" alt="" title="" />
		</a>
        {/strip}
		&nbsp;
		<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}" class="inner">
		    {$smarty.const.TRANS_MANAGE_FRAUD_SETTINGS}
		</a>
   	</td>
</tr>
</table>
{***************** FRAUD SETS *****************}
<fieldset>
<legend>{$smarty.const.TRANS_CURRENT_FRAUD_SETS}</legend>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
        <tr class="headerRow">
            <td>{$smarty.const.TRANS_FRAUD_SET_NAME}</td>
            <td>{$smarty.const.TRANS_FRAUD_SET_EMAIL}</td>
            <td>{$smarty.const.TRANS_ACTIONS}</td>
        </tr>
		{section name=i loop=$fraudSets}
			{assign var="fraudSetID" value=$fraudSets[i].fraudSetID}
			{if $className=="alt1"}
			    {assign var="className" value="alt2"}
			{else}
			    {assign var="className" value="alt1"}
			{/if}
			<tr class="{cycle values="alt1,alt2"}">
				<td>
					{$fraudSets[i].fraudSetName}
					{include
						file="$tplDirectory/widgets/quickEditLink.tpl"
						editActionName="EditFraudSetResponse"
						editID=$fraudSetID
						editKey="fraudSetID"
						editName="TRANS_FRAUD_SET_NAME"
						editColumn="fraudSetName"
						editValue=$fraudSets[i].fraudSetName}
				</td>
				<td>
					{$fraudSets[i].fraudSetEmail}
					{include
						file="$tplDirectory/widgets/quickEditLink.tpl"
						editActionName="EditFraudSetResponse"
						editID=$fraudSetID
						editKey="fraudSetID"
						editName="TRANS_FRAUD_SET_EMAIL"
						editColumn="fraudSetEmail"
						editValue=$fraudSets[i].fraudSetEmail}
				</td>
				<td>
                    {include file="$tplDirectory/widgets/actionLink.tpl"
                        page="fraudsets.php"
                        actionName="ShowFraudSetDetails"
                        args="fraudSetID=$fraudSetID"
                        icoImage="view"
                        altText="TRANS_MANAGE"
                        linkText="TRANS_MANAGE"}
					&nbsp;
					&nbsp;
                    {include file="$tplDirectory/widgets/actionLink.tpl"
                        page="fraudsets.php"
                        actionName="RemoveFraudSetResponse"
                        args="fraudSetID=$fraudSetID"
                        icoImage="remove"
                        altText="TRANS_REMOVE"
                        linkText="TRANS_REMOVE"}
				</td>
			</tr>
		{sectionelse}
			<tr class="{cycle values="alt1,alt2"}">
				<td colspan="3">
						{$smarty.const.TRANS_NO_FRAUD_SETS_DEFINED}
				</td>
			</tr>
		{/section}
        <form method="post" action="fraudsets.php">
        <input type="hidden" name="action" value="{getActionID action="AddFraudSetResponse"}" />
        <input type="hidden" name="sid" value="{$sid}" />
		<tr bgcolor="#FFFFFF">
            <td><input type="text" name="fraudSetName" value="" style="width:140px" /></td>
            <td><input type="text" name="fraudSetEmail" value="" style="width:140px" /></td>
            <td><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_DEFINE_NEW_FRAUD_SET}" /></td>
        </tr>
        </form>
</table>
</fieldset>

{***************** COUNTRY THRESHOLDS *****************}

<fieldset>
<legend>{$smarty.const.TRANS_CURRENT_COUNTRY_THRESHOLDS}</legend>
<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
        <tr class="headerRow">
            <td>{$smarty.const.TRANS_THRESHOLD_NAME}</td>
            <td>{$smarty.const.TRANS_THRESHOLD_TYPE}</td>
            <td>{$smarty.const.TRANS_THRESHOLD_COUNTRY_OR_REGION}</td>
            <td>{$smarty.const.TRANS_ACTIONS}</td>
        </tr>
		{section name=i loop=$countryThresholds}
			{assign var="thresholdID" value=$countryThresholds[i].thresholdID}
			{if $className=="alt1"}
			    {assign var="className" value="alt2"}
			{else}
			    {assign var="className" value="alt1"}
			{/if}
			<tr class="{cycle values="alt1,alt2"}">
				<td>
					{$countryThresholds[i].thresholdName}
					{include
						file="$tplDirectory/widgets/quickEditLink.tpl"
						editActionName="EditFraudCountryThresholdResponse"
						editID=$thresholdID
						editKey="thresholdID"
						editName="TRANS_THRESHOLD_NAME"
						editColumn="thresholdName"
						editValue=$countryThresholds[i].thresholdID}
				</td>
				<td>
                    {assign var="countryType" value=$countryThresholds[i].countryType}
                    {if ($countryType==0)}
                        {$smarty.const.TRANS_APPLY_TO_ALL_COUNTRIES}
                    {elseif ($countryType==1)}
                        {$smarty.const.TRANS_APPLY_TO_ONE_COUNTRY}
                    {elseif ($countryType==2)}
                        {$smarty.const.TRANS_APPLY_TO_REGION_OF_COUNTRIES}
                    {/if}
				</td>
				<td>
                    {if ($countryType==0)}
                        {$smarty.const.TRANS_COUNTRY}: *
                    {elseif ($countryType==1)}
                        {assign var="countriesID" value=$countryThresholds[i].countriesID}
					    {$smarty.const.TRANS_COUNTRY}: {$countryList[$countriesID]}
                    {elseif ($countryType==2)}
                        {assign var="regionsID" value=$countryThresholds[i].regionsID}
                        {$smarty.const.TRANS_REGION}: {$regionNames[$regionsID]}
                    {/if}
				</td>
				<td>
                    {include file="$tplDirectory/widgets/actionLink.tpl"
                        page="fraudsets.php"
                        actionName="EditFraudCountryThreshold"
                        args="thresholdID=$thresholdID"
                        icoImage="view"
                        altText="TRANS_CONFIGURE"
                        linkText="TRANS_CONFIGURE"}
                    &nbsp;
                    &nbsp;
                    {include file="$tplDirectory/widgets/actionLink.tpl"
                        page="fraudsets.php"
                        actionName="RemoveFraudCountryThresholdResponse"
                        args="thresholdID=$thresholdID"
                        icoImage="remove"
                        altText="TRANS_REMOVE"
                        linkText="TRANS_REMOVE"}
				</td>
			</tr>
		{sectionelse}
			<tr class="{cycle values="alt1,alt2"}">
				<td colspan="4">
						{$smarty.const.TRANS_NO_COUNTRY_THRESHOLDS_DEFINED}
				</td>
			</tr>
		{/section}
        <form method="post" action="fraudsets.php">
        <input type="hidden" name="action" value="{getActionID action="AddFraudCountryThresholdResponse"}" />
        <input type="hidden" name="sid" value="{$sid}" />
		<tr bgcolor="#FFFFFF">
            <td><input type="text" name="thresholdName" value="" style="width:140px" /></td>
            <td valign="middle">
                <table border="0" cellpadding="0" cellspacing="0" class="list">
                <tr>
                    <td><input type="radio" name="countryType" id="countryType0" value="0" checked="checked" onclick="showCountryOptions('all');" /></td>
                    <td>{$smarty.const.TRANS_APPLY_TO_ALL_COUNTRIES}</td>
                </tr>
                <tr>
                    <td><input type="radio" name="countryType" id="countryType1" value="1" onclick="showCountryOptions('one');" /></td>
                    <td>{$smarty.const.TRANS_APPLY_TO_ONE_COUNTRY}</td>
                </tr>
                <tr>
                    <td><input type="radio" name="countryType" id="countryType2" value="2" onclick="showCountryOptions('region');" /></td>
                    <td>{$smarty.const.TRANS_APPLY_TO_REGION_OF_COUNTRIES}</td>
                </tr>
                </table>
                </nobr>
            </td>
            <td>
                <select name="countriesID" id="countriesID" style="display:none;visibility:hidden;">
                    {html_options options=$countryList selected=$selectedCountry}
                </select>
                <select name="regionsID" id="regionsID" style="display:none;visibility:hidden;">
                    {foreach key=regionID item=childRegions from=$nestedRegions}
                        <option value="{$regionID}" id="{$regionID}">{$regionNames[$regionID]}</option>
                        {section name=i loop=$childRegions}
                            {assign var="regionID" value=$childRegions[i]}
                            <option value="{$regionID}" id="{$regionID}">-- {$regionNames[$regionID]}</option>
                        {/section}
                    {/foreach}
                </select>
            </td>
            <td><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_DEFINE_NEW_COUNTRY_THRESHOLD}" /></td>
        </tr>
        </form>
</table>
</fieldset>

<br />
<br />

{include file="$tplDirectory/footer.tpl"}