{* $Id: header.tpl 12329 2007-12-07 22:11:44Z kbailey $
 * --------------------------------------------------------------
 * This is the primary header template for the Admin GUI of ModernBill. Note that this header.tpl
 * file will open several HTML tags must be closed by the footer.tpl file.
 *
 * Smarty Variables:
 *  $htmlTitle		The title of this document
 *  $htmlLang		The language this document will render
 *	$parentName		The page info parent name
 *	$childName		The page info child name
 *	$useMenu		The tab name to highlight
 *	$sideNavMajor		The side navigation file to include
 *	$loginName		The name of the admin user who is logged in
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *
 * Example Usage:
 *  {include file="$tplDirectory/header.tpl" parentName="TRANS_MANAGE_CLIENTS" childName="TRANS_SHOW_CLIENTS" sideNavMajor="clients"}
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_EVENTS" d="Events"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_HELPDESK" d="Helpdesk"}
{t c="TRANS_LOGOFF" d="Logoff"}
{t c="TRANS_LOGGED_IN_AS" d="Logged in as"}
{t c="TRANS_MODULES" d="Modules"}
{t c="TRANS_PRODUCTS" d="Products"}
{t c="TRANS_PROFILE" d="Profile"}
{t c="TRANS_SYSTEM" d="System"}
{t c="TRANS_SEARCH" d="Search"}
{t c="TRANS_SMART" d="Smart"}
{t c="TRANS_HOME" d="Home"}
{t c="TRANS_STOP_RECORDING" d="Stop Recording"}
{t c="TRANS_STOP_DEBUGGING" d="Stop Debugging"}
{t c="TRANS_CLIENT_SIDE_PAYMENT_OPTIONS" d="Client Side Payment Options"}
{t c="TRANS_NEW_ORDER_EMAILS" d="New Order Email"}
{if $smarty.request.__print==1}
	{include
		file="$tplDirectory/header.print.tpl"
		parentName=$parentName
		childName=$childName}
{else}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{$smarty.const.TRANS_TEXTDIRECTION}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{$smarty.const.$parentName|default:$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {$smarty.const.$childName|default:$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {$smarty.const.$grandchildName|default:$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/menu.css" />
<script language="javascript" type="text/javascript" src="{$jsDirectory}/preloadm.js"></script>
<!-- <script language="JavaScript" type="text/javascript" src="{$jsDirectory}/overlib.js"></script> -->
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/toggle.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/main.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/pushpull.js"></script>
{if $systemQueue.systemQueueRunning}
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/progress.js"></script>
{/if}
{if $includeAjaxJS}
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/../ajax/core/ajax.inc.js"></script>
{/if}
{if $includeDomainJS}
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/domains.js"></script>
{/if}
{if $includeTableSorting}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/common.js"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/css.js"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/table-sorting.js"></script>
{/if}
{* the following css & js files support the js calendar *}
<link rel="stylesheet" type="text/css" charset="utf-8" href="{$jsDirectory}/cal/themes/enx.css" />
<link rel="stylesheet" type="text/css" charset="utf-8" href="{$jsDirectory}/cal/themes/layouts/small.css" />
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/lib/prototype.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/scriptaculous.js"></script>
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/cal/src/utils.js"></script>
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/cal/src/calendar.js"></script>
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/cal/src/calendar-setup.js"></script>
<script language="javascript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/cal/lang/calendar-{$calendarLanguageFile}.js"></script>

<script language="javascript" type="text/javascript" charset="utf-8">

{* only all the following sub-menus if a sub menu file exists *}
{if $sideNavMajor==""}
	{assign var="sideNavMajor" value=$useMenu}
{/if}
{assign var="argsSystemQueueStatus" value="queue"|getStatusID:"new"}
	var sideNavMajor = '{$sideNavMajor}';
{literal}

	var navGoNow = true;

	function toggleSubNav(x){
		toggleobjbyid('majorNavDiv_'+x);
		var a = document.getElementById('majorNavDivZag_'+x);
		if(a.className=="lbox01m1"){
			a.className="lbox01m0";
		}else{
			a.className="lbox01m1";
		}
	}
	
	function showSubNav(x){
//		hideobjbyid('majorNavDiv_clients');
//		hideobjbyid('majorNavDiv_products');
//		hideobjbyid('majorNavDiv_finances');
//		hideobjbyid('majorNavDiv_reports');
//		hideobjbyid('majorNavDiv_helpdesk');
//		hideobjbyid('majorNavDiv_events');
//		hideobjbyid('majorNavDiv_system');
//		showobjbyid('majorNavDiv_'+x);
	}

{/literal}


</script>

</head>
{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1}
<body onLoad="checkSystemEventStatus()">
{else}
<body>
{/if}
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<div id="navOverDiv" style="position:absolute; display: none; z-index:1000; border: 1px solid #999; background: #cfcdc7; width: 201px; padding-top: 10px; padding-bottom: 5px;"></div>
<table cellspacing="0" cellpadding="0" class="top01" ondblclick="handleDoubleClick(event);">
<tbody>
<tr>
<td colspan="2" class="bgt">
<table border="0" cellspacing="0" cellpadding="0" class="top">
		<tr>
			<td class="TopLeftLogo"><img src="{$imageDirectory}/logos/PPBLogo.gif" width="210" height="48" alt="Your Logo" title="Your Logo"/></td>
			<td class="TopTextBlock">{strip}
				<span class="loginInfo">
					{if $recording}
					<span id="recordAdminActions"><a href="{getHREF page="admins.php" actionName="RecordAdminActions"}"
					<img src="{$imageDirectory}/loadingcr.gif" width="16" height="16" alt="" title="" style="vertical-align:middle;border-style:none;" />{$smarty.const.TRANS_STOP_RECORDING}</a></span>
					{else}
					<span id="recordAdminActions"></span>
					{/if}
					{if $debugLogging}
					<span id="debugLogging"><a href="{getHREF page="events.php" actionName="ShowDbgPageloads"}" style="text-transform:capitalize;">
					<img src="{$imageDirectory}/ico/debug_view.gif" width="16" height="16" alt="" title="" style="vertical-align:middle;border-style:none;" />{$smarty.const.TRANS_VIEW}</a></span>
					<span id="debugLogging"><a href="{getHREF page="events.php" actionName="EditDbgPageloadsSettingsResponse" args="debugToLog=0"}" style="text-transform:capitalize;">
					<img src="{$imageDirectory}/ico/debug_stop.gif" width="16" height="16" alt="" title="" style="vertical-align:middle;border-style:none;" />{$smarty.const.TRANS_STOP}</a></span>
					{/if}
					{strip}
                    &nbsp;
                    <img src="{$imageDirectory}/ico/homeicon.gif" width="16" height="16" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					<a href="{getHREF page="dashboard.php" actionName="ShowDashboard"}">
                        {$smarty.const.TRANS_DASHBOARD}
                    </a>
                    &nbsp;|&nbsp;
					{$smarty.const.TRANS_LOGGED_IN_AS}: <strong>{$loginUsername}</strong>
                    &nbsp;
                    <img src="{$imageDirectory}/ico/024.gif" width="16" height="16" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					<a href="{getHREF page="admins.php" actionName="EditMyProfile"}">
                        {$smarty.const.TRANS_PROFILE}
                    </a>
					&nbsp;
                    <img src="{$imageDirectory}/ico/022.gif" width="16" height="16" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					<a href="{getHREF page="login.php" actionName="LogoutResponse"}">
                        {$smarty.const.TRANS_LOGOFF}
                    </a>
					{/strip}
				</span>{* loginInfo *}
			{/strip}</td>
			<td class="TopRightLogo"><a target="_blank" href="http://www.parallels.com"><img src="{$imageDirectory}/logos/ParallelsLogo.gif" width="170" height="48" alt="Parallels" title="Parallels"/></a></td>
		</tr>
</table>
</td>
</tr>
<tr>
	<td class="bgl" valign="top" style="*height:94%;">{* see note below *}
			<div class="block01">
			
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_clients.tpl"}
				{* include file="$tplDirectory/widgets/menus/sideMenuMajor_helpdesk.tpl" *}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_finances.tpl"}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_events.tpl"}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_products.tpl"}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_modules.tpl"}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_migrate.tpl"}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_reports.tpl"}
				{include file="$tplDirectory/widgets/menus/sideMenuMajor_system.tpl"}

<div class="copyright">
<a target="_blank" href="http://www.parallels.com">
&copy; Copyright 1999-2008, Parallels
<br/>
All rights reserved
</a>
</div>
			</div>{* block01 *}
		</td>
		<td class="bgr" valign="top" style="*height:94%;">
		<div style="vertical-align:top;">

		{if $parentName==""}
			{assign var="parentName" value=$sideNavMajor}
		{/if}
		<div class="amenu">
			{include file="$tplDirectory/widgets/pageInfo.tpl" parentName=$parentName childName=$childName}
			<div style="float: right; margin-right: 10px; margin-top: 4px;">
				{include file="$tplDirectory/widgets/showSearchBox.tpl" searchBoxID="topSearchQueryBox"}
			</div>
		</div>{* amenu *}
		<div class="amenuBT">
			{include file="$tplDirectory/widgets/pageInfo2.tpl" parentName=$parentName childName=$childName}
			<div style="float: right; margin-right: 10px; margin-top: 10px;">
				{include file="$tplDirectory/widgets/showBookmarks.tpl"}
			</div>
		</div>
		
		<div class="block02">{* required open div -- do not remove or close *}
				<div class="block03">{* required open div -- do not remove or close *}

				{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1 && $hideEventStatusBar!=1}
					{include file="$tplDirectory/widgets/showEventStatus.tpl"}
				{/if}

{*
 * Note: Leave the <td> above open. It will be closed at the top of the footer.tpl file.
 * Example: "header.tpl <td>" some content "</td> footer.tpl"
 *}

{/if} {* END IF FOR PRINT=1 *}
