{* $Id: ProcessTransactionRefund.tpl 11517 2007-07-03 20:33:26Z kbailey $
* --------------------------------------------------------------
* This template displays a form to edit a Invoice.
*
* Smarty Variables:
*	n/a
*
*}

{t c="TRANS_REFUND_MONEY_TO_CUSTOMER" d="Refund Money To Customer"}
{t c="TRANS_EDIT_INVOICE" d="Edit Invoice"}
{t c="TRANS_MANAGE_INVOICES" d="Manage Invoices"}
{t c="TRANS_INVOICE_DATE_DUE" d="Invoice Due Date"}
{t c="TRANS_INVOICE_COMMENTS" d="Invoice Comments"}
{t c="TRANS_INVOICE_STATUS" d="Invoice Status"}
{t c="TRANS_PROCESS_TRANSACTION_REFUND" d="Process Refund"}
{t c="TRANS_PARTIAL_REFUND" d="Partial Refund"}
{t c="TRANS_PROCESS_REFUND_CONFIRM_MESSAGE" d="Are you sure you want to refund this transaction?  This will return the funds to the customer and you will not be able to undo this."}

{t c="TRANS_PROCESS_REFUND_CONFIRM_YES" d="Yes, process this refund"}
{t c="TRANS_PROCESS_REFUND_CONFIRM_NO" d="No, do not process this refund"}
{t c="TRANS_LESSER_AMOUNT" d="Lesser Amount"}
{t c="TRANS_PROCESS_REFUND_AMOUNT" d="Refund Amount"}
{t c="TRANS_MARK_RELATED_ITEMS_AS_UNPAID" d="Mark related items as unpaid"}

{t c="TRANS_INVOICE_ID" d="Invoice ID"}
{t c="TRANS_MB_TRANSACTION_ID" d="MB Transaction ID"}
{t c="TRANS_GW_TRANSACTION_ID" d="GW Transaction ID"}
{t c="TRANS_REFUND_VOID_EXPLAINATION" d="You can only void a transaction before it is settled.  Most gateways settle transactions nightly, so void attempts may not work as expected after that."}

{t c="TRANS_LINE_ITEMS_TO_BE_REFUNDED" d="Line Items to be Refunded"}

{t c="TRANS_THIS_TRANSACTION_DOES_NOT_HAVE_BILLING_INFORMATION_ASSOCIATED_WITH_IT" d="This transaction does not have billing information associated with it.  In order to refund it you will need to log into your gateway account, locate the transaction, and refund it from there."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_MANAGE_INVOICES"
	grandchildName="TRANS_PROCESS_TRANSACTION_REFUND"
	sideNavMajor="finances"
	sideNavMinor="invoices"
	useMenu="finances"}


{foreach key="jk" item="transaction" from=$transactions}

<form method="post" action="invoices.php">
<input type="hidden" name="action" value="{getActionID action="ProcessTransactionRefundResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="invoiceID" value="{$invoiceID}" />
<input type="hidden" name="transactionID" value="{$transaction.transactionID}" />
<input type="hidden" name="redirectURL" value="invoices.php" />
<input type="hidden" name="redirectAction" value="ShowInvoiceDetails" />
<input type="hidden" name="redirectArgs" value="invoiceID={$invoiceID}" />

<fieldset>
{if $transaction.billingAccountID!=0}
<legend>{$smarty.const.TRANS_PROCESS_REFUND_CONFIRM_MESSAGE}</legend>
{/if}

				<table width="100%" cellpadding="0" cellspacing="0" class="list">
					<tr>
						<td class="title"><label>{$smarty.const.TRANS_INVOICES}: </label></td>
						<td><strong>{$invoiceInfo.invoiceNumber}</strong></td>
					</tr>
					<tr>
						<td class="title"><label>{$smarty.const.TRANS_MB_TRANSACTION_ID}:</label></td> 
						<td><strong>{$transaction.transactionID}</strong></td>
					</tr>
					<tr>
						<td class="title"><label>{$transaction.configGroupTransKey} {$smarty.const.TRANS_TRANSACTION_ID}:</label></td> 
						<td><strong>{$transaction.transactionCode}</strong></td>
					</tr>

					{if $transaction.billingAccountID==0}
						<tr>
							<td class="title">{$smarty.const.TRANS_NOTE}:</td>
							<td>{$smarty.const.TRANS_THIS_TRANSACTION_DOES_NOT_HAVE_BILLING_INFORMATION_ASSOCIATED_WITH_IT}</td>
						</tr>
					{else}

						{if $lineItemsForTransactions}
							<tr>
								<td class="title"><label>{$smarty.const.TRANS_LINE_ITEMS_TO_BE_REFUNDED}: </label></td>
								<td>
									{foreach item="li" key="hh" from=$lineItemsForTransactions[$transaction.transactionID]}
										{$li.lineItemPaymentAmount|getAmount:$transaction.currencyID} - {$lineItemNames[$li.lineItemID]}<br />
										<input type="hidden" name="lineItemIDs[]" value="{$li.lineItemID}" />
									{/foreach}
									{$smarty.const.TRANS_TOTAL}: <strong>{$transactionRefundTotals[$transaction.transactionID]|getAmount:$transaction.currencyID}</strong>
									<input type="hidden" name="refundAmount" value="{$transactionRefundTotals[$transaction.transactionID]}" />
								</td>
							</tr>
							<tr>
								<td class="title"></td>
								<td><input type="checkbox" name="markUnpaid" value="1" checked="checked" /> {$smarty.const.TRANS_MARK_RELATED_ITEMS_AS_UNPAID}</td>
							</tr>
							<tr>
								<td class="title"><label>{$smarty.const.TRANS_ACTION}: </label></td>
								<td>
									{$transaction.gatewayActions[$transaction.selectedAction]}
								</td>
							</tr>
						{else}
							{if $transaction.canPartial==1}
								<tr>
									<td class="title"><label>{$smarty.const.TRANS_TRANSACTION_AMOUNT}: </label></td>
									<td><strong><input type="radio" value="full" name="refundType" id="refundTypeFull{$transaction.transactionID}" checked="checked" onmouseup="setTimeout('checkRefundType{$transaction.transactionID}();', 100);" /> {$transaction.transactionAmount-$transaction.transactionAmountRefunded|getAmount:$transaction.currencyID}</strong><br />
															<input type="radio" value="partial" name="refundType" id="refundTypePartial{$transaction.transactionID}" onmouseup="setTimeout('checkRefundType{$transaction.transactionID}();', 100);" /> {$smarty.const.TRANS_LESSER_AMOUNT}: <input type="text" name="lesserAmount" disabled="disabled" id="lesserAmount{$transaction.transactionID}" value="{$transaction.transactionAmount-$transaction.transactionAmountRefunded|getAmount:$transaction.currencyID}"
															onchange="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true};{1000|getAmount:$currencyID:true:true}', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}'); checkLesserAmount('{$transaction.transactionAmount-$transaction.transactionAmountRefunded}', this);" /></td>
								</tr>
							{else}
								<tr>
									<td class="title"><label>{$smarty.const.TRANS_TRANSACTION_AMOUNT}: </label></td>
									<td><strong>{$transaction.transactionAmount-$transaction.transactionAmountRefunded|getAmount:$transaction.currencyID}</strong></td>
								</tr>
							{/if}
							<tr>
								<td class="title"></td>
								<td><input type="checkbox" name="markUnpaid" id="markUnpaid{$transaction.transactionID}" value="1" checked="checked" /> {$smarty.const.TRANS_MARK_RELATED_ITEMS_AS_UNPAID}</td>
							</tr>
							<tr>
								<td class="title"><label>{$smarty.const.TRANS_ACTION}: </label></td>
								<td><select name="gatewayAction">
									{html_options options=$transaction.gatewayActions selected=$transaction.selectedAction}
								</select> * </td>
							</tr>
						{/if}
						<tr>
							<td class="title"><label>{$smarty.const.TRANS_ENCRYPTION_KEY}: </label></td>
							<td><input type="password" name="key" value="" /></td>
						</tr>
						<tr class="listButtons">
							<td colspan="2"><div><input class="submit" type="submit" value="{$smarty.const.TRANS_PROCESS_REFUND_CONFIRM_YES}"> <input class="button" type="button" value="{$smarty.const.TRANS_CANCEL}" onclick="history.go(-1);"></div></td>
						</tr>
					{/if}
				</table>
</fieldset>
</form>

{literal}
<script type="text/javascript">
function checkRefundType{/literal}{$transaction.transactionID}{literal}(){
	if (document.getElementById('refundTypePartial{/literal}{$transaction.transactionID}{literal}').checked){
		document.getElementById('markUnpaid{/literal}{$transaction.transactionID}{literal}').disabled = true;
		document.getElementById('lesserAmount{/literal}{$transaction.transactionID}{literal}').disabled = false;
	} else {
		document.getElementById('markUnpaid{/literal}{$transaction.transactionID}{literal}').disabled = false;
		document.getElementById('lesserAmount{/literal}{$transaction.transactionID}{literal}').disabled = true;
	}
}
setTimeout('checkRefundType{/literal}{$transaction.transactionID}{literal}();', 100);
</script>
{/literal}

{/foreach}

{literal}
<script type="text/javascript">
function checkLesserAmount(maxAmt, field){
	var amt = XKgetNumberFromLocaleFormat(field.value, "{/literal}{$localeArray.locale_separator_decimal}{literal}", "{/literal}{$localeArray.locale_separator_grouping}{literal}");
	if (amt>parseFloat(maxAmt)){
		{/literal}field.value = XKformatNumber('{1000|getAmount:$currencyID:true:true};{1000|getAmount:$currencyID:true:true}', maxAmt, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');{literal}
	}
}
</script>
{/literal}

{if $transaction.billingAccountID!=0}
	<div style="text-align: center;">{$smarty.const.TRANS_REFUND_VOID_EXPLAINATION}</div>
{/if}


{include file="$tplDirectory/footer.tpl"}