{* $Id: ShowGenerateInvoiceEvents.tpl 10044 2006-11-17 20:13:20Z kbailey $
 * --------------------------------------------------------------
 * This template displays the menu for generating invoices.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_CLIENT_OPTIONS" d="Client Options"}
{t c="TRANS_CONTINUE" d="Continue"}
{t c="TRANS_DOMAIN_OPTIONS" d="Domain Options"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_GENERATE_INVOICE_OPTIONS" d="Generate Invoice Options"}
{t c="TRANS_INCLUDE_ALL_CLIENTS_THAT_ARE" d="Include all clients that are"}
{t c="TRANS_INCLUDE_ALL_DOMAINS_THAT_ARE" d="Include all domains that are"}
{t c="TRANS_INCLUDE_ALL_DOMAINS_THAT_EXPIRE_ON_OR_BEFORE" d="Include all domains that <b>expire on or before</b>"}
{t c="TRANS_INCLUDE_ALL_PACKAGES_THAT_ARE" d="Include all packages that are"}
{t c="TRANS_INCLUDE_ALL_PACKAGES_THAT_RENEW_ON_OR_BEFORE" d="Include all packages that <b>renew on or before</b>"}
{t c="TRANS_INVOICES" d="Invoices"}
{t c="TRANS_INVOICE_STATS" d="Invoice Stats"}
{t c="TRANS_PACKAGE_OPTIONS" d="Package Options"}
{t c="TRANS_SCHEDULE_INVOICES_ON" d="Schedule invoices to <b>generate on or after</b>"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_SUSPENDED" d="Suspended"}
{t c="TRANS_INVOICES_TO_BE_GENERATED" d="Invoices to be generated"}
{t c="TRANS_INITIATING" d="Initiating invoice generation ... <strong>success.</strong>"}

{t c="TRANS_INVOICES_GENERATED" d="Invoices Generated"}
{t c="TRANS_INVOICES_THAT_WOULD_GENERATE" d="Invoices That Would Generate"}
{t c="TRANS_RENEWAL_DATE" d="Renewal Date"}
{t c="TRANS_NEXT_RENEWAL_DATE" d="Next Renewal Date"}
{t c="TRANS_PROCEED_WITH_INVOICE_GENERATION" d="Proceed with invoice generation"}
{t c="TRANS_RUN_INVOICES_NOW" d="Run Invoices Now"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_INVOICES"
	grandchildName="TRANS_GENERATE_INVOICES"
	sideNavMajor="finances"
	sideNavMinor="invoices"}


<script type="text/javascript" language="javascript" charset="utf-8">
// <![CDATA[
	{literal}
	function warnClear(url){
		{/literal}
		{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1}
		if (confirm("{$smarty.const.TRANS_WARN_SYSTEM_QUEUE_CLEAR}"))document.location.href = url;
		{else}
		document.location.href = url;
		{/if}
		{literal}
	}
	{/literal}
// ]]>
</script>

{if $clientInfo.clientID}

	{include file="$tplDirectory/widgets/context/client.tpl" 
		client=$clientInfo suppressEditLink=1 suppressDeleteLink=1}
	
	<table width="100%" border="0" cellpadding="0" cellspacing="3" class="tabTight">
	
		{if $previewMode==1}
			<form method="post" action="invoices.php">
				<input type="hidden" name="action" value="{getActionID action="GenerateInvoiceEvents"}" />
				<input type="hidden" name="sid" value="{$sid}" />
				<input type="hidden" name="reRequest" value="{$reRequest}" />
			<tr>
				<td>{$smarty.const.TRANS_INVOICES_THAT_WOULD_GENERATE}: <b>{$numInvoices}</b> </td>
				<td><input type="submit" class="submit" value="{$smarty.const.TRANS_PROCEED_WITH_INVOICE_GENERATION}" /></td>
			</tr>
			</form>
		{else}
			<tr>
				<td>{$smarty.const.TRANS_INVOICES_GENERATED}:  <b>{$numInvoices}</b></td>
				<td></td>
			</tr>
		{/if}
	
		<tr>
			<td colspan="2">{$smarty.const.TRANS_INVOICES}: </td>
		</tr>
	
	
		{foreach key="k" item="invoice" from=$invoices}
			{assign var="currencyID" value=$invoice.currencyID}
			<tr>
				<td colspan="2">
				
					{if $invoice.invoiceNumber}
						{$smarty.const.TRANS_INVOICE_NUMBER}: <a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoice.invoiceID`"}"><strong>{$invoice.invoiceNumber}</strong></a><br />
					{/if}
				
					<table width="100%" cellpadding="4" cellspacing="0" border="0" class="tabTight">
				
						<tr class="alt1">
							<th colspan="2" align="left">{$smarty.const.TRANS_ITEM}</th>
							<th align="left">{$smarty.const.TRANS_RENEWAL_DATE}</th>
							<th align="left">{$smarty.const.TRANS_NEXT_RENEWAL_DATE}</th>
							<th align="right">{$smarty.const.TRANS_PRICE}</th>
							<th align="right">{$smarty.const.TRANS_DISCOUNT}</th>
							<th align="right">{$smarty.const.TRANS_SETUP}</th>
							<th style="border-right: 1px solid #ccc; padding-right: 5px;" align="right">{$smarty.const.TRANS_TAX}</th>
							<th align="right">{$smarty.const.TRANS_TOTALS}</th>
						</tr>
				
					{section name="i" loop=$invoice.packages}
				
						<tr class="{if $smarty.section.i.index%2==0}alt1{else}alt2{/if}">
							<td style="{if $invoice.packages[i].isAddon==1}padding-left: 15px;{/if}border-top: 1px solid #ccc;" align="left" colspan="2">
							{assign var="tpid" value=$invoice.packages[i].packageID}
							{if $invoice.packages[i].isAddon<1}({$smarty.const.TRANS_ID}:{$tpid}){/if} {$invoice.packages[i].packageName}
							{if $domains.$tpid}
								<br />{$smarty.const.TRANS_DOMAIN}: {$domains.$tpid.domainName}
							{/if}
							</td>
							<td style="border-top: 1px solid #ccc;">{$invoice.packages[i].lastBillingDate|getDate}</td>
							<td style="border-top: 1px solid #ccc;">{$invoice.packages[i].nextBillingDate|getDate}</td>
							{assign var="tmpPrice" value=$invoice.packages[i].packagePrice+$invoice.packages[i].packageDiscountAmount}
							<td style="border-top: 1px solid #ccc;" align="right">{$tmpPrice|getAmount:$currencyID}</td>
							<td style="border-top: 1px solid #ccc;" align="right">{$invoice.packages[i].packageDiscountAmount|getAmount:$currencyID}</td>
							<td style="border-top: 1px solid #ccc;" align="right">{$invoice.packages[i].packageSetupAmount|getAmount:$currencyID}</td>
							<td style="border-top: 1px solid #ccc; border-right: 1px solid #ccc; padding-right: 5px;" align="right">{$invoice.packages[i].packageTaxAmount|getAmount:$currencyID}</td>
							<td style="border-top: 1px solid #ccc;" align="right">{$invoice.packages[i].packageTotalAmount|getAmount:$currencyID}</td>
						</tr>
						{if $invoice.packages[i].taxZones.0.amount}
							{assign var="firstTaxZone" value="1"}
							{section name="j" loop=$invoice.packages[i].taxZones}
								{if $invoice.packages[i].taxZones[j].amount>0}
						<tr class="{if $smarty.section.i.index%2==0}alt1{else}alt2{/if}">
							<td align="right">{if $firstTaxZone==1}{assign var="firstTaxZone" value="0"}{$smarty.const.TRANS_ITEM_TAXES}: {/if}</td>
							<td align="left" colspan="4">{$invoice.packages[i].taxZones[j].tax_zone_description}</td>
							<td align="right">{if $invoice.packages[i].taxZones[j].tax_zone_amount_type==0}
									{$invoice.packages[i].taxZones[j].tax_zone_amount}%
									{else}
									{$invoice.packages[i].taxZones[j].tax_zone_amount|getAmount:$currencyID}
									{/if}</td>
							<td></td>
							<td align="right" style=" border-right: 1px solid #ccc; padding-right: 5px;">{$invoice.packages[i].taxZones[j].amount|getAmount:$currencyID}</td>
							<td></td>
						</tr>
								{/if}
							{/section}
						{/if}
				
					{/section}
				
					</table>
				<br />
					<table width="100%" cellpadding="4" cellspacing="0" border="0">
						<tr>
							<td align="right" style="border-top: 2px solid #ccc;">
								<table align="right" cellpadding="4" cellspacing="0" border="0">
									<tr>
										<td style="padding: 2px; text-align: right; font-size: 11pt;">{$smarty.const.TRANS_SUB_TOTAL}:</td>
										<td style="padding: 2px; text-align: right; font-size: 11pt;"> {$invoice.invoiceSubTotalAmount|getAmount:$currencyID}</td>
									</tr>
									<tr>
										<td style="padding: 2px; text-align: right; font-size: 11pt;">{$smarty.const.TRANS_TAX}: </td>
										<td style="padding: 2px; text-align: right; font-size: 11pt;"> {$invoice.invoiceTax|getAmount:$currencyID}</td>
									</tr>
									<tr>
										<td style="padding: 2px; text-align: right; font-size: 11pt;">{$smarty.const.TRANS_INVOICE_TOTAL}: </td>
										<td style="padding: 2px; text-align: right; font-size: 11pt;"><strong>{$invoice.invoiceTotalAmount|getAmount:$currencyID}</strong></td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				
				</td>
			</tr>
		
		{foreachelse}
			<tr>
				<td colspan="2">{$smarty.const.TRANS_NONE}</td>
			</tr>
		{/foreach}
	
	
	</table>
	
	
	
	
	
	
	
	
	
	
	
	


{else}
<table  width="100%" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tr>
	<td>
		<br />
        {$smarty.const.TRANS_INITIATING}
        <br />
		{$smarty.const.TRANS_INVOICES_TO_BE_GENERATED}: <strong>{$numInovicesToBeGenerated}</strong><br />
		{if $runNow==1}
			<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1"}');">
				{$smarty.const.TRANS_RUN_INVOICES_NOW}
			</a>
		{/if}
	</td>
</tr>
</table>
{/if}

{include file="$tplDirectory/footer.tpl"}