{* $Id: ShowGenerateInvoiceMenu.tpl 9841 2006-10-27 15:34:50Z kbailey $
 * --------------------------------------------------------------
 * This template displays the menu for generating invoices.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_CLIENT_OPTIONS" d="Client Options"}
{t c="TRANS_CONTINUE" d="Continue"}
{t c="TRANS_DOMAIN_OPTIONS" d="Domain Options"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_GENERATE_INVOICE_OPTIONS" d="Generate Invoice Options"}
{t c="TRANS_INCLUDE_ALL_CLIENTS_THAT_ARE" d="Include all clients that are"}
{t c="TRANS_INCLUDE_ALL_DOMAINS_THAT_ARE" d="Include all domains that are"}
{t c="TRANS_INCLUDE_ALL_DOMAINS_THAT_EXPIRE_ON_OR_BEFORE" d="Include all domains that <b>expire on or before</b>"}
{t c="TRANS_INCLUDE_ALL_PACKAGES_THAT_ARE" d="Include all packages that are"}
{t c="TRANS_INCLUDE_ALL_PACKAGES_THAT_RENEW_ON_OR_BEFORE" d="Include all packages that <b>renew on or before</b>"}
{t c="TRANS_INVOICES" d="Invoices"}
{t c="TRANS_INVOICE_STATS" d="Invoice Stats"}
{t c="TRANS_PACKAGE_OPTIONS" d="Package Options"}
{t c="TRANS_SCHEDULE_INVOICES_ON" d="Schedule invoices to <b>generate on or after</b>"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_SUSPENDED" d="Suspended"}
{t c="TRANS_YES" d="Yes"}
{t c="TRANS_NO" d="No"}
{t c="TRANS_WALK_PACKAGES_FORWARD" d="Walk packages forward:"}
{t c="TRANS_GENERATE_INVOICES_FOR_CLIENT" d="Generate Invoices For Client"}
{t c="TRANS_PREVIEW_MODE" d="Preview Mode"}
{t c="TRANS_PACKAGES_TO_INVOICE" d="Packages to Invoice"}
{t c="TRANS_DO_NOT_INVOICE" d="Do Not Invoice"}
{t c="TRANS_INVOICE" d="Invoice"}
{t c="TRANS_INVOICE_DUE_DATE_OVERRIDE" d="Invoice Due Date Override"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_INVOICES"
	grandchildName="TRANS_GENERATE_INVOICE_OPTIONS"
	sideNavMajor="finances"
	sideNavMinor="invoices"}

		<form method="post" action="invoices.php" onsubmit="XKselectAllOptionsInMultiSelects(this);">
		<input type="hidden" name="action" value="{getActionID action="GenerateInvoiceEvents"}" />
		<input type="hidden" name="sid" value="{$sid}" />

		<fieldset>
			<legend><strong>{$smarty.const.TRANS_CLIENT_OPTIONS}</strong></legend>
			{if $clientInfo.clientID}
			<table width="100%" class="list">
			<tr>
				<td class="title">{$smarty.const.TRANS_GENERATE_INVOICES_FOR_CLIENT}:</td>
				<td>
					<input type="hidden" name="clientID" value="{$clientInfo.clientID}" />
					<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=`$clientInfo.clientID`"}">{$clientInfo.contactFirstName} {$clientInfo.contactLastName}</a>
					<input type="hidden" name="getActiveClients" value="{if $clientInfo.clientStatus==0}1{else}0{/if}"  />
					<input type="hidden" name="getSuspendedClients" value="{if $suspended==1}1{else}0{/if}" />
				</td>
			</tr>
			<tr>
				<td class="title">&nbsp;</td>
				<td>
					<input type="checkbox" name="previewMode" value="1" checked="checked" /> {$smarty.const.TRANS_PREVIEW_MODE}
				</td>
			</tr>
			<tr>
				<td class="title">{$smarty.const.TRANS_PACKAGES_TO_INVOICE}: </td>
				<td>
					{include file="$tplDirectory/widgets/comboBox.tpl"
						comboTitleLeft=TRANS_INVOICE
						comboNameLeft="packageIDs"
						comboOptionsLeft=$packages
						
						comboWidth="220"
			
						comboTitleRight=TRANS_DO_NOT_INVOICE
						comboNameRight="selectablePackages"
						comboOptionsRight=$selectablePackages
						submitName="suppress"
					}
				</td>
			</tr>
			</table>
			{else}
			<table width="100%" class="list">
			<tr>
				<td class="title">{$smarty.const.TRANS_INCLUDE_ALL_CLIENTS_THAT_ARE}:</td>
				<td>
					<input type="checkbox" name="getActiveClients" value="1" checked /> {$smarty.const.TRANS_ACTIVE}
					&nbsp;&nbsp;
					<input type="checkbox" name="getSuspendedClients" value="0" /> {$smarty.const.TRANS_SUSPENDED}
				</td>
			</tr>
			</table>
			{/if}
		</fieldset>

		<br />

		<fieldset>
			<legend><strong>{$smarty.const.TRANS_PACKAGE_OPTIONS}</strong></legend>
			<table width="100%" class="list">
			{if $clientInfo.clientID}
				<input type="hidden" name="getActivePackages" value="1" /><input type="hidden" name="getSuspendedPackages" value="1" />
			{else}
			<tr>
				<td class="title">{$smarty.const.TRANS_INCLUDE_ALL_PACKAGES_THAT_ARE}:</td>
				<td>
					<input type="checkbox" name="getActivePackages" value="1" checked /> {$smarty.const.TRANS_ACTIVE}
					&nbsp;&nbsp;
					<input type="checkbox" name="getSuspendedPackages" value="0" /> {$smarty.const.TRANS_SUSPENDED}
				</td>
			</tr>
			{/if}
			<tr>
				<td class="title">{$smarty.const.TRANS_INCLUDE_ALL_PACKAGES_THAT_RENEW_ON_OR_BEFORE}:</td>
				<td>
					{html_select_locale_date start_year=1993 end_year=2029 prefix="packageRenew" hour="23" minute="59" display_time="true" setID="true" fieldOrder=$localeData.locale_date_order} <input class="reset" type="reset" value=" ... " id="packageRenew" />
					<script type="text/javascript">
					{literal}
		            	function updatePackageRenewSelect(cal) {
							var date = cal.date;
							var selectMonth = document.getElementById("packageRenewMonth");
							selectMonth.selectedIndex = date.getMonth();
							var selectDay = document.getElementById("packageRenewDay");
							selectDay.selectedIndex = (date.getDate() - 1);
							var selectYear = document.getElementById("packageRenewYear");
							selectYear.selectedIndex = (date.getFullYear() - 1993);
						}
						Zapatec.Calendar.setup({
							button         :    "packageRenew",
							onUpdate       :     updatePackageRenewSelect,
							showsTime      :     false
						});
					{/literal}
					</script>
				</td>
			</tr>
            <tr>
                <td class="title">{$smarty.const.TRANS_WALK_PACKAGES_FORWARD}</td>
                <td><input type="radio" name="disableWalkMode" value="0" checked="checked" /> {$smarty.const.TRANS_YES}
                &nbsp;&nbsp;<input type="radio" name="disableWalkMode" value="1" /> {$smarty.const.TRANS_NO}</td>
            </tr>
			</table>
		</fieldset>

		<br />

		<fieldset>
			<legend><strong>{$smarty.const.TRANS_DOMAIN_OPTIONS}</strong></legend>
			<table width="100%" class="list">
			{if $clientInfo.clientID}
				<input type="hidden" name="getActiveDomains" value="1" />
			{else}
			<tr>
				<td class="title">{$smarty.const.TRANS_INCLUDE_ALL_DOMAINS_THAT_ARE}:</td>
				<td>
					<input type="checkbox" name="getActiveDomains" value="1" checked /> {$smarty.const.TRANS_ACTIVE}
				</td>
			</tr>
			{/if}
			<tr>
				<td class="title">{$smarty.const.TRANS_INCLUDE_ALL_DOMAINS_THAT_EXPIRE_ON_OR_BEFORE}:</td>
				<td>
					{html_select_locale_date start_year=1993 end_year=2029 prefix="domainRenew" hour="23" minute="59" display_time="true" setID="true" fieldOrder=$localeData.locale_date_order} <input class="reset" type="reset" value=" ... " id="domainRenew" />
					<script type="text/javascript">
					{literal}
		            	function updateDomainRenewSelect(cal) {
							var date = cal.date;
							var selectMonth = document.getElementById("domainRenewMonth");
							selectMonth.selectedIndex = date.getMonth();
							var selectDay = document.getElementById("domainRenewDay");
							selectDay.selectedIndex = (date.getDate() - 1);
							var selectYear = document.getElementById("domainRenewYear");
							selectYear.selectedIndex = (date.getFullYear() - 1993);
						}
						Zapatec.Calendar.setup({
							button         :    "domainRenew",
							onUpdate       :     updateDomainRenewSelect,
							showsTime      :     false
						});
					{/literal}
					</script>
				</td>
			</tr>
			</table>
		</fieldset>

		<br />
		<fieldset>
			<legend><strong>{$smarty.const.TRANS_GENERATE_INVOICE_OPTIONS}</strong></legend>
			<table width="100%" class="list">
			<tr>
				<td class="title">{$smarty.const.TRANS_INVOICE_DUE_DATE_OVERRIDE}</td>
				<td>
					{include file="$tplDirectory/widgets/dateSelector.tpl" param="overrideDateDue" optional="yes"}
				</td>
			</tr>
		{if !$clientInfo.clientID}
			<tr>
				<td class="title">{$smarty.const.TRANS_SCHEDULE_INVOICES_ON}:</td>
				<td>
					{html_select_locale_date start_year=1993 end_year=2029 prefix="scheduleTime" display_time="true" setID="true" fieldOrder=$localeData.locale_date_order} <input class="reset" type="reset" value=" ... " id="scheduleTime" />
					<script type="text/javascript">
					{literal}
		            	function updateScheduleTimeSelect(cal) {
							var date = cal.date;
							var selectMonth = document.getElementById("scheduleTimeMonth");
							selectMonth.selectedIndex = date.getMonth();
							var selectDay = document.getElementById("scheduleTimeDay");
							selectDay.selectedIndex = (date.getDate() - 1);
							var selectYear = document.getElementById("scheduleTimeYear");
							selectYear.selectedIndex = (date.getFullYear() - 1993);
						}
						Zapatec.Calendar.setup({
							button         : "scheduleTime",
							onUpdate       : updateScheduleTimeSelect,
					        showsTime      : false,
						});
					{/literal}
					</script>
				</td>
			</tr>
		{/if}
			</table>
		</fieldset>
		<table width="100%" class="list">
			<tr class="listButtons">
			<td><div><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_CONTINUE}" /></div></td>
			</tr>
		</table>
		</form>

{include file="$tplDirectory/footer.tpl"}