{* $Id: ShowInvoiceStats.tpl 9809 2006-10-24 22:11:55Z kbailey $
 * --------------------------------------------------------------
 * This template displays a mini invoice stats report.
 *
 * Smarty Variables:
 *	$invoiceStats (array of invoice status and their count)
 *		invoiceStatus
 *		numInovices
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_INVOICES" d="Invoices"}
{t c="TRANS_INVOICE_STATS" d="Invoice Stats"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_INVOICES_READY_TO_BE_GENERATED" d="Invoices ready to be generated"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_INVOICES"
	grandchildName="TRANS_QUICK_STATS"
	sideNavMajor="finances"
	sideNavMinor="invoices"}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="tab01">
<tr>
	<td>
		<div class="blueDiv">
		<table width="100%" border="0" cellpadding="0" cellspacing="1" style="border-collapse:separate;border-spacing:1px;">
		<thead>
		<tr class="headerRowBlue">
			{foreach item="statusName" key="status" from=$statusLabels}
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
					headerName=$statusName}
			{/foreach}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
				headerName="TRANS_TOTAL"}
		</tr>
		</thead>
		{assign var="total" value="0"}
		<tbody>
		<tr class="{cycle values="alt1,alt2"}">
			{assign var="totalCount" value=0}
			{assign var="totalAmount" value=0}
			{assign var="totalAmountPaid" value=0}
			{foreach item="statusName" key="status" from=$statusLabels}
				{assign var="stats" value=$invoiceStats.$status}
				{assign var="totalCount" value=$totalCount+$stats.total}
				{assign var="totalAmount" value=$totalAmount+$stats.invoiceAmount}
				{assign var="totalAmountPaid" value=$totalAmountPaid+$stats.invoiceAmountPaid}
			    <td align="center">
					{if $stats.total == 0}
						0
					{else}
						{include file="$tplDirectory/widgets/actionLink.tpl"
							page="invoices.php"
							actionName="ShowInvoices"
							args="invoiceStatus=`$stats.invoiceStatus`"
							altText=$stats.total
							linkText=$stats.total
						}
					{/if}
				</td>
			{/foreach}
			<td align="center">
				{if $totalCount == 0}
					0
				{else}
					{include file="$tplDirectory/widgets/actionLink.tpl"
						page="invoices.php"
						actionName="ShowInvoices"
						altText=$totalCount
						linkText=$totalCount
					}
				{/if}
			</td>
		</tr>
		<tr class="{cycle values="alt1,alt2"}">
			{foreach item="statusName" key="status" from=$statusLabels}
				{assign var="stats" value=$invoiceStats.$status}
			    <td align="center">
					{if $totalCount == 0}
						0%
					{else}
						{$stats.total/$totalCount*100|round}%
					{/if}
				</td>
			{/foreach}
			<td align="center">
				&nbsp;
			</td>
		</tr>
		</tbody>
		</table>

		</div>

	</td>
</tr>
</table>

<strong>{$smarty.const.TRANS_INVOICES_READY_TO_BE_GENERATED}: {$numInovicesToBeGenerated}</strong>

{include file="$tplDirectory/footer.tpl"}