{* $Id: ShowInvoices.tpl 11341 2007-06-13 15:59:53Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of invoice records.
 *
 * Smarty Variables:
 *	$invoices (array of invoices that match input criteria)
 *		invoiceID			A unique invoice ID
 *		invoiceNumber		An invoice's number
 *		invoiceAmount		An invoice's amount
 *		invoiceDateEntered	An invoice's generation date
 *		invoiceDateDue		An invoice's due date
 *		invoiceStatus		The status of an invoice
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_AMOUNT" d="Amount"}
{t c="TRANS_CLIENT" d="Client"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_INVOICEID" d="Invoice ID"}
{t c="TRANS_INVOICE_NUMBER" d="Invoice No."}
{t c="TRANS_COMMENTS" d="Comments"}
{t c="TRANS_DUE" d="Due"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_ENTERED" d="Entered"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_MANAGE_INVOICES" d="Manage Invoices"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_INVOICES" d="Show Invoices"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}


{t c="TRANS_QUANTITY" d="Quantity"}
{t c="TRANS_PACKAGE_ID" d="Package ID"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_BEGIN" d="Begin"}
{t c="TRANS_CURRENT" d="Current"}
{t c="TRANS_NEXT" d="Next"}
{t c="TRANS_PRICE" d="Price"}
{t c="TRANS_DISCOUNT" d="Discount"}
{t c="TRANS_SETUP" d="Setup"}
{t c="TRANS_TAX" d="Tax"}
{t c="TRANS_TOTALS" d="Totals"}
{t c="TRANS_ADDONS" d="Addons"}
{t c="TRANS_ADDON_ID" d="Addon ID"}
{t c="TRANS_RESULTS_SORTED_BY" d="Results Sorted By"}
{t c="TRANS_ASSIGNING_INVOICE_NUMBER" d="<em>Assigning Number</em>"}

{assign var="filterArgs" value="invoiceStatus=$invoiceStatus"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_MANAGE_INVOICES"
	grandchildName="TRANS_SHOW_INVOICES"
	sideNavMajor="finances"
	sideNavMinor="invoices"
	useMenu="finances"}

{if $client}
	{include file="$tplDirectory/widgets/context/client.tpl" client=$client suppressEditLink=1 suppressDeleteLink=1}
	{assign var="numCols" value="8"}
{else}
	{assign var="numCols" value="9"}
{/if}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>

<tr class="listRowNoBorders">
	<td colspan="{math equation="$numCols-4"}" style="text-align:left;">
	{* SUPPRESSING FOR 5.1
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$invoices}
			XKtoggle('row_{$invoices[iter].invoiceNumber}'); 
		{/section} 
		{/strip}return false;">
			<img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$invoices}
			XKtoggle('row_{$invoices[iter].invoiceNumber}'); 
		{/section} 
		{/strip}return false;">
			{$smarty.const.TRANS_ADDITIONAL_DATA}
		</a>
	*}
	</td>
	<td colspan="4" style="text-align:right;color:#666666;">
		{include file="$tplDirectory/widgets/context/sortedBy.tpl"}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		colWidth="15%" headerClass="firstTD" headerName="TRANS_INVOICE_NUMBER" sortColumn="invoiceNumber"}

	{include file="$tplDirectory/widgets/table/listHeaderSortAmount.tpl" 
		colWidth="10%" headerName="TRANS_AMOUNT" sortColumn="invoiceAmount"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerName="TRANS_PAID"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		headerName="TRANS_DUE"}

	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" 
		colWidth="10%" headerName="TRANS_ENTERED" sortColumn="invoiceDateEntered"}

	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" 
		colWidth="10%" headerName="TRANS_DUE" sortColumn="invoiceDateDue"}

	{if !$client}
		{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" 
			colWidth="25%" headerName="TRANS_CLIENT" sortColumn="clientID"}
	{/if}

	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" 
		colWidth="10%" filterName="TRANS_STATUS" filterColumn="invoiceStatus" filterOptions="$invoiceStatusList" suppressFilterName=1 mergeFilterName=1}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" 
		colWidth="20%" headerClass="lastTD" headerName="TRANS_ACTIONS"}
</tr>
</thead>
{section name="i" loop=$invoices}
	{assign var="xclientID" value=$invoices[i].clientID}
	{assign var="clientContactID" value=$invoices[i].clientContactID}
	{assign var="invoiceID" value=$invoices[i].invoiceID}
	{assign var="invoiceNumber" value=$invoices[i].invoiceNumber}
	{assign var="extendeddata" value=$invoices[i].lineItems.lineItem.0}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}"
	onmouseover="this.className='althover';"
	onmouseout="this.className='{$className}';">
	<td style="text-align:left;" {* style="cursor: pointer;" onclick="return XKtoggle('row_{$invoices[i].invoiceID}');" *}>
		&nbsp;
		<strong>
		{if $invoiceNumber}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="invoices.php"
				actionName="ShowInvoiceDetails"
				args="invoiceID=$invoiceID"
				altText=$invoiceNumber
				linkText=$invoiceNumber
			}
		{else}
			{$smarty.const.TRANS_ASSIGNING_INVOICE_NUMBER}
		{/if}
		</strong>
	</td>
	<td style="text-align:right;">
		{$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}
	</td>
	<td style="text-align:right;color:green;">
		{$invoices[i].invoiceAmountPaid|getAmount:$invoices[i].currencyID}
	</td>
	<td style="text-align:right;color:red;">
		{$invoices[i].invoiceAmountDue|getAmount:$invoices[i].currencyID}
	</td>
	<td style="text-align:center;">
		{$invoices[i].invoiceDateEntered|getDate}
	</td>
	<td style="text-align:center;">
		{if $invoices[i].invoiceStatus == "invoice"|getStatusID:"creditnote" ||
			$invoices[i].invoiceStatus == "invoice"|getStatusID:"void"}
			--
		{elseif $invoices[i].invoiceStatus == "invoice"|getStatusID:"due" ||
				$invoices[i].invoiceStatus == "invoice"|getStatusID:"declined" ||
				$invoices[i].invoiceStatus == "invoice"|getStatusID:"errored" ||
				$invoices[i].invoiceStatus == "invoice"|getStatusID:"bad_debt"}
			{if $smarty.now > $invoices[i].invoiceDateDue}	
				<strong style="color:red;">{$invoices[i].invoiceDateDue|getDate}</strong>
			{else}
				{$invoices[i].invoiceDateDue|getDate}
			{/if}
		{else}
			{* closed refunded *}
			{$invoices[i].invoiceDateDue|getDate}
		{/if}

	</td>
	{if !$client}
	<td style="text-align:left;">
		{strip}
		{if $invoices[i].invoiceClientContactID}
			{assign var="tcontactID" value=$invoices[i].invoiceClientContactID}
			{assign var="tcontact" value=$otherContacts[$tcontactID]}
			{if $tcontact.contactCompany}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$xclientID"
					clientID=$xclientID
					clientContactID=$tcontactID
					altText=$tcontact.contactCompany
					linkText=$tcontact.contactCompany
				}<span style="border-right: 1px dashed #999999;">&nbsp;</span><span style="border-left: 1px dashed #fff;">&nbsp;</span>
				{assign var="contactName" value="`$tcontact.contactLastName`, `$tcontact.contactFirstName`"}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientContacts"
					args="clientID=$xclientID&clientContactID=$tcontactID"
					altText=$contactName
					linkText=$contactName
				}
			{elseif $invoices[i].clientCompany}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$xclientID"
					clientID=$xclientID
					clientContactID=$tcontactID
					altText=$invoices[i].clientCompany
					linkText=$invoices[i].clientCompany
				}<span style="border-right: 1px dashed #999999;">&nbsp;</span><span style="border-left: 1px dashed #fff;">&nbsp;</span>
				{assign var="contactName" value="`$tcontact.contactLastName`, `$tcontact.contactFirstName`"}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientContacts"
					args="clientID=$xclientID&clientContactID=$tcontactID"
					altText=$contactName
					linkText=$contactName
				}
			{else}
				{assign var="contactName" value="`$invoices[i].contactLastName`, `$invoices[i].contactFirstName`"}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$xclientID"
					clientID=$xclientID
					clientContactID=$clientContactID
					altText=$contactName
					linkText=$contactName
				}
			{/if}
		{else}
			{if $invoices[i].clientCompany}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$xclientID"
					clientID=$xclientID
					clientContactID=$clientContactID
					altText=$invoices[i].clientCompany
					linkText=$invoices[i].clientCompany
				}<span style="border-right: 1px dashed #999999;">&nbsp;</span><span style="border-left: 1px dashed #fff;">&nbsp;</span>
				{assign var="contactName" value="`$invoices[i].contactLastName`, `$invoices[i].contactFirstName`"}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientContacts"
					args="clientID=$xclientID&clientContactID=$clientContactID"
					altText=$contactName
					linkText=$contactName
				}
			{elseif $invoices[i].clientCompany}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$xclientID"
					clientID=$xclientID
					clientContactID=$clientContactID
					altText=$invoices[i].clientCompany
					linkText=$invoices[i].clientCompany
				}<span style="border-right: 1px dashed #999999;">&nbsp;</span><span style="border-left: 1px dashed #fff;">&nbsp;</span>
				{assign var="contactName" value="`$invoices[i].contactLastName`, `$invoices[i].contactFirstName`"}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientContacts"
					args="clientID=$xclientID&clientContactID=$clientContactID"
					altText=$contactName
					linkText=$contactName
				}
			{else}
				{assign var="contactName" value="`$invoices[i].contactLastName`, `$invoices[i].contactFirstName`"}
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="clients.php"
					actionName="ShowClientDetails"
					args="clientID=$xclientID"
					clientID=$xclientID
					clientContactID=$clientContactID
					altText=$contactName
					linkText=$contactName
				}
			{/if}
		{/if}
        {/strip}
	</td>
	{/if}
	<td style="text-align:left;">
		{$invoices[i].invoiceStatus|getArrayValueByID:$invoiceStatusList}
	</td>
	<td style="text-align:center;" nowrap="nowrap">
		{strip}		
		{* DETAILS ????? redirectArgs=$bookmarkArgs *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="invoices.php"
			actionName="ShowInvoiceDetails"
			args="invoiceID=$invoiceID"
			icoImage="view"
			altText="TRANS_DETAILS"
			linkText="TRANS_DETAILS"
			noSpace="1"
		}
		&nbsp;
		{* DETAILS ????? redirectArgs=$bookmarkArgs *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="invoices.php"
			actionName="ShowInvoiceDetails"
			args="invoiceID=$invoiceID&__print=1"
			showPrintMenu="yes"
			icoImage="printer_view.gif"
			altText="TRANS_PRINT"
			linkText="TRANS_PRINT"
			noSpace="1"
			target="_blank"
		}
		{/strip}
	</td>
</tr>
</tbody>

{* SUPPRESSING THIS FOR 5.1 
<tbody id="row_{$invoices[i].invoiceID}" class="off">
<tr class="althover">
	<td colspan="{$numCols}">
		{$smarty.const.TRANS_COMMENTS}: {$invoices[i].invoiceComments}

		{if $lineItems[$invoiceID]}
			<table width="100%" border="1" cellpadding="4" class="ledger">
			<tr>
                <td class="green" style="white-space: nowrap;">{$smarty.const.TRANS_PACKAGE_ID}</td>
				<td class="green" colspan="2">{$smarty.const.TRANS_DESCRIPTION}</td>
				<td class="green">{$smarty.const.TRANS_BEGIN}</td>
				<td class="green">{$smarty.const.TRANS_CURRENT}</td>
				<td class="green">{$smarty.const.TRANS_NEXT}</td>
                <td>{$smarty.const.TRANS_QUANTITY}</td>
				<td>{$smarty.const.TRANS_PRICE}</td>
				<td>{$smarty.const.TRANS_DISCOUNT}</td>
				<td>{$smarty.const.TRANS_SETUP}</td>
				<td>{$smarty.const.TRANS_TAX}</td>
				<td>{$smarty.const.TRANS_TOTALS}</td>
			</tr>
            {assign var="inaddons" value="no"}
			{section name="j" loop=$lineItems[$invoiceID]}
				{assign var="currencyID" value=$lineItems[$invoiceID][j].currencyID}
                {if $lineItems[$invoiceID][j].packageAddonID>0}
                    {if $inaddons=="no"}
                        {assign var="inaddons" value="yes"}
                        <tr class="alt1">
                            <td class="green" align="right">{$smarty.const.TRANS_ADDONS}</td>
                            <td class="green" colspan="5">{$smarty.const.TRANS_DESCRIPTION}  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                            <td>{$smarty.const.TRANS_QUANTITY}</td>
                            <td>{$smarty.const.TRANS_PRICE}</td>
                            <td>{$smarty.const.TRANS_DISCOUNT}</td>
                            <td>{$smarty.const.TRANS_SETUP}</td>
                            <td>{$smarty.const.TRANS_TAX}</td>
                            <td>{$smarty.const.TRANS_TOTALS}</td>
                        </tr>
                    {/if}
                        <tr>
                            <td class="green" align="right">{$lineItems[$invoiceID][j].packageAddonID}</td>
                            <td class="green" colspan="5">{$lineItems[$invoiceID][j].lineItemDescription}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemQuantity}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemPriceAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemDiscountAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemSetupAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemTaxAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemTotalAmount|getAmount:$currencyID}</td>
                        </tr>


                {else}
                {assign var="inaddons" value="no"}
				<tr class="alt1">
                    <td class="green">{$lineItems[$invoiceID][j].packageID}</td>
					<td class="green" colspan="2">{$lineItems[$invoiceID][j].lineItemDescription}</td>
					<td class="green">{$lineItems[$invoiceID][j].lineItemDateBeginRenewal|getDate:"short"}</td>
					<td class="green">{$lineItems[$invoiceID][j].lineItemDateCurrentRenewal|getDate:"short"}</td>
					<td class="green">{$lineItems[$invoiceID][j].lineItemDateNextRenewal|getDate:"short"}</td>
                    <td>{$lineItems[$invoiceID][j].lineItemQuantity}</td>
					<td>{$lineItems[$invoiceID][j].lineItemPriceAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemDiscountAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemSetupAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemTaxAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemTotalAmount|getAmount:$currencyID}</td>
				</tr>
                {/if}
			{/section}
			</table>
		{else}
			<br />
			No Line Items
    	{/if}
	</td>
</tr>
</tbody>
*}

{sectionelse}
<tr class="alt1">
	<td colspan="{$numCols}">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="clientID=`$clientID`"}
{include file="$tplDirectory/footer.tpl"}
