
{t c="TRANS_MORE_STEPS" d="more steps"}
{t c="TRANS_MIGRATION_ACTION" d="Migration Action"}
{t c="TRANS_NUM_CLIENTS_PER_STEP" d="Clients Per Step"}
{t c="TRANS_MIGRATION_NUM_STEPS" d="Number of steps"}
{t c="TRANS_MIGRATE" d="Migrate"}
{t c="TRANS_DEMIGRATE" d="Demigrate"}
{t c="TRANS_CONTROL" d="Control"}
{t c="TRANS_START" d="Start"}
{t c="TRANS_PERFORM_MIGRATION_TASKS" d="Perform Migration Tasks"}
{t c="TRANS_RUN_MIGRATION" d="Run Migration"}
{t c="TRANS_RUN_CLIENT_MIGRATION" d="Run Client Migration"}
{t c="TRANS_ALL" d="All"}
{t c="TRANS_MIGRATION_PROGRESS" d="Migration Progress"}
{t c="TRANS_ESTIMATED_TIME_LEFT" d="Estimated Time Left"}
{t c="TRANS_TOTAL_TIME" d="Total Time"}
{t c="TRANS_SKIP_ONE_AND_GO" d="Skip client and continue"}
{t c="TRANS_DOUBLE_CHECK_ADDON_CHOICES" d="Double-check Add-on Choices"}
{t c="TRANS_SHOW_HIDE_DEBUG_INFORMATION" d="Show/Hide Debug Info"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_MIGRATION"
	childName="TRANS_PERFORM_MIGRATION_TASKS"
	grandchildName="TRANS_RUN_CLIENT_MIGRATION"
	sideNavMajor="system"
	sideNavMinor="migrate"}



<script language="javascript">
<!--

var migrationProcessURL = "migrate.php?sid={$sid}&action={getActionID action="MigrateProcess"}&migrationConfigID={$migrationConfigID}";
var migrationDeprocessURL = "migrate.php?sid={$sid}&action={getActionID action="MigrateDeprocess"}&migrationConfigID={$migrationConfigID}";
var migrationSkipURL = "migrate.php?sid={$sid}&action={getActionID action="MigrateSkip"}&migrationConfigID={$migrationConfigID}";
var containerWidth = parseInt('{$containerWidth}');

var totalToDo = '{$totalClients}';

{literal}

var keepGoing = false;
var totalExecutionTime = 0;
var totalTime = 0;
var intervalHolder = false;
var numDone = 0;
var numDoneAdjust = 0;

function getRadioValue(f, name){
	for (i=0; i<f.elements.length; i++){
		if (f.elements[i].name==name && f.elements[i].checked){
			return f.elements[i].value;
		}
	}
}

function getCurrentSeconds(){
	var d = new Date();
	return d.formatDate("U");
}

function updateTimes(){
	totalTime++;
	updateTotalTime(totalTime);

	var t = parseInt(totalToDo);
	var leftToDo = totalToDo-numDone;
	var d = numDone-numDoneAdjust;
	if (d>0){
		var pers = d/totalTime;

		timeLeft = leftToDo/pers;		

		updateEstimatedTime(Math.round(timeLeft));
		updateClientsPerSecond(pers.toFixed(3));
	}
}

function updateTotalTime(time){
	document.getElementById('totalTimeSpan').innerHTML = makeDisplayTime(time);	
}

function updateEstimatedTime(time){
	document.getElementById('estimatedTimeSpan').innerHTML = makeDisplayTime(time);	
}

function updateClientsPerSecond(perSec){
	document.getElementById('perSec').innerHTML = " ("+perSec+"/sec)";	
}

function makeDisplayTime(stamp){
	var seconds = stamp%60;
	var minutes = Math.round(stamp/60)%60;
	var hours = Math.round(stamp/(60*60))%24;
	var days = Math.round(stamp/(60*60*24))*1;
	return days+":"+paddTwo(hours)+":"+paddTwo(minutes)+":"+paddTwo(seconds);
}

function paddTwo(num){
	if (num<10){
		return "0"+num;
	} else {
		return ""+num;
	}
}

function getMigrationSettings(){
	var f = document.migrationSettings;
	
	var ret = new Array();
	ret["clientsPerStep"] = parseInt(f.numClientsPerStep.value);
	ret["action"] = getRadioValue(f, "migrationAction");
	ret["steps"] = getRadioValue(f, "migrationSteps");
	ret["numSteps"] = f.numSteps.value;
	ret["doNotMigrateProducts"] = getRadioValue(f, "doNotMigrateProducts");
	ret["migratorID"] = f.migratorID.value;
	if(typeof f.clientID != "undefined") {
		ret["clientID"] = f.clientID.value;
	}
	
	return ret;
}

function migrationSkip(){
	var settings = getMigrationSettings();
	keepGoing = true;
	intervalHolder = setInterval("updateTimes();", 1000);
	disableStartFormElements();
	document.getElementById('migrationStatusWindow').src = migrationSkipURL;
}

function migrationStart(){
	var settings = getMigrationSettings();
	keepGoing = true;
	intervalHolder = setInterval("updateTimes();", 1000);
	if (settings['action']=="migrate"){
		runMigrationLoad();
	} else {
		runDemigrationLoad();
	}
}

function migrationStop(){
	keepGoing = false;
}

function runMigrationLoad(){
	if (keepGoing==true){
		disableStartFormElements();
		var settings = getMigrationSettings();
		if (settings['steps']=="all"){
			if(typeof f.clientID != "undefined") {
				document.getElementById('migrationStatusWindow').src = migrationProcessURL+"&clientProcessStep="+settings['clientsPerStep']+"&clientID="+settings['clientID']+"&doNotMigrateProducts="+settings['doNotMigrateProducts']+"&migratorID="+settings['migratorID']+"&"+Math.random();
			} else {
				document.getElementById('migrationStatusWindow').src = migrationProcessURL+"&clientProcessStep="+settings['clientsPerStep']+"&doNotMigrateProducts="+settings['doNotMigrateProducts']+"&migratorID="+settings['migratorID']+"&"+Math.random();
			}
		} else {
			if (settings['numSteps']<1){
				enableStartFormElements();
			} else {
				document.migrationSettings.numSteps.value = document.migrationSettings.numSteps.value-1;
				if(typeof f.clientID != "undefined") {
					document.getElementById('migrationStatusWindow').src = migrationProcessURL+"&clientProcessStep="+settings['clientsPerStep']+"&clientID="+settings['clientID']+"&doNotMigrateProducts="+settings['doNotMigrateProducts']+"&migratorID="+settings['migratorID']+"&"+Math.random();
				} else {
					document.getElementById('migrationStatusWindow').src = migrationProcessURL+"&clientProcessStep="+settings['clientsPerStep']+"&doNotMigrateProducts="+settings['doNotMigrateProducts']+"&migratorID="+settings['migratorID']+"&"+Math.random();
				}
			}
		}
	} else {
		enableStartFormElements();
	}
}

function runDemigrationLoad(){
	if (keepGoing==true){
		disableStartFormElements();
		var settings = getMigrationSettings();
		if (settings['steps']=="all"){
			document.getElementById('migrationStatusWindow').src = migrationDeprocessURL+"&clientProcessStep="+settings['clientsPerStep']+"&"+Math.random();
		} else {
			if (settings['numSteps']<1){
				enableStartFormElements();
			} else {
				document.migrationSettings.numSteps.value = document.migrationSettings.numSteps.value-1;
				document.getElementById('migrationStatusWindow').src = migrationDeprocessURL+"&clientProcessStep="+settings['clientsPerStep']+"&"+Math.random();
			}
		}
	} else {
		enableStartFormElements();
	}
}

function enableStartFormElements(){
	clearInterval(intervalHolder);
	f = document.migrationSettings;
	for (i=0;i<f.elements.length; i++){
		f.elements[i].disabled = false;
	}
	f.controlStop.disabled = true;
}

function disableStartFormElements(){
	f = document.migrationSettings;
	for (i=0;i<f.elements.length; i++){
		f.elements[i].disabled = true;
	}
	f.controlStop.disabled = false;
}

function updateNumClients(done){
	var t = parseInt(totalToDo);
	var d = parseInt(done);
	numDone = d;
	if (numDoneAdjust==0){
		numDoneAdjust = numDone;
	}
	if (t<1){
		updateProgressBarSize(0);
	} else {
		var percentage = d/t;
		var udw = percentage*containerWidth;
		percentage = percentage*100;
		if(percentage > 50) {
			updateProgressBarLeftPercentage(percentage.toFixed(2)+"%");
			updateProgressBarRightPercentage("");
		} else {
			updateProgressBarLeftPercentage("");
			updateProgressBarRightPercentage(percentage.toFixed(2)+"%");
		}
		updateProgressBarSize(""+udw);
	}
}

function updateProgressBarSize(size){
	document.getElementById('clientsProgressBarParent').style.width = (parseInt(size)+10)+"px";
	document.getElementById('clientsProgressBar').style.width = parseInt(size)+"px";
}

function updateProgressBarRightPercentage(value){
	document.getElementById('clientsProgressBarRightPercentage').innerHTML = value;
}

function updateProgressBarLeftPercentage(value){
	document.getElementById('clientsProgressBarLeftPercentage').innerHTML = value;
}


function toggleMDebug(){
	if ($('migrationStatusWindow').style.display=="none"){
		$('migrationStatusWindow').style.display = 'block';
	} else {
		$('migrationStatusWindow').style.display = 'none';
	}
}



{/literal}
// -->
</script>

<form name="migrationSettings" onsubmit="return false;">
<fieldset>
<legend><span id="titleHeader">{$smarty.const.TRANS_PERFORM_MIGRATION_TASKS}</span></legend>

<table border="0" width="100%" class="list">

	<tr>
		<td class="title">{$smarty.const.TRANS_MIGRATION_ACTION}: </td>
		<td><input type="radio" value="migrate" name="migrationAction" checked="checked" /> {$smarty.const.TRANS_MIGRATE} &nbsp;&nbsp;&nbsp; <input type="radio" name="migrationAction" value="demigrate" /> {$smarty.const.TRANS_DEMIGRATE}
		</td>
	</tr>

	<tr>
		<td class="title">{$smarty.const.TRANS_NUM_CLIENTS_PER_STEP}: </td>
		<td><input type="text" size="5" value="5" name="numClientsPerStep" /></td>
	</tr>

	<tr>
		<td class="title">{$smarty.const.TRANS_MIGRATION_NUM_STEPS}: </td>
		<td><input type="radio" value="all" name="migrationSteps" checked="checked" /> {$smarty.const.TRANS_ALL} &nbsp;&nbsp;&nbsp; <input type="radio" name="migrationSteps" value="set" /> <input type="text" size="5" name="numSteps" value="10" /> {$smarty.const.TRANS_MORE_STEPS}</td>
	</tr>

{if $migrateProducts}
	<tr>
		<td class="title">{$smarty.const.TRANS_DOUBLE_CHECK_ADDON_CHOICES}: </td>
		<td><input type="radio" value="0" name="doNotMigrateProducts" /> {$smarty.const.TRANS_YES} &nbsp;&nbsp;&nbsp; <input type="radio" name="doNotMigrateProducts" value="1" checked="checked" /> {$smarty.const.TRANS_NO}
		</td>
	</tr>
{else}
	<input type="hidden" name="doNotMigrateProducts" value="0" />
{/if}
	
	{if $smarty.request.override}
	<tr>
		<td class="title">{$smarty.const.TRANS_OVERRIDE_ID}: </td>
		<td><input type="text" size="5" value="" name="clientID" /></td>
	</tr>
	{/if}

{if $distributionMetrics.1}
	<tr>
		<td class="title">{$smarty.const.TRANS_MIGRATOR_ID}: </td>
		<td><select name="migratorID">
			{html_options options=$distributionMetrics selected=$migratorID}
		</select></td>
	</tr>
{else}
	<input type="hidden" name="migratorID" value="0" />
{/if}
	
	<tr>
		<td class="title">{$smarty.const.TRANS_CONTROL}:</td>
		<td><input type="button" name="controlStart" value="{$smarty.const.TRANS_START}" onclick="migrationStart();" /> <input type="button" name="controlStop" value="{$smarty.const.TRANS_STOP}" disabled="disabled" onclick="migrationStop();" />
		</td>
	</tr>
</table>
<table width="100%" border="0" class="list">
	<tr>
		<td colspan="2">
		<span id="timeSpan" style="float: right;">{$smarty.const.TRANS_TOTAL_TIME}: <span id="totalTimeSpan" style="font-weight: bold;">--:--:--:--</span> ,{$smarty.const.TRANS_ESTIMATED_TIME_LEFT}: <span id="estimatedTimeSpan" style="font-weight: bold;">--:--:--:--</span> <span id="perSec"></span></span>
		<strong>{$smarty.const.TRANS_MIGRATION_PROGRESS}</strong> &nbsp;
		<a href="javascript:toggleMDebug();">[{$smarty.const.TRANS_SHOW_HIDE_DEBUG_INFORMATION}]</a>
		<br />
		{include file="$tplDirectory/widgets/progressBar.tpl"
		      tdid="clientsProgressBar"
		      containerWidth=$containerWidth
		      containerColor="#cccccc"
		      barWidth=$barWidth
		      rightPercentage=$rightPercentage
		      leftPercentage=$leftPercentage
		      rightPercentageColor="#000000"
		      leftPercentageColor="#ffffff"
		      }

		
		</td>
	</tr>

</table>
</fieldset>

<iframe style="display: none;" src="blank.php" height="300" width="100%" name="migrationStatusWindow" id="migrationStatusWindow"></iframe>





{include file="$tplDirectory/footer.tpl"}
