{* $Id: AddHistoricalPackage.tpl 12529 2008-01-21 17:18:29Z kbailey $
 * --------------------------------------------------------------
 *
 * Author: Ben Woolley
 *}
{t c="TRANS_ADD_NEW_PACKAGE" d="Add New Package"}
{t c="TRANS_IMPORT_EXISTING_PACKAGE" d="Import Existing Package"}
{t c="TRANS_WHEN_PACKAGE_START_DATE_OLD" d="When did this package start?"}
{t c="TRANS_WHEN_PACKAGE_START_DATE_NEW" d="When should this package start?"}
{t c="TRANS_NEXT_RENEWAL_DATE" d="Next Renewal Date"}
{t c="TRANS_START_DATE" d="Start Date"}
{t c="TRANS_OTHER" d="Other"}
{t c="TRANS_REGISTER_DOMAIN" d="Register Domain"}
{t c="TRANS_TRANSFER_PRICE" d="Transfer Price"}
{t c="TRANS_NO_SERVER_GROUPS" d="No Server Groups"}
{t c="TRANS_PANELS" d="Panels"}
{t c="TRANS_CREATE" d="Create"}
{t c="TRANS_GENERATE_IMMEDIATELY" d="Generate Immediately"}
{t c="TRANS_ENABLE_INVOICE_EMAIL" d="Enable Invoice Email"}
{t c="TRANS_CHARGE_IMMEDIATELY" d="Charge Immediately"}
{t c="TRANS_INVOICE_DUE_DATE_OVERRIDE" d="Invoice Due Date Override"}
{t c="TRANS_ON_INVOICES" d="On Invoices"}
{t c="TRANS_NEW_ORDER_EMAIL" d="New Order Email"}
{t c="TRANS_EMAIL_TO_SEND" d="Email To Send"}

{if $historical}{assign var="label" value="TRANS_IMPORT_EXISTING_PACKAGE"}{else}{assign var="label" value="TRANS_ADD_NEW_PACKAGE"}{/if}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName=$label
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="packages"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/client.tpl" client=$clientInfo suppressEditLink=1 suppressDeleteLink=1}
{include file="$tplDirectory/widgets/context/product.tpl" product=$product types=$productTypes}
{if $productType == "domain"}
	{include file="$tplDirectory/widgets/context/tld.tpl" TLD=$TLD}
{/if}
{include file="$tplDirectory/widgets/context/cycle.tpl" cycle=$cycle}

<form method="post" action="packages.php">
<input type="hidden" name="action" value="{getActionID action="AddHistoricalPackageResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="clientID" value="{$clientID}" />
<input type="hidden" name="orderFormID" value="{$orderFormID}" />
<input type="hidden" name="productID" value="{$productID}" />
<input type="hidden" name="productVariantID" value="{$productVariantID}" />
<input type="hidden" name="cycleID" value="{$cycleID}" />
<input type="hidden" name="mode" value="{$mode}" />

<fieldset>
<legend>{$smarty.const.$label}</legend>

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>
{if $historical && $product.productStopNumCycles != 1}
	<tr {if $invalid.packageNextRenewal}class="highlight"{/if}>
		<td class="title"><label for="packageNextRenewal">{$smarty.const.TRANS_NEXT_RENEWAL_DATE}</label></td>
		<td>
			{include file="$tplDirectory/widgets/dateSelector.tpl" param="packageNextRenewal"}
		</td>
	</tr>
{/if}
<tr {if $invalid.packageStartDate}class="highlight"{/if}>
	<td class="title"><label for="packageStartDate">{$smarty.const.TRANS_START_DATE}</label></td>
	<td>
		{include file="$tplDirectory/widgets/dateSelector.tpl" param="packageStartDate"}
	{if $historical}
		{$smarty.const.TRANS_WHEN_PACKAGE_START_DATE_OLD}
	{else}
		{$smarty.const.TRANS_WHEN_PACKAGE_START_DATE_NEW}
	{/if}
	</td>
</tr>

{if $associateDomain}
	<tr {if $invalid.domainName}class="highlight"{/if}>
		<td class="title"><label for="domainName">{$smarty.const.TRANS_DOMAIN}</label></td>
		<td>
			{if $clientDomains}
				<select id="packageDomainID" name="packageDomainID"> <option value="">{$smarty.const.TRANS_OTHER}</option> {html_options options=$clientDomains selected=$formValues.packageDomainID} </select> {$invalid.packageDomainID}  {$smarty.const.TRANS_OTHER}
			{/if}
			<input size="32" maxlength="255" type="text" id="domainName" name="domainName" value="{$formValues.domainName}" />
			{$invalid.domainName}
			{if $tldExtension}.{$tldExtension}{else}. <input style="width: 5em;" size="5" maxlength="255" type="text" id="domainTLD" name="domainTLD" value="{$formValues.domainTLD}" />{/if}
			{$invalid.domainTLD}
		</td>
	</tr>

{/if}

{if $productType == "domain"}
	<tr {if $invalid.registerDomain}class="highlight"{/if}>
		<td class="title"><label for="registerDomain">{$smarty.const.TRANS_REGISTER_DOMAIN}</label></td>
		<td>
			{include file="$tplDirectory/widgets/dateSelector.tpl" param="registerDomain" optional="yes"}
		</td>
	</tr>
{/if}

<tr {if $invalid.billingAccountID}class="highlight"{/if}>
	<td class="title"><label for="billingAccountID">{$smarty.const.TRANS_BILLING_ACCOUNT}</label></td>
	<td>
		<select id="billingAccountID" name="billingAccountID"> <option value="">{$smarty.const.TRANS_NONE}</option> {html_options options=$clientBillingAccounts selected=$formValues.billingAccountID} </select>
		{$invalid.billingAccountID}
		<input type="checkbox" id="enableCharging" name="enableCharging" value="1" checked="checked" /> <label for="enableCharging">{$smarty.const.TRANS_CHARGE_IMMEDIATELY}</label>
	</td>
</tr>

<tr {if $invalid.generalPrice}class="highlight"{/if}>
	<td class="title"><label for="comments">{$smarty.const.TRANS_COMMENTS} ({$smarty.const.TRANS_ON_INVOICES})</label></td>
	<td>
		<textarea id="comments" name="comments" style="width: 97%;" rows="4"></textarea>
	</td>
</tr>

{if $formValues.generalPrice != -1}
	<tr {if $invalid.generalPrice}class="highlight"{/if}>
		<td class="title"><label for="generalPrice">{$smarty.const.TRANS_PRICE}</label></td>
		<td>
			<input size="32" maxlength="255" type="text" id="generalPrice" name="generalPrice" value="{$formValues.generalPrice|getAmount:$currencyID}" onchange="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true};{1000|getAmount:$currencyID:true:true}', this.value, '{$localeData.locale_separator_decimal}', '{$localeData.locale_separator_grouping}');" />
			{$invalid.generalPrice}
		</td>
	</tr>
{/if}
{if $formValues.setupPrice != -1}
	<tr {if $invalid.setupPrice}class="highlight"{/if}>
		<td class="title"><label for="setupPrice">{$smarty.const.TRANS_SETUP_PRICE}</label></td>
		<td>
			<input size="32" maxlength="255" type="text" id="setupPrice" name="setupPrice" value="{$formValues.setupPrice|getAmount:$currencyID}" onchange="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true};{1000|getAmount:$currencyID:true:true}', this.value, '{$localeData.locale_separator_decimal}', '{$localeData.locale_separator_grouping}');" />
			{$invalid.setupPrice}
		</td>
	</tr>
{/if}
{*
{if $formValues.transferPrice != -1}
	<tr {if $invalid.transferPrice}class="highlight"{/if}>
		<td class="title"><label for="transferPrice">{$smarty.const.TRANS_TRANSFER_PRICE}</label></td>
		<td>
			<input size="32" maxlength="255" type="text" id="transferPrice" name="transferPrice" value="{$formValues.transferPrice|getAmount:$currencyID}" onchange="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true};{1000|getAmount:$currencyID:true:true}', this.value, '{$localeData.locale_separator_decimal}', '{$localeData.locale_separator_grouping}');" />
			{$invalid.transferPrice}
		</td>
	</tr>
{/if}
*}

{if $productType != "domain"}
	<tr>
		<td class="title">{$smarty.const.TRANS_SERVER_GROUPS}</td>
		<td>
			{foreach from=$serverGroups key="serverGroupID" item="serverGroupName"}
				{assign var="panels" value=$panelsByServerGroupID.$serverGroupID}
				<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
				<tbody>
				<tr>
					<td class="title">{$serverGroupName}</td>
					<td>
						<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
						<tbody>
							{assign var="usernameArg" value="sg`$serverGroupID`username"}
							{assign var="passwordArg" value="sg`$serverGroupID`password"}
							{assign var="panelArg" value="sg`$serverGroupID`panel"}
							{assign var="createArg" value="sg`$serverGroupID`create"}
							
							<tr>
								<td class="title">{$smarty.const.TRANS_USERNAME}</td>
								<td><input size="32" maxlength="255" type="text" id="{$usernameArg}" name="{$usernameArg}" value="{$formValues.$usernameArg}" /></td>
							</tr>
							<tr>
								<td class="title">{$smarty.const.TRANS_PASSWORD}</td>
								<td><input size="32" maxlength="255" type="text" id="{$passwordArg}" name="{$passwordArg}" value="{$formValues.$passwordArg}" /></td>
							</tr>
							{if $historical}
							<tr>
								<td class="title">{$smarty.const.TRANS_PANELS}</td>
								<td><select id="{$panelArg}" name="{$panelArg}"> {html_options options=$panels selected=$formValues.panelArg} </select></td>
							</tr>
							{/if}
							<tr>
								<td class="title">{$smarty.const.TRANS_CREATE}</td>
								<td>{include file="$tplDirectory/widgets/dateSelector.tpl" param=$createArg optional="yes"}</td>
							</tr>
						</tbody>
						</table>
					</td>
				</tr>
				</tbody>
				</table>
			{foreachelse}
				{$smarty.const.TRANS_NO_SERVER_GROUPS}
			{/foreach}
		</td>
	</tr>
{/if}


<tr>
	<td class="title"><label for="generateInvoice">{$smarty.const.TRANS_INVOICE}</label></td>
	<td>
		<input type="checkbox" checked="checked" id="generateInvoice" name="generateInvoice" value="1" xonmouseup="setTimeout('checkEnableEmailCheckbox();', 100)" /> <label xonmouseup="setTimeout('checkEnableEmailCheckbox();', 100)" for="generateInvoice">{$smarty.const.TRANS_GENERATE_IMMEDIATELY}</label>
	</td>
</tr>
<tr>
	<td class="title">{$smarty.const.TRANS_EMAIL_TO_SEND}</td>
	<td>
		<select name="emailOptions">
			<option value="0">{$smarty.const.TRANS_NONE}</option>
			<option value="1">{$smarty.const.TRANS_NEW_ORDER_EMAIL}</option>
			<option value="2">{$smarty.const.TRANS_INVOICE_EMAIL}</option>
		</select>
	</td>
</tr>
<tr {if $invalid.registerDomain}class="highlight"{/if}>
	<td class="title"><label for="registerDomain">{$smarty.const.TRANS_INVOICE_DUE_DATE_OVERRIDE}</label></td>
	<td>
		{include file="$tplDirectory/widgets/dateSelector.tpl" param="overrideDateDue" optional="yes"}
	</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div>
	<input class="submit" type="submit" name="submit" value="{$smarty.const.$label}" />
	</div></td>
</tr>
</table>
</fieldset>
</form>

{literal}
<script type="text/javascript">
	function checkEnableEmailCheckbox() {
		if(document.getElementById('generateInvoice').checked == true) {
			document.getElementById('enableInvoiceEmail').disabled = false;
		} else {
			document.getElementById('enableInvoiceEmail').disabled = true;
		}
	}
	checkEnableEmailCheckbox();
</script>
{/literal}


{include file="$tplDirectory/footer.tpl"}
