{* $Id: AddTLD.tpl 9605 2006-10-16 20:48:42Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to edit an existing client.
 *
 * Smarty Variables:
 *	$formValues (array of this clients data)
 *		clientID			A unique client ID
 *		clientFirstName		A client's first name
 *		clientLastName		A client's last name
 *		clientEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_TLDID" d="TLD ID"}
{t c="TRANS_TLDS" d="TLDs"}
{t c="TRANS_TLD" d="TLD"}
{t c="TRANS_MANAGE_PRODUCTS" d="Manage Products"}
{t c="TRANS_ADD" d="Add"}
{t c="TRANS_ADD_TLD" d="Add TLD"}
{t c="TRANS_RESET" d="Reset"}

{t c="TRANS_ID" d="ID"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_EXTENSION" d="Extension"}
{t c="TRANS_WHOIS_SERVER" d="Whois Server"}
{t c="TRANS_WHOIS_RESPONSE" d="Whois Response"}
{t c="TRANS_ACCEPTED" d="Accepted"}
{t c="TRANS_ACCEPTABLE" d="Acceptable"}
{t c="TRANS_UNACCEPTABLE" d="Unacceptable"}
{t c="TRANS_AUTO_SEARCH" d="Auto Search"}
{t c="TRANS_TRANSFER_MINIMUM_CYCLE" d="Transfer Minimum Term"}
{t c="TRANS_MINIMUM_TERM" d="Minimum Term"}
{t c="TRANS_MAXIMUM_TERM" d="Maximum Term"}
{t c="TRANS_LOCAL_RENEW_TYPE" d="Local Renew Type"}
{t c="TRANS_IS_TRANSFERABLE" d="Is Transferable"}
{t c="TRANS_TRANSFER_TYPE" d="Transfer Type"}
{t c="TRANS_IDN_SUPPORT" d="IDN Support"}
{t c="TRANS_IDN_TYPE" d="IDN Type"}
{t c="TRANS_REMOTE_LOCK" d="Remote Lock"}
{t c="TRANS_REMOTE_AUTORENEW" d="Remote Autorenew"}
{t c="TRANS_REGISTRAR" d="Registrar"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_YEAR" d="Year"}
{t c="TRANS_ENABLED" d="Enabled"}

{t c="TRANS_ORDER_FORMS" d="Order Forms"}
{t c="TRANS_ORDER_FORM_ID" d="Order Form ID"}
{t c="TRANS_ORDER_FORM_NAME" d="Order Form Name"}

{t c="TRANS_CYCLES" d="Cycles"}

{t c="TRANS_SELECTED" d="Selected"}
{t c="TRANS_SELECTABLE" d="Selectable"}

{t c="TRANS_UNSUPPORTED_TLD" d="This Registrar does not support this TLD"}


{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_TLDS"
	grandchildName="TRANS_ADD"
	sideNavMajor="products"
	sideNavMinor="tlds"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form name="addTLD" method="post" action="products.php">
<input type="hidden" name="action" value="{getActionID action="AddTLDResponse"}">
<input type="hidden" name="tldID" value="{$formValues.tldID}">
<input type="hidden" name="sid" value="{$sid}">

<fieldset>
<legend>{$smarty.const.TRANS_TLD}</legend>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
<tbody>
<tr {if $invalid.tldName}class="highlight"{/if}>
	<td class="title"><label for="tldName">{$smarty.const.TRANS_NAME}</label></td>
	<td><input size="80"	maxlength="100" type="text" id="tldName" name="tldName" value="{$formValues.tldName}" /> {$invalid.tldName}</td>
</tr>
<tr {if $invalid.tldExtension}class="highlight"{/if}>
	<td class="title"><label for="tldExtension">{$smarty.const.TRANS_EXTENSION}</label></td>
	<td><input size="25" maxlength="25" type="text" id="tldExtension" name="tldExtension" value="{$formValues.tldExtension}" /> {$invalid.tldExtension}</td>
</tr>
<tr {if $invalid.registrarID}class="highlight"{elseif $tldNotSupported}class="highlight"{/if}>
	<td class="title"><label for="registrarID">{$smarty.const.TRANS_REGISTRAR}</label></td>
	<td><select id="registrarID" name="registrarID"> {html_options options=$registrars selected=$formValues.registrarID} </select> {$invalid.registrarID}{if $tldNotSupported}{$smarty.const.TRANS_UNSUPPORTED_TLD}{/if}</td>
</tr>
<tr {if $invalid.tldAccepted}class="highlight"{/if}>
	<td class="title"><label for="tldActive">{$smarty.const.TRANS_ACTIVE}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldActive" value="0">
		<input type="checkbox" id="tldActive" name="tldActive" value="1" {strip}
			{if $formValues.tldActive}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldActive">{$smarty.const.TRANS_ACTIVE}</label>
		{$invalid.tldActive}
	</td>
</tr>
{*
* We may already know what the whois server and response is. Only fringe cases will this need to be defined,
* otherwise it only causes confusion.
<tr {if $invalid.tldWhoisServer}class="highlight"{/if}>
	<td class="title"><label for="tldWhoisServer">{$smarty.const.TRANS_WHOIS_SERVER}</label></td>
	<td><input size="80" 	maxlength="100" type="text" id="tldWhoisServer" name="tldWhoisServer" value="{$formValues.tldWhoisServer}" /> {$invalid.tldWhoisServer}</td>
</tr>
<tr {if $invalid.tldWhoisResp}class="highlight"{/if}>
	<td class="title"><label for="tldWhoisResp">{$smarty.const.TRANS_WHOIS_RESPONSE}</label></td>
	<td><input size="80" 	maxlength="100" type="text" id="tldWhoisResp" name="tldWhoisResp" value="{$formValues.tldWhoisResp}" /> {$invalid.tldWhoisResp}</td>
</tr>
*}
<tr {if $invalid.tldAutoSearch}class="highlight"{/if}>
	<td class="title"><label for="tldAutoSearch">{$smarty.const.TRANS_AUTO_SEARCH}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldAutoSearch" value="0">
		<input type="checkbox" id="tldAutoSearch" name="tldAutoSearch" value="1" {strip}
			{if $formValues.tldAutoSearch}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldAutoSearch">{$smarty.const.TRANS_ENABLED}</label>
		{$invalid.tldAutoSearch}
	</td>
</tr>
<tr {if $invalid.tldIsTransferable}class="highlight"{/if}>
	<td class="title"><label for="tldIsTransferable">{$smarty.const.TRANS_IS_TRANSFERABLE}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldIsTransferable" value="0">
		<input type="checkbox" id="tldIsTransferable" name="tldIsTransferable" value="1" {strip}
			{if $formValues.tldIsTransferable}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldIsTransferable">{$smarty.const.TRANS_YES}</label>
		{$invalid.tldIsTransferable}
	</td>
</tr>
<tr {if $invalid.tldTransferType}class="highlight"{/if}>
	<td class="title"><label for="tldTransferType">{$smarty.const.TRANS_TRANSFER_TYPE}</label></td>
	<td><select id="tldTransferType" name="tldTransferType"> {html_options options=$transferTypes selected=$formValues.tldTransferType} </select> {$invalid.tldTransferType}</td>
</tr>
<tr {if $invalid.tldTransferMinimumCycleID}class="highlight"{/if}>
	<td class="title"><label for="tldTransferMinimumCycleID">{$smarty.const.TRANS_TRANSFER_MINIMUM_CYCLE}</label></td>
	<td><select id="tldTransferMinimumCycleID" name="tldTransferMinimumCycleID"> {html_options options=$cycleList selected=$formValues.tldTransferMinimumCycleID} </select> {$invalid.tldTransferMinimumCycleID}</td>
</tr>
<tr {if $invalid.tldMinimumCycleID}class="highlight"{/if}>
	<td class="title"><label for="tldMinimumCycleID">{$smarty.const.TRANS_MINIMUM_TERM}</label></td>
	<td><select id="tldMinimumCycleID" name="tldMinimumCycleID"> {html_options options=$cycleList selected=$formValues.tldMinimumCycleID} </select> {$invalid.tldMinimumCycleID}</td>
</tr>
<tr {if $invalid.tldMaximumCycleID}class="highlight"{/if}>
	<td class="title"><label for="tldMaximumCycleID">{$smarty.const.TRANS_MAXIMUM_TERM}</label></td>
	<td><select id="tldMaximumCycleID" name="tldMaximumCycleID"> {html_options options=$cycleList selected=$formValues.tldMaximumCycleID} </select> {$invalid.tldMaximumCycleID}</td>
</tr>
<tr {if $invalid.tldRenewType}class="highlight"{/if}>
	<td class="title"><label for="tldRenewType">{$smarty.const.TRANS_LOCAL_RENEW_TYPE}</label></td>
	<td><select id="tldRenewType" name="tldRenewType"> {html_options options=$tldRenewTypes selected=$formValues.tldRenewType} </select> {$invalid.tldRenewType}</td>
</tr>
<tr {if $invalid.tldIDNSupport}class="highlight"{/if}>
	<td class="title"><label for="tldIDNSupport">{$smarty.const.TRANS_IDN_SUPPORT}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldIDNSupport" value="0">
		<input type="checkbox" id="tldIDNSupport" name="tldIDNSupport" value="1" {strip}
			{if $formValues.tldIDNSupport}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldIDNSupport">{$smarty.const.TRANS_YES}</label>
		{$invalid.tldIDNSupport}
	</td>
</tr>
<tr {if $invalid.tldIDNType}class="highlight"{/if}>
	<td class="title"><label for="tldIDNType">{$smarty.const.TRANS_IDN_TYPE}</label></td>
	<td><select id="tldIDNType" name="tldIDNType"> {html_options options=$IDNTypes selected=$formValues.tldIDNType} </select> {$invalid.tldIDNType}</td>
</tr>
<tr {if $invalid.tldRemoteLockEnabled}class="highlight"{/if}>
	<td class="title"><label for="tldRemoteLockEnabled">{$smarty.const.TRANS_REMOTE_LOCK}</label></td>
	<td>
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldRemoteLockEnabled" value="0">
		<input type="checkbox" id="tldRemoteLockEnabled" name="tldRemoteLockEnabled" value="1" {strip}
			{if $formValues.tldRemoteLockEnabled}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldRemoteLockEnabled">{$smarty.const.TRANS_ENABLED}</label>
		{$invalid.tldRemoteLockEnabled}
	</td>
</tr>

<tr class="listButtons">
	<td colspan=2>
	<div>
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_TLD}" onClick="selectAllOptions(document.addTLD.elements['orderForms[]']);selectAllOptions(document.addTLD.elements['cycles[]']);" />
		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" />
	</div>
	</td>
</tr>
</tbody>
</table>

</fieldset>
</form>

{include file="$tplDirectory/footer.tpl"}