{* $Id: ShowProducts.tpl 12403 2007-12-28 17:46:28Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of products.
 *
 * Smarty Variables:
 *	$products (array of products that match criteria)
 *		$productID		    Product ID
 *		$productType		Product Type
 *		$productName		Product Name
 *		$productComments	Product Comments
 *		$productActive		Product Active
 *		$productDisplayOrder	Product Display Order
 *	$productActive			The $_REQUEST value of product Active filter option
 *	$productType			The $_REQUEST value of product Type filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_TYPE" d="Type"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_PRODUCTID" d="Product ID"}
{t c="TRANS_COMMENTS" d="Comments"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_MANAGE_PRODUCTS" d="Manage Products"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_PRODUCTS" d="Show Products"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_UNDEFINED" d="Undefined"}
{t c="TRANS_REGULAR" d="Regular"}
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_CERT" d="Cert"}
{t c="TRANS_VID" d="VID"}
{t c="TRANS_PUSH" d="Push"}

{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}

{t c="TRANS_PLEASE_SELECT_THE_PRODUCT_THIS_CLIENT_HAS" d="Please select the product that the client you are importing has on your server."}

{assign var="filterArgs" value="productType=$productType&productActive=$productActive"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_SHOW_PRODUCTS"
	sideNavMajor="products"
	sideNavMinor="products"}

{if $clientInfo.clientID}
	{include file="$tplDirectory/widgets/context/client.tpl" client=$clientInfo suppressEditLink=1 suppressDeleteLink=1}
{elseif $tunnelVars}
	<table width="100%" class="tabTips">
		<tr>
			<td>{$smarty.const.TRANS_PLEASE_SELECT_THE_PRODUCT_THIS_CLIENT_HAS}</td>
		</tr>
	</table>
{/if}
{if $tunnelVars}
<form name="panelImportForm" action="clients.php">
	<input type="hidden" name="sid" value="{$sid}" />
	<input type="hidden" name="configGroupID" value="{$configGroupID}" />
	<input type="hidden" name="serverGroupID" value="{$serverGroupID}" />
	<input type="hidden" name="action" value="{getActionID action="ImportClientFromPanel"}" />
	{foreach key="kk" item="tv" from=$tunnelVars}
	<input type="hidden" name="tunnelVars[]" value="{$tv}" />
	{/foreach}
	<input type="hidden" name="productID" value="0" />
</form>
{/if}


<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="2" style="text-align:left;">
	 	&nbsp;
	</td>
	<td colspan="{if !$noVendors}4{else}3{/if}" style="text-align:right;color:#666666;">
		{include file="$tplDirectory/widgets/context/sortedBy.tpl"}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerClass="firstTD" headerName="TRANS_PRODUCTID" sortColumn="productID" headerClass="firstTD"}
	{if !$noVendors}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_VID"}
	{/if}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_NAME" sortColumn="productName"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" filterName="TRANS_TYPE" filterColumn="productType"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" filterName="TRANS_STATUS" filterColumn="productActive" filterOptions=$activeInactive}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerClass="lastTD" headerName="TRANS_ACTIONS" headerClass="lastTD"}
</tr>
</thead>


{section name=i loop="$products"}
{assign var="productID" value=$products[i].productID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td class="listRowFirstTD">
	 	<strong>
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="products.php"
				actionName="ShowProductDetails"
				args="productID=$productID"
				productID=$productID
				linkText=$productID
			}
		</strong>
	</td>
	{if !$noVendors}
	<td>
		{if $products[i].productVendorRels.0.vendorID}
			{assign var="vid" value=$products[i].productVendorRels.0.vendorID}
			<span title="{$vendors.$vid|escape:html}">{$vid}</span>
		{/if}
	</td>
	{/if}
	<td>
		{$products[i].productName}
		{if $packageCounts.$productID}
			{assign var="packageCount" value=$packageCounts.$productID}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="packages.php"
				actionName="ShowPackages"
				args="productID=$productID"
				linkText="($packageCount)"
			}
		{/if}
		{include
			file="$tplDirectory/widgets/quickEditLink.tpl"
			editID=$productID
			editKey="productID"
			editActionName="EditProductResponse"
			editName="TRANS_NAME"
			editColumn="productName"
			editValue=$products[i].productName}
	</td>
	<td>
		{$products[i].productType|getTypeName:"products"}
	</td>
	<td>
		{$products[i].productActive|getArrayValueByID:$activeInactive}
	</td>
	<td class="nowrap">
		{if $clientInfo.clientID}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="clients.php"
				actionName="ShowClientDetails"
				args="clientID=`$clientInfo.clientID`&mode=$mode&productID=$productID"
				icoImage="arrow_right_blue.gif"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_SELECT"
				titleText=""
				linkText="TRANS_SELECT"
				noSpace="1"
			}
		{elseif $tunnelVars}
			<input type="button" class="button" value="{$smarty.const.TRANS_SELECT}" onclick="document.panelImportForm.productID.value='{$productID}';document.panelImportForm.submit();" />
		{else}
			{strip}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="products.php"
				actionName="ShowProductDetails"
				args="productID=$productID"
				icoImage="view"
				productID=$productID
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_DETAILS"
				titleText=""
				linkText="TRANS_DETAILS"
				noSpace="1"
			}
			{if $packageCounts.$productID<1}
				&nbsp;
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="products.php"
					actionName="RemoveProduct"
					args="productID=$productID"
					icoImage="remove"
					icoWidth=""
					icoHeight=""
					icoStyle=""
					altText="TRANS_REMOVE"
					titleText=""
					linkText="TRANS_REMOVE"
					noSpace="1"
				}
			{/if}
			{if $vendorEnabled}
				&nbsp;
				{include file="$tplDirectory/widgets/actionLink.tpl"
					page="vendors.php"
					actionName="PushProduct"
					args="productID=$productID"
					icoImage="push.gif"
					icoWidth=""
					icoHeight=""
					icoStyle=""
					altText="TRANS_PUSH"
					titleText=""
					linkText="TRANS_PUSH"
					noSpace="1"
				}
			{/if}
			{/strip}
		{/if}
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="5">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>


{include file="$tplDirectory/widgets/paginationLinks.tpl" filterArgs="clientID=`$clientInfo.clientID`&mode=$mode&tunnelVars=$tunnelVars&configGroupID=$configGroupID"}
<br />
{include file="$tplDirectory/footer.tpl"}
