{* $Id: EditTaxZoneGroup.tpl 7627 2006-06-19 21:48:58Z mgarrett $
 * --------------------------------------------------------------
 * This template displays a form to edit a tax zone. Note that for now, one is unable to 
 * change the administrator associated with a tax zone.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *	$countrylist -- List of countries to choose from. 
 *}

{t c="TRANS_MANAGE_TAX_ZONE_GROUPS" d="Manage Tax Zone Groups"}
{t c="TRANS_MANAGE_TAXES" d="Manage Taxes"}
{t c="TRANS_EDIT_TAX_ZONE_GROUP" d="Edit Tax Zone Group"}
{t c="TRANS_TAX_ZONES" d="Tax Zones"}
{t c="TRANS_TAX_ZONE_GROUP_NAME" d="Tax Zone Group Name"}
{t c="TRANS_TAX_ZONE_GROUP_ACTIVE" d="Tax Zone Group Active"}

{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_SYSTEM"
    childName="TRANS_MANAGE_TAXES"
    grandchildName="TRANS_MANAGE_TAX_ZONE_GROUPS"
    sideNavMajor="system"
   	sideNavMinor="taxes"
    parentConfigGroupID=0}

<fieldset>
<legend>{$smarty.const.TRANS_EDIT_TAX_ZONE}</legend>
<form method="post" action="taxes.php" name="EditTaxes">
<input name="taxZoneGroupID" type="hidden" value="{$taxGroup.taxZoneGroupID}" />
<input type="hidden" name="action" value="{getActionID action="EditTaxZoneGroupResponse"}">
<input type="hidden" name="sid" value="{$sid}">


<table border="0" cellpadding="0" cellspacing="0" class="list" width="100%">
    <tr>
        <td class="title">{$smarty.const.TRANS_TAX_ZONE_GROUP_NAME}</td>
        <td><input type="text" name="taxZoneGroupName" value="{$taxGroup.taxZoneGroupName}" /></td>
    </tr>
    <tr>
        <td class="title">{$smarty.const.TRANS_TAX_ZONE_GROUP_ACTIVE}</td>
        <td><select id="taxZoneGroupActive" name="taxZoneGroupActive">
{html_options options=$activeInactive selected=$taxGroup.taxZoneGroupActive}
</select></td>
    </tr>
    <tr>
		<td class="title">{$smarty.const.TRANS_TAX_ZONES}</td>
		<td>
		{include file="$tplDirectory/widgets/comboBox.tpl"
			comboTitleLeft=TRANS_SELECTED
			comboNameLeft="taxZones"
			comboOptionsLeft=$selectedTaxZones

			comboTitleRight=TRANS_SELECTABLE
			comboNameRight="selectableTaxZones"
			comboOptionsRight=$selectableTaxZones
			formName="EditTaxes"
			submitName="suppress"
		}
		</td>
    </tr>

    <tr class="listButtons">
        <td colspan="2"><div><input class="submit" type="submit" value="{$smarty.const.TRANS_SAVE}" onclick="selectAllOptions(document.EditTaxes.elements['taxZones[]']);"></div></td>
    </tr>
</table>


</form>
</fieldset>

{include file="$tplDirectory/footer.tpl"}
