{* $Id: ShowTaxZones.tpl 11070 2007-04-30 20:51:12Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of tax zones. All pieces of data associated with a 
 * tax zone are available in the $taxzones variable, which is an array of tax zones.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *}


{t c="TRANS_STACKABLE" d="Stackable"}
{t c="TRANS_THIS_TAX_IS_TAXABLE" d="This tax is taxable"}

{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_SYSTEM"
    childName="TRANS_MANAGE_TAXES"
    grandchildName="TRANS_MANAGE_TAX_ZONES"
    sideNavMajor="system"
   	sideNavMinor="taxes"
    parentConfigGroupID=0}

<div style="text-align:right;"><div class="rm"><a href="taxes.php?action={getActionID action="AddTaxZone"}&sid={$sid}">{$smarty.const.TRANS_ADD_TAX_ZONE}</a></div></div>
<fieldset>
<legend>{$smarty.const.TRANS_TAX_ZONES}</legend>
    
<table border="0" width="100%" cellpadding="0" cellspacing="0" class="list">

	<tr>
		<td colspan="8" style="cursor: pointer;" onclick="{strip} {section name="i" loop=$taxzones}
			XKtoggle('zonerow{$taxzones[i].taxZoneID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
		</td>
	</tr>


    <tr class="headerRow">
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ID"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_COUNTRY"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_NAME"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_AMOUNT"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_AMOUNT_TYPE"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_DESCRIPTION"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIVE"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
    </tr>

{section name="i" loop=$taxzones}
	<tr class="{cycle values="alt1,alt2"}" style="cursor: pointer;">
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneID}</td>
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].countriesISO2} - {$taxzones[i].countryName}</td>
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneName}</td>
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneAmount}</td>
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{if !$taxzones[i].taxZoneAmountType}{$smarty.const.TRANS_PERCENTAGE}{else}{$smarty.const.TRANS_SET_AMOUNT}{/if}
        	{if $taxzones[i].taxZoneStackable==1} -- {$smarty.const.TRANS_STACKABLE}{/if}
        </td>
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneDescription}</td>
        <td onclick="XKtoggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneActive|getArrayValueByID:$activeInactive}</td>
        <td width="54">
        {strip}
        <a href="taxes.php?action={getActionID action="EditTaxZone"}&taxZoneID={$taxzones[i].taxZoneID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a>
        &nbsp;
        <a href="taxes.php?action={getActionID action="RemoveTaxZone"}&taxZoneID={$taxzones[i].taxZoneID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
        </a>
        {/strip}
        </td>
	</tr>
	<tbody id="zonerow{$taxzones[i].taxZoneID}" class="off">
	<tr>
		<td colspan="8" valign="top" class="comments altinner">
		<table width="100%">
			<tr>
			<td width="50%" valign="top">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
                <tr>
                    <th colspan="2"><strong>{$smarty.const.TRANS_TAX_ZONE_GROUPS}</strong></th>
                </tr>

                {section name="j" loop=$taxzones[i].taxZoneGroups.0.taxZoneGroup}
				<tr class="{if $smarty.section.j.index%2==0}alt1{else}alt2{/if}">
					<td>{$taxzones[i].taxZoneGroups.0.taxZoneGroup[j].taxZoneGroupID}</td>
					<td>{$taxzones[i].taxZoneGroups.0.taxZoneGroup[j].taxZoneGroupName}</td>
				</tr>
                {/section}

            </table>
            </td>
			<td width="50%" valign="top">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
                <tr>
                    <th colspan="2"><strong>{$smarty.const.TRANS_LEDGER_ACCOUNT}</strong></th>
                </tr>
                <tr>
                    <td colspan="2">&nbsp;{$taxzones[i].ledgerAccountNumber} - {assign var="ledgerAccountTransKey" value=$taxzones[i].ledgerAccountTransKey}
    					{$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}</td>
                </tr>

            </table>
            </td>
           </tr>
          </table>
	</tr>
	</tbody>
{sectionelse}
    <tr>
        <td colspan="8" class="alt1">{$smarty.const.TRANS_NO_TAX_ZONES}</td>
    </tr>
{/section}


</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}


{include file="$tplDirectory/footer.tpl"}
