{* $Id: ShowThemes.tpl 12329 2007-12-07 22:11:44Z kbailey $
 * --------------------------------------------------------------
 * This template displays the themes.
 *
 * Smarty Variables:
 *	$themes (array of themes data)
 *		themeID
 *		themeName
 *  	themeDisplayName
 *  	themeActive
 *  $newThemes (array of new directories that could be themes)
 *  $missingThemes (array of missing theme directories that exist in the database)
 *
 *  $actionID			The unique action ID for this page view
 *  $actionName			The action name for this action ID
 *  $imageDirectory		The image directory for this theme
 *  $tplDirectory		The template directory for this theme
 *  $sid				The current sessionID
 *
 * Author: Andy Christ
 *}
{t c="TRANS_THEME_DISPLAY_NAME" d="Display Name"}
{t c="TRANS_NO_THEMES_FOUND" d="No Themes Found"}
{t c="TRANS_ADD_THEME" d="Add Theme"}
{t c="TRANS_REMOVE_THEME" d="Remove Missing Theme"}
{t c="TRANS_THEMES" d="Themes"}

{t c="TRANS_THEME_DISPLAY_NAME" d="Display Name"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName="TRANS_MANAGE_THEMES"
	sideNavMajor="system"
	sideNavMinor="themes"}

	{* left column *}
		<a href="{getHREF page="themes.php" actionName="AddTheme"}"><img src="{$imageDirectory}/ico/note_add.gif" width="16" height="16" alt="" title="" /></a>&nbsp;<a href="{getHREF page="themes.php" actionName="AddTheme"}">{$smarty.const.TRANS_ADD_NEW_THEME}</a>
<br />
		
		<form method="post" action="themes.php">

		{if $newThemes}
			<input type="hidden" name="action" value="{getActionID action="AddThemeResponse"}">
			<input type="hidden" name="redirectURL" value="{$fileName}" />
			<input type="hidden" name="redirectAction" value="{$actionName}" />
			<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
			<input type="hidden" name="sid" value="{$sid}">
			{html_options name=themeName options=$newThemes}
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_THEME}">
		{/if}

		</form>

		<form method="post" action="themes.php">

		{if $missingThemes}
			<input type="hidden" name="action" value="{getActionID action="RemoveThemeResponse"}">
			<input type="hidden" name="redirectURL" value="{$fileName}" />
			<input type="hidden" name="redirectAction" value="{$actionName}" />
			<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
			<input type="hidden" name="sid" value="{$sid}">
			{html_options name=themeID options=$missingThemes}
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_REMOVE_THEME}">
		{/if}

		</form>
<br />
	<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_THEMES" sortColumn="themeDisplayName"}
			{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS" headerAlign="left"}
		</tr>
		{section name=i loop=$themes}
			{assign var="themeID" value=$themes[i].themeID}
			{if $className=="alt1"}
			    {assign var="className" value="alt2"}
			{else}
			    {assign var="className" value="alt1"}
			{/if}
			<tr class="{cycle values="alt1,alt2"}">
				<td class="title">
					{$themes[i].themeDisplayName}
					{include
						file="$tplDirectory/widgets/quickEditLink.tpl"
						editActionName="EditThemeResponse"
						editID=$themeID
						editKey="themeID"
						editName="TRANS_THEME_DISPLAY_NAME"
						editColumn="themeDisplayName"
						editValue=$themes[i].themeDisplayName}
				</td>
				<td>
					{strip}
<!--
					<a href="{getHREF page="themes.php" actionName="ShowThemeDetails" args="themeID=$themeID"}">
						<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
					</a>
-->
					&nbsp;
					<a href="{getHREF page="themes.php" actionName="EditTheme" args="themeID=$themeID"}">
						<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
					</a>
					&nbsp;
					<a href="{getHREF page="themes.php" actionName="RemoveThemeResponse" args="themeID=$themeID"}">
						<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
					</a>
					{/strip}
				</td>
			</tr>
		{sectionelse}
			<tr>
				<td colspan="2">
						{$smarty.const.TRANS_NO_THEMES_FOUND}
				</td>
			</tr>
		{/section}
		<tr>
			<td colspan="2">
				{include file="$tplDirectory/widgets/paginationLinks.tpl"}
			</td>
		</tr>
		</table>


{include file="$tplDirectory/footer.tpl"}