{* $Id: RemoveTodo.tpl 8004 2006-07-10 16:10:11Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to verify the removal of a to-do. This template 
 * is provided an array of information about the to-do about to be removed, and 
 * can display that information to the user. This template should contain a form that 
 * posts the todoID to the RemoveTodoResponse action of todos.php, and also 
 * a cancel option, that returns to the ShowTodos action.
 *
 * Smarty Variables:
 *	$todo  An array of this to-do data. Every element in this array can be considered
 *		   to be one to-do, and as such, every element is an array. Every to-do
 *		   has the following keys:
 *			todoID  -- The ID of the to-do item.
 *			todoTitle  -- The title of the to-do item.
 *			todoDesc -- A short description of the to-do item.
 *			adminID -- The ID of the admin who generated this to-do item.
 *			todoStatusID -- The status of the to-do item.
 *			todoDue -- The date and time that this item should be finished before.
 *}
{t c="TRANS_REMOVE_TODO_MESG" d="Are you sure you want to remove this todo task?"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_TODOS"
	childName="TRANS_TODOS"
	grandchildName="TRANS_REMOVE"
	sideNavMajor="events"
	sideNavMinor="todos"
	}
<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_SUBJECT" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_AUTHOR"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ASSIGNED_ADMINS"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_STATUS"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_DATE_DUE" headerClass="lastTD"}
</tr>
</thead>
<tbody>
	<tr class="{cycle values="alt1,alt2"}">
		<td>{$todo.todoTitle}</td>
		<td>{$todo.admins.0.adminFirstName} {$todo.admins.0.adminLastName} - {$todo.admins.0.adminUsername}</td>
		<td>{$todo.assigned.0.adminFirstName} {$todo.assigned.0.adminLastName} - {$todo.assigned.0.adminUsername}</td>
		<td>{$todo.todoStatusID|getArrayValueByID:$todostatus}</td>
		<td>{$todo.todoDateDue|getDate:medium}</td>
	</tr>
</tbody>
</table>
<br />
	
<fieldset>
<legend>{$smarty.const.TRANS_REMOVE_TODO_MESG}</legend>

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
<tbody>
<tr class="listButtons">
	<td><div>
		<form style="display: inline;" method="post" action="todos.php">
			<input type="hidden" name="action" value="{getActionID action="RemoveTodoResponse"}" />
			<input type="hidden" name="sid" value="{$sid}" />
			<input type="hidden" name="todoID" value="{$todo.todoID}" />
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_YES}" />
		</form>
		<form style="display: inline;" method="get" action="todos.php">
			<input type="hidden" name="action" value="{getActionID action="ShowTodoDetails"}" />
			<input type="hidden" name="sid" value="{$sid}" />
			<input type="hidden" name="todoID" value="{$todo.todoID}" />
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_NO}"><br />
		</form>		
	</div></td>
</tr>
</tbody>
</table>
</fieldset>

{include file="$tplDirectory/footer.tpl"}