{* $Id: formSlider.tpl 5685 2006-03-22 00:48:07Z kbailey $
 * --------------------------------------------------------------
 * This template is a widget that displays the pagination links for a list of results.
 *
 * Smarty Variables:
 *  $formName               The name of the form.
 *  $formFieldName          The name of the form field to output to.
 *  $sliderBoxWidth         The width of the containing slider box.
 *  $sliderBoxHeight        The height of the containing slider box.
 *  $sliderWidth            The width of the slider box.
 *  $sliderHeight           The height of the slider box.
 *  $valueInBox             Put the value inside the slider box?
 *  $orientation            Either vertical or horizontal
 *  $fieldType              The type of form field to use. possible values = "text", "hidden", "div"
 *                          text = text field of size $fieldSize, lets them change it via the text field
 *                          hidden = a hidden field so they have nothing to view
 *                          div = a hidden field with a div tag to view the value but not be able to change it
 *  $fieldSize              The width in pixels of the text box, ie - 25
 *  $sliderMin              The minimum value of the slider
 *  $sliderMax              The max value of the slider
 *  $sliderValue            The value of the slider right now
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/formSlider.tpl"
 *     formName="theform"
 *     formFieldName="slider1"
 *     sliderBoxWidth="122"
 *     sliderBoxHeight="18"
 *     sliderWidth="20"
 *     sliderHeight="16"
 *     orientation="horizontal"
 *     valueInBox="yes"
 *     fieldType="text"
 *     fieldSize=30
 *     sliderMin=0
 *     sliderMax=10
 *     sliderValue=2.5}
 *}


<table border="0" cellpadding="0" cellspacing="0" id="{$formFieldName}tab">
    <tr>
        <td align="center">
<div id="{$formFieldName}sliderparent" class="sliderBox" style="width: {$sliderBoxWidth}px; height: {$sliderBoxHeight}px;">
    <div class="slider" style="{if $sliderFontSize}font-size: {$sliderFontSize};{/if}width: {$sliderWidth}px; height: {$sliderHeight}px;" id="{$formFieldName}sliderobj" onmousedown="XKsliderSetDown(event, this);">{if $valueInBox=="yes"}{$sliderValue}{/if}</div>
</div>
        </td>
        {if $orientation=="vertical"}
        </tr>
        <tr>
        {/if}
        <td align="center">{strip}

        {if $fieldType=="text"}
        <input class="sliderValueTextBox" type="text" style="width: {$fieldSize}px" name="{$formFieldName}" value="{$sliderValue}" onfocus="XKeditingField=this;" onkeyup="XKsliderEditTextField(event, this, '{$formFieldName}sliderobj');" onblur="XKeditingField=false;XKsliderEditTextField(event, this, '{$formFieldName}sliderobj');" />
        {elseif $fieldType=="hidden"}
        <input type="hidden" name="{$formFieldName}" value="{$sliderValue}" />
        {else}
        <input type="hidden" name="{$formFieldName}" value="{$sliderValue}" />
        <div class="sliderValueBox" style="width: {$fieldSize}px; height: {$sliderBoxHeight}px;" id="{$formFieldName}slidervaluebox">{$sliderValue}</div>
        {/if}

        {/strip}</td>
    </tr>
</table>

<script language="javascript" type="text/javascript">
<!--

function {$formFieldName}{literal}XKdoRegisters(){
{/literal}

    {if $fieldType=="div"}XKregisterSliderTarget(document.getElementById('{$formFieldName}sliderobj'), 'div', document.getElementById('{$formFieldName}slidervaluebox'));{/if}

    {if $valueInBox=="yes"}XKregisterSliderTarget(document.getElementById('{$formFieldName}sliderobj'), 'div', document.getElementById('{$formFieldName}sliderobj'));{/if}

    XKregisterSliderTarget(document.getElementById('{$formFieldName}sliderobj'), 'formtext', document.{$formName}.{$formFieldName});
    XKregisterSlider(document.getElementById('{$formFieldName}sliderparent'), document.getElementById('{$formFieldName}sliderobj'), '{$orientation}', {$sliderMin}, {$sliderMax}, {if $sliderValue}{$sliderValue}{else}0{/if});

    //XKeditingField=false;
    //XKsliderEditTextField(event, document.getElementById('{$formFieldName}'), '{$formFieldName}sliderobj');
{literal}
}
{/literal}
setTimeout("{$formFieldName}XKdoRegisters();", 100);


//-->
</script>