{* $Id: autoEditForm.tpl 11232 2007-06-01 14:08:57Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to edit the current admin's profile.
 *
 * Example Usage:
 *
{include
	file="$tplDirectory/widgets/forms/autoEditForm.tpl"
	inTable="yes" | "no" | blank=no
	inForm="yes" | "no" | blank=no
	formName="editForm" | blank
	tableClass="tab01" | whatever | blank=tab01
	formEncType="multipart/form-data" | blank=none
	suppressInputValidation="yes" | "no" | blank=no
	submitLabel="TRANS_SAVE_CHANGES" | blank=nothing
	formAction="packages.php" | blank
	actionName="EditPackageResponse" | blank
	hiddenFields=$hiddenFields | blank
	fields=$fields
	showOnly="yes" | blank}
 *
 * Author: Kris Bailey
 *}

{t c="TRANS_X" d="X"}
{t c="TRANS_OK" d="OK"}
{t c="TRANS_OR_ADD_MANUAL_DOMAIN" d="or add manual domain"}
{t c="TRANS_ASSOCIATED_DOMAIN" d="Associated Domain"}

{if $getDataFrom.fields}
	{assign var="inTable" value=$getDataFrom.inTable}
	{assign var="inForm" value=$getDataFrom.inForm}
	{assign var="formName" value=$getDataFrom.formName}
	{assign var="tableClass" value=$getDataFrom.tableClass}
	{assign var="formEncType" value=$getDataFrom.formEncType}
	{assign var="suppressInputValidation" value=$getDataFrom.suppressInputValidation}
	{assign var="submitLabel" value=$getDataFrom.submitLabel}
	{assign var="formAction" value=$getDataFrom.formAction}
	{assign var="actionName" value=$getDataFrom.actionName}
	{assign var="hiddenFields" value=$getDataFrom.hiddenFields}
	{assign var="fields" value=$getDataFrom.fields}
	{assign var="showOnly" value=$getDataFrom.showOnly}

{/if}

{if $inForm!="yes"}
	<form method="post" action="{$formAction}" {if $formName!=""}name="{$formName}"{/if} {if $formEncType!=""}enctype="{$formEncType}"{/if} onsubmit="XKselectAllOptionsInMultiSelects(this);">
	<input type="hidden" name="action" value="{getActionID action=$actionName}">
	<input type="hidden" name="sid" value="{$sid}">
{/if}

{foreach key="fieldName" item="fieldValue" from=$hiddenFields}
	<input type="hidden" name="{$fieldName}" value="{$fieldValue|escape:html}" />
{/foreach}

{if $autoEditTitle}
<fieldset>
	<legend>{$smarty.const.$autoEditTitle|default:$autoEditTitle}</legend>
{/if}

{if $inTable!="yes"}
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
{/if}

{assign var="reset" value=1}

{foreach key="fieldName" item="data" from=$fields}
	{assign var="reset" value=0}
	{if $nextLoopReset==1}
		{assign var="reset" value=1}
		{assign var="nextLoopReset" value=0}
	{/if}

	{* // Separator // *}
	{if $data.fieldType=="titleRow"}
		{assign var="nextLoopReset" value=1}
		{assign var="title" value=$data.fieldTitle}
		<tr>
			<td colspan="2"><fieldset><legend>{$smarty.const.$title|default:$title}</legend></fieldset></td>
		</tr>
	{* // Text field input // *}
	{elseif $data.fieldType=="" || $data.fieldType=="text"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}{if $data.currencyID}{$data.fieldValue|getAmount:$data.currencyID}{else}{$data.fieldValue}{/if}{else}<input type="text" style="width:200px;" name="{$fieldName}" id="{$fieldName}" value="{if $data.currencyID!=""}{$data.fieldValue|getAmount:$data.currencyID}{else}{$data.fieldValue|escape:html}{/if}" {if $data.currencyID!=""}onchange="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true};{1000|getAmount:$currencyID:true:true}', this.value, '{$localeData.locale_separator_decimal}', '{$localeData.locale_separator_grouping}');" {/if} /> {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Password field input // *}
	{elseif $data.fieldType=="password"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}********{else}<input type="password" style="width:200px;" name="{$fieldName}" onkeyup="if (this.value!=document.getElementById('{$fieldName}Confirm').value){literal}{{/literal}document.getElementById('{$fieldName}ConfirmStatus').innerHTML='{$smarty.const.TRANS_X}';{literal}}{/literal}else{literal}{{/literal}document.getElementById('{$fieldName}ConfirmStatus').innerHTML='{$smarty.const.TRANS_OK}';{literal}}{/literal}" id="{$fieldName}" value="" /> {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
		{if $showOnly=="yes" || $data.showOnly==1}{else}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title">{$smarty.const.TRANS_CONFIRM}</th>
			<td><input type="password" style="width:200px;" onkeyup="if (this.value!=document.getElementById('{$fieldName}').value){literal}{{/literal}document.getElementById('{$fieldName}ConfirmStatus').innerHTML='{$smarty.const.TRANS_X}';{literal}}{/literal}else{literal}{{/literal}document.getElementById('{$fieldName}ConfirmStatus').innerHTML='{$smarty.const.TRANS_OK}';{literal}}{/literal}" name="{$fieldName}Confirm" id="{$fieldName}Confirm" value="" /> <div id="{$fieldName}ConfirmStatus"></div></td>
		</tr>
		{/if}
	{* // Textarea field input // *}
	{elseif $data.fieldType=="textarea"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}{$data.fieldValue}{else}<textarea style="width: 97%;" rows="4" cols="35" name="{$fieldName}" id="{$fieldName}">{$data.fieldValue|escape:html}</textarea> {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Textarea field input with base64 stuff // *}
	{elseif $data.fieldType=="base64SerializedData"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}{$data.fieldValue|decodeSerialized}{else}<textarea rows="4" cols="35" name="{$fieldName}" id="{$fieldName}">{$data.fieldValue|decodeSerialized:1|escape:html}</textarea> {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Select menu field input // *}
	{elseif $data.fieldType=="select"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}
				{assign var="selected" value=$data.fieldValue.selected}
				{$data.fieldValue.selectable.$selected}{else}<select style="width:200px;" name="{$fieldName}" id="{$fieldName}">
				{if $data.allowBlankChoice==1}
					<option value=""> </option>
				{/if}
				{html_options options=$data.fieldValue.selectable selected=$data.fieldValue.selected}
			    </select> 
				{if $data.addDomainField}
					{$smarty.const.TRANS_OR_ADD_MANUAL_DOMAIN}: 
					<input type="text" style="width:100px;" size="15" name="newDomainSLD" value="" />.
					<input type="text" style="width:30px;" size="5" name="newDomainTLD" value="" />
				{/if}
				{$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Radio button field input // *}
	{elseif $data.fieldType=="radio"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}
				{assign var="selected" value=$data.fieldValue.selected}
				{$data.fieldValue.selectable.$selected}{else}{html_radios separator=$data.fieldSeparator options=$data.fieldValue.selectable selected=$data.fieldValue.selected}
			    {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Checkbox button field input // *}
	{elseif $data.fieldType=="checkbox"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}{else}<input type="hidden" name="{$fieldName}" value="0" />{/if}
			<input type="checkbox" name="{$fieldName}" value="1"{if $showOnly=="yes" || $data.showOnly==1}disabled="disabled"{/if} {if $data.fieldValue>0}checked="checked"{/if} />
			    {$invalid.$fieldName}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Multi-select field input // *}
	{elseif $data.fieldType=="multiselect"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}
				{section name="xi" loop=$data.fieldValue.selected}
					{assign var="selected" value=$data.fieldValue.selected[xi]}
					{if $smarty.section.i.index>0}<br />{/if}
					{$data.fieldValue.selectable.$selected}
				{/section}
				{else}{include file="$tplDirectory/widgets/comboBox.tpl"
				comboTitleLeft=TRANS_SELECTED
				comboNameLeft=$fieldName
				comboOptionsLeft=$data.selected

				comboTitleRight=TRANS_SELECTABLE
				comboNameRight="selectable`$fieldName`"
				comboOptionsRight=$data.selectable
				formName=$formName
				submitName="suppress"
				}
			    {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{* // Date selector field input // *}
	{elseif $data.fieldType=="dateselect"}
		{assign var="title" value=$data.fieldTitle}
		<tr {if $invalid.$fieldName}class="highlight"{else}reset=$reset{/if}>
			<td width="25%" class="title"><label name="{$fieldName}">{$smarty.const.$title|default:$title}</label>:</td>
			<td>{if $showOnly=="yes" || $data.showOnly==1}{$data.fieldValue.$fieldName|getDate:long}{else}{include file="$tplDirectory/widgets/dateSelector.tpl" optional=$data.dateOptional formValues=$data.fieldValue param=$fieldName default=$fieldName real=$fieldName}
			    {$invalid.$fieldName}{/if}
			{if $data.helpTitle && $data.helpText}
				{include file="$tplDirectory/widgets/smallTip.tpl" title=$data.helpTitle|stripslashes|escape:html text=$data.helpText|stripslashes|escape:html}
			{/if}
			</td>
		</tr>
	{/if}

{/foreach}

{if $submitLabel!=""}
	<tr class="listButtons">
		<td colspan="2">
		<div>
			<input class="submit" type="submit" value="{$smarty.const.$submitLabel|default:$submitLabel}" />
			&nbsp;
			{if $backLabel!=""}
				<input class="button" type="button" value="{$smarty.const.$backLabel|default:$backLabel}" onclick="history.go(-1);" />
			{/if}
		</div>
		</td>
	</tr>
{/if}

{if $inTable!="yes"}
	</table>
{/if}

{if $autoEditTitle}
</fieldset>
{/if}

{if $inForm!="yes"}
	</form>
{/if}

