{* $Id: ledgerForm.tpl 11742 2007-08-06 17:13:15Z kbailey $
 * --------------------------------------------------------------
 * This template is a widget that displays the pagination links for a list of results.
 *
 * Smarty Variables:
 *  $containerWidth         The width of the container
 *  $containerColor         The background color of the containing div (nothing if not set)
 *  $barWidth               The pixel width of the bar NOT INCLUDING THE 10px FOR THE SIDES
 *  $tdid                   The html id to use for the td in the middle
 *
 * Example Usage:
 *  {include file="$tplDirectory/widgets/ledgerForm.tpl"
 *      containerClass="box01"
 *      containerName="leDiv"
 *      fieldPrefix=""
 *      existingEntries=$existingEntries
 *      printScript=1
 *      currency="USD"
 *      formname="form"
 *      ledgerAccounts=$ledgerAccounts
 *      accountTypes=$accountTypes}
 *}

{t c="TRANS_ADD_LEDGER_ENTRY" d="+ Add Ledger Entry"}
{t c="TRANS_REMOVE_LEDGER_ENTRY_ARE_YOU_SURE" d="Are you sure you wish to remove this ledger entry from this Transaction?"}
{t c="TRANS_DEBITS" d="Debits"}
{t c="TRANS_CREDITS" d="Credits"}
{t c="TRANS_RECALCULATE" d="Recalculate"}
{t c="TRANS_INV_ID" d="Inv. ID"}

{assign var="prefix" value=$fieldPrefix}

{if $printScript}
{literal}
<script language=javascript>
<!--

    var XKLEtabletop = "<table border='0' cellpadding='0' cellspacing='0'><tr><td>";
    var XKLEtablebottom = "</td></tr></table>";

    function killRow(rid, form, prefix, containername){
        if (confirm("{/literal}{$smarty.const.TRANS_REMOVE_LEDGER_ENTRY_ARE_YOU_SURE}{literal}")){
            document.getElementById(rid).style.display = 'none';
            document.getElementById(rid).style.visibility = 'hidden';
            document.getElementById(rid).innerHTML = '';
            XKmakeTotals(form, prefix, containername);
        }
    }

    var XKLEUID = 1000;

    function buildLedgerRow(prefix, formname, containerName){
        XKLEUID++;
        var leHTML = "<div id='ledgerRow"+XKLEUID+"'>"+XKLEtabletop;
        leHTML += ""; //"<tr>";
        leHTML += "<div class='ledgerEntryBox' style='width: 33px;'><table border='0'><tr><td><div class=\"rm07\"><a class=\"st01\" href=\"javascript:killRow('ledgerRow"+XKLEUID+"', document."+formname+", '"+prefix+"', '"+containerName+"');\">X</a></div></td></tr></table> </div>";
        leHTML += "<div class='ledgerEntryBox' style='width: 197px;'><select style='width: 190px;' name='"+prefix+"ledgerEntries["+XKLEUID+"][ledgerAccountID]'><option value='0'>{/literal}{$smarty.const.TRANS_SELECT_A_LEDGER_ACCOUNT}{literal}</option>";
{/literal}
        {section name=i loop=$ledgerAccounts}
            {assign var="ledgerAccountID" value=$ledgerAccounts[i].ledgerAccountID}

                {if $ledgerAccounts[i].ledgerAccountType != $ledgerAccountType}
{if $notFirstTime}
        leHTML += "</optgroup>";
{/if}
                        {assign var="ledgerAccountType" value=$ledgerAccounts[i].ledgerAccountType}
                        {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
        leHTML += "<optgroup label=\"{$smarty.const.$transkey|default:$transkey}\">";
                        {assign var="notFirstTime" value="1"}
                {/if}
{assign var="ledgerAccountTransKey" value=$ledgerAccounts[i].ledgerAccountTransKey}
        leHTML += "<option value=\"{$ledgerAccounts[i].ledgerAccountID}\"{if $selectedLedgerID == $ledgerAccounts[i].ledgerAccountID} selected=\"selected\"{/if}>";
        leHTML += "    {$ledgerAccounts[i].ledgerAccountNumber} - {$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}";
        leHTML += "</option>";

        {sectionelse}

        {/section}
        leHTML += "</optgroup>";
{literal}
        leHTML += "</select></div>";
        leHTML += "<div class='ledgerEntryBox' style='width: 55px;'><input size='4' type=text name='"+prefix+"ledgerEntries["+XKLEUID+"][clientID]' value='0'></div>";
        leHTML += "<div class='ledgerEntryBox' style='width: 50px;'><input size='4' type=text name='"+prefix+"ledgerEntries["+XKLEUID+"][invoiceID]' value='0'></div>";
        leHTML += "<div class='ledgerEntryBox' style='width: 130px;'><input type=text name='"+prefix+"ledgerEntries["+XKLEUID+"][generalLedgerDescription]' value=''></div>";
        leHTML += "<div class='ledgerEntryBox' style='width: 125px; text-align: right;'>{/literal}{$currency}{literal} <input type='text' style='text-align: right;' name='"+prefix+"ledgerEntryDebits["+XKLEUID+"][generalLedgerDebitAmount]' onchange=\"XKmakeTotals(document."+formname+", '"+prefix+"', '"+containerName+"');this.value=XKformatNumber(' ###.##; ###.##', XKround(this.value,2).toString(), '.', ',');\" size=10 value='0.00'></div>";
        leHTML += "<div class='ledgerEntryBox' style='border-right: 1px solid gray; width: 125px; text-align: right;'>{/literal}{$currency}{literal} <input type='text' style='text-align: right;' name='"+prefix+"ledgerEntryCredits["+XKLEUID+"][generalLedgerCreditAmount]' onchange=\"XKmakeTotals(document."+formname+", '"+prefix+"', '"+containerName+"');this.value=XKformatNumber(' ###.##; ###.##', XKround(this.value,2).toString(), '.', ',');\" size=10 value='0.00'></div>";
        leHTML += XKLEtablebottom;
        leHTML += "</div>";
        leHTML += "<div id='{/literal}{$containerName}"+(XKLEUID+1)+"{literal}' style=''>";
        leHTML += "</div>";

        return leHTML;
    }

    function addLedgerEntry(prefix, formname, containerName){

        var leHTML = buildLedgerRow(prefix, formname, containerName);
        target = document.getElementById(containerName+XKLEUID);
        target.innerHTML += leHTML;

    }

    function XKmakeTotals(form, prefix, containerName){
        //ledgerEntrieCredits
        var debits = XKgetFormFieldTotals(form, prefix+"ledgerEntryDebits");
        var credits = XKgetFormFieldTotals(form, prefix+"ledgerEntryCredits");
        var cango = XKcheckDebitCredit(form, prefix+"ledgerEntryDebits");
        document.getElementById(containerName+'dtotal').innerHTML = XKformatNumber("{/literal}{$currency}{literal} ###.##;{/literal}{$currency}{literal} ###.##", debits, '.', ',');
        document.getElementById(containerName+'ctotal').innerHTML = XKformatNumber("{/literal}{$currency}{literal} ###.##;{/literal}{$currency}{literal} ###.##", credits, '.', ',');
        if (debits==credits && cango==true){
            form.save.disabled = false;
            document.getElementById(containerName+'dtotal').style.color = '';
            document.getElementById(containerName+'ctotal').style.color = '';
        } else {
            form.save.disabled = true;
            document.getElementById(containerName+'dtotal').style.color = 'red';
            document.getElementById(containerName+'ctotal').style.color = 'red';
        }
    }



//-->
</script>
{/literal}
{/if}

{if $containerClass==''}
    {assign var="class" value="box01"}
{/if}

{if $containerName==''}
    {assign var="containerName" value="leDiv"}
{/if}

<table border='0' cellpadding='0' cellspacing='0'>
    <tr>
        <td>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 33px;'>&nbsp;</div>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 197px;'>{$smarty.const.TRANS_GL_ACCOUNT}</div>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 55px;'>{$smarty.const.TRANS_CLIENT_ID}</div>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 50px;'>{$smarty.const.TRANS_INV_ID}</div>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 130px;'>{$smarty.const.TRANS_DESCRIPTION}</div>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 125px; text-align: right;'>{$smarty.const.TRANS_DEBITS}</div>
            <div class='ledgerHeaderBox' style='float: left; padding: 2px; width: 125px; text-align: right; border-right: 1px solid gray;'>{$smarty.const.TRANS_CREDITS}</div>
        </td>
    </tr>
</table>

{section name=i loop=$existingEntries}

<div id='ledgerRow{$smarty.section.i.index}'>
    <table border='0' cellpadding='0' cellspacing='0'>
        <tr>
            <td>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 33px;'><table border='0'><tr><td><div class="rm07"><a class="st01" href="javascript:killRow('ledgerRow{$smarty.section.i.index}');">X</a></div></td></tr></table></div>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 197px;'><select style='width: 190px;' name='{$fieldPrefix}ledgerEntries[{$smarty.section.i.index}][ledgerAccountID]'><option value='0'>{$smarty.const.TRANS_SELECT_A_LEDGER_ACCOUNT}</option>
        {section name=j loop=$ledgerAccounts}
            {assign var="ledgerAccountID" value=$ledgerAccounts[j].ledgerAccountID}
                {if $ledgerAccounts[j].ledgerAccountType != $ledgerAccountType}
{if $notFirstTime}
</optgroup>
{/if}
                        {assign var="ledgerAccountType" value=$ledgerAccounts[j].ledgerAccountType}
                        {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
<optgroup label="{$smarty.const.$transkey|default:$transkey}">
                        {assign var="notFirstTime" value="1"}
                {/if}
{assign var="ledgerAccountTransKey" value=$ledgerAccounts[j].ledgerAccountTransKey}
<option value="{$ledgerAccounts[j].ledgerAccountID}"{if $existingEntries[i].ledgerAccountID == $ledgerAccounts[j].ledgerAccountID} selected="selected"{/if}>
{$ledgerAccounts[j].ledgerAccountNumber} - {$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}
</option>
        {sectionelse}
        {/section}
</optgroup>
            </select></div>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 55px;'><input type="text" size="4" name='{$prefix}ledgerEntries[{$smarty.section.i.index}][clientID]' value='{$existingEntries[i].clientID}'></div>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 50px;'><input type="text" size="4" name='{$prefix}ledgerEntries[{$smarty.section.i.index}][invoiceID]' value='{$existingEntries[i].invoiceID}'></div>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 130px;'><input type="text" name='{$prefix}ledgerEntries[{$smarty.section.i.index}][generalLedgerDescription]' value='{$existingEntries[i].generalLedgerDescription}'></div>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 125px; text-align: right;'>{$currency} <input type='text' style='text-align: right;' name='{$prefix}ledgerEntryDebits[{$smarty.section.i.index}][generalLedgerDebitAmount]' onchange="XKmakeTotals(document.{$formname}, '{$prefix}', '{$containerName}');this.value=XKformatNumber(' ###.##; ###.##', XKround(this.value,2).toString(), '.', ',');" size="10" value='{$existingEntries[i].generalLedgerDebitAmount}'></div>
            <div class='ledgerEntryBox' style='float: left; padding: 2px; width: 125px; text-align: right; border-right: 1px solid gray;'>{$currency} <input type='text' style='text-align: right;' name='{$prefix}ledgerEntryCredits[{$smarty.section.i.index}][generalLedgerCreditAmount]' onchange="XKmakeTotals(document.{$formname}, '{$prefix}', '{$containerName}');this.value=XKformatNumber(' ###.##; ###.##', XKround(this.value,2).toString(), '.', ',');" size="10" value='{$existingEntries[i].generalLedgerCreditAmount}'></div>
            </td>
        </tr>
    </table>
</div>



{/section}

<div id="{$containerName}1001" style="{$containerClass}">
</div>

<table border='0' cellpadding='0' cellspacing='0'>
    <tr>
        <td>
            <div class='ledgerHeaderFirstBox' style='height: 25px; float: left; padding: 2px; width: 34px;'>&nbsp;</div>
            <div class='ledgerHeaderFirstBox' style='height: 25px; float: left; padding: 2px; width: 198px;'><table border="0">
    <tr>
        <td><div class="rm"><a class="st01" href="javascript:addLedgerEntry('{$fieldPrefix}', '{$formname}', '{$containerName}');">{$smarty.const.TRANS_ADD_LEDGER_ENTRY}</a></div></td>
    </tr>
</table></div>
            <div class='ledgerHeaderFirstBox' style='height: 25px; float: left; padding: 2px; width: 56px;'>&nbsp;</div>
            <div class='ledgerHeaderFirstBox' style='height: 25px; float: left; padding: 2px; width: 51px;'>&nbsp;</div>
            <div class='ledgerHeaderFirstBox' style='height: 25px; float: left; padding: 2px; width: 131px;'><table border="0">
    <tr>
        <td><div class="rm"><a class="st01" href="javascript:XKmakeTotals(document.{$formname}, '{$prefix}', '{$containerName}');">{$smarty.const.TRANS_RECALCULATE}</a></div></td>
    </tr>
</table></div>
            <div class='ledgerHeaderBox' style='height: 25px; float: left; padding: 2px; width: 125px; text-align: right; border-top: 0px;'><div id="{$containerName}dtotal" style="text-align: right;">-</div></div>
            <div class='ledgerHeaderBox' style='height: 25px; float: left; padding: 2px; width: 125px; text-align: right; border-top: 0px; border-right: 1px solid gray;'><div id="{$containerName}ctotal" style="text-align: right;">-</div></div>
        </td>
    </tr>
</table>
<script language="javascript" type="text/javascript">
<!--
XKmakeTotals(document.{$formname}, '{$prefix}', '{$containerName}');
//-->
</script>