{* $Id: progressBar.tpl 7608 2006-06-19 18:41:15Z kbailey $
 * --------------------------------------------------------------
 * This template is a widget that displays the pagination links for a list of results.
 *
 * Smarty Variables:
 *	$fileName 				The name of the file to link to in the URL
 *	$queryArgs 				All urldecoded query args to append to the URL
 *	$filterArgs 			All urldecoded filter args to append to the URL
 *	$sortArgs 				All urldecoded sort args to append to the URL
 *  $leftPercentage         The left percentage to show
 *  $rightPercentage        The right percentage to show
 *  $rightPercentageColor   The color of the text right percentage
 *  $containerWidth         The width of the container
 *  $containerColor         The background color of the containing div (nothing if not set)
 *  $barWidth               The pixel width of the bar NOT INCLUDING THE 10px FOR THE SIDES
 *  $tdid                   The html id to use for the td in the middle
 *
 * Example Usage:
 *  {include file="$tplDirectory/widgets/progressBar.tpl" tdid=""
 *      containerWidth="400"
 *      containerColor="#FF0000"
 *      barWidth="300"
 *      leftPercentage="Limit: 300"
 *      rightPercentage="Used: 400"
 *      rightPercentageColor="#000000"}
 *}
<table width="{$containerWidth}" cellpadding=0 cellspacing=0>
    <tr>
        <td style="width: {$barWidth+10}px;" id="{$tdid}Parent" {if $containerColor!=''}bgcolor="{$containerColor}"{/if}>
{if $barWidth>0}
    <table border=0 cellpadding=0 cellspacing=0>
        <tr>
            <td style="width: 5; align: left;"><img src="{$imageDirectory}/progressl.png" width="5" height="20"></td>
            <td {if $tdid!=""}id="{$tdid}"{/if} style="width: {$barWidth}px; background: url('{$imageDirectory}/progressm.png') repeat-x center; text-align: center; color: #FFFFFF; font-weight: bold; font-size: 11px;"><span id="{$tdid}LeftPercentage">{$leftPercentage}</span></td>
            <td style="width: 5; align: right;"><img src="{$imageDirectory}/progressr.png" width="5" height="20"></td>
        </tr>
    </table>
{else}
&nbsp;
{/if}
        </td>
        <td {if $containerColor!=''}bgcolor="{$containerColor}"{/if} style="text-align: center; color: {$rightPercentageColor}; font-weight: bold; font-size: 11px;"><span id="{$tdid}RightPercentage">{$rightPercentage}</span></td>
    </tr>
</table>
