{* $Id: autoShowTable.tpl 12281 2007-11-27 15:40:21Z bwoolley $
 * --------------------------------------------------------------
 * This widget will generate a show table automatically based on smarty variables
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/autoShowTable.tpl"
 *	         tableClass="tab01"
 *		 searchActionName="ShowPackageAddons"
 *		 tableFields=$fieldsArray
 *		 tableData=$tableData
 *		 }
 *}


<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
	<thead>
		<tr class="headerRow">
			{assign var="headerClass" value="firstTD"}
			{foreach key="fieldName" item="data" from=$tableFields}

				{if $data.fieldType=="" || $data.fieldType=="search"}
					{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerClass=$headerClass headerName=$data.fieldTitle sortColumn=$fieldName}
				{elseif $data.fieldType=="bool"}
					{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerClass=$headerClass headerName=$data.fieldTitle sortColumn=$fieldName}
				{elseif $data.fieldType=="date"}
					{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerClass=$headerClass headerName=$data.fieldTitle sortColumn=$fieldName}
				{elseif $data.fieldType=="filter"}
					{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" headerClass=$headerClass filterName=$data.fieldTitle filterColumn=$fieldName filterOptions=$data.filterOptions}
				{else}
					{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerClass=$headerClass headerName=$data.fieldTitle sortColumn=$fieldName}
				{/if}

				{assign var="headerClass" value=""}

			{foreachelse}
				Invalid parameters passed to template.
			{/foreach}

			{if $rowActions}
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS"}
			{/if}

		</tr>
	</thead>
{section name=i loop=$tableData}
	<tbody>
	<tr class="{if $smarty.section.i.index%2==0}alt1{else}alt2{/if}">

			{foreach key="fieldName" item="data" from=$tableFields}

				{if $data.fieldType=="" || $data.fieldType=="search"}
					<td>{$tableData[i].$fieldName}
						{if $data.enableQuickEdit}
							{include
								file="$tplDirectory/widgets/quickEditLink.tpl"
								editID=$tableData[i].$keyCol
								editKey=$keyCol
								useEditIcon=1
								editActionName=$editResponseAction
								editName=$data.fieldTitle
								editColumn=$fieldName
								editValue=$tableData[i].$fieldName}
						{/if}
					</td>
				{elseif $data.fieldType=="bool"}
					{assign var="boolValue" value=$tableData[i].$fieldName*1}
					<td>{$yesNo.$boolValue}
						{if $data.enableQuickEdit}
							{include
								file="$tplDirectory/widgets/quickEditSelectLink.tpl"
								editID=$tableData[i].$keyCol
								editKey=$keyCol
								useEditIcon=1
								editActionName=$editResponseAction
								editName=$data.fieldTitle
								editColumn=$fieldName
								editSelected=$tableData[i].$fieldName
								editOptions=$yesNo}
						{/if}
					</td>
				{elseif $data.fieldType=="date"}
					<td>{$tableData[i].$fieldName|getDate:short} 
						{if $data.enableQuickEdit}
							{include
								file="$tplDirectory/widgets/quickEditDateLink.tpl"
								editID=$tableData[i].$keyCol
								useEditIcon=1
								editKey=$keyCol
								editActionName=$editResponseAction
								editName=$data.fieldTitle
								editColumn=$fieldName
								editValue=$tableData[i].$fieldName
								showHourMin=1}
						{/if}
					</td>
				{elseif $data.fieldType=="filter"}
					{assign var="rowFilterID" value=$tableData[i].$fieldName}
					<td>{$data.filterOptions.$rowFilterID}
						{if $data.enableQuickEdit}
							{include
								file="$tplDirectory/widgets/quickEditSelectLink.tpl"
								editID=$tableData[i].$keyCol
								editKey=$keyCol
								useEditIcon=1
								editActionName=$editResponseAction
								editName=$data.fieldTitle
								editColumn=$fieldName
								editSelected=$tableData[i].$fieldName
								editOptions=$data.filterOptions}
						{/if}
					</td>
				{else}
					<td>{$tableData[i].$fieldName}
						{if $data.enableQuickEdit}
							{include
								file="$tplDirectory/widgets/quickEditLink.tpl"
								editID=$tableData[i].$keyCol
								editKey=$keyCol
								useEditIcon=1
								editActionName=$editResponseAction
								editName=$data.fieldTitle
								editColumn=$fieldName
								editValue=$tableData[i].$fieldName}
						{/if}
					</td>
				{/if}

			{foreachelse}
				Invalid parameters passed to template.
			{/foreach}

			{if $rowActions || $manualRowActions}
				<td>
				{section name=j loop=$rowActions}

					<a href="{getHREF page=$SCRIPT_NAME actionName=$rowActions[j].action args=""}{section name=x loop=$rowActions[j].args}{assign var="argName" value=$rowActions[j].args[x]}&{$argName}={$tableData[i].$argName}{/section}{if $actionsAppend}{$actionsAppend}{/if}">
						<img src="{$imageDirectory}{$rowActions[j].icon}" border="0" />
					</a>
					&nbsp;

				{/section}				
				{section name=j loop=$manualRowActions}

					<a href="{getHREF page=$SCRIPT_NAME actionName=$manualRowActions[j].action args=""}{section name=x loop=$manualRowActions[j].args}{assign var="argName" value=$manualRowActions[j].args[x]}&{$argName}={$tableData[i].$argName}{/section}{if $actionsAppend}{$actionsAppend}{/if}">
						<img src="{$imageDirectory}{$manualRowActions[j].icon}" border="0" />
					</a>
					&nbsp;

				{/section}				
				</td>
			{/if}


	</tr>
	</tbody>
{sectionelse}
	{assign var="noResults" value="1"}	
{/section}
</table>
{if $noResults==1}
<br />
{$smarty.const.TRANS_NORESULTS}
{/if}

{include file="$tplDirectory/widgets/paginationLinks.tpl"}




