{* $Id: wizardQuestionInputSelect.tpl 12708 2008-02-28 17:01:59Z kbailey $
 * --------------------------------------------------------------
 * This widget template displays a question input select menu.
 *
 * Smarty Variables:
 *	$question		The question.
 *  $inputName		The name of the select menu.
 *  $selectOptions	An array of the select options.
 *  $selected		The selected options value.
 *  $appendText		The appended text messege.
 *
 * Example Usage:
 *  {include file="$tplDirectory/admin/widgets/wizard/questionInputSelect.tpl" question="Some Question" inputName="" selectOptions="" selected="" appendText=""}
 *}
 
{if $smarty.const.WIZARD_CART_DISPLAY==1}

	<tr {if $questionErrorMesgs}class="highlight"{/if}>
		<td class="title" valign="top"><label for="{$questionID}">{$question}</label></td>
		<td>
			<select name="{$questionID}" {if ($questionSize)}size="{$questionAnswers[i].size}"{else}size="1"{/if}>
				{section name="i" loop=$questionAnswers}
					<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}
					{if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer}</option>
				{/section}
			</select>
			{if $questionDescription}<br />{$questionDescription}{/if} {if $questionErrorMesgs}<br />{$questionErrorMesgs}{/if}
		</td>
	</tr>

{elseif $smarty.const.WIZARD_ADMIN_ADDON_DISPLAY==1}

	<select name="addonValues[{literal}{ID}{/literal}][{$questionID}]" {if ($questionSize)}size="{$questionAnswers[i].size}"{else}size="1"{/if}>
		{section name="i" loop=$questionAnswers}
			<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}
			{if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer}</option>
		{/section}
	</select>
	{if $questionDescription}<br />{$questionDescription}{/if} {if $questionErrorMesgs}<br />{$questionErrorMesgs}{/if}

{else}

	<tr {if $questionErrorMesgs}class="highlight"{/if}>
		<td class="title" valign="top"><label for="{$questionID}">{$question}</label></td>
		<td>
			<input type="hidden" name="{$questionID}" value="" />
			<select name="{$questionID}" {if ($questionSize)}size="{$questionAnswers[i].size}"{else}size="1"{/if}>
				{section name="i" loop=$questionAnswers}
					<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}
					{if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer}</option>
				{/section}
			</select>
			{if $questionDescription}<br />{$questionDescription}{/if} {if $questionErrorMesgs}<br />{$questionErrorMesgs}{/if}
		</td>
	</tr>

{/if}
