{* $Id: ShowDashboard.tpl 12386 2007-12-21 23:43:39Z kbailey $
 * --------------------------------------------------------------
 * This template displays the client dashboard.
 *
 * Smarty Variables:
 *  $invoices (array of invoice data)
 *  $packages (array of package data)
 *  $helpdeskTicketsOpen (array of open tickets)
 *  $helpdeskTicketsOpenSubject (array of open ticket's subjects)
 *  $helpdeskEnabled (1 or 0 to show the helpdesk section)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Michael Fountain
 *}
{strip}
{t c="TRANS_ACCOUNT_SUMMARY" d="Account Summary"}
{t c="TRANS_PACKAGE_SUMMARY" d="Package Summary"}
{t c="TRANS_DOMAIN_SUMMARY" d="Domain Summary"}
{t c="TRANS_SSLCERT_SUMMARY" d="SSL Certificate Summary"}
{t c="TRANS_NONE" d="None"}
{t c="TRANS_ACCOUNTING_ACCOUNTS_LABEL" d="Account"}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_AVAILABLE_CREDIT" d="Available Credits"}
{t c="TRANS_BALANCE" d="Balance"}
{t c="TRANS_OPEN_TICKETS" d="Open Tickets"}
{t c="TRANS_INVOICES_DUE" d="Invoices Due"}
{t c="TRANS_ACTIVE_BILLABLE_PACKAGES" d="Active & Billable Packages"}
{t c="TRANS_NEWS_AND_ANNOUNCMENTS" d="News & Announcements"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_PRODUCT" d="Product"}
{t c="TRANS_PRICE" d="Price"}
{t c="TRANS_BILLING_CYCLE" d="Billing Cycle"}
{t c="TRANS_NEXT_RENEWAL" d="Next Renewal"}
{t c="TRANS_MANAGE" d="Manage"}
{t c="TRANS_ACTION" d="Action"}
{t c="TRANS_INVOICE_NUMBER" d="Invoice Number"}
{t c="TRANS_AMOUNT" d="Amount"}
{t c="TRANS_AMOUNT_PAID" d="Amount Paid"}
{t c="TRANS_DATE_GENERATED" d="Date Generated"}
{t c="TRANS_DATE_DUE" d="Date Due"}
{t c="TRANS_PAY_NOW" d="Pay Now"}
{t c="TRANS_NEW_TICKET" d="Create a New Ticket"}
{t c="TRANS_NONEWS" d="No News"}
{t c="TRANS_DETAILS" d="Details"}

{t c="TRANS_SUBJECT" d="Subject"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_LAST_MODIFIED" d="Last Modified"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_VIEW_INVOICE" d="View Invoice"}
{t c="TRANS_PAY_ALL" d="Pay All"}
{t c="TRANS_WE_NEED_YOUR_INPUT" d="We need your input to continue"}
{t c="TRANS_THE_SERVER_ACCOUNT_USERNAME_YOU_SELECTED_IS_ALREADY_TAKEN_PLEASE_CHOOSE_ANOTHER" d="The plesk account username you have chosen is already taken, please click here to choose another."}
{/strip}
{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="overview"}

{if $showPPCOffer}
    {include file="$tplDirectory/widgets/google/showAcceptedOffer.tpl"}
    <br />
{/if}

{if $clientInputData}
	<fieldset>
		<legend>{$smarty.const.TRANS_WE_NEED_YOUR_INPUT}:</legend>
		{foreach key="x" item="inputRow" from=$clientInputData}
			{assign var="msg" value="`$inputRow.message`"}
			<h6 style="margin-left: 10px; margin-top: 10px; text-transform: none;"><a href="{getHREF page="packages.php" actionName="ShowClientServiceInputForm" args="packageID=`$inputRow.packageID`&serverGroupID=`$inputRow.serverGroupID`&configGroupID=`$inputRow.configGroupID`&"}">{$smarty.const.$msg}</a></h6>
		{/foreach}
	</fieldset><br />
{/if}

<fieldset>
	<legend><img src="{$imageDirectory}/ico/invoice-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {$smarty.const.TRANS_INVOICES_DUE}</legend>
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
    <tr class="headerRow">
	    <td style="text-align: center;">
            {$smarty.const.TRANS_INVOICE_NUMBER}
        </td>
        <td style="text-align: center;">
            {$smarty.const.TRANS_AMOUNT}
        </td>
        <td style="text-align: center;">
            {$smarty.const.TRANS_AMOUNT_PAID}
        </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_DATE_GENERATED}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_DATE_DUE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_STATUS}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_ACTION}
	    </td>
    </tr>
    {section name=i loop=$invoices}
    	{if $invoices[i].invoiceAmount!=$invoices[i].invoiceAmountPaid}
    	{assign var="invoiceEchod" value=1}
        <tr class="{cycle values="alt1,alt1"}">
            <td style="text-align: center;">
				<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">
					{$invoices[i].invoiceNumber}
				</a>
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmountPaid|getAmount:$invoices[i].currencyID}
            </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateEntered|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateDue|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceStatus|getStatusName:"invoice"}
	        </td>
	        <td style="text-align: right;">
				<div class="rm"><a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">{$smarty.const.TRANS_VIEW_INVOICE}</a></div>
			 	<div class="rm"><a href="{getHREF page="invoices.php" actionName="PayInvoices"}&amp;invoiceID={$invoices[i].invoiceID}">{$smarty.const.TRANS_PAY_NOW}</a></div>
	        </td>
        </tr>
        {/if}
    {/section}
    {if $invoiceEchod!=1}
        <tr class="alt1">
            <td style="text-align: left;" colspan="7"><i>{$smarty.const.TRANS_NONE}</i></td>
        </tr>
    {else}
        <tr class="listButtons">
	        <td colspan="7"><div>
			 	<div class="rm"><a href="{getHREF page="invoices.php" actionName="PayInvoices"}">{$smarty.const.TRANS_PAY_ALL}</a><div>
	        </div></td>
        </tr>
    {/if}
	</table>
</fieldset>{* box07x *}
<br />

<fieldset>
	<legend><img src="{$imageDirectory}/ico/package-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {$smarty.const.TRANS_ACTIVE_BILLABLE_PACKAGES}</legend>
	<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
    <tr class="headerRow">
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_ID}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_PACKAGE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_PRICE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_BILLING_CYCLE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_NEXT_RENEWAL}
	    </td>
	    <td  style="text-align: center;">
		    {$smarty.const.TRANS_STATUS}
	    </td>
	    <td  style="text-align: center;">
		    {$smarty.const.TRANS_ACTION}
	    </td>
    </tr>
    {section name=i loop=$packages}
        <tr class="{cycle values="alt1,alt1"}">
	        <td style="text-align: left;">
		        {$packages[i].packageID}
	        </td>
	        <td style="text-align: left;">
		        {$packages[i].packageName|stripslashes}
		        {if $packages[i].domains.0.domainID>0}
		        	{foreach item="domain" key="dk" from=$packages[i].domains}
		        		<br />
		        		<!-- <a href="{getHREF page="domains.php" actionName="ShowDomainDetails" args="domainID=`$domain.domainID`"}"> --><strong>{$domain.domainSLD}.{$domain.domainTLD}</strong><!-- </a> -->
		        	{/foreach}
		        {/if}
	        </td>
	        <td style="text-align: right;">
		        {$packages[i].packagePrice|getAmount:$packages[i].paymentGroupCurrencyID}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].cycleID|getArrayValueByID:$cycles}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].packageDateNextRenewal|getDate}
	        </td>
	        <td  style="text-align: center;">
		        {$packages[i].packageStatus|getStatusName:"package"}
	        </td>
	        <td  style="text-align: center;">
		        <a href="{getHREF page="packages.php" actionName="ShowPackages"}">{$smarty.const.TRANS_MANAGE}</a>
	        </td>
        </tr>
    {sectionelse}
        <tr class="alt1">
            <td colspan="7"><i>{$smarty.const.TRANS_NONE}</i></td>
        </tr>
    {/section}
	</table>
</fieldset>{* box07x *}
<br />

{*
{if $helpdeskEnabled}
<fieldset>
	<legend><img src="{$imageDirectory}/ico/ticket-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {$smarty.const.TRANS_OPEN_TICKETS}</legend>
		<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
		<tr class="headerRow">
			<td width="25%" style="text-align: center;">{$smarty.const.TRANS_TICKET_ID}</td>
			<td width="35%" style="text-align: center;">{$smarty.const.TRANS_SUBJECT}</td>
			<td width="20%" style="text-align: center;">{$smarty.const.TRANS_DATE_CREATED}</td>
			<td width="20%" style="text-align: center;">{$smarty.const.TRANS_LAST_MODIFIED}</td>
		</tr>
		{foreach key=id item=ticket from=$helpdeskTickets}
			{if $ticket.hdTicketStatusID==2}
			<tr class="{cycle values="alt1,alt1"}">
				<td width="25%" style="text-align: left;"><a href="{getHREF page="helpdesk.php"
								actionName="ShowHelpdeskTicketDetails"
								args="hdTicketID=`$ticket.hdTicketID`"}">{$ticket.hdTicketKey}</a></td>
				<td width="35%" style="text-align: left;">{$ticket.hdTicketSubject|mb_truncate:25}</td>
				<td width="20%" style="text-align: left;">{$ticket.hdTicketDateCreated|getDateTime:short}</td>
				<td width="20%" style="text-align: left;"><div class="floatleft">{$ticket.hdTicketDateModified|getDateTime:short}</td>
			</tr>
			{/if}
		{/foreach}
		<tr class="alt1">
			<td colspan="4"><i><a href="{getHREF page="helpdesk.php" actionName="AddHelpdeskTicket"}">{$smarty.const.TRANS_NEW_TICKET}</a></i></td>
		</tr>
		</table>
</fieldset>{* box07 * }
<br />
{/if}
*}

{*
<fieldset>
	<legend><img src="{$imageDirectory}/ico/news-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {$smarty.const.TRANS_NEWS_AND_ANNOUNCMENTS}</legend>
	<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
	 <tr class="headerRow">
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_SUBJECT}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_DESCRIPTION}
	    </td>
	</tr>
	{foreach from=$news item=n}
    		<tr style="cursor:pointer;" onClick="XKtoggle('row_{$n.newsGroupID}');">
    			<td>{$n.newsGroupName}</td>
    			<td>{$n.newsGroupDescription}</td>
    		</tr>
    		<tbody id="row_{$n.newsGroupID}">
    		<tr>
    			<td colspan="2">
    				<table width="100%" cellspacing="2" cellpadding="0" border="0" class="list">
    				<tr class="headerRow">
    					<td style="text-align:center;">
    						{$smarty.const.TRANS_SUBJECT}
    					</td>
    					<td style="text-align:center;">
    						{$smarty.const.TRANS_PRIORITY}
    					</td>
    				</tr>
    				{foreach from=$n.articles item=a}
					<tr style="cursor:pointer;" onClick="XKtoggle('article_{$a.newsID}');">
						<td>{$a.newsSubject}</td>
						<td>{$a.priorityID|getArrayValueByID:$priorities}</td>
					</tr>
					<tbody id="article_{$a.newsID}">
						<td colspan="2">
							{$a.newsBody|nl2br|html_entity_decode}
						</td>
					</tbody>
					<script type="text/javascript" language="javascript" charset="utf-8">
					//<[[CDATA][
					XKtoggle('article_{$a.newsID}');
					//]]>
					</script>
    				{foreachelse}
    					<tr bgcolor="#EEEDE9">
    						<td colspan="2"><i>{$smarty.const.TRANS_NORESULTS}</a></td>
    					</tr>
    				{/foreach}
    				</table>
    			</td>
    		</tr>
    		<script type="text/javascript" language="javascript" charset="utf-8">
		//<[[CDATA][
		XKtoggle('row_{$n.newsGroupID}');
		//]]>
		</script>
    	{foreachelse}
    		<tr class="alt1">
	        	<td colspan="2"><i>{$smarty.const.TRANS_NONEWS}</i></td>
	    	</tr>
	{/foreach}
	</table>
</fieldset>{* box07 * }
*}

{include file="$tplDirectory/footer.tpl"}
