{* $Id: ShowInvoices.tpl 11448 2007-06-27 16:44:50Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of invoice records.
 *
 * Smarty Variables:
 *	$invoices (array of invoices that match input criteria)
 *		invoiceID			A unique invoice ID
 *		invoiceNumber		An invoice's number
 *		invoiceAmount		An invoice's amount
 *		invoiceDateEntered	An invoice's generation date
 *		invoiceDateDue		An invoice's due date
 *		invoiceStatus		The status of an invoice
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_AMOUNT" d="Amount"}
{t c="TRANS_CLIENT" d="Client"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_INVOICEID" d="Invoice ID"}
{t c="TRANS_INVOICE_NUMBER" d="Invoice Number"}
{t c="TRANS_COMMENTS" d="Comments"}
{t c="TRANS_DUE" d="Due"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_ENTERED" d="Entered"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_MANAGE_INVOICES" d="Manage Invoices"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_INVOICES" d="Show Invoices"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}


{t c="TRANS_QUANTITY" d="Quantity"}
{t c="TRANS_PACKAGE_ID" d="Package ID"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_BEGIN" d="Begin"}
{t c="TRANS_CURRENT" d="Current"}
{t c="TRANS_NEXT" d="Next"}
{t c="TRANS_PRICE" d="Price"}
{t c="TRANS_DISCOUNT" d="Discount"}
{t c="TRANS_SETUP" d="Setup"}
{t c="TRANS_TAX" d="Tax"}
{t c="TRANS_TOTALS" d="Totals"}
{t c="TRANS_ADDONS" d="Addons"}
{t c="TRANS_ADDON_ID" d="Addon ID"}

{assign var="filterArgs" value="invoiceStatus=$invoiceStatus"}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="invoices"}


		<fieldset>
			<legend><img src="{$imageDirectory}/ico/invoice-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {$smarty.const.TRANS_INVOICES}</legend>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr>
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}
	<td colspan="7" style="cursor: pointer;" onclick="{strip} {section name=iter loop=$invoices}
		XKtoggle('row_{$invoices[iter].invoiceNumber}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_INVOICE_NUMBER" sortColumn="invoiceNumber"}
	{include file="$tplDirectory/widgets/table/listHeaderSortAmount.tpl" headerName="TRANS_AMOUNT" sortColumn="invoiceAmount"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_ENTERED" sortColumn="invoiceDateEntered"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_DUE" sortColumn="invoiceDateDue"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" filterName="TRANS_STATUS" filterColumn="invoiceStatus" filterOptions="$invoiceStatusList"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS"}
</tr>
</thead>
{section name="i" loop=$invoices}
{assign var="invoiceID" value=$invoices[i].invoiceID}
{assign var="extendeddata" value=$invoices[i].lineItems.lineItem.0}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td style="cursor: pointer;" xonclick="return XKtoggle('row_{$invoices[i].invoiceID}');">
	<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=$invoiceID&redirectArgs=$bookmarkArgs"}">{$invoices[i].invoiceNumber}</a>
	</td>
	<td>
		{$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}
	</td>
	<td>
		{$invoices[i].invoiceDateEntered|getDate}
	</td>
	<td>
		{$invoices[i].invoiceDateDue|getDate}
	</td>
	<td align="center">
		{$invoices[i].invoiceStatus|getArrayValueByID:$invoiceStatusList}
	</td>
	<td align="center">
		{strip}
		<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=$invoiceID&redirectArgs=$bookmarkArgs"}">
			<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		</a>
		{/strip}
	</td>
</tr>
</tbody>
{*
<tbody id="row_{$invoices[i].invoiceID}" class="off">
<tr>
	<td colspan="7" class="altinner">
		{$invoices[i].invoiceComments}

		{if $lineItems[$invoiceID]}
			<table width="100%" border="0" cellpadding="0" class="ledger">
			<tr>
                <td class="green" style="white-space: nowrap;">{$smarty.const.TRANS_PACKAGE_ID}</td>
				<td class="green" colspan="2">{$smarty.const.TRANS_DESCRIPTION}</td>
				<td class="green">{$smarty.const.TRANS_BEGIN}</td>
				<td class="green">{$smarty.const.TRANS_CURRENT}</td>
				<td class="green">{$smarty.const.TRANS_NEXT}</td>
                <td>{$smarty.const.TRANS_QUANTITY}</td>
				<td>{$smarty.const.TRANS_PRICE}</td>
				<td>{$smarty.const.TRANS_DISCOUNT}</td>
				<td>{$smarty.const.TRANS_SETUP}</td>
				<td>{$smarty.const.TRANS_TAX}</td>
				<td>{$smarty.const.TRANS_TOTALS}</td>
			</tr>
            {assign var="inaddons" value="no"}
			{section name="j" loop=$lineItems[$invoiceID]}
				{assign var="currencyID" value=$lineItems[$invoiceID][j].currencyID}
                {if $lineItems[$invoiceID][j].packageAddonID>0}
                    {if $inaddons=="no"}
                        {assign var="inaddons" value="yes"}
                        <tr class="alt1">
                            <td class="green" align="right">{$smarty.const.TRANS_ADDONS}</td>
                            <td class="green" colspan="5">{$smarty.const.TRANS_DESCRIPTION}  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                            <td>{$smarty.const.TRANS_QUANTITY}</td>
                            <td>{$smarty.const.TRANS_PRICE}</td>
                            <td>{$smarty.const.TRANS_DISCOUNT}</td>
                            <td>{$smarty.const.TRANS_SETUP}</td>
                            <td>{$smarty.const.TRANS_TAX}</td>
                            <td>{$smarty.const.TRANS_TOTALS}</td>
                        </tr>
                    {/if}
                        <tr>
                            <td class="green" align="right">{$lineItems[$invoiceID][j].packageAddonID}</td>
                            <td class="green" colspan="5">{$lineItems[$invoiceID][j].lineItemDescription}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemQuantity}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemPriceAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemDiscountAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemSetupAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemTaxAmount|getAmount:$currencyID}</td>
                            <td>{$lineItems[$invoiceID][j].lineItemTotalAmount|getAmount:$currencyID}</td>
                        </tr>


                {else}
                {assign var="inaddons" value="no"}
				<tr class="alt1">
                    <td class="green">{$lineItems[$invoiceID][j].packageID}</td>
					<td class="green" colspan="2">{$lineItems[$invoiceID][j].lineItemDescription}</td>
					<td class="green">{$lineItems[$invoiceID][j].lineItemDateBeginRenewal|getDate:"short"}</td>
					<td class="green">{$lineItems[$invoiceID][j].lineItemDateCurrentRenewal|getDate:"short"}</td>
					<td class="green">{$lineItems[$invoiceID][j].lineItemDateNextRenewal|getDate:"short"}</td>
                    <td>{$lineItems[$invoiceID][j].lineItemQuantity}</td>
					<td>{$lineItems[$invoiceID][j].lineItemPriceAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemDiscountAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemSetupAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemTaxAmount|getAmount:$currencyID}</td>
					<td>{$lineItems[$invoiceID][j].lineItemTotalAmount|getAmount:$currencyID}</td>
				</tr>
                {/if}
			{/section}
			</table>
		{else}
			<br />
			No Line Items
    	{/if}
	</td>
</tr>
</tbody>
*}

{sectionelse}
<tr class="alt1">
	<td colspan="7">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

</fieldset>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}

{include file="$tplDirectory/footer.tpl"}
