{* $Id: ShowLogin.tpl 12032 2007-10-05 14:09:29Z bwoolley $
 * --------------------------------------------------------------
 * This template displays the client login form.
 *
 * Smarty Variables:
 *  $redirectActionID  -  The action ID to redirect to. This is 0 if we're not redirecting.
 *  $redirectActionFile  -  The filename to redirect to. This is "" if we're not redirecting.
 *
 *  $htmlLang		The language this document will render
 *	$userIP			The logged IP address of the user
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *}
{t c="TRANS_CLIENT_LOGIN" d="Client Login"}
{t c="TRANS_IP_LOGGING_ENABLED" d="IP Logging Enabled"}
{t c="TRANS_INVALIDSESSION" d="Invalid Session"}
{t c="TRANS_FORGOT" d="Forgot"}
{t c="TRANS_FORGOT_YOUR_PASSWORD" d="Forgot your password"}
{t c="TRANS_LOGIN" d="Login"}
{t c="TRANS_LOGINFAILURE" d="Login Failure"}
{t c="TRANS_LOGOUTSUCCESSFUL" d="Logout Successful"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_PASSWORD" d="Password"}
{t c="TRANS_LOGIN_TEXT" d="Enter the login name into \"Login\" and password into the \"Password\" fields respectively. Then click \"Login\"."}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{$smarty.const.TRANS_TEXTDIRECTION}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{$smarty.const.$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {$smarty.const.$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {$smarty.const.$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta name="copyright" content="2006, ModernGigabyte, LLC" />
<meta name="description" content="{$appParentName} {$appParentVersion}-{$appParentBuild} {$appCurrentName}-{$appCurrentVersion}" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/clientstyle.css" charset="utf-8" />
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/toggle.js"></script>
</head>
<body>
<table border="0" cellspacing="0" cellpadding="0" class="top">
	<tr>
		<td class="TopLeftLogo"><img src="{$imageDirectory}/logos/PPBLogo.gif" width="210" height="48" alt="Your Logo" title="Your Logo"/></td>
		<td class="TopTextBlock"><div class="loginInfo"><a target="_blank" href="http://www.parallels.com">&copy; Copyright 1999-2008, Parallels<br />All rights reserved</div></td>
		<td class="TopRightLogo"><a target="_blank" href="http://www.parallels.com"><img src="{$imageDirectory}/logos/ParallelsLogo.gif" width="170" height="48" alt="Parallels" title="Parallels"/></a></td>
	</tr>
</table>
<div class="login-div">
		<form name="login" method="post" action="login.php">
		<input type="hidden" name="action" value="{getActionID action="LoginResponse"}" />
		{if ($redirectActionID && $redirectActionFile)}
		    <input type="hidden" name="redirectActionID" value="{$redirectActionID}" />
		    <input type="hidden" name="redirectActionFile" value="{$redirectActionFile}" />
		    <input type="hidden" name="redirectArgs" value="{$redirectArgs}" />
		{/if}
		<center>
		{assign var="msg" value=$smarty.request.msg}
		{if $msg}<div class="error-box"><div>{$smarty.const.$msg}</div></div>{/if}
			<table border="0" cellspacing="0" cellpadding="0" class="login" align="center">
				<tr>
					<td class="loginTitle">
					{$smarty.const.TRANS_CLIENT_LOGIN}
					</td>
				</tr>
				<tr>
					<td>
						<div class="login02">
							<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="login04">
							<tr>
								<td colspan="2">
							{$smarty.const.TRANS_IP_LOGGING_ENABLED}: {$userIP}
								</td>
							</tr>
							<tr>
								<td colspan="2">
							{$smarty.const.TRANS_LOGIN_TEXT}
								</td>
							</tr>
							<tr>
								<td>{$smarty.const.TRANS_USERNAME}:</td>
								<td><input name="contactUsername" type="text" value="" /></td>
							</tr>
							<tr>
								<td>{$smarty.const.TRANS_PASSWORD}:</td>
								<td><input name="contactPassword" type="password" value="" /></td>
							</tr>
							<tr>
								<td><a href="{getHREF page="login.php" actionName="ShowForgottenPassword"}">{$smarty.const.TRANS_FORGOT_YOUR_PASSWORD}?</a></td>
								<td class="loginbutton"><div class="rm_login"><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_LOGIN}" /></div></td>
							</tr>
							</table>
						</div>
					</td>
				</tr>
			</table>
		</center>
		</form>
</div>
</body>
</html>
