{* $Id: ShowPackageDetails.tpl 12889 2008-04-22 18:31:04Z btyra $
 * --------------------------------------------------------------
 * This template displays a list of packages.
 *
 * Smarty Variables:
 *	$packages (array of packages that match criteria)
 *      $packageUsage (array of usage info)
 *
 *}
{strip}
 
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_CONFIGURE" d="Configure"}
{t c="TRANS_UPGRADE_DOWNGRADE" d="Upgrade/Downgrade"}
{t c="TRANS_WITHDRAW_CANCELLATION" d="Withdraw Cancellation"}
{t c="TRANS_PACKAGE_PENDING_CANCELLATION" d="PACKAGE PENDING CANCELLATION"}
{t c="TRANS_NO_PACKAGES_FOUND" d="No Packages Found"}
{t c="TRANS_UPGRADE" d="Upgrade"} 
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_PANEL_OPTIONS" d="Panel Options"}
{t c="TRANS_STOP_DATE" d="Stop Date"}
{t c="TRANS_MORE_CYCLES" d="more cycles"}
{t c="TRANS_MANAGE_CERT" d="Manage Certificate"}
{t c="TRANS_MINUTES" d="minutes"}
{t c="TRANS_OVER_THE_LIMIT" d="You are over your limit!"}
{t c="TRANS_NEXT_BILL_DATE" d="Next Bill Date"}
{t c="TRANS_PACKAGE_IS_NOT_ACTIVE" d="Package is not active, you cannot perform management actions on it."}

{/strip}
{include file="$tplDirectory/header.tpl" tabMajor="packages" tabMinor="packages"}


{if $numPackages==0}
	<strong>{$smarty.const.TRANS_NO_PACKAGES_FOUND}</strong>
{else}

	{foreach key="statusID" item="packageGroup" from=$statusPackages}
		{assign var="packages" value=$packageGroup.packages}

		<fieldset>
			<legend><img src="{$imageDirectory}/ico/package-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" />{$packageStatuses.$statusID}</legend>
			<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
				<tr class="headerRow">
					<td>
						{$smarty.const.TRANS_PACKAGE}
					</td>
					<td>
						{$smarty.const.TRANS_ACTIONS}
					</td>
				</tr>

				{section name="i" loop=$packages}
				<tr>
					<td colspan="2" class="headerRow">
						{$packages[i].packageName}
						{if $packages[i].packagePendingCancellation>0 && $packages[i].packageStatus != $cancelledStatusID}
							<br /><strong>{$smarty.const.TRANS_PACKAGE_PENDING_CANCELLATION}</strong>
						{/if}
					</td>
				</tr>
				<tr class="{cycle values="alt1,alt2"}">
				    <td align="left" valign="top">
						<table border="0">
							<tr>
								<td class="title">{$smarty.const.TRANS_ID}</td>
								<td>{$packages[i].packageID}</td>
							</tr>
							{if $packages[i].domains}
							<tr>
								<td class="title">{$smarty.const.TRANS_DOMAINS}</td>
								<td valign="top">
									{section name="x" loop=$packages[i].domains}
										<strong>{$packages[i].domains[x].domainSLD}.{$packages[i].domains[x].domainTLD}</strong><br />
									{/section}
								</td>
							</tr>
							{/if}
							<tr>
								<td class="title">{$smarty.const.TRANS_PRICE}</td>
								<td valign="top">{$packages[i].packagePrice|getAmount:$packages[i].paymentGroupCurrencyID}</td>
							</tr>
							<tr>
								<td class="title">{$smarty.const.TRANS_BILLING_CYCLE}</td>
								<td valign="top">{$packages[i].cycleID|getArrayValueByID:$cycles}</td>
							</tr>
							<tr>
								<td class="title">{$smarty.const.TRANS_NEXT_BILL_DATE}</td>
								<td valign="top">{$packages[i].packageDateNextRenewal|getDate:short}</td>
							</tr>
							{if $packages[i].stopDate>10}
							<tr>
								<td class="title">{$smarty.const.TRANS_STOP_DATE}</td>
								<td valign="top">{$packages[i].stopDate|getDate:short}<br />
									<small style="white-space: nowrap;">({$packages[i].moreCycles} {$smarty.const.TRANS_MORE_CYCLES})</small></td>
							</tr>
							{/if}
						</table>
						{assign var="packageID" value=$packages[i].packageID}
						{if $childPackages.$packageID || $packages[i].packageAddons}
							<br />{$smarty.const.TRANS_OPTIONS}<br />
							<table border="0">
							
							{foreach key="x" item="package" from=$packages[i].packageAddons}
								<tr class="comments altinner">
									<td></td>
									<td style="text-align: center; cursor: pointer;">
										{$package.packageAddonID}
									</td>
									<td style="text-align: left;">
										{$package.packageAddonDisplayName}
									</td>
									<td style="text-align: right;">
										{$package.packageAddonPrice|getAmount:$packages[i].paymentGroupCurrencyID}
									</td>
									<td style="text-align: center;">
										{$packages[i].cycleID|getArrayValueByID:$cycles}
									</td>
									<td style="text-align: center;">
										{$packages[i].packageDateNextRenewal|getDate:short}
									</td>
									<td style="text-align: center;">
										{if $packages[i].stopDate>10}
											{$packages[i].stopDate|getDate:short}<br />
											<small style="white-space: nowrap;">({$packages[i].moreCycles} {$smarty.const.TRANS_MORE_CYCLES})</small>
										{else}
											--
										{/if}
									</td>
									
									<td></td>
									
								</tr>
							{/foreach}
		
							{foreach key="x" item="package" from=$childPackages.$packageID}
								<tr class="comments altinner">
									<td></td>
									<td style="text-align: center; cursor: pointer;">
										{$package.packageID}
									</td>
									<td style="text-align: left;">
										{$package.packageName}
										{if $package.packagePendingCancellation>0 && $package.packageStatus != $cancelledStatusID}
											<br /><strong>{$smarty.const.TRANS_PACKAGE_PENDING_CANCELLATION}</strong>
										{/if}
									</td>
									<td style="text-align: right;">
										{$package.packagePrice|getAmount:$package.paymentGroupCurrencyID}
									</td>
									<td style="text-align: center;">
										{$package.cycleID|getArrayValueByID:$cycles}
									</td>
									<td style="text-align: center;">
										{$package.packageDateNextRenewal|getDate:short}
									</td>
									<td style="text-align: center;">
										{if $package.stopDate>10}
											{$package.stopDate|getDate:short}<br />
											<small style="white-space: nowrap;">({$package.moreCycles} {$smarty.const.TRANS_MORE_CYCLES})</small>
										{else}
											--
										{/if}
									</td>
									
									<td></td>
									
								</tr>
							{/foreach}
		
							</table>
						
						{/if}
					</td>
					
					<td align="left" valign="top">
					
						{if $packages[i].clientCancel==1}
							{if $packages[i].packagePendingCancellation==0 && $packages[i].mayCancel==1}
								{include file="$tplDirectory/widgets/actionLink.tpl"
									page="packages.php"
									actionName="CancelPackage"
									args="packageID=`$packages[i].packageID`"
									icoImage="cancel"
									icoWidth=""
									icoHeight=""
									icoStyle=""
									altText="TRANS_CANCEL"
									titleText="TRANS_CANCEL"
									linkText="TRANS_CANCEL"
									noSpace="1"
								}<br />
							{/if}
							{if $packages[i].packagePendingCancellation==1}
								{include file="$tplDirectory/widgets/actionLink.tpl"
									page="packages.php"
									actionName="CancelPackage"
									args="packageID=`$packages[i].packageID`"
									icoImage="uncancel"
									icoWidth=""
									icoHeight=""
									icoStyle=""
									altText="TRANS_WITHDRAW_CANCELLATION"
									titleText="TRANS_WITHDRAW_CANCELLATION"
									linkText="TRANS_WITHDRAW_CANCELLATION"
									noSpace="1"
								}<br />
							{/if}
						{/if}
						{if $statusID == ("none"|get_status_id:"package") AND $packages[i].productType == ("products"|getTypeID:"hosting")}
							{include file="$tplDirectory/widgets/actionLink.tpl"
										page="packages.php"
										actionName="ShowPanelOptions"
										args="packageID=`$packages[i].packageID`"
										icoImage="view"
										icoWidth=""
										icoHeight=""
										icoStyle=""
										altText="TRANS_PANEL_OPTIONS"
										titleText="TRANS_PANEL_OPTIONS"
										linkText="TRANS_PANEL_OPTIONS"
										noSpace="1"
										}<br />
						{/if}
						{if $packages[i].productType == ("products"|getTypeID:"cert")}
							{if  $statusID == ("pending"|get_status_id:"package") && $packages[i].invoicePaid}
								{include file="$tplDirectory/widgets/actionLink.tpl"
										page="certs.php"
										actionName="OrderCertCSRRequest"
										args="packageID=`$packages[i].packageID`"
										icoImage="view"
										icoWidth=""
										icoHeight=""
										icoStyle=""
										altText="TRANS_TODO_BEGIN_CERT_REQUEST"
										titleText="TRANS_TODO_BEGIN_CERT_REQUEST"
										linkText="TRANS_TODO_BEGIN_CERT_REQUEST"
										noSpace="1"
										}<br />
							{elseif  $statusID == ("none"|get_status_id:"package")}
								{include file="$tplDirectory/widgets/actionLink.tpl"
										page="certs.php"
										actionName="ShowCertDetails"
										args="packageID=`$packages[i].packageID`"
										icoImage="view"
										icoWidth=""
										icoHeight=""
										icoStyle=""
										altText="TRANS_MANAGE_CERT"
										titleText="TRANS_MANAGE_CERT"
										linkText="TRANS_MANAGE_CERT"
										noSpace="1"
										}<br />
							{/if}
						{/if}
						{if $packages[i].packagePendingCancellation==0 && $upgradeDowngradeStatuses.$statusID==1}
							{*if $packages[i].rules.addons==1}
        							{include file="$tplDirectory/widgets/actionLink.tpl"
									    page="packages.php"
									    actionName="EditPackageAddons"
									    args="packageID=`$packages[i].packageID`"
									    icoImage="addons"
									    icoWidth=""
									    icoHeight=""
									    icoStyle=""
									    altText="TRANS_CONFIGURE"
									    titleText="TRANS_CONFIGURE"
									    linkText="TRANS_CONFIGURE"
									    noSpace="1"
									}<br />
							{/if *}
							{if $packages[i].rules.upgrade==1}
        							{include file="$tplDirectory/widgets/actionLink.tpl"
									    page="packages.php"
									    actionName="UpgradePackage"
									    args="packageID=`$packages[i].packageID`"
									    icoImage="upgrade"
									    icoWidth=""
									    icoHeight=""
									    icoStyle=""
									    altText="TRANS_UPGRADE"
									    titleText="TRANS_UPGRADE"
									    linkText="TRANS_UPGRADE"
									    noSpace="1"
									}<br />
							{/if}
							{if $packages[i].rules.downgrade==1}
        							{include file="$tplDirectory/widgets/actionLink.tpl"
									    page="packages.php"
									    actionName="DowngradePackage"
									    args="packageID=`$packages[i].packageID`"
									    icoImage="downgrade"
									    icoWidth=""
									    icoHeight=""
									    icoStyle=""
									    altText="TRANS_DOWNGRADE"
									    titleText="TRANS_DOWNGRADE"
									    linkText="TRANS_DOWNGRADE"
									    noSpace="1"
									}<br />
							{/if}
						{/if}
						{if $packages[i].packageStatus == 0 || $packages[i].packageStatus==13}
							<br />
							{assign var="panelFiles" value=$packages[i].panelTemplates}
							{foreach item="tmpl" key="serverGroupID" from=$panelFiles}
								<h6>{$tmpl.1}</h6>
								{include file=$tmpl.0 serverGroupID=$serverGroupID attributes=$packages[i].keyedAttributes}<br /><br />
							{/foreach}
						{else}
							{$smarty.const.TRANS_PACKAGE_IS_NOT_ACTIVE}
						{/if}
					</td>
				</tr>
					{if $packageUsage[$packageID]}
						{assign var="usage" value=$packageUsage[$packageID]}
							{if $usage.packageUsage != 0}
							<tr align="left">
								<td colspan="8">
									<div style="margin: 0px; padding: 0px;">
										{if $usage.packageUsage>$usage.packageUsageLimit}
											<div style="padding: 4px; color: red; font-weight: bold;">{$smarty.const.TRANS_USAGE}: <strong>{$usage.packageUsage|getAmount:" "}</strong> of <strong>{$usage.packageUsageLimit|getAmount:" "}</strong> {$usage.packageUsageUnit}</div>
											{include file="$tplDirectory/widgets/progressBar.tpl"
											       containerWidth="400"
											       containerColor="red"
												leftPercentage="TRANS_OVER_THE_LIMIT"
											       barWidth=$usage.packageUsageLimit*400/$usage.packageUsage}
										{else}
											<div style="padding: 4px;">{$smarty.const.TRANS_USAGE}: <strong>{$usage.packageUsage|getAmount:" "}</strong> of <strong>{$usage.packageUsageLimit|getAmount:" "}</strong> {$usage.packageUsageUnit}</div>
											{include file="$tplDirectory/widgets/progressBar.tpl"
											       containerWidth="400"
											       containerColor="#CCCCCC"
											       barWidth=$usage.packageUsage*400/$usage.packageUsageLimit}
										{/if}
									</div>
								</td>
							</tr>
							{/if}
					{/if}
				{/section}

			</table>

		</fieldset>
		<br />

	{/foreach}

{/if}


{include file="$tplDirectory/footer.tpl"}