{* $Id: AddClientContact.tpl 12803 2008-03-24 16:12:13Z btyra $
 * --------------------------------------------------------------
 * This template displays the domains.
 *
 * Smarty Variables:
 *  $client (array of client data if this is the primary contact)
 *  $contacts (array of contact data)
 *  $isPrimary (used to allow actions to only the main login)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Andy Christ
 *}

{t c="TRANS_ADD_CONTACT" d="Add a Contact"}

{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_EMAIL" d="e-mail"}
{t c="TRANS_EMAIL_HTML" d="HTLM"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_ADDRESS" d="Address 1"}
{t c="TRANS_ADDRESS2" d="Address 2"}
{t c="TRANS_CITY" d="City"}
{t c="TRANS_STATE" d="State"}
{t c="TRANS_ZIP" d="Zip"}
{t c="TRANS_PRIMARY_PHONE" d="Phone 1"}
{t c="TRANS_SECONDARY_PHONE" d="Phone 2"}
{t c="TRANS_FAX" d="Fax"}
{t c="TRANS_PRIMARY" d="Primary"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_LANGUAGE" d="Language"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_PASSWORD" d="Password"}
{t c="TRANS_CONFIRM_PASSWORD" d="Confirm Password"}
{t c="TRANS_EMAIL_ACTIONS" d="Email Actions"}


{include file="$tplDirectory/header.tpl" tabMajor="profile" tabMinor="contacts"}

{assign var="selectableEmailActions" value=$emailActions}
		<fieldset>
			<legend><img src="{$imageDirectory}/ico/contact-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {$smarty.const.TRANS_ADD_CONTACT}</legend>

				<form method="post" action="profile.php" name="AddClientContact" onSubmit="XKselectAllOptionsInMultiSelects(this);">
				<input type="hidden" name="action" value="{getActionID action="AddClientContactResponse"}">
				<input type="hidden" name="clientID" value="{$client.clientID}">
				<input type="hidden" name="clientContactID" value="{$clientContactID}">
				<input type="hidden" name="sid" value="{$sid}">
				
				<table border="0" cellpadding="0" cellspacing="0" class="list" width="100%">
				<tbody>
				<tr class="{if $invalid.contactFirstName}highlight{else}{/if}">
					<td class="title"><label for="contactFirstName">{$smarty.const.TRANS_FIRST_NAME}</label></td>
					<td><input size="50" maxlength="50" type="text" id="contactFirstName" name="contactFirstName" value="{$formValues.contactFirstName}" /> {$invalid.contactFirstName}</td>
				</tr>
				<tr class="{if $invalid.contactLastName}highlight{else}{/if}">
					<td class="title"><label for="contactLastName">{$smarty.const.TRANS_LAST_NAME}</label></td>
					<td><input size="50" maxlength="50" type="text" id="contactLastName" name="contactLastName" value="{$formValues.contactLastName}" /> {$invalid.contactLastName}</td>
				</tr>
				<tr class="{if $invalid.contactUsername}highlight{else}{/if}">
					<td class="title"><label for="contactUsername">{$smarty.const.TRANS_USERNAME}</label></td>
					<td><input size="20" maxlength="20" type="text" id="contactUsername" name="contactUsername" value="{$formValues.contactUsername}" /> {$invalid.contactUsername}</td>
				</tr>
				<tr class="{if $invalid.contactActive}highlight{else}{/if}">
					<td class="title"><label for="clientActive">{$smarty.const.TRANS_ACTIVE}</label></td>
					<td>
						<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
						<input type="hidden" name="contactActive" value="0">
						<input type="checkbox" id="contactActive" name="contactActive" value="1" {if $formValues.contactActive}checked="checked" {/if}/> <label for="contactActive">{$smarty.const.TRANS_ACTIVE}</label>
						{$invalid.contactActive}
					</td>
				</tr>
				<tr class="{if $invalid.contactPassword}highlight{else}{/if}">
					<td class="title"><label for="contactPassword">{$smarty.const.TRANS_PASSWORD}</label></td>
					<td><input size="32" maxlength="32" type="password" id="contactPassword" name="contactPassword" value="" /> {$invalid.contactPassword}</td>
				</tr>
				<tr class="{if $invalid.contactPasswordConfirm}highlight{else}{/if}">
					<td class="title"><label for="contactPasswordConfirm">{$smarty.const.TRANS_CONFIRM_PASSWORD}</label></td>
					<td><input size="32" maxlength="32" type="password" id="contactPasswordConfirm" name="contactPasswordConfirm" value="" /> {$invalid.contactPasswordConfirm}</td>
				</tr>
				<tr class="{if $invalid.contactEmail}highlight{else}{/if}">
					<td class="title"><label for="contactEmail">{$smarty.const.TRANS_EMAIL}</label></td>
					<td><input size="50" maxlength="100" type="text" id="contactEmail" name="contactEmail" value="{$formValues.contactEmail}" /> {$invalid.contactEmail}</td>
				</tr>
				<tr class="{if $invalid.contactEmailFormat}highlight{else}{/if}">
					<td class="title"><label for="contactEmailFormat">{$smarty.const.TRANS_EMAIL_FORMAT}</label></td>
					<td>
						<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
						<input type="hidden" name="contactEmailFormat" value="0">
						{if $invalid}{assign var="isinvalid" value="1"}{else}{assign var="isinvalid" value="0"}{/if}
						<input type="checkbox" id="contactEmailFormat" name="contactEmailFormat" value="1" {if $formValues.contactEmailFormat}checked="checked" {/if}/> <label for="contactEmailFormat">{$smarty.const.TRANS_HTML}</label>
						{$invalid.contactEmailFormat}
					</td>
				</tr>
				<tr class="{if $invalid.contactCompany}highlight{else}{/if}">
					<td class="title"><label for="contactCompany">{$smarty.const.TRANS_COMPANY}</label></td>
					<td><input size="50" maxlength="100" type="text" id="contactCompany" name="contactCompany" value="{$formValues.contactCompany}" /> {$invalid.contactCompany}</td>
				</tr>
				<tr class="{if $invalid.contactAddress1}highlight{else}{/if}">
					<td class="title"><label for="contactAddress1">{$smarty.const.TRANS_ADDRESS}</label></td>
					<td><input size="50" maxlength="100" type="text" id="contactAddress1" name="contactAddress1" value="{$formValues.contactAddress1}" /> {$invalid.contactAddress1}</td>
				</tr>
				<tr class="{if $invalid.contactAddress2}highlight{else}{/if}">
					<td class="title"><label for="contactAddress2">{$smarty.const.TRANS_ADDRESS2}</label></td>
					<td><input size="50" maxlength="100" type="text" id="contactAddress2" name="contactAddress2" value="{$formValues.contactAddress2}" /> {$invalid.contactAddress2}</td>
				</tr>
				<tr class="{if $invalid.contactCity}highlight{else}{/if}">
					<td class="title"><label for="contactCity">{$smarty.const.TRANS_CITY}</label></td>
					<td><input size="50" maxlength="100" type="text" id="contactCity" name="contactCity" value="{$formValues.contactCity}" /> {$invalid.contactCity}</td>
				</tr>
				<tr class="{if $invalid.contactState}highlight{else}{/if}">
					<td class="title"><label for="contactState">{$smarty.const.TRANS_STATE}</label></td>
					<td><input size="25" maxlength="100" type="text" id="contactState" name="contactState" value="{$formValues.contactState}" /> {$invalid.contactState}</td>
				</tr>
				<tr class="{if $invalid.contactZip}highlight{else}{/if}">
					<td class="title"><label for="contactZip">{$smarty.const.TRANS_ZIP}</label></td>
					<td><input size="25" maxlength="100" type="text" id="contactZip" name="contactZip" value="{$formValues.contactZip}" /> {$invalid.contactZip}</td>
				</tr>
				<tr class="{if $invalid.countriesID}highlight{else}{/if}">
					<td class="title"><label for="countriesID">{$smarty.const.TRANS_COUNTRY}</label></td>
					<td><select id="countriesID" id="countriesID" name="countriesID"> {html_options options=$countryList selected=$formValues.countriesID} </select> {$invalid.countriesID}</td>
				</tr>
				<tr class="{if $invalid.countriesID}highlight{else}{/if}">
					<td class="title"><label for="languageID">{$smarty.const.TRANS_LANGUAGE}</label></td>
					<td><select id="languageID" id="languageID" name="languageID"> {html_options options=$languageList selected=$formValues.languageID} </select> {$invalid.languageID}</td>
				</tr>
				<tr class="{if $invalid.contactPhone1}highlight{else}{/if}">
					<td class="title"><label for="contactPhone1">{$smarty.const.TRANS_PRIMARY_PHONE}</label></td>
					<td><input size="25" maxlength="25" type="text" id="contactPhone1" name="contactPhone1" value="{$formValues.contactPhone1}" /> {$invalid.contactPhone1}</td>
				</tr>
				<tr class="{if $invalid.contactPhone2}highlight{else}{/if}">
					<td class="title"><label for="contactPhone2">{$smarty.const.TRANS_SECONDARY_PHONE}</label></td>
					<td><input size="25" maxlength="25" type="text" id="contactPhone2" name="contactPhone2" value="{$formValues.contactPhone2}" /> {$invalid.contactPhone2}</td>
				</tr>
				<tr class="{if $invalid.contactFax}highlight{else}{/if}">
					<td class="title"><label for="contactFax">{$smarty.const.TRANS_FAX}</label></td>
					<td><input size="25" maxlength="25" type="text" id="contactFax" name="contactFax" value="{$formValues.contactFax}" /> {$invalid.contactFax}</td>
				</tr>
				<tr class="{if $invalid.contactPrimary}highlight{else}{/if}">
					<td class="title"><label for="contactPrimary">{$smarty.const.TRANS_PRIMARY}</label></td>
					<td>
						<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
						<input type="hidden" name="contactPrimary" value="0">
						{if $invalid}{assign var="isinvalid" value="1"}{else}{assign var="isinvalid" value="0"}{/if}
						<input type="checkbox" id="contactPrimary" name="contactPrimary" value="1" {if $formValues.contactPrimary}checked="checked" {/if}/> <label for="contactPrimary">{$smarty.const.TRANS_SET_PRIMARY}</label>
						{$invalid.contactPrimary}
					</td>
				</tr>
				
				<tr class="{if $invalid.emailActions}highlight{else}{/if}">
					<td class="title"><label for="emailActionIDs">{$smarty.const.TRANS_EMAIL_ACTIONS}</label></td>
					<td>
						{include file="$tplDirectory/widgets/comboBox.tpl"
							comboTitleLeft=TRANS_SELECTED
							comboNameLeft="emailActionIDs"
				
							comboTitleRight=TRANS_SELECTABLE
							comboNameRight="selectableEmailActions"
							comboOptionsRight=$emailActions
							formName="AddClientContact"
							submitName="suppress"}
						{$invalid.orderForms}
					</td>
				</tr>
				
				<tr class="listButtons">
					<td colspan="2"><div>
						<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_CONTACT}" />
				{*		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" /> *}
					</div></td>
				</tr>

				</table>

				</form>

		<fieldset>{* box07 *}

{include file="$tplDirectory/footer.tpl"}
