{* $Id: ShowAllTodos.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template 
 * will eventually display less information about a to-do item than the ShowTodoDetails action; but 
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *
 *}
{t c="TRANS_TASKS" d="Todo Tasks"}
{t c="TRANS_ALL_TODOS" d="All Todos"}
{t c="TRANS_SUBJECT" d="Subject"}
{t c="TRANS_ADMIN" d="User"}
{t c="TRANS_STATUS" d="Status"}

{t c="TRANS_MANAGE_TODOS" d="Manage Todos"}
{t c="TRANS_DATE_DUE" d="Date Due"}
{t c="TRANS_ASSIGNED_ADMINS" d="Assigned Admins"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_OPEN" d="Open"}
{t c="TRANS_CLOSED" d="Closed"}

{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_DELETE" d="Delete"}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

		<fieldset>
			<legend>{$smarty.const.TRANS_ALL_TODOS}</legend>>
			<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
			<!-- <a href="todos.php?action={getActionID action="AddTodo"}&sid={$sid}">{$smarty.const.TRANS_ADD}</a><br /> -->
			
			<thead>
				<tr class="headerRow">
					{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_SUBJECT" sortColumn="todoTitle"}
					{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_ASSIGNED_ADMINS" sortColumn="todoAssignedAdminID"}
					{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_DATE_DUE" sortColumn="todoDateDue"}
					{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_STATUS" sortColumn="todoStatusID"}
					{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
				</tr>
			</thead>
			
			{if count($todos) > 0}
				{section name="i" loop="$todos"}
					{if $className=="alt1"}
						{assign var="className" value="alt2"}
					{else}
						{assign var="className" value="alt1"}
					{/if}
					{assign var="todoID" value=$todos[i].todoID}
					<tbody>
					<tr class="{cycle values="alt1,alt2"}">
						<td onmouseover="this.style.cursor='hand'" onclick="return XKtoggle('row_{$todoID}');">
						
							<a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=$todoID"}">{$todos[i].todoTitle}</a>
						</td>
						<td onmouseover="this.style.cursor='hand'" onclick="return XKtoggle('row_{$todoID}');">
							{$todos[i].assigned.0.adminFirstName} {$todos[i].assigned.0.adminLastName} - {$todos[i].assigned.0.adminUsername}
						</td>
						<td onmouseover="this.style.cursor='hand'" onclick="return XKtoggle('row_{$todoID}');">
							{$todos[i].todoDateDue|getDate:medium}
						</td>
						<td onmouseover="this.style.cursor='hand'" onclick="return XKtoggle('row_{$todoID}');">
							{$todos[i].todoStatusID|getArrayValueByID:$todostatus}
						</td>
						<td mouseover="this.style.cursor='hand'" onclick="return XKtoggle('row_{$todoID}');">
							<a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=$todoID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
							</a>
			
							<a href="{getHREF page="todos.php" actionName="EditTodo" args="todoID=$todoID"}">
								<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
							</a>
			
							<a href="{getHREF page="todos.php" actionName="RemoveTodo" args="todoID=$todoID"}">
								<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
							</a>
						</td>
					</tr>
					</tbody>
				{sectionelse}
					<tr class="alt1">
						<td colspan="5">{$smarty.const.TRANS_NORESULTS}</td>
					</tr>
				{/section}
			</table>
			{else}
				{$smarty.const.TRANS_NORESULTS}
			{/if}
		</fieldset>

{include file="$tplDirectory/footer.tpl"}
