{* $Id: ShowTodoDetails.tpl 10514 2007-01-19 15:19:10Z bsmith $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template 
 * will eventually display more information about a to-do item than the ShowTodos action; but 
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *}

{t c="TRANS_TODO_DETAILS" d="Todo Details"}
{t c="TRANS_TODOS" d="Todos"}

{t c="TRANS_MANAGE_TODOS" d="Manage Todos"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_DELETE" d="Delete"}

{t c="TRANS_TITLE" d="Title"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_AUTHOR" d="Author"}
{t c="TRANS_ASSIGNED_ADMINS" d="Assigned Admins"}
{t c="TRANS_DATE_DUE" d="Date Due"}
{t c="TRANS_DATE_CREATED" d="Date Created"}

{t c="TRANS_OPEN" d="Open"}
{t c="TRANS_CLOSED" d="Closed"}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

{assign var=todoID value=$todo.todoID}
		<fieldset>
			<legend>{$smarty.const.TRANS_TODO_DETAILS}</legend>
			<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
			<tbody>
			<tr>
				<td colspan="2">{$smarty.const.TRANS_TODOS} <span style="margin-left:70%;"><input class="submit" type="button" onClick="document.location.href='{getHREF page="todos.php" actionName="EditTodo" args="todoID=$todoID"}';" value="{$smarty.const.TRANS_EDIT}" />  <input class="submit" type="button" onClick="document.location.href='{getHREF page="todos.php" actionName="RemoveTodo" args="todoID=$todoID"}';" value="{$smarty.const.TRANS_DELETE}" /></span></td>
			</tr>
			<tr>
				<td class="title"><label for="todoTitle">{$smarty.const.TRANS_TITLE}</label></td>
				<td>{$todo.todoTitle|constant}</td>
			</tr>
			<tr>
				<td class="title"><label for="todoDesc">{$smarty.const.TRANS_DESCRIPTION}</label></td>
				<td>{$todo.todoDesc|nl2br|constant}
				{if $todo.todoLinkFile}
					{assign var=todoLinkFile value=$todo.todoLinkFile}
					{assign var=todoLinkActionName value=$todo.todoLinkActionName}
					{assign var=todoLinkPk value=$todo.todoLinkPk}
					{assign var=todoLinkName value=$todo.todoLinkName}
					<a href="{getHREF page="$todoLinkFile" actionName="$todoLinkActionName" args="$todoLinkName=$todoLinkPk"}">
						<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
					</a>
				{/if}
				</td>
			</tr>
			{if $todo.admins.0}
			<tr>
				<td class="title"><label for="todoAdminID">{$smarty.const.TRANS_AUTHOR}</label></td>
				<td>{$todo.admins.0.adminFirstName} {$todo.admins.0.adminLastName}</td>
			</tr>
			{/if}
			{if $todo.assigned.0}
			<tr>
				<td class="title"><label for="todoAdmin">{$smarty.const.TRANS_ASSIGNED_ADMINS}</label></td>
				<td>{$todo.assigned.0.adminFirstName} {$todo.assigned.0.adminLastName} - {$todo.assigned.0.adminUsername}</td>
			</tr>
			{/if}
			<tr>
				<td class="title"><label for="todoStatusID">{$smarty.const.TRANS_STATUS}</label></td>
				<td>{$todo.todoStatusID|getArrayValueByID:$todostatus}</td>
			</tr>
			<tr>
				<td class="title"><label for="todoDateDue">{$smarty.const.TRANS_DATE_DUE}</label></td>
				<td>{$todo.todoDateDue|getDate:medium}</td>
			</tr>
			<tr>
				<td class="title"><label for="todoDateDue">{$smarty.const.TRANS_DATE_CREATED}</label></td>
				<td>{$todo.todoDateCreated|getDate:medium}</td>
			</tr>
			</tbody>
			</table>
		</div>
{include file="$tplDirectory/footer.tpl"}
