{* $Id: comboBox.tpl 9754 2006-10-23 14:31:34Z bsmith $
 * --------------------------------------------------------------
 * This widget template builds the combo select boxes which allows you to push/pull
 * select options from the left/right box to the right/left box.
 *
 * Smarty Variables:
 *	$comboTitleLeft		The title of the left combat box
 *	$comboNameLeft  	The name of the left select list
 *	$comboOptionsLeft	The left select option values
 *	$comboTitleRight	The title of the right combat box
 *	$comboNameRight  	The name of the right select list
 *	$comboOptionsRight	The right select option values
 *	$useOptionValues	Flag to use the option values instead of the option keys.
 *	$formName			The name of the combo form button
 *	$submitName			The name of the submit button
 *  $positionButtons    Flag to display position buttons or not.
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/comboBox.tpl" }
 *}
{t c="TRANS_SELECT_ALL" d="Select All"}

<table cellpadding="1" cellspacing="1" class="tab07">
<tr>
	<td valign="top" align="center">
		<strong>{strip}
			{if $smarty.const.$comboTitleLeft}
				{$smarty.const.$comboTitleLeft}
			{else}
				{$smarty.const.TRANS_SELECTED}
			{/if}
		{/strip}</strong>
		<br />
	    <select multiple="multiple" size="10" name="{$comboNameLeft}[]" style="width:150px" ondblclick="moveSelectedOptions(document.{$formName}.elements['{$comboNameLeft}[]'],document.{$formName}.elements['{$comboNameRight}[]']);">
			{if $useOptionValues}
				{foreach from=$comboOptionsLeft item=actionName}
					<option label="{$actionName}" value="{$actionName}">{$actionName}</option>
				{/foreach}
			{else}
				{html_options options=$comboOptionsLeft}
			{/if}
		</select>
		<br />
		<input class="button" type="button" onclick="moveAllOptions(document.{$formName}.elements['{$comboNameLeft}[]'],document.{$formName}.elements['{$comboNameRight}[]']);" value="&gt;&gt;" />
		&nbsp;
		<input class="button" type="button" onclick="moveSelectedOptions(document.{$formName}.elements['{$comboNameLeft}[]'],document.{$formName}.elements['{$comboNameRight}[]']);" value="&gt;" />
	</td>
    {if $positionButtons=="yes"}
    <td valign="middle" align="center"><br /><br /><br /><br />
        <input class="button" type="button" onclick="XKmoveUp(document.{$formName}.elements['{$comboNameLeft}[]'])" value=" &uarr; " /><br />
        <input class="button" type="button" onclick="XKmoveDown(document.{$formName}.elements['{$comboNameLeft}[]'])" value=" &darr; " /><br />
    </td>
    {/if}
	<td valign="top" align="center">
		<strong>{strip}
			{if $smarty.const.$comboTitleRight}
				{$smarty.const.$comboTitleRight}
			{else}
				{$smarty.const.TRANS_UNSELECTED}
			{/if}
		{/strip}</strong>
		<br />
		<select multiple="multiple" size="10" name="{$comboNameRight}[]" style="width:150px" ondblclick="moveSelectedOptions(document.{$formName}.elements['{$comboNameRight}[]'],document.{$formName}.elements['{$comboNameLeft}[]']);">
			{if $useOptionValues}
				{foreach from=$comboOptionsRight item=actionName}
					<option label="{$actionName}" value="{$actionName}">{$actionName}</option>
				{/foreach}
			{else}
				{html_options options=$comboOptionsRight}
			{/if}
		</select>
		<br />
		<input class="button" type="button" onclick="moveSelectedOptions(document.{$formName}.elements['{$comboNameRight}[]'],document.{$formName}.elements['{$comboNameLeft}[]']);" value="&lt;" />
		&nbsp;
		<input class="button" type="button" onclick="moveAllOptions(document.{$formName}.elements['{$comboNameRight}[]'],document.{$formName}.elements['{$comboNameLeft}[]']);" value="&lt;&lt;" />
	</td>
</tr>
{if $submitName != "suppress"}
	<tr>
		<td colspan="2" align="center">
			<input class="submit" type="submit" name="submit" value="{$smarty.const.$submitName}" onclick="selectAllOptions(document.{$formName}.elements['{$comboNameLeft}[]']);" />
		</td>
	</tr>
{/if}
</table>