{* $Id: tabbedTable.tpl 10482 2007-01-12 23:17:57Z bsmith $
 * --------------------------------------------------------------
 * This bookmark template displays the admin's bookmarks.
 *
 * Smarty Variables:
 *	
 *	$actionName		The current action name
 *  $sid			The current sessionID
 *
 * Example Usage:
 *  {include file="$tplDirectory/widgets/showBookmarks.tpl"}
 *
 * Author: Brian Smith
 *}
{strip}

{if $table==""}
	{assign var=table value=$data.table}
{/if}

{if !count($tabs)}
	{assign var=tabs value=$data.tabs}
{/if}

{if !count($rows)}
	{assign var=rows value=$data.rows}
{/if}

{if $tableName==""}
	{assign var=tableName value=$table.tableName}
{/if}

{foreach from=$tabs key=key item=it}
	{assign var=tabNames[] value=$key}
{/foreach}

{if $table.defaultTab}
	{assign var=defaultTab value=$table.defaultTab}
{else}
	{foreach from=$tabs key=key item=it name=tabsName}
		{if $smarty.foreach.tabsName.first}
			{assign var=defaultTab value=$key}
		{/if}
	{/foreach}
{/if}

{assign var=tabCount value=count($tabs)}


{/strip}
<script language="javascript">
//<[[CDATA][
{literal}
function tabbedTable_{/literal}{$tableName}{literal}() {
	
	var availTabs = new Array({/literal}{strip}
		{foreach from=$tabs key=key item=it name=tabsName}
			'{$key}'{if !$smarty.foreach.tabsName.last},{/if}
		{/foreach}{/strip}{literal});

	var tabHeights = new Array();
	
	var maxHeight = 0;

	function XKtoggleTab( tabName ) {
		for(var i=0; i<availTabs.length; i++) {
			if (availTabs[ i ] == tabName) {
				toggleOn( tabName );
				document.getElementById(tabName + '_tab').style.backgroundImage = {/literal}"url({$imageDirectory}/bg/greengradient.gif)";{literal}
				document.getElementById(tabName + '_tab').style.borderLeft = '1px solid black';
				document.getElementById(tabName + '_tab').style.borderRight = '1px solid black';
			} else {
				toggleOff( availTabs[ i ] );
				document.getElementById(availTabs[ i ] + '_tab').style.backgroundImage = {/literal}"url({$imageDirectory}/bg/bluegradient.gif)";{literal}
				document.getElementById(availTabs[ i ] + '_tab').style.borderLeft = '';
				document.getElementById(availTabs[ i ] + '_tab').style.borderRight = '';
			}
		}
	}
	this.XKtoggleTab=XKtoggleTab;

	function registerHeight( tabName, h ) {
		for( var i=0; i<availTabs.length; i++ ) {
			if (availTabs[ i ].toString() == tabName.toString()) {
				tabHeights[ tabName.toString() ] = parseInt(h);

				
				if (parseInt(maxHeight) <= parseInt(h)) {
					maxHeight = parseInt(h);
				}
				break;
			}
		}
	}
	this.registerHeight=registerHeight;

	function defineTabWindowHeight() {
		for( var keyValue in tabHeights ) {
			if (document.getElementById( keyValue )) {
				document.getElementById(keyValue).style.height = parseInt(maxHeight)+"px";
			}
		}
	}
	this.defineTabWindowHeight=defineTabWindowHeight;
}
{/literal}

var {$tableName} = new tabbedTable_{$tableName}();

//]]>
</script>
<table class="list" style="background-color:#f3f0f3;border-left:1px inset gray;border-bottom:1px outset gray;border-right:1px outset gray;" cellspacing="0" cellpadding="0" border="0" width="100%" id="{$tableName}_table">
<thead>
<tr class="headerRow" style="cursor:pointer;height:2em;">
	{assign var="i" value=0}
	{foreach from=$tabs key=key item=it name=tabs}
		{assign var=i value=$i+1}
		{assign var=tabDisplayName value=$it.displayName}
		{if $smarty.const.$tabDisplayName}
			{assign var=$tabDisplayName value=$smart.const.$tabDisplayName}
		{/if}
		<td id="{$key}_tab" onClick="{$tableName}.XKtoggleTab('{$key}');">{$tabDisplayName}</td>

		{if !$smarty.foreach.tabs.last}
		{assign var=i value=$i+1}
		<td style="background:white;border-top:0px solid white;border-left:1 px solid gray;border-right:1px solid gray;width:10px;">&nbsp;</td>
		{/if}
	{/foreach}
</tr>
</thead>

{foreach from=$rows key=key item=contents}
	<tbody id="{$key}">
	<tr vAlign="top">
		<td colspan="{$i}">
			{foreach from=$contents item=row}
				{include file="$tplDirectory/widgets/tabbedTable/`$row.dataTemplate`.tpl" data=$row}
			{/foreach}
		</td>
	</tr>
	</tbody>
	<script language="javascript">{$tableName}.registerHeight('{$key}', XKgetHeight('{$key}'));</script>
{/foreach}

</table>

<script language="javascript">{$tableName}.XKtoggleTab('{$defaultTab}');{$tableName}.defineTabWindowHeight();</script>

