{* $Id: listHeaderSort.tpl 7027 2006-05-23 22:26:18Z bsmith $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a generic search box, that when you click on the header name,
 * will only search this column using text!
 *
 * Smarty Variables:
 *	$headerName  	The constant representation of that column name
 *	$fileName		The file name to submit to
 *	$actionID		The current actionID
 *  $sortColumn		The sort column to pass to the sortLinks widget
 *	$sortArgs		The sort arguments to pass to the sortLinks widget
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_X" sortColumn="someColumnName"}
 *}
{t c="TRANS_FIND" d="Find"}
{t c="TRANS_QUICK_FIND" d="Search On"}
{t c="TRANS_SORT_ASC" d="Ascending Sort"}
{t c="TRANS_SORT_DESC" d="Descending Sort"}
{t c="TRANS_ENTER_KEYWORD_OR_ID" d="Enter Keyword/ID"}

{if $fileName==""}
	{assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}

{assign var="newSort" value="asc"}
{assign var="newSortTitle" value=$smarty.const.TRANS_SORT_ASC}
{if $smarty.request.sortDir == "asc"}
	{assign var="newSort" value="desc"}
	{assign var="newSortTitle" value=$smarty.const.TRANS_SORT_DESC}
{/if}

{strip}
{if $smarty.request.sortColumn == $sortColumn}
<td {if $colWidth>0}width="{$colWidth}"{/if} class="$headerClass" nowrap="nowrap">
{else}
<td {if $colWidth>0}width="{$colWidth}"{/if} class="$headerClass" nowrap="nowrap">
{/if}
	<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
		&lt;form method=\'get\' action=\'{$fileName}\'&gt;
			&lt;input type=\'hidden\' name=\'action\' value=\'{$actionID}\' /&gt;
			{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
			{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
            {strip}
			&lt;table border=\'0\' cellspacing=\'0\' cellpadding=\'0\'&gt;
			&lt;tr&gt;
				&lt;td&gt;&lt;img src=\'{$imageDirectory}/ico/data_find.gif\' width=\'16\' height=\'16\' alt=\'\' style=\'margin:0px;\' /&gt;&lt;/td&gt;
                &lt;td colspan=\'2\'&gt;
                    &nbsp;&nbsp;&lt;strong&gt;{$smarty.const.TRANS_SEARCH_BY}: {$smarty.const.TRANS_KEYWORD_OR_ID}&lt;/strong&gt;
                &lt;/td&gt;
            &lt;/tr&gt;
			&lt;tr&gt;
                &lt;td&gt;&nbsp;&lt;/td&gt;
				&lt;td&gt;&lt;input type=\'text\' name=\'query\' value=\'\' class=\'input\' /&gt;&lt;/td&gt;
				&lt;td width=\'13\'&gt;&lt;input type=\'image\' src=\'{$imageDirectory}/ico/030.gif\' size=\'13\' alt=\'\' /&gt;&lt;/td&gt;
			&lt;/tr&gt;
			&lt;/table&gt;
            {/strip}
			&lt;input type=\'hidden\' name=\'queryColumn\' value=\'{$sortColumn}\' /&gt;
			&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
            {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		&lt;/form&gt;&lt;/div&gt;',
		BGCLASS, 'popupBG',
		FGCLASS, 'popupFG',
		CENTER, STICKY,
		CAPTION, '&nbsp;{$smarty.const.TRANS_QUICK_FIND}: {$smarty.const.$headerName}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
		<img src="{$imageDirectory}/ico/quicksearch.gif" border="0" alt="{$smarty.const.TRANS_SEARCH}" title="{$smarty.const.TRANS_SEARCH}" />
	</a>
	&nbsp;
	<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=$newSort"}" title="{$newSortTitle}">
		<b>{$smarty.const.$headerName}</b>
	</a>
</td>
{if $addEmptyTD}
<td>&nbsp;</td>
{/if}
{/strip}