{t c="TRANS_PLESK_ATTR_GROUP__DISK_SPACE_TRAFFIC" d="Disk Space and Traffic"}
{t c="TRANS_PLESK_ATTR_GROUP__DOMAINS" d="Domains"}
{t c="TRANS_PLESK_ATTR_GROUP__MAIL" d="Mail"}
{t c="TRANS_PLESK_ATTR_GROUP__DATABASES" d="Databases"}
{t c="TRANS_PLESK_ATTR_GROUP__APPLICATIONS" d="Applications"}
{t c="TRANS_PLESK_ATTR_GROUP__SECURITY" d="Security"}

{t c="TRANS_PLESK_ATTR___DISK_SPACE" d="Disk Space"}
{t c="TRANS_PLESK_ATTR___TRAFFIC" d="Traffic"}

{t c="TRANS_PLESK_ATTR___DOMAINS" d="Domain(s)"}
{t c="TRANS_PLESK_ATTR___SUBDOMAINS" d="Sub domain(s)"}
{t c="TRANS_PLESK_ATTR___DOMAINALIASES" d="Domain alias(es)"}
{t c="TRANS_PLESK_ATTR___WEBUSERS" d="Web user(s)"}
{t c="TRANS_PLESK_ATTR___FTPACCOUNTS" d="FTP account(s)"}
{t c="TRANS_PLESK_ATTR___FPACCOUNTS" d="FrontPage account(s)"}

{t c="TRANS_PLESK_ATTR___MAILBOXES" d="Mailbox(es)"}
{t c="TRANS_PLESK_ATTR___MAILBOXQUOTA" d="Mailbox quota"}
{t c="TRANS_PLESK_ATTR___TOTAL_MAILBOXQUOTA" d="Total mailbox quota"}
{t c="TRANS_PLESK_ATTR___MAILREDIRECTS" d="Mail redirect(s)"}
{t c="TRANS_PLESK_ATTR___MAILAUTORESPONDERS" d="Autoresponder(s)"}
{t c="TRANS_PLESK_ATTR___MAILLISTS" d="Mailing list(s)"}
{t c="TRANS_PLESK_ATTR___MAILGROUPS" d="Mail group(s)"}
{t c="TRANS_PLESK_ATTR___MSSQLDB" d="Microsoft SQL databas(es)"}
{t c="TRANS_PLESK_ATTR___MYSQLDB" d="MySQL databas(es)"}
{t c="TRANS_PLESK_ATTR___IISAPPPOOLS" d="IIS applications pool(s)"}
{t c="TRANS_PLESK_ATTR___SHAREDSSLLINKS" d="Shared SSl link(s)"}

{php}

define('SIZE_GB', 1073741824);
define('SIZE_MB', 1048576);
define('SIZE_OTHER', 1);

function getDetailedAttributes($productInfo) {
	$map_size_name = array(
		SIZE_GB => 'GB',
		SIZE_MB => 'MB',
		SIZE_OTHER => ''
	);
	$result = array(
		'TRANS_PLESK_ATTR_GROUP__DISK_SPACE_TRAFFIC' => array(
			array(
				'name' => 'clientDiskSpace',
				'unit_size' => SIZE_GB,
				'unit_name' => $map_size_name[SIZE_GB],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___DISK_SPACE'
			),
			array(
				'name' => 'clientMaxTraffic',
				'unit_size' => SIZE_GB,
				'unit_name' => $map_size_name[SIZE_GB],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___TRAFFIC'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__DOMAINS' => array(
			array(
				'name' => 'clientMaxDomains',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___DOMAINS'
			),
			array(
				'name' => 'clientMaxSubdomains',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___SUBDOMAINS'
			),
			array(
				'name' => 'clientMaxDomainAliases',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___DOMAINALIASES'
			),
			array(
				'name' => 'clientMaxWebusers',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___WEBUSERS'
			),
			array(
				'name' => 'clientMaxFTPAccounts',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___FTPACCOUNTS'
			),
			array(
				'name' => 'clientMaxFPAccounts',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___FPACCOUNTS'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__MAIL' => array(
			array(
				'name' => 'clientMaxMailbox',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILBOXES'
			),
			array(
				'name' => 'clientMailBoxQuota',
				'unit_size' => SIZE_MB,
				'unit_name' => $map_size_name[SIZE_MB],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILBOXQUOTA'
			),
			array(
				'name' => 'clientTotalMailBoxQuota',
				'unit_size' => SIZE_MB,
				'unit_name' => $map_size_name[SIZE_MB],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___TOTAL_MAILBOXQUOTA'
			),
			array(
				'name' => 'clientMaxMailredirects',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILREDIRECTS'
			),
			array(
				'name' => 'clientMaxMailAutoresponders',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILAUTORESPONDERS'
			),
			array(
				'name' => 'clientMaxMaillists',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILLISTS'
			),
			array(
				'name' => 'clientMaxMailGroups',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MAILGROUPS'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__DATABASES' => array(
			array(
				'name' => 'clientMaxMSSQLDB',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MSSQLDB'
			),
			array(
				'name' => 'clientMaxMYSQLDB',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___MYSQLDB'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__APPLICATIONS' => array(
			array(
				'name' => 'clientMaxIISAPPPools',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___IISAPPPOOLS'
			),
		),
		'TRANS_PLESK_ATTR_GROUP__SECURITY' => array(
			array(
				'name' => 'clientMaxSharedSSLLinks',
				'unit_size' => SIZE_OTHER,
				'unit_name' => $map_size_name[SIZE_OTHER],
				'data' => 0,
				'title' => 'TRANS_PLESK_ATTR___SHAREDSSLLINKS'
			),
		)
	);
	foreach (array_keys($result) as $group_id) {
		foreach (array_keys($result[$group_id]) as $attr_id) {
			$result[$group_id][$attr_id]['data'] = $productInfo['keyedAttributes'][$result[$group_id][$attr_id]['name']];
		}
	}
	return $result;
}
{/php}
