<?php
// $Id: types.php 12225 2007-11-14 18:06:30Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2007 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

/**
 * This file maintains "type" constants and their helper functions.
 *
 * DO NOT ADD APPLICATION SPECIFC TYPES TO THIS FILE UNLESS THEY ARE
 * SHARED BY ALL MBAPI APPLICATIONS!
 *
 * Application specifc types should be located here:
 *
 * /lib-APPLICATION/include/config/internal/types.php
 */

$CONF["types"] = array();
$CONF["APItypes"] = array();

$CONF["types"]["DBDriver"] = array();
$CONF["types"]["DBDriver"][0] = TRANS_MYSQL;
$CONF["types"]["DBDriver"][1] = TRANS_MYSQLI;
$CONF["types"]["DBDriver"][2] = TRANS_POSTGRES7;
$CONF["types"]["DBDriver"][3] = TRANS_POSTGRES8;
$CONF["types"]["DBDriver"][4] = TRANS_ORACLE;
$CONF["types"]["DBDriver"][5] = TRANS_MSSQL;

$CONF["APItypes"]["DBDriver"] = array();
$CONF["APItypes"]["DBDriver"][0] = "mysql";
$CONF["APItypes"]["DBDriver"][1] = "mysqli";
$CONF["APItypes"]["DBDriver"][2] = "postgres7";
$CONF["APItypes"]["DBDriver"][3] = "postgres8";
$CONF["APItypes"]["DBDriver"][4] = "oci8po";
$CONF["APItypes"]["DBDriver"][5] = "mssql";

$CONF["types"]["paramInput"] = array();
$CONF["types"]["paramInput"]["h"] = TRANS_HIDDEN;
$CONF["types"]["paramInput"]["t"] = TRANS_TEXT;
$CONF["types"]["paramInput"]["p"] = TRANS_PASSWORD;
$CONF["types"]["paramInput"]["a"] = TRANS_TEXTAREA;
$CONF["types"]["paramInput"]["s"] = TRANS_SELECT;
$CONF["types"]["paramInput"]["s"] = TRANS_MULTISELECT;
$CONF["types"]["paramInput"]["c"] = TRANS_CHECKBOXES;
$CONF["types"]["paramInput"]["r"] = TRANS_RADIO_BUTTONS;

$CONF["APItypes"]["paramInput"] = array();
$CONF["APItypes"]["paramInput"]["h"] = "hidden";
$CONF["APItypes"]["paramInput"]["t"] = "text";
$CONF["APItypes"]["paramInput"]["p"] = "password";
$CONF["APItypes"]["paramInput"]["a"] = "textarea";
$CONF["APItypes"]["paramInput"]["s"] = "select";
$CONF["APItypes"]["paramInput"]["s"] = "multiselect";
$CONF["APItypes"]["paramInput"]["c"] = "checkbox";
$CONF["APItypes"]["paramInput"]["r"] = "radio";

$CONF["types"]["user"] = array();
$CONF["types"]["user"][0] = TRANS_PUBLIC_USER;
$CONF["types"]["user"][1] = TRANS_CLIENT_USER;
$CONF["types"]["user"][2] = TRANS_ADMIN_USER;

$CONF["APItypes"]["user"] = array();
$CONF["APItypes"]["user"][0] = "public";
$CONF["APItypes"]["user"][1] = "client";
$CONF["APItypes"]["user"][2] = "admin";

$php_options = get_loaded_extensions();
$CONF["types"]["crypt"] = array();
$CONF["types"]["crypt"][0] = TRANS_CRYPT_BLOWFISH;
if(in_array("mcrypt",$php_options)) {
	$CONF["types"]["crypt"][1] = TRANS_CRYPT_3DES;
	$CONF["types"]["crypt"][2] = TRANS_CRYPT_TWOFISH;
	$CONF["types"]["crypt"][3] = TRANS_CRYPT_TWOFISH128;
	$CONF["types"]["crypt"][4] = TRANS_CRYPT_TWOFISH192;
	$CONF["types"]["crypt"][5] = TRANS_CRYPT_TWOFISH256;
	$CONF["types"]["crypt"][6] = TRANS_CRYPT_RIJNDAEL_128;
	$CONF["types"]["crypt"][7] = TRANS_CRYPT_RIJNDAEL_192;
	$CONF["types"]["crypt"][8] = TRANS_CRYPT_RIJNDAEL_256;
}

$CONF["APItypes"]["crypt"] = array();
$CONF["APItypes"]["crypt"][0] = TRANS_CRYPT_BLOWFISH;
if(in_array("mcrypt",$php_options)) {
	$CONF["APItypes"]["crypt"][1] = "3des";
	$CONF["APItypes"]["crypt"][2] = "twofish";
	$CONF["APItypes"]["crypt"][3] = "twofish128";
	$CONF["APItypes"]["crypt"][4] = "twofish192";
	$CONF["APItypes"]["crypt"][5] = "twofish256";
	$CONF["APItypes"]["crypt"][6] = "rijndael128";
	$CONF["APItypes"]["crypt"][7] = "rijndael192";
	$CONF["APItypes"]["crypt"][8] = "rijndael256";
}

/**
 * class for handling types
 */
class TypeOf {
	/**
	 * string  type
	 */
	var $type;

	/**
	 * string  interface
	 */
	var $interface;

	/**
	 * constructor
	 *
	 * @param  string  type
	 * @param  boolean  whether to use API names rather than display names
	 */
	function TypeOf($type, $api = false) {
		$this->type = $type;
		$this->interface = $api ? "APItypes" : "types";
	}

	/**
	 * id by name
	 *
	 * @param  string  name
	 * @return  int  id
	 */
	function id($name) {
		global $CONF;
		return isset($CONF[$this->interface][$this->type]) ? array_search($name, $CONF[$this->interface][$this->type]) : false;
	}

	/**
	 * name by id
	 *
	 * @param  int  id
	 * @return  string  name
	 */
	function name($id) {
		global $CONF;
		return isset($CONF[$this->interface][$this->type][$id]) ? $CONF[$this->interface][$this->type][$id] : false;
	}

	/**
	 * HTML options
	 *
	 * @return  array  of associated names by ID
	 */
	function options() {
		global $CONF;
		return  isset($CONF[$this->interface][$this->type]) ? $CONF[$this->interface][$this->type] : array();
	}

	/**
	 * multi-select HTML options 
	 *
	 * @ return  array  list($selected, $selectable)
	 */
	function select($IDs = array()) {
		global $CONF;
		$selected = $selectable = array();
		foreach($this->options() as $id => $name) {
			if(in_array($id, $IDs)) {
				$selected[$id] = $name;
			} else {
				$selectable[$id] = $name;
			}
		}
		return array($selected, $selectable);
	}
}

/**
 * get type ID from name
 *
 * @param  string  type
 * @param  string  name
 * @return  int  ID
 */
function getTypeID($type, $name) {
	$t =& new TypeOf($type);
	return $t->id($name);
}

/**
 * get type name from ID
 *
 * @param  string  type
 * @param  int  ID
 * @return  string  name
 */
function getTypeName($type, $id) {
	$t =& new TypeOf($type);
	return $t->name($id);
}

/**
 * get type options
 *
 * @param  string  type
 * @return  array  of associated names by ID
 */
function getTypes($type) {
	$t =& new TypeOf($type);
	return $t->options();
}

/**
 * get API type ID from name
 *
 * @param  string  type
 * @param  string  name
 * @return  int  ID
 */
function getAPITypeID($type, $name) {
	$t =& new TypeOf($type, true);
	return $t->id($name);
}

/**
 * get API type name from ID
 *
 * @param  string  type
 * @param  int  ID
 * @return  string  name
 */
function getAPITypeName($type, $id) {
	$t =& new TypeOf($type, true);
	return $t->name($id);
}

/**
 * get API type options
 *
 * @param  string  type
 * @return  array  of associated names by ID
 */
function getAPITypes($type) {
	$t =& new TypeOf($type, true);
	return $t->options();
}

?>
