<?php
// $Id: mbapimap.php 12281 2007-11-27 15:40:21Z bwoolley $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-tk/functions.php");

defineFlags(
	"COLUMN",
	array(
		"IS_SORTABLE_DEFAULT",
		"IS_SORTABLE",
		"IS_SEARCHABLE",
		"ORDERED",
		"BOOL",
		"INT",
		"STRING",
		"FLOAT",
		"PASSWORD",
		"ENCRYPT",
		"IS_DATE",
		"IS_AMOUNT",
		"KEY",
		"PRIOR_KEY",
		"NAME",
		"CONSTANT",
		"IS_HISTORICAL",
		"IS_ACTIVE",
		"IS_TYPE",
		"IS_STATUS",

		"IS_EDITABLE",
		"IS_DISPLAYABLE",
		"IS_LISTABLE",
		"HAS_FOREIGN_NAME",
		"IS_QUICK_EDITABLE",
		"IS_SERIALIZED_DATA",
		"LOWERCASE",
		"UPPERCASE",

		// action access control
		"RESTRICT_SHOW",
		"RESTRICT_EDIT",
		"RESTRICT_ADD",
		"RESTRICT_REMOVE",
		"RESTRICT_MODIFY",
		"RESTRICT_DETAILS"
	)
);
define("COLUMN_INTEGER", COLUMN_INT);

define("COLUMN_SORTABLE", COLUMN_IS_SORTABLE|COLUMN_ORDERED);
define("COLUMN_SEARCHABLE", COLUMN_IS_SEARCHABLE|COLUMN_SORTABLE);
define("COLUMN_SORTABLE_DEFAULT", COLUMN_IS_SORTABLE_DEFAULT|COLUMN_ORDERED);

define("COLUMN_SEARCHABLE_INTEGER", COLUMN_SEARCHABLE|COLUMN_INT);
define("COLUMN_SEARCHABLE_STRING", COLUMN_SEARCHABLE|COLUMN_STRING);
define("COLUMN_SEARCHABLE_FLOAT", COLUMN_SEARCHABLE|COLUMN_FLOAT);

define("COLUMN_DATE", COLUMN_SEARCHABLE_INTEGER|COLUMN_IS_DATE);
define("COLUMN_AMOUNT", COLUMN_SEARCHABLE_FLOAT|COLUMN_IS_AMOUNT);

define("COLUMN_ID", COLUMN_SORTABLE|COLUMN_SEARCHABLE_INTEGER);
define("COLUMN_DEFAULT_ID", COLUMN_SORTABLE_DEFAULT|COLUMN_SEARCHABLE_INTEGER);

define("COLUMN_TEXT", COLUMN_SORTABLE|COLUMN_SEARCHABLE_STRING);

define("COLUMN_TYPE", COLUMN_IS_TYPE);
define("COLUMN_STATUS", COLUMN_IS_STATUS);

define("COLUMN_PRIMARY_KEY", COLUMN_KEY|COLUMN_DEFAULT_ID);
define("COLUMN_PRIOR_PRIMARY_KEY", COLUMN_PRIOR_KEY|COLUMN_ID);
define("COLUMN_PRIMARY_NAME", COLUMN_NAME|COLUMN_TEXT);

define("COLUMN_TRANSLATION_MESSAGE", COLUMN_TEXT|COLUMN_CONSTANT);

define("COLUMN_ACTIVE", COLUMN_BOOL|COLUMN_IS_ACTIVE);
define("COLUMN_HISTORICAL", COLUMN_BOOL|COLUMN_IS_HISTORICAL);

define("COLUMN_EDITABLE", COLUMN_IS_EDITABLE);
define("COLUMN_DISPLAYABLE", COLUMN_IS_DISPLAYABLE);
define("COLUMN_LISTABLE", COLUMN_IS_LISTABLE);
define("COLUMN_SERIALIZED_DATA", COLUMN_IS_SERIALIZED_DATA);

define("COLUMN_SEARCHABLE_INT", COLUMN_SEARCHABLE_INTEGER);
define("COLUMN_SEARCHABLE_STR", COLUMN_SEARCHABLE_STRING);

defineOptions(
	"PARAM_MODE",
	array(
		"INCLUSIVE",
		"EXCLUSIVE",
	)
);

defineOptions(
	"PARAM_TYPE",
	array(
		"PLAIN",
		"CALLBACK",
	)
);

function mapColumnRestriction($col, &$mode) {
	// set mode
	$show = (bool) ($mode & ACTION_MODE_SHOW);
	$add = (bool) ($mode & ACTION_MODE_ADD);
	$edit = (bool) ($mode & ACTION_MODE_EDIT);

	$remove = (bool) ($mode & ACTION_MODE_REMOVE);
	$details = (bool) ($mode & ACTION_MODE_DETAILS);

	$response = (bool) ($mode & ACTION_MODE_RESPONSE);
	$insert = ($mode == (ACTION_MODE_ADD|ACTION_MODE_RESPONSE));
	$update = ($mode == (ACTION_MODE_EDIT|ACTION_MODE_RESPONSE));


	// perhaps this should be static
	$columnRestrictionMap = array(
		COLUMN_INT => INPUT_RESTRICTION_INT,
		COLUMN_STRING => INPUT_RESTRICTION_STRING,
		COLUMN_FLOAT => INPUT_RESTRICTION_DOUBLE,
		COLUMN_BOOL => INPUT_RESTRICTION_BOOL,
		COLUMN_ID => INPUT_RESTRICTION_POSITIVE_INT,
		COLUMN_IS_AMOUNT => INPUT_RESTRICTION_PRICE,
		COLUMN_IS_DATE => INPUT_RESTRICTION_UNSIGNED_INT,
		COLUMN_IS_TYPE => INPUT_RESTRICTION_TYPE,
		COLUMN_IS_STATUS => INPUT_RESTRICTION_STATUS,
		COLUMN_PASSWORD => INPUT_RESTRICTION_PASSWORD,
	);

	$isRequired = true;
	$restriction = 0;
	foreach($columnRestrictionMap as $columnFlags => $restrictionFlags) {
		/*
		echo '<pre>{';
		print_r($columnFlags);
		echo '|';
		print_r($restrictionFlags);
		echo '=';
		print_r($col & $columnFlags);
		echo '|' . (int)($col & $columnFlags && ($col & $columnFlags) === $columnFlags);
		echo '}</pre>';
		*/

		if(binEq(($col & $columnFlags), $columnFlags)) {
			$restriction |= $restrictionFlags;
		}

		if ($show && bitBool($col & COLUMN_RESTRICT_SHOW)) {
			$isRequired = true;
		} elseif ($add && bitBool($col & COLUMN_RESTRICT_ADD)) {
			$isRequired = true;
		} elseif ($edit && bitBool($col & COLUMN_RESTRICT_EDIT)) {
			$isRequired = true;

		} elseif (($edit || $add) && bitBool($col & COLUMN_RESTRICT_MODIFY)) {
			$isRequired = true;

		} elseif ($remove && bitBool($col & COLUMN_RESTRICT_REMOVE)) {
			$isRequired = true;
		} elseif ($details && bitBool($col & COLUMN_RESTRICT_DETAILS)) {
		 	$isRequired = true;

		} elseif (($reponse || $insert || $update) && (bitBool($col & COLUMN_RESTRICT_EDIT) || bitBool($col & COLUMN_RESTRICT_ADD)) && bitBool($col & COLUMN_RESTRICT_MODIFY)) {
			$isRequired = true;

		} else {
			$isRequired = false;
		}
	}
	return array($restriction, $isRequired);
}

function baseMap($table, $file, $plural, $singular, $relationalForm = array()) {
	// XXX TODO: $source param for subCommands
	$file = (is_string($file) && $file) ? $file : $plural;
	return array(
		"names" => array(
			"singular" => $singular,
			"plural" => $plural,
			"file" => $file,
		),
		"request" => array(
			"command" => "GetData",
			"subCommand" => $plural,
			"params" => array(),
		),
		"response" => array(
			'path' => array($plural, $singular),
		),
		"insert" => array(
			"command" => "SetData",
			"subCommand" => "insert:${plural}",
			"params" => array(),
		),
		"update" => array(
			"command" => "SetData",
			"subCommand" => "update:${plural}",
			"params" => array(),
		),
		"clone" => array(
			"command" => "SetData",
			"subCommand" => "clone:${plural}",
			"params" => $relationalForm,
		),
		"delete" => array(
			"command" => "SetData",
			"subCommand" => "delete:${plural}",
			"params" => $relationalForm,
		),
		"table" => $table,
	);
}

function processMap($command, $subCommand, $path) {
	return array(
		"names" => array(
			"singular" => $singular,
			"plural" => $plural,
		),
		"request" => array(
			"request" => array(
				"command" => $command,
				"subCommand" => $subCommand,
			),
			"response" => array(
				"path" => (array) $path,
			),
		),
	);
}

/**
 * Param class for mapping action arguments to Set* command parameters. This acts as a sort of param macro.
 */
class Param {
	/**
	 * array  of params
	 */
	var $params;

	/**
	 * int  of a mode option
	 */
	var $mode;

	/**
	 * int  of a type option
	 */
	var $type;

	/**
	 * int  bitmask of input restrictions, to override the default specified in $CONF['columnRestrictionMap']
	 */
	var $restriction;

	/**
	 * callback  for manipulating the request before it gets inserted
	 */
	var $callback;

	/**
	 * constructor
	 *
	 * @param  array  of params
	 * @param  int  of a mode option
	 * @param  int  of a type option
	 * @param  int  bitmast of input restrictions
	 * @param  callback  for manipulating the request before it gets inserted
	 */
	function Param($params = array(), $mode = PARAM_MODE_INCLUSIVE, $type = PARAM_TYPE_PLAIN, $restriction = NULL, $callback = NULL) {
		$this->params = (array) $params;
		$this->mode = $mode;
		$this->type = $type;
		$this->restriction = $restriction;
		$this->callback = $callback;
	}

	/**
	 * get a list of params
	 *
	 * @return  array  of params
	 */
	function getParams() {
		return $this->params;
	}

	/**
	 * get restriction bitmask
	 *
	 * @return  int  bitmastk of input retrictions
	 */
	function getRestriction() {
		return $this->restriction;
	}
}

/**
 * Class to hold param structure (array) with Param objects, and to resolve the Param object macros for inserting into am MBQuery object.
 */
class Params {
	/**
	 * array  param structure with Param objects
	 */
	var $params;

	/**
	 * array  argument values for processing Param macros
	 */
	var $args;

	/**
	 * DataSource  which these params are for
	 */
	var $d;

	/**
	 * constructor
	 *
	 * @param  array  of param structure
	 * @param  array  of args for the macros
	 */
	function Params($params = array(), $args = array()) {
		$this->params = (array) $params;
		$this->args = (array) $args;
	}

	/**
	 *  get argument values
	 *
	 * @return  array  of argument values for processing Param macros
	 */
	function getArgs() {
		return $this->args;
	}

	/**
	 * set argument values
	 *
	 * @param  array  of argument values for processing Param macros
	 */
	function setArgs($args) {
		$this->args = $args;
	}

	/**
	 * get the data source used for column information
	 *
	 * @return  DataSource  used for column information
	 */
	function getDataSource() {
		return $this->d;
	}

	/**
	 * set the data source used for column information
	 *
	 * @param  DataSource  used for column information
	 */
	function setDataSource(&$d) {
		$this->d =& $d;
	}

	/**
	 * process the Param macros and return the results
	 *
	 * @return  array  of params for MBQuery.
	 */
	function getResolvedParams() {
	}
}

$allParams =& new Param(array(), PARAM_MODE_EXCLUSIVE);
$allParamsRoot =& new Params($allParams);
global $allParams, $allParamsRoot;

require_once mb_path("/lib-tk/include/validator/validator.php");

?>
