-- MySQL dump 10.11
--
-- Host: localhost    Database: mb5
-- ------------------------------------------------------
-- Server version	5.0.45-Debian_1ubuntu3.3-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `accounting_control_rel`
--

DROP TABLE IF EXISTS `accounting_control_rel`;
CREATE TABLE `accounting_control_rel` (
  `general_ledger_id` int(10) unsigned NOT NULL default '0',
  `control_type` smallint(5) unsigned NOT NULL default '0',
  `control_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`general_ledger_id`,`control_type`,`control_id`)
);

--
-- Dumping data for table `accounting_control_rel`
--

LOCK TABLES `accounting_control_rel` WRITE;
/*!40000 ALTER TABLE `accounting_control_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounting_control_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_general_journal`
--

DROP TABLE IF EXISTS `accounting_general_journal`;
CREATE TABLE `accounting_general_journal` (
  `general_journal_id` int(10) unsigned NOT NULL auto_increment,
  `general_date_created` int(10) unsigned default NULL,
  `general_description` varchar(255) default NULL,
  `general_debit_amount` decimal(10,2) unsigned default '0.00',
  `general_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`general_journal_id`),
  KEY `purchase_date_created` (`general_date_created`),
  KEY `currency_id` (`currency_id`)
);

--
-- Dumping data for table `accounting_general_journal`
--

LOCK TABLES `accounting_general_journal` WRITE;
/*!40000 ALTER TABLE `accounting_general_journal` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounting_general_journal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_general_ledger`
--

DROP TABLE IF EXISTS `accounting_general_ledger`;
CREATE TABLE `accounting_general_ledger` (
  `general_ledger_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `journal_table_id` int(10) unsigned default NULL,
  `journal_table_name` varchar(100) default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `general_ledger_date_created` int(10) unsigned default NULL,
  `general_ledger_description` varchar(255) default NULL,
  `general_ledger_debit_amount` decimal(10,2) unsigned default '0.00',
  `general_ledger_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`general_ledger_id`),
  KEY `client_id` (`client_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `journal_table_id` (`journal_table_id`),
  KEY `journal_table_name` (`journal_table_name`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `general_ledger_date_created` (`general_ledger_date_created`),
  KEY `currency_id` (`currency_id`)
);

--
-- Dumping data for table `accounting_general_ledger`
--

LOCK TABLES `accounting_general_ledger` WRITE;
/*!40000 ALTER TABLE `accounting_general_ledger` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounting_general_ledger` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_ledger_accounts`
--

DROP TABLE IF EXISTS `accounting_ledger_accounts`;
CREATE TABLE `accounting_ledger_accounts` (
  `ledger_account_id` smallint(5) unsigned NOT NULL auto_increment,
  `parent_ledger_account_id` smallint(5) unsigned default '0',
  `ledger_account_number` int(10) unsigned default NULL,
  `ledger_account_type` tinyint(3) default NULL,
  `ledger_account_name` varchar(50) default NULL,
  `ledger_account_trans_key` varchar(255) default NULL,
  PRIMARY KEY  (`ledger_account_id`),
  KEY `ledger_account_number` (`ledger_account_number`),
  KEY `ledger_account_type` (`ledger_account_type`),
  KEY `parent_ledger_account_id` (`parent_ledger_account_id`)
) AUTO_INCREMENT=41;

--
-- Dumping data for table `accounting_ledger_accounts`
--

LOCK TABLES `accounting_ledger_accounts` WRITE;
/*!40000 ALTER TABLE `accounting_ledger_accounts` DISABLE KEYS */;
INSERT INTO `accounting_ledger_accounts` VALUES (1,0,10000,1,'cash','TRANS_CASH'),(2,0,10010,1,'cash_1','TRANS_CASH_1'),(3,0,10020,1,'cash_2','TRANS_CASH_2'),(4,0,11000,1,'accounts_receivable','TRANS_ACCOUNTS_RECEIVABLE'),(5,0,11500,1,'authorized_payments','TRANS_AUTHORIZED_PAYMENTS'),(6,0,12000,1,'hardware_assets','TRANS_HARDWARE_ASSETS'),(7,0,13001,1,'deferred_charge','TRANS_DEFERRED_CHARGES'),(8,0,20000,2,'accounts_payable','TRANS_ACCOUNTS_PAYABLE'),(9,0,20001,2,'deferred_revenue','TRANS_DEFERRED_REVENUE'),(10,0,21000,2,'domains_payable','TRANS_DOMAINS_PAYABLE'),(11,0,22000,2,'certs_payable','TRANS_CERTS_PAYABLE'),(12,0,25000,2,'customer_credits','TRANS_CUSTOMER_CREDITS'),(13,0,27000,2,'affiliate_commissions_payable','TRANS_AFFILIATE_COMMISSIONS_PAYABLE'),(14,0,29000,2,'taxes_payable','TRANS_TAXES_PAYABLE'),(15,0,30000,3,'equity','TRANS_EQUITY'),(16,0,40000,4,'revenue','TRANS_REVENUE'),(17,0,40099,4,'coupon_revenue','TRANS_COUPON_REVENUE'),(18,0,49000,4,'currency_income','TRANS_CURRENCY_CONVERSION_INCOME'),(19,0,50000,5,'cogs','TRANS_COGS'),(20,0,51000,5,'domain_cogs','TRANS_DOMAIN_COGS'),(21,0,52000,5,'certs_cogs','TRANS_CERTS_COGS'),(22,0,53000,5,'setup_cogs','TRANS_SETUP_COGS'),(23,0,54000,5,'usage_cogs','TRANS_USAGE_COGS'),(24,0,60000,6,'expense','TRANS_EXPENSE'),(25,0,60200,6,'gateway_fees','TRANS_GATEWAY_FEES'),(26,0,60300,6,'paypal_fees','TRANS_PAYPAL_FEES'),(27,0,60500,6,'coupon_expense','TRANS_COUPON_EXPENSE'),(28,0,61000,6,'refund_expense','TRANS_REFUND_EXPENSE'),(29,0,62000,6,'customer_expense','TRANS_CUSTOMER_EXPENSE'),(30,0,65000,6,'wages_expense','TRANS_WAGES_EXPENSE'),(31,0,65010,6,'entertainment_expense','TRANS_ENTERTAINMENT_EXPENSE'),(32,0,65020,6,'rent_expense','TRANS_RENT_EXPENSE'),(33,0,65030,6,'travel_expense','TRANS_TRAVEL_EXPENSE'),(34,0,65040,6,'commissions_expense','TRANS_COMMISSIONS_EXPENSE'),(35,0,65050,6,'income_tax_expense','TRANS_INCOME_TAX_EXPENSE'),(36,0,66000,6,'depreciation_expense','TRANS_DEPRECIATION_EXPENSE'),(37,0,66010,6,'colocation_expense','TRANS_COLOCATION_EXPENSE'),(38,0,66020,6,'hardware_lease_expense','TRANS_HARDWARE_LEASE_EXPENSE'),(39,0,67000,6,'affiliate_commissions_expense','TRANS_AFFILIATE_COMMISSIONS'),(40,0,69000,6,'currency_expense','TRANS_CURRENCY_CONVERSION_EXPENSE');
/*!40000 ALTER TABLE `accounting_ledger_accounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_ledger_groups`
--

DROP TABLE IF EXISTS `accounting_ledger_groups`;
CREATE TABLE `accounting_ledger_groups` (
  `ledger_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `ledger_group_name` varchar(255) default NULL,
  PRIMARY KEY  (`ledger_group_id`)
);

--
-- Dumping data for table `accounting_ledger_groups`
--

LOCK TABLES `accounting_ledger_groups` WRITE;
/*!40000 ALTER TABLE `accounting_ledger_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounting_ledger_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_purchases_journal`
--

DROP TABLE IF EXISTS `accounting_purchases_journal`;
CREATE TABLE `accounting_purchases_journal` (
  `purchase_journal_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `line_item_id` int(10) unsigned default NULL,
  `purchase_date_created` int(10) unsigned default NULL,
  `purchase_description` varchar(255) default NULL,
  `purchase_debit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_credit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_acc_pay_debit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_acc_pay_credit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_cash_debit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_cash_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`purchase_journal_id`),
  KEY `client_id` (`client_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `purchase_date_created` (`purchase_date_created`),
  KEY `currency_id` (`currency_id`),
  KEY `line_item_id` (`line_item_id`)
);

--
-- Dumping data for table `accounting_purchases_journal`
--

LOCK TABLES `accounting_purchases_journal` WRITE;
/*!40000 ALTER TABLE `accounting_purchases_journal` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounting_purchases_journal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_receipts_journal`
--

DROP TABLE IF EXISTS `accounting_receipts_journal`;
CREATE TABLE `accounting_receipts_journal` (
  `receipt_journal_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `transaction_id` int(10) unsigned default NULL,
  `receipt_date_created` int(10) unsigned default NULL,
  `receipt_description` varchar(255) default NULL,
  `receipt_cash_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_cash_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_acc_rec_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_acc_rec_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_sales_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_sales_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_tax_pay_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_tax_pay_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_coupon_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_coupon_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`receipt_journal_id`),
  KEY `client_id` (`client_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `transaction_id` (`transaction_id`),
  KEY `receipt_date_created` (`receipt_date_created`),
  KEY `currency_id` (`currency_id`)
);

--
-- Dumping data for table `accounting_receipts_journal`
--

LOCK TABLES `accounting_receipts_journal` WRITE;
/*!40000 ALTER TABLE `accounting_receipts_journal` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounting_receipts_journal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_group_action_rel`
--

DROP TABLE IF EXISTS `admin_group_action_rel`;
CREATE TABLE `admin_group_action_rel` (
  `admin_group_id` smallint(5) unsigned NOT NULL default '0',
  `action_name` varchar(90) NOT NULL default '',
  PRIMARY KEY  (`admin_group_id`,`action_name`)
);

--
-- Dumping data for table `admin_group_action_rel`
--

LOCK TABLES `admin_group_action_rel` WRITE;
/*!40000 ALTER TABLE `admin_group_action_rel` DISABLE KEYS */;
INSERT INTO `admin_group_action_rel` VALUES (1,'ActivatePackage'),(1,'ActivatePackageAddon'),(1,'ActivatePackageResponse'),(1,'AddAdmin'),(1,'AddAdminGroup'),(1,'AddAdminGroupResponse'),(1,'AddAdminResponse'),(1,'AddAttribute'),(1,'AddAttributeGroup'),(1,'AddAttributeGroupResponse'),(1,'AddAttributeMap'),(1,'AddAttributeMapping'),(1,'AddAttributeMappingResponse'),(1,'AddAttributeMapResponse'),(1,'AddAttributeResponse'),(1,'AddBan'),(1,'AddBanResponse'),(1,'AddBillingAccount'),(1,'AddBillingAccountResponse'),(1,'AddBookmark'),(1,'AddBookmarkResponse'),(1,'AddCartCoupon'),(1,'AddCartCouponResponse'),(1,'AddCartDomain'),(1,'AddCartDomainResponse'),(1,'AddCartProduct'),(1,'AddCartProductResponse'),(1,'AddCert'),(1,'AddCertResponse'),(1,'AddCheck'),(1,'AddCheckResponse'),(1,'AddClient'),(1,'AddClientContact'),(1,'AddClientContactResponse'),(1,'AddClientCreditResponse'),(1,'AddClientResponse'),(1,'AddCompany'),(1,'AddCompanyResponse'),(1,'AddCoupon'),(1,'AddCouponResponse'),(1,'AddCustomClientAttribute'),(1,'AddCustomClientAttributeResponse'),(1,'AddCustomProductAttribute'),(1,'AddCustomProductAttributeResponse'),(1,'AddCycle'),(1,'AddCycleDiscount'),(1,'AddCycleDiscountGroup'),(1,'AddCycleDiscountGroupResponse'),(1,'AddCycleDiscountResponse'),(1,'AddCycleGroup'),(1,'AddCycleGroupResponse'),(1,'AddCycleResponse'),(1,'AddDeposit'),(1,'AddDepositResponse'),(1,'AddDomain'),(1,'AddDomainResponse'),(1,'AddEmailTemplate'),(1,'AddEmailTemplateGroup'),(1,'AddEmailTemplateGroupResponse'),(1,'AddEmailTemplateResponse'),(1,'AddFAQ'),(1,'AddFAQCategory'),(1,'AddFAQCategoryResponse'),(1,'AddFAQResponse'),(1,'AddFraudCountryThresholdResponse'),(1,'AddFraudSetResponse'),(1,'AddGeneralJournalEntry'),(1,'AddGeneralJournalEntryResponse'),(1,'AddGenericAttribute'),(1,'AddGenericAttributeResponse'),(1,'AddGroupAttribute'),(1,'AddGroupAttributeResponse'),(1,'AddHelpdeskBucket'),(1,'AddHelpdeskBucketResponse'),(1,'AddHelpdeskDepartment'),(1,'AddHelpdeskDepartmentResponse'),(1,'AddHelpdeskResponseTemplate'),(1,'AddHelpdeskResponseTemplateResponse'),(1,'AddHelpdeskTicket'),(1,'AddHelpdeskTicketResponse'),(1,'AddHistoricalPackage'),(1,'AddHistoricalPackageMenu'),(1,'AddHistoricalPackageResponse'),(1,'AddInvalidIpnLog'),(1,'AddInvalidIpnLogResponse'),(1,'AddInvoice'),(1,'AddInvoiceResponse'),(1,'AddInvoicingGroup'),(1,'AddInvoicingGroupResponse'),(1,'AddIPLog'),(1,'AddIPLogResponse'),(1,'AddLedgerAccount'),(1,'AddMigrationConfig'),(1,'AddMigrationConfigResponse'),(1,'AddNews'),(1,'AddNewsGroup'),(1,'AddNewsGroupResponse'),(1,'AddNewsResponse'),(1,'AddOrderForm'),(1,'AddOrderFormResponse'),(1,'AddPackage'),(1,'AddPackageAddon'),(1,'AddPackageAddonAttribute'),(1,'AddPackageAddonAttributeResponse'),(1,'AddPackageAddonResponse'),(1,'AddPackageAttribute'),(1,'AddPackageAttributeResponse'),(1,'AddPackageResponse'),(1,'AddPanel'),(1,'AddPanelResponse'),(1,'AddPaymentGroup'),(1,'AddPaymentGroupResponse'),(1,'AddPrepayDiscount'),(1,'AddPrepayDiscountResponse'),(1,'AddPrice'),(1,'AddProduct'),(1,'AddProductAddon'),(1,'AddProductAddonGroup'),(1,'AddProductAddonGroupResponse'),(1,'AddProductAddonResponse'),(1,'AddProductAttributes'),(1,'AddProductAttributesResponse'),(1,'AddProductGroup'),(1,'AddProductGroupResponse'),(1,'AddProductPricing'),(1,'AddProductPricingResponse'),(1,'AddProductRelation'),(1,'AddProductRelationResponse'),(1,'AddProductResponse'),(1,'AddProductValues'),(1,'AddProductValuesResponse'),(1,'AddProductVariable'),(1,'AddProductVariableResponse'),(1,'AddProductVariableValue'),(1,'AddProductVariableValueResponse'),(1,'AddProductVariant'),(1,'AddProductVariantResponse'),(1,'AddQuestionValueMap'),(1,'AddQuestionValueMapping'),(1,'AddQuestionValueMappingResponse'),(1,'AddQuestionValueMapResponse'),(1,'AddRegistrar'),(1,'AddRegistrarResponse'),(1,'AddServer'),(1,'AddServerGroup'),(1,'AddServerGroupResponse'),(1,'AddServerResponse'),(1,'AddSingleInvoice'),(1,'AddSingleInvoiceResponse'),(1,'AddSkeletonProduct'),(1,'AddTaxZone'),(1,'AddTaxZoneGroup'),(1,'AddTaxZoneGroupResponse'),(1,'AddTaxZoneResponse'),(1,'AddTheme'),(1,'AddThemeResponse'),(1,'AddTLD'),(1,'AddTLDResponse'),(1,'AddTodo'),(1,'AddTodoResponse'),(1,'AddVendor'),(1,'AddVendorInvoices'),(1,'AddVendorResponse'),(1,'AddWebsiteWidget'),(1,'AddWebsiteWidgetResponse'),(1,'AddWizardQuestion'),(1,'AddWizardQuestionResponse'),(1,'AddWizardStep'),(1,'AddWizardStepResponse'),(1,'APILoginResponse'),(1,'CancelAuthTransaction'),(1,'CancelCert'),(1,'CancelCertResponse'),(1,'CancelInvoice'),(1,'CancelInvoiceResponse'),(1,'CancelPackage'),(1,'CancelPackageResponse'),(1,'CancelVendorPackage'),(1,'CaptureFunds'),(1,'ChangePackageClient'),(1,'ChangePackageClientResponse'),(1,'ChangePackageCycle'),(1,'ChangePackageCycleResponse'),(1,'ChargeVirtualTerminal'),(1,'ChargeVirtualTerminalResponse'),(1,'CheckCertStatus'),(1,'CheckCertStatusResponse'),(1,'CheckDomainAvailability'),(1,'CheckDomainTransferAvailability'),(1,'CheckMultiDomainWhois'),(1,'CheckRunPaymentQueue'),(1,'CheckServerLoad'),(1,'ClearCart'),(1,'ClearPaymentQueue'),(1,'CloneAdminGroup'),(1,'CloneAdminGroupResponse'),(1,'CloneBookmark'),(1,'CloneBookmarkResponse'),(1,'CloneCoupon'),(1,'CloneCouponResponse'),(1,'CloneOrderForm'),(1,'CloneOrderFormResponse'),(1,'CloneProduct'),(1,'CloneProductAddon'),(1,'CloneProductAddonResponse'),(1,'CloneProductAttribute'),(1,'CloneProductAttributeResponse'),(1,'CloneProductResponse'),(1,'CloneServerGroup'),(1,'CloneServerGroupResponse'),(1,'CloneTheme'),(1,'CloneThemeResponse'),(1,'ClosePeriod'),(1,'ClosePeriodConfirm'),(1,'ClosePeriodResponse'),(1,'ConfirmCreditNote'),(1,'ConfirmCreditNoteResponse'),(1,'CreateMarketplaceSeller'),(1,'CreatePackage'),(1,'CreateVendorPackage'),(1,'CreateVendorUser'),(1,'CreateVendorUserResponse'),(1,'DeletePackage'),(1,'DeletePackageAddon'),(1,'DeletePackageResponse'),(1,'DeleteVendorPackage'),(1,'DisassociateDomain'),(1,'DowngradePackage'),(1,'DowngradePackageAddon'),(1,'DowngradePackageResponse'),(1,'EditAdmin'),(1,'EditAdminGroup'),(1,'EditAdminGroupResponse'),(1,'EditAdminResponse'),(1,'EditAppliedValues'),(1,'EditAppliedValuesResponse'),(1,'EditAttribute'),(1,'EditAttributeGroup'),(1,'EditAttributeGroupResponse'),(1,'EditAttributeMap'),(1,'EditAttributeMapping'),(1,'EditAttributeMappingResponse'),(1,'EditAttributeMapResponse'),(1,'EditAttributeResponse'),(1,'EditBan'),(1,'EditBanResponse'),(1,'EditBasicClientAttributes'),(1,'EditBasicClientAttributesResponse'),(1,'EditBillingAccount'),(1,'EditBillingAccountResponse'),(1,'EditBookmark'),(1,'EditBookmarkResponse'),(1,'EditCartDomain'),(1,'EditCartDomainResponse'),(1,'EditCartProduct'),(1,'EditCartProductResponse'),(1,'EditCert'),(1,'EditCertResponse'),(1,'EditCheck'),(1,'EditCheckResponse'),(1,'EditClient'),(1,'EditClientArchiveState'),(1,'EditClientArchiveStateResponse'),(1,'EditClientContact'),(1,'EditClientContactResponse'),(1,'EditClientResponse'),(1,'EditCompany'),(1,'EditCompanyResponse'),(1,'EditConfigParamsResponse'),(1,'EditCoupon'),(1,'EditCouponResponse'),(1,'EditCycle'),(1,'EditCycleDiscount'),(1,'EditCycleDiscountGroup'),(1,'EditCycleDiscountGroupResponse'),(1,'EditCycleDiscountResponse'),(1,'EditCycleGroup'),(1,'EditCycleGroupResponse'),(1,'EditCycleResponse'),(1,'EditDbgPageloadsSettings'),(1,'EditDbgPageloadsSettingsResponse'),(1,'EditDeposit'),(1,'EditDepositResponse'),(1,'EditDomain'),(1,'EditDomainAccessPassword'),(1,'EditDomainAccessPasswordResponse'),(1,'EditDomainContactData'),(1,'EditDomainContactDataResponse'),(1,'EditDomainDNS'),(1,'EditDomainDNSResponse'),(1,'EditDomainRegistrarLockOptions'),(1,'EditDomainRegistrarLockOptionsResponse'),(1,'EditDomainRenewTypeOptions'),(1,'EditDomainRenewTypeOptionsResponse'),(1,'EditDomainResponse'),(1,'EditEmailConfig'),(1,'EditEmailConfigResponse'),(1,'EditEmailQueue'),(1,'EditEmailQueueResponse'),(1,'EditEmailTemplate'),(1,'EditEmailTemplateGroup'),(1,'EditEmailTemplateGroupResponse'),(1,'EditEmailTemplateResponse'),(1,'EditEncryptionConfigs'),(1,'EditEncryptionConfigsConfirm'),(1,'EditEncryptionConfigsResponse'),(1,'EditEvent'),(1,'EditEventResponse'),(1,'EditFAQ'),(1,'EditFAQCategory'),(1,'EditFAQCategoryResponse'),(1,'EditFAQResponse'),(1,'EditFraudCountryThreshold'),(1,'EditFraudCountryThresholdResponse'),(1,'EditFraudGuardianConfig'),(1,'EditFraudGuardianConfigResponse'),(1,'EditFraudSetOrderFormsResponse'),(1,'EditFraudSetResponse'),(1,'EditGeneralJournalEntry'),(1,'EditGeneralJournalEntryResponse'),(1,'EditGenericAttributeResponse'),(1,'EditGroupAttribute'),(1,'EditGroupAttributeResponse'),(1,'EditHelpdeskBucket'),(1,'EditHelpdeskBucketResponse'),(1,'EditHelpdeskDepartment'),(1,'EditHelpdeskDepartmentResponse'),(1,'EditHelpdeskResponseTemplate'),(1,'EditHelpdeskResponseTemplateResponse'),(1,'EditHelpdeskTicket'),(1,'EditHelpdeskTicketResponse'),(1,'EditiDevAffiliateConfig'),(1,'EditiDevAffiliateConfigResponse'),(1,'EditInvalidIpnLog'),(1,'EditInvalidIpnLogResponse'),(1,'EditInvoice'),(1,'EditInvoiceResponse'),(1,'EditInvoicingGroup'),(1,'EditInvoicingGroupResponse'),(1,'EditIPLog'),(1,'EditIPLogResponse'),(1,'EditLedgerAccount'),(1,'EditLedgerAccountResponse'),(1,'EditLedgerGroupEntries'),(1,'EditLedgerGroupEntriesResponse'),(1,'EditLedgerGroups'),(1,'EditMigrationConfig'),(1,'EditMigrationConfigResponse'),(1,'EditMyProfile'),(1,'EditMyProfileResponse'),(1,'EditNewOrdersResponse'),(1,'EditNews'),(1,'EditNewsGroup'),(1,'EditNewsGroupResponse'),(1,'EditNewsResponse'),(1,'EditOneProductRelations'),(1,'EditOneProductRelationsResponse'),(1,'EditOrderForm'),(1,'EditOrderFormResponse'),(1,'EditPackage'),(1,'EditPackageAddon'),(1,'EditPackageAddonAttribute'),(1,'EditPackageAddonAttributeResponse'),(1,'EditPackageAddonResponse'),(1,'EditPackageAddons'),(1,'EditPackageAddonsResponse'),(1,'EditPackageAttribute'),(1,'EditPackageAttributeResponse'),(1,'EditPackageResponse'),(1,'EditPanel'),(1,'EditPanelAttributeResponse'),(1,'EditPanelConfig'),(1,'EditPanelConfigResponse'),(1,'EditPanelResponse'),(1,'EditPaymentGroup'),(1,'EditPaymentGroupResponse'),(1,'EditPaymentQueue'),(1,'EditPaymentQueueResponse'),(1,'EditPPCFactoryConfig'),(1,'EditPPCFactoryConfigResponse'),(1,'EditPrepayDiscount'),(1,'EditPrepayDiscountResponse'),(1,'EditPrice'),(1,'EditProduct'),(1,'EditProductAddon'),(1,'EditProductAddonAttributes'),(1,'EditProductAddonAttributesResponse'),(1,'EditProductAddonGroup'),(1,'EditProductAddonGroupResponse'),(1,'EditProductAddonGroups'),(1,'EditProductAddonGroupsResponse'),(1,'EditProductAddonResponse'),(1,'EditProductAddons'),(1,'EditProductAddonsResponse'),(1,'EditProductAttribute'),(1,'EditProductAttributeResponse'),(1,'EditProductAttributes'),(1,'EditProductChildren'),(1,'EditProductChildrenResponse'),(1,'EditProductCoupons'),(1,'EditProductCouponsResponse'),(1,'EditProductCycles'),(1,'EditProductCyclesResponse'),(1,'EditProductEmails'),(1,'EditProductEmailsResponse'),(1,'EditProductGroup'),(1,'EditProductGroupResponse'),(1,'EditProductMiscellaneous'),(1,'EditProductMiscellaneousResponse'),(1,'EditProductNotifications'),(1,'EditProductNotificationsResponse'),(1,'EditProductOrderForms'),(1,'EditProductOrderFormsResponse'),(1,'EditProductPriceResponse'),(1,'EditProductPrices'),(1,'EditProductPricesResponse'),(1,'EditProductRelation'),(1,'EditProductRelationResponse'),(1,'EditProductResponse'),(1,'EditProductServerGroups'),(1,'EditProductServerGroupsResponse'),(1,'EditProductsGroup'),(1,'EditProductsGroupResponse'),(1,'EditProductTLDs'),(1,'EditProductTLDsResponse'),(1,'EditProductValues'),(1,'EditProductValuesResponse'),(1,'EditProductVariable'),(1,'EditProductVariableResponse'),(1,'EditProductVariableValue'),(1,'EditProductVariableValueResponse'),(1,'EditProductVariant'),(1,'EditProductVariantLedgerEntries'),(1,'EditProductVariantLedgerEntriesResponse'),(1,'EditProductVariantPrices'),(1,'EditProductVariantPricesResponse'),(1,'EditProductVariantResponse'),(1,'EditQuestionValueMap'),(1,'EditQuestionValueMapping'),(1,'EditQuestionValueMappingResponse'),(1,'EditQuestionValueMapResponse'),(1,'EditRegistrarConfig'),(1,'EditRegistrarConfigResponse'),(1,'EditRegistrarSettings'),(1,'EditRegistrarSettingsResponse'),(1,'EditSellerSettings'),(1,'EditSellerSettingsResponse'),(1,'EditServer'),(1,'EditServerGroup'),(1,'EditServerGroupResponse'),(1,'EditServerResponse'),(1,'EditSSLFactoryConfig'),(1,'EditSSLFactoryConfigResponse'),(1,'EditTaxZone'),(1,'EditTaxZoneGroup'),(1,'EditTaxZoneGroupResponse'),(1,'EditTaxZoneResponse'),(1,'EditTheme'),(1,'EditThemeResponse'),(1,'EditTLD'),(1,'EditTLDResponse'),(1,'EditTodo'),(1,'EditTodoResponse'),(1,'EditUltimateAffiliateConfig'),(1,'EditUltimateAffiliateConfigResponse'),(1,'EditUsagePricing'),(1,'EditUsagePricingResponse'),(1,'EditVendor'),(1,'EditVendorResponse'),(1,'EditWebsiteWidget'),(1,'EditWebsiteWidgetResponse'),(1,'EditWizardQuestion'),(1,'EditWizardQuestionResponse'),(1,'EditWizardStep'),(1,'EditWizardStepResponse'),(1,'EnablePackage'),(1,'EnablePackageAddon'),(1,'EnablePackageResponse'),(1,'ExportPaymentQueue'),(1,'ForgottenPasswordResponse'),(1,'ForwardToClientInterface'),(1,'GenerateInvoiceEvents'),(1,'GeneratePaymentQueue'),(1,'GeneratePaymentQueueResponse'),(1,'GetAutocompleteClients'),(1,'GetAutocompleteDomains'),(1,'GetAutocompleteProducts'),(1,'GetBillingAccounts'),(1,'GetClientStatus'),(1,'GetCompanyInformation'),(1,'GetEmailTemplate'),(1,'GetEmailTemplateVariables'),(1,'GetLogEnabledCommands'),(1,'GetMBAPIMap'),(1,'GetOrderForms'),(1,'GetReportActivePackagesByCycle'),(1,'GetReportActivePerServer'),(1,'GetReportActivePerServerGroup'),(1,'GetReportBilledServerRevenue'),(1,'GetReportCustomerPaymentsByDate'),(1,'GetReportDailyInvoices'),(1,'GetReportDailySignups'),(1,'GetReportMostPopularPackages'),(1,'GetReportPackagesByStatus'),(1,'GetReportPaymentsByPaymentType'),(1,'GetReportRecurringServerRevenue'),(1,'GetReportRevenuePerServer'),(1,'GetVendorInformation'),(1,'GetVendorProducts'),(1,'ImportClientFromPanel'),(1,'ImportClientFromPanelResponse'),(1,'InstallSystemLicense'),(1,'InstallSystemLicenseResponse'),(1,'LockDomainPrices'),(1,'LockDomainPricesResponse'),(1,'LockPackageAddonPrices'),(1,'LockPackageAddonPricesResponse'),(1,'LockPackagePrices'),(1,'LockPackagePricesResponse'),(1,'LockProductAddonPrices'),(1,'LockProductAddonPricesResponse'),(1,'LockProductPrices'),(1,'LockProductPricesResponse'),(1,'LoginResponse'),(1,'LogoutResponse'),(1,'ManageClientActionActivate'),(1,'ManageClientActionActivateResponse'),(1,'ManageClientActionArchive'),(1,'ManageClientActionArchiveResponse'),(1,'ManageClientActionCancel'),(1,'ManageClientActionCancelResponse'),(1,'ManageClientActionDelete'),(1,'ManageClientActionDeleteResponse'),(1,'ManageClientActionPurge'),(1,'ManageClientActionPurgeResponse'),(1,'ManageClientActionSuspend'),(1,'ManageClientActionSuspendResponse'),(1,'ManageClientActionUnsuspend'),(1,'ManageClientActionUnsuspendResponse'),(1,'ManageClientNotes'),(1,'ManageClientNotesResponse'),(1,'ManageSellerProduct'),(1,'MergeClient'),(1,'MergeClientResponse'),(1,'MergeCompanies'),(1,'MergeCompaniesResponse'),(1,'MigrateConfig'),(1,'MigrateConfigAssociate'),(1,'MigrateConfigAssociateResponse'),(1,'MigrateConfigResponse'),(1,'MigrateDeprocess'),(1,'MigrateDisabled'),(1,'MigrateError'),(1,'MigrateIntro'),(1,'MigrateManager'),(1,'MigrateModuleDeprocess'),(1,'MigrateModuleManager'),(1,'MigrateModuleProcess'),(1,'MigrateProcess'),(1,'MigrateProductDeprocess'),(1,'MigrateProductManager'),(1,'MigrateProductProcess'),(1,'MigrateProductSkip'),(1,'MigrateSkip'),(1,'OrderCertConfirmOrder'),(1,'OrderCertContactRequest'),(1,'OrderCertContactRequestResponse'),(1,'OrderCertCSRRequest'),(1,'OrderCertCSRRequestResponse'),(1,'OrderCertCSRVerify'),(1,'OrderCertEnterCSR'),(1,'OrderCertGetApproverEula'),(1,'OrderCertGetApproverEulaResponse'),(1,'OrderCertGetApproverResponse'),(1,'OrderCertOrderResponse'),(1,'OrderCertOrderResults'),(1,'OrderCertOrderSummary'),(1,'OrderCertReceipt'),(1,'OrderCertSelectApprover'),(1,'OrderCertSelectApproverResponse'),(1,'OrderCertSubmitOrderResponse'),(1,'OrderCertVerifyCSRResponse'),(1,'OrderFormProvisioning'),(1,'PayInvoice'),(1,'PayInvoiceResponse'),(1,'PayInvoices'),(1,'PayInvoicesResponse'),(1,'PerformPanelAction'),(1,'PreviewEmailTemplate'),(1,'ProcessCartCheckout'),(1,'ProcessCartCheckoutLoader'),(1,'ProcessCartLogin'),(1,'ProcessCartLoginResponse'),(1,'ProcessCartRegister'),(1,'ProcessManualPayment'),(1,'ProcessTransactionRefund'),(1,'ProcessTransactionRefundResponse'),(1,'PurgeDbgPageloads'),(1,'PushProduct'),(1,'ReassignPackageAttributeResponse'),(1,'ReauthBillingAccount'),(1,'ReauthBillingAccountResponse'),(1,'RecordAdminActions'),(1,'ReencryptBillingAccountsResponse'),(1,'RegisterDomainConfirm'),(1,'RegisterDomainConfirmResponse'),(1,'ReloadEmailTemplateResponse'),(1,'RemoveAdmin'),(1,'RemoveAdminGroup'),(1,'RemoveAdminGroupResponse'),(1,'RemoveAdminResponse'),(1,'RemoveAttribute'),(1,'RemoveAttributeGroup'),(1,'RemoveAttributeGroupResponse'),(1,'RemoveAttributeMap'),(1,'RemoveAttributeMapping'),(1,'RemoveAttributeMappingResponse'),(1,'RemoveAttributeMapResponse'),(1,'RemoveAttributeResponse'),(1,'RemoveBan'),(1,'RemoveBanResponse'),(1,'RemoveBillingAccount'),(1,'RemoveBillingAccountResponse'),(1,'RemoveBookmark'),(1,'RemoveBookmarkResponse'),(1,'RemoveCartCoupon'),(1,'RemoveCartCouponResponse'),(1,'RemoveCartProduct'),(1,'RemoveCartProductResponse'),(1,'RemoveCert'),(1,'RemoveCertResponse'),(1,'RemoveClient'),(1,'RemoveClientContact'),(1,'RemoveClientContactResponse'),(1,'RemoveClientNoteResponse'),(1,'RemoveClientResponse'),(1,'RemoveCompany'),(1,'RemoveCompanyResponse'),(1,'RemoveCoupon'),(1,'RemoveCouponResponse'),(1,'RemoveCycle'),(1,'RemoveCycleDiscount'),(1,'RemoveCycleDiscountGroup'),(1,'RemoveCycleDiscountGroupResponse'),(1,'RemoveCycleDiscountResponse'),(1,'RemoveCycleGroup'),(1,'RemoveCycleGroupResponse'),(1,'RemoveCycleResponse'),(1,'RemoveDomain'),(1,'RemoveDomainResponse'),(1,'RemoveEmail'),(1,'RemoveEmailQueue'),(1,'RemoveEmailQueueResponse'),(1,'RemoveEmailResponse'),(1,'RemoveEmailTemplate'),(1,'RemoveEmailTemplateGroup'),(1,'RemoveEmailTemplateGroupResponse'),(1,'RemoveEmailTemplateResponse'),(1,'RemoveEvent'),(1,'RemoveEventResponse'),(1,'RemoveFAQ'),(1,'RemoveFAQCategory'),(1,'RemoveFAQCategoryResponse'),(1,'RemoveFAQResponse'),(1,'RemoveFraudCountryThresholdResponse'),(1,'RemoveFraudSetResponse'),(1,'RemoveGateway'),(1,'RemoveGatewayResponse'),(1,'RemoveGroupAttribute'),(1,'RemoveGroupAttributeResponse'),(1,'RemoveHelpdeskBucket'),(1,'RemoveHelpdeskBucketResponse'),(1,'RemoveHelpdeskDepartment'),(1,'RemoveHelpdeskDepartmentResponse'),(1,'RemoveHelpdeskResponseTemplate'),(1,'RemoveHelpdeskResponseTemplateResponse'),(1,'RemoveHelpdeskTicket'),(1,'RemoveHelpdeskTicketResponse'),(1,'RemoveInvalidIpnLog'),(1,'RemoveInvalidIpnLogResponse'),(1,'RemoveInvoice'),(1,'RemoveInvoiceResponse'),(1,'RemoveInvoiceTransaction'),(1,'RemoveInvoiceTransactionResponse'),(1,'RemoveInvoicingGroup'),(1,'RemoveInvoicingGroupResponse'),(1,'RemoveIPLog'),(1,'RemoveIPLogResponse'),(1,'RemoveLedgerAccount'),(1,'RemoveLedgerGroup'),(1,'RemoveLedgerGroupResponse'),(1,'RemoveMigrationConfig'),(1,'RemoveMigrationConfigResponse'),(1,'RemoveNews'),(1,'RemoveNewsGroup'),(1,'RemoveNewsGroupResponse'),(1,'RemoveNewsResponse'),(1,'RemoveOrderForm'),(1,'RemoveOrderFormResponse'),(1,'RemovePackage'),(1,'RemovePackageAddon'),(1,'RemovePackageAddonAttribute'),(1,'RemovePackageAddonAttributeResponse'),(1,'RemovePackageAddonResponse'),(1,'RemovePackageAttribute'),(1,'RemovePackageAttributeResponse'),(1,'RemovePackageResponse'),(1,'RemovePanel'),(1,'RemovePanelResponse'),(1,'RemovePaymentGroup'),(1,'RemovePaymentGroupGateway'),(1,'RemovePaymentGroupGatewayResponse'),(1,'RemovePaymentGroupResponse'),(1,'RemovePaymentQueue'),(1,'RemovePaymentQueueResponse'),(1,'RemovePrepayDiscount'),(1,'RemovePrepayDiscountResponse'),(1,'RemoveProduct'),(1,'RemoveProductAddon'),(1,'RemoveProductAddonGroup'),(1,'RemoveProductAddonGroupResponse'),(1,'RemoveProductAddonResponse'),(1,'RemoveProductAttribute'),(1,'RemoveProductAttributeResponse'),(1,'RemoveProductGroup'),(1,'RemoveProductGroupResponse'),(1,'RemoveProductRelation'),(1,'RemoveProductRelationResponse'),(1,'RemoveProductResponse'),(1,'RemoveProductValues'),(1,'RemoveProductValuesResponse'),(1,'RemoveProductVariable'),(1,'RemoveProductVariableResponse'),(1,'RemoveProductVariableValue'),(1,'RemoveProductVariableValueResponse'),(1,'RemoveProductVariant'),(1,'RemoveProductVariantResponse'),(1,'RemoveQuestion'),(1,'RemoveQuestionResponse'),(1,'RemoveQuestionValueMap'),(1,'RemoveQuestionValueMapping'),(1,'RemoveQuestionValueMappingResponse'),(1,'RemoveQuestionValueMapResponse'),(1,'RemoveServer'),(1,'RemoveServerGroup'),(1,'RemoveServerGroupResponse'),(1,'RemoveServerResponse'),(1,'RemoveTaxZone'),(1,'RemoveTaxZoneGroup'),(1,'RemoveTaxZoneGroupResponse'),(1,'RemoveTaxZoneResponse'),(1,'RemoveTheme'),(1,'RemoveThemeResponse'),(1,'RemoveTLD'),(1,'RemoveTLDResponse'),(1,'RemoveTodo'),(1,'RemoveTodoResponse'),(1,'RemoveTransaction'),(1,'RemoveTransactionResponse'),(1,'RemoveWebsiteWidget'),(1,'RemoveWebsiteWidgetResponse'),(1,'RemoveWizardQuestion'),(1,'RemoveWizardQuestionResponse'),(1,'RemoveWizardStep'),(1,'RemoveWizardStepResponse'),(1,'RenewDomain'),(1,'RenewDomainResponse'),(1,'ReplayCallbackLog'),(1,'ReplayCallbackLogResponse'),(1,'ReportClientList'),(1,'ReportClientListDetailed'),(1,'ReportClientListGraph'),(1,'RequestProductSync'),(1,'RequestVendorInvoiceSync'),(1,'ResendCertApproverEmail'),(1,'ResendCertApproverEmailResponse'),(1,'ResendEmail'),(1,'ResendEmailResponse'),(1,'ResendInvoice'),(1,'ResendInvoiceResponse'),(1,'ResetContactPassword'),(1,'ResetContactPasswordResponse'),(1,'RunDebugEvent'),(1,'RunEvents'),(1,'RunPaymentQueue'),(1,'RunPaymentQueueResponse'),(1,'SearchDispatchResponse'),(1,'SendClientEmail'),(1,'SendClientEmailResponse'),(1,'SendEmailQueue'),(1,'SendEmailQueueResponse'),(1,'SendSellerMessage'),(1,'ShowAccountingReportsMenu'),(1,'ShowAccountingStats'),(1,'ShowAccountsPayableLedger'),(1,'ShowAccountsReceivableLedger'),(1,'ShowAdminDetails'),(1,'ShowAdminGroupDetails'),(1,'ShowAdminGroups'),(1,'ShowAdmins'),(1,'ShowAdminStats'),(1,'ShowAgingReport'),(1,'ShowAgingReportContainer'),(1,'ShowAllTodos'),(1,'ShowAttributeDetails'),(1,'ShowAttributeGroups'),(1,'ShowAttributeMapDetails'),(1,'ShowAttributeMappingDetails'),(1,'ShowAttributeMappings'),(1,'ShowAttributeMaps'),(1,'ShowAttributes'),(1,'ShowBalanceSheet'),(1,'ShowBalanceSheetContainer'),(1,'ShowBanDetails'),(1,'ShowBans'),(1,'ShowBillingAccountDetails'),(1,'ShowBillingAccounts'),(1,'ShowBookmarks'),(1,'ShowCallbackLog'),(1,'ShowCallbackLogDetails'),(1,'ShowCart'),(1,'ShowCartCheckoutConfirmForm'),(1,'ShowCartCheckoutForm'),(1,'ShowCartCheckoutSuccess'),(1,'ShowCartProductAddons'),(1,'ShowCartProductAddonsStep'),(1,'ShowCashFlow'),(1,'ShowCashFlowContainer'),(1,'ShowCertDetails'),(1,'ShowCerts'),(1,'ShowClientARHistory'),(1,'ShowClientCallbackLog'),(1,'ShowClientCallbackLogDetails'),(1,'ShowClientContactDetails'),(1,'ShowClientContacts'),(1,'ShowClientCreditHistory'),(1,'ShowClientDetails'),(1,'ShowClientGraph'),(1,'ShowClients'),(1,'ShowClientServiceInputForm'),(1,'ShowClientServiceInputFormResponse'),(1,'ShowClientStats'),(1,'ShowCompanies'),(1,'ShowCompanyDetails'),(1,'ShowConfigs'),(1,'ShowCouponDetails'),(1,'ShowCoupons'),(1,'ShowCycleDiscountGroups'),(1,'ShowCycleDiscounts'),(1,'ShowCycleGroups'),(1,'ShowCycleGroupsResponse'),(1,'ShowCycles'),(1,'ShowCyclesResponse'),(1,'ShowCycleStats'),(1,'ShowDashboard'),(1,'ShowDashboardNewOrders'),(1,'ShowDashboardTodos'),(1,'ShowDbgPageloadDetails'),(1,'ShowDbgPageloads'),(1,'ShowDomainDetails'),(1,'ShowDomainEPPCodeStep'),(1,'ShowDomains'),(1,'ShowEmailDetails'),(1,'ShowEmailMenus'),(1,'ShowEmailQueue'),(1,'ShowEmailQueueDetails'),(1,'ShowEmailTemplateDetails'),(1,'ShowEmailTemplateGroupDetails'),(1,'ShowEmailTemplateGroups'),(1,'ShowEmailTemplates'),(1,'ShowEventInputDetails'),(1,'ShowEventOutputDetails'),(1,'ShowEvents'),(1,'ShowEventsStats'),(1,'ShowEventStatusBar'),(1,'ShowFAQs'),(1,'ShowFinancesMenu'),(1,'ShowFinancialGraph'),(1,'ShowForgottenPassword'),(1,'ShowFraudCountryThresholds'),(1,'ShowFraudSetDetails'),(1,'ShowFraudSets'),(1,'ShowGeneralJournal'),(1,'ShowGeneralLedger'),(1,'ShowGenerateInvoiceMenu'),(1,'ShowGenericBar'),(1,'ShowGroupAttributes'),(1,'ShowHelpdesk'),(1,'ShowHelpdeskBucketDetails'),(1,'ShowHelpdeskBuckets'),(1,'ShowHelpdeskBucketTickets'),(1,'ShowHelpdeskDepartments'),(1,'ShowHelpdeskGraph'),(1,'ShowHelpdeskResponseTemplates'),(1,'ShowHelpdeskTicketDetails'),(1,'ShowHelpdeskTickets'),(1,'ShowInvalidIpnLogDetails'),(1,'ShowInvalidIpnLogs'),(1,'ShowInvoiceDetails'),(1,'ShowInvoices'),(1,'ShowInvoiceSheet'),(1,'ShowInvoiceSheetContainer'),(1,'ShowInvoiceStats'),(1,'ShowInvoicingGroups'),(1,'ShowIPLog'),(1,'ShowJournalsMenu'),(1,'ShowLastFiveClientInvoices'),(1,'ShowLastFiveClientPackages'),(1,'ShowLedgerAccountDetails'),(1,'ShowLedgerAccounts'),(1,'ShowLedgersMenu'),(1,'ShowLogDetails'),(1,'ShowLogin'),(1,'ShowLogMenu'),(1,'ShowMBRequirementsTest'),(1,'ShowMigrationConfigDetails'),(1,'ShowMigrationConfigs'),(1,'ShowMultiDomainWhois'),(1,'ShowMultiDomainWhoisStep'),(1,'ShowNewOrders'),(1,'ShowNews'),(1,'ShowNewsDetails'),(1,'ShowNewsGroups'),(1,'ShowOrderFormProductsStep'),(1,'ShowOrderForms'),(1,'ShowPackageAddonAttributeDetails'),(1,'ShowPackageAddonAttributes'),(1,'ShowPackageAddonDetails'),(1,'ShowPackageAddons'),(1,'ShowPackageAttributeDetails'),(1,'ShowPackageAttributes'),(1,'ShowPackageDetails'),(1,'ShowPackageGraph'),(1,'ShowPackages'),(1,'ShowPanelClientLogin'),(1,'ShowPanelDetails'),(1,'ShowPanelOptions'),(1,'ShowPaymentGroups'),(1,'ShowPaymentQueue'),(1,'ShowPaymentQueueDetails'),(1,'ShowPaymentQueueStats'),(1,'ShowPDFInvoice'),(1,'ShowPHPInfo'),(1,'ShowPPCCodes'),(1,'ShowPrepayDiscounts'),(1,'ShowProductAddonDetails'),(1,'ShowProductAddonGroups'),(1,'ShowProductAddons'),(1,'ShowProductAttributeDetails'),(1,'ShowProductAttributes'),(1,'ShowProductDetails'),(1,'ShowProductGraph'),(1,'ShowProductGroups'),(1,'ShowProductRelationDetails'),(1,'ShowProductRelations'),(1,'ShowProducts'),(1,'ShowProductsRevenue'),(1,'ShowProductsRevenueContainer'),(1,'ShowProductStats'),(1,'ShowProductVariableDetails'),(1,'ShowProductVariables'),(1,'ShowProductVariableValueDetails'),(1,'ShowProductVariableValues'),(1,'ShowProductVariants'),(1,'ShowProfitAndLoss'),(1,'ShowProfitAndLossContainer'),(1,'ShowPurchasesJournal'),(1,'ShowQuestionValueMapDetails'),(1,'ShowQuestionValueMappingDetails'),(1,'ShowQuestionValueMappings'),(1,'ShowQuestionValueMaps'),(1,'ShowReceiptsJournal'),(1,'ShowRegisterDomainForm'),(1,'ShowRegistrars'),(1,'ShowReportContainer'),(1,'ShowReportDetails'),(1,'ShowReports'),(1,'ShowResendInvoice'),(1,'ShowResendInvoiceResponse'),(1,'ShowSellerStatus'),(1,'ShowServerDetails'),(1,'ShowServerGroupDetails'),(1,'ShowServerGroups'),(1,'ShowServerGroupsReport'),(1,'ShowServers'),(1,'ShowSignupSheet'),(1,'ShowSignupSheetContainer'),(1,'ShowSystemLibraryInfo'),(1,'ShowSystemLicenseInfo'),(1,'ShowSystemModuleInfo'),(1,'ShowSystemServerInfo'),(1,'ShowTaxPayableLedger'),(1,'ShowTaxZoneGroups'),(1,'ShowTaxZones'),(1,'ShowThemeDetails'),(1,'ShowThemes'),(1,'ShowTLDDetails'),(1,'ShowTLDLoader'),(1,'ShowTLDs'),(1,'ShowTodoDetails'),(1,'ShowTodos'),(1,'ShowTransactionDetails'),(1,'ShowTransactionLog'),(1,'ShowTransactions'),(1,'ShowTransferDomainForm'),(1,'ShowTrendGraph'),(1,'ShowUncapturedFunds'),(1,'ShowVendorDetails'),(1,'ShowVendors'),(1,'ShowVirtualTerminals'),(1,'ShowWebsiteWidget'),(1,'ShowWebsiteWidgets'),(1,'ShowWizardQuestions'),(1,'ShowWizardSteps'),(1,'StopEvents'),(1,'SuppressPPCCodeResponse'),(1,'SuspendPackage'),(1,'SuspendPackageAddon'),(1,'SuspendPackageResponse'),(1,'SuspendVendorPackage'),(1,'SyncDomainDates'),(1,'SyncDomainDatesResponse'),(1,'SyncSellerInventory'),(1,'SyncVendorAPIURL'),(1,'SyncVendorDetails'),(1,'TakeClientPayment'),(1,'TakeClientPaymentResponse'),(1,'TestSellerApiURL'),(1,'TestVendorAPIURL'),(1,'TransferDomainConfirm'),(1,'TransferDomainConfirmResponse'),(1,'UnlockDomainPrices'),(1,'UnlockDomainPricesResponse'),(1,'UnlockPackageAddonPrices'),(1,'UnlockPackageAddonPricesResponse'),(1,'UnlockPackagePrices'),(1,'UnlockPackagePricesResponse'),(1,'UnLockProductAddonPrices'),(1,'UnLockProductAddonPricesResponse'),(1,'UnLockProductPrices'),(1,'UnLockProductPricesResponse'),(1,'UnsuspendVendorPackage'),(1,'UpdatePackage'),(1,'UpdatePackageBillingShares'),(1,'UpdatePackageBillingSharesResponse'),(1,'UpdateSellerStatus'),(1,'UpdateSellerVendor'),(1,'UpdateSellerVendorResponse'),(1,'UpdateVendorInformation'),(1,'UpgradePackage'),(1,'UpgradePackageAddon'),(1,'UpgradePackageResponse'),(1,'UploadReport'),(1,'UploadReportResponse'),(1,'VoidInvoice'),(1,'VoidInvoiceResponse'),(1,'FirstTimeIntroduction'),(1,'FirstTimeDisplayStep'),(1,'FirstTimePerformAction'),(1,'LoginToPanel'),(2,'RunEvents');
/*!40000 ALTER TABLE `admin_group_action_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_group_rel`
--

DROP TABLE IF EXISTS `admin_group_rel`;
CREATE TABLE `admin_group_rel` (
  `admin_group_id` smallint(5) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`admin_group_id`,`admin_id`)
);

--
-- Dumping data for table `admin_group_rel`
--

LOCK TABLES `admin_group_rel` WRITE;
/*!40000 ALTER TABLE `admin_group_rel` DISABLE KEYS */;
INSERT INTO `admin_group_rel` VALUES (1,1),(2,4);
/*!40000 ALTER TABLE `admin_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_groups`
--

DROP TABLE IF EXISTS `admin_groups`;
CREATE TABLE `admin_groups` (
  `admin_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `admin_group_name` varchar(50) default NULL,
  PRIMARY KEY  (`admin_group_id`)
) AUTO_INCREMENT=3;

--
-- Dumping data for table `admin_groups`
--

LOCK TABLES `admin_groups` WRITE;
/*!40000 ALTER TABLE `admin_groups` DISABLE KEYS */;
INSERT INTO `admin_groups` VALUES (1,'root'),(2,'cronadmin');
/*!40000 ALTER TABLE `admin_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admins`
--

DROP TABLE IF EXISTS `admins`;
CREATE TABLE `admins` (
  `admin_id` smallint(5) unsigned NOT NULL auto_increment,
  `admin_first_name` varchar(50) default NULL,
  `admin_last_name` varchar(50) default NULL,
  `admin_email` varchar(100) default NULL,
  `admin_username` varchar(75) default NULL,
  `admin_password` varchar(255) default NULL,
  `admin_temp_password` varchar(255) default NULL,
  `admin_remote_access_hash` varchar(255) default NULL,
  `admin_active` tinyint(3) unsigned default NULL,
  `theme_id` smallint(5) unsigned default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`admin_id`),
  KEY `admin_username` (`admin_username`),
  KEY `admin_password` (`admin_password`),
  KEY `admin_active` (`admin_active`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`)
) AUTO_INCREMENT=5;

--
-- Dumping data for table `admins`
--

LOCK TABLES `admins` WRITE;
/*!40000 ALTER TABLE `admins` DISABLE KEYS */;
INSERT INTO `admins` VALUES (1,'FIRSTNAME','LASTNAME','EMAIL','admin','UNKNOWN',NULL,'bdf2f164541abbab07c0f68b6be6e375662ff613',1,2,21,225),(2,'OrderForm','User','EMAIL','admin_ezorder','7b2e9f54cdff413fcde01f330af6896c3cd7e6cd',NULL,'e3dcc4e331741e58a6ff6366e3798bfcb12c2955',1,2,21,225),(3,'API','User','EMAIL','admin_api','7b2e9f54cdff413fcde01f330af6896c3cd7e6cd',NULL,'e22aaf18b2823d47d230f76a916f3cc7d3cba961',1,2,21,225),(4,'Cron','User','EMAIL','cronadmin','7b2e9f54cdff413fcde01f330af6896c3cd7e6cd',NULL,'339f331c8183edd04fc25568699a9dec2219c1c0',1,2,21,225);
/*!40000 ALTER TABLE `admins` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `affiliates`
--

DROP TABLE IF EXISTS `affiliates`;
CREATE TABLE `affiliates` (
  `affiliate_id` int(8) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `affiliate_code` varchar(255) default NULL,
  `affiliate_hits` int(8) unsigned default NULL,
  `affiliate_count` int(8) unsigned default NULL,
  `affiliate_pay_time` smallint(5) unsigned default NULL,
  `affiliate_pay_amount` decimal(10,2) unsigned default '0.00',
  `affiliate_pay_type` tinyint(3) unsigned default NULL,
  `affiliate_pay_cycle` int(10) unsigned default NULL,
  `affiliate_pay_sum` decimal(10,2) unsigned default '0.00',
  `affiliate_status` tinyint(3) unsigned default NULL,
  `affiliate_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`affiliate_id`),
  KEY `client_id` (`client_id`),
  KEY `affiliate_status` (`affiliate_status`),
  KEY `affiliate_code` (`affiliate_code`)
);

--
-- Dumping data for table `affiliates`
--

LOCK TABLES `affiliates` WRITE;
/*!40000 ALTER TABLE `affiliates` DISABLE KEYS */;
/*!40000 ALTER TABLE `affiliates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attribute_groups`
--

DROP TABLE IF EXISTS `attribute_groups`;
CREATE TABLE `attribute_groups` (
  `group_id` int(10) unsigned NOT NULL auto_increment,
  `group_name` varchar(100) default NULL,
  `group_active` tinyint(1) default '1',
  PRIMARY KEY  (`group_id`)
);

--
-- Dumping data for table `attribute_groups`
--

LOCK TABLES `attribute_groups` WRITE;
/*!40000 ALTER TABLE `attribute_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `attribute_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attribute_map_mapping_rel`
--

DROP TABLE IF EXISTS `attribute_map_mapping_rel`;
CREATE TABLE `attribute_map_mapping_rel` (
  `attribute_map_id` int(10) unsigned NOT NULL default '0',
  `attribute_mapping_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`attribute_map_id`,`attribute_mapping_id`)
);

--
-- Dumping data for table `attribute_map_mapping_rel`
--

LOCK TABLES `attribute_map_mapping_rel` WRITE;
/*!40000 ALTER TABLE `attribute_map_mapping_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `attribute_map_mapping_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attribute_mappings`
--

DROP TABLE IF EXISTS `attribute_mappings`;
CREATE TABLE `attribute_mappings` (
  `attribute_mapping_id` int(10) unsigned NOT NULL auto_increment,
  `attribute_id` int(10) unsigned default NULL,
  `attribute_match_value` varchar(100) default NULL,
  `attribute_nomatch_value` varchar(100) default NULL,
  PRIMARY KEY  (`attribute_mapping_id`),
  KEY `attribute_id` (`attribute_id`)
);

--
-- Dumping data for table `attribute_mappings`
--

LOCK TABLES `attribute_mappings` WRITE;
/*!40000 ALTER TABLE `attribute_mappings` DISABLE KEYS */;
/*!40000 ALTER TABLE `attribute_mappings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attribute_maps`
--

DROP TABLE IF EXISTS `attribute_maps`;
CREATE TABLE `attribute_maps` (
  `attribute_map_id` int(10) unsigned NOT NULL auto_increment,
  `attribute_map_name` varchar(100) default NULL,
  PRIMARY KEY  (`attribute_map_id`)
);

--
-- Dumping data for table `attribute_maps`
--

LOCK TABLES `attribute_maps` WRITE;
/*!40000 ALTER TABLE `attribute_maps` DISABLE KEYS */;
/*!40000 ALTER TABLE `attribute_maps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attributes`
--

DROP TABLE IF EXISTS `attributes`;
CREATE TABLE `attributes` (
  `attribute_id` int(10) unsigned NOT NULL auto_increment,
  `attribute_name` varchar(100) default NULL,
  `attribute_type` tinyint(3) unsigned default NULL,
  `attribute_subtype` tinyint(3) unsigned default NULL,
  `attribute_input_restrictions` bigint(20) default NULL,
  `question_id` int(8) unsigned default NULL,
  `value_map_id` smallint(5) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`attribute_id`),
  KEY `attribute_type` (`attribute_type`),
  KEY `attribute_subtype` (`attribute_subtype`),
  KEY `question_id` (`question_id`),
  KEY `product_id` (`product_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `value_map_id` (`value_map_id`)
);

--
-- Dumping data for table `attributes`
--

LOCK TABLES `attributes` WRITE;
/*!40000 ALTER TABLE `attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bans`
--

DROP TABLE IF EXISTS `bans`;
CREATE TABLE `bans` (
  `ban_id` int(10) unsigned NOT NULL auto_increment,
  `ban_type` tinyint(3) unsigned default NULL,
  `ban_string` varchar(255) default NULL,
  `ban_message` longtext,
  `ban_count` smallint(5) unsigned default NULL,
  `ban_active` tinyint(3) unsigned default NULL,
  `ban_date_last_used` int(10) unsigned default NULL,
  PRIMARY KEY  (`ban_id`),
  KEY `ban_string` (`ban_string`),
  KEY `ban_type` (`ban_type`),
  KEY `ban_active` (`ban_active`)
) AUTO_INCREMENT=1347;

--
-- Dumping data for table `bans`
--

LOCK TABLES `bans` WRITE;
/*!40000 ALTER TABLE `bans` DISABLE KEYS */;
INSERT INTO `bans` VALUES (1,0,'123email.com','banned e-mail',NULL,NULL,NULL),(2,0,'123india.com','banned e-mail',NULL,NULL,NULL),(3,0,'163.net','banned e-mail',NULL,NULL,NULL),(4,0,'2akron.com','banned e-mail',NULL,NULL,NULL),(5,0,'2asheville.com','banned e-mail',NULL,NULL,NULL),(6,0,'2athens.com','banned e-mail',NULL,NULL,NULL),(7,0,'2batonrouge.com','banned e-mail',NULL,NULL,NULL),(8,0,'2bmail.co.uk','banned e-mail',NULL,NULL,NULL),(9,0,'2concord.com','banned e-mail',NULL,NULL,NULL),(10,0,'2conventions.com','banned e-mail',NULL,NULL,NULL),(11,0,'2costamesa.com','banned e-mail',NULL,NULL,NULL),(12,0,'2houston.com','banned e-mail',NULL,NULL,NULL),(13,0,'2louisville.com','banned e-mail',NULL,NULL,NULL),(14,0,'2milwaukee.com','banned e-mail',NULL,NULL,NULL),(15,0,'2roanoke.com','banned e-mail',NULL,NULL,NULL),(16,0,'2santabarbara.com','banned e-mail',NULL,NULL,NULL),(17,0,'2sarasota.com','banned e-mail',NULL,NULL,NULL),(18,0,'2wheeling.com','banned e-mail',NULL,NULL,NULL),(19,0,'2yakima.com','banned e-mail',NULL,NULL,NULL),(20,0,'4800numbers.com','banned e-mail',NULL,NULL,NULL),(21,0,'4abilene.com','banned e-mail',NULL,NULL,NULL),(22,0,'4accessories.com','banned e-mail',NULL,NULL,NULL),(23,0,'4acne.com','banned e-mail',NULL,NULL,NULL),(24,0,'4actionfigures.com','banned e-mail',NULL,NULL,NULL),(25,0,'4addictions.com','banned e-mail',NULL,NULL,NULL),(26,0,'4adirondacks.com','banned e-mail',NULL,NULL,NULL),(27,0,'4adoptions.com','banned e-mail',NULL,NULL,NULL),(28,0,'4adventurevacations.com','banned e-mail',NULL,NULL,NULL),(29,0,'4advertising.com','banned e-mail',NULL,NULL,NULL),(30,0,'4advice.com','banned e-mail',NULL,NULL,NULL),(31,0,'4aerobics.com','banned e-mail',NULL,NULL,NULL),(32,0,'4aids.com','banned e-mail',NULL,NULL,NULL),(33,0,'4airconditioners.com','banned e-mail',NULL,NULL,NULL),(34,0,'4aircraft.com','banned e-mail',NULL,NULL,NULL),(35,0,'4airinfo.com','banned e-mail',NULL,NULL,NULL),(36,0,'4airline.com','banned e-mail',NULL,NULL,NULL),(37,0,'4alarms.com','banned e-mail',NULL,NULL,NULL),(38,0,'4albany.com','banned e-mail',NULL,NULL,NULL),(39,0,'4albuquerque.com','banned e-mail',NULL,NULL,NULL),(40,0,'4alcoholism.com','banned e-mail',NULL,NULL,NULL),(41,0,'4alexandria.com','banned e-mail',NULL,NULL,NULL),(42,0,'4aliens.com','banned e-mail',NULL,NULL,NULL),(43,0,'4allentown.com','banned e-mail',NULL,NULL,NULL),(44,0,'4allergies.com','banned e-mail',NULL,NULL,NULL),(45,0,'4alternative.com','banned e-mail',NULL,NULL,NULL),(46,0,'4altmedicine.com','banned e-mail',NULL,NULL,NULL),(47,0,'4altoona.com','banned e-mail',NULL,NULL,NULL),(48,0,'4alzheimers.com','banned e-mail',NULL,NULL,NULL),(49,0,'4amarillo.com','banned e-mail',NULL,NULL,NULL),(50,0,'4anaheim.com','banned e-mail',NULL,NULL,NULL),(51,0,'4anchorage.com','banned e-mail',NULL,NULL,NULL),(52,0,'4anderson.com','banned e-mail',NULL,NULL,NULL),(53,0,'4animals.com','banned e-mail',NULL,NULL,NULL),(54,0,'4anime.com','banned e-mail',NULL,NULL,NULL),(55,0,'4annarbor.com','banned e-mail',NULL,NULL,NULL),(56,0,'4anniston.com','banned e-mail',NULL,NULL,NULL),(57,0,'4anniversary.com','banned e-mail',NULL,NULL,NULL),(58,0,'4annuities.com','banned e-mail',NULL,NULL,NULL),(59,0,'4antiques.com','banned e-mail',NULL,NULL,NULL),(60,0,'4anything.com','banned e-mail',NULL,NULL,NULL),(61,0,'4apartmenthunting.com','banned e-mail',NULL,NULL,NULL),(62,0,'4appetizers.com','banned e-mail',NULL,NULL,NULL),(63,0,'4appleton.com','banned e-mail',NULL,NULL,NULL),(64,0,'4appliances.com','banned e-mail',NULL,NULL,NULL),(65,0,'4aquariums.com','banned e-mail',NULL,NULL,NULL),(66,0,'4architects.com','banned e-mail',NULL,NULL,NULL),(67,0,'4arlington.com','banned e-mail',NULL,NULL,NULL),(68,0,'4aromatherapy.com','banned e-mail',NULL,NULL,NULL),(69,0,'4art.com','banned e-mail',NULL,NULL,NULL),(70,0,'4arthritis.com','banned e-mail',NULL,NULL,NULL),(71,0,'4artsales.com','banned e-mail',NULL,NULL,NULL),(72,0,'4arubatravel.com','banned e-mail',NULL,NULL,NULL),(73,0,'4aspen.com','banned e-mail',NULL,NULL,NULL),(74,0,'4assistivetechnology.com','banned e-mail',NULL,NULL,NULL),(75,0,'4asthma.com','banned e-mail',NULL,NULL,NULL),(76,0,'4atlanta.com','banned e-mail',NULL,NULL,NULL),(77,0,'4atlanticcity.com','banned e-mail',NULL,NULL,NULL),(78,0,'4attentiondeficit.com','banned e-mail',NULL,NULL,NULL),(79,0,'4auction.com','banned e-mail',NULL,NULL,NULL),(80,0,'4audiobooks.com','banned e-mail',NULL,NULL,NULL),(81,0,'4audiocassettes.com','banned e-mail',NULL,NULL,NULL),(82,0,'4augusta.com','banned e-mail',NULL,NULL,NULL),(83,0,'4aurora.com','banned e-mail',NULL,NULL,NULL),(84,0,'4austin.com','banned e-mail',NULL,NULL,NULL),(85,0,'4authors.com','banned e-mail',NULL,NULL,NULL),(86,0,'4autoglass.com','banned e-mail',NULL,NULL,NULL),(87,0,'4autoinsurance.com','banned e-mail',NULL,NULL,NULL),(88,0,'4autoparts.com','banned e-mail',NULL,NULL,NULL),(89,0,'4autoracing.com','banned e-mail',NULL,NULL,NULL),(90,0,'4autorepair.com','banned e-mail',NULL,NULL,NULL),(91,0,'4autos.com','banned e-mail',NULL,NULL,NULL),(92,0,'4autumn.com','banned e-mail',NULL,NULL,NULL),(93,0,'4b2b.com','banned e-mail',NULL,NULL,NULL),(94,0,'4babies.com','banned e-mail',NULL,NULL,NULL),(95,0,'4babyboomers.com','banned e-mail',NULL,NULL,NULL),(96,0,'4babynames.com','banned e-mail',NULL,NULL,NULL),(97,0,'4babyshowers.com','banned e-mail',NULL,NULL,NULL),(98,0,'4backpacks.com','banned e-mail',NULL,NULL,NULL),(99,0,'4backpain.com','banned e-mail',NULL,NULL,NULL),(100,0,'4backup.com','banned e-mail',NULL,NULL,NULL),(101,0,'4bagels.com','banned e-mail',NULL,NULL,NULL),(102,0,'4bailbonds.com','banned e-mail',NULL,NULL,NULL),(103,0,'4bakeries.com','banned e-mail',NULL,NULL,NULL),(104,0,'4bakersfield.com','banned e-mail',NULL,NULL,NULL),(105,0,'4ballooning.com','banned e-mail',NULL,NULL,NULL),(106,0,'4ballparks.com','banned e-mail',NULL,NULL,NULL),(107,0,'4baltimore.com','banned e-mail',NULL,NULL,NULL),(108,0,'4bangor.com','banned e-mail',NULL,NULL,NULL),(109,0,'4banking.com','banned e-mail',NULL,NULL,NULL),(110,0,'4barbecue.com','banned e-mail',NULL,NULL,NULL),(111,0,'4barcelonaspain.com','banned e-mail',NULL,NULL,NULL),(112,0,'4barharbor.com','banned e-mail',NULL,NULL,NULL),(113,0,'4bars.com','banned e-mail',NULL,NULL,NULL),(114,0,'4baseball.com','banned e-mail',NULL,NULL,NULL),(115,0,'4baseballcards.com','banned e-mail',NULL,NULL,NULL),(116,0,'4basketball.com','banned e-mail',NULL,NULL,NULL),(117,0,'4baskets.com','banned e-mail',NULL,NULL,NULL),(118,0,'4battlecreek.com','banned e-mail',NULL,NULL,NULL),(119,0,'4beaches.com','banned e-mail',NULL,NULL,NULL),(120,0,'4beaumont.com','banned e-mail',NULL,NULL,NULL),(121,0,'4beauty.com','banned e-mail',NULL,NULL,NULL),(122,0,'4bedandbath.com','banned e-mail',NULL,NULL,NULL),(123,0,'4bedandbreakfast.com','banned e-mail',NULL,NULL,NULL),(124,0,'4beer.com','banned e-mail',NULL,NULL,NULL),(125,0,'4bellingham.com','banned e-mail',NULL,NULL,NULL),(126,0,'4bentonharbor.com','banned e-mail',NULL,NULL,NULL),(127,0,'4berkeley.com','banned e-mail',NULL,NULL,NULL),(128,0,'4berlin.com','banned e-mail',NULL,NULL,NULL),(129,0,'4bermudatravel.com','banned e-mail',NULL,NULL,NULL),(130,0,'4bestsellers.com','banned e-mail',NULL,NULL,NULL),(131,0,'4bikes.com','banned e-mail',NULL,NULL,NULL),(132,0,'4billiards.com','banned e-mail',NULL,NULL,NULL),(133,0,'4billings.com','banned e-mail',NULL,NULL,NULL),(134,0,'4bills.com','banned e-mail',NULL,NULL,NULL),(135,0,'4biloxi.com','banned e-mail',NULL,NULL,NULL),(136,0,'4binghamton.com','banned e-mail',NULL,NULL,NULL),(137,0,'4bioengineering.com','banned e-mail',NULL,NULL,NULL),(138,0,'4biology.com','banned e-mail',NULL,NULL,NULL),(139,0,'4biotech.com','banned e-mail',NULL,NULL,NULL),(140,0,'4birds.com','banned e-mail',NULL,NULL,NULL),(141,0,'4birmingham.com','banned e-mail',NULL,NULL,NULL),(142,0,'4birthday.com','banned e-mail',NULL,NULL,NULL),(143,0,'4bismarck.com','banned e-mail',NULL,NULL,NULL),(144,0,'4bizops.com','banned e-mail',NULL,NULL,NULL),(145,0,'4bloomington.com','banned e-mail',NULL,NULL,NULL),(146,0,'4blues.com','banned e-mail',NULL,NULL,NULL),(147,0,'4boats.com','banned e-mail',NULL,NULL,NULL),(148,0,'4boise.com','banned e-mail',NULL,NULL,NULL),(149,0,'4bonds.com','banned e-mail',NULL,NULL,NULL),(150,0,'4bookkeeping.com','banned e-mail',NULL,NULL,NULL),(151,0,'4bookstores.com','banned e-mail',NULL,NULL,NULL),(152,0,'4boston.com','banned e-mail',NULL,NULL,NULL),(153,0,'4boulder.com','banned e-mail',NULL,NULL,NULL),(154,0,'4bowling.com','banned e-mail',NULL,NULL,NULL),(155,0,'4boxing.com','banned e-mail',NULL,NULL,NULL),(156,0,'4bradenton.com','banned e-mail',NULL,NULL,NULL),(157,0,'4brakes.com','banned e-mail',NULL,NULL,NULL),(158,0,'4bread.com','banned e-mail',NULL,NULL,NULL),(159,0,'4breastcancer.com','banned e-mail',NULL,NULL,NULL),(160,0,'4bremerton.com','banned e-mail',NULL,NULL,NULL),(161,0,'4bridalshowers.com','banned e-mail',NULL,NULL,NULL),(162,0,'4brides.com','banned e-mail',NULL,NULL,NULL),(163,0,'4bridge.com','banned e-mail',NULL,NULL,NULL),(164,0,'4bridgeport.com','banned e-mail',NULL,NULL,NULL),(165,0,'4brownsville.com','banned e-mail',NULL,NULL,NULL),(166,0,'4bryan.com','banned e-mail',NULL,NULL,NULL),(167,0,'4buddhism.com','banned e-mail',NULL,NULL,NULL),(168,0,'4buffalo.com','banned e-mail',NULL,NULL,NULL),(169,0,'4building.com','banned e-mail',NULL,NULL,NULL),(170,0,'4buildingsupplies.com','banned e-mail',NULL,NULL,NULL),(171,0,'4burlington.com','banned e-mail',NULL,NULL,NULL),(172,0,'4buses.com','banned e-mail',NULL,NULL,NULL),(173,0,'4businessinsurance.com','banned e-mail',NULL,NULL,NULL),(174,0,'4businesstravel.com','banned e-mail',NULL,NULL,NULL),(175,0,'4businessupdates.com','banned e-mail',NULL,NULL,NULL),(176,0,'4cable.com','banned e-mail',NULL,NULL,NULL),(177,0,'4cabletv.com','banned e-mail',NULL,NULL,NULL),(178,0,'4cake.com','banned e-mail',NULL,NULL,NULL),(179,0,'4calendars.com','banned e-mail',NULL,NULL,NULL),(180,0,'4californiacoast.com','banned e-mail',NULL,NULL,NULL),(181,0,'4cameras.com','banned e-mail',NULL,NULL,NULL),(182,0,'4camping.com','banned e-mail',NULL,NULL,NULL),(183,0,'4camps.com','banned e-mail',NULL,NULL,NULL),(184,0,'4cancer.com','banned e-mail',NULL,NULL,NULL),(185,0,'4candles.com','banned e-mail',NULL,NULL,NULL),(186,0,'4candy.com','banned e-mail',NULL,NULL,NULL),(187,0,'4canton.com','banned e-mail',NULL,NULL,NULL),(188,0,'4capecod.com','banned e-mail',NULL,NULL,NULL),(189,0,'4capital.com','banned e-mail',NULL,NULL,NULL),(190,0,'4carcare.com','banned e-mail',NULL,NULL,NULL),(191,0,'4careers.com','banned e-mail',NULL,NULL,NULL),(192,0,'4caribbeantravel.com','banned e-mail',NULL,NULL,NULL),(193,0,'4carloans.com','banned e-mail',NULL,NULL,NULL),(194,0,'4cartoons.com','banned e-mail',NULL,NULL,NULL),(195,0,'4casper.com','banned e-mail',NULL,NULL,NULL),(196,0,'4catalogs.com','banned e-mail',NULL,NULL,NULL),(197,0,'4caterers.com','banned e-mail',NULL,NULL,NULL),(198,0,'4catholicism.com','banned e-mail',NULL,NULL,NULL),(199,0,'4cats.com','banned e-mail',NULL,NULL,NULL),(200,0,'4cd.com','banned e-mail',NULL,NULL,NULL),(201,0,'4cdrom.com','banned e-mail',NULL,NULL,NULL),(202,0,'4cedarrapids.com','banned e-mail',NULL,NULL,NULL),(203,0,'4cellphones.com','banned e-mail',NULL,NULL,NULL),(204,0,'4censorship.com','banned e-mail',NULL,NULL,NULL),(205,0,'4cerebralpalsy.com','banned e-mail',NULL,NULL,NULL),(206,0,'4champagne.com','banned e-mail',NULL,NULL,NULL),(207,0,'4champaign.com','banned e-mail',NULL,NULL,NULL),(208,0,'4chandler.com','banned e-mail',NULL,NULL,NULL),(209,0,'4charities.com','banned e-mail',NULL,NULL,NULL),(210,0,'4charleston.com','banned e-mail',NULL,NULL,NULL),(211,0,'4charlotte.com','banned e-mail',NULL,NULL,NULL),(212,0,'4charlottesville.com','banned e-mail',NULL,NULL,NULL),(213,0,'4charters.com','banned e-mail',NULL,NULL,NULL),(214,0,'4chatroom.com','banned e-mail',NULL,NULL,NULL),(215,0,'4chattanooga.com','banned e-mail',NULL,NULL,NULL),(216,0,'4cheerleading.com','banned e-mail',NULL,NULL,NULL),(217,0,'4cheese.com','banned e-mail',NULL,NULL,NULL),(218,0,'4chesapeake.com','banned e-mail',NULL,NULL,NULL),(219,0,'4cheyenne.com','banned e-mail',NULL,NULL,NULL),(220,0,'4chicago.com','banned e-mail',NULL,NULL,NULL),(221,0,'4chico.com','banned e-mail',NULL,NULL,NULL),(222,0,'4children.com','banned e-mail',NULL,NULL,NULL),(223,0,'4childrensbooks.com','banned e-mail',NULL,NULL,NULL),(224,0,'4chocolates.com','banned e-mail',NULL,NULL,NULL),(225,0,'4christmas.com','banned e-mail',NULL,NULL,NULL),(226,0,'4chulavista.com','banned e-mail',NULL,NULL,NULL),(227,0,'4cigars.com','banned e-mail',NULL,NULL,NULL),(228,0,'4cincinnati.com','banned e-mail',NULL,NULL,NULL),(229,0,'4cities.com','banned e-mail',NULL,NULL,NULL),(230,0,'4civilrights.com','banned e-mail',NULL,NULL,NULL),(231,0,'4civilwar.com','banned e-mail',NULL,NULL,NULL),(232,0,'4clarksville.com','banned e-mail',NULL,NULL,NULL),(233,0,'4classical.com','banned e-mail',NULL,NULL,NULL),(234,0,'4classiccars.com','banned e-mail',NULL,NULL,NULL),(235,0,'4classicmovies.com','banned e-mail',NULL,NULL,NULL),(236,0,'4classicrock.com','banned e-mail',NULL,NULL,NULL),(237,0,'4classifieds.com','banned e-mail',NULL,NULL,NULL),(238,0,'4cleaning.com','banned e-mail',NULL,NULL,NULL),(239,0,'4clearwater.com','banned e-mail',NULL,NULL,NULL),(240,0,'4cleveland.com','banned e-mail',NULL,NULL,NULL),(241,0,'4clipart.com','banned e-mail',NULL,NULL,NULL),(242,0,'4clocks.com','banned e-mail',NULL,NULL,NULL),(243,0,'4clothes.com','banned e-mail',NULL,NULL,NULL),(244,0,'4coats.com','banned e-mail',NULL,NULL,NULL),(245,0,'4coffee.com','banned e-mail',NULL,NULL,NULL),(246,0,'4coins.com','banned e-mail',NULL,NULL,NULL),(247,0,'4colds.com','banned e-mail',NULL,NULL,NULL),(248,0,'4collectibles.com','banned e-mail',NULL,NULL,NULL),(249,0,'4collectors.com','banned e-mail',NULL,NULL,NULL),(250,0,'4collegebasketball.com','banned e-mail',NULL,NULL,NULL),(251,0,'4collegefootball.com','banned e-mail',NULL,NULL,NULL),(252,0,'4collegelife.com','banned e-mail',NULL,NULL,NULL),(253,0,'4colleges.com','banned e-mail',NULL,NULL,NULL),(254,0,'4cologne.com','banned e-mail',NULL,NULL,NULL),(255,0,'4coloradosprings.com','banned e-mail',NULL,NULL,NULL),(256,0,'4columbia.com','banned e-mail',NULL,NULL,NULL),(257,0,'4columbus.com','banned e-mail',NULL,NULL,NULL),(258,0,'4comedy.com','banned e-mail',NULL,NULL,NULL),(259,0,'4comics.com','banned e-mail',NULL,NULL,NULL),(260,0,'4commercials.com','banned e-mail',NULL,NULL,NULL),(261,0,'4commodities.com','banned e-mail',NULL,NULL,NULL),(262,0,'4companies.com','banned e-mail',NULL,NULL,NULL),(263,0,'4computerbasics.com','banned e-mail',NULL,NULL,NULL),(264,0,'4computerhardware.com','banned e-mail',NULL,NULL,NULL),(265,0,'4computerrental.com','banned e-mail',NULL,NULL,NULL),(266,0,'4computersecurity.com','banned e-mail',NULL,NULL,NULL),(267,0,'4computersoftware.com','banned e-mail',NULL,NULL,NULL),(268,0,'4computertraining.com','banned e-mail',NULL,NULL,NULL),(269,0,'4computerwallpaper.com','banned e-mail',NULL,NULL,NULL),(270,0,'4computing.com','banned e-mail',NULL,NULL,NULL),(271,0,'4concerts.com','banned e-mail',NULL,NULL,NULL),(272,0,'4congress.com','banned e-mail',NULL,NULL,NULL),(273,0,'4conservation.com','banned e-mail',NULL,NULL,NULL),(274,0,'4conspiracytheories.com','banned e-mail',NULL,NULL,NULL),(275,0,'4construction.com','banned e-mail',NULL,NULL,NULL),(276,0,'4consultants.com','banned e-mail',NULL,NULL,NULL),(277,0,'4contactlenses.com','banned e-mail',NULL,NULL,NULL),(278,0,'4contests.com','banned e-mail',NULL,NULL,NULL),(279,0,'4contraception.com','banned e-mail',NULL,NULL,NULL),(280,0,'4controversies.com','banned e-mail',NULL,NULL,NULL),(281,0,'4cookbooks.com','banned e-mail',NULL,NULL,NULL),(282,0,'4cookies.com','banned e-mail',NULL,NULL,NULL),(283,0,'4cooking.com','banned e-mail',NULL,NULL,NULL),(284,0,'4cooks.com','banned e-mail',NULL,NULL,NULL),(285,0,'4cookware.com','banned e-mail',NULL,NULL,NULL),(286,0,'4coolsite.com','banned e-mail',NULL,NULL,NULL),(287,0,'4copiers.com','banned e-mail',NULL,NULL,NULL),(288,0,'4coralsprings.com','banned e-mail',NULL,NULL,NULL),(289,0,'4corona.com','banned e-mail',NULL,NULL,NULL),(290,0,'4corpuschristi.com','banned e-mail',NULL,NULL,NULL),(291,0,'4cosmetics.com','banned e-mail',NULL,NULL,NULL),(292,0,'4cosmeticsurgery.com','banned e-mail',NULL,NULL,NULL),(293,0,'4costumes.com','banned e-mail',NULL,NULL,NULL),(294,0,'4costuming.com','banned e-mail',NULL,NULL,NULL),(295,0,'4cottages.com','banned e-mail',NULL,NULL,NULL),(296,0,'4coughs.com','banned e-mail',NULL,NULL,NULL),(297,0,'4country.com','banned e-mail',NULL,NULL,NULL),(298,0,'4coupons.com','banned e-mail',NULL,NULL,NULL),(299,0,'4couriers.com','banned e-mail',NULL,NULL,NULL),(300,0,'4courses.com','banned e-mail',NULL,NULL,NULL),(301,0,'4cpas.com','banned e-mail',NULL,NULL,NULL),(302,0,'4crafts.com','banned e-mail',NULL,NULL,NULL),(303,0,'4credit4.com','banned e-mail',NULL,NULL,NULL),(304,0,'4creditcards.com','banned e-mail',NULL,NULL,NULL),(305,0,'4crime.com','banned e-mail',NULL,NULL,NULL),(306,0,'4crosswords.com','banned e-mail',NULL,NULL,NULL),(307,0,'4cruise.com','banned e-mail',NULL,NULL,NULL),(308,0,'4cumberland.com','banned e-mail',NULL,NULL,NULL),(309,0,'4currencytrading.com','banned e-mail',NULL,NULL,NULL),(310,0,'4currentevents.com','banned e-mail',NULL,NULL,NULL),(311,0,'4cyberculture.com','banned e-mail',NULL,NULL,NULL),(312,0,'4cycling.com','banned e-mail',NULL,NULL,NULL),(313,0,'4dad.com','banned e-mail',NULL,NULL,NULL),(314,0,'4dallas.com','banned e-mail',NULL,NULL,NULL),(315,0,'4dance.com','banned e-mail',NULL,NULL,NULL),(316,0,'4danville.com','banned e-mail',NULL,NULL,NULL),(317,0,'4databases.com','banned e-mail',NULL,NULL,NULL),(318,0,'4datarecovery.com','banned e-mail',NULL,NULL,NULL),(319,0,'4davenport.com','banned e-mail',NULL,NULL,NULL),(320,0,'4daycare.com','banned e-mail',NULL,NULL,NULL),(321,0,'4dayton.com','banned e-mail',NULL,NULL,NULL),(322,0,'4daytonabeach.com','banned e-mail',NULL,NULL,NULL),(323,0,'4daytrading.com','banned e-mail',NULL,NULL,NULL),(324,0,'4deafcommunity.com','banned e-mail',NULL,NULL,NULL),(325,0,'4debtconsolidation.com','banned e-mail',NULL,NULL,NULL),(326,0,'4debtmanagement.com','banned e-mail',NULL,NULL,NULL),(327,0,'4decatur.com','banned e-mail',NULL,NULL,NULL),(328,0,'4delis.com','banned e-mail',NULL,NULL,NULL),(329,0,'4delivery.com','banned e-mail',NULL,NULL,NULL),(330,0,'4democracy.com','banned e-mail',NULL,NULL,NULL),(331,0,'4democrats.com','banned e-mail',NULL,NULL,NULL),(332,0,'4dentists.com','banned e-mail',NULL,NULL,NULL),(333,0,'4denver.com','banned e-mail',NULL,NULL,NULL),(334,0,'4departmentstores.com','banned e-mail',NULL,NULL,NULL),(335,0,'4designers.com','banned e-mail',NULL,NULL,NULL),(336,0,'4desktoppublishing.com','banned e-mail',NULL,NULL,NULL),(337,0,'4desktopthemes.com','banned e-mail',NULL,NULL,NULL),(338,0,'4desmoines.com','banned e-mail',NULL,NULL,NULL),(339,0,'4desserts.com','banned e-mail',NULL,NULL,NULL),(340,0,'4detroit.com','banned e-mail',NULL,NULL,NULL),(341,0,'4diabetes.com','banned e-mail',NULL,NULL,NULL),(342,0,'4diet.com','banned e-mail',NULL,NULL,NULL),(343,0,'4digitalcameras.com','banned e-mail',NULL,NULL,NULL),(344,0,'4dinner.com','banned e-mail',NULL,NULL,NULL),(345,0,'4dinosaurs.com','banned e-mail',NULL,NULL,NULL),(346,0,'4directions.com','banned e-mail',NULL,NULL,NULL),(347,0,'4directories.com','banned e-mail',NULL,NULL,NULL),(348,0,'4disability.com','banned e-mail',NULL,NULL,NULL),(349,0,'4disco.com','banned e-mail',NULL,NULL,NULL),(350,0,'4discountstores.com','banned e-mail',NULL,NULL,NULL),(351,0,'4divorce.com','banned e-mail',NULL,NULL,NULL),(352,0,'4dolls.com','banned e-mail',NULL,NULL,NULL),(353,0,'4domesticviolence.com','banned e-mail',NULL,NULL,NULL),(354,0,'4dothan.com','banned e-mail',NULL,NULL,NULL),(355,0,'4dresses.com','banned e-mail',NULL,NULL,NULL),(356,0,'4drips.com','banned e-mail',NULL,NULL,NULL),(357,0,'4drugstores.com','banned e-mail',NULL,NULL,NULL),(358,0,'4dublin.com','banned e-mail',NULL,NULL,NULL),(359,0,'4dubuque.com','banned e-mail',NULL,NULL,NULL),(360,0,'4duluth.com','banned e-mail',NULL,NULL,NULL),(361,0,'4durham.com','banned e-mail',NULL,NULL,NULL),(362,0,'4dvdvideo.com','banned e-mail',NULL,NULL,NULL),(363,0,'4earrings.com','banned e-mail',NULL,NULL,NULL),(364,0,'4earthquakes.com','banned e-mail',NULL,NULL,NULL),(365,0,'4easter.com','banned e-mail',NULL,NULL,NULL),(366,0,'4eauclaire.com','banned e-mail',NULL,NULL,NULL),(367,0,'4economics.com','banned e-mail',NULL,NULL,NULL),(368,0,'4edinburgh.com','banned e-mail',NULL,NULL,NULL),(369,0,'4editorials.com','banned e-mail',NULL,NULL,NULL),(370,0,'4education.com','banned e-mail',NULL,NULL,NULL),(371,0,'4educationaltoys.com','banned e-mail',NULL,NULL,NULL),(372,0,'4elections.com','banned e-mail',NULL,NULL,NULL),(373,0,'4electricians.com','banned e-mail',NULL,NULL,NULL),(374,0,'4electroniccommerce.com','banned e-mail',NULL,NULL,NULL),(375,0,'4electronics.com','banned e-mail',NULL,NULL,NULL),(376,0,'4elizabeth.com','banned e-mail',NULL,NULL,NULL),(377,0,'4elkhart.com','banned e-mail',NULL,NULL,NULL),(378,0,'4elmonte.com','banned e-mail',NULL,NULL,NULL),(379,0,'4elpaso.com','banned e-mail',NULL,NULL,NULL),(380,0,'4elvis.com','banned e-mail',NULL,NULL,NULL),(381,0,'4email.com','banned e-mail',NULL,NULL,NULL),(382,0,'4employment.com','banned e-mail',NULL,NULL,NULL),(383,0,'4employmentagencies.com','banned e-mail',NULL,NULL,NULL),(384,0,'4encryption.com','banned e-mail',NULL,NULL,NULL),(385,0,'4endangeredspecies.com','banned e-mail',NULL,NULL,NULL),(386,0,'4engineers.com','banned e-mail',NULL,NULL,NULL),(387,0,'4enid.com','banned e-mail',NULL,NULL,NULL),(388,0,'4entertainment.com','banned e-mail',NULL,NULL,NULL),(389,0,'4entertainmentupdates.com','banned e-mail',NULL,NULL,NULL),(390,0,'4environment.com','banned e-mail',NULL,NULL,NULL),(391,0,'4equipmentleasing.com','banned e-mail',NULL,NULL,NULL),(392,0,'4erie.com','banned e-mail',NULL,NULL,NULL),(393,0,'4escondido.com','banned e-mail',NULL,NULL,NULL),(394,0,'4estateplanning.com','banned e-mail',NULL,NULL,NULL),(395,0,'4ethics.com','banned e-mail',NULL,NULL,NULL),(396,0,'4eugene.com','banned e-mail',NULL,NULL,NULL),(397,0,'4europe.com','banned e-mail',NULL,NULL,NULL),(398,0,'4evansville.com','banned e-mail',NULL,NULL,NULL),(399,0,'4exchangerates.com','banned e-mail',NULL,NULL,NULL),(400,0,'4executivesearch.com','banned e-mail',NULL,NULL,NULL),(401,0,'4exercise.com','banned e-mail',NULL,NULL,NULL),(402,0,'4extreme.com','banned e-mail',NULL,NULL,NULL),(403,0,'4factoryoutlets.com','banned e-mail',NULL,NULL,NULL),(404,0,'4fairytales.com','banned e-mail',NULL,NULL,NULL),(405,0,'4families.com','banned e-mail',NULL,NULL,NULL),(406,0,'4family.com','banned e-mail',NULL,NULL,NULL),(407,0,'4fanclubs.com','banned e-mail',NULL,NULL,NULL),(408,0,'4fargo.com','banned e-mail',NULL,NULL,NULL),(409,0,'4farming.com','banned e-mail',NULL,NULL,NULL),(410,0,'4farminsurance.com','banned e-mail',NULL,NULL,NULL),(411,0,'4fashiondolls.com','banned e-mail',NULL,NULL,NULL),(412,0,'4fatfree.com','banned e-mail',NULL,NULL,NULL),(413,0,'4fathersday.com','banned e-mail',NULL,NULL,NULL),(414,0,'4faxes.com','banned e-mail',NULL,NULL,NULL),(415,0,'4fayetteville.com','banned e-mail',NULL,NULL,NULL),(416,0,'4feet.com','banned e-mail',NULL,NULL,NULL),(417,0,'4fertility.com','banned e-mail',NULL,NULL,NULL),(418,0,'4fiction.com','banned e-mail',NULL,NULL,NULL),(419,0,'4figureskating.com','banned e-mail',NULL,NULL,NULL),(420,0,'4finance.com','banned e-mail',NULL,NULL,NULL),(421,0,'4financial.com','banned e-mail',NULL,NULL,NULL),(422,0,'4financialaid.com','banned e-mail',NULL,NULL,NULL),(423,0,'4financialnews.com','banned e-mail',NULL,NULL,NULL),(424,0,'4financialplanning.com','banned e-mail',NULL,NULL,NULL),(425,0,'4firewalls.com','banned e-mail',NULL,NULL,NULL),(426,0,'4fitchburg.com','banned e-mail',NULL,NULL,NULL),(427,0,'4fitness.com','banned e-mail',NULL,NULL,NULL),(428,0,'4flags.com','banned e-mail',NULL,NULL,NULL),(429,0,'4flint.com','banned e-mail',NULL,NULL,NULL),(430,0,'4floodinsurance.com','banned e-mail',NULL,NULL,NULL),(431,0,'4florence.com','banned e-mail',NULL,NULL,NULL),(432,0,'4flowers.com','banned e-mail',NULL,NULL,NULL),(433,0,'4flu.com','banned e-mail',NULL,NULL,NULL),(434,0,'4flyfishing.com','banned e-mail',NULL,NULL,NULL),(435,0,'4folk.com','banned e-mail',NULL,NULL,NULL),(436,0,'4fontana.com','banned e-mail',NULL,NULL,NULL),(437,0,'4fonts.com','banned e-mail',NULL,NULL,NULL),(438,0,'4foods.com','banned e-mail',NULL,NULL,NULL),(439,0,'4fools.com','banned e-mail',NULL,NULL,NULL),(440,0,'4football.com','banned e-mail',NULL,NULL,NULL),(441,0,'4fortcollins.com','banned e-mail',NULL,NULL,NULL),(442,0,'4fortlauderdale.com','banned e-mail',NULL,NULL,NULL),(443,0,'4fortmyers.com','banned e-mail',NULL,NULL,NULL),(444,0,'4fortpierce.com','banned e-mail',NULL,NULL,NULL),(445,0,'4fortsmith.com','banned e-mail',NULL,NULL,NULL),(446,0,'4fortwaltonbeach.com','banned e-mail',NULL,NULL,NULL),(447,0,'4fortwayne.com','banned e-mail',NULL,NULL,NULL),(448,0,'4fortworth.com','banned e-mail',NULL,NULL,NULL),(449,0,'4franchises.com','banned e-mail',NULL,NULL,NULL),(450,0,'4freestuff.com','banned e-mail',NULL,NULL,NULL),(451,0,'4fremont.com','banned e-mail',NULL,NULL,NULL),(452,0,'4fresno.com','banned e-mail',NULL,NULL,NULL),(453,0,'4frontpage.com','banned e-mail',NULL,NULL,NULL),(454,0,'4fruit.com','banned e-mail',NULL,NULL,NULL),(455,0,'4fullerton.com','banned e-mail',NULL,NULL,NULL),(456,0,'4furnishings.com','banned e-mail',NULL,NULL,NULL),(457,0,'4gadgets.com','banned e-mail',NULL,NULL,NULL),(458,0,'4gadsden.com','banned e-mail',NULL,NULL,NULL),(459,0,'4gainesville.com','banned e-mail',NULL,NULL,NULL),(460,0,'4games.com','banned e-mail',NULL,NULL,NULL),(461,0,'4gameshows.com','banned e-mail',NULL,NULL,NULL),(462,0,'4gardengrove.com','banned e-mail',NULL,NULL,NULL),(463,0,'4gardening.com','banned e-mail',NULL,NULL,NULL),(464,0,'4gardens.com','banned e-mail',NULL,NULL,NULL),(465,0,'4garland.com','banned e-mail',NULL,NULL,NULL),(466,0,'4gary.com','banned e-mail',NULL,NULL,NULL),(467,0,'4gear.com','banned e-mail',NULL,NULL,NULL),(468,0,'4gems.com','banned e-mail',NULL,NULL,NULL),(469,0,'4genealogy.com','banned e-mail',NULL,NULL,NULL),(470,0,'4genx.com','banned e-mail',NULL,NULL,NULL),(471,0,'4gifs.com','banned e-mail',NULL,NULL,NULL),(472,0,'4giftcertificates.com','banned e-mail',NULL,NULL,NULL),(473,0,'4gifts4.com','banned e-mail',NULL,NULL,NULL),(474,0,'4gizmos.com','banned e-mail',NULL,NULL,NULL),(475,0,'4glasses.com','banned e-mail',NULL,NULL,NULL),(476,0,'4glendale.com','banned e-mail',NULL,NULL,NULL),(477,0,'4glensfalls.com','banned e-mail',NULL,NULL,NULL),(478,0,'4golf.com','banned e-mail',NULL,NULL,NULL),(479,0,'4golfing.com','banned e-mail',NULL,NULL,NULL),(480,0,'4golfresorts.com','banned e-mail',NULL,NULL,NULL),(481,0,'4gossip.com','banned e-mail',NULL,NULL,NULL),(482,0,'4gourmets.com','banned e-mail',NULL,NULL,NULL),(483,0,'4government.com','banned e-mail',NULL,NULL,NULL),(484,0,'4graduateschools.com','banned e-mail',NULL,NULL,NULL),(485,0,'4graduation.com','banned e-mail',NULL,NULL,NULL),(486,0,'4grandcanyon.com','banned e-mail',NULL,NULL,NULL),(487,0,'4grandfather.com','banned e-mail',NULL,NULL,NULL),(488,0,'4grandforks.com','banned e-mail',NULL,NULL,NULL),(489,0,'4grandmother.com','banned e-mail',NULL,NULL,NULL),(490,0,'4grandrapids.com','banned e-mail',NULL,NULL,NULL),(491,0,'4gre.com','banned e-mail',NULL,NULL,NULL),(492,0,'4greatfalls.com','banned e-mail',NULL,NULL,NULL),(493,0,'4greeley.com','banned e-mail',NULL,NULL,NULL),(494,0,'4greenbay.com','banned e-mail',NULL,NULL,NULL),(495,0,'4greensboro.com','banned e-mail',NULL,NULL,NULL),(496,0,'4greenville.com','banned e-mail',NULL,NULL,NULL),(497,0,'4greetingcards.com','banned e-mail',NULL,NULL,NULL),(498,0,'4groceries.com','banned e-mail',NULL,NULL,NULL),(499,0,'4grooms.com','banned e-mail',NULL,NULL,NULL),(500,0,'4guitars.com','banned e-mail',NULL,NULL,NULL),(501,0,'4gulfcoast.com','banned e-mail',NULL,NULL,NULL),(502,0,'4gulfport.com','banned e-mail',NULL,NULL,NULL),(503,0,'4gymnastics.com','banned e-mail',NULL,NULL,NULL),(504,0,'4hagerstown.com','banned e-mail',NULL,NULL,NULL),(505,0,'4hair.com','banned e-mail',NULL,NULL,NULL),(506,0,'4hairloss.com','banned e-mail',NULL,NULL,NULL),(507,0,'4halloween.com','banned e-mail',NULL,NULL,NULL),(508,0,'4hampton.com','banned e-mail',NULL,NULL,NULL),(509,0,'4handbags.com','banned e-mail',NULL,NULL,NULL),(510,0,'4hanukkah.com','banned e-mail',NULL,NULL,NULL),(511,0,'4hardware.com','banned e-mail',NULL,NULL,NULL),(512,0,'4harrisburg.com','banned e-mail',NULL,NULL,NULL),(513,0,'4hartford.com','banned e-mail',NULL,NULL,NULL),(514,0,'4hats.com','banned e-mail',NULL,NULL,NULL),(515,0,'4hayward.com','banned e-mail',NULL,NULL,NULL),(516,0,'4headaches.com','banned e-mail',NULL,NULL,NULL),(517,0,'4headhunters.com','banned e-mail',NULL,NULL,NULL),(518,0,'4healthandfitness.com','banned e-mail',NULL,NULL,NULL),(519,0,'4healthfood.com','banned e-mail',NULL,NULL,NULL),(520,0,'4healthinfo.com','banned e-mail',NULL,NULL,NULL),(521,0,'4healthinsurance.com','banned e-mail',NULL,NULL,NULL),(522,0,'4healthymen.com','banned e-mail',NULL,NULL,NULL),(523,0,'4healthywomen.com','banned e-mail',NULL,NULL,NULL),(524,0,'4heartburn.com','banned e-mail',NULL,NULL,NULL),(525,0,'4heavymetal.com','banned e-mail',NULL,NULL,NULL),(526,0,'4henderson.com','banned e-mail',NULL,NULL,NULL),(527,0,'4her.com','banned e-mail',NULL,NULL,NULL),(528,0,'4herbs.com','banned e-mail',NULL,NULL,NULL),(529,0,'4heroes.com','banned e-mail',NULL,NULL,NULL),(530,0,'4hickory.com','banned e-mail',NULL,NULL,NULL),(531,0,'4highschools.com','banned e-mail',NULL,NULL,NULL),(532,0,'4hiking.com','banned e-mail',NULL,NULL,NULL),(533,0,'4hiphop.com','banned e-mail',NULL,NULL,NULL),(534,0,'4history.com','banned e-mail',NULL,NULL,NULL),(535,0,'4hmos.com','banned e-mail',NULL,NULL,NULL),(536,0,'4hobbies.com','banned e-mail',NULL,NULL,NULL),(537,0,'4hockey.com','banned e-mail',NULL,NULL,NULL),(538,0,'4holidays.com','banned e-mail',NULL,NULL,NULL),(539,0,'4holocaust.com','banned e-mail',NULL,NULL,NULL),(540,0,'4home.com','banned e-mail',NULL,NULL,NULL),(541,0,'4homebrew.com','banned e-mail',NULL,NULL,NULL),(542,0,'4homebusiness.com','banned e-mail',NULL,NULL,NULL),(543,0,'4homeequity.com','banned e-mail',NULL,NULL,NULL),(544,0,'4homeimprovement.com','banned e-mail',NULL,NULL,NULL),(545,0,'4homeoffice.com','banned e-mail',NULL,NULL,NULL),(546,0,'4homeopathy.com','banned e-mail',NULL,NULL,NULL),(547,0,'4homeowners.com','banned e-mail',NULL,NULL,NULL),(548,0,'4homepages.com','banned e-mail',NULL,NULL,NULL),(549,0,'4homeschooling.com','banned e-mail',NULL,NULL,NULL),(550,0,'4homesick.com','banned e-mail',NULL,NULL,NULL),(551,0,'4honeymoons.com','banned e-mail',NULL,NULL,NULL),(552,0,'4honolulu.com','banned e-mail',NULL,NULL,NULL),(553,0,'4horoscopes.com','banned e-mail',NULL,NULL,NULL),(554,0,'4horror.com','banned e-mail',NULL,NULL,NULL),(555,0,'4horses.com','banned e-mail',NULL,NULL,NULL),(556,0,'4hospitals.com','banned e-mail',NULL,NULL,NULL),(557,0,'4hostels.com','banned e-mail',NULL,NULL,NULL),(558,0,'4hotel.com','banned e-mail',NULL,NULL,NULL),(559,0,'4hotlines.com','banned e-mail',NULL,NULL,NULL),(560,0,'4hotrods.com','banned e-mail',NULL,NULL,NULL),(561,0,'4hotsprings.com','banned e-mail',NULL,NULL,NULL),(562,0,'4hottubs.com','banned e-mail',NULL,NULL,NULL),(563,0,'4houses.com','banned e-mail',NULL,NULL,NULL),(564,0,'4how2.com','banned e-mail',NULL,NULL,NULL),(565,0,'4howardstern.com','banned e-mail',NULL,NULL,NULL),(566,0,'4humanrights.com','banned e-mail',NULL,NULL,NULL),(567,0,'4huntington.com','banned e-mail',NULL,NULL,NULL),(568,0,'4huntingtonbeach.com','banned e-mail',NULL,NULL,NULL),(569,0,'4huntsville.com','banned e-mail',NULL,NULL,NULL),(570,0,'4hurricanes.com','banned e-mail',NULL,NULL,NULL),(571,0,'4icecream.com','banned e-mail',NULL,NULL,NULL),(572,0,'4independence.com','banned e-mail',NULL,NULL,NULL),(573,0,'4independenceday.com','banned e-mail',NULL,NULL,NULL),(574,0,'4indianapolis.com','banned e-mail',NULL,NULL,NULL),(575,0,'4indierock.com','banned e-mail',NULL,NULL,NULL),(576,0,'4indigestion.com','banned e-mail',NULL,NULL,NULL),(577,0,'4industrialmusic.com','banned e-mail',NULL,NULL,NULL),(578,0,'4industrialsupplies.com','banned e-mail',NULL,NULL,NULL),(579,0,'4industry.com','banned e-mail',NULL,NULL,NULL),(580,0,'4information.com','banned e-mail',NULL,NULL,NULL),(581,0,'4inglewood.com','banned e-mail',NULL,NULL,NULL),(582,0,'4inns.com','banned e-mail',NULL,NULL,NULL),(583,0,'4insects.com','banned e-mail',NULL,NULL,NULL),(584,0,'4insomnia.com','banned e-mail',NULL,NULL,NULL),(585,0,'4inspiration.com','banned e-mail',NULL,NULL,NULL),(586,0,'4instantmessaging.com','banned e-mail',NULL,NULL,NULL),(587,0,'4instruments.com','banned e-mail',NULL,NULL,NULL),(588,0,'4interest.com','banned e-mail',NULL,NULL,NULL),(589,0,'4interiordesign.com','banned e-mail',NULL,NULL,NULL),(590,0,'4internet.com','banned e-mail',NULL,NULL,NULL),(591,0,'4internetservice.com','banned e-mail',NULL,NULL,NULL),(592,0,'4internships.com','banned e-mail',NULL,NULL,NULL),(593,0,'4intranet.com','banned e-mail',NULL,NULL,NULL),(594,0,'4investing.com','banned e-mail',NULL,NULL,NULL),(595,0,'4investmentadvice.com','banned e-mail',NULL,NULL,NULL),(596,0,'4invitations.com','banned e-mail',NULL,NULL,NULL),(597,0,'4iowacity.com','banned e-mail',NULL,NULL,NULL),(598,0,'4ipo.com','banned e-mail',NULL,NULL,NULL),(599,0,'4irvine.com','banned e-mail',NULL,NULL,NULL),(600,0,'4irving.com','banned e-mail',NULL,NULL,NULL),(601,0,'4islands.com','banned e-mail',NULL,NULL,NULL),(602,0,'4italianfood.com','banned e-mail',NULL,NULL,NULL),(603,0,'4jackson.com','banned e-mail',NULL,NULL,NULL),(604,0,'4jacksonville.com','banned e-mail',NULL,NULL,NULL),(605,0,'4jamestown.com','banned e-mail',NULL,NULL,NULL),(606,0,'4janesville.com','banned e-mail',NULL,NULL,NULL),(607,0,'4javascript.com','banned e-mail',NULL,NULL,NULL),(608,0,'4jazz.com','banned e-mail',NULL,NULL,NULL),(609,0,'4jeans.com','banned e-mail',NULL,NULL,NULL),(610,0,'4jerseycity.com','banned e-mail',NULL,NULL,NULL),(611,0,'4jewelry.com','banned e-mail',NULL,NULL,NULL),(612,0,'4johnstown.com','banned e-mail',NULL,NULL,NULL),(613,0,'4jokes.com','banned e-mail',NULL,NULL,NULL),(614,0,'4joplin.com','banned e-mail',NULL,NULL,NULL),(615,0,'4journalism.com','banned e-mail',NULL,NULL,NULL),(616,0,'4journals.com','banned e-mail',NULL,NULL,NULL),(617,0,'4jpegs.com','banned e-mail',NULL,NULL,NULL),(618,0,'4judaism.com','banned e-mail',NULL,NULL,NULL),(619,0,'4kalamazoo.com','banned e-mail',NULL,NULL,NULL),(620,0,'4kankakee.com','banned e-mail',NULL,NULL,NULL),(621,0,'4kansascity.com','banned e-mail',NULL,NULL,NULL),(622,0,'4keywest.com','banned e-mail',NULL,NULL,NULL),(623,0,'4kidshealth.com','banned e-mail',NULL,NULL,NULL),(624,0,'4kidstuff.com','banned e-mail',NULL,NULL,NULL),(625,0,'4killeen.com','banned e-mail',NULL,NULL,NULL),(626,0,'4kingofprussia.com','banned e-mail',NULL,NULL,NULL),(627,0,'4kingsport.com','banned e-mail',NULL,NULL,NULL),(628,0,'4kites.com','banned e-mail',NULL,NULL,NULL),(629,0,'4knoxville.com','banned e-mail',NULL,NULL,NULL),(630,0,'4kokomo.com','banned e-mail',NULL,NULL,NULL),(631,0,'4kosher.com','banned e-mail',NULL,NULL,NULL),(632,0,'4lacrosse.com','banned e-mail',NULL,NULL,NULL),(633,0,'4lafayette.com','banned e-mail',NULL,NULL,NULL),(634,0,'4lakecharles.com','banned e-mail',NULL,NULL,NULL),(635,0,'4lakeland.com','banned e-mail',NULL,NULL,NULL),(636,0,'4lakeplacid.com','banned e-mail',NULL,NULL,NULL),(637,0,'4lakewood.com','banned e-mail',NULL,NULL,NULL),(638,0,'4lancaster.com','banned e-mail',NULL,NULL,NULL),(639,0,'4landscaping.com','banned e-mail',NULL,NULL,NULL),(640,0,'4lansing.com','banned e-mail',NULL,NULL,NULL),(641,0,'4laredo.com','banned e-mail',NULL,NULL,NULL),(642,0,'4lascruces.com','banned e-mail',NULL,NULL,NULL),(643,0,'4laserprinters.com','banned e-mail',NULL,NULL,NULL),(644,0,'4lasvegas.com','banned e-mail',NULL,NULL,NULL),(645,0,'4lateshoppers.com','banned e-mail',NULL,NULL,NULL),(646,0,'4lawns.com','banned e-mail',NULL,NULL,NULL),(647,0,'4lawrence.com','banned e-mail',NULL,NULL,NULL),(648,0,'4lawschools.com','banned e-mail',NULL,NULL,NULL),(649,0,'4lawton.com','banned e-mail',NULL,NULL,NULL),(650,0,'4learning.com','banned e-mail',NULL,NULL,NULL),(651,0,'4leasing.com','banned e-mail',NULL,NULL,NULL),(652,0,'4leather.com','banned e-mail',NULL,NULL,NULL),(653,0,'4legal.com','banned e-mail',NULL,NULL,NULL),(654,0,'4legalinsurance.com','banned e-mail',NULL,NULL,NULL),(655,0,'4lewiston.com','banned e-mail',NULL,NULL,NULL),(656,0,'4lexington.com','banned e-mail',NULL,NULL,NULL),(657,0,'4libraries.com','banned e-mail',NULL,NULL,NULL),(658,0,'4lifeinsurance.com','banned e-mail',NULL,NULL,NULL),(659,0,'4lima.com','banned e-mail',NULL,NULL,NULL),(660,0,'4limos.com','banned e-mail',NULL,NULL,NULL),(661,0,'4lincoln.com','banned e-mail',NULL,NULL,NULL),(662,0,'4linedancing.com','banned e-mail',NULL,NULL,NULL),(663,0,'4lingerie.com','banned e-mail',NULL,NULL,NULL),(664,0,'4liquor.com','banned e-mail',NULL,NULL,NULL),(665,0,'4littlerock.com','banned e-mail',NULL,NULL,NULL),(666,0,'4liveevents.com','banned e-mail',NULL,NULL,NULL),(667,0,'4livonia.com','banned e-mail',NULL,NULL,NULL),(668,0,'4loans4.com','banned e-mail',NULL,NULL,NULL),(669,0,'4london.com','banned e-mail',NULL,NULL,NULL),(670,0,'4longbeach.com','banned e-mail',NULL,NULL,NULL),(671,0,'4longdistance.com','banned e-mail',NULL,NULL,NULL),(672,0,'4longisland.com','banned e-mail',NULL,NULL,NULL),(673,0,'4longview.com','banned e-mail',NULL,NULL,NULL),(674,0,'4losangeles.com','banned e-mail',NULL,NULL,NULL),(675,0,'4lottery.com','banned e-mail',NULL,NULL,NULL),(676,0,'4lowell.com','banned e-mail',NULL,NULL,NULL),(677,0,'4lubbock.com','banned e-mail',NULL,NULL,NULL),(678,0,'4luggage.com','banned e-mail',NULL,NULL,NULL),(679,0,'4lunchtime.com','banned e-mail',NULL,NULL,NULL),(680,0,'4lynchburg.com','banned e-mail',NULL,NULL,NULL),(681,0,'4macon.com','banned e-mail',NULL,NULL,NULL),(682,0,'4macs.com','banned e-mail',NULL,NULL,NULL),(683,0,'4madison.com','banned e-mail',NULL,NULL,NULL),(684,0,'4magazines.com','banned e-mail',NULL,NULL,NULL),(685,0,'4malls.com','banned e-mail',NULL,NULL,NULL),(686,0,'4malpractice.com','banned e-mail',NULL,NULL,NULL),(687,0,'4management.com','banned e-mail',NULL,NULL,NULL),(688,0,'4manchester.com','banned e-mail',NULL,NULL,NULL),(689,0,'4mansfield.com','banned e-mail',NULL,NULL,NULL),(690,0,'4maps.com','banned e-mail',NULL,NULL,NULL),(691,0,'4markets.com','banned e-mail',NULL,NULL,NULL),(692,0,'4marriage.com','banned e-mail',NULL,NULL,NULL),(693,0,'4martialarts.com','banned e-mail',NULL,NULL,NULL),(694,0,'4massage.com','banned e-mail',NULL,NULL,NULL),(695,0,'4maui.com','banned e-mail',NULL,NULL,NULL),(696,0,'4mba.com','banned e-mail',NULL,NULL,NULL),(697,0,'4mcallen.com','banned e-mail',NULL,NULL,NULL),(698,0,'4meat.com','banned e-mail',NULL,NULL,NULL),(699,0,'4medford.com','banned e-mail',NULL,NULL,NULL),(700,0,'4mediation.com','banned e-mail',NULL,NULL,NULL),(701,0,'4medicalbooks.com','banned e-mail',NULL,NULL,NULL),(702,0,'4medicine.com','banned e-mail',NULL,NULL,NULL),(703,0,'4medschools.com','banned e-mail',NULL,NULL,NULL),(704,0,'4meetings.com','banned e-mail',NULL,NULL,NULL),(705,0,'4melbourne.com','banned e-mail',NULL,NULL,NULL),(706,0,'4memorialday.com','banned e-mail',NULL,NULL,NULL),(707,0,'4memphis.com','banned e-mail',NULL,NULL,NULL),(708,0,'4merced.com','banned e-mail',NULL,NULL,NULL),(709,0,'4mesa.com','banned e-mail',NULL,NULL,NULL),(710,0,'4mesquite.com','banned e-mail',NULL,NULL,NULL),(711,0,'4miami.com','banned e-mail',NULL,NULL,NULL),(712,0,'4microbrew.com','banned e-mail',NULL,NULL,NULL),(713,0,'4middleages.com','banned e-mail',NULL,NULL,NULL),(714,0,'4midi.com','banned e-mail',NULL,NULL,NULL),(715,0,'4midland.com','banned e-mail',NULL,NULL,NULL),(716,0,'4milan.com','banned e-mail',NULL,NULL,NULL),(717,0,'4military.com','banned e-mail',NULL,NULL,NULL),(718,0,'4minneapolis.com','banned e-mail',NULL,NULL,NULL),(719,0,'4missoula.com','banned e-mail',NULL,NULL,NULL),(720,0,'4mobile.com','banned e-mail',NULL,NULL,NULL),(721,0,'4mobsters.com','banned e-mail',NULL,NULL,NULL),(722,0,'4modelbuilders.com','banned e-mail',NULL,NULL,NULL),(723,0,'4models.com','banned e-mail',NULL,NULL,NULL),(724,0,'4modems.com','banned e-mail',NULL,NULL,NULL),(725,0,'4modernart.com','banned e-mail',NULL,NULL,NULL),(726,0,'4modesto.com','banned e-mail',NULL,NULL,NULL),(727,0,'4mom.com','banned e-mail',NULL,NULL,NULL),(728,0,'4monaco.com','banned e-mail',NULL,NULL,NULL),(729,0,'4monitors.com','banned e-mail',NULL,NULL,NULL),(730,0,'4monroe.com','banned e-mail',NULL,NULL,NULL),(731,0,'4monterey.com','banned e-mail',NULL,NULL,NULL),(732,0,'4montgomery.com','banned e-mail',NULL,NULL,NULL),(733,0,'4montreal.com','banned e-mail',NULL,NULL,NULL),(734,0,'4morenovalley.com','banned e-mail',NULL,NULL,NULL),(735,0,'4mortgage.com','banned e-mail',NULL,NULL,NULL),(736,0,'4motels.com','banned e-mail',NULL,NULL,NULL),(737,0,'4motherboards.com','banned e-mail',NULL,NULL,NULL),(738,0,'4mothersday.com','banned e-mail',NULL,NULL,NULL),(739,0,'4motivation.com','banned e-mail',NULL,NULL,NULL),(740,0,'4motorcycles.com','banned e-mail',NULL,NULL,NULL),(741,0,'4motorhomes.com','banned e-mail',NULL,NULL,NULL),(742,0,'4mountainbikes.com','banned e-mail',NULL,NULL,NULL),(743,0,'4mountains.com','banned e-mail',NULL,NULL,NULL),(744,0,'4movie.com','banned e-mail',NULL,NULL,NULL),(745,0,'4moviestars.com','banned e-mail',NULL,NULL,NULL),(746,0,'4moving.com','banned e-mail',NULL,NULL,NULL),(747,0,'4mp3audio.com','banned e-mail',NULL,NULL,NULL),(748,0,'4muncie.com','banned e-mail',NULL,NULL,NULL),(749,0,'4museums.com','banned e-mail',NULL,NULL,NULL),(750,0,'4musicals.com','banned e-mail',NULL,NULL,NULL),(751,0,'4musicians.com','banned e-mail',NULL,NULL,NULL),(752,0,'4muskegon.com','banned e-mail',NULL,NULL,NULL),(753,0,'4mutualfunds.com','banned e-mail',NULL,NULL,NULL),(754,0,'4mythology.com','banned e-mail',NULL,NULL,NULL),(755,0,'4nantucket.com','banned e-mail',NULL,NULL,NULL),(756,0,'4napavalley.com','banned e-mail',NULL,NULL,NULL),(757,0,'4naperville.com','banned e-mail',NULL,NULL,NULL),(758,0,'4nashville.com','banned e-mail',NULL,NULL,NULL),(759,0,'4nationalparks.com','banned e-mail',NULL,NULL,NULL),(760,0,'4naturalfoods.com','banned e-mail',NULL,NULL,NULL),(761,0,'4naturalproducts.com','banned e-mail',NULL,NULL,NULL),(762,0,'4netbanks.com','banned e-mail',NULL,NULL,NULL),(763,0,'4netnames.com','banned e-mail',NULL,NULL,NULL),(764,0,'4newage.com','banned e-mail',NULL,NULL,NULL),(765,0,'4newagemusic.com','banned e-mail',NULL,NULL,NULL),(766,0,'4newark.com','banned e-mail',NULL,NULL,NULL),(767,0,'4newbedford.com','banned e-mail',NULL,NULL,NULL),(768,0,'4newcars.com','banned e-mail',NULL,NULL,NULL),(769,0,'4newengland.com','banned e-mail',NULL,NULL,NULL),(770,0,'4newhaven.com','banned e-mail',NULL,NULL,NULL),(771,0,'4newhomes.com','banned e-mail',NULL,NULL,NULL),(772,0,'4newlondon.com','banned e-mail',NULL,NULL,NULL),(773,0,'4neworleans.com','banned e-mail',NULL,NULL,NULL),(774,0,'4newport.com','banned e-mail',NULL,NULL,NULL),(775,0,'4newportnews.com','banned e-mail',NULL,NULL,NULL),(776,0,'4news.com','banned e-mail',NULL,NULL,NULL),(777,0,'4newsgroups.com','banned e-mail',NULL,NULL,NULL),(778,0,'4newsletters.com','banned e-mail',NULL,NULL,NULL),(779,0,'4newspapers.com','banned e-mail',NULL,NULL,NULL),(780,0,'4newsupdates.com','banned e-mail',NULL,NULL,NULL),(781,0,'4newyear.com','banned e-mail',NULL,NULL,NULL),(782,0,'4newyork.com','banned e-mail',NULL,NULL,NULL),(783,0,'4nonfiction.com','banned e-mail',NULL,NULL,NULL),(784,0,'4nonprofits.com','banned e-mail',NULL,NULL,NULL),(785,0,'4norfolk.com','banned e-mail',NULL,NULL,NULL),(786,0,'4norwalk.com','banned e-mail',NULL,NULL,NULL),(787,0,'4notebooks.com','banned e-mail',NULL,NULL,NULL),(788,0,'4novelties.com','banned e-mail',NULL,NULL,NULL),(789,0,'4nurses.com','banned e-mail',NULL,NULL,NULL),(790,0,'4nuts.com','banned e-mail',NULL,NULL,NULL),(791,0,'4oakland.com','banned e-mail',NULL,NULL,NULL),(792,0,'4obituaries.com','banned e-mail',NULL,NULL,NULL),(793,0,'4ocala.com','banned e-mail',NULL,NULL,NULL),(794,0,'4oceanside.com','banned e-mail',NULL,NULL,NULL),(795,0,'4oddities.com','banned e-mail',NULL,NULL,NULL),(796,0,'4odds.com','banned e-mail',NULL,NULL,NULL),(797,0,'4odessa.com','banned e-mail',NULL,NULL,NULL),(798,0,'4officesupplies.com','banned e-mail',NULL,NULL,NULL),(799,0,'4oklahomacity.com','banned e-mail',NULL,NULL,NULL),(800,0,'4oliveoil.com','banned e-mail',NULL,NULL,NULL),(801,0,'4olympia.com','banned e-mail',NULL,NULL,NULL),(802,0,'4omaha.com','banned e-mail',NULL,NULL,NULL),(803,0,'4onlineinvestment.com','banned e-mail',NULL,NULL,NULL),(804,0,'4ontario.com','banned e-mail',NULL,NULL,NULL),(805,0,'4opera.com','banned e-mail',NULL,NULL,NULL),(806,0,'4opportunities.com','banned e-mail',NULL,NULL,NULL),(807,0,'4options.com','banned e-mail',NULL,NULL,NULL),(808,0,'4orange.com','banned e-mail',NULL,NULL,NULL),(809,0,'4orangecounty.com','banned e-mail',NULL,NULL,NULL),(810,0,'4organizers.com','banned e-mail',NULL,NULL,NULL),(811,0,'4orlando.com','banned e-mail',NULL,NULL,NULL),(812,0,'4outdoors.com','banned e-mail',NULL,NULL,NULL),(813,0,'4outerbanks.com','banned e-mail',NULL,NULL,NULL),(814,0,'4overlandpark.com','banned e-mail',NULL,NULL,NULL),(815,0,'4overnight.com','banned e-mail',NULL,NULL,NULL),(816,0,'4owensboro.com','banned e-mail',NULL,NULL,NULL),(817,0,'4oxnard.com','banned e-mail',NULL,NULL,NULL),(818,0,'4packaging.com','banned e-mail',NULL,NULL,NULL),(819,0,'4pager.com','banned e-mail',NULL,NULL,NULL),(820,0,'4palmdale.com','banned e-mail',NULL,NULL,NULL),(821,0,'4palmsprings.com','banned e-mail',NULL,NULL,NULL),(822,0,'4panamacity.com','banned e-mail',NULL,NULL,NULL),(823,0,'4paper.com','banned e-mail',NULL,NULL,NULL),(824,0,'4paris.com','banned e-mail',NULL,NULL,NULL),(825,0,'4parkcity.com','banned e-mail',NULL,NULL,NULL),(826,0,'4parkersburg.com','banned e-mail',NULL,NULL,NULL),(827,0,'4parks.com','banned e-mail',NULL,NULL,NULL),(828,0,'4party.com','banned e-mail',NULL,NULL,NULL),(829,0,'4pasadena.com','banned e-mail',NULL,NULL,NULL),(830,0,'4pascagoula.com','banned e-mail',NULL,NULL,NULL),(831,0,'4pasta.com','banned e-mail',NULL,NULL,NULL),(832,0,'4patentinfo.com','banned e-mail',NULL,NULL,NULL),(833,0,'4paterson.com','banned e-mail',NULL,NULL,NULL),(834,0,'4patios.com','banned e-mail',NULL,NULL,NULL),(835,0,'4payroll.com','banned e-mail',NULL,NULL,NULL),(836,0,'4pcs.com','banned e-mail',NULL,NULL,NULL),(837,0,'4pdas.com','banned e-mail',NULL,NULL,NULL),(838,0,'4pembrokepines.com','banned e-mail',NULL,NULL,NULL),(839,0,'4penpals.com','banned e-mail',NULL,NULL,NULL),(840,0,'4pens.com','banned e-mail',NULL,NULL,NULL),(841,0,'4pensacola.com','banned e-mail',NULL,NULL,NULL),(842,0,'4pensions.com','banned e-mail',NULL,NULL,NULL),(843,0,'4people.com','banned e-mail',NULL,NULL,NULL),(844,0,'4peoria.com','banned e-mail',NULL,NULL,NULL),(845,0,'4perfume.com','banned e-mail',NULL,NULL,NULL),(846,0,'4personalinjury.com','banned e-mail',NULL,NULL,NULL),(847,0,'4petcare.com','banned e-mail',NULL,NULL,NULL),(848,0,'4petites.com','banned e-mail',NULL,NULL,NULL),(849,0,'4pharmaceutical.com','banned e-mail',NULL,NULL,NULL),(850,0,'4philadelphia.com','banned e-mail',NULL,NULL,NULL),(851,0,'4phoenix.com','banned e-mail',NULL,NULL,NULL),(852,0,'4phonenumbers.com','banned e-mail',NULL,NULL,NULL),(853,0,'4photography.com','banned e-mail',NULL,NULL,NULL),(854,0,'4physicians.com','banned e-mail',NULL,NULL,NULL),(855,0,'4pilots.com','banned e-mail',NULL,NULL,NULL),(856,0,'4pinebluff.com','banned e-mail',NULL,NULL,NULL),(857,0,'4pittsburgh.com','banned e-mail',NULL,NULL,NULL),(858,0,'4pittsfield.com','banned e-mail',NULL,NULL,NULL),(859,0,'4pizzas.com','banned e-mail',NULL,NULL,NULL),(860,0,'4plano.com','banned e-mail',NULL,NULL,NULL),(861,0,'4plants.com','banned e-mail',NULL,NULL,NULL),(862,0,'4pms.com','banned e-mail',NULL,NULL,NULL),(863,0,'4poetry.com','banned e-mail',NULL,NULL,NULL),(864,0,'4politicalparties.com','banned e-mail',NULL,NULL,NULL),(865,0,'4politics.com','banned e-mail',NULL,NULL,NULL),(866,0,'4pomona.com','banned e-mail',NULL,NULL,NULL),(867,0,'4ponds.com','banned e-mail',NULL,NULL,NULL),(868,0,'4pools.com','banned e-mail',NULL,NULL,NULL),(869,0,'4pop.com','banned e-mail',NULL,NULL,NULL),(870,0,'4portland.com','banned e-mail',NULL,NULL,NULL),(871,0,'4portsmouth.com','banned e-mail',NULL,NULL,NULL),(872,0,'4poster.com','banned e-mail',NULL,NULL,NULL),(873,0,'4poughkeepsie.com','banned e-mail',NULL,NULL,NULL),(874,0,'4powertools.com','banned e-mail',NULL,NULL,NULL),(875,0,'4prague.com','banned e-mail',NULL,NULL,NULL),(876,0,'4pregnancy.com','banned e-mail',NULL,NULL,NULL),(877,0,'4president.com','banned e-mail',NULL,NULL,NULL),(878,0,'4press.com','banned e-mail',NULL,NULL,NULL),(879,0,'4printers.com','banned e-mail',NULL,NULL,NULL),(880,0,'4programming.com','banned e-mail',NULL,NULL,NULL),(881,0,'4proms.com','banned e-mail',NULL,NULL,NULL),(882,0,'4providence.com','banned e-mail',NULL,NULL,NULL),(883,0,'4provo.com','banned e-mail',NULL,NULL,NULL),(884,0,'4prowrestling.com','banned e-mail',NULL,NULL,NULL),(885,0,'4psychology.com','banned e-mail',NULL,NULL,NULL),(886,0,'4publicrelations.com','banned e-mail',NULL,NULL,NULL),(887,0,'4pueblo.com','banned e-mail',NULL,NULL,NULL),(888,0,'4punkrock.com','banned e-mail',NULL,NULL,NULL),(889,0,'4puzzles.com','banned e-mail',NULL,NULL,NULL),(890,0,'4quitsmoking.com','banned e-mail',NULL,NULL,NULL),(891,0,'4quotes.com','banned e-mail',NULL,NULL,NULL),(892,0,'4racetracks.com','banned e-mail',NULL,NULL,NULL),(893,0,'4radio.com','banned e-mail',NULL,NULL,NULL),(894,0,'4raleigh.com','banned e-mail',NULL,NULL,NULL),(895,0,'4raleighdurham.com','banned e-mail',NULL,NULL,NULL),(896,0,'4ram.com','banned e-mail',NULL,NULL,NULL),(897,0,'4ramadan.com','banned e-mail',NULL,NULL,NULL),(898,0,'4ranchocucamonga.com','banned e-mail',NULL,NULL,NULL),(899,0,'4randb.com','banned e-mail',NULL,NULL,NULL),(900,0,'4rapidcity.com','banned e-mail',NULL,NULL,NULL),(901,0,'4reading.com','banned e-mail',NULL,NULL,NULL),(902,0,'4realestate.com','banned e-mail',NULL,NULL,NULL),(903,0,'4recipes.com','banned e-mail',NULL,NULL,NULL),(904,0,'4records.com','banned e-mail',NULL,NULL,NULL),(905,0,'4redding.com','banned e-mail',NULL,NULL,NULL),(906,0,'4redrocks.com','banned e-mail',NULL,NULL,NULL),(907,0,'4reference.com','banned e-mail',NULL,NULL,NULL),(908,0,'4refinancing.com','banned e-mail',NULL,NULL,NULL),(909,0,'4reggae.com','banned e-mail',NULL,NULL,NULL),(910,0,'4religion.com','banned e-mail',NULL,NULL,NULL),(911,0,'4reminders.com','banned e-mail',NULL,NULL,NULL),(912,0,'4reno.com','banned e-mail',NULL,NULL,NULL),(913,0,'4rental.com','banned e-mail',NULL,NULL,NULL),(914,0,'4republicans.com','banned e-mail',NULL,NULL,NULL),(915,0,'4resorts.com','banned e-mail',NULL,NULL,NULL),(916,0,'4resumes.com','banned e-mail',NULL,NULL,NULL),(917,0,'4retail.com','banned e-mail',NULL,NULL,NULL),(918,0,'4retirement.com','banned e-mail',NULL,NULL,NULL),(919,0,'4retirementplanning.com','banned e-mail',NULL,NULL,NULL),(920,0,'4richland.com','banned e-mail',NULL,NULL,NULL),(921,0,'4richmond.com','banned e-mail',NULL,NULL,NULL),(922,0,'4rings.com','banned e-mail',NULL,NULL,NULL),(923,0,'4riotravel.com','banned e-mail',NULL,NULL,NULL),(924,0,'4riverside.com','banned e-mail',NULL,NULL,NULL),(925,0,'4roadtrips.com','banned e-mail',NULL,NULL,NULL),(926,0,'4rochester.com','banned e-mail',NULL,NULL,NULL),(927,0,'4rock.com','banned e-mail',NULL,NULL,NULL),(928,0,'4rockclimbing.com','banned e-mail',NULL,NULL,NULL),(929,0,'4rockford.com','banned e-mail',NULL,NULL,NULL),(930,0,'4rockvillecentre.com','banned e-mail',NULL,NULL,NULL),(931,0,'4rodeo.com','banned e-mail',NULL,NULL,NULL),(932,0,'4rollerblading.com','banned e-mail',NULL,NULL,NULL),(933,0,'4rollercoasters.com','banned e-mail',NULL,NULL,NULL),(934,0,'4romance.com','banned e-mail',NULL,NULL,NULL),(935,0,'4rome.com','banned e-mail',NULL,NULL,NULL),(936,0,'4runners.com','banned e-mail',NULL,NULL,NULL),(937,0,'4sacramento.com','banned e-mail',NULL,NULL,NULL),(938,0,'4safari.com','banned e-mail',NULL,NULL,NULL),(939,0,'4safety.com','banned e-mail',NULL,NULL,NULL),(940,0,'4saginaw.com','banned e-mail',NULL,NULL,NULL),(941,0,'4sailing.com','banned e-mail',NULL,NULL,NULL),(942,0,'4salem.com','banned e-mail',NULL,NULL,NULL),(943,0,'4salinas.com','banned e-mail',NULL,NULL,NULL),(944,0,'4salsa.com','banned e-mail',NULL,NULL,NULL),(945,0,'4saltlakecity.com','banned e-mail',NULL,NULL,NULL),(946,0,'4sanangelo.com','banned e-mail',NULL,NULL,NULL),(947,0,'4sanantonio.com','banned e-mail',NULL,NULL,NULL),(948,0,'4sanbernardino.com','banned e-mail',NULL,NULL,NULL),(949,0,'4sanbuenaventura.com','banned e-mail',NULL,NULL,NULL),(950,0,'4sandiego.com','banned e-mail',NULL,NULL,NULL),(951,0,'4sanfrancisco.com','banned e-mail',NULL,NULL,NULL),(952,0,'4sanjose.com','banned e-mail',NULL,NULL,NULL),(953,0,'4santa.com','banned e-mail',NULL,NULL,NULL),(954,0,'4santaana.com','banned e-mail',NULL,NULL,NULL),(955,0,'4santaclarita.com','banned e-mail',NULL,NULL,NULL),(956,0,'4santafe.com','banned e-mail',NULL,NULL,NULL),(957,0,'4santarosa.com','banned e-mail',NULL,NULL,NULL),(958,0,'4saratogasprings.com','banned e-mail',NULL,NULL,NULL),(959,0,'4sats.com','banned e-mail',NULL,NULL,NULL),(960,0,'4savannah.com','banned e-mail',NULL,NULL,NULL),(961,0,'4savings.com','banned e-mail',NULL,NULL,NULL),(962,0,'4scanners.com','banned e-mail',NULL,NULL,NULL),(963,0,'4scarves.com','banned e-mail',NULL,NULL,NULL),(964,0,'4scholarships.com','banned e-mail',NULL,NULL,NULL),(965,0,'4school.com','banned e-mail',NULL,NULL,NULL),(966,0,'4scifi.com','banned e-mail',NULL,NULL,NULL),(967,0,'4scores.com','banned e-mail',NULL,NULL,NULL),(968,0,'4scottsdale.com','banned e-mail',NULL,NULL,NULL),(969,0,'4scranton.com','banned e-mail',NULL,NULL,NULL),(970,0,'4screensavers.com','banned e-mail',NULL,NULL,NULL),(971,0,'4scuba.com','banned e-mail',NULL,NULL,NULL),(972,0,'4seafood.com','banned e-mail',NULL,NULL,NULL),(973,0,'4search.com','banned e-mail',NULL,NULL,NULL),(974,0,'4seashore.com','banned e-mail',NULL,NULL,NULL),(975,0,'4seattle.com','banned e-mail',NULL,NULL,NULL),(976,0,'4securities.com','banned e-mail',NULL,NULL,NULL),(977,0,'4sedona.com','banned e-mail',NULL,NULL,NULL),(978,0,'4selfhelp.com','banned e-mail',NULL,NULL,NULL),(979,0,'4seniors.com','banned e-mail',NULL,NULL,NULL),(980,0,'4shakespeare.com','banned e-mail',NULL,NULL,NULL),(981,0,'4shareware.com','banned e-mail',NULL,NULL,NULL),(982,0,'4sharon.com','banned e-mail',NULL,NULL,NULL),(983,0,'4sheboygan.com','banned e-mail',NULL,NULL,NULL),(984,0,'4sherman.com','banned e-mail',NULL,NULL,NULL),(985,0,'4shirts.com','banned e-mail',NULL,NULL,NULL),(986,0,'4shoes.com','banned e-mail',NULL,NULL,NULL),(987,0,'4shopping.com','banned e-mail',NULL,NULL,NULL),(988,0,'4shreveport.com','banned e-mail',NULL,NULL,NULL),(989,0,'4signs.com','banned e-mail',NULL,NULL,NULL),(990,0,'4silkflowers.com','banned e-mail',NULL,NULL,NULL),(991,0,'4silver.com','banned e-mail',NULL,NULL,NULL),(992,0,'4simivalley.com','banned e-mail',NULL,NULL,NULL),(993,0,'4singing.com','banned e-mail',NULL,NULL,NULL),(994,0,'4siouxcity.com','banned e-mail',NULL,NULL,NULL),(995,0,'4siouxfalls.com','banned e-mail',NULL,NULL,NULL),(996,0,'4skateboarding.com','banned e-mail',NULL,NULL,NULL),(997,0,'4skiing.com','banned e-mail',NULL,NULL,NULL),(998,0,'4skincare.com','banned e-mail',NULL,NULL,NULL),(999,0,'4skis.com','banned e-mail',NULL,NULL,NULL),(1000,0,'4snacks.com','banned e-mail',NULL,NULL,NULL),(1001,0,'4sneakers.com','banned e-mail',NULL,NULL,NULL),(1002,0,'4snowboarding.com','banned e-mail',NULL,NULL,NULL),(1003,0,'4soapoperas.com','banned e-mail',NULL,NULL,NULL),(1004,0,'4soccer.com','banned e-mail',NULL,NULL,NULL),(1005,0,'4socialstudies.com','banned e-mail',NULL,NULL,NULL),(1006,0,'4sociology.com','banned e-mail',NULL,NULL,NULL),(1007,0,'4softball.com','banned e-mail',NULL,NULL,NULL),(1008,0,'4songs.com','banned e-mail',NULL,NULL,NULL),(1009,0,'4southbend.com','banned e-mail',NULL,NULL,NULL),(1010,0,'4spas.com','banned e-mail',NULL,NULL,NULL),(1011,0,'4specialtyfoods.com','banned e-mail',NULL,NULL,NULL),(1012,0,'4spices.com','banned e-mail',NULL,NULL,NULL),(1013,0,'4spokane.com','banned e-mail',NULL,NULL,NULL),(1014,0,'4sportfishing.com','banned e-mail',NULL,NULL,NULL),(1015,0,'4sportinggoods.com','banned e-mail',NULL,NULL,NULL),(1016,0,'4sportsnews.com','banned e-mail',NULL,NULL,NULL),(1017,0,'4sportsschedules.com','banned e-mail',NULL,NULL,NULL),(1018,0,'4sportswear.com','banned e-mail',NULL,NULL,NULL),(1019,0,'4spring.com','banned e-mail',NULL,NULL,NULL),(1020,0,'4springbreak.com','banned e-mail',NULL,NULL,NULL),(1021,0,'4springfield.com','banned e-mail',NULL,NULL,NULL),(1022,0,'4springwater.com','banned e-mail',NULL,NULL,NULL),(1023,0,'4stadiums.com','banned e-mail',NULL,NULL,NULL),(1024,0,'4stamford.com','banned e-mail',NULL,NULL,NULL),(1025,0,'4stamps.com','banned e-mail',NULL,NULL,NULL),(1026,0,'4stargazing.com','banned e-mail',NULL,NULL,NULL),(1027,0,'4stars.com','banned e-mail',NULL,NULL,NULL),(1028,0,'4statecollege.com','banned e-mail',NULL,NULL,NULL),(1029,0,'4stationery.com','banned e-mail',NULL,NULL,NULL),(1030,0,'4stcloud.com','banned e-mail',NULL,NULL,NULL),(1031,0,'4steak.com','banned e-mail',NULL,NULL,NULL),(1032,0,'4steamboatsprings.com','banned e-mail',NULL,NULL,NULL),(1033,0,'4stereos.com','banned e-mail',NULL,NULL,NULL),(1034,0,'4sterlingheights.com','banned e-mail',NULL,NULL,NULL),(1035,0,'4steubenville.com','banned e-mail',NULL,NULL,NULL),(1036,0,'4stjoseph.com','banned e-mail',NULL,NULL,NULL),(1037,0,'4stlouis.com','banned e-mail',NULL,NULL,NULL),(1038,0,'4stock.com','banned e-mail',NULL,NULL,NULL),(1039,0,'4stockmarket.com','banned e-mail',NULL,NULL,NULL),(1040,0,'4stockquotes.com','banned e-mail',NULL,NULL,NULL),(1041,0,'4stockton.com','banned e-mail',NULL,NULL,NULL),(1042,0,'4stpatricksday.com','banned e-mail',NULL,NULL,NULL),(1043,0,'4stpaul.com','banned e-mail',NULL,NULL,NULL),(1044,0,'4stpetersburg.com','banned e-mail',NULL,NULL,NULL),(1045,0,'4stress.com','banned e-mail',NULL,NULL,NULL),(1046,0,'4studyabroad.com','banned e-mail',NULL,NULL,NULL),(1047,0,'4substanceabuse.com','banned e-mail',NULL,NULL,NULL),(1048,0,'4subways.com','banned e-mail',NULL,NULL,NULL),(1049,0,'4summer.com','banned e-mail',NULL,NULL,NULL),(1050,0,'4summervacation.com','banned e-mail',NULL,NULL,NULL),(1051,0,'4sunglasses.com','banned e-mail',NULL,NULL,NULL),(1052,0,'4sunnyvale.com','banned e-mail',NULL,NULL,NULL),(1053,0,'4superbowl.com','banned e-mail',NULL,NULL,NULL),(1054,0,'4surfing.com','banned e-mail',NULL,NULL,NULL),(1055,0,'4sweepstakes.com','banned e-mail',NULL,NULL,NULL),(1056,0,'4swimming.com','banned e-mail',NULL,NULL,NULL),(1057,0,'4swing.com','banned e-mail',NULL,NULL,NULL),(1058,0,'4switzerland.com','banned e-mail',NULL,NULL,NULL),(1059,0,'4syracuse.com','banned e-mail',NULL,NULL,NULL),(1060,0,'4tabloids.com','banned e-mail',NULL,NULL,NULL),(1061,0,'4tacoma.com','banned e-mail',NULL,NULL,NULL),(1062,0,'4talentagencies.com','banned e-mail',NULL,NULL,NULL),(1063,0,'4talkradio.com','banned e-mail',NULL,NULL,NULL),(1064,0,'4talkshows.com','banned e-mail',NULL,NULL,NULL),(1065,0,'4tallahassee.com','banned e-mail',NULL,NULL,NULL),(1066,0,'4tampa.com','banned e-mail',NULL,NULL,NULL),(1067,0,'4tattoos.com','banned e-mail',NULL,NULL,NULL),(1068,0,'4taxes.com','banned e-mail',NULL,NULL,NULL),(1069,0,'4tea.com','banned e-mail',NULL,NULL,NULL),(1070,0,'4teams.com','banned e-mail',NULL,NULL,NULL),(1071,0,'4technology.com','banned e-mail',NULL,NULL,NULL),(1072,0,'4teenagers.com','banned e-mail',NULL,NULL,NULL),(1073,0,'4telecommuting.com','banned e-mail',NULL,NULL,NULL),(1074,0,'4teleconference.com','banned e-mail',NULL,NULL,NULL),(1075,0,'4telemarketing.com','banned e-mail',NULL,NULL,NULL),(1076,0,'4tempe.com','banned e-mail',NULL,NULL,NULL),(1077,0,'4temps.com','banned e-mail',NULL,NULL,NULL),(1078,0,'4tennis.com','banned e-mail',NULL,NULL,NULL),(1079,0,'4terrehaute.com','banned e-mail',NULL,NULL,NULL),(1080,0,'4texarkana.com','banned e-mail',NULL,NULL,NULL),(1081,0,'4thanksgiving.com','banned e-mail',NULL,NULL,NULL),(1082,0,'4the50s.com','banned e-mail',NULL,NULL,NULL),(1083,0,'4the60s.com','banned e-mail',NULL,NULL,NULL),(1084,0,'4the70s.com','banned e-mail',NULL,NULL,NULL),(1085,0,'4the80s.com','banned e-mail',NULL,NULL,NULL),(1086,0,'4the90s.com','banned e-mail',NULL,NULL,NULL),(1087,0,'4theater.com','banned e-mail',NULL,NULL,NULL),(1088,0,'4thecoldwar.com','banned e-mail',NULL,NULL,NULL),(1089,0,'4themeparks.com','banned e-mail',NULL,NULL,NULL),(1090,0,'4themillennium.com','banned e-mail',NULL,NULL,NULL),(1091,0,'4thepersonals.com','banned e-mail',NULL,NULL,NULL),(1092,0,'4thousandoaks.com','banned e-mail',NULL,NULL,NULL),(1093,0,'4tickets.com','banned e-mail',NULL,NULL,NULL),(1094,0,'4ties.com','banned e-mail',NULL,NULL,NULL),(1095,0,'4time.com','banned e-mail',NULL,NULL,NULL),(1096,0,'4timeshares.com','banned e-mail',NULL,NULL,NULL),(1097,0,'4tires.com','banned e-mail',NULL,NULL,NULL),(1098,0,'4toledo.com','banned e-mail',NULL,NULL,NULL),(1099,0,'4top40.com','banned e-mail',NULL,NULL,NULL),(1100,0,'4topeka.com','banned e-mail',NULL,NULL,NULL),(1101,0,'4toronto.com','banned e-mail',NULL,NULL,NULL),(1102,0,'4torrance.com','banned e-mail',NULL,NULL,NULL),(1103,0,'4toys.com','banned e-mail',NULL,NULL,NULL),(1104,0,'4trade.com','banned e-mail',NULL,NULL,NULL),(1105,0,'4traffic.com','banned e-mail',NULL,NULL,NULL),(1106,0,'4training.com','banned e-mail',NULL,NULL,NULL),(1107,0,'4trains.com','banned e-mail',NULL,NULL,NULL),(1108,0,'4travel2.com','banned e-mail',NULL,NULL,NULL),(1109,0,'4travelagencies.com','banned e-mail',NULL,NULL,NULL),(1110,0,'4travelbooks.com','banned e-mail',NULL,NULL,NULL),(1111,0,'4travelers.com','banned e-mail',NULL,NULL,NULL),(1112,0,'4trenton.com','banned e-mail',NULL,NULL,NULL),(1113,0,'4trivia.com','banned e-mail',NULL,NULL,NULL),(1114,0,'4tropicalvacations.com','banned e-mail',NULL,NULL,NULL),(1115,0,'4trucks.com','banned e-mail',NULL,NULL,NULL),(1116,0,'4tshirts.com','banned e-mail',NULL,NULL,NULL),(1117,0,'4tucson.com','banned e-mail',NULL,NULL,NULL),(1118,0,'4tulsa.com','banned e-mail',NULL,NULL,NULL),(1119,0,'4tuscaloosa.com','banned e-mail',NULL,NULL,NULL),(1120,0,'4tuxedos.com','banned e-mail',NULL,NULL,NULL),(1121,0,'4tv.com','banned e-mail',NULL,NULL,NULL),(1122,0,'4tvshows.com','banned e-mail',NULL,NULL,NULL),(1123,0,'4twins.com','banned e-mail',NULL,NULL,NULL),(1124,0,'4tyler.com','banned e-mail',NULL,NULL,NULL),(1125,0,'4umbrellas.com','banned e-mail',NULL,NULL,NULL),(1126,0,'4unions.com','banned e-mail',NULL,NULL,NULL),(1127,0,'4universities.com','banned e-mail',NULL,NULL,NULL),(1128,0,'4urbanlegends.com','banned e-mail',NULL,NULL,NULL),(1129,0,'4usedcars.com','banned e-mail',NULL,NULL,NULL),(1130,0,'4utica.com','banned e-mail',NULL,NULL,NULL),(1131,0,'4vacation.com','banned e-mail',NULL,NULL,NULL),(1132,0,'4vacationhomes.com','banned e-mail',NULL,NULL,NULL),(1133,0,'4vail.com','banned e-mail',NULL,NULL,NULL),(1134,0,'4valentine.com','banned e-mail',NULL,NULL,NULL),(1135,0,'4vallejo.com','banned e-mail',NULL,NULL,NULL),(1136,0,'4vancouver.com','banned e-mail',NULL,NULL,NULL),(1137,0,'4vcrs.com','banned e-mail',NULL,NULL,NULL),(1138,0,'4vegetarians.com','banned e-mail',NULL,NULL,NULL),(1139,0,'4venice.com','banned e-mail',NULL,NULL,NULL),(1140,0,'4venturecapital.com','banned e-mail',NULL,NULL,NULL),(1141,0,'4veterans.com','banned e-mail',NULL,NULL,NULL),(1142,0,'4vets.com','banned e-mail',NULL,NULL,NULL),(1143,0,'4victoria.com','banned e-mail',NULL,NULL,NULL),(1144,0,'4videocassettes.com','banned e-mail',NULL,NULL,NULL),(1145,0,'4videogames.com','banned e-mail',NULL,NULL,NULL),(1146,0,'4vietnamwar.com','banned e-mail',NULL,NULL,NULL),(1147,0,'4vinegar.com','banned e-mail',NULL,NULL,NULL),(1148,0,'4virginiabeach.com','banned e-mail',NULL,NULL,NULL),(1149,0,'4virtual.com','banned e-mail',NULL,NULL,NULL),(1150,0,'4virus.com','banned e-mail',NULL,NULL,NULL),(1151,0,'4visalia.com','banned e-mail',NULL,NULL,NULL),(1152,0,'4visualbasic.com','banned e-mail',NULL,NULL,NULL),(1153,0,'4vitamins.com','banned e-mail',NULL,NULL,NULL),(1154,0,'4volleyball.com','banned e-mail',NULL,NULL,NULL),(1155,0,'4volunteer.com','banned e-mail',NULL,NULL,NULL),(1156,0,'4waco.com','banned e-mail',NULL,NULL,NULL),(1157,0,'4wallstreet.com','banned e-mail',NULL,NULL,NULL),(1158,0,'4warren.com','banned e-mail',NULL,NULL,NULL),(1159,0,'4washingtondc.com','banned e-mail',NULL,NULL,NULL),(1160,0,'4watches.com','banned e-mail',NULL,NULL,NULL),(1161,0,'4waterbury.com','banned e-mail',NULL,NULL,NULL),(1162,0,'4watercraft.com','banned e-mail',NULL,NULL,NULL),(1163,0,'4waterfront.com','banned e-mail',NULL,NULL,NULL),(1164,0,'4waterloo.com','banned e-mail',NULL,NULL,NULL),(1165,0,'4waterskiing.com','banned e-mail',NULL,NULL,NULL),(1166,0,'4watersports.com','banned e-mail',NULL,NULL,NULL),(1167,0,'4wausau.com','banned e-mail',NULL,NULL,NULL),(1168,0,'4wavfiles.com','banned e-mail',NULL,NULL,NULL),(1169,0,'4weather.com','banned e-mail',NULL,NULL,NULL),(1170,0,'4webcams.com','banned e-mail',NULL,NULL,NULL),(1171,0,'4webdesign.com','banned e-mail',NULL,NULL,NULL),(1172,0,'4webhosting.com','banned e-mail',NULL,NULL,NULL),(1173,0,'4webmalls.com','banned e-mail',NULL,NULL,NULL),(1174,0,'4wedding.com','banned e-mail',NULL,NULL,NULL),(1175,0,'4weightloss.com','banned e-mail',NULL,NULL,NULL),(1176,0,'4westcovina.com','banned e-mail',NULL,NULL,NULL),(1177,0,'4westpalmbeach.com','banned e-mail',NULL,NULL,NULL),(1178,0,'4whitepages.com','banned e-mail',NULL,NULL,NULL),(1179,0,'4wholesale.com','banned e-mail',NULL,NULL,NULL),(1180,0,'4wichita.com','banned e-mail',NULL,NULL,NULL),(1181,0,'4wichitafalls.com','banned e-mail',NULL,NULL,NULL),(1182,0,'4williamsburg.com','banned e-mail',NULL,NULL,NULL),(1183,0,'4williamsport.com','banned e-mail',NULL,NULL,NULL),(1184,0,'4wilmington.com','banned e-mail',NULL,NULL,NULL),(1185,0,'4windows.com','banned e-mail',NULL,NULL,NULL),(1186,0,'4windsurfing.com','banned e-mail',NULL,NULL,NULL),(1187,0,'4wine.com','banned e-mail',NULL,NULL,NULL),(1188,0,'4winecountry.com','banned e-mail',NULL,NULL,NULL),(1189,0,'4winston-salem.com','banned e-mail',NULL,NULL,NULL),(1190,0,'4winter.com','banned e-mail',NULL,NULL,NULL),(1191,0,'4wirelessdevices.com','banned e-mail',NULL,NULL,NULL),(1192,0,'4woodworking.com','banned e-mail',NULL,NULL,NULL),(1193,0,'4worcester.com','banned e-mail',NULL,NULL,NULL),(1194,0,'4workingmothers.com','banned e-mail',NULL,NULL,NULL),(1195,0,'4worldrecords.com','banned e-mail',NULL,NULL,NULL),(1196,0,'4worldwarii.com','banned e-mail',NULL,NULL,NULL),(1197,0,'4worstofweb.com','banned e-mail',NULL,NULL,NULL),(1198,0,'4writers.com','banned e-mail',NULL,NULL,NULL),(1199,0,'4y2kbug.com','banned e-mail',NULL,NULL,NULL),(1200,0,'4yellowpages.com','banned e-mail',NULL,NULL,NULL),(1201,0,'4yellowstone.com','banned e-mail',NULL,NULL,NULL),(1202,0,'4yoga.comYoga','banned e-mail',NULL,NULL,NULL),(1203,0,'4york.com','banned e-mail',NULL,NULL,NULL),(1204,0,'4youngstown.com','banned e-mail',NULL,NULL,NULL),(1205,0,'4yuma.com','banned e-mail',NULL,NULL,NULL),(1206,0,'4yuma.comn2.com','banned e-mail',NULL,NULL,NULL),(1207,0,'4zoos.com','banned e-mail',NULL,NULL,NULL),(1208,0,'909mail.dk','banned e-mail',NULL,NULL,NULL),(1209,0,'abcflash.net','banned e-mail',NULL,NULL,NULL),(1210,0,'accountant.com','banned e-mail',NULL,NULL,NULL),(1211,0,'adexec.com','banned e-mail',NULL,NULL,NULL),(1212,0,'aggies.org','banned e-mail',NULL,NULL,NULL),(1213,0,'allergist.com','banned e-mail',NULL,NULL,NULL),(1214,0,'alumidirector.com','banned e-mail',NULL,NULL,NULL),(1215,0,'AmExMail.com','banned e-mail',NULL,NULL,NULL),(1216,0,'apexmail.com','banned e-mail',NULL,NULL,NULL),(1217,0,'archeologist.com','banned e-mail',NULL,NULL,NULL),(1218,0,'arrl.net','banned e-mail',NULL,NULL,NULL),(1219,0,'asia.com','banned e-mail',NULL,NULL,NULL),(1220,0,'AWSearch.zzn.com','banned e-mail',NULL,NULL,NULL),(1221,0,'basemail.com.br','banned e-mail',NULL,NULL,NULL),(1222,0,'beer.com','banned e-mail',NULL,NULL,NULL),(1223,0,'berkscounty.com','banned e-mail',NULL,NULL,NULL),(1224,0,'bigfoot.com','banned e-mail',NULL,NULL,NULL),(1225,0,'bimamail.com','banned e-mail',NULL,NULL,NULL),(1226,0,'bstar.com','banned e-mail',NULL,NULL,NULL),(1227,0,'caramail.com','banned e-mail',NULL,NULL,NULL),(1228,0,'cheerful.com','banned e-mail',NULL,NULL,NULL),(1229,0,'chemist.com','banned e-mail',NULL,NULL,NULL),(1230,0,'clerk.com','banned e-mail',NULL,NULL,NULL),(1231,0,'collectiblesuperstore.com','banned e-mail',NULL,NULL,NULL),(1232,0,'columnist.com','banned e-mail',NULL,NULL,NULL),(1233,0,'comic.com','banned e-mail',NULL,NULL,NULL),(1234,0,'compaqsucks.com','banned e-mail',NULL,NULL,NULL),(1235,0,'coolmail.com','banned e-mail',NULL,NULL,NULL),(1236,0,'coolmail.net','banned e-mail',NULL,NULL,NULL),(1237,0,'counselor.com','banned e-mail',NULL,NULL,NULL),(1238,0,'crosswinds.net','banned e-mail',NULL,NULL,NULL),(1239,0,'cruddybuddy.com','banned e-mail',NULL,NULL,NULL),(1240,0,'deliveryman.com','banned e-mail',NULL,NULL,NULL),(1241,0,'diplomats.com','banned e-mail',NULL,NULL,NULL),(1242,0,'dot.com','banned e-mail',NULL,NULL,NULL),(1243,0,'dr.com','banned e-mail',NULL,NULL,NULL),(1244,0,'dragoncon.net','banned e-mail',NULL,NULL,NULL),(1245,0,'eastmail.com','banned e-mail',NULL,NULL,NULL),(1246,0,'email.com','banned e-mail',NULL,NULL,NULL),(1247,0,'email.ro','banned e-mail',NULL,NULL,NULL),(1248,0,'emumail.net','banned e-mail',NULL,NULL,NULL),(1249,0,'engineer.com','banned e-mail',NULL,NULL,NULL),(1250,0,'europe.com','banned e-mail',NULL,NULL,NULL),(1251,0,'execs.com','banned e-mail',NULL,NULL,NULL),(1252,0,'financier.com','banned e-mail',NULL,NULL,NULL),(1253,0,'flashmail.com','banned e-mail',NULL,NULL,NULL),(1254,0,'fnmail.com','banned e-mail',NULL,NULL,NULL),(1255,0,'francemel.com','banned e-mail',NULL,NULL,NULL),(1256,0,'freemail.c3.hu','banned e-mail',NULL,NULL,NULL),(1257,0,'freemail.com','banned e-mail',NULL,NULL,NULL),(1258,0,'freemail.nl','banned e-mail',NULL,NULL,NULL),(1259,0,'freeweb.essenet.it','banned e-mail',NULL,NULL,NULL),(1260,0,'gardener.com','banned e-mail',NULL,NULL,NULL),(1261,0,'geocities.com','banned e-mail',NULL,NULL,NULL),(1262,0,'geologist.com','banned e-mail',NULL,NULL,NULL),(1263,0,'gmail.com','banned e-mail',NULL,NULL,NULL),(1264,0,'gmx.net','banned e-mail',NULL,NULL,NULL),(1265,0,'gnwmail.com','banned e-mail',NULL,NULL,NULL),(1266,0,'go.com','banned e-mail',NULL,NULL,NULL),(1267,0,'goplay.com','banned e-mail',NULL,NULL,NULL),(1268,0,'gotoworld.com','banned e-mail',NULL,NULL,NULL),(1269,0,'grabmail.com','banned e-mail',NULL,NULL,NULL),(1270,0,'graphicdesigner.com','banned e-mail',NULL,NULL,NULL),(1271,0,'hello.net.au','banned e-mail',NULL,NULL,NULL),(1272,0,'hotmail.com','banned e-mail',NULL,NULL,NULL),(1273,0,'hotpop.com','banned e-mail',NULL,NULL,NULL),(1274,0,'india.com','banned e-mail',NULL,NULL,NULL),(1275,0,'insurer.com','banned e-mail',NULL,NULL,NULL),(1276,0,'joinme.com','banned e-mail',NULL,NULL,NULL),(1277,0,'journalist.com','banned e-mail',NULL,NULL,NULL),(1278,0,'joymail.com','banned e-mail',NULL,NULL,NULL),(1279,0,'juno.com','banned e-mail',NULL,NULL,NULL),(1280,0,'kitty.cc','banned e-mail',NULL,NULL,NULL),(1281,0,'lawyer.com','banned e-mail',NULL,NULL,NULL),(1282,0,'legislator.com','banned e-mail',NULL,NULL,NULL),(1283,0,'liquidinformation.net','banned e-mail',NULL,NULL,NULL),(1284,0,'lobbyist.com','banned e-mail',NULL,NULL,NULL),(1285,0,'loja.net','banned e-mail',NULL,NULL,NULL),(1286,0,'lycosmail.com','banned e-mail',NULL,NULL,NULL),(1287,0,'mad.scientist.com','banned e-mail',NULL,NULL,NULL),(1288,0,'mail.com','banned e-mail',NULL,NULL,NULL),(1289,0,'mail.forum.dk','banned e-mail',NULL,NULL,NULL),(1290,0,'mail.kitty.cc','banned e-mail',NULL,NULL,NULL),(1291,0,'mailandnews.com','banned e-mail',NULL,NULL,NULL),(1292,0,'mailbr.com.br','banned e-mail',NULL,NULL,NULL),(1293,0,'mailcity.com','banned e-mail',NULL,NULL,NULL),(1294,0,'mailexcite.com','banned e-mail',NULL,NULL,NULL),(1295,0,'mailgo.com','banned e-mail',NULL,NULL,NULL),(1296,0,'mailroom.com','banned e-mail',NULL,NULL,NULL),(1297,0,'mailstart.com','banned e-mail',NULL,NULL,NULL),(1298,0,'mauimail.com','banned e-mail',NULL,NULL,NULL),(1299,0,'milmail.com','banned e-mail',NULL,NULL,NULL),(1300,0,'minister.com','banned e-mail',NULL,NULL,NULL),(1301,0,'mixmail.com','banned e-mail',NULL,NULL,NULL),(1302,0,'mygale.org','banned e-mail',NULL,NULL,NULL),(1303,0,'mymail.com','banned e-mail',NULL,NULL,NULL),(1304,0,'n2.com','banned e-mail',NULL,NULL,NULL),(1305,0,'n2mail.com','banned e-mail',NULL,NULL,NULL),(1306,0,'netscape.com','banned e-mail',NULL,NULL,NULL),(1307,0,'optician.com','banned e-mail',NULL,NULL,NULL),(1308,0,'pediatrician.com','banned e-mail',NULL,NULL,NULL),(1309,0,'pinoymail.com','banned e-mail',NULL,NULL,NULL),(1310,0,'podox.com','banned e-mail',NULL,NULL,NULL),(1311,0,'podox.sk','banned e-mail',NULL,NULL,NULL),(1312,0,'politician.com','banned e-mail',NULL,NULL,NULL),(1313,0,'post.com','banned e-mail',NULL,NULL,NULL),(1314,0,'post.cz','banned e-mail',NULL,NULL,NULL),(1315,0,'postmark.net','banned e-mail',NULL,NULL,NULL),(1316,0,'postmaster.co.uk','banned e-mail',NULL,NULL,NULL),(1317,0,'pplmail.com','banned e-mail',NULL,NULL,NULL),(1318,0,'presidency.com','banned e-mail',NULL,NULL,NULL),(1319,0,'priest.com','banned e-mail',NULL,NULL,NULL),(1320,0,'publicist.com','banned e-mail',NULL,NULL,NULL),(1321,0,'realtyagent.com','banned e-mail',NULL,NULL,NULL),(1322,0,'registerednurses.com','banned e-mail',NULL,NULL,NULL),(1323,0,'representative.com','banned e-mail',NULL,NULL,NULL),(1324,0,'rescueteam.com','banned e-mail',NULL,NULL,NULL),(1325,0,'rocketmail.com','banned e-mail',NULL,NULL,NULL),(1326,0,'sagra.lu','banned e-mail',NULL,NULL,NULL),(1327,0,'scientist.com','banned e-mail',NULL,NULL,NULL),(1328,0,'sociologist.com','banned e-mail',NULL,NULL,NULL),(1329,0,'start.com.au','banned e-mail',NULL,NULL,NULL),(1330,0,'supernews.com','banned e-mail',NULL,NULL,NULL),(1331,0,'talk21.com','banned e-mail',NULL,NULL,NULL),(1332,0,'techie.com','banned e-mail',NULL,NULL,NULL),(1333,0,'thefreesite.com','banned e-mail',NULL,NULL,NULL),(1334,0,'themail.com','banned e-mail',NULL,NULL,NULL),(1335,0,'tripod.com','banned e-mail',NULL,NULL,NULL),(1336,0,'umpire.com','banned e-mail',NULL,NULL,NULL),(1337,0,'underwriters.com','banned e-mail',NULL,NULL,NULL),(1338,0,'usa.com','banned e-mail',NULL,NULL,NULL),(1339,0,'usa.net','banned e-mail',NULL,NULL,NULL),(1340,0,'uymail.com','banned e-mail',NULL,NULL,NULL),(1341,0,'writeme.com','banned e-mail',NULL,NULL,NULL),(1342,0,'xoom.com','banned e-mail',NULL,NULL,NULL),(1343,0,'yahoo.com','banned e-mail',NULL,NULL,NULL),(1344,0,'zdnetmail.com','banned e-mail',NULL,NULL,NULL),(1345,0,'zensearch.com','banned e-mail',NULL,NULL,NULL),(1346,0,'zipmail.com.br','banned e-mail',NULL,NULL,NULL);
/*!40000 ALTER TABLE `bans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `batch_log`
--

DROP TABLE IF EXISTS `batch_log`;
CREATE TABLE `batch_log` (
  `batch_log_id` int(10) unsigned NOT NULL auto_increment,
  `batch_date_created` int(10) unsigned default NULL,
  `batch_sum_approved` decimal(10,2) default '0.00',
  `batch_sum_declined` decimal(10,2) default '0.00',
  `batch_sum_error` decimal(10,2) default '0.00',
  `batch_num_approved` smallint(5) unsigned default NULL,
  `batch_num_declined` smallint(5) unsigned default NULL,
  `batch_num_error` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`batch_log_id`),
  KEY `batch_date_created` (`batch_date_created`)
);

--
-- Dumping data for table `batch_log`
--

LOCK TABLES `batch_log` WRITE;
/*!40000 ALTER TABLE `batch_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `batch_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bookmarks`
--

DROP TABLE IF EXISTS `bookmarks`;
CREATE TABLE `bookmarks` (
  `bookmark_id` int(8) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `client_id` int(8) unsigned default NULL,
  `bookmark_url` text,
  `bookmark_action` varchar(60) default NULL,
  `bookmark_args` varchar(255) default NULL,
  `bookmark_name` varchar(50) default NULL,
  `bookmark_target` varchar(20) default NULL,
  `bookmark_window_width` smallint(5) unsigned default NULL,
  `bookmark_window_height` smallint(5) unsigned default NULL,
  `bookmark_count` int(8) unsigned default NULL,
  PRIMARY KEY  (`bookmark_id`),
  KEY `client_id` (`client_id`),
  KEY `admin_id` (`admin_id`)
);

--
-- Dumping data for table `bookmarks`
--

LOCK TABLES `bookmarks` WRITE;
/*!40000 ALTER TABLE `bookmarks` DISABLE KEYS */;
/*!40000 ALTER TABLE `bookmarks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `callback_log`
--

DROP TABLE IF EXISTS `callback_log`;
CREATE TABLE `callback_log` (
  `callback_log_id` int(10) unsigned NOT NULL auto_increment,
  `callback_log_type` tinyint(3) unsigned default NULL,
  `callback_log_transaction_id` varchar(255) default NULL,
  `callback_log_parent_transaction_id` varchar(255) default NULL,
  `callback_log_action` varchar(100) default NULL,
  `callback_log_action_status` varchar(100) default NULL,
  `client_id` int(8) unsigned default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  `transaction_id` int(10) unsigned default NULL,
  `subscription_id` int(8) unsigned default NULL,
  `config_group_id` int(8) unsigned default NULL,
  `callback_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`callback_log_id`),
  KEY `callback_log_type` (`callback_log_type`),
  KEY `callback_log_transaction_id` (`callback_log_transaction_id`),
  KEY `callback_log_parent_transaction_id` (`callback_log_parent_transaction_id`),
  KEY `callback_log_action` (`callback_log_action`),
  KEY `callback_log_action_status` (`callback_log_action_status`),
  KEY `client_id` (`client_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `transaction_id` (`transaction_id`),
  KEY `subscription_id` (`subscription_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `callback_log_date_created` (`callback_log_date_created`)
);

--
-- Dumping data for table `callback_log`
--

LOCK TABLES `callback_log` WRITE;
/*!40000 ALTER TABLE `callback_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `callback_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `callback_log_attributes`
--

DROP TABLE IF EXISTS `callback_log_attributes`;
CREATE TABLE `callback_log_attributes` (
  `callback_log_attribute_id` int(15) unsigned NOT NULL auto_increment,
  `callback_log_id` int(10) unsigned default NULL,
  `callback_log_attribute_name` varchar(255) default NULL,
  `callback_log_attribute_value` varchar(255) default NULL,
  PRIMARY KEY  (`callback_log_attribute_id`),
  KEY `callback_log_id` (`callback_log_id`),
  KEY `callback_log_attribute_name` (`callback_log_attribute_name`)
);

--
-- Dumping data for table `callback_log_attributes`
--

LOCK TABLES `callback_log_attributes` WRITE;
/*!40000 ALTER TABLE `callback_log_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `callback_log_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_attributes`
--

DROP TABLE IF EXISTS `client_attributes`;
CREATE TABLE `client_attributes` (
  `client_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `attribute_id` int(10) unsigned default NULL,
  `client_attribute_value` varchar(255) default NULL,
  PRIMARY KEY  (`client_attribute_id`),
  KEY `client_id` (`client_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `attribute_id` (`attribute_id`)
);

--
-- Dumping data for table `client_attributes`
--

LOCK TABLES `client_attributes` WRITE;
/*!40000 ALTER TABLE `client_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_billing_account_shares`
--

DROP TABLE IF EXISTS `client_billing_account_shares`;
CREATE TABLE `client_billing_account_shares` (
  `billing_account_share_id` int(10) unsigned NOT NULL auto_increment,
  `billing_account_id` int(10) unsigned default NULL,
  `package_id` int(10) unsigned default NULL,
  `billing_account_fallback_group` tinyint(3) unsigned default NULL,
  `billing_account_share_group` tinyint(3) unsigned default NULL,
  `billing_account_share_value` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`billing_account_share_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `package_id` (`package_id`),
  KEY `billing_account_share_value` (`billing_account_share_value`),
  KEY `billing_account_fallback_group` (`billing_account_fallback_group`),
  KEY `billing_account_share_group` (`billing_account_share_group`)
);

--
-- Dumping data for table `client_billing_account_shares`
--

LOCK TABLES `client_billing_account_shares` WRITE;
/*!40000 ALTER TABLE `client_billing_account_shares` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_billing_account_shares` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_billing_accounts`
--

DROP TABLE IF EXISTS `client_billing_accounts`;
CREATE TABLE `client_billing_accounts` (
  `billing_account_id` int(10) unsigned NOT NULL auto_increment,
  `prior_billing_account_id` int(10) unsigned default NULL,
  `billing_account_date_failed` int(10) unsigned default '0',
  `billing_account_historical` smallint(3) unsigned default '0',
  `client_contact_id` int(10) unsigned default NULL,
  `billing_card_name_on_card` varchar(255) default NULL,
  `billing_card_type` tinyint(3) unsigned default NULL,
  `billing_card_num` text,
  `billing_card_exp_month` tinyint(3) unsigned default NULL,
  `billing_card_exp_year` smallint(5) unsigned default NULL,
  `billing_card_issue_num` char(3) default NULL,
  `billing_card_start_date` varchar(255) default NULL,
  `protx_security_key` varchar(255) default NULL,
  `protx_transaction_code` varchar(255) default NULL,
  `protx_transaction_id` varchar(255) default NULL,
  `protx_authorization_code` varchar(255) default NULL,
  `velocitypay_cross_reference` varchar(50) default NULL,
  `velocitypay_auth_amount` decimal(10,2) unsigned default NULL,
  `billing_bank_type` varchar(25) default NULL,
  `billing_bank_name` varchar(50) default NULL,
  `billing_bank_aba_code` varchar(20) default NULL,
  `billing_bank_account_num` varchar(255) default NULL,
  `billing_bank_license_num` varchar(25) default NULL,
  `billing_bank_license_state` varchar(50) default NULL,
  `billing_bank_dob` varchar(25) default NULL,
  `billing_bank_state` varchar(50) default NULL,
  `billing_account_num_last_four` varchar(4) default NULL,
  `billing_account_active` tinyint(1) unsigned default '1',
  `billing_account_type` tinyint(3) unsigned default NULL,
  `billing_account_status` tinyint(3) unsigned default '0',
  `sec_gateway_config_group_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`billing_account_id`),
  KEY `client_contact_id` (`client_contact_id`),
  KEY `billing_account_type` (`billing_account_type`),
  KEY `billing_account_date_failed` (`billing_account_date_failed`),
  KEY `protx_security_key` (`protx_security_key`),
  KEY `protx_transaction_code` (`protx_transaction_code`),
  KEY `protx_transaction_id` (`protx_transaction_id`),
  KEY `sec_gateway_config_group_id` (`sec_gateway_config_group_id`),
  KEY `velocitypay_cross_reference` (`velocitypay_cross_reference`),
  KEY `billing_account_status` (`billing_account_status`),
  KEY `prior_billing_account_id` (`prior_billing_account_id`),
  KEY `billing_account_historical` (`billing_account_historical`)
);

--
-- Dumping data for table `client_billing_accounts`
--

LOCK TABLES `client_billing_accounts` WRITE;
/*!40000 ALTER TABLE `client_billing_accounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_billing_accounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_change_log`
--

DROP TABLE IF EXISTS `client_change_log`;
CREATE TABLE `client_change_log` (
  `change_log_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `change_log_db_table_name` varchar(100) default NULL,
  `change_log_db_table_pk` varchar(50) default NULL,
  `change_log_db_table_pkvalue` varchar(50) default NULL,
  `change_log_column_name` varchar(100) default NULL,
  `change_log_old_value` longtext,
  `change_log_new_value` longtext,
  `change_log_action_by` tinyint(3) unsigned default NULL,
  `change_log_action_who` int(10) unsigned default NULL,
  `parent_change_log_id` int(10) unsigned default NULL,
  `change_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`change_log_id`),
  KEY `client_id` (`client_id`),
  KEY `change_log_date_created` (`change_log_date_created`)
);

--
-- Dumping data for table `client_change_log`
--

LOCK TABLES `client_change_log` WRITE;
/*!40000 ALTER TABLE `client_change_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_change_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_children_rel`
--

DROP TABLE IF EXISTS `client_children_rel`;
CREATE TABLE `client_children_rel` (
  `client_id` int(8) unsigned NOT NULL default '0',
  `child_client_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_id`,`child_client_id`)
);

--
-- Dumping data for table `client_children_rel`
--

LOCK TABLES `client_children_rel` WRITE;
/*!40000 ALTER TABLE `client_children_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_children_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_contact_session_rel`
--

DROP TABLE IF EXISTS `client_contact_session_rel`;
CREATE TABLE `client_contact_session_rel` (
  `client_contact_id` int(10) unsigned NOT NULL default '0',
  `session_id` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`client_contact_id`,`session_id`)
);

--
-- Dumping data for table `client_contact_session_rel`
--

LOCK TABLES `client_contact_session_rel` WRITE;
/*!40000 ALTER TABLE `client_contact_session_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_contact_session_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_contacts`
--

DROP TABLE IF EXISTS `client_contacts`;
CREATE TABLE `client_contacts` (
  `client_contact_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `contact_username` varchar(75) default NULL,
  `contact_password` varchar(255) default NULL,
  `contact_temp_password` varchar(255) default NULL,
  `contact_first_name` varchar(100) default NULL,
  `contact_last_name` varchar(100) default NULL,
  `contact_email` varchar(100) default NULL,
  `contact_email_format` tinyint(3) unsigned default NULL,
  `contact_email_invoice_pdf` tinyint(3) unsigned default NULL,
  `contact_company` varchar(100) default NULL,
  `contact_address_1` varchar(100) default NULL,
  `contact_address_2` varchar(100) default NULL,
  `contact_city` varchar(100) default NULL,
  `contact_county` varchar(100) default '',
  `contact_state` varchar(100) default NULL,
  `contact_zip` varchar(100) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `contact_phone1` varchar(25) default NULL,
  `contact_phone2` varchar(25) default NULL,
  `contact_fax` varchar(25) default NULL,
  `contact_mobile_phone` varchar(25) default NULL,
  `contact_date_created` int(10) unsigned default NULL,
  `contact_primary` tinyint(3) unsigned default NULL,
  `contact_active` tinyint(1) unsigned default '1',
  `contact_external_id_1` varchar(50) default NULL,
  `contact_external_id_2` varchar(50) default NULL,
  `contact_external_id_3` varchar(50) default NULL,
  PRIMARY KEY  (`client_contact_id`),
  UNIQUE KEY `contact_username` (`contact_username`),
  KEY `client_id` (`client_id`),
  KEY `contact_password` (`contact_password`),
  KEY `contact_first_name` (`contact_first_name`),
  KEY `contact_last_name` (`contact_last_name`),
  KEY `contact_email` (`contact_email`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`),
  KEY `contact_primary` (`contact_primary`),
  KEY `contact_active` (`contact_active`)
);

--
-- Dumping data for table `client_contacts`
--

LOCK TABLES `client_contacts` WRITE;
/*!40000 ALTER TABLE `client_contacts` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_contacts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_group_rel`
--

DROP TABLE IF EXISTS `client_group_rel`;
CREATE TABLE `client_group_rel` (
  `client_id` int(8) unsigned NOT NULL default '0',
  `client_group_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_id`,`client_group_id`)
);

--
-- Dumping data for table `client_group_rel`
--

LOCK TABLES `client_group_rel` WRITE;
/*!40000 ALTER TABLE `client_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_groups`
--

DROP TABLE IF EXISTS `client_groups`;
CREATE TABLE `client_groups` (
  `client_group_id` int(8) unsigned NOT NULL auto_increment,
  `client_group_name` varchar(50) default NULL,
  PRIMARY KEY  (`client_group_id`)
);

--
-- Dumping data for table `client_groups`
--

LOCK TABLES `client_groups` WRITE;
/*!40000 ALTER TABLE `client_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `client_notes`
--

DROP TABLE IF EXISTS `client_notes`;
CREATE TABLE `client_notes` (
  `client_note_id` int(8) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `admin_id` smallint(5) unsigned default NULL,
  `client_note_date_created` int(10) unsigned default NULL,
  `client_note_date_modified` int(10) unsigned default NULL,
  `client_note_text` longtext,
  PRIMARY KEY  (`client_note_id`),
  KEY `client_id` (`client_id`),
  KEY `admin_id` (`admin_id`)
);

--
-- Dumping data for table `client_notes`
--

LOCK TABLES `client_notes` WRITE;
/*!40000 ALTER TABLE `client_notes` DISABLE KEYS */;
/*!40000 ALTER TABLE `client_notes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `clients`
--

DROP TABLE IF EXISTS `clients`;
CREATE TABLE `clients` (
  `client_id` int(8) unsigned NOT NULL auto_increment,
  `company_id` smallint(5) unsigned default NULL,
  `client_company` varchar(100) default NULL,
  `client_status` smallint(5) unsigned default NULL,
  `client_status_reason` varchar(255) default NULL,
  `apply_tax` tinyint(3) unsigned default NULL,
  `tax_id_number` varchar(50) default NULL,
  `theme_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `client_active` tinyint(1) unsigned default '1',
  `client_mail_invoices` tinyint(1) unsigned default '0',
  `group_id` int(10) unsigned default NULL,
  `client_billing_day` tinyint(2) unsigned default '0',
  `default_billing_account_id` int(10) unsigned default '0',
  `client_date_created` decimal(17,7) unsigned default NULL,
  `client_date_cancelled` int(10) unsigned default NULL,
  `client_signup_ip` bigint(20) default '0',
  `client_last_ip` bigint(20) default '0',
  PRIMARY KEY  (`client_id`),
  KEY `client_status` (`client_status`),
  KEY `client_active` (`client_active`),
  KEY `company_id` (`company_id`),
  KEY `countries_id` (`countries_id`),
  KEY `client_date_cancelled` (`client_date_cancelled`)
);

--
-- Dumping data for table `clients`
--

LOCK TABLES `clients` WRITE;
/*!40000 ALTER TABLE `clients` DISABLE KEYS */;
/*!40000 ALTER TABLE `clients` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `companies`
--

DROP TABLE IF EXISTS `companies`;
CREATE TABLE `companies` (
  `company_id` smallint(5) unsigned NOT NULL auto_increment,
  `company_name` varchar(50) default NULL,
  `company_short_description` text,
  `company_description` text,
  `company_url` varchar(255) default NULL,
  `company_client_url` varchar(255) default NULL,
  `company_order_url` varchar(255) default NULL,
  `company_email` varchar(100) default NULL,
  `company_address_1` varchar(100) default NULL,
  `company_address_2` varchar(100) default NULL,
  `company_city` varchar(100) default NULL,
  `company_state` varchar(100) default NULL,
  `company_zip` varchar(100) default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `company_phone1` varchar(25) default NULL,
  `company_phone2` varchar(25) default NULL,
  `company_fax` varchar(25) default NULL,
  `company_tax_id_number` varchar(50) default NULL,
  PRIMARY KEY  (`company_id`),
  KEY `company_name` (`company_name`),
  KEY `company_tax_id_number` (`company_tax_id_number`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `companies`
--

LOCK TABLES `companies` WRITE;
/*!40000 ALTER TABLE `companies` DISABLE KEYS */;
INSERT INTO `companies` VALUES (1,'COMPANYNAME','COMPANYDESCRIPTION','','COMPANYURL','http://localhost/cvs/app-modernbill-client/','http://localhost/cvs/app-modernbill-order/','','','','','','',225,'','','',NULL);
/*!40000 ALTER TABLE `companies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_admin_group_rel`
--

DROP TABLE IF EXISTS `company_admin_group_rel`;
CREATE TABLE `company_admin_group_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `admin_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`admin_group_id`)
);

--
-- Dumping data for table `company_admin_group_rel`
--

LOCK TABLES `company_admin_group_rel` WRITE;
/*!40000 ALTER TABLE `company_admin_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `company_admin_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_admin_rel`
--

DROP TABLE IF EXISTS `company_admin_rel`;
CREATE TABLE `company_admin_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`admin_id`)
);

--
-- Dumping data for table `company_admin_rel`
--

LOCK TABLES `company_admin_rel` WRITE;
/*!40000 ALTER TABLE `company_admin_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `company_admin_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_client_group_rel`
--

DROP TABLE IF EXISTS `company_client_group_rel`;
CREATE TABLE `company_client_group_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `client_group_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`client_group_id`)
);

--
-- Dumping data for table `company_client_group_rel`
--

LOCK TABLES `company_client_group_rel` WRITE;
/*!40000 ALTER TABLE `company_client_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `company_client_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_news_rel`
--

DROP TABLE IF EXISTS `company_news_rel`;
CREATE TABLE `company_news_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `news_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`news_id`)
);

--
-- Dumping data for table `company_news_rel`
--

LOCK TABLES `company_news_rel` WRITE;
/*!40000 ALTER TABLE `company_news_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `company_news_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_product_rel`
--

DROP TABLE IF EXISTS `company_product_rel`;
CREATE TABLE `company_product_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `product_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`product_id`)
);

--
-- Dumping data for table `company_product_rel`
--

LOCK TABLES `company_product_rel` WRITE;
/*!40000 ALTER TABLE `company_product_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `company_product_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config_groups`
--

DROP TABLE IF EXISTS `config_groups`;
CREATE TABLE `config_groups` (
  `config_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `parent_config_group_id` smallint(5) unsigned default NULL,
  `config_group_name` varchar(100) default NULL,
  `config_group_icon` varchar(25) default NULL,
  `config_group_trans_key` varchar(80) default NULL,
  `config_group_order` smallint(5) unsigned default NULL,
  `config_group_locked` tinyint(3) unsigned default NULL,
  `config_group_action_file` varchar(25) default NULL,
  `config_group_action_name` varchar(50) default NULL,
  PRIMARY KEY  (`config_group_id`),
  KEY `parent_config_group_id` (`parent_config_group_id`),
  KEY `config_group_name` (`config_group_name`),
  KEY `config_group_locked` (`config_group_locked`)
) AUTO_INCREMENT=77;

--
-- Dumping data for table `config_groups`
--

LOCK TABLES `config_groups` WRITE;
/*!40000 ALTER TABLE `config_groups` DISABLE KEYS */;
INSERT INTO `config_groups` VALUES (1,0,'system','040.gif','TRANS_SYSTEM_SETTINGS',1,1,NULL,NULL),(2,1,'internal','','',0,1,'',''),(3,1,'main','','TRANS_MAIN_SYSTEM_SETTINGS',1,1,'',''),(4,1,'encryption','','TRANS_ENCRYPTION_SETTINGS',2,1,'configs.php','EditEncryptionConfigs'),(5,1,'admin','','TRANS_ADMIN_SETTINGS',3,1,'admins.php','ShowAdmins'),(6,1,'migration','','TRANS_MIGRATION_SETTINGS',4,1,'migrate.php','MigrateIntro'),(7,1,'company','','TRANS_COMPANY_SETTINGS',5,1,'companies.php','EditCompany'),(8,1,'versions','','TRANS_VERSIONS',6,1,'',''),(9,0,'payment','041.gif','TRANS_PAYMENT_SETTINGS',2,1,NULL,NULL),(10,9,'paymentGroups','','TRANS_PAYMENT_GROUPS',2,1,'paymentgroups.php','ShowPaymentGroups'),(11,10,'gateway','','TRANS_GATEWAY_MODULES',2,1,'',''),(12,9,'paymentQueue','','TRANS_PAYMENT_QUEUE',3,1,'',''),(13,9,'clientSidePaymentOptions','','TRANS_CLIENT_SIDE_PAYMENT_OPTIONS',4,1,'',''),(14,9,'virtualTerminal','','TRANS_VIRTUAL_TERMINALS',2,1,'paymentgroups.php','ShowVirtualTerminals'),(15,0,'order','045.gif','TRANS_ORDER_SETTINGS',6,1,NULL,NULL),(16,15,'orderforms','','TRANS_ORDER_FORM_SETTINGS',1,1,'orderforms.php','ShowOrderForms'),(17,16,'0','','TRANS_ORDER_FORM',1,1,'orderforms.php','ShowOrderForms'),(18,15,'fraudsets','','TRANS_MANAGE_FRAUD_SETTINGS',2,1,'fraudsets.php','ShowFraudSets'),(19,15,'ppcsets','','TRANS_PPC_SETTINGS',2,1,'modules.php','EditPPCFactoryConfig'),(20,15,'attributes','','TRANS_CUSTOM_ATTRIBUTES',2,1,'orderforms.php','ShowAttributes'),(21,0,'server','043.gif','TRANS_SERVER_SETTINGS',4,1,NULL,NULL),(22,21,'serverGroups','','TRANS_SERVER_GROUP_SETTINGS',2,1,'servergroups.php','ShowServerGroups'),(23,22,'panel','','TRANS_SERVER_MODULES',2,1,'',''),(24,23,'generic','','TRANS_PANEL_GENERIC',1,1,NULL,NULL),(25,23,'directadmin','','TRANS_PANEL_DIRECTADMIN',2,1,NULL,NULL),(26,23,'plesk','','TRANS_PANEL_PLESK',3,1,NULL,NULL),(27,23,'cpanel','','TRANS_PANEL_CPANEL',4,1,NULL,NULL),(28,23,'helm','','TRANS_PANEL_HELM',5,1,NULL,NULL),(29,23,'ensim','','TRANS_PANEL_ENSIM',6,1,NULL,NULL),(30,23,'tcadmin','','TRANS_PANEL_TCADMIN',7,1,NULL,NULL),(31,23,'freeradius','','TRANS_PANEL_FREERADIUS',8,1,NULL,NULL),(32,23,'hostopia','','TRANS_PANEL_HOSTOPIA',9,1,NULL,NULL),(33,23,'interworx','','TRANS_PANEL_INTERWORX',10,1,NULL,NULL),(34,21,'modules','','TRANS_MODULES',2,1,'modules.php','ShowSystemModuleInfo'),(35,0,'product','047.gif','TRANS_PRODUCT_SETTINGS_CONFIGURATION',8,1,NULL,NULL),(36,35,'generic','','TRANS_PRODUCT_SETTINGS',1,1,'products.php','ShowProducts'),(37,35,'managementrules','','TRANS_PRODUCT_MANAGEMENT_SETTINGS',1,1,'',''),(38,35,'cycles','','TRANS_CYCLE_SETTINGS',1,1,'products.php','ShowCycles'),(39,0,'domain','042.gif','TRANS_DOMAIN_SETTINGS',3,1,NULL,NULL),(40,39,'tlds','','TRANS_DOMAIN_TLD_SETTINGS',1,1,'products.php','ShowTLDs'),(41,39,'sync','','TRANS_DOMAIN_SYNC_SETTINGS',2,1,'',''),(42,39,'registrar','','TRANS_REGISTRAR_MODULES',3,1,'registrars.php','ShowRegistrars'),(43,42,'generic','','TRANS_REGISTRAR_GENERIC',1,1,NULL,NULL),(44,42,'enom','','TRANS_REGISTRAR_ENOM',2,1,'modules.php','EditRegistrarConfig'),(45,42,'registercom','','TRANS_REGISTRAR_REGISTERCOM',2,1,'modules.php','EditRegistrarConfig'),(46,42,'opensrs','','TRANS_REGISTRAR_OPENSRS',2,1,'modules.php','EditRegistrarConfig'),(47,0,'billing','044.gif','TRANS_BILLING_SETTINGS',5,1,NULL,NULL),(48,47,'invoice','','TRANS_INVOICE_SETTINGS',3,1,'',''),(49,47,'tax','','TRANS_TAX_SETTINGS',2,1,'taxes.php','ShowTaxZones'),(50,47,'prepaydiscounts','','TRANS_PREPAY_DISCOUNT_TIERS',2,1,'configs.php','ShowPrepayDiscounts'),(51,0,'email','046.gif','TRANS_EMAIL_SETTINGS',7,1,NULL,NULL),(52,51,'emailSettings','','TRANS_EMAIL_SETTINGS',4,1,'modules.php','EditEmailConfig'),(53,51,'templates','','TRANS_EMAIL_TEMPLATE_GROUPS',2,1,'emails.php','ShowEmailTemplateGroups'),(54,0,'automation','048.gif','TRANS_AUTOMATION_SETTINGS',9,1,NULL,NULL),(55,54,'systemQueue','','TRANS_SYSTEM_QUEUE_SETTINGS',1,1,'',''),(56,54,'ipqueue','','TRANS_IP_QUEUE_SETTINGS',2,1,'servers.php','ShowIPLog'),(57,54,'autoSuspension','','TRANS_AUTOSUSPEND_SETTINGS',4,1,'',''),(58,0,'userSettings','049.gif','TRANS_USER_SETTINGS',10,1,NULL,NULL),(59,58,'display','','TRANS_USER_SETTINGS',1,1,'',''),(60,58,'forums','','TRANS_FORUMS_SETTINGS',3,1,'',''),(61,58,'themes','','TRANS_THEME_SETTINGS',4,1,'themes.php','ShowThemes'),(62,0,'other','050.gif','TRANS_OTHER_SETTINGS',11,1,NULL,NULL),(63,62,'faq','','TRANS_FAQ_SETTINGS',1,1,'',''),(64,62,'news','','TRANS_NEWS_SETTINGS',2,1,'',''),(65,62,'affiliates','','TRANS_AFFILIATE_MODULES',3,1,'',''),(66,62,'fraud','','TRANS_FRAUD_MODULES',4,1,NULL,NULL),(67,66,'fraudguardian','','TRANS_OTHER_MODULES_FRAUDGUARDIAN',1,1,'modules.php','EditFraudGuardianConfig'),(68,67,'0','','FraudGuardian',1,0,'modules.php','EditFraudCallConfig'),(69,62,'ppc','','TRANS_PPC_MODULES',5,1,NULL,NULL),(70,69,'ppcfactory','','TRANS_PPC_MODULES_PPCFACTORY',1,1,'modules.php','EditPPCFactoryConfig'),(71,70,'0','','PPCfactory',1,0,'modules.php','EditPPCFactoryConfig'),(72,62,'ssl','','TRANS_SSL_MODULES',6,1,NULL,NULL),(73,72,'sslfactory','','TRANS_SSL_MODULES_SSLFACTORY',1,1,'modules.php','EditSSLFactoryConfig'),(74,26,'0',NULL,'Plesk',1,0,NULL,NULL),(75,11,'paypal',NULL,'TRANS_PAYPAL',1,1,NULL,NULL),(76,75,'0',NULL,'PayPal',1,0,NULL,NULL);
/*!40000 ALTER TABLE `config_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config_param_values`
--

DROP TABLE IF EXISTS `config_param_values`;
CREATE TABLE `config_param_values` (
  `config_param_value_id` int(10) unsigned NOT NULL auto_increment,
  `config_param_id` int(10) unsigned default NULL,
  `config_param_value_name` varchar(75) default NULL,
  `config_param_value_trans_key` varchar(80) default NULL,
  `config_param_value_order` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`config_param_value_id`),
  KEY `config_param_id` (`config_param_id`),
  KEY `config_param_value_order` (`config_param_value_order`)
) AUTO_INCREMENT=279;

--
-- Dumping data for table `config_param_values`
--

LOCK TABLES `config_param_values` WRITE;
/*!40000 ALTER TABLE `config_param_values` DISABLE KEYS */;
INSERT INTO `config_param_values` VALUES (1,3,'0','TRANS_NO',1),(2,3,'1','TRANS_YES',2),(3,8,'charge','TRANS_CHARGE',1),(4,8,'auth','TRANS_AUTH_ONLY',2),(5,9,'0','TRANS_NO',1),(6,9,'1','TRANS_YES',2),(7,10,'0','TRANS_NO',1),(8,10,'1','TRANS_YES',2),(9,11,'0','TRANS_NO',1),(10,11,'1','TRANS_YES',2),(11,12,'0','TRANS_NO',1),(12,12,'1','TRANS_YES',2),(13,13,'0','TRANS_NO',1),(14,13,'1','TRANS_YES',2),(15,14,'0','TRANS_NO',1),(16,14,'1','TRANS_YES',2),(17,15,'0','TRANS_NO',1),(18,15,'1','TRANS_YES',2),(19,18,'0','TRANS_NO',1),(20,18,'1','TRANS_YES',2),(21,19,'0','TRANS_NO',1),(22,19,'1','TRANS_YES',2),(23,20,'0','TRANS_NO',1),(24,20,'1','TRANS_YES',2),(25,21,'0','TRANS_NO',1),(26,21,'1','TRANS_YES',2),(27,22,'0','TRANS_NO',1),(28,22,'1','TRANS_YES',2),(29,23,'0','TRANS_NO',1),(30,23,'1','TRANS_YES',2),(31,24,'0','TRANS_NO',1),(32,24,'1','TRANS_YES',2),(33,25,'0','TRANS_NOW',1),(34,25,'1','TRANS_END_OF_CYCLE',2),(35,26,'0','TRANS_NO',1),(36,26,'1','TRANS_YES',2),(37,27,'0','TRANS_NO',1),(38,27,'1','TRANS_YES',2),(39,28,'0','TRANS_NO',1),(40,28,'1','TRANS_YES',2),(41,29,'0','TRANS_NO',1),(42,29,'1','TRANS_YES',2),(43,30,'0','TRANS_NOW',1),(44,30,'1','TRANS_END_OF_CYCLE',2),(45,31,'0','TRANS_NO',1),(46,31,'1','TRANS_YES',2),(47,32,'0','TRANS_NO',1),(48,32,'1','TRANS_YES',2),(49,33,'0','TRANS_NO',1),(50,33,'1','TRANS_YES',2),(51,34,'0','TRANS_NO',1),(52,34,'1','TRANS_YES',2),(53,36,'0','TRANS_NO',1),(54,36,'1','TRANS_YES',2),(55,40,'0','TRANS_NO',1),(56,40,'1','TRANS_YES',2),(57,41,'0','TRANS_NO',1),(58,41,'1','TRANS_YES',2),(59,42,'0','TRANS_NO',1),(60,42,'1','TRANS_YES',2),(61,43,'0','TRANS_DISABLED',1),(62,43,'1','TRANS_REGISTRAR_AUTORENEW',2),(63,43,'2','TRANS_MODERNBILL_RENEW',3),(64,44,'0','TRANS_NO',1),(65,44,'1','TRANS_YES',2),(66,45,'0','TRANS_NO',1),(67,45,'1','TRANS_YES',2),(68,46,'0','TRANS_NO',1),(69,46,'1','TRANS_YES',2),(70,47,'0','TRANS_NO',1),(71,47,'1','TRANS_YES',2),(72,48,'0','TRANS_NO',1),(73,48,'1','TRANS_YES',2),(74,49,'0','TRANS_NO',1),(75,49,'1','TRANS_YES',2),(76,50,'0','TRANS_NO',1),(77,50,'1','TRANS_YES',2),(78,51,'0','TRANS_NO',1),(79,51,'1','TRANS_YES',2),(80,52,'0','TRANS_NO',1),(81,52,'1','TRANS_YES',2),(82,53,'0','TRANS_NO',1),(83,53,'1','TRANS_YES',2),(84,94,'0','TRANS_NO',1),(85,94,'1','TRANS_YES',2),(86,98,'0','TRANS_NO',1),(87,98,'1','TRANS_YES',2),(88,99,'0','TRANS_NO',1),(89,99,'1','TRANS_YES',2),(90,100,'0','TRANS_NO',1),(91,100,'1','TRANS_YES',2),(92,101,'0','TRANS_DISABLED',1),(93,101,'1','TRANS_REGISTRAR_AUTORENEW',2),(94,101,'2','TRANS_MODERNBILL_RENEW',3),(95,102,'0','TRANS_NO',1),(96,102,'1','TRANS_YES',2),(97,103,'0','TRANS_NO',1),(98,103,'1','TRANS_YES',2),(99,104,'0','TRANS_NO',1),(100,104,'1','TRANS_YES',2),(101,105,'0','TRANS_NO',1),(102,105,'1','TRANS_YES',2),(103,106,'0','TRANS_NO',1),(104,106,'1','TRANS_YES',2),(105,107,'0','TRANS_NO',1),(106,107,'1','TRANS_YES',2),(107,108,'0','TRANS_NO',1),(108,108,'1','TRANS_YES',2),(109,109,'0','TRANS_NO',1),(110,109,'1','TRANS_YES',2),(111,110,'0','TRANS_NO',1),(112,110,'1','TRANS_YES',2),(113,111,'0','TRANS_NO',1),(114,111,'1','TRANS_YES',2),(115,152,'0','TRANS_NO',1),(116,152,'1','TRANS_YES',2),(117,157,'0','TRANS_NO',1),(118,157,'1','TRANS_YES',2),(119,158,'0','TRANS_NO',1),(120,158,'1','TRANS_YES',2),(121,159,'0','TRANS_NO',1),(122,159,'1','TRANS_YES',2),(123,160,'0','TRANS_DISABLED',1),(124,160,'1','TRANS_REGISTRAR_AUTORENEW',2),(125,160,'2','TRANS_MODERNBILL_RENEW',3),(126,161,'0','TRANS_NO',1),(127,161,'1','TRANS_YES',2),(128,162,'0','TRANS_NO',1),(129,162,'1','TRANS_YES',2),(130,163,'0','TRANS_NO',1),(131,163,'1','TRANS_YES',2),(132,164,'0','TRANS_NO',1),(133,164,'1','TRANS_YES',2),(134,165,'0','TRANS_NO',1),(135,165,'1','TRANS_YES',2),(136,166,'0','TRANS_NO',1),(137,166,'1','TRANS_YES',2),(138,167,'0','TRANS_NO',1),(139,167,'1','TRANS_YES',2),(140,168,'0','TRANS_NO',1),(141,168,'1','TRANS_YES',2),(142,169,'0','TRANS_NO',1),(143,169,'1','TRANS_YES',2),(144,170,'0','TRANS_NO',1),(145,170,'1','TRANS_YES',2),(146,211,'anniversary','TRANS_ANNIVERSARY',1),(147,211,'monthly','TRANS_MONTHLY',2),(148,212,'1','1',1),(149,212,'2','2',2),(150,212,'3','3',3),(151,212,'4','4',4),(152,212,'5','5',5),(153,212,'6','6',6),(154,212,'7','7',7),(155,212,'8','8',8),(156,212,'9','9',9),(157,212,'10','10',10),(158,212,'11','11',11),(159,212,'12','12',12),(160,212,'13','13',13),(161,212,'14','14',14),(162,212,'15','15',15),(163,212,'16','16',16),(164,212,'17','17',17),(165,212,'18','18',18),(166,212,'19','19',19),(167,212,'20','20',20),(168,212,'21','21',21),(169,212,'22','22',22),(170,212,'23','23',23),(171,212,'24','24',24),(172,212,'25','25',25),(173,212,'26','26',26),(174,212,'27','27',27),(175,212,'28','28',28),(176,213,'1','1',1),(177,213,'2','2',2),(178,213,'3','3',3),(179,213,'4','4',4),(180,213,'5','5',5),(181,213,'6','6',6),(182,213,'7','7',7),(183,213,'8','8',8),(184,213,'9','9',9),(185,213,'10','10',10),(186,213,'11','11',11),(187,213,'12','12',12),(188,213,'13','13',13),(189,213,'14','14',14),(190,213,'15','15',15),(191,213,'16','16',16),(192,213,'17','17',17),(193,213,'18','18',18),(194,213,'19','19',19),(195,213,'20','20',20),(196,213,'21','21',21),(197,213,'22','22',22),(198,213,'23','23',23),(199,213,'24','24',24),(200,213,'25','25',25),(201,213,'26','26',26),(202,213,'27','27',27),(203,213,'28','28',28),(204,214,'0','TRANS_NO',1),(205,214,'1','TRANS_YES',2),(206,215,'0','TRANS_NO',1),(207,215,'1','TRANS_YES',2),(208,216,'0','TRANS_NO',1),(209,216,'1','TRANS_YES',2),(210,217,'0','TRANS_NO',1),(211,217,'1','TRANS_YES',2),(212,218,'0','TRANS_NO',1),(213,218,'1','TRANS_YES',2),(214,219,'%%ID%%','ID',1),(215,219,'%%SEQ%%','SEQ, example: 123',2),(216,219,'%%CURYEAR%%-%%ID%%','YEAR-ID, example: 01-2006-12345',3),(217,219,'%%CURMONTH%%-%%CURYEAR%%-%%ID%%','MONTH-YEAR-ID, example: 01-2006-12345',4),(218,219,'%%VATYEAR%%-%%ID%%','VATYEAR-ID, example: 10-2006-12345',5),(219,219,'%%VATMONTH%%-%%VATYEAR%%-%%ID%%','VATMONTH-VATYEAR-ID, , example: 10-2006-12345',6),(220,219,'%%CURYEAR%%-%%SEQ%%','YEAR-SEQ, example: 2006-1',7),(221,219,'%%CURMONTH%%-%%CURYEAR%%-%%SEQ%%','MONTH-YEAR-SEQ, example: 01-2006-1',8),(222,219,'%%VATYEAR%%-%%SEQ%%','VATYEAR-SEQ, example: 2006-1',9),(223,219,'%%VATMONTH%%-%%VATYEAR%%-%%SEQ%%','VATMONTH-VATYEAR-SEQ, example: 10-2006-1',10),(224,232,'0','TRANS_RUN_NO',1),(225,232,'1','TRANS_RUN_NO_BALANCE',2),(226,232,'2','TRANS_RUN_PAID',3),(227,232,'3','TRANS_RUN_NOT_PAID',4),(228,233,'0','TRANS_RUN_NO',1),(229,233,'1','TRANS_RUN_NO_BALANCE',2),(230,233,'2','TRANS_RUN_PAID',3),(231,233,'3','TRANS_RUN_NOT_PAID',4),(232,234,'0','TRANS_RUN_NO',1),(233,234,'1','TRANS_RUN_NO_BALANCE',2),(234,234,'2','TRANS_RUN_PAID',3),(235,234,'3','TRANS_RUN_NOT_PAID',4),(236,235,'0','TRANS_RUN_NO',1),(237,235,'1','TRANS_RUN_NO_BALANCE',2),(238,235,'2','TRANS_RUN_PAID',3),(239,235,'3','TRANS_RUN_NOT_PAID',4),(240,236,'0','TRANS_RUN_NO',1),(241,236,'1','TRANS_RUN_NO_BALANCE',2),(242,236,'2','TRANS_RUN_PAID',3),(243,236,'3','TRANS_RUN_NOT_PAID',4),(244,237,'0','TRANS_RUN_AFTER_PANEL',1),(245,237,'1','TRANS_RUN_AFTER_PANEL_FAILURE',2),(246,237,'2','TRANS_RUN_IGNORE_PANEL',3),(247,239,'0','TRANS_NO',1),(248,239,'1','TRANS_YES',2),(249,244,'0','TRANS_NO',1),(250,244,'1','TRANS_YES',2),(251,245,'0','TRANS_NO',1),(252,245,'1','TRANS_YES',2),(253,246,'0','TRANS_NO',1),(254,246,'1','TRANS_YES',2),(255,247,'0','TRANS_NO',1),(256,247,'1','TRANS_YES',2),(257,248,'0','TRANS_NO',1),(258,248,'1','TRANS_YES',2),(259,249,'0','TRANS_NO',1),(260,249,'1','TRANS_YES',2),(261,250,'0','TRANS_NO',1),(262,250,'1','TRANS_YES',2),(263,251,'0','TRANS_NO',1),(264,251,'1','TRANS_YES',2),(265,278,'1','TRANS_YES',1),(266,278,NULL,'TRANS_NO',1),(267,283,'1','TRANS_YES',1),(268,283,NULL,'TRANS_NO',1),(269,284,'1','TRANS_PANEL_ACCOUNT_NAME_RULE_USER_INPUT',1),(270,284,'3','TRANS_PANEL_ACCOUNT_NAME_RULE_FIRST_4DOMAIN_LAST1_TLD',3),(271,284,'5','TRANS_PANEL_ACCOUNT_NAME_RULE_ADD_PREFIX',5),(272,284,'6','TRANS_PANEL_ACCOUNT_NAME_RULE_ADD_SUFFIX',6),(273,284,'7','TRANS_PANEL_ACCOUNT_NAME_RULE_ADD_SEQUENCE',7),(274,284,'8','TRANS_PANEL_ACCOUNT_NAME_RULE_RANDOM',8),(275,285,'1','TRANS_YES',1),(276,285,NULL,'TRANS_NO',1),(277,295,NULL,'TRANS_NO',1),(278,295,'1','TRANS_YES',2);
/*!40000 ALTER TABLE `config_param_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config_params`
--

DROP TABLE IF EXISTS `config_params`;
CREATE TABLE `config_params` (
  `config_param_id` int(10) unsigned NOT NULL auto_increment,
  `config_group_id` smallint(5) unsigned default NULL,
  `config_param_name` varchar(100) default NULL,
  `config_param_value` text,
  `config_param_group_trans_key` varchar(80) default NULL,
  `config_param_trans_key` varchar(80) default NULL,
  `config_param_description` varchar(75) default NULL,
  `config_param_input_type` char(1) default NULL,
  `config_param_required` tinyint(3) unsigned default NULL,
  `config_param_order` smallint(5) unsigned default NULL,
  `config_param_locked` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`config_param_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `config_param_name` (`config_param_name`),
  KEY `config_param_required` (`config_param_required`)
) AUTO_INCREMENT=298;

--
-- Dumping data for table `config_params`
--

LOCK TABLES `config_params` WRITE;
/*!40000 ALTER TABLE `config_params` DISABLE KEYS */;
INSERT INTO `config_params` VALUES (1,2,'license','plesk',NULL,NULL,NULL,NULL,NULL,0,0),(2,2,'registry_0000','',NULL,NULL,NULL,NULL,NULL,0,0),(3,3,'helpdesk_enabled','1','','TRANS_ENABLE_INTERNAL_HELPDESK','TRANS_ENABLE_INTERNAL_HELPDESK_DESC','r',1,1,0),(4,4,'encryption_agree','agree','','TRANS_ENCRYPTION_AGREE','TRANS_ENCRYPTION_AGREE_DESC','t',2,1,0),(5,4,'encryption_hash','AxZBOKAt8C/f1GiiAC3wITm1ebA+x1VyDfdXV1/eybCCCbMbkgMYgS/QJ1daeBKD+lHViy3d7k1RcUERxfFybqRYQjbEImDP39hx7N6ai0nGw4rRHZaR+1Jsrkw1AcMvPIb4JDk=','','TRANS_ENCRYPTION_HASH','TRANS_ENCRYPTION_HASH_DESC','a',3,1,0),(6,4,'lek_pin','Peett/+SAzrxyX2wWZBoe5SuTZOpPiXBDcg=','','TRANS_ENCRYPTION_LEK_PEN','TRANS_ENCRYPTION_LEK_PEN_DESC','p',4,1,0),(7,8,'installVersion','5.3.1-1','','TRANS_INSTALL_VERSION','TRANS_INSTALL_VERSION_DESC','t',2,1,0),(8,12,'transactionAction','charge','','TRANS_PAYMENT_QUEUE_ACTION','TRANS_PAYMENT_QUEUE_ACTION_DESC','s',1,1,0),(9,12,'generateNew','1','','TRANS_PAYMENT_QUEUE_NEW','','r',1,1,0),(10,12,'generateDeclined','1','','TRANS_PAYMENT_QUEUE_DECLINED','','r',1,2,0),(11,12,'generateError','1','','TRANS_PAYMENT_QUEUE_ERROR','','r',1,3,0),(12,12,'generateDueDateOnly','1','','TRANS_PAYMENT_QUEUE_DUE_DATE_ONLY','','r',1,4,0),(13,12,'clearPaymentQueue','1','','TRANS_PAYMENT_QUEUE_CLEAR','TRANS_PAYMENT_QUEUE_CLEAR_DESC','r',1,5,0),(14,12,'try_lesser_amounts','0','','TRANS_PAYMENT_QUEUE_TRY_LESSER_AMOUNTS','TRANS_PAYMENT_QUEUE_TRY_LESSER_AMOUNTS_DESC','r',1,6,0),(15,12,'enable_advanced_share_editing','0','','TRANS_ENABLE_ADVANCED_PAYMENT_SHARE_EDITING','TRANS_ENABLE_ADVANCED_PAYMENT_SHARE_EDITING_DESC','r',1,6,0),(16,12,'batch_run_offset','1','','TRANS_PAYMENT_QUEUE_BATCH_DAYS_BEFORE_DUE','TRANS_PAYMENT_QUEUE_BATCH_DAYS_BEFORE_DUE_DESC','t',1,7,0),(17,12,'payment_queue_line_item_threshold','50','','TRANS_PAYMENT_QUEUE_LINE_ITEM_THRESHOLD','TRANS_PAYMENT_QUEUE_LINE_ITEM_THRESHOLD_DESC','t',1,8,0),(18,13,'card','1','','TRANS_CREDIT_CARD_ACCOUNT','','r',1,1,0),(19,13,'echeck','1','','TRANS_ECHECK_ACCOUNT','','r',1,1,0),(20,13,'bank','1','','TRANS_BANK_DRAFT_ACCOUNT','','r',1,1,0),(21,13,'manual','1','','TRANS_MANUAL_PAYMENT_ACCOUNT','','r',1,1,0),(22,13,'secondary','1','','TRANS_THIRD_PARTY_GATEWAY_ACCOUNT','','r',1,1,0),(23,13,'wire','1','','TRANS_WIRE_ACCOUNT','','r',1,1,0),(24,37,'allowClientUpgrade','1','','TRANS_ALLOW_CLIENT_INITIATED_UPGRADES','','r',1,1,0),(25,37,'whenUpgrade','1','','TRANS_WHEN_SHOULD_CLIENT_INITIATED_UPGRADES_OCCUR','','r',1,2,0),(26,37,'applyUpgradeCredits','1','','TRANS_APPLY_CREDITS_FOR_IMMEDIATE_UPGRADES','','r',1,2,0),(27,37,'provisionUpgrades','1','','TRANS_PROVISION_UPGRADES','','r',1,2,0),(28,37,'generateUpgradeInvoice','1','','TRANS_GENERATE_INVOICE_FOR_IMMEDIATE_UPGRADES','','r',1,2,0),(29,37,'allowClientDowngrade','1','','TRANS_ALLOW_CLIENT_INITIATED_DOWNGRADES','','r',1,2,0),(30,37,'whenDowngrade','1','','TRANS_WHEN_SHOULD_CLIENT_INITIATED_DOWNGRADES_OCCUR','','r',1,2,0),(31,37,'applyDowngradeCredits','1','','TRANS_APPLY_CREDITS_FOR_IMMEDIATE_DOWNGRADES','','r',1,2,0),(32,37,'provisionDowngrades','1','','TRANS_PROVISION_DOWNGRADES','','r',1,2,0),(33,37,'generateDowngradeInvoice','1','','TRANS_GENERATE_INVOICE_FOR_IMMEDIATE_DOWNGRADES','','r',1,2,0),(34,37,'allowClientAddonManagement','1','','TRANS_ALLOW_CLIENT_INITIATED_ADDON_MANAGEMENT','','r',1,3,0),(35,41,'count','100','','TRANS_DOMAIN_SYNC_COUNT','TRANS_DOMAIN_SYNC_COUNT_DESC','t',NULL,0,0),(36,44,'moduleEnabled','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENABLE_ENOM','','r',1,1,0),(37,44,'moduleDisplayName','','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_DISPLAY_NAME','','t',0,2,0),(38,44,'moduleUsername','','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_USERNAME','','t',0,3,0),(39,44,'modulePassword','','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_PASSWORD','','p',0,4,0),(40,44,'moduleTestMode','1','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_ENABLE_TEST_MODE','','r',0,5,0),(41,44,'moduleAllowDomainPassword','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_DOMAIN_PASSWORD','TRANS_REGISTRAR_ENOM_ALLOW_DOMAIN_PASSWORD_DESC','r',0,6,0),(42,44,'moduleAllowRegistrarLock','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_REGISTRAR_LOCK','TRANS_REGISTRAR_ENOM_ALLOW_REGISTRAR_LOCK_DESC','r',0,7,0),(43,44,'moduleAllowAutorenew','2','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_AUTORENEW','TRANS_REGISTRAR_ENOM_ALLOW_AUTORENEW_DESC','r',0,8,0),(44,44,'moduleAllowNameserverOverride','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_NAMESERVER_OVERRIDE','TRANS_REGISTRAR_ENOM_ALLOW_NAMESERVER_OVERRIDE_DESC','r',0,9,0),(45,44,'moduleUseCustomNameserver','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_USE_CUSTOM_NAMESERVER','TRANS_REGISTRAR_ENOM_USE_CUSTOM_NAMESERVER_DESC','r',0,10,0),(46,44,'moduleAllowRenew','1','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_RENEW','TRANS_REGISTRAR_ENOM_ALLOW_RENEW_DESC','r',0,11,0),(47,44,'moduleAllowTransfer','1','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_TRANSFER','TRANS_REGISTRAR_ENOM_ALLOW_TRANSFER_DESC','r',0,12,0),(48,44,'moduleAllowChangeDNS','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_DNS','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_DNS_DESC','r',0,13,0),(49,44,'moduleAllowChangeContactInfo','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_CONTACT_INFO','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_CONTACT_INFO_DESC','r',0,14,0),(50,44,'moduleAllowChangeRegistrarLock','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_CHAGE_REGISTRAR_LOCK','TRANS_REGISTRAR_ENOM_ALLOW_CHAGE_REGISTRAR_LOCK_DESC','r',0,15,0),(51,44,'moduleAllowChangeAutorenew','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_AUTORENEW','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_AUTORENEW_DESC','r',0,16,0),(52,44,'moduleAllowChangeUpdateDomainPassword','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_UPDATE_DOMAIN_PASSWORD','TRANS_REGISTRAR_ENOM_ALLOW_CHANGE_UPDATE_DOMAIN_PASSWORD_DESC','r',0,17,0),(53,44,'moduleAllowRegisterNameServer','0','TRANS_ENOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENOM_ALLOW_REGISTER_NAME_SERVER','TRANS_REGISTRAR_ENOM_ALLOW_REGISTER_NAME_SERVER_DESC','r',10,18,1),(54,44,'adminFirstName','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,19,0),(55,44,'adminLastName','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,20,0),(56,44,'adminCompany','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,21,0),(57,44,'adminEmail','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,22,0),(58,44,'adminAddress1','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,23,0),(59,44,'adminAddress2','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,24,0),(60,44,'adminCity','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_CITY','','t',0,25,0),(61,44,'adminState','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_STATE','','t',0,26,0),(62,44,'adminPostalCode','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,27,0),(63,44,'adminCountry','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,28,0),(64,44,'adminPhone','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,29,0),(65,44,'adminFax','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_FAX','','t',0,30,0),(66,44,'techFirstName','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,31,0),(67,44,'techLastName','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,32,0),(68,44,'techCompany','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,33,0),(69,44,'techEmail','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,34,0),(70,44,'techAddress1','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,35,0),(71,44,'techAddress2','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,36,0),(72,44,'techCity','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_CITY','','t',0,37,0),(73,44,'techState','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_STATE','','t',0,38,0),(74,44,'techPostalCode','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,39,0),(75,44,'techCountry','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,40,0),(76,44,'techPhone','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,41,0),(77,44,'techFax','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_FAX','','t',0,42,0),(78,44,'auxBillingFirstName','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,43,0),(79,44,'auxBillingLastName','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,44,0),(80,44,'auxBillingCompany','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,45,0),(81,44,'auxBillingEmail','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,46,0),(82,44,'auxBillingAddress1','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,47,0),(83,44,'auxBillingAddress2','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,48,0),(84,44,'auxBillingCity','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_CITY','','t',0,49,0),(85,44,'auxBillingState','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_STATE','','t',0,50,0),(86,44,'auxBillingPostalCode','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,51,0),(87,44,'auxBillingCountry','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,52,0),(88,44,'auxBillingPhone','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,53,0),(89,44,'auxBillingFax','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_FAX','','t',0,54,0),(90,44,'domainNameserver1','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS1','','t',0,55,0),(91,44,'domainNameserver2','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS2','','t',0,56,0),(92,44,'domainNameserver3','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS3','','t',0,57,0),(93,44,'domainNameserver4','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS4','','t',0,58,0),(94,45,'moduleEnabled','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENABLE_REGISTERCOM','','r',1,1,0),(95,45,'moduleDisplayName','','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_DISPLAY_NAME','','t',0,2,0),(96,45,'moduleUsername','','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_USERNAME','','t',0,3,0),(97,45,'modulePassword','','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_PASSWORD','','p',0,4,0),(98,45,'moduleTestMode','1','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_ENABLE_TEST_MODE','','r',0,5,0),(99,45,'moduleAllowDomainPassword','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_DOMAIN_PASSWORD','TRANS_REGISTRAR_REGISTERCOM_ALLOW_DOMAIN_PASSWORD_DESC','r',0,6,0),(100,45,'moduleAllowRegistrarLock','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_REGISTRAR_LOCK','TRANS_REGISTRAR_REGISTERCOM_ALLOW_REGISTRAR_LOCK_DESC','r',0,7,0),(101,45,'moduleAllowAutorenew','2','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_AUTORENEW','TRANS_REGISTRAR_REGISTERCOM_ALLOW_AUTORENEW_DESC','r',0,8,0),(102,45,'moduleAllowNameserverOverride','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_NAMESERVER_OVERRIDE','TRANS_REGISTRAR_REGISTERCOM_ALLOW_NAMESERVER_OVERRIDE_DESC','r',0,9,0),(103,45,'moduleUseCustomNameserver','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_USE_CUSTOM_NAMESERVER','TRANS_REGISTRAR_REGISTERCOM_USE_CUSTOM_NAMESERVER_DESC','r',0,10,0),(104,45,'moduleAllowRenew','1','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_RENEW','TRANS_REGISTRAR_REGISTERCOM_ALLOW_RENEW_DESC','r',0,11,0),(105,45,'moduleAllowTransfer','1','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_TRANSFER','TRANS_REGISTRAR_REGISTERCOM_ALLOW_TRANSFER_DESC','r',0,12,0),(106,45,'moduleAllowChangeDNS','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_DNS','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_DNS_DESC','r',0,13,0),(107,45,'moduleAllowChangeContactInfo','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_CONTACT_INFO','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_CONTACT_INFO_DESC','r',0,14,0),(108,45,'moduleAllowChangeRegistrarLock','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHAGE_REGISTRAR_LOCK','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHAGE_REGISTRAR_LOCK_DESC','r',0,15,0),(109,45,'moduleAllowChangeAutorenew','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_AUTORENEW','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_AUTORENEW_DESC','r',0,16,0),(110,45,'moduleAllowChangeUpdateDomainPassword','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_UPDATE_DOMAIN_PASSWORD','TRANS_REGISTRAR_REGISTERCOM_ALLOW_CHANGE_UPDATE_DOMAIN_PASSWORD_DESC','r',0,17,0),(111,45,'moduleAllowRegisterNameServer','0','TRANS_REGISTERCOM_ADMIN_ACCOUNT','TRANS_REGISTRAR_REGISTERCOM_ALLOW_REGISTER_NAME_SERVER','TRANS_REGISTRAR_REGISTERCOM_ALLOW_REGISTER_NAME_SERVER_DESC','r',10,18,1),(112,45,'adminFirstName','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,19,0),(113,45,'adminLastName','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,20,0),(114,45,'adminCompany','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,21,0),(115,45,'adminEmail','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,22,0),(116,45,'adminAddress1','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,23,0),(117,45,'adminAddress2','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,24,0),(118,45,'adminCity','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_CITY','','t',0,25,0),(119,45,'adminState','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_STATE','','t',0,26,0),(120,45,'adminPostalCode','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,27,0),(121,45,'adminCountry','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,28,0),(122,45,'adminPhone','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,29,0),(123,45,'adminFax','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_FAX','','t',0,30,0),(124,45,'techFirstName','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,31,0),(125,45,'techLastName','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,32,0),(126,45,'techCompany','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,33,0),(127,45,'techEmail','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,34,0),(128,45,'techAddress1','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,35,0),(129,45,'techAddress2','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,36,0),(130,45,'techCity','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_CITY','','t',0,37,0),(131,45,'techState','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_STATE','','t',0,38,0),(132,45,'techPostalCode','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,39,0),(133,45,'techCountry','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,40,0),(134,45,'techPhone','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,41,0),(135,45,'techFax','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_FAX','','t',0,42,0),(136,45,'auxBillingFirstName','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,43,0),(137,45,'auxBillingLastName','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,44,0),(138,45,'auxBillingCompany','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,45,0),(139,45,'auxBillingEmail','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,46,0),(140,45,'auxBillingAddress1','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,47,0),(141,45,'auxBillingAddress2','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,48,0),(142,45,'auxBillingCity','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_CITY','','t',0,49,0),(143,45,'auxBillingState','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_STATE','','t',0,50,0),(144,45,'auxBillingPostalCode','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,51,0),(145,45,'auxBillingCountry','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,52,0),(146,45,'auxBillingPhone','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,53,0),(147,45,'auxBillingFax','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_FAX','','t',0,54,0),(148,45,'domainNameserver1','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS1','','t',0,55,0),(149,45,'domainNameserver2','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS2','','t',0,56,0),(150,45,'domainNameserver3','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS3','','t',0,57,0),(151,45,'domainNameserver4','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS4','','t',0,58,0),(152,46,'moduleEnabled','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_ENABLE_OPENSRS','','r',1,1,0),(153,46,'moduleDisplayName','','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_DISPLAY_NAME','','t',0,2,0),(154,46,'moduleUsername','','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_USERNAME','','t',0,3,0),(155,46,'modulePassword','','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_PRIVATE_KEY','','p',0,4,0),(156,46,'modulePrivateKey','','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_PRIVATE_KEY','','t',0,5,0),(157,46,'moduleTestMode','1','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_ENABLE_TEST_MODE','','r',0,6,0),(158,46,'moduleAllowDomainPassword','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_DOMAIN_PASSWORD','TRANS_REGISTRAR_OPENSRS_ALLOW_DOMAIN_PASSWORD_DESC','r',0,7,0),(159,46,'moduleAllowRegistrarLock','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_REGISTRAR_LOCK','TRANS_REGISTRAR_OPENSRS_ALLOW_REGISTRAR_LOCK_DESC','r',0,8,0),(160,46,'moduleAllowAutorenew','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_AUTORENEW','TRANS_REGISTRAR_OPENSRS_ALLOW_AUTORENEW_DESC','r',0,9,0),(161,46,'moduleAllowNameserverOverride','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_NAMESERVER_OVERRIDE','TRANS_REGISTRAR_OPENSRS_ALLOW_NAMESERVER_OVERRIDE_DESC','r',0,10,0),(162,46,'moduleUseCustomNameserver','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_USE_CUSTOM_NAMESERVER','TRANS_REGISTRAR_OPENSRS_USE_CUSTOM_NAMESERVER_DESC','r',0,11,0),(163,46,'moduleAllowRenew','1','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_RENEW','TRANS_REGISTRAR_OPENSRS_ALLOW_RENEW_DESC','r',0,12,0),(164,46,'moduleAllowTransfer','1','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_TRANSFER','TRANS_REGISTRAR_OPENSRS_ALLOW_TRANSFER_DESC','r',0,13,0),(165,46,'moduleAllowChangeDNS','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_DNS','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_DNS_DESC','r',0,14,0),(166,46,'moduleAllowChangeContactInfo','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_CONTACT_INFO','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_CONTACT_INFO_DESC','r',0,15,0),(167,46,'moduleAllowChangeRegistrarLock','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_CHAGE_REGISTRAR_LOCK','TRANS_REGISTRAR_OPENSRS_ALLOW_CHAGE_REGISTRAR_LOCK_DESC','r',0,16,0),(168,46,'moduleAllowChangeAutorenew','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_AUTORENEW','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_AUTORENEW_DESC','r',0,17,0),(169,46,'moduleAllowChangeUpdateDomainPassword','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_UPDATE_DOMAIN_PASSWORD','TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_UPDATE_DOMAIN_PASSWORD_DESC','r',0,18,0),(170,46,'moduleAllowRegisterNameServer','0','TRANS_OPENSRS_ADMIN_ACCOUNT','TRANS_REGISTRAR_OPENSRS_ALLOW_REGISTER_NAME_SERVER','TRANS_REGISTRAR_OPENSRS_ALLOW_REGISTER_NAME_SERVER_DESC','r',10,19,1),(171,46,'adminFirstName','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,19,0),(172,46,'adminLastName','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,21,0),(173,46,'adminCompany','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,22,0),(174,46,'adminEmail','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,23,0),(175,46,'adminAddress1','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,24,0),(176,46,'adminAddress2','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,25,0),(177,46,'adminCity','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_CITY','','t',0,26,0),(178,46,'adminStaten','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_STATE','','t',0,27,0),(179,46,'adminPostalCode','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,28,0),(180,46,'adminCountry','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,28,0),(181,46,'adminPhone','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,30,0),(182,46,'adminFax','','TRANS_REGISTRAR_ADMIN_CONTACT','TRANS_REGISTRAR_FAX','','t',0,31,0),(183,46,'techFirstName','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,32,0),(184,46,'techLastName','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,33,0),(185,46,'techCompany','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,34,0),(186,46,'techEmail','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,35,0),(187,46,'techAddress1','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,36,0),(188,46,'techAddress2','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,37,0),(189,46,'techCity','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_CITY','','t',0,38,0),(190,46,'techState','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_STATE','','t',0,39,0),(191,46,'techPostalCode','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,40,0),(192,46,'techCountry','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,41,0),(193,46,'techPhone','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,42,0),(194,46,'techFax','','TRANS_REGISTRAR_TECH_CONTACT','TRANS_REGISTRAR_FAX','','t',0,43,0),(195,46,'auxBillingFirstName','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_FIRST_NAME','','t',0,44,0),(196,46,'auxBillingLastName','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_LAST_NAME','','t',0,45,0),(197,46,'auxBillingCompany','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_COMPANY','','t',0,46,0),(198,46,'auxBillingEmail','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_EMAIL','','t',0,47,0),(199,46,'auxBillingAddress1','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ADDRESS1','','t',0,48,0),(200,46,'auxBillingAddress2','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ADDRESS2','','t',0,49,0),(201,46,'auxBillingCity','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_CITY','','t',0,50,0),(202,46,'auxBillingState','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_STATE','','t',0,51,0),(203,46,'auxBillingPostalCode','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_ZIP','','t',0,52,0),(204,46,'auxBillingCountry','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_COUNTRY','','t',0,53,0),(205,46,'auxBillingPhone','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_PHONE','','t',0,54,0),(206,46,'auxBillingFax','','TRANS_REGISTRAR_AUXBILLING_CONTACT','TRANS_REGISTRAR_FAX','','t',0,55,0),(207,46,'domainNameserver1','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS1','','t',0,56,0),(208,46,'domainNameserver2','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS2','','t',0,57,0),(209,46,'domainNameserver3','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS3','','t',0,58,0),(210,46,'domainNameserver4','','TRANS_REGISTRAR_NS','TRANS_REGISTRAR_NS4','','t',0,59,0),(211,48,'billingMode','anniversary','','TRANS_BILLING_MODE','','r',1,1,0),(212,48,'billingDayOfMonth','1','','TRANS_MONTHLY_BILLING_DAY','TRANS_MONTHLY_BILLING_DAY_DESC','s',1,2,0),(213,48,'billingProrationThreshold','15','','TRANS_MONTHLY_PRORATION_THRESHOLD','TRANS_MONTHLY_PRORATION_THRESHOLD_DESC','s',1,2,0),(214,48,'getActiveClients','1','','TRANS_INVOICE_ACTIVE_CLIENTS','','r',1,2,0),(215,48,'getSuspendedClients','0','','TRANS_INVOICE_SUSPENDED_CLIENTS','','r',1,2,0),(216,48,'getActivePackages','1','','TRANS_INVOICE_ACTIVE_PACKAGES','','r',1,3,0),(217,48,'getSuspendedPackages','0','','TRANS_INVOICE_SUSPENDED_PACKAGES','','r',1,4,0),(218,48,'sendInvoiceEmail','1','','TRANS_INVOICE_SEND_EMAIL','','r',1,6,0),(219,48,'invoice_number_template','%%CURMONTH%%-%%CURYEAR%%-%%SEQ%%','','TRANS_INVOICE_NUMBER_TEMPLATE','','s',1,7,0),(220,48,'invoice_sequence','100000','','TRANS_INVOICE_SEQUENCE','TRANS_INVOICE_SEQUENCE_DESC','t',1,8,0),(221,48,'invoice_generate_offset','10','','TRANS_INVOICE_GENERATE_DAYS_BEFORE_RENEW_DATE','TRANS_INVOICE_GENERATE_DAYS_BEFORE_RENEW_DATE_DESC','t',1,9,0),(222,48,'invoice_domain_generate_offset','30','','TRANS_INVOICE_DOMAIN_GENERATE_DAYS_BEFORE_RENEW_DATE','TRANS_INVOICE_DOMAIN_GENERATE_DAYS_BEFORE_RENEW_DATE_DESC','t',1,9,0),(223,48,'invoice_due_offset','9','','TRANS_INVOICE_DUE_DAYS_AFTER_GENERATION','TRANS_INVOICE_DUE_DAYS_AFTER_GENERATION_DESC','t',1,10,0),(224,48,'invoice_line_item_threshold','50','','TRANS_INVOICE_LINE_ITEM_THRESHOLD','TRANS_INVOICE_LINE_ITEM_THRESHOLD_DESC','t',1,11,0),(225,52,'emailMethod','php','','TRANS_EMAIL_METHOD',NULL,NULL,NULL,0,0),(226,52,'emailSendmailLocation','/usr/sbin/sendmail','','TRANS_EMAIL_SENDMAIL_LOCATION',NULL,NULL,NULL,0,0),(227,52,'emailSMTPServer','','','TRANS_EMAIL_SMTP_SERVER_LOCATION',NULL,NULL,NULL,0,0),(228,52,'emailSMTPAuth','','','TRANS_EMAIL_SMTP_REQUIRE_AUTHENTICATION',NULL,NULL,NULL,0,0),(229,52,'emailSMTPUsername','','','TRANS_EMAIL_SMTP_USERNAME',NULL,NULL,NULL,0,0),(230,52,'emailSMTPPassword','','','TRANS_EMAIL_SMTP_PASSWORD',NULL,NULL,NULL,0,0),(231,55,'max_system_queue_events','3','','TRANS_MAX_SYSTEM_QUEUE_EVENTS','TRANS_MAX_SYSTEM_QUEUE_DESC','t',1,1,0),(232,55,'run_queue_active_client_type','2','','TRANS_RUN_SYSTEM_QUEUE_ACTIVE_CLIENT_TYPE','TRANS_RUN_SYSTEM_QUEUE_ACTIVE_CLIENT_TYPE_DESC','s',1,2,0),(233,55,'run_queue_new_client_type','2','','TRANS_RUN_SYSTEM_QUEUE_NEW_CLIENT_TYPE','TRANS_RUN_SYSTEM_QUEUE_NEW_CLIENT_TYPE_DESC','s',1,3,0),(234,55,'run_queue_domain_new_type','2','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_TYPE','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_TYPE_DESC','s',1,4,0),(235,55,'run_queue_domain_active_type','2','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_ACTIVE_TYPE','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_ACTIVE_TYPE_DESC','s',1,5,0),(236,55,'run_queue_domain_renewal_type','2','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_RENEWAL_TYPE','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_RENEWAL_TYPE_DESC','s',1,6,0),(237,55,'run_queue_domain_new_sync','0','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_SYNC','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_SYNC_DESC','s',1,7,0),(238,55,'system_queue_push_time','15','','TRANS_SYSTEM_QUEUE_PUSH_MINUTES','TRANS_SYSTEM_QUEUE_PUSH_MINUTES_DESC','t',1,8,0),(239,57,'enableAutoSuspend','1','','TRANS_AUTOMATION_AUTOSUSPEND_ENABLED','TRANS_AUTOMATION_AUTOSUSPEND_ENABLED_DESC','r',1,1,0),(240,57,'autoSuspendFirstNotice','5','','TRANS_AUTOMATION_AUTOSUSPEND_FIRST_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_FIRST_NOTICE_DESC','t',1,2,0),(241,57,'autoSuspendSecondNotice','10','','TRANS_AUTOMATION_AUTOSUSPEND_SECOND_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_SECOND_NOTICE_DESC','t',1,3,0),(242,57,'autoSuspendThirdNotice','15','','TRANS_AUTOMATION_AUTOSUSPEND_THIRD_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_THIRD_NOTICE_DESC','t',1,4,0),(243,57,'autoSuspendClean','90','','TRANS_AUTOMATION_AUTOSUSPEND_CLEAN_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_CLEAN_NOTICE_DESC','t',1,4,0),(244,57,'sendSuspensionEmails','1','','TRANS_AUTOMATION_AUTOSUSPEND_SEND_EMAIL','TRANS_AUTOMATION_AUTOSUSPEND_SEND_EMAIL_DESC','r',1,6,0),(245,59,'editUserName','0','','TRANS_USER_EDIT_USER_NAME','TRANS_USER_EDIT_USER_NAME_DESC','r',1,1,0),(246,59,'editFirstName','1','','TRANS_USER_EDIT_FIRST_NAME','TRANS_USER_EDIT_FIRST_NAME_DESC','r',1,2,0),(247,59,'editLastName','1','','TRANS_USER_EDIT_LAST_NAME','TRANS_USER_EDIT_LAST_NAME_DESC','r',1,3,0),(248,59,'editEmail','0','','TRANS_USER_EDIT_EMAIL','TRANS_USER_EDIT_EMAIL_DESC','r',1,4,0),(249,59,'editCompanyName','1','','TRANS_USER_EDIT_COMPANY_NAME','TRANS_USER_EDIT_COMPANY_NAME_DESC','r',1,5,0),(250,59,'editCountry','1','','TRANS_USER_EDIT_COUNTRY','TRANS_USER_EDIT_COUNTRY_DESC','r',1,6,0),(251,59,'editEmailActions','1','','TRANS_USER_EDIT_EMAILACTIONS','TRANS_USER_EDIT_EMAILACTIONS_DESC','r',1,7,0),(252,68,'enableFraudGuardian','','','TRANS_FRAUD_MODULES_ENABLEFRAUDGUARDIAN',NULL,NULL,NULL,0,0),(253,68,'usernameFraudGuardian','','','TRANS_FRAUD_MODULES_USERNAMEFRAUDGUARDIAN',NULL,NULL,NULL,0,0),(254,68,'passwordFraudGuardian','','','TRANS_FRAUD_MODULES_PASSWORDFRAUDGUARDIAN',NULL,NULL,NULL,0,0),(255,71,'enablePPCfactory','','','TRANS_PPC_MODULES_ENABLEPPCFACTORY',NULL,NULL,NULL,0,0),(256,71,'testmodePPCfactory','','','TRANS_PPC_MODULES_TESTMODEPPCFACTORY',NULL,NULL,NULL,0,0),(257,71,'usernamePPCfactory','','','TRANS_PPC_MODULES_USERNAMEPPCFACTORY',NULL,NULL,NULL,0,0),(258,71,'passwordPPCfactory','','','TRANS_PPC_MODULES_PASSWORDPPCFACTORY',NULL,NULL,NULL,0,0),(259,73,'enableSSLFactory','','','TRANS_SSL_MODULES_ENABLESSLFACTORY',NULL,NULL,NULL,0,0),(260,73,'usernameSSLFactory','','','TRANS_SSL_MODULES_USERNAMESSLFACTORY',NULL,NULL,NULL,0,0),(261,73,'accessCodeSSLFactory','','','TRANS_SSL_MODULES_ACCESSCODESSLFACTORY',NULL,NULL,NULL,0,0),(262,74,'panelMinUsernameLength','6','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_MIN_USERNAME_LENGTH','TRANS_PANEL_MIN_USERNAME_LENGTH_DESC','t',NULL,1,NULL),(263,74,'panelMaxUsernameLength','12','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_MAX_USERNAME_LENGTH','TRANS_PANEL_MAX_USERNAME_LENGTH_DESC','t',NULL,2,NULL),(264,74,'panelMinPasswordLength','6','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_MIN_PASSWORD_LENGTH','TRANS_PANEL_MIN_PASSWORD_LENGTH_DESC','t',NULL,3,NULL),(265,74,'panelMaxPasswordLength','12','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_MAX_PASSWORD_LENGTH','TRANS_PANEL_MAX_PASSWORD_LENGTH_DESC','t',NULL,4,NULL),(266,74,'panelMaxAccounts','1000','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_MAX_ACCOUNTS','TRANS_PANEL_MAX_ACCOUNTS_DESC','t',NULL,5,NULL),(267,74,'panelCurrentAccounts','1','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_CURRENT_ACCOUNTS','TRANS_PANEL_CURRENT_ACCOUNTS_DESC','t',NULL,6,NULL),(268,74,'panelNameserver1','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_1','TRANS_PANEL_NAMESERVER_1_DESC','t',NULL,7,NULL),(269,74,'panelNameserver1IP','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_1_IP','TRANS_PANEL_NAMESERVER_1_IP_DESC','t',NULL,8,NULL),(270,74,'panelNameserver2','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_2','TRANS_PANEL_NAMESERVER_2_DESC','t',NULL,9,NULL),(271,74,'panelNameserver2IP','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_2_IP','TRANS_PANEL_NAMESERVER_2_IP_DESC','t',NULL,10,NULL),(272,74,'panelNameserver3','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_3','TRANS_PANEL_NAMESERVER_3_DESC','t',NULL,11,NULL),(273,74,'panelNameserver3IP','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_3_IP','TRANS_PANEL_NAMESERVER_3_IP_DESC','t',NULL,12,NULL),(274,74,'panelNameserver4','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_4','TRANS_PANEL_NAMESERVER_4_DESC','t',NULL,13,NULL),(275,74,'panelNameserver4IP','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_NAMESERVER_4_IP','TRANS_PANEL_NAMESERVER_4_IP_DESC','t',NULL,14,NULL),(276,74,'panelLoginURL',NULL,'TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_LOGIN_URL','TRANS_PANEL_LOGIN_URL_DESC','t',NULL,15,NULL),(277,74,'moduleDisplayName','Local Plesk Server','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_SERVERNAME','TRANS_PANEL_SERVERNAME_DESC','t',1,1,NULL),(278,74,'moduleEnabled','1','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_ENABLED',NULL,'r',1,2,NULL),(279,74,'moduleUsername','admin','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PLESK_USERNAME','TRANS_PLESK_USERNAME_DESC','t',1,3,NULL),(280,74,'modulePassword','ZSvRP1h8XZ8+dSZ1dVqdsRhLMR5S6clrJztsIGvnMTkdfZd/VVRiZWIR','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PLESK_PASSWORD','TRANS_PLESK_PASSWORD_DESC','p',1,4,NULL),(281,74,'api','https://localhost:8443','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PLESK_URL','TRANS_PLESK_URL_DESC','t',1,5,NULL),(282,74,'ip','UNKNOWN','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_SHARED_IP','TRANS_PANEL_PLESK_SHARED_IP_DESC','t',1,6,NULL),(283,74,'showServerLoad','1','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_DIRECTADMIN_SHOW_SERVER_LOAD','TRANS_DIRECTADMIN_SHOW_SERVER_LOAD_DESC','r',1,12,NULL),(284,74,'panelUsernameRule','1','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_ACCOUNT_NAME_RULE','TRANS_PANEL_ACCOUNT_NAME_RULE_DESC','s',1,13,NULL),(285,74,'allowClientLogin','1','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_ALLOW_CLIENT_LOGIN',NULL,'r',1,15,NULL),(286,74,'panelUsernamePrefix','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_USERNAME_PREFIX','TRANS_PANEL_USERNAME_PREFIX_DESC','t',1,15,NULL),(287,74,'panelUsernameSequence','','TRANS_PANEL_GROUP_TRANS_KEY','TRANS_PANEL_USERNAME_SEQUENCE','TRANS_PANEL_USERNAME_SEQUENCE_DESC','t',1,16,NULL),(288,76,'PayPal_ID','COMPANYEMAIL',NULL,'TRANS_PAYPAL_ID','TRANS_PAYPAL_ID_DESC','t',1,1,NULL),(289,76,'Item_Name','',NULL,'TRANS_PAYPAL_ITEMNAME','TRANS_PAYPAL_ITEMNAME_DESC','t',1,2,NULL),(290,76,'Return_URL','http://COMPANYURL',NULL,'TRANS_PAYPAL_RETURNURL','TRANS_PAYPAL_RETURNURL_DESC','t',1,3,NULL),(291,76,'Cancel_URL','http://COMPANYURL',NULL,'TRANS_PAYPAL_CANCELURL','TRANS_PAYPAL_CANCELURL_DESC','t',1,4,NULL),(292,76,'Display_Logo','http://MODERNBILLROOT/lib-themes/default/lib-modernbill/images/logos/logo.gif',NULL,'TRANS_PAYPAL_DISPLAYLOGO','TRANS_PAYPAL_DISPLAYLOGO_DESC','t',1,5,NULL),(293,76,'Submit_Image','https://www.paypal.com/en_US/i/btn/x-click-but03.gif',NULL,'TRANS_PAYPAL_SUBMITIMAGE','TRANS_PAYPAL_SUBMITIMAGE_DESC','t',1,6,NULL),(294,76,'IPN_URL','http://MODERNBILLROOT/lib-mbapi/include/modules/gateway/return/paypal.php',NULL,'TRANS_PAYPAL_IPNURL','TRANS_PAYPAL_IPNURL_DESC','t',1,7,NULL),(295,76,'Enable_Subscriptions','1',NULL,'TRANS_PAYPAL_SUBENABLE','TRANS_PAYPAL_SUBENABLE_DESC','r',NULL,8,NULL),(296,76,'Subscriptions_Image','https://www.paypal.com/images/x-click-but20.gif',NULL,'TRANS_PAYPAL_SUBIMAGE','TRANS_PAYPAL_SUBIMAGE_DESC','t',1,10,NULL),(297,76,'Acceptable_PayPal_Payees','COMPANYEMAIL',NULL,'TRANS_PAYPAL_ACCEPT_ADDRESSES','TRANS_PAYPAL_ACCEPT_ADDRESSES_DESC','a',1,11,NULL);
/*!40000 ALTER TABLE `config_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact_email_action_rel`
--

DROP TABLE IF EXISTS `contact_email_action_rel`;
CREATE TABLE `contact_email_action_rel` (
  `client_contact_id` int(10) unsigned NOT NULL default '0',
  `email_action_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_contact_id`,`email_action_id`)
);

--
-- Dumping data for table `contact_email_action_rel`
--

LOCK TABLES `contact_email_action_rel` WRITE;
/*!40000 ALTER TABLE `contact_email_action_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `contact_email_action_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `countries`
--

DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `countries_id` smallint(5) unsigned NOT NULL auto_increment,
  `countries_iso_2` char(2) default NULL,
  `countries_iso_num` char(3) default NULL,
  `countries_region` char(3) default NULL,
  `countries_phone_code` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`countries_id`),
  KEY `countries_iso_2` (`countries_iso_2`),
  KEY `countries_region` (`countries_region`),
  KEY `countries_iso_num` (`countries_iso_num`),
  KEY `countries_phone_code` (`countries_phone_code`)
) AUTO_INCREMENT=245;

--
-- Dumping data for table `countries`
--

LOCK TABLES `countries` WRITE;
/*!40000 ALTER TABLE `countries` DISABLE KEYS */;
INSERT INTO `countries` VALUES (1,'AD','020','039',376),(2,'AE','784','145',971),(3,'AF','004','062',93),(4,'AG','028','029',1),(5,'AI','660','029',1),(6,'AL','008','039',355),(7,'AM','051','145',374),(8,'AN','530','029',599),(9,'AO','024','017',244),(10,'AQ','010','QO',672),(11,'AR','032','005',54),(12,'AS','016','061',684),(13,'AT','040','155',43),(14,'AU','036','053',61),(15,'AW','533','029',297),(16,'AX','248','154',358),(17,'AZ','031','145',994),(18,'BA','070','039',387),(19,'BB','052','029',1),(20,'BD','050','062',880),(21,'BE','056','155',32),(22,'BF','854','011',226),(23,'BG','100','151',359),(24,'BH','048','145',973),(25,'BI','108','014',257),(26,'BJ','204','011',229),(27,'BM','060','021',1),(28,'BN','096','035',673),(29,'BO','068','005',591),(30,'BR','076','005',55),(31,'BS','044','029',1),(32,'BT','064','062',975),(33,'BV','074','QO',47),(34,'BW','072','018',267),(35,'BY','112','151',375),(36,'BZ','084','013',501),(37,'CA','124','021',1),(38,'CC','166','QO',61),(39,'CD','180','017',243),(40,'CF','140','017',236),(41,'CG','178','017',242),(42,'CH','756','155',41),(43,'CI','384','011',225),(44,'CK','184','061',682),(45,'CL','152','005',56),(46,'CM','120','017',237),(47,'CN','156','030',86),(48,'CO','170','005',57),(49,'CR','188','013',506),(50,'RS','688','039',381),(51,'ME','499','039',382),(52,'CU','192','029',53),(53,'CV','132','011',238),(54,'CX','162','QO',618),(55,'CY','196','145',357),(56,'CZ','203','151',420),(57,'DE','276','155',49),(58,'DJ','262','014',253),(59,'DK','208','154',45),(60,'DM','212','029',1),(61,'DO','214','029',1),(62,'DZ','012','015',213),(63,'EC','218','005',593),(64,'EE','233','154',372),(65,'EG','818','015',20),(66,'EH','732','015',212),(67,'ER','232','014',291),(68,'ES','724','039',34),(69,'ET','231','014',251),(70,'FI','246','154',358),(71,'FJ','242','054',679),(72,'FK','238','005',500),(73,'FM','583','057',691),(74,'FO','234','154',298),(75,'FR','250','155',33),(76,'GA','266','017',241),(77,'GB','826','154',44),(78,'GD','308','029',1),(79,'GE','268','145',995),(80,'GF','254','005',594),(81,'GH','288','011',233),(82,'GI','292','039',350),(83,'GL','304','021',299),(84,'GM','270','011',220),(85,'GN','324','011',224),(86,'GP','312','029',590),(87,'GQ','226','017',240),(88,'GR','300','039',30),(89,'GS','239','QO',995),(90,'GT','320','013',502),(91,'GU','316','057',1),(92,'GW','624','011',245),(93,'GY','328','005',592),(94,'HK','344','030',852),(95,'HM','334','QO',61),(96,'HN','340','013',504),(97,'HR','191','039',385),(98,'HT','332','029',509),(99,'HU','348','151',36),(100,'ID','360','035',62),(101,'IE','372','154',353),(102,'IL','376','145',972),(103,'IN','356','062',91),(104,'IO','086','QO',246),(105,'IQ','368','145',964),(106,'IR','364','062',98),(107,'IS','352','154',354),(108,'IT','380','039',39),(109,'JM','388','029',1),(110,'JO','400','145',962),(111,'JP','392','030',81),(112,'KE','404','014',254),(113,'KG','417','062',996),(114,'KH','116','035',855),(115,'KI','296','057',686),(116,'KM','174','014',269),(117,'KN','659','029',1),(118,'KP','408','030',850),(119,'KR','410','030',82),(120,'KW','414','145',965),(121,'KY','136','029',1),(122,'KZ','398','062',7),(123,'LA','418','035',856),(124,'LB','422','145',961),(125,'LC','662','029',1),(126,'LI','438','155',423),(127,'LK','144','062',94),(128,'LR','430','011',231),(129,'LS','426','018',266),(130,'LT','440','154',370),(131,'LU','442','155',352),(132,'LV','428','154',371),(133,'LY','434','015',218),(134,'MA','504','015',212),(135,'MC','492','155',377),(136,'MD','498','151',373),(137,'MG','450','014',261),(138,'MH','584','057',692),(139,'MK','807','039',389),(140,'ML','466','011',269),(141,'MM','104','035',95),(142,'MN','496','030',976),(143,'MO','446','030',853),(144,'MP','580','057',1),(145,'MQ','474','029',596),(146,'MR','478','011',222),(147,'MS','500','029',1),(148,'MT','470','039',356),(149,'MU','480','014',230),(150,'MV','462','062',960),(151,'MW','454','014',265),(152,'MX','484','013',52),(153,'MY','458','035',60),(154,'MZ','508','014',258),(155,'NA','516','018',264),(156,'NC','540','054',687),(157,'NE','562','011',227),(158,'NF','574','053',672),(159,'NG','566','011',234),(160,'NI','558','013',505),(161,'NL','528','155',31),(162,'NO','578','154',47),(163,'NP','524','062',977),(164,'NR','520','057',674),(165,'NU','570','061',683),(166,'NZ','554','053',64),(167,'OM','512','145',968),(168,'PA','591','013',507),(169,'PE','604','005',51),(170,'PF','258','061',689),(171,'PG','598','054',675),(172,'PH','608','035',63),(173,'PK','586','062',92),(174,'PL','616','151',48),(175,'PM','666','021',508),(176,'PN','612','061',872),(177,'PR','630','029',1),(178,'PS','275','145',970),(179,'PT','620','039',351),(180,'PW','585','057',680),(181,'PY','600','005',595),(182,'QA','634','145',974),(183,'RE','638','014',262),(184,'RO','642','151',40),(185,'RU','643','151',7),(186,'RW','646','014',250),(187,'SA','682','145',966),(188,'SB','090','054',677),(189,'SC','690','014',248),(190,'SD','736','015',249),(191,'SE','752','154',46),(192,'SG','702','035',65),(193,'SH','654','011',290),(194,'SI','705','039',386),(195,'SJ','744','154',47),(196,'SK','703','151',421),(197,'SL','694','011',232),(198,'SM','674','039',378),(199,'SN','686','011',221),(200,'SO','706','014',252),(201,'SR','740','005',597),(202,'ST','678','017',239),(203,'SV','222','013',503),(204,'SY','760','145',963),(205,'SZ','748','018',268),(206,'TC','796','029',1),(207,'TD','148','017',235),(208,'TF','260','QO',596),(209,'TG','768','011',228),(210,'TH','764','035',66),(211,'TJ','762','062',992),(212,'TK','772','061',690),(213,'TL','626','035',670),(214,'TM','795','062',993),(215,'TN','788','015',216),(216,'TO','776','061',676),(217,'TR','792','145',90),(218,'TT','780','029',1),(219,'TV','798','061',688),(220,'TW','158','030',886),(221,'TZ','834','014',255),(222,'UA','804','151',380),(223,'UG','800','014',256),(224,'UM','581','QO',1),(225,'US','840','021',1),(226,'UY','858','005',598),(227,'UZ','860','062',998),(228,'VA','336','039',39),(229,'VC','670','029',1),(230,'VE','862','005',58),(231,'VG','092','029',1),(232,'VI','850','029',340),(233,'VN','704','035',84),(234,'VU','548','054',678),(235,'WF','876','061',681),(236,'WS','882','061',684),(237,'YE','887','145',967),(238,'YT','175','014',269),(239,'ZA','710','018',27),(240,'ZM','894','014',260),(241,'ZW','716','014',263),(242,'GG','831','154',44),(243,'JE','832','154',44),(244,'IM','833','154',44);
/*!40000 ALTER TABLE `countries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coupon_condition_groups`
--

DROP TABLE IF EXISTS `coupon_condition_groups`;
CREATE TABLE `coupon_condition_groups` (
  `coupon_condition_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `coupon_condition_group_name` varchar(255) default NULL,
  `coupon_id` smallint(5) unsigned default NULL,
  `coupon_condition_group_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`coupon_condition_group_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `coupon_condition_group_active` (`coupon_condition_group_active`)
);

--
-- Dumping data for table `coupon_condition_groups`
--

LOCK TABLES `coupon_condition_groups` WRITE;
/*!40000 ALTER TABLE `coupon_condition_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `coupon_condition_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coupon_conditions`
--

DROP TABLE IF EXISTS `coupon_conditions`;
CREATE TABLE `coupon_conditions` (
  `coupon_condition_id` smallint(5) unsigned NOT NULL auto_increment,
  `coupon_condition_group_id` smallint(5) unsigned default NULL,
  `product_variant_id` int(8) unsigned default NULL,
  `cycle_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`coupon_condition_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `cycle_id` (`cycle_id`),
  KEY `coupon_condition_group_id` (`coupon_condition_group_id`)
);

--
-- Dumping data for table `coupon_conditions`
--

LOCK TABLES `coupon_conditions` WRITE;
/*!40000 ALTER TABLE `coupon_conditions` DISABLE KEYS */;
/*!40000 ALTER TABLE `coupon_conditions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coupons`
--

DROP TABLE IF EXISTS `coupons`;
CREATE TABLE `coupons` (
  `coupon_id` smallint(5) unsigned NOT NULL auto_increment,
  `coupon_code` varchar(255) default NULL,
  `coupon_discount` decimal(10,2) default '0.00',
  `coupon_type` tinyint(3) unsigned default NULL,
  `coupon_comments` longtext,
  `coupon_active` tinyint(3) unsigned default NULL,
  `coupon_date_created` int(10) unsigned default '0',
  `coupon_date_started` int(10) unsigned default '0',
  `coupon_date_ended` int(10) unsigned default '0',
  `coupon_count` int(11) unsigned default '0',
  `coupon_max_count` int(10) unsigned default '0',
  `coupon_new_only` tinyint(3) unsigned default NULL,
  `coupon_num_cycles` smallint(5) unsigned default NULL,
  `coupon_apply_number` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`coupon_id`),
  KEY `coupon_active` (`coupon_active`),
  KEY `coupon_date_ended` (`coupon_date_ended`),
  KEY `coupon_date_started` (`coupon_date_started`),
  KEY `coupon_max_count` (`coupon_max_count`),
  KEY `coupon_new_only` (`coupon_new_only`),
  KEY `coupon_num_cycles` (`coupon_num_cycles`),
  KEY `coupon_code` (`coupon_code`)
);

--
-- Dumping data for table `coupons`
--

LOCK TABLES `coupons` WRITE;
/*!40000 ALTER TABLE `coupons` DISABLE KEYS */;
/*!40000 ALTER TABLE `coupons` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycle_discount_groups`
--

DROP TABLE IF EXISTS `cycle_discount_groups`;
CREATE TABLE `cycle_discount_groups` (
  `cycle_discount_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_discount_group_name` varchar(50) default NULL,
  `cycle_discount_group_active` tinyint(1) unsigned default '1',
  PRIMARY KEY  (`cycle_discount_group_id`),
  KEY `cycle_discount_group_active` (`cycle_discount_group_active`)
);

--
-- Dumping data for table `cycle_discount_groups`
--

LOCK TABLES `cycle_discount_groups` WRITE;
/*!40000 ALTER TABLE `cycle_discount_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `cycle_discount_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycle_discounts`
--

DROP TABLE IF EXISTS `cycle_discounts`;
CREATE TABLE `cycle_discounts` (
  `cycle_discount_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_discount_group_id` smallint(5) unsigned default NULL,
  `cycle_discount_active` tinyint(1) unsigned default '1',
  `cycle_id` smallint(5) unsigned default NULL,
  `cycle_discount_amount` decimal(5,2) unsigned default '0.00',
  PRIMARY KEY  (`cycle_discount_id`),
  KEY `cycle_discount_group_id` (`cycle_discount_group_id`),
  KEY `cycle_discount_active` (`cycle_discount_active`),
  KEY `cycle_id` (`cycle_id`)
);

--
-- Dumping data for table `cycle_discounts`
--

LOCK TABLES `cycle_discounts` WRITE;
/*!40000 ALTER TABLE `cycle_discounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `cycle_discounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycle_group_rel`
--

DROP TABLE IF EXISTS `cycle_group_rel`;
CREATE TABLE `cycle_group_rel` (
  `cycle_id` int(8) unsigned NOT NULL default '0',
  `cycle_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`cycle_id`,`cycle_group_id`)
);

--
-- Dumping data for table `cycle_group_rel`
--

LOCK TABLES `cycle_group_rel` WRITE;
/*!40000 ALTER TABLE `cycle_group_rel` DISABLE KEYS */;
INSERT INTO `cycle_group_rel` VALUES (1,1),(2,2),(3,3),(4,3),(5,3),(6,4),(7,4),(8,4),(9,4),(10,4),(11,4),(12,4),(13,4),(14,4),(15,4),(16,5);
/*!40000 ALTER TABLE `cycle_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycle_groups`
--

DROP TABLE IF EXISTS `cycle_groups`;
CREATE TABLE `cycle_groups` (
  `cycle_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_group_display_name` varchar(75) default NULL,
  `cycle_group_internal_name` varchar(75) default NULL,
  PRIMARY KEY  (`cycle_group_id`),
  KEY `cycle_group_internal_name` (`cycle_group_internal_name`)
) AUTO_INCREMENT=6;

--
-- Dumping data for table `cycle_groups`
--

LOCK TABLES `cycle_groups` WRITE;
/*!40000 ALTER TABLE `cycle_groups` DISABLE KEYS */;
INSERT INTO `cycle_groups` VALUES (1,'TRANS_DAILY','daily'),(2,'TRANS_WEEKLY','weekly'),(3,'TRANS_MONTHLY','monthly'),(4,'TRANS_YEARLY','yearly'),(5,'TRANS_ONE_TIME','onetime');
/*!40000 ALTER TABLE `cycle_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycles`
--

DROP TABLE IF EXISTS `cycles`;
CREATE TABLE `cycles` (
  `cycle_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_display_name` varchar(50) default NULL,
  `cycle_num_seconds` tinyint(3) unsigned default '0',
  `cycle_num_minutes` tinyint(3) unsigned default '0',
  `cycle_num_hours` tinyint(3) unsigned default '0',
  `cycle_num_days` smallint(5) unsigned default '0',
  `cycle_num_months` tinyint(3) unsigned default '0',
  `cycle_num_years` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`cycle_id`),
  KEY `cycle_display_name` (`cycle_display_name`)
) AUTO_INCREMENT=17;

--
-- Dumping data for table `cycles`
--

LOCK TABLES `cycles` WRITE;
/*!40000 ALTER TABLE `cycles` DISABLE KEYS */;
INSERT INTO `cycles` VALUES (1,'TRANS_1DAY',0,0,0,1,0,0),(2,'TRANS_1WEEK',0,0,0,7,0,0),(3,'TRANS_1MONTH',0,0,0,0,1,0),(4,'TRANS_3MONTHS',0,0,0,0,3,0),(5,'TRANS_6MONTHS',0,0,0,0,6,0),(6,'TRANS_1YEAR',0,0,0,0,0,1),(7,'TRANS_2YEARS',0,0,0,0,0,2),(8,'TRANS_3YEARS',0,0,0,0,0,3),(9,'TRANS_4YEARS',0,0,0,0,0,4),(10,'TRANS_5YEARS',0,0,0,0,0,5),(11,'TRANS_6YEARS',0,0,0,0,0,6),(12,'TRANS_7YEARS',0,0,0,0,0,7),(13,'TRANS_8YEARS',0,0,0,0,0,8),(14,'TRANS_9YEARS',0,0,0,0,0,9),(15,'TRANS_10YEARS',0,0,0,0,0,10),(16,'TRANS_ONE_TIME',0,0,0,1,0,0);
/*!40000 ALTER TABLE `cycles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_change_log`
--

DROP TABLE IF EXISTS `data_change_log`;
CREATE TABLE `data_change_log` (
  `change_log_id` int(10) unsigned NOT NULL auto_increment,
  `user_type` tinyint(3) unsigned default NULL,
  `user_id` int(8) unsigned default NULL,
  `change_log_date_created` int(10) unsigned default NULL,
  `change_log_table_name` varchar(40) default NULL,
  `change_log_column_name` varchar(32) default NULL,
  `change_log_column_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`change_log_id`),
  KEY `change_log_table_name` (`change_log_table_name`),
  KEY `change_log_column_name` (`change_log_column_name`),
  KEY `change_log_column_id` (`change_log_column_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`)
);

--
-- Dumping data for table `data_change_log`
--

LOCK TABLES `data_change_log` WRITE;
/*!40000 ALTER TABLE `data_change_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `data_change_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dbg_entries`
--

DROP TABLE IF EXISTS `dbg_entries`;
CREATE TABLE `dbg_entries` (
  `dbg_entry_id` bigint(20) unsigned NOT NULL auto_increment,
  `dbg_pageload_id` bigint(20) unsigned default NULL,
  `dbg_entry_date_created` int(10) unsigned default NULL,
  `dbg_entry_file` varchar(255) default NULL,
  `dbg_entry_line` smallint(5) unsigned default NULL,
  `dbg_entry_message` text,
  PRIMARY KEY  (`dbg_entry_id`),
  KEY `dbg_pageload_id` (`dbg_pageload_id`),
  KEY `dbg_entry_file` (`dbg_entry_file`),
  KEY `dbg_entry_line` (`dbg_entry_line`)
);

--
-- Dumping data for table `dbg_entries`
--

LOCK TABLES `dbg_entries` WRITE;
/*!40000 ALTER TABLE `dbg_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `dbg_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dbg_pageloads`
--

DROP TABLE IF EXISTS `dbg_pageloads`;
CREATE TABLE `dbg_pageloads` (
  `dbg_pageload_id` bigint(20) unsigned NOT NULL auto_increment,
  `dbg_pageload_date_created` int(10) unsigned default NULL,
  `dbg_pageload_page` varchar(255) default NULL,
  `dbg_pageload_action` varchar(255) default NULL,
  `dbg_pageload_pid` int(10) default NULL,
  `user_type` tinyint(4) default NULL,
  `user_id` int(11) default NULL,
  PRIMARY KEY  (`dbg_pageload_id`),
  KEY `dbg_pageload_page` (`dbg_pageload_page`),
  KEY `dbg_pageload_action` (`dbg_pageload_action`),
  KEY `dbg_pageload_pid` (`dbg_pageload_pid`),
  KEY `user_type` (`user_type`),
  KEY `user_id` (`user_id`)
);

--
-- Dumping data for table `dbg_pageloads`
--

LOCK TABLES `dbg_pageloads` WRITE;
/*!40000 ALTER TABLE `dbg_pageloads` DISABLE KEYS */;
/*!40000 ALTER TABLE `dbg_pageloads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_addresses`
--

DROP TABLE IF EXISTS `email_addresses`;
CREATE TABLE `email_addresses` (
  `email_address_id` int(10) unsigned NOT NULL auto_increment,
  `email_address_name` varchar(100) default NULL,
  `email_address` varchar(255) default NULL,
  `email_address_type` tinyint(3) unsigned default NULL,
  `email_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`email_address_id`),
  KEY `email_id` (`email_id`),
  KEY `email_address` (`email_address`),
  KEY `email_address_type` (`email_address_type`)
);

--
-- Dumping data for table `email_addresses`
--

LOCK TABLES `email_addresses` WRITE;
/*!40000 ALTER TABLE `email_addresses` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_addresses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_attachments`
--

DROP TABLE IF EXISTS `email_attachments`;
CREATE TABLE `email_attachments` (
  `email_attachment_id` int(10) unsigned NOT NULL auto_increment,
  `email_id` int(10) unsigned default NULL,
  `email_attachment_path` longtext,
  `email_attachment_remote` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`email_attachment_id`),
  KEY `email_id` (`email_id`)
);

--
-- Dumping data for table `email_attachments`
--

LOCK TABLES `email_attachments` WRITE;
/*!40000 ALTER TABLE `email_attachments` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_attachments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_headers`
--

DROP TABLE IF EXISTS `email_headers`;
CREATE TABLE `email_headers` (
  `email_header_id` int(10) unsigned NOT NULL auto_increment,
  `email_id` int(10) unsigned default NULL,
  `email_header` longtext,
  PRIMARY KEY  (`email_header_id`),
  KEY `email_id` (`email_id`)
);

--
-- Dumping data for table `email_headers`
--

LOCK TABLES `email_headers` WRITE;
/*!40000 ALTER TABLE `email_headers` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_headers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_queue`
--

DROP TABLE IF EXISTS `email_queue`;
CREATE TABLE `email_queue` (
  `email_id` int(10) unsigned NOT NULL auto_increment,
  `client_contact_id` int(10) unsigned default '0',
  `admin_id` smallint(5) unsigned default '0',
  `email_subject` varchar(255) default NULL,
  `email_body` text,
  `email_text_body` text,
  `email_from_address` varchar(60) default NULL,
  `email_from_name` varchar(50) default NULL,
  `email_sent` tinyint(3) unsigned default NULL,
  `email_sent_type` tinyint(3) unsigned default NULL,
  `email_failed` tinyint(3) unsigned default NULL,
  `email_date_created` int(10) unsigned default NULL,
  `email_date_sent` int(10) unsigned default NULL,
  `email_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`email_id`),
  KEY `email_date_created` (`email_date_created`),
  KEY `email_sent` (`email_sent`),
  KEY `email_failed` (`email_failed`),
  KEY `email_active` (`email_active`),
  KEY `client_contact_id` (`client_contact_id`),
  KEY `admin_id` (`admin_id`)
);

--
-- Dumping data for table `email_queue`
--

LOCK TABLES `email_queue` WRITE;
/*!40000 ALTER TABLE `email_queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_tpl_groups`
--

DROP TABLE IF EXISTS `email_tpl_groups`;
CREATE TABLE `email_tpl_groups` (
  `email_tpl_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `email_tpl_group_name` varchar(255) default NULL,
  `email_action_id` tinyint(3) unsigned default NULL,
  `email_tpl_group_priority` tinyint(3) unsigned default NULL,
  `email_tpl_group_from_name` varchar(255) default NULL,
  `email_tpl_group_from_address` varchar(255) default NULL,
  `email_tpl_group_reply_name` varchar(255) default NULL,
  `email_tpl_group_reply_address` varchar(255) default NULL,
  `email_tpl_group_cc_address` varchar(255) default NULL,
  `email_tpl_group_bcc_address` varchar(255) default NULL,
  PRIMARY KEY  (`email_tpl_group_id`),
  KEY `email_action_id` (`email_action_id`)
) AUTO_INCREMENT=26;

--
-- Dumping data for table `email_tpl_groups`
--

LOCK TABLES `email_tpl_groups` WRITE;
/*!40000 ALTER TABLE `email_tpl_groups` DISABLE KEYS */;
INSERT INTO `email_tpl_groups` VALUES (1,'packageInfo - Hosting Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(2,'packageInfo - Non-Hosting Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(3,'packageInfo - Domain Registration Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(4,'packageInfo - Usage Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(5,'cc Payment Email',3,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(6,'eCheck Payment Email',4,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(7,'packageInfo - Contract Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(8,'Invoice Email',2,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(9,'Bank Draft Email',5,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(10,'Manual Payment Email',6,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(11,'CC Expire Notice',13,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(12,'Secondary Gateway Email',7,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(13,'Declined Charge',8,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(14,'Error Payment Email',9,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(15,'Domain Renewal Email',10,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(16,'Successful Domain Transfer',11,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(17,'Failed Domain Transfer Email',12,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(18,'[1] 1st Notice',14,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(19,'[2] 2nd Notice',14,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(20,'[3] 3rd Notice - Suspension Email',14,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(21,'[X] Account Deletion',14,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(22,'Package Enable Email',15,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(23,'Password Notification Emails',16,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(24,'User Defined Emails',17,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL),(25,'New Order Emails',20,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
/*!40000 ALTER TABLE `email_tpl_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_tpls`
--

DROP TABLE IF EXISTS `email_tpls`;
CREATE TABLE `email_tpls` (
  `email_tpl_id` smallint(5) unsigned NOT NULL auto_increment,
  `email_tpl_group_id` smallint(5) unsigned default NULL,
  `email_tpl_subject` varchar(255) default NULL,
  `email_tpl_primary` tinyint(3) unsigned default NULL,
  `email_tpl_body` text,
  `email_tpl_text_body` text,
  `language_id` smallint(5) unsigned default NULL,
  `country_type` tinyint(3) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `regions_id` char(3) default NULL,
  PRIMARY KEY  (`email_tpl_id`),
  KEY `email_tpl_group_id` (`email_tpl_group_id`),
  KEY `language_id` (`language_id`),
  KEY `country_type` (`country_type`),
  KEY `countries_id` (`countries_id`),
  KEY `regions_id` (`regions_id`),
  KEY `email_tpl_primary` (`email_tpl_primary`)
) AUTO_INCREMENT=26;

--
-- Dumping data for table `email_tpls`
--

LOCK TABLES `email_tpls` WRITE;
/*!40000 ALTER TABLE `email_tpls` DISABLE KEYS */;
INSERT INTO `email_tpls` VALUES (1,1,'Welcome {$contactFirstName} {$contactLastName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Welcome to `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n  	  &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Welcome {$contactFirstName} {$contactLastName}!&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n        Thank you for signing up with {$companyName}. Your new account information is provided below.&lt;br /&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;ACCOUNT INFORMATION:&quot;}\n\n		 		   		&lt;font color=&quot;#ec7400&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Plan:&lt;/strong&gt;&lt;/font&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt; {$packageName}&lt;br /&gt;\n                        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Price:&lt;/strong&gt;&lt;/font&gt; {$packagePrice|getAmount:$currencyID}&lt;br /&gt;\n                        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Domain:&lt;/strong&gt;&lt;/font&gt; {$domainSLD}.{$domainTLD}&lt;br /&gt;\n                        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;IP Address:&lt;/strong&gt;&lt;/font&gt; {$packageIP}&lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n\n\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;LOGIN INFORMATION:&quot;}\n\n                          &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#ec7400&quot;&gt;Domain:&lt;/font&gt;&lt;/strong&gt; {$domainSLD}.{$domainTLD}&lt;br /&gt;\n                          &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Username:&lt;/strong&gt;&lt;/font&gt; {$packageUsername}&lt;br /&gt;\n                          &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Password:&lt;/strong&gt;&lt;/font&gt; {$packagePassword}&lt;/font&gt;\n        {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n		&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;FTP INFORMATION:&quot;}\n\n                          &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#ec7400&quot;&gt;FTP:&lt;/font&gt;&lt;/strong&gt; {$packageIP}&lt;br /&gt;\n                          &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Username:&lt;/strong&gt;&lt;/font&gt; {$packageUsername}&lt;br /&gt;\n                          &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Password:&lt;/strong&gt;&lt;/font&gt; {$packagePassword}&lt;/font&gt;\n        {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;TELNET/SSH INFORMATION:&quot;}\n\n                          &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#ec7400&quot;&gt;SSH:&lt;/font&gt;&lt;/strong&gt; {$packageIP}&lt;br /&gt;\n                          &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Username:&lt;/strong&gt;&lt;/font&gt; {$packageUsername}&lt;br /&gt;\n                          &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Password:&lt;/strong&gt;&lt;/font&gt; {$packagePassword}&lt;/font&gt;\n        {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;NAMESERVER INFORMATION:&quot;}\n\n                          &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot; color=&quot;#ec7400&quot;&gt;\n                          {if $nameserver1}&lt;strong&gt;{$nameserver1}:&lt;/strong&gt; {$nameserver1IP}&lt;br /&gt;{/if}\n                          {if $nameserver2}&lt;strong&gt;{$nameserver2}:&lt;/strong&gt; {$nameserver2IP}&lt;br /&gt;{/if}\n                          {if $nameserver3}&lt;strong&gt;{$nameserver3}:&lt;/strong&gt; {$nameserver3IP}&lt;br /&gt;{/if}\n                          {if $nameserver4}&lt;strong&gt;{$nameserver4}:&lt;/strong&gt; {$nameserver4IP}&lt;br /&gt;{/if}\n                          &lt;/font&gt;\n        {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;You may access your control panel at &lt;a href=&quot;http://{$packageIP}/CONTROL PANEL PATH&quot; target=&quot;_blank&quot;&gt;http://{$packageIP}/CONTROL PANEL PATH&lt;/a&gt; or &lt;a href=&quot;http://{$domainSLD}.{$domainTLD}/CONTROL PANEL PATH&quot; target=&quot;_blank&quot;&gt;http://{$domainSLD}.{$domainTLD}/CONTROL PANEL PATH&lt;/a&gt; if your domain has been transferred to our nameservers.&lt;/font&gt;&lt;/td&gt;\n	  &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/bottomTableStart.tpl&quot;}\n        &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;BILLING:&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Login to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!&lt;br /&gt;\n                  &lt;br /&gt;\n                  &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n                  &lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}&lt;br /&gt;\n                  &lt;br /&gt;\n                Need help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password. &lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td height=&quot;10&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/bottomTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Welcome {$contactFirstName} {$contactLastName}!\n  \nThank you for signing up with {$companyName}. Your new account information is provided below.\n\nACCOUNT INFORMATION:\n\nPlan: {$packageName}\nPrice: {$packagePrice|getAmount:$currencyID}\nDomain: {$domainSLD}.{$domainTLD}\nIP Address: {$packageIP}\n\nLOGIN INFORMATION:\n\nDomain: {$domainSLD}.{$domainTLD}\nUsername: {$packageUsername}\nPassword: {$packagePassword}\n\nFTP INFORMATION:\n\nFTP: {$packageIP}\nUsername: {$packageUsername}\nPassword: {$packagePassword}\n\nTELNET/SSH INFORMATION:\n\nSSH: {$packageIP}\nUsername: {$packageUsername}\nPassword: {$packagePassword}\n\nNAMESERVER INFORMATION:\n\n{if $nameserver1}{$nameserver1}: {$nameserver1IP}\n{/if}{if $nameserver2}{$nameserver2}: {$nameserver2IP}\n{/if}{if $nameserver3}{$nameserver3}: {$nameserver3IP}\n{/if}{if $nameserver4}{$nameserver4}: {$nameserver4IP}\n{/if}\nYou may access your control panel at http://{$packageIP}/CONTROL PANEL PATH or http://{$domainSLD}.{$domainTLD}/CONTROL PANEL PATH if your domain has been transferred to our nameservers.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL}\n\n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(2,2,'Welcome {$contactFirstName} {$contactLastName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Welcome to `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Welcome {$contactFirstName} {$contactLastName}!&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Thank you for purchasing {$packageName} with {$companyName}.&lt;br /&gt;\n          &lt;br /&gt;\n          This email contains important information regarding your order.&lt;br /&gt;&lt;br /&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;BILLING:&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Login to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!&lt;br /&gt;\n                  &lt;br /&gt;\n                  &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n                  &lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}&lt;br /&gt;\n                  &lt;br /&gt;\n                Need help with your password? Visit the URL above and click the &amp;quot;Forgot your password?&amp;quot; link to retrieve your password. &lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n      {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n                        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Welcome {$contactFirstName} {$contactLastName}! \n\nThank you for purchasing {$packageName} with {$companyName}. This email contains important information regarding your order.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(3,3,'Thank You for Registering with {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Thank you for Registering with `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Thank you for registering/transferring {$domainSLD}.{$domainTLD} to {$companyName}. If you are registering a new domain name, this will occur shortly. If you are transferring a domain, an email will be sent to you when the transfer occurs.&lt;br /&gt;&lt;br /&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;DOMAIN INFORMATION:&quot;}\n\n        &lt;font color=&quot;#ec7400&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Domain&lt;/strong&gt;&lt;/font&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt; {$domainSLD}.{$domainTLD}&lt;br /&gt;\n                        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Term:&lt;/strong&gt;&lt;/font&gt; {$packageCycleName}\n        &lt;/font&gt;\n        {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n&lt;br /&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n      {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;NAMESERVER INFORMATION:&quot;}\n\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Remember to update your DNS entries in order for your domain to propagate to your new hosting account.\n		&lt;br /&gt;&lt;br /&gt;The DNS entries are listed below:&lt;/font&gt;&lt;br /&gt;\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#ec7400&quot;&gt;{$nameserver1}:&lt;/font&gt;&lt;/strong&gt; {$nameserver1IP}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;{$nameserver2}:&lt;/strong&gt;&lt;/font&gt; {$nameserver2IP}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;{$nameserver3}:&lt;/strong&gt;&lt;/font&gt; {$nameserver3IP}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;{$nameserver4}:&lt;/strong&gt;&lt;/font&gt; {$nameserver4IP}&lt;/font&gt;\n	   {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n                        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/bottomTableStart.tpl&quot;}\n        &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;BILLING:&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Login to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!&lt;br /&gt;\n                  &lt;br /&gt;\n                  &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n                  &lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}&lt;br /&gt;\n                  &lt;br /&gt;\n                Need help with your password? Visit the URL above and click the &amp;quot;Forgot your password?&amp;quot; link to retrieve your password. &lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n&lt;br /&gt;\n      &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/bottomTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Dear {$contactFirstName} {$contactLastName}, \n  \nThank you for registering/transferring {$domainSLD}.{$domainTLD} to {$companyName}. If you are registering a new domain name, this will occur shortly. If you are transferring a domain, an email will be sent to you when the transfer occurs.\n\nDOMAIN INFORMATION:\n\nDomain {$domainSLD}.{$domainTLD}\nTerm: {$packageCycleName}\n\nNAMESERVER INFORMATION:\n\nRemember to update your DNS entries in order for your domain to propagate to your new hosting account. The DNS entries are listed below:\n\n{$nameserver1}: {$nameserver1IP}\n{$nameserver2}: {$nameserver2IP}\n{$nameserver3}: {$nameserver3IP}\n{$nameserver4}: {$nameserver4IP}\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(4,4,'Welcome {$contactFirstName} {$contactLastName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Welcome `$contactFirstName` `$contactLastName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Thank you for ordering your {$packageName} with {$companyName}. &lt;br /&gt;\n          &lt;br /&gt;\n          This email contains important information regarding your order.&lt;br /&gt;&lt;br /&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;BILLING:&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Login to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!&lt;br /&gt;\n                  &lt;br /&gt;\n                  &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n                  &lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}&lt;br /&gt;\n                  &lt;br /&gt;\n                Need help with your password? Visit the URL above and click the &amp;quot;Forgot your password?&amp;quot; link to retrieve your password. &lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n      {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n                        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nThank you for ordering your {$packageName} with {$companyName}. This email contains important information regarding your order.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(5,5,'Credit Card Receipt: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Credit Card Receipt: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.&lt;br /&gt;&lt;br /&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Credit Card Type:&lt;/strong&gt;&lt;/font&gt; {$billingCardType}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Credit Card Number:&lt;/strong&gt;&lt;/font&gt; {$billingAccountNumLastFour}\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Return:&lt;/strong&gt;&lt;/font&gt; {$authReturn}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Code:&lt;/strong&gt;&lt;/font&gt; {$authCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;AVS Code:&lt;/strong&gt;&lt;/font&gt; {$avsCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;You will see a charge from {$companyName} for this transaction.&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/bottomTableStart.tpl&quot;}\n      &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/bottomTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nYour Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.\n\nPAYMENT INFORMATION:\n\nCredit Card Type: {$billingCardType}\nCredit Card Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nYou will see a charge from {$companyName} for this transaction.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(6,6,'eCheck Payment Receipt: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;eCheck Payment Receipt: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.&lt;br /&gt;&lt;br /&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Bank Name:&lt;/strong&gt;&lt;/font&gt; {$billingBankName}&lt;br /&gt;\n		&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Bank ABA Code:&lt;/strong&gt;&lt;/font&gt; {$billingBankAbaCode}&lt;br /&gt;\n		&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Bank Account Number:&lt;/strong&gt;&lt;/font&gt; {$billingAccountNumLastFour}&lt;br /&gt;\n\n&lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Return:&lt;/strong&gt;&lt;/font&gt; {$authReturn}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Code:&lt;/strong&gt;&lt;/font&gt; {$authCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;AVS Code:&lt;/strong&gt;&lt;/font&gt; {$avsCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;You will see a charge from {$companyName} for this transaction.&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/bottomTableStart.tpl&quot;}\n      &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/bottomTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nYour Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.\n\nPAYMENT INFORMATION:\n\nBank Name: {$billingBankName}\nBank ABA Code: {$billingBankAbaCode}\nBank Account Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nYou will see a charge from {$companyName} for this transaction.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(7,7,'Welcome {$contactFirstName} {$contactLastName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Welcome `$contactFirstName` `$contactLastName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Thank you for ordering your {$packageName} with {$companyName}. &lt;br /&gt;\n          &lt;br /&gt;\n          This email contains important information regarding your order.&lt;br /&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;BILLING:&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Login to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!&lt;br /&gt;\n                  &lt;br /&gt;\n                  &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n                  &lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}&lt;br /&gt;\n                  &lt;br /&gt;\n                Need help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password. &lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n      {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n                        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nThank you for ordering your {$packageName} with {$companyName}. This email contains important information regarding your order.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(8,8,'Invoice ({$invoiceNumber}): {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Invoice `$invoiceNumber`: `$companyName`&quot;}\n{include file=&quot;$tplDirectory/widgets/topTableStart.tpl&quot;}\n&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n&lt;br /&gt;\nThis is a notice that Invoice {$invoiceNumber} has been generated for services by {$companyName} on {$invoiceDateEntered|getDate}.&lt;/font&gt;&lt;br /&gt; &lt;br /&gt;\n&lt;table width=&quot;97%&quot; border=&quot;0&quot; cellpadding=&quot;0&quot; cellspacing=&quot;1&quot; bgcolor=&quot;#86b8e6&quot;&gt;\n  &lt;tbody&gt;\n  &lt;tr&gt;\n&lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n  &lt;tr&gt;\n    &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n    &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Description&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/th&gt;\n  \n&lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n  &lt;tr&gt;\n    &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n    &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Period&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/th&gt;\n  &lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n    &lt;tr&gt;\n      &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;/tr&gt;\n    &lt;tr&gt;\n      &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n      &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Qty&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n    &lt;/tr&gt;\n  &lt;/table&gt;\n    &lt;/th&gt;\n&lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n  &lt;tr&gt;\n    &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n    &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Price&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/th&gt;\n&lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n  &lt;tr&gt;\n    &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n    &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Disc.&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/th&gt;\n&lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n  &lt;tr&gt;\n    &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n    &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Tax&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/th&gt;\n&lt;th bgcolor=&quot;#b9d6f0&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td height=&quot;1&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n  &lt;tr&gt;\n    &lt;td width=&quot;1&quot; bgcolor=&quot;#FFFFFF&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n    &lt;td width=&quot;4&quot;&gt;&lt;/td&gt;\n    &lt;td&gt;&lt;div align=&quot;center&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#406789&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Total&lt;/font&gt;&lt;/strong&gt;&lt;/div&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/th&gt;\n&lt;/tr&gt; {foreach key=&quot;i&quot; item=&quot;lineItem&quot; from=$lineItems}\n&lt;tr&gt;\n	&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemDescription}\n{if $lineItem.domains.0}\n	{foreach key=&quot;xd&quot; item=&quot;domain&quot; from=$lineItem.domains}\n		&lt;br /&gt;&lt;b&gt;{$domain.domainSLD}.{$domain.domainTLD}&lt;/b&gt;\n	{/foreach}\n{elseif $lineItem.domainName}\n&lt;br /&gt;{$lineItem.domainName}\n{/if}&lt;/font&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/td&gt;\n	&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;\n		&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n			&lt;tr&gt;\n				&lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemDateCurrentRenewal|getDate:short} - {$lineItem.lineItemDateNextRenewal|getDate:short}&lt;/font&gt;&lt;/td&gt;\n			&lt;/tr&gt;\n		&lt;/table&gt;\n	&lt;/td&gt;\n	&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;\n		&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n			&lt;tr&gt;\n				&lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemQuantity}&lt;/font&gt;&lt;/td&gt;\n			&lt;/tr&gt;\n		&lt;/table&gt;\n	&lt;/td&gt;\n&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemPriceAmount|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/td&gt;\n&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemDiscountAmount|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/td&gt;\n&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemTaxAmount|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/td&gt;\n&lt;td bgcolor=&quot;#f5f5f5&quot;&gt;&lt;table width=&quot;100%&quot; border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot;&gt;\n  &lt;tr&gt;\n    &lt;td&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$lineItem.lineItemTotalAmount|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n  &lt;/tr&gt;\n&lt;/table&gt;  &lt;/td&gt;\n&lt;/tr&gt; {/foreach} &lt;/tbody&gt;&lt;/table&gt; &lt;br /&gt;\n&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;&lt;font color=&quot;#ec7400&quot;&gt;Total Due:&lt;/font&gt;&lt;/strong&gt; {$invoiceAmount|getAmount:$currencyID}&lt;br /&gt;\n&lt;br /&gt;\n&lt;strong&gt;&lt;font color=&quot;#ec7400&quot;&gt;Due Date:&lt;/font&gt;&lt;/strong&gt; {$invoiceDateDue|getDate}&lt;br /&gt;\n&lt;br /&gt;\n&lt;/font&gt;\n&lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n&lt;p&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$invoiceComments}&lt;/font&gt;&lt;/p&gt;\n&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{if $paymentType==$billingTypeCard} Our records show that you pay with credit card.  We will charge your card automatically for the balance of this invoice automatically if necessary. {elseif $paymentType==$billingTypeBank} Our records show that you pay through bank drafts. Please remit payment for your outstanding balance. {elseif $paymentType==$billingTypeEcheck} Our records show that you pay through eCheck.  We will charge your account automatically for the balance of this invoice.  {elseif $paymentType==$billingTypeSecondary} Our records show that you pay through PayPal.  If you have a subscription set up, then your payment will be made automatically. If not, please remit payment for your outstanding balance to XXX@XXX.com through PayPal. {elseif $paymentType==$billingTypeWire} Our records show that you pay through wire transfer.  Please remit payment for your outstanding balance. {else} Our records show that you pay manually.  Please remit payment for your outstanding balance.{/if} &lt;br /&gt; &lt;br /&gt;\n{$companyName}&lt;br /&gt;\n{$companyAddress1}&lt;br /&gt;\n{$companyAddress2}&lt;br /&gt;\n{$companyCity}, {$companyState}&lt;br /&gt;\n{$companyZip}&lt;br /&gt;\n&lt;br /&gt;\nYou may login to view your invoice online here:&lt;br /&gt;\n&lt;br /&gt;\n&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n&lt;br /&gt;\nThank you,&lt;br /&gt;&lt;br /&gt;\n{$companyName}&lt;br /&gt;\n&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;br /&gt;&lt;br /&gt;\nDate: {$currentTime|getDateTime:full}&lt;/font&gt;&lt;br /&gt;&lt;br /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/topTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice that Invoice {$invoiceNumber} has been generated for services by {$companyName} on {$invoiceDateEntered|getDate}.\n\n{foreach key=&quot;i&quot; item=&quot;lineItem&quot; from=$lineItems}\nDescription: {$lineItem.lineItemDescription} {if $lineItem.domains.0}\n({foreach key=&quot;xd&quot; item=&quot;domain&quot; from=$lineItem.domains}{$domain.domainSLD}.{$domain.domainTLD} {/foreach})\n{elseif $lineItem.domainName}\n({$lineItem.domainName})\n{/if}Period: {$lineItem.lineItemDateCurrentRenewal|getDate:short} - {$lineItem.lineItemDateNextRenewal|getDate:short}\nQuantity: {$lineItem.lineItemQuantity}\nPrice: {$lineItem.lineItemPriceAmount}\nDiscount: {$lineItem.lineItemDiscountAmount}\nTax: {$lineItem.lineItemTaxAmount}\nItem Total: {$lineItem.lineItemTotalAmount}\n\n{/foreach}\n\n------------------------------------------\nTotal Due: {$invoiceAmount}\nDue Date: {$invoiceDateDue|getDate}\n\n{$invoiceComments}\n{if $paymentType==$billingTypeCard} Our records show that you pay with credit card. We will charge your card automatically for the balance of this invoice automatically if necessary. {elseif $paymentType==$billingTypeBank} Our records show that you pay through bank drafts. Please remit payment for your outstanding balance. {elseif $paymentType==$billingTypeEcheck} Our records show that you pay through eCheck. We will charge your account automatically for the balance of this invoice. {elseif $paymentType==$billingTypeSecondary} Our records show that you pay through PayPal. If you have a subscription set up, then your payment will be made automatically. If not, please remit payment for your outstanding balance to XXX@XXX.com through PayPal. {elseif $paymentType==$billingTypeWire} Our records show that you pay through wire transfer. Please remit payment for your outstanding balance. {else} Our records show that you pay manually. Please remit payment for your outstanding balance.{/if}\n\n\n{$companyName}\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nYou may login to view your invoice online here:\n{$companyClientURL}\n\nThank you,\n\n{$companyName}\n{$companyURL}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(9,9,'Bank Draft Payment Receipt: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Bank Draft Payment Receipt: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.&lt;br /&gt;&lt;br /&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Bank Name:&lt;/strong&gt;&lt;/font&gt; {$billingBankName}&lt;br /&gt;\n		&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Bank ABA Code:&lt;/strong&gt;&lt;/font&gt; {$billingBankAbaCode}&lt;br /&gt;\n		&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Bank Account Number:&lt;/strong&gt;&lt;/font&gt; {$billingAccountNumLastFour}&lt;br /&gt;\n\n&lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Return:&lt;/strong&gt;&lt;/font&gt; {$authReturn}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Code:&lt;/strong&gt;&lt;/font&gt; {$authCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;AVS Code:&lt;/strong&gt;&lt;/font&gt; {$avsCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n&lt;br /&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;You will see a charge from {$companyName} for this transaction.&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/bottomTableStart.tpl&quot;}\n      &lt;tr&gt;\n        &lt;td bgcolor=&quot;#FFFFFF&quot;&gt;\n		{include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/bottomTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nYour Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.\n\nPAYMENT INFORMATION:\n\nBank Name: {$billingBankName}\nBank ABA Code: {$billingBankAbaCode}\nBank Account Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nYou will see a charge from {$companyName} for this transaction.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(10,10,'Payment Receipt: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Payment Receipt: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          A payment has been applied to Invoice {$invoiceNumber}.&lt;br /&gt;&lt;br /&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Thank you for your payment.&lt;/font&gt;&lt;br /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;&lt;img name=&quot;&quot; src=&quot;&quot; width=&quot;1&quot; height=&quot;10&quot; alt=&quot;&quot; /&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n      {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n                        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nA payment has been applied to Invoice {$invoiceNumber}.\n\nPAYMENT INFORMATION:\n\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nThank you for your payment.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(11,11,'Credit Card Expiration Notice: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Credit Card Expiration Notice: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;This is a notice to inform you that your credit card on file with {$companyName} has expired or will be expiring soon:\n			 &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n&lt;br /&gt;&lt;br /&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;CREDIT CARD INFORMATION:&quot;}\n\n        &lt;font color=&quot;#ec7400&quot; size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Credit Card: &lt;/strong&gt;&lt;/font&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;{$billingCardType} - {$billingAccountNumLastFour}&lt;br /&gt;\n                        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Expire Month:&lt;/strong&gt;&lt;/font&gt; {$billingCardExpMonth}&lt;br /&gt;\n                        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Expire Year:&lt;/strong&gt;&lt;/font&gt; {$billingCardExpYear}&lt;/font&gt;\n        {include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot; height=&quot;10&quot;&gt;\n        &lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Please login to your account and update your credit card as soon as possible in order to avoid an interruption in your service.&lt;br /&gt;&lt;br /&gt;\n        Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your credit card on file with {$companyName} has expired or will be expiring soon: \n\nCREDIT CARD INFORMATION:\n\nCredit Card: {$billingCardType} - {$billingAccountNumLastFour}\nExpire Month: {$billingCardExpMonth}\nExpire Year: {$billingCardExpYear}\n\nPlease login to your account and update your credit card as soon as possible in order to avoid an interruption in your service:\n\n{$companyClientURL}\n  \n  Thank you,\n  \n  {$companyName}\n  {$companyURL} \n  \n  {$companyAddress1}\n  {$companyAddress2}\n  {$companyCity}, {$companyState}\n  {$companyZip}\n  \n  Date: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(12,12,'Payment Receipt: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Payment Receipt: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n			  A payment has been applied to your account at {$companyName}.&lt;br /&gt;&lt;br /&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Gateway Name:&lt;/strong&gt;&lt;/font&gt; {$gatewayName}\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;Thank you for your payment.&lt;br /&gt;&lt;br /&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n      {include file=&quot;$tplDirectory/widgets/contentBoxHeader.tpl&quot; contentBoxHeaderTitle=&quot;QUESTIONS?&quot;}\n		&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;br /&gt;\n                  &lt;br /&gt;\n                  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;\n                {include file=&quot;$tplDirectory/widgets/contentBoxFooter.tpl&quot;}\n                        &lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nA payment has been applied to your account at {$companyName}.\n\nPAYMENT INFORMATION:\n\nGateway Name: {$gatewayName}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nThank you for your payment.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(13,13,'Declined Charge: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Declined Charge: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          We have attempted to process your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}. However, your transaction was declined. Details are provided below:&lt;br/&gt;&lt;br/&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Credit Card Type:&lt;/strong&gt;&lt;/font&gt; {$billingCardType}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Credit Card Number:&lt;/strong&gt;&lt;/font&gt; {$billingAccountNumLastFour}\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Return:&lt;/strong&gt;&lt;/font&gt; {$authReturn}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Code:&lt;/strong&gt;&lt;/font&gt; {$authCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;AVS Code:&lt;/strong&gt;&lt;/font&gt; {$avsCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br/&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;NOTE: We will attempt to process your invoice again soon.&lt;br /&gt;&lt;br /&gt;\n        Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nWe have attempted to process your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}. However, your transaction was declined. Details are provided below:\n\nPAYMENT INFORMATION:\n\nCredit Card Type: {$billingCardType}\nCredit Card Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nNOTE: We will attempt to process your invoice again soon.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}',21,0,225,'2'),(14,14,'Payment Error: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Payment Error: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          We have attempted to process your invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}. However, your transaction was declined. Details are provided below:&lt;br /&gt;&lt;br /&gt;\n          &lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;\n        {include file=&quot;$tplDirectory/widgets/boxHeader.tpl&quot; boxHeaderTitle=&quot;PAYMENT INFORMATION:&quot;}\n\n        &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Credit Card Type:&lt;/strong&gt;&lt;/font&gt; {$billingCardType}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Credit Card Number:&lt;/strong&gt;&lt;/font&gt; {$billingAccountNumLastFour}\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Date/Time:&lt;/strong&gt;&lt;/font&gt; {$transactionDateCreated|getDate}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction ID:&lt;/strong&gt;&lt;/font&gt; {$transactionCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Return:&lt;/strong&gt;&lt;/font&gt; {$authReturn}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Auth Code:&lt;/strong&gt;&lt;/font&gt; {$authCode}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;AVS Code:&lt;/strong&gt;&lt;/font&gt; {$avsCode}&lt;br /&gt;\n        &lt;hr size=&quot;1&quot; noshade=&quot;noshade&quot; color=&quot;#cccccc&quot;/&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Transaction Amount:&lt;/strong&gt;&lt;/font&gt; {$transactionAmount|getAmount:$currencyID}&lt;br /&gt;\n        &lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Notes:&lt;/strong&gt;&lt;/font&gt; {$transactionNotes}\n        &lt;/font&gt;\n		{include file=&quot;$tplDirectory/widgets/boxFooter.tpl&quot;}\n        &lt;/td&gt;\n      &lt;/tr&gt;\n      &lt;tr&gt;\n        &lt;td width=&quot;352&quot;&gt;&lt;br /&gt;&lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;NOTE: We will attempt to process your invoice again soon. Please log into the billing system to correct this error:&lt;br /&gt;&lt;br /&gt;\n        &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;&lt;br /&gt;\n        Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nWe have attempted to process your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}. However, your transaction was declined. Details are provided below:\n\nPAYMENT INFORMATION:\n\nCredit Card Type: {$billingCardType}\nCredit Card Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes} {include file=&amp;quot;$tplDirectory/widgets/boxFooter.tpl&amp;quot;}\n\nNOTE: We will attempt to process your invoice again soon. Please log into the billing system to correct this error:\n\n{$companyClientURL}\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(15,15,'Domain Renewal Notice: {$domainSLD}.{$domainTLD}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Domain Renewal Notice: `$domainSLD`.`$domainTLD`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          This is a notice to inform you that your domain {$domainSLD}.{$domainTLD} has been invoiced in the amount of {$invoiceAmount|getAmount:$currencyID} on {$invoiceDateEntered|getDate}. Your domain will be renewed once payment has been made on the invoice.&lt;br /&gt;&lt;br /&gt;\n          &lt;strong&gt;Domain Expiry Date:&lt;/strong&gt; {$domainDateExpires|getDate}&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your domain {$domainSLD}.{$domainTLD} has been invoiced in the amount of {$invoiceAmount|getAmount:$currencyID} on {$invoiceDateEntered|getDate}. Your domain will be renewed once payment has been made on the invoice.\n\nDomain Expiry Date: {$domainDateExpires|getDate}\n\nThank you,\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(16,16,'Domain Transfer Success: {$domainSLD}.{$domainTLD}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Domain Transfer Success: `$domainSLD`.`$domainTLD`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          This is a notice to inform you that your domain {$domainSLD}.{$domainTLD} has been transferred to {$companyName} successfully.&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your domain {$domainSLD}.{$domainTLD} has been transferred to {$companyName} successfully.\n\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(17,17,'Failed Domain Transfer: {$domainSLD}.{$domainTLD}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Failed Domain Transfer: `$domainSLD`.`$domainTLD`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          This is a notice to inform you that your domain {$domainSLD}.{$domainTLD} failed to transfer to {$companyName} successfully.&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your domain {$domainSLD}.{$domainTLD} failed to transfer to {$companyName} successfully.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(18,18,'1st Notice: Invoice Overdue',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Reminder: `$companyName` Invoice Overdue&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          This is a reminder that your Invoice {$invoiceNumber} with {$companyName} is now past due.&lt;br /&gt;&lt;br /&gt;\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice. If the invoice is not paid in full, your account will be subject to suspension.&lt;br /&gt;&lt;br /&gt;\n\n&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Login URL:&lt;/strong&gt;&lt;/font&gt; &lt;a href=&quot;{$companyClientURL}&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Login Username:&lt;/strong&gt;&lt;/font&gt; {$contactUsername}&lt;br /&gt;&lt;br /&gt;\nIf you have forgotten your password, the above URL has a Forgot Password link.&lt;br /&gt;&lt;br /&gt;\n\nIf you have already submitted payment, please disregard this message as your payment is currently being processed and your account will be updated to reflect your new balance shortly. We appreciate your business. If there is anything we can do for you, please let us know.&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Dear {$contactFirstName} {$contactLastName},\n\nThis is a reminder that your Invoice {$invoiceNumber} with {$companyName} is now past due.\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice. If the invoice is not paid in full, your account will be subject to suspension.\n\nLogin URL: {$companyClientURL}\nLogin Username: {$contactUsername}\n\nIf you have forgotten your password, the above URL has a Forgot Password link.\n\nIf you have already submitted payment, please disregard this message as your payment is currently being processed and your account will be updated to reflect your new balance shortly. We appreciate your business. If there is anything we can do for you, please let us know.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(19,19,'2nd Notice: Invoice Overdue',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;2nd Notice: `$companyName` Invoice Overdue&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          This is the second notice that your invoice {$invoiceNumber} with {$companyName} is past due.&lt;br /&gt;&lt;br /&gt;\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice. If the invoice is not paid in full, your account will be subject to suspension as stated in our Terms and Conditions that you agreed to at the time of purchase.&lt;br /&gt;&lt;br /&gt;\n\n&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Login URL:&lt;/strong&gt;&lt;/font&gt; &lt;a href=&quot;{$companyClientURL}&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Login Username:&lt;/strong&gt;&lt;/font&gt; {$contactUsername}&lt;br /&gt;&lt;br /&gt;\nIf you have forgotten your password, the above URL has a Forgot Password link.&lt;br /&gt;&lt;br /&gt;\n\nWe appreciate your prompt attention in this matter.&lt;br /&gt;&lt;br /&gt;\n\nIf you have already submitted payment, please disregard this message as your payment is currently being processed and your account will be updated to reflect your new balance shortly.\n&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Dear {$contactFirstName} {$contactLastName},\n\nThis is the second notice that your invoice {$invoiceNumber} with {$companyName} is past due.\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice. If the invoice is not paid in full, your account will be subject to suspension as stated in our Terms and Conditions that you agreed to at the time of purchase.\n\nLogin URL: {$companyClientURL}\nLogin Username: {$contactUsername}\n\nIf you have forgotten your password, the above URL has a Forgot Password link.\n\nWe appreciate your prompt attention in this matter.\n\nIf you have already submitted payment, please disregard this message as your payment is currently being processed and your account will be updated to reflect your new balance shortly. \n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(20,20,'Final Notice: Package Suspension',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Final Notice: `$companyName` Package Suspended&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n         This is the 3rd and FINAL notice that your invoice {$invoiceNumber} with {$companyName} is past due. Your account has been suspended until payment is made in full on your invoice.&lt;br /&gt;&lt;br /&gt;\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice to re-activate service. If the invoice is not paid in full, your account will be subject to termination in accordance with our Terms and Conditions that you agreed to at the time of purchase.&lt;br /&gt;&lt;br /&gt;\n\n&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Login URL:&lt;/strong&gt;&lt;/font&gt; &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt;\n&lt;font color=&quot;#ec7400&quot;&gt;&lt;strong&gt;Login Username:&lt;/strong&gt;&lt;/font&gt; {$contactUsername}&lt;br /&gt;&lt;br /&gt;\nIf you have forgotten your password, the above URL has a Forgot Password link.&lt;br /&gt;&lt;br /&gt;\n\nIf you believe this message to be in error, please provide either the last four digits of the credit card you made payment with, a check number, or third party gateway receipt so that we can correct any discrepancies.&lt;br /&gt;&lt;br /&gt;\n\nIf you have already submitted payment, please contact us immediately so that we can determine the current status of your account.\n\n&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Dear {$contactFirstName} {$contactLastName},\n\nThis is the 3rd and FINAL notice that your invoice {$invoiceNumber} with {$companyName} is past due. Your account has been suspended until payment is made in full on your invoice.\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice to re-activate service. If the invoice is not paid in full, your account will be subject to termination in accordance with our Terms and Conditions that you agreed to at the time of purchase.\n\nLogin URL: {$companyClientURL}\nLogin Username: {$contactUsername}\n\nIf you have forgotten your password, the above URL has a Forgot Password link.\n\nIf you believe this message to be in error, please provide either the last four digits of the credit card you made payment with, a check number, or third party gateway receipt so that we can correct any discrepancies.\n\nIf you have already submitted payment, please contact us immediately so that we can determine the current status of your account. \n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(21,21,'Account Deleted: {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Account Terminated: `$companyName`&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n         This is a notice to inform you that your account with {$companyName} has been terminated in accordance with our Terms and Conditions, due to the fact that there is currently an outstanding invoice on your account.&lt;br /&gt;&lt;br /&gt;\n\nWe have made a number of attempts to make contact prior to taking this action, but we have not received any response up to this point.&lt;br /&gt;&lt;br /&gt;\n\nIf you wish to re-establish service, please contact support.&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Dear {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your account with {$companyName} has been terminated in accordance with our Terms and Conditions, due to the fact that there is currently an outstanding invoice on your account.\n\n\nWe have made a number of attempts to make contact prior to taking this action, but we have not received any response up to this point.\n\nIf you wish to re-establish service, please contact support.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(22,22,'Package Re-Enabled Notice',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Package Re-Activation Notice&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;We have received your payment to your Invoice {$invoiceNumber} in the amount of {$invoiceAmountPaid|getAmount:$currencyID} on {$invoiceDatePaid|getDate}. Your account is now up to date and in good standing.&lt;br /&gt;&lt;br /&gt;\n			  Your package {$packageName} has been re-activated and you can continue using your account as normal.&lt;br /&gt;&lt;br /&gt;\n          	  We appreciate your cooperation and apologize for any surprise this may have caused.&lt;br /&gt;&lt;br /&gt;\n          	  Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}','Dear {$contactFirstName} {$contactLastName},\n\nWe have received your payment to your  Invoice {$invoiceNumber} in the amount of  {$invoiceAmountPaid|getAmount:$currencyID} on  {$invoiceDatePaid|getDate}. Your account is now up to date and in good  standing.\n\nYour package {$packageName} has been re-activated and you can continue using your account as normal.\n\nWe appreciate your cooperation and apologize for any surprise this may have caused.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(23,23,'Package Reset',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Password Reset&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;\n              &lt;br /&gt;\n          Your password has been reset. Your new password is: \'{$newPassword}\'&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Dear {$contactFirstName} {$contactLastName},\n\nYour password has been reset. Your new password is: \'{$newPassword}\'\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(24,24,'Insert Subject Here',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Insert Subject Here&quot;}\n\n{include file=&quot;$tplDirectory/widgets/leftColumnStart.tpl&quot;}\n      &lt;font size=&quot;2&quot; face=&quot;Tahoma&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;&lt;br /&gt;\n          Insert body here.&lt;br /&gt;&lt;br /&gt;\n          Thank you,&lt;br /&gt;\n                  &lt;br /&gt;\n                  {$companyName}&lt;br /&gt;\n                    &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/font&gt;&lt;/td&gt;\n      &lt;/tr&gt;\n{include file=&quot;$tplDirectory/widgets/leftColumnEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnStart.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumn.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/rightColumnEndTable.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Dear {$contactFirstName} {$contactLastName},\n\nInsert body here.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'2'),(25,25,'Welcome to {$companyName}',1,'{include file=&quot;$tplDirectory/widgets/header.tpl&quot; headerTitle=&quot;Welcome to `$companyName`&quot;}\n{include file=&quot;$tplDirectory/widgets/topTableStart.tpl&quot;}\n&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;br /&gt;               &lt;br /&gt;\nThank you very much for choosing {$companyName} as your Web and E-Commerce Hosting Provider. This is your order confirmation email for your Web hosting account with {$companyName}. Please note that this is not your account information. An email with your username, password, and IP address will be emailed to you later once your account is setup at {$companyName}.&lt;/font&gt;&lt;br /&gt; &lt;br /&gt;\n{include file=&quot;$tplDirectory/widgets/codeBoxHeader.tpl&quot; codeBoxHeaderTitle=&quot;CONTACT INFORMATION&quot;}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n&lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Email:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n&lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$contactEmail}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{if $contactCompany}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Company:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$contactCompany}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{elseif $clientCompany}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Company:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$clientCompany}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{/if}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Address:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td height=&quot;48&quot;&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$contactAddress1}&lt;br /&gt;\n	{strip}\n	{if $contactAddress2}\n	{$contactAddress2}&lt;br /&gt;\n	{/if}\n	{/strip}\n	{$contactCity}, {$contactState} {$contactZip} &lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Phone:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$contactPhone1}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{if $contactFax}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Fax:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$contactFax}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{/if}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;strong&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot; color=&quot;#ec7400&quot;&gt;Username:&lt;/font&gt;&lt;/strong&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$contactUsername}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{include file=&quot;$tplDirectory/widgets/codeBoxFooter.tpl&quot;}\n&lt;br /&gt;\n{include file=&quot;$tplDirectory/widgets/codeBoxHeader.tpl&quot; codeBoxHeaderTitle=&quot;ORDER INFORMATION&quot;}\n{foreach from=$lineItems item=&quot;lineItem&quot; key=&quot;xk&quot;}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;&lt;strong&gt;\n	\n{assign var=&quot;name&quot; value=$lineItem.lineItemDescription}{$smarty.const.$name|default:$name}\n{strip}\n{if $lineItem.domainName}\n{assign var=&quot;name&quot; value=$lineItem.domainName}\n&lt;br /&gt;{$smarty.const.$name|default:$name}\n{elseif $lineItem.domains.0}\n&lt;br /&gt;{$lineItem.domains.0.domainSLD}.{$lineItem.domains.0.domainTLD}\n{/if}\n{/strip}\n		&lt;/strong&gt;&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$cycles[$lineItem.cycleID]} @ {$lineItem.lineItemPriceAmount|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{foreachelse}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;- Empty - &lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{/foreach}\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;&lt;strong&gt;Sub Total&lt;/strong&gt;&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$invoiceSubTotal|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;&lt;strong&gt;Total Due&lt;/strong&gt;&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n&lt;table border=&quot;0&quot; cellspacing=&quot;5&quot; cellpadding=&quot;0&quot; width=&quot;100%&quot;&gt;\n &lt;tbody&gt;\n	&lt;tr&gt;\n	&lt;td&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;{$invoiceAmount|getAmount:$currencyID}&lt;/font&gt;&lt;/td&gt;\n	&lt;/tr&gt;\n &lt;/tbody&gt;\n&lt;/table&gt;\n{include file=&quot;$tplDirectory/widgets/codeBoxFooter.tpl&quot;}\n&lt;br /&gt;&lt;font face=&quot;Tahoma&quot; size=&quot;2&quot;&gt;Thank you for signing up!&lt;br /&gt;&lt;br /&gt;\n{$companyName}&lt;/font&gt;&lt;br /&gt;&lt;br /&gt;\n{include file=&quot;$tplDirectory/widgets/topTableEnd.tpl&quot;}\n{include file=&quot;$tplDirectory/widgets/footer.tpl&quot;}\n','Dear {$contactFirstName} {$contactLastName},\n\n Thank you very much for choosing {$companyName} as your Web and E-Commerce\nHosting Provider. This is your order confirmation email for your Web hosting\naccount with {$companyName}. Please note that this is not your account\ninformation. An email with your username, password, and IP address will be\nemailed to you later once your account is setup at {$companyName}.\n\nContact Information:\nEmail: {$contactEmail}\n{if $contactCompany}\nCompany: {$contactCompany}\n{elseif $clientCompany}\nCompany: {$clientCompany}\n{/if}\nAddress: {$contactAddress1} {strip}\n{if $contactAddress2}\n{$contactAddress2}\n{/if}\n{/strip}\n{$contactCity}, {$contactState} {$contactZip}\nPhone: {$contactPhone1}\n{if $contactFax}Fax: {$contactFax}\n{/if}\nUsername: {$contactUsername}\n\nOrder Information:\n\n{foreach from=$lineItems item=lineItem}\n{assign var=&quot;name&quot; value=$lineItem.lineItemDescription}{$smarty.const.$name|default:$name}\n{strip}\n{if $lineItem.domainName}\n{assign var=&quot;name&quot; value=$lineItem.domainName}\n{$smarty.const.$name|default:$name}\n{elseif $lineItem.domains.0}\n{$lineItem.domains.0.domainSLD}.{$lineItem.domains.0.domainTLD}\n{/if}\n{/strip}\n{$cycles[$lineItem.cycleID]} @ {$lineItem.lineItemTotalAmount|getAmount:$currencyID}\n{foreachelse}\n- Empty - \n{/foreach}\n\nSub Total: {$invoiceSubTotal|getAmount:$currencyID}\nTotal Due: {$invoiceAmount|getAmount:$currencyID}\n\n\nThank You for Signing Up!\n{$companyName}',21,0,225,'2');
/*!40000 ALTER TABLE `email_tpls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `faq_categories`
--

DROP TABLE IF EXISTS `faq_categories`;
CREATE TABLE `faq_categories` (
  `faq_category_id` tinyint(3) unsigned NOT NULL auto_increment,
  `faq_category_name` varchar(50) default NULL,
  `faq_category_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`faq_category_id`),
  KEY `faq_category_type` (`faq_category_type`)
);

--
-- Dumping data for table `faq_categories`
--

LOCK TABLES `faq_categories` WRITE;
/*!40000 ALTER TABLE `faq_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `faq_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `faqs`
--

DROP TABLE IF EXISTS `faqs`;
CREATE TABLE `faqs` (
  `faq_id` smallint(5) unsigned NOT NULL auto_increment,
  `faq_category_id` tinyint(3) unsigned default NULL,
  `faq_question` text,
  `faq_answer` longtext,
  `faq_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`faq_id`),
  KEY `faq_category_id` (`faq_category_id`)
);

--
-- Dumping data for table `faqs`
--

LOCK TABLES `faqs` WRITE;
/*!40000 ALTER TABLE `faqs` DISABLE KEYS */;
/*!40000 ALTER TABLE `faqs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fraud_country_thresholds`
--

DROP TABLE IF EXISTS `fraud_country_thresholds`;
CREATE TABLE `fraud_country_thresholds` (
  `threshold_id` int(10) unsigned NOT NULL auto_increment,
  `threshold_name` varchar(100) default NULL,
  `country_type` tinyint(3) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `regions_id` char(3) default NULL,
  `level_one_score` decimal(3,1) unsigned default NULL,
  `level_two_score` decimal(3,1) unsigned default NULL,
  `level_three_score` decimal(3,1) unsigned default NULL,
  `level_one_action` tinyint(3) unsigned default NULL,
  `level_two_action` tinyint(3) unsigned default NULL,
  `level_three_action` tinyint(3) unsigned default NULL,
  `catch_all_action` tinyint(3) unsigned default NULL,
  `override_one_amount` decimal(10,2) unsigned default NULL,
  `override_two_amount` decimal(10,2) unsigned default NULL,
  `override_three_amount` decimal(10,2) unsigned default NULL,
  `override_one_action` tinyint(3) unsigned default NULL,
  `override_two_action` tinyint(3) unsigned default NULL,
  `override_three_action` tinyint(3) unsigned default NULL,
  `primary_score_to_use` tinyint(3) unsigned default NULL,
  `free_email_weight` decimal(3,1) unsigned default NULL,
  `country_match_weight` decimal(3,1) unsigned default NULL,
  `anon_proxy_weight` decimal(3,1) unsigned default NULL,
  `country_risk_weight` decimal(3,1) unsigned default NULL,
  `ip_distance_weight` decimal(3,1) unsigned default NULL,
  `bin_match_weight` decimal(3,1) unsigned default NULL,
  `bin_bank_match_weight` decimal(3,1) unsigned default NULL,
  `high_risk_email_weight` decimal(3,1) unsigned default NULL,
  `high_risk_shipping_weight` decimal(3,1) unsigned default NULL,
  `open_proxy_weight` decimal(3,1) unsigned default NULL,
  `fraud_soft_reject_message` text,
  `fraud_hard_reject_message` text,
  PRIMARY KEY  (`threshold_id`),
  KEY `country_type` (`country_type`),
  KEY `countries_id` (`countries_id`),
  KEY `regions_id` (`regions_id`)
);

--
-- Dumping data for table `fraud_country_thresholds`
--

LOCK TABLES `fraud_country_thresholds` WRITE;
/*!40000 ALTER TABLE `fraud_country_thresholds` DISABLE KEYS */;
/*!40000 ALTER TABLE `fraud_country_thresholds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fraud_results_log`
--

DROP TABLE IF EXISTS `fraud_results_log`;
CREATE TABLE `fraud_results_log` (
  `fraud_result_log_id` int(10) unsigned NOT NULL auto_increment,
  `threshold_id` int(10) unsigned default NULL,
  `client_id` int(8) unsigned default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `fraud_result_order_email` varchar(100) default NULL,
  `fraud_result_order_amount` decimal(10,2) unsigned default NULL,
  `fraud_result_o_amount` decimal(10,2) unsigned default NULL,
  `fraud_result_o_amount_action` tinyint(3) unsigned default NULL,
  `fraud_result_default_score` decimal(3,1) unsigned default NULL,
  `fraud_result_adjusted_score` decimal(3,1) unsigned default NULL,
  `fraud_result_score_action` tinyint(3) unsigned default NULL,
  `fraud_result_final_action_used` tinyint(3) unsigned default NULL,
  `fraud_result_ip` bigint(20) default NULL,
  `fraud_result_ip_lon` decimal(10,6) default NULL,
  `fraud_result_ip_lat` decimal(10,6) default NULL,
  `fraud_result_ip_city` varchar(255) default NULL,
  `fraud_result_ip_region` varchar(255) default NULL,
  `fraud_result_ip_country` char(2) default NULL,
  `fraud_result_ip_isp` varchar(255) default NULL,
  `fraud_result_ip_org` varchar(255) default NULL,
  `fraud_result_ip_country_match` tinyint(3) unsigned default NULL,
  `fraud_result_ip_distance` smallint(5) unsigned default NULL,
  `fraud_result_bin` smallint(5) unsigned default NULL,
  `fraud_result_bin_country` char(2) default NULL,
  `fraud_result_bin_match` tinyint(3) unsigned default NULL,
  `fraud_result_bin_bank_match` tinyint(3) unsigned default NULL,
  `fraud_result_bin_name` varchar(255) default NULL,
  `fraud_result_bin_phone` varchar(255) default NULL,
  `fraud_result_bin_phone_match` tinyint(3) unsigned default NULL,
  `fraud_result_risky_email` tinyint(3) unsigned default NULL,
  `fraud_result_risky_country` tinyint(3) unsigned default NULL,
  `fraud_result_risky_shipping` tinyint(3) unsigned default NULL,
  `fraud_result_is_free_email` tinyint(3) unsigned default NULL,
  `fraud_result_is_anon_proxy` tinyint(3) unsigned default NULL,
  `fraud_result_is_open_proxy` tinyint(3) unsigned default NULL,
  `fraud_result_date_created` int(10) unsigned default NULL,
  `fraud_result_spam_score` decimal(3,1) unsigned default NULL,
  `fraud_result_phone_match` tinyint(3) unsigned default NULL,
  `fraud_result_billing_match` tinyint(3) unsigned default NULL,
  `fraud_result_ship_match` tinyint(3) unsigned default NULL,
  `fraud_result_error` varchar(255) default NULL,
  PRIMARY KEY  (`fraud_result_log_id`),
  KEY `threshold_id` (`threshold_id`),
  KEY `client_id` (`client_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `fraud_result_date_created` (`fraud_result_date_created`),
  KEY `fraud_result_ip_country` (`fraud_result_ip_country`),
  KEY `fraud_result_default_score` (`fraud_result_default_score`),
  KEY `fraud_result_adjusted_score` (`fraud_result_adjusted_score`)
);

--
-- Dumping data for table `fraud_results_log`
--

LOCK TABLES `fraud_results_log` WRITE;
/*!40000 ALTER TABLE `fraud_results_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `fraud_results_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fraud_set_order_form_rel`
--

DROP TABLE IF EXISTS `fraud_set_order_form_rel`;
CREATE TABLE `fraud_set_order_form_rel` (
  `fraud_set_id` tinyint(3) unsigned NOT NULL default '0',
  `order_form_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fraud_set_id`,`order_form_id`)
);

--
-- Dumping data for table `fraud_set_order_form_rel`
--

LOCK TABLES `fraud_set_order_form_rel` WRITE;
/*!40000 ALTER TABLE `fraud_set_order_form_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `fraud_set_order_form_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fraud_set_threshold_rel`
--

DROP TABLE IF EXISTS `fraud_set_threshold_rel`;
CREATE TABLE `fraud_set_threshold_rel` (
  `fraud_set_id` tinyint(3) unsigned NOT NULL default '0',
  `threshold_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fraud_set_id`,`threshold_id`)
);

--
-- Dumping data for table `fraud_set_threshold_rel`
--

LOCK TABLES `fraud_set_threshold_rel` WRITE;
/*!40000 ALTER TABLE `fraud_set_threshold_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `fraud_set_threshold_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fraud_sets`
--

DROP TABLE IF EXISTS `fraud_sets`;
CREATE TABLE `fraud_sets` (
  `fraud_set_id` tinyint(3) unsigned NOT NULL auto_increment,
  `config_group_id` smallint(5) unsigned default NULL,
  `fraud_set_name` varchar(75) default NULL,
  `fraud_set_email` varchar(100) default NULL,
  PRIMARY KEY  (`fraud_set_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `fraud_set_name` (`fraud_set_name`)
);

--
-- Dumping data for table `fraud_sets`
--

LOCK TABLES `fraud_sets` WRITE;
/*!40000 ALTER TABLE `fraud_sets` DISABLE KEYS */;
/*!40000 ALTER TABLE `fraud_sets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `graph_cache`
--

DROP TABLE IF EXISTS `graph_cache`;
CREATE TABLE `graph_cache` (
  `graph_cache_id` int(10) unsigned NOT NULL auto_increment,
  `graph_cache_ref` int(10) unsigned default NULL,
  `graph_cache_op` varchar(255) default NULL,
  `graph_cache_type` varchar(255) default NULL,
  `graph_cache_date_created` int(10) unsigned default NULL,
  `graph_cache_count` int(10) unsigned default NULL,
  `graph_cache_src` longblob,
  PRIMARY KEY  (`graph_cache_id`),
  KEY `cache_ref` (`graph_cache_ref`)
);

--
-- Dumping data for table `graph_cache`
--

LOCK TABLES `graph_cache` WRITE;
/*!40000 ALTER TABLE `graph_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `graph_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `group_attributes`
--

DROP TABLE IF EXISTS `group_attributes`;
CREATE TABLE `group_attributes` (
  `group_attribute_id` int(10) NOT NULL auto_increment,
  `group_id` int(10) default NULL,
  `group_attribute_name` varchar(100) default NULL,
  `group_attribute_value` varchar(255) default NULL,
  PRIMARY KEY  (`group_attribute_id`)
);

--
-- Dumping data for table `group_attributes`
--

LOCK TABLES `group_attributes` WRITE;
/*!40000 ALTER TABLE `group_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `group_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gw_transaction_attrs`
--

DROP TABLE IF EXISTS `gw_transaction_attrs`;
CREATE TABLE `gw_transaction_attrs` (
  `gw_transaction_attr_id` int(10) unsigned NOT NULL auto_increment,
  `gw_transaction_id` int(10) unsigned default NULL,
  `gw_transaction_attr_name` varchar(255) default NULL,
  `gw_transaction_attr_value` varchar(255) default NULL,
  PRIMARY KEY  (`gw_transaction_attr_id`),
  KEY `gw_transaction_id` (`gw_transaction_id`)
);

--
-- Dumping data for table `gw_transaction_attrs`
--

LOCK TABLES `gw_transaction_attrs` WRITE;
/*!40000 ALTER TABLE `gw_transaction_attrs` DISABLE KEYS */;
/*!40000 ALTER TABLE `gw_transaction_attrs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gw_transactions`
--

DROP TABLE IF EXISTS `gw_transactions`;
CREATE TABLE `gw_transactions` (
  `gw_transaction_id` int(10) unsigned NOT NULL auto_increment,
  `gw_transaction_type` tinyint(3) unsigned default NULL,
  `gw_transaction_ref` varchar(255) default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`gw_transaction_id`),
  KEY `gw_transaction_ref` (`gw_transaction_ref`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `config_group_id` (`config_group_id`)
);

--
-- Dumping data for table `gw_transactions`
--

LOCK TABLES `gw_transactions` WRITE;
/*!40000 ALTER TABLE `gw_transactions` DISABLE KEYS */;
/*!40000 ALTER TABLE `gw_transactions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_assignment_rel`
--

DROP TABLE IF EXISTS `hd_assignment_rel`;
CREATE TABLE `hd_assignment_rel` (
  `hd_ticket_id` int(10) unsigned default NULL,
  `admin_id` smallint(5) unsigned default NULL,
  `source_admin_id` smallint(5) unsigned default NULL,
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `admin_id` (`admin_id`),
  KEY `source_admin_id` (`source_admin_id`)
);

--
-- Dumping data for table `hd_assignment_rel`
--

LOCK TABLES `hd_assignment_rel` WRITE;
/*!40000 ALTER TABLE `hd_assignment_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_assignment_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_bucket_admin_rel`
--

DROP TABLE IF EXISTS `hd_bucket_admin_rel`;
CREATE TABLE `hd_bucket_admin_rel` (
  `hd_bucket_id` smallint(5) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  `may_view_tickets` tinyint(3) unsigned default NULL,
  `may_respond_tickets` tinyint(3) unsigned default NULL,
  `may_note_tickets` tinyint(3) unsigned default NULL,
  `may_modify_tickets` tinyint(3) unsigned default NULL,
  `may_delete_tickets` tinyint(3) unsigned default NULL,
  `may_assign_tickets` tinyint(3) unsigned default NULL,
  `may_merge_tickets` tinyint(3) unsigned default NULL,
  `may_notify_user` tinyint(3) unsigned default NULL,
  `may_respond_all` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`hd_bucket_id`,`admin_id`)
);

--
-- Dumping data for table `hd_bucket_admin_rel`
--

LOCK TABLES `hd_bucket_admin_rel` WRITE;
/*!40000 ALTER TABLE `hd_bucket_admin_rel` DISABLE KEYS */;
INSERT INTO `hd_bucket_admin_rel` VALUES (1,1,1,1,1,1,1,1,1,1,1),(2,1,1,1,1,1,1,1,1,1,1);
/*!40000 ALTER TABLE `hd_bucket_admin_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_bucket_department_rel`
--

DROP TABLE IF EXISTS `hd_bucket_department_rel`;
CREATE TABLE `hd_bucket_department_rel` (
  `hd_bucket_id` smallint(5) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_bucket_id`,`hd_department_id`)
);

--
-- Dumping data for table `hd_bucket_department_rel`
--

LOCK TABLES `hd_bucket_department_rel` WRITE;
/*!40000 ALTER TABLE `hd_bucket_department_rel` DISABLE KEYS */;
INSERT INTO `hd_bucket_department_rel` VALUES (1,1),(2,2);
/*!40000 ALTER TABLE `hd_bucket_department_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_buckets`
--

DROP TABLE IF EXISTS `hd_buckets`;
CREATE TABLE `hd_buckets` (
  `hd_bucket_id` smallint(5) unsigned NOT NULL auto_increment,
  `hd_bucket_name` varchar(50) default NULL,
  PRIMARY KEY  (`hd_bucket_id`)
) AUTO_INCREMENT=3;

--
-- Dumping data for table `hd_buckets`
--

LOCK TABLES `hd_buckets` WRITE;
/*!40000 ALTER TABLE `hd_buckets` DISABLE KEYS */;
INSERT INTO `hd_buckets` VALUES (1,'main sales bucket'),(2,'main tech support bucket');
/*!40000 ALTER TABLE `hd_buckets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_department_admin_rel`
--

DROP TABLE IF EXISTS `hd_department_admin_rel`;
CREATE TABLE `hd_department_admin_rel` (
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_department_id`,`admin_id`)
);

--
-- Dumping data for table `hd_department_admin_rel`
--

LOCK TABLES `hd_department_admin_rel` WRITE;
/*!40000 ALTER TABLE `hd_department_admin_rel` DISABLE KEYS */;
INSERT INTO `hd_department_admin_rel` VALUES (1,1),(2,1);
/*!40000 ALTER TABLE `hd_department_admin_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_departments`
--

DROP TABLE IF EXISTS `hd_departments`;
CREATE TABLE `hd_departments` (
  `hd_department_id` tinyint(3) unsigned NOT NULL auto_increment,
  `hd_department_name` varchar(50) default NULL,
  `hd_department_description` text,
  PRIMARY KEY  (`hd_department_id`)
) AUTO_INCREMENT=3;

--
-- Dumping data for table `hd_departments`
--

LOCK TABLES `hd_departments` WRITE;
/*!40000 ALTER TABLE `hd_departments` DISABLE KEYS */;
INSERT INTO `hd_departments` VALUES (1,'Sales Department','Sales Department bucket'),(2,'Tech Support Department','Tech Support Department bucket');
/*!40000 ALTER TABLE `hd_departments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_email_tpl_department_rel`
--

DROP TABLE IF EXISTS `hd_email_tpl_department_rel`;
CREATE TABLE `hd_email_tpl_department_rel` (
  `hd_email_tpl_id` smallint(5) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_email_tpl_id`,`hd_department_id`)
);

--
-- Dumping data for table `hd_email_tpl_department_rel`
--

LOCK TABLES `hd_email_tpl_department_rel` WRITE;
/*!40000 ALTER TABLE `hd_email_tpl_department_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_email_tpl_department_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_email_tpls`
--

DROP TABLE IF EXISTS `hd_email_tpls`;
CREATE TABLE `hd_email_tpls` (
  `hd_email_tpl_id` smallint(5) unsigned NOT NULL auto_increment,
  `hd_email_tpl_name` varchar(50) default NULL,
  `hd_email_tpl_subject` varchar(200) default NULL,
  `hd_email_tpl_body` text,
  PRIMARY KEY  (`hd_email_tpl_id`)
);

--
-- Dumping data for table `hd_email_tpls`
--

LOCK TABLES `hd_email_tpls` WRITE;
/*!40000 ALTER TABLE `hd_email_tpls` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_email_tpls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_resp_tpl_department_rel`
--

DROP TABLE IF EXISTS `hd_resp_tpl_department_rel`;
CREATE TABLE `hd_resp_tpl_department_rel` (
  `hd_resp_tpl_id` int(8) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_resp_tpl_id`,`hd_department_id`)
);

--
-- Dumping data for table `hd_resp_tpl_department_rel`
--

LOCK TABLES `hd_resp_tpl_department_rel` WRITE;
/*!40000 ALTER TABLE `hd_resp_tpl_department_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_resp_tpl_department_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_resp_tpls`
--

DROP TABLE IF EXISTS `hd_resp_tpls`;
CREATE TABLE `hd_resp_tpls` (
  `hd_resp_tpl_id` int(8) unsigned NOT NULL auto_increment,
  `hd_resp_tpl_name` varchar(50) default NULL,
  `hd_resp_tpl_body` text,
  `admin_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`hd_resp_tpl_id`),
  KEY `admin_id` (`admin_id`)
);

--
-- Dumping data for table `hd_resp_tpls`
--

LOCK TABLES `hd_resp_tpls` WRITE;
/*!40000 ALTER TABLE `hd_resp_tpls` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_resp_tpls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_attachments`
--

DROP TABLE IF EXISTS `hd_ticket_attachments`;
CREATE TABLE `hd_ticket_attachments` (
  `hd_ticket_id` int(10) unsigned default NULL,
  `hd_ticket_attachment_filename` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`hd_ticket_attachment_filename`)
);

--
-- Dumping data for table `hd_ticket_attachments`
--

LOCK TABLES `hd_ticket_attachments` WRITE;
/*!40000 ALTER TABLE `hd_ticket_attachments` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_attachments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_bucket_rel`
--

DROP TABLE IF EXISTS `hd_ticket_bucket_rel`;
CREATE TABLE `hd_ticket_bucket_rel` (
  `hd_ticket_id` int(10) unsigned NOT NULL default '0',
  `hd_bucket_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_ticket_id`,`hd_bucket_id`)
);

--
-- Dumping data for table `hd_ticket_bucket_rel`
--

LOCK TABLES `hd_ticket_bucket_rel` WRITE;
/*!40000 ALTER TABLE `hd_ticket_bucket_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_bucket_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_contacts`
--

DROP TABLE IF EXISTS `hd_ticket_contacts`;
CREATE TABLE `hd_ticket_contacts` (
  `hd_ticket_contact_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `hd_contact_first_name` varchar(100) default NULL,
  `hd_contact_last_name` varchar(100) default NULL,
  `hd_contact_email` varchar(100) default NULL,
  `hd_contact_company` varchar(100) default NULL,
  `hd_contact_address_1` varchar(100) default NULL,
  `hd_contact_address_2` varchar(100) default NULL,
  `hd_contact_city` varchar(100) default NULL,
  `hd_contact_state` varchar(100) default NULL,
  `hd_contact_zip` varchar(100) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `hd_contact_phone1` varchar(25) default NULL,
  `hd_contact_phone2` varchar(25) default NULL,
  `hd_contact_fax` varchar(25) default NULL,
  `hd_contact_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`hd_ticket_contact_id`),
  KEY `hd_contact_first_name` (`hd_contact_first_name`),
  KEY `hd_contact_last_name` (`hd_contact_last_name`),
  KEY `hd_contact_email` (`hd_contact_email`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`)
);

--
-- Dumping data for table `hd_ticket_contacts`
--

LOCK TABLES `hd_ticket_contacts` WRITE;
/*!40000 ALTER TABLE `hd_ticket_contacts` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_contacts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_department_rel`
--

DROP TABLE IF EXISTS `hd_ticket_department_rel`;
CREATE TABLE `hd_ticket_department_rel` (
  `hd_ticket_id` int(10) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_ticket_id`,`hd_department_id`)
);

--
-- Dumping data for table `hd_ticket_department_rel`
--

LOCK TABLES `hd_ticket_department_rel` WRITE;
/*!40000 ALTER TABLE `hd_ticket_department_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_department_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_events`
--

DROP TABLE IF EXISTS `hd_ticket_events`;
CREATE TABLE `hd_ticket_events` (
  `hd_ticket_event_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `hd_ticket_priority_id` tinyint(3) unsigned default NULL,
  `hd_ticket_status_id` tinyint(3) unsigned default NULL,
  `hd_ticket_event_comment` text,
  PRIMARY KEY  (`hd_ticket_event_id`),
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `hd_ticket_priority_id` (`hd_ticket_priority_id`),
  KEY `hd_ticket_status_id` (`hd_ticket_status_id`)
);

--
-- Dumping data for table `hd_ticket_events`
--

LOCK TABLES `hd_ticket_events` WRITE;
/*!40000 ALTER TABLE `hd_ticket_events` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_events` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_notes`
--

DROP TABLE IF EXISTS `hd_ticket_notes`;
CREATE TABLE `hd_ticket_notes` (
  `hd_ticket_note_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `admin_id` smallint(5) unsigned default NULL,
  `hd_ticket_note_body` text,
  PRIMARY KEY  (`hd_ticket_note_id`),
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `admin_id` (`admin_id`)
);

--
-- Dumping data for table `hd_ticket_notes`
--

LOCK TABLES `hd_ticket_notes` WRITE;
/*!40000 ALTER TABLE `hd_ticket_notes` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_notes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_ticket_resps`
--

DROP TABLE IF EXISTS `hd_ticket_resps`;
CREATE TABLE `hd_ticket_resps` (
  `hd_ticket_resp_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `hd_ticket_resp_body` text,
  `hd_ticket_resp_date_created` int(10) unsigned default NULL,
  `hd_ticket_resp_date_modified` int(10) unsigned default NULL,
  PRIMARY KEY  (`hd_ticket_resp_id`),
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`)
);

--
-- Dumping data for table `hd_ticket_resps`
--

LOCK TABLES `hd_ticket_resps` WRITE;
/*!40000 ALTER TABLE `hd_ticket_resps` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_ticket_resps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_tickets`
--

DROP TABLE IF EXISTS `hd_tickets`;
CREATE TABLE `hd_tickets` (
  `hd_ticket_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_key` varchar(11) default NULL,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `hd_ticket_subject` varchar(100) default NULL,
  `hd_ticket_body` text,
  `hd_ticket_date_created` int(10) unsigned default NULL,
  `hd_ticket_date_modified` int(10) unsigned default NULL,
  `hd_ticket_priority_id` tinyint(3) unsigned default NULL,
  `hd_ticket_status_id` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`hd_ticket_id`),
  KEY `hd_ticket_key` (`hd_ticket_key`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `hd_ticket_date_created` (`hd_ticket_date_created`),
  KEY `hd_ticket_priority_id` (`hd_ticket_priority_id`),
  KEY `hd_ticket_status_id` (`hd_ticket_status_id`)
);

--
-- Dumping data for table `hd_tickets`
--

LOCK TABLES `hd_tickets` WRITE;
/*!40000 ALTER TABLE `hd_tickets` DISABLE KEYS */;
/*!40000 ALTER TABLE `hd_tickets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invalid_ipn_log`
--

DROP TABLE IF EXISTS `invalid_ipn_log`;
CREATE TABLE `invalid_ipn_log` (
  `ipn_id` int(10) NOT NULL auto_increment,
  `ipn_status` int(1) default '0',
  `ipn_reason` varchar(255) default NULL,
  `ipn_module` varchar(30) default NULL,
  `ipn_server` text,
  `ipn_get` text,
  `ipn_post` text,
  `ipn_date_created` int(10) default NULL,
  PRIMARY KEY  (`ipn_id`)
);

--
-- Dumping data for table `invalid_ipn_log`
--

LOCK TABLES `invalid_ipn_log` WRITE;
/*!40000 ALTER TABLE `invalid_ipn_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `invalid_ipn_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_line_items`
--

DROP TABLE IF EXISTS `invoice_line_items`;
CREATE TABLE `invoice_line_items` (
  `line_item_id` int(10) unsigned NOT NULL auto_increment,
  `invoice_id` int(10) unsigned default NULL,
  `package_id` int(10) unsigned default NULL,
  `package_addon_id` int(10) unsigned NOT NULL default '0',
  `cycle_id` smallint(5) unsigned default NULL,
  `line_item_quantity` smallint(5) unsigned default NULL,
  `line_item_description` varchar(255) default NULL,
  `line_item_date_begin_renewal` int(10) unsigned default NULL,
  `line_item_date_current_renewal` int(10) unsigned default NULL,
  `line_item_date_next_renewal` int(10) unsigned default NULL,
  `line_item_price_amount` decimal(10,2) default '0.00',
  `line_item_discount_amount` decimal(10,2) default '0.00',
  `line_item_discount` decimal(10,2) default '0.00',
  `line_item_setup_amount` decimal(10,2) default '0.00',
  `line_item_tax_amount` decimal(10,2) default '0.00',
  `line_item_taxable_tax_amount` decimal(10,2) default '0.00',
  `line_item_total_amount` decimal(10,2) default '0.00',
  `proration_discount_amount` decimal(10,2) default '0.00',
  `proration_discount` decimal(10,2) default '0.00',
  `proration_duration` int(10) unsigned default NULL,
  `line_item_is_usage` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`line_item_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `package_id` (`package_id`),
  KEY `cycle_id` (`cycle_id`),
  KEY `line_item_date_begin_renewal` (`line_item_date_begin_renewal`),
  KEY `line_item_date_current_renewal` (`line_item_date_current_renewal`),
  KEY `line_item_date_next_renewal` (`line_item_date_next_renewal`),
  KEY `line_item_price_amount` (`line_item_price_amount`),
  KEY `line_item_setup_amount` (`line_item_setup_amount`),
  KEY `line_item_tax_amount` (`line_item_tax_amount`),
  KEY `line_item_taxable_tax_amount` (`line_item_taxable_tax_amount`),
  KEY `line_item_total_amount` (`line_item_total_amount`),
  KEY `line_item_is_usage` (`line_item_is_usage`)
);

--
-- Dumping data for table `invoice_line_items`
--

LOCK TABLES `invoice_line_items` WRITE;
/*!40000 ALTER TABLE `invoice_line_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_line_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_tax_zone_rel`
--

DROP TABLE IF EXISTS `invoice_tax_zone_rel`;
CREATE TABLE `invoice_tax_zone_rel` (
  `invoice_id` int(10) unsigned NOT NULL default '0',
  `tax_zone_id` smallint(5) unsigned NOT NULL default '0',
  `invoice_tax_amount_type` tinyint(3) unsigned default NULL,
  `invoice_tax_amount` decimal(10,2) default '0.00',
  `invoice_tax_total` decimal(10,2) default '0.00',
  PRIMARY KEY  (`invoice_id`,`tax_zone_id`),
  KEY `invoice_tax_amount_type` (`invoice_tax_amount_type`)
);

--
-- Dumping data for table `invoice_tax_zone_rel`
--

LOCK TABLES `invoice_tax_zone_rel` WRITE;
/*!40000 ALTER TABLE `invoice_tax_zone_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_tax_zone_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_transaction_rel`
--

DROP TABLE IF EXISTS `invoice_transaction_rel`;
CREATE TABLE `invoice_transaction_rel` (
  `invoice_id` int(10) unsigned NOT NULL default '0',
  `transaction_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`invoice_id`,`transaction_id`)
);

--
-- Dumping data for table `invoice_transaction_rel`
--

LOCK TABLES `invoice_transaction_rel` WRITE;
/*!40000 ALTER TABLE `invoice_transaction_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_transaction_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoices`
--

DROP TABLE IF EXISTS `invoices`;
CREATE TABLE `invoices` (
  `invoice_id` int(10) unsigned NOT NULL auto_increment,
  `invoice_process_id` varchar(40) default '',
  `invoice_process_date` int(10) unsigned default '0',
  `invoice_number` varchar(15) default NULL,
  `credit_note_for_invoice_id` int(10) unsigned default NULL,
  `client_id` int(10) unsigned default '0',
  `client_contact_id` int(10) unsigned default '0',
  `currency_id` char(3) default NULL,
  `invoice_amount` decimal(10,2) default '0.00',
  `invoice_amount_paid` decimal(10,2) default '0.00',
  `invoice_date_entered` int(10) unsigned default NULL,
  `invoice_date_due` int(10) unsigned default NULL,
  `invoice_date_paid` int(10) unsigned default NULL,
  `invoice_date_pushed` int(10) unsigned default '0',
  `invoice_payment_method` varchar(50) default NULL,
  `invoice_snapshot` longtext,
  `invoice_comments` longtext,
  `invoice_batch_timestamp` int(10) unsigned default NULL,
  `invoice_sub_total` decimal(10,2) default '0.00',
  `invoice_discount` decimal(10,2) default '0.00',
  `invoice_status` tinyint(3) unsigned default NULL,
  `payment_group_id` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`invoice_id`),
  KEY `invoice_process_id` (`invoice_process_id`),
  KEY `invoice_process_date` (`invoice_process_date`),
  KEY `payment_group_id` (`payment_group_id`),
  KEY `invoice_status` (`invoice_status`),
  KEY `invoice_date_due` (`invoice_date_due`),
  KEY `invoice_date_pushed` (`invoice_date_pushed`),
  KEY `invoice_amount` (`invoice_amount`),
  KEY `invoice_amount_paid` (`invoice_amount_paid`),
  KEY `invoice_date_entered` (`invoice_date_entered`),
  KEY `invoice_payment_method` (`invoice_payment_method`),
  KEY `currency_id` (`currency_id`)
);

--
-- Dumping data for table `invoices`
--

LOCK TABLES `invoices` WRITE;
/*!40000 ALTER TABLE `invoices` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoicing_groups`
--

DROP TABLE IF EXISTS `invoicing_groups`;
CREATE TABLE `invoicing_groups` (
  `invoicing_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `invoicing_group_name` varchar(50) default NULL,
  PRIMARY KEY  (`invoicing_group_id`),
  KEY `invoicing_group_name` (`invoicing_group_name`)
);

--
-- Dumping data for table `invoicing_groups`
--

LOCK TABLES `invoicing_groups` WRITE;
/*!40000 ALTER TABLE `invoicing_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoicing_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ip_log`
--

DROP TABLE IF EXISTS `ip_log`;
CREATE TABLE `ip_log` (
  `ip` bigint(20) NOT NULL default '0',
  `external_id` varchar(50) default NULL,
  `config_group_id` int(8) unsigned default NULL,
  PRIMARY KEY  (`ip`),
  KEY `external_id` (`external_id`),
  KEY `config_group_id` (`config_group_id`)
);

--
-- Dumping data for table `ip_log`
--

LOCK TABLES `ip_log` WRITE;
/*!40000 ALTER TABLE `ip_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `ip_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `languages`
--

DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `language_id` smallint(5) unsigned NOT NULL auto_increment,
  `language_iso2` varchar(7) default NULL,
  `language_iso3` varchar(6) default NULL,
  `language_name` varchar(120) default NULL,
  `language_c1` tinyint(3) unsigned default NULL,
  `language_c2` varchar(25) default NULL,
  PRIMARY KEY  (`language_id`),
  KEY `language_iso2` (`language_iso2`),
  KEY `language_iso3` (`language_iso3`)
) AUTO_INCREMENT=131;

--
-- Dumping data for table `languages`
--

LOCK TABLES `languages` WRITE;
/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
INSERT INTO `languages` VALUES (1,'aa','aar','Qafar',NULL,NULL),(2,'af','afr','Afrikaans',1,NULL),(3,'am','amh','áŠ áˆ›áˆ­áŠ›',NULL,NULL),(4,'ar','ara','â€ŽØ§Ù„Ø¹Ø±Ø¨ÙŠØ©â€Ž',1,NULL),(5,'as','asm','à¦…à¦¸à¦®à¦¿à§Ÿà¦¾',1,NULL),(6,'az_Cyrl','aze','ÐÐ·Ó™Ñ€Ð±Ð°Ñ˜Ò¹Ð°Ð½ - Cyrl',1,NULL),(7,'az_Latn','aze','azÉ™rbaycanca - Latn',1,NULL),(8,'be','bel','Ð‘ÐµÐ»Ð°Ñ€ÑƒÑÐºÑ–',1,NULL),(9,'bg','bul','Ð‘ÑŠÐ»Ð³Ð°Ñ€ÑÐºÐ¸',1,NULL),(10,'bn','ben','à¦¬à¦¾à¦‚à¦²à¦¾',1,NULL),(11,'bs','bos','Bosanski',1,NULL),(12,'byn','byn','á‰¥áˆŠáŠ•',NULL,NULL),(13,'ca','cat','catalÃ ',1,NULL),(14,'cs','cze','ÄŒeÅ¡tina',NULL,NULL),(15,'cy','wel','Cymraeg',1,NULL),(16,'da','dan','Dansk',1,NULL),(17,'de','ger','Deutsch',1,NULL),(18,'dv','div','â€ŽÞ‹Þ¨ÞˆÞ¬Þ€Þ¨Þ„Þ¦ÞÞ°â€Ž',1,NULL),(19,'dz','dzo','à½¢à¾«à½¼à½„à¼‹à½',NULL,NULL),(20,'el','gre','Î•Î»Î»Î·Î½Î¹ÎºÎ¬',1,NULL),(21,'en','eng','English',1,NULL),(22,'eo','epo','Esperanto',NULL,NULL),(23,'es','spa','espaÃ±ol',1,NULL),(24,'et','est','Eesti',1,NULL),(25,'eu','baq','euskara',1,NULL),(26,'fa','per','â€ŽÙØ§Ø±Ø³ÛŒâ€Ž',1,NULL),(27,'fi','fin','suomi',1,NULL),(28,'fo','fao','fÃ¸royskt',1,NULL),(29,'fr','fre','franÃ§ais',1,NULL),(30,'ga','gla','Gaeilge',1,NULL),(31,'gez','gez','áŒá‹•á‹áŠ›',NULL,NULL),(32,'gl','glg','galego',NULL,NULL),(33,'gu','guj','àª—à«àªœàª°àª¾àª¤à«€',1,NULL),(34,'gv','glv','Gaelg',NULL,NULL),(35,'haw','haw','Ê»Ålelo HawaiÊ»i',NULL,NULL),(36,'he','heb','â€Ž×¢×‘×¨×™×ªâ€Ž',1,NULL),(37,'hi','hin','à¤¹à¤¿à¤‚à¤¦à¥€',1,NULL),(38,'hr','scr','hrvatski',1,NULL),(39,'hu','hun','magyar',1,NULL),(40,'hy','arm','Õ€Õ¡ÕµÕ¥Ö€Õ§Õ¶',1,NULL),(41,'id','ind','Bahasa Indonesia',1,NULL),(42,'is','ice','Ãslenska',1,NULL),(43,'it','ita','italiano',1,NULL),(44,'iu','ike','áƒá“„á’ƒá‘Žá‘á‘¦ á‘Žá‘Žá•‹á…á“¯á–…',NULL,NULL),(45,'ja','jpn','æ—¥æœ¬èªž',1,NULL),(46,'ka','geo','áƒ¥áƒáƒ áƒ—áƒ£áƒšáƒ˜',1,NULL),(47,'kk','kaz','ÒšÐ°Ð·Ð°Ò›',1,NULL),(48,'kl','kal','Kalaallisut',NULL,NULL),(49,'km','khm','áž—áž¶ážŸáž¶ážáŸ’áž˜áŸ‚ážš',1,NULL),(50,'kn','kan','à²•à²¨à³à²¨à²¡',NULL,NULL),(51,'ko','kor','í•œêµ­ì–´',1,NULL),(52,'kok','knn','à¤•à¥‹à¤‚à¤•à¤£à¥€',NULL,NULL),(53,'kw','cor','kernewek',NULL,NULL),(54,'ky','kir','ÐšÑ‹Ñ€Ð³Ñ‹Ð·',1,NULL),(55,'lo','lao','àº¥àº²àº§',1,NULL),(56,'lt','lit','LietuviÅ³',1,NULL),(57,'lv','lav','latvieÅ¡u',1,NULL),(58,'mk','mac','Ð¼Ð°ÐºÐµÐ´Ð¾Ð½ÑÐºÐ¸',1,NULL),(59,'ml','mal','à´®à´²à´¯à´¾à´³à´‚',1,NULL),(60,'mn','mon','ÐœÐ¾Ð½Ð³Ð¾Ð» Ñ…ÑÐ»',1,NULL),(61,'mr','mar','à¤®à¤°à¤¾à¤ à¥€',NULL,NULL),(62,'ms','may','Bahasa Melayu',1,NULL),(63,'mt','mlt','Malti',1,NULL),(64,'nb','nor','norsk bokmÃ¥l',1,NULL),(65,'nl','dut','Nederlands',1,NULL),(66,'nn','nor','norsk nynorsk',1,NULL),(67,'om','orm','Oromoo',NULL,NULL),(68,'or','ori','à¬“à­œà¬¿à¬†',1,NULL),(69,'pa','pan','à¨ªà©°à¨œà¨¾à¨¬à©€',1,NULL),(70,'pl','pol','polski',1,NULL),(71,'ps','pus','â€ŽÙ¾ÚšØªÙˆâ€Ž',NULL,NULL),(72,'pt','por','portuguÃªs',1,NULL),(73,'ro','rum','RomÃ¢nÄƒ',1,NULL),(74,'ru','rus','Ñ€ÑƒÑÑÐºÐ¸Ð¹',1,NULL),(75,'sa','san','à¤¸à¤‚à¤¸à¥à¤•à¥ƒà¤¤',1,NULL),(76,'sid','sid','Sidaamu Afo',NULL,NULL),(77,'sk','slo','slovenskÃ½',1,NULL),(78,'sl','slv','SlovenÅ¡Äina',1,NULL),(79,'so','som','Soomaali',1,NULL),(80,'sq','alb','shqipe',1,NULL),(81,'sr_Cyrl','scc','Ð¡Ñ€Ð¿ÑÐºÐ¸ - Ð‹Ð¸Ñ€Ð¸Ð»Ð¸Ñ†Ð°',1,NULL),(82,'sr_Latn','scc','Srpski - Latinica',1,NULL),(83,'sv','swe','svenska',1,NULL),(84,'sw','swa','Kiswahili',1,NULL),(85,'syr','syr','â€ŽÜ£Ü˜ÜªÜÜÜâ€Ž',1,NULL),(86,'ta','tam','à®¤à®®à®¿à®´à¯',1,NULL),(87,'te','tel','à°¤à±†à°²à±à°—à±',1,NULL),(88,'th','tha','à¹„à¸—à¸¢',1,NULL),(89,'ti','tir','á‰µáŒáˆ­áŠ›',NULL,NULL),(90,'tig','tig','á‰µáŒáˆ¨',NULL,NULL),(91,'tr','tur','TÃ¼rkÃ§e',1,NULL),(92,'tt','tat','Ð¢Ð°Ñ‚Ð°Ñ€',NULL,NULL),(93,'uk','ukr','Ð£ÐºÑ€Ð°Ñ—Ð½ÑÑŒÐºÐ°',1,NULL),(94,'ur','urd','â€ŽØ§Ø±Ø¯Ùˆâ€Ž',1,NULL),(95,'uz_Arab','uzb','â€ŽØ§Û‰Ø²Ø¨ÛÚ© - ÐÑ€Ð°Ð±â€Ž',1,NULL),(96,'uz_Cyrl','uzb','ÐŽÐ·Ð±ÐµÐº - ÐšÐ¸Ñ€Ð¸Ð»',1,NULL),(97,'uz_Latn','uzb','oÊ¿zbek - Lotin',1,NULL),(98,'vi','vie','Tiáº¿ng Viá»‡t',1,NULL),(99,'wal','wal','á‹ˆáˆ‹á‹­á‰³á‰±',NULL,NULL),(100,'zh_Hans','chi','ä¸­æ–‡ - ç®€ä½“æ±‰è¯­',1,NULL),(101,'zh_Hant','chi','ä¸­æ–‡ - ç¹é«”æ¼¢èªž',1,NULL),(102,'ak','aka','Akan',NULL,NULL),(103,'ee','ewe','Ewe',NULL,NULL),(104,'fur','fur','furlan',NULL,NULL),(105,'gaa','gaa','Ga',NULL,NULL),(106,'ha_Arab','hau','Ù‡ÙŽÙˆÙØ³ÙŽ - Arab',NULL,NULL),(107,'ha_Latn','hau','Hausa - Latn',NULL,NULL),(108,'ig','ibo','Igbo',NULL,NULL),(109,'ia','ina','Interlingua',NULL,NULL),(110,'kam','kam','Kamba',NULL,NULL),(111,'rw','kin','Kinyarwanda',NULL,NULL),(112,'ku_Arab','kur','Ú©ÙˆØ±Ø¯ÛŒ - Arab',NULL,NULL),(113,'ku_Latn','kur','kurdÃ® - Latn',NULL,NULL),(114,'ln','lin','lingÃ¡la',NULL,NULL),(115,'ne','nep','à¤¨à¥‡à¤ªà¤¾à¤²à¥€',NULL,NULL),(116,'se','sme','davvisÃ¡megiella',NULL,NULL),(117,'nso','nso','Sesotho sa Leboa',NULL,NULL),(118,'ny','nya','Nyanja',NULL,NULL),(119,'pa_Arab','pan','Ù¾Ù†Ø¬Ø§Ø¨ÛŒ - Ú¯ÙØ±Ù…ÙÚ©Ú¾ÛŒ',NULL,NULL),(120,'pa_Guru','pan','à¨ªà©°à¨œà¨¾à¨¬à©€ - à¨—à©à¨°à¨®à©à¨–à©€',NULL,NULL),(121,'nr','nbl','Nrebele',NULL,NULL),(122,'st','sot','Sesotho',NULL,NULL),(123,'ss','ssw','Swati',NULL,NULL),(124,'tg','tgk','Ñ‚Ð¾Ò·Ð¸ÐºÓ£',NULL,NULL),(125,'ts','tso','XiTsonga',NULL,NULL),(126,'tn','tsn','Setswana',NULL,NULL),(127,'ve','ven','Tshivenda',NULL,NULL),(128,'xh','xho','isiXhosa',NULL,NULL),(129,'yo','yor','ede YorÃ¹bÃ¡',NULL,NULL),(130,'zu','zul','isiZulu',NULL,NULL);
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `line_items_tax_zone_rel`
--

DROP TABLE IF EXISTS `line_items_tax_zone_rel`;
CREATE TABLE `line_items_tax_zone_rel` (
  `line_item_id` int(10) unsigned NOT NULL default '0',
  `tax_zone_id` smallint(5) unsigned NOT NULL default '0',
  `line_item_tax_amount_type` tinyint(3) unsigned default NULL,
  `line_item_tax_amount` decimal(10,2) default '0.00',
  `line_item_tax_total` decimal(10,2) default '0.00',
  PRIMARY KEY  (`line_item_id`,`tax_zone_id`),
  KEY `line_item_tax_amount_type` (`line_item_tax_amount_type`)
);

--
-- Dumping data for table `line_items_tax_zone_rel`
--

LOCK TABLES `line_items_tax_zone_rel` WRITE;
/*!40000 ALTER TABLE `line_items_tax_zone_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `line_items_tax_zone_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `locales`
--

DROP TABLE IF EXISTS `locales`;
CREATE TABLE `locales` (
  `locale_id` smallint(5) unsigned NOT NULL auto_increment,
  `locale_language` varchar(7) default NULL,
  `locale_country_iso_2` char(2) default NULL,
  `locale_currency_code` char(3) default NULL,
  `locale_currency_symbol` varchar(36) default NULL,
  `locale_currency_rounding` char(2) default NULL,
  `locale_currency_digits` char(2) default NULL,
  `locale_separator_decimal` varchar(6) default NULL,
  `locale_separator_grouping` varchar(10) default NULL,
  `locale_pattern_decimal` varchar(50) default NULL,
  `locale_pattern_currency` varchar(75) default NULL,
  `locale_sign_percent` varchar(75) default NULL,
  `locale_sign_minus` varchar(10) default NULL,
  `locale_time_full` varchar(200) default NULL,
  `locale_time_long` varchar(200) default NULL,
  `locale_time_medium` varchar(100) default NULL,
  `locale_time_short` varchar(125) default NULL,
  `locale_date_full` varchar(200) default NULL,
  `locale_date_long` varchar(200) default NULL,
  `locale_date_medium` varchar(200) default NULL,
  `locale_date_short` varchar(150) default NULL,
  `locale_datetime_pattern` varchar(30) default NULL,
  `locale_datetime_am` varchar(125) default NULL,
  `locale_datetime_pm` varchar(125) default NULL,
  `locale_week_firstday` char(3) default NULL,
  `locale_week_weekend_start` char(3) default NULL,
  `locale_week_weekend_end` char(3) default NULL,
  `locale_month_abbreviated_1` varchar(100) default NULL,
  `locale_month_abbreviated_2` varchar(100) default NULL,
  `locale_month_abbreviated_3` varchar(100) default NULL,
  `locale_month_abbreviated_4` varchar(100) default NULL,
  `locale_month_abbreviated_5` varchar(100) default NULL,
  `locale_month_abbreviated_6` varchar(100) default NULL,
  `locale_month_abbreviated_7` varchar(100) default NULL,
  `locale_month_abbreviated_8` varchar(100) default NULL,
  `locale_month_abbreviated_9` varchar(100) default NULL,
  `locale_month_abbreviated_10` varchar(100) default NULL,
  `locale_month_abbreviated_11` varchar(100) default NULL,
  `locale_month_abbreviated_12` varchar(100) default NULL,
  `locale_month_narrow_1` varchar(20) default NULL,
  `locale_month_narrow_2` varchar(20) default NULL,
  `locale_month_narrow_3` varchar(20) default NULL,
  `locale_month_narrow_4` varchar(20) default NULL,
  `locale_month_narrow_5` varchar(20) default NULL,
  `locale_month_narrow_6` varchar(20) default NULL,
  `locale_month_narrow_7` varchar(20) default NULL,
  `locale_month_narrow_8` varchar(20) default NULL,
  `locale_month_narrow_9` varchar(20) default NULL,
  `locale_month_narrow_10` varchar(20) default NULL,
  `locale_month_narrow_11` varchar(20) default NULL,
  `locale_month_narrow_12` varchar(20) default NULL,
  `locale_month_wide_1` varchar(150) default NULL,
  `locale_month_wide_2` varchar(150) default NULL,
  `locale_month_wide_3` varchar(150) default NULL,
  `locale_month_wide_4` varchar(150) default NULL,
  `locale_month_wide_5` varchar(150) default NULL,
  `locale_month_wide_6` varchar(150) default NULL,
  `locale_month_wide_7` varchar(150) default NULL,
  `locale_month_wide_8` varchar(153) default NULL,
  `locale_month_wide_9` varchar(150) default NULL,
  `locale_month_wide_10` varchar(150) default NULL,
  `locale_month_wide_11` varchar(180) default NULL,
  `locale_month_wide_12` varchar(180) default NULL,
  `locale_day_abbreviated_sun` varchar(110) default NULL,
  `locale_day_abbreviated_mon` varchar(110) default NULL,
  `locale_day_abbreviated_tue` varchar(110) default NULL,
  `locale_day_abbreviated_wed` varchar(110) default NULL,
  `locale_day_abbreviated_thu` varchar(110) default NULL,
  `locale_day_abbreviated_fri` varchar(110) default NULL,
  `locale_day_abbreviated_sat` varchar(110) default NULL,
  `locale_day_wide_sun` varchar(150) default NULL,
  `locale_day_wide_mon` varchar(150) default NULL,
  `locale_day_wide_tue` varchar(150) default NULL,
  `locale_day_wide_wed` varchar(150) default NULL,
  `locale_day_wide_thu` varchar(150) default NULL,
  `locale_day_wide_fri` varchar(150) default NULL,
  `locale_day_wide_sat` varchar(150) default NULL,
  PRIMARY KEY  (`locale_id`),
  KEY `locale_country_iso_2` (`locale_country_iso_2`),
  KEY `locale_language` (`locale_language`),
  KEY `locale_currency_code` (`locale_currency_code`)
) AUTO_INCREMENT=382;

--
-- Dumping data for table `locales`
--

LOCK TABLES `locales` WRITE;
/*!40000 ALTER TABLE `locales` DISABLE KEYS */;
INSERT INTO `locales` VALUES (1,'aa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM dd, yyyy','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,'saaku','carra',NULL,NULL,NULL,'Qun','Nah','Cig','Agd','Cax','Qas','Qad','Leq','Way','Dit','Xim','Kax',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Qunxa Garablu','Naharsi Kudo','Ciggilta Kudo','Agda Baxisso','Caxah Alsa','Qasa Dirri','Qado Dirri','Leqeeni','Waysu','Diteli','Ximoli','Kaxxa Garablu','Aca','Etl','Tal','Arb','Kam','Gum','Sab','Acaada','Etleeni','Talaata','Arbaqa','Kamiisi','Gumqata','Sabti'),(2,'aa','DJ','DJF','FD','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3,'aa','ER','ERN','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Kudo',NULL,'Agda Baxis',NULL,NULL,NULL,'Liiqen',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4,'aa','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Kudo',NULL,'Agda Baxis',NULL,NULL,NULL,'Liiqen',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5,'af',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','yyyy-MM-dd',NULL,'vm.','nm.',NULL,NULL,NULL,'Jan.','Feb.','Mrt.','Apr.','Mei','Jun.','Jul.','Aug.','Sep.','Okt.','Nov.','Des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januarie','Februarie','Maart','April','Mei','Junie','Julie','Augustus','September','Oktober','November','Desember','So.','Ma.','Di.','Wo.','Do.','Vr.','Sa.','Sondag','Maandag','Dinsdag','Woensdag','Donderdag','Vrydag','Saterdag'),(6,'af','NA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7,'af','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','yyyy/MM/dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8,'ak',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'AN','EW',NULL,NULL,NULL,'S-Æ†','K-Æ†','E-Æ†','E-O','E-K','O-A','A-K','D-Æ†','F-Æ','Æ†-A','Æ†-O','M-Æ†',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Sanda-Æ†pÉ›pÉ”n','Kwakwar-Æ†gyefuo','EbÉ”w-Æ†benem','EbÉ”bira-Oforisuo','Esusow Aketseaba-KÉ”tÉ”nimba','Obirade-AyÉ›wohomumu','AyÉ›woho-Kitawonsa','Difuu-Æ†sandaa','Fankwa-ÆbÉ”','Æ†bÉ›sÉ›-Ahinime','Æ†berÉ›fÉ›w-Obubuo','Mumu-Æ†pÉ›nimba','Kwe','Dwo','Ben','Wuk','Yaw','Fia','Mem','Kwesida','Dwowda','Benada','Wukuda','Yawda','Fida','Memeneda'),(9,'ak','GH','GHC','Â¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10,'am',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,'hh:mm:ss a','hh:mm:ss a','h:mm:ss a','h:mm a','EEEEá£ MMMM dd á‰€áŠ• yyyy G','MMMM d yyyy','MMM d yyyy','dd/MM/yy',NULL,'áŒ¡á‹‹á‰µ','áŠ¨áˆ°á‹“á‰µ',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','áŠ¥áˆ‘á‹µ','áˆ°áŠž','áˆ›áŠ­áˆ°','áˆ¨á‰¡á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰¥','á‰…á‹³áˆœ','áŠ¥áˆ‘á‹µ','áˆ°áŠž','áˆ›áŠ­áˆ°áŠž','áˆ¨á‰¡á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰¥','á‰…á‹³áˆœ'),(11,'am','ET','ETB','á‰¥áˆ­',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEEá£ dd MMMM á‰€áŠ• yyyy G','dd MMMM yyyy','dd-MMM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12,'ar',NULL,NULL,NULL,NULL,NULL,'Ù«','Ù¬','#,##0.###;#,##0.###-','Â¤ #,##0.00;Â¤ #,##0.00-','Ùª',NULL,'z h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, d MMMM, yyyy','d MMMM, yyyy','dd/MM/yyyy','d/M/yyyy',NULL,'Øµ','Ù…',NULL,NULL,NULL,'ÙŠÙ†Ø§ÙŠØ±','ÙØ¨Ø±Ø§ÙŠØ±','Ù…Ø§Ø±Ø³','Ø£Ø¨Ø±ÙŠÙ„','Ù…Ø§ÙŠÙˆ','ÙŠÙˆÙ†ÙŠÙˆ','ÙŠÙˆÙ„ÙŠÙˆ','Ø£ØºØ³Ø·Ø³','Ø³Ø¨ØªÙ…Ø¨Ø±','Ø£ÙƒØªÙˆØ¨Ø±','Ù†ÙˆÙÙ…Ø¨Ø±','Ø¯ÙŠØ³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙŠÙ†Ø§ÙŠØ±','ÙØ¨Ø±Ø§ÙŠØ±','Ù…Ø§Ø±Ø³','Ø£Ø¨Ø±ÙŠÙ„','Ù…Ø§ÙŠÙˆ','ÙŠÙˆÙ†ÙŠÙˆ','ÙŠÙˆÙ„ÙŠÙˆ','Ø£ØºØ³Ø·Ø³','Ø³Ø¨ØªÙ…Ø¨Ø±','Ø£ÙƒØªÙˆØ¨Ø±','Ù†ÙˆÙÙ…Ø¨Ø±','Ø¯ÙŠØ³Ù…Ø¨Ø±','Ø­','Ù†','Ø«','Ø±','Ø®','Ø¬','Ø³','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª'),(13,'ar','AE','AED','Ø¯.Ø¥.â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14,'ar','BH','BHD','Ø¯.Ø¨.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15,'ar','DZ','DZD','Ø¯.Ø¬.â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16,'ar','EG','EGP','Ø¬.Ù….â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17,'ar','IQ','IQD','Ø¯.Ø¹.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18,'ar','JO','JOD','Ø¯.Ø£.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ø£ÙŠØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ø£ÙŠØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19,'ar','KW','KWD','Ø¯.Ùƒ.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20,'ar','LB','LBP','Ù„.Ù„.â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21,'ar','LY','LYD','Ø¯.Ù„.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22,'ar','MA','MAD','Ø¯.Ù….â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23,'ar','OM','OMR','Ø±.Ø¹.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24,'ar','QA','QAR','Ø±.Ù‚.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25,'ar','SA','SAR','Ø±.Ø³.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26,'ar','SD','SDD','.â€Ø¯.Ø³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27,'ar','SY','SYP','Ù„.Ø³.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28,'ar','TN','TND','Ø¯.Øª.â€','0','3',NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29,'ar','YE','YER','Ø±.ÙŠ.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30,'as',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦ªà§‚à§°à§à¦¬à¦¾','à¦…à¦ª',NULL,NULL,NULL,'à¦œà¦¾à¦¨à§','à¦«à§‡à¦¬à§à§°à§','à¦®à¦¾à§°à§à¦š','à¦à¦ªà§à§°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—','à¦¸à§‡à¦ªà§à¦Ÿ','à¦…à¦•à§à¦Ÿà§‹','à¦¨à¦­à§‡','à¦¡à¦¿à¦¸à§‡',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦œà¦¾à¦¨à§à¦¯à¦¼à¦¾à§°à§€','à¦«à§‡à¦¬à§à§°à§à¦¯à¦¼à¦¾à§°à§€','à¦®à¦¾à§°à§à¦š','à¦à¦ªà§à§°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—à¦·à§à¦Ÿ','à¦¸à§‡à¦ªà§à¦Ÿà§‡à¦®à§à¦¬à§°','à¦…à¦•à§à¦Ÿà§‹à¦¬à§°','à¦¨à¦­à§‡à¦®à§à¦¬à§°','à¦¡à¦¿à¦¸à§‡à¦®à§à¦¬à§°','à§°à¦¬à¦¿','à¦¸à§‹à¦®','à¦®à¦™à§à¦—à¦²','à¦¬à§à¦§','à¦¬à§ƒà¦¹à¦·à§à¦ªà¦¤à¦¿','à¦¶à§à¦•à§à§°','à¦¶à¦¨à¦¿','à¦¦à§‡à¦“à¦¬à¦¾à§°','à¦¸à§‹à¦®à¦¬à¦¾à§°','à¦®à¦™à§à¦—à¦²à¦¬à¦¾à§°','à¦¬à§à¦§à¦¬à¦¾à§°','à¦¬à§ƒà¦¹à¦·à§à¦ªà¦¤à¦¿à¦¬à¦¾à§°','à¦¶à§à¦•à§à§°à¦¬à¦¾à§°','à¦¶à¦¨à¦¿à¦¬à¦¾à§°'),(31,'as','IN','INR','à¦Ÿà¦•à¦¾',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h.mm.ss a z','h.mm.ss a z','h.mm.ss a','h.mm. a','EEEE, d MMMM, yyyy','d MMMM, yyyy','dd-MM-yyyy','d-M-yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32,'az',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yan','fev','mar','apr','may','iyn','iyl','avq','sen','okt','noy','dek',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Yanvar','Fevral','Mart','Aprel','May','Ä°yun','Ä°yul','Avqust','Sentyabr','Oktyabr','Noyabr','Dekabr','B.','B.e.','Ã‡.a.','Ã‡.','C.a.','C.','Åž.','bazar','bazar ertÉ™si','Ã§É™rÅŸÉ™nbÉ™ axÅŸam','Ã§É™rÅŸÉ™nbÉ™','cÃ¼mÉ™ axÅŸamÄ±','cÃ¼mÉ™ axÅŸamÄ±','ÅŸÉ™nbÉ™'),(33,'az_Cyrl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½Ð²Ð°Ñ€','Ñ„ÐµÐ²Ñ€Ð°Ð»','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€ÐµÐ»','Ð¼Ð°Ð¹','Ð¸Ñ˜ÑƒÐ½','Ð¸Ñ˜ÑƒÐ»','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ½Ñ‚Ñ˜Ð°Ð±Ñ€','Ð¾ÐºÑ‚Ñ˜Ð°Ð±Ñ€','Ð½Ð¾Ñ˜Ð°Ð±Ñ€','Ð´ÐµÐºÐ°Ð±Ñ€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð±Ð°Ð·Ð°Ñ€','Ð±Ð°Ð·Ð°Ñ€ ÐµÑ€Ñ‚Ó™ÑÐ¸','Ñ‡Ó™Ñ€ÑˆÓ™Ð½Ð±Ó™ Ð°Ñ…ÑˆÐ°Ð¼Ñ‹','Ñ‡Ó™Ñ€ÑˆÓ™Ð½Ð±Ó™','Ò¹Ò¯Ð¼Ó™ Ð°Ñ…ÑˆÐ°Ð¼Ñ‹','Ò¹Ò¯Ð¼Ó™','ÑˆÓ™Ð½Ð±Ó™'),(34,'az_Cyrl','AZ','AZN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35,'az_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36,'az_Latn','AZ','AZN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37,'be',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE, d MMMM yyyy','d MMMM yyyy','d.M.yyyy','d.M.yy',NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ‚Ñƒ','Ð»ÑŽÑ‚','ÑÐ°Ðº','ÐºÑ€Ð°','Ð¼Ð°Ð¹','Ñ‡ÑÑ€','Ð»Ñ–Ð¿','Ð¶Ð½Ñ–','Ð²ÐµÑ€','ÐºÐ°Ñ','Ð»Ñ–Ñ','ÑÐ½Ðµ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ‚ÑƒÐ´Ð·ÐµÐ½ÑŒ','Ð»ÑŽÑ‚Ñ‹','ÑÐ°ÐºÐ°Ð²Ñ–Ðº','ÐºÑ€Ð°ÑÐ°Ð²Ñ–Ðº','Ð¼Ð°Ð¹','Ñ‡ÑÑ€Ð²ÐµÐ½ÑŒ','Ð»Ñ–Ð¿ÐµÐ½ÑŒ','Ð¶Ð½Ñ–Ð²ÐµÐ½ÑŒ','Ð²ÐµÑ€Ð°ÑÐµÐ½ÑŒ','ÐºÐ°ÑÑ‚Ñ€Ñ‹Ñ‡Ð½Ñ–Ðº','Ð»Ñ–ÑÑ‚Ð°Ð¿Ð°Ð´','ÑÐ½ÐµÐ¶Ð°Ð½ÑŒ','Ð½Ð´','Ð¿Ð½','Ð°Ñž','ÑÑ€','Ñ‡Ñ†','Ð¿Ñ‚','ÑÐ±','Ð½ÑÐ´Ð·ÐµÐ»Ñ','Ð¿Ð°Ð½ÑÐ´Ð·ÐµÐ»Ð°Ðº','Ð°ÑžÑ‚Ð¾Ñ€Ð°Ðº','ÑÐµÑ€Ð°Ð´Ð°','Ñ‡Ð°Ñ†Ð²ÐµÑ€','Ð¿ÑÑ‚Ð½Ñ–Ñ†Ð°','ÑÑƒÐ±Ð¾Ñ‚Ð°'),(38,'be','BY','BYR','','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39,'bg',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,'HH:mm:ss',NULL,NULL,'dd MMMM yyyy, EEEE','dd MMMM yyyy','dd.MM.yyyy','dd.MM.yy',NULL,'Ð¿Ñ€. Ð¾Ð±.','ÑÐ». Ð¾Ð±.',NULL,NULL,NULL,'ÑÐ½.','Ñ„ÐµÐ²Ñ€.','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€.','Ð¼Ð°Ð¹','ÑŽÐ½Ð¸','ÑŽÐ»Ð¸','Ð°Ð²Ð³.','ÑÐµÐ¿Ñ‚.','Ð¾ÐºÑ‚.','Ð½Ð¾ÐµÐ¼.','Ð´ÐµÐº.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÑÐ½ÑƒÐ°Ñ€Ð¸','Ñ„ÐµÐ²Ñ€ÑƒÐ°Ñ€Ð¸','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€Ð¸Ð»','Ð¼Ð°Ð¹','ÑŽÐ½Ð¸','ÑŽÐ»Ð¸','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ¿Ñ‚ÐµÐ¼Ð²Ñ€Ð¸','Ð¾ÐºÑ‚Ð¾Ð¼Ð²Ñ€Ð¸','Ð½Ð¾ÐµÐ¼Ð²Ñ€Ð¸','Ð´ÐµÐºÐµÐ¼Ð²Ñ€Ð¸','Ð½Ð´','Ð¿Ð½','Ð²Ñ‚','ÑÑ€','Ñ‡Ñ‚','Ð¿Ñ‚','ÑÐ±','Ð½ÐµÐ´ÐµÐ»Ñ','Ð¿Ð¾Ð½ÐµÐ´ÐµÐ»Ð½Ð¸Ðº','Ð²Ñ‚Ð¾Ñ€Ð½Ð¸Ðº','ÑÑ€ÑÐ´Ð°','Ñ‡ÐµÑ‚Ð²ÑŠÑ€Ñ‚ÑŠÐº','Ð¿ÐµÑ‚ÑŠÐº','ÑÑŠÐ±Ð¾Ñ‚Ð°'),(40,'bg','BG','BGN','Ð»Ð².',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41,'bn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦ªà§‚à¦°à§à¦¬à¦¾à¦¹à§à¦£','à¦…à¦ªà¦°à¦¾à¦¹à§à¦£',NULL,NULL,NULL,'à¦œà¦¾à¦¨à§à¦¯à¦¼à¦¾à¦°à§€','à¦«à§‡à¦¬à§à¦°à§à¦¯à¦¼à¦¾à¦°à§€','à¦®à¦¾à¦°à§à¦š','à¦à¦ªà§à¦°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—à¦¸à§à¦Ÿ','à¦¸à§‡à¦ªà§à¦Ÿà§‡à¦®à§à¦¬à¦°','à¦…à¦•à§à¦Ÿà§‹à¦¬à¦°','à¦¨à¦­à§‡à¦®à§à¦¬à¦°','à¦¡à¦¿à¦¸à§‡à¦®à§à¦¬à¦°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦œà¦¾à¦¨à§à¦¯à¦¼à¦¾à¦°à§€','à¦«à§‡à¦¬à§à¦°à§à¦¯à¦¼à¦¾à¦°à§€','à¦®à¦¾à¦°à§à¦š','à¦à¦ªà§à¦°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—à¦¸à§à¦Ÿ','à¦¸à§‡à¦ªà§à¦Ÿà§‡à¦®à§à¦¬à¦°','à¦…à¦•à§à¦Ÿà§‹à¦¬à¦°','à¦¨à¦­à§‡à¦®à§à¦¬à¦°','à¦¡à¦¿à¦¸à§‡à¦®à§à¦¬à¦°','à¦°à¦¬à¦¿','à¦¸à§‹à¦®','à¦®à¦™à§à¦—à¦²','à¦¬à§à¦§','à¦¬à§ƒà¦¹à¦¸à§à¦ªà¦¤à¦¿','à¦¶à§à¦•à§à¦°','à¦¶à¦¨à¦¿','à¦°à¦¬à¦¿à¦¬à¦¾à¦°','à¦¸à§‹à¦®à¦¬à¦¾à¦°','à¦®à¦™à§à¦—à¦²à¦¬à¦¾à¦°','à¦¬à§à¦§à¦¬à¦¾à¦°','à¦¬à§ƒà¦¹à¦·à§à¦ªà¦¤à¦¿à¦¬à¦¾à¦°','à¦¶à§à¦•à§à¦°à¦¬à¦¾à¦°','à¦¶à¦¨à¦¿à¦¬à¦¾à¦°'),(42,'bn','BD','BDT','à§³',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43,'bn','IN','INR','à¦Ÿà¦¾à¦•à¦¾',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44,'bs',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Maj','Jun','Jul','Avg','Sep','Okt','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januar','Februar','Mart','April','Maj','Juni','Juli','Avgust','Septembar','Oktobar','Novembar','Decembar','Ned','Pon','Uto','Sri','ÄŒet','Pet','Sub','Nedjelja','Ponedjeljak','Utorak','Srijeda','ÄŒetvrtak','Petak','Subota'),(45,'bs','BA','BAM','KM',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46,'byn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á‹á‹±áˆµ áŒƒá‰¥','á‹á‹±áˆµ á‹°áˆá‰¢',NULL,NULL,NULL,'áˆá‹°á‰µ','áŠ«á‰¥áŠ½','áŠ­á‰¥áˆ‹','á‹áŒ…áŠº','áŠ­á‰¢á‰…','áˆ/á‰µ','áŠ°áˆ­','áˆ›áˆ­á‹«','á‹«áŠ¸áŠ’','áˆ˜á‰°áˆ‰','áˆ/áˆ','á‰°áˆ•áˆ³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áˆá‹°á‰µáˆª','áŠ«á‰¥áŠ½á‰¥á‰²','áŠ­á‰¥áˆ‹','á‹áŒ…áŠºáˆª','áŠ­á‰¢á‰…áˆª','áˆáŠªáŠ¤áˆ á‰µáŒ“Ì…áŠ’áˆª','áŠ°áˆ­áŠ©','áˆ›áˆ­á‹«áˆ á‰µáˆª','á‹«áŠ¸áŠ’ áˆ˜áˆ³á‰…áˆˆáˆª','áˆ˜á‰°áˆ‰','áˆáŠªáŠ¤áˆ áˆ˜áˆ½á‹ˆáˆª','á‰°áˆ•áˆ³áˆµáˆª','áˆ°/á‰…','áˆ°áŠ‘','áˆ°áˆŠáŒ','áˆˆáŒ“','áŠ£áˆá‹µ','áŠ£áˆ­á‰¥','áˆ°/áˆ½','áˆ°áŠ•á‰ áˆ­ á‰…á‹³á‹…','áˆ°áŠ‘','áˆ°áˆŠáŒ','áˆˆáŒ“ á‹ˆáˆª áˆˆá‰¥á‹‹','áŠ£áˆá‹µ','áŠ£áˆ­á‰¥','áˆ°áŠ•á‰ áˆ­ áˆ½áŒ“á‹…'),(47,'byn','ER','ERN',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¡ dd MMMM áŒáˆ­áŒ‹ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48,'ca',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE d \'de\' MMMM \'de\' yyyy','d \'de\' MMMM \'de\' yyyy','dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'gen.','febr.','marÃ§','abr.','maig','juny','jul.','ag.','set.','oct.','nov.','des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'gener','febrer','marÃ§','abril','maig','juny','juliol','agost','setembre','octubre','novembre','desembre','dg.','dl.','dt.','dc.','dj.','dv.','ds.','diumenge','dilluns','dimarts','dimecres','dijous','divendres','dissabte'),(49,'ca','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50,'cch',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Dyon','Baa','Atat','Anas','Atyo','Achi','Atar','Awur','Shad','Shak','Naba','Nata',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Pen Dyon','Pen Ba\'a','Pen Atat','Pen Anas','Pen Atyon','Pen Achirim','Pen Atariba','Pen Awurr','Pen Shadon','Pen Shakur','Pen Kur Naba','Pen Kur Natat','Yok','Tung','T. Tung','Tsan','Nas','Nat','Chir','Wai Yoka Bawai','Wai Tunga','Toki Gitung','Tsam Kasuwa','Wai Na Nas','Wai Na Tiyon','Wai Na Chirim'),(51,'cch','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52,'cs',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, d. MMMM yyyy','d. MMMM yyyy','d.M.yyyy','d.M.yy',NULL,'dop.','odp.',NULL,NULL,NULL,'led','Ãºno','bÅ™e','dub','kvÄ›','Ärn','Ärc','srp','zÃ¡Å™','Å™Ã­j','lis','pro','l','Ãº','b','d','k','Ä','Ä','s','z','Å™','l','p','ledna','Ãºnora','bÅ™ezna','dubna','kvÄ›tna','Äervna','Äervence','srpna','zÃ¡Å™Ã­','Å™Ã­jna','listopadu','prosince','ne','po','Ãºt','st','Ät','pÃ¡','so','nedÄ›le','pondÄ›lÃ­','ÃºterÃ½','stÅ™eda','Ätvrtek','pÃ¡tek','sobota'),(53,'cs','CZ','CZK','KÄ',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54,'cy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ion','Chwef','Mawrth','Ebrill','Mai','Meh','Gorff','Awst','Medi','Hyd','Tach','Rhag',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ionawr','Chwefror','Mawrth','Ebrill','Mai','Mehefin','Gorffenaf','Awst','Medi','Hydref','Tachwedd','Rhagfyr','Sul','Llun','Maw','Mer','Iau','Gwen','Sad','Dydd Sul','Dydd Llun','Dydd Mawrth','Dydd Mercher','Dydd Iau','Dydd Gwener','Dydd Sadwrn'),(55,'cy','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, dd MMMM yyyy','dd MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56,'da',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,'âˆ’','HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE \'den\' d. MMMM yyyy','d. MMM yyyy','dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','marts','april','maj','juni','juli','august','september','oktober','november','december','sÃ¸n','man','tir','ons','tor','fre','lÃ¸r','sÃ¸ndag','mandag','tirsdag','onsdag','torsdag','fredag','lÃ¸rdag'),(57,'da','DK','DKK','kr',NULL,NULL,NULL,NULL,NULL,'Â¤ #,##0.00;Â¤ -#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58,'de',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H:mm\' Uhr \'z',NULL,NULL,NULL,'EEEE, d. MMMM yyyy','d. MMMM yyyy','dd.MM.yyyy','dd.MM.yy',NULL,'vorm.','nachm.',NULL,NULL,NULL,'Jan','Feb','MÃ¤r','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januar','Februar','MÃ¤rz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember','So','Mo','Di','Mi','Do','Fr','Sa','Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag'),(59,'de','AT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm\' Uhr \'z',NULL,NULL,NULL,'EEEE, dd. MMMM yyyy','dd. MMMM yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'JÃ¤n',NULL,'MÃ¤r',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'JÃ¤nner',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60,'de','BE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,'HH \'h\' mm \'min\' ss \'s\' z',NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d-MMM-yy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'MÃ¤r',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Son','Mon','Die','Mit','Don','Fre','Sam',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61,'de','CH','CHF','SFr.','5','2','.','',NULL,'Â¤ #,##0.00;Â¤-#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62,'de','DE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63,'de','LI','CHF','SFr.','5','2','.','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64,'de','LU','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65,'dv',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66,'dv','MV','MVR','Þƒ.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67,'dz',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤#,##,##0.00',NULL,NULL,'à½†à½´à¼‹à½šà½¼à½‘à¼‹ h à½¦à¾à½¢à¼‹à½˜à¼‹ mm à½¦à¾à½¢à¼‹à½†à½±à¼‹ ss a zzzz','à½†à½´à¼‹à½šà½¼à½‘à¼‹ h à½¦à¾à½¢à¼‹à½˜à¼‹ mm à½¦à¾à½¢à¼‹à½†à½±à¼‹ ss a zzz','à½†à½´à¼‹à½šà½¼à½‘à¼‹h:mm:ss a','à½†à½´à¼‹à½šà½¼à½‘à¼‹ h à½¦à¾à½¢à¼‹à½˜à¼‹ mm a','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹yyyy à½Ÿà¾³à¼‹ MMMM à½šà½ºà½¦à¼‹ dd','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹yyyy à½Ÿà¾³à¼‹ MMMM à½šà½ºà½¦à¼‹ dd','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹yyyy à½Ÿà¾³à¼‹ MMM à½šà½ºà½¦à¼‹ dd','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹ yyyy à½Ÿà¾³à¼‹ MMM à½šà½ºà½¦à¼‹ dd','{1} {0}','à½¦à¾”à¼‹à½†à¼‹','à½•à¾±à½²à¼‹à½†à¼‹',NULL,NULL,NULL,'à½Ÿà¾³à¼‹ à¼¡','à½Ÿà¾³à¼‹ à¼¢','à½Ÿà¾³à¼‹ à¼£','à½Ÿà¾³à¼‹ à¼¤','à½Ÿà¾³à¼‹ à¼¥','à½Ÿà¾³à¼‹ à¼¦','à½Ÿà¾³à¼‹ à¼§','à½Ÿà¾³à¼‹ à¼¨','à½Ÿà¾³à¼‹ à¼©','à½Ÿà¾³à¼‹ à¼¡à¼ ','à½Ÿà¾³à¼‹ à¼¡à¼¡','à½Ÿà¾³à¼‹ à¼¡à¼¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‘à½„à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‚à½‰à½²à½¦à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‚à½¦à½´à½˜à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½žà½²à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½£à¾”à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‘à¾²à½´à½‚à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½‘à½´à½“à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½¢à¾’à¾±à½‘à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‘à½‚à½´à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½…à½´à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½…à½´à¼‹à½‚à½…à½²à½‚à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½…à½´à¼‹à½‚à½‰à½²à½¦à¼‹à½”à¼‹','à½Ÿà¾³à¼‹','à½˜à½²à½¢à¼‹','à½£à¾·à½‚à¼‹','à½•à½´à½¢à¼‹','à½¦à½„à½¦à¼‹','à½¦à¾¤à½ºà½“à¼‹','à½‰à½²à¼‹','à½‚à½Ÿà½ à¼‹à½Ÿà¾³à¼‹à½–à¼‹','à½‚à½Ÿà½ à¼‹à½˜à½²à½‚à¼‹à½‘à½˜à½¢à¼‹','à½‚à½Ÿà½ à¼‹à½£à¾·à½‚à¼‹à½”à¼‹','à½‚à½Ÿà½ à¼‹à½•à½´à½¢à¼‹à½–à½´à¼‹','à½‚à½Ÿà½ à¼‹à½”à¼‹à½¦à½„à½¦à¼‹','à½‚à½Ÿà½ à¼‹à½¦à¾¤à½ºà½“à¼‹à½”à¼‹','à½‚à½Ÿà½ à¼‹à½‰à½²à¼‹à½˜à¼‹'),(68,'dz','BT','INR','â‚¨',NULL,NULL,NULL,NULL,NULL,NULL,'à½–à½¢à¾’à¼‹à½†à½±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69,'ee',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'AN','EW',NULL,NULL,NULL,'Dzv','Dzd','Ted','AfÉ”','Dam','Mas','Sia','Dea','Any','Kel','Ade','Dzm',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Dzove','Dzodze','Tedoxe','AfÉ”fiÉ›','Dama','Masa','SiamlÉ”m','Deasiamime','AnyÉ”nyÉ”','Kele','AdeÉ›mekpÉ”xe','Dzome','KÉ”s Kwe','Dzo','Bra','KuÉ–','Yaw','FiÉ–','Mem','KÉ”siÉ–a','DzoÉ–a','BraÉ–a','KuÉ–a','YawoÉ–a','FiÉ–a','MemleÉ–a'),(70,'ee','GH','GHC','Â¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71,'ee','TG','XOF','CFA','0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72,'el',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE, dd MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','dd/MM/yyyy',NULL,'Î Îœ','ÎœÎœ',NULL,NULL,NULL,'Î™Î±Î½','Î¦ÎµÎ²','ÎœÎ±Ï','Î‘Ï€Ï','ÎœÎ±ÏŠ','Î™Î¿Ï…Î½','Î™Î¿Ï…Î»','Î‘Ï…Î³','Î£ÎµÏ€','ÎŸÎºÏ„','ÎÎ¿Îµ','Î”ÎµÎº','Î™','Î¦','Îœ','Î‘','Îœ','Î™','Î™','Î‘','Î£','ÎŸ','Î','Î”','Î™Î±Î½Î¿Ï…Î±ÏÎ¯Î¿Ï…','Î¦ÎµÎ²ÏÎ¿Ï…Î±ÏÎ¯Î¿Ï…','ÎœÎ±ÏÏ„Î¯Î¿Ï…','Î‘Ï€ÏÎ¹Î»Î¯Î¿Ï…','ÎœÎ±ÎÎ¿Ï…','Î™Î¿Ï…Î½Î¯Î¿Ï…','Î™Î¿Ï…Î»Î¯Î¿Ï…','Î‘Ï…Î³Î¿ÏÏƒÏ„Î¿Ï…','Î£ÎµÏ€Ï„ÎµÎ¼Î²ÏÎ¯Î¿Ï…','ÎŸÎºÏ„Ï‰Î²ÏÎ¯Î¿Ï…','ÎÎ¿ÎµÎ¼Î²ÏÎ¯Î¿Ï…','Î”ÎµÎºÎµÎ¼Î²ÏÎ¯Î¿Ï…','ÎšÏ…Ï','Î”ÎµÏ…','Î¤ÏÎ¹','Î¤ÎµÏ„','Î ÎµÎ¼','Î Î±Ï','Î£Î±Î²','ÎšÏ…ÏÎ¹Î±ÎºÎ®','Î”ÎµÏ…Ï„Î­ÏÎ±','Î¤ÏÎ¯Ï„Î·','Î¤ÎµÏ„Î¬ÏÏ„Î·','Î Î­Î¼Ï€Ï„Î·','Î Î±ÏÎ±ÏƒÎºÎµÏ…Î®','Î£Î¬Î²Î²Î±Ï„Î¿'),(73,'el','CY','CYP','Â£',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74,'el','GR','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00Â¤;-Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75,'en',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a v','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE, MMMM d, yyyy','MMMM d, yyyy','MMM d, yyyy','M/d/yy',NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'January','February','March','April','May','June','July','August','September','October','November','December','Sun','Mon','Tue','Wed','Thu','Fri','Sat','Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'),(76,'en','AS','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77,'en','AU','AUD','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a',NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','dd/MM/yyyy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78,'en','BE','EUR','â‚¬',NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,'HH\' h \'mm\' min \'ss\' s \'z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE d MMMM yyyy','EEE d MMM yyyy','dd MMM yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79,'en','BW','BWP','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80,'en','BZ','BZD','BZ$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','dd MMMM yyyy','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81,'en','CA','CAD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'d-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82,'en','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83,'en','GU','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84,'en','HK','HKD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85,'en','IE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,'a.m.','p.m.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86,'en','IN','INR','â‚¨',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87,'en','JM','JMD','J$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88,'en','MH','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89,'en','MP','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90,'en','MT','MTL','Lm',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, d MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91,'en','NA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92,'en','NZ','NZD','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a',NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','d/MM/yyyy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93,'en','PH','PHP','Php',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'MM d, yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94,'en','PK','PKR','Pra',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95,'en','SG','SGD','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a hh:mm:ss','a hh:mm:ss','a hh:mm','a hh:mm','dd MMMM yyyy','dd MMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96,'en','TT','TTD','TT$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97,'en','UM','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98,'en','US','USD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99,'en','VI','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100,'en','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','yyyy/MM/dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101,'en','ZW','ZWD','Z$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM,yy','d/M/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102,'eo',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H\'-a horo kaj \'m z',NULL,NULL,NULL,'EEEE, d\'-a de \'MMMM yyyy','yyyy-MMMM-dd','yyyy-MMM-dd','yy-MM-dd',NULL,'atm','ptm',NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aÅ­g','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januaro','februaro','marto','aprilo','majo','junio','julio','aÅ­gusto','septembro','oktobro','novembro','decembro','di','lu','ma','me','Äµa','ve','sa','dimanÄ‰o','lundo','mardo','merkredo','ÄµaÅ­do','vendredo','sabato'),(103,'es',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,'HH\'H\'mm\'\'ss&quot; z',NULL,NULL,NULL,'EEEE d\' de \'MMMM\' de \'yyyy','d\' de \'MMMM\' de \'yyyy','dd-MMM-yy','d/MM/yy',NULL,'a.m.','p.m.',NULL,NULL,NULL,'ene','feb','mar','abr','may','jun','jul','ago','sep','oct','nov','dic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'enero','febrero','marzo','abril','mayo','junio','julio','agosto','septiembre','octubre','noviembre','diciembre','dom','lun','mar','miÃ©','jue','vie','sÃ¡b','domingo','lunes','martes','miÃ©rcoles','jueves','viernes','sÃ¡bado'),(104,'es','AR','ARS','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH\'h\'\'\'mm z','H:mm:ss z',NULL,NULL,NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105,'es','BO','BOB','Bs',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106,'es','CL','CLP','$','0','-1',NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,'HH:mm:ss z','H:mm:ss z','H:mm:ss','H:mm',NULL,NULL,'dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107,'es','CO','COP','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','H:mm:ss z','H:mm:ss','H:mm',NULL,NULL,'d/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108,'es','CR','CRC','C',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109,'es','DO','DOP','RD$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110,'es','EC','USD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,'HH:mm:ss z','H:mm:ss z','H:mm:ss','H:mm',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111,'es','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,'H:mm:ss','H:mm',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112,'es','GT','GTQ','Q',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'d/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113,'es','HN','HNL','L',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE dd\' de \'MMMM\' de \'yyyy','dd\' de \'MMMM\' de \'yyyy','dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114,'es','MX','MXN','$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115,'es','NI','NIO','C$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116,'es','PA','PAB','B',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'MM/dd/yyyy','MM/dd/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117,'es','PE','PEN','S/',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118,'es','PR','USD','$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'MM/dd/yyyy','MM/dd/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119,'es','PY','PYG','G','0','-1',NULL,NULL,NULL,'Â¤ #,##0.00;Â¤ -#,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120,'es','SV','SVC','',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121,'es','US','USD','US$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a',NULL,NULL,'MMM d, yyyy','M/d/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122,'es','UY','UYU','',NULL,NULL,NULL,NULL,NULL,'Â¤ #,##0.00;(Â¤#,##0.00)',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123,'es','VE','VEB','Bs',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤ -#,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124,'et',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, d, MMMM yyyy','d MMMM yyyy','dd.MM.yyyy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,'jaan','veebr','mÃ¤rts','apr','mai','juuni','juuli','aug','sept','okt','nov','dets',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'jaanuar','veebruar','mÃ¤rts','aprill','mai','juuni','juuli','august','september','oktoober','november','detsember','P','E','T','K','N','R','L','pÃ¼hapÃ¤ev','esmaspÃ¤ev','teisipÃ¤ev','kolmapÃ¤ev','neljapÃ¤ev','reede','laupÃ¤ev'),(125,'et','EE','EEK','kr',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126,'eu',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'urt','ots','mar','api','mai','eka','uzt','abu','ira','urr','aza','abe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'urtarrila','otsaila','martxoa','apirila','maiatza','ekaina','uztaila','abuztua','iraila','urria','azaroa','abendua','ig','al','as','az','og','or','lr','igandea','astelehena','asteartea','asteazkena','osteguna','ostirala','larunbata'),(127,'eu','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, yyyy\'eko\' MMMM\'ren\' dd\'a\'','EEE, yyyy\'eko\' MMM\'ren\' dd\'a\'','yy\'-\'MMM\'-\'dd','yy\'-\'MM\'-\'dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128,'fa',NULL,NULL,NULL,NULL,NULL,'Ù«','Ù¬','#,##0.###;\'â€ª\'-#,##0.###\'â€¬\'','#,##0.00 Â¤;\'â€ª\'-#,##0.00\'â€¬\' Â¤','Ùª','âˆ’','H:mm:ss (vvvv)','H:mm:ss (zzzz)','H:mm:ss','H:mm','EEEE d MMMM yyyy GGGG','d MMMM yyyy','yyyy/M/d','yy/M/d G','{0}ØŒ Ø³Ø§','Ù‚Ø¨Ù„ Ø§Ø² Ø¸Ù‡Ø±','Ø¨Ø¹Ø¯ Ø§Ø² Ø¸Ù‡Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ú˜Ø§Ù†ÙˆÛŒÙ‡Ù”','ÙÙˆØ±ÛŒÙ‡Ù”','Ù…Ø§Ø±Ø³','Ø¢ÙˆØ±ÛŒÙ„','Ù…Ù‡Ù”','Ú˜ÙˆØ¦Ù†','Ú˜ÙˆØ¦ÛŒÙ‡Ù”','Ø§ÙˆØª','Ø³Ù¾ØªØ§Ù…Ø¨Ø±','Ø§Ú©ØªØ¨Ø±','Ù†ÙˆØ§Ù…Ø¨Ø±','Ø¯Ø³Ø§Ù…Ø¨Ø±','ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡','ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡'),(129,'fa','AF','AFN','Ø‹',NULL,NULL,'Ù«','Ù¬',NULL,NULL,'Ùª','âˆ’',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†Ùˆ',NULL,NULL,NULL,'Ù…Ù€ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„',NULL,NULL,NULL,NULL,'Ø¯Ø³Ù…',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÛŒ','ÙØ¨Ø±ÙˆØ±ÛŒ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§ÛŒ','Ø§Ú¯Ø³Øª','Ø³Ù¾ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130,'fa','IR','IRR','ï·¼',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131,'fi',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00Â Â¤',NULL,NULL,'H.mm.ss v','\'klo \'H.mm.ss','H.mm.ss','H.mm','EEEE\'na \'d. MMMM\'ta \'yyyy','d. MMMM\'ta \'yyyy','d.M.yyyy','d.M.yyyy',NULL,'ap.','ip.',NULL,NULL,NULL,'tammi','helmi','maalis','huhti','touko','kesÃ¤','heinÃ¤','elo','syys','loka','marras','joulu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'tammikuu','helmikuu','maaliskuu','huhtikuu','toukokuu','kesÃ¤kuu','heinÃ¤kuu','elokuu','syyskuu','lokakuu','marraskuu','joulukuu','su','ma','ti','ke','to','pe','la','sunnuntai','maanantai','tiistai','keskiviikko','torstai','perjantai','lauantai'),(132,'fi','FI','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133,'fo',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE dd MMMM yyyy','d. MMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','mai','jun','jul','aug','sep','okt','nov','des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mars','aprÃ­l','mai','juni','juli','august','september','oktober','november','desember','sun','mÃ¡n','tÃ½s','mik','hÃ³s','frÃ­','ley','sunnudagur','mÃ¡nadagur','tÃ½sdagur','mikudagur','hÃ³sdagur','frÃ­ggjadagur','leygardagur'),(134,'fo','FO','DKK','kr',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤ -#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135,'fr',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00 Â¤',NULL,NULL,'HH\' h \'mm z',NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'janv.','fÃ©vr.','mars','avr.','mai','juin','juil.','aoÃ»t','sept.','oct.','nov.','dÃ©c.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janvier','fÃ©vrier','mars','avril','mai','juin','juillet','aoÃ»t','septembre','octobre','novembre','dÃ©cembre','dim.','lun.','mar.','mer.','jeu.','ven.','sam.','dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi'),(136,'fr','BE','EUR','â‚¬',NULL,NULL,NULL,'.',NULL,NULL,NULL,NULL,'H\' h \'mm\' min \'ss\' s \'z',NULL,NULL,NULL,NULL,NULL,'dd-MMM-yy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137,'fr','CA','CAD','$',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤;(#,##0.00Â¤)',NULL,NULL,'HH\' h \'mm\' min \'ss\' s \'z',NULL,NULL,NULL,NULL,NULL,'yy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138,'fr','CH','CHF','sFr.','5','2','.','',NULL,'Â¤ #,##0.00;Â¤-#,##0.00',NULL,NULL,'HH.mm:ss\' h\' z',NULL,NULL,NULL,'EEEE, d MMMM yyyy',NULL,NULL,'dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139,'fr','FR','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140,'fr','LU','EUR','â‚¬',NULL,NULL,NULL,'.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141,'fr','MC','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142,'fur',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'d MMMM yyyy EEEE','d MMMM yyyy','d MMM yyyy','d/MM/yy',NULL,'a.','p.',NULL,NULL,NULL,'Zen','Fev','Mar','Avr','Mai','Jug','Lui','Avo','Set','Otu','Nov','Dic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ZenÃ¢r','FevrÃ¢r','MarÃ§','AvrÃ®l','Mai','Jugn','Lui','Avost','Setembar','Otubar','Novembar','Dicembar','dom','lun','mar','mie','joi','vin','sab','domenie','lunis','martars','miercus','joibe','vinars','sabide'),(143,'fur','IT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144,'ga',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'Ean','Feabh','MÃ¡rta','Aib','Beal','Meith','IÃºil','LÃºn','MFÃ³mh','DFÃ³mh','Samh','Noll',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EanÃ¡ir','Feabhra','MÃ¡rta','AibreÃ¡n','Bealtaine','Meitheamh','IÃºil','LÃºnasa','MeÃ¡n FÃ³mhair','Deireadh FÃ³mhair','Samhain','Nollaig','Domh','Luan','MÃ¡irt','CÃ©ad','DÃ©ar','Aoine','Sath','DÃ© Domhnaigh','DÃ© Luain','DÃ© MÃ¡irt','DÃ© CÃ©adaoin','DÃ©ardaoin','DÃ© hAoine','DÃ© Sathairn'),(145,'ga','IE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146,'gaa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'LB','SN',NULL,NULL,NULL,'Aha','Ofl','Och','Abe','Agb','Otu','Maa','Man','Gbo','Ant','Ale','Afu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Aharabata','Oflo','Ochokrikri','Abeibee','Agbeinaa','Otukwadan','Maawe','Manyawale','Gbo','Anton','Alemle','Afuabee','Ho','Dzu','Dzf','Sho','Soo','Soh','Ho','Hogbaa','Dzu','Dzufo','Sho','Soo','Sohaa','Ho'),(147,'gaa','GH','GHC','Â¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148,'gez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒ½á‰£áˆ•','áˆáˆ´á‰µ',NULL,NULL,NULL,'áŒ áˆáˆ¨','áŠ¨á‰°á‰°','áˆ˜áŒˆá‰ ','áŠ áŠ€á‹˜','áŒáŠ•á‰£','áˆ áŠ•á‹¨','áˆáˆ˜áˆˆ','áŠáˆáˆ°','áŠ¨áˆ¨áˆ˜','áŒ á‰€áˆ˜','áŠ€á‹°áˆ¨','áŠ€áˆ áˆ ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒ áˆáˆ¨','áŠ¨á‰°á‰°','áˆ˜áŒˆá‰ ','áŠ áŠ€á‹˜','áŒáŠ•á‰£á‰µ','áˆ áŠ•á‹¨','áˆáˆ˜áˆˆ','áŠáˆáˆ°','áŠ¨áˆ¨áˆ˜','áŒ á‰€áˆ˜','áŠ€á‹°áˆ¨','áŠ€áˆ áˆ ','áŠ¥áŠá‹µ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ«á‰¥á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰ ','á‰€á‹³áˆš','áŠ¥áŠá‹µ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ«á‰¥á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰ ','á‰€á‹³áˆšá‰µ'),(149,'gez','ER','ERN','$',NULL,NULL,NULL,'á‹ˆ',NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¥ dd MMMM áˆ˜á‹“áˆá‰µ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150,'gez','ET','ETB','$',NULL,NULL,NULL,'á‹ˆ',NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¥ dd MMMM áˆ˜á‹“áˆá‰µ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151,'gl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Xan','Feb','Mar','Abr','Mai','XuÃ±','Xul','Ago','Set','Out','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Xaneiro','Febreiro','Marzo','Abril','Maio','XuÃ±o','Xullo','Agosto','Setembro','Outubro','Novembro','Decembro','Dom','Lun','Mar','MÃ©r','Xov','Ven','SÃ¡b','Domingo','Luns','Martes','MÃ©rcores','Xoves','Venres','SÃ¡bado'),(152,'gl','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153,'gu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'àªªà«‚àª°à«àªµÂ àª®àª§à«àª¯àª¾àª¹à«àª¨','àª‰àª¤à«àª¤àª°Â àª®àª§à«àª¯àª¾àª¹à«àª¨',NULL,NULL,NULL,'àªœàª¾àª¨à«àª¯à«','àª«à«‡àª¬à«àª°à«','àª®àª¾àª°à«àªš','àªàªªà«àª°àª¿àª²','àª®à«‡','àªœà«‚àª¨','àªœà«àª²àª¾àªˆ','àª‘àª—àª¸à«àªŸ','àª¸àªªà«àªŸà«‡','àª‘àª•à«àªŸà«‹','àª¨àªµà«‡','àª¡àª¿àª¸à«‡',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'àªœàª¾àª¨à«àª¯à«àª†àª°à«€','àª«à«‡àª¬à«àª°à«àª†àª°à«€','àª®àª¾àª°à«àªš','àªàªªà«àª°àª¿àª²','àª®à«‡','àªœà«‚àª¨','àªœà«àª²àª¾àªˆ','àª‘àª—àª¸à«àªŸ','àª¸àªªà«àªŸà«‡àª®à«àª¬àª°','àª‘àª•à«àªŸà«àª¬àª°','àª¨àªµà«‡àª®à«àª¬àª°','àª¡àª¿àª¸à«‡àª®à«àª¬àª°','àª°àªµàª¿','àª¸à«‹àª®','àª®àª‚àª—àª³','àª¬à«àª§','àª—à«àª°à«','àª¶à«àª•à«àª°','àª¶àª¨àª¿','àª°àªµàª¿àªµàª¾àª°','àª¸à«‹àª®àªµàª¾àª°','àª®àª‚àª—àª³àªµàª¾àª°','àª¬à«àª§àªµàª¾àª°','àª—à«àª°à«àªµàª¾àª°','àª¶à«àª•à«àª°àªµàª¾àª°','àª¶àª¨àª¿àªµàª¾àª°'),(154,'gu','IN','INR','àª°à«',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155,'gv',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'J-guer','T-arree','Mayrnt','Avrril','Boaldyn','M-souree','J-souree','Luanistyn','M-fouyir','J-fouyir','M.Houney','M.Nollick',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jerrey-geuree','Toshiaght-arree','Mayrnt','Averil','Boaldyn','Mean-souree','Jerrey-souree','Luanistyn','Mean-fouyir','Jerrey-fouyir','Mee Houney','Mee ny Nollick','Jed','Jel','Jem','Jerc','Jerd','Jeh','Jes','Jedoonee','Jelhein','Jemayrt','Jercean','Jerdein','Jeheiney','Jesarn'),(156,'gv','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,'HH:mm:ss',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157,'ha',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Fab','Mar','Afr','May','Yun','Yul','Agu','Sat','Okt','Nuw','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janairu','Fabrairu','Maris','Afrilu','Mayu','Yuni','Yuli','Agusta','Satumba','Oktoba','Nuwamba','Disamba','Lah','Lit','Tal','Lar','Alh','Jum','Asa','Lahadi','Littinin','Talata','Laraba','Alhamis','Jumma\'a','Asabar'),(158,'ha_Arab',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'A.M.','P.M.',NULL,NULL,NULL,'Ø¬ÙŽÙ†','Ú¢ÙŽØ¨','Ù…ÙŽØ±','Ø£ÙŽÚ¢Ù’Ø±','Ù…ÙŽÙŠ','ÙŠÙÙˆÙ†','ÙŠÙÙˆÙ„','Ø£ÙŽØºÙ','Ø³ÙŽØª','Ø£ÙÙƒÙ’Øª','Ù†ÙÙˆ','Ø¯ÙØ³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬ÙŽÙ†ÙŽÙŠÙ’Ø±Ù','Ú¢ÙŽØ¨Ù’Ø±ÙŽÙŠÙ’Ø±Ù','Ù…ÙŽØ±ÙØ³Ù’','Ø£ÙŽÚ¢Ù’Ø±ÙÙ„Ù','Ù…ÙŽÙŠÙ','ÙŠÙÙˆÙ†Ù','ÙŠÙÙˆÙ„Ù','Ø£ÙŽØºÙØ³Ù’ØªÙŽ','Ø³ÙŽØªÙÙ…Ù’Ø¨ÙŽ','Ø£ÙÙƒÙ’ØªÙˆÙØ¨ÙŽ','Ù†ÙÙˆÙŽÙ…Ù’Ø¨ÙŽ','Ø¯ÙØ³ÙŽÙ…Ù’Ø¨ÙŽ','Ù„ÙŽØ­','Ù„ÙØª','ØªÙŽÙ„','Ù„ÙŽØ±','Ø£ÙŽÙ„Ù’Ø­','Ø¬ÙÙ…','Ø£ÙŽØ³ÙŽ','Ù„ÙŽØ­ÙŽØ¯Ù','Ù„ÙØªÙÙ†ÙÙ†Ù’','ØªÙŽÙ„ÙŽØªÙŽ','Ù„ÙŽØ±ÙŽØ¨ÙŽ','Ø£ÙŽÙ„Ù’Ø­ÙŽÙ…ÙØ³Ù’','Ø¬ÙÙ…ÙŽØ¹ÙŽ','Ø£ÙŽØ³ÙŽØ¨ÙŽØ±Ù’'),(159,'ha_Arab','NG','NGN','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160,'ha_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161,'ha_Latn','GH','GHC',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162,'ha_Latn','NE','XOF',NULL,'0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163,'ha_Latn','NG','NGN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164,'haw',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ian.','Pep.','Mal.','Ê»Ap.','Mei','Iun.','Iul.','Ê»Au.','Kep.','Ê»Ok.','Now.','Kek.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ianuali','Pepeluali','Malaki','Ê»Apelila','Mei','Iune','Iulai','Ê»Aukake','Kepakemapa','Ê»Okakopa','Nowemapa','Kekemapa','LP','P1','P2','P3','P4','P5','P6','LÄpule','PoÊ»akahi','PoÊ»alua','PoÊ»akolu','PoÊ»ahÄ','PoÊ»alima','PoÊ»aono'),(165,'haw','US','USD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE, d MMMM yyyy','d MMMM yyyy','d MMM yyyy','d/M/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166,'he',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','dd/MM/yyyy','dd/MM/yy','{0} {1}',NULL,NULL,NULL,NULL,NULL,'×™× ×•','×¤×‘×¨','×ž×¨×¥','××¤×¨','×ž××™','×™×•× ','×™×•×œ','××•×’','×¡×¤×˜','××•×§','× ×•×‘','×“×¦×ž',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'×™× ×•××¨','×¤×‘×¨×•××¨','×ž×¨×¥','××¤×¨×™×œ','×ž××™','×™×•× ×™','×™×•×œ×™','××•×’×•×¡×˜','×¡×¤×˜×ž×‘×¨','××•×§×˜×•×‘×¨','× ×•×‘×ž×‘×¨','×“×¦×ž×‘×¨','×','×‘','×’','×“','×”','×•','×©','×™×•× ×¨××©×•×Ÿ','×™×•× ×©× ×™','×™×•× ×©×œ×™×©×™','×™×•× ×¨×‘×™×¢×™','×™×•× ×—×ž×™×©×™','×™×•× ×©×™×©×™','×©×‘×ª'),(167,'he','IL','ILS','â‚ª',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(168,'hi',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤ªà¥‚à¤°à¥à¤µà¤¾à¤¹à¥à¤¨','à¤…à¤ªà¤°à¤¾à¤¹à¥à¤¨',NULL,NULL,NULL,'à¤œà¤¨à¤µà¤°à¥€','à¤«à¤°à¤µà¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¥ˆà¤²','à¤®à¤ˆ','à¤œà¥‚à¤¨','à¤œà¥à¤²à¤¾à¤ˆ','à¤…à¤—à¤¸à¥à¤¤','à¤¸à¤¿à¤¤à¤®à¥à¤¬à¤°','à¤…à¤•à¥à¤¤à¥‚à¤¬à¤°','à¤¨à¤µà¤®à¥à¤¬à¤°','à¤¦à¤¿à¤¸à¤®à¥à¤¬à¤°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¨à¤µà¤°à¥€','à¤«à¤°à¤µà¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¥ˆà¤²','à¤®à¤ˆ','à¤œà¥‚à¤¨','à¤œà¥à¤²à¤¾à¤ˆ','à¤…à¤—à¤¸à¥à¤¤','à¤¸à¤¿à¤¤à¤®à¥à¤¬à¤°','à¤…à¤•à¥à¤¤à¥‚à¤¬à¤°','à¤¨à¤µà¤®à¥à¤¬à¤°','à¤¦à¤¿à¤¸à¤®à¥à¤¬à¤°','à¤°à¤µà¤¿','à¤¸à¥‹à¤®','à¤®à¤‚à¤—à¤²','à¤¬à¥à¤§','à¤—à¥à¤°à¥','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤°à¤µà¤¿à¤µà¤¾à¤°','à¤¸à¥‹à¤®à¤µà¤¾à¤°','à¤®à¤‚à¤—à¤²à¤µà¤¾à¤°','à¤¬à¥à¤§à¤µà¤¾à¤°','à¤—à¥à¤°à¥à¤µà¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°','à¤¶à¤¨à¤¿à¤µà¤¾à¤°'),(169,'hi','IN','INR','à¤°à¥.',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(170,'hr',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yyyy. MMMM dd','yyyy. MMMM dd','yyyy.MM.dd','yyyy.MM.dd',NULL,NULL,NULL,NULL,NULL,NULL,'sij','vel','oÅ¾u','tra','svi','lip','srp','kol','ruj','lis','stu','pro','s','v','o','t','s','l','s','k','r','l','s','p','sijeÄnja','veljaÄe','oÅ¾ujka','travnja','svibnja','lipnja','srpnja','kolovoza','rujna','listopada','studenoga','prosinca','ned','pon','uto','sri','Äet','pet','sub','nedjelja','ponedjeljak','utorak','srijeda','Äetvrtak','petak','subota'),(171,'hr','HR','HRK','Kn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(172,'hu',NULL,NULL,NULL,NULL,NULL,',','Â ','#,##0.###','#,##0.00 Â¤',NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','yyyy. MMMM d.','yyyy. MMMM d.','yyyy.MM.dd.','yyyy.MM.dd.',NULL,'DE','DU',NULL,NULL,NULL,'jan.','febr.','mÃ¡rc.','Ã¡pr.','mÃ¡j.','jÃºn.','jÃºl.','aug.','szept.','okt.','nov.','dec.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januÃ¡r','februÃ¡r','mÃ¡rcius','Ã¡prilis','mÃ¡jus','jÃºnius','jÃºlius','augusztus','szeptember','oktÃ³ber','november','december','V','H','K','Sze','Cs','P','Szo','vasÃ¡rnap','hÃ©tfÅ‘','kedd','szerda','csÃ¼tÃ¶rtÃ¶k','pÃ©ntek','szombat'),(173,'hu','HU','HUF','Ft',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(174,'hy',NULL,NULL,NULL,NULL,NULL,',','.','#0.###','#0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, MMMM d, yyyy','MMMM dd, yyyy','MMM d, yyyy','MM/dd/yy',NULL,'Ô±Õ¼â€¤','ÔµÖ€â€¤',NULL,NULL,NULL,'Õ…Õ¶Ö€','Õ“Õ¿Ö€','Õ„Ö€Õ¿','Ô±ÕºÖ€','Õ„ÕµÕ½','Õ…Õ¶Õ½','Õ…Õ¬Õ½','Õ•Õ£Õ½','ÕÕ¥Õº','Õ€Õ¸Õ¯','Õ†Õ¸Õµ','Ô´Õ¥Õ¯',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Õ…Õ¸Ö‚Õ¶Õ¸Ö‚Õ¡Ö€','Õ“Õ¥Õ¿Ö€Õ¸Ö‚Õ¡Ö€','Õ„Õ¡Ö€Õ¿','Ô±ÕºÖ€Õ«Õ¬','Õ„Õ¡ÕµÕ«Õ½','Õ…Õ¸Ö‚Õ¶Õ«Õ½','Õ…Õ¸Ö‚Õ¬Õ«Õ½','Õ•Õ£Õ¸Õ½Õ¿Õ¸Õ½','ÕÕ¥ÕºÕ¿Õ¥Õ´Õ¢Õ¥Ö€','Õ€Õ¸Õ¯Õ¿Õ¥Õ´Õ¢Õ¥Ö€','Õ†Õ¸ÕµÕ¥Õ´Õ¢Õ¥Ö€','Ô´Õ¥Õ¯Õ¿Õ¥Õ´Õ¢Õ¥Ö€','Ô¿Õ«Ö€','ÔµÖ€Õ¯','ÔµÖ€Ö„','Õ‰Õ¸Ö€','Õ€Õ¶Õ£','ÕˆÖ‚Ö€','Õ‡Õ¡Õ¢','Ô¿Õ«Ö€Õ¡Õ¯Õ«','ÔµÖ€Õ¯Õ¸Ö‚Õ·Õ¡Õ¢Õ©Õ«','ÔµÖ€Õ¥Ö„Õ·Õ¡Õ¢Õ©Õ«','Õ‰Õ¸Ö€Õ¥Ö„Õ·Õ¡Õ¢Õ©Õ«','Õ€Õ«Õ¶Õ£Õ·Õ¡Õ¢Õ©Õ«','ÕˆÖ‚Ö€Õ¢Õ¡Õ©','Õ‡Õ¡Õ¢Õ¡Õ©'),(175,'hy','AM','AMD',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Õ€Õ¶Õ¾','Õ“Õ¿Õ¾',NULL,NULL,NULL,'Õ€Õ¶Õ½','Õ€Õ¬Õ½',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Õ€Õ¸Ö‚Õ¶Õ¾Õ¡Ö€','Õ“Õ¥Õ¿Ö€Õ¾Õ¡Ö€',NULL,NULL,NULL,'Õ€Õ¸Ö‚Õ¶Õ«Õ½','Õ€Õ¸Ö‚Õ¬Õ«Õ½',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(176,'ia',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'jan','feb','mar','apr','mai','jun','jul','aug','sep','oct','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januario','februario','martio','april','maio','junio','julio','augusto','septembre','octobre','novembre','decembre','dom','lun','mar','mer','jov','ven','sab','dominica','lunedi','martedi','mercuridi','jovedi','venerdi','sabbato'),(177,'id',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Mei','Jun','Jul','Agu','Sep','Okt','Nov','Des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januari','Februari','Maret','April','Mei','Juni','Juli','Agustus','September','Oktober','November','Desember','Min','Sen','Sel','Rab','Kam','Jum','Sab','Minggu','Senin','Selasa','Rabu','Kamis','Jumat','Sabtu'),(178,'id','ID','IDR','Rp',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H:mm:ss','H:mm:ss','H:mm:ss','H:mm','EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(179,'ig',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'A.M.','P.M.',NULL,NULL,NULL,'Jen','Feb','Maa','Epr','Mee','Juu','Jul','á»Œgá»','Sep','á»Œkt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jená»¥wará»‹','Febrá»¥wará»‹','Maachá»‹','Eprel','Mee','Juun','Julaá»‹','á»Œgá»á»st','Septemba','á»Œktoba','Novemba','Disemba','á»¤ka','Má»n','Tiu','Wen','Tá»á»','Fraá»‹','Sat','Mbá»sá»‹ á»¤ka','Má»nde','Tiuzdee','Wenezdee','Tá»á»zdee','Fraá»‹dee','Satá»dee'),(180,'ig','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(181,'is',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d. MMMM yyyy','d. MMMM yyyy','d.M.yyyy','d.M.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maÃ­','jÃºn','jÃºl','Ã¡gÃº','sep','okt','nÃ³v','des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janÃºar','febrÃºar','mars','aprÃ­l','maÃ­','jÃºnÃ­','jÃºlÃ­','Ã¡gÃºst','september','oktÃ³ber','nÃ³vember','desember','sun','mÃ¡n','Ã¾ri','miÃ°','fim','fÃ¶s','lau','sunnudagur','mÃ¡nudagur','Ã¾riÃ°judagur','miÃ°vikudagur','fimmtudagur','fÃ¶studagur','laugardagur'),(182,'is','IS','ISK','kr.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(183,'it',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','dd MMMM yyyy','dd/MMM/yy','dd/MM/yy',NULL,'m.','p.',NULL,NULL,NULL,'gen','feb','mar','apr','mag','giu','lug','ago','set','ott','nov','dic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'gennaio','febbraio','marzo','aprile','maggio','giugno','luglio','agosto','settembre','ottobre','novembre','dicembre','dom','lun','mar','mer','gio','ven','sab','domenica','lunedÃ¬','martedÃ¬','mercoledÃ¬','giovedÃ¬','venerdÃ¬','sabato'),(184,'it','CH','CHF','SFr.','5','2','.','',NULL,'Â¤ #,##0.00;Â¤-#,##0.00',NULL,NULL,'HH.mm:ss\' h\' z',NULL,NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','d-MMM-yy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(185,'it','IT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H:mm:ss z',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(186,'iu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á”­á“á“„áŠá“•','á••á•á•—áŠá“•','á’«á‘¦á“¯','áŠáƒá‘‰á³á“—','á’ªáƒ','á”«á“‚','á”ªá“šáƒ','áŠá…á’¡á’á“¯','á“°á‘¦á‘á•á•™','á†á‘¦á‘‘á•á•™','á“…á•™áƒá•á•™','á‘á“°á•á•™',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á”­á“á“„áŠá“•','á••á•á•—áŠá“•','á’«á‘¦á“¯','áŠáƒá‘‰á³á“—','á’ªáƒ','á”«á“‚','á”ªá“šáƒ','áŠá…á’¡á’á“¯','á“°á‘¦á‘á•á•™','á†á‘¦á‘‘á•á•™','á“…á•™áƒá•á•™','á‘á“°á•á•™','á“ˆá‘¦á“°á–‘á”­','á“‡á’¡á’á”¾á”­á…','á“‡á’¡á’á”¾á”­á…á“•á–…á‘­','á±á–“á‘¦á“¯á–…','á“¯á‘•á’»á’¥á–…','á‘•á“ªá“•á•á’¥á–…','á“ˆá‘¦á“°á–‘á”­á“•á–…á•¿','á“ˆá‘¦á“°á–‘á”­','á“‡á’¡á’á”¾á”­á…','á“‡á’¡á’á”¾á”­á…á“•á–…á‘­','á±á–“á‘¦á“¯á–…','á“¯á‘•á’»á’¥á–…','á‘•á“ªá“•á•á’¥á–…','á“ˆá‘¦á“°á–‘á”­á“•á–…á•¿'),(187,'ja',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H\'æ™‚\'mm\'åˆ†\'ss\'ç§’\'z','H:mm:ss:z','H:mm:ss','H:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy/MM/dd',NULL,NULL,'åˆå‰','åˆå¾Œ',NULL,NULL,NULL,'1 æœˆ','2 æœˆ','3 æœˆ','4 æœˆ','5 æœˆ','6 æœˆ','7 æœˆ','8 æœˆ','9 æœˆ','10 æœˆ','11 æœˆ','12 æœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1 æœˆ','2 æœˆ','3 æœˆ','4 æœˆ','5 æœˆ','6 æœˆ','7 æœˆ','8 æœˆ','9 æœˆ','10 æœˆ','11 æœˆ','12 æœˆ','æ—¥','æœˆ','ç«','æ°´','æœ¨','é‡‘','åœŸ','æ—¥æ›œæ—¥','æœˆæ›œæ—¥','ç«æ›œæ—¥','æ°´æ›œæ—¥','æœ¨æ›œæ—¥','é‡‘æ›œæ—¥','åœŸæ›œæ—¥'),(188,'ja','JP','JPY','ï¿¥','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(189,'ka',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'áƒ¡áƒ—:áƒ¬áƒ—:áƒ¬áƒ›','áƒ¡áƒ—:áƒ¬áƒ—:áƒ¬áƒ›','áƒ¡áƒ—:áƒ¬áƒ—:áƒ¬áƒ›','áƒ¡áƒ—:áƒ¬áƒ—',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áƒ˜áƒáƒœ','áƒ—áƒ”áƒ‘','áƒ›áƒáƒ ','áƒáƒžáƒ ','áƒ›áƒáƒ˜','áƒ˜áƒ•áƒœ','áƒ˜áƒ•áƒš','áƒáƒ’áƒ•','áƒ¡áƒ”áƒ¥','áƒáƒ¥áƒ¢','áƒœáƒáƒ”','áƒ“áƒ”áƒ™',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áƒ˜áƒáƒœáƒ•áƒáƒ áƒ˜','áƒ—áƒ”áƒ‘áƒ”áƒ áƒ•áƒáƒšáƒ˜','áƒ›áƒáƒ áƒ¢áƒ˜','áƒáƒžáƒ áƒ˜áƒšáƒ˜','áƒ›áƒáƒ˜áƒ¡áƒ˜','áƒ˜áƒ•áƒœáƒ˜áƒ¡áƒ˜','áƒ˜áƒ•áƒšáƒ˜áƒ¡áƒ˜','áƒáƒ’áƒ•áƒ˜áƒ¡áƒ¢áƒ','áƒ¡áƒ”áƒ¥áƒ¢áƒ”áƒ›áƒ‘áƒ”áƒ áƒ˜','áƒáƒ¥áƒ¢áƒáƒ›áƒ‘áƒ”áƒ áƒ˜','áƒœáƒáƒ”áƒ›áƒ‘áƒ”áƒ áƒ˜','áƒ“áƒ”áƒ™áƒ”áƒ›áƒ‘áƒ”áƒ áƒ˜','áƒ™áƒ•áƒ˜','áƒáƒ áƒ¨','áƒ¡áƒáƒ›','áƒáƒ—áƒ®','áƒ®áƒ£áƒ—','áƒžáƒáƒ ','áƒ¨áƒáƒ‘','áƒ™áƒ•áƒ˜áƒ áƒ','áƒáƒ áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒ¡áƒáƒ›áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒáƒ—áƒ®áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒ®áƒ£áƒ—áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒžáƒáƒ áƒáƒ¡áƒ™áƒ”áƒ•áƒ˜','áƒ¨áƒáƒ‘áƒáƒ—áƒ˜'),(190,'ka','GE','GEL','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(191,'kaj',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'A.M.','P.M.',NULL,NULL,NULL,'AÌ±yr','AÌ±hw','AÌ±ta','AÌ±na','AÌ±pf','AÌ±ki','AÌ±ty','AÌ±ni','AÌ±ku','Swa','Sby','Sbh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Hywan AÌ±yrnig','Hywan AÌ±hwa','Hywan AÌ±tat','Hywan AÌ±naai','Hywan AÌ±pfwon','Hywan AÌ±kitat','Hywan AÌ±tyirin','Hywan AÌ±ninai','Hywan AÌ±kumviriyin','Hywan Swak','Hywan Swak B\'aÌ±yrnig','Hywan Swak B\'aÌ±hwa','Lad','Lin','Tal','Lar','Lam','Jum','Asa','Ladi','Lintani','Talata','Larba','Lamit','Juma','Asabar'),(192,'kaj','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(193,'kam',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mwei wa mbee','Mwei wa keli','Mwei wa katatu','Mwei wa kanne','Mwei wa katano','Mwei wa thanthatu','Mwei wa muonza','Mwei wa nyanya','Mwei wa kenda','Mwei wa ikumi','Mwei wa ikumi na imwe','Mwei wa ikumi na ili',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mwei wa mbee','Mwei wa keli','Mwei wa katatu','Mwei wa kanne','Mwei wa katano','Mwei wa thanthatu','Mwei wa muonza','Mwei wa nyanya','Mwei wa kenda','Mwei wa ikumi','Mwei wa ikumi na imwe','Mwei wa ikumi na ili','Jpl','Jtt','Jnn','Jtn','Alh','Ijm','Jms','Jumapili','Jumatatu','Jumanne','Jumatano','Alamisi','Ijumaa','Jumamosi'),(194,'kam','KE','KES','KSh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(195,'kcg',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Juw','Swi','Tsa','Nya','Tsw','Ata','Ana','Ari','Aku','Swa','Man','Mas',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Zwat Juwung','Zwat Swiyang','Zwat Tsat','Zwat Nyai','Zwat Tswon','Zwat Ataah','Zwat Anatat','Zwat Arinai','Zwat Akubunyung','Zwat Swag','Zwat Mangjuwang','Zwat Swag-Ma-Suyang','Lad','Tan','Tal','Lar','Lam','Jum','Asa','Ladi','Tanii','Talata','Larba','Lamit','Juma','Asabat'),(196,'kcg','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(197,'kfo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Wey','Fan','Tat','Nan','Tuy','Tso','Taf','War','Kun','Ban','Kom','Sau',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Fai Weyene','Fai Fani','Fai Tataka','Fai Nangra','Fai Tuyo','Fai Tsoyi','Fai Tafaka','Fai Warachi','Fai Kunobok','Fai Bansok','Fai Kom','Fai Sauk','Lah','Kub','Gba','Tan','Yei','Koy','Sat','Lahadi','Je-Kubacha','Je-Gbai','Tansati','Je-Yei','Je-Koye','Sati'),(198,'kfo','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(199,'kk',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy \'Ð¶.\'','d MMMM yyyy \'Ð¶.\'','dd.MM.yyyy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,'Ò›Ð°Ò£.','Ð°Ò›Ð¿.','Ð½Ð°Ñƒ.','ÑÓ™Ñƒ.','Ð¼Ð°Ð¼.','Ð¼Ð°Ñƒ.','ÑˆÑ–Ð».','Ñ‚Ð°Ð¼.','Ò›Ñ‹Ñ€.','Ò›Ð°Ð·.','Ò›Ð°Ñ€.','Ð¶ÐµÐ»Ñ‚.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ò›Ð°Ò£Ñ‚Ð°Ñ€','Ð°Ò›Ð¿Ð°Ð½','Ð½Ð°ÑƒÑ€Ñ‹Ð·','ÑÓ™ÑƒÑ–Ñ€','Ð¼Ð°Ð¼Ñ‹Ñ€','Ð¼Ð°ÑƒÑÑ‹Ð¼','ÑˆÑ–Ð»Ð´Ðµ','Ñ‚Ð°Ð¼Ñ‹Ð·','Ò›Ñ‹Ñ€ÐºÒ¯Ð¹ÐµÐº','Ò›Ð°Ð·Ð°Ð½','Ò›Ð°Ñ€Ð°ÑˆÐ°','Ð¶ÐµÐ»Ñ‚Ð¾Ò›ÑÐ°Ð½','Ð¶Ñ.','Ð´Ñ.','ÑÑ.','ÑÑ€.','Ð±Ñ.','Ð¶Ð¼.','ÑÒ».','Ð¶ÐµÐºÑÐµÐ½Ñ–','Ð´ÑƒÐ¹ÑÐµÐ½Ð±Ñ–','ÑÐµÐ¹ÑÐµÐ½Ð±Ñ–','ÑÓ™Ñ€ÐµÐ½Ð±Ñ–','Ð±ÐµÐ¹ÑÐµÐ½Ð±Ñ–','Ð¶Ò±Ð¼Ð°','ÑÐµÐ½Ð±Ñ–'),(200,'kk','KZ','KZT','Ñ‚Ò£Ð³.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤;-Â¤ #,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(201,'kl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januari','februari','martsi','aprili','maji','juni','juli','augustusi','septemberi','oktoberi','novemberi','decemberi','sab','ata','mar','pin','sis','tal','arf','sabaat','ataasinngorneq','marlunngorneq','pingasunngorneq','sisamanngorneq','tallimanngorneq','arfininngorneq'),(202,'kl','GL','DKK','kr',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤ -#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(203,'km',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H\' áž˜áŸ‰áŸ„áž„ \'m\' áž“áž¶áž‘áž¸ \'ss\' ážœáž·áž“áž¶áž‘áž¸â€‹\' z','H\' áž˜áŸ‰áŸ„áž„ \'m\' áž“áž¶áž‘áž¸ \'ss\' ážœáž·áž“áž¶áž‘áž¸â€‹\'','H:mm:ss','H:mm','EEEE\' ážáŸ’áž„áŸƒ \'d\' ážáŸ‚ \'MMMM\' áž†áŸ’áž“áž¶áŸ† \' yyyy','EEEE\' ážáŸ’áž„áŸƒ \'d\' ážáŸ‚ \'MMMM\' áž†áŸ’áž“áž¶áŸ† \' yyyy','d MMMM yyyy','d/M/yyyy','{1}, {0}','áž–áŸ’ážšáž¹áž€','áž›áŸ’áž„áž¶áž…',NULL,NULL,NULL,'áŸ¡','áŸ¢','áŸ£','áŸ¤','áŸ¥','áŸ¦','áŸ§','áŸ¨','áŸ©','áŸ¡áŸ ','áŸ¡áŸ¡','áŸ¡áŸ¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áž˜áž€ážšáž¶','áž€áž»áž˜áŸ’áž—áŸˆ','áž˜áž·áž“áž¶','áž˜áŸážŸáž¶','áž§ážŸáž—áž¶','áž˜áž·ážáž»áž“áž¶','áž€áž€áŸ’áž€ážŠáž¶','ážŸáž¸áž áž¶','áž€áž‰áŸ’áž‰áž¶','ážáž»áž›áž¶','ážœáž·áž…áŸ’áž†áž·áž€áž¶','áž’áŸ’áž“áž¼','áž¢áž¶','áž…','áž¢','áž–áž»','áž–áŸ’ážš','ážŸáž»','ážŸ','ážáŸ’áž„áŸƒáž¢áž¶áž‘áž·ážáŸ’áž™','â€‹ážáŸ’áž„áŸƒáž…áŸáž“áŸ’áž‘','ážáŸ’áž„áŸƒáž¢áž„áŸ’áž‚áž¶ážš','ážáŸ’áž„áŸƒáž–áž»áž’','ážáŸ’áž„áŸƒáž–áŸ’ážšáž ážŸáŸ’áž”ážáž·áŸ','ážáŸ’áž„áŸƒážŸáž»áž€áŸ’ážš','ážáŸ’áž„áŸƒážŸáŸ…ážšáŸ'),(204,'km','KH','KHR','áŸ›',NULL,NULL,NULL,NULL,NULL,'#,##0.00Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(205,'kn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à²ªà³‚à²°à³à²µà²¾à²¹à³à²¨','à²…à²ªà²°à²¾à²¹à³à²¨',NULL,NULL,NULL,'à²œà²¨à²µà²°à³€','à²«à³†à²¬à³à²°à²µà²°à³€','à²®à²¾à²°à³à²šà³','à²Žà²ªà³à²°à²¿à²²à³','à²®à³†','à²œà³‚à²¨à³','à²œà³à²²à³ˆ','à²†à²—à²¸à³à²Ÿà³','à²¸à²ªà³à²Ÿà³†à²‚à²¬à²°à³','à²…à²•à³à²Ÿà³‹à²¬à²°à³','à²¨à²µà³†à²‚à²¬à²°à³','à²¡à²¿à²¸à³†à²‚à²¬à²°à³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à²œà²¨à²µà²°à³€','à²«à³†à²¬à³à²°à²µà²°à³€','à²®à²¾à²°à³à²šà³','à²Žà²ªà³à²°à²¿à²²à³','à²®à³†','à²œà³‚à²¨à³','à²œà³à²²à³ˆ','à²†à²—à²¸à³à²Ÿà³','à²¸à²ªà³à²Ÿà³†à²‚à²¬à²°à³','à²…à²•à³à²Ÿà³‹à²¬à²°à³','à²¨à²µà³†à²‚à²¬à²°à³','à²¡à²¿à²¸à³†à²‚à²¬à²°à³','à²°.','à²¸à³‹.','à²®à²‚.','à²¬à³.','à²—à³.','à²¶à³.','à²¶à²¨à²¿.','à²°à²µà²¿à²µà²¾à²°','à²¸à³‹à²®à²µà²¾à²°','à²®à²‚à²—à²³à²µà²¾à²°','à²¬à³à²§à²µà²¾à²°','à²—à³à²°à³à²µà²¾à²°','à²¶à³à²•à³à²°à²µà²¾à²°','à²¶à²¨à²¿à²µà²¾à²°'),(206,'kn','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(207,'ko',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a hh\'ì‹œ\' mm\'ë¶„\' ss\'ì´ˆ\' z','a hh\'ì‹œ\' mm\'ë¶„\' ss\'ì´ˆ\'','a hh\'ì‹œ\' mm\'ë¶„\'','a hh\'ì‹œ\' mm\'ë¶„\'','yyyy\'ë…„\' M\'ì›”\' d\'ì¼\' EEEE','yyyy\'ë…„\' M\'ì›”\' d\'ì¼\'','yyyy. MM. dd','yy. MM. dd',NULL,'ì˜¤ì „','ì˜¤í›„',NULL,NULL,NULL,'1ì›”','2ì›”','3ì›”','4ì›”','5ì›”','6ì›”','7ì›”','8ì›”','9ì›”','10ì›”','11ì›”','12ì›”',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1ì›”','2ì›”','3ì›”','4ì›”','5ì›”','6ì›”','7ì›”','8ì›”','9ì›”','10ì›”','11ì›”','12ì›”','ì¼','ì›”','í™”','ìˆ˜','ëª©','ê¸ˆ','í† ','ì¼ìš”ì¼','ì›”ìš”ì¼','í™”ìš”ì¼','ìˆ˜ìš”ì¼','ëª©ìš”ì¼','ê¸ˆìš”ì¼','í† ìš”ì¼'),(208,'ko','KR','KRW','ï¿¦','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,'a h:mm:ss','a h:mm',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(209,'kok',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤®.à¤ªà¥‚.','à¤®.à¤¨à¤‚.',NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥ƒà¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥à¤°à¥à¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°','à¤°à¤µà¤¿','à¤¸à¥‹à¤®','à¤®à¤‚à¤—à¤³','à¤¬à¥à¤§','à¤—à¥à¤°à¥','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤†à¤¦à¤¿à¤¤à¥à¤¯à¤µà¤¾à¤°','à¤¸à¥‹à¤®à¤µà¤¾à¤°','à¤®à¤‚à¤—à¤³à¤¾à¤°','à¤¬à¥à¤§à¤µà¤¾à¤°','à¤—à¥à¤°à¥à¤µà¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°','à¤¶à¤¨à¤¿à¤µà¤¾à¤°'),(210,'kok','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(211,'ku',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'BN','PN',NULL,NULL,NULL,'Ã§il','sib','adr','nÃ®s','gul','hez','tÃ®r',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ã§ile','sibat','adar','nÃ®san','gulan','hezÃ®ran',NULL,NULL,NULL,NULL,NULL,NULL,'yÅŸ','dÅŸ','sÅŸ','Ã§ÅŸ','pÅŸ','Ã®n','ÅŸ','yekÅŸem','duÅŸem','ÅŸÃª','Ã§arÅŸem','pÃªncÅŸem','Ã®n','ÅŸemÃ®'),(212,'ku_Arab',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(213,'ku_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(214,'ku_Latn','IQ','IQD',NULL,'0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(215,'ku_Latn','IR','IRR',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(216,'ku_Latn','SY','SYP',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(217,'ku_Latn','TR','TRY',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(218,'kw',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'Gen','Whe','Mer','Ebr','Me','Efn','Gor','Est','Gwn','Hed','Du','Kev',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mys Genver','Mys Whevrel','Mys Merth','Mys Ebrel','Mys Me','Mys Efan','Mys Gortheren','Mye Est','Mys Gwyngala','Mys Hedra','Mys Du','Mys Kevardhu','Sul','Lun','Mth','Mhr','Yow','Gwe','Sad','De Sul','De Lun','De Merth','De Merher','De Yow','De Gwener','De Sadorn'),(219,'kw','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,'HH:mm:ss',NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(220,'ky',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(221,'ky','KG','KGS','ÑÐ¾Ð¼',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(222,'ln',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'s1','s2','s3','s4','s5','s6','s7','s8','s9','s10','s11','s12',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sÃ¡nzÃ¡ ya yambo','sÃ¡nzÃ¡ ya mÃ­balÃ©','sÃ¡nzÃ¡ ya mÃ­sÃ¡to','sÃ¡nzÃ¡ ya mÃ­nÃ©i','sÃ¡nzÃ¡ ya mÃ­tÃ¡no','sÃ¡nzÃ¡ ya motÃ³bÃ¡','sÃ¡nzÃ¡ ya nsambo','sÃ¡nzÃ¡ ya mwambe','sÃ¡nzÃ¡ ya libwa','sÃ¡nzÃ¡ ya zÃ³mÃ­','sÃ¡nzÃ¡ ya zÃ³mÃ­ na mÉ”ÌŒkÉ”Ì','sÃ¡nzÃ¡ ya zÃ³mÃ­ na mÃ­balÃ©','eye','m1','m2','m3','m4','m5','mps','eyenga','mokÉ”lÉ” ya libosÃ³','mokÉ”lÉ” ya mÃ­balÃ©','mokÉ”lÉ” ya mÃ­sÃ¡to','mokÉ”lÉ” ya mÃ­nÃ©i','mokÉ”lÉ” ya mÃ­tÃ¡no','mpÉ”ÌsÉ”'),(223,'ln','CD','CDF','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(224,'ln','CG','XAF',NULL,'0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(225,'lo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H\'à»‚àº¡àº‡ \'m\'àº™àº²àº—àºµ \'ss\' àº§àº´àº™àº²àº—àºµ','H\' à»‚àº¡àº‡ \'m\'àº™àº²àº—àºµ\'','H:mm:ss','H:mm','EEEE\'àº—àºµ  \'d MMMM G yyyy','d MMMM yyyy','d MMM yyyy','d/M/yyyy','{1}, {0}','àºà»ˆàº­àº™àº—à»ˆàº½àº‡','àº«àº¥àº±àº‡àº—à»ˆàº½àº‡',NULL,NULL,NULL,'àº¡.àº.','àº.àºž.','àº¡àºµ.àº™.','àº¡.àºª..','àºž.àºž.','àº¡àº´.àº–.','àº.àº¥.','àºª.àº«.','àº.àº.','àº•.àº¥.','àºž.àºˆ.','àº—.àº§.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'àº¡àº±àº‡àºàº­àº™','àºàº¸àº¡àºžàº²','àº¡àºµàº™àº²','à»€àº¡àºªàº²','àºžàº¶àº”àºªàº°àºžàº²','àº¡àº´àº–àº¸àº™àº²','àºà»àº¥àº°àºàº»àº”','àºªàº´àº‡àº«àº²','àºàº±àº™àºàº²','àº•àº¸àº¥àº²','àºžàº°àºˆàº´àº','àº—àº±àº™àº§àº²','àº­àº².','àºˆ.','àº­.','àºž.','àºžàº«.','àºªàº.','àºª.','àº§àº±àº™àº­àº²àº—àº´àº”','àº§àº±àº™àºˆàº±àº™','àº§àº±àº™àº­àº±àº‡àº„àº²àº™','àº§àº±àº™àºžàº¸àº”','àº§àº±àº™àºžàº°àº«àº±àº”','àº§àº±àº™àºªàº¸àº','àº§àº±àº™à»€àºªàº»àº²'),(226,'lo','LA','LAK','â‚­',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(227,'lt',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yyyy \'m.\' MMMM d \'d.\',EEEE','yyyy \'m.\' MMMM d \'d.\'','yyyy.MM.dd','yyyy-MM-dd',NULL,'prieÅ¡piet','popiet',NULL,NULL,NULL,'Sau','Vas','Kov','Bal','Geg','Bir','Lie','Rgp','Rgs','Spl','Lap','Grd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sausio','vasario','kovo','balandÅ¾io','geguÅ¾Ä—s','birÅ¾elio','liepos','rugpjÅ«Äio','rugsÄ—jo','spalio','lapkriÄio','gruodÅ¾io','Sk','Pr','An','Tr','Kt','Pn','Å t','sekmadienis','pirmadienis','antradienis','treÄiadienis','ketvirtadienis','penktadienis','Å¡eÅ¡tadienis'),(228,'lt','LT','LTL','Lt',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(229,'lv',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, yyyy\'. gada \'d. MMMM','yyyy\'. gada \'d. MMMM','yyyy.d.M','yy.d.M',NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Mai','JÅ«n','JÅ«l','Aug','Sep','Okt','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janvÄris','februÄris','marts','aprÄ«lis','maijs','jÅ«nijs','jÅ«lijs','augusts','septembris','oktobris','novembris','decembris','Sv','P','O','T','C','Pk','S','svÄ“tdiena','pirmdiena','otrdiena','treÅ¡diena','ceturtdiena','piektdiena','sestdiena'),(230,'lv','LV','LVL','Ls',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(231,'mk',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, dd MMMM yyyy','dd MMMM yyyy','dd.M.yyyy','dd.M.yy',NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½.','Ñ„ÐµÐ².','Ð¼Ð°Ñ€.','Ð°Ð¿Ñ€.','Ð¼Ð°Ñ˜.','Ñ˜ÑƒÐ½.','Ñ˜ÑƒÐ».','Ð°Ð²Ð³.','ÑÐµÐ¿Ñ‚.','Ð¾ÐºÑ‚.','Ð½Ð¾ÐµÐ¼.','Ð´ÐµÐºÐµÐ¼.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½ÑƒÐ°Ñ€Ð¸','Ñ„ÐµÐ²Ñ€ÑƒÐ°Ñ€Ð¸','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€Ð¸Ð»','Ð¼Ð°Ñ˜','Ñ˜ÑƒÐ½Ð¸','Ñ˜ÑƒÐ»Ð¸','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ¿Ñ‚ÐµÐ¼Ð²Ñ€Ð¸','Ð¾ÐºÑ‚Ð¾Ð¼Ð²Ñ€Ð¸','Ð½Ð¾ÐµÐ¼Ð²Ñ€Ð¸','Ð´ÐµÐºÐµÐ¼Ð²Ñ€Ð¸','Ð½ÐµÐ´.','Ð¿Ð¾Ð½.','Ð²Ñ‚.','ÑÑ€Ðµ.','Ñ‡ÐµÑ‚.','Ð¿ÐµÑ‚.','ÑÐ°Ð±.','Ð½ÐµÐ´ÐµÐ»Ð°','Ð¿Ð¾Ð½ÐµÐ´ÐµÐ»Ð½Ð¸Ðº','Ð²Ñ‚Ð¾Ñ€Ð½Ð¸Ðº','ÑÑ€ÐµÐ´Ð°','Ñ‡ÐµÑ‚Ð²Ñ€Ñ‚Ð¾Ðº','Ð¿ÐµÑ‚Ð¾Ðº','ÑÐ°Ð±Ð¾Ñ‚Ð°'),(232,'mk','MK','MKD','MDen',NULL,NULL,NULL,NULL,'#,##0.###;(#,##0.###)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(233,'ml',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à´°à´¾à´µà´¿à´²àµ†','à´µàµˆà´•àµ',NULL,NULL,NULL,'à´œà´¨àµ','à´«à´¿à´¬àµ','à´®à´¾à´±àµà´…','à´à´ªàµà´±à´¿à´²àµà´…','à´®àµ†à´¯àµ','à´œàµ‚à´£àµà´…','à´œàµ‚àµˆà´²','à´†à´—','à´¸àµ†à´ªàµà´¤à´‚','à´’à´•àµà´Ÿ','à´¨à´µà´‚','à´¡à´¿à´¸à´‚',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à´œà´¨àµà´µà´°à´¿','à´«à´¿à´¬àµà´±à´µà´°à´¿','à´®à´¾à´±àµà´…à´šàµà´…à´šàµ','à´à´ªàµà´±à´¿à´²àµà´…','à´®àµ†à´¯àµ','à´œàµ‚à´£àµà´…','à´œàµ‚àµˆà´²','à´†à´—à´¸àµà´¤àµà´…','à´¸àµ†à´ªàµà´¤à´‚à´¬à´±àµà´…','à´’à´•àµà´Ÿàµˆà´¬à´±àµà´…','à´¨à´µà´‚à´¬à´±àµà´…','à´¡à´¿à´¸à´‚à´¬à´±àµà´…','à´žà´¾','à´¤à´¿','à´šàµŠ','à´¬àµ','à´µàµà´¯','à´µàµ†','à´¶','à´žà´¾à´¯à´±àµà´…','à´¤à´¿à´™àµà´•à´³àµà´…','à´šàµŠà´µàµà´µ','à´¬àµà´¨à´­àµà´…','à´µàµà´¯à´¾à´´à´‚','à´µàµ†à´³àµà´³à´¿','à´¶à´¨à´¿'),(234,'ml','IN','INR','â‚¨',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(235,'mn',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ…ÑƒÐ»','Ò¯Ñ…Ñ','Ð±Ð°Ñ€','Ñ‚ÑƒÑƒ','Ð»ÑƒÑƒ','Ð¼Ð¾Ð³','Ð¼Ð¾Ñ€','Ñ…Ð¾Ð½','Ð±Ð¸Ñ‡','Ñ‚Ð°Ñ…','Ð½Ð¾Ñ…','Ð³Ð°Ñ…',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¥ÑƒÐ»Ð³Ð°Ð½Ð°','Ò®Ñ…ÑÑ€','Ð‘Ð°Ñ€','Ð¢ÑƒÑƒÐ»Ð°Ð¹','Ð›ÑƒÑƒ','ÐœÐ¾Ð³Ð¾Ð¹','ÐœÐ¾Ñ€ÑŒ','Ð¥Ð¾Ð½ÑŒ','Ð‘Ð¸Ñ‡','Ð¢Ð°Ñ…Ð¸Ð°','ÐÐ¾Ñ…Ð¾Ð¹','Ð“Ð°Ñ…Ð°Ð¹','ÐÑ','Ð”Ð°','ÐœÑ','Ð›Ñ…','ÐŸÒ¯','Ð‘Ð°','Ð‘Ñ','Ð½ÑÐ¼','Ð´Ð°Ð²Ð°Ð°','Ð¼ÑÐ³Ð¼Ð°Ñ€','Ð»Ñ…Ð°Ð³Ð²Ð°','Ð¿Ò¯Ñ€ÑÐ²','Ð±Ð°Ð°ÑÐ°Ð½','Ð±ÑÐ¼Ð±Ð°'),(236,'mn','MN','MNT','â‚®',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(237,'mr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤®.à¤ªà¥‚.','à¤®.à¤¨à¤‚.',NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥ƒà¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥ƒà¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°','à¤°à¤µà¤¿','à¤¸à¥‹à¤®','à¤®à¤‚à¤—à¤³','à¤¬à¥à¤§','à¤—à¥à¤°à¥','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤°à¤µà¤¿à¤µà¤¾à¤°','à¤¸à¥‹à¤®à¤µà¤¾à¤°','à¤®à¤‚à¤—à¤³à¤µà¤¾à¤°','à¤¬à¥à¤§à¤µà¤¾à¤°','à¤—à¥à¤°à¥à¤µà¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°','à¤¶à¤¨à¤¿à¤µà¤¾à¤°'),(238,'mr','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(239,'ms',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mac','Apr','Mei','Jun','Jul','Ogos','Sep','Okt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januari','Februari','Mac','April','Mei','Jun','Julai','Ogos','September','Oktober','November','Disember','Ahd','Isn','Sel','Rab','Kha','Jum','Sab','Ahad','Isnin','Selasa','Rabu','Khamis','Jumaat','Sabtu'),(240,'ms','BN','BND','$',NULL,NULL,',','.',NULL,NULL,NULL,NULL,'h:mm:ss aa','H:mm:ss','H:mm:ss','H:mm:ss','dd MMMM yyyy','dd MMMM yyyy','dd/MM/yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(241,'ms','MY','MYR','RM',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm','EEEE dd MMM yyyy','dd MMMM yyyy','dd MMMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(242,'mt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d \'taâ€™\' MMMM yyyy','d \'taâ€™\' MMMM yyyy','dd MMM yyyy','dd/MM/yyyy',NULL,'QN','WN',NULL,NULL,NULL,'Jan','Fra','Mar','Apr','Mej','Ä un','Lul','Awi','Set','Ott','Nov','DiÄ‹',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jannar','Frar','Marzu','April','Mejju','Ä unju','Lulju','Awissu','Settembru','Ottubru','Novembru','DiÄ‹embru','Ä¦ad','Tne','Tli','Erb','Ä¦am','Ä im','Sib','Il-Ä¦add','It-Tnejn','It-Tlieta','L-ErbgÄ§a','Il-Ä¦amis','Il-Ä imgÄ§a','Is-Sibt'),(243,'mt','MT','MTL','Lm',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(244,'nb',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'\'kl. \'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE d. MMMM yyyy','d. MMMM yyyy','d. MMM. yyyy','dd.MM.yy',NULL,'formiddag','ettermiddag',NULL,NULL,NULL,'jan.','feb.','mars','april','mai','juni','juli','aug.','sep.','okt.','nov.','des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mars','april','mai','juni','juli','august','september','oktober','november','desember','sÃ¸.','ma.','ti.','on.','to.','fr.','lÃ¸.','sÃ¸ndag','mandag','tirsdag','onsdag','torsdag','fredag','lÃ¸rdag'),(245,'nb','NO','NOK','kr',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(246,'ne',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤ªà¥‚à¤°à¥à¤µà¤¾à¤¨à¥à¤¹','à¤…à¤ªà¤°à¤¾à¤¨à¥à¤¹',NULL,NULL,NULL,'à¤œà¤¨','à¤«à¥‡à¤¬','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¤¿','à¤®à¥‡','à¤œà¥à¤¨','à¤œà¥à¤²à¤¾','à¤…à¤—','à¤¸à¥‡à¤ªà¥à¤Ÿ','à¤…à¤•à¥à¤Ÿà¥‹','à¤¨à¥‹à¤­à¥‡','à¤¡à¤¿à¤¸à¥‡',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¨à¤µà¤°à¥€','à¤«à¥‡à¤¬à¥à¤°à¥à¤…à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥à¤¨','à¤œà¥à¤²à¤¾à¤ˆ','à¤…à¤—à¤¸à¥à¤¤','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤®à¥à¤¬à¤°','à¤…à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤­à¥‡à¤®à¥à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤®à¥à¤¬à¤°','à¤†à¤‡à¤¤','à¤¸à¥‹à¤®','à¤®à¤™à¥à¤—à¤²','à¤¬à¥à¤§','à¤¬à¤¿à¤¹à¥€','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤†à¤‡à¤¤à¤¬à¤¾à¤°','à¤¸à¥‹à¤®à¤¬à¤¾à¤°','à¤®à¤™à¥à¤—à¤²à¤¬à¤¾à¤°','à¤¬à¥à¤§à¤¬à¤¾à¤°','à¤¬à¤¿à¤¹à¥€à¤¬à¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤¬à¤¾à¤°','à¤¶à¤¨à¤¿à¤¬à¤¾à¤°'),(247,'ne','NP','NPR','à¤°à¥‚',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(248,'nl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'HH:mm:ss v',NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mrt','apr','mei','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januari','februari','maart','april','mei','juni','juli','augustus','september','oktober','november','december','zo','ma','di','wo','do','vr','za','zondag','maandag','dinsdag','woensdag','donderdag','vrijdag','zaterdag'),(249,'nl','BE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'d-MMM-yy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(250,'nl','NL','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'Â¤ #,##0.00;Â¤ #,##0.00-',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(251,'nn',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'\'kl. \'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE d. MMMM yyyy','d. MMMM yyyy','d. MMM. yyyy','dd.MM.yy',NULL,'formiddag','ettermiddag',NULL,NULL,NULL,'jan.','feb.','mars','april','mai','juni','juli','aug.','sep.','okt.','nov.','des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mars','april','mai','juni','juli','august','september','oktober','november','desember','sÃ¸.','mÃ¥.','ty.','on.','to.','fr.','la.','sÃ¸ndag','mÃ¥ndag','tysdag','onsdag','torsdag','fredag','laurdag'),(252,'nn','NO','NOK','kr',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(253,'nr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mat','Apr','Mey','Jun','Jul','Arh','Sep','Okt','Usi','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janabari','uFeberbari','uMatjhi','u-Apreli','Meyi','Juni','Julayi','Arhostosi','Septemba','Oktoba','Usinyikhaba','Disemba','Son','Mvu','Bil','Tha','Ne','Hla','Gqi','uSonto','uMvulo','uLesibili','Lesithathu','uLesine','ngoLesihlanu','umGqibelo'),(254,'nr','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(255,'nso',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mat','Apo','Mei','Jun','Jul','Ago','Set','Okt','Nof','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janaware','Feberware','MatÅ¡he','Aporele','Mei','June','Julae','Agostose','Setemere','Oktobore','Nofemere','Disemere','Son','Mos','Bed','Rar','Ne','Hla','Mok','Sontaga','Mosupalogo','Labobedi','Laboraro','Labone','Labohlano','Mokibelo'),(256,'nso','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(257,'ny',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mal','Epu','Mei','Jun','Jul','Oga','Sep','Oku','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januwale','Febuluwale','Malichi','Epulo','Mei','Juni','Julai','Ogasiti','Seputemba','Okutoba','Novemba','Disemba','Mul','Lem','Wir','Tat','Nai','San','Wer','Lamulungu','Lolemba','Lachiwiri','Lachitatu','Lachinayi','Lachisanu','Loweruka'),(258,'ny','MW','MWK','K',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(259,'om',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ama','Gur','Bit','Elb','Cam','Wax','Ado','Hag','Ful','Onk','Sad','Mud',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Amajjii','Guraandhala','Bitooteessa','Elba','Caamsa','Waxabajjii','Adooleessa','Hagayya','Fuulbana','Onkololeessa','Sadaasa','Muddee','Dil','Wix','Qib','Rob','Kam','Jim','San','Dilbata','Wiixata','Qibxata','Roobii','Kamiisa','Jimaata','Sanbata'),(260,'om','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM d, yyyy','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,'WD','WB',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(261,'om','KE','KES','Ksh',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM d, yyyy','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,'WD','WB',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(262,'or',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¬œà¬¾à¬¨à­à¬†à¬°à­€','à¬«à­‡à¬¬à­à¬°à­à­Ÿà¬¾à¬°à­€','à¬®à¬¾à¬°à­à¬šà­à¬š','à¬…à¬ªà­à¬°à­‡à¬²','à¬®à­‡','à¬œà­à¬¨','à¬œà­à¬²à¬¾à¬‡','à¬…à¬—à¬·à­à¬Ÿ','à¬¸à­‡à¬ªà­à¬Ÿà­‡à¬®à­à¬¬à¬°','à¬…à¬•à­à¬Ÿà­‹à¬¬à¬°','à¬¨à¬­à­‡à¬®à­à¬¬à¬°','à¬¡à¬¿à¬¸à­‡à¬®à­à¬¬à¬°','à¬°à¬¬à¬¿','à¬¸à­‹à¬®','à¬®à¬™à­à¬—à¬³','à¬¬à­à¬§','à¬—à­à¬°à­','à¬¶à­à¬•à­à¬°','à¬¶à¬¨à¬¿','à¬°à¬¬à¬¿à¬¬à¬¾à¬°','à¬¸à­‹à¬®à¬¬à¬¾à¬°','à¬®à¬™à­à¬—à¬³à¬¬à¬¾à¬°','à¬¬à­à¬§à¬¬à¬¾à¬°','à¬—à­à¬°à­à¬¬à¬¾à¬°','à¬¶à­à¬•à­à¬°à¬¬à¬¾à¬°','à¬¶à¬¨à¬¿à¬¬à¬¾à¬°'),(263,'or','IN','INR','â‚¨',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(264,'pa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¨¸à¨µà©‡à¨°à©‡','à¨¸à¨¼à¨¾à¨®',NULL,NULL,NULL,'à¨œà¨¨à¨µà¨°à©€','à¨«à¨¼à¨°à¨µà¨°à©€','à¨®à¨¾à¨°à¨š','à¨…à¨ªà©à¨°à©ˆà¨²','à¨®à¨ˆ','à¨œà©‚à¨¨','à¨œà©à¨²à¨¾à¨ˆ','à¨…à¨—à¨¸à¨¤','à¨¸à¨¤à©°à¨¬à¨°','à¨…à¨•à¨¤à©‚à¨¬à¨°','à¨¨à¨µà©°à¨¬à¨°','à¨¦à¨¸à©°à¨¬à¨°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¨œà¨¨à¨µà¨°à©€','à¨«à¨¼à¨°à¨µà¨°à©€','à¨®à¨¾à¨°à¨š','à¨…à¨ªà©à¨°à©ˆà¨²','à¨®à¨ˆ','à¨œà©‚à¨¨','à¨œà©à¨²à¨¾à¨ˆ','à¨…à¨—à¨¸à¨¤','à¨¸à¨¤à©°à¨¬à¨°','à¨…à¨•à¨¤à©‚à¨¬à¨°','à¨¨à¨µà©°à¨¬à¨°','à¨¦à¨¸à©°à¨¬à¨°','à¨à¨¤.','à¨¸à©‹à¨®.','à¨®à©°à¨—à¨².','à¨¬à©à©±à¨§.','à¨µà©€à¨°.','à¨¸à¨¼à©à©±à¨•à¨°.','à¨¸à¨¼à¨¨à¨¿à©±à¨šà¨°.','à¨à¨¤à¨µà¨¾à¨°','à¨¸à©‹à¨®à¨µà¨¾à¨°','à¨®à©°à¨—à¨²à¨µà¨¾à¨°','à¨¬à©à©±à¨§à¨µà¨¾à¨°','à¨µà©€à¨°à¨µà¨¾à¨°','à¨¸à¨¼à©à©±à¨•à¨°à¨µà¨¾à¨°','à¨¸à¨¼à¨¨à¨¿à©±à¨šà¨°à¨µà¨¾à¨°'),(265,'pa_Arab',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÛŒ','ÙØ±ÙˆØ±ÛŒ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…Ø¦','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§Ø¦ÛŒ','Ø§Ú¯Ø³Øª','Ø³ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§ØªÙˆØ§Ø±','Ù¾ÛŒØ±','Ù…Ù†Ú¯Ù„','Ø¨ÙØ¯Ú¾','Ø¬Ù…Ø¹Ø±Ø§Øª','Ø¬Ù…Ø¹Û','ÛÙØªÛ'),(266,'pa_Arab','PK','PKR','Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(267,'pa_Guru',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(268,'pa_Guru','IN','INR','â‚¨',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(269,'pl',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','yyyy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,'st','lut','mrz','kw','maj','cz','lip','sier','wrz','paÅº','lis','gr','s','l','m','k','m','c','l','s','w','p','l','g','stycznia','lutego','marca','kwietnia','maja','czerwca','lipca','sierpnia','wrzeÅ›nia','paÅºdziernika','listopada','grudnia','niedz.','pon.','wt.','Å›r.','czw.','pt.','sob.','niedziela','poniedziaÅ‚ek','wtorek','Å›roda','czwartek','piÄ…tek','sobota'),(270,'pl','PL','PLN','zÅ‚',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sty',NULL,'mar','kwi',NULL,'cze',NULL,'sie',NULL,NULL,NULL,'gru',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(271,'ps',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H:mm:ss (z)','H:mm:ss (z)','H:mm:ss','H:mm','EEEE Ø¯ yyyy Ø¯ MMMM d','Ø¯ yyyy Ø¯ MMMM d','d MMMM yyyy','yyyy/M/d',NULL,'Øº.Ù….','Øº.Ùˆ.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ù…Ù€ÛŒ','Ø¬ÙˆÙ†',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÙŠ','ÙØ¨Ø±ÙˆØ±ÙŠ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§ÛŒ','Ø§Ú«Ø³Øª','Ø³Ù¾ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡'),(272,'ps','AF','AFN','Ø‹',NULL,NULL,'Ù«','Ù¬',NULL,'#,##0.00 Â¤','Ùª','âˆ’',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(273,'pt',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'HH\'H\'mm\'m\'ss\'s\' z',NULL,NULL,NULL,'EEEE, d\' de \'MMMM\' de \'yyyy','d\' de \'MMMM\' de \'yyyy','d/MMM/yyyy','dd-MM-yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janeiro','fevereiro','marÃ§o','abril','maio','junho','julho','agosto','setembro','outubro','novembro','dezembro','dom','seg','ter','qua','qui','sex','sÃ¡b','domingo','segunda-feira','terÃ§a-feira','quarta-feira','quinta-feira','sexta-feira','sÃ¡bado'),(274,'pt','BR','BRL','R$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH\'h\'mm\'min\'ss\'s\' z','H\'h\'m\'min\'s\'s\' z',NULL,NULL,NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(275,'pt','PT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yyyy/MM/dd','yy/MM/dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(276,'ro',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'d MMMM yyyy','d MMMM yyyy','dd.MM.yyyy','dd.MM.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'Ian','Feb','Mar','Apr','Mai','Iun','Iul','Aug','Sep','Oct','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ianuarie','februarie','martie','aprilie','mai','iunie','iulie','august','septembrie','octombrie','noiembrie','decembrie','D','L','Ma','Mi','J','V','S','duminicÄƒ','luni','marÈ›i','miercuri','joi','vineri','sÃ®mbÄƒtÄƒ'),(277,'ro','RO','RON',NULL,NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(278,'root',NULL,NULL,NULL,NULL,NULL,'.',',','#,##0.###','Â¤ #,##0.00','%','-','HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, yyyy MMMM dd','yyyy MMMM d','yyyy MMM d','yy/MM/dd','{1} {0}','AM','PM',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1','2','3','4','5','6','7','8','9','10','11','12','1','2','3','4','5','6','7','1','2','3','4','5','6','7'),(279,'ru',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00Â¤',NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','d MMMM yyyy\\u00a0\'Ð³.\'','d MMMM yyyy\\u00a0\'Ð³.\'','dd.MM.yyyy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,'ÑÐ½Ð².','Ñ„ÐµÐ²Ñ€.','Ð¼Ð°Ñ€Ñ‚Ð°','Ð°Ð¿Ñ€.','Ð¼Ð°Ñ','Ð¸ÑŽÐ½Ñ','Ð¸ÑŽÐ»Ñ','Ð°Ð²Ð³.','ÑÐµÐ½Ñ‚.','Ð¾ÐºÑ‚.','Ð½Ð¾ÑÐ±.','Ð´ÐµÐº.','Ð¯','Ð¤','Ðœ','Ð','Ðœ','Ð˜','Ð˜','Ð','Ð¡','Ðž','Ð','Ð”','ÑÐ½Ð²Ð°Ñ€Ñ','Ñ„ÐµÐ²Ñ€Ð°Ð»Ñ','Ð¼Ð°Ñ€Ñ‚Ð°','Ð°Ð¿Ñ€ÐµÐ»Ñ','Ð¼Ð°Ñ','Ð¸ÑŽÐ½Ñ','Ð¸ÑŽÐ»Ñ','Ð°Ð²Ð³ÑƒÑÑ‚Ð°','ÑÐµÐ½Ñ‚ÑÐ±Ñ€Ñ','Ð¾ÐºÑ‚ÑÐ±Ñ€Ñ','Ð½Ð¾ÑÐ±Ñ€Ñ','Ð´ÐµÐºÐ°Ð±Ñ€Ñ','Ð’Ñ','ÐŸÐ½','Ð’Ñ‚','Ð¡Ñ€','Ð§Ñ‚','ÐŸÑ‚','Ð¡Ð±','Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ','Ð¿Ð¾Ð½ÐµÐ´ÐµÐ»ÑŒÐ½Ð¸Ðº','Ð²Ñ‚Ð¾Ñ€Ð½Ð¸Ðº','ÑÑ€ÐµÐ´Ð°','Ñ‡ÐµÑ‚Ð²ÐµÑ€Ð³','Ð¿ÑÑ‚Ð½Ð¸Ñ†Ð°','ÑÑƒÐ±Ð±Ð¾Ñ‚Ð°'),(280,'ru','RU','RUB','Ñ€ÑƒÐ±.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(281,'ru','UA','UAH','Ð³Ñ€Ð½.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, d MMMM yyyy \'Ð³.\'','d MMMM yyyy','d MMM yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(282,'rw',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'mut.','gas.','wer.','mat.','gic.','kam.','nya.','kan.','nze.','ukw.','ugu.','uku.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mutarama','Gashyantare','Werurwe','Mata','Gicuransi','Kamena','Nyakanga','Kanama','Nzeli','Ukwakira','Ugushyingo','Ukuboza','cyu.','mbe.','kab.','gtu.','kan.','gnu.','gnd.','Ku cyumweru','Kuwa mbere','Kuwa kabiri','Kuwa gatatu','Kuwa kane','Kuwa gatanu','Kuwa gatandatu'),(283,'rw','RW','RWF','F','0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(284,'sa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤#,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(285,'sa','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(286,'se',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,'#,##0.00Â Â¤',NULL,'âˆ’',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'tsiengele','goevte','njoktje','voerhtje','suehpede','ruffie','snaltje','mietske','skierede','rihkede','rahka','goeve',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'aejlege','mÃ¥anta','dÃ¤jsta','gaskevahkoe','dÃ¥arsta','bearjadahke','laavadahke'),(287,'se','NO','NOK','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'oÄ‘Ä‘j','guov','njuk','cuo','mies','geas','suoi','borg','ÄakÄ','golg','skÃ¡b','juov',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'oÄ‘Ä‘ajagemÃ¡nnu','guovvamÃ¡nnu','njukÄamÃ¡nnu','cuoÅ‹omÃ¡nnu','miessemÃ¡nnu','geassemÃ¡nnu','suoidnemÃ¡nnu','borgemÃ¡nnu','ÄakÄamÃ¡nnu','golggotmÃ¡nnu','skÃ¡bmamÃ¡nnu','juovlamÃ¡nnu','sotn','vuos','maÅ‹','gask','duor','bear','lÃ¡v','sotnabeaivi','vuossÃ¡rga','maÅ‹Å‹ebÃ¡rga','gaskavahkku','duorasdat','bearjadat','lÃ¡vvardat'),(288,'sh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(289,'sh','BA','BAM',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(290,'sh','CS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(291,'sh','YU',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(292,'sid',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM dd, yyyy','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,'soodo','hawwaro',NULL,NULL,NULL,'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'January','February','March','April','May','June','July','August','September','October','November','December','Sam','San','Mak','Row','Ham','Arb','Qid','Sambata','Sanyo','Maakisanyo','Roowe','Hamuse','Arbe','Qidaame'),(293,'sid','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(294,'sk',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, d. MMMM yyyy','d. MMMM yyyy','d.M.yyyy','d.M.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','mÃ¡j','jÃºn','jÃºl','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januÃ¡r','februÃ¡r','marec','aprÃ­l','mÃ¡j','jÃºn','jÃºl','august','september','oktÃ³ber','november','december','Ne','Po','Ut','St','Å t','Pi','So','NedeÄ¾a','Pondelok','Utorok','Streda','Å tvrtok','Piatok','Sobota'),(295,'sk','SK','SKK','Sk',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(296,'sl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, dd. MMMM yyyy','dd. MMMM yyyy','d.M.yyyy','d.M.yy',NULL,'dop.','pop.',NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','avg','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','marec','april','maj','junij','julij','avgust','september','oktober','november','december','ned','pon','tor','sre','Äet','pet','sob','nedelja','ponedeljek','torek','sreda','Äetrtek','petek','sobota'),(297,'sl','SI','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(298,'so',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM dd, yyyy','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,'sn','gn',NULL,NULL,NULL,'Kob','Lab','Sad','Afr','Sha','Lix','Tod','Sid','Sag','Tob','KIT','LIT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Bisha Koobaad','Bisha Labaad','Bisha Saddexaad','Bisha Afraad','Bisha Shanaad','Bisha Lixaad','Bisha Todobaad','Bisha Sideedaad','Bisha Sagaalaad','Bisha Tobnaad','Bisha Kow iyo Tobnaad','Bisha Laba iyo Tobnaad','Axa','Isn','Sal','Arb','Kha','Jim','Sab','Axad','Isniin','Salaaso','Arbaco','Khamiis','Jimco','Sabti'),(299,'so','DJ','DJF','$','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(300,'so','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(301,'so','KE','KES','Ksh',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(302,'so','SO','SOS','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(303,'sq',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'h.mm.ss.a z','h.mm.ss.a z','h:mm:ss.a','h.mm.a','EEEE, dd MMMM yyyy','dd MMMM yyyy','yyyy-MM-dd','yy-MM-dd',NULL,'PD','MD',NULL,NULL,NULL,'Jan','Shk','Mar','Pri','Maj','Qer','Kor','Gsh','Sht','Tet','NÃ«n','Dhj',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janar','shkurt','mars','prill','maj','qershor','korrik','gusht','shtator','tetor','nÃ«ntor','dhjetor','Die','HÃ«n','Mar','MÃ«r','Enj','Pre','Sht','e diel','e hÃ«nÃ«','e martÃ«','e mÃ«rkurÃ«','e enjte','e premte','e shtunÃ«'),(304,'sq','AL','ALL','Lek',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(305,'sr',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE, dd.MMMM.yyyy.','dd.MM.yyyy.','dd.MM.yyyy.','d.M.yy.',NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½','Ñ„ÐµÐ±','Ð¼Ð°Ñ€','Ð°Ð¿Ñ€','Ð¼Ð°Ñ˜','Ñ˜ÑƒÐ½','Ñ˜ÑƒÐ»','Ð°Ð²Ð³','ÑÐµÐ¿','Ð¾ÐºÑ‚','Ð½Ð¾Ð²','Ð´ÐµÑ†',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½ÑƒÐ°Ñ€','Ñ„ÐµÐ±Ñ€ÑƒÐ°Ñ€','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€Ð¸Ð»','Ð¼Ð°Ñ˜','Ñ˜ÑƒÐ½','Ñ˜ÑƒÐ»','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ¿Ñ‚ÐµÐ¼Ð±Ð°Ñ€','Ð¾ÐºÑ‚Ð¾Ð±Ð°Ñ€','Ð½Ð¾Ð²ÐµÐ¼Ð±Ð°Ñ€','Ð´ÐµÑ†ÐµÐ¼Ð±Ð°Ñ€','Ð½ÐµÐ´','Ð¿Ð¾Ð½','ÑƒÑ‚Ð¾','ÑÑ€Ðµ','Ñ‡ÐµÑ‚','Ð¿ÐµÑ‚','ÑÑƒÐ±','Ð½ÐµÐ´ÐµÑ™Ð°','Ð¿Ð¾Ð½ÐµÐ´ÐµÑ™Ð°Ðº','ÑƒÑ‚Ð¾Ñ€Ð°Ðº','ÑÑ€ÐµÐ´Ð°','Ñ‡ÐµÑ‚Ð²Ñ€Ñ‚Ð°Ðº','Ð¿ÐµÑ‚Ð°Ðº','ÑÑƒÐ±Ð¾Ñ‚Ð°'),(306,'sr_Cyrl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(307,'sr_Cyrl','BA','BAM','ÐšÐœ.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 ÐºÐ¼',NULL,NULL,'HH \'Ñ‡Ð°ÑÐ¾Ð²Ð°\', mm \'Ð¼Ð¸Ð½ÑƒÑ‚Ð°\', ss\' ÑÐµÐºÑƒÐ½Ð´Ð¸\'',NULL,'HH:mm:ss','HH:mm','EEEE, dd. MMMM yyyy.','dd. MMMM yyyy.','yyyy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜ÑƒÐ½Ð¸','Ñ˜ÑƒÐ»Ð¸',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ€Ð¸',NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ€Ð¸Ñ˜ÐµÐ´Ð°',NULL,NULL,NULL),(308,'sr_Cyrl','CS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(309,'sr_Cyrl','YU',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(310,'sr_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, dd. MMMM yyyy.','EEEE, d.MM.yyyy.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','avg','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mart','april','maj','jun','jul','avgust','septembar','oktobar','novembar','decembar','ned','pon','uto','sre','Äet','pet','sub','nedelja','ponedeljak','utorak','sreda','Äetvrtak','petak','subota'),(311,'sr_Latn','BA','BAM','KM.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 km',NULL,NULL,'HH \'Äasova\', mm \'minuta\', ss \'sekundi\'',NULL,'HH:mm:ss','HH:mm',NULL,'dd. MMMM yyyy.','yyyy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'juni','juli',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sri',NULL,NULL,NULL,NULL,NULL,NULL,'srijeda',NULL,NULL,NULL),(312,'sr_Latn','CS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(313,'sr_Latn','RS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(314,'sr_Latn','ME','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(315,'sr_Latn','YU',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(316,'ss',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Bhi','Van','Vol','Mab','Nkh','Nhl','Kho','Ngc','Nyo','Mph','Lwe','Ngo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Bhimbidvwane','iNdlovana','iNdlovu-lenkhulu','Mabasa','iNkhwekhweti','iNhlaba','Kholwane','iNgci','iNyoni','iMphala','Lweti','iNgongoni','Son','Mso','Bil','Tsa','Ne','Hla','Mgc','Lisontfo','uMsombuluko','Lesibili','Lesitsatfu','Lesine','Lesihlanu','uMgcibelo'),(317,'ss','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(318,'st',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Phe','Kol','Ube','Mme','Mot','Jan','Upu','Pha','Leo','Mph','Pun','Tsh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Phesekgong','Hlakola','Hlakubele','Mmese','Motsheanong','Phupjane','Phupu','Phata','Leotshe','Mphalane','Pundungwane','Tshitwe','Son','Mma','Bed','Rar','Ne','Hla','Moq','Sontaha','Mmantaha','Labobedi','Laboraru','Labone','Labohlane','Moqebelo'),(319,'st','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(320,'sv',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00 Â¤',NULL,'âˆ’','\'kl. \'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE\'en den\' d MMMM yyyy','EEEE d MMM yyyy','d MMM yyyy','yyyy-MM-dd',NULL,'fm','em',NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januari','februari','mars','april','maj','juni','juli','augusti','september','oktober','november','december','sÃ¶n','mÃ¥n','tis','ons','tors','fre','lÃ¶r','sÃ¶ndag','mÃ¥ndag','tisdag','onsdag','torsdag','fredag','lÃ¶rdag'),(321,'sv','FI','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(322,'sv','SE','SEK','kr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEE d MMM yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(323,'sw',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Mei','Jun','Jul','Ago','Sep','Okt','Nov','Des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januari','Februari','Machi','Aprili','Mei','Juni','Julai','Agosti','Septemba','Oktoba','Novemba','Desemba','Jpi','Jtt','Jnn','Jtn','Alh','Iju','Jmo','Jumapili','Jumatatu','Jumanne','Jumatano','Alhamisi','Ijumaa','Jumamosi'),(324,'sw','KE','KES','KSh',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(325,'sw','TZ','TZS','TSh',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(326,'syr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÜÜŸÜ¢Â ÜÜ’','Ü«Ü’Ü›','ÜÜ•Üª','Ü¢ÜÜ£Ü¢','ÜÜÜª','ÜšÜ™ÜÜªÜ¢','Ü¬Ü¡Ü˜Ü™','ÜÜ’','ÜÜÜ Ü˜Ü ','ÜÜ¬Ü«Â ÜÜ','ÜÜ¬Ü«Â ÜÜ’','ÜÜŸÜ¢Â ÜÜ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(327,'syr','SY','SYP','Ù„.Ø³.â€',NULL,NULL,NULL,NULL,'#,##0.###;#,##0.###-','Â¤ #,##0.00;Â¤ #,##0.00-',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss','h:mm','dd MMMM, yyyy','dd MMMM, yyyy','dd/MM/yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(328,'ta',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à®•à®¾à®²à¯ˆ','à®®à®¾à®²à¯ˆ',NULL,NULL,NULL,'à®œà®©.','à®ªà®¿à®ªà¯.','à®®à®¾à®°à¯.','à®à®ªà¯.','à®®à¯‡','à®œà¯‚à®©à¯','à®œà¯‚à®²à¯ˆ','à®†à®•.','à®šà¯†à®ªà¯.','à®…à®•à¯.','à®¨à®µ.','à®Ÿà®¿à®š.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à®œà®©à®µà®°à®¿','à®ªà®¿à®ªà¯à®°à®µà®°à®¿','à®®à®¾à®°à¯à®šà¯','à®à®ªà¯à®°à®²à¯','à®®à¯‡','à®œà¯‚à®©à¯','à®œà¯‚à®²à¯ˆ','à®†à®•à®¸à¯à®Ÿà¯','à®šà¯†à®ªà¯à®Ÿà®®à¯à®ªà®°à¯','à®…à®•à¯à®Ÿà¯‹à®ªà®°à¯','à®¨à®µà®®à¯à®ªà®°à¯','à®Ÿà®¿à®šà®®à¯à®ªà®°à¯','à®žà®¾','à®¤à®¿','à®šà¯†','à®ªà¯','à®µà®¿','à®µà¯†','à®š','à®žà®¾à®¯à®¿à®±à¯','à®¤à®¿à®™à¯à®•à®³à¯','à®šà¯†à®µà¯à®µà®¾à®¯à¯','à®ªà¯à®¤à®©à¯','à®µà®¿à®¯à®¾à®´à®©à¯','à®µà¯†à®³à¯à®³à®¿','à®šà®©à®¿'),(329,'ta','IN','INR','à®°à¯‚',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(330,'te',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à°ªà±‚à°°à±à°µà°¾à°¹à±à°¨à°‚','à°…à°ªà°°à°¾à°¹à±à°¨à°‚',NULL,NULL,NULL,'à°œà°¨à°µà°°à°¿','à°«à°¿à°¬à±à°°à°µà°°à°¿','à°®à°¾à°°à±à°šà°¿','à°à°ªà±à°°à°¿à°²à±','à°®à±‡','à°œà±‚à°¨à±','à°œà±‚à°²à±ˆ','à°†à°—à°¸à±à°Ÿà±','à°¸à±†à°ªà±à°Ÿà±†à°‚à°¬à°°à±','à°…à°•à±à°Ÿà±‹à°¬à°°à±','à°¨à°µà°‚à°¬à°°à±','à°¡à°¿à°¸à±†à°‚à°¬à°°à±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à°œà°¨à°µà°°à°¿','à°«à°¿à°¬à±à°°à°µà°°à°¿','à°®à°¾à°°à±à°šà°¿','à°à°ªà±à°°à°¿à°²à±','à°®à±‡','à°œà±‚à°¨à±','à°œà±‚à°²à±ˆ','à°†à°—à°¸à±à°Ÿà±','à°¸à±†à°ªà±à°Ÿà±†à°‚à°¬à°°à±','à°…à°•à±à°Ÿà±‹à°¬à°°à±','à°¨à°µà°‚à°¬à°°à±','à°¡à°¿à°¸à±†à°‚à°¬à°°à±','à°†à°¦à°¿','à°¸à±‹à°®','à°®à°‚à°—à°³','à°¬à±à°§','à°—à±à°°à±','à°¶à±à°•à±à°°','à°¶à°¨à°¿','à°†à°¦à°¿à°µà°¾à°°à°‚','à°¸à±‹à°®à°µà°¾à°°à°‚','à°®à°‚à°—à°³à°µà°¾à°°à°‚','à°¬à±à°§à°µà°¾à°°à°‚','à°—à±à°°à±à°µà°¾à°°à°‚','à°¶à±à°•à±à°°à°µà°¾à°°à°‚','à°¶à°¨à°¿à°µà°¾à°°à°‚'),(331,'te','IN','INR','à°°à±‚.',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(332,'tg',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¿Ðµ. Ñ‡Ð¾.','Ð¿Ð°. Ñ‡Ð¾.',NULL,NULL,NULL,'Ð¯Ð½Ð²','Ð¤ÐµÐ²','ÐœÐ°Ñ€','ÐÐ¿Ñ€','ÐœÐ°Ð¹','Ð˜ÑŽÐ½','Ð˜ÑŽÐ»','ÐÐ²Ð³','Ð¡ÐµÐ½','ÐžÐºÑ‚','ÐÐ¾Ñ','Ð”ÐµÐº',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¯Ð½Ð²Ð°Ñ€','Ð¤ÐµÐ²Ñ€Ð°Ð»','ÐœÐ°Ñ€Ñ‚','ÐÐ¿Ñ€ÐµÐ»','ÐœÐ°Ð¹','Ð˜ÑŽÐ½','Ð˜ÑŽÐ»','ÐÐ²Ð³ÑƒÑÑ‚','Ð¡ÐµÐ½Ñ‚ÑÐ±Ñ€','ÐžÐºÑ‚ÑÐ±Ñ€','ÐÐ¾ÑÐ±Ñ€','Ð”ÐµÐºÐ°Ð±Ñ€','Ð¯ÑˆÐ±','Ð”ÑˆÐ±','Ð¡ÑˆÐ±','Ð§ÑˆÐ±','ÐŸÑˆÐ±','Ò¶Ð¼ÑŠ','Ð¨Ð½Ð±','Ð¯ÐºÑˆÐ°Ð½Ð±Ðµ','Ð”ÑƒÑˆÐ°Ð½Ð±Ðµ','Ð¡ÐµÑˆÐ°Ð½Ð±Ðµ','Ð§Ð¾Ñ€ÑˆÐ°Ð½Ð±Ðµ','ÐŸÐ°Ð½Ò·ÑˆÐ°Ð½Ð±Ðµ','Ò¶ÑƒÐ¼ÑŠÐ°','Ð¨Ð°Ð½Ð±Ðµ'),(333,'tg','TJ','TJS','ÑÐ¾Ð¼',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(334,'th',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H\' à¸™à¸²à¸¬à¸´à¸à¸² \'m\' à¸™à¸²à¸—à¸µ \'ss\' à¸§à¸´à¸™à¸²à¸—à¸µ\'','H\' à¸™à¸²à¸¬à¸´à¸à¸² \'m\' à¸™à¸²à¸—à¸µ\'','H:mm:ss','H:mm','EEEE\'à¸—à¸µà¹ˆ \'d MMMM G yyyy','d MMMM yyyy','d MMM yyyy','d/M/yyyy','{1}, {0}',NULL,NULL,NULL,NULL,NULL,'à¸¡.à¸„.','à¸.à¸ž.','à¸¡à¸µ.à¸„.','à¹€à¸¡.à¸¢.','à¸ž.à¸„.','à¸¡à¸´.à¸¢.','à¸.à¸„.','à¸ª.à¸„.','à¸.à¸¢.','à¸•.à¸„.','à¸ž.à¸¢.','à¸˜.à¸„.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¸¡à¸à¸£à¸²à¸„à¸¡','à¸à¸¸à¸¡à¸ à¸²à¸žà¸±à¸™à¸˜à¹Œ','à¸¡à¸µà¸™à¸²à¸„à¸¡','à¹€à¸¡à¸©à¸²à¸¢à¸™','à¸žà¸¤à¸©à¸ à¸²à¸„à¸¡','à¸¡à¸´à¸–à¸¸à¸™à¸²à¸¢à¸™','à¸à¸£à¸à¸Žà¸²à¸„à¸¡','à¸ªà¸´à¸‡à¸«à¸²à¸„à¸¡','à¸à¸±à¸™à¸¢à¸²à¸¢à¸™','à¸•à¸¸à¸¥à¸²à¸„à¸¡','à¸žà¸¤à¸¨à¸ˆà¸´à¸à¸²à¸¢à¸™','à¸˜à¸±à¸™à¸§à¸²à¸„à¸¡','à¸­à¸².','à¸ˆ.','à¸­.','à¸ž.','à¸žà¸¤.','à¸¨.','à¸ª.','à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œ','à¸ˆà¸±à¸™à¸—à¸£à¹Œ','à¸­à¸±à¸‡à¸„à¸²à¸£','à¸žà¸¸à¸˜','à¸žà¸¤à¸«à¸±à¸ªà¸šà¸”à¸µ','à¸¨à¸¸à¸à¸£à¹Œ','à¹€à¸ªà¸²à¸£à¹Œ'),(335,'th','TH','THB','à¸¿',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(336,'ti',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŠ•áŒ‰áˆ† áˆ°á‹“á‰°','á‹µáˆ•áˆ­ áˆ°á‹“á‰µ',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','áˆ°áŠ•á‰ ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ¨á‰¡á‹•','áŠƒáˆ™áˆµ','á‹“áˆ­á‰¢','á‰€á‹³áˆ','áˆ°áŠ•á‰ á‰µ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ¨á‰¡á‹•','áŠƒáˆ™áˆµ','á‹“áˆ­á‰¢','á‰€á‹³áˆ'),(337,'ti','ER','ERN','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¡ dd MMMM áˆ˜á‹“áˆá‰² yyyy G','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'áŒ¥áˆª','áˆˆáŠ«á‰²','áˆ˜áŒ‹á‰¢','áˆšá‹«á‹','áŒáŠ•á‰¦','áˆ°áŠ','áˆ“áˆáˆˆ','áŠáˆ“áˆ°','áˆ˜áˆµáŠ¨','áŒ¥á‰…áˆ','áˆ•á‹³áˆ­','á‰³áˆ•áˆ³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒ¥áˆª','áˆˆáŠ«á‰²á‰µ','áˆ˜áŒ‹á‰¢á‰µ','áˆšá‹«á‹á‹«','áŒáŠ•á‰¦á‰µ','áˆ°áŠ','áˆ“áˆáˆˆ','áŠáˆ“áˆ°','áˆ˜áˆµáŠ¨áˆ¨áˆ','áŒ¥á‰…áˆá‰²','áˆ•á‹³áˆ­','á‰³áˆ•áˆ³áˆµ',NULL,NULL,'áˆ°áˆ‰áˆµ',NULL,'áˆ“áˆ™áˆµ',NULL,NULL,NULL,NULL,'áˆ°áˆ‰áˆµ',NULL,'áˆ“áˆ™áˆµ',NULL,NULL),(338,'ti','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá£ dd MMMM áˆ˜á‹“áˆá‰² yyyy G','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(339,'tig',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á‰€á‹°áˆ áˆ°áˆ­áˆá‹•áˆ','áˆ“á‰† áˆµáˆ­áˆá‹•áˆ',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','áˆ°/á‹“','áˆ°áŠ–','á‰³áˆ‹áˆ¸','áŠ£áˆ¨áˆ­','áŠ¨áˆšáˆ½','áŒ…áˆá‹“','áˆ°/áŠ•','áˆ°áŠ•á‰ á‰µ á‹“á‰£á‹­','áˆ°áŠ–','á‰³áˆ‹áˆ¸áŠ–','áŠ£áˆ¨áˆ­á‰£á‹“','áŠ¨áˆšáˆ½','áŒ…áˆá‹“á‰µ','áˆ°áŠ•á‰ á‰µ áŠ•áŠ¢áˆ½'),(340,'tig','ER','ERN','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¡ dd MMMM á‹®áˆ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(341,'tn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Fer','Tlh','Mop','Mor','Mot','See','Phu','Pha','Lwe','Dip','Ngw','Sed',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ferikgong','Tlhakole','Mopitlo','Moranang','Motsheganang','Seetebosigo','Phukwi','Phatwe','Lwetse','Diphalane','Ngwanatsele','Sedimonthole','Tsh','Mos','Bed','Rar','Ne','Tla','Mat','Tshipi','Mosopulogo','Labobedi','Laboraro','Labone','Labotlhano','Matlhatso'),(342,'tn','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(343,'tr',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'dd MMMM yyyy EEEE','dd MMMM yyyy EEEE','dd.MMM.yyyy','dd.MM.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'Oca','Åžub','Mar','Nis','May','Haz','Tem','AÄŸu','Eyl','Eki','Kas','Ara',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ocak','Åžubat','Mart','Nisan','MayÄ±s','Haziran','Temmuz','AÄŸustos','EylÃ¼l','Ekim','KasÄ±m','AralÄ±k','Paz','Pzt','Sal','Ã‡ar','Per','Cum','Cmt','Pazar','Pazartesi','SalÄ±','Ã‡arÅŸamba','PerÅŸembe','Cuma','Cumartesi'),(344,'tr','TR','TRY','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(345,'ts',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Sun','Yan','Kul','Dzi','Mud','Kho','Maw','Mha','Ndz','Nhl','Huk','N\'w',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Sunguti','Nyenyenyani','Nyenyankulu','Dzivamisoko','Mudyaxihi','Khotavuxika','Mawuwani','Mhawuri','Ndzhati','Nhlangula','Hukuri','N\'wendzamhala','Son','Mus','Bir','Har','Ne','Tlh','Mug','Sonto','Musumbhunuku','Ravumbirhi','Ravunharhu','Ravumune','Ravuntlhanu','Mugqivela'),(346,'ts','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(347,'tt',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(348,'tt','RU','RUB',NULL,NULL,NULL,NULL,NULL,NULL,'#,##0.00Â¤',NULL,NULL,'h:mm:ss a','H:mm:ss','H:mm:ss','H:mm:ss','d MMMM yyyy','d MMMM yyyy','dd.MM.yyyy','dd.MM.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(349,'uk',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy \'Ñ€.\'','d MMMM yyyy','d MMM yyyy','dd.MM.yy',NULL,'Ð´Ð¿','Ð¿Ð¿',NULL,NULL,NULL,'ÑÑ–Ñ‡.','Ð»ÑŽÑ‚.','Ð±ÐµÑ€.','ÐºÐ²Ñ–Ñ‚.','Ñ‚Ñ€Ð°Ð².','Ñ‡ÐµÑ€Ð².','Ð»Ð¸Ð¿.','ÑÐµÑ€Ð¿.','Ð²ÐµÑ€.','Ð¶Ð¾Ð²Ñ‚.','Ð»Ð¸ÑÑ‚.','Ð³Ñ€ÑƒÐ´.','Ð¡','Ð›','Ð‘','Ðš','Ð¢','Ð§','Ð›','Ð¡','Ð’','Ð–','Ð›','Ð“','ÑÑ–Ñ‡Ð½Ñ','Ð»ÑŽÑ‚Ð¾Ð³Ð¾','Ð±ÐµÑ€ÐµÐ·Ð½Ñ','ÐºÐ²Ñ–Ñ‚Ð½Ñ','Ñ‚Ñ€Ð°Ð²Ð½Ñ','Ñ‡ÐµÑ€Ð²Ð½Ñ','Ð»Ð¸Ð¿Ð½Ñ','ÑÐµÑ€Ð¿Ð½Ñ','Ð²ÐµÑ€ÐµÑÐ½Ñ','Ð¶Ð¾Ð²Ñ‚Ð½Ñ','Ð»Ð¸ÑÑ‚Ð¾Ð¿Ð°Ð´Ð°','Ð³Ñ€ÑƒÐ´Ð½Ñ','ÐÐ´','ÐŸÐ½','Ð’Ñ‚','Ð¡Ñ€','Ð§Ñ‚','ÐŸÑ‚','Ð¡Ð±','ÐÐµÐ´Ñ–Ð»Ñ','ÐŸÐ¾Ð½ÐµÐ´Ñ–Ð»Ð¾Ðº','Ð’Ñ–Ð²Ñ‚Ð¾Ñ€Ð¾Ðº','Ð¡ÐµÑ€ÐµÐ´Ð°','Ð§ÐµÑ‚Ð²ÐµÑ€','ÐŸÊ¼ÑÑ‚Ð½Ð¸Ñ†Ñ','Ð¡ÑƒÐ±Ð¾Ñ‚Ð°'),(350,'uk','UA','UAH','Ð³Ñ€Ð½.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(351,'ur',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(352,'ur','IN','INR','â‚¨',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(353,'ur','PK','PKR','Rs',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(354,'uz',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¯Ð½Ð²','Ð¤ÐµÐ²','ÐœÐ°Ñ€','ÐÐ¿Ñ€','ÐœÐ°Ð¹','Ð˜ÑŽÐ½','Ð˜ÑŽÐ»','ÐÐ²Ð³','Ð¡ÐµÐ½','ÐžÐºÑ‚','ÐÐ¾Ñ','Ð”ÐµÐº',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÐœÑƒÒ³Ð°Ñ€Ñ€Ð°Ð¼','Ð¡Ð°Ñ„Ð°Ñ€','Ð Ð°Ð±Ð¸ÑƒÐ»-Ð°Ð²Ð²Ð°Ð»','Ð Ð°Ð±Ð¸ÑƒÐ»-Ð¾Ñ…Ð¸Ñ€','Ð–ÑƒÐ¼Ð¾Ð´Ð¸ÑƒÐ»-ÑƒÐ»Ð¾','Ð–ÑƒÐ¼Ð¾Ð´Ð¸ÑƒÐ»-ÑƒÑ…Ñ€Ð¾','Ð Ð°Ð¶Ð°Ð±','Ð¨Ð°ÑŠÐ±Ð¾Ð½','Ð Ð°Ð¼Ð°Ð·Ð¾Ð½','Ð¨Ð°Ð²Ð²Ð¾Ð»','Ð—Ð¸Ð»-Ò›Ð°ÑŠÐ´Ð°','Ð—Ð¸Ð»-Ò³Ð¸Ð¶Ð¶Ð°','Ð¯ÐºÑˆ','Ð”ÑƒÑˆ','Ð¡ÐµÑˆ','Ð§Ð¾Ñ€','ÐŸÐ°Ð¹','Ð–ÑƒÐ¼','Ð¨Ð°Ð½','ÑÐºÑˆÐ°Ð½Ð±Ð°','Ð´ÑƒÑˆÐ°Ð½Ð±Ð°','ÑÐµÑˆÐ°Ð½Ð±Ð°','Ñ‡Ð¾Ñ€ÑˆÐ°Ð½Ð±Ð°','Ð¿Ð°Ð¹ÑˆÐ°Ð½Ð±Ð°','Ð¶ÑƒÐ¼Ð°','ÑˆÐ°Ð½Ð±Ð°'),(355,'uz_Arab',NULL,NULL,NULL,NULL,NULL,'Ù«','Ù¬',NULL,'#,##0.00 Â¤','Ùª','âˆ’','H:mm:ss (z)','H:mm:ss (z)','H:mm:ss','H:mm','yyyy Ù†Ú†ÛŒ ÛŒÛŒÙ„ d Ù†Ú†ÛŒ MMMM EEEE Ú©ÙˆÙ†ÛŒ','d Ù†Ú†ÛŒ MMMM yyyy','d MMMM yyyy','yyyy/M/d',NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†Ùˆ','ÙØ¨Ø±','Ù…Ø§Ø±','Ø§Ù¾Ø±','Ù…Ù€ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„','Ø§Ú¯Ø³','Ø³Ù¾Øª','Ø§Ú©Øª','Ù†ÙˆÙ…','Ø¯Ø³Ù…',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÛŒ','ÙØ¨Ø±ÙˆØ±ÛŒ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§ÛŒ','Ø§Ú¯Ø³Øª','Ø³Ù¾ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±','ÛŒ.','Ø¯.','Ø³.','Ú†.','Ù¾.','Ø¬.','Ø´.','ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡'),(356,'uz_Arab','AF','AFN','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(357,'uz_Cyrl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(358,'uz_Cyrl','UZ','UZS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(359,'uz_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Yanv','Fev','Mar','Apr','May','Iyun','Iyul','Avg','Sen','Okt','Noya','Dek',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Muharram','Safar','Rabiul-avval','Rabiul-oxir','Jumodiul-ulo','Jumodiul-uxro','Rajab','ShaÊ¿bon','Ramazon','Shavvol','Zil-qaÊ¿da','Zil-hijja','Yaksh','Dush','Sesh','Chor','Pay','Jum','Shan','yakshanba','dushanba','seshanba','chorshanba','payshanba','juma','shanba'),(360,'uz_Latn','UZ','UZS','soÊ¿m',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(361,'ve',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Pha','Luh','á¹°ha','Lam','Shu','Lwi','Lwa','á¹°ha','Khu','Tsh','á¸¼ar','Nye',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Phando','Luhuhi','á¹°hafamuhwe','Lambamai','Shundunthule','Fulwi','Fulwana','á¹°hangule','Khubvumedzi','Tshimedzi','á¸¼ara','Nyendavhusiku','Swo','Mus','Vhi','Rar','á¹Ša','á¹°an','Mug','Swondaha','Musumbuluwo','á¸¼avhuvhili','á¸¼avhuraru','á¸¼avhuá¹‹a','á¸¼avhuá¹±anu','Mugivhela'),(362,'ve','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(363,'vi',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, \'ngÃ y\' dd MMMM \'nÄƒm\' yyyy','\'NgÃ y\' dd \'thÃ¡ng\' M \'nÄƒm\' yyyy','dd-MM-yyyy','dd/MM/yyyy','{0} {1}','SA','CH',NULL,NULL,NULL,'thg 1','thg 2','thg 3','thg 4','thg 5','thg 6','thg 7','thg 8','thg 9','thg 10','thg 11','thg 12',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'thÃ¡ng má»™t','thÃ¡ng hai','thÃ¡ng ba','thÃ¡ng tÆ°','thÃ¡ng nÄƒm','thÃ¡ng sÃ¡u','thÃ¡ng báº£y','thÃ¡ng tÃ¡m','thÃ¡ng chÃ­n','thÃ¡ng mÆ°á»i','thÃ¡ng mÆ°á»i má»™t','thÃ¡ng mÆ°á»i hai','CN','Th 2','Th 3','Th 4','Th 5','Th 6','Th 7','Chá»§ nháº­t','Thá»© hai','Thá»© ba','Thá»© tÆ°','Thá»© nÄƒm','Thá»© sÃ¡u','Thá»© báº£y'),(364,'vi','VN','VND','Ä‘',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(365,'wal',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áˆ›áˆˆá‹¶','á‰ƒáˆ›',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','á‹ˆáŒ‹','áˆ³á‹­áŠ–','áˆ›á‰†áˆ³','áŠ áˆ©á‹‹','áˆƒáˆ™áˆ³','áŠ áˆ­á‰£','á‰„áˆ«','á‹ˆáŒ‹','áˆ³á‹­áŠ–','áˆ›á‰†áˆ³áŠ›','áŠ áˆ©á‹‹','áˆƒáˆ™áˆ³','áŠ áˆ­á‰£','á‰„áˆ«'),(366,'wal','ET','ETB','$',NULL,NULL,NULL,'á‹ˆ',NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¥ dd MMMM áŒ‹áˆ‹áˆ³ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(367,'xh',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mat','Epr','Mey','Jun','Jul','Aga','Sep','Okt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janyuwari','Februwari','Matshi','Epreli','Meyi','Juni','Julayi','Agasti','Septemba','Okthoba','Novemba','Disemba','Caw','Mvu','Bin','Tha','Sin','Hla','Mgq','Cawe','Mvulo','Lwesibini','Lwesithathu','Lwesine','Lwesihlanu','Mgqibelo'),(368,'xh','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(369,'yo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ARO','ALE',NULL,NULL,NULL,'Sere','Erele','Erena','Igbe','Ebibi','Okudu','Agemo','Ogun','Owewe','Owara','Belu','Ope',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Osukini','Osukeji','Osuketa','Osukerin','Osukarun','Osukefa','Osukeje','Osukejo','Osukesan','Osukewa','Osukokanla','Osukejila','Aiku','Aje','Isegun','Ojoru','Ojobo','Eti','Abameta','Ojoaiku','Ojoaje','Ojoisegun','Ojoru','Ojobo','Ojoeti','Ojoabameta'),(370,'yo','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(371,'zh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ä¸Šåˆ','ä¸‹åˆ',NULL,NULL,NULL,'ä¸€æœˆ','äºŒæœˆ','ä¸‰æœˆ','å››æœˆ','äº”æœˆ','å…­æœˆ','ä¸ƒæœˆ','å…«æœˆ','ä¹æœˆ','åæœˆ','åä¸€æœˆ','åäºŒæœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ä¸€æœˆ','äºŒæœˆ','ä¸‰æœˆ','å››æœˆ','äº”æœˆ','å…­æœˆ','ä¸ƒæœˆ','å…«æœˆ','ä¹æœˆ','åæœˆ','åä¸€æœˆ','åäºŒæœˆ','å‘¨æ—¥','å‘¨ä¸€','å‘¨äºŒ','å‘¨ä¸‰','å‘¨å››','å‘¨äº”','å‘¨å…­','æ˜ŸæœŸæ—¥','æ˜ŸæœŸä¸€','æ˜ŸæœŸäºŒ','æ˜ŸæœŸä¸‰','æ˜ŸæœŸå››','æ˜ŸæœŸäº”','æ˜ŸæœŸå…­'),(372,'zh','CN','CNY','ï¿¥',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(373,'zh_Hans',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(374,'zh_Hans','CN','CNY',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'ahh\'æ—¶\'mm\'åˆ†\'ss\'ç§’\' z','ahh\'æ—¶\'mm\'åˆ†\'ss\'ç§’\'','ahh:mm:ss','ah:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy-M-d','yy-M-d',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(375,'zh_Hans','SG','SGD',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'a hh:mm:ss','a hh:mm:ss','a hh:mm','a hh:mm','dd MMMM yyyy','dd MMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(376,'zh_Hant',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ahh\'æ™‚\'mm\'åˆ†\'ss\'ç§’\' z','ahh\'æ™‚\'mm\'åˆ†\'ss\'ç§’\'','a h:mm:ss','a h:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy/M/d','yyyy/M/d',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(377,'zh_Hant','HK','HKD',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,'ahh:mm:ss','ah:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\' EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yy\'å¹´\'M\'æœˆ\'d\'æ—¥\'',NULL,NULL,NULL,NULL,NULL,NULL,'1æœˆ','2æœˆ','3æœˆ','4æœˆ','5æœˆ','6æœˆ','7æœˆ','8æœˆ','9æœˆ','10æœˆ','11æœˆ','12æœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(378,'zh_Hant','MO','MOP','MOP',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,'ahh:mm:ss','ah:mm','yyyy\'å¹´\'MM\'æœˆ\'dd\'æ—¥\' EEEE','yyyy\'å¹´\'MM\'æœˆ\'dd\'æ—¥\'','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yy\'å¹´\'M\'æœˆ\'d\'æ—¥\'',NULL,NULL,NULL,NULL,NULL,NULL,'1æœˆ','2æœˆ','3æœˆ','4æœˆ','5æœˆ','6æœˆ','7æœˆ','8æœˆ','9æœˆ','10æœˆ','11æœˆ','12æœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(379,'zh_Hant','TW','TWD','',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'é€±æ—¥','é€±ä¸€',NULL,'é€±ä¸‰','é€±å››','é€±äº”','é€±å…­',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(380,'zu',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mas','Apr','Mey','Jun','Jul','Aga','Sep','Okt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januwari','Februwari','Mashi','Apreli','Meyi','Juni','Julayi','Agasti','Septemba','Okthoba','Novemba','Disemba','Son','Mso','Bil','Tha','Sin','Hla','Mgq','Sonto','Msombuluko','Lwesibili','Lwesithathu','Lwesine','Lwesihlanu','Mgqibelo'),(381,'zu','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `locales` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marketplace_sellers`
--

DROP TABLE IF EXISTS `marketplace_sellers`;
CREATE TABLE `marketplace_sellers` (
  `seller_id` smallint(5) unsigned NOT NULL auto_increment,
  `seller_date_registered` int(10) unsigned default NULL,
  `seller_active` tinyint(1) unsigned default '1',
  `seller_api_url` varchar(100) default NULL,
  `seller_api_status` tinyint(3) unsigned default '1',
  `seller_username` varchar(75) default NULL,
  `seller_password` varchar(255) default NULL,
  `client_id` int(8) unsigned default NULL,
  PRIMARY KEY  (`seller_id`),
  KEY `seller_date_registered` (`seller_date_registered`),
  KEY `seller_active` (`seller_active`),
  KEY `seller_api_status` (`seller_api_status`),
  KEY `client_id` (`client_id`)
);

--
-- Dumping data for table `marketplace_sellers`
--

LOCK TABLES `marketplace_sellers` WRITE;
/*!40000 ALTER TABLE `marketplace_sellers` DISABLE KEYS */;
/*!40000 ALTER TABLE `marketplace_sellers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mbapi_log`
--

DROP TABLE IF EXISTS `mbapi_log`;
CREATE TABLE `mbapi_log` (
  `mbapi_log_id` int(10) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `session_id` varchar(40) default NULL,
  `mbapi_input` longtext,
  `mbapi_response` longtext,
  `ip` bigint(20) default NULL,
  `mbapi_status` tinyint(3) unsigned default NULL,
  `mbapi_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`mbapi_log_id`),
  KEY `admin_id` (`admin_id`),
  KEY `session_id` (`session_id`),
  KEY `ip` (`ip`),
  KEY `mbapi_status` (`mbapi_status`)
);

--
-- Dumping data for table `mbapi_log`
--

LOCK TABLES `mbapi_log` WRITE;
/*!40000 ALTER TABLE `mbapi_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `mbapi_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migration_configs`
--

DROP TABLE IF EXISTS `migration_configs`;
CREATE TABLE `migration_configs` (
  `migration_config_id` tinyint(3) unsigned NOT NULL auto_increment,
  `migration_name` varchar(255) default NULL,
  `migration_comment` varchar(255) default NULL,
  `migration_payment_group_id` tinyint(3) unsigned default NULL,
  `migration_order_form_id` smallint(5) unsigned default NULL,
  `migration_product_id` int(10) unsigned default NULL,
  `migration_orphan_product_id` int(10) unsigned default NULL,
  `migration_type` tinyint(3) unsigned default NULL,
  `migration_dbdriver_type` tinyint(3) unsigned default NULL,
  `migration_dbhost` varchar(255) default NULL,
  `migration_dbname` varchar(255) default NULL,
  `migration_dbusername` varchar(255) default NULL,
  `migration_dbpassword` varchar(255) default NULL,
  PRIMARY KEY  (`migration_config_id`)
);

--
-- Dumping data for table `migration_configs`
--

LOCK TABLES `migration_configs` WRITE;
/*!40000 ALTER TABLE `migration_configs` DISABLE KEYS */;
/*!40000 ALTER TABLE `migration_configs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migration_mappings`
--

DROP TABLE IF EXISTS `migration_mappings`;
CREATE TABLE `migration_mappings` (
  `migration_mapping_id` int(10) unsigned NOT NULL auto_increment,
  `migration_config_id` tinyint(3) unsigned default NULL,
  `migration_obj_id` int(10) unsigned default NULL,
  `migration_ext_id` int(10) unsigned default NULL,
  `migration_int_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`migration_mapping_id`),
  KEY `migration_config_id` (`migration_config_id`),
  KEY `migration_obj_id` (`migration_obj_id`),
  KEY `migration_ext_id` (`migration_ext_id`),
  KEY `migration_int_id` (`migration_int_id`)
);

--
-- Dumping data for table `migration_mappings`
--

LOCK TABLES `migration_mappings` WRITE;
/*!40000 ALTER TABLE `migration_mappings` DISABLE KEYS */;
/*!40000 ALTER TABLE `migration_mappings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migration_objs`
--

DROP TABLE IF EXISTS `migration_objs`;
CREATE TABLE `migration_objs` (
  `migration_obj_id` int(10) unsigned NOT NULL auto_increment,
  `migration_config_id` tinyint(3) unsigned default NULL,
  `migration_obj_name` varchar(255) default NULL,
  `migration_ext_seq_id` int(10) unsigned default NULL,
  `migration_ext_obj_name` varchar(100) default NULL,
  `migration_ext_obj_key` varchar(100) default NULL,
  `migration_int_seq_id` int(10) unsigned default NULL,
  `migration_int_obj_name` varchar(100) default NULL,
  `migration_int_obj_key` varchar(100) default NULL,
  PRIMARY KEY  (`migration_obj_id`),
  KEY `migration_obj_name` (`migration_obj_name`),
  KEY `migration_ext_seq_id` (`migration_ext_seq_id`),
  KEY `migration_int_seq_id` (`migration_int_seq_id`),
  KEY `migration_config_id` (`migration_config_id`)
);

--
-- Dumping data for table `migration_objs`
--

LOCK TABLES `migration_objs` WRITE;
/*!40000 ALTER TABLE `migration_objs` DISABLE KEYS */;
/*!40000 ALTER TABLE `migration_objs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migration_options`
--

DROP TABLE IF EXISTS `migration_options`;
CREATE TABLE `migration_options` (
  `migration_option_id` smallint(5) unsigned NOT NULL auto_increment,
  `migration_config_id` tinyint(3) unsigned default NULL,
  `migration_option_name` varchar(255) default NULL,
  `migration_option_value` varchar(255) default NULL,
  PRIMARY KEY  (`migration_option_id`),
  KEY `migration_option_name` (`migration_option_name`),
  KEY `migration_option_value` (`migration_option_value`)
);

--
-- Dumping data for table `migration_options`
--

LOCK TABLES `migration_options` WRITE;
/*!40000 ALTER TABLE `migration_options` DISABLE KEYS */;
/*!40000 ALTER TABLE `migration_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migration_reservations`
--

DROP TABLE IF EXISTS `migration_reservations`;
CREATE TABLE `migration_reservations` (
  `migration_obj_id` int(10) unsigned NOT NULL default '0',
  `migration_ext_id` varchar(255) NOT NULL default '',
  `admin_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`migration_obj_id`,`migration_ext_id`),
  KEY `admin_id` (`admin_id`)
);

--
-- Dumping data for table `migration_reservations`
--

LOCK TABLES `migration_reservations` WRITE;
/*!40000 ALTER TABLE `migration_reservations` DISABLE KEYS */;
/*!40000 ALTER TABLE `migration_reservations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news`
--

DROP TABLE IF EXISTS `news`;
CREATE TABLE `news` (
  `news_id` int(8) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `news_subject` varchar(100) default NULL,
  `news_short_body` text,
  `news_body` text,
  `news_date_created` int(10) unsigned default NULL,
  `priority_id` tinyint(3) unsigned default NULL,
  `news_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`news_id`),
  KEY `admin_id` (`admin_id`),
  KEY `priority_id` (`priority_id`),
  KEY `news_active` (`news_active`)
);

--
-- Dumping data for table `news`
--

LOCK TABLES `news` WRITE;
/*!40000 ALTER TABLE `news` DISABLE KEYS */;
/*!40000 ALTER TABLE `news` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news_client_group_rel`
--

DROP TABLE IF EXISTS `news_client_group_rel`;
CREATE TABLE `news_client_group_rel` (
  `client_group_id` int(8) unsigned NOT NULL default '0',
  `news_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_group_id`,`news_id`)
);

--
-- Dumping data for table `news_client_group_rel`
--

LOCK TABLES `news_client_group_rel` WRITE;
/*!40000 ALTER TABLE `news_client_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `news_client_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news_group_rel`
--

DROP TABLE IF EXISTS `news_group_rel`;
CREATE TABLE `news_group_rel` (
  `news_id` int(8) unsigned NOT NULL default '0',
  `news_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`news_id`,`news_group_id`)
);

--
-- Dumping data for table `news_group_rel`
--

LOCK TABLES `news_group_rel` WRITE;
/*!40000 ALTER TABLE `news_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `news_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news_groups`
--

DROP TABLE IF EXISTS `news_groups`;
CREATE TABLE `news_groups` (
  `news_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `news_group_name` varchar(100) default NULL,
  `news_group_description` varchar(255) default NULL,
  `news_group_active` tinyint(3) unsigned default NULL,
  `news_group_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`news_group_id`),
  KEY `news_group_active` (`news_group_active`),
  KEY `news_group_order` (`news_group_order`)
);

--
-- Dumping data for table `news_groups`
--

LOCK TABLES `news_groups` WRITE;
/*!40000 ALTER TABLE `news_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `news_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_coupon_rel`
--

DROP TABLE IF EXISTS `order_form_coupon_rel`;
CREATE TABLE `order_form_coupon_rel` (
  `order_form_id` smallint(5) unsigned NOT NULL default '0',
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`order_form_id`,`coupon_id`)
);

--
-- Dumping data for table `order_form_coupon_rel`
--

LOCK TABLES `order_form_coupon_rel` WRITE;
/*!40000 ALTER TABLE `order_form_coupon_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_form_coupon_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_items`
--

DROP TABLE IF EXISTS `order_form_items`;
CREATE TABLE `order_form_items` (
  `order_form_item_id` int(10) unsigned NOT NULL auto_increment,
  `order_form_id` smallint(5) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `order_form_item_order` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`order_form_item_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `order_form_item_order` (`order_form_item_order`),
  KEY `product_id` (`product_id`)
) AUTO_INCREMENT=11;

--
-- Dumping data for table `order_form_items`
--

LOCK TABLES `order_form_items` WRITE;
/*!40000 ALTER TABLE `order_form_items` DISABLE KEYS */;
INSERT INTO `order_form_items` VALUES (1,1,1,1),(2,1,2,2),(3,1,3,3),(4,1,4,4),(5,1,6,0),(6,1,7,0),(7,1,8,0),(8,1,9,0),(9,1,10,0),(10,1,11,0);
/*!40000 ALTER TABLE `order_form_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_params`
--

DROP TABLE IF EXISTS `order_form_params`;
CREATE TABLE `order_form_params` (
  `order_form_param_id` int(10) unsigned NOT NULL auto_increment,
  `order_form_id` smallint(5) unsigned default NULL,
  `order_form_param_name` varchar(100) default NULL,
  `order_form_param_value` text,
  `order_form_param_trans_key` varchar(80) default NULL,
  `order_form_param_description` varchar(75) default NULL,
  `order_form_param_input_type` char(1) default NULL,
  `order_form_param_required` tinyint(3) unsigned default NULL,
  `order_form_param_order` smallint(5) unsigned default NULL,
  `order_form_param_locked` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`order_form_param_id`),
  KEY `order_form_id` (`order_form_id`)
) AUTO_INCREMENT=14;

--
-- Dumping data for table `order_form_params`
--

LOCK TABLES `order_form_params` WRITE;
/*!40000 ALTER TABLE `order_form_params` DISABLE KEYS */;
INSERT INTO `order_form_params` VALUES (1,1,'dom_options','a:4:{i:0;s:9:\"dom_whois\";i:1;s:7:\"dom_reg\";i:2;s:12:\"dom_transfer\";i:3;s:12:\"dom_existing\";}','TRANS_ORDER_DOMAIN_OPTIONS','TRANS_ORDER_DOMAIN_OPTIONS_DESC','c',0,2,0),(2,1,'email_banning','1','TRANS_ORDER_EMAIL_BANNING','TRANS_ORDER_EMAIL_BANNING_DESC','r',0,3,0),(3,1,'email_banning_text','TRANS_ORDER_EMAIL_BANNING_MESSAGE','TRANS_ORDER_EMAIL_BANNING_TEXT','TRANS_ORDER_EMAIL_BANNING_TEXT_DESC','a',0,4,0),(4,1,'ip_banning_text','TRANS_ORDER_IP_BANNING_MESSAGE','TRANS_ORDER_IP_BANNING_TEXT','TRANS_ORDER_IP_BANNING_TEXT_DESC','a',0,4,0),(5,1,'payment_type_check','1','TRANS_ORDER_ENABLE_CHECK','TRANS_ORDER_ENABLE_CHECK_DESC','r',0,5,0),(6,1,'payment_type_invoice','1','TRANS_ORDER_ENABLE_INVOICE','TRANS_ORDER_ENABLE_INVOICE_DESC','r',0,6,0),(7,1,'payment_type_draft','1','TRANS_ORDER_ENABLE_BANK_DRAFT','TRANS_ORDER_ENABLE_BANK_DRAFT_DESC','r',0,7,0),(8,1,'username_min_length','6','TRANS_ORDERFORM_MIN_USERNAME','TRANS_ORDERFORM_MIN_USERNAME_DESC','t',0,8,0),(9,1,'username_max_length','15','TRANS_ORDERFORM_MAX_USERNAME','TRANS_ORDERFORM_MAX_USERNAME_DESC','t',0,9,0),(10,1,'password_min_length','6','TRANS_ORDERFORM_MIN_PASSWORD','TRANS_ORDERFORM_MIN_PASSWORD_DESC','t',0,10,0),(11,1,'password_max_length','15','TRANS_ORDERFORM_MAX_PASSWORD','TRANS_ORDERFORM_MAX_PASSWORD_DESC','t',0,11,0),(12,1,'continue_shopping_url','http://localhost/cvs/app-modernbill-order/','TRANS_ORDERFORM_CONTINUE_SHOPPING_URL','TRANS_ORDERFORM_CONTINUE_SHOPPING_URL_DESC','t',0,12,0),(13,1,'terms_url','http://localhost/','TRANS_ORDERFORM_TERMS_URL','TRANS_ORDERFORM_TERMS_URL','t',0,12,0);
/*!40000 ALTER TABLE `order_form_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_values`
--

DROP TABLE IF EXISTS `order_form_values`;
CREATE TABLE `order_form_values` (
  `order_form_value_id` int(10) unsigned NOT NULL auto_increment,
  `order_form_param_id` int(10) unsigned default NULL,
  `order_form_value_name` varchar(25) default NULL,
  `order_form_value_trans_key` varchar(80) default NULL,
  `order_form_value_order` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`order_form_value_id`),
  KEY `order_form_param_id` (`order_form_param_id`),
  KEY `order_form_value_order` (`order_form_value_order`)
) AUTO_INCREMENT=14;

--
-- Dumping data for table `order_form_values`
--

LOCK TABLES `order_form_values` WRITE;
/*!40000 ALTER TABLE `order_form_values` DISABLE KEYS */;
INSERT INTO `order_form_values` VALUES (1,1,'dom_whois','TRANS_ORDER_WHOIS_LOOKUP',0),(2,1,'dom_reg','TRANS_ORDER_DOMAIN_REGISTRATION',1),(3,1,'dom_transfer','TRANS_ORDER_TRANSFER_DOMAIN',2),(4,1,'dom_existing','TRANS_ORDER_EXISTING_DOMAIN',3),(5,1,'dom_skip','TRANS_ORDER_SKIP_DOMAIN',4),(6,2,'1','TRANS_YES',0),(7,2,'0','TRANS_NO',1),(8,5,'1','TRANS_YES',0),(9,5,'0','TRANS_NO',1),(10,6,'1','TRANS_YES',0),(11,6,'0','TRANS_NO',1),(12,7,'1','TRANS_YES',0),(13,7,'0','TRANS_NO',1);
/*!40000 ALTER TABLE `order_form_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_forms`
--

DROP TABLE IF EXISTS `order_forms`;
CREATE TABLE `order_forms` (
  `order_form_id` smallint(5) unsigned NOT NULL auto_increment,
  `order_form_name` varchar(50) default NULL,
  `payment_group_id` tinyint(3) unsigned default NULL,
  `company_id` smallint(5) unsigned default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `order_form_verify_vat` int(1) default NULL,
  `order_form_disable_charging` int(1) default '0',
  PRIMARY KEY  (`order_form_id`),
  KEY `payment_group_id` (`payment_group_id`),
  KEY `company_id` (`company_id`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `order_forms`
--

LOCK TABLES `order_forms` WRITE;
/*!40000 ALTER TABLE `order_forms` DISABLE KEYS */;
INSERT INTO `order_forms` VALUES (1,'OF 1',1,1,21,225,NULL,0);
/*!40000 ALTER TABLE `order_forms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_addon_attributes`
--

DROP TABLE IF EXISTS `package_addon_attributes`;
CREATE TABLE `package_addon_attributes` (
  `package_addon_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `package_addon_id` int(10) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `package_attribute_name` varchar(100) default NULL,
  `package_attribute_value` longtext,
  `package_attribute_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_addon_attribute_id`),
  KEY `package_addon_id` (`package_addon_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `package_attribute_name` (`package_attribute_name`),
  KEY `package_attribute_date_created` (`package_attribute_date_created`),
  KEY `server_group_id` (`server_group_id`)
);

--
-- Dumping data for table `package_addon_attributes`
--

LOCK TABLES `package_addon_attributes` WRITE;
/*!40000 ALTER TABLE `package_addon_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_addon_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_addon_ledger_entries`
--

DROP TABLE IF EXISTS `package_addon_ledger_entries`;
CREATE TABLE `package_addon_ledger_entries` (
  `package_addon_ledger_id` int(10) unsigned NOT NULL auto_increment,
  `package_addon_id` int(10) unsigned default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `journal_type` varchar(20) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `package_addon_ledger_debit` decimal(10,2) unsigned default NULL,
  `package_addon_ledger_credit` decimal(10,2) unsigned default NULL,
  `package_addon_ledger_comment` varchar(255) default NULL,
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`package_addon_ledger_id`),
  KEY `package_addon_id` (`package_addon_id`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `journal_type` (`journal_type`),
  KEY `currency_id` (`currency_id`)
);

--
-- Dumping data for table `package_addon_ledger_entries`
--

LOCK TABLES `package_addon_ledger_entries` WRITE;
/*!40000 ALTER TABLE `package_addon_ledger_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_addon_ledger_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_addons`
--

DROP TABLE IF EXISTS `package_addons`;
CREATE TABLE `package_addons` (
  `package_addon_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `package_addon_display_name` varchar(255) default NULL,
  `package_addon_original_price` decimal(10,2) unsigned default '0.00',
  `package_addon_price` decimal(10,2) unsigned default NULL,
  `package_addon_setup` decimal(10,2) unsigned default NULL,
  `package_addon_discount` decimal(10,2) unsigned default NULL,
  `package_addon_price_lock` tinyint(3) unsigned default NULL,
  `package_addon_discountable` tinyint(1) unsigned default NULL,
  `package_addon_active` tinyint(1) unsigned default NULL,
  `package_addon_product_id` int(10) unsigned default NULL,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  `coupon_num_cycles` smallint(5) unsigned NOT NULL default '0',
  `coupon_price` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  (`package_addon_id`),
  KEY `package_id` (`package_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `package_addon_active` (`package_addon_active`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `package_addon_product_id` (`package_addon_product_id`)
);

--
-- Dumping data for table `package_addons`
--

LOCK TABLES `package_addons` WRITE;
/*!40000 ALTER TABLE `package_addons` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_addons` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_attributes`
--

DROP TABLE IF EXISTS `package_attributes`;
CREATE TABLE `package_attributes` (
  `package_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default '0',
  `config_group_id` int(8) unsigned default NULL,
  `package_attribute_name` varchar(100) default NULL,
  `package_attribute_value` longtext,
  `package_attribute_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_attribute_id`),
  KEY `package_id` (`package_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `package_attribute_name` (`package_attribute_name`),
  KEY `package_attribute_date_created` (`package_attribute_date_created`),
  KEY `server_group_id` (`server_group_id`)
);

--
-- Dumping data for table `package_attributes`
--

LOCK TABLES `package_attributes` WRITE;
/*!40000 ALTER TABLE `package_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_cert_rel`
--

DROP TABLE IF EXISTS `package_cert_rel`;
CREATE TABLE `package_cert_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `cert_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`cert_id`)
);

--
-- Dumping data for table `package_cert_rel`
--

LOCK TABLES `package_cert_rel` WRITE;
/*!40000 ALTER TABLE `package_cert_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_cert_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_certs`
--

DROP TABLE IF EXISTS `package_certs`;
CREATE TABLE `package_certs` (
  `cert_id` int(10) unsigned NOT NULL auto_increment,
  `cert_timestamp` int(10) unsigned default NULL,
  `or_id` varchar(25) default NULL,
  `r_id` int(10) unsigned default NULL,
  `ct_code` varchar(25) default NULL,
  `af_id` varchar(25) default NULL,
  `or_status` tinyint(3) unsigned default NULL,
  `or_startstamp` int(10) unsigned default NULL,
  `or_submitstamp` int(10) unsigned default NULL,
  `or_syncstamp` int(10) unsigned default NULL,
  `or_successcode` char(3) default NULL,
  `or_errorcode` varchar(20) default NULL,
  `or_errormsg` varchar(255) default NULL,
  `or_techSameAsAdmin` varchar(5) default NULL,
  `or_billSameAsPrevious` varchar(5) default NULL,
  `OD_Method` varchar(8) default NULL,
  `OD_ProductCode` varchar(20) default NULL,
  `OD_ValidityPeriod` tinyint(3) unsigned default NULL,
  `OD_ServerCount` tinyint(3) unsigned default NULL,
  `OD_Price` decimal(10,2) default NULL,
  `OD_RenewalBehavior` varchar(8) default NULL,
  `OD_SpecialInstructions` longtext,
  `OD_PartnerOrderID` varchar(50) default NULL,
  `OD_GeoTrustOrderID` int(10) unsigned default NULL,
  `OD_OrderDate` int(10) unsigned default NULL,
  `OD_OrderCompleteDate` int(10) unsigned default NULL,
  `OD_OrderDeactivatedDate` int(10) unsigned default NULL,
  `OD_OrderStatusMajor` varchar(20) default NULL,
  `OD_OrderStatusMinorCode` varchar(20) default NULL,
  `OD_OrderStatusMinorName` varchar(20) default NULL,
  `OD_ApproverNotifiedDate` int(10) unsigned default NULL,
  `OD_ApproverConfirmDate` int(10) unsigned default NULL,
  `OD_ApproverEmailAddress` varchar(255) default NULL,
  `ORG_OrganizationName` varchar(255) default NULL,
  `ORG_DUNS` varchar(50) default NULL,
  `ORG_AddressLine1` varchar(100) default NULL,
  `ORG_AddressLine2` varchar(100) default NULL,
  `ORG_AddressLine3` varchar(100) default NULL,
  `ORG_City` varchar(50) default NULL,
  `ORG_Region` varchar(255) default NULL,
  `ORG_PostalCode` varchar(20) default NULL,
  `ORG_Country` char(2) default NULL,
  `ORG_Phone` varchar(30) default NULL,
  `ORG_Fax` varchar(30) default NULL,
  `AC_FirstName` varchar(100) default NULL,
  `AC_LastName` varchar(100) default NULL,
  `AC_Phone` varchar(30) default NULL,
  `AC_Email` varchar(255) default NULL,
  `TC_FirstName` varchar(100) default NULL,
  `TC_LastName` varchar(100) default NULL,
  `TC_Phone` varchar(30) default NULL,
  `TC_Email` varchar(255) default NULL,
  `BC_FirstName` varchar(100) default NULL,
  `BC_LastName` varchar(100) default NULL,
  `BC_Phone` varchar(30) default NULL,
  `BC_Email` varchar(255) default NULL,
  `CSR_CSR` longtext,
  `CSR_WildCard` varchar(5) default NULL,
  `CSR_Subject` varchar(255) default NULL,
  `CSR_DomainName` varchar(255) default NULL,
  `CSR_Country` char(2) default NULL,
  `CSR_Email` varchar(255) default NULL,
  `CSR_Locality` varchar(255) default NULL,
  `CSR_Organization` varchar(255) default NULL,
  `CSR_OrganizationUnit` varchar(255) default NULL,
  `CSR_State` varchar(100) default NULL,
  `CSR_IsValidDomainName` varchar(5) default NULL,
  `CSR_HasBadExtensions` varchar(5) default NULL,
  `CSR_CommonName` varchar(255) default NULL,
  `CSR_WebServerType` varchar(20) default NULL,
  `CSR_DNSNames` text,
  `CSR_CertificateStatus` varchar(50) default NULL,
  `CSR_StartDate` int(10) unsigned default NULL,
  `CSR_EndDate` int(10) unsigned default NULL,
  `CSR_SerialNumber` varchar(25) default NULL,
  `UPG_CUIndicator` varchar(5) default NULL,
  `UPG_CUCertificate` longtext,
  `UPG_CUmonths` tinyint(3) unsigned default NULL,
  `UPG_CUSerialNumber` varchar(25) default NULL,
  `UPG_CUExpirationDate` int(10) unsigned default NULL,
  `UPG_CUIssuer` varchar(100) default NULL,
  `RI_RenewalIndicator` varchar(5) default NULL,
  `RI_RenewalMonths` tinyint(3) unsigned default NULL,
  `RI_RenewalSerialNumber` varchar(100) default NULL,
  `RI_RenewalExpirationDate` int(10) unsigned default NULL,
  `RI_RenewalOrderID` varchar(50) default NULL,
  `RI_RenewalProductCode` varchar(50) default NULL,
  `FF_CACertType` varchar(10) default NULL,
  `FF_CACert` longtext,
  `FF_ServerCertificate` longtext,
  `FF_IconScript` longtext,
  `FF_ChoicePointURL` varchar(255) default NULL,
  `FF_CpsURL` varchar(255) default NULL,
  `get_approverlist` longtext,
  `get_useragreement` longtext,
  PRIMARY KEY  (`cert_id`),
  KEY `ct_code` (`ct_code`),
  KEY `OD_GeoTrustOrderID` (`OD_GeoTrustOrderID`),
  KEY `OD_PartnerOrderID` (`OD_PartnerOrderID`),
  KEY `or_id` (`or_id`),
  KEY `r_id` (`r_id`),
  KEY `af_id` (`af_id`),
  KEY `or_status` (`or_status`)
);

--
-- Dumping data for table `package_certs`
--

LOCK TABLES `package_certs` WRITE;
/*!40000 ALTER TABLE `package_certs` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_certs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_config_group_rel`
--

DROP TABLE IF EXISTS `package_config_group_rel`;
CREATE TABLE `package_config_group_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `config_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`config_group_id`)
);

--
-- Dumping data for table `package_config_group_rel`
--

LOCK TABLES `package_config_group_rel` WRITE;
/*!40000 ALTER TABLE `package_config_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_config_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_database_rel`
--

DROP TABLE IF EXISTS `package_database_rel`;
CREATE TABLE `package_database_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `package_database_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`package_database_id`)
);

--
-- Dumping data for table `package_database_rel`
--

LOCK TABLES `package_database_rel` WRITE;
/*!40000 ALTER TABLE `package_database_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_database_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_databases`
--

DROP TABLE IF EXISTS `package_databases`;
CREATE TABLE `package_databases` (
  `package_database_id` int(10) unsigned NOT NULL auto_increment,
  `package_database_type` tinyint(3) unsigned default NULL,
  `package_database_name` varchar(75) default NULL,
  `package_database_username` varchar(75) default NULL,
  `package_database_password` varchar(255) default NULL,
  `package_database_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_database_id`)
);

--
-- Dumping data for table `package_databases`
--

LOCK TABLES `package_databases` WRITE;
/*!40000 ALTER TABLE `package_databases` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_databases` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_domain_rel`
--

DROP TABLE IF EXISTS `package_domain_rel`;
CREATE TABLE `package_domain_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `domain_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`domain_id`)
);

--
-- Dumping data for table `package_domain_rel`
--

LOCK TABLES `package_domain_rel` WRITE;
/*!40000 ALTER TABLE `package_domain_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_domain_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_domains`
--

DROP TABLE IF EXISTS `package_domains`;
CREATE TABLE `package_domains` (
  `domain_id` int(10) unsigned NOT NULL auto_increment,
  `domain_sld` varchar(255) default NULL,
  `domain_tld` varchar(255) default NULL,
  `domain_idn_language` char(3) default NULL,
  `domain_active` tinyint(1) unsigned default '1',
  `domain_date_created` int(10) unsigned default NULL,
  `domain_remote_purchase_id` varchar(255) default NULL,
  `domain_remote_domain_id` varchar(255) default NULL,
  `domain_date_expires` int(10) unsigned default NULL,
  `domain_date_last_sync` int(10) unsigned default NULL,
  `registrar_id` smallint(5) unsigned default NULL,
  `domain_renew_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`domain_id`),
  KEY `domain_sld` (`domain_sld`),
  KEY `domain_tld` (`domain_tld`),
  KEY `domain_date_expires` (`domain_date_expires`),
  KEY `registrar_id` (`registrar_id`),
  KEY `domain_remote_purchase_id` (`domain_remote_purchase_id`),
  KEY `domain_remote_domain_id` (`domain_remote_domain_id`),
  KEY `domain_date_last_sync` (`domain_date_last_sync`)
);

--
-- Dumping data for table `package_domains`
--

LOCK TABLES `package_domains` WRITE;
/*!40000 ALTER TABLE `package_domains` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_domains` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_fee_rel`
--

DROP TABLE IF EXISTS `package_fee_rel`;
CREATE TABLE `package_fee_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `package_addon_id` int(10) unsigned NOT NULL default '0',
  `package_fee_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`package_addon_id`,`package_fee_id`)
);

--
-- Dumping data for table `package_fee_rel`
--

LOCK TABLES `package_fee_rel` WRITE;
/*!40000 ALTER TABLE `package_fee_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_fee_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_ledger_entries`
--

DROP TABLE IF EXISTS `package_ledger_entries`;
CREATE TABLE `package_ledger_entries` (
  `package_ledger_id` int(10) NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `package_ledger_num_cycles` smallint(5) unsigned default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `journal_type` varchar(20) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `package_ledger_debit` decimal(10,2) unsigned default NULL,
  `package_ledger_credit` decimal(10,2) unsigned default NULL,
  `package_ledger_comment` varchar(255) default NULL,
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`package_ledger_id`),
  KEY `package_id` (`package_id`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `journal_type` (`journal_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `currency_id` (`currency_id`)
);

--
-- Dumping data for table `package_ledger_entries`
--

LOCK TABLES `package_ledger_entries` WRITE;
/*!40000 ALTER TABLE `package_ledger_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_ledger_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_license_rel`
--

DROP TABLE IF EXISTS `package_license_rel`;
CREATE TABLE `package_license_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `license_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`license_id`)
);

--
-- Dumping data for table `package_license_rel`
--

LOCK TABLES `package_license_rel` WRITE;
/*!40000 ALTER TABLE `package_license_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_license_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_licenses`
--

DROP TABLE IF EXISTS `package_licenses`;
CREATE TABLE `package_licenses` (
  `license_id` int(10) unsigned NOT NULL auto_increment,
  `license_locked` varchar(255) default NULL,
  `license_data` longtext,
  `license_cipher` text,
  `license_key` text,
  `license_date_created` int(10) unsigned default NULL,
  `license_date_last_renewal` int(10) unsigned default NULL,
  `license_date_next_renewal` int(10) unsigned default NULL,
  `license_date_stop_renewal` int(10) unsigned default NULL,
  `license_status` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`license_id`),
  KEY `license_locked` (`license_locked`),
  KEY `license_date_created` (`license_date_created`),
  KEY `license_date_last_renewal` (`license_date_last_renewal`),
  KEY `license_date_next_renewal` (`license_date_next_renewal`),
  KEY `license_date_stop_renewal` (`license_date_stop_renewal`),
  KEY `license_status` (`license_status`)
);

--
-- Dumping data for table `package_licenses`
--

LOCK TABLES `package_licenses` WRITE;
/*!40000 ALTER TABLE `package_licenses` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_licenses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_pop_rel`
--

DROP TABLE IF EXISTS `package_pop_rel`;
CREATE TABLE `package_pop_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `package_pop_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`package_pop_id`)
);

--
-- Dumping data for table `package_pop_rel`
--

LOCK TABLES `package_pop_rel` WRITE;
/*!40000 ALTER TABLE `package_pop_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_pop_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_pops`
--

DROP TABLE IF EXISTS `package_pops`;
CREATE TABLE `package_pops` (
  `package_pop_id` int(10) unsigned NOT NULL auto_increment,
  `package_pop_real_name` varchar(255) default NULL,
  `package_pop_username` varchar(255) default NULL,
  `package_pop_password` varchar(255) default NULL,
  `package_pop_quota` varchar(25) default NULL,
  `package_pop_ftp` tinyint(3) unsigned default NULL,
  `package_pop_telnet` tinyint(3) unsigned default NULL,
  `package_pop_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_pop_id`)
);

--
-- Dumping data for table `package_pops`
--

LOCK TABLES `package_pops` WRITE;
/*!40000 ALTER TABLE `package_pops` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_pops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_usage_log`
--

DROP TABLE IF EXISTS `package_usage_log`;
CREATE TABLE `package_usage_log` (
  `usage_log_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `package_usage` decimal(20,10) unsigned default NULL,
  `usage_log_date_created` int(10) unsigned default NULL,
  `external_id` varchar(255) default NULL,
  `usage_log_date_billed` int(10) unsigned default NULL,
  `interface_id` smallint(5) unsigned default '0',
  `package_usage_type` smallint(5) unsigned default '0',
  `package_usage_record_type` smallint(5) unsigned default '0',
  `package_usage_com_type` smallint(5) unsigned default '0',
  `package_usage_com_brand` smallint(5) unsigned default '0',
  `package_usage_link_date` int(10) unsigned default NULL,
  `package_usage_link_status` smallint(5) unsigned default '0',
  `package_usage_message_duration` int(10) default '-1',
  `package_usage_data_size` int(20) default '-1',
  `package_usage_message_date` int(10) NOT NULL default '-1',
  `package_usage_date_session` int(10) default '-1',
  `package_usage_date_created` int(10) unsigned default NULL,
  `package_usage_date_billed` int(10) unsigned default NULL,
  `groupby_invoice_id` int(10) unsigned default NULL,
  `line_item_id` int(10) unsigned default NULL,
  `package_usage_serial_number` int(10) unsigned default NULL,
  `package_usage_vendor` varchar(10) default '0',
  `package_usage_username` varchar(255) default NULL,
  `package_usage_vessel` varchar(32) default NULL,
  `package_usage_rate` varchar(64) default NULL,
  `package_usage_external_status` char(1) default 'N',
  `package_usage_external_status_error` smallint(1) default '0',
  `package_usage_extra_info_1` varchar(255) default NULL,
  `package_usage_extra_info_2` varchar(255) default NULL,
  `package_usage_extra_info_3` varchar(255) default NULL,
  `package_usage_extra_info_f1` decimal(20,10) default NULL,
  `package_usage_extra_info_f2` decimal(20,10) default NULL,
  `package_usage_extra_info_f3` decimal(20,10) default NULL,
  `package_usage_extra_info_f4` decimal(20,10) default NULL,
  `package_usage_extra_info_f5` decimal(20,10) default NULL,
  `package_usage_extra_info_f6` decimal(20,10) default NULL,
  `package_usage_price` decimal(10,2) unsigned default NULL,
  `package_usage_cost` decimal(10,2) unsigned default NULL,
  PRIMARY KEY  (`usage_log_id`),
  KEY `package_id` (`package_id`),
  KEY `usage_log_date_created` (`usage_log_date_created`),
  KEY `usage_log_date_billed` (`usage_log_date_billed`),
  KEY `config_group_id` (`config_group_id`),
  KEY `groupby_invoice_id` (`groupby_invoice_id`),
  KEY `line_item_id` (`line_item_id`)
);

--
-- Dumping data for table `package_usage_log`
--

LOCK TABLES `package_usage_log` WRITE;
/*!40000 ALTER TABLE `package_usage_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_usage_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_vendor_rel`
--

DROP TABLE IF EXISTS `package_vendor_rel`;
CREATE TABLE `package_vendor_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `vendor_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_package_id` int(10) unsigned NOT NULL default '0',
  `vendor_product_id` int(10) unsigned NOT NULL default '0',
  `vendor_order_form_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_product_variant_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`vendor_id`,`vendor_package_id`,`vendor_product_id`,`vendor_order_form_id`,`vendor_product_variant_id`)
);

--
-- Dumping data for table `package_vendor_rel`
--

LOCK TABLES `package_vendor_rel` WRITE;
/*!40000 ALTER TABLE `package_vendor_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_vendor_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `packages`
--

DROP TABLE IF EXISTS `packages`;
CREATE TABLE `packages` (
  `package_id` int(10) unsigned NOT NULL auto_increment,
  `parent_package_id` int(10) unsigned default NULL,
  `invoice_process_id` varchar(40) default '',
  `invoice_process_date` int(10) unsigned default '0',
  `client_id` int(8) unsigned default '0',
  `client_contact_id` int(8) unsigned default '0',
  `product_id` int(10) unsigned default NULL,
  `product_variant_id` int(8) unsigned default NULL,
  `primary_domain_id` int(10) unsigned default NULL,
  `package_group_id` smallint(5) unsigned default NULL,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `cycle_discount_group_id` smallint(5) unsigned default NULL,
  `invoicing_group_id` smallint(5) unsigned default NULL,
  `package_name` varchar(255) default NULL,
  `package_quantity` int(10) unsigned default '1',
  `package_proratable` tinyint(1) unsigned default NULL,
  `package_invoice_separately` tinyint(1) unsigned default '0',
  `package_discountable` tinyint(1) unsigned default '1',
  `package_date_created` int(10) unsigned default NULL,
  `package_date_begin_renewal` int(10) unsigned default NULL,
  `package_date_last_renewal` int(10) unsigned default NULL,
  `package_date_next_renewal` int(10) unsigned default NULL,
  `package_date_stop_renewal` int(10) unsigned default NULL,
  `package_date_cancelled` int(10) unsigned default NULL,
  `package_pending_cancellation` tinyint(3) unsigned NOT NULL default '0',
  `package_active` tinyint(1) default NULL,
  `package_status` tinyint(3) unsigned default NULL,
  `package_status_reason` varchar(255) default NULL,
  `package_comments` longtext,
  `package_type` tinyint(3) unsigned default NULL,
  `package_original_price` decimal(10,2) unsigned default '0.00',
  `package_price` decimal(10,2) unsigned default '0.00',
  `package_discount` decimal(10,2) unsigned default '0.00',
  `package_setup` decimal(10,2) unsigned default '0.00',
  `package_cost_currency_id` char(3) default NULL,
  `package_cost_amount` decimal(10,2) unsigned default '0.00',
  `package_setup_cost_currency_id` char(3) default NULL,
  `package_setup_cost_amount` decimal(10,2) unsigned default '0.00',
  `package_price_lock` tinyint(3) unsigned default NULL,
  `package_prior_id` int(10) unsigned default NULL,
  `cycle_id` int(8) unsigned default NULL,
  `aff_code` varchar(255) default NULL,
  `aff_date_last_paid` int(10) unsigned default NULL,
  `usage_date_last_renewal` int(10) unsigned default NULL,
  `usage_date_next_renewal` int(10) unsigned default NULL,
  `usage_cycle_id` int(8) unsigned default NULL,
  `usage_calculate_only` tinyint(3) unsigned default NULL,
  `external_id` varchar(255) default NULL,
  `external_id_1` varchar(255) default NULL,
  `external_id_2` varchar(255) default NULL,
  `external_id_3` varchar(255) default NULL,
  `payment_group_id` tinyint(3) unsigned default NULL,
  `coupon_id` int(10) unsigned default NULL,
  `coupon_num_cycles` smallint(5) unsigned default NULL,
  `coupon_price` decimal(10,2) unsigned default '0.00',
  `package_cancellation_type` tinyint(3) unsigned NOT NULL default '0',
  `package_client_permissions` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`package_id`),
  KEY `invoice_process_id` (`invoice_process_id`),
  KEY `invoice_process_date` (`invoice_process_date`),
  KEY `client_id` (`client_id`),
  KEY `product_id` (`product_id`),
  KEY `package_group_id` (`package_group_id`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `invoicing_group_id` (`invoicing_group_id`),
  KEY `package_invoice_separately` (`package_invoice_separately`),
  KEY `package_date_created` (`package_date_created`),
  KEY `package_date_begin_renewal` (`package_date_begin_renewal`),
  KEY `package_date_last_renewal` (`package_date_last_renewal`),
  KEY `package_date_next_renewal` (`package_date_next_renewal`),
  KEY `package_date_stop_renewal` (`package_date_stop_renewal`),
  KEY `package_date_cancelled` (`package_date_cancelled`),
  KEY `package_active` (`package_active`),
  KEY `package_status` (`package_status`),
  KEY `package_type` (`package_type`),
  KEY `cycle_id` (`cycle_id`),
  KEY `usage_date_last_renewal` (`usage_date_last_renewal`),
  KEY `usage_date_next_renewal` (`usage_date_next_renewal`),
  KEY `usage_cycle_id` (`usage_cycle_id`),
  KEY `usage_calculate_only` (`usage_calculate_only`),
  KEY `payment_group_id` (`payment_group_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `cycle_discount_group_id` (`cycle_discount_group_id`)
);

--
-- Dumping data for table `packages`
--

LOCK TABLES `packages` WRITE;
/*!40000 ALTER TABLE `packages` DISABLE KEYS */;
/*!40000 ALTER TABLE `packages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_groups`
--

DROP TABLE IF EXISTS `payment_groups`;
CREATE TABLE `payment_groups` (
  `payment_group_id` tinyint(3) unsigned NOT NULL auto_increment,
  `payment_group_name` varchar(255) default NULL,
  `payment_group_currency_id` char(3) default NULL,
  PRIMARY KEY  (`payment_group_id`),
  KEY `payment_group_currency_id` (`payment_group_currency_id`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `payment_groups`
--

LOCK TABLES `payment_groups` WRITE;
/*!40000 ALTER TABLE `payment_groups` DISABLE KEYS */;
INSERT INTO `payment_groups` VALUES (1,'PG 1','USD');
/*!40000 ALTER TABLE `payment_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_groups_gateway_rel`
--

DROP TABLE IF EXISTS `payment_groups_gateway_rel`;
CREATE TABLE `payment_groups_gateway_rel` (
  `payment_groups_gateway_rel_id` smallint(5) unsigned NOT NULL auto_increment,
  `payment_group_id` tinyint(3) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `gateway_type` tinyint(3) unsigned default '1',
  PRIMARY KEY  (`payment_groups_gateway_rel_id`),
  KEY `payment_group_id` (`payment_group_id`),
  KEY `config_group_id` (`config_group_id`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `payment_groups_gateway_rel`
--

LOCK TABLES `payment_groups_gateway_rel` WRITE;
/*!40000 ALTER TABLE `payment_groups_gateway_rel` DISABLE KEYS */;
INSERT INTO `payment_groups_gateway_rel` VALUES (1,1,76,0);
/*!40000 ALTER TABLE `payment_groups_gateway_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_queue`
--

DROP TABLE IF EXISTS `payment_queue`;
CREATE TABLE `payment_queue` (
  `payment_id` int(10) unsigned NOT NULL auto_increment,
  `payment_process_id` varchar(40) default '',
  `payment_process_date` int(10) unsigned default '0',
  `line_item_id` int(10) unsigned default NULL,
  `groupby_invoice_id` int(10) NOT NULL default '0',
  `payment_description` varchar(100) default NULL,
  `payment_amount` decimal(10,2) default '0.00',
  `billing_account_share_id` int(10) unsigned default NULL,
  `payment_date_created` int(10) unsigned default NULL,
  `payment_date_charged` int(10) NOT NULL default '0',
  PRIMARY KEY  (`payment_id`),
  KEY `payment_process_id` (`payment_process_id`),
  KEY `payment_process_date` (`payment_process_date`),
  KEY `billing_account_share_id` (`billing_account_share_id`),
  KEY `payment_date_charged` (`payment_date_charged`),
  KEY `line_item_id` (`line_item_id`),
  KEY `groupby_invoice_id` (`groupby_invoice_id`)
);

--
-- Dumping data for table `payment_queue`
--

LOCK TABLES `payment_queue` WRITE;
/*!40000 ALTER TABLE `payment_queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ppc_codes`
--

DROP TABLE IF EXISTS `ppc_codes`;
CREATE TABLE `ppc_codes` (
  `code_id` int(10) unsigned NOT NULL auto_increment,
  `code_remote_id` int(10) unsigned default NULL,
  `code_type` tinyint(3) unsigned default NULL,
  `code_to_use` varchar(255) default NULL,
  `code_value` decimal(10,2) unsigned default NULL,
  `code_currency_id` char(3) default NULL,
  `code_date_expires` int(10) unsigned default NULL,
  `code_date_distributed` int(10) unsigned default NULL,
  `code_status` tinyint(3) unsigned default NULL,
  `code_client_id` int(8) unsigned default NULL,
  `code_client_email` varchar(255) default NULL,
  `code_product_id` int(10) unsigned default NULL,
  `code_product_name` varchar(100) default NULL,
  `code_product_price` decimal(10,2) unsigned default NULL,
  PRIMARY KEY  (`code_id`),
  KEY `code_type` (`code_type`),
  KEY `code_currency_id` (`code_currency_id`),
  KEY `code_date_expires` (`code_date_expires`),
  KEY `code_date_distributed` (`code_date_distributed`),
  KEY `code_status` (`code_status`),
  KEY `code_client_id` (`code_client_id`),
  KEY `code_product_id` (`code_product_id`),
  KEY `code_remote_id` (`code_remote_id`)
);

--
-- Dumping data for table `ppc_codes`
--

LOCK TABLES `ppc_codes` WRITE;
/*!40000 ALTER TABLE `ppc_codes` DISABLE KEYS */;
/*!40000 ALTER TABLE `ppc_codes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prepay_discounts`
--

DROP TABLE IF EXISTS `prepay_discounts`;
CREATE TABLE `prepay_discounts` (
  `prepay_discount_id` int(10) unsigned NOT NULL auto_increment,
  `prepay_discount_name` varchar(100) default NULL,
  `prepay_discount_active` tinyint(1) default NULL,
  `cycle_id` int(10) default NULL,
  `prepay_discount_num_cycles` int(5) default NULL,
  `prepay_discount_amount` decimal(10,2) default NULL,
  `prepay_discount_percentage` decimal(10,2) default NULL,
  PRIMARY KEY  (`prepay_discount_id`)
);

--
-- Dumping data for table `prepay_discounts`
--

LOCK TABLES `prepay_discounts` WRITE;
/*!40000 ALTER TABLE `prepay_discounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `prepay_discounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_addon_group_rel`
--

DROP TABLE IF EXISTS `product_addon_group_rel`;
CREATE TABLE `product_addon_group_rel` (
  `product_addon_group_rel_id` smallint(10) unsigned NOT NULL auto_increment,
  `product_addon_group_id` smallint(5) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `default_selected_product_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`product_addon_group_rel_id`)
) AUTO_INCREMENT=7;

--
-- Dumping data for table `product_addon_group_rel`
--

LOCK TABLES `product_addon_group_rel` WRITE;
/*!40000 ALTER TABLE `product_addon_group_rel` DISABLE KEYS */;
INSERT INTO `product_addon_group_rel` VALUES (1,1,2,NULL),(2,1,3,NULL),(3,1,4,NULL),(4,2,2,NULL),(5,2,3,NULL),(6,2,4,NULL);
/*!40000 ALTER TABLE `product_addon_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_addon_groups`
--

DROP TABLE IF EXISTS `product_addon_groups`;
CREATE TABLE `product_addon_groups` (
  `product_addon_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_addon_group_active` tinyint(3) unsigned default NULL,
  `product_addon_group_name` varchar(75) default NULL,
  `product_addon_group_input_type` char(1) default NULL,
  `product_addon_group_none_choice` tinyint(1) default '1',
  PRIMARY KEY  (`product_addon_group_id`),
  KEY `product_addon_group_active` (`product_addon_group_active`)
) AUTO_INCREMENT=3;

--
-- Dumping data for table `product_addon_groups`
--

LOCK TABLES `product_addon_groups` WRITE;
/*!40000 ALTER TABLE `product_addon_groups` DISABLE KEYS */;
INSERT INTO `product_addon_groups` VALUES (1,1,'Would you like additional disk space?','r',1),(2,1,'Would you like additional E-Mail Addresses?','r',1);
/*!40000 ALTER TABLE `product_addon_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_attributes`
--

DROP TABLE IF EXISTS `product_attributes`;
CREATE TABLE `product_attributes` (
  `product_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `product_id` int(10) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default NULL,
  `product_attribute_name` varchar(100) default NULL,
  `product_attribute_value` longtext,
  `product_attribute_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`product_attribute_id`),
  KEY `product_id` (`product_id`),
  KEY `product_attribute_name` (`product_attribute_name`),
  KEY `server_group_id` (`server_group_id`)
) AUTO_INCREMENT=502;

--
-- Dumping data for table `product_attributes`
--

LOCK TABLES `product_attributes` WRITE;
/*!40000 ALTER TABLE `product_attributes` DISABLE KEYS */;
INSERT INTO `product_attributes` VALUES (415,2,1,'ssi','yes',1211556406),(416,2,1,'php','yes',1211556406),(414,2,1,'frontpage','no',1211556406),(412,2,1,'customErrorDocs','yes',1211556406),(413,2,1,'anonymousFTP','no',1211556406),(411,2,1,'mailService','yes',1211556406),(409,2,1,'domainWWW','yes',1211556406),(410,2,1,'ssl','no',1211556406),(408,2,1,'domainUserAllowed','yes',1211556406),(406,2,1,'aclAddPackages','yes',1211556406),(407,2,1,'dns','yes',1211556406),(405,2,1,'clientBackupManager','yes',1211556406),(404,2,1,'clientManageQuota','yes',1211556406),(403,2,1,'clientManageSubdomains','yes',1211556406),(402,2,1,'clientManageNotChrootShell','no',1211556406),(401,2,1,'clientManageSHAccess','no',1211556406),(400,2,1,'clientManageCrontab','yes',1211556406),(398,2,1,'clientManageDNS','yes',1211556406),(399,2,1,'clientManageLog','yes',1211556406),(397,2,1,'clientManageMaillists','yes',1211556406),(396,2,1,'clientManageWebapps','no',1211556406),(394,2,1,'clientChangeLimits','yes',1211556406),(395,2,1,'clientManageAnonFTP','no',1211556406),(393,2,1,'clientManagePhysicalHosting','yes',1211556406),(392,2,1,'clientCreateDomains','yes',1211556406),(391,2,1,'domainMaxMaillists','1',1211556406),(390,2,1,'clientMaxMaillists','1',1211556406),(389,2,1,'domainMaxMailAutoresponders','1',1211556406),(387,2,1,'domainMaxMailGroups','1',1211556406),(388,2,1,'clientMaxMailAutoresponders','1',1211556406),(386,2,1,'clientMaxMailGroups','1',1211556406),(385,2,1,'domainMaxMailredirects','3',1211556406),(384,2,1,'clientMaxMailredirects','3',1211556406),(383,2,1,'domainMailboxQuota','10485760',1211556405),(382,2,1,'clientMailBoxQuota','10485760',1211556405),(381,2,1,'domainMaxMailbox','20',1211556405),(380,2,1,'clientMaxMailbox','20',1211556405),(379,2,1,'domainMaxTomcatWebapps','0',1211556405),(378,2,1,'clientMaxTomcatWebapps','0',1211556405),(377,2,1,'domainMaxMYSQLDB','3',1211556405),(376,2,1,'clientMaxMYSQLDB','3',1211556405),(375,2,1,'domainMaxWebusers','1',1211556405),(374,2,1,'clientMaxWebusers','1',1211556405),(373,2,1,'domainMaxTraffic','21474836480',1211556405),(372,2,1,'clientMaxTraffic','21474836480',1211556405),(371,2,1,'domainDiskSpace','20971520',1211556405),(370,2,1,'clientDiskSpace','20971520',1211556405),(491,3,1,'python','yes',1211556441),(489,3,1,'perl','yes',1211556441),(490,3,1,'asp','yes',1211556441),(487,3,1,'php','yes',1211556441),(488,3,1,'cgi','yes',1211556441),(486,3,1,'ssi','yes',1211556441),(484,3,1,'anonymousFTP','yes',1211556441),(485,3,1,'frontpage','no',1211556441),(483,3,1,'customErrorDocs','yes',1211556441),(481,3,1,'ssl','no',1211556441),(482,3,1,'mailService','yes',1211556441),(479,3,1,'domainUserAllowed','yes',1211556441),(480,3,1,'domainWWW','yes',1211556441),(478,3,1,'dns','yes',1211556441),(477,3,1,'aclAddPackages','yes',1211556441),(475,3,1,'clientManageQuota','yes',1211556441),(476,3,1,'clientBackupManager','yes',1211556441),(474,3,1,'clientManageSubdomains','yes',1211556441),(473,3,1,'clientManageNotChrootShell','yes',1211556441),(472,3,1,'clientManageSHAccess','yes',1211556441),(470,3,1,'clientManageLog','yes',1211556441),(471,3,1,'clientManageCrontab','yes',1211556441),(469,3,1,'clientManageDNS','yes',1211556441),(468,3,1,'clientManageMaillists','yes',1211556441),(467,3,1,'clientManageWebapps','no',1211556441),(466,3,1,'clientManageAnonFTP','yes',1211556441),(465,3,1,'clientChangeLimits','yes',1211556441),(464,3,1,'clientManagePhysicalHosting','yes',1211556441),(463,3,1,'clientCreateDomains','yes',1211556441),(462,3,1,'domainMaxMaillists','5',1211556441),(461,3,1,'clientMaxMaillists','5',1211556441),(460,3,1,'domainMaxMailAutoresponders','5',1211556441),(458,3,1,'domainMaxMailGroups','5',1211556440),(459,3,1,'clientMaxMailAutoresponders','5',1211556440),(457,3,1,'clientMaxMailGroups','5',1211556440),(456,3,1,'domainMaxMailredirects','10',1211556440),(455,3,1,'clientMaxMailredirects','10',1211556440),(454,3,1,'domainMailboxQuota','10485760',1211556440),(453,3,1,'clientMailBoxQuota','10485760',1211556440),(452,3,1,'domainMaxMailbox','100',1211556440),(451,3,1,'clientMaxMailbox','100',1211556440),(450,3,1,'domainMaxTomcatWebapps','0',1211556440),(449,3,1,'clientMaxTomcatWebapps','0',1211556440),(448,3,1,'domainMaxMYSQLDB','3',1211556440),(447,3,1,'clientMaxMYSQLDB','3',1211556440),(446,3,1,'domainMaxWebusers','2',1211556440),(445,3,1,'clientMaxWebusers','2',1211556440),(444,3,1,'domainMaxTraffic','53687091200',1211556440),(443,3,1,'clientMaxTraffic','53687091200',1211556440),(441,3,1,'clientDiskSpace','1073741824',1211556440),(442,3,1,'domainDiskSpace','1073741824',1211556440),(440,3,1,'domainMaxSubdomains','10',1211556440),(439,3,1,'clientMaxSubdomains','0',1211556440),(438,3,1,'clientMaxDomains','1',1211556440),(437,3,1,'calculate_only','yes',1211556440),(436,3,1,'usage_limit','50',1211556440),(435,3,1,'usage_factor','-1024',1211556440),(434,3,1,'usage_cycle','3',1211556440),(433,3,1,'usage_type','traffic',1211556440),(432,3,1,'logBySize','10240',1211556440),(431,3,1,'logByTime','',1211556440),(430,3,1,'logCompress','yes',1211556440),(429,3,1,'logRotate','yes',1211556440),(428,3,1,'shellType','/usr/local/psa/bin/chrootsh',1211556440),(427,3,1,'webstat','awstats',1211556440),(426,3,1,'suspend_expired','1',1211556440),(425,3,1,'productServerWeight','5',1211556440),(417,2,1,'cgi','yes',1211556406),(369,2,1,'domainMaxSubdomains','',1211556405),(368,2,1,'clientMaxSubdomains','0',1211556405),(367,2,1,'clientMaxDomains','1',1211556405),(366,2,1,'calculate_only','yes',1211556405),(365,2,1,'usage_limit','20',1211556405),(364,2,1,'usage_factor','-1024',1211556405),(363,2,1,'usage_cycle','3',1211556405),(362,2,1,'usage_type','traffic',1211556405),(361,2,1,'logBySize','10240',1211556405),(360,2,1,'logByTime','',1211556405),(359,2,1,'logCompress','yes',1211556405),(358,2,1,'logRotate','yes',1211556405),(357,2,1,'shellType','/bin/false',1211556405),(356,2,1,'webstat','awstats',1211556405),(355,2,1,'suspend_expired','1',1211556405),(354,2,1,'productServerWeight','1',1211556405),(283,4,1,'productServerWeight','20',1211556361),(284,4,1,'suspend_expired','1',1211556361),(285,4,1,'webstat','awstats',1211556362),(286,4,1,'shellType','/bin/bash',1211556362),(287,4,1,'logRotate','yes',1211556362),(288,4,1,'logCompress','yes',1211556362),(289,4,1,'logByTime','',1211556362),(290,4,1,'logBySize','10240',1211556362),(291,4,1,'usage_type','traffic',1211556362),(292,4,1,'usage_cycle','3',1211556362),(293,4,1,'usage_factor','-1024',1211556362),(294,4,1,'usage_limit','80',1211556362),(295,4,1,'calculate_only','yes',1211556362),(296,4,1,'clientMaxDomains','1',1211556362),(297,4,1,'clientMaxSubdomains','20',1211556362),(298,4,1,'domainMaxSubdomains','20',1211556362),(299,4,1,'clientDiskSpace','4294967296',1211556362),(300,4,1,'domainDiskSpace','4294967296',1211556362),(301,4,1,'clientMaxTraffic','85899345920',1211556362),(302,4,1,'domainMaxTraffic','85899345920',1211556362),(303,4,1,'clientMaxWebusers','5',1211556362),(304,4,1,'domainMaxWebusers','5',1211556362),(305,4,1,'clientMaxMYSQLDB','3',1211556362),(306,4,1,'domainMaxMYSQLDB','3',1211556362),(307,4,1,'clientMaxTomcatWebapps','0',1211556362),(308,4,1,'domainMaxTomcatWebapps','0',1211556362),(309,4,1,'clientMaxMailbox','250',1211556362),(310,4,1,'domainMaxMailbox','250',1211556362),(311,4,1,'clientMailBoxQuota','104857600',1211556362),(312,4,1,'domainMailboxQuota','104857600',1211556362),(313,4,1,'clientMaxMailredirects','10',1211556362),(314,4,1,'domainMaxMailredirects','10',1211556362),(315,4,1,'clientMaxMailGroups','10',1211556362),(316,4,1,'domainMaxMailGroups','10',1211556362),(317,4,1,'clientMaxMailAutoresponders','10',1211556362),(318,4,1,'domainMaxMailAutoresponders','10',1211556362),(319,4,1,'clientMaxMaillists','10',1211556362),(320,4,1,'domainMaxMaillists','10',1211556362),(321,4,1,'clientCreateDomains','yes',1211556362),(322,4,1,'clientManagePhysicalHosting','yes',1211556362),(323,4,1,'clientChangeLimits','yes',1211556362),(324,4,1,'clientManageAnonFTP','yes',1211556362),(325,4,1,'clientManageWebapps','no',1211556362),(326,4,1,'clientManageMaillists','yes',1211556362),(327,4,1,'clientManageDNS','yes',1211556362),(328,4,1,'clientManageLog','yes',1211556362),(329,4,1,'clientManageCrontab','yes',1211556362),(330,4,1,'clientManageSHAccess','yes',1211556362),(331,4,1,'clientManageNotChrootShell','yes',1211556362),(332,4,1,'clientManageSubdomains','yes',1211556362),(333,4,1,'clientManageQuota','yes',1211556362),(334,4,1,'clientBackupManager','yes',1211556362),(335,4,1,'aclAddPackages','yes',1211556362),(336,4,1,'dns','yes',1211556362),(337,4,1,'domainUserAllowed','yes',1211556362),(338,4,1,'domainWWW','yes',1211556362),(339,4,1,'ssl','no',1211556362),(340,4,1,'mailService','yes',1211556362),(341,4,1,'customErrorDocs','yes',1211556362),(342,4,1,'anonymousFTP','yes',1211556362),(343,4,1,'frontpage','no',1211556362),(344,4,1,'ssi','yes',1211556362),(345,4,1,'php','yes',1211556362),(346,4,1,'cgi','yes',1211556362),(347,4,1,'perl','yes',1211556362),(348,4,1,'asp','yes',1211556362),(349,4,1,'python','yes',1211556362),(350,4,1,'coldfusion','no',1211556362),(351,4,1,'domainWebuserScripts','no',1211556362),(352,4,1,'logEmail','no',1211556363),(353,4,1,'domainwebmail','yes',1211556363),(418,2,1,'perl','yes',1211556406),(419,2,1,'asp','no',1211556406),(420,2,1,'python','yes',1211556406),(421,2,1,'coldfusion','no',1211556406),(422,2,1,'domainWebuserScripts','no',1211556406),(423,2,1,'logEmail','no',1211556406),(424,2,1,'domainwebmail','yes',1211556406),(492,3,1,'coldfusion','no',1211556441),(493,3,1,'domainWebuserScripts','no',1211556441),(494,3,1,'logEmail','no',1211556441),(495,3,1,'domainwebmail','yes',1211556441),(496,6,1,'clientDiskSpace','1073741824',1211559572),(497,7,1,'clientDiskSpace','2147483648',1211559572),(498,8,1,'clientDiskSpace','5368709120',1211559572),(499,9,1,'clientMaxMailbox','20',1211559887),(500,10,1,'clientMaxMailbox','100',1211559887),(501,11,1,'clientMaxMailbox','250',1211559887);
/*!40000 ALTER TABLE `product_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_children_rel`
--

DROP TABLE IF EXISTS `product_children_rel`;
CREATE TABLE `product_children_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `child_product_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`child_product_id`)
);

--
-- Dumping data for table `product_children_rel`
--

LOCK TABLES `product_children_rel` WRITE;
/*!40000 ALTER TABLE `product_children_rel` DISABLE KEYS */;
INSERT INTO `product_children_rel` VALUES (2,6),(2,7),(2,8),(2,9),(2,10),(2,11),(3,6),(3,7),(3,8),(3,9),(3,10),(3,11),(4,6),(4,7),(4,8),(4,9),(4,10),(4,11);
/*!40000 ALTER TABLE `product_children_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_coupon_pre_rel`
--

DROP TABLE IF EXISTS `product_coupon_pre_rel`;
CREATE TABLE `product_coupon_pre_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`coupon_id`)
);

--
-- Dumping data for table `product_coupon_pre_rel`
--

LOCK TABLES `product_coupon_pre_rel` WRITE;
/*!40000 ALTER TABLE `product_coupon_pre_rel` DISABLE KEYS */;
INSERT INTO `product_coupon_pre_rel` VALUES (2,0),(3,0),(4,0);
/*!40000 ALTER TABLE `product_coupon_pre_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_coupon_rel`
--

DROP TABLE IF EXISTS `product_coupon_rel`;
CREATE TABLE `product_coupon_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`coupon_id`)
);

--
-- Dumping data for table `product_coupon_rel`
--

LOCK TABLES `product_coupon_rel` WRITE;
/*!40000 ALTER TABLE `product_coupon_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_coupon_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_cycle_ghost_rel`
--

DROP TABLE IF EXISTS `product_cycle_ghost_rel`;
CREATE TABLE `product_cycle_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `cycle_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`cycle_id`)
);

--
-- Dumping data for table `product_cycle_ghost_rel`
--

LOCK TABLES `product_cycle_ghost_rel` WRITE;
/*!40000 ALTER TABLE `product_cycle_ghost_rel` DISABLE KEYS */;
INSERT INTO `product_cycle_ghost_rel` VALUES (1,6),(1,7),(2,3),(3,3),(4,3),(5,1),(6,3),(7,3),(8,3),(9,3),(10,3),(11,3);
/*!40000 ALTER TABLE `product_cycle_ghost_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_file_rel`
--

DROP TABLE IF EXISTS `product_file_rel`;
CREATE TABLE `product_file_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `file_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`file_id`)
);

--
-- Dumping data for table `product_file_rel`
--

LOCK TABLES `product_file_rel` WRITE;
/*!40000 ALTER TABLE `product_file_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_file_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_files`
--

DROP TABLE IF EXISTS `product_files`;
CREATE TABLE `product_files` (
  `file_id` smallint(5) unsigned NOT NULL auto_increment,
  `file_name` varchar(255) default NULL,
  `file_path` text,
  `file_data` longblob,
  PRIMARY KEY  (`file_id`),
  KEY `file_name` (`file_name`)
);

--
-- Dumping data for table `product_files`
--

LOCK TABLES `product_files` WRITE;
/*!40000 ALTER TABLE `product_files` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_files` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_group_rel`
--

DROP TABLE IF EXISTS `product_group_rel`;
CREATE TABLE `product_group_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `product_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`product_group_id`)
);

--
-- Dumping data for table `product_group_rel`
--

LOCK TABLES `product_group_rel` WRITE;
/*!40000 ALTER TABLE `product_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_groups`
--

DROP TABLE IF EXISTS `product_groups`;
CREATE TABLE `product_groups` (
  `product_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_group_name` varchar(50) default NULL,
  `product_group_api_name` varchar(50) default NULL,
  PRIMARY KEY  (`product_group_id`)
);

--
-- Dumping data for table `product_groups`
--

LOCK TABLES `product_groups` WRITE;
/*!40000 ALTER TABLE `product_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_ledger_curr_rel`
--

DROP TABLE IF EXISTS `product_ledger_curr_rel`;
CREATE TABLE `product_ledger_curr_rel` (
  `product_ledger_id` int(10) unsigned NOT NULL default '0',
  `currency_id` char(3) NOT NULL default '',
  PRIMARY KEY  (`product_ledger_id`,`currency_id`)
);

--
-- Dumping data for table `product_ledger_curr_rel`
--

LOCK TABLES `product_ledger_curr_rel` WRITE;
/*!40000 ALTER TABLE `product_ledger_curr_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_ledger_curr_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_ledger_cycle_rel`
--

DROP TABLE IF EXISTS `product_ledger_cycle_rel`;
CREATE TABLE `product_ledger_cycle_rel` (
  `product_ledger_id` int(10) unsigned NOT NULL default '0',
  `cycle_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_ledger_id`,`cycle_id`)
);

--
-- Dumping data for table `product_ledger_cycle_rel`
--

LOCK TABLES `product_ledger_cycle_rel` WRITE;
/*!40000 ALTER TABLE `product_ledger_cycle_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_ledger_cycle_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_ledger_entries`
--

DROP TABLE IF EXISTS `product_ledger_entries`;
CREATE TABLE `product_ledger_entries` (
  `product_ledger_id` int(10) NOT NULL auto_increment,
  `ledger_group_id` smallint(5) unsigned default NULL,
  `product_variant_id` int(8) default NULL,
  `product_ledger_num_cycles` smallint(5) unsigned default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `journal_type` varchar(20) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `product_ledger_debit` decimal(10,2) unsigned default NULL,
  `product_ledger_credit` decimal(10,2) unsigned default NULL,
  `product_ledger_comment` varchar(255) default NULL,
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`product_ledger_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `journal_type` (`journal_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `currency_id` (`currency_id`),
  KEY `ledger_group_id` (`ledger_group_id`)
);

--
-- Dumping data for table `product_ledger_entries`
--

LOCK TABLES `product_ledger_entries` WRITE;
/*!40000 ALTER TABLE `product_ledger_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_ledger_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_order_form_ghost_rel`
--

DROP TABLE IF EXISTS `product_order_form_ghost_rel`;
CREATE TABLE `product_order_form_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `order_form_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`order_form_id`)
);

--
-- Dumping data for table `product_order_form_ghost_rel`
--

LOCK TABLES `product_order_form_ghost_rel` WRITE;
/*!40000 ALTER TABLE `product_order_form_ghost_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_order_form_ghost_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_relations`
--

DROP TABLE IF EXISTS `product_relations`;
CREATE TABLE `product_relations` (
  `product_relation_id` int(8) unsigned NOT NULL auto_increment,
  `subject_product_id` int(10) unsigned default NULL,
  `related_product_id` int(10) unsigned default NULL,
  `product_relation_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`product_relation_id`),
  KEY `subject_product_id` (`subject_product_id`),
  KEY `related_product_id` (`related_product_id`)
) AUTO_INCREMENT=7;

--
-- Dumping data for table `product_relations`
--

LOCK TABLES `product_relations` WRITE;
/*!40000 ALTER TABLE `product_relations` DISABLE KEYS */;
INSERT INTO `product_relations` VALUES (1,2,3,1),(2,2,4,1),(3,3,4,1),(4,3,2,2),(5,4,3,1),(6,4,2,1);
/*!40000 ALTER TABLE `product_relations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_server_group_ghost_rel`
--

DROP TABLE IF EXISTS `product_server_group_ghost_rel`;
CREATE TABLE `product_server_group_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `server_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`server_group_id`)
);

--
-- Dumping data for table `product_server_group_ghost_rel`
--

LOCK TABLES `product_server_group_ghost_rel` WRITE;
/*!40000 ALTER TABLE `product_server_group_ghost_rel` DISABLE KEYS */;
INSERT INTO `product_server_group_ghost_rel` VALUES (2,1),(3,1),(4,1),(6,1),(7,1),(8,1),(9,1),(10,1),(11,1);
/*!40000 ALTER TABLE `product_server_group_ghost_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_tld_ghost_rel`
--

DROP TABLE IF EXISTS `product_tld_ghost_rel`;
CREATE TABLE `product_tld_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `tld_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`tld_id`)
);

--
-- Dumping data for table `product_tld_ghost_rel`
--

LOCK TABLES `product_tld_ghost_rel` WRITE;
/*!40000 ALTER TABLE `product_tld_ghost_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_tld_ghost_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_usage_prices`
--

DROP TABLE IF EXISTS `product_usage_prices`;
CREATE TABLE `product_usage_prices` (
  `product_usage_price_id` int(10) unsigned NOT NULL auto_increment,
  `product_id` int(10) unsigned default NULL,
  `currency_id` char(3) default NULL,
  `product_usage_price_amount` decimal(10,2) unsigned default NULL,
  PRIMARY KEY  (`product_usage_price_id`),
  KEY `product_id` (`product_id`),
  KEY `currency_id` (`currency_id`)
) AUTO_INCREMENT=4;

--
-- Dumping data for table `product_usage_prices`
--

LOCK TABLES `product_usage_prices` WRITE;
/*!40000 ALTER TABLE `product_usage_prices` DISABLE KEYS */;
INSERT INTO `product_usage_prices` VALUES (1,2,'USD','2.00'),(2,3,'USD','2.00'),(3,4,'USD','2.00');
/*!40000 ALTER TABLE `product_usage_prices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_variable_values`
--

DROP TABLE IF EXISTS `product_variable_values`;
CREATE TABLE `product_variable_values` (
  `product_variable_value_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_variable_id` smallint(5) unsigned default NULL,
  `product_variable_value` varchar(100) default NULL,
  PRIMARY KEY  (`product_variable_value_id`),
  KEY `product_variable_id` (`product_variable_id`)
);

--
-- Dumping data for table `product_variable_values`
--

LOCK TABLES `product_variable_values` WRITE;
/*!40000 ALTER TABLE `product_variable_values` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_variable_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_variables`
--

DROP TABLE IF EXISTS `product_variables`;
CREATE TABLE `product_variables` (
  `product_variable_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_variable_name` varchar(100) default NULL,
  PRIMARY KEY  (`product_variable_id`)
);

--
-- Dumping data for table `product_variables`
--

LOCK TABLES `product_variables` WRITE;
/*!40000 ALTER TABLE `product_variables` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_variables` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_variant_prices`
--

DROP TABLE IF EXISTS `product_variant_prices`;
CREATE TABLE `product_variant_prices` (
  `product_variant_price_id` int(10) unsigned NOT NULL auto_increment,
  `product_variant_id` int(8) unsigned default NULL,
  `product_variant_price_type` tinyint(3) unsigned default NULL,
  `cycle_id` smallint(5) unsigned default NULL,
  `currency_id` char(3) default NULL,
  `product_variant_price_amount` decimal(10,2) unsigned default '0.00',
  `cost_currency_id` char(3) default NULL,
  `cost_amount` decimal(10,2) unsigned default '0.00',
  PRIMARY KEY  (`product_variant_price_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `product_variant_price_type` (`product_variant_price_type`),
  KEY `cycle_id` (`cycle_id`),
  KEY `currency_id` (`currency_id`)
) AUTO_INCREMENT=508;

--
-- Dumping data for table `product_variant_prices`
--

LOCK TABLES `product_variant_prices` WRITE;
/*!40000 ALTER TABLE `product_variant_prices` DISABLE KEYS */;
INSERT INTO `product_variant_prices` VALUES (450,31,1,6,'USD','0.00',NULL,'0.00'),(2,1,0,6,'USD','15.00',NULL,'0.00'),(3,1,0,7,'USD','30.00',NULL,'0.00'),(4,1,0,8,'USD','45.00',NULL,'0.00'),(5,1,0,9,'USD','60.00',NULL,'0.00'),(6,2,2,6,'USD','15.00',NULL,'0.00'),(7,2,0,6,'USD','15.00',NULL,'0.00'),(8,2,0,7,'USD','30.00',NULL,'0.00'),(9,2,0,8,'USD','45.00',NULL,'0.00'),(10,2,0,9,'USD','60.00',NULL,'0.00'),(11,3,2,6,'USD','15.00',NULL,'0.00'),(12,3,0,6,'USD','15.00',NULL,'0.00'),(13,3,0,7,'USD','30.00',NULL,'0.00'),(14,3,0,8,'USD','45.00',NULL,'0.00'),(15,3,0,9,'USD','60.00',NULL,'0.00'),(16,4,2,6,'USD','15.00',NULL,'0.00'),(17,4,0,6,'USD','15.00',NULL,'0.00'),(18,4,0,7,'USD','30.00',NULL,'0.00'),(19,4,0,8,'USD','45.00',NULL,'0.00'),(20,4,0,9,'USD','60.00',NULL,'0.00'),(21,5,2,6,'USD','24.95',NULL,'0.00'),(22,5,0,6,'USD','24.95',NULL,'0.00'),(23,5,0,7,'USD','49.95',NULL,'0.00'),(24,5,0,8,'USD','45.00',NULL,'0.00'),(25,5,0,9,'USD','60.00',NULL,'0.00'),(26,6,2,6,'USD','15.00',NULL,'0.00'),(27,6,0,6,'USD','15.00',NULL,'0.00'),(28,6,0,7,'USD','30.00',NULL,'0.00'),(29,6,0,8,'USD','45.00',NULL,'0.00'),(30,6,0,9,'USD','60.00',NULL,'0.00'),(31,7,2,6,'USD','15.00',NULL,'0.00'),(32,7,0,6,'USD','15.00',NULL,'0.00'),(33,7,0,7,'USD','30.00',NULL,'0.00'),(34,7,0,8,'USD','45.00',NULL,'0.00'),(35,7,0,9,'USD','60.00',NULL,'0.00'),(36,8,2,6,'USD','15.00',NULL,'0.00'),(37,8,0,6,'USD','15.00',NULL,'0.00'),(38,8,0,7,'USD','30.00',NULL,'0.00'),(39,8,0,8,'USD','45.00',NULL,'0.00'),(40,8,0,9,'USD','60.00',NULL,'0.00'),(41,9,2,6,'USD','15.00',NULL,'0.00'),(42,9,0,6,'USD','15.00',NULL,'0.00'),(43,9,0,7,'USD','30.00',NULL,'0.00'),(44,9,0,8,'USD','45.00',NULL,'0.00'),(45,9,0,9,'USD','60.00',NULL,'0.00'),(51,11,2,6,'USD','24.95',NULL,'0.00'),(52,11,0,6,'USD','24.95',NULL,'0.00'),(53,11,0,7,'USD','49.95',NULL,'0.00'),(54,11,0,8,'USD','45.00',NULL,'0.00'),(55,11,0,9,'USD','60.00',NULL,'0.00'),(56,12,2,6,'USD','15.00',NULL,'0.00'),(57,12,0,6,'USD','15.00',NULL,'0.00'),(58,12,0,7,'USD','30.00',NULL,'0.00'),(59,12,0,8,'USD','45.00',NULL,'0.00'),(60,12,0,9,'USD','60.00',NULL,'0.00'),(61,13,2,6,'USD','15.00',NULL,'0.00'),(62,13,0,6,'USD','15.00',NULL,'0.00'),(63,13,0,7,'USD','30.00',NULL,'0.00'),(64,13,0,8,'USD','45.00',NULL,'0.00'),(65,13,0,9,'USD','60.00',NULL,'0.00'),(66,14,2,6,'USD','15.00',NULL,'0.00'),(67,14,0,6,'USD','15.00',NULL,'0.00'),(68,14,0,7,'USD','30.00',NULL,'0.00'),(69,14,0,8,'USD','45.00',NULL,'0.00'),(70,14,0,9,'USD','60.00',NULL,'0.00'),(71,15,2,6,'USD','15.00',NULL,'0.00'),(72,15,0,6,'USD','15.00',NULL,'0.00'),(73,15,0,7,'USD','30.00',NULL,'0.00'),(74,15,0,8,'USD','45.00',NULL,'0.00'),(75,15,0,9,'USD','60.00',NULL,'0.00'),(76,16,2,6,'USD','15.00',NULL,'0.00'),(77,16,0,6,'USD','15.00',NULL,'0.00'),(78,16,0,7,'USD','30.00',NULL,'0.00'),(79,16,0,8,'USD','45.00',NULL,'0.00'),(80,16,0,9,'USD','60.00',NULL,'0.00'),(81,17,2,6,'USD','15.00',NULL,'0.00'),(82,17,0,6,'USD','15.00',NULL,'0.00'),(83,17,0,7,'USD','30.00',NULL,'0.00'),(84,17,0,8,'USD','45.00',NULL,'0.00'),(85,17,0,9,'USD','60.00',NULL,'0.00'),(86,18,2,6,'USD','15.00',NULL,'0.00'),(87,18,0,6,'USD','15.00',NULL,'0.00'),(88,18,0,7,'USD','30.00',NULL,'0.00'),(89,18,0,8,'USD','45.00',NULL,'0.00'),(90,18,0,9,'USD','60.00',NULL,'0.00'),(91,19,2,6,'USD','15.00',NULL,'0.00'),(92,19,0,6,'USD','15.00',NULL,'0.00'),(93,19,0,7,'USD','30.00',NULL,'0.00'),(94,19,0,8,'USD','45.00',NULL,'0.00'),(95,19,0,9,'USD','60.00',NULL,'0.00'),(96,20,2,6,'USD','15.00',NULL,'0.00'),(97,20,0,6,'USD','15.00',NULL,'0.00'),(98,20,0,7,'USD','30.00',NULL,'0.00'),(99,20,0,8,'USD','45.00',NULL,'0.00'),(100,20,0,9,'USD','60.00',NULL,'0.00'),(101,21,2,6,'USD','15.00',NULL,'0.00'),(102,21,0,6,'USD','15.00',NULL,'0.00'),(103,21,0,7,'USD','30.00',NULL,'0.00'),(104,21,0,8,'USD','45.00',NULL,'0.00'),(105,21,0,9,'USD','60.00',NULL,'0.00'),(106,22,2,6,'USD','24.95',NULL,'0.00'),(107,22,0,6,'USD','24.95',NULL,'0.00'),(108,22,0,7,'USD','49.95',NULL,'0.00'),(109,22,0,8,'USD','45.00',NULL,'0.00'),(110,22,0,9,'USD','60.00',NULL,'0.00'),(111,23,2,6,'USD','15.00',NULL,'0.00'),(112,23,0,6,'USD','15.00',NULL,'0.00'),(113,23,0,7,'USD','30.00',NULL,'0.00'),(114,23,0,8,'USD','45.00',NULL,'0.00'),(115,23,0,9,'USD','60.00',NULL,'0.00'),(116,24,2,6,'USD','15.00',NULL,'0.00'),(117,24,0,6,'USD','15.00',NULL,'0.00'),(118,24,0,7,'USD','30.00',NULL,'0.00'),(119,24,0,8,'USD','45.00',NULL,'0.00'),(120,24,0,9,'USD','60.00',NULL,'0.00'),(121,25,2,6,'USD','15.00',NULL,'0.00'),(122,25,0,6,'USD','15.00',NULL,'0.00'),(123,25,0,7,'USD','30.00',NULL,'0.00'),(124,25,0,8,'USD','45.00',NULL,'0.00'),(125,25,0,9,'USD','60.00',NULL,'0.00'),(126,26,2,6,'USD','15.00',NULL,'0.00'),(127,26,0,6,'USD','15.00',NULL,'0.00'),(128,26,0,7,'USD','30.00',NULL,'0.00'),(129,26,0,8,'USD','45.00',NULL,'0.00'),(130,26,0,9,'USD','60.00',NULL,'0.00'),(131,27,2,6,'USD','15.00',NULL,'0.00'),(132,27,0,6,'USD','15.00',NULL,'0.00'),(133,27,0,7,'USD','30.00',NULL,'0.00'),(134,27,0,8,'USD','45.00',NULL,'0.00'),(135,27,0,9,'USD','60.00',NULL,'0.00'),(136,28,2,6,'USD','15.00',NULL,'0.00'),(137,28,0,6,'USD','15.00',NULL,'0.00'),(138,28,0,7,'USD','30.00',NULL,'0.00'),(139,28,0,8,'USD','45.00',NULL,'0.00'),(140,28,0,9,'USD','60.00',NULL,'0.00'),(141,29,2,6,'USD','15.00',NULL,'0.00'),(142,29,0,6,'USD','15.00',NULL,'0.00'),(143,29,0,7,'USD','30.00',NULL,'0.00'),(144,29,0,8,'USD','45.00',NULL,'0.00'),(145,29,0,9,'USD','60.00',NULL,'0.00'),(146,30,2,6,'USD','15.00',NULL,'0.00'),(147,30,0,6,'USD','15.00',NULL,'0.00'),(148,30,0,7,'USD','30.00',NULL,'0.00'),(149,30,0,8,'USD','45.00',NULL,'0.00'),(150,30,0,9,'USD','60.00',NULL,'0.00'),(151,31,2,6,'USD','24.95',NULL,'0.00'),(152,31,0,6,'USD','24.95',NULL,'0.00'),(153,31,0,7,'USD','49.95',NULL,'0.00'),(154,31,0,8,'USD','45.00',NULL,'0.00'),(155,31,0,9,'USD','60.00',NULL,'0.00'),(156,32,2,6,'USD','15.00',NULL,'0.00'),(157,32,0,6,'USD','15.00',NULL,'0.00'),(158,32,0,7,'USD','30.00',NULL,'0.00'),(159,32,0,8,'USD','45.00',NULL,'0.00'),(160,32,0,9,'USD','60.00',NULL,'0.00'),(161,33,2,6,'USD','15.00',NULL,'0.00'),(162,33,0,6,'USD','15.00',NULL,'0.00'),(163,33,0,7,'USD','30.00',NULL,'0.00'),(164,33,0,8,'USD','45.00',NULL,'0.00'),(165,33,0,9,'USD','60.00',NULL,'0.00'),(166,34,2,6,'USD','15.00',NULL,'0.00'),(167,34,0,6,'USD','15.00',NULL,'0.00'),(168,34,0,7,'USD','30.00',NULL,'0.00'),(169,34,0,8,'USD','45.00',NULL,'0.00'),(170,34,0,9,'USD','60.00',NULL,'0.00'),(171,35,2,6,'USD','15.00',NULL,'0.00'),(172,35,0,6,'USD','15.00',NULL,'0.00'),(173,35,0,7,'USD','30.00',NULL,'0.00'),(174,35,0,8,'USD','45.00',NULL,'0.00'),(175,35,0,9,'USD','60.00',NULL,'0.00'),(176,36,2,6,'USD','24.95',NULL,'0.00'),(177,36,0,6,'USD','24.95',NULL,'0.00'),(178,36,0,7,'USD','49.95',NULL,'0.00'),(179,36,0,8,'USD','45.00',NULL,'0.00'),(180,36,0,9,'USD','60.00',NULL,'0.00'),(181,37,2,6,'USD','15.00',NULL,'0.00'),(182,37,0,6,'USD','15.00',NULL,'0.00'),(183,37,0,7,'USD','30.00',NULL,'0.00'),(184,37,0,8,'USD','45.00',NULL,'0.00'),(185,37,0,9,'USD','60.00',NULL,'0.00'),(186,38,2,6,'USD','15.00',NULL,'0.00'),(187,38,0,6,'USD','15.00',NULL,'0.00'),(188,38,0,7,'USD','30.00',NULL,'0.00'),(189,38,0,8,'USD','45.00',NULL,'0.00'),(190,38,0,9,'USD','60.00',NULL,'0.00'),(191,39,2,6,'USD','15.00',NULL,'0.00'),(192,39,0,6,'USD','15.00',NULL,'0.00'),(193,39,0,7,'USD','30.00',NULL,'0.00'),(194,39,0,8,'USD','45.00',NULL,'0.00'),(195,39,0,9,'USD','60.00',NULL,'0.00'),(196,40,2,6,'USD','15.00',NULL,'0.00'),(197,40,0,6,'USD','15.00',NULL,'0.00'),(198,40,0,7,'USD','30.00',NULL,'0.00'),(199,40,0,8,'USD','45.00',NULL,'0.00'),(200,40,0,9,'USD','60.00',NULL,'0.00'),(201,41,2,6,'USD','15.00',NULL,'0.00'),(202,41,0,6,'USD','15.00',NULL,'0.00'),(203,41,0,7,'USD','30.00',NULL,'0.00'),(204,41,0,8,'USD','45.00',NULL,'0.00'),(205,41,0,9,'USD','60.00',NULL,'0.00'),(206,42,2,6,'USD','15.00',NULL,'0.00'),(207,42,0,6,'USD','15.00',NULL,'0.00'),(208,42,0,7,'USD','30.00',NULL,'0.00'),(209,42,0,8,'USD','45.00',NULL,'0.00'),(210,42,0,9,'USD','60.00',NULL,'0.00'),(211,43,2,6,'USD','15.00',NULL,'0.00'),(212,43,0,6,'USD','15.00',NULL,'0.00'),(213,43,0,7,'USD','30.00',NULL,'0.00'),(214,43,0,8,'USD','45.00',NULL,'0.00'),(215,43,0,9,'USD','60.00',NULL,'0.00'),(216,44,2,6,'USD','15.00',NULL,'0.00'),(217,44,0,6,'USD','15.00',NULL,'0.00'),(218,44,0,7,'USD','30.00',NULL,'0.00'),(219,44,0,8,'USD','45.00',NULL,'0.00'),(220,44,0,9,'USD','60.00',NULL,'0.00'),(221,45,2,6,'USD','15.00',NULL,'0.00'),(222,45,0,6,'USD','15.00',NULL,'0.00'),(223,45,0,7,'USD','30.00',NULL,'0.00'),(224,45,0,8,'USD','45.00',NULL,'0.00'),(225,45,0,9,'USD','60.00',NULL,'0.00'),(226,46,2,6,'USD','15.00',NULL,'0.00'),(227,46,0,6,'USD','15.00',NULL,'0.00'),(228,46,0,7,'USD','30.00',NULL,'0.00'),(229,46,0,8,'USD','45.00',NULL,'0.00'),(230,46,0,9,'USD','60.00',NULL,'0.00'),(231,47,2,6,'USD','15.00',NULL,'0.00'),(232,47,0,6,'USD','15.00',NULL,'0.00'),(233,47,0,7,'USD','30.00',NULL,'0.00'),(234,47,0,8,'USD','45.00',NULL,'0.00'),(235,47,0,9,'USD','60.00',NULL,'0.00'),(236,48,2,6,'USD','15.00',NULL,'0.00'),(237,48,0,6,'USD','15.00',NULL,'0.00'),(238,48,0,7,'USD','30.00',NULL,'0.00'),(239,48,0,8,'USD','45.00',NULL,'0.00'),(240,48,0,9,'USD','60.00',NULL,'0.00'),(241,49,2,6,'USD','15.00',NULL,'0.00'),(242,49,0,6,'USD','15.00',NULL,'0.00'),(243,49,0,7,'USD','30.00',NULL,'0.00'),(244,49,0,8,'USD','45.00',NULL,'0.00'),(245,49,0,9,'USD','60.00',NULL,'0.00'),(246,50,2,6,'USD','15.00',NULL,'0.00'),(247,50,0,6,'USD','15.00',NULL,'0.00'),(248,50,0,7,'USD','30.00',NULL,'0.00'),(249,50,0,8,'USD','45.00',NULL,'0.00'),(250,50,0,9,'USD','60.00',NULL,'0.00'),(251,51,2,6,'USD','15.00',NULL,'0.00'),(252,51,0,6,'USD','15.00',NULL,'0.00'),(253,51,0,7,'USD','30.00',NULL,'0.00'),(254,51,0,8,'USD','45.00',NULL,'0.00'),(255,51,0,9,'USD','60.00',NULL,'0.00'),(256,52,2,6,'USD','15.00',NULL,'0.00'),(257,52,0,6,'USD','15.00',NULL,'0.00'),(258,52,0,7,'USD','30.00',NULL,'0.00'),(259,52,0,8,'USD','45.00',NULL,'0.00'),(260,52,0,9,'USD','60.00',NULL,'0.00'),(261,53,2,6,'USD','15.00',NULL,'0.00'),(262,53,0,6,'USD','15.00',NULL,'0.00'),(263,53,0,7,'USD','30.00',NULL,'0.00'),(264,53,0,8,'USD','45.00',NULL,'0.00'),(265,53,0,9,'USD','60.00',NULL,'0.00'),(266,54,2,6,'USD','15.00',NULL,'0.00'),(267,54,0,6,'USD','15.00',NULL,'0.00'),(268,54,0,7,'USD','30.00',NULL,'0.00'),(269,54,0,8,'USD','45.00',NULL,'0.00'),(270,54,0,9,'USD','60.00',NULL,'0.00'),(271,55,2,6,'USD','15.00',NULL,'0.00'),(272,55,0,6,'USD','15.00',NULL,'0.00'),(273,55,0,7,'USD','30.00',NULL,'0.00'),(274,55,0,8,'USD','45.00',NULL,'0.00'),(275,55,0,9,'USD','60.00',NULL,'0.00'),(276,56,2,6,'USD','15.00',NULL,'0.00'),(277,56,0,6,'USD','15.00',NULL,'0.00'),(278,56,0,7,'USD','30.00',NULL,'0.00'),(279,56,0,8,'USD','45.00',NULL,'0.00'),(280,56,0,9,'USD','60.00',NULL,'0.00'),(281,57,2,6,'USD','15.00',NULL,'0.00'),(282,57,0,6,'USD','15.00',NULL,'0.00'),(283,57,0,7,'USD','30.00',NULL,'0.00'),(284,57,0,8,'USD','45.00',NULL,'0.00'),(285,57,0,9,'USD','60.00',NULL,'0.00'),(286,58,2,6,'USD','15.00',NULL,'0.00'),(287,58,0,6,'USD','15.00',NULL,'0.00'),(288,58,0,7,'USD','30.00',NULL,'0.00'),(289,58,0,8,'USD','45.00',NULL,'0.00'),(290,58,0,9,'USD','60.00',NULL,'0.00'),(291,59,2,6,'USD','15.00',NULL,'0.00'),(292,59,0,6,'USD','15.00',NULL,'0.00'),(293,59,0,7,'USD','30.00',NULL,'0.00'),(294,59,0,8,'USD','45.00',NULL,'0.00'),(295,59,0,9,'USD','60.00',NULL,'0.00'),(296,60,2,6,'USD','15.00',NULL,'0.00'),(297,60,0,6,'USD','15.00',NULL,'0.00'),(298,60,0,7,'USD','30.00',NULL,'0.00'),(299,60,0,8,'USD','45.00',NULL,'0.00'),(300,60,0,9,'USD','60.00',NULL,'0.00'),(301,61,2,6,'USD','15.00',NULL,'0.00'),(302,61,0,6,'USD','15.00',NULL,'0.00'),(303,61,0,7,'USD','30.00',NULL,'0.00'),(304,61,0,8,'USD','45.00',NULL,'0.00'),(305,61,0,9,'USD','60.00',NULL,'0.00'),(306,62,2,6,'USD','15.00',NULL,'0.00'),(307,62,0,6,'USD','15.00',NULL,'0.00'),(308,62,0,7,'USD','30.00',NULL,'0.00'),(309,62,0,8,'USD','45.00',NULL,'0.00'),(310,62,0,9,'USD','60.00',NULL,'0.00'),(311,63,2,6,'USD','15.00',NULL,'0.00'),(312,63,0,6,'USD','15.00',NULL,'0.00'),(313,63,0,7,'USD','30.00',NULL,'0.00'),(314,63,0,8,'USD','45.00',NULL,'0.00'),(315,63,0,9,'USD','60.00',NULL,'0.00'),(316,64,2,6,'USD','15.00',NULL,'0.00'),(317,64,0,6,'USD','15.00',NULL,'0.00'),(318,64,0,7,'USD','30.00',NULL,'0.00'),(319,64,0,8,'USD','45.00',NULL,'0.00'),(320,64,0,9,'USD','60.00',NULL,'0.00'),(321,65,2,6,'USD','15.00',NULL,'0.00'),(322,65,0,6,'USD','15.00',NULL,'0.00'),(323,65,0,7,'USD','30.00',NULL,'0.00'),(324,65,0,8,'USD','45.00',NULL,'0.00'),(325,65,0,9,'USD','60.00',NULL,'0.00'),(326,66,2,6,'USD','15.00',NULL,'0.00'),(327,66,0,6,'USD','15.00',NULL,'0.00'),(328,66,0,7,'USD','30.00',NULL,'0.00'),(329,66,0,8,'USD','45.00',NULL,'0.00'),(330,66,0,9,'USD','60.00',NULL,'0.00'),(331,67,2,6,'USD','15.00',NULL,'0.00'),(332,67,0,6,'USD','15.00',NULL,'0.00'),(333,67,0,7,'USD','30.00',NULL,'0.00'),(334,67,0,8,'USD','45.00',NULL,'0.00'),(335,67,0,9,'USD','60.00',NULL,'0.00'),(336,68,2,6,'USD','15.00',NULL,'0.00'),(337,68,0,6,'USD','15.00',NULL,'0.00'),(338,68,0,7,'USD','30.00',NULL,'0.00'),(339,68,0,8,'USD','45.00',NULL,'0.00'),(340,68,0,9,'USD','60.00',NULL,'0.00'),(341,69,2,6,'USD','15.00',NULL,'0.00'),(342,69,0,6,'USD','15.00',NULL,'0.00'),(343,69,0,7,'USD','30.00',NULL,'0.00'),(344,69,0,8,'USD','45.00',NULL,'0.00'),(345,69,0,9,'USD','60.00',NULL,'0.00'),(346,70,2,6,'USD','15.00',NULL,'0.00'),(347,70,0,6,'USD','15.00',NULL,'0.00'),(348,70,0,7,'USD','30.00',NULL,'0.00'),(349,70,0,8,'USD','45.00',NULL,'0.00'),(350,70,0,9,'USD','60.00',NULL,'0.00'),(351,71,2,6,'USD','15.00',NULL,'0.00'),(352,71,0,6,'USD','15.00',NULL,'0.00'),(353,71,0,7,'USD','30.00',NULL,'0.00'),(354,71,0,8,'USD','45.00',NULL,'0.00'),(355,71,0,9,'USD','60.00',NULL,'0.00'),(356,72,2,6,'USD','15.00',NULL,'0.00'),(357,72,0,6,'USD','15.00',NULL,'0.00'),(358,72,0,7,'USD','30.00',NULL,'0.00'),(359,72,0,8,'USD','45.00',NULL,'0.00'),(360,72,0,9,'USD','60.00',NULL,'0.00'),(361,73,2,6,'USD','15.00',NULL,'0.00'),(362,73,0,6,'USD','15.00',NULL,'0.00'),(363,73,0,7,'USD','30.00',NULL,'0.00'),(364,73,0,8,'USD','45.00',NULL,'0.00'),(365,73,0,9,'USD','60.00',NULL,'0.00'),(366,74,2,6,'USD','15.00',NULL,'0.00'),(367,74,0,6,'USD','15.00',NULL,'0.00'),(368,74,0,7,'USD','30.00',NULL,'0.00'),(369,74,0,8,'USD','45.00',NULL,'0.00'),(370,74,0,9,'USD','60.00',NULL,'0.00'),(371,75,2,6,'USD','15.00',NULL,'0.00'),(372,75,0,6,'USD','15.00',NULL,'0.00'),(373,75,0,7,'USD','30.00',NULL,'0.00'),(374,75,0,8,'USD','45.00',NULL,'0.00'),(375,75,0,9,'USD','60.00',NULL,'0.00'),(376,76,2,6,'USD','15.00',NULL,'0.00'),(377,76,0,6,'USD','15.00',NULL,'0.00'),(378,76,0,7,'USD','30.00',NULL,'0.00'),(379,76,0,8,'USD','45.00',NULL,'0.00'),(380,76,0,9,'USD','60.00',NULL,'0.00'),(381,77,2,6,'USD','15.00',NULL,'0.00'),(382,77,0,6,'USD','15.00',NULL,'0.00'),(383,77,0,7,'USD','30.00',NULL,'0.00'),(384,77,0,8,'USD','45.00',NULL,'0.00'),(385,77,0,9,'USD','60.00',NULL,'0.00'),(386,78,2,6,'USD','15.00',NULL,'0.00'),(387,78,0,6,'USD','15.00',NULL,'0.00'),(388,78,0,7,'USD','30.00',NULL,'0.00'),(389,78,0,8,'USD','45.00',NULL,'0.00'),(390,78,0,9,'USD','60.00',NULL,'0.00'),(391,79,2,6,'USD','15.00',NULL,'0.00'),(392,79,0,6,'USD','15.00',NULL,'0.00'),(393,79,0,7,'USD','30.00',NULL,'0.00'),(394,79,0,8,'USD','45.00',NULL,'0.00'),(395,79,0,9,'USD','60.00',NULL,'0.00'),(396,80,2,6,'USD','15.00',NULL,'0.00'),(397,80,0,6,'USD','15.00',NULL,'0.00'),(398,80,0,7,'USD','30.00',NULL,'0.00'),(399,80,0,8,'USD','45.00',NULL,'0.00'),(400,80,0,9,'USD','60.00',NULL,'0.00'),(401,81,2,6,'USD','15.00',NULL,'0.00'),(402,81,0,6,'USD','15.00',NULL,'0.00'),(403,81,0,7,'USD','30.00',NULL,'0.00'),(404,81,0,8,'USD','45.00',NULL,'0.00'),(405,81,0,9,'USD','60.00',NULL,'0.00'),(406,82,2,6,'USD','15.00',NULL,'0.00'),(407,82,0,6,'USD','15.00',NULL,'0.00'),(408,82,0,7,'USD','30.00',NULL,'0.00'),(409,82,0,8,'USD','45.00',NULL,'0.00'),(410,82,0,9,'USD','60.00',NULL,'0.00'),(411,83,2,6,'USD','15.00',NULL,'0.00'),(412,83,0,6,'USD','15.00',NULL,'0.00'),(413,83,0,7,'USD','30.00',NULL,'0.00'),(414,83,0,8,'USD','45.00',NULL,'0.00'),(415,83,0,9,'USD','60.00',NULL,'0.00'),(416,84,2,6,'USD','15.00',NULL,'0.00'),(417,84,0,6,'USD','15.00',NULL,'0.00'),(418,84,0,7,'USD','30.00',NULL,'0.00'),(419,84,0,8,'USD','45.00',NULL,'0.00'),(420,84,0,9,'USD','60.00',NULL,'0.00'),(421,85,2,6,'USD','15.00',NULL,'0.00'),(422,85,0,6,'USD','15.00',NULL,'0.00'),(423,85,0,7,'USD','30.00',NULL,'0.00'),(424,85,0,8,'USD','45.00',NULL,'0.00'),(425,85,0,9,'USD','60.00',NULL,'0.00'),(426,86,2,6,'USD','15.00',NULL,'0.00'),(427,86,0,6,'USD','15.00',NULL,'0.00'),(428,86,0,7,'USD','30.00',NULL,'0.00'),(429,86,0,8,'USD','45.00',NULL,'0.00'),(430,86,0,9,'USD','60.00',NULL,'0.00'),(431,87,0,3,'USD','7.95',NULL,'0.00'),(432,88,0,3,'USD','10.00',NULL,'0.00'),(433,89,0,3,'USD','29.95',NULL,'0.00'),(434,90,0,1,'USD','0.01',NULL,'0.00'),(483,97,2,7,'USD','0.00',NULL,'0.00'),(482,97,4,7,'USD','0.00',NULL,'0.00'),(481,97,3,7,'USD','0.00',NULL,'0.00'),(480,97,1,7,'USD','0.00',NULL,'0.00'),(479,97,0,7,'USD','49.95',NULL,'0.00'),(444,36,1,6,'USD','0.00',NULL,'0.00'),(445,36,3,6,'USD','0.00',NULL,'0.00'),(446,36,4,6,'USD','0.00',NULL,'0.00'),(447,36,1,7,'USD','0.00',NULL,'0.00'),(448,36,3,7,'USD','0.00',NULL,'0.00'),(449,36,4,7,'USD','0.00',NULL,'0.00'),(451,31,3,6,'USD','0.00',NULL,'0.00'),(452,31,4,6,'USD','0.00',NULL,'0.00'),(453,31,1,7,'USD','0.00',NULL,'0.00'),(454,31,3,7,'USD','0.00',NULL,'0.00'),(455,31,4,7,'USD','0.00',NULL,'0.00'),(456,22,1,6,'USD','0.00',NULL,'0.00'),(457,22,3,6,'USD','0.00',NULL,'0.00'),(458,22,4,6,'USD','0.00',NULL,'0.00'),(459,22,1,7,'USD','0.00',NULL,'0.00'),(460,22,3,7,'USD','0.00',NULL,'0.00'),(461,22,4,7,'USD','0.00',NULL,'0.00'),(462,11,1,6,'USD','0.00',NULL,'0.00'),(463,11,3,6,'USD','0.00',NULL,'0.00'),(464,11,4,6,'USD','0.00',NULL,'0.00'),(465,11,1,7,'USD','0.00',NULL,'0.00'),(466,11,3,7,'USD','0.00',NULL,'0.00'),(467,11,4,7,'USD','0.00',NULL,'0.00'),(468,5,1,6,'USD','0.00',NULL,'0.00'),(469,5,3,6,'USD','0.00',NULL,'0.00'),(470,5,4,6,'USD','0.00',NULL,'0.00'),(471,5,1,7,'USD','0.00',NULL,'0.00'),(472,5,3,7,'USD','0.00',NULL,'0.00'),(473,5,4,7,'USD','0.00',NULL,'0.00'),(484,87,1,3,'USD','0.00',NULL,'0.00'),(485,87,3,3,'USD','0.00',NULL,'0.00'),(486,87,4,3,'USD','0.00',NULL,'0.00'),(487,89,1,3,'USD','0.00',NULL,'0.00'),(488,89,3,3,'USD','0.00',NULL,'0.00'),(489,89,4,3,'USD','0.00',NULL,'0.00'),(490,98,0,3,'USD','2.95',NULL,'0.00'),(491,98,1,3,'USD','0.00',NULL,'0.00'),(492,99,0,3,'USD','5.95',NULL,'0.00'),(493,99,1,3,'USD','0.00',NULL,'0.00'),(494,100,0,3,'USD','8.95',NULL,'0.00'),(495,100,1,3,'USD','0.00',NULL,'0.00'),(496,101,0,3,'USD','1.95',NULL,'0.00'),(497,101,1,3,'USD','0.00',NULL,'0.00'),(498,102,0,3,'USD','3.95',NULL,'0.00'),(499,102,1,3,'USD','0.00',NULL,'0.00'),(500,103,0,3,'USD','7.95',NULL,'0.00'),(501,103,1,3,'USD','0.00',NULL,'0.00'),(502,100,3,3,'USD','0.00',NULL,'0.00'),(503,100,4,3,'USD','0.00',NULL,'0.00'),(504,99,3,3,'USD','0.00',NULL,'0.00'),(505,99,4,3,'USD','0.00',NULL,'0.00'),(506,98,3,3,'USD','0.00',NULL,'0.00'),(507,98,4,3,'USD','0.00',NULL,'0.00');
/*!40000 ALTER TABLE `product_variant_prices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_variants`
--

DROP TABLE IF EXISTS `product_variants`;
CREATE TABLE `product_variants` (
  `product_variant_id` int(8) unsigned NOT NULL auto_increment,
  `product_variant_display_name` varchar(100) default NULL,
  `product_variant_active` tinyint(3) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `product_variable_value_id` smallint(5) unsigned default NULL,
  `tld_id` int(8) unsigned default NULL,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `cycle_discount_group_id` smallint(5) unsigned default NULL,
  `invoicing_group_id` smallint(5) unsigned default '0',
  PRIMARY KEY  (`product_variant_id`),
  KEY `product_id` (`product_id`),
  KEY `product_variable_value_id` (`product_variable_value_id`),
  KEY `tld_id` (`tld_id`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `cycle_discount_group_id` (`cycle_discount_group_id`),
  KEY `invoicing_group_id` (`invoicing_group_id`)
) AUTO_INCREMENT=104;

--
-- Dumping data for table `product_variants`
--

LOCK TABLES `product_variants` WRITE;
/*!40000 ALTER TABLE `product_variants` DISABLE KEYS */;
INSERT INTO `product_variants` VALUES (1,'Dot ac domain registration.',0,1,NULL,1,NULL,NULL,0),(2,'Dot am domain registration.',0,1,NULL,2,NULL,NULL,0),(3,'Dot at domain registration.',0,1,NULL,47,NULL,NULL,0),(4,'Dot be domain registration.',0,1,NULL,48,NULL,NULL,0),(5,'Dot biz domain registration.',1,1,NULL,5,0,0,0),(6,'Dot ca domain registration.',0,1,NULL,6,NULL,NULL,0),(7,'Dot cc domain registration.',0,1,NULL,7,NULL,NULL,0),(8,'Dot cn domain registration.',0,1,NULL,8,NULL,NULL,0),(9,'Dot co.in domain registration.',0,1,NULL,9,NULL,NULL,0),(11,'Dot com domain registration.',1,1,NULL,11,0,0,0),(12,'Dot com.cn domain registration.',0,1,NULL,12,NULL,NULL,0),(13,'Dot com.mx domain registration.',0,1,NULL,13,NULL,NULL,0),(14,'Dot com.tw domain registration.',0,1,NULL,14,NULL,NULL,0),(15,'Dot de domain registration.',0,1,NULL,51,NULL,NULL,0),(16,'Dot eu domain registration.',0,1,NULL,16,NULL,NULL,0),(17,'Dot firm.in domain registration.',0,1,NULL,17,NULL,NULL,0),(18,'Dot gen.in domain registration.',0,1,NULL,18,NULL,NULL,0),(19,'Dot idv.tw domain registration.',0,1,NULL,19,NULL,NULL,0),(20,'Dot in domain registration.',0,1,NULL,20,NULL,NULL,0),(21,'Dot ind.in domain registration.',0,1,NULL,21,NULL,NULL,0),(22,'Dot info domain registration.',1,1,NULL,22,0,0,0),(23,'Dot io domain registration.',0,1,NULL,23,NULL,NULL,0),(24,'Dot it domain registration.',0,1,NULL,61,NULL,NULL,0),(25,'Dot jobs domain registration.',0,1,NULL,25,NULL,NULL,0),(26,'Dot jp domain registration.',0,1,NULL,26,NULL,NULL,0),(27,'Dot kids.us domain registration.',0,1,NULL,27,NULL,NULL,0),(28,'Dot me.uk domain registration.',0,1,NULL,28,NULL,NULL,0),(29,'Dot mobi domain registration.',0,1,NULL,29,NULL,NULL,0),(30,'Dot name domain registration.',0,1,NULL,30,NULL,NULL,0),(31,'Dot net domain registration.',1,1,NULL,31,0,0,0),(32,'Dot net.in domain registration.',0,1,NULL,32,NULL,NULL,0),(33,'Dot net.cn domain registration.',0,1,NULL,33,NULL,NULL,0),(34,'Dot nl domain registration.',0,1,NULL,66,NULL,NULL,0),(35,'Dot nu domain registration.',0,1,NULL,35,NULL,NULL,0),(36,'Dot org domain registration.',1,1,NULL,36,0,0,0),(37,'Dot org.cn domain registration.',0,1,NULL,37,NULL,NULL,0),(38,'Dot org.in domain registration.',0,1,NULL,38,NULL,NULL,0),(39,'Dot org.tw domain registration.',0,1,NULL,39,NULL,NULL,0),(40,'Dot org.uk domain registration.',0,1,NULL,40,NULL,NULL,0),(41,'Dot sh domain registration.',0,1,NULL,41,NULL,NULL,0),(42,'Dot tm domain registration.',0,1,NULL,42,NULL,NULL,0),(43,'Dot tv domain registration.',0,1,NULL,43,NULL,NULL,0),(44,'Dot tw domain registration.',0,1,NULL,44,NULL,NULL,0),(45,'Dot us domain registration.',0,1,NULL,45,NULL,NULL,0),(46,'Dot ws domain registration.',0,1,NULL,46,NULL,NULL,0),(47,'Dot ch domain registration.',0,1,NULL,49,NULL,NULL,0),(48,'Dot cz domain registration.',0,1,NULL,50,NULL,NULL,0),(49,'Dot dk domain registration.',0,1,NULL,52,NULL,NULL,0),(50,'Dot co.ee domain registration.',0,1,NULL,53,NULL,NULL,0),(51,'Dot es domain registration.',0,1,NULL,54,NULL,NULL,0),(52,'Dot com.es domain registration.',0,1,NULL,55,NULL,NULL,0),(53,'Dot org.es domain registration.',0,1,NULL,56,NULL,NULL,0),(54,'Dot fr domain registration.',0,1,NULL,57,NULL,NULL,0),(55,'Dot gr domain registration.',0,1,NULL,58,NULL,NULL,0),(56,'Dot hu domain registration.',0,1,NULL,59,NULL,NULL,0),(57,'Dot ie domain registration.',0,1,NULL,60,NULL,NULL,0),(58,'Dot li domain registration.',0,1,NULL,62,NULL,NULL,0),(59,'Dot lt domain registration.',0,1,NULL,63,NULL,NULL,0),(60,'Dot lu domain registration.',0,1,NULL,64,NULL,NULL,0),(61,'Dot lv domain registration.',0,1,NULL,65,NULL,NULL,0),(62,'Dot com.pt domain registration.',0,1,NULL,67,NULL,NULL,0),(63,'Dot se domain registration.',0,1,NULL,68,NULL,NULL,0),(64,'Dot sk domain registration.',0,1,NULL,69,NULL,NULL,0),(65,'Dot ro domain registration.',0,1,NULL,70,NULL,NULL,0),(66,'Dot ru domain registration.',0,1,NULL,71,NULL,NULL,0),(67,'Dot la domain registration.',0,1,NULL,73,NULL,NULL,0),(68,'Dot br.com domain registration.',0,1,NULL,74,NULL,NULL,0),(69,'Dot cn.com domain registration.',0,1,NULL,75,NULL,NULL,0),(70,'Dot de.com domain registration.',0,1,NULL,76,NULL,NULL,0),(71,'Dot eu.com domain registration.',0,1,NULL,77,NULL,NULL,0),(72,'Dot hu.com domain registration.',0,1,NULL,78,NULL,NULL,0),(73,'Dot no.com domain registration.',0,1,NULL,79,NULL,NULL,0),(74,'Dot qc.com domain registration.',0,1,NULL,80,NULL,NULL,0),(75,'Dot ru.com domain registration.',0,1,NULL,81,NULL,NULL,0),(76,'Dot sa.com domain registration.',0,1,NULL,82,NULL,NULL,0),(77,'Dot se.com domain registration.',0,1,NULL,83,NULL,NULL,0),(78,'Dot se.net domain registration.',0,1,NULL,84,NULL,NULL,0),(79,'Dot uk.com domain registration.',0,1,NULL,85,NULL,NULL,0),(80,'Dot uk.net domain registration.',0,1,NULL,86,NULL,NULL,0),(81,'Dot us.com domain registration.',0,1,NULL,87,NULL,NULL,0),(82,'Dot uy.com domain registration.',0,1,NULL,88,NULL,NULL,0),(83,'Dot za.com domain registration.',0,1,NULL,89,NULL,NULL,0),(84,'Dot cpa.pro domain registration.',0,1,NULL,90,NULL,NULL,0),(85,'Dot law.pro domain registration.',0,1,NULL,91,NULL,NULL,0),(86,'Dot med.pro domain registration.',0,1,NULL,92,NULL,NULL,0),(87,'',1,2,NULL,0,0,0,0),(88,'',1,3,NULL,0,NULL,NULL,0),(89,'',1,4,NULL,0,0,0,0),(90,'General Service',1,5,NULL,0,NULL,NULL,0),(91,'',0,1,NULL,3,NULL,NULL,0),(92,'',0,1,NULL,4,NULL,NULL,0),(94,'',0,1,NULL,15,NULL,NULL,0),(95,'',0,1,NULL,24,NULL,NULL,0),(96,'',0,1,NULL,34,NULL,NULL,0),(97,'Dot co.uk domain registration.',1,1,NULL,10,0,0,0),(98,NULL,1,6,NULL,0,0,0,0),(99,NULL,1,7,NULL,0,0,0,0),(100,NULL,1,8,NULL,0,0,0,0),(101,NULL,1,9,NULL,0,NULL,NULL,0),(102,NULL,1,10,NULL,0,NULL,NULL,0),(103,NULL,1,11,NULL,0,NULL,NULL,0);
/*!40000 ALTER TABLE `product_variants` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_vendor_qties`
--

DROP TABLE IF EXISTS `product_vendor_qties`;
CREATE TABLE `product_vendor_qties` (
  `product_vendor_qty_id` int(10) unsigned NOT NULL auto_increment,
  `quantity_available` int(10) default NULL,
  `quantity_unavailable` int(10) default NULL,
  PRIMARY KEY  (`product_vendor_qty_id`),
  KEY `quantity_available` (`quantity_available`),
  KEY `quantity_unavailable` (`quantity_unavailable`)
);

--
-- Dumping data for table `product_vendor_qties`
--

LOCK TABLES `product_vendor_qties` WRITE;
/*!40000 ALTER TABLE `product_vendor_qties` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_vendor_qties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_vendor_qty_rel`
--

DROP TABLE IF EXISTS `product_vendor_qty_rel`;
CREATE TABLE `product_vendor_qty_rel` (
  `product_variant_id` int(10) unsigned NOT NULL default '0',
  `vendor_id` smallint(5) unsigned NOT NULL default '0',
  `product_vendor_qty_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`product_variant_id`,`vendor_id`),
  KEY `product_vendor_qty_id` (`product_vendor_qty_id`)
);

--
-- Dumping data for table `product_vendor_qty_rel`
--

LOCK TABLES `product_vendor_qty_rel` WRITE;
/*!40000 ALTER TABLE `product_vendor_qty_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_vendor_qty_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_vendor_rel`
--

DROP TABLE IF EXISTS `product_vendor_rel`;
CREATE TABLE `product_vendor_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `vendor_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_product_id` int(10) unsigned NOT NULL default '0',
  `vendor_order_form_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_product_variant_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`vendor_id`,`vendor_product_id`,`vendor_order_form_id`,`vendor_product_variant_id`)
);

--
-- Dumping data for table `product_vendor_rel`
--

LOCK TABLES `product_vendor_rel` WRITE;
/*!40000 ALTER TABLE `product_vendor_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_vendor_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products`
--

DROP TABLE IF EXISTS `products`;
CREATE TABLE `products` (
  `product_id` int(10) unsigned NOT NULL auto_increment,
  `product_type` tinyint(3) unsigned default NULL,
  `product_variable_id` smallint(5) unsigned default NULL,
  `product_is_lockable` tinyint(3) unsigned default '0',
  `product_is_addon` tinyint(1) unsigned default '0',
  `product_invoice_separately` tinyint(1) unsigned default '0',
  `product_addon_group_id` smallint(5) unsigned default '0',
  `product_addon_attribute_name` varchar(255) default NULL,
  `product_name` varchar(100) default NULL,
  `product_comments` longtext,
  `product_stop_num_cycles` int(10) unsigned default NULL,
  `product_active` tinyint(1) unsigned default NULL,
  `product_proratable` tinyint(1) unsigned default NULL,
  `product_discountable` tinyint(1) unsigned default '1',
  `product_date_created` int(10) unsigned default NULL,
  `product_domain_required` tinyint(3) unsigned default NULL,
  `product_addon_required` tinyint(3) unsigned default NULL,
  `product_intro_cycle_id` smallint(5) unsigned default NULL,
  `product_intro_num_cycles` smallint(5) unsigned default NULL,
  `email_tpl_group_id` smallint(5) unsigned default NULL,
  `notify_admin_group_id` smallint(5) unsigned default NULL,
  `product_cancellation_type` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`),
  KEY `product_type` (`product_type`),
  KEY `product_variable_id` (`product_variable_id`),
  KEY `product_active` (`product_active`),
  KEY `product_proratable` (`product_proratable`),
  KEY `product_is_lockable` (`product_is_lockable`),
  KEY `product_invoice_separately` (`product_invoice_separately`),
  KEY `product_addon_group_id` (`product_addon_group_id`)
) AUTO_INCREMENT=12;

--
-- Dumping data for table `products`
--

LOCK TABLES `products` WRITE;
/*!40000 ALTER TABLE `products` DISABLE KEYS */;
INSERT INTO `products` VALUES (1,3,NULL,0,0,0,0,NULL,'Domains','Domain registration or transfer.',NULL,1,0,1,1208548655,2,2,NULL,NULL,NULL,NULL,0),(2,1,0,0,0,0,0,NULL,'Bronze Hosting','Bronze website hosting, includes basic domain hosting with email.',0,1,1,1,1208548658,1,0,NULL,NULL,1,0,0),(3,1,0,0,0,0,0,NULL,'Silver Hosting','Silver website hosting, includes domain hosting with email and database access.',0,1,1,1,1208548658,1,0,NULL,NULL,1,0,0),(4,1,0,0,0,0,0,NULL,'Gold Hosting','Gold website hosting, includes deluxe domain hosting with unlimited email and databases.',0,1,1,1,1208548658,1,0,NULL,NULL,1,0,0),(5,2,NULL,0,0,0,0,NULL,'Service','General Service.',1,1,1,1,1208548658,1,2,NULL,NULL,NULL,NULL,0),(6,1,NULL,0,1,0,1,'clientDiskSpace','1 Additional Gigabyte','',0,1,1,1,1211559572,2,2,0,0,NULL,NULL,0),(7,1,NULL,0,1,0,1,'clientDiskSpace','2 Additional Gigabytes','',0,1,1,1,1211559572,2,2,0,0,NULL,NULL,0),(8,1,NULL,0,1,0,1,'clientDiskSpace','5 Additional Gigabytes','',0,1,1,1,1211559572,2,2,0,0,NULL,NULL,0),(9,1,NULL,0,1,0,2,'clientMaxMailbox','20 Additional E-mail Addresses','',0,1,1,1,1211559887,2,2,0,0,NULL,NULL,0),(10,1,NULL,0,1,0,2,'clientMaxMailbox','100 Additional E-mail Addresses','',0,1,1,1,1211559887,2,2,0,0,NULL,NULL,0),(11,1,NULL,0,1,0,2,'clientMaxMailbox','250 Additional E-mail Addresses','',0,1,1,1,1211559887,2,2,0,0,NULL,NULL,0);
/*!40000 ALTER TABLE `products` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_value_map_mapping_rel`
--

DROP TABLE IF EXISTS `question_value_map_mapping_rel`;
CREATE TABLE `question_value_map_mapping_rel` (
  `value_map_id` smallint(5) unsigned NOT NULL default '0',
  `value_mapping_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`value_map_id`,`value_mapping_id`)
);

--
-- Dumping data for table `question_value_map_mapping_rel`
--

LOCK TABLES `question_value_map_mapping_rel` WRITE;
/*!40000 ALTER TABLE `question_value_map_mapping_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value_map_mapping_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_value_mappings`
--

DROP TABLE IF EXISTS `question_value_mappings`;
CREATE TABLE `question_value_mappings` (
  `value_mapping_id` smallint(5) unsigned NOT NULL auto_increment,
  `value_mapping_value` varchar(255) default NULL,
  `attribute_map_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`value_mapping_id`),
  KEY `attribute_map_id` (`attribute_map_id`)
);

--
-- Dumping data for table `question_value_mappings`
--

LOCK TABLES `question_value_mappings` WRITE;
/*!40000 ALTER TABLE `question_value_mappings` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value_mappings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_value_maps`
--

DROP TABLE IF EXISTS `question_value_maps`;
CREATE TABLE `question_value_maps` (
  `value_map_id` smallint(5) unsigned NOT NULL auto_increment,
  `value_map_name` varchar(100) default NULL,
  PRIMARY KEY  (`value_map_id`),
  KEY `value_map_name` (`value_map_name`)
);

--
-- Dumping data for table `question_value_maps`
--

LOCK TABLES `question_value_maps` WRITE;
/*!40000 ALTER TABLE `question_value_maps` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value_maps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_totals`
--

DROP TABLE IF EXISTS `report_totals`;
CREATE TABLE `report_totals` (
  `report_date_created` int(10) unsigned NOT NULL default '0',
  `client_total_count` int(8) unsigned default NULL,
  `client_active_count` int(8) unsigned default NULL,
  `client_inactive_count` int(8) unsigned default NULL,
  `client_pending_count` int(8) unsigned default NULL,
  `client_canceled_count` int(8) unsigned default NULL,
  `client_fraud_count` int(8) unsigned default NULL,
  `package_new_count` int(8) unsigned default NULL,
  `package_new_sum` decimal(10,2) unsigned default NULL,
  `package_renew_count` int(8) unsigned default NULL,
  `package_renew_sum` decimal(10,2) unsigned default NULL,
  `invoice_total_count` int(8) unsigned default NULL,
  `invoice_total_sum` decimal(10,2) unsigned default NULL,
  `invoice_due_count` int(8) unsigned default NULL,
  `invoice_due_sum` decimal(10,2) unsigned default NULL,
  `invoice_paid_count` int(8) unsigned default NULL,
  `invoice_paid_sum` decimal(10,2) unsigned default NULL,
  `invoice_batch_count` int(8) unsigned default NULL,
  `invoice_batch_sum` decimal(10,2) unsigned default NULL,
  `invoice_declined_count` int(8) unsigned default NULL,
  `invoice_declined_sum` decimal(10,2) unsigned default NULL,
  `invoice_error_count` int(8) unsigned default NULL,
  `invoice_error_sum` decimal(10,2) unsigned default NULL,
  `registrar_debits` decimal(10,2) unsigned default NULL,
  `registrar_credits` decimal(10,2) unsigned default NULL,
  `domain_count` int(8) unsigned default NULL,
  `domain_exp_this` smallint(5) unsigned default NULL,
  `domain_exp_next` smallint(5) unsigned default NULL,
  `update_by` int(8) unsigned default NULL,
  `update_timestamp` int(10) unsigned default NULL,
  `report_saved` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`report_date_created`),
  KEY `update_by` (`update_by`),
  KEY `report_saved` (`report_saved`),
  KEY `update_timestamp` (`update_timestamp`)
);

--
-- Dumping data for table `report_totals`
--

LOCK TABLES `report_totals` WRITE;
/*!40000 ALTER TABLE `report_totals` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_totals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `saved_orders`
--

DROP TABLE IF EXISTS `saved_orders`;
CREATE TABLE `saved_orders` (
  `saved_order_code` varchar(50) NOT NULL default '',
  `client_id` int(8) unsigned default NULL,
  `saved_order_date_modified` int(10) unsigned default NULL,
  PRIMARY KEY  (`saved_order_code`),
  KEY `client_id` (`client_id`),
  KEY `saved_order_date_modified` (`saved_order_date_modified`)
);

--
-- Dumping data for table `saved_orders`
--

LOCK TABLES `saved_orders` WRITE;
/*!40000 ALTER TABLE `saved_orders` DISABLE KEYS */;
/*!40000 ALTER TABLE `saved_orders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `secret_answers`
--

DROP TABLE IF EXISTS `secret_answers`;
CREATE TABLE `secret_answers` (
  `secret_answer_id` int(10) unsigned NOT NULL auto_increment,
  `client_contact_id` int(10) unsigned default NULL,
  `question_type` tinyint(3) unsigned default NULL,
  `secret_answer` varchar(150) default NULL,
  PRIMARY KEY  (`secret_answer_id`),
  KEY `client_contact_id` (`client_contact_id`)
);

--
-- Dumping data for table `secret_answers`
--

LOCK TABLES `secret_answers` WRITE;
/*!40000 ALTER TABLE `secret_answers` DISABLE KEYS */;
/*!40000 ALTER TABLE `secret_answers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_group_rel`
--

DROP TABLE IF EXISTS `server_group_rel`;
CREATE TABLE `server_group_rel` (
  `server_id` int(8) unsigned NOT NULL default '0',
  `server_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_id`,`server_group_id`)
);

--
-- Dumping data for table `server_group_rel`
--

LOCK TABLES `server_group_rel` WRITE;
/*!40000 ALTER TABLE `server_group_rel` DISABLE KEYS */;
INSERT INTO `server_group_rel` VALUES (74,1);
/*!40000 ALTER TABLE `server_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_groups`
--

DROP TABLE IF EXISTS `server_groups`;
CREATE TABLE `server_groups` (
  `server_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `server_group_name` varchar(75) default NULL,
  `server_group_fill_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`server_group_id`),
  KEY `server_group_fill_type` (`server_group_fill_type`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `server_groups`
--

LOCK TABLES `server_groups` WRITE;
/*!40000 ALTER TABLE `server_groups` DISABLE KEYS */;
INSERT INTO `server_groups` VALUES (1,'Plesk',0);
/*!40000 ALTER TABLE `server_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `servers`
--

DROP TABLE IF EXISTS `servers`;
CREATE TABLE `servers` (
  `server_id` int(8) unsigned NOT NULL auto_increment,
  `server_name` varchar(75) default NULL,
  `server_ip` bigint(20) default NULL,
  `server_description` text,
  `server_status_id` tinyint(3) unsigned default NULL,
  `server_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`server_id`),
  KEY `server_status_id` (`server_status_id`),
  KEY `server_active` (`server_active`)
);

--
-- Dumping data for table `servers`
--

LOCK TABLES `servers` WRITE;
/*!40000 ALTER TABLE `servers` DISABLE KEYS */;
/*!40000 ALTER TABLE `servers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `session_id` varchar(40) NOT NULL default '',
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `session_date_created` int(10) unsigned default NULL,
  `session_date_accessed` int(10) unsigned default NULL,
  `session_date_expired` int(10) unsigned default NULL,
  `session_ip` bigint(20) default NULL,
  `session_headers` text,
  `session_active` tinyint(3) unsigned default '1',
  PRIMARY KEY  (`session_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `session_ip` (`session_ip`),
  KEY `session_active` (`session_active`),
  KEY `session_date_expired` (`session_date_expired`),
  KEY `session_date_accessed` (`session_date_accessed`)
);

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_coupons`
--

DROP TABLE IF EXISTS `shopping_coupons`;
CREATE TABLE `shopping_coupons` (
  `shopping_session_id` varchar(255) default NULL,
  `coupon_id` smallint(5) unsigned default NULL,
  `shopping_coupon_type` tinyint(1) unsigned default '0',
  KEY `shopping_session_id` (`shopping_session_id`),
  KEY `coupon_id` (`coupon_id`)
);

--
-- Dumping data for table `shopping_coupons`
--

LOCK TABLES `shopping_coupons` WRITE;
/*!40000 ALTER TABLE `shopping_coupons` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_coupons` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_items`
--

DROP TABLE IF EXISTS `shopping_items`;
CREATE TABLE `shopping_items` (
  `shopping_item_id` int(10) unsigned NOT NULL auto_increment,
  `shopping_session_id` varchar(255) default NULL,
  `product_id` int(10) unsigned default NULL,
  `product_variant_id` int(8) unsigned default NULL,
  `parent_shopping_item_id` int(10) unsigned default NULL,
  `shopping_item_primary_domain_id` int(10) unsigned default NULL,
  `cycle_id` smallint(5) unsigned default NULL,
  `currency_id` char(3) default NULL,
  `shopping_item_quantity` smallint(5) unsigned default NULL,
  `shopping_item_sld` varchar(255) default NULL,
  `shopping_item_tld` varchar(20) default NULL,
  `shopping_item_domain_type` tinyint(3) unsigned default NULL,
  `shopping_item_domain_language` char(3) default NULL,
  `shopping_item_transfer_key` varchar(255) default NULL,
  `shopping_item_price` decimal(10,2) unsigned default NULL,
  `shopping_item_setup_price` decimal(10,2) unsigned default NULL,
  `shopping_item_date_added` int(10) unsigned default NULL,
  PRIMARY KEY  (`shopping_item_id`),
  KEY `shopping_session_id` (`shopping_session_id`),
  KEY `product_id` (`product_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `parent_shopping_item_id` (`parent_shopping_item_id`),
  KEY `shopping_item_date_added` (`shopping_item_date_added`)
) AUTO_INCREMENT=10;

--
-- Dumping data for table `shopping_items`
--

LOCK TABLES `shopping_items` WRITE;
/*!40000 ALTER TABLE `shopping_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_items_domains_rel`
--

DROP TABLE IF EXISTS `shopping_items_domains_rel`;
CREATE TABLE `shopping_items_domains_rel` (
  `shopping_items_domains_rel_id` int(10) unsigned NOT NULL auto_increment,
  `shopping_item_id` int(10) unsigned default NULL,
  `shopping_items_domains_type` tinyint(1) unsigned default NULL,
  `domain_id` int(10) unsigned default NULL,
  `domain_sld` varchar(255) default NULL,
  `domain_tld` varchar(25) default NULL,
  `domain_shopping_item_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`shopping_items_domains_rel_id`),
  KEY `domain_id` (`domain_id`),
  KEY `domain_shopping_item_id` (`domain_shopping_item_id`),
  KEY `shopping_item_id` (`shopping_item_id`)
) AUTO_INCREMENT=3;

--
-- Dumping data for table `shopping_items_domains_rel`
--

LOCK TABLES `shopping_items_domains_rel` WRITE;
/*!40000 ALTER TABLE `shopping_items_domains_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_items_domains_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_sessions`
--

DROP TABLE IF EXISTS `shopping_sessions`;
CREATE TABLE `shopping_sessions` (
  `shopping_session_id` varchar(255) NOT NULL default '',
  `client_id` int(8) unsigned default NULL,
  `client_contact_id` int(10) unsigned default NULL,
  `shopping_session_timestamp` int(10) unsigned default NULL,
  `shopping_session_ip` bigint(20) default NULL,
  `shopping_session_url` varchar(255) default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `fraud_level_action` tinyint(3) unsigned default NULL,
  `fraud_level_action_status` tinyint(3) unsigned default NULL,
  `shopping_session_fingerprint` varchar(255) default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`shopping_session_id`),
  KEY `client_id` (`client_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `shopping_session_ip` (`shopping_session_ip`),
  KEY `invoice_id` (`invoice_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `client_contact_id` (`client_contact_id`)
);

--
-- Dumping data for table `shopping_sessions`
--

LOCK TABLES `shopping_sessions` WRITE;
/*!40000 ALTER TABLE `shopping_sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source_log`
--

DROP TABLE IF EXISTS `source_log`;
CREATE TABLE `source_log` (
  `source_log_id` bigint(20) unsigned NOT NULL auto_increment,
  `source_log_source_type` tinyint(4) default NULL,
  `source_log_user_type` tinyint(4) default NULL,
  `source_log_user_id` int(11) default NULL,
  `source_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`source_log_id`),
  KEY `source_log_source_type` (`source_log_source_type`)
);

--
-- Dumping data for table `source_log`
--

LOCK TABLES `source_log` WRITE;
/*!40000 ALTER TABLE `source_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `source_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source_log_col`
--

DROP TABLE IF EXISTS `source_log_col`;
CREATE TABLE `source_log_col` (
  `source_log_col_id` bigint(20) unsigned NOT NULL auto_increment,
  `source_log_row_id` bigint(20) unsigned default NULL,
  `source_log_col_name` varchar(32) default NULL,
  `source_log_col_old_val` varchar(255) default NULL,
  `source_log_col_new_val` varchar(255) default NULL,
  PRIMARY KEY  (`source_log_col_id`),
  KEY `source_log_col_id` (`source_log_col_id`)
);

--
-- Dumping data for table `source_log_col`
--

LOCK TABLES `source_log_col` WRITE;
/*!40000 ALTER TABLE `source_log_col` DISABLE KEYS */;
/*!40000 ALTER TABLE `source_log_col` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source_log_row`
--

DROP TABLE IF EXISTS `source_log_row`;
CREATE TABLE `source_log_row` (
  `source_log_row_id` bigint(20) unsigned NOT NULL auto_increment,
  `source_log_id` bigint(20) unsigned default NULL,
  `source_log_row_pri_key` int(10) unsigned default NULL,
  PRIMARY KEY  (`source_log_row_id`),
  KEY `source_log_id` (`source_log_id`),
  KEY `source_log_row_pri_key` (`source_log_row_pri_key`)
);

--
-- Dumping data for table `source_log_row`
--

LOCK TABLES `source_log_row` WRITE;
/*!40000 ALTER TABLE `source_log_row` DISABLE KEYS */;
/*!40000 ALTER TABLE `source_log_row` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subscription_package_addon_rel`
--

DROP TABLE IF EXISTS `subscription_package_addon_rel`;
CREATE TABLE `subscription_package_addon_rel` (
  `subscription_id` int(10) unsigned NOT NULL default '0',
  `package_addon_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`,`package_addon_id`)
);

--
-- Dumping data for table `subscription_package_addon_rel`
--

LOCK TABLES `subscription_package_addon_rel` WRITE;
/*!40000 ALTER TABLE `subscription_package_addon_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscription_package_addon_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subscription_package_rel`
--

DROP TABLE IF EXISTS `subscription_package_rel`;
CREATE TABLE `subscription_package_rel` (
  `subscription_id` int(8) unsigned NOT NULL default '0',
  `package_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`,`package_id`)
);

--
-- Dumping data for table `subscription_package_rel`
--

LOCK TABLES `subscription_package_rel` WRITE;
/*!40000 ALTER TABLE `subscription_package_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscription_package_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subscriptions`
--

DROP TABLE IF EXISTS `subscriptions`;
CREATE TABLE `subscriptions` (
  `subscription_id` int(8) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `subscription_external_id` varchar(255) default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  `subscription_status` tinyint(3) unsigned default NULL,
  `subscription_date_created` int(10) unsigned default NULL,
  `subscription_date_modified` int(10) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `subscription_account_identifier` varchar(255) default NULL,
  PRIMARY KEY  (`subscription_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `subscription_status` (`subscription_status`),
  KEY `client_id` (`client_id`),
  KEY `billing_account_id` (`billing_account_id`)
);

--
-- Dumping data for table `subscriptions`
--

LOCK TABLES `subscriptions` WRITE;
/*!40000 ALTER TABLE `subscriptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscriptions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `suspend_log`
--

DROP TABLE IF EXISTS `suspend_log`;
CREATE TABLE `suspend_log` (
  `suspend_id` int(8) unsigned NOT NULL auto_increment,
  `invoice_id` int(10) unsigned default NULL,
  `lite_stamp` int(10) unsigned default NULL,
  `medium_stamp` int(10) unsigned default NULL,
  `harsh_stamp` int(10) unsigned default NULL,
  `suspend_stamp` int(10) unsigned default NULL,
  `enable_stamp` int(10) unsigned default NULL,
  PRIMARY KEY  (`suspend_id`),
  KEY `invoice_id` (`invoice_id`)
);

--
-- Dumping data for table `suspend_log`
--

LOCK TABLES `suspend_log` WRITE;
/*!40000 ALTER TABLE `suspend_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `suspend_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_queue`
--

DROP TABLE IF EXISTS `system_queue`;
CREATE TABLE `system_queue` (
  `system_queue_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default NULL,
  `system_queue_parent_id` int(10) unsigned default NULL,
  `system_queue_status` tinyint(3) default '0',
  `system_queue_command` varchar(30) default NULL,
  `system_queue_command_input` longtext,
  `system_queue_minute` tinyint(3) unsigned default NULL,
  `system_queue_hour` tinyint(3) unsigned default NULL,
  `system_queue_day` tinyint(3) unsigned default NULL,
  `system_queue_month` tinyint(3) unsigned default NULL,
  `system_queue_year` tinyint(3) unsigned default NULL,
  `system_queue_is_recurring` tinyint(3) unsigned default NULL,
  `system_queue_date_created` int(10) unsigned default '0',
  `system_queue_date_to_run` int(10) unsigned default '0',
  `system_queue_date_started` int(10) unsigned default '0',
  `system_queue_date_finished` int(10) unsigned default '0',
  PRIMARY KEY  (`system_queue_id`),
  KEY `system_queue_command` (`system_queue_command`),
  KEY `system_queue_date_to_run` (`system_queue_date_to_run`),
  KEY `system_queue_is_recurring` (`system_queue_is_recurring`),
  KEY `system_queue_date_created` (`system_queue_date_created`),
  KEY `system_queue_date_started` (`system_queue_date_started`),
  KEY `system_queue_date_finished` (`system_queue_date_finished`),
  KEY `system_queue_parent_id` (`system_queue_parent_id`),
  KEY `system_queue_status` (`system_queue_status`),
  KEY `package_id` (`package_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `server_group_id` (`server_group_id`)
) AUTO_INCREMENT=9;

--
-- Dumping data for table `system_queue`
--

LOCK TABLES `system_queue` WRITE;
/*!40000 ALTER TABLE `system_queue` DISABLE KEYS */;
INSERT INTO `system_queue` VALUES (1,NULL,NULL,NULL,NULL,0,'ProcessInvoices','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessInvoices&lt;/command&gt;\n	&lt;params&gt;\n		&lt;numInvoicesToGenerate&gt;25&lt;/numInvoicesToGenerate&gt;\n		&lt;setBillingMode&gt;-1&lt;/setBillingMode&gt; \n		&lt;setSendInvoiceEmails&gt;-1&lt;/setSendInvoiceEmails&gt;\n		&lt;packageDateNextRenewalLessThan&gt;-1&lt;/packageDateNextRenewalLessThan&gt;\n		&lt;domainDateNextRenewalLessThan&gt;-1&lt;/domainDateNextRenewalLessThan&gt;\n		&lt;getActiveClients&gt;-1&lt;/getActiveClients&gt;\n		&lt;getSuspendedClients&gt;-1&lt;/getSuspendedClients&gt;\n		&lt;getActivePackages&gt;-1&lt;/getActivePackages&gt;\n		&lt;getSuspendedPackages&gt;-1&lt;/getSuspendedPackages&gt;\n		&lt;getActiveDomains&gt;-1&lt;/getActiveDomains&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,1208505453,1208509053,0,0),(2,NULL,NULL,NULL,NULL,0,'ProcessPaymentQueue','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessPaymentQueue&lt;/command&gt;\n	&lt;params&gt;\n		&lt;automated&gt;1&lt;/automated&gt;\n		&lt;generateNew&gt;-1&lt;/generateNew&gt;\n		&lt;generateDeclined&gt;-1&lt;/generateDeclined&gt;\n		&lt;generateError&gt;-1&lt;/generateError&gt;\n		&lt;generateDueDateOnly&gt;-1&lt;/generateDueDateOnly&gt;\n		&lt;dueDateTimestamp&gt;-1&lt;/dueDateTimestamp&gt;\n		&lt;numInvoicesToQueue&gt;25&lt;/numInvoicesToQueue&gt;\n		&lt;numInvoicesToCharge&gt;25&lt;/numInvoicesToCharge&gt;\n		&lt;chargeLesserAmounts&gt;-1&lt;/chargeLesserAmounts&gt;\n		&lt;runPaymentQueue&gt;1&lt;/runPaymentQueue&gt;\n		&lt;clearPaymentQueue&gt;-1&lt;/clearPaymentQueue&gt;\n&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,1208505453,1208566653,0,0),(3,NULL,NULL,NULL,NULL,0,'ProcessSuspensions','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessSuspensions&lt;/command&gt;\n	&lt;params&gt;\n		&lt;setSendSuspensionEmails&gt;&lt;/setSendSuspensionEmails&gt;\n		&lt;suspensionLevel1Day&gt;-1&lt;/suspensionLevel1Day&gt;\n		&lt;suspensionLevel2Day&gt;-1&lt;/suspensionLevel2Day&gt;\n		&lt;suspensionLevel3Day&gt;-1&lt;/suspensionLevel3Day&gt;\n		&lt;suspensionCleanDay&gt;-1&lt;/suspensionCleanDay&gt;\n		&lt;limitClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/limitClientGroups&gt;\n		&lt;excludeClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/excludeClientGroups&gt;\n		&lt;limitClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/limitClients&gt;\n		&lt;excludeClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/excludeClients&gt;\n		&lt;limitPackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/limitPackages&gt;\n		&lt;excludePackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/excludePackages&gt;\n		&lt;limitDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/limitDomains&gt;\n		&lt;excludeDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/excludeDomains&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,1208505453,1208577453,0,0),(4,NULL,NULL,NULL,NULL,0,'ProcessUnsuspensions','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessUnsuspensions&lt;/command&gt;\n	&lt;params&gt;\n		&lt;setSendSuspensionEmails&gt;&lt;/setSendSuspensionEmails&gt;\n		&lt;suspensionLevel1Day&gt;-1&lt;/suspensionLevel1Day&gt;\n		&lt;suspensionLevel2Day&gt;-1&lt;/suspensionLevel2Day&gt;\n		&lt;suspensionLevel3Day&gt;-1&lt;/suspensionLevel3Day&gt;\n		&lt;suspensionCleanDay&gt;-1&lt;/suspensionCleanDay&gt;\n		&lt;limitClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/limitClientGroups&gt;\n		&lt;excludeClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/excludeClientGroups&gt;\n		&lt;limitClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/limitClients&gt;\n		&lt;excludeClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/excludeClients&gt;\n		&lt;limitPackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/limitPackages&gt;\n		&lt;excludePackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/excludePackages&gt;\n		&lt;limitDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/limitDomains&gt;\n		&lt;excludeDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/excludeDomains&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',20,0,0,0,0,1,1208505453,1208501853,0,0),(5,NULL,NULL,NULL,NULL,0,'ProcessUsage','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessUsage&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,1208505453,1208512653,0,0),(6,NULL,NULL,NULL,NULL,0,'ProcessCancellation','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessCancellation&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,1208505453,1208496033,0,0),(7,NULL,NULL,NULL,NULL,0,'ProcessExpiredCreditCards','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessExpiredCreditCards&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,7,0,0,1,1208505453,1208494653,0,0),(8,NULL,NULL,NULL,NULL,0,'ProcessDomainSynchronization','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessDomainSynchronization&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,7,0,0,1,1208505453,1208494653,0,0);
/*!40000 ALTER TABLE `system_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_queue_log`
--

DROP TABLE IF EXISTS `system_queue_log`;
CREATE TABLE `system_queue_log` (
  `system_queue_log_id` int(10) unsigned NOT NULL auto_increment,
  `system_queue_id` int(10) unsigned default NULL,
  `system_queue_log_message` text,
  `system_queue_num_errors` tinyint(3) unsigned default NULL,
  `system_queue_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`system_queue_log_id`),
  KEY `system_queue_id` (`system_queue_id`),
  KEY `system_queue_log_date_created` (`system_queue_log_date_created`),
  KEY `system_queue_num_errors` (`system_queue_num_errors`)
);

--
-- Dumping data for table `system_queue_log`
--

LOCK TABLES `system_queue_log` WRITE;
/*!40000 ALTER TABLE `system_queue_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `system_queue_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_zone_group_zone_rel`
--

DROP TABLE IF EXISTS `tax_zone_group_zone_rel`;
CREATE TABLE `tax_zone_group_zone_rel` (
  `tax_zone_group_zone_rel_id` smallint(5) unsigned NOT NULL auto_increment,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `tax_zone_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`tax_zone_group_zone_rel_id`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `tax_zone_id` (`tax_zone_id`)
);

--
-- Dumping data for table `tax_zone_group_zone_rel`
--

LOCK TABLES `tax_zone_group_zone_rel` WRITE;
/*!40000 ALTER TABLE `tax_zone_group_zone_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_zone_group_zone_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_zone_groups`
--

DROP TABLE IF EXISTS `tax_zone_groups`;
CREATE TABLE `tax_zone_groups` (
  `tax_zone_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `tax_zone_group_name` varchar(100) default NULL,
  `tax_zone_group_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`tax_zone_group_id`),
  KEY `tax_zone_group_active` (`tax_zone_group_active`)
);

--
-- Dumping data for table `tax_zone_groups`
--

LOCK TABLES `tax_zone_groups` WRITE;
/*!40000 ALTER TABLE `tax_zone_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_zone_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_zones`
--

DROP TABLE IF EXISTS `tax_zones`;
CREATE TABLE `tax_zones` (
  `tax_zone_id` smallint(5) unsigned NOT NULL auto_increment,
  `countries_iso_2` char(2) default NULL,
  `tax_zone_name` varchar(255) default NULL,
  `tax_zone_amount_type` tinyint(3) default '0',
  `tax_zone_amount` decimal(6,2) unsigned default NULL,
  `tax_zone_description` varchar(255) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `tax_zone_active` tinyint(3) unsigned default NULL,
  `tax_zone_stackable` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`tax_zone_id`),
  KEY `countries_iso_2` (`countries_iso_2`),
  KEY `tax_zone_active` (`tax_zone_active`),
  KEY `tax_zone_stackable` (`tax_zone_stackable`),
  KEY `ledger_account_id` (`ledger_account_id`)
);

--
-- Dumping data for table `tax_zones`
--

LOCK TABLES `tax_zones` WRITE;
/*!40000 ALTER TABLE `tax_zones` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_zones` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `themes`
--

DROP TABLE IF EXISTS `themes`;
CREATE TABLE `themes` (
  `theme_id` smallint(5) unsigned NOT NULL auto_increment,
  `theme_name` varchar(50) default NULL,
  `theme_display_name` varchar(255) default NULL,
  `theme_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`theme_id`),
  KEY `theme_name` (`theme_name`),
  KEY `theme_active` (`theme_active`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `themes`
--

LOCK TABLES `themes` WRITE;
/*!40000 ALTER TABLE `themes` DISABLE KEYS */;
INSERT INTO `themes` VALUES (2,'xpreloaded','XPreloaded',1);
/*!40000 ALTER TABLE `themes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tlds`
--

DROP TABLE IF EXISTS `tlds`;
CREATE TABLE `tlds` (
  `tld_id` int(8) unsigned NOT NULL auto_increment,
  `registrar_id` smallint(5) unsigned default NULL,
  `tld_extension` varchar(25) default NULL,
  `tld_name` varchar(100) default NULL,
  `tld_whois_server` varchar(100) default NULL,
  `tld_whois_resp` varchar(100) default NULL,
  `tld_active` tinyint(3) unsigned default NULL,
  `tld_auto_search` tinyint(3) unsigned default NULL,
  `tld_transfer_minimum_cycle_id` smallint(5) unsigned default NULL,
  `tld_minimum_cycle_id` smallint(5) unsigned default NULL,
  `tld_maximum_cycle_id` smallint(5) unsigned default NULL,
  `tld_renew_type` tinyint(3) unsigned default NULL,
  `tld_is_transferable` tinyint(3) unsigned default NULL,
  `tld_transfer_type` tinyint(3) unsigned default NULL,
  `tld_idn_support` tinyint(3) unsigned default NULL,
  `tld_idn_type` tinyint(3) unsigned default NULL,
  `tld_remote_lock_enabled` tinyint(3) unsigned default NULL,
  `tld_display_order` int(8) unsigned default NULL,
  PRIMARY KEY  (`tld_id`),
  KEY `tld_extension` (`tld_extension`),
  KEY `tld_display_order` (`tld_display_order`),
  KEY `registrar_id` (`registrar_id`)
) AUTO_INCREMENT=93;

--
-- Dumping data for table `tlds`
--

LOCK TABLES `tlds` WRITE;
/*!40000 ALTER TABLE `tlds` DISABLE KEYS */;
INSERT INTO `tlds` VALUES (1,44,'ac','ac','','',1,1,6,6,15,2,1,0,1,0,0,11),(2,44,'am','am','','',1,1,6,6,15,2,1,0,1,0,0,12),(3,44,'at','at','','',1,1,6,6,15,2,1,0,1,0,0,13),(4,44,'be','be','','',1,1,6,6,15,2,1,0,1,0,0,14),(5,44,'biz','biz','','',1,1,6,6,15,2,1,0,5,0,0,15),(6,44,'ca','ca','','',1,1,6,6,15,2,1,0,1,0,0,16),(7,44,'cc','cc','','',1,1,6,6,15,2,1,0,1,0,0,17),(8,44,'cn','cn','','',1,1,6,6,15,2,1,0,1,0,0,18),(9,44,'co.in','co.in','','',1,1,6,6,15,2,1,0,1,0,0,19),(10,44,'co.uk','co.uk','','',1,1,7,7,15,2,1,0,1,0,0,4),(11,44,'com','com','','',1,1,6,6,15,2,1,0,1,0,0,1),(12,44,'com.cn','com.cn','','',1,1,6,6,15,2,1,0,1,0,0,22),(13,44,'com.mx','com.mx','','',1,1,6,6,15,2,1,0,1,0,0,23),(14,44,'com.tw','com.tw','','',1,1,6,6,15,2,1,0,1,0,0,24),(15,44,'de','de','','',1,1,6,6,15,2,1,0,1,0,0,25),(16,44,'eu','eu','','',1,1,6,6,15,2,1,0,1,0,0,26),(17,44,'firm.in','firm.in','','',1,1,6,6,15,2,1,0,1,0,0,27),(18,44,'gen.in','gen.in','','',1,1,6,6,15,2,1,0,1,0,0,28),(19,44,'idv.tw','idv.tw','','',1,1,6,6,15,2,1,0,1,0,0,29),(20,44,'in','in','','',1,1,6,6,15,2,1,0,1,0,0,30),(21,44,'ind.in','ind.in','','',1,1,6,6,15,2,1,0,1,0,0,31),(22,44,'info','info','','',1,1,6,6,15,2,1,0,1,0,0,6),(23,44,'io','io','','',1,1,6,6,15,2,1,0,1,0,0,33),(24,44,'it','it','','',1,1,6,6,15,2,1,0,1,0,0,34),(25,44,'jobs','jobs','','',1,1,6,6,15,2,1,0,1,0,0,35),(26,44,'jp','jp','','',1,1,6,6,15,2,1,0,1,0,0,36),(27,44,'kids.us','kids.us','','',1,1,6,6,15,2,1,0,1,0,0,37),(28,44,'me.uk','me.uk','','',1,1,6,6,15,2,1,0,1,0,0,38),(29,44,'mobi','mobi','','',1,1,6,6,15,2,1,0,1,0,0,39),(30,44,'name','name','','',1,1,6,6,15,2,1,0,1,0,0,40),(31,44,'net','net','','',1,1,6,6,15,2,1,0,1,0,0,2),(32,44,'net.in','net.in','','',1,1,6,6,15,2,1,0,1,0,0,42),(33,44,'net.cn','net.cn','','',1,1,6,6,15,2,1,0,1,0,0,43),(34,44,'nl','nl','','',1,1,6,6,15,2,1,0,1,0,0,44),(35,44,'nu','nu','','',1,1,6,6,15,2,1,0,1,0,0,45),(36,44,'org','org','','',1,1,6,6,15,2,1,0,1,0,0,3),(37,44,'org.cn','org.cn','','',1,1,6,6,15,2,1,0,1,0,0,47),(38,44,'org.in','org.in','','',1,1,6,6,15,2,1,0,1,0,0,48),(39,44,'org.tw','org.tw','','',1,1,6,6,15,2,1,0,1,0,0,49),(40,44,'org.uk','org.uk','','',1,1,6,6,15,2,1,0,1,0,0,50),(41,44,'sh','sh','','',1,1,6,6,15,2,1,0,1,0,0,51),(42,44,'tm','tm','','',1,1,6,6,15,2,1,0,1,0,0,52),(43,44,'tv','tv','','',1,1,6,6,15,2,1,0,1,0,0,53),(44,44,'tw','tw','','',1,1,6,6,15,2,1,0,1,0,0,54),(45,44,'us','us','','',1,1,6,6,15,2,1,0,1,0,0,55),(46,44,'ws','ws','','',1,1,6,6,15,2,1,0,1,0,0,56),(47,44,'at','at','','',1,1,6,6,15,2,1,0,1,0,0,57),(48,44,'be','be','','',1,1,6,6,15,2,1,0,1,0,0,58),(49,44,'ch','ch','','',1,1,6,6,15,2,1,0,1,0,0,59),(50,44,'cz','cz','','',1,1,6,6,15,2,1,0,1,0,0,60),(51,44,'de','de','','',1,1,6,6,15,2,1,0,1,0,0,61),(52,44,'dk','dk','','',1,1,6,6,15,2,1,0,1,0,0,62),(53,44,'co.ee','co.ee','','',1,1,6,6,15,2,1,0,1,0,0,63),(54,44,'es','es','','',1,1,6,6,15,2,1,0,1,0,0,64),(55,44,'com.es','com.es','','',1,1,6,6,15,2,1,0,1,0,0,65),(56,44,'org.es','org.es','','',1,1,6,6,15,2,1,0,1,0,0,66),(57,44,'fr','fr','','',1,1,6,6,15,2,1,0,1,0,0,67),(58,44,'gr','gr','','',1,1,6,6,15,2,1,0,1,0,0,68),(59,44,'hu','hu','','',1,1,6,6,15,2,1,0,1,0,0,69),(60,44,'ie','ie','','',1,1,6,6,15,2,1,0,1,0,0,70),(61,44,'it','it','','',1,1,6,6,15,2,1,0,1,0,0,71),(62,44,'li','li','','',1,1,6,6,15,2,1,0,1,0,0,72),(63,44,'lt','lt','','',1,1,6,6,15,2,1,0,1,0,0,73),(64,44,'lu','lu','','',1,1,6,6,15,2,1,0,1,0,0,74),(65,44,'lv','lv','','',1,1,6,6,15,2,1,0,1,0,0,75),(66,44,'nl','nl','','',1,1,6,6,15,2,1,0,1,0,0,76),(67,44,'com.pt','com.pt','','',1,1,6,6,15,2,1,0,1,0,0,77),(68,44,'se','se','','',1,1,6,6,15,2,1,0,1,0,0,78),(69,44,'sk','sk','','',1,1,6,6,15,2,1,0,1,0,0,79),(70,44,'ro','ro','','',1,1,6,6,15,2,1,0,1,0,0,80),(71,44,'ru','ru','','',1,1,6,6,15,2,1,0,1,0,0,81),(73,44,'la','la','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,83),(74,44,'br.com','br.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,84),(75,44,'cn.com','cn.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,85),(76,44,'de.com','de.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,86),(77,44,'eu.com','eu.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,87),(78,44,'hu.com','hu.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,88),(79,44,'no.com','no.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,89),(80,44,'qc.com','qc.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,90),(81,44,'ru.com','ru.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,91),(82,44,'sa.com','sa.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,92),(83,44,'se.com','se.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,93),(84,44,'se.net','se.net','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,94),(85,44,'uk.com','uk.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,95),(86,44,'uk.net','uk.net','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,96),(87,44,'us.com','us.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,97),(88,44,'uy.com','uy.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,98),(89,44,'za.com','za.com','whois.centralnic.net','',1,1,6,6,15,2,1,0,1,0,0,99),(90,44,'cpa.pro','cpa.pro','whois.registrypro.pro','',1,1,6,6,15,2,1,0,1,0,0,100),(91,44,'law.pro','law.pro','whois.registrypro.pro','',1,1,6,6,15,2,1,0,1,0,0,101),(92,44,'med.pro','med.pro','whois.registrypro.pro','',1,1,6,6,15,2,1,0,1,0,0,102);
/*!40000 ALTER TABLE `tlds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `todos`
--

DROP TABLE IF EXISTS `todos`;
CREATE TABLE `todos` (
  `todo_id` int(8) unsigned NOT NULL auto_increment,
  `todo_title` varchar(255) default NULL,
  `todo_desc` longtext,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `todo_assigned_admin_id` smallint(5) unsigned default NULL,
  `todo_status_id` tinyint(3) unsigned default NULL,
  `todo_priority` tinyint(3) unsigned default NULL,
  `todo_is_public` tinyint(3) unsigned default NULL,
  `todo_link_pk` int(10) unsigned default NULL,
  `todo_link_name` varchar(50) default NULL,
  `todo_link_action_name` varchar(100) default NULL,
  `todo_link_file` varchar(75) default NULL,
  `todo_date_due` int(10) unsigned default NULL,
  `todo_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`todo_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `todo_status_id` (`todo_status_id`),
  KEY `todo_priority` (`todo_priority`),
  KEY `todo_date_due` (`todo_date_due`),
  KEY `todo_assigned_admin_id` (`todo_assigned_admin_id`),
  KEY `todo_is_public` (`todo_is_public`)
);

--
-- Dumping data for table `todos`
--

LOCK TABLES `todos` WRITE;
/*!40000 ALTER TABLE `todos` DISABLE KEYS */;
/*!40000 ALTER TABLE `todos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transaction_log`
--

DROP TABLE IF EXISTS `transaction_log`;
CREATE TABLE `transaction_log` (
  `transaction_id` int(10) unsigned NOT NULL auto_increment,
  `auth_return` tinyint(3) unsigned default NULL,
  `transaction_payment_method` tinyint(3) unsigned default NULL,
  `transaction_code` varchar(255) default NULL,
  `transaction_notes` varchar(255) default NULL,
  `transaction_date_created` int(10) unsigned default NULL,
  `auth_code` varchar(255) default NULL,
  `avs_code` varchar(255) default NULL,
  `transaction_amount` decimal(10,2) default '0.00',
  `transaction_amount_refunded` decimal(10,2) default '0.00',
  `currency_id` char(3) default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `billing_account_id` int(10) unsigned default '0',
  PRIMARY KEY  (`transaction_id`),
  KEY `auth_return` (`auth_return`),
  KEY `currency_id` (`currency_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `billing_account_id` (`billing_account_id`)
);

--
-- Dumping data for table `transaction_log`
--

LOCK TABLES `transaction_log` WRITE;
/*!40000 ALTER TABLE `transaction_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `transaction_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transaction_success_rel`
--

DROP TABLE IF EXISTS `transaction_success_rel`;
CREATE TABLE `transaction_success_rel` (
  `transaction_id` int(10) unsigned default NULL,
  `billing_account_share_id` int(10) unsigned default NULL,
  `line_item_id` int(10) unsigned default NULL,
  `line_item_payment_amount` decimal(10,2) unsigned default '0.00',
  KEY `transaction_id` (`transaction_id`),
  KEY `billing_account_share_id` (`billing_account_share_id`),
  KEY `line_item_id` (`line_item_id`)
);

--
-- Dumping data for table `transaction_success_rel`
--

LOCK TABLES `transaction_success_rel` WRITE;
/*!40000 ALTER TABLE `transaction_success_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `transaction_success_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_contacts`
--

DROP TABLE IF EXISTS `vendor_contacts`;
CREATE TABLE `vendor_contacts` (
  `vendor_contact_id` smallint(5) unsigned NOT NULL auto_increment,
  `vendor_id` smallint(5) unsigned default NULL,
  `vendor_contact_first_name` varchar(100) default NULL,
  `vendor_contact_last_name` varchar(100) default NULL,
  `vendor_contact_phone1` varchar(25) default NULL,
  `vendor_contact_phone2` varchar(25) default NULL,
  `vendor_contact_fax` varchar(25) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `vendor_contact_active` tinyint(1) unsigned default '1',
  PRIMARY KEY  (`vendor_contact_id`),
  KEY `vendor_id` (`vendor_id`),
  KEY `vendor_contact_first_name` (`vendor_contact_first_name`),
  KEY `vendor_contact_last_name` (`vendor_contact_last_name`),
  KEY `language_id` (`language_id`),
  KEY `vendor_contact_active` (`vendor_contact_active`)
);

--
-- Dumping data for table `vendor_contacts`
--

LOCK TABLES `vendor_contacts` WRITE;
/*!40000 ALTER TABLE `vendor_contacts` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_contacts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inv_msg_note_rel`
--

DROP TABLE IF EXISTS `vendor_inv_msg_note_rel`;
CREATE TABLE `vendor_inv_msg_note_rel` (
  `vendor_inv_msg_id` int(10) unsigned NOT NULL default '0',
  `vendor_inv_note_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`vendor_inv_msg_id`,`vendor_inv_note_id`)
);

--
-- Dumping data for table `vendor_inv_msg_note_rel`
--

LOCK TABLES `vendor_inv_msg_note_rel` WRITE;
/*!40000 ALTER TABLE `vendor_inv_msg_note_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inv_msg_note_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inv_msg_prov_rel`
--

DROP TABLE IF EXISTS `vendor_inv_msg_prov_rel`;
CREATE TABLE `vendor_inv_msg_prov_rel` (
  `vendor_inv_msg_id` int(10) unsigned NOT NULL default '0',
  `vendor_prov_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`vendor_inv_msg_id`,`vendor_prov_id`)
);

--
-- Dumping data for table `vendor_inv_msg_prov_rel`
--

LOCK TABLES `vendor_inv_msg_prov_rel` WRITE;
/*!40000 ALTER TABLE `vendor_inv_msg_prov_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inv_msg_prov_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inventory_msgs`
--

DROP TABLE IF EXISTS `vendor_inventory_msgs`;
CREATE TABLE `vendor_inventory_msgs` (
  `vendor_inv_msg_id` int(10) unsigned NOT NULL auto_increment,
  `vendor_id` smallint(5) unsigned default NULL,
  `vendor_inv_msg_type` tinyint(3) unsigned default '1',
  `vendor_inv_msg_token` varchar(100) default NULL,
  `vendor_inv_msg_text` varchar(255) default NULL,
  PRIMARY KEY  (`vendor_inv_msg_id`),
  KEY `vendor_inv_msg_type` (`vendor_inv_msg_type`),
  KEY `vendor_inv_msg_token` (`vendor_inv_msg_token`)
);

--
-- Dumping data for table `vendor_inventory_msgs`
--

LOCK TABLES `vendor_inventory_msgs` WRITE;
/*!40000 ALTER TABLE `vendor_inventory_msgs` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inventory_msgs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inventory_notes`
--

DROP TABLE IF EXISTS `vendor_inventory_notes`;
CREATE TABLE `vendor_inventory_notes` (
  `vendor_inv_note_id` int(10) unsigned NOT NULL auto_increment,
  `vendor_inv_note_type` tinyint(3) unsigned default '1',
  `product_variant_id` int(10) unsigned default NULL,
  `vendor_inv_note_qty` int(10) unsigned default NULL,
  `vendor_inv_note_date` int(10) unsigned default NULL,
  PRIMARY KEY  (`vendor_inv_note_id`),
  KEY `vendor_inv_note_type` (`vendor_inv_note_type`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `vendor_inv_note_qty` (`vendor_inv_note_qty`),
  KEY `vendor_inv_note_date` (`vendor_inv_note_date`)
);

--
-- Dumping data for table `vendor_inventory_notes`
--

LOCK TABLES `vendor_inventory_notes` WRITE;
/*!40000 ALTER TABLE `vendor_inventory_notes` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inventory_notes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_prov_package_rel`
--

DROP TABLE IF EXISTS `vendor_prov_package_rel`;
CREATE TABLE `vendor_prov_package_rel` (
  `vendor_prov_id` int(10) unsigned NOT NULL default '0',
  `ext_package_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`vendor_prov_id`,`ext_package_id`)
);

--
-- Dumping data for table `vendor_prov_package_rel`
--

LOCK TABLES `vendor_prov_package_rel` WRITE;
/*!40000 ALTER TABLE `vendor_prov_package_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_prov_package_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_provisionings`
--

DROP TABLE IF EXISTS `vendor_provisionings`;
CREATE TABLE `vendor_provisionings` (
  `vendor_prov_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`vendor_prov_id`)
);

--
-- Dumping data for table `vendor_provisionings`
--

LOCK TABLES `vendor_provisionings` WRITE;
/*!40000 ALTER TABLE `vendor_provisionings` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_provisionings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendors`
--

DROP TABLE IF EXISTS `vendors`;
CREATE TABLE `vendors` (
  `vendor_id` smallint(5) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `vendor_name` varchar(100) default NULL,
  `vendor_active` tinyint(1) unsigned default '1',
  `vendor_api_url` varchar(255) default NULL,
  `vendor_seller_username` varchar(255) default NULL,
  `vendor_seller_password` varchar(255) default NULL,
  `vendor_date_last_invoice_sync` int(10) unsigned default NULL,
  `vendor_activation_rule` tinyint(3) unsigned default '2',
  `vendor_markup_percentage` decimal(10,2) default NULL,
  `vendor_address_1` varchar(100) default NULL,
  `vendor_address_2` varchar(100) default NULL,
  `vendor_city` varchar(100) default NULL,
  `vendor_state` varchar(100) default NULL,
  `vendor_zip` varchar(100) default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`vendor_id`),
  KEY `vendor_name` (`vendor_name`),
  KEY `vendor_active` (`vendor_active`),
  KEY `vendor_seller_username` (`vendor_seller_username`),
  KEY `vendor_seller_password` (`vendor_seller_password`),
  KEY `vendor_date_last_invoice_sync` (`vendor_date_last_invoice_sync`),
  KEY `vendor_city` (`vendor_city`),
  KEY `vendor_state` (`vendor_state`),
  KEY `vendor_zip` (`vendor_zip`),
  KEY `countries_id` (`countries_id`)
);

--
-- Dumping data for table `vendors`
--

LOCK TABLES `vendors` WRITE;
/*!40000 ALTER TABLE `vendors` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `website_widgets`
--

DROP TABLE IF EXISTS `website_widgets`;
CREATE TABLE `website_widgets` (
  `website_widget_id` int(10) unsigned NOT NULL auto_increment,
  `website_widget_name` varchar(100) default NULL,
  `website_widget_tpl` varchar(100) default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`website_widget_id`),
  KEY `order_form_id` (`order_form_id`)
) AUTO_INCREMENT=2;

--
-- Dumping data for table `website_widgets`
--

LOCK TABLES `website_widgets` WRITE;
/*!40000 ALTER TABLE `website_widgets` DISABLE KEYS */;
INSERT INTO `website_widgets` VALUES (1,'WW 1','stepByStep-Folder',1);
/*!40000 ALTER TABLE `website_widgets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `website_widgets_products_rel`
--

DROP TABLE IF EXISTS `website_widgets_products_rel`;
CREATE TABLE `website_widgets_products_rel` (
  `website_widget_id` int(10) unsigned NOT NULL default '0',
  `product_id` int(10) unsigned NOT NULL default '0',
  `website_widget_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`website_widget_id`,`product_id`)
);

--
-- Dumping data for table `website_widgets_products_rel`
--

LOCK TABLES `website_widgets_products_rel` WRITE;
/*!40000 ALTER TABLE `website_widgets_products_rel` DISABLE KEYS */;
INSERT INTO `website_widgets_products_rel` VALUES (1,2,1),(1,3,2),(1,4,3);
/*!40000 ALTER TABLE `website_widgets_products_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `whois_stats`
--

DROP TABLE IF EXISTS `whois_stats`;
CREATE TABLE `whois_stats` (
  `whois_id` int(10) unsigned NOT NULL auto_increment,
  `whois_domain` varchar(255) default NULL,
  `whois_quantity` int(8) unsigned default NULL,
  `whois_from` varchar(25) default NULL,
  `whois_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`whois_id`)
);

--
-- Dumping data for table `whois_stats`
--

LOCK TABLES `whois_stats` WRITE;
/*!40000 ALTER TABLE `whois_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `whois_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_question_param_values`
--

DROP TABLE IF EXISTS `wizard_question_param_values`;
CREATE TABLE `wizard_question_param_values` (
  `question_param_value_id` int(10) unsigned NOT NULL auto_increment,
  `question_param_id` int(8) unsigned default NULL,
  `question_param_value_text` longtext,
  PRIMARY KEY  (`question_param_value_id`),
  KEY `question_param_id` (`question_param_id`)
);

--
-- Dumping data for table `wizard_question_param_values`
--

LOCK TABLES `wizard_question_param_values` WRITE;
/*!40000 ALTER TABLE `wizard_question_param_values` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_question_param_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_question_params`
--

DROP TABLE IF EXISTS `wizard_question_params`;
CREATE TABLE `wizard_question_params` (
  `question_param_id` int(8) unsigned NOT NULL auto_increment,
  `question_id` int(8) unsigned default NULL,
  `question_param_name` varchar(255) default NULL,
  `question_param_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`question_param_id`),
  KEY `question_id` (`question_id`),
  KEY `question_param_name` (`question_param_name`)
);

--
-- Dumping data for table `wizard_question_params`
--

LOCK TABLES `wizard_question_params` WRITE;
/*!40000 ALTER TABLE `wizard_question_params` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_question_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_questions`
--

DROP TABLE IF EXISTS `wizard_questions`;
CREATE TABLE `wizard_questions` (
  `question_id` int(8) unsigned NOT NULL auto_increment,
  `step_id` smallint(5) unsigned default NULL,
  `question_display_name` varchar(80) default NULL,
  `question_order` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`question_id`),
  KEY `step_id` (`step_id`),
  KEY `question_order` (`question_order`),
  KEY `question_display_name` (`question_display_name`)
);

--
-- Dumping data for table `wizard_questions`
--

LOCK TABLES `wizard_questions` WRITE;
/*!40000 ALTER TABLE `wizard_questions` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_questions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_steps`
--

DROP TABLE IF EXISTS `wizard_steps`;
CREATE TABLE `wizard_steps` (
  `step_id` smallint(5) unsigned NOT NULL auto_increment,
  `step_name` varchar(255) default NULL,
  PRIMARY KEY  (`step_id`),
  KEY `step_name` (`step_name`)
);

--
-- Dumping data for table `wizard_steps`
--

LOCK TABLES `wizard_steps` WRITE;
/*!40000 ALTER TABLE `wizard_steps` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_steps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizards`
--

DROP TABLE IF EXISTS `wizards`;
CREATE TABLE `wizards` (
  `wizard_id` int(10) unsigned default NULL,
  `session_id` varchar(40) default NULL,
  `wizard_date_modified` int(10) unsigned default NULL,
  `wizard_data` longtext,
  KEY `session_id` (`session_id`),
  KEY `wizard_id` (`wizard_id`)
);

--
-- Dumping data for table `wizards`
--

LOCK TABLES `wizards` WRITE;
/*!40000 ALTER TABLE `wizards` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizards` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2008-05-27 17:04:01
